/* file.c generated by valac 0.56.14, the Vala compiler
 * generated from file.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */
/* Returns true if the file is claimed, false if it exists, and throws an Error otherwise.  The file*/
/* will be created when the function exits and should be overwritten.  Note that the file is not*/
/* held open; claiming a file is merely based on its existence.*/
/**/
/* This function is thread-safe.*/

#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <glib-object.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef gboolean (*ProgressMonitor) (guint64 current, guint64 total, gboolean do_event_loop, gpointer user_data);
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))

VALA_EXTERN gboolean claim_file (GFile* file,
                     GError** error);
VALA_EXTERN GFile* generate_unique_file (GFile* dir,
                             const gchar* basename,
                             gboolean* collision,
                             GeeCollection* used,
                             GError** error);
VALA_EXTERN void disassemble_filename (const gchar* basename,
                           gchar** name,
                           gchar** ext);
VALA_EXTERN glong find_last_offset (const gchar* str,
                        gchar c);
VALA_EXTERN guint64 query_total_file_size (GFile* file_or_dir,
                               GCancellable* cancellable,
                               GError** error);
VALA_EXTERN void delete_all_files (GFile* dir,
                       GeeSet* exceptions,
                       ProgressMonitor monitor,
                       gpointer monitor_target,
                       guint64 file_count,
                       GCancellable* cancellable,
                       GError** error);
VALA_EXTERN GDateTime* query_file_modified (GFile* file,
                                GError** error);
VALA_EXTERN GDateTime* coarsify_date_time (GDateTime* dt);
VALA_EXTERN gboolean query_is_directory (GFile* file);
VALA_EXTERN gboolean query_is_directory_empty (GFile* dir,
                                   GError** error);
VALA_EXTERN gchar* get_display_pathname (GFile* file);
VALA_EXTERN gchar* strip_pretty_path (const gchar* path);
VALA_EXTERN gchar* get_file_info_id (GFileInfo* info);
VALA_EXTERN guint64 count_files_in_directory (GFile* dir,
                                  GError** error);
VALA_EXTERN gboolean file_equal (GFile* a,
                     GFile* b);
VALA_EXTERN guint file_hash (GFile* file);

static gpointer
_g_error_copy0 (gpointer self)
{
#line 23 "../src/util/file.vala"
	return self ? g_error_copy (self) : NULL;
#line 81 "file.c"
}

gboolean
claim_file (GFile* file,
            GError** error)
{
	gboolean _tmp9_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 12 "../src/util/file.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), FALSE);
#line 93 "file.c"
	{
		GFileOutputStream* _tmp0_;
		GFileOutputStream* _tmp1_;
#line 14 "../src/util/file.vala"
		_tmp0_ = g_file_create (file, G_FILE_CREATE_NONE, NULL, &_inner_error0_);
#line 14 "../src/util/file.vala"
		_tmp1_ = _tmp0_;
#line 14 "../src/util/file.vala"
		_g_object_unref0 (_tmp1_);
#line 14 "../src/util/file.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 105 "file.c"
			goto __catch0_g_error;
		}
#line 17 "../src/util/file.vala"
		result = TRUE;
#line 17 "../src/util/file.vala"
		return result;
#line 112 "file.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp2_;
#line 13 "../src/util/file.vala"
		err = _inner_error0_;
#line 13 "../src/util/file.vala"
		_inner_error0_ = NULL;
#line 20 "../src/util/file.vala"
		_tmp2_ = err;
#line 20 "../src/util/file.vala"
		if (!g_error_matches (_tmp2_, G_IO_ERROR, G_IO_ERROR_EXISTS)) {
#line 127 "file.c"
			gchar* _tmp3_;
			gchar* _tmp4_;
			GError* _tmp5_;
			const gchar* _tmp6_;
			GError* _tmp7_;
			GError* _tmp8_;
#line 21 "../src/util/file.vala"
			_tmp3_ = g_file_get_path (file);
#line 21 "../src/util/file.vala"
			_tmp4_ = _tmp3_;
#line 21 "../src/util/file.vala"
			_tmp5_ = err;
#line 21 "../src/util/file.vala"
			_tmp6_ = _tmp5_->message;
#line 21 "../src/util/file.vala"
			g_warning ("file.vala:21: claim_file %s: %s", _tmp4_, _tmp6_);
#line 21 "../src/util/file.vala"
			_g_free0 (_tmp4_);
#line 23 "../src/util/file.vala"
			_tmp7_ = err;
#line 23 "../src/util/file.vala"
			_tmp8_ = _g_error_copy0 (_tmp7_);
#line 23 "../src/util/file.vala"
			_inner_error0_ = _tmp8_;
#line 23 "../src/util/file.vala"
			_g_error_free0 (err);
#line 154 "file.c"
			goto __finally0;
		}
#line 26 "../src/util/file.vala"
		result = FALSE;
#line 26 "../src/util/file.vala"
		_g_error_free0 (err);
#line 26 "../src/util/file.vala"
		return result;
#line 163 "file.c"
	}
	__finally0:
#line 13 "../src/util/file.vala"
	g_propagate_error (error, _inner_error0_);
#line 13 "../src/util/file.vala"
	return _tmp9_;
#line 170 "file.c"
}

GFile*
generate_unique_file (GFile* dir,
                      const gchar* basename,
                      gboolean* collision,
                      GeeCollection* used,
                      GError** error)
{
	gboolean _vala_collision = FALSE;
	GFile* file = NULL;
	GFile* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GFile* _tmp2_;
	gchar* name = NULL;
	gchar* ext = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp21_;
	gchar* _tmp22_;
	GError* _inner_error0_ = NULL;
	GFile* result;
#line 38 "../src/util/file.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (dir, g_file_get_type ()), NULL);
#line 38 "../src/util/file.vala"
	g_return_val_if_fail (basename != NULL, NULL);
#line 38 "../src/util/file.vala"
	g_return_val_if_fail ((used == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (used, GEE_TYPE_COLLECTION), NULL);
#line 40 "../src/util/file.vala"
	_tmp0_ = g_file_get_child (dir, basename);
#line 40 "../src/util/file.vala"
	file = _tmp0_;
#line 41 "../src/util/file.vala"
	_tmp2_ = file;
#line 41 "../src/util/file.vala"
	_tmp1_ = claim_file (_tmp2_, &_inner_error0_);
#line 41 "../src/util/file.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 41 "../src/util/file.vala"
		g_propagate_error (error, _inner_error0_);
#line 41 "../src/util/file.vala"
		_g_object_unref0 (file);
#line 41 "../src/util/file.vala"
		return NULL;
#line 215 "file.c"
	}
#line 41 "../src/util/file.vala"
	if (_tmp1_) {
#line 42 "../src/util/file.vala"
		_vala_collision = FALSE;
#line 44 "../src/util/file.vala"
		result = file;
#line 44 "../src/util/file.vala"
		if (collision) {
#line 44 "../src/util/file.vala"
			*collision = _vala_collision;
#line 227 "file.c"
		}
#line 44 "../src/util/file.vala"
		return result;
#line 231 "file.c"
	}
#line 48 "../src/util/file.vala"
	_vala_collision = TRUE;
#line 51 "../src/util/file.vala"
	disassemble_filename (basename, &_tmp3_, &_tmp4_);
#line 51 "../src/util/file.vala"
	_g_free0 (name);
#line 51 "../src/util/file.vala"
	name = _tmp3_;
#line 51 "../src/util/file.vala"
	_g_free0 (ext);
#line 51 "../src/util/file.vala"
	ext = _tmp4_;
#line 245 "file.c"
	{
		gint ctr = 0;
#line 54 "../src/util/file.vala"
		ctr = 1;
#line 250 "file.c"
		{
			gboolean _tmp5_ = FALSE;
#line 54 "../src/util/file.vala"
			_tmp5_ = TRUE;
#line 54 "../src/util/file.vala"
			while (TRUE) {
#line 257 "file.c"
				gchar* _tmp7_ = NULL;
				const gchar* _tmp8_;
				gchar* new_name = NULL;
				gchar* _tmp14_;
				gboolean _tmp15_ = FALSE;
				const gchar* _tmp17_;
				GFile* _tmp18_;
				gboolean _tmp19_ = FALSE;
				GFile* _tmp20_;
#line 54 "../src/util/file.vala"
				if (!_tmp5_) {
#line 269 "file.c"
					gint _tmp6_;
#line 54 "../src/util/file.vala"
					_tmp6_ = ctr;
#line 54 "../src/util/file.vala"
					ctr = _tmp6_ + 1;
#line 275 "file.c"
				}
#line 54 "../src/util/file.vala"
				_tmp5_ = FALSE;
#line 54 "../src/util/file.vala"
				if (!(ctr < G_MAXINT)) {
#line 54 "../src/util/file.vala"
					break;
#line 283 "file.c"
				}
#line 55 "../src/util/file.vala"
				_tmp8_ = ext;
#line 55 "../src/util/file.vala"
				if (_tmp8_ != NULL) {
#line 289 "file.c"
					const gchar* _tmp9_;
					const gchar* _tmp10_;
					gchar* _tmp11_;
#line 55 "../src/util/file.vala"
					_tmp9_ = name;
#line 55 "../src/util/file.vala"
					_tmp10_ = ext;
#line 55 "../src/util/file.vala"
					_tmp11_ = g_strdup_printf ("%s_%d.%s", _tmp9_, ctr, _tmp10_);
#line 55 "../src/util/file.vala"
					_g_free0 (_tmp7_);
#line 55 "../src/util/file.vala"
					_tmp7_ = _tmp11_;
#line 303 "file.c"
				} else {
					const gchar* _tmp12_;
					gchar* _tmp13_;
#line 55 "../src/util/file.vala"
					_tmp12_ = name;
#line 55 "../src/util/file.vala"
					_tmp13_ = g_strdup_printf ("%s_%d", _tmp12_, ctr);
#line 55 "../src/util/file.vala"
					_g_free0 (_tmp7_);
#line 55 "../src/util/file.vala"
					_tmp7_ = _tmp13_;
#line 315 "file.c"
				}
#line 55 "../src/util/file.vala"
				_tmp14_ = g_strdup (_tmp7_);
#line 55 "../src/util/file.vala"
				new_name = _tmp14_;
#line 56 "../src/util/file.vala"
				if (used != NULL) {
#line 323 "file.c"
					const gchar* _tmp16_;
#line 56 "../src/util/file.vala"
					_tmp16_ = new_name;
#line 56 "../src/util/file.vala"
					_tmp15_ = gee_collection_contains (used, _tmp16_);
#line 329 "file.c"
				} else {
#line 56 "../src/util/file.vala"
					_tmp15_ = FALSE;
#line 333 "file.c"
				}
#line 56 "../src/util/file.vala"
				if (_tmp15_) {
#line 57 "../src/util/file.vala"
					_g_free0 (new_name);
#line 57 "../src/util/file.vala"
					_g_free0 (_tmp7_);
#line 57 "../src/util/file.vala"
					continue;
#line 343 "file.c"
				}
#line 59 "../src/util/file.vala"
				_tmp17_ = new_name;
#line 59 "../src/util/file.vala"
				_tmp18_ = g_file_get_child (dir, _tmp17_);
#line 59 "../src/util/file.vala"
				_g_object_unref0 (file);
#line 59 "../src/util/file.vala"
				file = _tmp18_;
#line 60 "../src/util/file.vala"
				_tmp20_ = file;
#line 60 "../src/util/file.vala"
				_tmp19_ = claim_file (_tmp20_, &_inner_error0_);
#line 60 "../src/util/file.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 60 "../src/util/file.vala"
					g_propagate_error (error, _inner_error0_);
#line 60 "../src/util/file.vala"
					_g_free0 (new_name);
#line 60 "../src/util/file.vala"
					_g_free0 (_tmp7_);
#line 60 "../src/util/file.vala"
					_g_free0 (ext);
#line 60 "../src/util/file.vala"
					_g_free0 (name);
#line 60 "../src/util/file.vala"
					_g_object_unref0 (file);
#line 60 "../src/util/file.vala"
					return NULL;
#line 373 "file.c"
				}
#line 60 "../src/util/file.vala"
				if (_tmp19_) {
#line 61 "../src/util/file.vala"
					result = file;
#line 61 "../src/util/file.vala"
					_g_free0 (new_name);
#line 61 "../src/util/file.vala"
					_g_free0 (_tmp7_);
#line 61 "../src/util/file.vala"
					_g_free0 (ext);
#line 61 "../src/util/file.vala"
					_g_free0 (name);
#line 61 "../src/util/file.vala"
					if (collision) {
#line 61 "../src/util/file.vala"
						*collision = _vala_collision;
#line 391 "file.c"
					}
#line 61 "../src/util/file.vala"
					return result;
#line 395 "file.c"
				}
#line 54 "../src/util/file.vala"
				_g_free0 (new_name);
#line 54 "../src/util/file.vala"
				_g_free0 (_tmp7_);
#line 401 "file.c"
			}
		}
	}
#line 64 "../src/util/file.vala"
	_tmp21_ = g_file_get_path (dir);
#line 64 "../src/util/file.vala"
	_tmp22_ = _tmp21_;
#line 64 "../src/util/file.vala"
	g_warning ("file.vala:64: generate_unique_filename %s for %s: unable to claim file", _tmp22_, basename);
#line 64 "../src/util/file.vala"
	_g_free0 (_tmp22_);
#line 66 "../src/util/file.vala"
	result = NULL;
#line 66 "../src/util/file.vala"
	_g_free0 (ext);
#line 66 "../src/util/file.vala"
	_g_free0 (name);
#line 66 "../src/util/file.vala"
	_g_object_unref0 (file);
#line 66 "../src/util/file.vala"
	if (collision) {
#line 66 "../src/util/file.vala"
		*collision = _vala_collision;
#line 425 "file.c"
	}
#line 66 "../src/util/file.vala"
	return result;
#line 429 "file.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1458 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1458 "glib-2.0.vapi"
	end = _tmp0_;
#line 1459 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1459 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1460 "glib-2.0.vapi"
		result = maxlen;
#line 1460 "glib-2.0.vapi"
		return result;
#line 452 "file.c"
	} else {
		gchar* _tmp2_;
#line 1462 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1462 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1462 "glib-2.0.vapi"
		return result;
#line 461 "file.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1469 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1471 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1471 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 480 "file.c"
	} else {
#line 1471 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 484 "file.c"
	}
#line 1471 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1473 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 490 "file.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1475 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1475 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1475 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 500 "file.c"
	}
#line 1478 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1479 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1480 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 508 "file.c"
	} else {
#line 1482 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 512 "file.c"
	}
#line 1484 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1485 "glib-2.0.vapi"
		len = string_length - offset;
#line 518 "file.c"
	}
#line 1487 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1488 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1488 "glib-2.0.vapi"
	result = _tmp3_;
#line 1488 "glib-2.0.vapi"
	return result;
#line 528 "file.c"
}

void
disassemble_filename (const gchar* basename,
                      gchar** name,
                      gchar** ext)
{
	gchar* _vala_name = NULL;
	gchar* _vala_ext = NULL;
	glong offset = 0L;
#line 69 "../src/util/file.vala"
	g_return_if_fail (basename != NULL);
#line 70 "../src/util/file.vala"
	offset = find_last_offset (basename, '.');
#line 71 "../src/util/file.vala"
	if (offset <= ((glong) 0)) {
#line 545 "file.c"
		gchar* _tmp0_;
#line 72 "../src/util/file.vala"
		_tmp0_ = g_strdup (basename);
#line 72 "../src/util/file.vala"
		_g_free0 (_vala_name);
#line 72 "../src/util/file.vala"
		_vala_name = _tmp0_;
#line 73 "../src/util/file.vala"
		_g_free0 (_vala_ext);
#line 73 "../src/util/file.vala"
		_vala_ext = NULL;
#line 557 "file.c"
	} else {
		gchar* _tmp1_;
		gchar* _tmp2_;
#line 75 "../src/util/file.vala"
		_tmp1_ = string_substring (basename, (glong) 0, offset);
#line 75 "../src/util/file.vala"
		_g_free0 (_vala_name);
#line 75 "../src/util/file.vala"
		_vala_name = _tmp1_;
#line 76 "../src/util/file.vala"
		_tmp2_ = string_substring (basename, offset + 1, (glong) -1);
#line 76 "../src/util/file.vala"
		_g_free0 (_vala_ext);
#line 76 "../src/util/file.vala"
		_vala_ext = _tmp2_;
#line 573 "file.c"
	}
#line 69 "../src/util/file.vala"
	if (name) {
#line 69 "../src/util/file.vala"
		*name = _vala_name;
#line 579 "file.c"
	} else {
#line 69 "../src/util/file.vala"
		_g_free0 (_vala_name);
#line 583 "file.c"
	}
#line 69 "../src/util/file.vala"
	if (ext) {
#line 69 "../src/util/file.vala"
		*ext = _vala_ext;
#line 589 "file.c"
	} else {
#line 69 "../src/util/file.vala"
		_g_free0 (_vala_ext);
#line 593 "file.c"
	}
}

guint64
query_total_file_size (GFile* file_or_dir,
                       GCancellable* cancellable,
                       GError** error)
{
	GFileType type = 0;
	GFileEnumerator* enumerator = NULL;
	guint64 total_bytes = 0ULL;
	GFileInfo* info = NULL;
	GError* _inner_error0_ = NULL;
	guint64 result;
#line 81 "../src/util/file.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file_or_dir, g_file_get_type ()), 0ULL);
#line 81 "../src/util/file.vala"
	g_return_val_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()), 0ULL);
#line 82 "../src/util/file.vala"
	type = g_file_query_file_type (file_or_dir, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL);
#line 83 "../src/util/file.vala"
	if (type == G_FILE_TYPE_REGULAR) {
#line 616 "file.c"
		GFileInfo* info = NULL;
		GFileInfo* _tmp11_;
#line 84 "../src/util/file.vala"
		info = NULL;
#line 621 "file.c"
		{
			GFileInfo* _tmp0_ = NULL;
			GFileInfo* _tmp1_;
			GFileInfo* _tmp2_;
#line 86 "../src/util/file.vala"
			_tmp1_ = g_file_query_info (file_or_dir, G_FILE_ATTRIBUTE_STANDARD_SIZE, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, cancellable, &_inner_error0_);
#line 86 "../src/util/file.vala"
			_tmp0_ = _tmp1_;
#line 86 "../src/util/file.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 632 "file.c"
				goto __catch0_g_error;
			}
#line 86 "../src/util/file.vala"
			_tmp2_ = _tmp0_;
#line 86 "../src/util/file.vala"
			_tmp0_ = NULL;
#line 86 "../src/util/file.vala"
			_g_object_unref0 (info);
#line 86 "../src/util/file.vala"
			info = _tmp2_;
#line 85 "../src/util/file.vala"
			_g_object_unref0 (_tmp0_);
#line 645 "file.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* err = NULL;
			GError* _tmp3_;
			gchar* _tmp6_;
			gchar* _tmp7_;
			GError* _tmp8_;
			const gchar* _tmp9_;
#line 85 "../src/util/file.vala"
			err = _inner_error0_;
#line 85 "../src/util/file.vala"
			_inner_error0_ = NULL;
#line 89 "../src/util/file.vala"
			_tmp3_ = err;
#line 89 "../src/util/file.vala"
			if (g_error_matches (_tmp3_, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
#line 664 "file.c"
				GError* _tmp4_;
				GError* _tmp5_;
#line 90 "../src/util/file.vala"
				_tmp4_ = err;
#line 90 "../src/util/file.vala"
				_tmp5_ = _g_error_copy0 (_tmp4_);
#line 90 "../src/util/file.vala"
				_inner_error0_ = _tmp5_;
#line 90 "../src/util/file.vala"
				_g_error_free0 (err);
#line 675 "file.c"
				goto __finally0;
			}
#line 92 "../src/util/file.vala"
			_tmp6_ = g_file_get_path (file_or_dir);
#line 92 "../src/util/file.vala"
			_tmp7_ = _tmp6_;
#line 92 "../src/util/file.vala"
			_tmp8_ = err;
#line 92 "../src/util/file.vala"
			_tmp9_ = _tmp8_->message;
#line 92 "../src/util/file.vala"
			g_debug ("file.vala:92: Unable to query filesize for %s: %s", _tmp7_, _tmp9_);
#line 92 "../src/util/file.vala"
			_g_free0 (_tmp7_);
#line 94 "../src/util/file.vala"
			result = (guint64) 0;
#line 94 "../src/util/file.vala"
			_g_error_free0 (err);
#line 94 "../src/util/file.vala"
			_g_object_unref0 (info);
#line 94 "../src/util/file.vala"
			return result;
#line 698 "file.c"
		}
		__finally0:
#line 85 "../src/util/file.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 703 "file.c"
			guint64 _tmp10_ = 0ULL;
#line 85 "../src/util/file.vala"
			g_propagate_error (error, _inner_error0_);
#line 85 "../src/util/file.vala"
			_g_object_unref0 (info);
#line 85 "../src/util/file.vala"
			return _tmp10_;
#line 711 "file.c"
		}
#line 97 "../src/util/file.vala"
		_tmp11_ = info;
#line 97 "../src/util/file.vala"
		result = (guint64) g_file_info_get_size (_tmp11_);
#line 97 "../src/util/file.vala"
		_g_object_unref0 (info);
#line 97 "../src/util/file.vala"
		return result;
#line 721 "file.c"
	} else {
#line 98 "../src/util/file.vala"
		if (type != G_FILE_TYPE_DIRECTORY) {
#line 99 "../src/util/file.vala"
			result = (guint64) 0;
#line 99 "../src/util/file.vala"
			return result;
#line 729 "file.c"
		}
	}
	{
		GFileEnumerator* _tmp12_ = NULL;
		GFileEnumerator* _tmp13_;
		GFileEnumerator* _tmp14_;
		GFileEnumerator* _tmp15_;
#line 104 "../src/util/file.vala"
		_tmp13_ = g_file_enumerate_children (file_or_dir, G_FILE_ATTRIBUTE_STANDARD_NAME, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, cancellable, &_inner_error0_);
#line 104 "../src/util/file.vala"
		_tmp12_ = _tmp13_;
#line 104 "../src/util/file.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 743 "file.c"
			goto __catch1_g_error;
		}
#line 104 "../src/util/file.vala"
		_tmp14_ = _tmp12_;
#line 104 "../src/util/file.vala"
		_tmp12_ = NULL;
#line 104 "../src/util/file.vala"
		_g_object_unref0 (enumerator);
#line 104 "../src/util/file.vala"
		enumerator = _tmp14_;
#line 106 "../src/util/file.vala"
		_tmp15_ = enumerator;
#line 106 "../src/util/file.vala"
		if (_tmp15_ == NULL) {
#line 107 "../src/util/file.vala"
			result = (guint64) 0;
#line 107 "../src/util/file.vala"
			_g_object_unref0 (_tmp12_);
#line 107 "../src/util/file.vala"
			_g_object_unref0 (enumerator);
#line 107 "../src/util/file.vala"
			return result;
#line 766 "file.c"
		}
#line 103 "../src/util/file.vala"
		_g_object_unref0 (_tmp12_);
#line 770 "file.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* err = NULL;
		gboolean _tmp16_ = FALSE;
		GError* _tmp17_;
		GError* _tmp19_;
		GError* _tmp20_;
#line 103 "../src/util/file.vala"
		err = _inner_error0_;
#line 103 "../src/util/file.vala"
		_inner_error0_ = NULL;
#line 110 "../src/util/file.vala"
		_tmp17_ = err;
#line 110 "../src/util/file.vala"
		if (g_error_matches (_tmp17_, G_FILE_ERROR, G_FILE_ERROR_PERM)) {
#line 110 "../src/util/file.vala"
			_tmp16_ = TRUE;
#line 790 "file.c"
		} else {
			GError* _tmp18_;
#line 110 "../src/util/file.vala"
			_tmp18_ = err;
#line 110 "../src/util/file.vala"
			_tmp16_ = g_error_matches (_tmp18_, G_IO_ERROR, G_IO_ERROR_PERMISSION_DENIED);
#line 797 "file.c"
		}
#line 110 "../src/util/file.vala"
		if (_tmp16_) {
#line 111 "../src/util/file.vala"
			result = (guint64) 0;
#line 111 "../src/util/file.vala"
			_g_error_free0 (err);
#line 111 "../src/util/file.vala"
			_g_object_unref0 (enumerator);
#line 111 "../src/util/file.vala"
			return result;
#line 809 "file.c"
		}
#line 113 "../src/util/file.vala"
		_tmp19_ = err;
#line 113 "../src/util/file.vala"
		_tmp20_ = _g_error_copy0 (_tmp19_);
#line 113 "../src/util/file.vala"
		_inner_error0_ = _tmp20_;
#line 113 "../src/util/file.vala"
		_g_error_free0 (err);
#line 819 "file.c"
		goto __finally1;
	}
	__finally1:
#line 103 "../src/util/file.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 825 "file.c"
		guint64 _tmp21_ = 0ULL;
#line 103 "../src/util/file.vala"
		g_propagate_error (error, _inner_error0_);
#line 103 "../src/util/file.vala"
		_g_object_unref0 (enumerator);
#line 103 "../src/util/file.vala"
		return _tmp21_;
#line 833 "file.c"
	}
#line 116 "../src/util/file.vala"
	total_bytes = (guint64) 0;
#line 118 "../src/util/file.vala"
	info = NULL;
#line 119 "../src/util/file.vala"
	while (TRUE) {
#line 841 "file.c"
		GFileInfo* _tmp22_ = NULL;
		GFileEnumerator* _tmp23_;
		GFileInfo* _tmp24_;
		GFileInfo* _tmp26_;
		GFileInfo* _tmp27_;
		guint64 _tmp28_ = 0ULL;
		GFileInfo* _tmp29_;
		const gchar* _tmp30_;
		GFile* _tmp31_;
		GFile* _tmp32_;
		guint64 _tmp33_;
#line 119 "../src/util/file.vala"
		_tmp23_ = enumerator;
#line 119 "../src/util/file.vala"
		_tmp24_ = g_file_enumerator_next_file (_tmp23_, cancellable, &_inner_error0_);
#line 119 "../src/util/file.vala"
		_tmp22_ = _tmp24_;
#line 119 "../src/util/file.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 861 "file.c"
			guint64 _tmp25_ = 0ULL;
#line 119 "../src/util/file.vala"
			g_propagate_error (error, _inner_error0_);
#line 119 "../src/util/file.vala"
			_g_object_unref0 (info);
#line 119 "../src/util/file.vala"
			_g_object_unref0 (enumerator);
#line 119 "../src/util/file.vala"
			return _tmp25_;
#line 871 "file.c"
		}
#line 119 "../src/util/file.vala"
		_tmp26_ = _tmp22_;
#line 119 "../src/util/file.vala"
		_tmp22_ = NULL;
#line 119 "../src/util/file.vala"
		_g_object_unref0 (info);
#line 119 "../src/util/file.vala"
		info = _tmp26_;
#line 119 "../src/util/file.vala"
		_tmp27_ = info;
#line 119 "../src/util/file.vala"
		if (!(_tmp27_ != NULL)) {
#line 119 "../src/util/file.vala"
			_g_object_unref0 (_tmp22_);
#line 119 "../src/util/file.vala"
			break;
#line 889 "file.c"
		}
#line 120 "../src/util/file.vala"
		_tmp29_ = info;
#line 120 "../src/util/file.vala"
		_tmp30_ = g_file_info_get_name (_tmp29_);
#line 120 "../src/util/file.vala"
		_tmp31_ = g_file_get_child (file_or_dir, _tmp30_);
#line 120 "../src/util/file.vala"
		_tmp32_ = _tmp31_;
#line 120 "../src/util/file.vala"
		_tmp33_ = query_total_file_size (_tmp32_, cancellable, &_inner_error0_);
#line 120 "../src/util/file.vala"
		_g_object_unref0 (_tmp32_);
#line 120 "../src/util/file.vala"
		_tmp28_ = _tmp33_;
#line 120 "../src/util/file.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 907 "file.c"
			guint64 _tmp34_ = 0ULL;
#line 120 "../src/util/file.vala"
			g_propagate_error (error, _inner_error0_);
#line 120 "../src/util/file.vala"
			_g_object_unref0 (_tmp22_);
#line 120 "../src/util/file.vala"
			_g_object_unref0 (info);
#line 120 "../src/util/file.vala"
			_g_object_unref0 (enumerator);
#line 120 "../src/util/file.vala"
			return _tmp34_;
#line 919 "file.c"
		}
#line 120 "../src/util/file.vala"
		total_bytes += _tmp28_;
#line 119 "../src/util/file.vala"
		_g_object_unref0 (_tmp22_);
#line 925 "file.c"
	}
#line 122 "../src/util/file.vala"
	result = total_bytes;
#line 122 "../src/util/file.vala"
	_g_object_unref0 (info);
#line 122 "../src/util/file.vala"
	_g_object_unref0 (enumerator);
#line 122 "../src/util/file.vala"
	return result;
#line 935 "file.c"
}

void
delete_all_files (GFile* dir,
                  GeeSet* exceptions,
                  ProgressMonitor monitor,
                  gpointer monitor_target,
                  guint64 file_count,
                  GCancellable* cancellable,
                  GError** error)
{
	GFileType type = 0;
	GFileEnumerator* enumerator = NULL;
	GFileEnumerator* _tmp6_;
	GFileInfo* info = NULL;
	guint64 i = 0ULL;
	GError* _inner_error0_ = NULL;
#line 129 "../src/util/file.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (dir, g_file_get_type ()));
#line 129 "../src/util/file.vala"
	g_return_if_fail ((exceptions == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (exceptions, GEE_TYPE_SET));
#line 129 "../src/util/file.vala"
	g_return_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()));
#line 131 "../src/util/file.vala"
	type = g_file_query_file_type (dir, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL);
#line 132 "../src/util/file.vala"
	if (type != G_FILE_TYPE_DIRECTORY) {
#line 963 "file.c"
		gchar* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		GError* _tmp4_;
		GError* _tmp5_;
#line 133 "../src/util/file.vala"
		_tmp0_ = g_file_get_path (dir);
#line 133 "../src/util/file.vala"
		_tmp1_ = _tmp0_;
#line 133 "../src/util/file.vala"
		_tmp2_ = g_strdup_printf ("%s is not a directory", _tmp1_);
#line 133 "../src/util/file.vala"
		_tmp3_ = _tmp2_;
#line 133 "../src/util/file.vala"
		_tmp4_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_NOT_DIRECTORY, _tmp3_);
#line 133 "../src/util/file.vala"
		_tmp5_ = _tmp4_;
#line 133 "../src/util/file.vala"
		_g_free0 (_tmp3_);
#line 133 "../src/util/file.vala"
		_g_free0 (_tmp1_);
#line 133 "../src/util/file.vala"
		_inner_error0_ = _tmp5_;
#line 133 "../src/util/file.vala"
		g_propagate_error (error, _inner_error0_);
#line 133 "../src/util/file.vala"
		return;
#line 992 "file.c"
	}
#line 135 "../src/util/file.vala"
	_tmp6_ = g_file_enumerate_children (dir, "standard::name,standard::type", G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, cancellable, &_inner_error0_);
#line 135 "../src/util/file.vala"
	enumerator = _tmp6_;
#line 135 "../src/util/file.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 135 "../src/util/file.vala"
		g_propagate_error (error, _inner_error0_);
#line 135 "../src/util/file.vala"
		return;
#line 1004 "file.c"
	}
#line 137 "../src/util/file.vala"
	info = NULL;
#line 138 "../src/util/file.vala"
	i = (guint64) 0;
#line 139 "../src/util/file.vala"
	while (TRUE) {
#line 1012 "file.c"
		GFileInfo* _tmp7_ = NULL;
		GFileEnumerator* _tmp8_;
		GFileInfo* _tmp9_;
		GFileInfo* _tmp10_;
		GFileInfo* _tmp11_;
		GFileInfo* _tmp12_;
		gboolean _tmp13_ = FALSE;
		GFile* file = NULL;
		GFileInfo* _tmp16_;
		const gchar* _tmp17_;
		GFile* _tmp18_;
		gboolean _tmp25_ = FALSE;
#line 139 "../src/util/file.vala"
		_tmp8_ = enumerator;
#line 139 "../src/util/file.vala"
		_tmp9_ = g_file_enumerator_next_file (_tmp8_, cancellable, &_inner_error0_);
#line 139 "../src/util/file.vala"
		_tmp7_ = _tmp9_;
#line 139 "../src/util/file.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 139 "../src/util/file.vala"
			g_propagate_error (error, _inner_error0_);
#line 139 "../src/util/file.vala"
			_g_object_unref0 (info);
#line 139 "../src/util/file.vala"
			_g_object_unref0 (enumerator);
#line 139 "../src/util/file.vala"
			return;
#line 1041 "file.c"
		}
#line 139 "../src/util/file.vala"
		_tmp10_ = _tmp7_;
#line 139 "../src/util/file.vala"
		_tmp7_ = NULL;
#line 139 "../src/util/file.vala"
		_g_object_unref0 (info);
#line 139 "../src/util/file.vala"
		info = _tmp10_;
#line 139 "../src/util/file.vala"
		_tmp11_ = info;
#line 139 "../src/util/file.vala"
		if (!(_tmp11_ != NULL)) {
#line 139 "../src/util/file.vala"
			_g_object_unref0 (_tmp7_);
#line 139 "../src/util/file.vala"
			break;
#line 1059 "file.c"
		}
#line 140 "../src/util/file.vala"
		_tmp12_ = info;
#line 140 "../src/util/file.vala"
		if (g_file_info_get_file_type (_tmp12_) != G_FILE_TYPE_REGULAR) {
#line 141 "../src/util/file.vala"
			_g_object_unref0 (_tmp7_);
#line 141 "../src/util/file.vala"
			continue;
#line 1069 "file.c"
		}
#line 143 "../src/util/file.vala"
		if (exceptions != NULL) {
#line 1073 "file.c"
			GFileInfo* _tmp14_;
			const gchar* _tmp15_;
#line 143 "../src/util/file.vala"
			_tmp14_ = info;
#line 143 "../src/util/file.vala"
			_tmp15_ = g_file_info_get_name (_tmp14_);
#line 143 "../src/util/file.vala"
			_tmp13_ = gee_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (exceptions, GEE_TYPE_COLLECTION, GeeCollection), _tmp15_);
#line 1082 "file.c"
		} else {
#line 143 "../src/util/file.vala"
			_tmp13_ = FALSE;
#line 1086 "file.c"
		}
#line 143 "../src/util/file.vala"
		if (_tmp13_) {
#line 144 "../src/util/file.vala"
			_g_object_unref0 (_tmp7_);
#line 144 "../src/util/file.vala"
			continue;
#line 1094 "file.c"
		}
#line 146 "../src/util/file.vala"
		_tmp16_ = info;
#line 146 "../src/util/file.vala"
		_tmp17_ = g_file_info_get_name (_tmp16_);
#line 146 "../src/util/file.vala"
		_tmp18_ = g_file_get_child (dir, _tmp17_);
#line 146 "../src/util/file.vala"
		file = _tmp18_;
#line 1104 "file.c"
		{
			GFile* _tmp19_;
#line 148 "../src/util/file.vala"
			_tmp19_ = file;
#line 148 "../src/util/file.vala"
			g_file_delete (_tmp19_, cancellable, &_inner_error0_);
#line 148 "../src/util/file.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1113 "file.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* err = NULL;
			GFile* _tmp20_;
			gchar* _tmp21_;
			gchar* _tmp22_;
			GError* _tmp23_;
			const gchar* _tmp24_;
#line 147 "../src/util/file.vala"
			err = _inner_error0_;
#line 147 "../src/util/file.vala"
			_inner_error0_ = NULL;
#line 150 "../src/util/file.vala"
			_tmp20_ = file;
#line 150 "../src/util/file.vala"
			_tmp21_ = g_file_get_path (_tmp20_);
#line 150 "../src/util/file.vala"
			_tmp22_ = _tmp21_;
#line 150 "../src/util/file.vala"
			_tmp23_ = err;
#line 150 "../src/util/file.vala"
			_tmp24_ = _tmp23_->message;
#line 150 "../src/util/file.vala"
			g_warning ("file.vala:150: Unable to delete file %s: %s", _tmp22_, _tmp24_);
#line 150 "../src/util/file.vala"
			_g_free0 (_tmp22_);
#line 147 "../src/util/file.vala"
			_g_error_free0 (err);
#line 1146 "file.c"
		}
		__finally0:
#line 147 "../src/util/file.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 147 "../src/util/file.vala"
			g_propagate_error (error, _inner_error0_);
#line 147 "../src/util/file.vala"
			_g_object_unref0 (file);
#line 147 "../src/util/file.vala"
			_g_object_unref0 (_tmp7_);
#line 147 "../src/util/file.vala"
			_g_object_unref0 (info);
#line 147 "../src/util/file.vala"
			_g_object_unref0 (enumerator);
#line 147 "../src/util/file.vala"
			return;
#line 1163 "file.c"
		}
#line 153 "../src/util/file.vala"
		if (monitor != NULL) {
#line 153 "../src/util/file.vala"
			_tmp25_ = file_count > ((guint64) 0);
#line 1169 "file.c"
		} else {
#line 153 "../src/util/file.vala"
			_tmp25_ = FALSE;
#line 1173 "file.c"
		}
#line 153 "../src/util/file.vala"
		if (_tmp25_) {
#line 1177 "file.c"
			ProgressMonitor _tmp26_;
			gpointer _tmp26__target;
			guint64 _tmp27_;
			guint64 _tmp28_;
#line 154 "../src/util/file.vala"
			_tmp26_ = monitor;
#line 154 "../src/util/file.vala"
			_tmp26__target = monitor_target;
#line 154 "../src/util/file.vala"
			_tmp27_ = file_count;
#line 154 "../src/util/file.vala"
			i = i + 1;
#line 154 "../src/util/file.vala"
			_tmp28_ = i;
#line 154 "../src/util/file.vala"
			_tmp26_ (_tmp27_, _tmp28_, TRUE, _tmp26__target);
#line 1194 "file.c"
		}
#line 139 "../src/util/file.vala"
		_g_object_unref0 (file);
#line 139 "../src/util/file.vala"
		_g_object_unref0 (_tmp7_);
#line 1200 "file.c"
	}
#line 129 "../src/util/file.vala"
	_g_object_unref0 (info);
#line 129 "../src/util/file.vala"
	_g_object_unref0 (enumerator);
#line 1206 "file.c"
}

GDateTime*
query_file_modified (GFile* file,
                     GError** error)
{
	GFileInfo* info = NULL;
	GFileInfo* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	GDateTime* _tmp4_;
	GError* _inner_error0_ = NULL;
	GDateTime* result;
#line 158 "../src/util/file.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 159 "../src/util/file.vala"
	_tmp0_ = g_file_query_info (file, G_FILE_ATTRIBUTE_TIME_MODIFIED, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 159 "../src/util/file.vala"
	info = _tmp0_;
#line 159 "../src/util/file.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 159 "../src/util/file.vala"
		g_propagate_error (error, _inner_error0_);
#line 159 "../src/util/file.vala"
		return NULL;
#line 1233 "file.c"
	}
#line 162 "../src/util/file.vala"
	_tmp1_ = g_file_info_get_modification_date_time (info);
#line 162 "../src/util/file.vala"
	_tmp2_ = _tmp1_;
#line 162 "../src/util/file.vala"
	_tmp3_ = coarsify_date_time (_tmp2_);
#line 162 "../src/util/file.vala"
	_tmp4_ = _tmp3_;
#line 162 "../src/util/file.vala"
	_g_date_time_unref0 (_tmp2_);
#line 162 "../src/util/file.vala"
	result = _tmp4_;
#line 162 "../src/util/file.vala"
	_g_object_unref0 (info);
#line 162 "../src/util/file.vala"
	return result;
#line 1251 "file.c"
}

gboolean
query_is_directory (GFile* file)
{
	gboolean result;
#line 165 "../src/util/file.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), FALSE);
#line 166 "../src/util/file.vala"
	result = g_file_query_file_type (file, G_FILE_QUERY_INFO_NONE, NULL) == G_FILE_TYPE_DIRECTORY;
#line 166 "../src/util/file.vala"
	return result;
#line 1264 "file.c"
}

gboolean
query_is_directory_empty (GFile* dir,
                          GError** error)
{
	GFileEnumerator* enumerator = NULL;
	GFileEnumerator* _tmp0_;
	GFileEnumerator* _tmp2_;
	GFileInfo* _tmp3_ = NULL;
	GFileEnumerator* _tmp4_;
	GFileInfo* _tmp5_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 169 "../src/util/file.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (dir, g_file_get_type ()), FALSE);
#line 170 "../src/util/file.vala"
	if (g_file_query_file_type (dir, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL) != G_FILE_TYPE_DIRECTORY) {
#line 171 "../src/util/file.vala"
		result = FALSE;
#line 171 "../src/util/file.vala"
		return result;
#line 1287 "file.c"
	}
#line 173 "../src/util/file.vala"
	_tmp0_ = g_file_enumerate_children (dir, "standard::name", G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 173 "../src/util/file.vala"
	enumerator = _tmp0_;
#line 173 "../src/util/file.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1295 "file.c"
		gboolean _tmp1_ = FALSE;
#line 173 "../src/util/file.vala"
		g_propagate_error (error, _inner_error0_);
#line 173 "../src/util/file.vala"
		return _tmp1_;
#line 1301 "file.c"
	}
#line 175 "../src/util/file.vala"
	_tmp2_ = enumerator;
#line 175 "../src/util/file.vala"
	if (_tmp2_ == NULL) {
#line 176 "../src/util/file.vala"
		result = FALSE;
#line 176 "../src/util/file.vala"
		_g_object_unref0 (enumerator);
#line 176 "../src/util/file.vala"
		return result;
#line 1313 "file.c"
	}
#line 178 "../src/util/file.vala"
	_tmp4_ = enumerator;
#line 178 "../src/util/file.vala"
	_tmp5_ = g_file_enumerator_next_file (_tmp4_, NULL, &_inner_error0_);
#line 178 "../src/util/file.vala"
	_tmp3_ = _tmp5_;
#line 178 "../src/util/file.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1323 "file.c"
		gboolean _tmp6_ = FALSE;
#line 178 "../src/util/file.vala"
		g_propagate_error (error, _inner_error0_);
#line 178 "../src/util/file.vala"
		_g_object_unref0 (enumerator);
#line 178 "../src/util/file.vala"
		return _tmp6_;
#line 1331 "file.c"
	}
#line 178 "../src/util/file.vala"
	result = _tmp3_ == NULL;
#line 178 "../src/util/file.vala"
	_g_object_unref0 (_tmp3_);
#line 178 "../src/util/file.vala"
	_g_object_unref0 (enumerator);
#line 178 "../src/util/file.vala"
	return result;
#line 1341 "file.c"
}

gchar*
get_display_pathname (GFile* file)
{
	gchar* path = NULL;
	gchar* _tmp0_;
	gchar* home = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* result;
#line 181 "../src/util/file.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 183 "../src/util/file.vala"
	_tmp0_ = g_file_get_parse_name (file);
#line 183 "../src/util/file.vala"
	path = _tmp0_;
#line 184 "../src/util/file.vala"
	_tmp1_ = g_get_home_dir ();
#line 184 "../src/util/file.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 184 "../src/util/file.vala"
	home = _tmp2_;
#line 186 "../src/util/file.vala"
	_tmp3_ = path;
#line 186 "../src/util/file.vala"
	_tmp4_ = home;
#line 186 "../src/util/file.vala"
	if (g_strcmp0 (_tmp3_, _tmp4_) == 0) {
#line 1375 "file.c"
		gchar* _tmp5_;
#line 187 "../src/util/file.vala"
		_tmp5_ = g_strdup ("~");
#line 187 "../src/util/file.vala"
		result = _tmp5_;
#line 187 "../src/util/file.vala"
		_g_free0 (home);
#line 187 "../src/util/file.vala"
		_g_free0 (path);
#line 187 "../src/util/file.vala"
		return result;
#line 1387 "file.c"
	}
#line 189 "../src/util/file.vala"
	_tmp6_ = path;
#line 189 "../src/util/file.vala"
	_tmp7_ = home;
#line 189 "../src/util/file.vala"
	if (g_str_has_prefix (_tmp6_, _tmp7_)) {
#line 1395 "file.c"
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
#line 190 "../src/util/file.vala"
		_tmp8_ = path;
#line 190 "../src/util/file.vala"
		_tmp9_ = home;
#line 190 "../src/util/file.vala"
		_tmp10_ = strlen (_tmp9_);
#line 190 "../src/util/file.vala"
		_tmp11_ = _tmp10_;
#line 190 "../src/util/file.vala"
		_tmp12_ = string_substring (_tmp8_, (glong) _tmp11_, (glong) -1);
#line 190 "../src/util/file.vala"
		_tmp13_ = _tmp12_;
#line 190 "../src/util/file.vala"
		_tmp14_ = g_strdup_printf ("~%s", _tmp13_);
#line 190 "../src/util/file.vala"
		_tmp15_ = _tmp14_;
#line 190 "../src/util/file.vala"
		_g_free0 (_tmp13_);
#line 190 "../src/util/file.vala"
		result = _tmp15_;
#line 190 "../src/util/file.vala"
		_g_free0 (home);
#line 190 "../src/util/file.vala"
		_g_free0 (path);
#line 190 "../src/util/file.vala"
		return result;
#line 1430 "file.c"
	}
#line 192 "../src/util/file.vala"
	result = path;
#line 192 "../src/util/file.vala"
	_g_free0 (home);
#line 192 "../src/util/file.vala"
	return result;
#line 1438 "file.c"
}

gchar*
strip_pretty_path (const gchar* path)
{
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* result;
#line 195 "../src/util/file.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 196 "../src/util/file.vala"
	if (!g_str_has_prefix (path, "~")) {
#line 1454 "file.c"
		gchar* _tmp0_;
#line 197 "../src/util/file.vala"
		_tmp0_ = g_strdup (path);
#line 197 "../src/util/file.vala"
		result = _tmp0_;
#line 197 "../src/util/file.vala"
		return result;
#line 1462 "file.c"
	}
#line 199 "../src/util/file.vala"
	_tmp1_ = g_get_home_dir ();
#line 199 "../src/util/file.vala"
	_tmp2_ = string_substring (path, (glong) 1, (glong) -1);
#line 199 "../src/util/file.vala"
	_tmp3_ = _tmp2_;
#line 199 "../src/util/file.vala"
	_tmp4_ = g_strconcat (_tmp1_, _tmp3_, NULL);
#line 199 "../src/util/file.vala"
	_tmp5_ = _tmp4_;
#line 199 "../src/util/file.vala"
	_g_free0 (_tmp3_);
#line 199 "../src/util/file.vala"
	result = _tmp5_;
#line 199 "../src/util/file.vala"
	return result;
#line 1480 "file.c"
}

gchar*
get_file_info_id (GFileInfo* info)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 202 "../src/util/file.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (info, g_file_info_get_type ()), NULL);
#line 203 "../src/util/file.vala"
	_tmp0_ = g_file_info_get_attribute_string (info, G_FILE_ATTRIBUTE_ID_FILE);
#line 203 "../src/util/file.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 203 "../src/util/file.vala"
	result = _tmp1_;
#line 203 "../src/util/file.vala"
	return result;
#line 1499 "file.c"
}

guint64
count_files_in_directory (GFile* dir,
                          GError** error)
{
	guint64 count = 0ULL;
	GFileEnumerator* enumerator = NULL;
	GFileEnumerator* _tmp0_;
	GFileInfo* info = NULL;
	GError* _inner_error0_ = NULL;
	guint64 result;
#line 207 "../src/util/file.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (dir, g_file_get_type ()), 0ULL);
#line 208 "../src/util/file.vala"
	if (!query_is_directory (dir)) {
#line 209 "../src/util/file.vala"
		result = (guint64) 0;
#line 209 "../src/util/file.vala"
		return result;
#line 1520 "file.c"
	}
#line 211 "../src/util/file.vala"
	count = (guint64) 0;
#line 212 "../src/util/file.vala"
	_tmp0_ = g_file_enumerate_children (dir, "standard::*", G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 212 "../src/util/file.vala"
	enumerator = _tmp0_;
#line 212 "../src/util/file.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1530 "file.c"
		guint64 _tmp1_ = 0ULL;
#line 212 "../src/util/file.vala"
		g_propagate_error (error, _inner_error0_);
#line 212 "../src/util/file.vala"
		return _tmp1_;
#line 1536 "file.c"
	}
#line 215 "../src/util/file.vala"
	info = NULL;
#line 216 "../src/util/file.vala"
	while (TRUE) {
#line 1542 "file.c"
		GFileInfo* _tmp2_ = NULL;
		GFileEnumerator* _tmp3_;
		GFileInfo* _tmp4_;
		GFileInfo* _tmp6_;
		GFileInfo* _tmp7_;
		guint64 _tmp8_;
#line 216 "../src/util/file.vala"
		_tmp3_ = enumerator;
#line 216 "../src/util/file.vala"
		_tmp4_ = g_file_enumerator_next_file (_tmp3_, NULL, &_inner_error0_);
#line 216 "../src/util/file.vala"
		_tmp2_ = _tmp4_;
#line 216 "../src/util/file.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1557 "file.c"
			guint64 _tmp5_ = 0ULL;
#line 216 "../src/util/file.vala"
			g_propagate_error (error, _inner_error0_);
#line 216 "../src/util/file.vala"
			_g_object_unref0 (info);
#line 216 "../src/util/file.vala"
			_g_object_unref0 (enumerator);
#line 216 "../src/util/file.vala"
			return _tmp5_;
#line 1567 "file.c"
		}
#line 216 "../src/util/file.vala"
		_tmp6_ = _tmp2_;
#line 216 "../src/util/file.vala"
		_tmp2_ = NULL;
#line 216 "../src/util/file.vala"
		_g_object_unref0 (info);
#line 216 "../src/util/file.vala"
		info = _tmp6_;
#line 216 "../src/util/file.vala"
		_tmp7_ = info;
#line 216 "../src/util/file.vala"
		if (!(_tmp7_ != NULL)) {
#line 216 "../src/util/file.vala"
			_g_object_unref0 (_tmp2_);
#line 216 "../src/util/file.vala"
			break;
#line 1585 "file.c"
		}
#line 217 "../src/util/file.vala"
		_tmp8_ = count;
#line 217 "../src/util/file.vala"
		count = _tmp8_ + 1;
#line 216 "../src/util/file.vala"
		_g_object_unref0 (_tmp2_);
#line 1593 "file.c"
	}
#line 219 "../src/util/file.vala"
	result = count;
#line 219 "../src/util/file.vala"
	_g_object_unref0 (info);
#line 219 "../src/util/file.vala"
	_g_object_unref0 (enumerator);
#line 219 "../src/util/file.vala"
	return result;
#line 1603 "file.c"
}

gboolean
file_equal (GFile* a,
            GFile* b)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean result;
#line 223 "../src/util/file.vala"
	g_return_val_if_fail ((a == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (a, g_file_get_type ()), FALSE);
#line 223 "../src/util/file.vala"
	g_return_val_if_fail ((b == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (b, g_file_get_type ()), FALSE);
#line 224 "../src/util/file.vala"
	if (a != NULL) {
#line 224 "../src/util/file.vala"
		_tmp1_ = b != NULL;
#line 1621 "file.c"
	} else {
#line 224 "../src/util/file.vala"
		_tmp1_ = FALSE;
#line 1625 "file.c"
	}
#line 224 "../src/util/file.vala"
	if (_tmp1_) {
#line 224 "../src/util/file.vala"
		_tmp0_ = g_file_equal (a, b);
#line 1631 "file.c"
	} else {
#line 224 "../src/util/file.vala"
		_tmp0_ = FALSE;
#line 1635 "file.c"
	}
#line 224 "../src/util/file.vala"
	result = _tmp0_;
#line 224 "../src/util/file.vala"
	return result;
#line 1641 "file.c"
}

guint
file_hash (GFile* file)
{
	guint _tmp0_ = 0U;
	guint result;
#line 228 "../src/util/file.vala"
	g_return_val_if_fail ((file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), 0U);
#line 229 "../src/util/file.vala"
	if (file != NULL) {
#line 229 "../src/util/file.vala"
		_tmp0_ = g_file_hash (file);
#line 1655 "file.c"
	} else {
#line 229 "../src/util/file.vala"
		_tmp0_ = (guint) 0;
#line 1659 "file.c"
	}
#line 229 "../src/util/file.vala"
	result = _tmp0_;
#line 229 "../src/util/file.vala"
	return result;
#line 1665 "file.c"
}

