/* string.c generated by valac 0.56.14, the Vala compiler
 * generated from string.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>

#define DEFAULT_USER_TEXT_INPUT_LENGTH 1024
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
typedef enum  {
	PREPARE_INPUT_TEXT_OPTIONS_EMPTY_IS_NULL = 1 << 0,
	PREPARE_INPUT_TEXT_OPTIONS_VALIDATE = 1 << 1,
	PREPARE_INPUT_TEXT_OPTIONS_INVALID_IS_NULL = 1 << 2,
	PREPARE_INPUT_TEXT_OPTIONS_STRIP = 1 << 3,
	PREPARE_INPUT_TEXT_OPTIONS_STRIP_CRLF = 1 << 4,
	PREPARE_INPUT_TEXT_OPTIONS_NORMALIZE = 1 << 5,
	PREPARE_INPUT_TEXT_OPTIONS_DEFAULT = ((((PREPARE_INPUT_TEXT_OPTIONS_EMPTY_IS_NULL | PREPARE_INPUT_TEXT_OPTIONS_VALIDATE) | PREPARE_INPUT_TEXT_OPTIONS_INVALID_IS_NULL) | PREPARE_INPUT_TEXT_OPTIONS_STRIP_CRLF) | PREPARE_INPUT_TEXT_OPTIONS_STRIP) | PREPARE_INPUT_TEXT_OPTIONS_NORMALIZE
} PrepareInputTextOptions;

#define TYPE_PREPARE_INPUT_TEXT_OPTIONS (prepare_input_text_options_get_type ())
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

VALA_EXTERN gboolean is_string_empty (const gchar* s);
VALA_EXTERN gint utf8_cs_compare (const gchar* a,
                      const gchar* b);
VALA_EXTERN gint utf8_ci_compare (const gchar* a,
                      const gchar* b);
VALA_EXTERN gchar* uchar_array_to_string (guchar* data,
                              gint data_length1,
                              gint length);
VALA_EXTERN guchar* string_to_uchar_array (const gchar* str,
                               gint* result_length1);
static void _vala_array_add1 (guchar* * array,
                       gint* length,
                       gint* size,
                       guchar value);
VALA_EXTERN gchar* guarded_markup_escape_text (const gchar* plain);
VALA_EXTERN glong find_last_offset (const gchar* str,
                        gchar c);
VALA_EXTERN gboolean is_in_ci_array (const gchar* str,
                         gchar** strings,
                         gint strings_length1);
VALA_EXTERN GType prepare_input_text_options_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gchar* guess_convert (const gchar* text);
VALA_EXTERN gchar* prepare_input_text (const gchar* text,
                           PrepareInputTextOptions options,
                           gint dest_length);
VALA_EXTERN gboolean string_contains_char (const gchar* haystack,
                               gunichar needle);
VALA_EXTERN gboolean string_contains_str (const gchar* haystack,
                              const gchar* needle);
VALA_EXTERN gchar* string_sliced_at (const gchar* str,
                         gint index);
VALA_EXTERN gchar* string_sliced_at_first_str (const gchar* haystack,
                                   const gchar* needle,
                                   gint start_index);
VALA_EXTERN gchar* string_sliced_at_last_str (const gchar* haystack,
                                  const gchar* needle,
                                  gint start_index);
VALA_EXTERN gchar* string_sliced_at_first_char (const gchar* haystack,
                                    gunichar ch,
                                    gint start_index);
VALA_EXTERN gchar* string_sliced_at_last_char (const gchar* haystack,
                                   gunichar ch,
                                   gint start_index);
VALA_EXTERN gchar* string_strip_leading_zeroes (const gchar* str);
VALA_EXTERN gchar* string_remove_diacritics (const gchar* istring);
VALA_EXTERN gchar* string_to_hex_string (const gchar* str);
VALA_EXTERN guint string_collated_hash (void* ptr);
VALA_EXTERN guint string_precollated_hash (void* ptr);
VALA_EXTERN gint string_collated_compare (void* a,
                              void* b);
VALA_EXTERN gint string_precollated_compare (const gchar* astr,
                                 const gchar* akey,
                                 const gchar* bstr,
                                 const gchar* bkey);
VALA_EXTERN gboolean string_collated_equals (void* a,
                                 void* b);
VALA_EXTERN gboolean string_precollated_equals (const gchar* astr,
                                    const gchar* akey,
                                    const gchar* bstr,
                                    const gchar* bkey);

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1240 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1241 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1241 "glib-2.0.vapi"
	result = _tmp0_;
#line 1241 "glib-2.0.vapi"
	return result;
#line 117 "string.c"
}

inline gboolean
is_string_empty (const gchar* s)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 10 "../src/util/string.vala"
	if (s == NULL) {
#line 10 "../src/util/string.vala"
		_tmp0_ = TRUE;
#line 129 "string.c"
	} else {
#line 10 "../src/util/string.vala"
		_tmp0_ = string_get (s, (glong) 0) == '\0';
#line 133 "string.c"
	}
#line 10 "../src/util/string.vala"
	result = _tmp0_;
#line 10 "../src/util/string.vala"
	return result;
#line 139 "string.c"
}

gint
utf8_cs_compare (const gchar* a,
                 const gchar* b)
{
	gint result;
#line 14 "../src/util/string.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 14 "../src/util/string.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 15 "../src/util/string.vala"
	result = g_utf8_collate (a, b);
#line 15 "../src/util/string.vala"
	return result;
#line 155 "string.c"
}

gint
utf8_ci_compare (const gchar* a,
                 const gchar* b)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gint _tmp4_;
	gint result;
#line 19 "../src/util/string.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 19 "../src/util/string.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 20 "../src/util/string.vala"
	_tmp0_ = g_utf8_strdown (a, (gssize) -1);
#line 20 "../src/util/string.vala"
	_tmp1_ = _tmp0_;
#line 20 "../src/util/string.vala"
	_tmp2_ = g_utf8_strdown (b, (gssize) -1);
#line 20 "../src/util/string.vala"
	_tmp3_ = _tmp2_;
#line 20 "../src/util/string.vala"
	_tmp4_ = g_utf8_collate (_tmp1_, _tmp3_);
#line 20 "../src/util/string.vala"
	_g_free0 (_tmp3_);
#line 20 "../src/util/string.vala"
	_g_free0 (_tmp1_);
#line 20 "../src/util/string.vala"
	result = _tmp4_;
#line 20 "../src/util/string.vala"
	return result;
#line 190 "string.c"
}

gchar*
uchar_array_to_string (guchar* data,
                       gint data_length1,
                       gint length)
{
	GString* builder = NULL;
	GString* _tmp0_;
	GString* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* result;
#line 25 "../src/util/string.vala"
	if (length < 0) {
#line 26 "../src/util/string.vala"
		length = data_length1;
#line 208 "string.c"
	}
#line 28 "../src/util/string.vala"
	_tmp0_ = g_string_new ("");
#line 28 "../src/util/string.vala"
	builder = _tmp0_;
#line 214 "string.c"
	{
		gint ctr = 0;
#line 29 "../src/util/string.vala"
		ctr = 0;
#line 219 "string.c"
		{
			gboolean _tmp1_ = FALSE;
#line 29 "../src/util/string.vala"
			_tmp1_ = TRUE;
#line 29 "../src/util/string.vala"
			while (TRUE) {
#line 226 "string.c"
				guchar _tmp3_;
#line 29 "../src/util/string.vala"
				if (!_tmp1_) {
#line 230 "string.c"
					gint _tmp2_;
#line 29 "../src/util/string.vala"
					_tmp2_ = ctr;
#line 29 "../src/util/string.vala"
					ctr = _tmp2_ + 1;
#line 236 "string.c"
				}
#line 29 "../src/util/string.vala"
				_tmp1_ = FALSE;
#line 29 "../src/util/string.vala"
				if (!(ctr < length)) {
#line 29 "../src/util/string.vala"
					break;
#line 244 "string.c"
				}
#line 30 "../src/util/string.vala"
				_tmp3_ = data[ctr];
#line 30 "../src/util/string.vala"
				if (_tmp3_ != ((guchar) '\0')) {
#line 250 "string.c"
					GString* _tmp4_;
					guchar _tmp5_;
#line 31 "../src/util/string.vala"
					_tmp4_ = builder;
#line 31 "../src/util/string.vala"
					_tmp5_ = data[ctr];
#line 31 "../src/util/string.vala"
					g_string_append_c (_tmp4_, (gchar) _tmp5_);
#line 259 "string.c"
				} else {
#line 33 "../src/util/string.vala"
					break;
#line 263 "string.c"
				}
			}
		}
	}
#line 36 "../src/util/string.vala"
	_tmp6_ = builder;
#line 36 "../src/util/string.vala"
	_tmp7_ = _tmp6_->str;
#line 36 "../src/util/string.vala"
	_tmp8_ = g_strdup (_tmp7_);
#line 36 "../src/util/string.vala"
	result = _tmp8_;
#line 36 "../src/util/string.vala"
	_g_string_free0 (builder);
#line 36 "../src/util/string.vala"
	return result;
#line 280 "string.c"
}

static void
_vala_array_add1 (guchar* * array,
                  gint* length,
                  gint* size,
                  guchar value)
{
#line 43 "../src/util/string.vala"
	if ((*length) == (*size)) {
#line 43 "../src/util/string.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 43 "../src/util/string.vala"
		*array = g_renew (guchar, *array, *size);
#line 295 "string.c"
	}
#line 43 "../src/util/string.vala"
	(*array)[(*length)++] = value;
#line 299 "string.c"
}

guchar*
string_to_uchar_array (const gchar* str,
                       gint* result_length1)
{
	guchar* data = NULL;
	guchar* _tmp0_;
	gint data_length1;
	gint _data_size_;
	guchar* _tmp5_;
	gint _tmp5__length1;
	guchar* result;
#line 40 "../src/util/string.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 41 "../src/util/string.vala"
	_tmp0_ = g_new0 (guchar, 0);
#line 41 "../src/util/string.vala"
	data = _tmp0_;
#line 41 "../src/util/string.vala"
	data_length1 = 0;
#line 41 "../src/util/string.vala"
	_data_size_ = data_length1;
#line 323 "string.c"
	{
		gint ctr = 0;
#line 42 "../src/util/string.vala"
		ctr = 0;
#line 328 "string.c"
		{
			gboolean _tmp1_ = FALSE;
#line 42 "../src/util/string.vala"
			_tmp1_ = TRUE;
#line 42 "../src/util/string.vala"
			while (TRUE) {
#line 335 "string.c"
				gint _tmp3_;
				gint _tmp4_;
#line 42 "../src/util/string.vala"
				if (!_tmp1_) {
#line 340 "string.c"
					gint _tmp2_;
#line 42 "../src/util/string.vala"
					_tmp2_ = ctr;
#line 42 "../src/util/string.vala"
					ctr = _tmp2_ + 1;
#line 346 "string.c"
				}
#line 42 "../src/util/string.vala"
				_tmp1_ = FALSE;
#line 42 "../src/util/string.vala"
				_tmp3_ = strlen (str);
#line 42 "../src/util/string.vala"
				_tmp4_ = _tmp3_;
#line 42 "../src/util/string.vala"
				if (!(ctr < _tmp4_)) {
#line 42 "../src/util/string.vala"
					break;
#line 358 "string.c"
				}
#line 43 "../src/util/string.vala"
				_vala_array_add1 (&data, &data_length1, &_data_size_, (guchar) string_get (str, (glong) ctr));
#line 362 "string.c"
			}
		}
	}
#line 45 "../src/util/string.vala"
	_tmp5_ = data;
#line 45 "../src/util/string.vala"
	_tmp5__length1 = data_length1;
#line 45 "../src/util/string.vala"
	if (result_length1) {
#line 45 "../src/util/string.vala"
		*result_length1 = _tmp5__length1;
#line 374 "string.c"
	}
#line 45 "../src/util/string.vala"
	result = _tmp5_;
#line 45 "../src/util/string.vala"
	return result;
#line 380 "string.c"
}

inline gchar*
guarded_markup_escape_text (const gchar* plain)
{
	gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	gchar* result;
#line 56 "../src/util/string.vala"
	if (!is_string_empty (plain)) {
#line 56 "../src/util/string.vala"
		_tmp1_ = g_utf8_validate (plain, (gssize) -1, NULL);
#line 393 "string.c"
	} else {
#line 56 "../src/util/string.vala"
		_tmp1_ = FALSE;
#line 397 "string.c"
	}
#line 56 "../src/util/string.vala"
	if (_tmp1_) {
#line 401 "string.c"
		gchar* _tmp2_;
#line 56 "../src/util/string.vala"
		_tmp2_ = g_markup_escape_text (plain, (gssize) -1);
#line 56 "../src/util/string.vala"
		_g_free0 (_tmp0_);
#line 56 "../src/util/string.vala"
		_tmp0_ = _tmp2_;
#line 409 "string.c"
	} else {
		gchar* _tmp3_;
#line 56 "../src/util/string.vala"
		_tmp3_ = g_strdup ("");
#line 56 "../src/util/string.vala"
		_g_free0 (_tmp0_);
#line 56 "../src/util/string.vala"
		_tmp0_ = _tmp3_;
#line 418 "string.c"
	}
#line 56 "../src/util/string.vala"
	result = _tmp0_;
#line 56 "../src/util/string.vala"
	return result;
#line 424 "string.c"
}

glong
find_last_offset (const gchar* str,
                  gchar c)
{
	glong offset = 0L;
	gint _tmp0_;
	gint _tmp1_;
	glong result;
#line 59 "../src/util/string.vala"
	g_return_val_if_fail (str != NULL, 0L);
#line 60 "../src/util/string.vala"
	_tmp0_ = strlen (str);
#line 60 "../src/util/string.vala"
	_tmp1_ = _tmp0_;
#line 60 "../src/util/string.vala"
	offset = (glong) _tmp1_;
#line 61 "../src/util/string.vala"
	while (TRUE) {
#line 445 "string.c"
		glong _tmp2_;
#line 61 "../src/util/string.vala"
		offset = offset - 1;
#line 61 "../src/util/string.vala"
		_tmp2_ = offset;
#line 61 "../src/util/string.vala"
		if (!(_tmp2_ >= ((glong) 0))) {
#line 61 "../src/util/string.vala"
			break;
#line 455 "string.c"
		}
#line 62 "../src/util/string.vala"
		if (string_get (str, offset) == c) {
#line 63 "../src/util/string.vala"
			result = offset;
#line 63 "../src/util/string.vala"
			return result;
#line 463 "string.c"
		}
	}
#line 66 "../src/util/string.vala"
	result = (glong) -1;
#line 66 "../src/util/string.vala"
	return result;
#line 470 "string.c"
}

gboolean
is_in_ci_array (const gchar* str,
                gchar** strings,
                gint strings_length1)
{
	gchar* strdown = NULL;
	gchar* _tmp0_;
	gboolean result;
#line 71 "../src/util/string.vala"
	g_return_val_if_fail (str != NULL, FALSE);
#line 72 "../src/util/string.vala"
	_tmp0_ = g_utf8_strdown (str, (gssize) -1);
#line 72 "../src/util/string.vala"
	strdown = _tmp0_;
#line 487 "string.c"
	{
		gchar** str_element_collection = NULL;
		gint str_element_collection_length1 = 0;
		gint _str_element_collection_size_ = 0;
		gint str_element_it = 0;
#line 73 "../src/util/string.vala"
		str_element_collection = strings;
#line 73 "../src/util/string.vala"
		str_element_collection_length1 = strings_length1;
#line 73 "../src/util/string.vala"
		for (str_element_it = 0; str_element_it < str_element_collection_length1; str_element_it = str_element_it + 1) {
#line 499 "string.c"
			gchar* _tmp1_;
			gchar* str_element = NULL;
#line 73 "../src/util/string.vala"
			_tmp1_ = g_strdup (str_element_collection[str_element_it]);
#line 73 "../src/util/string.vala"
			str_element = _tmp1_;
#line 506 "string.c"
			{
				const gchar* _tmp2_;
				const gchar* _tmp3_;
#line 74 "../src/util/string.vala"
				_tmp2_ = strdown;
#line 74 "../src/util/string.vala"
				_tmp3_ = str_element;
#line 74 "../src/util/string.vala"
				if (g_strcmp0 (_tmp2_, _tmp3_) == 0) {
#line 75 "../src/util/string.vala"
					result = TRUE;
#line 75 "../src/util/string.vala"
					_g_free0 (str_element);
#line 75 "../src/util/string.vala"
					_g_free0 (strdown);
#line 75 "../src/util/string.vala"
					return result;
#line 524 "string.c"
				}
#line 73 "../src/util/string.vala"
				_g_free0 (str_element);
#line 528 "string.c"
			}
		}
	}
#line 78 "../src/util/string.vala"
	result = FALSE;
#line 78 "../src/util/string.vala"
	_g_free0 (strdown);
#line 78 "../src/util/string.vala"
	return result;
#line 538 "string.c"
}

static GType
prepare_input_text_options_get_type_once (void)
{
	static const GFlagsValue values[] = {{PREPARE_INPUT_TEXT_OPTIONS_EMPTY_IS_NULL, "PREPARE_INPUT_TEXT_OPTIONS_EMPTY_IS_NULL", "empty-is-null"}, {PREPARE_INPUT_TEXT_OPTIONS_VALIDATE, "PREPARE_INPUT_TEXT_OPTIONS_VALIDATE", "validate"}, {PREPARE_INPUT_TEXT_OPTIONS_INVALID_IS_NULL, "PREPARE_INPUT_TEXT_OPTIONS_INVALID_IS_NULL", "invalid-is-null"}, {PREPARE_INPUT_TEXT_OPTIONS_STRIP, "PREPARE_INPUT_TEXT_OPTIONS_STRIP", "strip"}, {PREPARE_INPUT_TEXT_OPTIONS_STRIP_CRLF, "PREPARE_INPUT_TEXT_OPTIONS_STRIP_CRLF", "strip-crlf"}, {PREPARE_INPUT_TEXT_OPTIONS_NORMALIZE, "PREPARE_INPUT_TEXT_OPTIONS_NORMALIZE", "normalize"}, {PREPARE_INPUT_TEXT_OPTIONS_DEFAULT, "PREPARE_INPUT_TEXT_OPTIONS_DEFAULT", "default"}, {0, NULL, NULL}};
	GType prepare_input_text_options_type_id;
	prepare_input_text_options_type_id = g_flags_register_static ("PrepareInputTextOptions", values);
	return prepare_input_text_options_type_id;
}

GType
prepare_input_text_options_get_type (void)
{
	static volatile gsize prepare_input_text_options_type_id__once = 0;
	if (g_once_init_enter (&prepare_input_text_options_type_id__once)) {
		GType prepare_input_text_options_type_id;
		prepare_input_text_options_type_id = prepare_input_text_options_get_type_once ();
		g_once_init_leave (&prepare_input_text_options_type_id__once, prepare_input_text_options_type_id);
	}
	return prepare_input_text_options_type_id__once;
}

gchar*
guess_convert (const gchar* text)
{
	gchar* output = NULL;
	gsize bytes_read = 0UL;
	const gchar* charset = NULL;
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_;
	gint _tmp22_;
	gint _tmp23_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 92 "../src/util/string.vala"
	g_return_val_if_fail (text != NULL, NULL);
#line 93 "../src/util/string.vala"
	output = NULL;
#line 94 "../src/util/string.vala"
	bytes_read = (gsize) 0;
#line 95 "../src/util/string.vala"
	charset = NULL;
#line 96 "../src/util/string.vala"
	g_debug ("string.vala:96: CONVERT: Text did not validate as UTF-8, trying conver" \
"sion");
#line 99 "../src/util/string.vala"
	_tmp1_ = g_get_charset (&_tmp0_);
#line 99 "../src/util/string.vala"
	charset = _tmp0_;
#line 99 "../src/util/string.vala"
	if (!_tmp1_) {
#line 590 "string.c"
		gint _tmp2_;
		gint _tmp3_;
		gsize _tmp4_ = 0UL;
		gchar* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
#line 100 "../src/util/string.vala"
		_tmp2_ = strlen (text);
#line 100 "../src/util/string.vala"
		_tmp3_ = _tmp2_;
#line 100 "../src/util/string.vala"
		_tmp5_ = g_locale_to_utf8 (text, (gssize) _tmp3_, &_tmp4_, NULL, NULL);
#line 100 "../src/util/string.vala"
		bytes_read = _tmp4_;
#line 100 "../src/util/string.vala"
		_g_free0 (output);
#line 100 "../src/util/string.vala"
		output = _tmp5_;
#line 101 "../src/util/string.vala"
		_tmp6_ = strlen (text);
#line 101 "../src/util/string.vala"
		_tmp7_ = _tmp6_;
#line 101 "../src/util/string.vala"
		if (bytes_read == ((gsize) _tmp7_)) {
#line 615 "string.c"
			const gchar* _tmp8_;
#line 102 "../src/util/string.vala"
			_tmp8_ = charset;
#line 102 "../src/util/string.vala"
			g_debug ("string.vala:102: CONVERT: Locale is not UTF-8, convert from %s", _tmp8_);
#line 103 "../src/util/string.vala"
			result = output;
#line 103 "../src/util/string.vala"
			return result;
#line 625 "string.c"
		}
	}
	{
		gchar* _tmp9_ = NULL;
		gint _tmp10_;
		gint _tmp11_;
		gsize _tmp12_ = 0UL;
		gchar* _tmp13_;
		gchar* _tmp14_;
#line 108 "../src/util/string.vala"
		_tmp10_ = strlen (text);
#line 108 "../src/util/string.vala"
		_tmp11_ = _tmp10_;
#line 108 "../src/util/string.vala"
		_tmp13_ = g_convert (text, (gssize) _tmp11_, "UTF-8", "WINDOWS-1252", &_tmp12_, NULL, &_inner_error0_);
#line 108 "../src/util/string.vala"
		bytes_read = _tmp12_;
#line 108 "../src/util/string.vala"
		_tmp9_ = _tmp13_;
#line 108 "../src/util/string.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 108 "../src/util/string.vala"
			if (_inner_error0_->domain == G_CONVERT_ERROR) {
#line 649 "string.c"
				goto __catch0_g_convert_error;
			}
#line 108 "../src/util/string.vala"
			_g_free0 (output);
#line 108 "../src/util/string.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 108 "../src/util/string.vala"
			g_clear_error (&_inner_error0_);
#line 108 "../src/util/string.vala"
			return NULL;
#line 660 "string.c"
		}
#line 108 "../src/util/string.vala"
		_tmp14_ = _tmp9_;
#line 108 "../src/util/string.vala"
		_tmp9_ = NULL;
#line 108 "../src/util/string.vala"
		_g_free0 (output);
#line 108 "../src/util/string.vala"
		output = _tmp14_;
#line 109 "../src/util/string.vala"
		charset = "WINDOWS-1252";
#line 107 "../src/util/string.vala"
		_g_free0 (_tmp9_);
#line 674 "string.c"
	}
	goto __finally0;
	__catch0_g_convert_error:
	{
		GError* _error_ = NULL;
		GError* _tmp15_;
#line 107 "../src/util/string.vala"
		_error_ = _inner_error0_;
#line 107 "../src/util/string.vala"
		_inner_error0_ = NULL;
#line 111 "../src/util/string.vala"
		_tmp15_ = _error_;
#line 111 "../src/util/string.vala"
		if (g_error_matches (_tmp15_, G_CONVERT_ERROR, G_CONVERT_ERROR_NO_CONVERSION)) {
#line 689 "string.c"
			{
				gchar* _tmp16_ = NULL;
				gint _tmp17_;
				gint _tmp18_;
				gsize _tmp19_ = 0UL;
				gchar* _tmp20_;
				gchar* _tmp21_;
#line 113 "../src/util/string.vala"
				_tmp17_ = strlen (text);
#line 113 "../src/util/string.vala"
				_tmp18_ = _tmp17_;
#line 113 "../src/util/string.vala"
				_tmp20_ = g_convert (text, (gssize) _tmp18_, "UTF-8", "ISO-8859-1", &_tmp19_, NULL, &_inner_error0_);
#line 113 "../src/util/string.vala"
				bytes_read = _tmp19_;
#line 113 "../src/util/string.vala"
				_tmp16_ = _tmp20_;
#line 113 "../src/util/string.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 709 "string.c"
					goto __catch1_g_error;
				}
#line 113 "../src/util/string.vala"
				_tmp21_ = _tmp16_;
#line 113 "../src/util/string.vala"
				_tmp16_ = NULL;
#line 113 "../src/util/string.vala"
				_g_free0 (output);
#line 113 "../src/util/string.vala"
				output = _tmp21_;
#line 114 "../src/util/string.vala"
				charset = "ISO-8859-1";
#line 112 "../src/util/string.vala"
				_g_free0 (_tmp16_);
#line 724 "string.c"
			}
			goto __finally1;
			__catch1_g_error:
			{
#line 112 "../src/util/string.vala"
				g_clear_error (&_inner_error0_);
#line 731 "string.c"
			}
			__finally1:
#line 112 "../src/util/string.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 112 "../src/util/string.vala"
				_g_error_free0 (_error_);
#line 112 "../src/util/string.vala"
				_g_free0 (output);
#line 112 "../src/util/string.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 112 "../src/util/string.vala"
				g_clear_error (&_inner_error0_);
#line 112 "../src/util/string.vala"
				return NULL;
#line 746 "string.c"
			}
		}
#line 107 "../src/util/string.vala"
		_g_error_free0 (_error_);
#line 751 "string.c"
	}
	__finally0:
#line 107 "../src/util/string.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 107 "../src/util/string.vala"
		_g_free0 (output);
#line 107 "../src/util/string.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 107 "../src/util/string.vala"
		g_clear_error (&_inner_error0_);
#line 107 "../src/util/string.vala"
		return NULL;
#line 764 "string.c"
	}
#line 119 "../src/util/string.vala"
	_tmp22_ = strlen (text);
#line 119 "../src/util/string.vala"
	_tmp23_ = _tmp22_;
#line 119 "../src/util/string.vala"
	if (bytes_read == ((gsize) _tmp23_)) {
#line 772 "string.c"
		const gchar* _tmp24_;
#line 120 "../src/util/string.vala"
		_tmp24_ = charset;
#line 120 "../src/util/string.vala"
		g_debug ("string.vala:120: CONVERT: Guessed conversion from %s", _tmp24_);
#line 122 "../src/util/string.vala"
		result = output;
#line 122 "../src/util/string.vala"
		return result;
#line 782 "string.c"
	}
#line 125 "../src/util/string.vala"
	result = NULL;
#line 125 "../src/util/string.vala"
	_g_free0 (output);
#line 125 "../src/util/string.vala"
	return result;
#line 790 "string.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1370 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1371 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1371 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1372 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1373 "glib-2.0.vapi"
	result = _result_;
#line 1373 "glib-2.0.vapi"
	return result;
#line 811 "string.c"
}

static gchar*
string_delimit (const gchar* self,
                const gchar* delimiters,
                gchar new_delimiter)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1378 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1378 "glib-2.0.vapi"
	g_return_val_if_fail (delimiters != NULL, NULL);
#line 1379 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1379 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1380 "glib-2.0.vapi"
	g_strdelimit (_result_, delimiters, new_delimiter);
#line 1381 "glib-2.0.vapi"
	result = _result_;
#line 1381 "glib-2.0.vapi"
	return result;
#line 836 "string.c"
}

gchar*
prepare_input_text (const gchar* text,
                    PrepareInputTextOptions options,
                    gint dest_length)
{
	gchar* prepped = NULL;
	gchar* _tmp0_;
	gboolean _tmp11_ = FALSE;
	gchar* result;
#line 129 "../src/util/string.vala"
	if (text == NULL) {
#line 130 "../src/util/string.vala"
		result = NULL;
#line 130 "../src/util/string.vala"
		return result;
#line 854 "string.c"
	}
#line 132 "../src/util/string.vala"
	_tmp0_ = g_strdup (text);
#line 132 "../src/util/string.vala"
	prepped = _tmp0_;
#line 133 "../src/util/string.vala"
	if ((options & PREPARE_INPUT_TEXT_OPTIONS_VALIDATE) == PREPARE_INPUT_TEXT_OPTIONS_VALIDATE) {
#line 134 "../src/util/string.vala"
		if (!g_utf8_validate (text, (gssize) -1, NULL)) {
#line 864 "string.c"
			gchar* _tmp1_;
			const gchar* _tmp2_;
#line 135 "../src/util/string.vala"
			_tmp1_ = guess_convert (text);
#line 135 "../src/util/string.vala"
			_g_free0 (prepped);
#line 135 "../src/util/string.vala"
			prepped = _tmp1_;
#line 137 "../src/util/string.vala"
			_tmp2_ = prepped;
#line 137 "../src/util/string.vala"
			if (_tmp2_ == NULL) {
#line 877 "string.c"
				const gchar* _tmp3_ = NULL;
				gchar* _tmp4_;
#line 138 "../src/util/string.vala"
				if ((options & PREPARE_INPUT_TEXT_OPTIONS_INVALID_IS_NULL) != 0) {
#line 138 "../src/util/string.vala"
					_tmp3_ = NULL;
#line 884 "string.c"
				} else {
#line 138 "../src/util/string.vala"
					_tmp3_ = "";
#line 888 "string.c"
				}
#line 138 "../src/util/string.vala"
				_tmp4_ = g_strdup (_tmp3_);
#line 138 "../src/util/string.vala"
				result = _tmp4_;
#line 138 "../src/util/string.vala"
				_g_free0 (prepped);
#line 138 "../src/util/string.vala"
				return result;
#line 898 "string.c"
			}
		}
	}
#line 147 "../src/util/string.vala"
	if ((options & PREPARE_INPUT_TEXT_OPTIONS_NORMALIZE) != 0) {
#line 904 "string.c"
		const gchar* _tmp5_;
		gchar* _tmp6_;
#line 148 "../src/util/string.vala"
		_tmp5_ = prepped;
#line 148 "../src/util/string.vala"
		_tmp6_ = g_utf8_normalize (_tmp5_, (gssize) -1, G_NORMALIZE_NFC);
#line 148 "../src/util/string.vala"
		_g_free0 (prepped);
#line 148 "../src/util/string.vala"
		prepped = _tmp6_;
#line 915 "string.c"
	}
#line 150 "../src/util/string.vala"
	if ((options & PREPARE_INPUT_TEXT_OPTIONS_STRIP) != 0) {
#line 919 "string.c"
		const gchar* _tmp7_;
		gchar* _tmp8_;
#line 151 "../src/util/string.vala"
		_tmp7_ = prepped;
#line 151 "../src/util/string.vala"
		_tmp8_ = string_strip (_tmp7_);
#line 151 "../src/util/string.vala"
		_g_free0 (prepped);
#line 151 "../src/util/string.vala"
		prepped = _tmp8_;
#line 930 "string.c"
	}
#line 155 "../src/util/string.vala"
	if ((options & PREPARE_INPUT_TEXT_OPTIONS_STRIP_CRLF) != 0) {
#line 934 "string.c"
		const gchar* _tmp9_;
		gchar* _tmp10_;
#line 156 "../src/util/string.vala"
		_tmp9_ = prepped;
#line 156 "../src/util/string.vala"
		_tmp10_ = string_delimit (_tmp9_, "\n\r", ' ');
#line 156 "../src/util/string.vala"
		_g_free0 (prepped);
#line 156 "../src/util/string.vala"
		prepped = _tmp10_;
#line 945 "string.c"
	}
#line 158 "../src/util/string.vala"
	if ((options & PREPARE_INPUT_TEXT_OPTIONS_EMPTY_IS_NULL) != 0) {
#line 949 "string.c"
		const gchar* _tmp12_;
#line 158 "../src/util/string.vala"
		_tmp12_ = prepped;
#line 158 "../src/util/string.vala"
		_tmp11_ = is_string_empty (_tmp12_);
#line 955 "string.c"
	} else {
#line 158 "../src/util/string.vala"
		_tmp11_ = FALSE;
#line 959 "string.c"
	}
#line 158 "../src/util/string.vala"
	if (_tmp11_) {
#line 159 "../src/util/string.vala"
		result = NULL;
#line 159 "../src/util/string.vala"
		_g_free0 (prepped);
#line 159 "../src/util/string.vala"
		return result;
#line 969 "string.c"
	}
#line 164 "../src/util/string.vala"
	if (dest_length >= 0) {
#line 973 "string.c"
		GString* sb = NULL;
		const gchar* _tmp13_;
		GString* _tmp14_;
		GString* _tmp15_;
		GString* _tmp16_;
		const gchar* _tmp17_;
		gchar* _tmp18_;
#line 165 "../src/util/string.vala"
		_tmp13_ = prepped;
#line 165 "../src/util/string.vala"
		_tmp14_ = g_string_new (_tmp13_);
#line 165 "../src/util/string.vala"
		sb = _tmp14_;
#line 166 "../src/util/string.vala"
		_tmp15_ = sb;
#line 166 "../src/util/string.vala"
		g_string_truncate (_tmp15_, (gsize) dest_length);
#line 167 "../src/util/string.vala"
		_tmp16_ = sb;
#line 167 "../src/util/string.vala"
		_tmp17_ = _tmp16_->str;
#line 167 "../src/util/string.vala"
		_tmp18_ = g_strdup (_tmp17_);
#line 167 "../src/util/string.vala"
		result = _tmp18_;
#line 167 "../src/util/string.vala"
		_g_string_free0 (sb);
#line 167 "../src/util/string.vala"
		_g_free0 (prepped);
#line 167 "../src/util/string.vala"
		return result;
#line 1005 "string.c"
	}
#line 171 "../src/util/string.vala"
	result = prepped;
#line 171 "../src/util/string.vala"
	return result;
#line 1011 "string.c"
}

static gint
string_index_of_char (const gchar* self,
                      gunichar c,
                      gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1161 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1162 "glib-2.0.vapi"
	_tmp0_ = g_utf8_strchr (((gchar*) self) + start_index, (gssize) -1, c);
#line 1162 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1164 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1164 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 1033 "string.c"
		gchar* _tmp2_;
#line 1165 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1165 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1165 "glib-2.0.vapi"
		return result;
#line 1041 "string.c"
	} else {
#line 1167 "glib-2.0.vapi"
		result = -1;
#line 1167 "glib-2.0.vapi"
		return result;
#line 1047 "string.c"
	}
}

inline gboolean
string_contains_char (const gchar* haystack,
                      gunichar needle)
{
	gboolean result;
#line 176 "../src/util/string.vala"
	g_return_val_if_fail (haystack != NULL, FALSE);
#line 177 "../src/util/string.vala"
	result = string_index_of_char (haystack, needle, 0) >= 0;
#line 177 "../src/util/string.vala"
	return result;
#line 1062 "string.c"
}

static gint
string_index_of (const gchar* self,
                 const gchar* needle,
                 gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1141 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1141 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1142 "glib-2.0.vapi"
	_tmp0_ = strstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1142 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1144 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1144 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 1086 "string.c"
		gchar* _tmp2_;
#line 1145 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1145 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1145 "glib-2.0.vapi"
		return result;
#line 1094 "string.c"
	} else {
#line 1147 "glib-2.0.vapi"
		result = -1;
#line 1147 "glib-2.0.vapi"
		return result;
#line 1100 "string.c"
	}
}

inline gboolean
string_contains_str (const gchar* haystack,
                     const gchar* needle)
{
	gboolean result;
#line 180 "../src/util/string.vala"
	g_return_val_if_fail (haystack != NULL, FALSE);
#line 180 "../src/util/string.vala"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 181 "../src/util/string.vala"
	result = string_index_of (haystack, needle, 0) >= 0;
#line 181 "../src/util/string.vala"
	return result;
#line 1117 "string.c"
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1491 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1492 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1492 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1492 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1493 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1494 "glib-2.0.vapi"
		start = string_length + start;
#line 1144 "string.c"
	}
#line 1496 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1497 "glib-2.0.vapi"
		end = string_length + end;
#line 1150 "string.c"
	}
#line 1499 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1499 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 1156 "string.c"
	} else {
#line 1499 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 1160 "string.c"
	}
#line 1499 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1500 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1500 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 1168 "string.c"
	} else {
#line 1500 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 1172 "string.c"
	}
#line 1500 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1501 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1502 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1502 "glib-2.0.vapi"
	result = _tmp4_;
#line 1502 "glib-2.0.vapi"
	return result;
#line 1184 "string.c"
}

inline gchar*
string_sliced_at (const gchar* str,
                  gint index)
{
	gchar* _tmp0_ = NULL;
	gchar* result;
#line 184 "../src/util/string.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 185 "../src/util/string.vala"
	if (index >= 0) {
#line 1197 "string.c"
		gint _tmp1_;
		gint _tmp2_;
		gchar* _tmp3_;
#line 185 "../src/util/string.vala"
		_tmp1_ = strlen (str);
#line 185 "../src/util/string.vala"
		_tmp2_ = _tmp1_;
#line 185 "../src/util/string.vala"
		_tmp3_ = string_slice (str, (glong) index, (glong) _tmp2_);
#line 185 "../src/util/string.vala"
		_g_free0 (_tmp0_);
#line 185 "../src/util/string.vala"
		_tmp0_ = _tmp3_;
#line 1211 "string.c"
	} else {
#line 185 "../src/util/string.vala"
		_g_free0 (_tmp0_);
#line 185 "../src/util/string.vala"
		_tmp0_ = NULL;
#line 1217 "string.c"
	}
#line 185 "../src/util/string.vala"
	result = _tmp0_;
#line 185 "../src/util/string.vala"
	return result;
#line 1223 "string.c"
}

inline gchar*
string_sliced_at_first_str (const gchar* haystack,
                            const gchar* needle,
                            gint start_index)
{
	gchar* _tmp0_;
	gchar* result;
#line 188 "../src/util/string.vala"
	g_return_val_if_fail (haystack != NULL, NULL);
#line 188 "../src/util/string.vala"
	g_return_val_if_fail (needle != NULL, NULL);
#line 189 "../src/util/string.vala"
	_tmp0_ = string_sliced_at (haystack, string_index_of (haystack, needle, start_index));
#line 189 "../src/util/string.vala"
	result = _tmp0_;
#line 189 "../src/util/string.vala"
	return result;
#line 1243 "string.c"
}

static gint
string_last_index_of (const gchar* self,
                      const gchar* needle,
                      gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1151 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1151 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1152 "glib-2.0.vapi"
	_tmp0_ = g_strrstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1152 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1154 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1154 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 1267 "string.c"
		gchar* _tmp2_;
#line 1155 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1155 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1155 "glib-2.0.vapi"
		return result;
#line 1275 "string.c"
	} else {
#line 1157 "glib-2.0.vapi"
		result = -1;
#line 1157 "glib-2.0.vapi"
		return result;
#line 1281 "string.c"
	}
}

inline gchar*
string_sliced_at_last_str (const gchar* haystack,
                           const gchar* needle,
                           gint start_index)
{
	gchar* _tmp0_;
	gchar* result;
#line 192 "../src/util/string.vala"
	g_return_val_if_fail (haystack != NULL, NULL);
#line 192 "../src/util/string.vala"
	g_return_val_if_fail (needle != NULL, NULL);
#line 193 "../src/util/string.vala"
	_tmp0_ = string_sliced_at (haystack, string_last_index_of (haystack, needle, start_index));
#line 193 "../src/util/string.vala"
	result = _tmp0_;
#line 193 "../src/util/string.vala"
	return result;
#line 1302 "string.c"
}

inline gchar*
string_sliced_at_first_char (const gchar* haystack,
                             gunichar ch,
                             gint start_index)
{
	gchar* _tmp0_;
	gchar* result;
#line 196 "../src/util/string.vala"
	g_return_val_if_fail (haystack != NULL, NULL);
#line 197 "../src/util/string.vala"
	_tmp0_ = string_sliced_at (haystack, string_index_of_char (haystack, ch, start_index));
#line 197 "../src/util/string.vala"
	result = _tmp0_;
#line 197 "../src/util/string.vala"
	return result;
#line 1320 "string.c"
}

static gint
string_last_index_of_char (const gchar* self,
                           gunichar c,
                           gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1171 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1172 "glib-2.0.vapi"
	_tmp0_ = g_utf8_strrchr (((gchar*) self) + start_index, (gssize) -1, c);
#line 1172 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1174 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1174 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 1342 "string.c"
		gchar* _tmp2_;
#line 1175 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1175 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1175 "glib-2.0.vapi"
		return result;
#line 1350 "string.c"
	} else {
#line 1177 "glib-2.0.vapi"
		result = -1;
#line 1177 "glib-2.0.vapi"
		return result;
#line 1356 "string.c"
	}
}

inline gchar*
string_sliced_at_last_char (const gchar* haystack,
                            gunichar ch,
                            gint start_index)
{
	gchar* _tmp0_;
	gchar* result;
#line 200 "../src/util/string.vala"
	g_return_val_if_fail (haystack != NULL, NULL);
#line 201 "../src/util/string.vala"
	_tmp0_ = string_sliced_at (haystack, string_last_index_of_char (haystack, ch, start_index));
#line 201 "../src/util/string.vala"
	result = _tmp0_;
#line 201 "../src/util/string.vala"
	return result;
#line 1375 "string.c"
}

static gunichar
string_get_char (const gchar* self,
                 glong index)
{
	gunichar result;
#line 1270 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0U);
#line 1271 "glib-2.0.vapi"
	result = g_utf8_get_char (((gchar*) self) + index);
#line 1271 "glib-2.0.vapi"
	return result;
#line 1389 "string.c"
}

gchar*
string_strip_leading_zeroes (const gchar* str)
{
	GString* stripped = NULL;
	GString* _tmp0_;
	gboolean prev_is_space = FALSE;
	GString* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* result;
#line 205 "../src/util/string.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 206 "../src/util/string.vala"
	_tmp0_ = g_string_new ("");
#line 206 "../src/util/string.vala"
	stripped = _tmp0_;
#line 207 "../src/util/string.vala"
	prev_is_space = TRUE;
#line 1410 "string.c"
	{
		const gchar* iter = NULL;
#line 208 "../src/util/string.vala"
		iter = str;
#line 1415 "string.c"
		{
			gboolean _tmp1_ = FALSE;
#line 208 "../src/util/string.vala"
			_tmp1_ = TRUE;
#line 208 "../src/util/string.vala"
			while (TRUE) {
#line 1422 "string.c"
				const gchar* _tmp4_;
				gunichar ch = 0U;
				const gchar* _tmp5_;
				gboolean _tmp6_ = FALSE;
#line 208 "../src/util/string.vala"
				if (!_tmp1_) {
#line 1429 "string.c"
					const gchar* _tmp2_;
					const gchar* _tmp3_;
#line 208 "../src/util/string.vala"
					_tmp2_ = iter;
#line 208 "../src/util/string.vala"
					_tmp3_ = g_utf8_next_char (_tmp2_);
#line 208 "../src/util/string.vala"
					iter = _tmp3_;
#line 1438 "string.c"
				}
#line 208 "../src/util/string.vala"
				_tmp1_ = FALSE;
#line 208 "../src/util/string.vala"
				_tmp4_ = iter;
#line 208 "../src/util/string.vala"
				if (!(string_get_char (_tmp4_, (glong) 0) != ((gunichar) 0))) {
#line 208 "../src/util/string.vala"
					break;
#line 1448 "string.c"
				}
#line 209 "../src/util/string.vala"
				_tmp5_ = iter;
#line 209 "../src/util/string.vala"
				ch = string_get_char (_tmp5_, (glong) 0);
#line 211 "../src/util/string.vala"
				if (!prev_is_space) {
#line 211 "../src/util/string.vala"
					_tmp6_ = TRUE;
#line 1458 "string.c"
				} else {
#line 211 "../src/util/string.vala"
					_tmp6_ = ch != ((gunichar) '0');
#line 1462 "string.c"
				}
#line 211 "../src/util/string.vala"
				if (_tmp6_) {
#line 1466 "string.c"
					GString* _tmp7_;
#line 212 "../src/util/string.vala"
					_tmp7_ = stripped;
#line 212 "../src/util/string.vala"
					g_string_append_unichar (_tmp7_, ch);
#line 213 "../src/util/string.vala"
					prev_is_space = g_unichar_isspace (ch);
#line 1474 "string.c"
				}
			}
		}
	}
#line 217 "../src/util/string.vala"
	_tmp8_ = stripped;
#line 217 "../src/util/string.vala"
	_tmp9_ = _tmp8_->str;
#line 217 "../src/util/string.vala"
	_tmp10_ = g_strdup (_tmp9_);
#line 217 "../src/util/string.vala"
	result = _tmp10_;
#line 217 "../src/util/string.vala"
	_g_string_free0 (stripped);
#line 217 "../src/util/string.vala"
	return result;
#line 1491 "string.c"
}

static gboolean
string_get_next_char (const gchar* self,
                      gint* index,
                      gunichar* c)
{
	gunichar _vala_c = 0U;
	gboolean result;
#line 1259 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1260 "glib-2.0.vapi"
	_vala_c = g_utf8_get_char (((gchar*) self) + (*index));
#line 1261 "glib-2.0.vapi"
	if (_vala_c != ((gunichar) 0)) {
#line 1507 "string.c"
		gchar* _tmp0_;
#line 1262 "glib-2.0.vapi"
		_tmp0_ = g_utf8_next_char (((gchar*) self) + (*index));
#line 1262 "glib-2.0.vapi"
		*index = (gint) (_tmp0_ - ((gchar*) self));
#line 1263 "glib-2.0.vapi"
		result = TRUE;
#line 1263 "glib-2.0.vapi"
		if (c) {
#line 1263 "glib-2.0.vapi"
			*c = _vala_c;
#line 1519 "string.c"
		}
#line 1263 "glib-2.0.vapi"
		return result;
#line 1523 "string.c"
	} else {
#line 1265 "glib-2.0.vapi"
		result = FALSE;
#line 1265 "glib-2.0.vapi"
		if (c) {
#line 1265 "glib-2.0.vapi"
			*c = _vala_c;
#line 1531 "string.c"
		}
#line 1265 "glib-2.0.vapi"
		return result;
#line 1535 "string.c"
	}
}

gchar*
string_remove_diacritics (const gchar* istring)
{
	GString* builder = NULL;
	GString* _tmp0_;
	gunichar ch = 0U;
	gint i = 0;
	GString* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* result;
#line 220 "../src/util/string.vala"
	g_return_val_if_fail (istring != NULL, NULL);
#line 221 "../src/util/string.vala"
	_tmp0_ = g_string_new ("");
#line 221 "../src/util/string.vala"
	builder = _tmp0_;
#line 223 "../src/util/string.vala"
	i = 0;
#line 224 "../src/util/string.vala"
	while (TRUE) {
#line 1560 "string.c"
		gchar* _tmp1_;
		gchar* _tmp2_;
		gunichar _tmp3_ = 0U;
		gboolean _tmp4_;
		gboolean _tmp5_;
		GString* _tmp6_;
#line 224 "../src/util/string.vala"
		_tmp1_ = g_utf8_normalize (istring, (gssize) -1, G_NORMALIZE_DEFAULT);
#line 224 "../src/util/string.vala"
		_tmp2_ = _tmp1_;
#line 224 "../src/util/string.vala"
		_tmp4_ = string_get_next_char (_tmp2_, &i, &_tmp3_);
#line 224 "../src/util/string.vala"
		ch = _tmp3_;
#line 224 "../src/util/string.vala"
		_tmp5_ = !_tmp4_;
#line 224 "../src/util/string.vala"
		_g_free0 (_tmp2_);
#line 224 "../src/util/string.vala"
		if (_tmp5_) {
#line 224 "../src/util/string.vala"
			break;
#line 1583 "string.c"
		}
#line 225 "../src/util/string.vala"
		switch (g_unichar_type (ch)) {
#line 225 "../src/util/string.vala"
			case G_UNICODE_CONTROL:
#line 225 "../src/util/string.vala"
			case G_UNICODE_FORMAT:
#line 225 "../src/util/string.vala"
			case G_UNICODE_UNASSIGNED:
#line 225 "../src/util/string.vala"
			case G_UNICODE_NON_SPACING_MARK:
#line 225 "../src/util/string.vala"
			case G_UNICODE_COMBINING_MARK:
#line 225 "../src/util/string.vala"
			case G_UNICODE_ENCLOSING_MARK:
#line 1599 "string.c"
			{
#line 233 "../src/util/string.vala"
				continue;
#line 1603 "string.c"
			}
			default:
			{
#line 235 "../src/util/string.vala"
				break;
#line 1609 "string.c"
			}
		}
#line 237 "../src/util/string.vala"
		_tmp6_ = builder;
#line 237 "../src/util/string.vala"
		g_string_append_unichar (_tmp6_, ch);
#line 1616 "string.c"
	}
#line 239 "../src/util/string.vala"
	_tmp7_ = builder;
#line 239 "../src/util/string.vala"
	_tmp8_ = _tmp7_->str;
#line 239 "../src/util/string.vala"
	_tmp9_ = g_strdup (_tmp8_);
#line 239 "../src/util/string.vala"
	result = _tmp9_;
#line 239 "../src/util/string.vala"
	_g_string_free0 (builder);
#line 239 "../src/util/string.vala"
	return result;
#line 1630 "string.c"
}

gchar*
string_to_hex_string (const gchar* str)
{
	GString* builder = NULL;
	GString* _tmp0_;
	guint8* data = NULL;
	GString* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* result;
#line 242 "../src/util/string.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 243 "../src/util/string.vala"
	_tmp0_ = g_string_new ("");
#line 243 "../src/util/string.vala"
	builder = _tmp0_;
#line 245 "../src/util/string.vala"
	data = (guint8*) str;
#line 246 "../src/util/string.vala"
	while (TRUE) {
#line 1653 "string.c"
		guint8* _tmp1_;
		const gchar* _tmp2_ = NULL;
		guint8* _tmp3_;
		GString* _tmp4_;
		guint8* _tmp5_;
#line 246 "../src/util/string.vala"
		_tmp1_ = data;
#line 246 "../src/util/string.vala"
		if (!(((gint) (*_tmp1_)) != 0)) {
#line 246 "../src/util/string.vala"
			break;
#line 1665 "string.c"
		}
#line 247 "../src/util/string.vala"
		_tmp3_ = data;
#line 247 "../src/util/string.vala"
		if (((gint) (*_tmp3_)) != 0) {
#line 247 "../src/util/string.vala"
			_tmp2_ = " ";
#line 1673 "string.c"
		} else {
#line 247 "../src/util/string.vala"
			_tmp2_ = "";
#line 1677 "string.c"
		}
#line 247 "../src/util/string.vala"
		_tmp4_ = builder;
#line 247 "../src/util/string.vala"
		_tmp5_ = data;
#line 247 "../src/util/string.vala"
		data = _tmp5_ + 1;
#line 247 "../src/util/string.vala"
		g_string_append_printf (_tmp4_, "%02Xh%s", (guint) (*_tmp5_), _tmp2_);
#line 1687 "string.c"
	}
#line 249 "../src/util/string.vala"
	_tmp6_ = builder;
#line 249 "../src/util/string.vala"
	_tmp7_ = _tmp6_->str;
#line 249 "../src/util/string.vala"
	_tmp8_ = g_strdup (_tmp7_);
#line 249 "../src/util/string.vala"
	result = _tmp8_;
#line 249 "../src/util/string.vala"
	_g_string_free0 (builder);
#line 249 "../src/util/string.vala"
	return result;
#line 1701 "string.c"
}

guint
string_collated_hash (void* ptr)
{
	gchar* str = NULL;
	gchar* _tmp0_;
	GHashFunc _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	guint _tmp4_;
	guint result;
#line 269 "../src/util/string.vala"
	_tmp0_ = g_strdup ((const gchar*) ptr);
#line 269 "../src/util/string.vala"
	str = _tmp0_;
#line 271 "../src/util/string.vala"
	_tmp1_ = g_str_hash;
#line 271 "../src/util/string.vala"
	_tmp2_ = g_utf8_collate_key (str, (gssize) -1);
#line 271 "../src/util/string.vala"
	_tmp3_ = _tmp2_;
#line 271 "../src/util/string.vala"
	_tmp4_ = _tmp1_ (_tmp3_);
#line 271 "../src/util/string.vala"
	_g_free0 (_tmp3_);
#line 271 "../src/util/string.vala"
	result = _tmp4_;
#line 271 "../src/util/string.vala"
	_g_free0 (str);
#line 271 "../src/util/string.vala"
	return result;
#line 1734 "string.c"
}

guint
string_precollated_hash (void* ptr)
{
	GHashFunc _tmp0_;
	guint result;
#line 276 "../src/util/string.vala"
	_tmp0_ = g_str_hash;
#line 276 "../src/util/string.vala"
	result = _tmp0_ ((const gchar*) ptr);
#line 276 "../src/util/string.vala"
	return result;
#line 1748 "string.c"
}

gint
string_collated_compare (void* a,
                         void* b)
{
	gchar* astr = NULL;
	gchar* _tmp0_;
	gchar* bstr = NULL;
	gchar* _tmp1_;
	gint _result_ = 0;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_ = 0;
	gint result;
#line 281 "../src/util/string.vala"
	_tmp0_ = g_strdup ((const gchar*) a);
#line 281 "../src/util/string.vala"
	astr = _tmp0_;
#line 282 "../src/util/string.vala"
	_tmp1_ = g_strdup ((const gchar*) b);
#line 282 "../src/util/string.vala"
	bstr = _tmp1_;
#line 284 "../src/util/string.vala"
	_tmp2_ = astr;
#line 284 "../src/util/string.vala"
	_tmp3_ = bstr;
#line 284 "../src/util/string.vala"
	_result_ = g_utf8_collate (_tmp2_, _tmp3_);
#line 286 "../src/util/string.vala"
	if (_result_ != 0) {
#line 286 "../src/util/string.vala"
		_tmp4_ = _result_;
#line 1782 "string.c"
	} else {
		GCompareFunc _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
#line 286 "../src/util/string.vala"
		_tmp5_ = ((GCompareFunc) g_strcmp0);
#line 286 "../src/util/string.vala"
		_tmp6_ = astr;
#line 286 "../src/util/string.vala"
		_tmp7_ = bstr;
#line 286 "../src/util/string.vala"
		_tmp4_ = _tmp5_ (_tmp6_, _tmp7_);
#line 1795 "string.c"
	}
#line 286 "../src/util/string.vala"
	result = _tmp4_;
#line 286 "../src/util/string.vala"
	_g_free0 (bstr);
#line 286 "../src/util/string.vala"
	_g_free0 (astr);
#line 286 "../src/util/string.vala"
	return result;
#line 1805 "string.c"
}

gint
string_precollated_compare (const gchar* astr,
                            const gchar* akey,
                            const gchar* bstr,
                            const gchar* bkey)
{
	gint _result_ = 0;
	GCompareFunc _tmp0_;
	gint _tmp1_ = 0;
	gint result;
#line 290 "../src/util/string.vala"
	g_return_val_if_fail (astr != NULL, 0);
#line 290 "../src/util/string.vala"
	g_return_val_if_fail (akey != NULL, 0);
#line 290 "../src/util/string.vala"
	g_return_val_if_fail (bstr != NULL, 0);
#line 290 "../src/util/string.vala"
	g_return_val_if_fail (bkey != NULL, 0);
#line 291 "../src/util/string.vala"
	_tmp0_ = ((GCompareFunc) g_strcmp0);
#line 291 "../src/util/string.vala"
	_result_ = _tmp0_ (akey, bkey);
#line 293 "../src/util/string.vala"
	if (_result_ != 0) {
#line 293 "../src/util/string.vala"
		_tmp1_ = _result_;
#line 1834 "string.c"
	} else {
		GCompareFunc _tmp2_;
#line 293 "../src/util/string.vala"
		_tmp2_ = ((GCompareFunc) g_strcmp0);
#line 293 "../src/util/string.vala"
		_tmp1_ = _tmp2_ (astr, bstr);
#line 1841 "string.c"
	}
#line 293 "../src/util/string.vala"
	result = _tmp1_;
#line 293 "../src/util/string.vala"
	return result;
#line 1847 "string.c"
}

gboolean
string_collated_equals (void* a,
                        void* b)
{
	gboolean result;
#line 298 "../src/util/string.vala"
	result = string_collated_compare (a, b) == 0;
#line 298 "../src/util/string.vala"
	return result;
#line 1859 "string.c"
}

gboolean
string_precollated_equals (const gchar* astr,
                           const gchar* akey,
                           const gchar* bstr,
                           const gchar* bkey)
{
	gboolean result;
#line 302 "../src/util/string.vala"
	g_return_val_if_fail (astr != NULL, FALSE);
#line 302 "../src/util/string.vala"
	g_return_val_if_fail (akey != NULL, FALSE);
#line 302 "../src/util/string.vala"
	g_return_val_if_fail (bstr != NULL, FALSE);
#line 302 "../src/util/string.vala"
	g_return_val_if_fail (bkey != NULL, FALSE);
#line 303 "../src/util/string.vala"
	result = string_precollated_compare (astr, akey, bstr, bkey) == 0;
#line 303 "../src/util/string.vala"
	return result;
#line 1881 "string.c"
}

