/* FlickrPublishing.c generated by valac 0.56.14, the Vala compiler
 * generated from FlickrPublishing.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include "shotwell-publishing.h"
#include <glib-object.h>
#include <glib.h>
#include "shotwell-plugin-dev-1.0.h"
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gobject/gvaluecollector.h>
#include "shotwell-plugin-common.h"
#include "shotwell-authenticator.h"
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include <libxml/tree.h>
#include <gtk/gtk.h>
#include <gee.h>
#include <gexiv2/gexiv2.h>

#define PUBLISHING_FLICKR_SERVICE_NAME "Flickr"
#define PUBLISHING_FLICKR_ENDPOINT_URL "https://api.flickr.com/services/rest"
#define PUBLISHING_FLICKR_ORIGINAL_SIZE -1
#define PUBLISHING_FLICKR_EXPIRED_SESSION_ERROR_CODE "98"

enum  {
	FLICKR_SERVICE_0_PROPERTY,
	FLICKR_SERVICE_NUM_PROPERTIES
};
static GParamSpec* flickr_service_properties[FLICKR_SERVICE_NUM_PROPERTIES];
typedef enum  {
	PUBLISHING_FLICKR_USER_KIND_PRO,
	PUBLISHING_FLICKR_USER_KIND_FREE
} PublishingFlickrUserKind;

#define PUBLISHING_FLICKR_TYPE_USER_KIND (publishing_flickr_user_kind_get_type ())

#define PUBLISHING_FLICKR_TYPE_VISIBILITY_SPECIFICATION (publishing_flickr_visibility_specification_get_type ())
#define PUBLISHING_FLICKR_VISIBILITY_SPECIFICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PUBLISHING_FLICKR_TYPE_VISIBILITY_SPECIFICATION, PublishingFlickrVisibilitySpecification))
#define PUBLISHING_FLICKR_VISIBILITY_SPECIFICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PUBLISHING_FLICKR_TYPE_VISIBILITY_SPECIFICATION, PublishingFlickrVisibilitySpecificationClass))
#define PUBLISHING_FLICKR_IS_VISIBILITY_SPECIFICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PUBLISHING_FLICKR_TYPE_VISIBILITY_SPECIFICATION))
#define PUBLISHING_FLICKR_IS_VISIBILITY_SPECIFICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PUBLISHING_FLICKR_TYPE_VISIBILITY_SPECIFICATION))
#define PUBLISHING_FLICKR_VISIBILITY_SPECIFICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PUBLISHING_FLICKR_TYPE_VISIBILITY_SPECIFICATION, PublishingFlickrVisibilitySpecificationClass))

typedef struct _PublishingFlickrVisibilitySpecification PublishingFlickrVisibilitySpecification;
typedef struct _PublishingFlickrVisibilitySpecificationClass PublishingFlickrVisibilitySpecificationClass;
typedef struct _PublishingFlickrVisibilitySpecificationPrivate PublishingFlickrVisibilitySpecificationPrivate;
typedef struct _PublishingFlickrParamSpecVisibilitySpecification PublishingFlickrParamSpecVisibilitySpecification;

#define PUBLISHING_FLICKR_TYPE_PUBLISHING_PARAMETERS (publishing_flickr_publishing_parameters_get_type ())
#define PUBLISHING_FLICKR_PUBLISHING_PARAMETERS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PUBLISHING_FLICKR_TYPE_PUBLISHING_PARAMETERS, PublishingFlickrPublishingParameters))
#define PUBLISHING_FLICKR_PUBLISHING_PARAMETERS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PUBLISHING_FLICKR_TYPE_PUBLISHING_PARAMETERS, PublishingFlickrPublishingParametersClass))
#define PUBLISHING_FLICKR_IS_PUBLISHING_PARAMETERS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PUBLISHING_FLICKR_TYPE_PUBLISHING_PARAMETERS))
#define PUBLISHING_FLICKR_IS_PUBLISHING_PARAMETERS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PUBLISHING_FLICKR_TYPE_PUBLISHING_PARAMETERS))
#define PUBLISHING_FLICKR_PUBLISHING_PARAMETERS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PUBLISHING_FLICKR_TYPE_PUBLISHING_PARAMETERS, PublishingFlickrPublishingParametersClass))

typedef struct _PublishingFlickrPublishingParameters PublishingFlickrPublishingParameters;
typedef struct _PublishingFlickrPublishingParametersClass PublishingFlickrPublishingParametersClass;
typedef struct _PublishingFlickrPublishingParametersPrivate PublishingFlickrPublishingParametersPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _publishing_flickr_visibility_specification_unref0(var) ((var == NULL) ? NULL : (var = (publishing_flickr_visibility_specification_unref (var), NULL)))
typedef struct _PublishingFlickrParamSpecPublishingParameters PublishingFlickrParamSpecPublishingParameters;

#define PUBLISHING_FLICKR_TYPE_PUBLISHING_OPTIONS_PANE (publishing_flickr_publishing_options_pane_get_type ())
#define PUBLISHING_FLICKR_PUBLISHING_OPTIONS_PANE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PUBLISHING_FLICKR_TYPE_PUBLISHING_OPTIONS_PANE, PublishingFlickrPublishingOptionsPane))
#define PUBLISHING_FLICKR_PUBLISHING_OPTIONS_PANE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PUBLISHING_FLICKR_TYPE_PUBLISHING_OPTIONS_PANE, PublishingFlickrPublishingOptionsPaneClass))
#define PUBLISHING_FLICKR_IS_PUBLISHING_OPTIONS_PANE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PUBLISHING_FLICKR_TYPE_PUBLISHING_OPTIONS_PANE))
#define PUBLISHING_FLICKR_IS_PUBLISHING_OPTIONS_PANE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PUBLISHING_FLICKR_TYPE_PUBLISHING_OPTIONS_PANE))
#define PUBLISHING_FLICKR_PUBLISHING_OPTIONS_PANE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PUBLISHING_FLICKR_TYPE_PUBLISHING_OPTIONS_PANE, PublishingFlickrPublishingOptionsPaneClass))

typedef struct _PublishingFlickrPublishingOptionsPane PublishingFlickrPublishingOptionsPane;
typedef struct _PublishingFlickrPublishingOptionsPaneClass PublishingFlickrPublishingOptionsPaneClass;
enum  {
	PUBLISHING_FLICKR_FLICKR_PUBLISHER_0_PROPERTY,
	PUBLISHING_FLICKR_FLICKR_PUBLISHER_NUM_PROPERTIES
};
static GParamSpec* publishing_flickr_flickr_publisher_properties[PUBLISHING_FLICKR_FLICKR_PUBLISHER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _publishing_rest_support_session_unref0(var) ((var == NULL) ? NULL : (var = (publishing_rest_support_session_unref (var), NULL)))
#define _publishing_flickr_publishing_parameters_unref0(var) ((var == NULL) ? NULL : (var = (publishing_flickr_publishing_parameters_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))

#define PUBLISHING_FLICKR_TYPE_ACCOUNT_INFO_FETCH_TRANSACTION (publishing_flickr_account_info_fetch_transaction_get_type ())
#define PUBLISHING_FLICKR_ACCOUNT_INFO_FETCH_TRANSACTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PUBLISHING_FLICKR_TYPE_ACCOUNT_INFO_FETCH_TRANSACTION, PublishingFlickrAccountInfoFetchTransaction))
#define PUBLISHING_FLICKR_ACCOUNT_INFO_FETCH_TRANSACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PUBLISHING_FLICKR_TYPE_ACCOUNT_INFO_FETCH_TRANSACTION, PublishingFlickrAccountInfoFetchTransactionClass))
#define PUBLISHING_FLICKR_IS_ACCOUNT_INFO_FETCH_TRANSACTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PUBLISHING_FLICKR_TYPE_ACCOUNT_INFO_FETCH_TRANSACTION))
#define PUBLISHING_FLICKR_IS_ACCOUNT_INFO_FETCH_TRANSACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PUBLISHING_FLICKR_TYPE_ACCOUNT_INFO_FETCH_TRANSACTION))
#define PUBLISHING_FLICKR_ACCOUNT_INFO_FETCH_TRANSACTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PUBLISHING_FLICKR_TYPE_ACCOUNT_INFO_FETCH_TRANSACTION, PublishingFlickrAccountInfoFetchTransactionClass))

typedef struct _PublishingFlickrAccountInfoFetchTransaction PublishingFlickrAccountInfoFetchTransaction;
typedef struct _PublishingFlickrAccountInfoFetchTransactionClass PublishingFlickrAccountInfoFetchTransactionClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _publishing_rest_support_transaction_unref0(var) ((var == NULL) ? NULL : (var = (publishing_rest_support_transaction_unref (var), NULL)))
typedef struct _PublishingFlickrFlickrPublisherDoFetchAccountInfoData PublishingFlickrFlickrPublisherDoFetchAccountInfoData;
#define _publishing_rest_support_xml_document_unref0(var) ((var == NULL) ? NULL : (var = (publishing_rest_support_xml_document_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))

#define PUBLISHING_FLICKR_TYPE_UPLOADER (publishing_flickr_uploader_get_type ())
#define PUBLISHING_FLICKR_UPLOADER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PUBLISHING_FLICKR_TYPE_UPLOADER, PublishingFlickrUploader))
#define PUBLISHING_FLICKR_UPLOADER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PUBLISHING_FLICKR_TYPE_UPLOADER, PublishingFlickrUploaderClass))
#define PUBLISHING_FLICKR_IS_UPLOADER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PUBLISHING_FLICKR_TYPE_UPLOADER))
#define PUBLISHING_FLICKR_IS_UPLOADER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PUBLISHING_FLICKR_TYPE_UPLOADER))
#define PUBLISHING_FLICKR_UPLOADER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PUBLISHING_FLICKR_TYPE_UPLOADER, PublishingFlickrUploaderClass))

typedef struct _PublishingFlickrUploader PublishingFlickrUploader;
typedef struct _PublishingFlickrUploaderClass PublishingFlickrUploaderClass;
#define _publishing_rest_support_batch_uploader_unref0(var) ((var == NULL) ? NULL : (var = (publishing_rest_support_batch_uploader_unref (var), NULL)))
typedef struct _PublishingFlickrFlickrPublisherDoPublishData PublishingFlickrFlickrPublisherDoPublishData;
typedef struct _PublishingFlickrAccountInfoFetchTransactionPrivate PublishingFlickrAccountInfoFetchTransactionPrivate;

#define PUBLISHING_FLICKR_TYPE_UPLOAD_TRANSACTION (publishing_flickr_upload_transaction_get_type ())
#define PUBLISHING_FLICKR_UPLOAD_TRANSACTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PUBLISHING_FLICKR_TYPE_UPLOAD_TRANSACTION, PublishingFlickrUploadTransaction))
#define PUBLISHING_FLICKR_UPLOAD_TRANSACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PUBLISHING_FLICKR_TYPE_UPLOAD_TRANSACTION, PublishingFlickrUploadTransactionClass))
#define PUBLISHING_FLICKR_IS_UPLOAD_TRANSACTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PUBLISHING_FLICKR_TYPE_UPLOAD_TRANSACTION))
#define PUBLISHING_FLICKR_IS_UPLOAD_TRANSACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PUBLISHING_FLICKR_TYPE_UPLOAD_TRANSACTION))
#define PUBLISHING_FLICKR_UPLOAD_TRANSACTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PUBLISHING_FLICKR_TYPE_UPLOAD_TRANSACTION, PublishingFlickrUploadTransactionClass))

typedef struct _PublishingFlickrUploadTransaction PublishingFlickrUploadTransaction;
typedef struct _PublishingFlickrUploadTransactionClass PublishingFlickrUploadTransactionClass;
typedef struct _PublishingFlickrUploadTransactionPrivate PublishingFlickrUploadTransactionPrivate;
typedef struct _PublishingFlickrUploadTransactionExecuteAsyncData PublishingFlickrUploadTransactionExecuteAsyncData;
typedef struct _PublishingFlickrPublishingOptionsPanePrivate PublishingFlickrPublishingOptionsPanePrivate;

#define PUBLISHING_FLICKR_PUBLISHING_OPTIONS_PANE_TYPE_VISIBILITY_ENTRY (publishing_flickr_publishing_options_pane_visibility_entry_get_type ())
#define PUBLISHING_FLICKR_PUBLISHING_OPTIONS_PANE_VISIBILITY_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PUBLISHING_FLICKR_PUBLISHING_OPTIONS_PANE_TYPE_VISIBILITY_ENTRY, PublishingFlickrPublishingOptionsPaneVisibilityEntry))
#define PUBLISHING_FLICKR_PUBLISHING_OPTIONS_PANE_VISIBILITY_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PUBLISHING_FLICKR_PUBLISHING_OPTIONS_PANE_TYPE_VISIBILITY_ENTRY, PublishingFlickrPublishingOptionsPaneVisibilityEntryClass))
#define PUBLISHING_FLICKR_PUBLISHING_OPTIONS_PANE_IS_VISIBILITY_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PUBLISHING_FLICKR_PUBLISHING_OPTIONS_PANE_TYPE_VISIBILITY_ENTRY))
#define PUBLISHING_FLICKR_PUBLISHING_OPTIONS_PANE_IS_VISIBILITY_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PUBLISHING_FLICKR_PUBLISHING_OPTIONS_PANE_TYPE_VISIBILITY_ENTRY))
#define PUBLISHING_FLICKR_PUBLISHING_OPTIONS_PANE_VISIBILITY_ENTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PUBLISHING_FLICKR_PUBLISHING_OPTIONS_PANE_TYPE_VISIBILITY_ENTRY, PublishingFlickrPublishingOptionsPaneVisibilityEntryClass))

typedef struct _PublishingFlickrPublishingOptionsPaneVisibilityEntry PublishingFlickrPublishingOptionsPaneVisibilityEntry;
typedef struct _PublishingFlickrPublishingOptionsPaneVisibilityEntryClass PublishingFlickrPublishingOptionsPaneVisibilityEntryClass;

#define PUBLISHING_FLICKR_PUBLISHING_OPTIONS_PANE_TYPE_SIZE_ENTRY (publishing_flickr_publishing_options_pane_size_entry_get_type ())
#define PUBLISHING_FLICKR_PUBLISHING_OPTIONS_PANE_SIZE_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PUBLISHING_FLICKR_PUBLISHING_OPTIONS_PANE_TYPE_SIZE_ENTRY, PublishingFlickrPublishingOptionsPaneSizeEntry))
#define PUBLISHING_FLICKR_PUBLISHING_OPTIONS_PANE_SIZE_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PUBLISHING_FLICKR_PUBLISHING_OPTIONS_PANE_TYPE_SIZE_ENTRY, PublishingFlickrPublishingOptionsPaneSizeEntryClass))
#define PUBLISHING_FLICKR_PUBLISHING_OPTIONS_PANE_IS_SIZE_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PUBLISHING_FLICKR_PUBLISHING_OPTIONS_PANE_TYPE_SIZE_ENTRY))
#define PUBLISHING_FLICKR_PUBLISHING_OPTIONS_PANE_IS_SIZE_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PUBLISHING_FLICKR_PUBLISHING_OPTIONS_PANE_TYPE_SIZE_ENTRY))
#define PUBLISHING_FLICKR_PUBLISHING_OPTIONS_PANE_SIZE_ENTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PUBLISHING_FLICKR_PUBLISHING_OPTIONS_PANE_TYPE_SIZE_ENTRY, PublishingFlickrPublishingOptionsPaneSizeEntryClass))

typedef struct _PublishingFlickrPublishingOptionsPaneSizeEntry PublishingFlickrPublishingOptionsPaneSizeEntry;
typedef struct _PublishingFlickrPublishingOptionsPaneSizeEntryClass PublishingFlickrPublishingOptionsPaneSizeEntryClass;
enum  {
	PUBLISHING_FLICKR_PUBLISHING_OPTIONS_PANE_0_PROPERTY,
	PUBLISHING_FLICKR_PUBLISHING_OPTIONS_PANE_NUM_PROPERTIES
};
static GParamSpec* publishing_flickr_publishing_options_pane_properties[PUBLISHING_FLICKR_PUBLISHING_OPTIONS_PANE_NUM_PROPERTIES];
typedef struct _PublishingFlickrPublishingOptionsPaneVisibilityEntryPrivate PublishingFlickrPublishingOptionsPaneVisibilityEntryPrivate;
typedef struct _PublishingFlickrPublishingOptionsPaneSizeEntryPrivate PublishingFlickrPublishingOptionsPaneSizeEntryPrivate;
#define _publishing_flickr_publishing_options_pane_visibility_entry_unref0(var) ((var == NULL) ? NULL : (var = (publishing_flickr_publishing_options_pane_visibility_entry_unref (var), NULL)))
#define _publishing_flickr_publishing_options_pane_size_entry_unref0(var) ((var == NULL) ? NULL : (var = (publishing_flickr_publishing_options_pane_size_entry_unref (var), NULL)))
typedef struct _PublishingFlickrPublishingOptionsPaneParamSpecSizeEntry PublishingFlickrPublishingOptionsPaneParamSpecSizeEntry;
typedef struct _PublishingFlickrPublishingOptionsPaneParamSpecVisibilityEntry PublishingFlickrPublishingOptionsPaneParamSpecVisibilityEntry;
enum  {
	PUBLISHING_FLICKR_PUBLISHING_OPTIONS_PANE_PUBLISH_SIGNAL,
	PUBLISHING_FLICKR_PUBLISHING_OPTIONS_PANE_LOGOUT_SIGNAL,
	PUBLISHING_FLICKR_PUBLISHING_OPTIONS_PANE_NUM_SIGNALS
};
static guint publishing_flickr_publishing_options_pane_signals[PUBLISHING_FLICKR_PUBLISHING_OPTIONS_PANE_NUM_SIGNALS] = {0};
typedef struct _PublishingFlickrUploaderPrivate PublishingFlickrUploaderPrivate;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _PublishingFlickrVisibilitySpecification {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PublishingFlickrVisibilitySpecificationPrivate * priv;
	gint friends_level;
	gint family_level;
	gint everyone_level;
};

struct _PublishingFlickrVisibilitySpecificationClass {
	GTypeClass parent_class;
	void (*finalize) (PublishingFlickrVisibilitySpecification *self);
};

struct _PublishingFlickrParamSpecVisibilitySpecification {
	GParamSpec parent_instance;
};

struct _PublishingFlickrPublishingParameters {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PublishingFlickrPublishingParametersPrivate * priv;
	PublishingFlickrUserKind user_kind;
	gint64 max_images_count;
	guint64 uploaded_images_count;
	gint photo_major_axis_size;
	gchar* username;
	PublishingFlickrVisibilitySpecification* visibility_specification;
	gboolean strip_metadata;
};

struct _PublishingFlickrPublishingParametersClass {
	GTypeClass parent_class;
	void (*finalize) (PublishingFlickrPublishingParameters *self);
};

struct _PublishingFlickrParamSpecPublishingParameters {
	GParamSpec parent_instance;
};

struct _PublishingFlickrFlickrPublisherPrivate {
	SpitPublishingService* service;
	SpitPublishingPluginHost* host;
	SpitPublishingProgressCallback progress_reporter;
	gpointer progress_reporter_target;
	GDestroyNotify progress_reporter_target_destroy_notify;
	gboolean running;
	gboolean was_started;
	PublishingRESTSupportOAuth1Session* session;
	PublishingFlickrPublishingOptionsPane* publishing_options_pane;
	SpitPublishingAuthenticator* authenticator;
	PublishingFlickrPublishingParameters* parameters;
};

struct _PublishingFlickrFlickrPublisherDoFetchAccountInfoData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	PublishingFlickrFlickrPublisher* self;
	SpitPublishingPluginHost* _tmp0_;
	SpitPublishingPluginHost* _tmp1_;
	PublishingFlickrAccountInfoFetchTransaction* txn;
	PublishingRESTSupportOAuth1Session* _tmp2_;
	PublishingFlickrAccountInfoFetchTransaction* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GError* err;
	SpitPublishingPluginHost* _tmp6_;
	GError* _tmp7_;
	GError* _inner_error0_;
};

struct _PublishingFlickrFlickrPublisherDoPublishData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	PublishingFlickrFlickrPublisher* self;
	gboolean strip_metadata;
	SpitPublishingPluginHost* _tmp0_;
	SpitPublishingPluginHost* _tmp1_;
	PublishingFlickrPublishingParameters* _tmp2_;
	gpointer _tmp3_;
	GDestroyNotify _tmp4_;
	SpitPublishingProgressCallback _tmp5_;
	SpitPublishingPublishable** publishables;
	SpitPublishingPluginHost* _tmp6_;
	gint _tmp7_;
	SpitPublishingPublishable** _tmp8_;
	gint publishables_length1;
	gint _publishables_size_;
	GeeArrayList* sorted_list;
	GeeArrayList* _tmp9_;
	SpitPublishingPublishable** _tmp10_;
	gint _tmp10__length1;
	SpitPublishingPublishable** p_collection;
	gint p_collection_length1;
	gint _p_collection_size_;
	gint p_it;
	SpitPublishingPublishable* _tmp11_;
	SpitPublishingPublishable* p;
	GeeArrayList* _tmp12_;
	SpitPublishingPublishable* _tmp13_;
	GeeArrayList* _tmp14_;
	PublishingFlickrUploader* uploader;
	PublishingRESTSupportOAuth1Session* _tmp15_;
	GeeArrayList* _tmp16_;
	gint _tmp17_;
	gpointer* _tmp18_;
	SpitPublishingPublishable** _tmp19_;
	gint _tmp19__length1;
	PublishingFlickrPublishingParameters* _tmp20_;
	PublishingFlickrUploader* _tmp21_;
	PublishingFlickrUploader* _tmp22_;
	gint num_published;
	PublishingFlickrUploader* _tmp23_;
	GError* err;
	GError* _tmp24_;
	const gchar* _tmp25_;
	SpitPublishingPluginHost* _tmp26_;
	GError* _tmp27_;
	GError* _inner_error0_;
};

struct _PublishingFlickrAccountInfoFetchTransaction {
	PublishingRESTSupportOAuth1Transaction parent_instance;
	PublishingFlickrAccountInfoFetchTransactionPrivate * priv;
};

struct _PublishingFlickrAccountInfoFetchTransactionClass {
	PublishingRESTSupportOAuth1TransactionClass parent_class;
};

struct _PublishingFlickrUploadTransaction {
	PublishingRESTSupportOAuth1UploadTransaction parent_instance;
	PublishingFlickrUploadTransactionPrivate * priv;
};

struct _PublishingFlickrUploadTransactionClass {
	PublishingRESTSupportOAuth1UploadTransactionClass parent_class;
};

struct _PublishingFlickrUploadTransactionPrivate {
	PublishingFlickrPublishingParameters* parameters;
};

struct _PublishingFlickrUploadTransactionExecuteAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	PublishingFlickrUploadTransaction* self;
	GError* _inner_error0_;
};

struct _PublishingFlickrPublishingOptionsPane {
	GObject parent_instance;
	PublishingFlickrPublishingOptionsPanePrivate * priv;
};

struct _PublishingFlickrPublishingOptionsPaneClass {
	GObjectClass parent_class;
};

struct _PublishingFlickrPublishingOptionsPanePrivate {
	GtkBuilder* builder;
	GtkBox* pane_widget;
	GtkLabel* visibility_label;
	GtkLabel* upload_info_label;
	GtkLabel* size_label;
	GtkButton* logout_button;
	GtkButton* publish_button;
	GtkComboBoxText* visibility_combo;
	GtkComboBoxText* size_combo;
	GtkCheckButton* strip_metadata_check;
	PublishingFlickrPublishingOptionsPaneVisibilityEntry** visibilities;
	gint visibilities_length1;
	gint _visibilities_size_;
	PublishingFlickrPublishingOptionsPaneSizeEntry** sizes;
	gint sizes_length1;
	gint _sizes_size_;
	PublishingFlickrPublishingParameters* parameters;
	PublishingFlickrFlickrPublisher* publisher;
	SpitPublishingPublisherMediaType media_type;
};

struct _PublishingFlickrPublishingOptionsPaneVisibilityEntry {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PublishingFlickrPublishingOptionsPaneVisibilityEntryPrivate * priv;
	PublishingFlickrVisibilitySpecification* specification;
	gchar* title;
};

struct _PublishingFlickrPublishingOptionsPaneVisibilityEntryClass {
	GTypeClass parent_class;
	void (*finalize) (PublishingFlickrPublishingOptionsPaneVisibilityEntry *self);
};

struct _PublishingFlickrPublishingOptionsPaneSizeEntry {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PublishingFlickrPublishingOptionsPaneSizeEntryPrivate * priv;
	gchar* title;
	gint size;
};

struct _PublishingFlickrPublishingOptionsPaneSizeEntryClass {
	GTypeClass parent_class;
	void (*finalize) (PublishingFlickrPublishingOptionsPaneSizeEntry *self);
};

struct _PublishingFlickrPublishingOptionsPaneParamSpecSizeEntry {
	GParamSpec parent_instance;
};

struct _PublishingFlickrPublishingOptionsPaneParamSpecVisibilityEntry {
	GParamSpec parent_instance;
};

struct _PublishingFlickrUploader {
	PublishingRESTSupportBatchUploader parent_instance;
	PublishingFlickrUploaderPrivate * priv;
};

struct _PublishingFlickrUploaderClass {
	PublishingRESTSupportBatchUploaderClass parent_class;
};

struct _PublishingFlickrUploaderPrivate {
	PublishingFlickrPublishingParameters* parameters;
	gboolean strip_metadata;
};

static gpointer flickr_service_parent_class = NULL;
static SpitPluggableIface * flickr_service_spit_pluggable_parent_iface = NULL;
static SpitPublishingServiceIface * flickr_service_spit_publishing_service_parent_iface = NULL;
static gpointer publishing_flickr_visibility_specification_parent_class = NULL;
static gpointer publishing_flickr_publishing_parameters_parent_class = NULL;
static gint PublishingFlickrFlickrPublisher_private_offset;
static gpointer publishing_flickr_flickr_publisher_parent_class = NULL;
static SpitPublishingPublisherIface * publishing_flickr_flickr_publisher_spit_publishing_publisher_parent_iface = NULL;
static gpointer publishing_flickr_account_info_fetch_transaction_parent_class = NULL;
static gint PublishingFlickrUploadTransaction_private_offset;
static gpointer publishing_flickr_upload_transaction_parent_class = NULL;
static gint PublishingFlickrPublishingOptionsPane_private_offset;
static gpointer publishing_flickr_publishing_options_pane_parent_class = NULL;
static gpointer publishing_flickr_publishing_options_pane_size_entry_parent_class = NULL;
static gpointer publishing_flickr_publishing_options_pane_visibility_entry_parent_class = NULL;
static SpitPublishingDialogPaneIface * publishing_flickr_publishing_options_pane_spit_publishing_dialog_pane_parent_iface = NULL;
static gint PublishingFlickrUploader_private_offset;
static gpointer publishing_flickr_uploader_parent_class = NULL;

static gint flickr_service_real_get_pluggable_interface (SpitPluggable* base,
                                                  gint min_host_interface,
                                                  gint max_host_interface);
static const gchar* flickr_service_real_get_id (SpitPluggable* base);
static const gchar* flickr_service_real_get_pluggable_name (SpitPluggable* base);
static SpitPluggableInfo* flickr_service_real_get_info (SpitPluggable* base);
static void flickr_service_real_activation (SpitPluggable* base,
                                     gboolean enabled);
static SpitPublishingPublisher* flickr_service_real_create_publisher (SpitPublishingService* base,
                                                               SpitPublishingPluginHost* host);
static SpitPublishingPublisherMediaType flickr_service_real_get_supported_media (SpitPublishingService* base);
static GType flickr_service_get_type_once (void);
VALA_EXTERN GType publishing_flickr_user_kind_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gpointer publishing_flickr_visibility_specification_ref (gpointer instance);
VALA_EXTERN void publishing_flickr_visibility_specification_unref (gpointer instance);
VALA_EXTERN GParamSpec* publishing_flickr_param_spec_visibility_specification (const gchar* name,
                                                                   const gchar* nick,
                                                                   const gchar* blurb,
                                                                   GType object_type,
                                                                   GParamFlags flags);
VALA_EXTERN void publishing_flickr_value_set_visibility_specification (GValue* value,
                                                           gpointer v_object);
VALA_EXTERN void publishing_flickr_value_take_visibility_specification (GValue* value,
                                                            gpointer v_object);
VALA_EXTERN gpointer publishing_flickr_value_get_visibility_specification (const GValue* value);
VALA_EXTERN GType publishing_flickr_visibility_specification_get_type (void) G_GNUC_CONST ;
VALA_EXTERN PublishingFlickrVisibilitySpecification* publishing_flickr_visibility_specification_new (gint friends_level,
                                                                                         gint family_level,
                                                                                         gint everyone_level);
VALA_EXTERN PublishingFlickrVisibilitySpecification* publishing_flickr_visibility_specification_construct (GType object_type,
                                                                                               gint friends_level,
                                                                                               gint family_level,
                                                                                               gint everyone_level);
static void publishing_flickr_visibility_specification_finalize (PublishingFlickrVisibilitySpecification * obj);
static GType publishing_flickr_visibility_specification_get_type_once (void);
VALA_EXTERN gpointer publishing_flickr_publishing_parameters_ref (gpointer instance);
VALA_EXTERN void publishing_flickr_publishing_parameters_unref (gpointer instance);
VALA_EXTERN GParamSpec* publishing_flickr_param_spec_publishing_parameters (const gchar* name,
                                                                const gchar* nick,
                                                                const gchar* blurb,
                                                                GType object_type,
                                                                GParamFlags flags);
VALA_EXTERN void publishing_flickr_value_set_publishing_parameters (GValue* value,
                                                        gpointer v_object);
VALA_EXTERN void publishing_flickr_value_take_publishing_parameters (GValue* value,
                                                         gpointer v_object);
VALA_EXTERN gpointer publishing_flickr_value_get_publishing_parameters (const GValue* value);
VALA_EXTERN GType publishing_flickr_publishing_parameters_get_type (void) G_GNUC_CONST ;
VALA_EXTERN PublishingFlickrPublishingParameters* publishing_flickr_publishing_parameters_new (void);
VALA_EXTERN PublishingFlickrPublishingParameters* publishing_flickr_publishing_parameters_construct (GType object_type);
static void publishing_flickr_publishing_parameters_finalize (PublishingFlickrPublishingParameters * obj);
static GType publishing_flickr_publishing_parameters_get_type_once (void);
VALA_EXTERN GType publishing_flickr_publishing_options_pane_get_type (void) G_GNUC_CONST ;
static void publishing_flickr_flickr_publisher_on_session_authenticated (PublishingFlickrFlickrPublisher* self);
static void _publishing_flickr_flickr_publisher_on_session_authenticated_spit_publishing_authenticator_authenticated (SpitPublishingAuthenticator* _sender,
                                                                                                               gpointer self);
static gboolean publishing_flickr_flickr_publisher_get_persistent_strip_metadata (PublishingFlickrFlickrPublisher* self);
static void publishing_flickr_flickr_publisher_set_persistent_strip_metadata (PublishingFlickrFlickrPublisher* self,
                                                                       gboolean strip_metadata);
static void publishing_flickr_flickr_publisher_do_fetch_account_info (PublishingFlickrFlickrPublisher* self,
                                                               GAsyncReadyCallback _callback_,
                                                               gpointer _user_data_);
static void publishing_flickr_flickr_publisher_do_fetch_account_info_finish (PublishingFlickrFlickrPublisher* self,
                                                                      GAsyncResult* _res_);
static void publishing_flickr_flickr_publisher_on_account_info_available (PublishingFlickrFlickrPublisher* self);
static void publishing_flickr_flickr_publisher_do_show_publishing_options_pane (PublishingFlickrFlickrPublisher* self);
static void publishing_flickr_flickr_publisher_on_publishing_options_pane_publish (PublishingFlickrFlickrPublisher* self,
                                                                            gboolean strip_metadata);
static void _publishing_flickr_flickr_publisher_on_publishing_options_pane_publish_publishing_flickr_publishing_options_pane_publish (PublishingFlickrPublishingOptionsPane* _sender,
                                                                                                                               gboolean strip_metadata,
                                                                                                                               gpointer self);
static void publishing_flickr_flickr_publisher_on_publishing_options_pane_logout (PublishingFlickrFlickrPublisher* self);
static void _publishing_flickr_flickr_publisher_on_publishing_options_pane_logout_publishing_flickr_publishing_options_pane_logout (PublishingFlickrPublishingOptionsPane* _sender,
                                                                                                                             gpointer self);
static void publishing_flickr_flickr_publisher_do_publish (PublishingFlickrFlickrPublisher* self,
                                                    gboolean strip_metadata,
                                                    GAsyncReadyCallback _callback_,
                                                    gpointer _user_data_);
static void publishing_flickr_flickr_publisher_do_publish_finish (PublishingFlickrFlickrPublisher* self,
                                                           GAsyncResult* _res_);
static void publishing_flickr_flickr_publisher_do_logout (PublishingFlickrFlickrPublisher* self);
static void publishing_flickr_flickr_publisher_on_upload_status_updated (PublishingFlickrFlickrPublisher* self,
                                                                  gint file_number,
                                                                  gdouble completed_fraction);
static void publishing_flickr_flickr_publisher_do_fetch_account_info_data_free (gpointer _data);
static gboolean publishing_flickr_flickr_publisher_do_fetch_account_info_co (PublishingFlickrFlickrPublisherDoFetchAccountInfoData* _data_);
VALA_EXTERN GType publishing_flickr_account_info_fetch_transaction_get_type (void) G_GNUC_CONST ;
VALA_EXTERN PublishingFlickrAccountInfoFetchTransaction* publishing_flickr_account_info_fetch_transaction_new (PublishingRESTSupportOAuth1Session* session);
VALA_EXTERN PublishingFlickrAccountInfoFetchTransaction* publishing_flickr_account_info_fetch_transaction_construct (GType object_type,
                                                                                                         PublishingRESTSupportOAuth1Session* session);
static void publishing_flickr_flickr_publisher_do_fetch_account_info_ready (GObject* source_object,
                                                                     GAsyncResult* _res_,
                                                                     gpointer _user_data_);
static void publishing_flickr_flickr_publisher_do_parse_account_info_from_xml (PublishingFlickrFlickrPublisher* self,
                                                                        const gchar* xml);
static void publishing_flickr_flickr_publisher_attempt_start (PublishingFlickrFlickrPublisher* self);
VALA_EXTERN PublishingFlickrPublishingOptionsPane* publishing_flickr_publishing_options_pane_new (PublishingFlickrFlickrPublisher* publisher,
                                                                                      PublishingFlickrPublishingParameters* parameters,
                                                                                      SpitPublishingPublisherMediaType media_type,
                                                                                      GtkBuilder* builder,
                                                                                      gboolean strip_metadata);
VALA_EXTERN PublishingFlickrPublishingOptionsPane* publishing_flickr_publishing_options_pane_construct (GType object_type,
                                                                                            PublishingFlickrFlickrPublisher* publisher,
                                                                                            PublishingFlickrPublishingParameters* parameters,
                                                                                            SpitPublishingPublisherMediaType media_type,
                                                                                            GtkBuilder* builder,
                                                                                            gboolean strip_metadata);
static void publishing_flickr_flickr_publisher_do_publish_data_free (gpointer _data);
static gboolean publishing_flickr_flickr_publisher_do_publish_co (PublishingFlickrFlickrPublisherDoPublishData* _data_);
static gint _publishing_flickr_flickr_publisher_flickr_date_time_compare_func_gcompare_data_func (gconstpointer a,
                                                                                           gconstpointer b,
                                                                                           gpointer self);
VALA_EXTERN GType publishing_flickr_uploader_get_type (void) G_GNUC_CONST ;
VALA_EXTERN PublishingFlickrUploader* publishing_flickr_uploader_new (PublishingRESTSupportOAuth1Session* session,
                                                          SpitPublishingPublishable** publishables,
                                                          gint publishables_length1,
                                                          PublishingFlickrPublishingParameters* parameters,
                                                          gboolean strip_metadata);
VALA_EXTERN PublishingFlickrUploader* publishing_flickr_uploader_construct (GType object_type,
                                                                PublishingRESTSupportOAuth1Session* session,
                                                                SpitPublishingPublishable** publishables,
                                                                gint publishables_length1,
                                                                PublishingFlickrPublishingParameters* parameters,
                                                                gboolean strip_metadata);
static void _publishing_flickr_flickr_publisher_on_upload_status_updated_spit_publishing_progress_callback (gint file_number,
                                                                                                     gdouble fraction_complete,
                                                                                                     gpointer self);
static void publishing_flickr_flickr_publisher_do_publish_ready (GObject* source_object,
                                                          GAsyncResult* _res_,
                                                          gpointer _user_data_);
static void publishing_flickr_flickr_publisher_do_show_success_pane (PublishingFlickrFlickrPublisher* self);
VALA_EXTERN gint publishing_flickr_flickr_publisher_get_persistent_visibility (PublishingFlickrFlickrPublisher* self);
VALA_EXTERN void publishing_flickr_flickr_publisher_set_persistent_visibility (PublishingFlickrFlickrPublisher* self,
                                                                   gint vis);
VALA_EXTERN gint publishing_flickr_flickr_publisher_get_persistent_default_size (PublishingFlickrFlickrPublisher* self);
VALA_EXTERN void publishing_flickr_flickr_publisher_set_persistent_default_size (PublishingFlickrFlickrPublisher* self,
                                                                     gint size);
static SpitPublishingService* publishing_flickr_flickr_publisher_real_get_service (SpitPublishingPublisher* base);
static gboolean publishing_flickr_flickr_publisher_real_is_running (SpitPublishingPublisher* base);
static void publishing_flickr_flickr_publisher_real_start (SpitPublishingPublisher* base);
static void publishing_flickr_flickr_publisher_real_stop (SpitPublishingPublisher* base);
static void publishing_flickr_flickr_publisher_finalize (GObject * obj);
static GType publishing_flickr_flickr_publisher_get_type_once (void);
static gchar* _publishing_flickr_transaction_validate_xml_publishing_rest_support_xml_document_check_for_error_response (PublishingRESTSupportXmlDocument* doc,
                                                                                                                  gpointer self);
static GType publishing_flickr_account_info_fetch_transaction_get_type_once (void);
VALA_EXTERN GType publishing_flickr_upload_transaction_get_type (void) G_GNUC_CONST ;
VALA_EXTERN PublishingFlickrUploadTransaction* publishing_flickr_upload_transaction_new (PublishingRESTSupportOAuth1Session* session,
                                                                             PublishingFlickrPublishingParameters* parameters,
                                                                             SpitPublishingPublishable* publishable);
VALA_EXTERN PublishingFlickrUploadTransaction* publishing_flickr_upload_transaction_construct (GType object_type,
                                                                                   PublishingRESTSupportOAuth1Session* session,
                                                                                   PublishingFlickrPublishingParameters* parameters,
                                                                                   SpitPublishingPublishable* publishable);
static void _g_free0_ (gpointer var);
static void publishing_flickr_upload_transaction_real_execute_async_data_free (gpointer _data);
static void publishing_flickr_upload_transaction_real_execute_async (PublishingRESTSupportTransaction* base,
                                                              GAsyncReadyCallback _callback_,
                                                              gpointer _user_data_);
static gboolean publishing_flickr_upload_transaction_real_execute_async_co (PublishingFlickrUploadTransactionExecuteAsyncData* _data_);
static void publishing_flickr_upload_transaction_execute_async_ready (GObject* source_object,
                                                               GAsyncResult* _res_,
                                                               gpointer _user_data_);
static void publishing_flickr_upload_transaction_finalize (PublishingRESTSupportTransaction * obj);
static GType publishing_flickr_upload_transaction_get_type_once (void);
static gpointer publishing_flickr_publishing_options_pane_visibility_entry_ref (gpointer instance);
static void publishing_flickr_publishing_options_pane_visibility_entry_unref (gpointer instance);
static GParamSpec* publishing_flickr_publishing_options_pane_param_spec_visibility_entry (const gchar* name,
                                                                                   const gchar* nick,
                                                                                   const gchar* blurb,
                                                                                   GType object_type,
                                                                                   GParamFlags flags) G_GNUC_UNUSED ;
static void publishing_flickr_publishing_options_pane_value_set_visibility_entry (GValue* value,
                                                                           gpointer v_object) G_GNUC_UNUSED ;
static void publishing_flickr_publishing_options_pane_value_take_visibility_entry (GValue* value,
                                                                            gpointer v_object) G_GNUC_UNUSED ;
static gpointer publishing_flickr_publishing_options_pane_value_get_visibility_entry (const GValue* value) G_GNUC_UNUSED ;
static GType publishing_flickr_publishing_options_pane_visibility_entry_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static gpointer publishing_flickr_publishing_options_pane_size_entry_ref (gpointer instance);
static void publishing_flickr_publishing_options_pane_size_entry_unref (gpointer instance);
static GParamSpec* publishing_flickr_publishing_options_pane_param_spec_size_entry (const gchar* name,
                                                                             const gchar* nick,
                                                                             const gchar* blurb,
                                                                             GType object_type,
                                                                             GParamFlags flags) G_GNUC_UNUSED ;
static void publishing_flickr_publishing_options_pane_value_set_size_entry (GValue* value,
                                                                     gpointer v_object) G_GNUC_UNUSED ;
static void publishing_flickr_publishing_options_pane_value_take_size_entry (GValue* value,
                                                                      gpointer v_object) G_GNUC_UNUSED ;
static gpointer publishing_flickr_publishing_options_pane_value_get_size_entry (const GValue* value) G_GNUC_UNUSED ;
static GType publishing_flickr_publishing_options_pane_size_entry_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static PublishingFlickrPublishingOptionsPaneVisibilityEntry** publishing_flickr_publishing_options_pane_create_visibilities (PublishingFlickrPublishingOptionsPane* self,
                                                                                                                      gint* result_length1);
static PublishingFlickrPublishingOptionsPaneSizeEntry** publishing_flickr_publishing_options_pane_create_sizes (PublishingFlickrPublishingOptionsPane* self,
                                                                                                         gint* result_length1);
static void publishing_flickr_publishing_options_pane_populate_visibility_combo (PublishingFlickrPublishingOptionsPane* self);
static void publishing_flickr_publishing_options_pane_on_visibility_changed (PublishingFlickrPublishingOptionsPane* self);
static void _publishing_flickr_publishing_options_pane_on_visibility_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                                             gpointer self);
static void publishing_flickr_publishing_options_pane_populate_size_combo (PublishingFlickrPublishingOptionsPane* self);
static void publishing_flickr_publishing_options_pane_on_size_changed (PublishingFlickrPublishingOptionsPane* self);
static void _publishing_flickr_publishing_options_pane_on_size_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                                       gpointer self);
static void publishing_flickr_publishing_options_pane_on_logout_clicked (PublishingFlickrPublishingOptionsPane* self);
static void _publishing_flickr_publishing_options_pane_on_logout_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                                      gpointer self);
static void publishing_flickr_publishing_options_pane_on_publish_clicked (PublishingFlickrPublishingOptionsPane* self);
static void _publishing_flickr_publishing_options_pane_on_publish_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                                       gpointer self);
static PublishingFlickrPublishingOptionsPaneVisibilityEntry* publishing_flickr_publishing_options_pane_visibility_entry_new (const gchar* creator_title,
                                                                                                                      PublishingFlickrVisibilitySpecification* creator_specification);
static PublishingFlickrPublishingOptionsPaneVisibilityEntry* publishing_flickr_publishing_options_pane_visibility_entry_construct (GType object_type,
                                                                                                                            const gchar* creator_title,
                                                                                                                            PublishingFlickrVisibilitySpecification* creator_specification);
static void _vala_array_add6 (PublishingFlickrPublishingOptionsPaneVisibilityEntry** * array,
                       gint* length,
                       gint* size,
                       PublishingFlickrPublishingOptionsPaneVisibilityEntry* value);
static void _vala_array_add7 (PublishingFlickrPublishingOptionsPaneVisibilityEntry** * array,
                       gint* length,
                       gint* size,
                       PublishingFlickrPublishingOptionsPaneVisibilityEntry* value);
static void _vala_array_add8 (PublishingFlickrPublishingOptionsPaneVisibilityEntry** * array,
                       gint* length,
                       gint* size,
                       PublishingFlickrPublishingOptionsPaneVisibilityEntry* value);
static void _vala_array_add9 (PublishingFlickrPublishingOptionsPaneVisibilityEntry** * array,
                       gint* length,
                       gint* size,
                       PublishingFlickrPublishingOptionsPaneVisibilityEntry* value);
static void _vala_array_add10 (PublishingFlickrPublishingOptionsPaneVisibilityEntry** * array,
                        gint* length,
                        gint* size,
                        PublishingFlickrPublishingOptionsPaneVisibilityEntry* value);
static PublishingFlickrPublishingOptionsPaneSizeEntry* publishing_flickr_publishing_options_pane_size_entry_new (const gchar* creator_title,
                                                                                                          gint creator_size);
static PublishingFlickrPublishingOptionsPaneSizeEntry* publishing_flickr_publishing_options_pane_size_entry_construct (GType object_type,
                                                                                                                const gchar* creator_title,
                                                                                                                gint creator_size);
static void _vala_array_add11 (PublishingFlickrPublishingOptionsPaneSizeEntry** * array,
                        gint* length,
                        gint* size,
                        PublishingFlickrPublishingOptionsPaneSizeEntry* value);
static void _vala_array_add12 (PublishingFlickrPublishingOptionsPaneSizeEntry** * array,
                        gint* length,
                        gint* size,
                        PublishingFlickrPublishingOptionsPaneSizeEntry* value);
static void _vala_array_add13 (PublishingFlickrPublishingOptionsPaneSizeEntry** * array,
                        gint* length,
                        gint* size,
                        PublishingFlickrPublishingOptionsPaneSizeEntry* value);
static void _vala_array_add14 (PublishingFlickrPublishingOptionsPaneSizeEntry** * array,
                        gint* length,
                        gint* size,
                        PublishingFlickrPublishingOptionsPaneSizeEntry* value);
static void _vala_array_add15 (PublishingFlickrPublishingOptionsPaneSizeEntry** * array,
                        gint* length,
                        gint* size,
                        PublishingFlickrPublishingOptionsPaneSizeEntry* value);
VALA_EXTERN void publishing_flickr_publishing_options_pane_notify_publish (PublishingFlickrPublishingOptionsPane* self);
VALA_EXTERN void publishing_flickr_publishing_options_pane_notify_logout (PublishingFlickrPublishingOptionsPane* self);
static GtkWidget* publishing_flickr_publishing_options_pane_real_get_widget (SpitPublishingDialogPane* base);
static SpitPublishingDialogPaneGeometryOptions publishing_flickr_publishing_options_pane_real_get_preferred_geometry (SpitPublishingDialogPane* base);
static void publishing_flickr_publishing_options_pane_real_on_pane_installed (SpitPublishingDialogPane* base);
static void _publishing_flickr_publishing_options_pane_notify_publish_publishing_flickr_publishing_options_pane_publish (PublishingFlickrPublishingOptionsPane* _sender,
                                                                                                                  gboolean strip_metadata,
                                                                                                                  gpointer self);
static void _publishing_flickr_publishing_options_pane_notify_logout_publishing_flickr_publishing_options_pane_logout (PublishingFlickrPublishingOptionsPane* _sender,
                                                                                                                gpointer self);
static void publishing_flickr_publishing_options_pane_real_on_pane_uninstalled (SpitPublishingDialogPane* base);
static void publishing_flickr_publishing_options_pane_size_entry_finalize (PublishingFlickrPublishingOptionsPaneSizeEntry * obj);
static GType publishing_flickr_publishing_options_pane_size_entry_get_type_once (void);
static void publishing_flickr_publishing_options_pane_visibility_entry_finalize (PublishingFlickrPublishingOptionsPaneVisibilityEntry * obj);
static GType publishing_flickr_publishing_options_pane_visibility_entry_get_type_once (void);
static void publishing_flickr_publishing_options_pane_finalize (GObject * obj);
static GType publishing_flickr_publishing_options_pane_get_type_once (void);
static void publishing_flickr_uploader_preprocess_publishable (PublishingFlickrUploader* self,
                                                        SpitPublishingPublishable* publishable);
static void _vala_array_add16 (gchar** * array,
                        gint* length,
                        gint* size,
                        gchar* value);
static PublishingRESTSupportTransaction* publishing_flickr_uploader_real_create_transaction (PublishingRESTSupportBatchUploader* base,
                                                                                      SpitPublishingPublishable* publishable);
static void publishing_flickr_uploader_finalize (PublishingRESTSupportBatchUploader * obj);
static GType publishing_flickr_uploader_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

FlickrService*
flickr_service_construct (GType object_type)
{
	FlickrService * self = NULL;
#line 9 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self = (FlickrService*) g_object_new (object_type, NULL);
#line 9 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return self;
#line 731 "FlickrPublishing.c"
}

FlickrService*
flickr_service_new (void)
{
#line 9 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return flickr_service_construct (TYPE_FLICKR_SERVICE);
#line 739 "FlickrPublishing.c"
}

static gint
flickr_service_real_get_pluggable_interface (SpitPluggable* base,
                                             gint min_host_interface,
                                             gint max_host_interface)
{
	FlickrService * self;
	gint result;
#line 11 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_FLICKR_SERVICE, FlickrService);
#line 12 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	result = spit_negotiate_interfaces (min_host_interface, max_host_interface, SPIT_PUBLISHING_CURRENT_INTERFACE);
#line 12 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return result;
#line 755 "FlickrPublishing.c"
}

static const gchar*
flickr_service_real_get_id (SpitPluggable* base)
{
	FlickrService * self;
	const gchar* result;
#line 16 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_FLICKR_SERVICE, FlickrService);
#line 17 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	result = "org.gnome.shotwell.publishing.flickr";
#line 17 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return result;
#line 769 "FlickrPublishing.c"
}

static const gchar*
flickr_service_real_get_pluggable_name (SpitPluggable* base)
{
	FlickrService * self;
	const gchar* result;
#line 20 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_FLICKR_SERVICE, FlickrService);
#line 21 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	result = "Flickr";
#line 21 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return result;
#line 783 "FlickrPublishing.c"
}

static SpitPluggableInfo*
flickr_service_real_get_info (SpitPluggable* base)
{
	FlickrService * self;
	SpitPluggableInfo* info = NULL;
	SpitPluggableInfo* _tmp0_;
	SpitPluggableInfo* result;
#line 24 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_FLICKR_SERVICE, FlickrService);
#line 25 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp0_ = spit_pluggable_info_new ();
#line 25 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	info = _tmp0_;
#line 26 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	spit_pluggable_info_set_authors (info, "Lucas Beeler");
#line 27 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	spit_pluggable_info_set_copyright (info, _ ("Copyright 2016 Software Freedom Conservancy Inc."));
#line 29 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	result = info;
#line 29 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return result;
#line 807 "FlickrPublishing.c"
}

static void
flickr_service_real_activation (SpitPluggable* base,
                                gboolean enabled)
{
	FlickrService * self;
#line 32 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_FLICKR_SERVICE, FlickrService);
#line 817 "FlickrPublishing.c"
}

static SpitPublishingPublisher*
flickr_service_real_create_publisher (SpitPublishingService* base,
                                      SpitPublishingPluginHost* host)
{
	FlickrService * self;
	PublishingFlickrFlickrPublisher* _tmp0_;
	SpitPublishingPublisher* result;
#line 35 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_FLICKR_SERVICE, FlickrService);
#line 35 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (host, SPIT_PUBLISHING_TYPE_PLUGIN_HOST), NULL);
#line 36 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp0_ = publishing_flickr_flickr_publisher_new (G_TYPE_CHECK_INSTANCE_CAST (self, SPIT_PUBLISHING_TYPE_SERVICE, SpitPublishingService), host);
#line 36 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, SPIT_PUBLISHING_TYPE_PUBLISHER, SpitPublishingPublisher);
#line 36 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return result;
#line 837 "FlickrPublishing.c"
}

static SpitPublishingPublisherMediaType
flickr_service_real_get_supported_media (SpitPublishingService* base)
{
	FlickrService * self;
	SpitPublishingPublisherMediaType result;
#line 39 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_FLICKR_SERVICE, FlickrService);
#line 40 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	result = SPIT_PUBLISHING_PUBLISHER_MEDIA_TYPE_PHOTO | SPIT_PUBLISHING_PUBLISHER_MEDIA_TYPE_VIDEO;
#line 40 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return result;
#line 851 "FlickrPublishing.c"
}

static void
flickr_service_class_init (FlickrServiceClass * klass,
                           gpointer klass_data)
{
#line 7 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	flickr_service_parent_class = g_type_class_peek_parent (klass);
#line 860 "FlickrPublishing.c"
}

static void
flickr_service_spit_pluggable_interface_init (SpitPluggableIface * iface,
                                              gpointer iface_data)
{
#line 7 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	flickr_service_spit_pluggable_parent_iface = g_type_interface_peek_parent (iface);
#line 7 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	iface->get_pluggable_interface = (gint (*) (SpitPluggable*, gint, gint)) flickr_service_real_get_pluggable_interface;
#line 7 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	iface->get_id = (const gchar* (*) (SpitPluggable*)) flickr_service_real_get_id;
#line 7 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	iface->get_pluggable_name = (const gchar* (*) (SpitPluggable*)) flickr_service_real_get_pluggable_name;
#line 7 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	iface->get_info = (SpitPluggableInfo* (*) (SpitPluggable*)) flickr_service_real_get_info;
#line 7 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	iface->activation = (void (*) (SpitPluggable*, gboolean)) flickr_service_real_activation;
#line 879 "FlickrPublishing.c"
}

static void
flickr_service_spit_publishing_service_interface_init (SpitPublishingServiceIface * iface,
                                                       gpointer iface_data)
{
#line 7 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	flickr_service_spit_publishing_service_parent_iface = g_type_interface_peek_parent (iface);
#line 7 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	iface->create_publisher = (SpitPublishingPublisher* (*) (SpitPublishingService*, SpitPublishingPluginHost*)) flickr_service_real_create_publisher;
#line 7 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	iface->get_supported_media = (SpitPublishingPublisherMediaType (*) (SpitPublishingService*)) flickr_service_real_get_supported_media;
#line 892 "FlickrPublishing.c"
}

static void
flickr_service_instance_init (FlickrService * self,
                              gpointer klass)
{
}

static GType
flickr_service_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FlickrServiceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) flickr_service_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FlickrService), 0, (GInstanceInitFunc) flickr_service_instance_init, NULL };
	static const GInterfaceInfo spit_pluggable_info = { (GInterfaceInitFunc) flickr_service_spit_pluggable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	static const GInterfaceInfo spit_publishing_service_info = { (GInterfaceInitFunc) flickr_service_spit_publishing_service_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType flickr_service_type_id;
	flickr_service_type_id = g_type_register_static (G_TYPE_OBJECT, "FlickrService", &g_define_type_info, 0);
	g_type_add_interface_static (flickr_service_type_id, SPIT_TYPE_PLUGGABLE, &spit_pluggable_info);
	g_type_add_interface_static (flickr_service_type_id, SPIT_PUBLISHING_TYPE_SERVICE, &spit_publishing_service_info);
	return flickr_service_type_id;
}

GType
flickr_service_get_type (void)
{
	static volatile gsize flickr_service_type_id__once = 0;
	if (g_once_init_enter (&flickr_service_type_id__once)) {
		GType flickr_service_type_id;
		flickr_service_type_id = flickr_service_get_type_once ();
		g_once_init_leave (&flickr_service_type_id__once, flickr_service_type_id);
	}
	return flickr_service_type_id__once;
}

static GType
publishing_flickr_user_kind_get_type_once (void)
{
	static const GEnumValue values[] = {{PUBLISHING_FLICKR_USER_KIND_PRO, "PUBLISHING_FLICKR_USER_KIND_PRO", "pro"}, {PUBLISHING_FLICKR_USER_KIND_FREE, "PUBLISHING_FLICKR_USER_KIND_FREE", "free"}, {0, NULL, NULL}};
	GType publishing_flickr_user_kind_type_id;
	publishing_flickr_user_kind_type_id = g_enum_register_static ("PublishingFlickrUserKind", values);
	return publishing_flickr_user_kind_type_id;
}

GType
publishing_flickr_user_kind_get_type (void)
{
	static volatile gsize publishing_flickr_user_kind_type_id__once = 0;
	if (g_once_init_enter (&publishing_flickr_user_kind_type_id__once)) {
		GType publishing_flickr_user_kind_type_id;
		publishing_flickr_user_kind_type_id = publishing_flickr_user_kind_get_type_once ();
		g_once_init_leave (&publishing_flickr_user_kind_type_id__once, publishing_flickr_user_kind_type_id);
	}
	return publishing_flickr_user_kind_type_id__once;
}

PublishingFlickrVisibilitySpecification*
publishing_flickr_visibility_specification_construct (GType object_type,
                                                      gint friends_level,
                                                      gint family_level,
                                                      gint everyone_level)
{
	PublishingFlickrVisibilitySpecification* self = NULL;
#line 62 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self = (PublishingFlickrVisibilitySpecification*) g_type_create_instance (object_type);
#line 63 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->friends_level = friends_level;
#line 64 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->family_level = family_level;
#line 65 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->everyone_level = everyone_level;
#line 62 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return self;
#line 964 "FlickrPublishing.c"
}

PublishingFlickrVisibilitySpecification*
publishing_flickr_visibility_specification_new (gint friends_level,
                                                gint family_level,
                                                gint everyone_level)
{
#line 62 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return publishing_flickr_visibility_specification_construct (PUBLISHING_FLICKR_TYPE_VISIBILITY_SPECIFICATION, friends_level, family_level, everyone_level);
#line 974 "FlickrPublishing.c"
}

static void
publishing_flickr_value_visibility_specification_init (GValue* value)
{
#line 57 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	value->data[0].v_pointer = NULL;
#line 982 "FlickrPublishing.c"
}

static void
publishing_flickr_value_visibility_specification_free_value (GValue* value)
{
#line 57 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (value->data[0].v_pointer) {
#line 57 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		publishing_flickr_visibility_specification_unref (value->data[0].v_pointer);
#line 992 "FlickrPublishing.c"
	}
}

static void
publishing_flickr_value_visibility_specification_copy_value (const GValue* src_value,
                                                             GValue* dest_value)
{
#line 57 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (src_value->data[0].v_pointer) {
#line 57 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		dest_value->data[0].v_pointer = publishing_flickr_visibility_specification_ref (src_value->data[0].v_pointer);
#line 1004 "FlickrPublishing.c"
	} else {
#line 57 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1008 "FlickrPublishing.c"
	}
}

static gpointer
publishing_flickr_value_visibility_specification_peek_pointer (const GValue* value)
{
#line 57 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return value->data[0].v_pointer;
#line 1017 "FlickrPublishing.c"
}

static gchar*
publishing_flickr_value_visibility_specification_collect_value (GValue* value,
                                                                guint n_collect_values,
                                                                GTypeCValue* collect_values,
                                                                guint collect_flags)
{
#line 57 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (collect_values[0].v_pointer) {
#line 1028 "FlickrPublishing.c"
		PublishingFlickrVisibilitySpecification * object;
		object = collect_values[0].v_pointer;
#line 57 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		if (object->parent_instance.g_class == NULL) {
#line 57 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1035 "FlickrPublishing.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 57 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1039 "FlickrPublishing.c"
		}
#line 57 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		value->data[0].v_pointer = publishing_flickr_visibility_specification_ref (object);
#line 1043 "FlickrPublishing.c"
	} else {
#line 57 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		value->data[0].v_pointer = NULL;
#line 1047 "FlickrPublishing.c"
	}
#line 57 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return NULL;
#line 1051 "FlickrPublishing.c"
}

static gchar*
publishing_flickr_value_visibility_specification_lcopy_value (const GValue* value,
                                                              guint n_collect_values,
                                                              GTypeCValue* collect_values,
                                                              guint collect_flags)
{
	PublishingFlickrVisibilitySpecification ** object_p;
	object_p = collect_values[0].v_pointer;
#line 57 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (!object_p) {
#line 57 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1066 "FlickrPublishing.c"
	}
#line 57 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (!value->data[0].v_pointer) {
#line 57 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		*object_p = NULL;
#line 1072 "FlickrPublishing.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 57 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		*object_p = value->data[0].v_pointer;
#line 1076 "FlickrPublishing.c"
	} else {
#line 57 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		*object_p = publishing_flickr_visibility_specification_ref (value->data[0].v_pointer);
#line 1080 "FlickrPublishing.c"
	}
#line 57 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return NULL;
#line 1084 "FlickrPublishing.c"
}

GParamSpec*
publishing_flickr_param_spec_visibility_specification (const gchar* name,
                                                       const gchar* nick,
                                                       const gchar* blurb,
                                                       GType object_type,
                                                       GParamFlags flags)
{
	PublishingFlickrParamSpecVisibilitySpecification* spec;
#line 57 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PUBLISHING_FLICKR_TYPE_VISIBILITY_SPECIFICATION), NULL);
#line 57 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 57 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 57 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return G_PARAM_SPEC (spec);
#line 1103 "FlickrPublishing.c"
}

gpointer
publishing_flickr_value_get_visibility_specification (const GValue* value)
{
#line 57 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PUBLISHING_FLICKR_TYPE_VISIBILITY_SPECIFICATION), NULL);
#line 57 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return value->data[0].v_pointer;
#line 1113 "FlickrPublishing.c"
}

void
publishing_flickr_value_set_visibility_specification (GValue* value,
                                                      gpointer v_object)
{
	PublishingFlickrVisibilitySpecification * old;
#line 57 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PUBLISHING_FLICKR_TYPE_VISIBILITY_SPECIFICATION));
#line 57 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	old = value->data[0].v_pointer;
#line 57 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (v_object) {
#line 57 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PUBLISHING_FLICKR_TYPE_VISIBILITY_SPECIFICATION));
#line 57 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 57 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		value->data[0].v_pointer = v_object;
#line 57 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		publishing_flickr_visibility_specification_ref (value->data[0].v_pointer);
#line 1135 "FlickrPublishing.c"
	} else {
#line 57 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		value->data[0].v_pointer = NULL;
#line 1139 "FlickrPublishing.c"
	}
#line 57 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (old) {
#line 57 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		publishing_flickr_visibility_specification_unref (old);
#line 1145 "FlickrPublishing.c"
	}
}

void
publishing_flickr_value_take_visibility_specification (GValue* value,
                                                       gpointer v_object)
{
	PublishingFlickrVisibilitySpecification * old;
#line 57 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PUBLISHING_FLICKR_TYPE_VISIBILITY_SPECIFICATION));
#line 57 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	old = value->data[0].v_pointer;
#line 57 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (v_object) {
#line 57 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PUBLISHING_FLICKR_TYPE_VISIBILITY_SPECIFICATION));
#line 57 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 57 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		value->data[0].v_pointer = v_object;
#line 1166 "FlickrPublishing.c"
	} else {
#line 57 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		value->data[0].v_pointer = NULL;
#line 1170 "FlickrPublishing.c"
	}
#line 57 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (old) {
#line 57 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		publishing_flickr_visibility_specification_unref (old);
#line 1176 "FlickrPublishing.c"
	}
}

static void
publishing_flickr_visibility_specification_class_init (PublishingFlickrVisibilitySpecificationClass * klass,
                                                       gpointer klass_data)
{
#line 57 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	publishing_flickr_visibility_specification_parent_class = g_type_class_peek_parent (klass);
#line 57 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	((PublishingFlickrVisibilitySpecificationClass *) klass)->finalize = publishing_flickr_visibility_specification_finalize;
#line 1188 "FlickrPublishing.c"
}

static void
publishing_flickr_visibility_specification_instance_init (PublishingFlickrVisibilitySpecification * self,
                                                          gpointer klass)
{
#line 57 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->ref_count = 1;
#line 1197 "FlickrPublishing.c"
}

static void
publishing_flickr_visibility_specification_finalize (PublishingFlickrVisibilitySpecification * obj)
{
	PublishingFlickrVisibilitySpecification * self;
#line 57 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PUBLISHING_FLICKR_TYPE_VISIBILITY_SPECIFICATION, PublishingFlickrVisibilitySpecification);
#line 57 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_signal_handlers_destroy (self);
#line 1208 "FlickrPublishing.c"
}

static GType
publishing_flickr_visibility_specification_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { publishing_flickr_value_visibility_specification_init, publishing_flickr_value_visibility_specification_free_value, publishing_flickr_value_visibility_specification_copy_value, publishing_flickr_value_visibility_specification_peek_pointer, "p", publishing_flickr_value_visibility_specification_collect_value, "p", publishing_flickr_value_visibility_specification_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (PublishingFlickrVisibilitySpecificationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) publishing_flickr_visibility_specification_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PublishingFlickrVisibilitySpecification), 0, (GInstanceInitFunc) publishing_flickr_visibility_specification_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType publishing_flickr_visibility_specification_type_id;
	publishing_flickr_visibility_specification_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PublishingFlickrVisibilitySpecification", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return publishing_flickr_visibility_specification_type_id;
}

GType
publishing_flickr_visibility_specification_get_type (void)
{
	static volatile gsize publishing_flickr_visibility_specification_type_id__once = 0;
	if (g_once_init_enter (&publishing_flickr_visibility_specification_type_id__once)) {
		GType publishing_flickr_visibility_specification_type_id;
		publishing_flickr_visibility_specification_type_id = publishing_flickr_visibility_specification_get_type_once ();
		g_once_init_leave (&publishing_flickr_visibility_specification_type_id__once, publishing_flickr_visibility_specification_type_id);
	}
	return publishing_flickr_visibility_specification_type_id__once;
}

gpointer
publishing_flickr_visibility_specification_ref (gpointer instance)
{
	PublishingFlickrVisibilitySpecification * self;
	self = instance;
#line 57 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_atomic_int_inc (&self->ref_count);
#line 57 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return instance;
#line 1243 "FlickrPublishing.c"
}

void
publishing_flickr_visibility_specification_unref (gpointer instance)
{
	PublishingFlickrVisibilitySpecification * self;
	self = instance;
#line 57 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 57 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		PUBLISHING_FLICKR_VISIBILITY_SPECIFICATION_GET_CLASS (self)->finalize (self);
#line 57 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1257 "FlickrPublishing.c"
	}
}

PublishingFlickrPublishingParameters*
publishing_flickr_publishing_parameters_construct (GType object_type)
{
	PublishingFlickrPublishingParameters* self = NULL;
#line 79 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self = (PublishingFlickrPublishingParameters*) g_type_create_instance (object_type);
#line 79 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return self;
#line 1269 "FlickrPublishing.c"
}

PublishingFlickrPublishingParameters*
publishing_flickr_publishing_parameters_new (void)
{
#line 79 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return publishing_flickr_publishing_parameters_construct (PUBLISHING_FLICKR_TYPE_PUBLISHING_PARAMETERS);
#line 1277 "FlickrPublishing.c"
}

static void
publishing_flickr_value_publishing_parameters_init (GValue* value)
{
#line 70 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	value->data[0].v_pointer = NULL;
#line 1285 "FlickrPublishing.c"
}

static void
publishing_flickr_value_publishing_parameters_free_value (GValue* value)
{
#line 70 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (value->data[0].v_pointer) {
#line 70 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		publishing_flickr_publishing_parameters_unref (value->data[0].v_pointer);
#line 1295 "FlickrPublishing.c"
	}
}

static void
publishing_flickr_value_publishing_parameters_copy_value (const GValue* src_value,
                                                          GValue* dest_value)
{
#line 70 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (src_value->data[0].v_pointer) {
#line 70 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		dest_value->data[0].v_pointer = publishing_flickr_publishing_parameters_ref (src_value->data[0].v_pointer);
#line 1307 "FlickrPublishing.c"
	} else {
#line 70 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1311 "FlickrPublishing.c"
	}
}

static gpointer
publishing_flickr_value_publishing_parameters_peek_pointer (const GValue* value)
{
#line 70 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return value->data[0].v_pointer;
#line 1320 "FlickrPublishing.c"
}

static gchar*
publishing_flickr_value_publishing_parameters_collect_value (GValue* value,
                                                             guint n_collect_values,
                                                             GTypeCValue* collect_values,
                                                             guint collect_flags)
{
#line 70 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (collect_values[0].v_pointer) {
#line 1331 "FlickrPublishing.c"
		PublishingFlickrPublishingParameters * object;
		object = collect_values[0].v_pointer;
#line 70 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		if (object->parent_instance.g_class == NULL) {
#line 70 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1338 "FlickrPublishing.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 70 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1342 "FlickrPublishing.c"
		}
#line 70 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		value->data[0].v_pointer = publishing_flickr_publishing_parameters_ref (object);
#line 1346 "FlickrPublishing.c"
	} else {
#line 70 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		value->data[0].v_pointer = NULL;
#line 1350 "FlickrPublishing.c"
	}
#line 70 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return NULL;
#line 1354 "FlickrPublishing.c"
}

static gchar*
publishing_flickr_value_publishing_parameters_lcopy_value (const GValue* value,
                                                           guint n_collect_values,
                                                           GTypeCValue* collect_values,
                                                           guint collect_flags)
{
	PublishingFlickrPublishingParameters ** object_p;
	object_p = collect_values[0].v_pointer;
#line 70 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (!object_p) {
#line 70 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1369 "FlickrPublishing.c"
	}
#line 70 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (!value->data[0].v_pointer) {
#line 70 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		*object_p = NULL;
#line 1375 "FlickrPublishing.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 70 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		*object_p = value->data[0].v_pointer;
#line 1379 "FlickrPublishing.c"
	} else {
#line 70 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		*object_p = publishing_flickr_publishing_parameters_ref (value->data[0].v_pointer);
#line 1383 "FlickrPublishing.c"
	}
#line 70 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return NULL;
#line 1387 "FlickrPublishing.c"
}

GParamSpec*
publishing_flickr_param_spec_publishing_parameters (const gchar* name,
                                                    const gchar* nick,
                                                    const gchar* blurb,
                                                    GType object_type,
                                                    GParamFlags flags)
{
	PublishingFlickrParamSpecPublishingParameters* spec;
#line 70 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PUBLISHING_FLICKR_TYPE_PUBLISHING_PARAMETERS), NULL);
#line 70 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 70 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 70 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return G_PARAM_SPEC (spec);
#line 1406 "FlickrPublishing.c"
}

gpointer
publishing_flickr_value_get_publishing_parameters (const GValue* value)
{
#line 70 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PUBLISHING_FLICKR_TYPE_PUBLISHING_PARAMETERS), NULL);
#line 70 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return value->data[0].v_pointer;
#line 1416 "FlickrPublishing.c"
}

void
publishing_flickr_value_set_publishing_parameters (GValue* value,
                                                   gpointer v_object)
{
	PublishingFlickrPublishingParameters * old;
#line 70 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PUBLISHING_FLICKR_TYPE_PUBLISHING_PARAMETERS));
#line 70 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	old = value->data[0].v_pointer;
#line 70 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (v_object) {
#line 70 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PUBLISHING_FLICKR_TYPE_PUBLISHING_PARAMETERS));
#line 70 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 70 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		value->data[0].v_pointer = v_object;
#line 70 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		publishing_flickr_publishing_parameters_ref (value->data[0].v_pointer);
#line 1438 "FlickrPublishing.c"
	} else {
#line 70 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		value->data[0].v_pointer = NULL;
#line 1442 "FlickrPublishing.c"
	}
#line 70 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (old) {
#line 70 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		publishing_flickr_publishing_parameters_unref (old);
#line 1448 "FlickrPublishing.c"
	}
}

void
publishing_flickr_value_take_publishing_parameters (GValue* value,
                                                    gpointer v_object)
{
	PublishingFlickrPublishingParameters * old;
#line 70 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PUBLISHING_FLICKR_TYPE_PUBLISHING_PARAMETERS));
#line 70 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	old = value->data[0].v_pointer;
#line 70 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (v_object) {
#line 70 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PUBLISHING_FLICKR_TYPE_PUBLISHING_PARAMETERS));
#line 70 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 70 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		value->data[0].v_pointer = v_object;
#line 1469 "FlickrPublishing.c"
	} else {
#line 70 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		value->data[0].v_pointer = NULL;
#line 1473 "FlickrPublishing.c"
	}
#line 70 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (old) {
#line 70 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		publishing_flickr_publishing_parameters_unref (old);
#line 1479 "FlickrPublishing.c"
	}
}

static void
publishing_flickr_publishing_parameters_class_init (PublishingFlickrPublishingParametersClass * klass,
                                                    gpointer klass_data)
{
#line 70 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	publishing_flickr_publishing_parameters_parent_class = g_type_class_peek_parent (klass);
#line 70 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	((PublishingFlickrPublishingParametersClass *) klass)->finalize = publishing_flickr_publishing_parameters_finalize;
#line 1491 "FlickrPublishing.c"
}

static void
publishing_flickr_publishing_parameters_instance_init (PublishingFlickrPublishingParameters * self,
                                                       gpointer klass)
{
#line 70 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->ref_count = 1;
#line 1500 "FlickrPublishing.c"
}

static void
publishing_flickr_publishing_parameters_finalize (PublishingFlickrPublishingParameters * obj)
{
	PublishingFlickrPublishingParameters * self;
#line 70 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PUBLISHING_FLICKR_TYPE_PUBLISHING_PARAMETERS, PublishingFlickrPublishingParameters);
#line 70 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_signal_handlers_destroy (self);
#line 75 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_free0 (self->username);
#line 76 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_publishing_flickr_visibility_specification_unref0 (self->visibility_specification);
#line 1515 "FlickrPublishing.c"
}

static GType
publishing_flickr_publishing_parameters_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { publishing_flickr_value_publishing_parameters_init, publishing_flickr_value_publishing_parameters_free_value, publishing_flickr_value_publishing_parameters_copy_value, publishing_flickr_value_publishing_parameters_peek_pointer, "p", publishing_flickr_value_publishing_parameters_collect_value, "p", publishing_flickr_value_publishing_parameters_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (PublishingFlickrPublishingParametersClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) publishing_flickr_publishing_parameters_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PublishingFlickrPublishingParameters), 0, (GInstanceInitFunc) publishing_flickr_publishing_parameters_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType publishing_flickr_publishing_parameters_type_id;
	publishing_flickr_publishing_parameters_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PublishingFlickrPublishingParameters", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return publishing_flickr_publishing_parameters_type_id;
}

GType
publishing_flickr_publishing_parameters_get_type (void)
{
	static volatile gsize publishing_flickr_publishing_parameters_type_id__once = 0;
	if (g_once_init_enter (&publishing_flickr_publishing_parameters_type_id__once)) {
		GType publishing_flickr_publishing_parameters_type_id;
		publishing_flickr_publishing_parameters_type_id = publishing_flickr_publishing_parameters_get_type_once ();
		g_once_init_leave (&publishing_flickr_publishing_parameters_type_id__once, publishing_flickr_publishing_parameters_type_id);
	}
	return publishing_flickr_publishing_parameters_type_id__once;
}

gpointer
publishing_flickr_publishing_parameters_ref (gpointer instance)
{
	PublishingFlickrPublishingParameters * self;
	self = instance;
#line 70 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_atomic_int_inc (&self->ref_count);
#line 70 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return instance;
#line 1550 "FlickrPublishing.c"
}

void
publishing_flickr_publishing_parameters_unref (gpointer instance)
{
	PublishingFlickrPublishingParameters * self;
	self = instance;
#line 70 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 70 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		PUBLISHING_FLICKR_PUBLISHING_PARAMETERS_GET_CLASS (self)->finalize (self);
#line 70 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1564 "FlickrPublishing.c"
	}
}

static inline gpointer
publishing_flickr_flickr_publisher_get_instance_private (PublishingFlickrFlickrPublisher* self)
{
	return G_STRUCT_MEMBER_P (self, PublishingFlickrFlickrPublisher_private_offset);
}

static void
_publishing_flickr_flickr_publisher_on_session_authenticated_spit_publishing_authenticator_authenticated (SpitPublishingAuthenticator* _sender,
                                                                                                          gpointer self)
{
#line 108 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	publishing_flickr_flickr_publisher_on_session_authenticated ((PublishingFlickrFlickrPublisher*) self);
#line 1580 "FlickrPublishing.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 98 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return self ? g_object_ref (self) : NULL;
#line 1588 "FlickrPublishing.c"
}

PublishingFlickrFlickrPublisher*
publishing_flickr_flickr_publisher_construct (GType object_type,
                                              SpitPublishingService* service,
                                              SpitPublishingPluginHost* host)
{
	PublishingFlickrFlickrPublisher * self = NULL;
	SpitPublishingService* _tmp0_;
	SpitPublishingPluginHost* _tmp1_;
	PublishingRESTSupportOAuth1Session* _tmp2_;
	PublishingFlickrPublishingParameters* _tmp3_;
	PublishingAuthenticatorFactory* _tmp4_;
	PublishingAuthenticatorFactory* _tmp5_;
	SpitPublishingAuthenticator* _tmp6_;
	SpitPublishingAuthenticator* _tmp7_;
#line 95 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (service, SPIT_PUBLISHING_TYPE_SERVICE), NULL);
#line 95 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (host, SPIT_PUBLISHING_TYPE_PLUGIN_HOST), NULL);
#line 95 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self = (PublishingFlickrFlickrPublisher*) g_object_new (object_type, NULL);
#line 97 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_debug ("FlickrPublishing.vala:97: FlickrPublisher instantiated.");
#line 98 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp0_ = _g_object_ref0 (service);
#line 98 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_object_unref0 (self->priv->service);
#line 98 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->service = _tmp0_;
#line 99 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp1_ = _g_object_ref0 (host);
#line 99 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_object_unref0 (self->priv->host);
#line 99 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->host = _tmp1_;
#line 100 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp2_ = publishing_rest_support_oauth1_session_new (PUBLISHING_FLICKR_ENDPOINT_URL);
#line 100 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_publishing_rest_support_session_unref0 (self->priv->session);
#line 100 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->session = _tmp2_;
#line 101 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp3_ = publishing_flickr_publishing_parameters_new ();
#line 101 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_publishing_flickr_publishing_parameters_unref0 (self->priv->parameters);
#line 101 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->parameters = _tmp3_;
#line 102 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp4_ = publishing_authenticator_factory_get_instance ();
#line 102 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp5_ = _tmp4_;
#line 102 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp6_ = spit_publishing_authenticator_factory_create (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, SPIT_PUBLISHING_TYPE_AUTHENTICATOR_FACTORY, SpitPublishingAuthenticatorFactory), "flickr", host);
#line 102 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_object_unref0 (self->priv->authenticator);
#line 102 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->authenticator = _tmp6_;
#line 102 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_object_unref0 (_tmp5_);
#line 104 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp7_ = self->priv->authenticator;
#line 104 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_signal_connect_object (_tmp7_, "authenticated", (GCallback) _publishing_flickr_flickr_publisher_on_session_authenticated_spit_publishing_authenticator_authenticated, self, 0);
#line 95 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return self;
#line 1655 "FlickrPublishing.c"
}

PublishingFlickrFlickrPublisher*
publishing_flickr_flickr_publisher_new (SpitPublishingService* service,
                                        SpitPublishingPluginHost* host)
{
#line 95 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return publishing_flickr_flickr_publisher_construct (PUBLISHING_FLICKR_TYPE_FLICKR_PUBLISHER, service, host);
#line 1664 "FlickrPublishing.c"
}

SpitPublishingAuthenticator*
publishing_flickr_flickr_publisher_get_authenticator (PublishingFlickrFlickrPublisher* self)
{
	SpitPublishingAuthenticator* _tmp0_;
	SpitPublishingAuthenticator* _tmp1_;
	SpitPublishingAuthenticator* result;
#line 111 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_val_if_fail (PUBLISHING_FLICKR_IS_FLICKR_PUBLISHER (self), NULL);
#line 112 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp0_ = self->priv->authenticator;
#line 112 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 112 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	result = _tmp1_;
#line 112 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return result;
#line 1683 "FlickrPublishing.c"
}

static gboolean
publishing_flickr_flickr_publisher_get_persistent_strip_metadata (PublishingFlickrFlickrPublisher* self)
{
	SpitPublishingPluginHost* _tmp0_;
	gboolean result;
#line 115 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_val_if_fail (PUBLISHING_FLICKR_IS_FLICKR_PUBLISHER (self), FALSE);
#line 116 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp0_ = self->priv->host;
#line 116 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	result = spit_host_interface_get_config_bool (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, SPIT_TYPE_HOST_INTERFACE, SpitHostInterface), "strip_metadata", FALSE);
#line 116 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return result;
#line 1699 "FlickrPublishing.c"
}

static void
publishing_flickr_flickr_publisher_set_persistent_strip_metadata (PublishingFlickrFlickrPublisher* self,
                                                                  gboolean strip_metadata)
{
	SpitPublishingPluginHost* _tmp0_;
#line 119 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_if_fail (PUBLISHING_FLICKR_IS_FLICKR_PUBLISHER (self));
#line 120 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp0_ = self->priv->host;
#line 120 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	spit_host_interface_set_config_bool (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, SPIT_TYPE_HOST_INTERFACE, SpitHostInterface), "strip_metadata", strip_metadata);
#line 1713 "FlickrPublishing.c"
}

static gpointer
_g_variant_ref0 (gpointer self)
{
#line 136 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return self ? g_variant_ref (self) : NULL;
#line 1721 "FlickrPublishing.c"
}

static void
publishing_flickr_flickr_publisher_on_session_authenticated (PublishingFlickrFlickrPublisher* self)
{
	GHashTable* params = NULL;
	SpitPublishingAuthenticator* _tmp0_;
	GHashTable* _tmp1_;
	GVariant* consumer_key = NULL;
	GVariant* consumer_secret = NULL;
	GVariant* auth_token = NULL;
	GVariant* auth_token_secret = NULL;
	GVariant* username = NULL;
	GHashTable* _tmp2_;
	gconstpointer _tmp3_ = NULL;
	GVariant* _tmp4_;
	GHashTable* _tmp5_;
	gconstpointer _tmp6_ = NULL;
	GVariant* _tmp7_;
	PublishingRESTSupportOAuth1Session* _tmp8_;
	GVariant* _tmp9_;
	const gchar* _tmp10_;
	GVariant* _tmp11_;
	const gchar* _tmp12_;
	GHashTable* _tmp13_;
	gconstpointer _tmp14_ = NULL;
	GVariant* _tmp15_;
	GHashTable* _tmp16_;
	gconstpointer _tmp17_ = NULL;
	GVariant* _tmp18_;
	GHashTable* _tmp19_;
	gconstpointer _tmp20_ = NULL;
	GVariant* _tmp21_;
	PublishingRESTSupportOAuth1Session* _tmp22_;
	GVariant* _tmp23_;
	const gchar* _tmp24_;
	GVariant* _tmp25_;
	const gchar* _tmp26_;
	GVariant* _tmp27_;
	const gchar* _tmp28_;
	PublishingFlickrPublishingParameters* _tmp29_;
	PublishingRESTSupportOAuth1Session* _tmp30_;
	gchar* _tmp31_;
#line 123 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_if_fail (PUBLISHING_FLICKR_IS_FLICKR_PUBLISHER (self));
#line 124 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (!spit_publishing_publisher_is_running (G_TYPE_CHECK_INSTANCE_CAST (self, SPIT_PUBLISHING_TYPE_PUBLISHER, SpitPublishingPublisher))) {
#line 125 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		return;
#line 1771 "FlickrPublishing.c"
	}
#line 127 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_debug ("FlickrPublishing.vala:127: EVENT: a fully authenticated session has be" \
"come available");
#line 129 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp0_ = self->priv->authenticator;
#line 129 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp1_ = spit_publishing_authenticator_get_authentication_parameter (_tmp0_);
#line 129 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	params = _tmp1_;
#line 130 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	consumer_key = NULL;
#line 131 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	consumer_secret = NULL;
#line 132 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	auth_token = NULL;
#line 133 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	auth_token_secret = NULL;
#line 134 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	username = NULL;
#line 136 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp2_ = params;
#line 136 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_hash_table_lookup_extended (_tmp2_, "ConsumerKey", NULL, &_tmp3_);
#line 136 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_variant_unref0 (consumer_key);
#line 136 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp4_ = _g_variant_ref0 ((GVariant*) _tmp3_);
#line 136 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	consumer_key = _tmp4_;
#line 137 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp5_ = params;
#line 137 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_hash_table_lookup_extended (_tmp5_, "ConsumerSecret", NULL, &_tmp6_);
#line 137 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_variant_unref0 (consumer_secret);
#line 137 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp7_ = _g_variant_ref0 ((GVariant*) _tmp6_);
#line 137 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	consumer_secret = _tmp7_;
#line 138 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp8_ = self->priv->session;
#line 138 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp9_ = consumer_key;
#line 138 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp10_ = g_variant_get_string (_tmp9_, NULL);
#line 138 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp11_ = consumer_secret;
#line 138 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp12_ = g_variant_get_string (_tmp11_, NULL);
#line 138 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	publishing_rest_support_oauth1_session_set_api_credentials (_tmp8_, _tmp10_, _tmp12_);
#line 140 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp13_ = params;
#line 140 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_hash_table_lookup_extended (_tmp13_, "AuthToken", NULL, &_tmp14_);
#line 140 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_variant_unref0 (auth_token);
#line 140 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp15_ = _g_variant_ref0 ((GVariant*) _tmp14_);
#line 140 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	auth_token = _tmp15_;
#line 141 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp16_ = params;
#line 141 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_hash_table_lookup_extended (_tmp16_, "AuthTokenSecret", NULL, &_tmp17_);
#line 141 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_variant_unref0 (auth_token_secret);
#line 141 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp18_ = _g_variant_ref0 ((GVariant*) _tmp17_);
#line 141 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	auth_token_secret = _tmp18_;
#line 142 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp19_ = params;
#line 142 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_hash_table_lookup_extended (_tmp19_, "Username", NULL, &_tmp20_);
#line 142 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_variant_unref0 (username);
#line 142 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp21_ = _g_variant_ref0 ((GVariant*) _tmp20_);
#line 142 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	username = _tmp21_;
#line 143 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp22_ = self->priv->session;
#line 143 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp23_ = auth_token;
#line 143 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp24_ = g_variant_get_string (_tmp23_, NULL);
#line 143 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp25_ = auth_token_secret;
#line 143 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp26_ = g_variant_get_string (_tmp25_, NULL);
#line 143 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp27_ = username;
#line 143 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp28_ = g_variant_get_string (_tmp27_, NULL);
#line 143 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	publishing_rest_support_oauth1_session_set_access_phase_credentials (_tmp22_, _tmp24_, _tmp26_, _tmp28_);
#line 146 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp29_ = self->priv->parameters;
#line 146 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp30_ = self->priv->session;
#line 146 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp31_ = publishing_rest_support_oauth1_session_get_username (_tmp30_);
#line 146 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_free0 (_tmp29_->username);
#line 146 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp29_->username = _tmp31_;
#line 148 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	publishing_flickr_flickr_publisher_do_fetch_account_info (self, NULL, NULL);
#line 123 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_variant_unref0 (username);
#line 123 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_variant_unref0 (auth_token_secret);
#line 123 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_variant_unref0 (auth_token);
#line 123 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_variant_unref0 (consumer_secret);
#line 123 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_variant_unref0 (consumer_key);
#line 123 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_hash_table_unref0 (params);
#line 1893 "FlickrPublishing.c"
}

static void
publishing_flickr_flickr_publisher_on_account_info_available (PublishingFlickrFlickrPublisher* self)
{
#line 151 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_if_fail (PUBLISHING_FLICKR_IS_FLICKR_PUBLISHER (self));
#line 152 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (!spit_publishing_publisher_is_running (G_TYPE_CHECK_INSTANCE_CAST (self, SPIT_PUBLISHING_TYPE_PUBLISHER, SpitPublishingPublisher))) {
#line 153 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		return;
#line 1905 "FlickrPublishing.c"
	}
#line 155 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_debug ("FlickrPublishing.vala:155: EVENT: account information has become avail" \
"able");
#line 156 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	publishing_flickr_flickr_publisher_do_show_publishing_options_pane (self);
#line 1911 "FlickrPublishing.c"
}

static void
_publishing_flickr_flickr_publisher_on_publishing_options_pane_publish_publishing_flickr_publishing_options_pane_publish (PublishingFlickrPublishingOptionsPane* _sender,
                                                                                                                          gboolean strip_metadata,
                                                                                                                          gpointer self)
{
#line 160 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	publishing_flickr_flickr_publisher_on_publishing_options_pane_publish ((PublishingFlickrFlickrPublisher*) self, strip_metadata);
#line 1921 "FlickrPublishing.c"
}

static void
_publishing_flickr_flickr_publisher_on_publishing_options_pane_logout_publishing_flickr_publishing_options_pane_logout (PublishingFlickrPublishingOptionsPane* _sender,
                                                                                                                        gpointer self)
{
#line 161 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	publishing_flickr_flickr_publisher_on_publishing_options_pane_logout ((PublishingFlickrFlickrPublisher*) self);
#line 1930 "FlickrPublishing.c"
}

static void
publishing_flickr_flickr_publisher_on_publishing_options_pane_publish (PublishingFlickrFlickrPublisher* self,
                                                                       gboolean strip_metadata)
{
	PublishingFlickrPublishingOptionsPane* _tmp0_;
	guint _tmp1_;
	PublishingFlickrPublishingOptionsPane* _tmp2_;
	guint _tmp3_;
#line 159 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_if_fail (PUBLISHING_FLICKR_IS_FLICKR_PUBLISHER (self));
#line 160 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp0_ = self->priv->publishing_options_pane;
#line 160 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_signal_parse_name ("publish", PUBLISHING_FLICKR_TYPE_PUBLISHING_OPTIONS_PANE, &_tmp1_, NULL, FALSE);
#line 160 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _publishing_flickr_flickr_publisher_on_publishing_options_pane_publish_publishing_flickr_publishing_options_pane_publish, self);
#line 161 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp2_ = self->priv->publishing_options_pane;
#line 161 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_signal_parse_name ("logout", PUBLISHING_FLICKR_TYPE_PUBLISHING_OPTIONS_PANE, &_tmp3_, NULL, FALSE);
#line 161 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _publishing_flickr_flickr_publisher_on_publishing_options_pane_logout_publishing_flickr_publishing_options_pane_logout, self);
#line 163 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (!spit_publishing_publisher_is_running (G_TYPE_CHECK_INSTANCE_CAST (self, SPIT_PUBLISHING_TYPE_PUBLISHER, SpitPublishingPublisher))) {
#line 164 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		return;
#line 1959 "FlickrPublishing.c"
	}
#line 166 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_debug ("FlickrPublishing.vala:166: EVENT: user clicked the 'Publish' button in" \
" the publishing options pane");
#line 167 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	publishing_flickr_flickr_publisher_do_publish (self, strip_metadata, NULL, NULL);
#line 1965 "FlickrPublishing.c"
}

static void
publishing_flickr_flickr_publisher_on_publishing_options_pane_logout (PublishingFlickrFlickrPublisher* self)
{
	PublishingFlickrPublishingOptionsPane* _tmp0_;
	guint _tmp1_;
	PublishingFlickrPublishingOptionsPane* _tmp2_;
	guint _tmp3_;
#line 170 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_if_fail (PUBLISHING_FLICKR_IS_FLICKR_PUBLISHER (self));
#line 171 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp0_ = self->priv->publishing_options_pane;
#line 171 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_signal_parse_name ("publish", PUBLISHING_FLICKR_TYPE_PUBLISHING_OPTIONS_PANE, &_tmp1_, NULL, FALSE);
#line 171 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _publishing_flickr_flickr_publisher_on_publishing_options_pane_publish_publishing_flickr_publishing_options_pane_publish, self);
#line 172 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp2_ = self->priv->publishing_options_pane;
#line 172 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_signal_parse_name ("logout", PUBLISHING_FLICKR_TYPE_PUBLISHING_OPTIONS_PANE, &_tmp3_, NULL, FALSE);
#line 172 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _publishing_flickr_flickr_publisher_on_publishing_options_pane_logout_publishing_flickr_publishing_options_pane_logout, self);
#line 174 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (!spit_publishing_publisher_is_running (G_TYPE_CHECK_INSTANCE_CAST (self, SPIT_PUBLISHING_TYPE_PUBLISHER, SpitPublishingPublisher))) {
#line 175 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		return;
#line 1993 "FlickrPublishing.c"
	}
#line 177 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_debug ("FlickrPublishing.vala:177: EVENT: user clicked the 'Logout' button in " \
"the publishing options pane");
#line 179 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	publishing_flickr_flickr_publisher_do_logout (self);
#line 1999 "FlickrPublishing.c"
}

static void
publishing_flickr_flickr_publisher_on_upload_status_updated (PublishingFlickrFlickrPublisher* self,
                                                             gint file_number,
                                                             gdouble completed_fraction)
{
	SpitPublishingProgressCallback _tmp0_;
	gpointer _tmp0__target;
	SpitPublishingProgressCallback _tmp1_;
	gpointer _tmp1__target;
#line 182 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_if_fail (PUBLISHING_FLICKR_IS_FLICKR_PUBLISHER (self));
#line 183 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (!spit_publishing_publisher_is_running (G_TYPE_CHECK_INSTANCE_CAST (self, SPIT_PUBLISHING_TYPE_PUBLISHER, SpitPublishingPublisher))) {
#line 184 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		return;
#line 2017 "FlickrPublishing.c"
	}
#line 186 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_debug ("FlickrPublishing.vala:186: EVENT: uploader reports upload %.2f percent" \
" complete.", 100.0 * completed_fraction);
#line 188 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp0_ = self->priv->progress_reporter;
#line 188 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp0__target = self->priv->progress_reporter_target;
#line 188 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_vala_assert (_tmp0_ != NULL, "progress_reporter != null");
#line 190 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp1_ = self->priv->progress_reporter;
#line 190 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp1__target = self->priv->progress_reporter_target;
#line 190 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp1_ (file_number, completed_fraction, _tmp1__target);
#line 2033 "FlickrPublishing.c"
}

static void
publishing_flickr_flickr_publisher_do_fetch_account_info_data_free (gpointer _data)
{
	PublishingFlickrFlickrPublisherDoFetchAccountInfoData* _data_;
	_data_ = _data;
#line 83 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_object_unref0 (_data_->self);
#line 83 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_slice_free (PublishingFlickrFlickrPublisherDoFetchAccountInfoData, _data_);
#line 2045 "FlickrPublishing.c"
}

static void
publishing_flickr_flickr_publisher_do_fetch_account_info (PublishingFlickrFlickrPublisher* self,
                                                          GAsyncReadyCallback _callback_,
                                                          gpointer _user_data_)
{
	PublishingFlickrFlickrPublisherDoFetchAccountInfoData* _data_;
	PublishingFlickrFlickrPublisher* _tmp0_;
#line 83 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_if_fail (PUBLISHING_FLICKR_IS_FLICKR_PUBLISHER (self));
#line 83 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_ = g_slice_new0 (PublishingFlickrFlickrPublisherDoFetchAccountInfoData);
#line 83 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 83 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_task_set_task_data (_data_->_async_result, _data_, publishing_flickr_flickr_publisher_do_fetch_account_info_data_free);
#line 83 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 83 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_->self = _tmp0_;
#line 83 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	publishing_flickr_flickr_publisher_do_fetch_account_info_co (_data_);
#line 2069 "FlickrPublishing.c"
}

static void
publishing_flickr_flickr_publisher_do_fetch_account_info_finish (PublishingFlickrFlickrPublisher* self,
                                                                 GAsyncResult* _res_)
{
	PublishingFlickrFlickrPublisherDoFetchAccountInfoData* _data_;
#line 83 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2079 "FlickrPublishing.c"
}

static void
publishing_flickr_flickr_publisher_do_fetch_account_info_ready (GObject* source_object,
                                                                GAsyncResult* _res_,
                                                                gpointer _user_data_)
{
	PublishingFlickrFlickrPublisherDoFetchAccountInfoData* _data_;
#line 201 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_ = _user_data_;
#line 201 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_->_source_object_ = source_object;
#line 201 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_->_res_ = _res_;
#line 201 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	publishing_flickr_flickr_publisher_do_fetch_account_info_co (_data_);
#line 2096 "FlickrPublishing.c"
}

static gboolean
publishing_flickr_flickr_publisher_do_fetch_account_info_co (PublishingFlickrFlickrPublisherDoFetchAccountInfoData* _data_)
{
#line 193 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	switch (_data_->_state_) {
#line 193 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		case 0:
#line 2106 "FlickrPublishing.c"
		goto _state_0;
#line 193 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		case 1:
#line 2110 "FlickrPublishing.c"
		goto _state_1;
		default:
#line 193 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_assert_not_reached ();
#line 2115 "FlickrPublishing.c"
	}
	_state_0:
#line 194 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_debug ("FlickrPublishing.vala:194: ACTION: running network transaction to fetc" \
"h account information");
#line 196 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_->_tmp0_ = _data_->self->priv->host;
#line 196 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	spit_publishing_plugin_host_set_service_locked (_data_->_tmp0_, TRUE);
#line 197 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_->_tmp1_ = _data_->self->priv->host;
#line 197 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	spit_publishing_plugin_host_install_account_fetch_wait_pane (_data_->_tmp1_);
#line 199 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_->_tmp2_ = _data_->self->priv->session;
#line 199 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_->_tmp3_ = publishing_flickr_account_info_fetch_transaction_new (_data_->_tmp2_);
#line 199 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_->txn = _data_->_tmp3_;
#line 2134 "FlickrPublishing.c"
	{
#line 201 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_data_->_state_ = 1;
#line 201 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		publishing_rest_support_transaction_execute_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->txn, PUBLISHING_REST_SUPPORT_TYPE_TRANSACTION, PublishingRESTSupportTransaction), publishing_flickr_flickr_publisher_do_fetch_account_info_ready, _data_);
#line 201 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		return FALSE;
#line 2142 "FlickrPublishing.c"
		_state_1:
#line 201 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		publishing_rest_support_transaction_execute_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->txn, PUBLISHING_REST_SUPPORT_TYPE_TRANSACTION, PublishingRESTSupportTransaction), _data_->_res_, &_data_->_inner_error0_);
#line 201 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2148 "FlickrPublishing.c"
			goto __catch0_g_error;
		}
#line 202 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_debug ("FlickrPublishing.vala:202: EVENT: account fetch transaction response r" \
"eceived over the network");
#line 203 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_data_->_tmp4_ = publishing_rest_support_transaction_get_response (G_TYPE_CHECK_INSTANCE_CAST (_data_->txn, PUBLISHING_REST_SUPPORT_TYPE_TRANSACTION, PublishingRESTSupportTransaction));
#line 203 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_data_->_tmp5_ = _data_->_tmp4_;
#line 203 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		publishing_flickr_flickr_publisher_do_parse_account_info_from_xml (_data_->self, _data_->_tmp5_);
#line 203 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_g_free0 (_data_->_tmp5_);
#line 2161 "FlickrPublishing.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 200 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_data_->err = _data_->_inner_error0_;
#line 200 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_data_->_inner_error0_ = NULL;
#line 205 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_debug ("FlickrPublishing.vala:205: EVENT: account fetch transaction caused a n" \
"etwork error");
#line 206 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_data_->_tmp6_ = _data_->self->priv->host;
#line 206 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_data_->_tmp7_ = _data_->err;
#line 206 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		spit_publishing_plugin_host_post_error (_data_->_tmp6_, _data_->_tmp7_);
#line 200 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_g_error_free0 (_data_->err);
#line 2180 "FlickrPublishing.c"
	}
	__finally0:
#line 200 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 200 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_publishing_rest_support_transaction_unref0 (_data_->txn);
#line 200 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 200 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 200 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_object_unref (_data_->_async_result);
#line 200 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		return FALSE;
#line 2195 "FlickrPublishing.c"
	}
#line 193 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_publishing_rest_support_transaction_unref0 (_data_->txn);
#line 193 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 193 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (_data_->_state_ != 0) {
#line 193 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 193 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2207 "FlickrPublishing.c"
		}
	}
#line 193 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_object_unref (_data_->_async_result);
#line 193 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return FALSE;
#line 2214 "FlickrPublishing.c"
}

static gint64
int64_parse (const gchar* str,
             guint _base)
{
	gint64 result;
#line 778 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0LL);
#line 779 "glib-2.0.vapi"
	result = g_ascii_strtoll (str, NULL, _base);
#line 779 "glib-2.0.vapi"
	return result;
#line 2228 "FlickrPublishing.c"
}

static void
publishing_flickr_flickr_publisher_do_parse_account_info_from_xml (PublishingFlickrFlickrPublisher* self,
                                                                   const gchar* xml)
{
	GError* _inner_error0_ = NULL;
#line 210 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_if_fail (PUBLISHING_FLICKR_IS_FLICKR_PUBLISHER (self));
#line 210 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_if_fail (xml != NULL);
#line 211 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_debug ("FlickrPublishing.vala:211: ACTION: parsing account information from xm" \
"l = '%s'", xml);
#line 2242 "FlickrPublishing.c"
	{
		PublishingRESTSupportXmlDocument* response_doc = NULL;
		PublishingRESTSupportXmlDocument* _tmp0_;
		xmlNode* root_node = NULL;
		PublishingRESTSupportXmlDocument* _tmp1_;
		xmlNode* _tmp2_;
		xmlNode* user_node = NULL;
		PublishingRESTSupportXmlDocument* _tmp3_;
		xmlNode* _tmp4_;
		xmlNode* _tmp5_;
		gchar* is_pro_str = NULL;
		PublishingRESTSupportXmlDocument* _tmp6_;
		xmlNode* _tmp7_;
		gchar* _tmp8_;
		gchar* max_images_str = NULL;
		PublishingRESTSupportXmlDocument* _tmp9_;
		xmlNode* _tmp10_;
		gchar* _tmp11_;
		gchar* uploaded_images_str = NULL;
		PublishingRESTSupportXmlDocument* _tmp12_;
		xmlNode* _tmp13_;
		gchar* _tmp14_;
		PublishingFlickrUserKind user_kind = 0;
		const gchar* _tmp15_;
		PublishingFlickrPublishingParameters* _tmp18_;
		const gchar* _tmp19_;
		PublishingFlickrPublishingParameters* _tmp20_;
		const gchar* _tmp21_;
		PublishingFlickrPublishingParameters* _tmp22_;
#line 213 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp0_ = publishing_flickr_transaction_parse_flickr_response (xml, &_inner_error0_);
#line 213 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		response_doc = _tmp0_;
#line 213 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 213 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			if (_inner_error0_->domain == SPIT_PUBLISHING_PUBLISHING_ERROR) {
#line 2280 "FlickrPublishing.c"
				goto __catch0_spit_publishing_publishing_error;
			}
#line 213 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 213 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			g_clear_error (&_inner_error0_);
#line 213 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			return;
#line 2289 "FlickrPublishing.c"
		}
#line 214 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp1_ = response_doc;
#line 214 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp2_ = publishing_rest_support_xml_document_get_root_node (_tmp1_);
#line 214 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		root_node = _tmp2_;
#line 216 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp3_ = response_doc;
#line 216 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp4_ = root_node;
#line 216 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp5_ = publishing_rest_support_xml_document_get_named_child (_tmp3_, _tmp4_, "user", &_inner_error0_);
#line 216 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		user_node = _tmp5_;
#line 216 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 216 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_publishing_rest_support_xml_document_unref0 (response_doc);
#line 216 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			if (_inner_error0_->domain == SPIT_PUBLISHING_PUBLISHING_ERROR) {
#line 2311 "FlickrPublishing.c"
				goto __catch0_spit_publishing_publishing_error;
			}
#line 216 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 216 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			g_clear_error (&_inner_error0_);
#line 216 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			return;
#line 2320 "FlickrPublishing.c"
		}
#line 218 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp6_ = response_doc;
#line 218 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp7_ = user_node;
#line 218 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp8_ = publishing_rest_support_xml_document_get_property_value (_tmp6_, _tmp7_, "ispro", &_inner_error0_);
#line 218 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		is_pro_str = _tmp8_;
#line 218 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 218 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_publishing_rest_support_xml_document_unref0 (response_doc);
#line 218 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			if (_inner_error0_->domain == SPIT_PUBLISHING_PUBLISHING_ERROR) {
#line 2336 "FlickrPublishing.c"
				goto __catch0_spit_publishing_publishing_error;
			}
#line 218 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 218 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			g_clear_error (&_inner_error0_);
#line 218 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			return;
#line 2345 "FlickrPublishing.c"
		}
#line 220 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp9_ = response_doc;
#line 220 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp10_ = user_node;
#line 220 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp11_ = publishing_rest_support_xml_document_get_property_value (_tmp9_, _tmp10_, "upload_limit", &_inner_error0_);
#line 220 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		max_images_str = _tmp11_;
#line 220 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 220 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_g_free0 (is_pro_str);
#line 220 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_publishing_rest_support_xml_document_unref0 (response_doc);
#line 220 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			if (_inner_error0_->domain == SPIT_PUBLISHING_PUBLISHING_ERROR) {
#line 2363 "FlickrPublishing.c"
				goto __catch0_spit_publishing_publishing_error;
			}
#line 220 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 220 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			g_clear_error (&_inner_error0_);
#line 220 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			return;
#line 2372 "FlickrPublishing.c"
		}
#line 221 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp12_ = response_doc;
#line 221 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp13_ = user_node;
#line 221 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp14_ = publishing_rest_support_xml_document_get_property_value (_tmp12_, _tmp13_, "upload_count", &_inner_error0_);
#line 221 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		uploaded_images_str = _tmp14_;
#line 221 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 221 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_g_free0 (max_images_str);
#line 221 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_g_free0 (is_pro_str);
#line 221 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_publishing_rest_support_xml_document_unref0 (response_doc);
#line 221 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			if (_inner_error0_->domain == SPIT_PUBLISHING_PUBLISHING_ERROR) {
#line 2392 "FlickrPublishing.c"
				goto __catch0_spit_publishing_publishing_error;
			}
#line 221 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 221 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			g_clear_error (&_inner_error0_);
#line 221 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			return;
#line 2401 "FlickrPublishing.c"
		}
#line 224 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp15_ = is_pro_str;
#line 224 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		if (g_strcmp0 (_tmp15_, "0") == 0) {
#line 225 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			user_kind = PUBLISHING_FLICKR_USER_KIND_FREE;
#line 2409 "FlickrPublishing.c"
		} else {
			const gchar* _tmp16_;
#line 226 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_tmp16_ = is_pro_str;
#line 226 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			if (g_strcmp0 (_tmp16_, "1") == 0) {
#line 227 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				user_kind = PUBLISHING_FLICKR_USER_KIND_PRO;
#line 2418 "FlickrPublishing.c"
			} else {
				GError* _tmp17_;
#line 229 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				_tmp17_ = g_error_new_literal (SPIT_PUBLISHING_PUBLISHING_ERROR, SPIT_PUBLISHING_PUBLISHING_ERROR_MALFORMED_RESPONSE, "Unable to determine if user has free or pro account");
#line 229 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				_inner_error0_ = _tmp17_;
#line 229 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				_g_free0 (uploaded_images_str);
#line 229 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				_g_free0 (max_images_str);
#line 229 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				_g_free0 (is_pro_str);
#line 229 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				_publishing_rest_support_xml_document_unref0 (response_doc);
#line 229 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				if (_inner_error0_->domain == SPIT_PUBLISHING_PUBLISHING_ERROR) {
#line 2435 "FlickrPublishing.c"
					goto __catch0_spit_publishing_publishing_error;
				}
#line 229 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 229 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				g_clear_error (&_inner_error0_);
#line 229 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				return;
#line 2444 "FlickrPublishing.c"
			}
		}
#line 232 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp18_ = self->priv->parameters;
#line 232 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp19_ = max_images_str;
#line 232 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp18_->max_images_count = int64_parse (_tmp19_, (guint) 0);
#line 233 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp20_ = self->priv->parameters;
#line 233 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp21_ = uploaded_images_str;
#line 233 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp20_->uploaded_images_count = (guint64) int64_parse (_tmp21_, (guint) 0);
#line 234 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp22_ = self->priv->parameters;
#line 234 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp22_->user_kind = user_kind;
#line 212 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_g_free0 (uploaded_images_str);
#line 212 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_g_free0 (max_images_str);
#line 212 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_g_free0 (is_pro_str);
#line 212 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_publishing_rest_support_xml_document_unref0 (response_doc);
#line 2471 "FlickrPublishing.c"
	}
	goto __finally0;
	__catch0_spit_publishing_publishing_error:
	{
		GError* err = NULL;
		GError* _tmp23_;
		SpitPublishingPluginHost* _tmp24_;
		GError* _tmp25_;
#line 212 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		err = _inner_error0_;
#line 212 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_inner_error0_ = NULL;
#line 240 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp23_ = err;
#line 240 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		if (g_error_matches (_tmp23_, SPIT_PUBLISHING_PUBLISHING_ERROR, SPIT_PUBLISHING_PUBLISHING_ERROR_EXPIRED_SESSION)) {
#line 241 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			publishing_flickr_flickr_publisher_do_logout (self);
#line 242 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_g_error_free0 (err);
#line 242 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			return;
#line 2494 "FlickrPublishing.c"
		}
#line 245 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp24_ = self->priv->host;
#line 245 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp25_ = err;
#line 245 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		spit_publishing_plugin_host_post_error (_tmp24_, _tmp25_);
#line 246 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_g_error_free0 (err);
#line 246 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		return;
#line 2506 "FlickrPublishing.c"
	}
	__finally0:
#line 212 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 212 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 212 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_clear_error (&_inner_error0_);
#line 212 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		return;
#line 2517 "FlickrPublishing.c"
	}
#line 249 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	publishing_flickr_flickr_publisher_on_account_info_available (self);
#line 2521 "FlickrPublishing.c"
}

static void
publishing_flickr_flickr_publisher_do_logout (PublishingFlickrFlickrPublisher* self)
{
	SpitPublishingAuthenticator* _tmp0_;
#line 252 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_if_fail (PUBLISHING_FLICKR_IS_FLICKR_PUBLISHER (self));
#line 253 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_debug ("FlickrPublishing.vala:253: ACTION: logging user out, deauthenticating " \
"session, and erasing stored credentials");
#line 255 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp0_ = self->priv->authenticator;
#line 255 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (spit_publishing_authenticator_can_logout (_tmp0_)) {
#line 2536 "FlickrPublishing.c"
		SpitPublishingAuthenticator* _tmp1_;
#line 256 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp1_ = self->priv->authenticator;
#line 256 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		spit_publishing_authenticator_logout (_tmp1_);
#line 2542 "FlickrPublishing.c"
	}
#line 259 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->running = FALSE;
#line 261 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	publishing_flickr_flickr_publisher_attempt_start (self);
#line 2548 "FlickrPublishing.c"
}

static void
publishing_flickr_flickr_publisher_do_show_publishing_options_pane (PublishingFlickrFlickrPublisher* self)
{
	SpitPublishingPluginHost* _tmp0_;
	GtkBuilder* builder = NULL;
	GtkBuilder* _tmp1_;
	PublishingFlickrPublishingParameters* _tmp8_;
	SpitPublishingPluginHost* _tmp9_;
	GtkBuilder* _tmp10_;
	PublishingFlickrPublishingOptionsPane* _tmp11_;
	PublishingFlickrPublishingOptionsPane* _tmp12_;
	PublishingFlickrPublishingOptionsPane* _tmp13_;
	SpitPublishingPluginHost* _tmp14_;
	PublishingFlickrPublishingOptionsPane* _tmp15_;
	GError* _inner_error0_ = NULL;
#line 264 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_if_fail (PUBLISHING_FLICKR_IS_FLICKR_PUBLISHER (self));
#line 265 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_debug ("FlickrPublishing.vala:265: ACTION: displaying publishing options pane");
#line 267 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp0_ = self->priv->host;
#line 267 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	spit_publishing_plugin_host_set_service_locked (_tmp0_, FALSE);
#line 269 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp1_ = gtk_builder_new ();
#line 269 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	builder = _tmp1_;
#line 2578 "FlickrPublishing.c"
	{
		GtkBuilder* _tmp2_;
#line 274 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp2_ = builder;
#line 274 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		gtk_builder_add_from_resource (_tmp2_, PLUGIN_RESOURCE_PATH "/" "flickr_publishing_options_pane.ui", &_inner_error0_);
#line 274 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2587 "FlickrPublishing.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
		SpitPublishingPluginHost* _tmp5_;
		GError* _tmp6_;
		GError* _tmp7_;
#line 271 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		e = _inner_error0_;
#line 271 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_inner_error0_ = NULL;
#line 277 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp3_ = e;
#line 277 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp4_ = _tmp3_->message;
#line 277 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_warning ("FlickrPublishing.vala:277: Could not parse UI file! Error: %s.", _tmp4_);
#line 278 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp5_ = self->priv->host;
#line 278 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp6_ = g_error_new_literal (SPIT_PUBLISHING_PUBLISHING_ERROR, SPIT_PUBLISHING_PUBLISHING_ERROR_LOCAL_FILE_ERROR, _ ("A file required for publishing is unavailable. Publishing to Flickr ca" \
"n’t continue."));
#line 278 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp7_ = _tmp6_;
#line 278 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		spit_publishing_plugin_host_post_error (_tmp5_, _tmp7_);
#line 278 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_g_error_free0 (_tmp7_);
#line 281 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_g_error_free0 (e);
#line 281 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_g_object_unref0 (builder);
#line 281 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		return;
#line 2626 "FlickrPublishing.c"
	}
	__finally0:
#line 271 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 271 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_g_object_unref0 (builder);
#line 271 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 271 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_clear_error (&_inner_error0_);
#line 271 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		return;
#line 2639 "FlickrPublishing.c"
	}
#line 284 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp8_ = self->priv->parameters;
#line 284 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp9_ = self->priv->host;
#line 284 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp10_ = builder;
#line 284 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp11_ = publishing_flickr_publishing_options_pane_new (self, _tmp8_, spit_publishing_plugin_host_get_publishable_media_type (_tmp9_), _tmp10_, publishing_flickr_flickr_publisher_get_persistent_strip_metadata (self));
#line 284 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_object_unref0 (self->priv->publishing_options_pane);
#line 284 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->publishing_options_pane = _tmp11_;
#line 286 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp12_ = self->priv->publishing_options_pane;
#line 286 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_signal_connect_object (_tmp12_, "publish", (GCallback) _publishing_flickr_flickr_publisher_on_publishing_options_pane_publish_publishing_flickr_publishing_options_pane_publish, self, 0);
#line 287 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp13_ = self->priv->publishing_options_pane;
#line 287 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_signal_connect_object (_tmp13_, "logout", (GCallback) _publishing_flickr_flickr_publisher_on_publishing_options_pane_logout_publishing_flickr_publishing_options_pane_logout, self, 0);
#line 288 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp14_ = self->priv->host;
#line 288 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp15_ = self->priv->publishing_options_pane;
#line 288 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	spit_publishing_plugin_host_install_dialog_pane (_tmp14_, G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, SPIT_PUBLISHING_TYPE_DIALOG_PANE, SpitPublishingDialogPane), SPIT_PUBLISHING_PLUGIN_HOST_BUTTON_MODE_CANCEL);
#line 264 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_object_unref0 (builder);
#line 2669 "FlickrPublishing.c"
}

gint
publishing_flickr_flickr_publisher_flickr_date_time_compare_func (SpitPublishingPublishable* a,
                                                                  SpitPublishingPublishable* b)
{
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	gint _tmp4_;
	gint result;
#line 291 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (a, SPIT_PUBLISHING_TYPE_PUBLISHABLE), 0);
#line 291 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (b, SPIT_PUBLISHING_TYPE_PUBLISHABLE), 0);
#line 293 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp0_ = spit_publishing_publishable_get_exposure_date_time (a);
#line 293 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp1_ = _tmp0_;
#line 293 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp2_ = spit_publishing_publishable_get_exposure_date_time (b);
#line 293 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp3_ = _tmp2_;
#line 293 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp4_ = g_date_time_compare (_tmp1_, _tmp3_);
#line 293 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_date_time_unref0 (_tmp3_);
#line 293 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_date_time_unref0 (_tmp1_);
#line 293 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	result = _tmp4_;
#line 293 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return result;
#line 2704 "FlickrPublishing.c"
}

static void
publishing_flickr_flickr_publisher_do_publish_data_free (gpointer _data)
{
	PublishingFlickrFlickrPublisherDoPublishData* _data_;
	_data_ = _data;
#line 83 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_object_unref0 (_data_->self);
#line 83 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_slice_free (PublishingFlickrFlickrPublisherDoPublishData, _data_);
#line 2716 "FlickrPublishing.c"
}

static void
publishing_flickr_flickr_publisher_do_publish (PublishingFlickrFlickrPublisher* self,
                                               gboolean strip_metadata,
                                               GAsyncReadyCallback _callback_,
                                               gpointer _user_data_)
{
	PublishingFlickrFlickrPublisherDoPublishData* _data_;
	PublishingFlickrFlickrPublisher* _tmp0_;
#line 83 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_if_fail (PUBLISHING_FLICKR_IS_FLICKR_PUBLISHER (self));
#line 83 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_ = g_slice_new0 (PublishingFlickrFlickrPublisherDoPublishData);
#line 83 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 83 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_task_set_task_data (_data_->_async_result, _data_, publishing_flickr_flickr_publisher_do_publish_data_free);
#line 83 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 83 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_->self = _tmp0_;
#line 83 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_->strip_metadata = strip_metadata;
#line 83 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	publishing_flickr_flickr_publisher_do_publish_co (_data_);
#line 2743 "FlickrPublishing.c"
}

static void
publishing_flickr_flickr_publisher_do_publish_finish (PublishingFlickrFlickrPublisher* self,
                                                      GAsyncResult* _res_)
{
	PublishingFlickrFlickrPublisherDoPublishData* _data_;
#line 83 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 2753 "FlickrPublishing.c"
}

static gint
_publishing_flickr_flickr_publisher_flickr_date_time_compare_func_gcompare_data_func (gconstpointer a,
                                                                                      gconstpointer b,
                                                                                      gpointer self)
{
	gint result;
	result = publishing_flickr_flickr_publisher_flickr_date_time_compare_func ((SpitPublishingPublishable*) a, (SpitPublishingPublishable*) b);
#line 317 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return result;
#line 2765 "FlickrPublishing.c"
}

static void
_publishing_flickr_flickr_publisher_on_upload_status_updated_spit_publishing_progress_callback (gint file_number,
                                                                                                gdouble fraction_complete,
                                                                                                gpointer self)
{
#line 321 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	publishing_flickr_flickr_publisher_on_upload_status_updated ((PublishingFlickrFlickrPublisher*) self, file_number, fraction_complete);
#line 2775 "FlickrPublishing.c"
}

static void
publishing_flickr_flickr_publisher_do_publish_ready (GObject* source_object,
                                                     GAsyncResult* _res_,
                                                     gpointer _user_data_)
{
	PublishingFlickrFlickrPublisherDoPublishData* _data_;
#line 321 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_ = _user_data_;
#line 321 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_->_source_object_ = source_object;
#line 321 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_->_res_ = _res_;
#line 321 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	publishing_flickr_flickr_publisher_do_publish_co (_data_);
#line 2792 "FlickrPublishing.c"
}

static gboolean
publishing_flickr_flickr_publisher_do_publish_co (PublishingFlickrFlickrPublisherDoPublishData* _data_)
{
#line 296 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	switch (_data_->_state_) {
#line 296 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		case 0:
#line 2802 "FlickrPublishing.c"
		goto _state_0;
#line 296 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		case 1:
#line 2806 "FlickrPublishing.c"
		goto _state_1;
		default:
#line 296 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_assert_not_reached ();
#line 2811 "FlickrPublishing.c"
	}
	_state_0:
#line 297 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	publishing_flickr_flickr_publisher_set_persistent_strip_metadata (_data_->self, _data_->strip_metadata);
#line 298 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_debug ("FlickrPublishing.vala:298: ACTION: uploading media items to remote ser" \
"ver.");
#line 300 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_->_tmp0_ = _data_->self->priv->host;
#line 300 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	spit_publishing_plugin_host_set_service_locked (_data_->_tmp0_, TRUE);
#line 301 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_->_tmp1_ = _data_->self->priv->host;
#line 301 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_->_tmp2_ = _data_->self->priv->parameters;
#line 301 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_->_tmp3_ = NULL;
#line 301 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_->_tmp4_ = NULL;
#line 301 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_->_tmp5_ = spit_publishing_plugin_host_serialize_publishables (_data_->_tmp1_, _data_->_tmp2_->photo_major_axis_size, _data_->strip_metadata, &_data_->_tmp3_, &_data_->_tmp4_);
#line 301 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	(_data_->self->priv->progress_reporter_target_destroy_notify == NULL) ? NULL : (_data_->self->priv->progress_reporter_target_destroy_notify (_data_->self->priv->progress_reporter_target), NULL);
#line 301 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_->self->priv->progress_reporter = NULL;
#line 301 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_->self->priv->progress_reporter_target = NULL;
#line 301 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_->self->priv->progress_reporter_target_destroy_notify = NULL;
#line 301 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_->self->priv->progress_reporter = _data_->_tmp5_;
#line 301 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_->self->priv->progress_reporter_target = _data_->_tmp3_;
#line 301 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_->self->priv->progress_reporter_target_destroy_notify = _data_->_tmp4_;
#line 307 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (!spit_publishing_publisher_is_running (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, SPIT_PUBLISHING_TYPE_PUBLISHER, SpitPublishingPublisher))) {
#line 308 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 308 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		if (_data_->_state_ != 0) {
#line 308 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 308 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2856 "FlickrPublishing.c"
			}
		}
#line 308 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_object_unref (_data_->_async_result);
#line 308 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		return FALSE;
#line 2863 "FlickrPublishing.c"
	}
#line 311 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_->_tmp6_ = _data_->self->priv->host;
#line 311 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_->_tmp7_ = 0;
#line 311 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_->_tmp8_ = spit_publishing_plugin_host_get_publishables (_data_->_tmp6_, &_data_->_tmp7_);
#line 311 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_->publishables = _data_->_tmp8_;
#line 311 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_->publishables_length1 = _data_->_tmp7_;
#line 311 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_->_publishables_size_ = _data_->publishables_length1;
#line 312 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_->_tmp9_ = gee_array_list_new (SPIT_PUBLISHING_TYPE_PUBLISHABLE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 312 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_->sorted_list = _data_->_tmp9_;
#line 314 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_->_tmp10_ = _data_->publishables;
#line 314 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_->_tmp10__length1 = _data_->publishables_length1;
#line 2885 "FlickrPublishing.c"
	{
#line 314 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_data_->p_collection_length1 = 0;
#line 314 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_data_->_p_collection_size_ = 0;
#line 314 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_data_->p_collection = _data_->_tmp10_;
#line 314 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_data_->p_collection_length1 = _data_->_tmp10__length1;
#line 314 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		for (_data_->p_it = 0; _data_->p_it < _data_->p_collection_length1; _data_->p_it = _data_->p_it + 1) {
#line 314 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_data_->_tmp11_ = _g_object_ref0 (_data_->p_collection[_data_->p_it]);
#line 314 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_data_->p = _data_->_tmp11_;
#line 2901 "FlickrPublishing.c"
			{
#line 315 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				_data_->_tmp12_ = _data_->sorted_list;
#line 315 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				_data_->_tmp13_ = _data_->p;
#line 315 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp12_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _data_->_tmp13_);
#line 314 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				_g_object_unref0 (_data_->p);
#line 2911 "FlickrPublishing.c"
			}
		}
	}
#line 317 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_->_tmp14_ = _data_->sorted_list;
#line 317 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	gee_list_sort (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp14_, GEE_TYPE_LIST, GeeList), _publishing_flickr_flickr_publisher_flickr_date_time_compare_func_gcompare_data_func, NULL, NULL);
#line 319 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_->_tmp15_ = _data_->self->priv->session;
#line 319 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_->_tmp16_ = _data_->sorted_list;
#line 319 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_->_tmp17_ = 0;
#line 319 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_->_tmp18_ = gee_collection_to_array (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp16_, GEE_TYPE_COLLECTION, GeeCollection), &_data_->_tmp17_);
#line 319 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_->_tmp19_ = _data_->_tmp18_;
#line 319 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_->_tmp19__length1 = _data_->_tmp17_;
#line 319 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_->_tmp20_ = _data_->self->priv->parameters;
#line 319 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_->_tmp21_ = publishing_flickr_uploader_new (_data_->_tmp15_, _data_->_tmp19_, _data_->_tmp17_, _data_->_tmp20_, _data_->strip_metadata);
#line 319 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_->_tmp22_ = _data_->_tmp21_;
#line 319 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_->_tmp19_ = (_vala_array_free (_data_->_tmp19_, _data_->_tmp19__length1, (GDestroyNotify) g_object_unref), NULL);
#line 319 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_->uploader = _data_->_tmp22_;
#line 2941 "FlickrPublishing.c"
	{
#line 321 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_data_->_tmp23_ = _data_->uploader;
#line 321 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_data_->_state_ = 1;
#line 321 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		publishing_rest_support_batch_uploader_upload_async (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp23_, PUBLISHING_REST_SUPPORT_TYPE_BATCH_UPLOADER, PublishingRESTSupportBatchUploader), _publishing_flickr_flickr_publisher_on_upload_status_updated_spit_publishing_progress_callback, _data_->self, publishing_flickr_flickr_publisher_do_publish_ready, _data_);
#line 321 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		return FALSE;
#line 2951 "FlickrPublishing.c"
		_state_1:
#line 321 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_data_->num_published = publishing_rest_support_batch_uploader_upload_finish (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp23_, PUBLISHING_REST_SUPPORT_TYPE_BATCH_UPLOADER, PublishingRESTSupportBatchUploader), _data_->_res_, &_data_->_inner_error0_);
#line 321 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 2957 "FlickrPublishing.c"
			goto __catch0_g_error;
		}
#line 322 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_debug ("FlickrPublishing.vala:322: EVENT: uploader reports upload complete; %d" \
" items published.", _data_->num_published);
#line 323 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		publishing_flickr_flickr_publisher_do_show_success_pane (_data_->self);
#line 2964 "FlickrPublishing.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 320 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_data_->err = _data_->_inner_error0_;
#line 320 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_data_->_inner_error0_ = NULL;
#line 325 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_data_->_tmp24_ = _data_->err;
#line 325 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_data_->_tmp25_ = _data_->_tmp24_->message;
#line 325 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_debug ("FlickrPublishing.vala:325: EVENT: uploader reports upload error = '%s'" \
".", _data_->_tmp25_);
#line 326 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_data_->_tmp26_ = _data_->self->priv->host;
#line 326 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_data_->_tmp27_ = _data_->err;
#line 326 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		spit_publishing_plugin_host_post_error (_data_->_tmp26_, _data_->_tmp27_);
#line 320 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_g_error_free0 (_data_->err);
#line 2987 "FlickrPublishing.c"
	}
	__finally0:
#line 320 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 320 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_publishing_rest_support_batch_uploader_unref0 (_data_->uploader);
#line 320 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_g_object_unref0 (_data_->sorted_list);
#line 320 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_data_->publishables = (_vala_array_free (_data_->publishables, _data_->publishables_length1, (GDestroyNotify) g_object_unref), NULL);
#line 320 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 320 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 320 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_object_unref (_data_->_async_result);
#line 320 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		return FALSE;
#line 3006 "FlickrPublishing.c"
	}
#line 296 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_publishing_rest_support_batch_uploader_unref0 (_data_->uploader);
#line 296 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_object_unref0 (_data_->sorted_list);
#line 296 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_->publishables = (_vala_array_free (_data_->publishables, _data_->publishables_length1, (GDestroyNotify) g_object_unref), NULL);
#line 296 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 296 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (_data_->_state_ != 0) {
#line 296 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 296 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3022 "FlickrPublishing.c"
		}
	}
#line 296 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_object_unref (_data_->_async_result);
#line 296 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return FALSE;
#line 3029 "FlickrPublishing.c"
}

static void
publishing_flickr_flickr_publisher_do_show_success_pane (PublishingFlickrFlickrPublisher* self)
{
	SpitPublishingPluginHost* _tmp0_;
	SpitPublishingPluginHost* _tmp1_;
#line 330 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_if_fail (PUBLISHING_FLICKR_IS_FLICKR_PUBLISHER (self));
#line 331 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_debug ("FlickrPublishing.vala:331: ACTION: showing success pane.");
#line 333 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp0_ = self->priv->host;
#line 333 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	spit_publishing_plugin_host_set_service_locked (_tmp0_, FALSE);
#line 334 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp1_ = self->priv->host;
#line 334 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	spit_publishing_plugin_host_install_success_pane (_tmp1_);
#line 3049 "FlickrPublishing.c"
}

gint
publishing_flickr_flickr_publisher_get_persistent_visibility (PublishingFlickrFlickrPublisher* self)
{
	SpitPublishingPluginHost* _tmp0_;
	gint result;
#line 337 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_val_if_fail (PUBLISHING_FLICKR_IS_FLICKR_PUBLISHER (self), 0);
#line 338 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp0_ = self->priv->host;
#line 338 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	result = spit_host_interface_get_config_int (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, SPIT_TYPE_HOST_INTERFACE, SpitHostInterface), "visibility", 0);
#line 338 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return result;
#line 3065 "FlickrPublishing.c"
}

void
publishing_flickr_flickr_publisher_set_persistent_visibility (PublishingFlickrFlickrPublisher* self,
                                                              gint vis)
{
	SpitPublishingPluginHost* _tmp0_;
#line 341 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_if_fail (PUBLISHING_FLICKR_IS_FLICKR_PUBLISHER (self));
#line 342 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp0_ = self->priv->host;
#line 342 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	spit_host_interface_set_config_int (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, SPIT_TYPE_HOST_INTERFACE, SpitHostInterface), "visibility", vis);
#line 3079 "FlickrPublishing.c"
}

gint
publishing_flickr_flickr_publisher_get_persistent_default_size (PublishingFlickrFlickrPublisher* self)
{
	SpitPublishingPluginHost* _tmp0_;
	gint result;
#line 345 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_val_if_fail (PUBLISHING_FLICKR_IS_FLICKR_PUBLISHER (self), 0);
#line 346 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp0_ = self->priv->host;
#line 346 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	result = spit_host_interface_get_config_int (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, SPIT_TYPE_HOST_INTERFACE, SpitHostInterface), "default_size", 1);
#line 346 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return result;
#line 3095 "FlickrPublishing.c"
}

void
publishing_flickr_flickr_publisher_set_persistent_default_size (PublishingFlickrFlickrPublisher* self,
                                                                gint size)
{
	SpitPublishingPluginHost* _tmp0_;
#line 349 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_if_fail (PUBLISHING_FLICKR_IS_FLICKR_PUBLISHER (self));
#line 350 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp0_ = self->priv->host;
#line 350 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	spit_host_interface_set_config_int (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, SPIT_TYPE_HOST_INTERFACE, SpitHostInterface), "default_size", size);
#line 3109 "FlickrPublishing.c"
}

static SpitPublishingService*
publishing_flickr_flickr_publisher_real_get_service (SpitPublishingPublisher* base)
{
	PublishingFlickrFlickrPublisher * self;
	SpitPublishingService* _tmp0_;
	SpitPublishingService* _tmp1_;
	SpitPublishingService* result;
#line 353 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, PUBLISHING_FLICKR_TYPE_FLICKR_PUBLISHER, PublishingFlickrFlickrPublisher);
#line 354 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp0_ = self->priv->service;
#line 354 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 354 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	result = _tmp1_;
#line 354 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return result;
#line 3129 "FlickrPublishing.c"
}

static gboolean
publishing_flickr_flickr_publisher_real_is_running (SpitPublishingPublisher* base)
{
	PublishingFlickrFlickrPublisher * self;
	gboolean result;
#line 357 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, PUBLISHING_FLICKR_TYPE_FLICKR_PUBLISHER, PublishingFlickrFlickrPublisher);
#line 358 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	result = self->priv->running;
#line 358 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return result;
#line 3143 "FlickrPublishing.c"
}

static void
publishing_flickr_flickr_publisher_attempt_start (PublishingFlickrFlickrPublisher* self)
{
	SpitPublishingAuthenticator* _tmp0_;
#line 363 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_if_fail (PUBLISHING_FLICKR_IS_FLICKR_PUBLISHER (self));
#line 364 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->running = TRUE;
#line 365 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->was_started = TRUE;
#line 367 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp0_ = self->priv->authenticator;
#line 367 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	spit_publishing_authenticator_authenticate (_tmp0_);
#line 3160 "FlickrPublishing.c"
}

static void
publishing_flickr_flickr_publisher_real_start (SpitPublishingPublisher* base)
{
	PublishingFlickrFlickrPublisher * self;
#line 370 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, PUBLISHING_FLICKR_TYPE_FLICKR_PUBLISHER, PublishingFlickrFlickrPublisher);
#line 371 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (spit_publishing_publisher_is_running (G_TYPE_CHECK_INSTANCE_CAST (self, SPIT_PUBLISHING_TYPE_PUBLISHER, SpitPublishingPublisher))) {
#line 372 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		return;
#line 3173 "FlickrPublishing.c"
	}
#line 374 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (self->priv->was_started) {
#line 375 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_error ("FlickrPublishing.vala:375: FlickrPublisher: start( ): can't start; thi" \
"s publisher is not restartable.");
#line 3179 "FlickrPublishing.c"
	}
#line 377 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_debug ("FlickrPublishing.vala:377: FlickrPublisher: starting interaction.");
#line 379 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	publishing_flickr_flickr_publisher_attempt_start (self);
#line 3185 "FlickrPublishing.c"
}

static void
publishing_flickr_flickr_publisher_real_stop (SpitPublishingPublisher* base)
{
	PublishingFlickrFlickrPublisher * self;
	PublishingRESTSupportOAuth1Session* _tmp0_;
#line 382 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, PUBLISHING_FLICKR_TYPE_FLICKR_PUBLISHER, PublishingFlickrFlickrPublisher);
#line 383 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_debug ("FlickrPublishing.vala:383: FlickrPublisher: stop( ) invoked.");
#line 385 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp0_ = self->priv->session;
#line 385 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (_tmp0_ != NULL) {
#line 3201 "FlickrPublishing.c"
		PublishingRESTSupportOAuth1Session* _tmp1_;
#line 386 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp1_ = self->priv->session;
#line 386 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		publishing_rest_support_session_stop_transactions (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, PUBLISHING_REST_SUPPORT_TYPE_SESSION, PublishingRESTSupportSession));
#line 3207 "FlickrPublishing.c"
	}
#line 388 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->running = FALSE;
#line 3211 "FlickrPublishing.c"
}

static void
publishing_flickr_flickr_publisher_class_init (PublishingFlickrFlickrPublisherClass * klass,
                                               gpointer klass_data)
{
#line 83 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	publishing_flickr_flickr_publisher_parent_class = g_type_class_peek_parent (klass);
#line 83 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_type_class_adjust_private_offset (klass, &PublishingFlickrFlickrPublisher_private_offset);
#line 83 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	G_OBJECT_CLASS (klass)->finalize = publishing_flickr_flickr_publisher_finalize;
#line 3224 "FlickrPublishing.c"
}

static void
publishing_flickr_flickr_publisher_spit_publishing_publisher_interface_init (SpitPublishingPublisherIface * iface,
                                                                             gpointer iface_data)
{
#line 83 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	publishing_flickr_flickr_publisher_spit_publishing_publisher_parent_iface = g_type_interface_peek_parent (iface);
#line 83 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	iface->get_service = (SpitPublishingService* (*) (SpitPublishingPublisher*)) publishing_flickr_flickr_publisher_real_get_service;
#line 83 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	iface->is_running = (gboolean (*) (SpitPublishingPublisher*)) publishing_flickr_flickr_publisher_real_is_running;
#line 83 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	iface->start = (void (*) (SpitPublishingPublisher*)) publishing_flickr_flickr_publisher_real_start;
#line 83 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	iface->stop = (void (*) (SpitPublishingPublisher*)) publishing_flickr_flickr_publisher_real_stop;
#line 3241 "FlickrPublishing.c"
}

static void
publishing_flickr_flickr_publisher_instance_init (PublishingFlickrFlickrPublisher * self,
                                                  gpointer klass)
{
#line 83 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv = publishing_flickr_flickr_publisher_get_instance_private (self);
#line 86 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->progress_reporter = NULL;
#line 86 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->progress_reporter_target = NULL;
#line 86 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->progress_reporter_target_destroy_notify = NULL;
#line 87 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->running = FALSE;
#line 88 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->was_started = FALSE;
#line 89 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->session = NULL;
#line 90 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->publishing_options_pane = NULL;
#line 91 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->authenticator = NULL;
#line 93 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->parameters = NULL;
#line 3268 "FlickrPublishing.c"
}

static void
publishing_flickr_flickr_publisher_finalize (GObject * obj)
{
	PublishingFlickrFlickrPublisher * self;
	SpitPublishingAuthenticator* _tmp0_;
	guint _tmp1_;
#line 83 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PUBLISHING_FLICKR_TYPE_FLICKR_PUBLISHER, PublishingFlickrFlickrPublisher);
#line 108 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp0_ = self->priv->authenticator;
#line 108 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_signal_parse_name ("authenticated", SPIT_PUBLISHING_TYPE_AUTHENTICATOR, &_tmp1_, NULL, FALSE);
#line 108 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _publishing_flickr_flickr_publisher_on_session_authenticated_spit_publishing_authenticator_authenticated, self);
#line 84 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_object_unref0 (self->priv->service);
#line 85 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_object_unref0 (self->priv->host);
#line 86 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	(self->priv->progress_reporter_target_destroy_notify == NULL) ? NULL : (self->priv->progress_reporter_target_destroy_notify (self->priv->progress_reporter_target), NULL);
#line 86 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->progress_reporter = NULL;
#line 86 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->progress_reporter_target = NULL;
#line 86 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->progress_reporter_target_destroy_notify = NULL;
#line 89 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_publishing_rest_support_session_unref0 (self->priv->session);
#line 90 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_object_unref0 (self->priv->publishing_options_pane);
#line 91 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_object_unref0 (self->priv->authenticator);
#line 93 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_publishing_flickr_publishing_parameters_unref0 (self->priv->parameters);
#line 83 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	G_OBJECT_CLASS (publishing_flickr_flickr_publisher_parent_class)->finalize (obj);
#line 3307 "FlickrPublishing.c"
}

static GType
publishing_flickr_flickr_publisher_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PublishingFlickrFlickrPublisherClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) publishing_flickr_flickr_publisher_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PublishingFlickrFlickrPublisher), 0, (GInstanceInitFunc) publishing_flickr_flickr_publisher_instance_init, NULL };
	static const GInterfaceInfo spit_publishing_publisher_info = { (GInterfaceInitFunc) publishing_flickr_flickr_publisher_spit_publishing_publisher_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType publishing_flickr_flickr_publisher_type_id;
	publishing_flickr_flickr_publisher_type_id = g_type_register_static (G_TYPE_OBJECT, "PublishingFlickrFlickrPublisher", &g_define_type_info, 0);
	g_type_add_interface_static (publishing_flickr_flickr_publisher_type_id, SPIT_PUBLISHING_TYPE_PUBLISHER, &spit_publishing_publisher_info);
	PublishingFlickrFlickrPublisher_private_offset = g_type_add_instance_private (publishing_flickr_flickr_publisher_type_id, sizeof (PublishingFlickrFlickrPublisherPrivate));
	return publishing_flickr_flickr_publisher_type_id;
}

GType
publishing_flickr_flickr_publisher_get_type (void)
{
	static volatile gsize publishing_flickr_flickr_publisher_type_id__once = 0;
	if (g_once_init_enter (&publishing_flickr_flickr_publisher_type_id__once)) {
		GType publishing_flickr_flickr_publisher_type_id;
		publishing_flickr_flickr_publisher_type_id = publishing_flickr_flickr_publisher_get_type_once ();
		g_once_init_leave (&publishing_flickr_flickr_publisher_type_id__once, publishing_flickr_flickr_publisher_type_id);
	}
	return publishing_flickr_flickr_publisher_type_id__once;
}

gchar*
publishing_flickr_transaction_validate_xml (PublishingRESTSupportXmlDocument* doc)
{
	xmlNode* root = NULL;
	xmlNode* _tmp0_;
	gchar* status = NULL;
	xmlNode* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp5_;
	xmlNode* errcode = NULL;
	xmlNode* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	xmlNode* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 393 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (doc, PUBLISHING_REST_SUPPORT_TYPE_XML_DOCUMENT), NULL);
#line 394 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp0_ = publishing_rest_support_xml_document_get_root_node (doc);
#line 394 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	root = _tmp0_;
#line 395 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp1_ = root;
#line 395 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp2_ = (gchar*) xmlGetProp (_tmp1_, (xmlChar*) "stat");
#line 395 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	status = _tmp2_;
#line 398 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp3_ = status;
#line 398 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (_tmp3_ == NULL) {
#line 3371 "FlickrPublishing.c"
		gchar* _tmp4_;
#line 399 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp4_ = g_strdup ("No status property in root node");
#line 399 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		result = _tmp4_;
#line 399 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_g_free0 (status);
#line 399 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		return result;
#line 3381 "FlickrPublishing.c"
	}
#line 401 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp5_ = status;
#line 401 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (g_strcmp0 (_tmp5_, "ok") == 0) {
#line 402 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		result = NULL;
#line 402 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_g_free0 (status);
#line 402 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		return result;
#line 3393 "FlickrPublishing.c"
	}
	{
		xmlNode* _tmp6_ = NULL;
		xmlNode* _tmp7_;
		xmlNode* _tmp8_;
#line 406 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp7_ = root;
#line 406 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp8_ = publishing_rest_support_xml_document_get_named_child (doc, _tmp7_, "err", &_inner_error0_);
#line 406 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp6_ = _tmp8_;
#line 406 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 406 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			if (_inner_error0_->domain == SPIT_PUBLISHING_PUBLISHING_ERROR) {
#line 3409 "FlickrPublishing.c"
				goto __catch0_spit_publishing_publishing_error;
			}
#line 406 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_g_free0 (status);
#line 406 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 406 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			g_clear_error (&_inner_error0_);
#line 406 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			return NULL;
#line 3420 "FlickrPublishing.c"
		}
#line 406 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		errcode = _tmp6_;
#line 3424 "FlickrPublishing.c"
	}
	goto __finally0;
	__catch0_spit_publishing_publishing_error:
	{
		gchar* _tmp9_;
#line 405 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_clear_error (&_inner_error0_);
#line 408 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp9_ = g_strdup ("No error code specified");
#line 408 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		result = _tmp9_;
#line 408 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_g_free0 (status);
#line 408 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		return result;
#line 3440 "FlickrPublishing.c"
	}
	__finally0:
#line 405 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 405 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_g_free0 (status);
#line 405 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 405 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_clear_error (&_inner_error0_);
#line 405 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		return NULL;
#line 3453 "FlickrPublishing.c"
	}
#line 414 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp10_ = errcode;
#line 414 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp11_ = (gchar*) xmlGetProp (_tmp10_, (xmlChar*) "msg");
#line 414 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp12_ = _tmp11_;
#line 414 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp13_ = errcode;
#line 414 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp14_ = (gchar*) xmlGetProp (_tmp13_, (xmlChar*) "code");
#line 414 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp15_ = _tmp14_;
#line 414 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp16_ = g_strdup_printf ("%s (error code %s)", _tmp12_, _tmp15_);
#line 414 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp17_ = _tmp16_;
#line 414 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_free0 (_tmp15_);
#line 414 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_free0 (_tmp12_);
#line 414 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	result = _tmp17_;
#line 414 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_free0 (status);
#line 414 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return result;
#line 3481 "FlickrPublishing.c"
}

static gchar*
_publishing_flickr_transaction_validate_xml_publishing_rest_support_xml_document_check_for_error_response (PublishingRESTSupportXmlDocument* doc,
                                                                                                           gpointer self)
{
	gchar* result;
	result = publishing_flickr_transaction_validate_xml (doc);
#line 429 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return result;
#line 3492 "FlickrPublishing.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1541 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1541 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1542 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1542 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1542 "glib-2.0.vapi"
	return result;
#line 3511 "FlickrPublishing.c"
}

static gpointer
_g_error_copy0 (gpointer self)
{
#line 434 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return self ? g_error_copy (self) : NULL;
#line 3519 "FlickrPublishing.c"
}

PublishingRESTSupportXmlDocument*
publishing_flickr_transaction_parse_flickr_response (const gchar* xml,
                                                     GError** error)
{
	PublishingRESTSupportXmlDocument* _result_ = NULL;
	GError* _inner_error0_ = NULL;
	PublishingRESTSupportXmlDocument* result;
#line 424 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_val_if_fail (xml != NULL, NULL);
#line 426 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_result_ = NULL;
#line 3533 "FlickrPublishing.c"
	{
		PublishingRESTSupportXmlDocument* _tmp0_ = NULL;
		PublishingRESTSupportXmlDocument* _tmp1_;
		PublishingRESTSupportXmlDocument* _tmp2_;
#line 429 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp1_ = publishing_rest_support_xml_document_parse_string (xml, _publishing_flickr_transaction_validate_xml_publishing_rest_support_xml_document_check_for_error_response, NULL, &_inner_error0_);
#line 429 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp0_ = _tmp1_;
#line 429 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 429 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			if (_inner_error0_->domain == SPIT_PUBLISHING_PUBLISHING_ERROR) {
#line 3546 "FlickrPublishing.c"
				goto __catch0_spit_publishing_publishing_error;
			}
#line 429 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_publishing_rest_support_xml_document_unref0 (_result_);
#line 429 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 429 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			g_clear_error (&_inner_error0_);
#line 429 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			return NULL;
#line 3557 "FlickrPublishing.c"
		}
#line 429 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp2_ = _tmp0_;
#line 429 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp0_ = NULL;
#line 429 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_publishing_rest_support_xml_document_unref0 (_result_);
#line 429 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_result_ = _tmp2_;
#line 428 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_publishing_rest_support_xml_document_unref0 (_tmp0_);
#line 3569 "FlickrPublishing.c"
	}
	goto __finally0;
	__catch0_spit_publishing_publishing_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gboolean _tmp7_;
#line 428 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		e = _inner_error0_;
#line 428 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_inner_error0_ = NULL;
#line 431 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp3_ = e;
#line 431 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp4_ = _tmp3_->message;
#line 431 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp5_ = g_strdup_printf ("(error code %s)", PUBLISHING_FLICKR_EXPIRED_SESSION_ERROR_CODE);
#line 431 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp6_ = _tmp5_;
#line 431 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp7_ = string_contains (_tmp4_, _tmp6_);
#line 431 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_g_free0 (_tmp6_);
#line 431 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		if (_tmp7_) {
#line 3598 "FlickrPublishing.c"
			GError* _tmp8_;
			const gchar* _tmp9_;
			GError* _tmp10_;
#line 432 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_tmp8_ = e;
#line 432 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_tmp9_ = _tmp8_->message;
#line 432 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_tmp10_ = g_error_new_literal (SPIT_PUBLISHING_PUBLISHING_ERROR, SPIT_PUBLISHING_PUBLISHING_ERROR_EXPIRED_SESSION, _tmp9_);
#line 432 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_inner_error0_ = _tmp10_;
#line 432 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_g_error_free0 (e);
#line 3612 "FlickrPublishing.c"
			goto __finally0;
		} else {
			GError* _tmp11_;
			GError* _tmp12_;
#line 434 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_tmp11_ = e;
#line 434 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_tmp12_ = _g_error_copy0 (_tmp11_);
#line 434 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_inner_error0_ = _tmp12_;
#line 434 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_g_error_free0 (e);
#line 3625 "FlickrPublishing.c"
			goto __finally0;
		}
#line 428 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_g_error_free0 (e);
#line 3630 "FlickrPublishing.c"
	}
	__finally0:
#line 428 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 428 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		if (_inner_error0_->domain == SPIT_PUBLISHING_PUBLISHING_ERROR) {
#line 428 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			g_propagate_error (error, _inner_error0_);
#line 428 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_publishing_rest_support_xml_document_unref0 (_result_);
#line 428 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			return NULL;
#line 3643 "FlickrPublishing.c"
		} else {
#line 428 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_publishing_rest_support_xml_document_unref0 (_result_);
#line 428 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 428 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			g_clear_error (&_inner_error0_);
#line 428 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			return NULL;
#line 3653 "FlickrPublishing.c"
		}
	}
#line 438 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	result = _result_;
#line 438 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return result;
#line 3660 "FlickrPublishing.c"
}

PublishingFlickrAccountInfoFetchTransaction*
publishing_flickr_account_info_fetch_transaction_construct (GType object_type,
                                                            PublishingRESTSupportOAuth1Session* session)
{
	PublishingFlickrAccountInfoFetchTransaction* self = NULL;
#line 443 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (session, PUBLISHING_REST_SUPPORT_OAUTH1_TYPE_SESSION), NULL);
#line 444 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self = (PublishingFlickrAccountInfoFetchTransaction*) publishing_rest_support_oauth1_transaction_construct (object_type, session, PUBLISHING_REST_SUPPORT_HTTP_METHOD_GET);
#line 445 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	publishing_rest_support_transaction_add_argument (G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_REST_SUPPORT_TYPE_TRANSACTION, PublishingRESTSupportTransaction), "method", "flickr.people.getUploadStatus");
#line 443 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return self;
#line 3676 "FlickrPublishing.c"
}

PublishingFlickrAccountInfoFetchTransaction*
publishing_flickr_account_info_fetch_transaction_new (PublishingRESTSupportOAuth1Session* session)
{
#line 443 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return publishing_flickr_account_info_fetch_transaction_construct (PUBLISHING_FLICKR_TYPE_ACCOUNT_INFO_FETCH_TRANSACTION, session);
#line 3684 "FlickrPublishing.c"
}

static void
publishing_flickr_account_info_fetch_transaction_class_init (PublishingFlickrAccountInfoFetchTransactionClass * klass,
                                                             gpointer klass_data)
{
#line 442 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	publishing_flickr_account_info_fetch_transaction_parent_class = g_type_class_peek_parent (klass);
#line 3693 "FlickrPublishing.c"
}

static void
publishing_flickr_account_info_fetch_transaction_instance_init (PublishingFlickrAccountInfoFetchTransaction * self,
                                                                gpointer klass)
{
}

static GType
publishing_flickr_account_info_fetch_transaction_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PublishingFlickrAccountInfoFetchTransactionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) publishing_flickr_account_info_fetch_transaction_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PublishingFlickrAccountInfoFetchTransaction), 0, (GInstanceInitFunc) publishing_flickr_account_info_fetch_transaction_instance_init, NULL };
	GType publishing_flickr_account_info_fetch_transaction_type_id;
	publishing_flickr_account_info_fetch_transaction_type_id = g_type_register_static (PUBLISHING_REST_SUPPORT_OAUTH1_TYPE_TRANSACTION, "PublishingFlickrAccountInfoFetchTransaction", &g_define_type_info, 0);
	return publishing_flickr_account_info_fetch_transaction_type_id;
}

GType
publishing_flickr_account_info_fetch_transaction_get_type (void)
{
	static volatile gsize publishing_flickr_account_info_fetch_transaction_type_id__once = 0;
	if (g_once_init_enter (&publishing_flickr_account_info_fetch_transaction_type_id__once)) {
		GType publishing_flickr_account_info_fetch_transaction_type_id;
		publishing_flickr_account_info_fetch_transaction_type_id = publishing_flickr_account_info_fetch_transaction_get_type_once ();
		g_once_init_leave (&publishing_flickr_account_info_fetch_transaction_type_id__once, publishing_flickr_account_info_fetch_transaction_type_id);
	}
	return publishing_flickr_account_info_fetch_transaction_type_id__once;
}

static inline gpointer
publishing_flickr_upload_transaction_get_instance_private (PublishingFlickrUploadTransaction* self)
{
	return G_STRUCT_MEMBER_P (self, PublishingFlickrUploadTransaction_private_offset);
}

static gpointer
_publishing_flickr_publishing_parameters_ref0 (gpointer self)
{
#line 456 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return self ? publishing_flickr_publishing_parameters_ref (self) : NULL;
#line 3734 "FlickrPublishing.c"
}

static void
_g_free0_ (gpointer var)
{
#line 474 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	var = (g_free (var), NULL);
#line 3742 "FlickrPublishing.c"
}

PublishingFlickrUploadTransaction*
publishing_flickr_upload_transaction_construct (GType object_type,
                                                PublishingRESTSupportOAuth1Session* session,
                                                PublishingFlickrPublishingParameters* parameters,
                                                SpitPublishingPublishable* publishable)
{
	PublishingFlickrUploadTransaction* self = NULL;
	PublishingFlickrPublishingParameters* _tmp0_;
	PublishingFlickrVisibilitySpecification* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	PublishingFlickrVisibilitySpecification* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	PublishingFlickrVisibilitySpecification* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	GHashTable* disposition_table = NULL;
	GHashFunc _tmp20_;
	GEqualFunc _tmp21_;
	GHashTable* _tmp22_;
	gchar* filename = NULL;
	gchar* _tmp23_;
	gboolean _tmp24_ = FALSE;
	const gchar* _tmp25_;
	GHashTable* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	GHashTable* _tmp33_;
	gchar* _tmp34_;
	gchar* _tmp35_;
	GHashTable* _tmp36_;
#line 452 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (session, PUBLISHING_REST_SUPPORT_OAUTH1_TYPE_SESSION), NULL);
#line 452 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_val_if_fail (PUBLISHING_FLICKR_IS_PUBLISHING_PARAMETERS (parameters), NULL);
#line 452 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (publishable, SPIT_PUBLISHING_TYPE_PUBLISHABLE), NULL);
#line 454 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self = (PublishingFlickrUploadTransaction*) publishing_rest_support_oauth1_upload_transaction_construct (object_type, session, publishable, "https://up.flickr.com/services/upload");
#line 456 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp0_ = _publishing_flickr_publishing_parameters_ref0 (parameters);
#line 456 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_publishing_flickr_publishing_parameters_unref0 (self->priv->parameters);
#line 456 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->parameters = _tmp0_;
#line 458 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp1_ = parameters->visibility_specification;
#line 458 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp2_ = g_strdup_printf ("%d", _tmp1_->everyone_level);
#line 458 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp3_ = _tmp2_;
#line 458 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	publishing_rest_support_transaction_add_argument (G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_REST_SUPPORT_TYPE_TRANSACTION, PublishingRESTSupportTransaction), "is_public", _tmp3_);
#line 458 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_free0 (_tmp3_);
#line 459 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp4_ = parameters->visibility_specification;
#line 459 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp5_ = g_strdup_printf ("%d", _tmp4_->friends_level);
#line 459 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp6_ = _tmp5_;
#line 459 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	publishing_rest_support_transaction_add_argument (G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_REST_SUPPORT_TYPE_TRANSACTION, PublishingRESTSupportTransaction), "is_friend", _tmp6_);
#line 459 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_free0 (_tmp6_);
#line 460 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp7_ = parameters->visibility_specification;
#line 460 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp8_ = g_strdup_printf ("%d", _tmp7_->family_level);
#line 460 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp9_ = _tmp8_;
#line 460 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	publishing_rest_support_transaction_add_argument (G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_REST_SUPPORT_TYPE_TRANSACTION, PublishingRESTSupportTransaction), "is_family", _tmp9_);
#line 460 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_free0 (_tmp9_);
#line 462 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (!parameters->strip_metadata) {
#line 3825 "FlickrPublishing.c"
		gchar* title = NULL;
		gchar* _tmp10_;
		gboolean _tmp11_ = FALSE;
		const gchar* _tmp12_;
		gchar* comment = NULL;
		gchar* _tmp15_;
		gboolean _tmp16_ = FALSE;
		const gchar* _tmp17_;
#line 463 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp10_ = spit_publishing_publishable_get_param_string (publishable, SPIT_PUBLISHING_PUBLISHABLE_PARAM_STRING_TITLE);
#line 463 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		title = _tmp10_;
#line 464 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp12_ = title;
#line 464 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		if (_tmp12_ != NULL) {
#line 3842 "FlickrPublishing.c"
			const gchar* _tmp13_;
#line 464 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_tmp13_ = title;
#line 464 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_tmp11_ = g_strcmp0 (_tmp13_, "") != 0;
#line 3848 "FlickrPublishing.c"
		} else {
#line 464 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_tmp11_ = FALSE;
#line 3852 "FlickrPublishing.c"
		}
#line 464 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		if (_tmp11_) {
#line 3856 "FlickrPublishing.c"
			const gchar* _tmp14_;
#line 465 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_tmp14_ = title;
#line 465 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			publishing_rest_support_transaction_add_argument (G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_REST_SUPPORT_TYPE_TRANSACTION, PublishingRESTSupportTransaction), "title", _tmp14_);
#line 3862 "FlickrPublishing.c"
		}
#line 468 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp15_ = spit_publishing_publishable_get_param_string (publishable, SPIT_PUBLISHING_PUBLISHABLE_PARAM_STRING_COMMENT);
#line 468 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		comment = _tmp15_;
#line 469 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp17_ = comment;
#line 469 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		if (_tmp17_ != NULL) {
#line 3872 "FlickrPublishing.c"
			const gchar* _tmp18_;
#line 469 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_tmp18_ = comment;
#line 469 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_tmp16_ = g_strcmp0 (_tmp18_, "") != 0;
#line 3878 "FlickrPublishing.c"
		} else {
#line 469 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_tmp16_ = FALSE;
#line 3882 "FlickrPublishing.c"
		}
#line 469 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		if (_tmp16_) {
#line 3886 "FlickrPublishing.c"
			const gchar* _tmp19_;
#line 470 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_tmp19_ = comment;
#line 470 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			publishing_rest_support_transaction_add_argument (G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_REST_SUPPORT_TYPE_TRANSACTION, PublishingRESTSupportTransaction), "description", _tmp19_);
#line 3892 "FlickrPublishing.c"
		}
#line 462 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_g_free0 (comment);
#line 462 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_g_free0 (title);
#line 3898 "FlickrPublishing.c"
	}
#line 474 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp20_ = g_str_hash;
#line 474 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp21_ = g_str_equal;
#line 474 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp22_ = g_hash_table_new_full (_tmp20_, _tmp21_, _g_free0_, _g_free0_);
#line 474 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	disposition_table = _tmp22_;
#line 476 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp23_ = spit_publishing_publishable_get_publishing_name (publishable);
#line 476 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	filename = _tmp23_;
#line 477 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp25_ = filename;
#line 477 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (_tmp25_ == NULL) {
#line 477 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp24_ = TRUE;
#line 3918 "FlickrPublishing.c"
	} else {
		const gchar* _tmp26_;
#line 477 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp26_ = filename;
#line 477 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp24_ = g_strcmp0 (_tmp26_, "") == 0;
#line 3925 "FlickrPublishing.c"
	}
#line 477 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (_tmp24_) {
#line 3929 "FlickrPublishing.c"
		gchar* _tmp27_;
#line 478 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp27_ = spit_publishing_publishable_get_param_string (publishable, SPIT_PUBLISHING_PUBLISHABLE_PARAM_STRING_BASENAME);
#line 478 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_g_free0 (filename);
#line 478 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		filename = _tmp27_;
#line 3937 "FlickrPublishing.c"
	}
#line 482 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp28_ = disposition_table;
#line 482 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp29_ = g_strdup ("filename");
#line 482 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp30_ = spit_publishing_publishable_get_param_string (publishable, SPIT_PUBLISHING_PUBLISHABLE_PARAM_STRING_BASENAME);
#line 482 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp31_ = _tmp30_;
#line 482 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp32_ = g_uri_escape_string (_tmp31_, NULL, TRUE);
#line 482 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_hash_table_insert (_tmp28_, _tmp29_, _tmp32_);
#line 482 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_free0 (_tmp31_);
#line 485 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp33_ = disposition_table;
#line 485 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp34_ = g_strdup ("name");
#line 485 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp35_ = g_strdup ("photo");
#line 485 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_hash_table_insert (_tmp33_, _tmp34_, _tmp35_);
#line 487 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp36_ = disposition_table;
#line 487 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	publishing_rest_support_upload_transaction_set_binary_disposition_table (G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_REST_SUPPORT_TYPE_UPLOAD_TRANSACTION, PublishingRESTSupportUploadTransaction), _tmp36_);
#line 452 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_free0 (filename);
#line 452 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_hash_table_unref0 (disposition_table);
#line 452 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return self;
#line 3971 "FlickrPublishing.c"
}

PublishingFlickrUploadTransaction*
publishing_flickr_upload_transaction_new (PublishingRESTSupportOAuth1Session* session,
                                          PublishingFlickrPublishingParameters* parameters,
                                          SpitPublishingPublishable* publishable)
{
#line 452 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return publishing_flickr_upload_transaction_construct (PUBLISHING_FLICKR_TYPE_UPLOAD_TRANSACTION, session, parameters, publishable);
#line 3981 "FlickrPublishing.c"
}

static void
publishing_flickr_upload_transaction_real_execute_async_data_free (gpointer _data)
{
	PublishingFlickrUploadTransactionExecuteAsyncData* _data_;
	_data_ = _data;
#line 449 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_publishing_rest_support_transaction_unref0 (_data_->self);
#line 449 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_slice_free (PublishingFlickrUploadTransactionExecuteAsyncData, _data_);
#line 3993 "FlickrPublishing.c"
}

static gpointer
_publishing_rest_support_transaction_ref0 (gpointer self)
{
#line 449 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return self ? publishing_rest_support_transaction_ref (self) : NULL;
#line 4001 "FlickrPublishing.c"
}

static void
publishing_flickr_upload_transaction_real_execute_async (PublishingRESTSupportTransaction* base,
                                                         GAsyncReadyCallback _callback_,
                                                         gpointer _user_data_)
{
	PublishingFlickrUploadTransaction * self;
	PublishingFlickrUploadTransactionExecuteAsyncData* _data_;
	PublishingFlickrUploadTransaction* _tmp0_;
#line 449 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, PUBLISHING_FLICKR_TYPE_UPLOAD_TRANSACTION, PublishingFlickrUploadTransaction);
#line 449 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_ = g_slice_new0 (PublishingFlickrUploadTransactionExecuteAsyncData);
#line 449 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_->_async_result = g_task_new (NULL, NULL, _callback_, _user_data_);
#line 449 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_task_set_task_data (_data_->_async_result, _data_, publishing_flickr_upload_transaction_real_execute_async_data_free);
#line 449 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp0_ = _publishing_rest_support_transaction_ref0 (self);
#line 449 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_->self = _tmp0_;
#line 449 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	publishing_flickr_upload_transaction_real_execute_async_co (_data_);
#line 4026 "FlickrPublishing.c"
}

static void
publishing_flickr_upload_transaction_execute_finish (PublishingRESTSupportTransaction* base,
                                                     GAsyncResult* _res_,
                                                     GError** error)
{
	PublishingFlickrUploadTransactionExecuteAsyncData* _data_;
#line 449 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 449 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (NULL == _data_) {
#line 449 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		return;
#line 4041 "FlickrPublishing.c"
	}
}

static void
publishing_flickr_upload_transaction_execute_async_ready (GObject* source_object,
                                                          GAsyncResult* _res_,
                                                          gpointer _user_data_)
{
	PublishingFlickrUploadTransactionExecuteAsyncData* _data_;
#line 492 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_ = _user_data_;
#line 492 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_->_source_object_ = source_object;
#line 492 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_->_res_ = _res_;
#line 492 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	publishing_flickr_upload_transaction_real_execute_async_co (_data_);
#line 4059 "FlickrPublishing.c"
}

static gboolean
publishing_flickr_upload_transaction_real_execute_async_co (PublishingFlickrUploadTransactionExecuteAsyncData* _data_)
{
#line 490 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	switch (_data_->_state_) {
#line 490 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		case 0:
#line 4069 "FlickrPublishing.c"
		goto _state_0;
#line 490 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		case 1:
#line 4073 "FlickrPublishing.c"
		goto _state_1;
		default:
#line 490 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_assert_not_reached ();
#line 4078 "FlickrPublishing.c"
	}
	_state_0:
#line 491 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	publishing_rest_support_oauth1_upload_transaction_authorize (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, PUBLISHING_REST_SUPPORT_OAUTH1_TYPE_UPLOAD_TRANSACTION, PublishingRESTSupportOAuth1UploadTransaction));
#line 492 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_data_->_state_ = 1;
#line 492 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	PUBLISHING_REST_SUPPORT_TRANSACTION_CLASS (publishing_flickr_upload_transaction_parent_class)->execute_async (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, PUBLISHING_REST_SUPPORT_OAUTH1_TYPE_UPLOAD_TRANSACTION, PublishingRESTSupportOAuth1UploadTransaction), PUBLISHING_REST_SUPPORT_TYPE_TRANSACTION, PublishingRESTSupportTransaction), publishing_flickr_upload_transaction_execute_async_ready, _data_);
#line 492 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return FALSE;
#line 4089 "FlickrPublishing.c"
	_state_1:
#line 492 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	PUBLISHING_REST_SUPPORT_TRANSACTION_CLASS (publishing_flickr_upload_transaction_parent_class)->execute_finish (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, PUBLISHING_REST_SUPPORT_OAUTH1_TYPE_UPLOAD_TRANSACTION, PublishingRESTSupportOAuth1UploadTransaction), PUBLISHING_REST_SUPPORT_TYPE_TRANSACTION, PublishingRESTSupportTransaction), _data_->_res_, &_data_->_inner_error0_);
#line 492 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 492 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		if (_data_->_inner_error0_->domain == SPIT_PUBLISHING_PUBLISHING_ERROR) {
#line 492 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 492 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			g_object_unref (_data_->_async_result);
#line 492 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			return FALSE;
#line 4103 "FlickrPublishing.c"
		} else {
#line 492 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 492 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 492 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			g_object_unref (_data_->_async_result);
#line 492 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			return FALSE;
#line 4113 "FlickrPublishing.c"
		}
	}
#line 490 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 490 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (_data_->_state_ != 0) {
#line 490 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 490 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4124 "FlickrPublishing.c"
		}
	}
#line 490 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_object_unref (_data_->_async_result);
#line 490 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return FALSE;
#line 4131 "FlickrPublishing.c"
}

static void
publishing_flickr_upload_transaction_class_init (PublishingFlickrUploadTransactionClass * klass,
                                                 gpointer klass_data)
{
#line 449 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	publishing_flickr_upload_transaction_parent_class = g_type_class_peek_parent (klass);
#line 449 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	((PublishingRESTSupportTransactionClass *) klass)->finalize = publishing_flickr_upload_transaction_finalize;
#line 449 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_type_class_adjust_private_offset (klass, &PublishingFlickrUploadTransaction_private_offset);
#line 449 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	((PublishingRESTSupportTransactionClass *) klass)->execute_async = (void (*) (PublishingRESTSupportTransaction*, GAsyncReadyCallback, gpointer)) publishing_flickr_upload_transaction_real_execute_async;
#line 449 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	((PublishingRESTSupportTransactionClass *) klass)->execute_finish = (void (*) (PublishingRESTSupportTransaction*, GAsyncResult*, GError**)) publishing_flickr_upload_transaction_execute_finish;
#line 4148 "FlickrPublishing.c"
}

static void
publishing_flickr_upload_transaction_instance_init (PublishingFlickrUploadTransaction * self,
                                                    gpointer klass)
{
#line 449 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv = publishing_flickr_upload_transaction_get_instance_private (self);
#line 4157 "FlickrPublishing.c"
}

static void
publishing_flickr_upload_transaction_finalize (PublishingRESTSupportTransaction * obj)
{
	PublishingFlickrUploadTransaction * self;
#line 449 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PUBLISHING_FLICKR_TYPE_UPLOAD_TRANSACTION, PublishingFlickrUploadTransaction);
#line 450 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_publishing_flickr_publishing_parameters_unref0 (self->priv->parameters);
#line 449 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	PUBLISHING_REST_SUPPORT_TRANSACTION_CLASS (publishing_flickr_upload_transaction_parent_class)->finalize (obj);
#line 4170 "FlickrPublishing.c"
}

static GType
publishing_flickr_upload_transaction_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PublishingFlickrUploadTransactionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) publishing_flickr_upload_transaction_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PublishingFlickrUploadTransaction), 0, (GInstanceInitFunc) publishing_flickr_upload_transaction_instance_init, NULL };
	GType publishing_flickr_upload_transaction_type_id;
	publishing_flickr_upload_transaction_type_id = g_type_register_static (PUBLISHING_REST_SUPPORT_OAUTH1_TYPE_UPLOAD_TRANSACTION, "PublishingFlickrUploadTransaction", &g_define_type_info, 0);
	PublishingFlickrUploadTransaction_private_offset = g_type_add_instance_private (publishing_flickr_upload_transaction_type_id, sizeof (PublishingFlickrUploadTransactionPrivate));
	return publishing_flickr_upload_transaction_type_id;
}

GType
publishing_flickr_upload_transaction_get_type (void)
{
	static volatile gsize publishing_flickr_upload_transaction_type_id__once = 0;
	if (g_once_init_enter (&publishing_flickr_upload_transaction_type_id__once)) {
		GType publishing_flickr_upload_transaction_type_id;
		publishing_flickr_upload_transaction_type_id = publishing_flickr_upload_transaction_get_type_once ();
		g_once_init_leave (&publishing_flickr_upload_transaction_type_id__once, publishing_flickr_upload_transaction_type_id);
	}
	return publishing_flickr_upload_transaction_type_id__once;
}

static inline gpointer
publishing_flickr_publishing_options_pane_get_instance_private (PublishingFlickrPublishingOptionsPane* self)
{
	return G_STRUCT_MEMBER_P (self, PublishingFlickrPublishingOptionsPane_private_offset);
}

static void
_publishing_flickr_publishing_options_pane_on_visibility_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                                        gpointer self)
{
#line 584 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	publishing_flickr_publishing_options_pane_on_visibility_changed ((PublishingFlickrPublishingOptionsPane*) self);
#line 4207 "FlickrPublishing.c"
}

static void
_publishing_flickr_publishing_options_pane_on_size_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                                  gpointer self)
{
#line 588 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	publishing_flickr_publishing_options_pane_on_size_changed ((PublishingFlickrPublishingOptionsPane*) self);
#line 4216 "FlickrPublishing.c"
}

static void
_publishing_flickr_publishing_options_pane_on_logout_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                                 gpointer self)
{
#line 597 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	publishing_flickr_publishing_options_pane_on_logout_clicked ((PublishingFlickrPublishingOptionsPane*) self);
#line 4225 "FlickrPublishing.c"
}

static void
_publishing_flickr_publishing_options_pane_on_publish_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                                  gpointer self)
{
#line 598 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	publishing_flickr_publishing_options_pane_on_publish_clicked ((PublishingFlickrPublishingOptionsPane*) self);
#line 4234 "FlickrPublishing.c"
}

PublishingFlickrPublishingOptionsPane*
publishing_flickr_publishing_options_pane_construct (GType object_type,
                                                     PublishingFlickrFlickrPublisher* publisher,
                                                     PublishingFlickrPublishingParameters* parameters,
                                                     SpitPublishingPublisherMediaType media_type,
                                                     GtkBuilder* builder,
                                                     gboolean strip_metadata)
{
	PublishingFlickrPublishingOptionsPane * self = NULL;
	GtkBuilder* _tmp0_;
	GSList* _tmp1_;
	GSList* _tmp2_;
	GtkBuilder* _tmp3_;
	GObject* _tmp4_;
	GtkBox* _tmp5_;
	GtkBuilder* _tmp6_;
	GObject* _tmp7_;
	GtkLabel* _tmp8_;
	GtkBuilder* _tmp9_;
	GObject* _tmp10_;
	GtkLabel* _tmp11_;
	GtkBuilder* _tmp12_;
	GObject* _tmp13_;
	GtkButton* _tmp14_;
	GtkBuilder* _tmp15_;
	GObject* _tmp16_;
	GtkButton* _tmp17_;
	GtkBuilder* _tmp18_;
	GObject* _tmp19_;
	GtkComboBoxText* _tmp20_;
	GtkBuilder* _tmp21_;
	GObject* _tmp22_;
	GtkComboBoxText* _tmp23_;
	GtkBuilder* _tmp24_;
	GObject* _tmp25_;
	GtkLabel* _tmp26_;
	GtkBuilder* _tmp27_;
	GObject* _tmp28_;
	GtkCheckButton* _tmp29_;
	SpitPublishingAuthenticator* _tmp30_;
	SpitPublishingAuthenticator* _tmp31_;
	gboolean _tmp32_;
	PublishingFlickrPublishingParameters* _tmp37_;
	PublishingFlickrFlickrPublisher* _tmp38_;
	gint _tmp39_ = 0;
	PublishingFlickrPublishingOptionsPaneVisibilityEntry** _tmp40_;
	gint _tmp41_ = 0;
	PublishingFlickrPublishingOptionsPaneSizeEntry** _tmp42_;
	gchar* upload_label_text = NULL;
	const gchar* _tmp43_;
	gchar* _tmp44_;
	GtkLabel* _tmp53_;
	const gchar* _tmp54_;
	gchar* visibility_label_text = NULL;
	gchar* _tmp55_;
	GtkLabel* _tmp58_;
	const gchar* _tmp59_;
	GtkComboBoxText* _tmp60_;
	GtkCheckButton* _tmp64_;
	GtkButton* _tmp65_;
	GtkButton* _tmp66_;
#line 536 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_val_if_fail (PUBLISHING_FLICKR_IS_FLICKR_PUBLISHER (publisher), NULL);
#line 536 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_val_if_fail (PUBLISHING_FLICKR_IS_PUBLISHING_PARAMETERS (parameters), NULL);
#line 536 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (builder, gtk_builder_get_type ()), NULL);
#line 536 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self = (PublishingFlickrPublishingOptionsPane*) g_object_new (object_type, NULL);
#line 538 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp0_ = _g_object_ref0 (builder);
#line 538 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_object_unref0 (self->priv->builder);
#line 538 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->builder = _tmp0_;
#line 539 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_vala_assert (builder != NULL, "builder != null");
#line 540 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp1_ = gtk_builder_get_objects (builder);
#line 540 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp2_ = _tmp1_;
#line 540 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_vala_assert (g_slist_length (_tmp2_) > ((guint) 0), "builder.get_objects().length() > 0");
#line 540 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	(_tmp2_ == NULL) ? NULL : (_tmp2_ = (g_slist_free (_tmp2_), NULL));
#line 543 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp3_ = self->priv->builder;
#line 543 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp4_ = gtk_builder_get_object (_tmp3_, "flickr_pane");
#line 543 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_box_get_type (), GtkBox));
#line 543 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_object_unref0 (self->priv->pane_widget);
#line 543 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->pane_widget = _tmp5_;
#line 544 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp6_ = self->priv->builder;
#line 544 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp7_ = gtk_builder_get_object (_tmp6_, "visibility_label");
#line 544 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_label_get_type (), GtkLabel));
#line 544 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_object_unref0 (self->priv->visibility_label);
#line 544 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->visibility_label = _tmp8_;
#line 545 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp9_ = self->priv->builder;
#line 545 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp10_ = gtk_builder_get_object (_tmp9_, "upload_info_label");
#line 545 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp11_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, gtk_label_get_type (), GtkLabel));
#line 545 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_object_unref0 (self->priv->upload_info_label);
#line 545 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->upload_info_label = _tmp11_;
#line 546 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp12_ = self->priv->builder;
#line 546 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp13_ = gtk_builder_get_object (_tmp12_, "logout_button");
#line 546 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp14_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, gtk_button_get_type (), GtkButton));
#line 546 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_object_unref0 (self->priv->logout_button);
#line 546 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->logout_button = _tmp14_;
#line 547 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp15_ = self->priv->builder;
#line 547 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp16_ = gtk_builder_get_object (_tmp15_, "publish_button");
#line 547 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp17_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, gtk_button_get_type (), GtkButton));
#line 547 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_object_unref0 (self->priv->publish_button);
#line 547 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->publish_button = _tmp17_;
#line 548 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp18_ = self->priv->builder;
#line 548 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp19_ = gtk_builder_get_object (_tmp18_, "visibility_combo");
#line 548 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp20_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, gtk_combo_box_text_get_type (), GtkComboBoxText));
#line 548 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_object_unref0 (self->priv->visibility_combo);
#line 548 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->visibility_combo = _tmp20_;
#line 549 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp21_ = self->priv->builder;
#line 549 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp22_ = gtk_builder_get_object (_tmp21_, "size_combo");
#line 549 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp23_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, gtk_combo_box_text_get_type (), GtkComboBoxText));
#line 549 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_object_unref0 (self->priv->size_combo);
#line 549 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->size_combo = _tmp23_;
#line 550 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp24_ = self->priv->builder;
#line 550 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp25_ = gtk_builder_get_object (_tmp24_, "size_label");
#line 550 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp26_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, gtk_label_get_type (), GtkLabel));
#line 550 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_object_unref0 (self->priv->size_label);
#line 550 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->size_label = _tmp26_;
#line 551 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp27_ = self->priv->builder;
#line 551 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp28_ = gtk_builder_get_object (_tmp27_, "strip_metadata_check");
#line 551 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp29_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, gtk_check_button_get_type (), GtkCheckButton));
#line 551 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_object_unref0 (self->priv->strip_metadata_check);
#line 551 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->strip_metadata_check = _tmp29_;
#line 553 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp30_ = publishing_flickr_flickr_publisher_get_authenticator (publisher);
#line 553 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp31_ = _tmp30_;
#line 553 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp32_ = !spit_publishing_authenticator_can_logout (_tmp31_);
#line 553 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_object_unref0 (_tmp31_);
#line 553 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (_tmp32_) {
#line 4422 "FlickrPublishing.c"
		GtkButton* _tmp33_;
		GtkContainer* _tmp34_;
		GtkContainer* _tmp35_;
		GtkButton* _tmp36_;
#line 554 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp33_ = self->priv->logout_button;
#line 554 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp34_ = gtk_widget_get_parent (G_TYPE_CHECK_INSTANCE_CAST (_tmp33_, gtk_widget_get_type (), GtkWidget));
#line 554 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp35_ = _tmp34_;
#line 554 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp36_ = self->priv->logout_button;
#line 554 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		gtk_container_remove (_tmp35_, G_TYPE_CHECK_INSTANCE_CAST (_tmp36_, gtk_widget_get_type (), GtkWidget));
#line 4437 "FlickrPublishing.c"
	}
#line 557 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp37_ = _publishing_flickr_publishing_parameters_ref0 (parameters);
#line 557 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_publishing_flickr_publishing_parameters_unref0 (self->priv->parameters);
#line 557 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->parameters = _tmp37_;
#line 558 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp38_ = _g_object_ref0 (publisher);
#line 558 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_object_unref0 (self->priv->publisher);
#line 558 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->publisher = _tmp38_;
#line 559 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->media_type = media_type;
#line 561 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp40_ = publishing_flickr_publishing_options_pane_create_visibilities (self, &_tmp39_);
#line 561 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->visibilities = (_vala_array_free (self->priv->visibilities, self->priv->visibilities_length1, (GDestroyNotify) publishing_flickr_publishing_options_pane_visibility_entry_unref), NULL);
#line 561 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->visibilities = _tmp40_;
#line 561 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->visibilities_length1 = _tmp39_;
#line 561 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->_visibilities_size_ = self->priv->visibilities_length1;
#line 562 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp42_ = publishing_flickr_publishing_options_pane_create_sizes (self, &_tmp41_);
#line 562 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->sizes = (_vala_array_free (self->priv->sizes, self->priv->sizes_length1, (GDestroyNotify) publishing_flickr_publishing_options_pane_size_entry_unref), NULL);
#line 562 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->sizes = _tmp42_;
#line 562 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->sizes_length1 = _tmp41_;
#line 562 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->_sizes_size_ = self->priv->sizes_length1;
#line 564 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp43_ = parameters->username;
#line 564 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp44_ = g_strdup_printf (_ ("You are logged into Flickr as %s.\n\n"), _tmp43_);
#line 564 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	upload_label_text = _tmp44_;
#line 565 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (parameters->user_kind == PUBLISHING_FLICKR_USER_KIND_FREE) {
#line 4481 "FlickrPublishing.c"
		const gchar* _tmp45_;
		gchar* _tmp46_;
		gchar* _tmp47_;
		gchar* _tmp48_;
#line 566 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp45_ = upload_label_text;
#line 566 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp46_ = g_strdup_printf (_ ("Your free Flickr account limits how many photos you can upload to the " \
"service.\n" \
"You have uploaded %llu out of your %lld file limit."), parameters->uploaded_images_count, parameters->max_images_count);
#line 566 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp47_ = _tmp46_;
#line 566 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp48_ = g_strconcat (_tmp45_, _tmp47_, NULL);
#line 566 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_g_free0 (upload_label_text);
#line 566 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		upload_label_text = _tmp48_;
#line 566 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_g_free0 (_tmp47_);
#line 4500 "FlickrPublishing.c"
	} else {
		const gchar* _tmp49_;
		gchar* _tmp50_;
		gchar* _tmp51_;
		gchar* _tmp52_;
#line 568 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp49_ = upload_label_text;
#line 568 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp50_ = g_strdup_printf (ngettext ("Your Flickr Pro account entitles you to unlimited uploads. You have cu" \
"rrently uploaded a file", "Your Flickr Pro account entitles you to unlimited uploads. You have cu" \
"rrently uploaded %d files", (gulong) ((gint) parameters->uploaded_images_count)), (gint) parameters->uploaded_images_count);
#line 568 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp51_ = _tmp50_;
#line 568 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp52_ = g_strconcat (_tmp49_, _tmp51_, NULL);
#line 568 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_g_free0 (upload_label_text);
#line 568 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		upload_label_text = _tmp52_;
#line 568 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_g_free0 (_tmp51_);
#line 4520 "FlickrPublishing.c"
	}
#line 571 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp53_ = self->priv->upload_info_label;
#line 571 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp54_ = upload_label_text;
#line 571 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	gtk_label_set_label (_tmp53_, _tmp54_);
#line 573 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp55_ = g_strdup (_ ("Photos _visible to"));
#line 573 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	visibility_label_text = _tmp55_;
#line 574 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (media_type == SPIT_PUBLISHING_PUBLISHER_MEDIA_TYPE_VIDEO) {
#line 4534 "FlickrPublishing.c"
		gchar* _tmp56_;
#line 575 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp56_ = g_strdup (_ ("Videos _visible to"));
#line 575 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_g_free0 (visibility_label_text);
#line 575 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		visibility_label_text = _tmp56_;
#line 4542 "FlickrPublishing.c"
	} else {
#line 576 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		if (media_type == (SPIT_PUBLISHING_PUBLISHER_MEDIA_TYPE_PHOTO | SPIT_PUBLISHING_PUBLISHER_MEDIA_TYPE_VIDEO)) {
#line 4546 "FlickrPublishing.c"
			gchar* _tmp57_;
#line 578 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_tmp57_ = g_strdup (_ ("Photos and videos _visible to"));
#line 578 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_g_free0 (visibility_label_text);
#line 578 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			visibility_label_text = _tmp57_;
#line 4554 "FlickrPublishing.c"
		}
	}
#line 581 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp58_ = self->priv->visibility_label;
#line 581 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp59_ = visibility_label_text;
#line 581 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	gtk_label_set_label (_tmp58_, _tmp59_);
#line 583 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	publishing_flickr_publishing_options_pane_populate_visibility_combo (self);
#line 584 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp60_ = self->priv->visibility_combo;
#line 584 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp60_, gtk_combo_box_get_type (), GtkComboBox), "changed", (GCallback) _publishing_flickr_publishing_options_pane_on_visibility_changed_gtk_combo_box_changed, self, 0);
#line 586 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (media_type != SPIT_PUBLISHING_PUBLISHER_MEDIA_TYPE_VIDEO) {
#line 4571 "FlickrPublishing.c"
		GtkComboBoxText* _tmp61_;
#line 587 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		publishing_flickr_publishing_options_pane_populate_size_combo (self);
#line 588 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp61_ = self->priv->size_combo;
#line 588 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp61_, gtk_combo_box_get_type (), GtkComboBox), "changed", (GCallback) _publishing_flickr_publishing_options_pane_on_size_changed_gtk_combo_box_changed, self, 0);
#line 4579 "FlickrPublishing.c"
	} else {
		GtkComboBoxText* _tmp62_;
		GtkLabel* _tmp63_;
#line 591 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp62_ = self->priv->size_combo;
#line 591 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp62_, gtk_widget_get_type (), GtkWidget), FALSE);
#line 592 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp63_ = self->priv->size_label;
#line 592 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp63_, gtk_widget_get_type (), GtkWidget), FALSE);
#line 4591 "FlickrPublishing.c"
	}
#line 595 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp64_ = self->priv->strip_metadata_check;
#line 595 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	gtk_toggle_button_set_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp64_, gtk_toggle_button_get_type (), GtkToggleButton), strip_metadata);
#line 597 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp65_ = self->priv->logout_button;
#line 597 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_signal_connect_object (_tmp65_, "clicked", (GCallback) _publishing_flickr_publishing_options_pane_on_logout_clicked_gtk_button_clicked, self, 0);
#line 598 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp66_ = self->priv->publish_button;
#line 598 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_signal_connect_object (_tmp66_, "clicked", (GCallback) _publishing_flickr_publishing_options_pane_on_publish_clicked_gtk_button_clicked, self, 0);
#line 536 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_free0 (visibility_label_text);
#line 536 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_free0 (upload_label_text);
#line 536 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return self;
#line 4611 "FlickrPublishing.c"
}

PublishingFlickrPublishingOptionsPane*
publishing_flickr_publishing_options_pane_new (PublishingFlickrFlickrPublisher* publisher,
                                               PublishingFlickrPublishingParameters* parameters,
                                               SpitPublishingPublisherMediaType media_type,
                                               GtkBuilder* builder,
                                               gboolean strip_metadata)
{
#line 536 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return publishing_flickr_publishing_options_pane_construct (PUBLISHING_FLICKR_TYPE_PUBLISHING_OPTIONS_PANE, publisher, parameters, media_type, builder, strip_metadata);
#line 4623 "FlickrPublishing.c"
}

static void
publishing_flickr_publishing_options_pane_on_logout_clicked (PublishingFlickrPublishingOptionsPane* self)
{
#line 601 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_if_fail (PUBLISHING_FLICKR_IS_PUBLISHING_OPTIONS_PANE (self));
#line 602 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_signal_emit (self, publishing_flickr_publishing_options_pane_signals[PUBLISHING_FLICKR_PUBLISHING_OPTIONS_PANE_LOGOUT_SIGNAL], 0);
#line 4633 "FlickrPublishing.c"
}

static gpointer
_publishing_flickr_visibility_specification_ref0 (gpointer self)
{
#line 607 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return self ? publishing_flickr_visibility_specification_ref (self) : NULL;
#line 4641 "FlickrPublishing.c"
}

static void
publishing_flickr_publishing_options_pane_on_publish_clicked (PublishingFlickrPublishingOptionsPane* self)
{
	PublishingFlickrPublishingParameters* _tmp0_;
	GtkCheckButton* _tmp1_;
	PublishingFlickrPublishingParameters* _tmp2_;
	PublishingFlickrPublishingOptionsPaneVisibilityEntry** _tmp3_;
	gint _tmp3__length1;
	GtkComboBoxText* _tmp4_;
	PublishingFlickrPublishingOptionsPaneVisibilityEntry* _tmp5_;
	PublishingFlickrVisibilitySpecification* _tmp6_;
	PublishingFlickrVisibilitySpecification* _tmp7_;
	GtkCheckButton* _tmp12_;
#line 605 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_if_fail (PUBLISHING_FLICKR_IS_PUBLISHING_OPTIONS_PANE (self));
#line 606 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp0_ = self->priv->parameters;
#line 606 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp1_ = self->priv->strip_metadata_check;
#line 606 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp0_->strip_metadata = gtk_toggle_button_get_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_toggle_button_get_type (), GtkToggleButton));
#line 607 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp2_ = self->priv->parameters;
#line 607 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp3_ = self->priv->visibilities;
#line 607 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp3__length1 = self->priv->visibilities_length1;
#line 607 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp4_ = self->priv->visibility_combo;
#line 607 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp5_ = _tmp3_[gtk_combo_box_get_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_combo_box_get_type (), GtkComboBox))];
#line 607 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp6_ = _tmp5_->specification;
#line 607 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp7_ = _publishing_flickr_visibility_specification_ref0 (_tmp6_);
#line 607 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_publishing_flickr_visibility_specification_unref0 (_tmp2_->visibility_specification);
#line 607 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp2_->visibility_specification = _tmp7_;
#line 610 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if ((self->priv->media_type & SPIT_PUBLISHING_PUBLISHER_MEDIA_TYPE_PHOTO) != 0) {
#line 4685 "FlickrPublishing.c"
		PublishingFlickrPublishingParameters* _tmp8_;
		PublishingFlickrPublishingOptionsPaneSizeEntry** _tmp9_;
		gint _tmp9__length1;
		GtkComboBoxText* _tmp10_;
		PublishingFlickrPublishingOptionsPaneSizeEntry* _tmp11_;
#line 611 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp8_ = self->priv->parameters;
#line 611 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp9_ = self->priv->sizes;
#line 611 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp9__length1 = self->priv->sizes_length1;
#line 611 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp10_ = self->priv->size_combo;
#line 611 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp11_ = _tmp9_[gtk_combo_box_get_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, gtk_combo_box_get_type (), GtkComboBox))];
#line 611 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp8_->photo_major_axis_size = _tmp11_->size;
#line 4703 "FlickrPublishing.c"
	}
#line 613 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp12_ = self->priv->strip_metadata_check;
#line 613 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_signal_emit (self, publishing_flickr_publishing_options_pane_signals[PUBLISHING_FLICKR_PUBLISHING_OPTIONS_PANE_PUBLISH_SIGNAL], 0, gtk_toggle_button_get_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, gtk_toggle_button_get_type (), GtkToggleButton)));
#line 4709 "FlickrPublishing.c"
}

static void
_vala_array_add6 (PublishingFlickrPublishingOptionsPaneVisibilityEntry** * array,
                  gint* length,
                  gint* size,
                  PublishingFlickrPublishingOptionsPaneVisibilityEntry* value)
{
#line 619 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if ((*length) == (*size)) {
#line 619 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 619 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		*array = g_renew (PublishingFlickrPublishingOptionsPaneVisibilityEntry*, *array, (*size) + 1);
#line 4724 "FlickrPublishing.c"
	}
#line 619 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	(*array)[(*length)++] = value;
#line 619 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	(*array)[*length] = NULL;
#line 4730 "FlickrPublishing.c"
}

static void
_vala_array_add7 (PublishingFlickrPublishingOptionsPaneVisibilityEntry** * array,
                  gint* length,
                  gint* size,
                  PublishingFlickrPublishingOptionsPaneVisibilityEntry* value)
{
#line 620 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if ((*length) == (*size)) {
#line 620 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 620 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		*array = g_renew (PublishingFlickrPublishingOptionsPaneVisibilityEntry*, *array, (*size) + 1);
#line 4745 "FlickrPublishing.c"
	}
#line 620 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	(*array)[(*length)++] = value;
#line 620 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	(*array)[*length] = NULL;
#line 4751 "FlickrPublishing.c"
}

static void
_vala_array_add8 (PublishingFlickrPublishingOptionsPaneVisibilityEntry** * array,
                  gint* length,
                  gint* size,
                  PublishingFlickrPublishingOptionsPaneVisibilityEntry* value)
{
#line 621 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if ((*length) == (*size)) {
#line 621 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 621 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		*array = g_renew (PublishingFlickrPublishingOptionsPaneVisibilityEntry*, *array, (*size) + 1);
#line 4766 "FlickrPublishing.c"
	}
#line 621 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	(*array)[(*length)++] = value;
#line 621 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	(*array)[*length] = NULL;
#line 4772 "FlickrPublishing.c"
}

static void
_vala_array_add9 (PublishingFlickrPublishingOptionsPaneVisibilityEntry** * array,
                  gint* length,
                  gint* size,
                  PublishingFlickrPublishingOptionsPaneVisibilityEntry* value)
{
#line 622 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if ((*length) == (*size)) {
#line 622 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 622 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		*array = g_renew (PublishingFlickrPublishingOptionsPaneVisibilityEntry*, *array, (*size) + 1);
#line 4787 "FlickrPublishing.c"
	}
#line 622 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	(*array)[(*length)++] = value;
#line 622 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	(*array)[*length] = NULL;
#line 4793 "FlickrPublishing.c"
}

static void
_vala_array_add10 (PublishingFlickrPublishingOptionsPaneVisibilityEntry** * array,
                   gint* length,
                   gint* size,
                   PublishingFlickrPublishingOptionsPaneVisibilityEntry* value)
{
#line 623 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if ((*length) == (*size)) {
#line 623 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 623 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		*array = g_renew (PublishingFlickrPublishingOptionsPaneVisibilityEntry*, *array, (*size) + 1);
#line 4808 "FlickrPublishing.c"
	}
#line 623 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	(*array)[(*length)++] = value;
#line 623 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	(*array)[*length] = NULL;
#line 4814 "FlickrPublishing.c"
}

static PublishingFlickrPublishingOptionsPaneVisibilityEntry**
publishing_flickr_publishing_options_pane_create_visibilities (PublishingFlickrPublishingOptionsPane* self,
                                                               gint* result_length1)
{
	PublishingFlickrPublishingOptionsPaneVisibilityEntry** _result_ = NULL;
	PublishingFlickrPublishingOptionsPaneVisibilityEntry** _tmp0_;
	gint _result__length1;
	gint __result__size_;
	PublishingFlickrVisibilitySpecification* _tmp1_;
	PublishingFlickrVisibilitySpecification* _tmp2_;
	PublishingFlickrPublishingOptionsPaneVisibilityEntry* _tmp3_;
	PublishingFlickrVisibilitySpecification* _tmp4_;
	PublishingFlickrVisibilitySpecification* _tmp5_;
	PublishingFlickrPublishingOptionsPaneVisibilityEntry* _tmp6_;
	PublishingFlickrVisibilitySpecification* _tmp7_;
	PublishingFlickrVisibilitySpecification* _tmp8_;
	PublishingFlickrPublishingOptionsPaneVisibilityEntry* _tmp9_;
	PublishingFlickrVisibilitySpecification* _tmp10_;
	PublishingFlickrVisibilitySpecification* _tmp11_;
	PublishingFlickrPublishingOptionsPaneVisibilityEntry* _tmp12_;
	PublishingFlickrVisibilitySpecification* _tmp13_;
	PublishingFlickrVisibilitySpecification* _tmp14_;
	PublishingFlickrPublishingOptionsPaneVisibilityEntry* _tmp15_;
	PublishingFlickrPublishingOptionsPaneVisibilityEntry** _tmp16_;
	gint _tmp16__length1;
	PublishingFlickrPublishingOptionsPaneVisibilityEntry** result;
#line 616 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_val_if_fail (PUBLISHING_FLICKR_IS_PUBLISHING_OPTIONS_PANE (self), NULL);
#line 617 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp0_ = g_new0 (PublishingFlickrPublishingOptionsPaneVisibilityEntry*, 0 + 1);
#line 617 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_result_ = _tmp0_;
#line 617 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_result__length1 = 0;
#line 617 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	__result__size_ = _result__length1;
#line 619 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp1_ = publishing_flickr_visibility_specification_new (1, 1, 1);
#line 619 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp2_ = _tmp1_;
#line 619 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp3_ = publishing_flickr_publishing_options_pane_visibility_entry_new (_ ("Everyone"), _tmp2_);
#line 619 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_vala_array_add6 (&_result_, &_result__length1, &__result__size_, _tmp3_);
#line 619 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_publishing_flickr_visibility_specification_unref0 (_tmp2_);
#line 620 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp4_ = publishing_flickr_visibility_specification_new (1, 1, 0);
#line 620 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp5_ = _tmp4_;
#line 620 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp6_ = publishing_flickr_publishing_options_pane_visibility_entry_new (_ ("Friends & family only"), _tmp5_);
#line 620 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_vala_array_add7 (&_result_, &_result__length1, &__result__size_, _tmp6_);
#line 620 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_publishing_flickr_visibility_specification_unref0 (_tmp5_);
#line 621 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp7_ = publishing_flickr_visibility_specification_new (0, 1, 0);
#line 621 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp8_ = _tmp7_;
#line 621 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp9_ = publishing_flickr_publishing_options_pane_visibility_entry_new (_ ("Family only"), _tmp8_);
#line 621 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_vala_array_add8 (&_result_, &_result__length1, &__result__size_, _tmp9_);
#line 621 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_publishing_flickr_visibility_specification_unref0 (_tmp8_);
#line 622 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp10_ = publishing_flickr_visibility_specification_new (1, 0, 0);
#line 622 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp11_ = _tmp10_;
#line 622 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp12_ = publishing_flickr_publishing_options_pane_visibility_entry_new (_ ("Friends only"), _tmp11_);
#line 622 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_vala_array_add9 (&_result_, &_result__length1, &__result__size_, _tmp12_);
#line 622 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_publishing_flickr_visibility_specification_unref0 (_tmp11_);
#line 623 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp13_ = publishing_flickr_visibility_specification_new (0, 0, 0);
#line 623 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp14_ = _tmp13_;
#line 623 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp15_ = publishing_flickr_publishing_options_pane_visibility_entry_new (_ ("Just me"), _tmp14_);
#line 623 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_vala_array_add10 (&_result_, &_result__length1, &__result__size_, _tmp15_);
#line 623 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_publishing_flickr_visibility_specification_unref0 (_tmp14_);
#line 625 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp16_ = _result_;
#line 625 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp16__length1 = _result__length1;
#line 625 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (result_length1) {
#line 625 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		*result_length1 = _tmp16__length1;
#line 4911 "FlickrPublishing.c"
	}
#line 625 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	result = _tmp16_;
#line 625 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return result;
#line 4917 "FlickrPublishing.c"
}

static gpointer
_publishing_flickr_publishing_options_pane_visibility_entry_ref0 (gpointer self)
{
#line 632 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return self ? publishing_flickr_publishing_options_pane_visibility_entry_ref (self) : NULL;
#line 4925 "FlickrPublishing.c"
}

static void
publishing_flickr_publishing_options_pane_populate_visibility_combo (PublishingFlickrPublishingOptionsPane* self)
{
	PublishingFlickrPublishingOptionsPaneVisibilityEntry** _tmp0_;
	gint _tmp0__length1;
	PublishingFlickrPublishingOptionsPaneVisibilityEntry** _tmp3_;
	gint _tmp3__length1;
	GtkComboBoxText* _tmp8_;
	PublishingFlickrFlickrPublisher* _tmp9_;
#line 628 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_if_fail (PUBLISHING_FLICKR_IS_PUBLISHING_OPTIONS_PANE (self));
#line 629 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp0_ = self->priv->visibilities;
#line 629 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp0__length1 = self->priv->visibilities_length1;
#line 629 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (_tmp0_ == NULL) {
#line 4945 "FlickrPublishing.c"
		gint _tmp1_ = 0;
		PublishingFlickrPublishingOptionsPaneVisibilityEntry** _tmp2_;
#line 630 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp2_ = publishing_flickr_publishing_options_pane_create_visibilities (self, &_tmp1_);
#line 630 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		self->priv->visibilities = (_vala_array_free (self->priv->visibilities, self->priv->visibilities_length1, (GDestroyNotify) publishing_flickr_publishing_options_pane_visibility_entry_unref), NULL);
#line 630 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		self->priv->visibilities = _tmp2_;
#line 630 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		self->priv->visibilities_length1 = _tmp1_;
#line 630 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		self->priv->_visibilities_size_ = self->priv->visibilities_length1;
#line 4958 "FlickrPublishing.c"
	}
#line 632 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp3_ = self->priv->visibilities;
#line 632 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp3__length1 = self->priv->visibilities_length1;
#line 4964 "FlickrPublishing.c"
	{
		PublishingFlickrPublishingOptionsPaneVisibilityEntry** v_collection = NULL;
		gint v_collection_length1 = 0;
		gint _v_collection_size_ = 0;
		gint v_it = 0;
#line 632 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		v_collection = _tmp3_;
#line 632 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		v_collection_length1 = _tmp3__length1;
#line 632 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		for (v_it = 0; v_it < v_collection_length1; v_it = v_it + 1) {
#line 4976 "FlickrPublishing.c"
			PublishingFlickrPublishingOptionsPaneVisibilityEntry* _tmp4_;
			PublishingFlickrPublishingOptionsPaneVisibilityEntry* v = NULL;
#line 632 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_tmp4_ = _publishing_flickr_publishing_options_pane_visibility_entry_ref0 (v_collection[v_it]);
#line 632 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			v = _tmp4_;
#line 4983 "FlickrPublishing.c"
			{
				GtkComboBoxText* _tmp5_;
				PublishingFlickrPublishingOptionsPaneVisibilityEntry* _tmp6_;
				const gchar* _tmp7_;
#line 633 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				_tmp5_ = self->priv->visibility_combo;
#line 633 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				_tmp6_ = v;
#line 633 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				_tmp7_ = _tmp6_->title;
#line 633 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				gtk_combo_box_text_append_text (_tmp5_, _tmp7_);
#line 632 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				_publishing_flickr_publishing_options_pane_visibility_entry_unref0 (v);
#line 4998 "FlickrPublishing.c"
			}
		}
	}
#line 635 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp8_ = self->priv->visibility_combo;
#line 635 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp9_ = self->priv->publisher;
#line 635 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	gtk_combo_box_set_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_combo_box_get_type (), GtkComboBox), publishing_flickr_flickr_publisher_get_persistent_visibility (_tmp9_));
#line 5008 "FlickrPublishing.c"
}

static void
_vala_array_add11 (PublishingFlickrPublishingOptionsPaneSizeEntry** * array,
                   gint* length,
                   gint* size,
                   PublishingFlickrPublishingOptionsPaneSizeEntry* value)
{
#line 641 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if ((*length) == (*size)) {
#line 641 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 641 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		*array = g_renew (PublishingFlickrPublishingOptionsPaneSizeEntry*, *array, (*size) + 1);
#line 5023 "FlickrPublishing.c"
	}
#line 641 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	(*array)[(*length)++] = value;
#line 641 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	(*array)[*length] = NULL;
#line 5029 "FlickrPublishing.c"
}

static void
_vala_array_add12 (PublishingFlickrPublishingOptionsPaneSizeEntry** * array,
                   gint* length,
                   gint* size,
                   PublishingFlickrPublishingOptionsPaneSizeEntry* value)
{
#line 642 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if ((*length) == (*size)) {
#line 642 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 642 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		*array = g_renew (PublishingFlickrPublishingOptionsPaneSizeEntry*, *array, (*size) + 1);
#line 5044 "FlickrPublishing.c"
	}
#line 642 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	(*array)[(*length)++] = value;
#line 642 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	(*array)[*length] = NULL;
#line 5050 "FlickrPublishing.c"
}

static void
_vala_array_add13 (PublishingFlickrPublishingOptionsPaneSizeEntry** * array,
                   gint* length,
                   gint* size,
                   PublishingFlickrPublishingOptionsPaneSizeEntry* value)
{
#line 643 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if ((*length) == (*size)) {
#line 643 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 643 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		*array = g_renew (PublishingFlickrPublishingOptionsPaneSizeEntry*, *array, (*size) + 1);
#line 5065 "FlickrPublishing.c"
	}
#line 643 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	(*array)[(*length)++] = value;
#line 643 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	(*array)[*length] = NULL;
#line 5071 "FlickrPublishing.c"
}

static void
_vala_array_add14 (PublishingFlickrPublishingOptionsPaneSizeEntry** * array,
                   gint* length,
                   gint* size,
                   PublishingFlickrPublishingOptionsPaneSizeEntry* value)
{
#line 644 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if ((*length) == (*size)) {
#line 644 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 644 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		*array = g_renew (PublishingFlickrPublishingOptionsPaneSizeEntry*, *array, (*size) + 1);
#line 5086 "FlickrPublishing.c"
	}
#line 644 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	(*array)[(*length)++] = value;
#line 644 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	(*array)[*length] = NULL;
#line 5092 "FlickrPublishing.c"
}

static void
_vala_array_add15 (PublishingFlickrPublishingOptionsPaneSizeEntry** * array,
                   gint* length,
                   gint* size,
                   PublishingFlickrPublishingOptionsPaneSizeEntry* value)
{
#line 645 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if ((*length) == (*size)) {
#line 645 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 645 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		*array = g_renew (PublishingFlickrPublishingOptionsPaneSizeEntry*, *array, (*size) + 1);
#line 5107 "FlickrPublishing.c"
	}
#line 645 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	(*array)[(*length)++] = value;
#line 645 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	(*array)[*length] = NULL;
#line 5113 "FlickrPublishing.c"
}

static PublishingFlickrPublishingOptionsPaneSizeEntry**
publishing_flickr_publishing_options_pane_create_sizes (PublishingFlickrPublishingOptionsPane* self,
                                                        gint* result_length1)
{
	PublishingFlickrPublishingOptionsPaneSizeEntry** _result_ = NULL;
	PublishingFlickrPublishingOptionsPaneSizeEntry** _tmp0_;
	gint _result__length1;
	gint __result__size_;
	PublishingFlickrPublishingOptionsPaneSizeEntry* _tmp1_;
	PublishingFlickrPublishingOptionsPaneSizeEntry* _tmp2_;
	PublishingFlickrPublishingOptionsPaneSizeEntry* _tmp3_;
	PublishingFlickrPublishingOptionsPaneSizeEntry* _tmp4_;
	PublishingFlickrPublishingOptionsPaneSizeEntry* _tmp5_;
	PublishingFlickrPublishingOptionsPaneSizeEntry** _tmp6_;
	gint _tmp6__length1;
	PublishingFlickrPublishingOptionsPaneSizeEntry** result;
#line 638 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_val_if_fail (PUBLISHING_FLICKR_IS_PUBLISHING_OPTIONS_PANE (self), NULL);
#line 639 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp0_ = g_new0 (PublishingFlickrPublishingOptionsPaneSizeEntry*, 0 + 1);
#line 639 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_result_ = _tmp0_;
#line 639 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_result__length1 = 0;
#line 639 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	__result__size_ = _result__length1;
#line 641 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp1_ = publishing_flickr_publishing_options_pane_size_entry_new (_ ("500 × 375 pixels"), 500);
#line 641 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_vala_array_add11 (&_result_, &_result__length1, &__result__size_, _tmp1_);
#line 642 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp2_ = publishing_flickr_publishing_options_pane_size_entry_new (_ ("1024 × 768 pixels"), 1024);
#line 642 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_vala_array_add12 (&_result_, &_result__length1, &__result__size_, _tmp2_);
#line 643 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp3_ = publishing_flickr_publishing_options_pane_size_entry_new (_ ("2048 × 1536 pixels"), 2048);
#line 643 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_vala_array_add13 (&_result_, &_result__length1, &__result__size_, _tmp3_);
#line 644 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp4_ = publishing_flickr_publishing_options_pane_size_entry_new (_ ("4096 × 3072 pixels"), 4096);
#line 644 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_vala_array_add14 (&_result_, &_result__length1, &__result__size_, _tmp4_);
#line 645 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp5_ = publishing_flickr_publishing_options_pane_size_entry_new (_ ("Original size"), PUBLISHING_FLICKR_ORIGINAL_SIZE);
#line 645 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_vala_array_add15 (&_result_, &_result__length1, &__result__size_, _tmp5_);
#line 647 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp6_ = _result_;
#line 647 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp6__length1 = _result__length1;
#line 647 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (result_length1) {
#line 647 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		*result_length1 = _tmp6__length1;
#line 5170 "FlickrPublishing.c"
	}
#line 647 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	result = _tmp6_;
#line 647 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return result;
#line 5176 "FlickrPublishing.c"
}

static gpointer
_publishing_flickr_publishing_options_pane_size_entry_ref0 (gpointer self)
{
#line 654 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return self ? publishing_flickr_publishing_options_pane_size_entry_ref (self) : NULL;
#line 5184 "FlickrPublishing.c"
}

static void
publishing_flickr_publishing_options_pane_populate_size_combo (PublishingFlickrPublishingOptionsPane* self)
{
	PublishingFlickrPublishingOptionsPaneSizeEntry** _tmp0_;
	gint _tmp0__length1;
	PublishingFlickrPublishingOptionsPaneSizeEntry** _tmp3_;
	gint _tmp3__length1;
	GtkComboBoxText* _tmp8_;
	PublishingFlickrFlickrPublisher* _tmp9_;
#line 650 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_if_fail (PUBLISHING_FLICKR_IS_PUBLISHING_OPTIONS_PANE (self));
#line 651 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp0_ = self->priv->sizes;
#line 651 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp0__length1 = self->priv->sizes_length1;
#line 651 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (_tmp0_ == NULL) {
#line 5204 "FlickrPublishing.c"
		gint _tmp1_ = 0;
		PublishingFlickrPublishingOptionsPaneSizeEntry** _tmp2_;
#line 652 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp2_ = publishing_flickr_publishing_options_pane_create_sizes (self, &_tmp1_);
#line 652 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		self->priv->sizes = (_vala_array_free (self->priv->sizes, self->priv->sizes_length1, (GDestroyNotify) publishing_flickr_publishing_options_pane_size_entry_unref), NULL);
#line 652 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		self->priv->sizes = _tmp2_;
#line 652 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		self->priv->sizes_length1 = _tmp1_;
#line 652 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		self->priv->_sizes_size_ = self->priv->sizes_length1;
#line 5217 "FlickrPublishing.c"
	}
#line 654 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp3_ = self->priv->sizes;
#line 654 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp3__length1 = self->priv->sizes_length1;
#line 5223 "FlickrPublishing.c"
	{
		PublishingFlickrPublishingOptionsPaneSizeEntry** e_collection = NULL;
		gint e_collection_length1 = 0;
		gint _e_collection_size_ = 0;
		gint e_it = 0;
#line 654 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		e_collection = _tmp3_;
#line 654 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		e_collection_length1 = _tmp3__length1;
#line 654 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		for (e_it = 0; e_it < e_collection_length1; e_it = e_it + 1) {
#line 5235 "FlickrPublishing.c"
			PublishingFlickrPublishingOptionsPaneSizeEntry* _tmp4_;
			PublishingFlickrPublishingOptionsPaneSizeEntry* e = NULL;
#line 654 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_tmp4_ = _publishing_flickr_publishing_options_pane_size_entry_ref0 (e_collection[e_it]);
#line 654 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			e = _tmp4_;
#line 5242 "FlickrPublishing.c"
			{
				GtkComboBoxText* _tmp5_;
				PublishingFlickrPublishingOptionsPaneSizeEntry* _tmp6_;
				const gchar* _tmp7_;
#line 655 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				_tmp5_ = self->priv->size_combo;
#line 655 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				_tmp6_ = e;
#line 655 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				_tmp7_ = _tmp6_->title;
#line 655 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				gtk_combo_box_text_append_text (_tmp5_, _tmp7_);
#line 654 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				_publishing_flickr_publishing_options_pane_size_entry_unref0 (e);
#line 5257 "FlickrPublishing.c"
			}
		}
	}
#line 657 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp8_ = self->priv->size_combo;
#line 657 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp9_ = self->priv->publisher;
#line 657 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	gtk_combo_box_set_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_combo_box_get_type (), GtkComboBox), publishing_flickr_flickr_publisher_get_persistent_default_size (_tmp9_));
#line 5267 "FlickrPublishing.c"
}

static void
publishing_flickr_publishing_options_pane_on_size_changed (PublishingFlickrPublishingOptionsPane* self)
{
	PublishingFlickrFlickrPublisher* _tmp0_;
	GtkComboBoxText* _tmp1_;
#line 660 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_if_fail (PUBLISHING_FLICKR_IS_PUBLISHING_OPTIONS_PANE (self));
#line 661 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp0_ = self->priv->publisher;
#line 661 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp1_ = self->priv->size_combo;
#line 661 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	publishing_flickr_flickr_publisher_set_persistent_default_size (_tmp0_, gtk_combo_box_get_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_combo_box_get_type (), GtkComboBox)));
#line 5283 "FlickrPublishing.c"
}

static void
publishing_flickr_publishing_options_pane_on_visibility_changed (PublishingFlickrPublishingOptionsPane* self)
{
	PublishingFlickrFlickrPublisher* _tmp0_;
	GtkComboBoxText* _tmp1_;
#line 664 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_if_fail (PUBLISHING_FLICKR_IS_PUBLISHING_OPTIONS_PANE (self));
#line 665 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp0_ = self->priv->publisher;
#line 665 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp1_ = self->priv->visibility_combo;
#line 665 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	publishing_flickr_flickr_publisher_set_persistent_visibility (_tmp0_, gtk_combo_box_get_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_combo_box_get_type (), GtkComboBox)));
#line 5299 "FlickrPublishing.c"
}

void
publishing_flickr_publishing_options_pane_notify_publish (PublishingFlickrPublishingOptionsPane* self)
{
	GtkCheckButton* _tmp0_;
#line 668 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_if_fail (PUBLISHING_FLICKR_IS_PUBLISHING_OPTIONS_PANE (self));
#line 669 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp0_ = self->priv->strip_metadata_check;
#line 669 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_signal_emit (self, publishing_flickr_publishing_options_pane_signals[PUBLISHING_FLICKR_PUBLISHING_OPTIONS_PANE_PUBLISH_SIGNAL], 0, gtk_toggle_button_get_active (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_toggle_button_get_type (), GtkToggleButton)));
#line 5312 "FlickrPublishing.c"
}

void
publishing_flickr_publishing_options_pane_notify_logout (PublishingFlickrPublishingOptionsPane* self)
{
#line 672 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_if_fail (PUBLISHING_FLICKR_IS_PUBLISHING_OPTIONS_PANE (self));
#line 673 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_signal_emit (self, publishing_flickr_publishing_options_pane_signals[PUBLISHING_FLICKR_PUBLISHING_OPTIONS_PANE_LOGOUT_SIGNAL], 0);
#line 5322 "FlickrPublishing.c"
}

static GtkWidget*
publishing_flickr_publishing_options_pane_real_get_widget (SpitPublishingDialogPane* base)
{
	PublishingFlickrPublishingOptionsPane * self;
	GtkBox* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* result;
#line 676 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, PUBLISHING_FLICKR_TYPE_PUBLISHING_OPTIONS_PANE, PublishingFlickrPublishingOptionsPane);
#line 677 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp0_ = self->priv->pane_widget;
#line 677 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget));
#line 677 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	result = _tmp1_;
#line 677 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return result;
#line 5342 "FlickrPublishing.c"
}

static SpitPublishingDialogPaneGeometryOptions
publishing_flickr_publishing_options_pane_real_get_preferred_geometry (SpitPublishingDialogPane* base)
{
	PublishingFlickrPublishingOptionsPane * self;
	SpitPublishingDialogPaneGeometryOptions result;
#line 680 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, PUBLISHING_FLICKR_TYPE_PUBLISHING_OPTIONS_PANE, PublishingFlickrPublishingOptionsPane);
#line 681 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	result = SPIT_PUBLISHING_DIALOG_PANE_GEOMETRY_OPTIONS_NONE;
#line 681 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return result;
#line 5356 "FlickrPublishing.c"
}

static void
_publishing_flickr_publishing_options_pane_notify_publish_publishing_flickr_publishing_options_pane_publish (PublishingFlickrPublishingOptionsPane* _sender,
                                                                                                             gboolean strip_metadata,
                                                                                                             gpointer self)
{
#line 685 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	publishing_flickr_publishing_options_pane_notify_publish ((PublishingFlickrPublishingOptionsPane*) self);
#line 5366 "FlickrPublishing.c"
}

static void
_publishing_flickr_publishing_options_pane_notify_logout_publishing_flickr_publishing_options_pane_logout (PublishingFlickrPublishingOptionsPane* _sender,
                                                                                                           gpointer self)
{
#line 686 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	publishing_flickr_publishing_options_pane_notify_logout ((PublishingFlickrPublishingOptionsPane*) self);
#line 5375 "FlickrPublishing.c"
}

static void
publishing_flickr_publishing_options_pane_real_on_pane_installed (SpitPublishingDialogPane* base)
{
	PublishingFlickrPublishingOptionsPane * self;
#line 684 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, PUBLISHING_FLICKR_TYPE_PUBLISHING_OPTIONS_PANE, PublishingFlickrPublishingOptionsPane);
#line 685 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_signal_connect_object (self, "publish", (GCallback) _publishing_flickr_publishing_options_pane_notify_publish_publishing_flickr_publishing_options_pane_publish, self, 0);
#line 686 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_signal_connect_object (self, "logout", (GCallback) _publishing_flickr_publishing_options_pane_notify_logout_publishing_flickr_publishing_options_pane_logout, self, 0);
#line 5388 "FlickrPublishing.c"
}

static void
publishing_flickr_publishing_options_pane_real_on_pane_uninstalled (SpitPublishingDialogPane* base)
{
	PublishingFlickrPublishingOptionsPane * self;
	guint _tmp0_;
	guint _tmp1_;
#line 689 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, PUBLISHING_FLICKR_TYPE_PUBLISHING_OPTIONS_PANE, PublishingFlickrPublishingOptionsPane);
#line 690 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_signal_parse_name ("publish", PUBLISHING_FLICKR_TYPE_PUBLISHING_OPTIONS_PANE, &_tmp0_, NULL, FALSE);
#line 690 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_signal_handlers_disconnect_matched (self, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _publishing_flickr_publishing_options_pane_notify_publish_publishing_flickr_publishing_options_pane_publish, self);
#line 691 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_signal_parse_name ("logout", PUBLISHING_FLICKR_TYPE_PUBLISHING_OPTIONS_PANE, &_tmp1_, NULL, FALSE);
#line 691 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_signal_handlers_disconnect_matched (self, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _publishing_flickr_publishing_options_pane_notify_logout_publishing_flickr_publishing_options_pane_logout, self);
#line 5407 "FlickrPublishing.c"
}

static PublishingFlickrPublishingOptionsPaneSizeEntry*
publishing_flickr_publishing_options_pane_size_entry_construct (GType object_type,
                                                                const gchar* creator_title,
                                                                gint creator_size)
{
	PublishingFlickrPublishingOptionsPaneSizeEntry* self = NULL;
	gchar* _tmp0_;
#line 501 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_val_if_fail (creator_title != NULL, NULL);
#line 501 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self = (PublishingFlickrPublishingOptionsPaneSizeEntry*) g_type_create_instance (object_type);
#line 502 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp0_ = g_strdup (creator_title);
#line 502 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_free0 (self->title);
#line 502 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->title = _tmp0_;
#line 503 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->size = creator_size;
#line 501 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return self;
#line 5431 "FlickrPublishing.c"
}

static PublishingFlickrPublishingOptionsPaneSizeEntry*
publishing_flickr_publishing_options_pane_size_entry_new (const gchar* creator_title,
                                                          gint creator_size)
{
#line 501 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return publishing_flickr_publishing_options_pane_size_entry_construct (PUBLISHING_FLICKR_PUBLISHING_OPTIONS_PANE_TYPE_SIZE_ENTRY, creator_title, creator_size);
#line 5440 "FlickrPublishing.c"
}

static void
publishing_flickr_publishing_options_pane_value_size_entry_init (GValue* value)
{
#line 497 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	value->data[0].v_pointer = NULL;
#line 5448 "FlickrPublishing.c"
}

static void
publishing_flickr_publishing_options_pane_value_size_entry_free_value (GValue* value)
{
#line 497 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (value->data[0].v_pointer) {
#line 497 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		publishing_flickr_publishing_options_pane_size_entry_unref (value->data[0].v_pointer);
#line 5458 "FlickrPublishing.c"
	}
}

static void
publishing_flickr_publishing_options_pane_value_size_entry_copy_value (const GValue* src_value,
                                                                       GValue* dest_value)
{
#line 497 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (src_value->data[0].v_pointer) {
#line 497 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		dest_value->data[0].v_pointer = publishing_flickr_publishing_options_pane_size_entry_ref (src_value->data[0].v_pointer);
#line 5470 "FlickrPublishing.c"
	} else {
#line 497 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		dest_value->data[0].v_pointer = NULL;
#line 5474 "FlickrPublishing.c"
	}
}

static gpointer
publishing_flickr_publishing_options_pane_value_size_entry_peek_pointer (const GValue* value)
{
#line 497 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return value->data[0].v_pointer;
#line 5483 "FlickrPublishing.c"
}

static gchar*
publishing_flickr_publishing_options_pane_value_size_entry_collect_value (GValue* value,
                                                                          guint n_collect_values,
                                                                          GTypeCValue* collect_values,
                                                                          guint collect_flags)
{
#line 497 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (collect_values[0].v_pointer) {
#line 5494 "FlickrPublishing.c"
		PublishingFlickrPublishingOptionsPaneSizeEntry * object;
		object = collect_values[0].v_pointer;
#line 497 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		if (object->parent_instance.g_class == NULL) {
#line 497 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 5501 "FlickrPublishing.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 497 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 5505 "FlickrPublishing.c"
		}
#line 497 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		value->data[0].v_pointer = publishing_flickr_publishing_options_pane_size_entry_ref (object);
#line 5509 "FlickrPublishing.c"
	} else {
#line 497 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		value->data[0].v_pointer = NULL;
#line 5513 "FlickrPublishing.c"
	}
#line 497 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return NULL;
#line 5517 "FlickrPublishing.c"
}

static gchar*
publishing_flickr_publishing_options_pane_value_size_entry_lcopy_value (const GValue* value,
                                                                        guint n_collect_values,
                                                                        GTypeCValue* collect_values,
                                                                        guint collect_flags)
{
	PublishingFlickrPublishingOptionsPaneSizeEntry ** object_p;
	object_p = collect_values[0].v_pointer;
#line 497 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (!object_p) {
#line 497 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 5532 "FlickrPublishing.c"
	}
#line 497 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (!value->data[0].v_pointer) {
#line 497 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		*object_p = NULL;
#line 5538 "FlickrPublishing.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 497 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		*object_p = value->data[0].v_pointer;
#line 5542 "FlickrPublishing.c"
	} else {
#line 497 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		*object_p = publishing_flickr_publishing_options_pane_size_entry_ref (value->data[0].v_pointer);
#line 5546 "FlickrPublishing.c"
	}
#line 497 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return NULL;
#line 5550 "FlickrPublishing.c"
}

static GParamSpec*
publishing_flickr_publishing_options_pane_param_spec_size_entry (const gchar* name,
                                                                 const gchar* nick,
                                                                 const gchar* blurb,
                                                                 GType object_type,
                                                                 GParamFlags flags)
{
	PublishingFlickrPublishingOptionsPaneParamSpecSizeEntry* spec;
#line 497 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PUBLISHING_FLICKR_PUBLISHING_OPTIONS_PANE_TYPE_SIZE_ENTRY), NULL);
#line 497 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 497 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 497 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return G_PARAM_SPEC (spec);
#line 5569 "FlickrPublishing.c"
}

static gpointer
publishing_flickr_publishing_options_pane_value_get_size_entry (const GValue* value)
{
#line 497 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PUBLISHING_FLICKR_PUBLISHING_OPTIONS_PANE_TYPE_SIZE_ENTRY), NULL);
#line 497 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return value->data[0].v_pointer;
#line 5579 "FlickrPublishing.c"
}

static void
publishing_flickr_publishing_options_pane_value_set_size_entry (GValue* value,
                                                                gpointer v_object)
{
	PublishingFlickrPublishingOptionsPaneSizeEntry * old;
#line 497 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PUBLISHING_FLICKR_PUBLISHING_OPTIONS_PANE_TYPE_SIZE_ENTRY));
#line 497 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	old = value->data[0].v_pointer;
#line 497 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (v_object) {
#line 497 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PUBLISHING_FLICKR_PUBLISHING_OPTIONS_PANE_TYPE_SIZE_ENTRY));
#line 497 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 497 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		value->data[0].v_pointer = v_object;
#line 497 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		publishing_flickr_publishing_options_pane_size_entry_ref (value->data[0].v_pointer);
#line 5601 "FlickrPublishing.c"
	} else {
#line 497 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		value->data[0].v_pointer = NULL;
#line 5605 "FlickrPublishing.c"
	}
#line 497 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (old) {
#line 497 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		publishing_flickr_publishing_options_pane_size_entry_unref (old);
#line 5611 "FlickrPublishing.c"
	}
}

static void
publishing_flickr_publishing_options_pane_value_take_size_entry (GValue* value,
                                                                 gpointer v_object)
{
	PublishingFlickrPublishingOptionsPaneSizeEntry * old;
#line 497 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PUBLISHING_FLICKR_PUBLISHING_OPTIONS_PANE_TYPE_SIZE_ENTRY));
#line 497 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	old = value->data[0].v_pointer;
#line 497 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (v_object) {
#line 497 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PUBLISHING_FLICKR_PUBLISHING_OPTIONS_PANE_TYPE_SIZE_ENTRY));
#line 497 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 497 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		value->data[0].v_pointer = v_object;
#line 5632 "FlickrPublishing.c"
	} else {
#line 497 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		value->data[0].v_pointer = NULL;
#line 5636 "FlickrPublishing.c"
	}
#line 497 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (old) {
#line 497 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		publishing_flickr_publishing_options_pane_size_entry_unref (old);
#line 5642 "FlickrPublishing.c"
	}
}

static void
publishing_flickr_publishing_options_pane_size_entry_class_init (PublishingFlickrPublishingOptionsPaneSizeEntryClass * klass,
                                                                 gpointer klass_data)
{
#line 497 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	publishing_flickr_publishing_options_pane_size_entry_parent_class = g_type_class_peek_parent (klass);
#line 497 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	((PublishingFlickrPublishingOptionsPaneSizeEntryClass *) klass)->finalize = publishing_flickr_publishing_options_pane_size_entry_finalize;
#line 5654 "FlickrPublishing.c"
}

static void
publishing_flickr_publishing_options_pane_size_entry_instance_init (PublishingFlickrPublishingOptionsPaneSizeEntry * self,
                                                                    gpointer klass)
{
#line 497 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->ref_count = 1;
#line 5663 "FlickrPublishing.c"
}

static void
publishing_flickr_publishing_options_pane_size_entry_finalize (PublishingFlickrPublishingOptionsPaneSizeEntry * obj)
{
	PublishingFlickrPublishingOptionsPaneSizeEntry * self;
#line 497 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PUBLISHING_FLICKR_PUBLISHING_OPTIONS_PANE_TYPE_SIZE_ENTRY, PublishingFlickrPublishingOptionsPaneSizeEntry);
#line 497 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_signal_handlers_destroy (self);
#line 498 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_free0 (self->title);
#line 5676 "FlickrPublishing.c"
}

static GType
publishing_flickr_publishing_options_pane_size_entry_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { publishing_flickr_publishing_options_pane_value_size_entry_init, publishing_flickr_publishing_options_pane_value_size_entry_free_value, publishing_flickr_publishing_options_pane_value_size_entry_copy_value, publishing_flickr_publishing_options_pane_value_size_entry_peek_pointer, "p", publishing_flickr_publishing_options_pane_value_size_entry_collect_value, "p", publishing_flickr_publishing_options_pane_value_size_entry_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (PublishingFlickrPublishingOptionsPaneSizeEntryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) publishing_flickr_publishing_options_pane_size_entry_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PublishingFlickrPublishingOptionsPaneSizeEntry), 0, (GInstanceInitFunc) publishing_flickr_publishing_options_pane_size_entry_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType publishing_flickr_publishing_options_pane_size_entry_type_id;
	publishing_flickr_publishing_options_pane_size_entry_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PublishingFlickrPublishingOptionsPaneSizeEntry", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return publishing_flickr_publishing_options_pane_size_entry_type_id;
}

static GType
publishing_flickr_publishing_options_pane_size_entry_get_type (void)
{
	static volatile gsize publishing_flickr_publishing_options_pane_size_entry_type_id__once = 0;
	if (g_once_init_enter (&publishing_flickr_publishing_options_pane_size_entry_type_id__once)) {
		GType publishing_flickr_publishing_options_pane_size_entry_type_id;
		publishing_flickr_publishing_options_pane_size_entry_type_id = publishing_flickr_publishing_options_pane_size_entry_get_type_once ();
		g_once_init_leave (&publishing_flickr_publishing_options_pane_size_entry_type_id__once, publishing_flickr_publishing_options_pane_size_entry_type_id);
	}
	return publishing_flickr_publishing_options_pane_size_entry_type_id__once;
}

static gpointer
publishing_flickr_publishing_options_pane_size_entry_ref (gpointer instance)
{
	PublishingFlickrPublishingOptionsPaneSizeEntry * self;
	self = instance;
#line 497 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_atomic_int_inc (&self->ref_count);
#line 497 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return instance;
#line 5711 "FlickrPublishing.c"
}

static void
publishing_flickr_publishing_options_pane_size_entry_unref (gpointer instance)
{
	PublishingFlickrPublishingOptionsPaneSizeEntry * self;
	self = instance;
#line 497 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 497 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		PUBLISHING_FLICKR_PUBLISHING_OPTIONS_PANE_SIZE_ENTRY_GET_CLASS (self)->finalize (self);
#line 497 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 5725 "FlickrPublishing.c"
	}
}

static PublishingFlickrPublishingOptionsPaneVisibilityEntry*
publishing_flickr_publishing_options_pane_visibility_entry_construct (GType object_type,
                                                                      const gchar* creator_title,
                                                                      PublishingFlickrVisibilitySpecification* creator_specification)
{
	PublishingFlickrPublishingOptionsPaneVisibilityEntry* self = NULL;
	PublishingFlickrVisibilitySpecification* _tmp0_;
	gchar* _tmp1_;
#line 511 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_val_if_fail (creator_title != NULL, NULL);
#line 511 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_val_if_fail (PUBLISHING_FLICKR_IS_VISIBILITY_SPECIFICATION (creator_specification), NULL);
#line 511 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self = (PublishingFlickrPublishingOptionsPaneVisibilityEntry*) g_type_create_instance (object_type);
#line 512 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp0_ = _publishing_flickr_visibility_specification_ref0 (creator_specification);
#line 512 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_publishing_flickr_visibility_specification_unref0 (self->specification);
#line 512 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->specification = _tmp0_;
#line 513 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp1_ = g_strdup (creator_title);
#line 513 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_free0 (self->title);
#line 513 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->title = _tmp1_;
#line 511 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return self;
#line 5757 "FlickrPublishing.c"
}

static PublishingFlickrPublishingOptionsPaneVisibilityEntry*
publishing_flickr_publishing_options_pane_visibility_entry_new (const gchar* creator_title,
                                                                PublishingFlickrVisibilitySpecification* creator_specification)
{
#line 511 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return publishing_flickr_publishing_options_pane_visibility_entry_construct (PUBLISHING_FLICKR_PUBLISHING_OPTIONS_PANE_TYPE_VISIBILITY_ENTRY, creator_title, creator_specification);
#line 5766 "FlickrPublishing.c"
}

static void
publishing_flickr_publishing_options_pane_value_visibility_entry_init (GValue* value)
{
#line 507 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	value->data[0].v_pointer = NULL;
#line 5774 "FlickrPublishing.c"
}

static void
publishing_flickr_publishing_options_pane_value_visibility_entry_free_value (GValue* value)
{
#line 507 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (value->data[0].v_pointer) {
#line 507 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		publishing_flickr_publishing_options_pane_visibility_entry_unref (value->data[0].v_pointer);
#line 5784 "FlickrPublishing.c"
	}
}

static void
publishing_flickr_publishing_options_pane_value_visibility_entry_copy_value (const GValue* src_value,
                                                                             GValue* dest_value)
{
#line 507 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (src_value->data[0].v_pointer) {
#line 507 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		dest_value->data[0].v_pointer = publishing_flickr_publishing_options_pane_visibility_entry_ref (src_value->data[0].v_pointer);
#line 5796 "FlickrPublishing.c"
	} else {
#line 507 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		dest_value->data[0].v_pointer = NULL;
#line 5800 "FlickrPublishing.c"
	}
}

static gpointer
publishing_flickr_publishing_options_pane_value_visibility_entry_peek_pointer (const GValue* value)
{
#line 507 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return value->data[0].v_pointer;
#line 5809 "FlickrPublishing.c"
}

static gchar*
publishing_flickr_publishing_options_pane_value_visibility_entry_collect_value (GValue* value,
                                                                                guint n_collect_values,
                                                                                GTypeCValue* collect_values,
                                                                                guint collect_flags)
{
#line 507 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (collect_values[0].v_pointer) {
#line 5820 "FlickrPublishing.c"
		PublishingFlickrPublishingOptionsPaneVisibilityEntry * object;
		object = collect_values[0].v_pointer;
#line 507 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		if (object->parent_instance.g_class == NULL) {
#line 507 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 5827 "FlickrPublishing.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 507 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 5831 "FlickrPublishing.c"
		}
#line 507 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		value->data[0].v_pointer = publishing_flickr_publishing_options_pane_visibility_entry_ref (object);
#line 5835 "FlickrPublishing.c"
	} else {
#line 507 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		value->data[0].v_pointer = NULL;
#line 5839 "FlickrPublishing.c"
	}
#line 507 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return NULL;
#line 5843 "FlickrPublishing.c"
}

static gchar*
publishing_flickr_publishing_options_pane_value_visibility_entry_lcopy_value (const GValue* value,
                                                                              guint n_collect_values,
                                                                              GTypeCValue* collect_values,
                                                                              guint collect_flags)
{
	PublishingFlickrPublishingOptionsPaneVisibilityEntry ** object_p;
	object_p = collect_values[0].v_pointer;
#line 507 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (!object_p) {
#line 507 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 5858 "FlickrPublishing.c"
	}
#line 507 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (!value->data[0].v_pointer) {
#line 507 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		*object_p = NULL;
#line 5864 "FlickrPublishing.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 507 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		*object_p = value->data[0].v_pointer;
#line 5868 "FlickrPublishing.c"
	} else {
#line 507 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		*object_p = publishing_flickr_publishing_options_pane_visibility_entry_ref (value->data[0].v_pointer);
#line 5872 "FlickrPublishing.c"
	}
#line 507 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return NULL;
#line 5876 "FlickrPublishing.c"
}

static GParamSpec*
publishing_flickr_publishing_options_pane_param_spec_visibility_entry (const gchar* name,
                                                                       const gchar* nick,
                                                                       const gchar* blurb,
                                                                       GType object_type,
                                                                       GParamFlags flags)
{
	PublishingFlickrPublishingOptionsPaneParamSpecVisibilityEntry* spec;
#line 507 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_val_if_fail (g_type_is_a (object_type, PUBLISHING_FLICKR_PUBLISHING_OPTIONS_PANE_TYPE_VISIBILITY_ENTRY), NULL);
#line 507 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 507 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 507 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return G_PARAM_SPEC (spec);
#line 5895 "FlickrPublishing.c"
}

static gpointer
publishing_flickr_publishing_options_pane_value_get_visibility_entry (const GValue* value)
{
#line 507 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PUBLISHING_FLICKR_PUBLISHING_OPTIONS_PANE_TYPE_VISIBILITY_ENTRY), NULL);
#line 507 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return value->data[0].v_pointer;
#line 5905 "FlickrPublishing.c"
}

static void
publishing_flickr_publishing_options_pane_value_set_visibility_entry (GValue* value,
                                                                      gpointer v_object)
{
	PublishingFlickrPublishingOptionsPaneVisibilityEntry * old;
#line 507 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PUBLISHING_FLICKR_PUBLISHING_OPTIONS_PANE_TYPE_VISIBILITY_ENTRY));
#line 507 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	old = value->data[0].v_pointer;
#line 507 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (v_object) {
#line 507 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PUBLISHING_FLICKR_PUBLISHING_OPTIONS_PANE_TYPE_VISIBILITY_ENTRY));
#line 507 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 507 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		value->data[0].v_pointer = v_object;
#line 507 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		publishing_flickr_publishing_options_pane_visibility_entry_ref (value->data[0].v_pointer);
#line 5927 "FlickrPublishing.c"
	} else {
#line 507 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		value->data[0].v_pointer = NULL;
#line 5931 "FlickrPublishing.c"
	}
#line 507 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (old) {
#line 507 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		publishing_flickr_publishing_options_pane_visibility_entry_unref (old);
#line 5937 "FlickrPublishing.c"
	}
}

static void
publishing_flickr_publishing_options_pane_value_take_visibility_entry (GValue* value,
                                                                       gpointer v_object)
{
	PublishingFlickrPublishingOptionsPaneVisibilityEntry * old;
#line 507 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, PUBLISHING_FLICKR_PUBLISHING_OPTIONS_PANE_TYPE_VISIBILITY_ENTRY));
#line 507 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	old = value->data[0].v_pointer;
#line 507 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (v_object) {
#line 507 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, PUBLISHING_FLICKR_PUBLISHING_OPTIONS_PANE_TYPE_VISIBILITY_ENTRY));
#line 507 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 507 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		value->data[0].v_pointer = v_object;
#line 5958 "FlickrPublishing.c"
	} else {
#line 507 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		value->data[0].v_pointer = NULL;
#line 5962 "FlickrPublishing.c"
	}
#line 507 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (old) {
#line 507 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		publishing_flickr_publishing_options_pane_visibility_entry_unref (old);
#line 5968 "FlickrPublishing.c"
	}
}

static void
publishing_flickr_publishing_options_pane_visibility_entry_class_init (PublishingFlickrPublishingOptionsPaneVisibilityEntryClass * klass,
                                                                       gpointer klass_data)
{
#line 507 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	publishing_flickr_publishing_options_pane_visibility_entry_parent_class = g_type_class_peek_parent (klass);
#line 507 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	((PublishingFlickrPublishingOptionsPaneVisibilityEntryClass *) klass)->finalize = publishing_flickr_publishing_options_pane_visibility_entry_finalize;
#line 5980 "FlickrPublishing.c"
}

static void
publishing_flickr_publishing_options_pane_visibility_entry_instance_init (PublishingFlickrPublishingOptionsPaneVisibilityEntry * self,
                                                                          gpointer klass)
{
#line 507 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->ref_count = 1;
#line 5989 "FlickrPublishing.c"
}

static void
publishing_flickr_publishing_options_pane_visibility_entry_finalize (PublishingFlickrPublishingOptionsPaneVisibilityEntry * obj)
{
	PublishingFlickrPublishingOptionsPaneVisibilityEntry * self;
#line 507 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PUBLISHING_FLICKR_PUBLISHING_OPTIONS_PANE_TYPE_VISIBILITY_ENTRY, PublishingFlickrPublishingOptionsPaneVisibilityEntry);
#line 507 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_signal_handlers_destroy (self);
#line 508 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_publishing_flickr_visibility_specification_unref0 (self->specification);
#line 509 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_free0 (self->title);
#line 6004 "FlickrPublishing.c"
}

static GType
publishing_flickr_publishing_options_pane_visibility_entry_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { publishing_flickr_publishing_options_pane_value_visibility_entry_init, publishing_flickr_publishing_options_pane_value_visibility_entry_free_value, publishing_flickr_publishing_options_pane_value_visibility_entry_copy_value, publishing_flickr_publishing_options_pane_value_visibility_entry_peek_pointer, "p", publishing_flickr_publishing_options_pane_value_visibility_entry_collect_value, "p", publishing_flickr_publishing_options_pane_value_visibility_entry_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (PublishingFlickrPublishingOptionsPaneVisibilityEntryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) publishing_flickr_publishing_options_pane_visibility_entry_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PublishingFlickrPublishingOptionsPaneVisibilityEntry), 0, (GInstanceInitFunc) publishing_flickr_publishing_options_pane_visibility_entry_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType publishing_flickr_publishing_options_pane_visibility_entry_type_id;
	publishing_flickr_publishing_options_pane_visibility_entry_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PublishingFlickrPublishingOptionsPaneVisibilityEntry", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return publishing_flickr_publishing_options_pane_visibility_entry_type_id;
}

static GType
publishing_flickr_publishing_options_pane_visibility_entry_get_type (void)
{
	static volatile gsize publishing_flickr_publishing_options_pane_visibility_entry_type_id__once = 0;
	if (g_once_init_enter (&publishing_flickr_publishing_options_pane_visibility_entry_type_id__once)) {
		GType publishing_flickr_publishing_options_pane_visibility_entry_type_id;
		publishing_flickr_publishing_options_pane_visibility_entry_type_id = publishing_flickr_publishing_options_pane_visibility_entry_get_type_once ();
		g_once_init_leave (&publishing_flickr_publishing_options_pane_visibility_entry_type_id__once, publishing_flickr_publishing_options_pane_visibility_entry_type_id);
	}
	return publishing_flickr_publishing_options_pane_visibility_entry_type_id__once;
}

static gpointer
publishing_flickr_publishing_options_pane_visibility_entry_ref (gpointer instance)
{
	PublishingFlickrPublishingOptionsPaneVisibilityEntry * self;
	self = instance;
#line 507 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_atomic_int_inc (&self->ref_count);
#line 507 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return instance;
#line 6039 "FlickrPublishing.c"
}

static void
publishing_flickr_publishing_options_pane_visibility_entry_unref (gpointer instance)
{
	PublishingFlickrPublishingOptionsPaneVisibilityEntry * self;
	self = instance;
#line 507 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 507 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		PUBLISHING_FLICKR_PUBLISHING_OPTIONS_PANE_VISIBILITY_ENTRY_GET_CLASS (self)->finalize (self);
#line 507 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 6053 "FlickrPublishing.c"
	}
}

static void
publishing_flickr_publishing_options_pane_class_init (PublishingFlickrPublishingOptionsPaneClass * klass,
                                                      gpointer klass_data)
{
#line 496 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	publishing_flickr_publishing_options_pane_parent_class = g_type_class_peek_parent (klass);
#line 496 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_type_class_adjust_private_offset (klass, &PublishingFlickrPublishingOptionsPane_private_offset);
#line 496 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	G_OBJECT_CLASS (klass)->finalize = publishing_flickr_publishing_options_pane_finalize;
#line 496 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	publishing_flickr_publishing_options_pane_signals[PUBLISHING_FLICKR_PUBLISHING_OPTIONS_PANE_PUBLISH_SIGNAL] = g_signal_new ("publish", PUBLISHING_FLICKR_TYPE_PUBLISHING_OPTIONS_PANE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
#line 496 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	publishing_flickr_publishing_options_pane_signals[PUBLISHING_FLICKR_PUBLISHING_OPTIONS_PANE_LOGOUT_SIGNAL] = g_signal_new ("logout", PUBLISHING_FLICKR_TYPE_PUBLISHING_OPTIONS_PANE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 6071 "FlickrPublishing.c"
}

static void
publishing_flickr_publishing_options_pane_spit_publishing_dialog_pane_interface_init (SpitPublishingDialogPaneIface * iface,
                                                                                      gpointer iface_data)
{
#line 496 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	publishing_flickr_publishing_options_pane_spit_publishing_dialog_pane_parent_iface = g_type_interface_peek_parent (iface);
#line 496 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	iface->get_widget = (GtkWidget* (*) (SpitPublishingDialogPane*)) publishing_flickr_publishing_options_pane_real_get_widget;
#line 496 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	iface->get_preferred_geometry = (SpitPublishingDialogPaneGeometryOptions (*) (SpitPublishingDialogPane*)) publishing_flickr_publishing_options_pane_real_get_preferred_geometry;
#line 496 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	iface->on_pane_installed = (void (*) (SpitPublishingDialogPane*)) publishing_flickr_publishing_options_pane_real_on_pane_installed;
#line 496 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	iface->on_pane_uninstalled = (void (*) (SpitPublishingDialogPane*)) publishing_flickr_publishing_options_pane_real_on_pane_uninstalled;
#line 6088 "FlickrPublishing.c"
}

static void
publishing_flickr_publishing_options_pane_instance_init (PublishingFlickrPublishingOptionsPane * self,
                                                         gpointer klass)
{
#line 496 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv = publishing_flickr_publishing_options_pane_get_instance_private (self);
#line 518 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->pane_widget = NULL;
#line 519 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->visibility_label = NULL;
#line 520 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->upload_info_label = NULL;
#line 521 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->size_label = NULL;
#line 522 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->logout_button = NULL;
#line 523 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->publish_button = NULL;
#line 524 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->visibility_combo = NULL;
#line 525 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->size_combo = NULL;
#line 526 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->strip_metadata_check = NULL;
#line 527 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->visibilities = NULL;
#line 527 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->visibilities_length1 = 0;
#line 527 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->_visibilities_size_ = self->priv->visibilities_length1;
#line 528 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->sizes = NULL;
#line 528 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->sizes_length1 = 0;
#line 528 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->_sizes_size_ = self->priv->sizes_length1;
#line 529 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->parameters = NULL;
#line 530 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->publisher = NULL;
#line 6131 "FlickrPublishing.c"
}

static void
publishing_flickr_publishing_options_pane_finalize (GObject * obj)
{
	PublishingFlickrPublishingOptionsPane * self;
#line 496 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PUBLISHING_FLICKR_TYPE_PUBLISHING_OPTIONS_PANE, PublishingFlickrPublishingOptionsPane);
#line 517 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_object_unref0 (self->priv->builder);
#line 518 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_object_unref0 (self->priv->pane_widget);
#line 519 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_object_unref0 (self->priv->visibility_label);
#line 520 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_object_unref0 (self->priv->upload_info_label);
#line 521 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_object_unref0 (self->priv->size_label);
#line 522 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_object_unref0 (self->priv->logout_button);
#line 523 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_object_unref0 (self->priv->publish_button);
#line 524 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_object_unref0 (self->priv->visibility_combo);
#line 525 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_object_unref0 (self->priv->size_combo);
#line 526 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_object_unref0 (self->priv->strip_metadata_check);
#line 527 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->visibilities = (_vala_array_free (self->priv->visibilities, self->priv->visibilities_length1, (GDestroyNotify) publishing_flickr_publishing_options_pane_visibility_entry_unref), NULL);
#line 528 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->sizes = (_vala_array_free (self->priv->sizes, self->priv->sizes_length1, (GDestroyNotify) publishing_flickr_publishing_options_pane_size_entry_unref), NULL);
#line 529 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_publishing_flickr_publishing_parameters_unref0 (self->priv->parameters);
#line 530 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_object_unref0 (self->priv->publisher);
#line 496 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	G_OBJECT_CLASS (publishing_flickr_publishing_options_pane_parent_class)->finalize (obj);
#line 6170 "FlickrPublishing.c"
}

static GType
publishing_flickr_publishing_options_pane_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PublishingFlickrPublishingOptionsPaneClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) publishing_flickr_publishing_options_pane_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PublishingFlickrPublishingOptionsPane), 0, (GInstanceInitFunc) publishing_flickr_publishing_options_pane_instance_init, NULL };
	static const GInterfaceInfo spit_publishing_dialog_pane_info = { (GInterfaceInitFunc) publishing_flickr_publishing_options_pane_spit_publishing_dialog_pane_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType publishing_flickr_publishing_options_pane_type_id;
	publishing_flickr_publishing_options_pane_type_id = g_type_register_static (G_TYPE_OBJECT, "PublishingFlickrPublishingOptionsPane", &g_define_type_info, 0);
	g_type_add_interface_static (publishing_flickr_publishing_options_pane_type_id, SPIT_PUBLISHING_TYPE_DIALOG_PANE, &spit_publishing_dialog_pane_info);
	PublishingFlickrPublishingOptionsPane_private_offset = g_type_add_instance_private (publishing_flickr_publishing_options_pane_type_id, sizeof (PublishingFlickrPublishingOptionsPanePrivate));
	return publishing_flickr_publishing_options_pane_type_id;
}

GType
publishing_flickr_publishing_options_pane_get_type (void)
{
	static volatile gsize publishing_flickr_publishing_options_pane_type_id__once = 0;
	if (g_once_init_enter (&publishing_flickr_publishing_options_pane_type_id__once)) {
		GType publishing_flickr_publishing_options_pane_type_id;
		publishing_flickr_publishing_options_pane_type_id = publishing_flickr_publishing_options_pane_get_type_once ();
		g_once_init_leave (&publishing_flickr_publishing_options_pane_type_id__once, publishing_flickr_publishing_options_pane_type_id);
	}
	return publishing_flickr_publishing_options_pane_type_id__once;
}

static inline gpointer
publishing_flickr_uploader_get_instance_private (PublishingFlickrUploader* self)
{
	return G_STRUCT_MEMBER_P (self, PublishingFlickrUploader_private_offset);
}

PublishingFlickrUploader*
publishing_flickr_uploader_construct (GType object_type,
                                      PublishingRESTSupportOAuth1Session* session,
                                      SpitPublishingPublishable** publishables,
                                      gint publishables_length1,
                                      PublishingFlickrPublishingParameters* parameters,
                                      gboolean strip_metadata)
{
	PublishingFlickrUploader* self = NULL;
	PublishingFlickrPublishingParameters* _tmp0_;
#line 699 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (session, PUBLISHING_REST_SUPPORT_OAUTH1_TYPE_SESSION), NULL);
#line 699 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_val_if_fail (PUBLISHING_FLICKR_IS_PUBLISHING_PARAMETERS (parameters), NULL);
#line 701 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self = (PublishingFlickrUploader*) publishing_rest_support_batch_uploader_construct (object_type, G_TYPE_CHECK_INSTANCE_CAST (session, PUBLISHING_REST_SUPPORT_TYPE_SESSION, PublishingRESTSupportSession), publishables, (gint) publishables_length1);
#line 703 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp0_ = _publishing_flickr_publishing_parameters_ref0 (parameters);
#line 703 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_publishing_flickr_publishing_parameters_unref0 (self->priv->parameters);
#line 703 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->parameters = _tmp0_;
#line 704 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv->strip_metadata = strip_metadata;
#line 699 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return self;
#line 6229 "FlickrPublishing.c"
}

PublishingFlickrUploader*
publishing_flickr_uploader_new (PublishingRESTSupportOAuth1Session* session,
                                SpitPublishingPublishable** publishables,
                                gint publishables_length1,
                                PublishingFlickrPublishingParameters* parameters,
                                gboolean strip_metadata)
{
#line 699 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return publishing_flickr_uploader_construct (PUBLISHING_FLICKR_TYPE_UPLOADER, session, publishables, publishables_length1, parameters, strip_metadata);
#line 6241 "FlickrPublishing.c"
}

static void
_vala_array_add16 (gchar** * array,
                   gint* length,
                   gint* size,
                   gchar* value)
{
#line 758 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if ((*length) == (*size)) {
#line 758 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 758 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 6256 "FlickrPublishing.c"
	}
#line 758 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	(*array)[(*length)++] = value;
#line 758 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	(*array)[*length] = NULL;
#line 6262 "FlickrPublishing.c"
}

static void
publishing_flickr_uploader_preprocess_publishable (PublishingFlickrUploader* self,
                                                   SpitPublishingPublishable* publishable)
{
	GExiv2Metadata* publishable_metadata = NULL;
	GExiv2Metadata* _tmp0_;
	GExiv2Metadata* _tmp10_;
	GError* _inner_error0_ = NULL;
#line 707 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_if_fail (PUBLISHING_FLICKR_IS_UPLOADER (self));
#line 707 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (publishable, SPIT_PUBLISHING_TYPE_PUBLISHABLE));
#line 708 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (spit_publishing_publishable_get_media_type (publishable) != SPIT_PUBLISHING_PUBLISHER_MEDIA_TYPE_PHOTO) {
#line 709 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		return;
#line 6281 "FlickrPublishing.c"
	}
#line 711 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp0_ = gexiv2_metadata_new ();
#line 711 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	publishable_metadata = _tmp0_;
#line 6287 "FlickrPublishing.c"
	{
		GExiv2Metadata* _tmp1_;
		GFile* _tmp2_;
		GFile* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 713 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp1_ = publishable_metadata;
#line 713 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp2_ = spit_publishing_publishable_get_serialized_file (publishable);
#line 713 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp3_ = _tmp2_;
#line 713 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp4_ = g_file_get_path (_tmp3_);
#line 713 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp5_ = _tmp4_;
#line 713 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		gexiv2_metadata_open_path (_tmp1_, _tmp5_, &_inner_error0_);
#line 713 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_g_free0 (_tmp5_);
#line 713 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_g_object_unref0 (_tmp3_);
#line 713 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6312 "FlickrPublishing.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GFile* _tmp6_;
		GFile* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 712 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_clear_error (&_inner_error0_);
#line 715 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp6_ = spit_publishing_publishable_get_serialized_file (publishable);
#line 715 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp7_ = _tmp6_;
#line 715 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp8_ = g_file_get_path (_tmp7_);
#line 715 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp9_ = _tmp8_;
#line 715 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_warning ("FlickrPublishing.vala:715: couldn't read metadata from file '%s' for u" \
"pload preprocessing.", _tmp9_);
#line 715 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_g_free0 (_tmp9_);
#line 715 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_g_object_unref0 (_tmp7_);
#line 6339 "FlickrPublishing.c"
	}
	__finally0:
#line 712 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 712 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_g_object_unref0 (publishable_metadata);
#line 712 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 712 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_clear_error (&_inner_error0_);
#line 712 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		return;
#line 6352 "FlickrPublishing.c"
	}
#line 723 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp10_ = publishable_metadata;
#line 723 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (!gexiv2_metadata_has_iptc (_tmp10_)) {
#line 724 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_g_object_unref0 (publishable_metadata);
#line 724 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		return;
#line 6362 "FlickrPublishing.c"
	}
	{
		gboolean _tmp11_ = FALSE;
		GExiv2Metadata* _tmp12_;
#line 727 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp12_ = publishable_metadata;
#line 727 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp11_ = gexiv2_metadata_try_has_tag (_tmp12_, "Iptc.Application2.Caption", &_inner_error0_);
#line 727 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6373 "FlickrPublishing.c"
			goto __catch1_g_error;
		}
#line 727 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		if (_tmp11_) {
#line 6378 "FlickrPublishing.c"
			gchar* _tmp13_ = NULL;
			GExiv2Metadata* _tmp14_;
			gchar* _tmp15_;
			GExiv2Metadata* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
#line 729 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_tmp14_ = publishable_metadata;
#line 729 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_tmp15_ = gexiv2_metadata_try_get_tag_string (_tmp14_, "Iptc.Application2.Caption", &_inner_error0_);
#line 729 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_tmp13_ = _tmp15_;
#line 729 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6393 "FlickrPublishing.c"
				goto __catch1_g_error;
			}
#line 728 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_tmp16_ = publishable_metadata;
#line 728 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_tmp17_ = publishing_rest_support_asciify_string (_tmp13_);
#line 728 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_tmp18_ = _tmp17_;
#line 728 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			gexiv2_metadata_try_set_tag_string (_tmp16_, "Iptc.Application2.Caption", _tmp18_, &_inner_error0_);
#line 728 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_g_free0 (_tmp18_);
#line 728 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 728 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				_g_free0 (_tmp13_);
#line 6410 "FlickrPublishing.c"
				goto __catch1_g_error;
			}
#line 727 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_g_free0 (_tmp13_);
#line 6415 "FlickrPublishing.c"
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
#line 726 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_clear_error (&_inner_error0_);
#line 6423 "FlickrPublishing.c"
	}
	__finally1:
#line 726 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 726 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_g_object_unref0 (publishable_metadata);
#line 726 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 726 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_clear_error (&_inner_error0_);
#line 726 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		return;
#line 6436 "FlickrPublishing.c"
	}
	{
		gboolean _tmp19_ = FALSE;
		GExiv2Metadata* _tmp20_;
#line 734 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp20_ = publishable_metadata;
#line 734 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp19_ = gexiv2_metadata_try_has_tag (_tmp20_, "Iptc.Application2.Headline", &_inner_error0_);
#line 734 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6447 "FlickrPublishing.c"
			goto __catch2_g_error;
		}
#line 734 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		if (_tmp19_) {
#line 6452 "FlickrPublishing.c"
			gchar* _tmp21_ = NULL;
			GExiv2Metadata* _tmp22_;
			gchar* _tmp23_;
			GExiv2Metadata* _tmp24_;
			gchar* _tmp25_;
			gchar* _tmp26_;
#line 736 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_tmp22_ = publishable_metadata;
#line 736 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_tmp23_ = gexiv2_metadata_try_get_tag_string (_tmp22_, "Iptc.Application2.Headline", &_inner_error0_);
#line 736 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_tmp21_ = _tmp23_;
#line 736 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6467 "FlickrPublishing.c"
				goto __catch2_g_error;
			}
#line 735 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_tmp24_ = publishable_metadata;
#line 735 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_tmp25_ = publishing_rest_support_asciify_string (_tmp21_);
#line 735 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_tmp26_ = _tmp25_;
#line 735 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			gexiv2_metadata_try_set_tag_string (_tmp24_, "Iptc.Application2.Headline", _tmp26_, &_inner_error0_);
#line 735 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_g_free0 (_tmp26_);
#line 735 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 735 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				_g_free0 (_tmp21_);
#line 6484 "FlickrPublishing.c"
				goto __catch2_g_error;
			}
#line 734 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_g_free0 (_tmp21_);
#line 6489 "FlickrPublishing.c"
		}
	}
	goto __finally2;
	__catch2_g_error:
	{
#line 733 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_clear_error (&_inner_error0_);
#line 6497 "FlickrPublishing.c"
	}
	__finally2:
#line 733 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 733 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_g_object_unref0 (publishable_metadata);
#line 733 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 733 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_clear_error (&_inner_error0_);
#line 733 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		return;
#line 6510 "FlickrPublishing.c"
	}
	{
		gboolean _tmp27_ = FALSE;
		GExiv2Metadata* _tmp28_;
#line 741 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp28_ = publishable_metadata;
#line 741 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_tmp27_ = gexiv2_metadata_try_has_tag (_tmp28_, "Iptc.Application2.Keywords", &_inner_error0_);
#line 741 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6521 "FlickrPublishing.c"
			goto __catch3_g_error;
		}
#line 741 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		if (_tmp27_) {
#line 6526 "FlickrPublishing.c"
			GeeSet* keyword_set = NULL;
			GeeHashSet* _tmp29_;
			gchar** iptc_keywords = NULL;
			GExiv2Metadata* _tmp30_;
			gchar** _tmp31_;
			gchar** _tmp32_;
			gint iptc_keywords_length1;
			gint _iptc_keywords_size_;
			gchar** _tmp33_;
			gint _tmp33__length1;
			gchar** xmp_keywords = NULL;
			GExiv2Metadata* _tmp38_;
			gchar** _tmp39_;
			gchar** _tmp40_;
			gint xmp_keywords_length1;
			gint _xmp_keywords_size_;
			gchar** _tmp41_;
			gint _tmp41__length1;
			gchar** all_keywords = NULL;
			GeeSet* _tmp46_;
			gint _tmp47_ = 0;
			gpointer* _tmp48_;
			gint all_keywords_length1;
			gint _all_keywords_size_;
			gchar** no_keywords = NULL;
			gchar** _tmp49_;
			gint no_keywords_length1;
			gint _no_keywords_size_;
			gchar** _tmp50_;
			gint _tmp50__length1;
#line 742 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_tmp29_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 742 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			keyword_set = G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, GEE_TYPE_SET, GeeSet);
#line 743 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_tmp30_ = publishable_metadata;
#line 743 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_tmp32_ = _tmp31_ = gexiv2_metadata_try_get_tag_multiple (_tmp30_, "Iptc.Application2.Keywords", &_inner_error0_);
#line 743 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			iptc_keywords = _tmp32_;
#line 743 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			iptc_keywords_length1 = _vala_array_length (_tmp31_);
#line 743 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_iptc_keywords_size_ = iptc_keywords_length1;
#line 743 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 743 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				_g_object_unref0 (keyword_set);
#line 6575 "FlickrPublishing.c"
				goto __catch3_g_error;
			}
#line 744 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_tmp33_ = iptc_keywords;
#line 744 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_tmp33__length1 = iptc_keywords_length1;
#line 744 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			if (_tmp33_ != NULL) {
#line 6584 "FlickrPublishing.c"
				gchar** _tmp34_;
				gint _tmp34__length1;
#line 745 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				_tmp34_ = iptc_keywords;
#line 745 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				_tmp34__length1 = iptc_keywords_length1;
#line 6591 "FlickrPublishing.c"
				{
					gchar** keyword_collection = NULL;
					gint keyword_collection_length1 = 0;
					gint _keyword_collection_size_ = 0;
					gint keyword_it = 0;
#line 745 "../plugins/shotwell-publishing/FlickrPublishing.vala"
					keyword_collection = _tmp34_;
#line 745 "../plugins/shotwell-publishing/FlickrPublishing.vala"
					keyword_collection_length1 = _tmp34__length1;
#line 745 "../plugins/shotwell-publishing/FlickrPublishing.vala"
					for (keyword_it = 0; keyword_it < keyword_collection_length1; keyword_it = keyword_it + 1) {
#line 6603 "FlickrPublishing.c"
						gchar* _tmp35_;
						gchar* keyword = NULL;
#line 745 "../plugins/shotwell-publishing/FlickrPublishing.vala"
						_tmp35_ = g_strdup (keyword_collection[keyword_it]);
#line 745 "../plugins/shotwell-publishing/FlickrPublishing.vala"
						keyword = _tmp35_;
#line 6610 "FlickrPublishing.c"
						{
							GeeSet* _tmp36_;
							const gchar* _tmp37_;
#line 746 "../plugins/shotwell-publishing/FlickrPublishing.vala"
							_tmp36_ = keyword_set;
#line 746 "../plugins/shotwell-publishing/FlickrPublishing.vala"
							_tmp37_ = keyword;
#line 746 "../plugins/shotwell-publishing/FlickrPublishing.vala"
							gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp36_, GEE_TYPE_COLLECTION, GeeCollection), _tmp37_);
#line 745 "../plugins/shotwell-publishing/FlickrPublishing.vala"
							_g_free0 (keyword);
#line 6622 "FlickrPublishing.c"
						}
					}
				}
			}
#line 748 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_tmp38_ = publishable_metadata;
#line 748 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_tmp40_ = _tmp39_ = gexiv2_metadata_try_get_tag_multiple (_tmp38_, "Xmp.dc.subject", &_inner_error0_);
#line 748 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			xmp_keywords = _tmp40_;
#line 748 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			xmp_keywords_length1 = _vala_array_length (_tmp39_);
#line 748 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_xmp_keywords_size_ = xmp_keywords_length1;
#line 748 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 748 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				iptc_keywords = (_vala_array_free (iptc_keywords, iptc_keywords_length1, (GDestroyNotify) g_free), NULL);
#line 748 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				_g_object_unref0 (keyword_set);
#line 6643 "FlickrPublishing.c"
				goto __catch3_g_error;
			}
#line 749 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_tmp41_ = xmp_keywords;
#line 749 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_tmp41__length1 = xmp_keywords_length1;
#line 749 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			if (_tmp41_ != NULL) {
#line 6652 "FlickrPublishing.c"
				gchar** _tmp42_;
				gint _tmp42__length1;
#line 750 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				_tmp42_ = xmp_keywords;
#line 750 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				_tmp42__length1 = xmp_keywords_length1;
#line 6659 "FlickrPublishing.c"
				{
					gchar** keyword_collection = NULL;
					gint keyword_collection_length1 = 0;
					gint _keyword_collection_size_ = 0;
					gint keyword_it = 0;
#line 750 "../plugins/shotwell-publishing/FlickrPublishing.vala"
					keyword_collection = _tmp42_;
#line 750 "../plugins/shotwell-publishing/FlickrPublishing.vala"
					keyword_collection_length1 = _tmp42__length1;
#line 750 "../plugins/shotwell-publishing/FlickrPublishing.vala"
					for (keyword_it = 0; keyword_it < keyword_collection_length1; keyword_it = keyword_it + 1) {
#line 6671 "FlickrPublishing.c"
						gchar* _tmp43_;
						gchar* keyword = NULL;
#line 750 "../plugins/shotwell-publishing/FlickrPublishing.vala"
						_tmp43_ = g_strdup (keyword_collection[keyword_it]);
#line 750 "../plugins/shotwell-publishing/FlickrPublishing.vala"
						keyword = _tmp43_;
#line 6678 "FlickrPublishing.c"
						{
							GeeSet* _tmp44_;
							const gchar* _tmp45_;
#line 751 "../plugins/shotwell-publishing/FlickrPublishing.vala"
							_tmp44_ = keyword_set;
#line 751 "../plugins/shotwell-publishing/FlickrPublishing.vala"
							_tmp45_ = keyword;
#line 751 "../plugins/shotwell-publishing/FlickrPublishing.vala"
							gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp44_, GEE_TYPE_COLLECTION, GeeCollection), _tmp45_);
#line 750 "../plugins/shotwell-publishing/FlickrPublishing.vala"
							_g_free0 (keyword);
#line 6690 "FlickrPublishing.c"
						}
					}
				}
			}
#line 753 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_tmp46_ = keyword_set;
#line 753 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_tmp48_ = gee_collection_to_array (G_TYPE_CHECK_INSTANCE_CAST (_tmp46_, GEE_TYPE_COLLECTION, GeeCollection), &_tmp47_);
#line 753 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			all_keywords = _tmp48_;
#line 753 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			all_keywords_length1 = _tmp47_;
#line 753 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_all_keywords_size_ = all_keywords_length1;
#line 758 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_vala_array_add16 (&all_keywords, &all_keywords_length1, &_all_keywords_size_, NULL);
#line 760 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_tmp49_ = g_new0 (gchar*, 1 + 1);
#line 760 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			no_keywords = _tmp49_;
#line 760 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			no_keywords_length1 = 1;
#line 760 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_no_keywords_size_ = no_keywords_length1;
#line 763 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_tmp50_ = no_keywords;
#line 763 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_tmp50__length1 = no_keywords_length1;
#line 763 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_g_free0 (_tmp50_[0]);
#line 763 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_tmp50_[0] = NULL;
#line 6723 "FlickrPublishing.c"
			{
				GExiv2Metadata* _tmp51_;
				gchar** _tmp52_;
				gint _tmp52__length1;
#line 766 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				_tmp51_ = publishable_metadata;
#line 766 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				_tmp52_ = all_keywords;
#line 766 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				_tmp52__length1 = all_keywords_length1;
#line 766 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				gexiv2_metadata_try_set_tag_multiple (_tmp51_, "Xmp.dc.subject", _tmp52_, &_inner_error0_);
#line 766 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6738 "FlickrPublishing.c"
					goto __catch4_g_error;
				}
			}
			goto __finally4;
			__catch4_g_error:
			{
#line 765 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				g_clear_error (&_inner_error0_);
#line 6747 "FlickrPublishing.c"
			}
			__finally4:
#line 765 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 765 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				no_keywords = (_vala_array_free (no_keywords, no_keywords_length1, (GDestroyNotify) g_free), NULL);
#line 765 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				all_keywords = (_vala_array_free (all_keywords, all_keywords_length1, (GDestroyNotify) g_free), NULL);
#line 765 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				xmp_keywords = (_vala_array_free (xmp_keywords, xmp_keywords_length1, (GDestroyNotify) g_free), NULL);
#line 765 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				iptc_keywords = (_vala_array_free (iptc_keywords, iptc_keywords_length1, (GDestroyNotify) g_free), NULL);
#line 765 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				_g_object_unref0 (keyword_set);
#line 6762 "FlickrPublishing.c"
				goto __catch3_g_error;
			}
			{
				GExiv2Metadata* _tmp53_;
				gchar** _tmp54_;
				gint _tmp54__length1;
#line 770 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				_tmp53_ = publishable_metadata;
#line 770 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				_tmp54_ = no_keywords;
#line 770 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				_tmp54__length1 = no_keywords_length1;
#line 770 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				gexiv2_metadata_try_set_tag_multiple (_tmp53_, "Iptc.Application2.Keywords", _tmp54_, &_inner_error0_);
#line 770 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6779 "FlickrPublishing.c"
					goto __catch5_g_error;
				}
			}
			goto __finally5;
			__catch5_g_error:
			{
#line 769 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				g_clear_error (&_inner_error0_);
#line 6788 "FlickrPublishing.c"
			}
			__finally5:
#line 769 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 769 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				no_keywords = (_vala_array_free (no_keywords, no_keywords_length1, (GDestroyNotify) g_free), NULL);
#line 769 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				all_keywords = (_vala_array_free (all_keywords, all_keywords_length1, (GDestroyNotify) g_free), NULL);
#line 769 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				xmp_keywords = (_vala_array_free (xmp_keywords, xmp_keywords_length1, (GDestroyNotify) g_free), NULL);
#line 769 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				iptc_keywords = (_vala_array_free (iptc_keywords, iptc_keywords_length1, (GDestroyNotify) g_free), NULL);
#line 769 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				_g_object_unref0 (keyword_set);
#line 6803 "FlickrPublishing.c"
				goto __catch3_g_error;
			}
			{
				GExiv2Metadata* _tmp55_;
				GFile* _tmp56_;
				GFile* _tmp57_;
				gchar* _tmp58_;
				gchar* _tmp59_;
#line 775 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				_tmp55_ = publishable_metadata;
#line 775 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				_tmp56_ = spit_publishing_publishable_get_serialized_file (publishable);
#line 775 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				_tmp57_ = _tmp56_;
#line 775 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				_tmp58_ = g_file_get_path (_tmp57_);
#line 775 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				_tmp59_ = _tmp58_;
#line 775 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				gexiv2_metadata_save_file (_tmp55_, _tmp59_, &_inner_error0_);
#line 775 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				_g_free0 (_tmp59_);
#line 775 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				_g_object_unref0 (_tmp57_);
#line 775 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6830 "FlickrPublishing.c"
					goto __catch6_g_error;
				}
			}
			goto __finally6;
			__catch6_g_error:
			{
				GFile* _tmp60_;
				GFile* _tmp61_;
				gchar* _tmp62_;
				gchar* _tmp63_;
#line 774 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				g_clear_error (&_inner_error0_);
#line 777 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				_tmp60_ = spit_publishing_publishable_get_serialized_file (publishable);
#line 777 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				_tmp61_ = _tmp60_;
#line 777 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				_tmp62_ = g_file_get_path (_tmp61_);
#line 777 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				_tmp63_ = _tmp62_;
#line 777 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				g_warning ("FlickrPublishing.vala:777: couldn't write metadata to file '%s' for up" \
"load preprocessing.", _tmp63_);
#line 777 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				_g_free0 (_tmp63_);
#line 777 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				_g_object_unref0 (_tmp61_);
#line 6857 "FlickrPublishing.c"
			}
			__finally6:
#line 774 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 774 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				no_keywords = (_vala_array_free (no_keywords, no_keywords_length1, (GDestroyNotify) g_free), NULL);
#line 774 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				all_keywords = (_vala_array_free (all_keywords, all_keywords_length1, (GDestroyNotify) g_free), NULL);
#line 774 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				xmp_keywords = (_vala_array_free (xmp_keywords, xmp_keywords_length1, (GDestroyNotify) g_free), NULL);
#line 774 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				iptc_keywords = (_vala_array_free (iptc_keywords, iptc_keywords_length1, (GDestroyNotify) g_free), NULL);
#line 774 "../plugins/shotwell-publishing/FlickrPublishing.vala"
				_g_object_unref0 (keyword_set);
#line 6872 "FlickrPublishing.c"
				goto __catch3_g_error;
			}
#line 741 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			no_keywords = (_vala_array_free (no_keywords, no_keywords_length1, (GDestroyNotify) g_free), NULL);
#line 741 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			all_keywords = (_vala_array_free (all_keywords, all_keywords_length1, (GDestroyNotify) g_free), NULL);
#line 741 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			xmp_keywords = (_vala_array_free (xmp_keywords, xmp_keywords_length1, (GDestroyNotify) g_free), NULL);
#line 741 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			iptc_keywords = (_vala_array_free (iptc_keywords, iptc_keywords_length1, (GDestroyNotify) g_free), NULL);
#line 741 "../plugins/shotwell-publishing/FlickrPublishing.vala"
			_g_object_unref0 (keyword_set);
#line 6885 "FlickrPublishing.c"
		}
	}
	goto __finally3;
	__catch3_g_error:
	{
#line 740 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_clear_error (&_inner_error0_);
#line 6893 "FlickrPublishing.c"
	}
	__finally3:
#line 740 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 740 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		_g_object_unref0 (publishable_metadata);
#line 740 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 740 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		g_clear_error (&_inner_error0_);
#line 740 "../plugins/shotwell-publishing/FlickrPublishing.vala"
		return;
#line 6906 "FlickrPublishing.c"
	}
#line 707 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_object_unref0 (publishable_metadata);
#line 6910 "FlickrPublishing.c"
}

static PublishingRESTSupportTransaction*
publishing_flickr_uploader_real_create_transaction (PublishingRESTSupportBatchUploader* base,
                                                    SpitPublishingPublishable* publishable)
{
	PublishingFlickrUploader * self;
	SpitPublishingPublishable* _tmp0_;
	SpitPublishingPublishable* _tmp1_;
	PublishingRESTSupportSession* _tmp2_;
	PublishingRESTSupportOAuth1Session* _tmp3_;
	PublishingFlickrPublishingParameters* _tmp4_;
	SpitPublishingPublishable* _tmp5_;
	SpitPublishingPublishable* _tmp6_;
	PublishingFlickrUploadTransaction* _tmp7_;
	PublishingRESTSupportTransaction* _tmp8_;
	PublishingRESTSupportTransaction* result;
#line 784 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, PUBLISHING_FLICKR_TYPE_UPLOADER, PublishingFlickrUploader);
#line 784 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (publishable, SPIT_PUBLISHING_TYPE_PUBLISHABLE), NULL);
#line 786 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp0_ = publishing_rest_support_batch_uploader_get_current_publishable (G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_REST_SUPPORT_TYPE_BATCH_UPLOADER, PublishingRESTSupportBatchUploader));
#line 786 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp1_ = _tmp0_;
#line 786 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	publishing_flickr_uploader_preprocess_publishable (self, _tmp1_);
#line 786 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_object_unref0 (_tmp1_);
#line 787 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp2_ = publishing_rest_support_batch_uploader_get_session (G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_REST_SUPPORT_TYPE_BATCH_UPLOADER, PublishingRESTSupportBatchUploader));
#line 787 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, PUBLISHING_REST_SUPPORT_OAUTH1_TYPE_SESSION, PublishingRESTSupportOAuth1Session);
#line 787 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp4_ = self->priv->parameters;
#line 787 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp5_ = publishing_rest_support_batch_uploader_get_current_publishable (G_TYPE_CHECK_INSTANCE_CAST (self, PUBLISHING_REST_SUPPORT_TYPE_BATCH_UPLOADER, PublishingRESTSupportBatchUploader));
#line 787 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp6_ = _tmp5_;
#line 787 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp7_ = publishing_flickr_upload_transaction_new (_tmp3_, _tmp4_, _tmp6_);
#line 787 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_tmp8_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, PUBLISHING_REST_SUPPORT_TYPE_TRANSACTION, PublishingRESTSupportTransaction);
#line 787 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_g_object_unref0 (_tmp6_);
#line 787 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_publishing_rest_support_session_unref0 (_tmp3_);
#line 787 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	result = _tmp8_;
#line 787 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	return result;
#line 6962 "FlickrPublishing.c"
}

static void
publishing_flickr_uploader_class_init (PublishingFlickrUploaderClass * klass,
                                       gpointer klass_data)
{
#line 695 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	publishing_flickr_uploader_parent_class = g_type_class_peek_parent (klass);
#line 695 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	((PublishingRESTSupportBatchUploaderClass *) klass)->finalize = publishing_flickr_uploader_finalize;
#line 695 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	g_type_class_adjust_private_offset (klass, &PublishingFlickrUploader_private_offset);
#line 695 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	((PublishingRESTSupportBatchUploaderClass *) klass)->create_transaction = (PublishingRESTSupportTransaction* (*) (PublishingRESTSupportBatchUploader*, SpitPublishingPublishable*)) publishing_flickr_uploader_real_create_transaction;
#line 6977 "FlickrPublishing.c"
}

static void
publishing_flickr_uploader_instance_init (PublishingFlickrUploader * self,
                                          gpointer klass)
{
#line 695 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self->priv = publishing_flickr_uploader_get_instance_private (self);
#line 6986 "FlickrPublishing.c"
}

static void
publishing_flickr_uploader_finalize (PublishingRESTSupportBatchUploader * obj)
{
	PublishingFlickrUploader * self;
#line 695 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PUBLISHING_FLICKR_TYPE_UPLOADER, PublishingFlickrUploader);
#line 696 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	_publishing_flickr_publishing_parameters_unref0 (self->priv->parameters);
#line 695 "../plugins/shotwell-publishing/FlickrPublishing.vala"
	PUBLISHING_REST_SUPPORT_BATCH_UPLOADER_CLASS (publishing_flickr_uploader_parent_class)->finalize (obj);
#line 6999 "FlickrPublishing.c"
}

static GType
publishing_flickr_uploader_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PublishingFlickrUploaderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) publishing_flickr_uploader_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PublishingFlickrUploader), 0, (GInstanceInitFunc) publishing_flickr_uploader_instance_init, NULL };
	GType publishing_flickr_uploader_type_id;
	publishing_flickr_uploader_type_id = g_type_register_static (PUBLISHING_REST_SUPPORT_TYPE_BATCH_UPLOADER, "PublishingFlickrUploader", &g_define_type_info, 0);
	PublishingFlickrUploader_private_offset = g_type_add_instance_private (publishing_flickr_uploader_type_id, sizeof (PublishingFlickrUploaderPrivate));
	return publishing_flickr_uploader_type_id;
}

GType
publishing_flickr_uploader_get_type (void)
{
	static volatile gsize publishing_flickr_uploader_type_id__once = 0;
	if (g_once_init_enter (&publishing_flickr_uploader_type_id__once)) {
		GType publishing_flickr_uploader_type_id;
		publishing_flickr_uploader_type_id = publishing_flickr_uploader_get_type_once ();
		g_once_init_leave (&publishing_flickr_uploader_type_id__once, publishing_flickr_uploader_type_id);
	}
	return publishing_flickr_uploader_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

