/* BatchImport.c generated by valac 0.56.14, the Vala compiler
 * generated from BatchImport.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU LGPL (version 2.1 or later).
 * See the COPYING file in this distribution.
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gobject/gvaluecollector.h>
#include <gee.h>
#include <float.h>
#include <math.h>
#include "metadata.h"

#define BATCH_IMPORT_WORK_SNIFFER_THROBBER_MSEC 125
#define BATCH_IMPORT_REPORT_EVERY_N_PREPARED_FILES 100
#define BATCH_IMPORT_REPORT_PREPARED_FILES_EVERY_N_MSEC 3000
#define BATCH_IMPORT_READY_SOURCES_COUNT_OVERFLOW 10
#define BATCH_IMPORT_DISPLAY_QUEUE_TIMER_MSEC 125
#define BATCH_IMPORT_DISPLAY_QUEUE_HYSTERESIS_OVERFLOW ((3 * 1000) / BATCH_IMPORT_DISPLAY_QUEUE_TIMER_MSEC)
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	IMPORT_RESULT_SUCCESS,
	IMPORT_RESULT_FILE_ERROR,
	IMPORT_RESULT_DECODE_ERROR,
	IMPORT_RESULT_DATABASE_ERROR,
	IMPORT_RESULT_USER_ABORT,
	IMPORT_RESULT_NOT_A_FILE,
	IMPORT_RESULT_PHOTO_EXISTS,
	IMPORT_RESULT_UNSUPPORTED_FORMAT,
	IMPORT_RESULT_NOT_AN_IMAGE,
	IMPORT_RESULT_DISK_FAILURE,
	IMPORT_RESULT_DISK_FULL,
	IMPORT_RESULT_CAMERA_ERROR,
	IMPORT_RESULT_FILE_WRITE_ERROR,
	IMPORT_RESULT_PIXBUF_CORRUPT_IMAGE
} ImportResult;

#define TYPE_IMPORT_RESULT (import_result_get_type ())
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_GPHOTO_ERROR (gphoto_error_get_type ())

#define TYPE_BATCH_IMPORT_JOB (batch_import_job_get_type ())
#define BATCH_IMPORT_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BATCH_IMPORT_JOB, BatchImportJob))
#define BATCH_IMPORT_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BATCH_IMPORT_JOB, BatchImportJobClass))
#define IS_BATCH_IMPORT_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BATCH_IMPORT_JOB))
#define IS_BATCH_IMPORT_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BATCH_IMPORT_JOB))
#define BATCH_IMPORT_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BATCH_IMPORT_JOB, BatchImportJobClass))

typedef struct _BatchImportJob BatchImportJob;
typedef struct _BatchImportJobClass BatchImportJobClass;
typedef struct _BatchImportJobPrivate BatchImportJobPrivate;

#define TYPE_DUPLICATED_FILE (duplicated_file_get_type ())
#define DUPLICATED_FILE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DUPLICATED_FILE, DuplicatedFile))
#define DUPLICATED_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DUPLICATED_FILE, DuplicatedFileClass))
#define IS_DUPLICATED_FILE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DUPLICATED_FILE))
#define IS_DUPLICATED_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DUPLICATED_FILE))
#define DUPLICATED_FILE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DUPLICATED_FILE, DuplicatedFileClass))

typedef struct _DuplicatedFile DuplicatedFile;
typedef struct _DuplicatedFileClass DuplicatedFileClass;

#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;

#define TYPE_DATA_SOURCE (data_source_get_type ())
#define DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SOURCE, DataSource))
#define DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SOURCE, DataSourceClass))
#define IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SOURCE))
#define IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SOURCE))
#define DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SOURCE, DataSourceClass))

typedef struct _DataSource DataSource;
typedef struct _DataSourceClass DataSourceClass;

#define TYPE_THUMBNAIL_SOURCE (thumbnail_source_get_type ())
#define THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSource))
#define THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))
#define IS_THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL_SOURCE))
#define IS_THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL_SOURCE))
#define THUMBNAIL_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))

typedef struct _ThumbnailSource ThumbnailSource;
typedef struct _ThumbnailSourceClass ThumbnailSourceClass;

#define TYPE_MEDIA_SOURCE (media_source_get_type ())
#define MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE, MediaSource))
#define MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE, MediaSourceClass))
#define IS_MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE))
#define IS_MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE))
#define MEDIA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE, MediaSourceClass))

typedef struct _MediaSource MediaSource;
typedef struct _MediaSourceClass MediaSourceClass;

#define TYPE_BATCH_IMPORT_ROLL (batch_import_roll_get_type ())
#define BATCH_IMPORT_ROLL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BATCH_IMPORT_ROLL, BatchImportRoll))
#define BATCH_IMPORT_ROLL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BATCH_IMPORT_ROLL, BatchImportRollClass))
#define IS_BATCH_IMPORT_ROLL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BATCH_IMPORT_ROLL))
#define IS_BATCH_IMPORT_ROLL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BATCH_IMPORT_ROLL))
#define BATCH_IMPORT_ROLL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BATCH_IMPORT_ROLL, BatchImportRollClass))

typedef struct _BatchImportRoll BatchImportRoll;
typedef struct _BatchImportRollClass BatchImportRollClass;
typedef struct _ParamSpecBatchImportJob ParamSpecBatchImportJob;

#define TYPE_FILE_IMPORT_JOB (file_import_job_get_type ())
#define FILE_IMPORT_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FILE_IMPORT_JOB, FileImportJob))
#define FILE_IMPORT_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FILE_IMPORT_JOB, FileImportJobClass))
#define IS_FILE_IMPORT_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FILE_IMPORT_JOB))
#define IS_FILE_IMPORT_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FILE_IMPORT_JOB))
#define FILE_IMPORT_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FILE_IMPORT_JOB, FileImportJobClass))

typedef struct _FileImportJob FileImportJob;
typedef struct _FileImportJobClass FileImportJobClass;
typedef struct _FileImportJobPrivate FileImportJobPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _batch_import_job_unref0(var) ((var == NULL) ? NULL : (var = (batch_import_job_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _BatchImportRollPrivate BatchImportRollPrivate;

#define TYPE_IMPORT_ID (import_id_get_type ())
typedef struct _ImportID ImportID;

#define TYPE_DATA_COLLECTION (data_collection_get_type ())
#define DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_COLLECTION, DataCollection))
#define DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_COLLECTION, DataCollectionClass))
#define IS_DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_COLLECTION))
#define IS_DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_COLLECTION))
#define DATA_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_COLLECTION, DataCollectionClass))

typedef struct _DataCollection DataCollection;
typedef struct _DataCollectionClass DataCollectionClass;

#define TYPE_VIEW_COLLECTION (view_collection_get_type ())
#define VIEW_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIEW_COLLECTION, ViewCollection))
#define VIEW_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIEW_COLLECTION, ViewCollectionClass))
#define IS_VIEW_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIEW_COLLECTION))
#define IS_VIEW_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIEW_COLLECTION))
#define VIEW_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIEW_COLLECTION, ViewCollectionClass))

typedef struct _ViewCollection ViewCollection;
typedef struct _ViewCollectionClass ViewCollectionClass;
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))
typedef struct _ParamSpecBatchImportRoll ParamSpecBatchImportRoll;

#define TYPE_BATCH_IMPORT_RESULT (batch_import_result_get_type ())
#define BATCH_IMPORT_RESULT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BATCH_IMPORT_RESULT, BatchImportResult))
#define BATCH_IMPORT_RESULT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BATCH_IMPORT_RESULT, BatchImportResultClass))
#define IS_BATCH_IMPORT_RESULT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BATCH_IMPORT_RESULT))
#define IS_BATCH_IMPORT_RESULT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BATCH_IMPORT_RESULT))
#define BATCH_IMPORT_RESULT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BATCH_IMPORT_RESULT, BatchImportResultClass))

typedef struct _BatchImportResult BatchImportResult;
typedef struct _BatchImportResultClass BatchImportResultClass;
typedef struct _BatchImportResultPrivate BatchImportResultPrivate;
typedef struct _ParamSpecBatchImportResult ParamSpecBatchImportResult;

#define TYPE_IMPORT_MANIFEST (import_manifest_get_type ())
#define IMPORT_MANIFEST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_IMPORT_MANIFEST, ImportManifest))
#define IMPORT_MANIFEST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_IMPORT_MANIFEST, ImportManifestClass))
#define IS_IMPORT_MANIFEST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_IMPORT_MANIFEST))
#define IS_IMPORT_MANIFEST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_IMPORT_MANIFEST))
#define IMPORT_MANIFEST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_IMPORT_MANIFEST, ImportManifestClass))

typedef struct _ImportManifest ImportManifest;
typedef struct _ImportManifestClass ImportManifestClass;
typedef struct _ImportManifestPrivate ImportManifestPrivate;
#define _g_timer_destroy0(var) ((var == NULL) ? NULL : (var = (g_timer_destroy (var), NULL)))
#define _batch_import_result_unref0(var) ((var == NULL) ? NULL : (var = (batch_import_result_unref (var), NULL)))
typedef struct _ParamSpecImportManifest ParamSpecImportManifest;

#define TYPE_BATCH_IMPORT (batch_import_get_type ())
#define BATCH_IMPORT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BATCH_IMPORT, BatchImport))
#define BATCH_IMPORT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BATCH_IMPORT, BatchImportClass))
#define IS_BATCH_IMPORT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BATCH_IMPORT))
#define IS_BATCH_IMPORT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BATCH_IMPORT))
#define BATCH_IMPORT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BATCH_IMPORT, BatchImportClass))

typedef struct _BatchImport BatchImport;
typedef struct _BatchImportClass BatchImportClass;
typedef struct _BatchImportPrivate BatchImportPrivate;
typedef void (*BatchImportImportReporter) (ImportManifest* manifest, BatchImportRoll* import_roll, gpointer user_data);

#define TYPE_PREPARED_FILE (prepared_file_get_type ())
#define PREPARED_FILE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PREPARED_FILE, PreparedFile))
#define PREPARED_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PREPARED_FILE, PreparedFileClass))
#define IS_PREPARED_FILE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PREPARED_FILE))
#define IS_PREPARED_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PREPARED_FILE))
#define PREPARED_FILE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PREPARED_FILE, PreparedFileClass))

typedef struct _PreparedFile PreparedFile;
typedef struct _PreparedFileClass PreparedFileClass;

#define TYPE_COMPLETED_IMPORT_OBJECT (completed_import_object_get_type ())
#define COMPLETED_IMPORT_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMPLETED_IMPORT_OBJECT, CompletedImportObject))
#define COMPLETED_IMPORT_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COMPLETED_IMPORT_OBJECT, CompletedImportObjectClass))
#define IS_COMPLETED_IMPORT_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMPLETED_IMPORT_OBJECT))
#define IS_COMPLETED_IMPORT_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COMPLETED_IMPORT_OBJECT))
#define COMPLETED_IMPORT_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COMPLETED_IMPORT_OBJECT, CompletedImportObjectClass))

typedef struct _CompletedImportObject CompletedImportObject;
typedef struct _CompletedImportObjectClass CompletedImportObjectClass;
enum  {
	BATCH_IMPORT_0_PROPERTY,
	BATCH_IMPORT_NUM_PROPERTIES
};
static GParamSpec* batch_import_properties[BATCH_IMPORT_NUM_PROPERTIES];

#define TYPE_APPLICATION (application_get_type ())
#define APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_APPLICATION, Application))
#define APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_APPLICATION, ApplicationClass))
#define IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_APPLICATION))
#define IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_APPLICATION))
#define APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_APPLICATION, ApplicationClass))

typedef struct _Application Application;
typedef struct _ApplicationClass ApplicationClass;
#define _application_unref0(var) ((var == NULL) ? NULL : (var = (application_unref (var), NULL)))

#define TYPE_WORKERS (workers_get_type ())
#define WORKERS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORKERS, Workers))
#define WORKERS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORKERS, WorkersClass))
#define IS_WORKERS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORKERS))
#define IS_WORKERS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORKERS))
#define WORKERS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORKERS, WorkersClass))

typedef struct _Workers Workers;
typedef struct _WorkersClass WorkersClass;
#define _batch_import_roll_unref0(var) ((var == NULL) ? NULL : (var = (batch_import_roll_unref (var), NULL)))
#define _import_manifest_unref0(var) ((var == NULL) ? NULL : (var = (import_manifest_unref (var), NULL)))

#define TYPE_BACKGROUND_JOB (background_job_get_type ())
#define BACKGROUND_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKGROUND_JOB, BackgroundJob))
#define BACKGROUND_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKGROUND_JOB, BackgroundJobClass))
#define IS_BACKGROUND_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKGROUND_JOB))
#define IS_BACKGROUND_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKGROUND_JOB))
#define BACKGROUND_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKGROUND_JOB, BackgroundJobClass))

typedef struct _BackgroundJob BackgroundJob;
typedef struct _BackgroundJobClass BackgroundJobClass;

#define TYPE_BACKGROUND_IMPORT_JOB (background_import_job_get_type ())
#define BACKGROUND_IMPORT_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKGROUND_IMPORT_JOB, BackgroundImportJob))
#define BACKGROUND_IMPORT_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKGROUND_IMPORT_JOB, BackgroundImportJobClass))
#define IS_BACKGROUND_IMPORT_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKGROUND_IMPORT_JOB))
#define IS_BACKGROUND_IMPORT_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKGROUND_IMPORT_JOB))
#define BACKGROUND_IMPORT_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKGROUND_IMPORT_JOB, BackgroundImportJobClass))

typedef struct _BackgroundImportJob BackgroundImportJob;
typedef struct _BackgroundImportJobClass BackgroundImportJobClass;
typedef struct _BackgroundJobPrivate BackgroundJobPrivate;
typedef enum  {
	BACKGROUND_JOB_JOB_PRIORITY_HIGHEST = 100,
	BACKGROUND_JOB_JOB_PRIORITY_HIGH = 75,
	BACKGROUND_JOB_JOB_PRIORITY_NORMAL = 50,
	BACKGROUND_JOB_JOB_PRIORITY_LOW = 25,
	BACKGROUND_JOB_JOB_PRIORITY_LOWEST = 0
} BackgroundJobJobPriority;

#define BACKGROUND_JOB_TYPE_JOB_PRIORITY (background_job_job_priority_get_type ())
typedef struct _BackgroundImportJobPrivate BackgroundImportJobPrivate;
typedef void (*CompletionCallback) (BackgroundJob* job, gpointer user_data);
typedef void (*CancellationCallback) (BackgroundJob* job, gpointer user_data);

#define TYPE_WORK_SNIFFER (work_sniffer_get_type ())
#define WORK_SNIFFER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORK_SNIFFER, WorkSniffer))
#define WORK_SNIFFER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORK_SNIFFER, WorkSnifferClass))
#define IS_WORK_SNIFFER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORK_SNIFFER))
#define IS_WORK_SNIFFER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORK_SNIFFER))
#define WORK_SNIFFER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORK_SNIFFER, WorkSnifferClass))

typedef struct _WorkSniffer WorkSniffer;
typedef struct _WorkSnifferClass WorkSnifferClass;
#define _background_job_unref0(var) ((var == NULL) ? NULL : (var = (background_job_unref (var), NULL)))
typedef struct _WorkSnifferPrivate WorkSnifferPrivate;

#define TYPE_FILE_TO_PREPARE (file_to_prepare_get_type ())
#define FILE_TO_PREPARE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FILE_TO_PREPARE, FileToPrepare))
#define FILE_TO_PREPARE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FILE_TO_PREPARE, FileToPrepareClass))
#define IS_FILE_TO_PREPARE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FILE_TO_PREPARE))
#define IS_FILE_TO_PREPARE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FILE_TO_PREPARE))
#define FILE_TO_PREPARE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FILE_TO_PREPARE, FileToPrepareClass))

typedef struct _FileToPrepare FileToPrepare;
typedef struct _FileToPrepareClass FileToPrepareClass;

#define TYPE_PREPARE_FILES_JOB (prepare_files_job_get_type ())
#define PREPARE_FILES_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PREPARE_FILES_JOB, PrepareFilesJob))
#define PREPARE_FILES_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PREPARE_FILES_JOB, PrepareFilesJobClass))
#define IS_PREPARE_FILES_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PREPARE_FILES_JOB))
#define IS_PREPARE_FILES_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PREPARE_FILES_JOB))
#define PREPARE_FILES_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PREPARE_FILES_JOB, PrepareFilesJobClass))

typedef struct _PrepareFilesJob PrepareFilesJob;
typedef struct _PrepareFilesJobClass PrepareFilesJobClass;

#define TYPE_NOTIFICATION_OBJECT (notification_object_get_type ())
#define NOTIFICATION_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NOTIFICATION_OBJECT, NotificationObject))
#define NOTIFICATION_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NOTIFICATION_OBJECT, NotificationObjectClass))
#define IS_NOTIFICATION_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NOTIFICATION_OBJECT))
#define IS_NOTIFICATION_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NOTIFICATION_OBJECT))
#define NOTIFICATION_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NOTIFICATION_OBJECT, NotificationObjectClass))

typedef struct _NotificationObject NotificationObject;
typedef struct _NotificationObjectClass NotificationObjectClass;
typedef void (*NotificationCallback) (BackgroundJob* job, NotificationObject* user, gpointer user_data);

#define TYPE_THUMBNAIL_WRITER_JOB (thumbnail_writer_job_get_type ())
#define THUMBNAIL_WRITER_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL_WRITER_JOB, ThumbnailWriterJob))
#define THUMBNAIL_WRITER_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL_WRITER_JOB, ThumbnailWriterJobClass))
#define IS_THUMBNAIL_WRITER_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL_WRITER_JOB))
#define IS_THUMBNAIL_WRITER_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL_WRITER_JOB))
#define THUMBNAIL_WRITER_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL_WRITER_JOB, ThumbnailWriterJobClass))

typedef struct _ThumbnailWriterJob ThumbnailWriterJob;
typedef struct _ThumbnailWriterJobClass ThumbnailWriterJobClass;
#define _completed_import_object_unref0(var) ((var == NULL) ? NULL : (var = (completed_import_object_unref (var), NULL)))

#define TYPE_PREPARED_FILE_IMPORT_JOB (prepared_file_import_job_get_type ())
#define PREPARED_FILE_IMPORT_JOB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PREPARED_FILE_IMPORT_JOB, PreparedFileImportJob))
#define PREPARED_FILE_IMPORT_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PREPARED_FILE_IMPORT_JOB, PreparedFileImportJobClass))
#define IS_PREPARED_FILE_IMPORT_JOB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PREPARED_FILE_IMPORT_JOB))
#define IS_PREPARED_FILE_IMPORT_JOB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PREPARED_FILE_IMPORT_JOB))
#define PREPARED_FILE_IMPORT_JOB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PREPARED_FILE_IMPORT_JOB, PreparedFileImportJobClass))

typedef struct _PreparedFileImportJob PreparedFileImportJob;
typedef struct _PreparedFileImportJobClass PreparedFileImportJobClass;
#define _prepared_file_unref0(var) ((var == NULL) ? NULL : (var = (prepared_file_unref (var), NULL)))
typedef struct _PreparedFilePrivate PreparedFilePrivate;
typedef enum  {
	PHOTO_FILE_FORMAT_JFIF,
	PHOTO_FILE_FORMAT_RAW,
	PHOTO_FILE_FORMAT_PNG,
	PHOTO_FILE_FORMAT_TIFF,
	PHOTO_FILE_FORMAT_BMP,
	PHOTO_FILE_FORMAT_GIF,
	PHOTO_FILE_FORMAT_WEBP,
	PHOTO_FILE_FORMAT_AVIF,
	PHOTO_FILE_FORMAT_HEIF,
	PHOTO_FILE_FORMAT_JPEGXL,
	PHOTO_FILE_FORMAT_UNKNOWN
} PhotoFileFormat;

#define TYPE_PHOTO_FILE_FORMAT (photo_file_format_get_type ())

#define TYPE_INTERLOCKED_NOTIFICATION_OBJECT (interlocked_notification_object_get_type ())
#define INTERLOCKED_NOTIFICATION_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_INTERLOCKED_NOTIFICATION_OBJECT, InterlockedNotificationObject))
#define INTERLOCKED_NOTIFICATION_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_INTERLOCKED_NOTIFICATION_OBJECT, InterlockedNotificationObjectClass))
#define IS_INTERLOCKED_NOTIFICATION_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_INTERLOCKED_NOTIFICATION_OBJECT))
#define IS_INTERLOCKED_NOTIFICATION_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_INTERLOCKED_NOTIFICATION_OBJECT))
#define INTERLOCKED_NOTIFICATION_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_INTERLOCKED_NOTIFICATION_OBJECT, InterlockedNotificationObjectClass))

typedef struct _InterlockedNotificationObject InterlockedNotificationObject;
typedef struct _InterlockedNotificationObjectClass InterlockedNotificationObjectClass;

#define TYPE_PREPARED_FILE_CLUSTER (prepared_file_cluster_get_type ())
#define PREPARED_FILE_CLUSTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PREPARED_FILE_CLUSTER, PreparedFileCluster))
#define PREPARED_FILE_CLUSTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PREPARED_FILE_CLUSTER, PreparedFileClusterClass))
#define IS_PREPARED_FILE_CLUSTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PREPARED_FILE_CLUSTER))
#define IS_PREPARED_FILE_CLUSTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PREPARED_FILE_CLUSTER))
#define PREPARED_FILE_CLUSTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PREPARED_FILE_CLUSTER, PreparedFileClusterClass))

typedef struct _PreparedFileCluster PreparedFileCluster;
typedef struct _PreparedFileClusterClass PreparedFileClusterClass;
typedef struct _NotificationObjectPrivate NotificationObjectPrivate;
typedef struct _InterlockedNotificationObjectPrivate InterlockedNotificationObjectPrivate;
typedef struct _PreparedFileClusterPrivate PreparedFileClusterPrivate;
#define _notification_object_unref0(var) ((var == NULL) ? NULL : (var = (notification_object_unref (var), NULL)))
typedef enum  {
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_UNKNOWN,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_ONLINE,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_OFFLINE,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_TRASH,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_EDITABLE,
	LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_DEVELOPER
} LibraryPhotoSourceCollectionState;

#define LIBRARY_PHOTO_SOURCE_COLLECTION_TYPE_STATE (library_photo_source_collection_state_get_type ())

#define TYPE_PHOTO_SOURCE (photo_source_get_type ())
#define PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_SOURCE, PhotoSource))
#define PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_SOURCE, PhotoSourceClass))
#define IS_PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_SOURCE))
#define IS_PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_SOURCE))
#define PHOTO_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_SOURCE, PhotoSourceClass))

typedef struct _PhotoSource PhotoSource;
typedef struct _PhotoSourceClass PhotoSourceClass;

#define TYPE_PHOTO (photo_get_type ())
#define PHOTO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO, Photo))
#define PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO, PhotoClass))
#define IS_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO))
#define IS_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO))
#define PHOTO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO, PhotoClass))

typedef struct _Photo Photo;
typedef struct _PhotoClass PhotoClass;

#define TYPE_LIBRARY_PHOTO (library_photo_get_type ())
#define LIBRARY_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_PHOTO, LibraryPhoto))
#define LIBRARY_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_PHOTO, LibraryPhotoClass))
#define IS_LIBRARY_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_PHOTO))
#define IS_LIBRARY_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_PHOTO))
#define LIBRARY_PHOTO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_PHOTO, LibraryPhotoClass))

typedef struct _LibraryPhoto LibraryPhoto;
typedef struct _LibraryPhotoClass LibraryPhotoClass;

#define TYPE_SOURCE_COLLECTION (source_collection_get_type ())
#define SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_COLLECTION, SourceCollection))
#define SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_COLLECTION, SourceCollectionClass))
#define IS_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_COLLECTION))
#define IS_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_COLLECTION))
#define SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_COLLECTION, SourceCollectionClass))

typedef struct _SourceCollection SourceCollection;
typedef struct _SourceCollectionClass SourceCollectionClass;

#define TYPE_DATABASE_SOURCE_COLLECTION (database_source_collection_get_type ())
#define DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollection))
#define DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))
#define IS_DATABASE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_SOURCE_COLLECTION))
#define IS_DATABASE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_SOURCE_COLLECTION))
#define DATABASE_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_SOURCE_COLLECTION, DatabaseSourceCollectionClass))

typedef struct _DatabaseSourceCollection DatabaseSourceCollection;
typedef struct _DatabaseSourceCollectionClass DatabaseSourceCollectionClass;

#define TYPE_MEDIA_SOURCE_COLLECTION (media_source_collection_get_type ())
#define MEDIA_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection))
#define MEDIA_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollectionClass))
#define IS_MEDIA_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_COLLECTION))
#define IS_MEDIA_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_COLLECTION))
#define MEDIA_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollectionClass))

typedef struct _MediaSourceCollection MediaSourceCollection;
typedef struct _MediaSourceCollectionClass MediaSourceCollectionClass;

#define TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION (library_photo_source_collection_get_type ())
#define LIBRARY_PHOTO_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollection))
#define LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollectionClass))
#define IS_LIBRARY_PHOTO_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION))
#define IS_LIBRARY_PHOTO_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION))
#define LIBRARY_PHOTO_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBRARY_PHOTO_SOURCE_COLLECTION, LibraryPhotoSourceCollectionClass))

typedef struct _LibraryPhotoSourceCollection LibraryPhotoSourceCollection;
typedef struct _LibraryPhotoSourceCollectionClass LibraryPhotoSourceCollectionClass;
typedef enum  {
	VIDEO_SOURCE_COLLECTION_STATE_UNKNOWN,
	VIDEO_SOURCE_COLLECTION_STATE_ONLINE,
	VIDEO_SOURCE_COLLECTION_STATE_OFFLINE,
	VIDEO_SOURCE_COLLECTION_STATE_TRASH
} VideoSourceCollectionState;

#define VIDEO_SOURCE_COLLECTION_TYPE_STATE (video_source_collection_state_get_type ())

#define TYPE_VIDEO_SOURCE (video_source_get_type ())
#define VIDEO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIDEO_SOURCE, VideoSource))
#define VIDEO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIDEO_SOURCE, VideoSourceClass))
#define IS_VIDEO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIDEO_SOURCE))
#define IS_VIDEO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIDEO_SOURCE))
#define VIDEO_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIDEO_SOURCE, VideoSourceClass))

typedef struct _VideoSource VideoSource;
typedef struct _VideoSourceClass VideoSourceClass;

#define TYPE_VIDEO (video_get_type ())
#define VIDEO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIDEO, Video))
#define VIDEO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIDEO, VideoClass))
#define IS_VIDEO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIDEO))
#define IS_VIDEO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIDEO))
#define VIDEO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIDEO, VideoClass))

typedef struct _Video Video;
typedef struct _VideoClass VideoClass;

#define TYPE_VIDEO_SOURCE_COLLECTION (video_source_collection_get_type ())
#define VIDEO_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIDEO_SOURCE_COLLECTION, VideoSourceCollection))
#define VIDEO_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIDEO_SOURCE_COLLECTION, VideoSourceCollectionClass))
#define IS_VIDEO_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIDEO_SOURCE_COLLECTION))
#define IS_VIDEO_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIDEO_SOURCE_COLLECTION))
#define VIDEO_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIDEO_SOURCE_COLLECTION, VideoSourceCollectionClass))

typedef struct _VideoSourceCollection VideoSourceCollection;
typedef struct _VideoSourceCollectionClass VideoSourceCollectionClass;

#define TYPE_VIDEO_ID (video_id_get_type ())
typedef struct _VideoID VideoID;

#define TYPE_DATABASE_TABLE (database_table_get_type ())
#define DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_TABLE, DatabaseTable))
#define DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_TABLE, DatabaseTableClass))
#define IS_DATABASE_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_TABLE))
#define IS_DATABASE_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_TABLE))
#define DATABASE_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_TABLE, DatabaseTableClass))

typedef struct _DatabaseTable DatabaseTable;
typedef struct _DatabaseTableClass DatabaseTableClass;

#define TYPE_VIDEO_TABLE (video_table_get_type ())
#define VIDEO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIDEO_TABLE, VideoTable))
#define VIDEO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIDEO_TABLE, VideoTableClass))
#define IS_VIDEO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIDEO_TABLE))
#define IS_VIDEO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIDEO_TABLE))
#define VIDEO_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIDEO_TABLE, VideoTableClass))

typedef struct _VideoTable VideoTable;
typedef struct _VideoTableClass VideoTableClass;
#define _database_table_unref0(var) ((var == NULL) ? NULL : (var = (database_table_unref (var), NULL)))

#define TYPE_SOURCE_HOLDING_TANK (source_holding_tank_get_type ())
#define SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTank))
#define SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTankClass))
#define IS_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_HOLDING_TANK))
#define IS_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_HOLDING_TANK))
#define SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_HOLDING_TANK, SourceHoldingTankClass))

typedef struct _SourceHoldingTank SourceHoldingTank;
typedef struct _SourceHoldingTankClass SourceHoldingTankClass;

#define TYPE_DATABASE_SOURCE_HOLDING_TANK (database_source_holding_tank_get_type ())
#define DATABASE_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTank))
#define DATABASE_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTankClass))
#define IS_DATABASE_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK))
#define IS_DATABASE_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATABASE_SOURCE_HOLDING_TANK))
#define DATABASE_SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATABASE_SOURCE_HOLDING_TANK, DatabaseSourceHoldingTankClass))

typedef struct _DatabaseSourceHoldingTank DatabaseSourceHoldingTank;
typedef struct _DatabaseSourceHoldingTankClass DatabaseSourceHoldingTankClass;

#define TYPE_MEDIA_SOURCE_HOLDING_TANK (media_source_holding_tank_get_type ())
#define MEDIA_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTank))
#define MEDIA_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTankClass))
#define IS_MEDIA_SOURCE_HOLDING_TANK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE_HOLDING_TANK))
#define IS_MEDIA_SOURCE_HOLDING_TANK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE_HOLDING_TANK))
#define MEDIA_SOURCE_HOLDING_TANK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE_HOLDING_TANK, MediaSourceHoldingTankClass))

typedef struct _MediaSourceHoldingTank MediaSourceHoldingTank;
typedef struct _MediaSourceHoldingTankClass MediaSourceHoldingTankClass;
#define _source_holding_tank_unref0(var) ((var == NULL) ? NULL : (var = (source_holding_tank_unref (var), NULL)))

#define TYPE_MONITORABLE (monitorable_get_type ())
#define MONITORABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MONITORABLE, Monitorable))
#define IS_MONITORABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MONITORABLE))
#define MONITORABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MONITORABLE, MonitorableIface))

typedef struct _Monitorable Monitorable;
typedef struct _MonitorableIface MonitorableIface;

#define TYPE_PHOTO_ID (photo_id_get_type ())
typedef struct _PhotoID PhotoID;

#define TYPE_PHOTO_TABLE (photo_table_get_type ())
#define PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_TABLE, PhotoTable))
#define PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_TABLE, PhotoTableClass))
#define IS_PHOTO_TABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_TABLE))
#define IS_PHOTO_TABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_TABLE))
#define PHOTO_TABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_TABLE, PhotoTableClass))

typedef struct _PhotoTable PhotoTable;
typedef struct _PhotoTableClass PhotoTableClass;
typedef struct _BatchImportProcessPreparedFilesData BatchImportProcessPreparedFilesData;
typedef struct _PrepareFilesJobPrivate PrepareFilesJobPrivate;
typedef struct _PreparedFileImportJobPrivate PreparedFileImportJobPrivate;

#define TYPE_READY_FOR_IMPORT (ready_for_import_get_type ())
#define READY_FOR_IMPORT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_READY_FOR_IMPORT, ReadyForImport))
#define READY_FOR_IMPORT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_READY_FOR_IMPORT, ReadyForImportClass))
#define IS_READY_FOR_IMPORT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_READY_FOR_IMPORT))
#define IS_READY_FOR_IMPORT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_READY_FOR_IMPORT))
#define READY_FOR_IMPORT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_READY_FOR_IMPORT, ReadyForImportClass))

typedef struct _ReadyForImport ReadyForImport;
typedef struct _ReadyForImportClass ReadyForImportClass;
typedef struct _ReadyForImportPrivate ReadyForImportPrivate;

#define TYPE_PHOTO_IMPORT_PARAMS (photo_import_params_get_type ())
#define PHOTO_IMPORT_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_IMPORT_PARAMS, PhotoImportParams))
#define PHOTO_IMPORT_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_IMPORT_PARAMS, PhotoImportParamsClass))
#define IS_PHOTO_IMPORT_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_IMPORT_PARAMS))
#define IS_PHOTO_IMPORT_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_IMPORT_PARAMS))
#define PHOTO_IMPORT_PARAMS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_IMPORT_PARAMS, PhotoImportParamsClass))

typedef struct _PhotoImportParams PhotoImportParams;
typedef struct _PhotoImportParamsClass PhotoImportParamsClass;

#define TYPE_VIDEO_IMPORT_PARAMS (video_import_params_get_type ())
#define VIDEO_IMPORT_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIDEO_IMPORT_PARAMS, VideoImportParams))
#define VIDEO_IMPORT_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIDEO_IMPORT_PARAMS, VideoImportParamsClass))
#define IS_VIDEO_IMPORT_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIDEO_IMPORT_PARAMS))
#define IS_VIDEO_IMPORT_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIDEO_IMPORT_PARAMS))
#define VIDEO_IMPORT_PARAMS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIDEO_IMPORT_PARAMS, VideoImportParamsClass))

typedef struct _VideoImportParams VideoImportParams;
typedef struct _VideoImportParamsClass VideoImportParamsClass;

#define TYPE_TOMBSTONE (tombstone_get_type ())
#define TOMBSTONE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TOMBSTONE, Tombstone))
#define TOMBSTONE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TOMBSTONE, TombstoneClass))
#define IS_TOMBSTONE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TOMBSTONE))
#define IS_TOMBSTONE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TOMBSTONE))
#define TOMBSTONE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TOMBSTONE, TombstoneClass))

typedef struct _Tombstone Tombstone;
typedef struct _TombstoneClass TombstoneClass;

#define TYPE_TOMBSTONE_SOURCE_COLLECTION (tombstone_source_collection_get_type ())
#define TOMBSTONE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TOMBSTONE_SOURCE_COLLECTION, TombstoneSourceCollection))
#define TOMBSTONE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TOMBSTONE_SOURCE_COLLECTION, TombstoneSourceCollectionClass))
#define IS_TOMBSTONE_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TOMBSTONE_SOURCE_COLLECTION))
#define IS_TOMBSTONE_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TOMBSTONE_SOURCE_COLLECTION))
#define TOMBSTONE_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TOMBSTONE_SOURCE_COLLECTION, TombstoneSourceCollectionClass))

typedef struct _TombstoneSourceCollection TombstoneSourceCollection;
typedef struct _TombstoneSourceCollectionClass TombstoneSourceCollectionClass;
typedef struct _PhotoImportParamsPrivate PhotoImportParamsPrivate;
typedef enum  {
	PHOTO_FILE_SNIFFER_OPTIONS_GET_ALL = 0x00000000,
	PHOTO_FILE_SNIFFER_OPTIONS_NO_MD5 = 0x00000001
} PhotoFileSnifferOptions;

#define PHOTO_FILE_SNIFFER_TYPE_OPTIONS (photo_file_sniffer_options_get_type ())

#define TYPE_THUMBNAILS (thumbnails_get_type ())
#define THUMBNAILS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAILS, Thumbnails))
#define THUMBNAILS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAILS, ThumbnailsClass))
#define IS_THUMBNAILS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAILS))
#define IS_THUMBNAILS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAILS))
#define THUMBNAILS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAILS, ThumbnailsClass))

typedef struct _Thumbnails Thumbnails;
typedef struct _ThumbnailsClass ThumbnailsClass;

#define TYPE_PHOTO_ROW (photo_row_get_type ())
#define PHOTO_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_ROW, PhotoRow))
#define PHOTO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_ROW, PhotoRowClass))
#define IS_PHOTO_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_ROW))
#define IS_PHOTO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_ROW))
#define PHOTO_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_ROW, PhotoRowClass))

typedef struct _PhotoRow PhotoRow;
typedef struct _PhotoRowClass PhotoRowClass;

#define TYPE_BACKING_PHOTO_ROW (backing_photo_row_get_type ())
#define BACKING_PHOTO_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BACKING_PHOTO_ROW, BackingPhotoRow))
#define BACKING_PHOTO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BACKING_PHOTO_ROW, BackingPhotoRowClass))
#define IS_BACKING_PHOTO_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BACKING_PHOTO_ROW))
#define IS_BACKING_PHOTO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BACKING_PHOTO_ROW))
#define BACKING_PHOTO_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BACKING_PHOTO_ROW, BackingPhotoRowClass))

typedef struct _BackingPhotoRow BackingPhotoRow;
typedef struct _BackingPhotoRowClass BackingPhotoRowClass;
typedef struct _BackingPhotoRowPrivate BackingPhotoRowPrivate;

#define TYPE_BACKING_PHOTO_ID (backing_photo_id_get_type ())
typedef struct _BackingPhotoID BackingPhotoID;

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;
typedef enum  {
	ORIENTATION_MIN = 1,
	ORIENTATION_TOP_LEFT = 1,
	ORIENTATION_TOP_RIGHT = 2,
	ORIENTATION_BOTTOM_RIGHT = 3,
	ORIENTATION_BOTTOM_LEFT = 4,
	ORIENTATION_LEFT_TOP = 5,
	ORIENTATION_RIGHT_TOP = 6,
	ORIENTATION_RIGHT_BOTTOM = 7,
	ORIENTATION_LEFT_BOTTOM = 8,
	ORIENTATION_MAX = 8
} Orientation;

#define TYPE_ORIENTATION (orientation_get_type ())
typedef enum  {
	RAW_DEVELOPER_SHOTWELL = 0,
	RAW_DEVELOPER_CAMERA,
	RAW_DEVELOPER_EMBEDDED
} RawDeveloper;

#define TYPE_RAW_DEVELOPER (raw_developer_get_type ())
#define _backing_photo_row_unref0(var) ((var == NULL) ? NULL : (var = (backing_photo_row_unref (var), NULL)))

#define TYPE_CONFIGURATION_FACADE (configuration_facade_get_type ())
#define CONFIGURATION_FACADE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONFIGURATION_FACADE, ConfigurationFacade))
#define CONFIGURATION_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONFIGURATION_FACADE, ConfigurationFacadeClass))
#define IS_CONFIGURATION_FACADE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONFIGURATION_FACADE))
#define IS_CONFIGURATION_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONFIGURATION_FACADE))
#define CONFIGURATION_FACADE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONFIGURATION_FACADE, ConfigurationFacadeClass))

typedef struct _ConfigurationFacade ConfigurationFacade;
typedef struct _ConfigurationFacadeClass ConfigurationFacadeClass;

#define CONFIG_TYPE_FACADE (config_facade_get_type ())
#define CONFIG_FACADE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONFIG_TYPE_FACADE, ConfigFacade))
#define CONFIG_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONFIG_TYPE_FACADE, ConfigFacadeClass))
#define CONFIG_IS_FACADE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONFIG_TYPE_FACADE))
#define CONFIG_IS_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONFIG_TYPE_FACADE))
#define CONFIG_FACADE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONFIG_TYPE_FACADE, ConfigFacadeClass))

typedef struct _ConfigFacade ConfigFacade;
typedef struct _ConfigFacadeClass ConfigFacadeClass;
#define _thumbnails_unref0(var) ((var == NULL) ? NULL : (var = (thumbnails_unref (var), NULL)))
typedef struct _ThumbnailWriterJobPrivate ThumbnailWriterJobPrivate;
typedef struct _CompletedImportObjectPrivate CompletedImportObjectPrivate;

#define TYPE_MEDIA_COLLECTION_REGISTRY (media_collection_registry_get_type ())
#define MEDIA_COLLECTION_REGISTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_COLLECTION_REGISTRY, MediaCollectionRegistry))
#define MEDIA_COLLECTION_REGISTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_COLLECTION_REGISTRY, MediaCollectionRegistryClass))
#define IS_MEDIA_COLLECTION_REGISTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_COLLECTION_REGISTRY))
#define IS_MEDIA_COLLECTION_REGISTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_COLLECTION_REGISTRY))
#define MEDIA_COLLECTION_REGISTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_COLLECTION_REGISTRY, MediaCollectionRegistryClass))

typedef struct _MediaCollectionRegistry MediaCollectionRegistry;
typedef struct _MediaCollectionRegistryClass MediaCollectionRegistryClass;
#define _media_collection_registry_unref0(var) ((var == NULL) ? NULL : (var = (media_collection_registry_unref (var), NULL)))

#define TYPE_CONTAINER_SOURCE_COLLECTION (container_source_collection_get_type ())
#define CONTAINER_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollection))
#define CONTAINER_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollectionClass))
#define IS_CONTAINER_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONTAINER_SOURCE_COLLECTION))
#define IS_CONTAINER_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONTAINER_SOURCE_COLLECTION))
#define CONTAINER_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONTAINER_SOURCE_COLLECTION, ContainerSourceCollectionClass))

typedef struct _ContainerSourceCollection ContainerSourceCollection;
typedef struct _ContainerSourceCollectionClass ContainerSourceCollectionClass;

#define TYPE_EVENT_SOURCE_COLLECTION (event_source_collection_get_type ())
#define EVENT_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EVENT_SOURCE_COLLECTION, EventSourceCollection))
#define EVENT_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EVENT_SOURCE_COLLECTION, EventSourceCollectionClass))
#define IS_EVENT_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EVENT_SOURCE_COLLECTION))
#define IS_EVENT_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EVENT_SOURCE_COLLECTION))
#define EVENT_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EVENT_SOURCE_COLLECTION, EventSourceCollectionClass))

typedef struct _EventSourceCollection EventSourceCollection;
typedef struct _EventSourceCollectionClass EventSourceCollectionClass;

#define TYPE_TAG_SOURCE_COLLECTION (tag_source_collection_get_type ())
#define TAG_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollection))
#define TAG_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollectionClass))
#define IS_TAG_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TAG_SOURCE_COLLECTION))
#define IS_TAG_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TAG_SOURCE_COLLECTION))
#define TAG_SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TAG_SOURCE_COLLECTION, TagSourceCollectionClass))

typedef struct _TagSourceCollection TagSourceCollection;
typedef struct _TagSourceCollectionClass TagSourceCollectionClass;
enum  {
	BATCH_IMPORT_STARTING_SIGNAL,
	BATCH_IMPORT_PREPARING_SIGNAL,
	BATCH_IMPORT_PROGRESS_SIGNAL,
	BATCH_IMPORT_IMPORTED_SIGNAL,
	BATCH_IMPORT_FATAL_ERROR_SIGNAL,
	BATCH_IMPORT_IMPORT_JOB_FAILED_SIGNAL,
	BATCH_IMPORT_IMPORT_COMPLETE_SIGNAL,
	BATCH_IMPORT_NUM_SIGNALS
};
static guint batch_import_signals[BATCH_IMPORT_NUM_SIGNALS] = {0};
typedef struct _DuplicatedFilePrivate DuplicatedFilePrivate;
enum  {
	DUPLICATED_FILE_0_PROPERTY,
	DUPLICATED_FILE_NUM_PROPERTIES
};
static GParamSpec* duplicated_file_properties[DUPLICATED_FILE_NUM_PROPERTIES];
#define _video_id_free0(var) ((var == NULL) ? NULL : (var = (video_id_free (var), NULL)))
#define _photo_id_free0(var) ((var == NULL) ? NULL : (var = (photo_id_free (var), NULL)))

#define TYPE_ABSTRACT_SEMAPHORE (abstract_semaphore_get_type ())
#define ABSTRACT_SEMAPHORE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ABSTRACT_SEMAPHORE, AbstractSemaphore))
#define ABSTRACT_SEMAPHORE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ABSTRACT_SEMAPHORE, AbstractSemaphoreClass))
#define IS_ABSTRACT_SEMAPHORE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ABSTRACT_SEMAPHORE))
#define IS_ABSTRACT_SEMAPHORE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ABSTRACT_SEMAPHORE))
#define ABSTRACT_SEMAPHORE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ABSTRACT_SEMAPHORE, AbstractSemaphoreClass))

typedef struct _AbstractSemaphore AbstractSemaphore;
typedef struct _AbstractSemaphoreClass AbstractSemaphoreClass;
typedef struct _FileToPreparePrivate FileToPreparePrivate;
#define _file_to_prepare_unref0(var) ((var == NULL) ? NULL : (var = (file_to_prepare_unref (var), NULL)))
typedef struct _ParamSpecFileToPrepare ParamSpecFileToPrepare;

#define TYPE_PHOTO_FILE_FORMAT_PROPERTIES (photo_file_format_properties_get_type ())
#define PHOTO_FILE_FORMAT_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_FORMAT_PROPERTIES, PhotoFileFormatProperties))
#define PHOTO_FILE_FORMAT_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_FORMAT_PROPERTIES, PhotoFileFormatPropertiesClass))
#define IS_PHOTO_FILE_FORMAT_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_FORMAT_PROPERTIES))
#define IS_PHOTO_FILE_FORMAT_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_FORMAT_PROPERTIES))
#define PHOTO_FILE_FORMAT_PROPERTIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_FORMAT_PROPERTIES, PhotoFileFormatPropertiesClass))

typedef struct _PhotoFileFormatProperties PhotoFileFormatProperties;
typedef struct _PhotoFileFormatPropertiesClass PhotoFileFormatPropertiesClass;

#define TYPE_RAW_FILE_FORMAT_PROPERTIES (raw_file_format_properties_get_type ())
#define RAW_FILE_FORMAT_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_RAW_FILE_FORMAT_PROPERTIES, RawFileFormatProperties))
#define RAW_FILE_FORMAT_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_RAW_FILE_FORMAT_PROPERTIES, RawFileFormatPropertiesClass))
#define IS_RAW_FILE_FORMAT_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_RAW_FILE_FORMAT_PROPERTIES))
#define IS_RAW_FILE_FORMAT_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_RAW_FILE_FORMAT_PROPERTIES))
#define RAW_FILE_FORMAT_PROPERTIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_RAW_FILE_FORMAT_PROPERTIES, RawFileFormatPropertiesClass))

typedef struct _RawFileFormatProperties RawFileFormatProperties;
typedef struct _RawFileFormatPropertiesClass RawFileFormatPropertiesClass;
#define _photo_file_format_properties_unref0(var) ((var == NULL) ? NULL : (var = (photo_file_format_properties_unref (var), NULL)))

#define TYPE_JFIF_FILE_FORMAT_PROPERTIES (jfif_file_format_properties_get_type ())
#define JFIF_FILE_FORMAT_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_JFIF_FILE_FORMAT_PROPERTIES, JfifFileFormatProperties))
#define JFIF_FILE_FORMAT_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_JFIF_FILE_FORMAT_PROPERTIES, JfifFileFormatPropertiesClass))
#define IS_JFIF_FILE_FORMAT_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_JFIF_FILE_FORMAT_PROPERTIES))
#define IS_JFIF_FILE_FORMAT_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_JFIF_FILE_FORMAT_PROPERTIES))
#define JFIF_FILE_FORMAT_PROPERTIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_JFIF_FILE_FORMAT_PROPERTIES, JfifFileFormatPropertiesClass))

typedef struct _JfifFileFormatProperties JfifFileFormatProperties;
typedef struct _JfifFileFormatPropertiesClass JfifFileFormatPropertiesClass;
typedef struct _ParamSpecPreparedFile ParamSpecPreparedFile;

#define TYPE_PHOTO_FILE_ADAPTER (photo_file_adapter_get_type ())
#define PHOTO_FILE_ADAPTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapter))
#define PHOTO_FILE_ADAPTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapterClass))
#define IS_PHOTO_FILE_ADAPTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_ADAPTER))
#define IS_PHOTO_FILE_ADAPTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_ADAPTER))
#define PHOTO_FILE_ADAPTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_ADAPTER, PhotoFileAdapterClass))

typedef struct _PhotoFileAdapter PhotoFileAdapter;
typedef struct _PhotoFileAdapterClass PhotoFileAdapterClass;

#define TYPE_PHOTO_FILE_READER (photo_file_reader_get_type ())
#define PHOTO_FILE_READER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_FILE_READER, PhotoFileReader))
#define PHOTO_FILE_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_FILE_READER, PhotoFileReaderClass))
#define IS_PHOTO_FILE_READER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_FILE_READER))
#define IS_PHOTO_FILE_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_FILE_READER))
#define PHOTO_FILE_READER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_FILE_READER, PhotoFileReaderClass))

typedef struct _PhotoFileReader PhotoFileReader;
typedef struct _PhotoFileReaderClass PhotoFileReaderClass;

#define TYPE_PHOTO_METADATA (photo_metadata_get_type ())
#define PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_METADATA, PhotoMetadata))
#define PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_METADATA, PhotoMetadataClass))
#define IS_PHOTO_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_METADATA))
#define IS_PHOTO_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_METADATA))
#define PHOTO_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_METADATA, PhotoMetadataClass))

typedef struct _PhotoMetadata PhotoMetadata;
typedef struct _PhotoMetadataClass PhotoMetadataClass;
#define _media_metadata_unref0(var) ((var == NULL) ? NULL : (var = (media_metadata_unref (var), NULL)))
#define _photo_file_adapter_unref0(var) ((var == NULL) ? NULL : (var = (photo_file_adapter_unref (var), NULL)))
#define _photo_import_params_unref0(var) ((var == NULL) ? NULL : (var = (photo_import_params_unref (var), NULL)))
#define _video_import_params_unref0(var) ((var == NULL) ? NULL : (var = (video_import_params_unref (var), NULL)))
typedef struct _VideoImportParamsPrivate VideoImportParamsPrivate;

#define TYPE_VIDEO_ROW (video_row_get_type ())
#define VIDEO_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIDEO_ROW, VideoRow))
#define VIDEO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIDEO_ROW, VideoRowClass))
#define IS_VIDEO_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIDEO_ROW))
#define IS_VIDEO_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIDEO_ROW))
#define VIDEO_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIDEO_ROW, VideoRowClass))

typedef struct _VideoRow VideoRow;
typedef struct _VideoRowClass VideoRowClass;
typedef struct _ParamSpecReadyForImport ParamSpecReadyForImport;
#define _ready_for_import_unref0(var) ((var == NULL) ? NULL : (var = (ready_for_import_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
typedef enum  {
	THUMBNAIL_CACHE_SIZE_LARGEST = 512,
	THUMBNAIL_CACHE_SIZE_LARGE = 512,
	THUMBNAIL_CACHE_SIZE_BIG = 360,
	THUMBNAIL_CACHE_SIZE_MEDIUM = 128,
	THUMBNAIL_CACHE_SIZE_SMALLEST = 128
} ThumbnailCacheSize;

#define THUMBNAIL_CACHE_TYPE_SIZE (thumbnail_cache_size_get_type ())
typedef struct _ParamSpecCompletedImportObject ParamSpecCompletedImportObject;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

typedef enum  {
	GPHOTO_ERROR_LIBRARY
} GPhotoError;
#define GPHOTO_ERROR gphoto_error_quark ()

struct _BatchImportJob {
	GTypeInstance parent_instance;
	volatile int ref_count;
	BatchImportJobPrivate * priv;
};

struct _BatchImportJobClass {
	GTypeClass parent_class;
	void (*finalize) (BatchImportJob *self);
	gchar* (*get_dest_identifier) (BatchImportJob* self);
	gchar* (*get_source_identifier) (BatchImportJob* self);
	gboolean (*is_directory) (BatchImportJob* self);
	gchar* (*get_basename) (BatchImportJob* self);
	gchar* (*get_path) (BatchImportJob* self);
	DuplicatedFile* (*get_duplicated_file) (BatchImportJob* self);
	GFile* (*get_associated_file) (BatchImportJob* self);
	void (*set_associated) (BatchImportJob* self, BatchImportJob* associated);
	gboolean (*determine_file_size) (BatchImportJob* self, guint64* filesize, GFile** file_or_dir);
	gboolean (*prepare) (BatchImportJob* self, GFile** file_to_import, gboolean* copy_to_library, GError** error);
	gboolean (*complete) (BatchImportJob* self, MediaSource* source, BatchImportRoll* import_roll, GError** error);
	GDateTime* (*get_exposure_time_override) (BatchImportJob* self);
	gboolean (*recurse) (BatchImportJob* self);
};

struct _ParamSpecBatchImportJob {
	GParamSpec parent_instance;
};

struct _FileImportJob {
	BatchImportJob parent_instance;
	FileImportJobPrivate * priv;
};

struct _FileImportJobClass {
	BatchImportJobClass parent_class;
};

struct _FileImportJobPrivate {
	GFile* file_or_dir;
	gboolean copy_to_library;
	FileImportJob* associated;
	gboolean _recurse;
};

struct _ImportID {
	gint64 id;
};

struct _BatchImportRoll {
	GTypeInstance parent_instance;
	volatile int ref_count;
	BatchImportRollPrivate * priv;
	ImportID import_id;
	ViewCollection* generated_events;
};

struct _BatchImportRollClass {
	GTypeClass parent_class;
	void (*finalize) (BatchImportRoll *self);
};

struct _ParamSpecBatchImportRoll {
	GParamSpec parent_instance;
};

struct _BatchImportResult {
	GTypeInstance parent_instance;
	volatile int ref_count;
	BatchImportResultPrivate * priv;
	BatchImportJob* job;
	GFile* file;
	gchar* src_identifier;
	gchar* dest_identifier;
	ImportResult result;
	gchar* errmsg;
	DuplicatedFile* duplicate_of;
};

struct _BatchImportResultClass {
	GTypeClass parent_class;
	void (*finalize) (BatchImportResult *self);
};

struct _ParamSpecBatchImportResult {
	GParamSpec parent_instance;
};

struct _ImportManifest {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ImportManifestPrivate * priv;
	GeeList* imported;
	GeeList* success;
	GeeList* camera_failed;
	GeeList* failed;
	GeeList* write_failed;
	GeeList* skipped_photos;
	GeeList* skipped_files;
	GeeList* aborted;
	GeeList* already_imported;
	GeeList* corrupt_files;
	GeeList* all;
	GTimer* timer;
};

struct _ImportManifestClass {
	GTypeClass parent_class;
	void (*finalize) (ImportManifest *self);
};

struct _ParamSpecImportManifest {
	GParamSpec parent_instance;
};

struct _BatchImport {
	GObject parent_instance;
	BatchImportPrivate * priv;
};

struct _BatchImportClass {
	GObjectClass parent_class;
};

struct _BatchImportPrivate {
	GeeIterable* jobs;
	BatchImportRoll* import_roll;
	gchar* name;
	guint64 completed_bytes;
	guint64 total_bytes;
	BatchImportImportReporter reporter;
	gpointer reporter_target;
	ImportManifest* manifest;
	gboolean scheduled;
	gboolean completed;
	gint file_imports_to_perform;
	gint file_imports_completed;
	GCancellable* cancellable;
	gulong last_preparing_ms;
	GeeHashSet* skipset;
	GeeHashMap* imported_full_md5_table;
	guint throbber_id;
	guint max_outstanding_import_jobs;
	gboolean untrash_duplicates;
	gboolean mark_duplicates_online;
	GeeList* ready_files;
	GeeList* ready_thumbnails;
	GeeList* display_imported_queue;
	GeeList* ready_sources;
};

struct _BackgroundJob {
	GTypeInstance parent_instance;
	volatile int ref_count;
	BackgroundJobPrivate * priv;
};

struct _BackgroundJobClass {
	GTypeClass parent_class;
	void (*finalize) (BackgroundJob *self);
	void (*execute) (BackgroundJob* self);
	BackgroundJobJobPriority (*get_priority) (BackgroundJob* self);
};

struct _BackgroundImportJob {
	BackgroundJob parent_instance;
	BackgroundImportJobPrivate * priv;
	ImportResult abort_flag;
	GeeList* failed;
};

struct _BackgroundImportJobClass {
	BackgroundJobClass parent_class;
};

struct _WorkSniffer {
	BackgroundImportJob parent_instance;
	WorkSnifferPrivate * priv;
	GeeList* files_to_prepare;
	guint64 total_bytes;
};

struct _WorkSnifferClass {
	BackgroundImportJobClass parent_class;
};

struct _PreparedFile {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PreparedFilePrivate * priv;
	BatchImportJob* job;
	ImportResult result;
	GFile* file;
	GFile* associated_file;
	gchar* source_id;
	gchar* dest_id;
	gboolean copy_to_library;
	gchar* exif_md5;
	gchar* thumbnail_md5;
	gchar* full_md5;
	PhotoFileFormat file_format;
	guint64 filesize;
	gboolean is_video;
};

struct _PreparedFileClass {
	GTypeClass parent_class;
	void (*finalize) (PreparedFile *self);
};

struct _NotificationObject {
	GTypeInstance parent_instance;
	volatile int ref_count;
	NotificationObjectPrivate * priv;
};

struct _NotificationObjectClass {
	GTypeClass parent_class;
	void (*finalize) (NotificationObject *self);
};

struct _InterlockedNotificationObject {
	NotificationObject parent_instance;
	InterlockedNotificationObjectPrivate * priv;
};

struct _InterlockedNotificationObjectClass {
	NotificationObjectClass parent_class;
};

struct _PreparedFileCluster {
	InterlockedNotificationObject parent_instance;
	PreparedFileClusterPrivate * priv;
	GeeArrayList* list;
};

struct _PreparedFileClusterClass {
	InterlockedNotificationObjectClass parent_class;
};

struct _VideoID {
	gint64 id;
};

struct _MonitorableIface {
	GTypeInterface parent_iface;
	gboolean (*is_offline) (Monitorable* self);
	void (*mark_online) (Monitorable* self);
	void (*mark_offline) (Monitorable* self);
	void (*set_master_file) (Monitorable* self, GFile* file);
	void (*set_master_timestamp) (Monitorable* self, GFileInfo* info);
};

struct _PhotoID {
	gint64 id;
};

struct _BatchImportProcessPreparedFilesData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	BatchImport* self;
	GeeList* list;
	GeeList* _prepared_file_list;
	gint _prepared_file_size;
	GeeList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _prepared_file_index;
	gint _tmp3_;
	gint _tmp4_;
	PreparedFile* prepared_file;
	GeeList* _tmp5_;
	gpointer _tmp6_;
	BatchImportResult* import_result;
	LibraryPhotoSourceCollectionState photo_state;
	LibraryPhoto* photo;
	LibraryPhotoSourceCollection* _tmp7_;
	PreparedFile* _tmp8_;
	GFile* _tmp9_;
	LibraryPhotoSourceCollectionState _tmp10_;
	LibraryPhoto* _tmp11_;
	LibraryPhoto* _tmp12_;
	PreparedFile* _tmp13_;
	BatchImportJob* _tmp14_;
	PreparedFile* _tmp15_;
	GFile* _tmp16_;
	PreparedFile* _tmp17_;
	GFile* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	PreparedFile* _tmp21_;
	GFile* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	LibraryPhoto* _tmp25_;
	GFile* _tmp26_;
	GFile* _tmp27_;
	DuplicatedFile* _tmp28_;
	DuplicatedFile* _tmp29_;
	BatchImportResult* _tmp30_;
	LibraryPhoto* _tmp31_;
	GEnumValue* _tmp32_;
	BatchImportResult* _tmp33_;
	BatchImportResult* _tmp34_;
	VideoSourceCollectionState video_state;
	Video* video;
	VideoSourceCollection* _tmp35_;
	PreparedFile* _tmp36_;
	GFile* _tmp37_;
	VideoSourceCollectionState _tmp38_;
	Video* _tmp39_;
	Video* _tmp40_;
	PreparedFile* _tmp41_;
	BatchImportJob* _tmp42_;
	PreparedFile* _tmp43_;
	GFile* _tmp44_;
	PreparedFile* _tmp45_;
	GFile* _tmp46_;
	gchar* _tmp47_;
	gchar* _tmp48_;
	PreparedFile* _tmp49_;
	GFile* _tmp50_;
	gchar* _tmp51_;
	gchar* _tmp52_;
	Video* _tmp53_;
	GFile* _tmp54_;
	GFile* _tmp55_;
	DuplicatedFile* _tmp56_;
	DuplicatedFile* _tmp57_;
	BatchImportResult* _tmp58_;
	Video* _tmp59_;
	GEnumValue* _tmp60_;
	BatchImportResult* _tmp61_;
	BatchImportResult* _tmp62_;
	gboolean _tmp63_;
	PreparedFile* _tmp64_;
	PreparedFile* _tmp65_;
	GFile* _tmp66_;
	PreparedFile* _tmp67_;
	const gchar* _tmp68_;
	VideoID* duplicate_ids;
	VideoTable* _tmp69_;
	VideoTable* _tmp70_;
	PreparedFile* _tmp71_;
	GFile* _tmp72_;
	PreparedFile* _tmp73_;
	const gchar* _tmp74_;
	gint _tmp75_;
	VideoID* _tmp76_;
	VideoID* _tmp77_;
	gint _tmp77__length1;
	gint duplicate_ids_length1;
	gint _duplicate_ids_size_;
	VideoID* _tmp78_;
	gint _tmp78__length1;
	DuplicatedFile* duplicated_file;
	VideoID* _tmp79_;
	gint _tmp79__length1;
	VideoID _tmp80_;
	DuplicatedFile* _tmp81_;
	ImportResult result_code;
	Video* dupe_video;
	VideoSourceCollection* _tmp82_;
	MediaSourceHoldingTank* _tmp83_;
	MediaSourceHoldingTank* _tmp84_;
	PreparedFile* _tmp85_;
	GFile* _tmp86_;
	MediaSource* _tmp87_;
	Video* _tmp88_;
	Video* _tmp89_;
	VideoSourceCollection* _tmp90_;
	MediaSourceHoldingTank* _tmp91_;
	MediaSourceHoldingTank* _tmp92_;
	PreparedFile* _tmp93_;
	const gchar* _tmp94_;
	MediaSource* _tmp95_;
	Video* _tmp96_;
	PreparedFile* _tmp97_;
	GFile* _tmp98_;
	gchar* _tmp99_;
	gchar* _tmp100_;
	Video* _tmp101_;
	PreparedFile* _tmp102_;
	GFile* _tmp103_;
	Video* _tmp104_;
	ImportManifest* _tmp105_;
	GeeList* _tmp106_;
	Video* _tmp107_;
	Video* _tmp108_;
	PreparedFile* _tmp109_;
	BatchImportJob* _tmp110_;
	PreparedFile* _tmp111_;
	GFile* _tmp112_;
	PreparedFile* _tmp113_;
	GFile* _tmp114_;
	gchar* _tmp115_;
	gchar* _tmp116_;
	PreparedFile* _tmp117_;
	GFile* _tmp118_;
	gchar* _tmp119_;
	gchar* _tmp120_;
	DuplicatedFile* _tmp121_;
	BatchImportResult* _tmp122_;
	ImportManifest* _tmp123_;
	BatchImportResult* _tmp124_;
	PreparedFile* _tmp125_;
	GFile* _tmp126_;
	GFile* _tmp127_;
	gboolean _tmp128_;
	PreparedFile* _tmp129_;
	BatchImportJob* _tmp130_;
	PreparedFile* _tmp131_;
	GFile* _tmp132_;
	PreparedFile* _tmp133_;
	GFile* _tmp134_;
	gchar* _tmp135_;
	gchar* _tmp136_;
	PreparedFile* _tmp137_;
	GFile* _tmp138_;
	gchar* _tmp139_;
	gchar* _tmp140_;
	PreparedFile* _tmp141_;
	GFile* _tmp142_;
	GFile* _tmp143_;
	DuplicatedFile* _tmp144_;
	DuplicatedFile* _tmp145_;
	BatchImportResult* _tmp146_;
	PreparedFile* _tmp147_;
	GFile* _tmp148_;
	PreparedFile* _tmp149_;
	const gchar* _tmp150_;
	PreparedFile* _tmp151_;
	LibraryPhotoSourceCollection* _tmp152_;
	PreparedFile* _tmp153_;
	GFile* _tmp154_;
	LibraryPhoto* _tmp155_;
	gboolean _tmp156_;
	LibraryPhoto* _tmp157_;
	PreparedFile* _tmp158_;
	const gchar* _tmp159_;
	LibraryPhotoSourceCollection* _tmp160_;
	PreparedFile* _tmp161_;
	const gchar* _tmp162_;
	LibraryPhoto* _tmp163_;
	LibraryPhoto* _tmp164_;
	PreparedFile* _tmp165_;
	GFile* _tmp166_;
	gchar* _tmp167_;
	gchar* _tmp168_;
	LibraryPhoto* _tmp169_;
	PreparedFile* _tmp170_;
	GFile* _tmp171_;
	LibraryPhoto* _tmp172_;
	LibraryPhoto* _tmp173_;
	gboolean _tmp174_;
	LibraryPhoto* _tmp175_;
	LibraryPhotoSourceCollection* _tmp176_;
	PreparedFile* _tmp177_;
	GFile* _tmp178_;
	LibraryPhoto* _tmp179_;
	gboolean _tmp180_;
	LibraryPhoto* _tmp181_;
	PreparedFile* _tmp182_;
	const gchar* _tmp183_;
	LibraryPhotoSourceCollection* _tmp184_;
	PreparedFile* _tmp185_;
	const gchar* _tmp186_;
	LibraryPhoto* _tmp187_;
	LibraryPhoto* _tmp188_;
	PreparedFile* _tmp189_;
	GFile* _tmp190_;
	gchar* _tmp191_;
	gchar* _tmp192_;
	LibraryPhoto* _tmp193_;
	PreparedFile* _tmp194_;
	GFile* _tmp195_;
	LibraryPhoto* _tmp196_;
	LibraryPhoto* _tmp197_;
	PreparedFile* _tmp198_;
	BatchImportJob* _tmp199_;
	PreparedFile* _tmp200_;
	GFile* _tmp201_;
	PreparedFile* _tmp202_;
	GFile* _tmp203_;
	gchar* _tmp204_;
	gchar* _tmp205_;
	PreparedFile* _tmp206_;
	GFile* _tmp207_;
	gchar* _tmp208_;
	gchar* _tmp209_;
	BatchImportResult* _tmp210_;
	ImportManifest* _tmp211_;
	GeeList* _tmp212_;
	LibraryPhoto* _tmp213_;
	ImportManifest* _tmp214_;
	BatchImportResult* _tmp215_;
	LibraryPhoto* _tmp216_;
	PreparedFile* _tmp217_;
	GFile* _tmp218_;
	gchar* _tmp219_;
	gchar* _tmp220_;
	PhotoID* photo_ids;
	PhotoTable* _tmp221_;
	PhotoTable* _tmp222_;
	PreparedFile* _tmp223_;
	GFile* _tmp224_;
	PreparedFile* _tmp225_;
	const gchar* _tmp226_;
	PreparedFile* _tmp227_;
	gint _tmp228_;
	PhotoID* _tmp229_;
	PhotoID* _tmp230_;
	gint _tmp230__length1;
	gint photo_ids_length1;
	gint _photo_ids_size_;
	PhotoID* _tmp231_;
	gint _tmp231__length1;
	DuplicatedFile* _vala1_duplicated_file;
	PhotoID* _tmp232_;
	gint _tmp232__length1;
	PhotoID _tmp233_;
	DuplicatedFile* _tmp234_;
	PreparedFile* _tmp235_;
	BatchImportJob* _tmp236_;
	PreparedFile* _tmp237_;
	GFile* _tmp238_;
	PreparedFile* _tmp239_;
	GFile* _tmp240_;
	gchar* _tmp241_;
	gchar* _tmp242_;
	PreparedFile* _tmp243_;
	GFile* _tmp244_;
	gchar* _tmp245_;
	gchar* _tmp246_;
	DuplicatedFile* _tmp247_;
	BatchImportResult* _tmp248_;
	BatchImportResult* _tmp249_;
	BatchImportResult* _tmp250_;
	GeeList* _tmp251_;
	PreparedFile* _tmp252_;
};

struct _PrepareFilesJob {
	BackgroundImportJob parent_instance;
	PrepareFilesJobPrivate * priv;
	gint prepared_files;
};

struct _PrepareFilesJobClass {
	BackgroundImportJobClass parent_class;
};

struct _PreparedFileImportJob {
	BackgroundJob parent_instance;
	PreparedFileImportJobPrivate * priv;
	PreparedFile* not_ready;
	ReadyForImport* ready;
	BatchImportResult* failed;
};

struct _PreparedFileImportJobClass {
	BackgroundJobClass parent_class;
};

struct _ReadyForImport {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ReadyForImportPrivate * priv;
	GFile* final_file;
	PreparedFile* prepared_file;
	PhotoImportParams* photo_import_params;
	VideoImportParams* video_import_params;
	BatchImportResult* batch_result;
	gboolean is_video;
};

struct _ReadyForImportClass {
	GTypeClass parent_class;
	void (*finalize) (ReadyForImport *self);
};

struct _PhotoImportParams {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PhotoImportParamsPrivate * priv;
	GFile* file;
	GFile* final_associated_file;
	ImportID import_id;
	PhotoFileSnifferOptions sniffer_options;
	gchar* exif_md5;
	gchar* thumbnail_md5;
	gchar* full_md5;
	Thumbnails* thumbnails;
	PhotoRow* row;
	GeeCollection* keywords;
};

struct _PhotoImportParamsClass {
	GTypeClass parent_class;
	void (*finalize) (PhotoImportParams *self);
};

struct _BackingPhotoID {
	gint64 id;
};

struct _Dimensions {
	gint width;
	gint height;
};

struct _BackingPhotoRow {
	GTypeInstance parent_instance;
	volatile int ref_count;
	BackingPhotoRowPrivate * priv;
	BackingPhotoID id;
	gint64 time_created;
	gchar* filepath;
	gint64 filesize;
	GDateTime* timestamp;
	PhotoFileFormat file_format;
	Dimensions dim;
	Orientation original_orientation;
};

struct _BackingPhotoRowClass {
	GTypeClass parent_class;
	void (*finalize) (BackingPhotoRow *self);
};

struct _ThumbnailWriterJob {
	BackgroundImportJob parent_instance;
	ThumbnailWriterJobPrivate * priv;
	CompletedImportObject* completed_import_source;
};

struct _ThumbnailWriterJobClass {
	BackgroundImportJobClass parent_class;
};

struct _CompletedImportObject {
	GTypeInstance parent_instance;
	volatile int ref_count;
	CompletedImportObjectPrivate * priv;
	Thumbnails* thumbnails;
	BatchImportResult* batch_result;
	MediaSource* source;
	BatchImportJob* original_job;
	GdkPixbuf* user_preview;
};

struct _CompletedImportObjectClass {
	GTypeClass parent_class;
	void (*finalize) (CompletedImportObject *self);
};

struct _DuplicatedFile {
	GObject parent_instance;
	DuplicatedFilePrivate * priv;
};

struct _DuplicatedFileClass {
	GObjectClass parent_class;
};

struct _DuplicatedFilePrivate {
	VideoID* video_id;
	PhotoID* photo_id;
	GFile* file;
};

struct _FileToPrepare {
	GTypeInstance parent_instance;
	volatile int ref_count;
	FileToPreparePrivate * priv;
	BatchImportJob* job;
	GFile* file;
	gboolean copy_to_library;
	FileToPrepare* associated;
};

struct _FileToPrepareClass {
	GTypeClass parent_class;
	void (*finalize) (FileToPrepare *self);
};

struct _ParamSpecFileToPrepare {
	GParamSpec parent_instance;
};

struct _WorkSnifferPrivate {
	GeeIterable* jobs;
	GeeHashSet* skipset;
};

struct _ParamSpecPreparedFile {
	GParamSpec parent_instance;
};

struct _PrepareFilesJobPrivate {
	GeeList* files_to_prepare;
	NotificationCallback notification;
	gpointer notification_target;
	GFile* library_dir;
	gint import_file_count;
	gint fail_every;
	gint skip_every;
};

struct _VideoImportParams {
	GTypeInstance parent_instance;
	volatile int ref_count;
	VideoImportParamsPrivate * priv;
	GFile* file;
	ImportID import_id;
	gchar* md5;
	GDateTime* exposure_time_override;
	Thumbnails* thumbnails;
	VideoRow* row;
};

struct _VideoImportParamsClass {
	GTypeClass parent_class;
	void (*finalize) (VideoImportParams *self);
};

struct _ParamSpecReadyForImport {
	GParamSpec parent_instance;
};

struct _PreparedFileImportJobPrivate {
	ImportID import_id;
};

struct _ParamSpecCompletedImportObject {
	GParamSpec parent_instance;
};

static gpointer batch_import_job_parent_class = NULL;
static gint FileImportJob_private_offset;
static gpointer file_import_job_parent_class = NULL;
static gpointer batch_import_roll_parent_class = NULL;
static gpointer batch_import_result_parent_class = NULL;
static gpointer import_manifest_parent_class = NULL;
static gint BatchImport_private_offset;
static gpointer batch_import_parent_class = NULL;
static Workers* batch_import_feeder_workers;
static Workers* batch_import_feeder_workers = NULL;
static Workers* batch_import_import_workers;
static Workers* batch_import_import_workers = NULL;
VALA_EXTERN LibraryPhotoSourceCollection* library_photo_global;
VALA_EXTERN VideoSourceCollection* video_global;
VALA_EXTERN TombstoneSourceCollection* tombstone_global;
VALA_EXTERN EventSourceCollection* event_global;
VALA_EXTERN TagSourceCollection* tag_global;
static gint DuplicatedFile_private_offset;
static gpointer duplicated_file_parent_class = NULL;
static gpointer background_import_job_parent_class = NULL;
static gpointer file_to_prepare_parent_class = NULL;
static gint WorkSniffer_private_offset;
static gpointer work_sniffer_parent_class = NULL;
static gpointer prepared_file_parent_class = NULL;
static gpointer prepared_file_cluster_parent_class = NULL;
static gint PrepareFilesJob_private_offset;
static gpointer prepare_files_job_parent_class = NULL;
static gpointer ready_for_import_parent_class = NULL;
static gint PreparedFileImportJob_private_offset;
static gpointer prepared_file_import_job_parent_class = NULL;
static gpointer completed_import_object_parent_class = NULL;
static gpointer thumbnail_writer_job_parent_class = NULL;

VALA_EXTERN GType import_result_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gchar* import_result_to_string (ImportResult self);
VALA_EXTERN gboolean import_result_is_abort (ImportResult self);
VALA_EXTERN gboolean import_result_is_nonuser_abort (ImportResult self);
VALA_EXTERN ImportResult import_result_convert_error (GError* err,
                                          ImportResult default_result);
VALA_EXTERN GQuark gphoto_error_quark (void);
VALA_EXTERN GType gphoto_error_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gpointer batch_import_job_ref (gpointer instance);
VALA_EXTERN void batch_import_job_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_batch_import_job (const gchar* name,
                                         const gchar* nick,
                                         const gchar* blurb,
                                         GType object_type,
                                         GParamFlags flags);
VALA_EXTERN void value_set_batch_import_job (GValue* value,
                                 gpointer v_object);
VALA_EXTERN void value_take_batch_import_job (GValue* value,
                                  gpointer v_object);
VALA_EXTERN gpointer value_get_batch_import_job (const GValue* value);
VALA_EXTERN GType batch_import_job_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BatchImportJob, batch_import_job_unref)
VALA_EXTERN GType duplicated_file_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DuplicatedFile, g_object_unref)
VALA_EXTERN GType data_object_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DataObject, g_object_unref)
VALA_EXTERN GType data_source_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DataSource, g_object_unref)
VALA_EXTERN GType thumbnail_source_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ThumbnailSource, g_object_unref)
VALA_EXTERN GType media_source_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MediaSource, g_object_unref)
VALA_EXTERN gpointer batch_import_roll_ref (gpointer instance);
VALA_EXTERN void batch_import_roll_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_batch_import_roll (const gchar* name,
                                          const gchar* nick,
                                          const gchar* blurb,
                                          GType object_type,
                                          GParamFlags flags);
VALA_EXTERN void value_set_batch_import_roll (GValue* value,
                                  gpointer v_object);
VALA_EXTERN void value_take_batch_import_roll (GValue* value,
                                   gpointer v_object);
VALA_EXTERN gpointer value_get_batch_import_roll (const GValue* value);
VALA_EXTERN GType batch_import_roll_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BatchImportRoll, batch_import_roll_unref)
VALA_EXTERN gchar* batch_import_job_get_dest_identifier (BatchImportJob* self);
VALA_EXTERN gchar* batch_import_job_get_source_identifier (BatchImportJob* self);
VALA_EXTERN gboolean batch_import_job_is_directory (BatchImportJob* self);
VALA_EXTERN gchar* batch_import_job_get_basename (BatchImportJob* self);
VALA_EXTERN gchar* batch_import_job_get_path (BatchImportJob* self);
VALA_EXTERN DuplicatedFile* batch_import_job_get_duplicated_file (BatchImportJob* self);
VALA_EXTERN GFile* batch_import_job_get_associated_file (BatchImportJob* self);
VALA_EXTERN void batch_import_job_set_associated (BatchImportJob* self,
                                      BatchImportJob* associated);
VALA_EXTERN gboolean batch_import_job_determine_file_size (BatchImportJob* self,
                                               guint64* filesize,
                                               GFile** file_or_dir);
VALA_EXTERN gboolean batch_import_job_prepare (BatchImportJob* self,
                                   GFile** file_to_import,
                                   gboolean* copy_to_library,
                                   GError** error);
VALA_EXTERN gboolean batch_import_job_complete (BatchImportJob* self,
                                    MediaSource* source,
                                    BatchImportRoll* import_roll,
                                    GError** error);
VALA_EXTERN GDateTime* batch_import_job_get_exposure_time_override (BatchImportJob* self);
VALA_EXTERN gboolean batch_import_job_recurse (BatchImportJob* self);
static gchar* batch_import_job_real_get_dest_identifier (BatchImportJob* self);
static gchar* batch_import_job_real_get_source_identifier (BatchImportJob* self);
static gboolean batch_import_job_real_is_directory (BatchImportJob* self);
static gchar* batch_import_job_real_get_basename (BatchImportJob* self);
static gchar* batch_import_job_real_get_path (BatchImportJob* self);
static DuplicatedFile* batch_import_job_real_get_duplicated_file (BatchImportJob* self);
static GFile* batch_import_job_real_get_associated_file (BatchImportJob* self);
static void batch_import_job_real_set_associated (BatchImportJob* self,
                                           BatchImportJob* associated);
static gboolean batch_import_job_real_determine_file_size (BatchImportJob* self,
                                                    guint64* filesize,
                                                    GFile** file_or_dir);
static gboolean batch_import_job_real_prepare (BatchImportJob* self,
                                        GFile** file_to_import,
                                        gboolean* copy_to_library,
                                        GError** error);
static gboolean batch_import_job_real_complete (BatchImportJob* self,
                                         MediaSource* source,
                                         BatchImportRoll* import_roll,
                                         GError** error);
static GDateTime* batch_import_job_real_get_exposure_time_override (BatchImportJob* self);
static gboolean batch_import_job_real_recurse (BatchImportJob* self);
VALA_EXTERN BatchImportJob* batch_import_job_construct (GType object_type);
static void batch_import_job_finalize (BatchImportJob * obj);
static GType batch_import_job_get_type_once (void);
VALA_EXTERN GType file_import_job_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FileImportJob, batch_import_job_unref)
VALA_EXTERN FileImportJob* file_import_job_new (GFile* file_or_dir,
                                    gboolean copy_to_library,
                                    gboolean recurse);
VALA_EXTERN FileImportJob* file_import_job_construct (GType object_type,
                                          GFile* file_or_dir,
                                          gboolean copy_to_library,
                                          gboolean recurse);
static gchar* file_import_job_real_get_dest_identifier (BatchImportJob* base);
static gchar* file_import_job_real_get_source_identifier (BatchImportJob* base);
static gboolean file_import_job_real_is_directory (BatchImportJob* base);
VALA_EXTERN gboolean query_is_directory (GFile* file);
static gchar* file_import_job_real_get_basename (BatchImportJob* base);
static gchar* file_import_job_real_get_path (BatchImportJob* base);
static void file_import_job_real_set_associated (BatchImportJob* base,
                                          BatchImportJob* associated);
static gboolean file_import_job_real_determine_file_size (BatchImportJob* base,
                                                   guint64* filesize,
                                                   GFile** file);
static gboolean file_import_job_real_prepare (BatchImportJob* base,
                                       GFile** file_to_import,
                                       gboolean* copy,
                                       GError** error);
VALA_EXTERN GFile* file_import_job_get_file (FileImportJob* self);
static gboolean file_import_job_real_recurse (BatchImportJob* base);
static void file_import_job_finalize (BatchImportJob * obj);
static GType file_import_job_get_type_once (void);
VALA_EXTERN GType import_id_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ImportID* import_id_dup (const ImportID* self);
VALA_EXTERN void import_id_free (ImportID* self);
VALA_EXTERN gpointer data_collection_ref (gpointer instance);
VALA_EXTERN void data_collection_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_data_collection (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
VALA_EXTERN void value_set_data_collection (GValue* value,
                                gpointer v_object);
VALA_EXTERN void value_take_data_collection (GValue* value,
                                 gpointer v_object);
VALA_EXTERN gpointer value_get_data_collection (const GValue* value);
VALA_EXTERN GType data_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DataCollection, data_collection_unref)
VALA_EXTERN GType view_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ViewCollection, data_collection_unref)
VALA_EXTERN ViewCollection* view_collection_new (const gchar* name);
VALA_EXTERN ViewCollection* view_collection_construct (GType object_type,
                                           const gchar* name);
VALA_EXTERN BatchImportRoll* batch_import_roll_new (void);
VALA_EXTERN BatchImportRoll* batch_import_roll_construct (GType object_type);
VALA_EXTERN void import_id_generate (ImportID* result);
static void batch_import_roll_finalize (BatchImportRoll * obj);
static GType batch_import_roll_get_type_once (void);
VALA_EXTERN gpointer batch_import_result_ref (gpointer instance);
VALA_EXTERN void batch_import_result_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_batch_import_result (const gchar* name,
                                            const gchar* nick,
                                            const gchar* blurb,
                                            GType object_type,
                                            GParamFlags flags);
VALA_EXTERN void value_set_batch_import_result (GValue* value,
                                    gpointer v_object);
VALA_EXTERN void value_take_batch_import_result (GValue* value,
                                     gpointer v_object);
VALA_EXTERN gpointer value_get_batch_import_result (const GValue* value);
VALA_EXTERN GType batch_import_result_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BatchImportResult, batch_import_result_unref)
VALA_EXTERN BatchImportResult* batch_import_result_new (BatchImportJob* job,
                                            GFile* file,
                                            const gchar* src_identifier,
                                            const gchar* dest_identifier,
                                            DuplicatedFile* duplicate_of,
                                            ImportResult _result_);
VALA_EXTERN BatchImportResult* batch_import_result_construct (GType object_type,
                                                  BatchImportJob* job,
                                                  GFile* file,
                                                  const gchar* src_identifier,
                                                  const gchar* dest_identifier,
                                                  DuplicatedFile* duplicate_of,
                                                  ImportResult _result_);
VALA_EXTERN BatchImportResult* batch_import_result_new_from_error (BatchImportJob* job,
                                                       GFile* file,
                                                       const gchar* src_identifier,
                                                       const gchar* dest_identifier,
                                                       GError* err,
                                                       ImportResult default_result);
VALA_EXTERN BatchImportResult* batch_import_result_construct_from_error (GType object_type,
                                                             BatchImportJob* job,
                                                             GFile* file,
                                                             const gchar* src_identifier,
                                                             const gchar* dest_identifier,
                                                             GError* err,
                                                             ImportResult default_result);
static void batch_import_result_finalize (BatchImportResult * obj);
static GType batch_import_result_get_type_once (void);
VALA_EXTERN gpointer import_manifest_ref (gpointer instance);
VALA_EXTERN void import_manifest_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_import_manifest (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
VALA_EXTERN void value_set_import_manifest (GValue* value,
                                gpointer v_object);
VALA_EXTERN void value_take_import_manifest (GValue* value,
                                 gpointer v_object);
VALA_EXTERN gpointer value_get_import_manifest (const GValue* value);
VALA_EXTERN GType import_manifest_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ImportManifest, import_manifest_unref)
VALA_EXTERN ImportManifest* import_manifest_new (GeeList* prefailed,
                                     GeeList* pre_already_imported);
VALA_EXTERN ImportManifest* import_manifest_construct (GType object_type,
                                           GeeList* prefailed,
                                           GeeList* pre_already_imported);
VALA_EXTERN void import_manifest_add_result (ImportManifest* self,
                                 BatchImportResult* batch_result);
static void import_manifest_finalize (ImportManifest * obj);
static GType import_manifest_get_type_once (void);
VALA_EXTERN GType batch_import_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BatchImport, g_object_unref)
VALA_EXTERN gpointer prepared_file_ref (gpointer instance);
VALA_EXTERN void prepared_file_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_prepared_file (const gchar* name,
                                      const gchar* nick,
                                      const gchar* blurb,
                                      GType object_type,
                                      GParamFlags flags);
VALA_EXTERN void value_set_prepared_file (GValue* value,
                              gpointer v_object);
VALA_EXTERN void value_take_prepared_file (GValue* value,
                               gpointer v_object);
VALA_EXTERN gpointer value_get_prepared_file (const GValue* value);
VALA_EXTERN GType prepared_file_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PreparedFile, prepared_file_unref)
VALA_EXTERN gpointer completed_import_object_ref (gpointer instance);
VALA_EXTERN void completed_import_object_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_completed_import_object (const gchar* name,
                                                const gchar* nick,
                                                const gchar* blurb,
                                                GType object_type,
                                                GParamFlags flags);
VALA_EXTERN void value_set_completed_import_object (GValue* value,
                                        gpointer v_object);
VALA_EXTERN void value_take_completed_import_object (GValue* value,
                                         gpointer v_object);
VALA_EXTERN gpointer value_get_completed_import_object (const GValue* value);
VALA_EXTERN GType completed_import_object_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CompletedImportObject, completed_import_object_unref)
VALA_EXTERN gpointer application_ref (gpointer instance);
VALA_EXTERN void application_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_application (const gchar* name,
                                    const gchar* nick,
                                    const gchar* blurb,
                                    GType object_type,
                                    GParamFlags flags);
VALA_EXTERN void value_set_application (GValue* value,
                            gpointer v_object);
VALA_EXTERN void value_take_application (GValue* value,
                             gpointer v_object);
VALA_EXTERN gpointer value_get_application (const GValue* value);
VALA_EXTERN GType application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Application, application_unref)
VALA_EXTERN Application* application_get_instance (void);
VALA_EXTERN void batch_import_user_halt (BatchImport* self);
static void _batch_import_user_halt_application_exiting (Application* _sender,
                                                  gboolean panicked,
                                                  gpointer self);
VALA_EXTERN gpointer workers_ref (gpointer instance);
VALA_EXTERN void workers_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_workers (const gchar* name,
                                const gchar* nick,
                                const gchar* blurb,
                                GType object_type,
                                GParamFlags flags);
VALA_EXTERN void value_set_workers (GValue* value,
                        gpointer v_object);
VALA_EXTERN void value_take_workers (GValue* value,
                         gpointer v_object);
VALA_EXTERN gpointer value_get_workers (const GValue* value);
VALA_EXTERN GType workers_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Workers, workers_unref)
VALA_EXTERN Workers* workers_new (guint max_threads,
                      gboolean exclusive);
VALA_EXTERN Workers* workers_construct (GType object_type,
                            guint max_threads,
                            gboolean exclusive);
VALA_EXTERN guint workers_thread_per_cpu_minus_one (void);
VALA_EXTERN BatchImport* batch_import_new (GeeIterable* jobs,
                               const gchar* name,
                               BatchImportImportReporter reporter,
                               gpointer reporter_target,
                               GeeArrayList* prefailed,
                               GeeArrayList* pre_already_imported,
                               GCancellable* cancellable,
                               BatchImportRoll* import_roll,
                               ImportManifest* skip_manifest);
VALA_EXTERN BatchImport* batch_import_construct (GType object_type,
                                     GeeIterable* jobs,
                                     const gchar* name,
                                     BatchImportImportReporter reporter,
                                     gpointer reporter_target,
                                     GeeArrayList* prefailed,
                                     GeeArrayList* pre_already_imported,
                                     GCancellable* cancellable,
                                     BatchImportRoll* import_roll,
                                     ImportManifest* skip_manifest);
VALA_EXTERN guint file_hash (GFile* file);
static guint _file_hash_gee_hash_data_func (gconstpointer v,
                                     gpointer self);
VALA_EXTERN gboolean file_equal (GFile* a,
                     GFile* b);
static gboolean _file_equal_gee_equal_data_func (gconstpointer a,
                                          gconstpointer b,
                                          gpointer self);
VALA_EXTERN GFile* media_source_get_file (MediaSource* self);
static gboolean batch_import_display_imported_timer (BatchImport* self);
static gboolean _batch_import_display_imported_timer_gsource_func (gpointer self);
VALA_EXTERN gchar* batch_import_get_name (BatchImport* self);
VALA_EXTERN gboolean batch_import_get_untrash_duplicates (BatchImport* self);
VALA_EXTERN void batch_import_set_untrash_duplicates (BatchImport* self,
                                          gboolean untrash_duplicates);
VALA_EXTERN gboolean batch_import_get_mark_duplicates_online (BatchImport* self);
VALA_EXTERN void batch_import_set_mark_duplicates_online (BatchImport* self,
                                              gboolean mark_duplicates_online);
static void batch_import_log_status (BatchImport* self,
                              const gchar* where);
static gboolean batch_import_report_failure (BatchImport* self,
                                      BatchImportResult* import_result);
VALA_EXTERN guint64 query_total_file_size (GFile* file_or_dir,
                               GCancellable* cancellable,
                               GError** error);
static void batch_import_report_progress (BatchImport* self,
                                   guint64 increment_of_progress);
VALA_EXTERN gulong now_ms (void);
VALA_EXTERN gpointer background_job_ref (gpointer instance);
VALA_EXTERN void background_job_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_background_job (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
VALA_EXTERN void value_set_background_job (GValue* value,
                               gpointer v_object);
VALA_EXTERN void value_take_background_job (GValue* value,
                                gpointer v_object);
VALA_EXTERN gpointer value_get_background_job (const GValue* value);
VALA_EXTERN GType background_job_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BackgroundJob, background_job_unref)
VALA_EXTERN GType background_import_job_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BackgroundImportJob, background_job_unref)
static gboolean batch_import_report_failures (BatchImport* self,
                                       BackgroundImportJob* background_job);
VALA_EXTERN GType background_job_job_priority_get_type (void) G_GNUC_CONST ;
static void batch_import_report_completed (BatchImport* self,
                                    const gchar* where);
static void batch_import_flush_ready_sources (BatchImport* self);
static void batch_import_file_import_complete (BatchImport* self);
VALA_EXTERN void batch_import_schedule (BatchImport* self);
VALA_EXTERN void workers_enqueue (Workers* self,
                      BackgroundJob* job);
static void batch_import_on_work_sniffed_out (BatchImport* self,
                                       BackgroundJob* j);
static void _batch_import_on_work_sniffed_out_completion_callback (BackgroundJob* job,
                                                            gpointer self);
static void batch_import_on_sniffer_cancelled (BatchImport* self,
                                        BackgroundJob* j);
static void _batch_import_on_sniffer_cancelled_cancellation_callback (BackgroundJob* job,
                                                               gpointer self);
VALA_EXTERN WorkSniffer* work_sniffer_new (BatchImport* owner,
                               GeeIterable* jobs,
                               CompletionCallback callback,
                               gpointer callback_target,
                               GCancellable* cancellable,
                               CancellationCallback cancellation,
                               gpointer cancellation_target,
                               GeeHashSet* skipset);
VALA_EXTERN WorkSniffer* work_sniffer_construct (GType object_type,
                                     BatchImport* owner,
                                     GeeIterable* jobs,
                                     CompletionCallback callback,
                                     gpointer callback_target,
                                     GCancellable* cancellable,
                                     CancellationCallback cancellation,
                                     gpointer cancellation_target,
                                     GeeHashSet* skipset);
VALA_EXTERN GType work_sniffer_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WorkSniffer, background_job_unref)
static gboolean batch_import_on_sniffer_working (BatchImport* self);
static gboolean _batch_import_on_sniffer_working_gsource_func (gpointer self);
VALA_EXTERN gpointer file_to_prepare_ref (gpointer instance);
VALA_EXTERN void file_to_prepare_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_file_to_prepare (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
VALA_EXTERN void value_set_file_to_prepare (GValue* value,
                                gpointer v_object);
VALA_EXTERN void value_take_file_to_prepare (GValue* value,
                                 gpointer v_object);
VALA_EXTERN gpointer value_get_file_to_prepare (const GValue* value);
VALA_EXTERN GType file_to_prepare_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FileToPrepare, file_to_prepare_unref)
VALA_EXTERN GType prepare_files_job_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PrepareFilesJob, background_job_unref)
VALA_EXTERN gpointer notification_object_ref (gpointer instance);
VALA_EXTERN void notification_object_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_notification_object (const gchar* name,
                                            const gchar* nick,
                                            const gchar* blurb,
                                            GType object_type,
                                            GParamFlags flags);
VALA_EXTERN void value_set_notification_object (GValue* value,
                                    gpointer v_object);
VALA_EXTERN void value_take_notification_object (GValue* value,
                                     gpointer v_object);
VALA_EXTERN gpointer value_get_notification_object (const GValue* value);
VALA_EXTERN GType notification_object_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NotificationObject, notification_object_unref)
static void batch_import_on_file_prepared (BatchImport* self,
                                    BackgroundJob* j,
                                    NotificationObject* user);
static void _batch_import_on_file_prepared_notification_callback (BackgroundJob* job,
                                                           NotificationObject* user,
                                                           gpointer self);
static void batch_import_on_files_prepared (BatchImport* self,
                                     BackgroundJob* j);
static void _batch_import_on_files_prepared_completion_callback (BackgroundJob* job,
                                                          gpointer self);
static void batch_import_on_file_prepare_cancelled (BatchImport* self,
                                             BackgroundJob* j);
static void _batch_import_on_file_prepare_cancelled_cancellation_callback (BackgroundJob* job,
                                                                    gpointer self);
VALA_EXTERN PrepareFilesJob* prepare_files_job_new (BatchImport* owner,
                                        GeeList* files_to_prepare,
                                        NotificationCallback notification,
                                        gpointer notification_target,
                                        CompletionCallback callback,
                                        gpointer callback_target,
                                        GCancellable* cancellable,
                                        CancellationCallback cancellation,
                                        gpointer cancellation_target);
VALA_EXTERN PrepareFilesJob* prepare_files_job_construct (GType object_type,
                                              BatchImport* owner,
                                              GeeList* files_to_prepare,
                                              NotificationCallback notification,
                                              gpointer notification_target,
                                              CompletionCallback callback,
                                              gpointer callback_target,
                                              GCancellable* cancellable,
                                              CancellationCallback cancellation,
                                              gpointer cancellation_target);
static void batch_import_flush_import_jobs (BatchImport* self);
VALA_EXTERN gint workers_get_pending_job_count (Workers* self);
static void batch_import_on_thumbnail_writer_completed (BatchImport* self,
                                                 BackgroundJob* j);
static void _batch_import_on_thumbnail_writer_completed_completion_callback (BackgroundJob* job,
                                                                      gpointer self);
static void batch_import_on_thumbnail_writer_cancelled (BatchImport* self,
                                                 BackgroundJob* j);
static void _batch_import_on_thumbnail_writer_cancelled_cancellation_callback (BackgroundJob* job,
                                                                        gpointer self);
VALA_EXTERN ThumbnailWriterJob* thumbnail_writer_job_new (BatchImport* owner,
                                              CompletedImportObject* completed_import_source,
                                              CompletionCallback callback,
                                              gpointer callback_target,
                                              GCancellable* cancellable,
                                              CancellationCallback cancel_callback,
                                              gpointer cancel_callback_target);
VALA_EXTERN ThumbnailWriterJob* thumbnail_writer_job_construct (GType object_type,
                                                    BatchImport* owner,
                                                    CompletedImportObject* completed_import_source,
                                                    CompletionCallback callback,
                                                    gpointer callback_target,
                                                    GCancellable* cancellable,
                                                    CancellationCallback cancel_callback,
                                                    gpointer cancel_callback_target);
VALA_EXTERN GType thumbnail_writer_job_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ThumbnailWriterJob, background_job_unref)
static void batch_import_on_import_files_completed (BatchImport* self,
                                             BackgroundJob* j);
static void _batch_import_on_import_files_completed_completion_callback (BackgroundJob* job,
                                                                  gpointer self);
static void batch_import_on_import_files_cancelled (BatchImport* self,
                                             BackgroundJob* j);
static void _batch_import_on_import_files_cancelled_cancellation_callback (BackgroundJob* job,
                                                                    gpointer self);
VALA_EXTERN PreparedFileImportJob* prepared_file_import_job_new (BatchImport* owner,
                                                     PreparedFile* prepared_file,
                                                     ImportID* import_id,
                                                     CompletionCallback callback,
                                                     gpointer callback_target,
                                                     GCancellable* cancellable,
                                                     CancellationCallback cancellation,
                                                     gpointer cancellation_target);
VALA_EXTERN PreparedFileImportJob* prepared_file_import_job_construct (GType object_type,
                                                           BatchImport* owner,
                                                           PreparedFile* prepared_file,
                                                           ImportID* import_id,
                                                           CompletionCallback callback,
                                                           gpointer callback_target,
                                                           GCancellable* cancellable,
                                                           CancellationCallback cancellation,
                                                           gpointer cancellation_target);
VALA_EXTERN GType prepared_file_import_job_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PreparedFileImportJob, background_job_unref)
static GFile* batch_import_get_in_current_import (BatchImport* self,
                                           PreparedFile* prepared_file);
VALA_EXTERN GType photo_file_format_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType interlocked_notification_object_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (InterlockedNotificationObject, notification_object_unref)
VALA_EXTERN GType prepared_file_cluster_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PreparedFileCluster, notification_object_unref)
static void batch_import_process_prepared_files (BatchImport* self,
                                          GeeList* list,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_);
static void batch_import_process_prepared_files_finish (BatchImport* self,
                                                 GAsyncResult* _res_);
static void batch_import_process_prepared_files_data_free (gpointer _data);
static gboolean batch_import_process_prepared_files_co (BatchImportProcessPreparedFilesData* _data_);
static gboolean _batch_import_process_prepared_files_co_gsource_func (gpointer self);
VALA_EXTERN GType library_photo_source_collection_state_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType photo_source_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoSource, g_object_unref)
VALA_EXTERN GType photo_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Photo, g_object_unref)
VALA_EXTERN GType library_photo_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LibraryPhoto, g_object_unref)
VALA_EXTERN GType source_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SourceCollection, data_collection_unref)
VALA_EXTERN GType database_source_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DatabaseSourceCollection, data_collection_unref)
VALA_EXTERN GType media_source_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MediaSourceCollection, data_collection_unref)
VALA_EXTERN GType library_photo_source_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LibraryPhotoSourceCollection, data_collection_unref)
VALA_EXTERN LibraryPhoto* library_photo_source_collection_get_state_by_file (LibraryPhotoSourceCollection* self,
                                                                 GFile* file,
                                                                 LibraryPhotoSourceCollectionState* state);
VALA_EXTERN DuplicatedFile* duplicated_file_create_from_file (GFile* file);
VALA_EXTERN GFile* media_source_get_master_file (MediaSource* self);
VALA_EXTERN void media_source_mark_online (MediaSource* self);
VALA_EXTERN GType video_source_collection_state_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType video_source_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VideoSource, g_object_unref)
VALA_EXTERN GType video_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Video, g_object_unref)
VALA_EXTERN GType video_source_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VideoSourceCollection, data_collection_unref)
VALA_EXTERN Video* video_source_collection_get_state_by_file (VideoSourceCollection* self,
                                                  GFile* file,
                                                  VideoSourceCollectionState* state);
VALA_EXTERN gboolean video_is_duplicate (GFile* file,
                             const gchar* full_md5);
VALA_EXTERN GType video_id_get_type (void) G_GNUC_CONST ;
VALA_EXTERN VideoID* video_id_dup (const VideoID* self);
VALA_EXTERN void video_id_free (VideoID* self);
VALA_EXTERN gpointer database_table_ref (gpointer instance);
VALA_EXTERN void database_table_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_database_table (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
VALA_EXTERN void value_set_database_table (GValue* value,
                               gpointer v_object);
VALA_EXTERN void value_take_database_table (GValue* value,
                                gpointer v_object);
VALA_EXTERN gpointer value_get_database_table (const GValue* value);
VALA_EXTERN GType database_table_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DatabaseTable, database_table_unref)
VALA_EXTERN GType video_table_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VideoTable, database_table_unref)
VALA_EXTERN VideoTable* video_table_get_instance (void);
VALA_EXTERN VideoID* video_table_get_duplicate_ids (VideoTable* self,
                                        GFile* file,
                                        const gchar* md5,
                                        gint* result_length1);
VALA_EXTERN DuplicatedFile* duplicated_file_create_from_video_id (VideoID* video_id);
VALA_EXTERN gpointer source_holding_tank_ref (gpointer instance);
VALA_EXTERN void source_holding_tank_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_source_holding_tank (const gchar* name,
                                            const gchar* nick,
                                            const gchar* blurb,
                                            GType object_type,
                                            GParamFlags flags);
VALA_EXTERN void value_set_source_holding_tank (GValue* value,
                                    gpointer v_object);
VALA_EXTERN void value_take_source_holding_tank (GValue* value,
                                     gpointer v_object);
VALA_EXTERN gpointer value_get_source_holding_tank (const GValue* value);
VALA_EXTERN GType source_holding_tank_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SourceHoldingTank, source_holding_tank_unref)
VALA_EXTERN GType database_source_holding_tank_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DatabaseSourceHoldingTank, source_holding_tank_unref)
VALA_EXTERN GType media_source_holding_tank_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MediaSourceHoldingTank, source_holding_tank_unref)
VALA_EXTERN MediaSourceHoldingTank* media_source_collection_get_offline_bin (MediaSourceCollection* self);
VALA_EXTERN MediaSource* media_source_holding_tank_fetch_by_master_file (MediaSourceHoldingTank* self,
                                                             GFile* file);
VALA_EXTERN MediaSource* media_source_holding_tank_fetch_by_md5 (MediaSourceHoldingTank* self,
                                                     const gchar* md5);
VALA_EXTERN GType monitorable_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Monitorable, g_object_unref)
VALA_EXTERN void monitorable_set_master_file (Monitorable* self,
                                  GFile* file);
VALA_EXTERN guint64 media_source_get_filesize (MediaSource* self);
VALA_EXTERN gboolean photo_is_duplicate (GFile* file,
                             const gchar* thumbnail_md5,
                             const gchar* full_md5,
                             PhotoFileFormat file_format);
VALA_EXTERN LibraryPhoto* library_photo_source_collection_get_trashed_by_file (LibraryPhotoSourceCollection* self,
                                                                   GFile* file);
VALA_EXTERN LibraryPhoto* library_photo_source_collection_get_trashed_by_md5 (LibraryPhotoSourceCollection* self,
                                                                  const gchar* md5);
VALA_EXTERN void media_source_untrash (MediaSource* self);
VALA_EXTERN void photo_remove_all_transformations (Photo* self,
                                       gboolean notify);
VALA_EXTERN LibraryPhoto* library_photo_source_collection_get_offline_by_file (LibraryPhotoSourceCollection* self,
                                                                   GFile* file);
VALA_EXTERN LibraryPhoto* library_photo_source_collection_get_offline_by_md5 (LibraryPhotoSourceCollection* self,
                                                                  const gchar* md5);
VALA_EXTERN GType photo_id_get_type (void) G_GNUC_CONST ;
VALA_EXTERN PhotoID* photo_id_dup (const PhotoID* self);
VALA_EXTERN void photo_id_free (PhotoID* self);
VALA_EXTERN GType photo_table_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoTable, database_table_unref)
VALA_EXTERN PhotoTable* photo_table_get_instance (void);
VALA_EXTERN PhotoID* photo_table_get_duplicate_ids (PhotoTable* self,
                                        GFile* file,
                                        const gchar* thumbnail_md5,
                                        const gchar* md5,
                                        PhotoFileFormat file_format,
                                        gint* result_length1);
VALA_EXTERN DuplicatedFile* duplicated_file_create_from_photo_id (PhotoID* photo_id);
static void batch_import_done_preparing_files (BatchImport* self,
                                        BackgroundJob* j,
                                        const gchar* caller);
VALA_EXTERN gpointer ready_for_import_ref (gpointer instance);
VALA_EXTERN void ready_for_import_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_ready_for_import (const gchar* name,
                                         const gchar* nick,
                                         const gchar* blurb,
                                         GType object_type,
                                         GParamFlags flags);
VALA_EXTERN void value_set_ready_for_import (GValue* value,
                                 gpointer v_object);
VALA_EXTERN void value_take_ready_for_import (GValue* value,
                                  gpointer v_object);
VALA_EXTERN gpointer value_get_ready_for_import (const GValue* value);
VALA_EXTERN GType ready_for_import_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ReadyForImport, ready_for_import_unref)
VALA_EXTERN gpointer photo_import_params_ref (gpointer instance);
VALA_EXTERN void photo_import_params_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_photo_import_params (const gchar* name,
                                            const gchar* nick,
                                            const gchar* blurb,
                                            GType object_type,
                                            GParamFlags flags);
VALA_EXTERN void value_set_photo_import_params (GValue* value,
                                    gpointer v_object);
VALA_EXTERN void value_take_photo_import_params (GValue* value,
                                     gpointer v_object);
VALA_EXTERN gpointer value_get_photo_import_params (const GValue* value);
VALA_EXTERN GType photo_import_params_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoImportParams, photo_import_params_unref)
VALA_EXTERN gpointer video_import_params_ref (gpointer instance);
VALA_EXTERN void video_import_params_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_video_import_params (const gchar* name,
                                            const gchar* nick,
                                            const gchar* blurb,
                                            GType object_type,
                                            GParamFlags flags);
VALA_EXTERN void value_set_video_import_params (GValue* value,
                                    gpointer v_object);
VALA_EXTERN void value_take_video_import_params (GValue* value,
                                     gpointer v_object);
VALA_EXTERN gpointer value_get_video_import_params (const GValue* value);
VALA_EXTERN GType video_import_params_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VideoImportParams, video_import_params_unref)
VALA_EXTERN GType tombstone_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Tombstone, g_object_unref)
VALA_EXTERN GType tombstone_source_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TombstoneSourceCollection, data_collection_unref)
VALA_EXTERN Tombstone* tombstone_source_collection_locate (TombstoneSourceCollection* self,
                                               GFile* file);
VALA_EXTERN void tombstone_source_collection_resurrect (TombstoneSourceCollection* self,
                                            Tombstone* tombstone);
VALA_EXTERN ImportResult video_import_create (VideoImportParams* params,
                                  Video** video);
VALA_EXTERN ImportResult library_photo_import_create (PhotoImportParams* params,
                                          LibraryPhoto** photo);
VALA_EXTERN GType photo_file_sniffer_options_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gpointer thumbnails_ref (gpointer instance);
VALA_EXTERN void thumbnails_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_thumbnails (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags);
VALA_EXTERN void value_set_thumbnails (GValue* value,
                           gpointer v_object);
VALA_EXTERN void value_take_thumbnails (GValue* value,
                            gpointer v_object);
VALA_EXTERN gpointer value_get_thumbnails (const GValue* value);
VALA_EXTERN GType thumbnails_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Thumbnails, thumbnails_unref)
VALA_EXTERN gpointer photo_row_ref (gpointer instance);
VALA_EXTERN void photo_row_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_photo_row (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags);
VALA_EXTERN void value_set_photo_row (GValue* value,
                          gpointer v_object);
VALA_EXTERN void value_take_photo_row (GValue* value,
                           gpointer v_object);
VALA_EXTERN gpointer value_get_photo_row (const GValue* value);
VALA_EXTERN GType photo_row_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoRow, photo_row_unref)
VALA_EXTERN gpointer backing_photo_row_ref (gpointer instance);
VALA_EXTERN void backing_photo_row_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_backing_photo_row (const gchar* name,
                                          const gchar* nick,
                                          const gchar* blurb,
                                          GType object_type,
                                          GParamFlags flags);
VALA_EXTERN void value_set_backing_photo_row (GValue* value,
                                  gpointer v_object);
VALA_EXTERN void value_take_backing_photo_row (GValue* value,
                                   gpointer v_object);
VALA_EXTERN gpointer value_get_backing_photo_row (const GValue* value);
VALA_EXTERN GType backing_photo_row_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BackingPhotoRow, backing_photo_row_unref)
VALA_EXTERN BackingPhotoRow* backing_photo_row_new (void);
VALA_EXTERN BackingPhotoRow* backing_photo_row_construct (GType object_type);
VALA_EXTERN GType backing_photo_id_get_type (void) G_GNUC_CONST ;
VALA_EXTERN BackingPhotoID* backing_photo_id_dup (const BackingPhotoID* self);
VALA_EXTERN void backing_photo_id_free (BackingPhotoID* self);
VALA_EXTERN GType dimensions_get_type (void) G_GNUC_CONST ;
VALA_EXTERN Dimensions* dimensions_dup (const Dimensions* self);
VALA_EXTERN void dimensions_free (Dimensions* self);
VALA_EXTERN GType orientation_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType raw_developer_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void photo_add_backing_photo_for_development (Photo* self,
                                              RawDeveloper d,
                                              BackingPhotoRow* bpr,
                                              gboolean notify,
                                              GError** error);
VALA_EXTERN PhotoFileFormat photo_get_master_file_format (Photo* self);
VALA_EXTERN GType configuration_facade_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ConfigurationFacade, g_object_unref)
VALA_EXTERN GType config_facade_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ConfigFacade, g_object_unref)
VALA_EXTERN ConfigFacade* config_facade_get_instance (void);
VALA_EXTERN RawDeveloper configuration_facade_get_default_raw_developer (ConfigurationFacade* self);
VALA_EXTERN gboolean photo_is_raw_developer_available (Photo* self,
                                           RawDeveloper d);
VALA_EXTERN void photo_set_default_raw_developer (Photo* self,
                                      RawDeveloper d);
VALA_EXTERN void photo_set_raw_developer (Photo* self,
                              RawDeveloper d,
                              gboolean notify);
VALA_EXTERN Thumbnails* ready_for_import_get_thumbnails (ReadyForImport* self);
VALA_EXTERN CompletedImportObject* completed_import_object_new (MediaSource* source,
                                                    Thumbnails* thumbnails,
                                                    BatchImportJob* original_job,
                                                    BatchImportResult* import_result);
VALA_EXTERN CompletedImportObject* completed_import_object_construct (GType object_type,
                                                          MediaSource* source,
                                                          Thumbnails* thumbnails,
                                                          BatchImportJob* original_job,
                                                          BatchImportResult* import_result);
VALA_EXTERN BatchImportResult* ready_for_import_abort (ReadyForImport* self);
VALA_EXTERN gchar* data_object_to_string (DataObject* self);
VALA_EXTERN void library_photo_import_failed (LibraryPhoto* photo);
VALA_EXTERN void video_import_failed (Video* video);
VALA_EXTERN gpointer media_collection_registry_ref (gpointer instance);
VALA_EXTERN void media_collection_registry_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_media_collection_registry (const gchar* name,
                                                  const gchar* nick,
                                                  const gchar* blurb,
                                                  GType object_type,
                                                  GParamFlags flags);
VALA_EXTERN void value_set_media_collection_registry (GValue* value,
                                          gpointer v_object);
VALA_EXTERN void value_take_media_collection_registry (GValue* value,
                                           gpointer v_object);
VALA_EXTERN gpointer value_get_media_collection_registry (const GValue* value);
VALA_EXTERN GType media_collection_registry_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MediaCollectionRegistry, media_collection_registry_unref)
VALA_EXTERN MediaCollectionRegistry* media_collection_registry_get_instance (void);
VALA_EXTERN void media_collection_registry_begin_transaction_on_all (MediaCollectionRegistry* self);
VALA_EXTERN GType container_source_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ContainerSourceCollection, data_collection_unref)
VALA_EXTERN GType event_source_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (EventSourceCollection, data_collection_unref)
VALA_EXTERN void data_collection_freeze_notifications (DataCollection* self);
VALA_EXTERN GType tag_source_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TagSourceCollection, data_collection_unref)
VALA_EXTERN void media_source_collection_import_many (MediaSourceCollection* self,
                                          GeeCollection* media);
VALA_EXTERN void event_generate_many_events (GeeCollection* sources,
                                 ViewCollection* events_so_far);
VALA_EXTERN void data_collection_thaw_notifications (DataCollection* self);
VALA_EXTERN void media_collection_registry_commit_transaction_on_all (MediaCollectionRegistry* self);
VALA_EXTERN guint64 media_source_get_master_filesize (MediaSource* self);
static void g_cclosure_user_marshal_VOID__UINT64_UINT64 (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT_INT (GClosure * closure,
                                                      GValue * return_value,
                                                      guint n_param_values,
                                                      const GValue * param_values,
                                                      gpointer invocation_hint,
                                                      gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__ENUM_STRING (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__BATCH_IMPORT_RESULT (GClosure * closure,
                                                        GValue * return_value,
                                                        guint n_param_values,
                                                        const GValue * param_values,
                                                        gpointer invocation_hint,
                                                        gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__IMPORT_MANIFEST_BATCH_IMPORT_ROLL (GClosure * closure,
                                                                      GValue * return_value,
                                                                      guint n_param_values,
                                                                      const GValue * param_values,
                                                                      gpointer invocation_hint,
                                                                      gpointer marshal_data);
static void batch_import_finalize (GObject * obj);
static GType batch_import_get_type_once (void);
static DuplicatedFile* duplicated_file_new (void);
static DuplicatedFile* duplicated_file_construct (GType object_type);
VALA_EXTERN gboolean photo_id_is_valid (PhotoID *self);
VALA_EXTERN gboolean video_id_is_valid (VideoID *self);
VALA_EXTERN GFile* duplicated_file_get_file (DuplicatedFile* self);
VALA_EXTERN LibraryPhoto* library_photo_source_collection_fetch (LibraryPhotoSourceCollection* self,
                                                     PhotoID* photo_id);
VALA_EXTERN Video* video_source_collection_fetch (VideoSourceCollection* self,
                                      VideoID* video_id);
static void duplicated_file_finalize (GObject * obj);
static GType duplicated_file_get_type_once (void);
VALA_EXTERN BackgroundImportJob* background_import_job_construct (GType object_type,
                                                      BatchImport* owner,
                                                      CompletionCallback callback,
                                                      gpointer callback_target,
                                                      GCancellable* cancellable,
                                                      CancellationCallback cancellation,
                                                      gpointer cancellation_target);
VALA_EXTERN gpointer abstract_semaphore_ref (gpointer instance);
VALA_EXTERN void abstract_semaphore_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_abstract_semaphore (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags);
VALA_EXTERN void value_set_abstract_semaphore (GValue* value,
                                   gpointer v_object);
VALA_EXTERN void value_take_abstract_semaphore (GValue* value,
                                    gpointer v_object);
VALA_EXTERN gpointer value_get_abstract_semaphore (const GValue* value);
VALA_EXTERN GType abstract_semaphore_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AbstractSemaphore, abstract_semaphore_unref)
VALA_EXTERN BackgroundJob* background_job_construct (GType object_type,
                                         GObject* owner,
                                         CompletionCallback callback,
                                         gpointer callback_target,
                                         GCancellable* cancellable,
                                         CancellationCallback cancellation,
                                         gpointer cancellation_target,
                                         AbstractSemaphore* completion_semaphore);
VALA_EXTERN ImportResult background_import_job_abort_check (BackgroundImportJob* self);
VALA_EXTERN gboolean background_job_is_cancelled (BackgroundJob* self);
VALA_EXTERN void background_import_job_abort (BackgroundImportJob* self,
                                  ImportResult _result_);
VALA_EXTERN void background_import_job_report_failure (BackgroundImportJob* self,
                                           BatchImportJob* job,
                                           GFile* file,
                                           const gchar* src_identifier,
                                           const gchar* dest_identifier,
                                           ImportResult _result_);
VALA_EXTERN void background_import_job_report_error (BackgroundImportJob* self,
                                         BatchImportJob* job,
                                         GFile* file,
                                         const gchar* src_identifier,
                                         const gchar* dest_identifier,
                                         GError* err,
                                         ImportResult default_result);
static void background_import_job_finalize (BackgroundJob * obj);
static GType background_import_job_get_type_once (void);
VALA_EXTERN FileToPrepare* file_to_prepare_new (BatchImportJob* job,
                                    GFile* file,
                                    gboolean copy_to_library);
VALA_EXTERN FileToPrepare* file_to_prepare_construct (GType object_type,
                                          BatchImportJob* job,
                                          GFile* file,
                                          gboolean copy_to_library);
VALA_EXTERN void file_to_prepare_set_associated (FileToPrepare* self,
                                     FileToPrepare* a);
VALA_EXTERN gchar* file_to_prepare_get_parent_path (FileToPrepare* self);
VALA_EXTERN gchar* file_to_prepare_get_path (FileToPrepare* self);
VALA_EXTERN gchar* file_to_prepare_get_basename (FileToPrepare* self);
VALA_EXTERN gboolean file_to_prepare_is_directory (FileToPrepare* self);
static void file_to_prepare_finalize (FileToPrepare * obj);
static GType file_to_prepare_get_type_once (void);
VALA_EXTERN void background_job_execute (BackgroundJob* self);
static void work_sniffer_real_execute (BackgroundJob* base);
static void work_sniffer_sniff_job (WorkSniffer* self,
                             BatchImportJob* job,
                             GError** error);
static gint __lambda12_ (WorkSniffer* self,
                  FileToPrepare* a,
                  FileToPrepare* b);
VALA_EXTERN gint utf8_cs_compare (const gchar* a,
                      const gchar* b);
static gint ___lambda12__gcompare_data_func (gconstpointer a,
                                      gconstpointer b,
                                      gpointer self);
VALA_EXTERN void disassemble_filename (const gchar* basename,
                           gchar** name,
                           gchar** ext);
VALA_EXTERN gboolean is_string_empty (const gchar* s);
VALA_EXTERN gpointer photo_file_format_properties_ref (gpointer instance);
VALA_EXTERN void photo_file_format_properties_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_photo_file_format_properties (const gchar* name,
                                                     const gchar* nick,
                                                     const gchar* blurb,
                                                     GType object_type,
                                                     GParamFlags flags);
VALA_EXTERN void value_set_photo_file_format_properties (GValue* value,
                                             gpointer v_object);
VALA_EXTERN void value_take_photo_file_format_properties (GValue* value,
                                              gpointer v_object);
VALA_EXTERN gpointer value_get_photo_file_format_properties (const GValue* value);
VALA_EXTERN GType photo_file_format_properties_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoFileFormatProperties, photo_file_format_properties_unref)
VALA_EXTERN GType raw_file_format_properties_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (RawFileFormatProperties, photo_file_format_properties_unref)
VALA_EXTERN RawFileFormatProperties* raw_file_format_properties_get_instance (void);
VALA_EXTERN gboolean photo_file_format_properties_is_recognized_extension (PhotoFileFormatProperties* self,
                                                               const gchar* ext);
static gboolean work_sniffer_is_paired (WorkSniffer* self,
                                 FileToPrepare* raw,
                                 FileToPrepare* maybe_paired);
VALA_EXTERN GType jfif_file_format_properties_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (JfifFileFormatProperties, photo_file_format_properties_unref)
VALA_EXTERN JfifFileFormatProperties* jfif_file_format_properties_get_instance (void);
VALA_EXTERN void work_sniffer_search_dir (WorkSniffer* self,
                              BatchImportJob* job,
                              GFile* dir,
                              gboolean copy_to_library,
                              gboolean recurse,
                              GError** error);
VALA_EXTERN GCancellable* background_job_get_cancellable (BackgroundJob* self);
VALA_EXTERN gboolean photo_is_file_image (GFile* file);
VALA_EXTERN gboolean photo_file_format_is_file_supported (GFile* file);
VALA_EXTERN gboolean video_reader_is_supported_video_file (GFile* file);
static void work_sniffer_finalize (BackgroundJob * obj);
static GType work_sniffer_get_type_once (void);
VALA_EXTERN PreparedFile* prepared_file_new (BatchImportJob* job,
                                 GFile* file,
                                 GFile* associated_file,
                                 const gchar* source_id,
                                 const gchar* dest_id,
                                 gboolean copy_to_library,
                                 const gchar* exif_md5,
                                 const gchar* thumbnail_md5,
                                 const gchar* full_md5,
                                 PhotoFileFormat file_format,
                                 guint64 filesize,
                                 gboolean is_video);
VALA_EXTERN PreparedFile* prepared_file_construct (GType object_type,
                                       BatchImportJob* job,
                                       GFile* file,
                                       GFile* associated_file,
                                       const gchar* source_id,
                                       const gchar* dest_id,
                                       gboolean copy_to_library,
                                       const gchar* exif_md5,
                                       const gchar* thumbnail_md5,
                                       const gchar* full_md5,
                                       PhotoFileFormat file_format,
                                       guint64 filesize,
                                       gboolean is_video);
static void prepared_file_finalize (PreparedFile * obj);
static GType prepared_file_get_type_once (void);
VALA_EXTERN PreparedFileCluster* prepared_file_cluster_new (GeeArrayList* list);
VALA_EXTERN PreparedFileCluster* prepared_file_cluster_construct (GType object_type,
                                                      GeeArrayList* list);
VALA_EXTERN InterlockedNotificationObject* interlocked_notification_object_construct (GType object_type);
static void prepared_file_cluster_finalize (NotificationObject * obj);
static GType prepared_file_cluster_get_type_once (void);
VALA_EXTERN GFile* app_dirs_get_import_dir (void);
static gint prepare_files_job_get_test_variable (const gchar* name);
VALA_EXTERN void background_job_set_notification_priority (BackgroundJob* self,
                                               gint priority);
static void prepare_files_job_real_execute (BackgroundJob* base);
static gboolean prepare_files_job_create_file (PrepareFilesJob* self,
                                        BatchImportJob* job,
                                        GFile** file,
                                        gboolean* copy_to_library);
static ImportResult prepare_files_job_prepare_file (PrepareFilesJob* self,
                                             BatchImportJob* job,
                                             GFile* file,
                                             GFile* associated_file,
                                             gboolean copy_to_library,
                                             PreparedFile** prepared_file);
VALA_EXTERN void background_job_notify (BackgroundJob* self,
                            NotificationCallback callback,
                            gpointer callback_target,
                            NotificationObject* user);
VALA_EXTERN gchar* md5_file (GFile* file,
                 GError** error);
VALA_EXTERN PhotoFileFormat photo_file_format_get_by_file_extension (GFile* file);
VALA_EXTERN gpointer photo_file_adapter_ref (gpointer instance);
VALA_EXTERN void photo_file_adapter_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_photo_file_adapter (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags);
VALA_EXTERN void value_set_photo_file_adapter (GValue* value,
                                   gpointer v_object);
VALA_EXTERN void value_take_photo_file_adapter (GValue* value,
                                    gpointer v_object);
VALA_EXTERN gpointer value_get_photo_file_adapter (const GValue* value);
VALA_EXTERN GType photo_file_adapter_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoFileAdapter, photo_file_adapter_unref)
VALA_EXTERN GType photo_file_reader_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoFileReader, photo_file_adapter_unref)
VALA_EXTERN PhotoFileReader* photo_file_format_create_reader (PhotoFileFormat self,
                                                  const gchar* filepath);
VALA_EXTERN GType photo_metadata_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoMetadata, media_metadata_unref)
VALA_EXTERN PhotoMetadata* photo_file_reader_read_metadata (PhotoFileReader* self,
                                                GError** error);
VALA_EXTERN gchar* photo_metadata_exif_hash (PhotoMetadata* self);
VALA_EXTERN gchar* photo_metadata_thumbnail_hash (PhotoMetadata* self);
static void prepare_files_job_finalize (BackgroundJob * obj);
static GType prepare_files_job_get_type_once (void);
VALA_EXTERN ReadyForImport* ready_for_import_new (GFile* final_file,
                                      PreparedFile* prepared_file,
                                      PhotoImportParams* photo_import_params,
                                      VideoImportParams* video_import_params,
                                      BatchImportResult* batch_result);
VALA_EXTERN ReadyForImport* ready_for_import_construct (GType object_type,
                                            GFile* final_file,
                                            PreparedFile* prepared_file,
                                            PhotoImportParams* photo_import_params,
                                            VideoImportParams* video_import_params,
                                            BatchImportResult* batch_result);
VALA_EXTERN gpointer video_row_ref (gpointer instance);
VALA_EXTERN void video_row_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_video_row (const gchar* name,
                                  const gchar* nick,
                                  const gchar* blurb,
                                  GType object_type,
                                  GParamFlags flags);
VALA_EXTERN void value_set_video_row (GValue* value,
                          gpointer v_object);
VALA_EXTERN void value_take_video_row (GValue* value,
                           gpointer v_object);
VALA_EXTERN gpointer value_get_video_row (const GValue* value);
VALA_EXTERN GType video_row_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VideoRow, video_row_unref)
static void ready_for_import_finalize (ReadyForImport * obj);
static GType ready_for_import_get_type_once (void);
VALA_EXTERN void background_job_set_completion_priority (BackgroundJob* self,
                                             gint priority);
static void prepared_file_import_job_real_execute (BackgroundJob* base);
VALA_EXTERN GFile* library_files_duplicate (GFile* src,
                                GFileProgressCallback progress_callback,
                                gpointer progress_callback_target,
                                gboolean blacklist,
                                GError** error);
VALA_EXTERN Thumbnails* thumbnails_new (void);
VALA_EXTERN Thumbnails* thumbnails_construct (GType object_type);
VALA_EXTERN VideoImportParams* video_import_params_new (GFile* file,
                                            ImportID* import_id,
                                            const gchar* md5,
                                            Thumbnails* thumbnails,
                                            GDateTime* exposure_time_override);
VALA_EXTERN VideoImportParams* video_import_params_construct (GType object_type,
                                                  GFile* file,
                                                  ImportID* import_id,
                                                  const gchar* md5,
                                                  Thumbnails* thumbnails,
                                                  GDateTime* exposure_time_override);
VALA_EXTERN ImportResult video_reader_prepare_for_import (VideoImportParams* params);
VALA_EXTERN PhotoImportParams* photo_import_params_new (GFile* file,
                                            GFile* final_associated_file,
                                            ImportID* import_id,
                                            PhotoFileSnifferOptions sniffer_options,
                                            const gchar* exif_md5,
                                            const gchar* thumbnail_md5,
                                            const gchar* full_md5,
                                            Thumbnails* thumbnails);
VALA_EXTERN PhotoImportParams* photo_import_params_construct (GType object_type,
                                                  GFile* file,
                                                  GFile* final_associated_file,
                                                  ImportID* import_id,
                                                  PhotoFileSnifferOptions sniffer_options,
                                                  const gchar* exif_md5,
                                                  const gchar* thumbnail_md5,
                                                  const gchar* full_md5,
                                                  Thumbnails* thumbnails);
VALA_EXTERN ImportResult photo_prepare_for_import (PhotoImportParams* params);
static void prepared_file_import_job_finalize (BackgroundJob * obj);
static GType prepared_file_import_job_get_type_once (void);
VALA_EXTERN GType thumbnail_cache_size_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GdkPixbuf* thumbnails_get (Thumbnails* self,
                           ThumbnailCacheSize size);
static void completed_import_object_finalize (CompletedImportObject * obj);
static GType completed_import_object_get_type_once (void);
static void thumbnail_writer_job_real_execute (BackgroundJob* base);
VALA_EXTERN void thumbnail_cache_import_thumbnails (ThumbnailSource* source,
                                        Thumbnails* thumbnails,
                                        gboolean force,
                                        GError** error);
static void thumbnail_writer_job_finalize (BackgroundJob * obj);
static GType thumbnail_writer_job_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

gchar*
import_result_to_string (ImportResult self)
{
	gchar* result;
#line 24 "../src/BatchImport.vala"
	switch (self) {
#line 24 "../src/BatchImport.vala"
		case IMPORT_RESULT_SUCCESS:
#line 2816 "BatchImport.c"
		{
			gchar* _tmp0_;
#line 26 "../src/BatchImport.vala"
			_tmp0_ = g_strdup (_ ("Success"));
#line 26 "../src/BatchImport.vala"
			result = _tmp0_;
#line 26 "../src/BatchImport.vala"
			return result;
#line 2825 "BatchImport.c"
		}
#line 24 "../src/BatchImport.vala"
		case IMPORT_RESULT_FILE_ERROR:
#line 2829 "BatchImport.c"
		{
			gchar* _tmp1_;
#line 29 "../src/BatchImport.vala"
			_tmp1_ = g_strdup (_ ("File error"));
#line 29 "../src/BatchImport.vala"
			result = _tmp1_;
#line 29 "../src/BatchImport.vala"
			return result;
#line 2838 "BatchImport.c"
		}
#line 24 "../src/BatchImport.vala"
		case IMPORT_RESULT_DECODE_ERROR:
#line 2842 "BatchImport.c"
		{
			gchar* _tmp2_;
#line 32 "../src/BatchImport.vala"
			_tmp2_ = g_strdup (_ ("Unable to decode file"));
#line 32 "../src/BatchImport.vala"
			result = _tmp2_;
#line 32 "../src/BatchImport.vala"
			return result;
#line 2851 "BatchImport.c"
		}
#line 24 "../src/BatchImport.vala"
		case IMPORT_RESULT_DATABASE_ERROR:
#line 2855 "BatchImport.c"
		{
			gchar* _tmp3_;
#line 35 "../src/BatchImport.vala"
			_tmp3_ = g_strdup (_ ("Database error"));
#line 35 "../src/BatchImport.vala"
			result = _tmp3_;
#line 35 "../src/BatchImport.vala"
			return result;
#line 2864 "BatchImport.c"
		}
#line 24 "../src/BatchImport.vala"
		case IMPORT_RESULT_USER_ABORT:
#line 2868 "BatchImport.c"
		{
			gchar* _tmp4_;
#line 38 "../src/BatchImport.vala"
			_tmp4_ = g_strdup (_ ("User aborted import"));
#line 38 "../src/BatchImport.vala"
			result = _tmp4_;
#line 38 "../src/BatchImport.vala"
			return result;
#line 2877 "BatchImport.c"
		}
#line 24 "../src/BatchImport.vala"
		case IMPORT_RESULT_NOT_A_FILE:
#line 2881 "BatchImport.c"
		{
			gchar* _tmp5_;
#line 41 "../src/BatchImport.vala"
			_tmp5_ = g_strdup (_ ("Not a file"));
#line 41 "../src/BatchImport.vala"
			result = _tmp5_;
#line 41 "../src/BatchImport.vala"
			return result;
#line 2890 "BatchImport.c"
		}
#line 24 "../src/BatchImport.vala"
		case IMPORT_RESULT_PHOTO_EXISTS:
#line 2894 "BatchImport.c"
		{
			gchar* _tmp6_;
#line 44 "../src/BatchImport.vala"
			_tmp6_ = g_strdup (_ ("File already exists in database"));
#line 44 "../src/BatchImport.vala"
			result = _tmp6_;
#line 44 "../src/BatchImport.vala"
			return result;
#line 2903 "BatchImport.c"
		}
#line 24 "../src/BatchImport.vala"
		case IMPORT_RESULT_UNSUPPORTED_FORMAT:
#line 2907 "BatchImport.c"
		{
			gchar* _tmp7_;
#line 47 "../src/BatchImport.vala"
			_tmp7_ = g_strdup (_ ("Unsupported file format"));
#line 47 "../src/BatchImport.vala"
			result = _tmp7_;
#line 47 "../src/BatchImport.vala"
			return result;
#line 2916 "BatchImport.c"
		}
#line 24 "../src/BatchImport.vala"
		case IMPORT_RESULT_NOT_AN_IMAGE:
#line 2920 "BatchImport.c"
		{
			gchar* _tmp8_;
#line 50 "../src/BatchImport.vala"
			_tmp8_ = g_strdup (_ ("Not an image file"));
#line 50 "../src/BatchImport.vala"
			result = _tmp8_;
#line 50 "../src/BatchImport.vala"
			return result;
#line 2929 "BatchImport.c"
		}
#line 24 "../src/BatchImport.vala"
		case IMPORT_RESULT_DISK_FAILURE:
#line 2933 "BatchImport.c"
		{
			gchar* _tmp9_;
#line 53 "../src/BatchImport.vala"
			_tmp9_ = g_strdup (_ ("Disk failure"));
#line 53 "../src/BatchImport.vala"
			result = _tmp9_;
#line 53 "../src/BatchImport.vala"
			return result;
#line 2942 "BatchImport.c"
		}
#line 24 "../src/BatchImport.vala"
		case IMPORT_RESULT_DISK_FULL:
#line 2946 "BatchImport.c"
		{
			gchar* _tmp10_;
#line 56 "../src/BatchImport.vala"
			_tmp10_ = g_strdup (_ ("Disk full"));
#line 56 "../src/BatchImport.vala"
			result = _tmp10_;
#line 56 "../src/BatchImport.vala"
			return result;
#line 2955 "BatchImport.c"
		}
#line 24 "../src/BatchImport.vala"
		case IMPORT_RESULT_CAMERA_ERROR:
#line 2959 "BatchImport.c"
		{
			gchar* _tmp11_;
#line 59 "../src/BatchImport.vala"
			_tmp11_ = g_strdup (_ ("Camera error"));
#line 59 "../src/BatchImport.vala"
			result = _tmp11_;
#line 59 "../src/BatchImport.vala"
			return result;
#line 2968 "BatchImport.c"
		}
#line 24 "../src/BatchImport.vala"
		case IMPORT_RESULT_FILE_WRITE_ERROR:
#line 2972 "BatchImport.c"
		{
			gchar* _tmp12_;
#line 62 "../src/BatchImport.vala"
			_tmp12_ = g_strdup (_ ("File write error"));
#line 62 "../src/BatchImport.vala"
			result = _tmp12_;
#line 62 "../src/BatchImport.vala"
			return result;
#line 2981 "BatchImport.c"
		}
#line 24 "../src/BatchImport.vala"
		case IMPORT_RESULT_PIXBUF_CORRUPT_IMAGE:
#line 2985 "BatchImport.c"
		{
			gchar* _tmp13_;
#line 65 "../src/BatchImport.vala"
			_tmp13_ = g_strdup (_ ("Corrupt image file"));
#line 65 "../src/BatchImport.vala"
			result = _tmp13_;
#line 65 "../src/BatchImport.vala"
			return result;
#line 2994 "BatchImport.c"
		}
		default:
		{
			gchar* _tmp14_;
#line 68 "../src/BatchImport.vala"
			_tmp14_ = g_strdup_printf (_ ("Imported failed (%d)"), (gint) self);
#line 68 "../src/BatchImport.vala"
			result = _tmp14_;
#line 68 "../src/BatchImport.vala"
			return result;
#line 3005 "BatchImport.c"
		}
	}
}

gboolean
import_result_is_abort (ImportResult self)
{
	gboolean result;
#line 73 "../src/BatchImport.vala"
	switch (self) {
#line 73 "../src/BatchImport.vala"
		case IMPORT_RESULT_DISK_FULL:
#line 73 "../src/BatchImport.vala"
		case IMPORT_RESULT_DISK_FAILURE:
#line 73 "../src/BatchImport.vala"
		case IMPORT_RESULT_USER_ABORT:
#line 3022 "BatchImport.c"
		{
#line 77 "../src/BatchImport.vala"
			result = TRUE;
#line 77 "../src/BatchImport.vala"
			return result;
#line 3028 "BatchImport.c"
		}
		default:
		{
#line 80 "../src/BatchImport.vala"
			result = FALSE;
#line 80 "../src/BatchImport.vala"
			return result;
#line 3036 "BatchImport.c"
		}
	}
}

gboolean
import_result_is_nonuser_abort (ImportResult self)
{
	gboolean result;
#line 85 "../src/BatchImport.vala"
	switch (self) {
#line 85 "../src/BatchImport.vala"
		case IMPORT_RESULT_DISK_FULL:
#line 85 "../src/BatchImport.vala"
		case IMPORT_RESULT_DISK_FAILURE:
#line 3051 "BatchImport.c"
		{
#line 88 "../src/BatchImport.vala"
			result = TRUE;
#line 88 "../src/BatchImport.vala"
			return result;
#line 3057 "BatchImport.c"
		}
		default:
		{
#line 91 "../src/BatchImport.vala"
			result = FALSE;
#line 91 "../src/BatchImport.vala"
			return result;
#line 3065 "BatchImport.c"
		}
	}
}

static gpointer
_g_error_copy0 (gpointer self)
{
#line 97 "../src/BatchImport.vala"
	return self ? g_error_copy (self) : NULL;
#line 3075 "BatchImport.c"
}

ImportResult
import_result_convert_error (GError* err,
                             ImportResult default_result)
{
	ImportResult result;
#line 95 "../src/BatchImport.vala"
	g_return_val_if_fail (err != NULL, 0);
#line 96 "../src/BatchImport.vala"
	if (err->domain == G_FILE_ERROR) {
#line 3087 "BatchImport.c"
		GError* ferr = NULL;
		GError* _tmp0_;
		GError* _tmp1_;
#line 97 "../src/BatchImport.vala"
		_tmp0_ = _g_error_copy0 ((GError*) err);
#line 97 "../src/BatchImport.vala"
		ferr = _tmp0_;
#line 99 "../src/BatchImport.vala"
		_tmp1_ = ferr;
#line 99 "../src/BatchImport.vala"
		if (g_error_matches (_tmp1_, G_FILE_ERROR, G_FILE_ERROR_NOSPC)) {
#line 100 "../src/BatchImport.vala"
			result = IMPORT_RESULT_DISK_FULL;
#line 100 "../src/BatchImport.vala"
			_g_error_free0 (ferr);
#line 100 "../src/BatchImport.vala"
			return result;
#line 3105 "BatchImport.c"
		} else {
			GError* _tmp2_;
#line 101 "../src/BatchImport.vala"
			_tmp2_ = ferr;
#line 101 "../src/BatchImport.vala"
			if (g_error_matches (_tmp2_, G_FILE_ERROR, G_FILE_ERROR_IO)) {
#line 102 "../src/BatchImport.vala"
				result = IMPORT_RESULT_DISK_FAILURE;
#line 102 "../src/BatchImport.vala"
				_g_error_free0 (ferr);
#line 102 "../src/BatchImport.vala"
				return result;
#line 3118 "BatchImport.c"
			} else {
				GError* _tmp3_;
#line 103 "../src/BatchImport.vala"
				_tmp3_ = ferr;
#line 103 "../src/BatchImport.vala"
				if (g_error_matches (_tmp3_, G_FILE_ERROR, G_FILE_ERROR_ISDIR)) {
#line 104 "../src/BatchImport.vala"
					result = IMPORT_RESULT_NOT_A_FILE;
#line 104 "../src/BatchImport.vala"
					_g_error_free0 (ferr);
#line 104 "../src/BatchImport.vala"
					return result;
#line 3131 "BatchImport.c"
				} else {
					GError* _tmp4_;
#line 105 "../src/BatchImport.vala"
					_tmp4_ = ferr;
#line 105 "../src/BatchImport.vala"
					if (g_error_matches (_tmp4_, G_FILE_ERROR, G_FILE_ERROR_ACCES)) {
#line 106 "../src/BatchImport.vala"
						result = IMPORT_RESULT_FILE_WRITE_ERROR;
#line 106 "../src/BatchImport.vala"
						_g_error_free0 (ferr);
#line 106 "../src/BatchImport.vala"
						return result;
#line 3144 "BatchImport.c"
					} else {
						GError* _tmp5_;
#line 107 "../src/BatchImport.vala"
						_tmp5_ = ferr;
#line 107 "../src/BatchImport.vala"
						if (g_error_matches (_tmp5_, G_FILE_ERROR, G_FILE_ERROR_PERM)) {
#line 108 "../src/BatchImport.vala"
							result = IMPORT_RESULT_FILE_WRITE_ERROR;
#line 108 "../src/BatchImport.vala"
							_g_error_free0 (ferr);
#line 108 "../src/BatchImport.vala"
							return result;
#line 3157 "BatchImport.c"
						} else {
#line 110 "../src/BatchImport.vala"
							result = IMPORT_RESULT_FILE_ERROR;
#line 110 "../src/BatchImport.vala"
							_g_error_free0 (ferr);
#line 110 "../src/BatchImport.vala"
							return result;
#line 3165 "BatchImport.c"
						}
					}
				}
			}
		}
#line 96 "../src/BatchImport.vala"
		_g_error_free0 (ferr);
#line 3173 "BatchImport.c"
	} else {
#line 111 "../src/BatchImport.vala"
		if (err->domain == G_IO_ERROR) {
#line 3177 "BatchImport.c"
			GError* ioerr = NULL;
			GError* _tmp6_;
			GError* _tmp7_;
#line 112 "../src/BatchImport.vala"
			_tmp6_ = _g_error_copy0 ((GError*) err);
#line 112 "../src/BatchImport.vala"
			ioerr = _tmp6_;
#line 114 "../src/BatchImport.vala"
			_tmp7_ = ioerr;
#line 114 "../src/BatchImport.vala"
			if (g_error_matches (_tmp7_, G_IO_ERROR, G_IO_ERROR_NO_SPACE)) {
#line 115 "../src/BatchImport.vala"
				result = IMPORT_RESULT_DISK_FULL;
#line 115 "../src/BatchImport.vala"
				_g_error_free0 (ioerr);
#line 115 "../src/BatchImport.vala"
				return result;
#line 3195 "BatchImport.c"
			} else {
				GError* _tmp8_;
#line 116 "../src/BatchImport.vala"
				_tmp8_ = ioerr;
#line 116 "../src/BatchImport.vala"
				if (g_error_matches (_tmp8_, G_IO_ERROR, G_IO_ERROR_FAILED)) {
#line 117 "../src/BatchImport.vala"
					result = IMPORT_RESULT_DISK_FAILURE;
#line 117 "../src/BatchImport.vala"
					_g_error_free0 (ioerr);
#line 117 "../src/BatchImport.vala"
					return result;
#line 3208 "BatchImport.c"
				} else {
					GError* _tmp9_;
#line 118 "../src/BatchImport.vala"
					_tmp9_ = ioerr;
#line 118 "../src/BatchImport.vala"
					if (g_error_matches (_tmp9_, G_IO_ERROR, G_IO_ERROR_IS_DIRECTORY)) {
#line 119 "../src/BatchImport.vala"
						result = IMPORT_RESULT_NOT_A_FILE;
#line 119 "../src/BatchImport.vala"
						_g_error_free0 (ioerr);
#line 119 "../src/BatchImport.vala"
						return result;
#line 3221 "BatchImport.c"
					} else {
						GError* _tmp10_;
#line 120 "../src/BatchImport.vala"
						_tmp10_ = ioerr;
#line 120 "../src/BatchImport.vala"
						if (g_error_matches (_tmp10_, G_IO_ERROR, G_IO_ERROR_CANCELLED)) {
#line 121 "../src/BatchImport.vala"
							result = IMPORT_RESULT_USER_ABORT;
#line 121 "../src/BatchImport.vala"
							_g_error_free0 (ioerr);
#line 121 "../src/BatchImport.vala"
							return result;
#line 3234 "BatchImport.c"
						} else {
							GError* _tmp11_;
#line 122 "../src/BatchImport.vala"
							_tmp11_ = ioerr;
#line 122 "../src/BatchImport.vala"
							if (g_error_matches (_tmp11_, G_IO_ERROR, G_IO_ERROR_READ_ONLY)) {
#line 123 "../src/BatchImport.vala"
								result = IMPORT_RESULT_FILE_WRITE_ERROR;
#line 123 "../src/BatchImport.vala"
								_g_error_free0 (ioerr);
#line 123 "../src/BatchImport.vala"
								return result;
#line 3247 "BatchImport.c"
							} else {
								GError* _tmp12_;
#line 124 "../src/BatchImport.vala"
								_tmp12_ = ioerr;
#line 124 "../src/BatchImport.vala"
								if (g_error_matches (_tmp12_, G_IO_ERROR, G_IO_ERROR_PERMISSION_DENIED)) {
#line 125 "../src/BatchImport.vala"
									result = IMPORT_RESULT_FILE_WRITE_ERROR;
#line 125 "../src/BatchImport.vala"
									_g_error_free0 (ioerr);
#line 125 "../src/BatchImport.vala"
									return result;
#line 3260 "BatchImport.c"
								} else {
#line 127 "../src/BatchImport.vala"
									result = IMPORT_RESULT_FILE_ERROR;
#line 127 "../src/BatchImport.vala"
									_g_error_free0 (ioerr);
#line 127 "../src/BatchImport.vala"
									return result;
#line 3268 "BatchImport.c"
								}
							}
						}
					}
				}
			}
#line 111 "../src/BatchImport.vala"
			_g_error_free0 (ioerr);
#line 3277 "BatchImport.c"
		} else {
#line 128 "../src/BatchImport.vala"
			if (err->domain == GPHOTO_ERROR) {
#line 129 "../src/BatchImport.vala"
				result = IMPORT_RESULT_CAMERA_ERROR;
#line 129 "../src/BatchImport.vala"
				return result;
#line 3285 "BatchImport.c"
			} else {
#line 130 "../src/BatchImport.vala"
				if (err->domain == GDK_PIXBUF_ERROR) {
#line 3289 "BatchImport.c"
					GError* pixbuferr = NULL;
					GError* _tmp13_;
					GError* _tmp14_;
#line 131 "../src/BatchImport.vala"
					_tmp13_ = _g_error_copy0 ((GError*) err);
#line 131 "../src/BatchImport.vala"
					pixbuferr = _tmp13_;
#line 133 "../src/BatchImport.vala"
					_tmp14_ = pixbuferr;
#line 133 "../src/BatchImport.vala"
					if (g_error_matches (_tmp14_, GDK_PIXBUF_ERROR, GDK_PIXBUF_ERROR_CORRUPT_IMAGE)) {
#line 134 "../src/BatchImport.vala"
						result = IMPORT_RESULT_PIXBUF_CORRUPT_IMAGE;
#line 134 "../src/BatchImport.vala"
						_g_error_free0 (pixbuferr);
#line 134 "../src/BatchImport.vala"
						return result;
#line 3307 "BatchImport.c"
					} else {
						GError* _tmp15_;
#line 135 "../src/BatchImport.vala"
						_tmp15_ = pixbuferr;
#line 135 "../src/BatchImport.vala"
						if (g_error_matches (_tmp15_, GDK_PIXBUF_ERROR, GDK_PIXBUF_ERROR_INSUFFICIENT_MEMORY)) {
#line 136 "../src/BatchImport.vala"
							result = default_result;
#line 136 "../src/BatchImport.vala"
							_g_error_free0 (pixbuferr);
#line 136 "../src/BatchImport.vala"
							return result;
#line 3320 "BatchImport.c"
						} else {
							GError* _tmp16_;
#line 137 "../src/BatchImport.vala"
							_tmp16_ = pixbuferr;
#line 137 "../src/BatchImport.vala"
							if (g_error_matches (_tmp16_, GDK_PIXBUF_ERROR, GDK_PIXBUF_ERROR_BAD_OPTION)) {
#line 138 "../src/BatchImport.vala"
								result = default_result;
#line 138 "../src/BatchImport.vala"
								_g_error_free0 (pixbuferr);
#line 138 "../src/BatchImport.vala"
								return result;
#line 3333 "BatchImport.c"
							} else {
								GError* _tmp17_;
#line 139 "../src/BatchImport.vala"
								_tmp17_ = pixbuferr;
#line 139 "../src/BatchImport.vala"
								if (g_error_matches (_tmp17_, GDK_PIXBUF_ERROR, GDK_PIXBUF_ERROR_UNKNOWN_TYPE)) {
#line 140 "../src/BatchImport.vala"
									result = IMPORT_RESULT_UNSUPPORTED_FORMAT;
#line 140 "../src/BatchImport.vala"
									_g_error_free0 (pixbuferr);
#line 140 "../src/BatchImport.vala"
									return result;
#line 3346 "BatchImport.c"
								} else {
									GError* _tmp18_;
#line 141 "../src/BatchImport.vala"
									_tmp18_ = pixbuferr;
#line 141 "../src/BatchImport.vala"
									if (g_error_matches (_tmp18_, GDK_PIXBUF_ERROR, GDK_PIXBUF_ERROR_UNSUPPORTED_OPERATION)) {
#line 142 "../src/BatchImport.vala"
										result = default_result;
#line 142 "../src/BatchImport.vala"
										_g_error_free0 (pixbuferr);
#line 142 "../src/BatchImport.vala"
										return result;
#line 3359 "BatchImport.c"
									} else {
										GError* _tmp19_;
#line 143 "../src/BatchImport.vala"
										_tmp19_ = pixbuferr;
#line 143 "../src/BatchImport.vala"
										if (g_error_matches (_tmp19_, GDK_PIXBUF_ERROR, GDK_PIXBUF_ERROR_FAILED)) {
#line 144 "../src/BatchImport.vala"
											result = default_result;
#line 144 "../src/BatchImport.vala"
											_g_error_free0 (pixbuferr);
#line 144 "../src/BatchImport.vala"
											return result;
#line 3372 "BatchImport.c"
										} else {
#line 146 "../src/BatchImport.vala"
											result = default_result;
#line 146 "../src/BatchImport.vala"
											_g_error_free0 (pixbuferr);
#line 146 "../src/BatchImport.vala"
											return result;
#line 3380 "BatchImport.c"
										}
									}
								}
							}
						}
					}
#line 130 "../src/BatchImport.vala"
					_g_error_free0 (pixbuferr);
#line 3389 "BatchImport.c"
				}
			}
		}
	}
#line 149 "../src/BatchImport.vala"
	result = default_result;
#line 149 "../src/BatchImport.vala"
	return result;
#line 3398 "BatchImport.c"
}

static GType
import_result_get_type_once (void)
{
	static const GEnumValue values[] = {{IMPORT_RESULT_SUCCESS, "IMPORT_RESULT_SUCCESS", "success"}, {IMPORT_RESULT_FILE_ERROR, "IMPORT_RESULT_FILE_ERROR", "file-error"}, {IMPORT_RESULT_DECODE_ERROR, "IMPORT_RESULT_DECODE_ERROR", "decode-error"}, {IMPORT_RESULT_DATABASE_ERROR, "IMPORT_RESULT_DATABASE_ERROR", "database-error"}, {IMPORT_RESULT_USER_ABORT, "IMPORT_RESULT_USER_ABORT", "user-abort"}, {IMPORT_RESULT_NOT_A_FILE, "IMPORT_RESULT_NOT_A_FILE", "not-a-file"}, {IMPORT_RESULT_PHOTO_EXISTS, "IMPORT_RESULT_PHOTO_EXISTS", "photo-exists"}, {IMPORT_RESULT_UNSUPPORTED_FORMAT, "IMPORT_RESULT_UNSUPPORTED_FORMAT", "unsupported-format"}, {IMPORT_RESULT_NOT_AN_IMAGE, "IMPORT_RESULT_NOT_AN_IMAGE", "not-an-image"}, {IMPORT_RESULT_DISK_FAILURE, "IMPORT_RESULT_DISK_FAILURE", "disk-failure"}, {IMPORT_RESULT_DISK_FULL, "IMPORT_RESULT_DISK_FULL", "disk-full"}, {IMPORT_RESULT_CAMERA_ERROR, "IMPORT_RESULT_CAMERA_ERROR", "camera-error"}, {IMPORT_RESULT_FILE_WRITE_ERROR, "IMPORT_RESULT_FILE_WRITE_ERROR", "file-write-error"}, {IMPORT_RESULT_PIXBUF_CORRUPT_IMAGE, "IMPORT_RESULT_PIXBUF_CORRUPT_IMAGE", "pixbuf-corrupt-image"}, {0, NULL, NULL}};
	GType import_result_type_id;
	import_result_type_id = g_enum_register_static ("ImportResult", values);
	return import_result_type_id;
}

GType
import_result_get_type (void)
{
	static volatile gsize import_result_type_id__once = 0;
	if (g_once_init_enter (&import_result_type_id__once)) {
		GType import_result_type_id;
		import_result_type_id = import_result_get_type_once ();
		g_once_init_leave (&import_result_type_id__once, import_result_type_id);
	}
	return import_result_type_id__once;
}

static gchar*
batch_import_job_real_get_dest_identifier (BatchImportJob* self)
{
#line 161 "../src/BatchImport.vala"
	g_critical ("Type `%s' does not implement abstract method `batch_import_job_get_dest_identifier'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 161 "../src/BatchImport.vala"
	return NULL;
#line 3429 "BatchImport.c"
}

gchar*
batch_import_job_get_dest_identifier (BatchImportJob* self)
{
	BatchImportJobClass* _klass_;
#line 161 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_BATCH_IMPORT_JOB (self), NULL);
#line 161 "../src/BatchImport.vala"
	_klass_ = BATCH_IMPORT_JOB_GET_CLASS (self);
#line 161 "../src/BatchImport.vala"
	if (_klass_->get_dest_identifier) {
#line 161 "../src/BatchImport.vala"
		return _klass_->get_dest_identifier (self);
#line 3444 "BatchImport.c"
	}
#line 161 "../src/BatchImport.vala"
	return NULL;
#line 3448 "BatchImport.c"
}

static gchar*
batch_import_job_real_get_source_identifier (BatchImportJob* self)
{
#line 163 "../src/BatchImport.vala"
	g_critical ("Type `%s' does not implement abstract method `batch_import_job_get_source_identifier'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 163 "../src/BatchImport.vala"
	return NULL;
#line 3458 "BatchImport.c"
}

gchar*
batch_import_job_get_source_identifier (BatchImportJob* self)
{
	BatchImportJobClass* _klass_;
#line 163 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_BATCH_IMPORT_JOB (self), NULL);
#line 163 "../src/BatchImport.vala"
	_klass_ = BATCH_IMPORT_JOB_GET_CLASS (self);
#line 163 "../src/BatchImport.vala"
	if (_klass_->get_source_identifier) {
#line 163 "../src/BatchImport.vala"
		return _klass_->get_source_identifier (self);
#line 3473 "BatchImport.c"
	}
#line 163 "../src/BatchImport.vala"
	return NULL;
#line 3477 "BatchImport.c"
}

static gboolean
batch_import_job_real_is_directory (BatchImportJob* self)
{
	gboolean _tmp0_ = FALSE;
#line 165 "../src/BatchImport.vala"
	g_critical ("Type `%s' does not implement abstract method `batch_import_job_is_directory'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 165 "../src/BatchImport.vala"
	return _tmp0_;
#line 3488 "BatchImport.c"
}

gboolean
batch_import_job_is_directory (BatchImportJob* self)
{
	BatchImportJobClass* _klass_;
#line 165 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_BATCH_IMPORT_JOB (self), FALSE);
#line 165 "../src/BatchImport.vala"
	_klass_ = BATCH_IMPORT_JOB_GET_CLASS (self);
#line 165 "../src/BatchImport.vala"
	if (_klass_->is_directory) {
#line 165 "../src/BatchImport.vala"
		return _klass_->is_directory (self);
#line 3503 "BatchImport.c"
	}
#line 165 "../src/BatchImport.vala"
	return FALSE;
#line 3507 "BatchImport.c"
}

static gchar*
batch_import_job_real_get_basename (BatchImportJob* self)
{
#line 167 "../src/BatchImport.vala"
	g_critical ("Type `%s' does not implement abstract method `batch_import_job_get_basename'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 167 "../src/BatchImport.vala"
	return NULL;
#line 3517 "BatchImport.c"
}

gchar*
batch_import_job_get_basename (BatchImportJob* self)
{
	BatchImportJobClass* _klass_;
#line 167 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_BATCH_IMPORT_JOB (self), NULL);
#line 167 "../src/BatchImport.vala"
	_klass_ = BATCH_IMPORT_JOB_GET_CLASS (self);
#line 167 "../src/BatchImport.vala"
	if (_klass_->get_basename) {
#line 167 "../src/BatchImport.vala"
		return _klass_->get_basename (self);
#line 3532 "BatchImport.c"
	}
#line 167 "../src/BatchImport.vala"
	return NULL;
#line 3536 "BatchImport.c"
}

static gchar*
batch_import_job_real_get_path (BatchImportJob* self)
{
#line 169 "../src/BatchImport.vala"
	g_critical ("Type `%s' does not implement abstract method `batch_import_job_get_path'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 169 "../src/BatchImport.vala"
	return NULL;
#line 3546 "BatchImport.c"
}

gchar*
batch_import_job_get_path (BatchImportJob* self)
{
	BatchImportJobClass* _klass_;
#line 169 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_BATCH_IMPORT_JOB (self), NULL);
#line 169 "../src/BatchImport.vala"
	_klass_ = BATCH_IMPORT_JOB_GET_CLASS (self);
#line 169 "../src/BatchImport.vala"
	if (_klass_->get_path) {
#line 169 "../src/BatchImport.vala"
		return _klass_->get_path (self);
#line 3561 "BatchImport.c"
	}
#line 169 "../src/BatchImport.vala"
	return NULL;
#line 3565 "BatchImport.c"
}

static DuplicatedFile*
batch_import_job_real_get_duplicated_file (BatchImportJob* self)
{
	DuplicatedFile* result;
#line 172 "../src/BatchImport.vala"
	result = NULL;
#line 172 "../src/BatchImport.vala"
	return result;
#line 3576 "BatchImport.c"
}

DuplicatedFile*
batch_import_job_get_duplicated_file (BatchImportJob* self)
{
	BatchImportJobClass* _klass_;
#line 171 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_BATCH_IMPORT_JOB (self), NULL);
#line 171 "../src/BatchImport.vala"
	_klass_ = BATCH_IMPORT_JOB_GET_CLASS (self);
#line 171 "../src/BatchImport.vala"
	if (_klass_->get_duplicated_file) {
#line 171 "../src/BatchImport.vala"
		return _klass_->get_duplicated_file (self);
#line 3591 "BatchImport.c"
	}
#line 171 "../src/BatchImport.vala"
	return NULL;
#line 3595 "BatchImport.c"
}

static GFile*
batch_import_job_real_get_associated_file (BatchImportJob* self)
{
	GFile* result;
#line 176 "../src/BatchImport.vala"
	result = NULL;
#line 176 "../src/BatchImport.vala"
	return result;
#line 3606 "BatchImport.c"
}

GFile*
batch_import_job_get_associated_file (BatchImportJob* self)
{
	BatchImportJobClass* _klass_;
#line 175 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_BATCH_IMPORT_JOB (self), NULL);
#line 175 "../src/BatchImport.vala"
	_klass_ = BATCH_IMPORT_JOB_GET_CLASS (self);
#line 175 "../src/BatchImport.vala"
	if (_klass_->get_associated_file) {
#line 175 "../src/BatchImport.vala"
		return _klass_->get_associated_file (self);
#line 3621 "BatchImport.c"
	}
#line 175 "../src/BatchImport.vala"
	return NULL;
#line 3625 "BatchImport.c"
}

static void
batch_import_job_real_set_associated (BatchImportJob* self,
                                      BatchImportJob* associated)
{
#line 180 "../src/BatchImport.vala"
	g_critical ("Type `%s' does not implement abstract method `batch_import_job_set_associated'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 180 "../src/BatchImport.vala"
	return;
#line 3636 "BatchImport.c"
}

void
batch_import_job_set_associated (BatchImportJob* self,
                                 BatchImportJob* associated)
{
	BatchImportJobClass* _klass_;
#line 180 "../src/BatchImport.vala"
	g_return_if_fail (IS_BATCH_IMPORT_JOB (self));
#line 180 "../src/BatchImport.vala"
	_klass_ = BATCH_IMPORT_JOB_GET_CLASS (self);
#line 180 "../src/BatchImport.vala"
	if (_klass_->set_associated) {
#line 180 "../src/BatchImport.vala"
		_klass_->set_associated (self, associated);
#line 3652 "BatchImport.c"
	}
}

static gboolean
batch_import_job_real_determine_file_size (BatchImportJob* self,
                                           guint64* filesize,
                                           GFile** file_or_dir)
{
	gboolean _tmp0_ = FALSE;
#line 187 "../src/BatchImport.vala"
	g_critical ("Type `%s' does not implement abstract method `batch_import_job_determine_file_size'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 187 "../src/BatchImport.vala"
	return _tmp0_;
#line 3666 "BatchImport.c"
}

gboolean
batch_import_job_determine_file_size (BatchImportJob* self,
                                      guint64* filesize,
                                      GFile** file_or_dir)
{
	BatchImportJobClass* _klass_;
#line 187 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_BATCH_IMPORT_JOB (self), FALSE);
#line 187 "../src/BatchImport.vala"
	_klass_ = BATCH_IMPORT_JOB_GET_CLASS (self);
#line 187 "../src/BatchImport.vala"
	if (_klass_->determine_file_size) {
#line 187 "../src/BatchImport.vala"
		return _klass_->determine_file_size (self, filesize, file_or_dir);
#line 3683 "BatchImport.c"
	}
#line 187 "../src/BatchImport.vala"
	return FALSE;
#line 3687 "BatchImport.c"
}

static gboolean
batch_import_job_real_prepare (BatchImportJob* self,
                               GFile** file_to_import,
                               gboolean* copy_to_library,
                               GError** error)
{
	gboolean _tmp0_ = FALSE;
#line 190 "../src/BatchImport.vala"
	g_critical ("Type `%s' does not implement abstract method `batch_import_job_prepare'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 190 "../src/BatchImport.vala"
	return _tmp0_;
#line 3701 "BatchImport.c"
}

gboolean
batch_import_job_prepare (BatchImportJob* self,
                          GFile** file_to_import,
                          gboolean* copy_to_library,
                          GError** error)
{
	BatchImportJobClass* _klass_;
#line 190 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_BATCH_IMPORT_JOB (self), FALSE);
#line 190 "../src/BatchImport.vala"
	_klass_ = BATCH_IMPORT_JOB_GET_CLASS (self);
#line 190 "../src/BatchImport.vala"
	if (_klass_->prepare) {
#line 190 "../src/BatchImport.vala"
		return _klass_->prepare (self, file_to_import, copy_to_library, error);
#line 3719 "BatchImport.c"
	}
#line 190 "../src/BatchImport.vala"
	return FALSE;
#line 3723 "BatchImport.c"
}

static gboolean
batch_import_job_real_complete (BatchImportJob* self,
                                MediaSource* source,
                                BatchImportRoll* import_roll,
                                GError** error)
{
	gboolean result;
#line 200 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_MEDIA_SOURCE (source), FALSE);
#line 200 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_BATCH_IMPORT_ROLL (import_roll), FALSE);
#line 201 "../src/BatchImport.vala"
	result = FALSE;
#line 201 "../src/BatchImport.vala"
	return result;
#line 3741 "BatchImport.c"
}

gboolean
batch_import_job_complete (BatchImportJob* self,
                           MediaSource* source,
                           BatchImportRoll* import_roll,
                           GError** error)
{
	BatchImportJobClass* _klass_;
#line 200 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_BATCH_IMPORT_JOB (self), FALSE);
#line 200 "../src/BatchImport.vala"
	_klass_ = BATCH_IMPORT_JOB_GET_CLASS (self);
#line 200 "../src/BatchImport.vala"
	if (_klass_->complete) {
#line 200 "../src/BatchImport.vala"
		return _klass_->complete (self, source, import_roll, error);
#line 3759 "BatchImport.c"
	}
#line 200 "../src/BatchImport.vala"
	return FALSE;
#line 3763 "BatchImport.c"
}

static GDateTime*
batch_import_job_real_get_exposure_time_override (BatchImportJob* self)
{
	GDateTime* result;
#line 207 "../src/BatchImport.vala"
	result = NULL;
#line 207 "../src/BatchImport.vala"
	return result;
#line 3774 "BatchImport.c"
}

GDateTime*
batch_import_job_get_exposure_time_override (BatchImportJob* self)
{
	BatchImportJobClass* _klass_;
#line 206 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_BATCH_IMPORT_JOB (self), NULL);
#line 206 "../src/BatchImport.vala"
	_klass_ = BATCH_IMPORT_JOB_GET_CLASS (self);
#line 206 "../src/BatchImport.vala"
	if (_klass_->get_exposure_time_override) {
#line 206 "../src/BatchImport.vala"
		return _klass_->get_exposure_time_override (self);
#line 3789 "BatchImport.c"
	}
#line 206 "../src/BatchImport.vala"
	return NULL;
#line 3793 "BatchImport.c"
}

static gboolean
batch_import_job_real_recurse (BatchImportJob* self)
{
	gboolean result;
#line 211 "../src/BatchImport.vala"
	result = TRUE;
#line 211 "../src/BatchImport.vala"
	return result;
#line 3804 "BatchImport.c"
}

gboolean
batch_import_job_recurse (BatchImportJob* self)
{
	BatchImportJobClass* _klass_;
#line 210 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_BATCH_IMPORT_JOB (self), FALSE);
#line 210 "../src/BatchImport.vala"
	_klass_ = BATCH_IMPORT_JOB_GET_CLASS (self);
#line 210 "../src/BatchImport.vala"
	if (_klass_->recurse) {
#line 210 "../src/BatchImport.vala"
		return _klass_->recurse (self);
#line 3819 "BatchImport.c"
	}
#line 210 "../src/BatchImport.vala"
	return FALSE;
#line 3823 "BatchImport.c"
}

BatchImportJob*
batch_import_job_construct (GType object_type)
{
	BatchImportJob* self = NULL;
#line 160 "../src/BatchImport.vala"
	self = (BatchImportJob*) g_type_create_instance (object_type);
#line 160 "../src/BatchImport.vala"
	return self;
#line 3834 "BatchImport.c"
}

static void
value_batch_import_job_init (GValue* value)
{
#line 160 "../src/BatchImport.vala"
	value->data[0].v_pointer = NULL;
#line 3842 "BatchImport.c"
}

static void
value_batch_import_job_free_value (GValue* value)
{
#line 160 "../src/BatchImport.vala"
	if (value->data[0].v_pointer) {
#line 160 "../src/BatchImport.vala"
		batch_import_job_unref (value->data[0].v_pointer);
#line 3852 "BatchImport.c"
	}
}

static void
value_batch_import_job_copy_value (const GValue* src_value,
                                   GValue* dest_value)
{
#line 160 "../src/BatchImport.vala"
	if (src_value->data[0].v_pointer) {
#line 160 "../src/BatchImport.vala"
		dest_value->data[0].v_pointer = batch_import_job_ref (src_value->data[0].v_pointer);
#line 3864 "BatchImport.c"
	} else {
#line 160 "../src/BatchImport.vala"
		dest_value->data[0].v_pointer = NULL;
#line 3868 "BatchImport.c"
	}
}

static gpointer
value_batch_import_job_peek_pointer (const GValue* value)
{
#line 160 "../src/BatchImport.vala"
	return value->data[0].v_pointer;
#line 3877 "BatchImport.c"
}

static gchar*
value_batch_import_job_collect_value (GValue* value,
                                      guint n_collect_values,
                                      GTypeCValue* collect_values,
                                      guint collect_flags)
{
#line 160 "../src/BatchImport.vala"
	if (collect_values[0].v_pointer) {
#line 3888 "BatchImport.c"
		BatchImportJob * object;
		object = collect_values[0].v_pointer;
#line 160 "../src/BatchImport.vala"
		if (object->parent_instance.g_class == NULL) {
#line 160 "../src/BatchImport.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 3895 "BatchImport.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 160 "../src/BatchImport.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 3899 "BatchImport.c"
		}
#line 160 "../src/BatchImport.vala"
		value->data[0].v_pointer = batch_import_job_ref (object);
#line 3903 "BatchImport.c"
	} else {
#line 160 "../src/BatchImport.vala"
		value->data[0].v_pointer = NULL;
#line 3907 "BatchImport.c"
	}
#line 160 "../src/BatchImport.vala"
	return NULL;
#line 3911 "BatchImport.c"
}

static gchar*
value_batch_import_job_lcopy_value (const GValue* value,
                                    guint n_collect_values,
                                    GTypeCValue* collect_values,
                                    guint collect_flags)
{
	BatchImportJob ** object_p;
	object_p = collect_values[0].v_pointer;
#line 160 "../src/BatchImport.vala"
	if (!object_p) {
#line 160 "../src/BatchImport.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 3926 "BatchImport.c"
	}
#line 160 "../src/BatchImport.vala"
	if (!value->data[0].v_pointer) {
#line 160 "../src/BatchImport.vala"
		*object_p = NULL;
#line 3932 "BatchImport.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 160 "../src/BatchImport.vala"
		*object_p = value->data[0].v_pointer;
#line 3936 "BatchImport.c"
	} else {
#line 160 "../src/BatchImport.vala"
		*object_p = batch_import_job_ref (value->data[0].v_pointer);
#line 3940 "BatchImport.c"
	}
#line 160 "../src/BatchImport.vala"
	return NULL;
#line 3944 "BatchImport.c"
}

GParamSpec*
param_spec_batch_import_job (const gchar* name,
                             const gchar* nick,
                             const gchar* blurb,
                             GType object_type,
                             GParamFlags flags)
{
	ParamSpecBatchImportJob* spec;
#line 160 "../src/BatchImport.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_BATCH_IMPORT_JOB), NULL);
#line 160 "../src/BatchImport.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 160 "../src/BatchImport.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 160 "../src/BatchImport.vala"
	return G_PARAM_SPEC (spec);
#line 3963 "BatchImport.c"
}

gpointer
value_get_batch_import_job (const GValue* value)
{
#line 160 "../src/BatchImport.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_BATCH_IMPORT_JOB), NULL);
#line 160 "../src/BatchImport.vala"
	return value->data[0].v_pointer;
#line 3973 "BatchImport.c"
}

void
value_set_batch_import_job (GValue* value,
                            gpointer v_object)
{
	BatchImportJob * old;
#line 160 "../src/BatchImport.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_BATCH_IMPORT_JOB));
#line 160 "../src/BatchImport.vala"
	old = value->data[0].v_pointer;
#line 160 "../src/BatchImport.vala"
	if (v_object) {
#line 160 "../src/BatchImport.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_BATCH_IMPORT_JOB));
#line 160 "../src/BatchImport.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 160 "../src/BatchImport.vala"
		value->data[0].v_pointer = v_object;
#line 160 "../src/BatchImport.vala"
		batch_import_job_ref (value->data[0].v_pointer);
#line 3995 "BatchImport.c"
	} else {
#line 160 "../src/BatchImport.vala"
		value->data[0].v_pointer = NULL;
#line 3999 "BatchImport.c"
	}
#line 160 "../src/BatchImport.vala"
	if (old) {
#line 160 "../src/BatchImport.vala"
		batch_import_job_unref (old);
#line 4005 "BatchImport.c"
	}
}

void
value_take_batch_import_job (GValue* value,
                             gpointer v_object)
{
	BatchImportJob * old;
#line 160 "../src/BatchImport.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_BATCH_IMPORT_JOB));
#line 160 "../src/BatchImport.vala"
	old = value->data[0].v_pointer;
#line 160 "../src/BatchImport.vala"
	if (v_object) {
#line 160 "../src/BatchImport.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_BATCH_IMPORT_JOB));
#line 160 "../src/BatchImport.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 160 "../src/BatchImport.vala"
		value->data[0].v_pointer = v_object;
#line 4026 "BatchImport.c"
	} else {
#line 160 "../src/BatchImport.vala"
		value->data[0].v_pointer = NULL;
#line 4030 "BatchImport.c"
	}
#line 160 "../src/BatchImport.vala"
	if (old) {
#line 160 "../src/BatchImport.vala"
		batch_import_job_unref (old);
#line 4036 "BatchImport.c"
	}
}

static void
batch_import_job_class_init (BatchImportJobClass * klass,
                             gpointer klass_data)
{
#line 160 "../src/BatchImport.vala"
	batch_import_job_parent_class = g_type_class_peek_parent (klass);
#line 160 "../src/BatchImport.vala"
	((BatchImportJobClass *) klass)->finalize = batch_import_job_finalize;
#line 160 "../src/BatchImport.vala"
	((BatchImportJobClass *) klass)->get_dest_identifier = (gchar* (*) (BatchImportJob*)) batch_import_job_real_get_dest_identifier;
#line 160 "../src/BatchImport.vala"
	((BatchImportJobClass *) klass)->get_source_identifier = (gchar* (*) (BatchImportJob*)) batch_import_job_real_get_source_identifier;
#line 160 "../src/BatchImport.vala"
	((BatchImportJobClass *) klass)->is_directory = (gboolean (*) (BatchImportJob*)) batch_import_job_real_is_directory;
#line 160 "../src/BatchImport.vala"
	((BatchImportJobClass *) klass)->get_basename = (gchar* (*) (BatchImportJob*)) batch_import_job_real_get_basename;
#line 160 "../src/BatchImport.vala"
	((BatchImportJobClass *) klass)->get_path = (gchar* (*) (BatchImportJob*)) batch_import_job_real_get_path;
#line 160 "../src/BatchImport.vala"
	((BatchImportJobClass *) klass)->get_duplicated_file = (DuplicatedFile* (*) (BatchImportJob*)) batch_import_job_real_get_duplicated_file;
#line 160 "../src/BatchImport.vala"
	((BatchImportJobClass *) klass)->get_associated_file = (GFile* (*) (BatchImportJob*)) batch_import_job_real_get_associated_file;
#line 160 "../src/BatchImport.vala"
	((BatchImportJobClass *) klass)->set_associated = (void (*) (BatchImportJob*, BatchImportJob*)) batch_import_job_real_set_associated;
#line 160 "../src/BatchImport.vala"
	((BatchImportJobClass *) klass)->determine_file_size = (gboolean (*) (BatchImportJob*, guint64*, GFile**)) batch_import_job_real_determine_file_size;
#line 160 "../src/BatchImport.vala"
	((BatchImportJobClass *) klass)->prepare = (gboolean (*) (BatchImportJob*, GFile**, gboolean*, GError**)) batch_import_job_real_prepare;
#line 160 "../src/BatchImport.vala"
	((BatchImportJobClass *) klass)->complete = (gboolean (*) (BatchImportJob*, MediaSource*, BatchImportRoll*, GError**)) batch_import_job_real_complete;
#line 160 "../src/BatchImport.vala"
	((BatchImportJobClass *) klass)->get_exposure_time_override = (GDateTime* (*) (BatchImportJob*)) batch_import_job_real_get_exposure_time_override;
#line 160 "../src/BatchImport.vala"
	((BatchImportJobClass *) klass)->recurse = (gboolean (*) (BatchImportJob*)) batch_import_job_real_recurse;
#line 4074 "BatchImport.c"
}

static void
batch_import_job_instance_init (BatchImportJob * self,
                                gpointer klass)
{
#line 160 "../src/BatchImport.vala"
	self->ref_count = 1;
#line 4083 "BatchImport.c"
}

static void
batch_import_job_finalize (BatchImportJob * obj)
{
	BatchImportJob * self;
#line 160 "../src/BatchImport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BATCH_IMPORT_JOB, BatchImportJob);
#line 160 "../src/BatchImport.vala"
	g_signal_handlers_destroy (self);
#line 4094 "BatchImport.c"
}

static GType
batch_import_job_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_batch_import_job_init, value_batch_import_job_free_value, value_batch_import_job_copy_value, value_batch_import_job_peek_pointer, "p", value_batch_import_job_collect_value, "p", value_batch_import_job_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (BatchImportJobClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) batch_import_job_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BatchImportJob), 0, (GInstanceInitFunc) batch_import_job_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType batch_import_job_type_id;
	batch_import_job_type_id = g_type_register_fundamental (g_type_fundamental_next (), "BatchImportJob", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
	return batch_import_job_type_id;
}

GType
batch_import_job_get_type (void)
{
	static volatile gsize batch_import_job_type_id__once = 0;
	if (g_once_init_enter (&batch_import_job_type_id__once)) {
		GType batch_import_job_type_id;
		batch_import_job_type_id = batch_import_job_get_type_once ();
		g_once_init_leave (&batch_import_job_type_id__once, batch_import_job_type_id);
	}
	return batch_import_job_type_id__once;
}

gpointer
batch_import_job_ref (gpointer instance)
{
	BatchImportJob * self;
	self = instance;
#line 160 "../src/BatchImport.vala"
	g_atomic_int_inc (&self->ref_count);
#line 160 "../src/BatchImport.vala"
	return instance;
#line 4129 "BatchImport.c"
}

void
batch_import_job_unref (gpointer instance)
{
	BatchImportJob * self;
	self = instance;
#line 160 "../src/BatchImport.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 160 "../src/BatchImport.vala"
		BATCH_IMPORT_JOB_GET_CLASS (self)->finalize (self);
#line 160 "../src/BatchImport.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 4143 "BatchImport.c"
	}
}

static inline gpointer
file_import_job_get_instance_private (FileImportJob* self)
{
	return G_STRUCT_MEMBER_P (self, FileImportJob_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 222 "../src/BatchImport.vala"
	return self ? g_object_ref (self) : NULL;
#line 4158 "BatchImport.c"
}

FileImportJob*
file_import_job_construct (GType object_type,
                           GFile* file_or_dir,
                           gboolean copy_to_library,
                           gboolean recurse)
{
	FileImportJob* self = NULL;
	GFile* _tmp0_;
#line 221 "../src/BatchImport.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file_or_dir, g_file_get_type ()), NULL);
#line 221 "../src/BatchImport.vala"
	self = (FileImportJob*) batch_import_job_construct (object_type);
#line 222 "../src/BatchImport.vala"
	_tmp0_ = _g_object_ref0 (file_or_dir);
#line 222 "../src/BatchImport.vala"
	_g_object_unref0 (self->priv->file_or_dir);
#line 222 "../src/BatchImport.vala"
	self->priv->file_or_dir = _tmp0_;
#line 223 "../src/BatchImport.vala"
	self->priv->copy_to_library = copy_to_library;
#line 224 "../src/BatchImport.vala"
	self->priv->_recurse = recurse;
#line 221 "../src/BatchImport.vala"
	return self;
#line 4185 "BatchImport.c"
}

FileImportJob*
file_import_job_new (GFile* file_or_dir,
                     gboolean copy_to_library,
                     gboolean recurse)
{
#line 221 "../src/BatchImport.vala"
	return file_import_job_construct (TYPE_FILE_IMPORT_JOB, file_or_dir, copy_to_library, recurse);
#line 4195 "BatchImport.c"
}

static gchar*
file_import_job_real_get_dest_identifier (BatchImportJob* base)
{
	FileImportJob * self;
	GFile* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 227 "../src/BatchImport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_FILE_IMPORT_JOB, FileImportJob);
#line 228 "../src/BatchImport.vala"
	_tmp0_ = self->priv->file_or_dir;
#line 228 "../src/BatchImport.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 228 "../src/BatchImport.vala"
	result = _tmp1_;
#line 228 "../src/BatchImport.vala"
	return result;
#line 4215 "BatchImport.c"
}

static gchar*
file_import_job_real_get_source_identifier (BatchImportJob* base)
{
	FileImportJob * self;
	GFile* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 231 "../src/BatchImport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_FILE_IMPORT_JOB, FileImportJob);
#line 232 "../src/BatchImport.vala"
	_tmp0_ = self->priv->file_or_dir;
#line 232 "../src/BatchImport.vala"
	_tmp1_ = g_file_get_path (_tmp0_);
#line 232 "../src/BatchImport.vala"
	result = _tmp1_;
#line 232 "../src/BatchImport.vala"
	return result;
#line 4235 "BatchImport.c"
}

static gboolean
file_import_job_real_is_directory (BatchImportJob* base)
{
	FileImportJob * self;
	GFile* _tmp0_;
	gboolean result;
#line 235 "../src/BatchImport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_FILE_IMPORT_JOB, FileImportJob);
#line 236 "../src/BatchImport.vala"
	_tmp0_ = self->priv->file_or_dir;
#line 236 "../src/BatchImport.vala"
	result = query_is_directory (_tmp0_);
#line 236 "../src/BatchImport.vala"
	return result;
#line 4252 "BatchImport.c"
}

static gchar*
file_import_job_real_get_basename (BatchImportJob* base)
{
	FileImportJob * self;
	GFile* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 239 "../src/BatchImport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_FILE_IMPORT_JOB, FileImportJob);
#line 240 "../src/BatchImport.vala"
	_tmp0_ = self->priv->file_or_dir;
#line 240 "../src/BatchImport.vala"
	_tmp1_ = g_file_get_basename (_tmp0_);
#line 240 "../src/BatchImport.vala"
	result = _tmp1_;
#line 240 "../src/BatchImport.vala"
	return result;
#line 4272 "BatchImport.c"
}

static gchar*
file_import_job_real_get_path (BatchImportJob* base)
{
	FileImportJob * self;
	gchar* _tmp0_ = NULL;
	gchar* result;
#line 243 "../src/BatchImport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_FILE_IMPORT_JOB, FileImportJob);
#line 244 "../src/BatchImport.vala"
	if (batch_import_job_is_directory (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_BATCH_IMPORT_JOB, BatchImportJob))) {
#line 4285 "BatchImport.c"
		GFile* _tmp1_;
		gchar* _tmp2_;
#line 244 "../src/BatchImport.vala"
		_tmp1_ = self->priv->file_or_dir;
#line 244 "../src/BatchImport.vala"
		_tmp2_ = g_file_get_path (_tmp1_);
#line 244 "../src/BatchImport.vala"
		_g_free0 (_tmp0_);
#line 244 "../src/BatchImport.vala"
		_tmp0_ = _tmp2_;
#line 4296 "BatchImport.c"
	} else {
		GFile* _tmp3_;
		GFile* _tmp4_;
		GFile* _tmp5_;
		gchar* _tmp6_;
#line 244 "../src/BatchImport.vala"
		_tmp3_ = self->priv->file_or_dir;
#line 244 "../src/BatchImport.vala"
		_tmp4_ = g_file_get_parent (_tmp3_);
#line 244 "../src/BatchImport.vala"
		_tmp5_ = _tmp4_;
#line 244 "../src/BatchImport.vala"
		_tmp6_ = g_file_get_path (_tmp5_);
#line 244 "../src/BatchImport.vala"
		_g_free0 (_tmp0_);
#line 244 "../src/BatchImport.vala"
		_tmp0_ = _tmp6_;
#line 244 "../src/BatchImport.vala"
		_g_object_unref0 (_tmp5_);
#line 4316 "BatchImport.c"
	}
#line 244 "../src/BatchImport.vala"
	result = _tmp0_;
#line 244 "../src/BatchImport.vala"
	return result;
#line 4322 "BatchImport.c"
}

static gpointer
_batch_import_job_ref0 (gpointer self)
{
#line 248 "../src/BatchImport.vala"
	return self ? batch_import_job_ref (self) : NULL;
#line 4330 "BatchImport.c"
}

static void
file_import_job_real_set_associated (BatchImportJob* base,
                                     BatchImportJob* associated)
{
	FileImportJob * self;
	FileImportJob* _tmp0_;
#line 247 "../src/BatchImport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_FILE_IMPORT_JOB, FileImportJob);
#line 247 "../src/BatchImport.vala"
	g_return_if_fail (IS_BATCH_IMPORT_JOB (associated));
#line 248 "../src/BatchImport.vala"
	_tmp0_ = _batch_import_job_ref0 (IS_FILE_IMPORT_JOB (associated) ? ((FileImportJob*) associated) : NULL);
#line 248 "../src/BatchImport.vala"
	_batch_import_job_unref0 (self->priv->associated);
#line 248 "../src/BatchImport.vala"
	self->priv->associated = _tmp0_;
#line 4349 "BatchImport.c"
}

static gboolean
file_import_job_real_determine_file_size (BatchImportJob* base,
                                          guint64* filesize,
                                          GFile** file)
{
	FileImportJob * self;
	guint64 _vala_filesize = 0ULL;
	GFile* _vala_file = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	gboolean result;
#line 251 "../src/BatchImport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_FILE_IMPORT_JOB, FileImportJob);
#line 252 "../src/BatchImport.vala"
	_vala_filesize = (guint64) 0;
#line 253 "../src/BatchImport.vala"
	_tmp0_ = self->priv->file_or_dir;
#line 253 "../src/BatchImport.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 253 "../src/BatchImport.vala"
	_g_object_unref0 (_vala_file);
#line 253 "../src/BatchImport.vala"
	_vala_file = _tmp1_;
#line 255 "../src/BatchImport.vala"
	result = FALSE;
#line 255 "../src/BatchImport.vala"
	if (filesize) {
#line 255 "../src/BatchImport.vala"
		*filesize = _vala_filesize;
#line 4381 "BatchImport.c"
	}
#line 255 "../src/BatchImport.vala"
	if (file) {
#line 255 "../src/BatchImport.vala"
		*file = _vala_file;
#line 4387 "BatchImport.c"
	} else {
#line 255 "../src/BatchImport.vala"
		_g_object_unref0 (_vala_file);
#line 4391 "BatchImport.c"
	}
#line 255 "../src/BatchImport.vala"
	return result;
#line 4395 "BatchImport.c"
}

static gboolean
file_import_job_real_prepare (BatchImportJob* base,
                              GFile** file_to_import,
                              gboolean* copy,
                              GError** error)
{
	FileImportJob * self;
	GFile* _vala_file_to_import = NULL;
	gboolean _vala_copy = FALSE;
	GFile* _tmp0_;
	GFile* _tmp1_;
	gboolean result;
#line 258 "../src/BatchImport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_FILE_IMPORT_JOB, FileImportJob);
#line 259 "../src/BatchImport.vala"
	_tmp0_ = self->priv->file_or_dir;
#line 259 "../src/BatchImport.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 259 "../src/BatchImport.vala"
	_g_object_unref0 (_vala_file_to_import);
#line 259 "../src/BatchImport.vala"
	_vala_file_to_import = _tmp1_;
#line 260 "../src/BatchImport.vala"
	_vala_copy = self->priv->copy_to_library;
#line 262 "../src/BatchImport.vala"
	result = TRUE;
#line 262 "../src/BatchImport.vala"
	if (file_to_import) {
#line 262 "../src/BatchImport.vala"
		*file_to_import = _vala_file_to_import;
#line 4428 "BatchImport.c"
	} else {
#line 262 "../src/BatchImport.vala"
		_g_object_unref0 (_vala_file_to_import);
#line 4432 "BatchImport.c"
	}
#line 262 "../src/BatchImport.vala"
	if (copy) {
#line 262 "../src/BatchImport.vala"
		*copy = _vala_copy;
#line 4438 "BatchImport.c"
	}
#line 262 "../src/BatchImport.vala"
	return result;
#line 4442 "BatchImport.c"
}

GFile*
file_import_job_get_file (FileImportJob* self)
{
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFile* result;
#line 265 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_FILE_IMPORT_JOB (self), NULL);
#line 266 "../src/BatchImport.vala"
	_tmp0_ = self->priv->file_or_dir;
#line 266 "../src/BatchImport.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 266 "../src/BatchImport.vala"
	result = _tmp1_;
#line 266 "../src/BatchImport.vala"
	return result;
#line 4461 "BatchImport.c"
}

static gboolean
file_import_job_real_recurse (BatchImportJob* base)
{
	FileImportJob * self;
	gboolean result;
#line 269 "../src/BatchImport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_FILE_IMPORT_JOB, FileImportJob);
#line 270 "../src/BatchImport.vala"
	result = self->priv->_recurse;
#line 270 "../src/BatchImport.vala"
	return result;
#line 4475 "BatchImport.c"
}

static void
file_import_job_class_init (FileImportJobClass * klass,
                            gpointer klass_data)
{
#line 215 "../src/BatchImport.vala"
	file_import_job_parent_class = g_type_class_peek_parent (klass);
#line 215 "../src/BatchImport.vala"
	((BatchImportJobClass *) klass)->finalize = file_import_job_finalize;
#line 215 "../src/BatchImport.vala"
	g_type_class_adjust_private_offset (klass, &FileImportJob_private_offset);
#line 215 "../src/BatchImport.vala"
	((BatchImportJobClass *) klass)->get_dest_identifier = (gchar* (*) (BatchImportJob*)) file_import_job_real_get_dest_identifier;
#line 215 "../src/BatchImport.vala"
	((BatchImportJobClass *) klass)->get_source_identifier = (gchar* (*) (BatchImportJob*)) file_import_job_real_get_source_identifier;
#line 215 "../src/BatchImport.vala"
	((BatchImportJobClass *) klass)->is_directory = (gboolean (*) (BatchImportJob*)) file_import_job_real_is_directory;
#line 215 "../src/BatchImport.vala"
	((BatchImportJobClass *) klass)->get_basename = (gchar* (*) (BatchImportJob*)) file_import_job_real_get_basename;
#line 215 "../src/BatchImport.vala"
	((BatchImportJobClass *) klass)->get_path = (gchar* (*) (BatchImportJob*)) file_import_job_real_get_path;
#line 215 "../src/BatchImport.vala"
	((BatchImportJobClass *) klass)->set_associated = (void (*) (BatchImportJob*, BatchImportJob*)) file_import_job_real_set_associated;
#line 215 "../src/BatchImport.vala"
	((BatchImportJobClass *) klass)->determine_file_size = (gboolean (*) (BatchImportJob*, guint64*, GFile**)) file_import_job_real_determine_file_size;
#line 215 "../src/BatchImport.vala"
	((BatchImportJobClass *) klass)->prepare = (gboolean (*) (BatchImportJob*, GFile**, gboolean*, GError**)) file_import_job_real_prepare;
#line 215 "../src/BatchImport.vala"
	((BatchImportJobClass *) klass)->recurse = (gboolean (*) (BatchImportJob*)) file_import_job_real_recurse;
#line 4506 "BatchImport.c"
}

static void
file_import_job_instance_init (FileImportJob * self,
                               gpointer klass)
{
#line 215 "../src/BatchImport.vala"
	self->priv = file_import_job_get_instance_private (self);
#line 218 "../src/BatchImport.vala"
	self->priv->associated = NULL;
#line 4517 "BatchImport.c"
}

static void
file_import_job_finalize (BatchImportJob * obj)
{
	FileImportJob * self;
#line 215 "../src/BatchImport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_FILE_IMPORT_JOB, FileImportJob);
#line 216 "../src/BatchImport.vala"
	_g_object_unref0 (self->priv->file_or_dir);
#line 218 "../src/BatchImport.vala"
	_batch_import_job_unref0 (self->priv->associated);
#line 215 "../src/BatchImport.vala"
	BATCH_IMPORT_JOB_CLASS (file_import_job_parent_class)->finalize (obj);
#line 4532 "BatchImport.c"
}

static GType
file_import_job_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FileImportJobClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) file_import_job_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FileImportJob), 0, (GInstanceInitFunc) file_import_job_instance_init, NULL };
	GType file_import_job_type_id;
	file_import_job_type_id = g_type_register_static (TYPE_BATCH_IMPORT_JOB, "FileImportJob", &g_define_type_info, 0);
	FileImportJob_private_offset = g_type_add_instance_private (file_import_job_type_id, sizeof (FileImportJobPrivate));
	return file_import_job_type_id;
}

GType
file_import_job_get_type (void)
{
	static volatile gsize file_import_job_type_id__once = 0;
	if (g_once_init_enter (&file_import_job_type_id__once)) {
		GType file_import_job_type_id;
		file_import_job_type_id = file_import_job_get_type_once ();
		g_once_init_leave (&file_import_job_type_id__once, file_import_job_type_id);
	}
	return file_import_job_type_id__once;
}

BatchImportRoll*
batch_import_roll_construct (GType object_type)
{
	BatchImportRoll* self = NULL;
	ImportID _tmp0_ = {0};
#line 281 "../src/BatchImport.vala"
	self = (BatchImportRoll*) g_type_create_instance (object_type);
#line 282 "../src/BatchImport.vala"
	import_id_generate (&_tmp0_);
#line 282 "../src/BatchImport.vala"
	self->import_id = _tmp0_;
#line 281 "../src/BatchImport.vala"
	return self;
#line 4570 "BatchImport.c"
}

BatchImportRoll*
batch_import_roll_new (void)
{
#line 281 "../src/BatchImport.vala"
	return batch_import_roll_construct (TYPE_BATCH_IMPORT_ROLL);
#line 4578 "BatchImport.c"
}

static void
value_batch_import_roll_init (GValue* value)
{
#line 277 "../src/BatchImport.vala"
	value->data[0].v_pointer = NULL;
#line 4586 "BatchImport.c"
}

static void
value_batch_import_roll_free_value (GValue* value)
{
#line 277 "../src/BatchImport.vala"
	if (value->data[0].v_pointer) {
#line 277 "../src/BatchImport.vala"
		batch_import_roll_unref (value->data[0].v_pointer);
#line 4596 "BatchImport.c"
	}
}

static void
value_batch_import_roll_copy_value (const GValue* src_value,
                                    GValue* dest_value)
{
#line 277 "../src/BatchImport.vala"
	if (src_value->data[0].v_pointer) {
#line 277 "../src/BatchImport.vala"
		dest_value->data[0].v_pointer = batch_import_roll_ref (src_value->data[0].v_pointer);
#line 4608 "BatchImport.c"
	} else {
#line 277 "../src/BatchImport.vala"
		dest_value->data[0].v_pointer = NULL;
#line 4612 "BatchImport.c"
	}
}

static gpointer
value_batch_import_roll_peek_pointer (const GValue* value)
{
#line 277 "../src/BatchImport.vala"
	return value->data[0].v_pointer;
#line 4621 "BatchImport.c"
}

static gchar*
value_batch_import_roll_collect_value (GValue* value,
                                       guint n_collect_values,
                                       GTypeCValue* collect_values,
                                       guint collect_flags)
{
#line 277 "../src/BatchImport.vala"
	if (collect_values[0].v_pointer) {
#line 4632 "BatchImport.c"
		BatchImportRoll * object;
		object = collect_values[0].v_pointer;
#line 277 "../src/BatchImport.vala"
		if (object->parent_instance.g_class == NULL) {
#line 277 "../src/BatchImport.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 4639 "BatchImport.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 277 "../src/BatchImport.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 4643 "BatchImport.c"
		}
#line 277 "../src/BatchImport.vala"
		value->data[0].v_pointer = batch_import_roll_ref (object);
#line 4647 "BatchImport.c"
	} else {
#line 277 "../src/BatchImport.vala"
		value->data[0].v_pointer = NULL;
#line 4651 "BatchImport.c"
	}
#line 277 "../src/BatchImport.vala"
	return NULL;
#line 4655 "BatchImport.c"
}

static gchar*
value_batch_import_roll_lcopy_value (const GValue* value,
                                     guint n_collect_values,
                                     GTypeCValue* collect_values,
                                     guint collect_flags)
{
	BatchImportRoll ** object_p;
	object_p = collect_values[0].v_pointer;
#line 277 "../src/BatchImport.vala"
	if (!object_p) {
#line 277 "../src/BatchImport.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 4670 "BatchImport.c"
	}
#line 277 "../src/BatchImport.vala"
	if (!value->data[0].v_pointer) {
#line 277 "../src/BatchImport.vala"
		*object_p = NULL;
#line 4676 "BatchImport.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 277 "../src/BatchImport.vala"
		*object_p = value->data[0].v_pointer;
#line 4680 "BatchImport.c"
	} else {
#line 277 "../src/BatchImport.vala"
		*object_p = batch_import_roll_ref (value->data[0].v_pointer);
#line 4684 "BatchImport.c"
	}
#line 277 "../src/BatchImport.vala"
	return NULL;
#line 4688 "BatchImport.c"
}

GParamSpec*
param_spec_batch_import_roll (const gchar* name,
                              const gchar* nick,
                              const gchar* blurb,
                              GType object_type,
                              GParamFlags flags)
{
	ParamSpecBatchImportRoll* spec;
#line 277 "../src/BatchImport.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_BATCH_IMPORT_ROLL), NULL);
#line 277 "../src/BatchImport.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 277 "../src/BatchImport.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 277 "../src/BatchImport.vala"
	return G_PARAM_SPEC (spec);
#line 4707 "BatchImport.c"
}

gpointer
value_get_batch_import_roll (const GValue* value)
{
#line 277 "../src/BatchImport.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_BATCH_IMPORT_ROLL), NULL);
#line 277 "../src/BatchImport.vala"
	return value->data[0].v_pointer;
#line 4717 "BatchImport.c"
}

void
value_set_batch_import_roll (GValue* value,
                             gpointer v_object)
{
	BatchImportRoll * old;
#line 277 "../src/BatchImport.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_BATCH_IMPORT_ROLL));
#line 277 "../src/BatchImport.vala"
	old = value->data[0].v_pointer;
#line 277 "../src/BatchImport.vala"
	if (v_object) {
#line 277 "../src/BatchImport.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_BATCH_IMPORT_ROLL));
#line 277 "../src/BatchImport.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 277 "../src/BatchImport.vala"
		value->data[0].v_pointer = v_object;
#line 277 "../src/BatchImport.vala"
		batch_import_roll_ref (value->data[0].v_pointer);
#line 4739 "BatchImport.c"
	} else {
#line 277 "../src/BatchImport.vala"
		value->data[0].v_pointer = NULL;
#line 4743 "BatchImport.c"
	}
#line 277 "../src/BatchImport.vala"
	if (old) {
#line 277 "../src/BatchImport.vala"
		batch_import_roll_unref (old);
#line 4749 "BatchImport.c"
	}
}

void
value_take_batch_import_roll (GValue* value,
                              gpointer v_object)
{
	BatchImportRoll * old;
#line 277 "../src/BatchImport.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_BATCH_IMPORT_ROLL));
#line 277 "../src/BatchImport.vala"
	old = value->data[0].v_pointer;
#line 277 "../src/BatchImport.vala"
	if (v_object) {
#line 277 "../src/BatchImport.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_BATCH_IMPORT_ROLL));
#line 277 "../src/BatchImport.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 277 "../src/BatchImport.vala"
		value->data[0].v_pointer = v_object;
#line 4770 "BatchImport.c"
	} else {
#line 277 "../src/BatchImport.vala"
		value->data[0].v_pointer = NULL;
#line 4774 "BatchImport.c"
	}
#line 277 "../src/BatchImport.vala"
	if (old) {
#line 277 "../src/BatchImport.vala"
		batch_import_roll_unref (old);
#line 4780 "BatchImport.c"
	}
}

static void
batch_import_roll_class_init (BatchImportRollClass * klass,
                              gpointer klass_data)
{
#line 277 "../src/BatchImport.vala"
	batch_import_roll_parent_class = g_type_class_peek_parent (klass);
#line 277 "../src/BatchImport.vala"
	((BatchImportRollClass *) klass)->finalize = batch_import_roll_finalize;
#line 4792 "BatchImport.c"
}

static void
batch_import_roll_instance_init (BatchImportRoll * self,
                                 gpointer klass)
{
	ViewCollection* _tmp0_;
#line 279 "../src/BatchImport.vala"
	_tmp0_ = view_collection_new ("BatchImportRoll generated events");
#line 279 "../src/BatchImport.vala"
	self->generated_events = _tmp0_;
#line 277 "../src/BatchImport.vala"
	self->ref_count = 1;
#line 4806 "BatchImport.c"
}

static void
batch_import_roll_finalize (BatchImportRoll * obj)
{
	BatchImportRoll * self;
#line 277 "../src/BatchImport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BATCH_IMPORT_ROLL, BatchImportRoll);
#line 277 "../src/BatchImport.vala"
	g_signal_handlers_destroy (self);
#line 279 "../src/BatchImport.vala"
	_data_collection_unref0 (self->generated_events);
#line 4819 "BatchImport.c"
}

static GType
batch_import_roll_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_batch_import_roll_init, value_batch_import_roll_free_value, value_batch_import_roll_copy_value, value_batch_import_roll_peek_pointer, "p", value_batch_import_roll_collect_value, "p", value_batch_import_roll_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (BatchImportRollClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) batch_import_roll_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BatchImportRoll), 0, (GInstanceInitFunc) batch_import_roll_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType batch_import_roll_type_id;
	batch_import_roll_type_id = g_type_register_fundamental (g_type_fundamental_next (), "BatchImportRoll", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return batch_import_roll_type_id;
}

GType
batch_import_roll_get_type (void)
{
	static volatile gsize batch_import_roll_type_id__once = 0;
	if (g_once_init_enter (&batch_import_roll_type_id__once)) {
		GType batch_import_roll_type_id;
		batch_import_roll_type_id = batch_import_roll_get_type_once ();
		g_once_init_leave (&batch_import_roll_type_id__once, batch_import_roll_type_id);
	}
	return batch_import_roll_type_id__once;
}

gpointer
batch_import_roll_ref (gpointer instance)
{
	BatchImportRoll * self;
	self = instance;
#line 277 "../src/BatchImport.vala"
	g_atomic_int_inc (&self->ref_count);
#line 277 "../src/BatchImport.vala"
	return instance;
#line 4854 "BatchImport.c"
}

void
batch_import_roll_unref (gpointer instance)
{
	BatchImportRoll * self;
	self = instance;
#line 277 "../src/BatchImport.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 277 "../src/BatchImport.vala"
		BATCH_IMPORT_ROLL_GET_CLASS (self)->finalize (self);
#line 277 "../src/BatchImport.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 4868 "BatchImport.c"
	}
}

BatchImportResult*
batch_import_result_construct (GType object_type,
                               BatchImportJob* job,
                               GFile* file,
                               const gchar* src_identifier,
                               const gchar* dest_identifier,
                               DuplicatedFile* duplicate_of,
                               ImportResult _result_)
{
	BatchImportResult* self = NULL;
	BatchImportJob* _tmp0_;
	GFile* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	DuplicatedFile* _tmp4_;
#line 301 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_BATCH_IMPORT_JOB (job), NULL);
#line 301 "../src/BatchImport.vala"
	g_return_val_if_fail ((file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 301 "../src/BatchImport.vala"
	g_return_val_if_fail (src_identifier != NULL, NULL);
#line 301 "../src/BatchImport.vala"
	g_return_val_if_fail (dest_identifier != NULL, NULL);
#line 301 "../src/BatchImport.vala"
	g_return_val_if_fail ((duplicate_of == NULL) || IS_DUPLICATED_FILE (duplicate_of), NULL);
#line 301 "../src/BatchImport.vala"
	self = (BatchImportResult*) g_type_create_instance (object_type);
#line 303 "../src/BatchImport.vala"
	_tmp0_ = _batch_import_job_ref0 (job);
#line 303 "../src/BatchImport.vala"
	_batch_import_job_unref0 (self->job);
#line 303 "../src/BatchImport.vala"
	self->job = _tmp0_;
#line 304 "../src/BatchImport.vala"
	_tmp1_ = _g_object_ref0 (file);
#line 304 "../src/BatchImport.vala"
	_g_object_unref0 (self->file);
#line 304 "../src/BatchImport.vala"
	self->file = _tmp1_;
#line 305 "../src/BatchImport.vala"
	_tmp2_ = g_strdup (src_identifier);
#line 305 "../src/BatchImport.vala"
	_g_free0 (self->src_identifier);
#line 305 "../src/BatchImport.vala"
	self->src_identifier = _tmp2_;
#line 306 "../src/BatchImport.vala"
	_tmp3_ = g_strdup (dest_identifier);
#line 306 "../src/BatchImport.vala"
	_g_free0 (self->dest_identifier);
#line 306 "../src/BatchImport.vala"
	self->dest_identifier = _tmp3_;
#line 307 "../src/BatchImport.vala"
	_tmp4_ = _g_object_ref0 (duplicate_of);
#line 307 "../src/BatchImport.vala"
	_g_object_unref0 (self->duplicate_of);
#line 307 "../src/BatchImport.vala"
	self->duplicate_of = _tmp4_;
#line 308 "../src/BatchImport.vala"
	self->result = _result_;
#line 301 "../src/BatchImport.vala"
	return self;
#line 4933 "BatchImport.c"
}

BatchImportResult*
batch_import_result_new (BatchImportJob* job,
                         GFile* file,
                         const gchar* src_identifier,
                         const gchar* dest_identifier,
                         DuplicatedFile* duplicate_of,
                         ImportResult _result_)
{
#line 301 "../src/BatchImport.vala"
	return batch_import_result_construct (TYPE_BATCH_IMPORT_RESULT, job, file, src_identifier, dest_identifier, duplicate_of, _result_);
#line 4946 "BatchImport.c"
}

BatchImportResult*
batch_import_result_construct_from_error (GType object_type,
                                          BatchImportJob* job,
                                          GFile* file,
                                          const gchar* src_identifier,
                                          const gchar* dest_identifier,
                                          GError* err,
                                          ImportResult default_result)
{
	BatchImportResult* self = NULL;
	BatchImportJob* _tmp0_;
	GFile* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
#line 311 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_BATCH_IMPORT_JOB (job), NULL);
#line 311 "../src/BatchImport.vala"
	g_return_val_if_fail ((file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 311 "../src/BatchImport.vala"
	g_return_val_if_fail (src_identifier != NULL, NULL);
#line 311 "../src/BatchImport.vala"
	g_return_val_if_fail (dest_identifier != NULL, NULL);
#line 311 "../src/BatchImport.vala"
	g_return_val_if_fail (err != NULL, NULL);
#line 311 "../src/BatchImport.vala"
	self = (BatchImportResult*) g_type_create_instance (object_type);
#line 313 "../src/BatchImport.vala"
	_tmp0_ = _batch_import_job_ref0 (job);
#line 313 "../src/BatchImport.vala"
	_batch_import_job_unref0 (self->job);
#line 313 "../src/BatchImport.vala"
	self->job = _tmp0_;
#line 314 "../src/BatchImport.vala"
	_tmp1_ = _g_object_ref0 (file);
#line 314 "../src/BatchImport.vala"
	_g_object_unref0 (self->file);
#line 314 "../src/BatchImport.vala"
	self->file = _tmp1_;
#line 315 "../src/BatchImport.vala"
	_tmp2_ = g_strdup (src_identifier);
#line 315 "../src/BatchImport.vala"
	_g_free0 (self->src_identifier);
#line 315 "../src/BatchImport.vala"
	self->src_identifier = _tmp2_;
#line 316 "../src/BatchImport.vala"
	_tmp3_ = g_strdup (dest_identifier);
#line 316 "../src/BatchImport.vala"
	_g_free0 (self->dest_identifier);
#line 316 "../src/BatchImport.vala"
	self->dest_identifier = _tmp3_;
#line 317 "../src/BatchImport.vala"
	self->result = import_result_convert_error (err, default_result);
#line 318 "../src/BatchImport.vala"
	_tmp4_ = err->message;
#line 318 "../src/BatchImport.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 318 "../src/BatchImport.vala"
	_g_free0 (self->errmsg);
#line 318 "../src/BatchImport.vala"
	self->errmsg = _tmp5_;
#line 311 "../src/BatchImport.vala"
	return self;
#line 5013 "BatchImport.c"
}

BatchImportResult*
batch_import_result_new_from_error (BatchImportJob* job,
                                    GFile* file,
                                    const gchar* src_identifier,
                                    const gchar* dest_identifier,
                                    GError* err,
                                    ImportResult default_result)
{
#line 311 "../src/BatchImport.vala"
	return batch_import_result_construct_from_error (TYPE_BATCH_IMPORT_RESULT, job, file, src_identifier, dest_identifier, err, default_result);
#line 5026 "BatchImport.c"
}

static void
value_batch_import_result_init (GValue* value)
{
#line 292 "../src/BatchImport.vala"
	value->data[0].v_pointer = NULL;
#line 5034 "BatchImport.c"
}

static void
value_batch_import_result_free_value (GValue* value)
{
#line 292 "../src/BatchImport.vala"
	if (value->data[0].v_pointer) {
#line 292 "../src/BatchImport.vala"
		batch_import_result_unref (value->data[0].v_pointer);
#line 5044 "BatchImport.c"
	}
}

static void
value_batch_import_result_copy_value (const GValue* src_value,
                                      GValue* dest_value)
{
#line 292 "../src/BatchImport.vala"
	if (src_value->data[0].v_pointer) {
#line 292 "../src/BatchImport.vala"
		dest_value->data[0].v_pointer = batch_import_result_ref (src_value->data[0].v_pointer);
#line 5056 "BatchImport.c"
	} else {
#line 292 "../src/BatchImport.vala"
		dest_value->data[0].v_pointer = NULL;
#line 5060 "BatchImport.c"
	}
}

static gpointer
value_batch_import_result_peek_pointer (const GValue* value)
{
#line 292 "../src/BatchImport.vala"
	return value->data[0].v_pointer;
#line 5069 "BatchImport.c"
}

static gchar*
value_batch_import_result_collect_value (GValue* value,
                                         guint n_collect_values,
                                         GTypeCValue* collect_values,
                                         guint collect_flags)
{
#line 292 "../src/BatchImport.vala"
	if (collect_values[0].v_pointer) {
#line 5080 "BatchImport.c"
		BatchImportResult * object;
		object = collect_values[0].v_pointer;
#line 292 "../src/BatchImport.vala"
		if (object->parent_instance.g_class == NULL) {
#line 292 "../src/BatchImport.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 5087 "BatchImport.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 292 "../src/BatchImport.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 5091 "BatchImport.c"
		}
#line 292 "../src/BatchImport.vala"
		value->data[0].v_pointer = batch_import_result_ref (object);
#line 5095 "BatchImport.c"
	} else {
#line 292 "../src/BatchImport.vala"
		value->data[0].v_pointer = NULL;
#line 5099 "BatchImport.c"
	}
#line 292 "../src/BatchImport.vala"
	return NULL;
#line 5103 "BatchImport.c"
}

static gchar*
value_batch_import_result_lcopy_value (const GValue* value,
                                       guint n_collect_values,
                                       GTypeCValue* collect_values,
                                       guint collect_flags)
{
	BatchImportResult ** object_p;
	object_p = collect_values[0].v_pointer;
#line 292 "../src/BatchImport.vala"
	if (!object_p) {
#line 292 "../src/BatchImport.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 5118 "BatchImport.c"
	}
#line 292 "../src/BatchImport.vala"
	if (!value->data[0].v_pointer) {
#line 292 "../src/BatchImport.vala"
		*object_p = NULL;
#line 5124 "BatchImport.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 292 "../src/BatchImport.vala"
		*object_p = value->data[0].v_pointer;
#line 5128 "BatchImport.c"
	} else {
#line 292 "../src/BatchImport.vala"
		*object_p = batch_import_result_ref (value->data[0].v_pointer);
#line 5132 "BatchImport.c"
	}
#line 292 "../src/BatchImport.vala"
	return NULL;
#line 5136 "BatchImport.c"
}

GParamSpec*
param_spec_batch_import_result (const gchar* name,
                                const gchar* nick,
                                const gchar* blurb,
                                GType object_type,
                                GParamFlags flags)
{
	ParamSpecBatchImportResult* spec;
#line 292 "../src/BatchImport.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_BATCH_IMPORT_RESULT), NULL);
#line 292 "../src/BatchImport.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 292 "../src/BatchImport.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 292 "../src/BatchImport.vala"
	return G_PARAM_SPEC (spec);
#line 5155 "BatchImport.c"
}

gpointer
value_get_batch_import_result (const GValue* value)
{
#line 292 "../src/BatchImport.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_BATCH_IMPORT_RESULT), NULL);
#line 292 "../src/BatchImport.vala"
	return value->data[0].v_pointer;
#line 5165 "BatchImport.c"
}

void
value_set_batch_import_result (GValue* value,
                               gpointer v_object)
{
	BatchImportResult * old;
#line 292 "../src/BatchImport.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_BATCH_IMPORT_RESULT));
#line 292 "../src/BatchImport.vala"
	old = value->data[0].v_pointer;
#line 292 "../src/BatchImport.vala"
	if (v_object) {
#line 292 "../src/BatchImport.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_BATCH_IMPORT_RESULT));
#line 292 "../src/BatchImport.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 292 "../src/BatchImport.vala"
		value->data[0].v_pointer = v_object;
#line 292 "../src/BatchImport.vala"
		batch_import_result_ref (value->data[0].v_pointer);
#line 5187 "BatchImport.c"
	} else {
#line 292 "../src/BatchImport.vala"
		value->data[0].v_pointer = NULL;
#line 5191 "BatchImport.c"
	}
#line 292 "../src/BatchImport.vala"
	if (old) {
#line 292 "../src/BatchImport.vala"
		batch_import_result_unref (old);
#line 5197 "BatchImport.c"
	}
}

void
value_take_batch_import_result (GValue* value,
                                gpointer v_object)
{
	BatchImportResult * old;
#line 292 "../src/BatchImport.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_BATCH_IMPORT_RESULT));
#line 292 "../src/BatchImport.vala"
	old = value->data[0].v_pointer;
#line 292 "../src/BatchImport.vala"
	if (v_object) {
#line 292 "../src/BatchImport.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_BATCH_IMPORT_RESULT));
#line 292 "../src/BatchImport.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 292 "../src/BatchImport.vala"
		value->data[0].v_pointer = v_object;
#line 5218 "BatchImport.c"
	} else {
#line 292 "../src/BatchImport.vala"
		value->data[0].v_pointer = NULL;
#line 5222 "BatchImport.c"
	}
#line 292 "../src/BatchImport.vala"
	if (old) {
#line 292 "../src/BatchImport.vala"
		batch_import_result_unref (old);
#line 5228 "BatchImport.c"
	}
}

static void
batch_import_result_class_init (BatchImportResultClass * klass,
                                gpointer klass_data)
{
#line 292 "../src/BatchImport.vala"
	batch_import_result_parent_class = g_type_class_peek_parent (klass);
#line 292 "../src/BatchImport.vala"
	((BatchImportResultClass *) klass)->finalize = batch_import_result_finalize;
#line 5240 "BatchImport.c"
}

static void
batch_import_result_instance_init (BatchImportResult * self,
                                   gpointer klass)
{
#line 298 "../src/BatchImport.vala"
	self->errmsg = NULL;
#line 292 "../src/BatchImport.vala"
	self->ref_count = 1;
#line 5251 "BatchImport.c"
}

static void
batch_import_result_finalize (BatchImportResult * obj)
{
	BatchImportResult * self;
#line 292 "../src/BatchImport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BATCH_IMPORT_RESULT, BatchImportResult);
#line 292 "../src/BatchImport.vala"
	g_signal_handlers_destroy (self);
#line 293 "../src/BatchImport.vala"
	_batch_import_job_unref0 (self->job);
#line 294 "../src/BatchImport.vala"
	_g_object_unref0 (self->file);
#line 295 "../src/BatchImport.vala"
	_g_free0 (self->src_identifier);
#line 296 "../src/BatchImport.vala"
	_g_free0 (self->dest_identifier);
#line 298 "../src/BatchImport.vala"
	_g_free0 (self->errmsg);
#line 299 "../src/BatchImport.vala"
	_g_object_unref0 (self->duplicate_of);
#line 5274 "BatchImport.c"
}

static GType
batch_import_result_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_batch_import_result_init, value_batch_import_result_free_value, value_batch_import_result_copy_value, value_batch_import_result_peek_pointer, "p", value_batch_import_result_collect_value, "p", value_batch_import_result_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (BatchImportResultClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) batch_import_result_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BatchImportResult), 0, (GInstanceInitFunc) batch_import_result_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType batch_import_result_type_id;
	batch_import_result_type_id = g_type_register_fundamental (g_type_fundamental_next (), "BatchImportResult", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return batch_import_result_type_id;
}

GType
batch_import_result_get_type (void)
{
	static volatile gsize batch_import_result_type_id__once = 0;
	if (g_once_init_enter (&batch_import_result_type_id__once)) {
		GType batch_import_result_type_id;
		batch_import_result_type_id = batch_import_result_get_type_once ();
		g_once_init_leave (&batch_import_result_type_id__once, batch_import_result_type_id);
	}
	return batch_import_result_type_id__once;
}

gpointer
batch_import_result_ref (gpointer instance)
{
	BatchImportResult * self;
	self = instance;
#line 292 "../src/BatchImport.vala"
	g_atomic_int_inc (&self->ref_count);
#line 292 "../src/BatchImport.vala"
	return instance;
#line 5309 "BatchImport.c"
}

void
batch_import_result_unref (gpointer instance)
{
	BatchImportResult * self;
	self = instance;
#line 292 "../src/BatchImport.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 292 "../src/BatchImport.vala"
		BATCH_IMPORT_RESULT_GET_CLASS (self)->finalize (self);
#line 292 "../src/BatchImport.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 5323 "BatchImport.c"
	}
}

ImportManifest*
import_manifest_construct (GType object_type,
                           GeeList* prefailed,
                           GeeList* pre_already_imported)
{
	ImportManifest* self = NULL;
	GTimer* _tmp0_;
#line 336 "../src/BatchImport.vala"
	g_return_val_if_fail ((prefailed == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (prefailed, GEE_TYPE_LIST), NULL);
#line 336 "../src/BatchImport.vala"
	g_return_val_if_fail ((pre_already_imported == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (pre_already_imported, GEE_TYPE_LIST), NULL);
#line 336 "../src/BatchImport.vala"
	self = (ImportManifest*) g_type_create_instance (object_type);
#line 338 "../src/BatchImport.vala"
	_tmp0_ = g_timer_new ();
#line 338 "../src/BatchImport.vala"
	_g_timer_destroy0 (self->timer);
#line 338 "../src/BatchImport.vala"
	self->timer = _tmp0_;
#line 339 "../src/BatchImport.vala"
	if (prefailed != NULL) {
#line 5348 "BatchImport.c"
		{
			GeeList* _job_list = NULL;
			gint _job_size = 0;
			GeeList* _tmp1_;
			gint _tmp2_;
			gint _tmp3_;
			gint _job_index = 0;
#line 340 "../src/BatchImport.vala"
			_job_list = prefailed;
#line 340 "../src/BatchImport.vala"
			_tmp1_ = _job_list;
#line 340 "../src/BatchImport.vala"
			_tmp2_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_COLLECTION, GeeCollection));
#line 340 "../src/BatchImport.vala"
			_tmp3_ = _tmp2_;
#line 340 "../src/BatchImport.vala"
			_job_size = _tmp3_;
#line 340 "../src/BatchImport.vala"
			_job_index = -1;
#line 340 "../src/BatchImport.vala"
			while (TRUE) {
#line 5370 "BatchImport.c"
				gint _tmp4_;
				gint _tmp5_;
				BatchImportJob* job = NULL;
				GeeList* _tmp6_;
				gpointer _tmp7_;
				BatchImportResult* batch_result = NULL;
				BatchImportJob* _tmp8_;
				BatchImportJob* _tmp9_;
				gchar* _tmp10_;
				gchar* _tmp11_;
				BatchImportJob* _tmp12_;
				gchar* _tmp13_;
				gchar* _tmp14_;
				BatchImportResult* _tmp15_;
				BatchImportResult* _tmp16_;
				BatchImportResult* _tmp17_;
#line 340 "../src/BatchImport.vala"
				_job_index = _job_index + 1;
#line 340 "../src/BatchImport.vala"
				_tmp4_ = _job_index;
#line 340 "../src/BatchImport.vala"
				_tmp5_ = _job_size;
#line 340 "../src/BatchImport.vala"
				if (!(_tmp4_ < _tmp5_)) {
#line 340 "../src/BatchImport.vala"
					break;
#line 5397 "BatchImport.c"
				}
#line 340 "../src/BatchImport.vala"
				_tmp6_ = _job_list;
#line 340 "../src/BatchImport.vala"
				_tmp7_ = gee_list_get (_tmp6_, _job_index);
#line 340 "../src/BatchImport.vala"
				job = (BatchImportJob*) _tmp7_;
#line 341 "../src/BatchImport.vala"
				_tmp8_ = job;
#line 341 "../src/BatchImport.vala"
				_tmp9_ = job;
#line 341 "../src/BatchImport.vala"
				_tmp10_ = batch_import_job_get_source_identifier (_tmp9_);
#line 341 "../src/BatchImport.vala"
				_tmp11_ = _tmp10_;
#line 341 "../src/BatchImport.vala"
				_tmp12_ = job;
#line 341 "../src/BatchImport.vala"
				_tmp13_ = batch_import_job_get_dest_identifier (_tmp12_);
#line 341 "../src/BatchImport.vala"
				_tmp14_ = _tmp13_;
#line 341 "../src/BatchImport.vala"
				_tmp15_ = batch_import_result_new (_tmp8_, NULL, _tmp11_, _tmp14_, NULL, IMPORT_RESULT_FILE_ERROR);
#line 341 "../src/BatchImport.vala"
				_tmp16_ = _tmp15_;
#line 341 "../src/BatchImport.vala"
				_g_free0 (_tmp14_);
#line 341 "../src/BatchImport.vala"
				_g_free0 (_tmp11_);
#line 341 "../src/BatchImport.vala"
				batch_result = _tmp16_;
#line 345 "../src/BatchImport.vala"
				_tmp17_ = batch_result;
#line 345 "../src/BatchImport.vala"
				import_manifest_add_result (self, _tmp17_);
#line 340 "../src/BatchImport.vala"
				_batch_import_result_unref0 (batch_result);
#line 340 "../src/BatchImport.vala"
				_batch_import_job_unref0 (job);
#line 5437 "BatchImport.c"
			}
		}
	}
#line 349 "../src/BatchImport.vala"
	if (pre_already_imported != NULL) {
#line 5443 "BatchImport.c"
		{
			GeeList* _job_list = NULL;
			gint _job_size = 0;
			GeeList* _tmp18_;
			gint _tmp19_;
			gint _tmp20_;
			gint _job_index = 0;
#line 350 "../src/BatchImport.vala"
			_job_list = pre_already_imported;
#line 350 "../src/BatchImport.vala"
			_tmp18_ = _job_list;
#line 350 "../src/BatchImport.vala"
			_tmp19_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, GEE_TYPE_COLLECTION, GeeCollection));
#line 350 "../src/BatchImport.vala"
			_tmp20_ = _tmp19_;
#line 350 "../src/BatchImport.vala"
			_job_size = _tmp20_;
#line 350 "../src/BatchImport.vala"
			_job_index = -1;
#line 350 "../src/BatchImport.vala"
			while (TRUE) {
#line 5465 "BatchImport.c"
				gint _tmp21_;
				gint _tmp22_;
				BatchImportJob* job = NULL;
				GeeList* _tmp23_;
				gpointer _tmp24_;
				BatchImportResult* batch_result = NULL;
				BatchImportJob* _tmp25_;
				BatchImportJob* _tmp26_;
				gchar* _tmp27_;
				gchar* _tmp28_;
				GFile* _tmp29_;
				GFile* _tmp30_;
				BatchImportJob* _tmp31_;
				gchar* _tmp32_;
				gchar* _tmp33_;
				BatchImportJob* _tmp34_;
				gchar* _tmp35_;
				gchar* _tmp36_;
				BatchImportJob* _tmp37_;
				DuplicatedFile* _tmp38_;
				DuplicatedFile* _tmp39_;
				BatchImportResult* _tmp40_;
				BatchImportResult* _tmp41_;
				BatchImportResult* _tmp42_;
#line 350 "../src/BatchImport.vala"
				_job_index = _job_index + 1;
#line 350 "../src/BatchImport.vala"
				_tmp21_ = _job_index;
#line 350 "../src/BatchImport.vala"
				_tmp22_ = _job_size;
#line 350 "../src/BatchImport.vala"
				if (!(_tmp21_ < _tmp22_)) {
#line 350 "../src/BatchImport.vala"
					break;
#line 5500 "BatchImport.c"
				}
#line 350 "../src/BatchImport.vala"
				_tmp23_ = _job_list;
#line 350 "../src/BatchImport.vala"
				_tmp24_ = gee_list_get (_tmp23_, _job_index);
#line 350 "../src/BatchImport.vala"
				job = (BatchImportJob*) _tmp24_;
#line 351 "../src/BatchImport.vala"
				_tmp25_ = job;
#line 351 "../src/BatchImport.vala"
				_tmp26_ = job;
#line 351 "../src/BatchImport.vala"
				_tmp27_ = batch_import_job_get_basename (_tmp26_);
#line 351 "../src/BatchImport.vala"
				_tmp28_ = _tmp27_;
#line 351 "../src/BatchImport.vala"
				_tmp29_ = g_file_new_for_path (_tmp28_);
#line 351 "../src/BatchImport.vala"
				_tmp30_ = _tmp29_;
#line 351 "../src/BatchImport.vala"
				_tmp31_ = job;
#line 351 "../src/BatchImport.vala"
				_tmp32_ = batch_import_job_get_source_identifier (_tmp31_);
#line 351 "../src/BatchImport.vala"
				_tmp33_ = _tmp32_;
#line 351 "../src/BatchImport.vala"
				_tmp34_ = job;
#line 351 "../src/BatchImport.vala"
				_tmp35_ = batch_import_job_get_dest_identifier (_tmp34_);
#line 351 "../src/BatchImport.vala"
				_tmp36_ = _tmp35_;
#line 351 "../src/BatchImport.vala"
				_tmp37_ = job;
#line 351 "../src/BatchImport.vala"
				_tmp38_ = batch_import_job_get_duplicated_file (_tmp37_);
#line 351 "../src/BatchImport.vala"
				_tmp39_ = _tmp38_;
#line 351 "../src/BatchImport.vala"
				_tmp40_ = batch_import_result_new (_tmp25_, _tmp30_, _tmp33_, _tmp36_, _tmp39_, IMPORT_RESULT_PHOTO_EXISTS);
#line 351 "../src/BatchImport.vala"
				_tmp41_ = _tmp40_;
#line 351 "../src/BatchImport.vala"
				_g_object_unref0 (_tmp39_);
#line 351 "../src/BatchImport.vala"
				_g_free0 (_tmp36_);
#line 351 "../src/BatchImport.vala"
				_g_free0 (_tmp33_);
#line 351 "../src/BatchImport.vala"
				_g_object_unref0 (_tmp30_);
#line 351 "../src/BatchImport.vala"
				_g_free0 (_tmp28_);
#line 351 "../src/BatchImport.vala"
				batch_result = _tmp41_;
#line 356 "../src/BatchImport.vala"
				_tmp42_ = batch_result;
#line 356 "../src/BatchImport.vala"
				import_manifest_add_result (self, _tmp42_);
#line 350 "../src/BatchImport.vala"
				_batch_import_result_unref0 (batch_result);
#line 350 "../src/BatchImport.vala"
				_batch_import_job_unref0 (job);
#line 5562 "BatchImport.c"
			}
		}
	}
#line 336 "../src/BatchImport.vala"
	return self;
#line 5568 "BatchImport.c"
}

ImportManifest*
import_manifest_new (GeeList* prefailed,
                     GeeList* pre_already_imported)
{
#line 336 "../src/BatchImport.vala"
	return import_manifest_construct (TYPE_IMPORT_MANIFEST, prefailed, pre_already_imported);
#line 5577 "BatchImport.c"
}

void
import_manifest_add_result (ImportManifest* self,
                            BatchImportResult* batch_result)
{
	gboolean reported = FALSE;
#line 361 "../src/BatchImport.vala"
	g_return_if_fail (IS_IMPORT_MANIFEST (self));
#line 361 "../src/BatchImport.vala"
	g_return_if_fail (IS_BATCH_IMPORT_RESULT (batch_result));
#line 362 "../src/BatchImport.vala"
	reported = TRUE;
#line 363 "../src/BatchImport.vala"
	switch (batch_result->result) {
#line 363 "../src/BatchImport.vala"
		case IMPORT_RESULT_SUCCESS:
#line 5595 "BatchImport.c"
		{
			GeeList* _tmp0_;
#line 365 "../src/BatchImport.vala"
			_tmp0_ = self->success;
#line 365 "../src/BatchImport.vala"
			gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection), batch_result);
#line 366 "../src/BatchImport.vala"
			break;
#line 5604 "BatchImport.c"
		}
#line 363 "../src/BatchImport.vala"
		case IMPORT_RESULT_USER_ABORT:
#line 5608 "BatchImport.c"
		{
			gboolean _tmp1_ = FALSE;
			GFile* _tmp2_;
#line 369 "../src/BatchImport.vala"
			_tmp2_ = batch_result->file;
#line 369 "../src/BatchImport.vala"
			if (_tmp2_ != NULL) {
#line 5616 "BatchImport.c"
				GFile* _tmp3_;
#line 369 "../src/BatchImport.vala"
				_tmp3_ = batch_result->file;
#line 369 "../src/BatchImport.vala"
				_tmp1_ = !query_is_directory (_tmp3_);
#line 5622 "BatchImport.c"
			} else {
#line 369 "../src/BatchImport.vala"
				_tmp1_ = FALSE;
#line 5626 "BatchImport.c"
			}
#line 369 "../src/BatchImport.vala"
			if (_tmp1_) {
#line 5630 "BatchImport.c"
				GeeList* _tmp4_;
#line 370 "../src/BatchImport.vala"
				_tmp4_ = self->aborted;
#line 370 "../src/BatchImport.vala"
				gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_COLLECTION, GeeCollection), batch_result);
#line 5636 "BatchImport.c"
			} else {
#line 372 "../src/BatchImport.vala"
				reported = FALSE;
#line 5640 "BatchImport.c"
			}
#line 373 "../src/BatchImport.vala"
			break;
#line 5644 "BatchImport.c"
		}
#line 363 "../src/BatchImport.vala"
		case IMPORT_RESULT_UNSUPPORTED_FORMAT:
#line 5648 "BatchImport.c"
		{
			GeeList* _tmp5_;
#line 376 "../src/BatchImport.vala"
			_tmp5_ = self->skipped_photos;
#line 376 "../src/BatchImport.vala"
			gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_COLLECTION, GeeCollection), batch_result);
#line 377 "../src/BatchImport.vala"
			break;
#line 5657 "BatchImport.c"
		}
#line 363 "../src/BatchImport.vala"
		case IMPORT_RESULT_NOT_A_FILE:
#line 363 "../src/BatchImport.vala"
		case IMPORT_RESULT_NOT_AN_IMAGE:
#line 5663 "BatchImport.c"
		{
			GeeList* _tmp6_;
#line 381 "../src/BatchImport.vala"
			_tmp6_ = self->skipped_files;
#line 381 "../src/BatchImport.vala"
			gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_COLLECTION, GeeCollection), batch_result);
#line 382 "../src/BatchImport.vala"
			break;
#line 5672 "BatchImport.c"
		}
#line 363 "../src/BatchImport.vala"
		case IMPORT_RESULT_PHOTO_EXISTS:
#line 5676 "BatchImport.c"
		{
			GeeList* _tmp7_;
#line 385 "../src/BatchImport.vala"
			_tmp7_ = self->already_imported;
#line 385 "../src/BatchImport.vala"
			gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_COLLECTION, GeeCollection), batch_result);
#line 386 "../src/BatchImport.vala"
			break;
#line 5685 "BatchImport.c"
		}
#line 363 "../src/BatchImport.vala"
		case IMPORT_RESULT_CAMERA_ERROR:
#line 5689 "BatchImport.c"
		{
			GeeList* _tmp8_;
#line 389 "../src/BatchImport.vala"
			_tmp8_ = self->camera_failed;
#line 389 "../src/BatchImport.vala"
			gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEE_TYPE_COLLECTION, GeeCollection), batch_result);
#line 390 "../src/BatchImport.vala"
			break;
#line 5698 "BatchImport.c"
		}
#line 363 "../src/BatchImport.vala"
		case IMPORT_RESULT_FILE_WRITE_ERROR:
#line 5702 "BatchImport.c"
		{
			GeeList* _tmp9_;
#line 393 "../src/BatchImport.vala"
			_tmp9_ = self->write_failed;
#line 393 "../src/BatchImport.vala"
			gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_COLLECTION, GeeCollection), batch_result);
#line 394 "../src/BatchImport.vala"
			break;
#line 5711 "BatchImport.c"
		}
#line 363 "../src/BatchImport.vala"
		case IMPORT_RESULT_PIXBUF_CORRUPT_IMAGE:
#line 5715 "BatchImport.c"
		{
			GeeList* _tmp10_;
#line 397 "../src/BatchImport.vala"
			_tmp10_ = self->corrupt_files;
#line 397 "../src/BatchImport.vala"
			gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, GEE_TYPE_COLLECTION, GeeCollection), batch_result);
#line 398 "../src/BatchImport.vala"
			break;
#line 5724 "BatchImport.c"
		}
		default:
		{
			GeeList* _tmp11_;
#line 401 "../src/BatchImport.vala"
			_tmp11_ = self->failed;
#line 401 "../src/BatchImport.vala"
			gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, GEE_TYPE_COLLECTION, GeeCollection), batch_result);
#line 402 "../src/BatchImport.vala"
			break;
#line 5735 "BatchImport.c"
		}
	}
#line 405 "../src/BatchImport.vala"
	if (reported) {
#line 5740 "BatchImport.c"
		GeeList* _tmp12_;
#line 406 "../src/BatchImport.vala"
		_tmp12_ = self->all;
#line 406 "../src/BatchImport.vala"
		gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GEE_TYPE_COLLECTION, GeeCollection), batch_result);
#line 5746 "BatchImport.c"
	}
}

static void
value_import_manifest_init (GValue* value)
{
#line 322 "../src/BatchImport.vala"
	value->data[0].v_pointer = NULL;
#line 5755 "BatchImport.c"
}

static void
value_import_manifest_free_value (GValue* value)
{
#line 322 "../src/BatchImport.vala"
	if (value->data[0].v_pointer) {
#line 322 "../src/BatchImport.vala"
		import_manifest_unref (value->data[0].v_pointer);
#line 5765 "BatchImport.c"
	}
}

static void
value_import_manifest_copy_value (const GValue* src_value,
                                  GValue* dest_value)
{
#line 322 "../src/BatchImport.vala"
	if (src_value->data[0].v_pointer) {
#line 322 "../src/BatchImport.vala"
		dest_value->data[0].v_pointer = import_manifest_ref (src_value->data[0].v_pointer);
#line 5777 "BatchImport.c"
	} else {
#line 322 "../src/BatchImport.vala"
		dest_value->data[0].v_pointer = NULL;
#line 5781 "BatchImport.c"
	}
}

static gpointer
value_import_manifest_peek_pointer (const GValue* value)
{
#line 322 "../src/BatchImport.vala"
	return value->data[0].v_pointer;
#line 5790 "BatchImport.c"
}

static gchar*
value_import_manifest_collect_value (GValue* value,
                                     guint n_collect_values,
                                     GTypeCValue* collect_values,
                                     guint collect_flags)
{
#line 322 "../src/BatchImport.vala"
	if (collect_values[0].v_pointer) {
#line 5801 "BatchImport.c"
		ImportManifest * object;
		object = collect_values[0].v_pointer;
#line 322 "../src/BatchImport.vala"
		if (object->parent_instance.g_class == NULL) {
#line 322 "../src/BatchImport.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 5808 "BatchImport.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 322 "../src/BatchImport.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 5812 "BatchImport.c"
		}
#line 322 "../src/BatchImport.vala"
		value->data[0].v_pointer = import_manifest_ref (object);
#line 5816 "BatchImport.c"
	} else {
#line 322 "../src/BatchImport.vala"
		value->data[0].v_pointer = NULL;
#line 5820 "BatchImport.c"
	}
#line 322 "../src/BatchImport.vala"
	return NULL;
#line 5824 "BatchImport.c"
}

static gchar*
value_import_manifest_lcopy_value (const GValue* value,
                                   guint n_collect_values,
                                   GTypeCValue* collect_values,
                                   guint collect_flags)
{
	ImportManifest ** object_p;
	object_p = collect_values[0].v_pointer;
#line 322 "../src/BatchImport.vala"
	if (!object_p) {
#line 322 "../src/BatchImport.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 5839 "BatchImport.c"
	}
#line 322 "../src/BatchImport.vala"
	if (!value->data[0].v_pointer) {
#line 322 "../src/BatchImport.vala"
		*object_p = NULL;
#line 5845 "BatchImport.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 322 "../src/BatchImport.vala"
		*object_p = value->data[0].v_pointer;
#line 5849 "BatchImport.c"
	} else {
#line 322 "../src/BatchImport.vala"
		*object_p = import_manifest_ref (value->data[0].v_pointer);
#line 5853 "BatchImport.c"
	}
#line 322 "../src/BatchImport.vala"
	return NULL;
#line 5857 "BatchImport.c"
}

GParamSpec*
param_spec_import_manifest (const gchar* name,
                            const gchar* nick,
                            const gchar* blurb,
                            GType object_type,
                            GParamFlags flags)
{
	ParamSpecImportManifest* spec;
#line 322 "../src/BatchImport.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_IMPORT_MANIFEST), NULL);
#line 322 "../src/BatchImport.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 322 "../src/BatchImport.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 322 "../src/BatchImport.vala"
	return G_PARAM_SPEC (spec);
#line 5876 "BatchImport.c"
}

gpointer
value_get_import_manifest (const GValue* value)
{
#line 322 "../src/BatchImport.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_IMPORT_MANIFEST), NULL);
#line 322 "../src/BatchImport.vala"
	return value->data[0].v_pointer;
#line 5886 "BatchImport.c"
}

void
value_set_import_manifest (GValue* value,
                           gpointer v_object)
{
	ImportManifest * old;
#line 322 "../src/BatchImport.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_IMPORT_MANIFEST));
#line 322 "../src/BatchImport.vala"
	old = value->data[0].v_pointer;
#line 322 "../src/BatchImport.vala"
	if (v_object) {
#line 322 "../src/BatchImport.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_IMPORT_MANIFEST));
#line 322 "../src/BatchImport.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 322 "../src/BatchImport.vala"
		value->data[0].v_pointer = v_object;
#line 322 "../src/BatchImport.vala"
		import_manifest_ref (value->data[0].v_pointer);
#line 5908 "BatchImport.c"
	} else {
#line 322 "../src/BatchImport.vala"
		value->data[0].v_pointer = NULL;
#line 5912 "BatchImport.c"
	}
#line 322 "../src/BatchImport.vala"
	if (old) {
#line 322 "../src/BatchImport.vala"
		import_manifest_unref (old);
#line 5918 "BatchImport.c"
	}
}

void
value_take_import_manifest (GValue* value,
                            gpointer v_object)
{
	ImportManifest * old;
#line 322 "../src/BatchImport.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_IMPORT_MANIFEST));
#line 322 "../src/BatchImport.vala"
	old = value->data[0].v_pointer;
#line 322 "../src/BatchImport.vala"
	if (v_object) {
#line 322 "../src/BatchImport.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_IMPORT_MANIFEST));
#line 322 "../src/BatchImport.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 322 "../src/BatchImport.vala"
		value->data[0].v_pointer = v_object;
#line 5939 "BatchImport.c"
	} else {
#line 322 "../src/BatchImport.vala"
		value->data[0].v_pointer = NULL;
#line 5943 "BatchImport.c"
	}
#line 322 "../src/BatchImport.vala"
	if (old) {
#line 322 "../src/BatchImport.vala"
		import_manifest_unref (old);
#line 5949 "BatchImport.c"
	}
}

static void
import_manifest_class_init (ImportManifestClass * klass,
                            gpointer klass_data)
{
#line 322 "../src/BatchImport.vala"
	import_manifest_parent_class = g_type_class_peek_parent (klass);
#line 322 "../src/BatchImport.vala"
	((ImportManifestClass *) klass)->finalize = import_manifest_finalize;
#line 5961 "BatchImport.c"
}

static void
import_manifest_instance_init (ImportManifest * self,
                               gpointer klass)
{
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
	GeeArrayList* _tmp4_;
	GeeArrayList* _tmp5_;
	GeeArrayList* _tmp6_;
	GeeArrayList* _tmp7_;
	GeeArrayList* _tmp8_;
	GeeArrayList* _tmp9_;
	GeeArrayList* _tmp10_;
#line 323 "../src/BatchImport.vala"
	_tmp0_ = gee_array_list_new (TYPE_MEDIA_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 323 "../src/BatchImport.vala"
	self->imported = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_LIST, GeeList);
#line 324 "../src/BatchImport.vala"
	_tmp1_ = gee_array_list_new (TYPE_BATCH_IMPORT_RESULT, (GBoxedCopyFunc) batch_import_result_ref, (GDestroyNotify) batch_import_result_unref, NULL, NULL, NULL);
#line 324 "../src/BatchImport.vala"
	self->success = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_LIST, GeeList);
#line 325 "../src/BatchImport.vala"
	_tmp2_ = gee_array_list_new (TYPE_BATCH_IMPORT_RESULT, (GBoxedCopyFunc) batch_import_result_ref, (GDestroyNotify) batch_import_result_unref, NULL, NULL, NULL);
#line 325 "../src/BatchImport.vala"
	self->camera_failed = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_LIST, GeeList);
#line 326 "../src/BatchImport.vala"
	_tmp3_ = gee_array_list_new (TYPE_BATCH_IMPORT_RESULT, (GBoxedCopyFunc) batch_import_result_ref, (GDestroyNotify) batch_import_result_unref, NULL, NULL, NULL);
#line 326 "../src/BatchImport.vala"
	self->failed = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_LIST, GeeList);
#line 327 "../src/BatchImport.vala"
	_tmp4_ = gee_array_list_new (TYPE_BATCH_IMPORT_RESULT, (GBoxedCopyFunc) batch_import_result_ref, (GDestroyNotify) batch_import_result_unref, NULL, NULL, NULL);
#line 327 "../src/BatchImport.vala"
	self->write_failed = G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_LIST, GeeList);
#line 328 "../src/BatchImport.vala"
	_tmp5_ = gee_array_list_new (TYPE_BATCH_IMPORT_RESULT, (GBoxedCopyFunc) batch_import_result_ref, (GDestroyNotify) batch_import_result_unref, NULL, NULL, NULL);
#line 328 "../src/BatchImport.vala"
	self->skipped_photos = G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_LIST, GeeList);
#line 329 "../src/BatchImport.vala"
	_tmp6_ = gee_array_list_new (TYPE_BATCH_IMPORT_RESULT, (GBoxedCopyFunc) batch_import_result_ref, (GDestroyNotify) batch_import_result_unref, NULL, NULL, NULL);
#line 329 "../src/BatchImport.vala"
	self->skipped_files = G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_LIST, GeeList);
#line 330 "../src/BatchImport.vala"
	_tmp7_ = gee_array_list_new (TYPE_BATCH_IMPORT_RESULT, (GBoxedCopyFunc) batch_import_result_ref, (GDestroyNotify) batch_import_result_unref, NULL, NULL, NULL);
#line 330 "../src/BatchImport.vala"
	self->aborted = G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_LIST, GeeList);
#line 331 "../src/BatchImport.vala"
	_tmp8_ = gee_array_list_new (TYPE_BATCH_IMPORT_RESULT, (GBoxedCopyFunc) batch_import_result_ref, (GDestroyNotify) batch_import_result_unref, NULL, NULL, NULL);
#line 331 "../src/BatchImport.vala"
	self->already_imported = G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEE_TYPE_LIST, GeeList);
#line 332 "../src/BatchImport.vala"
	_tmp9_ = gee_array_list_new (TYPE_BATCH_IMPORT_RESULT, (GBoxedCopyFunc) batch_import_result_ref, (GDestroyNotify) batch_import_result_unref, NULL, NULL, NULL);
#line 332 "../src/BatchImport.vala"
	self->corrupt_files = G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_LIST, GeeList);
#line 333 "../src/BatchImport.vala"
	_tmp10_ = gee_array_list_new (TYPE_BATCH_IMPORT_RESULT, (GBoxedCopyFunc) batch_import_result_ref, (GDestroyNotify) batch_import_result_unref, NULL, NULL, NULL);
#line 333 "../src/BatchImport.vala"
	self->all = G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, GEE_TYPE_LIST, GeeList);
#line 322 "../src/BatchImport.vala"
	self->ref_count = 1;
#line 6025 "BatchImport.c"
}

static void
import_manifest_finalize (ImportManifest * obj)
{
	ImportManifest * self;
#line 322 "../src/BatchImport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_IMPORT_MANIFEST, ImportManifest);
#line 322 "../src/BatchImport.vala"
	g_signal_handlers_destroy (self);
#line 323 "../src/BatchImport.vala"
	_g_object_unref0 (self->imported);
#line 324 "../src/BatchImport.vala"
	_g_object_unref0 (self->success);
#line 325 "../src/BatchImport.vala"
	_g_object_unref0 (self->camera_failed);
#line 326 "../src/BatchImport.vala"
	_g_object_unref0 (self->failed);
#line 327 "../src/BatchImport.vala"
	_g_object_unref0 (self->write_failed);
#line 328 "../src/BatchImport.vala"
	_g_object_unref0 (self->skipped_photos);
#line 329 "../src/BatchImport.vala"
	_g_object_unref0 (self->skipped_files);
#line 330 "../src/BatchImport.vala"
	_g_object_unref0 (self->aborted);
#line 331 "../src/BatchImport.vala"
	_g_object_unref0 (self->already_imported);
#line 332 "../src/BatchImport.vala"
	_g_object_unref0 (self->corrupt_files);
#line 333 "../src/BatchImport.vala"
	_g_object_unref0 (self->all);
#line 334 "../src/BatchImport.vala"
	_g_timer_destroy0 (self->timer);
#line 6060 "BatchImport.c"
}

static GType
import_manifest_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_import_manifest_init, value_import_manifest_free_value, value_import_manifest_copy_value, value_import_manifest_peek_pointer, "p", value_import_manifest_collect_value, "p", value_import_manifest_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (ImportManifestClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) import_manifest_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ImportManifest), 0, (GInstanceInitFunc) import_manifest_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType import_manifest_type_id;
	import_manifest_type_id = g_type_register_fundamental (g_type_fundamental_next (), "ImportManifest", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return import_manifest_type_id;
}

GType
import_manifest_get_type (void)
{
	static volatile gsize import_manifest_type_id__once = 0;
	if (g_once_init_enter (&import_manifest_type_id__once)) {
		GType import_manifest_type_id;
		import_manifest_type_id = import_manifest_get_type_once ();
		g_once_init_leave (&import_manifest_type_id__once, import_manifest_type_id);
	}
	return import_manifest_type_id__once;
}

gpointer
import_manifest_ref (gpointer instance)
{
	ImportManifest * self;
	self = instance;
#line 322 "../src/BatchImport.vala"
	g_atomic_int_inc (&self->ref_count);
#line 322 "../src/BatchImport.vala"
	return instance;
#line 6095 "BatchImport.c"
}

void
import_manifest_unref (gpointer instance)
{
	ImportManifest * self;
	self = instance;
#line 322 "../src/BatchImport.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 322 "../src/BatchImport.vala"
		IMPORT_MANIFEST_GET_CLASS (self)->finalize (self);
#line 322 "../src/BatchImport.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 6109 "BatchImport.c"
	}
}

static inline gpointer
batch_import_get_instance_private (BatchImport* self)
{
	return G_STRUCT_MEMBER_P (self, BatchImport_private_offset);
}

static void
_batch_import_user_halt_application_exiting (Application* _sender,
                                             gboolean panicked,
                                             gpointer self)
{
#line 524 "../src/BatchImport.vala"
	batch_import_user_halt ((BatchImport*) self);
#line 6126 "BatchImport.c"
}

static gpointer
_batch_import_roll_ref0 (gpointer self)
{
#line 504 "../src/BatchImport.vala"
	return self ? batch_import_roll_ref (self) : NULL;
#line 6134 "BatchImport.c"
}

static guint
_file_hash_gee_hash_data_func (gconstpointer v,
                               gpointer self)
{
	guint result;
	result = file_hash ((GFile*) v);
#line 507 "../src/BatchImport.vala"
	return result;
#line 6145 "BatchImport.c"
}

static gboolean
_file_equal_gee_equal_data_func (gconstpointer a,
                                 gconstpointer b,
                                 gpointer self)
{
	gboolean result;
	result = file_equal ((GFile*) a, (GFile*) b);
#line 507 "../src/BatchImport.vala"
	return result;
#line 6157 "BatchImport.c"
}

static gboolean
_batch_import_display_imported_timer_gsource_func (gpointer self)
{
	gboolean result;
	result = batch_import_display_imported_timer ((BatchImport*) self);
#line 517 "../src/BatchImport.vala"
	return result;
#line 6167 "BatchImport.c"
}

BatchImport*
batch_import_construct (GType object_type,
                        GeeIterable* jobs,
                        const gchar* name,
                        BatchImportImportReporter reporter,
                        gpointer reporter_target,
                        GeeArrayList* prefailed,
                        GeeArrayList* pre_already_imported,
                        GCancellable* cancellable,
                        BatchImportRoll* import_roll,
                        ImportManifest* skip_manifest)
{
	BatchImport * self = NULL;
	GeeIterable* _tmp0_;
	gchar* _tmp1_;
	ImportManifest* _tmp2_;
	GCancellable* _tmp3_ = NULL;
	GCancellable* _tmp6_;
	BatchImportRoll* _tmp7_ = NULL;
	BatchImportRoll* _tmp10_;
	Application* _tmp24_;
	Application* _tmp25_;
#line 494 "../src/BatchImport.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (jobs, GEE_TYPE_ITERABLE), NULL);
#line 494 "../src/BatchImport.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 494 "../src/BatchImport.vala"
	g_return_val_if_fail ((prefailed == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (prefailed, GEE_TYPE_ARRAY_LIST), NULL);
#line 494 "../src/BatchImport.vala"
	g_return_val_if_fail ((pre_already_imported == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (pre_already_imported, GEE_TYPE_ARRAY_LIST), NULL);
#line 494 "../src/BatchImport.vala"
	g_return_val_if_fail ((cancellable == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()), NULL);
#line 494 "../src/BatchImport.vala"
	g_return_val_if_fail ((import_roll == NULL) || IS_BATCH_IMPORT_ROLL (import_roll), NULL);
#line 494 "../src/BatchImport.vala"
	g_return_val_if_fail ((skip_manifest == NULL) || IS_IMPORT_MANIFEST (skip_manifest), NULL);
#line 494 "../src/BatchImport.vala"
	self = (BatchImport*) g_object_new (object_type, NULL);
#line 499 "../src/BatchImport.vala"
	_tmp0_ = _g_object_ref0 (jobs);
#line 499 "../src/BatchImport.vala"
	_g_object_unref0 (self->priv->jobs);
#line 499 "../src/BatchImport.vala"
	self->priv->jobs = _tmp0_;
#line 500 "../src/BatchImport.vala"
	_tmp1_ = g_strdup (name);
#line 500 "../src/BatchImport.vala"
	_g_free0 (self->priv->name);
#line 500 "../src/BatchImport.vala"
	self->priv->name = _tmp1_;
#line 501 "../src/BatchImport.vala"
	self->priv->reporter = reporter;
#line 501 "../src/BatchImport.vala"
	self->priv->reporter_target = reporter_target;
#line 502 "../src/BatchImport.vala"
	_tmp2_ = import_manifest_new (G_TYPE_CHECK_INSTANCE_CAST (prefailed, GEE_TYPE_LIST, GeeList), G_TYPE_CHECK_INSTANCE_CAST (pre_already_imported, GEE_TYPE_LIST, GeeList));
#line 502 "../src/BatchImport.vala"
	_import_manifest_unref0 (self->priv->manifest);
#line 502 "../src/BatchImport.vala"
	self->priv->manifest = _tmp2_;
#line 503 "../src/BatchImport.vala"
	if (cancellable != NULL) {
#line 6232 "BatchImport.c"
		GCancellable* _tmp4_;
#line 503 "../src/BatchImport.vala"
		_tmp4_ = _g_object_ref0 (cancellable);
#line 503 "../src/BatchImport.vala"
		_g_object_unref0 (_tmp3_);
#line 503 "../src/BatchImport.vala"
		_tmp3_ = _tmp4_;
#line 6240 "BatchImport.c"
	} else {
		GCancellable* _tmp5_;
#line 503 "../src/BatchImport.vala"
		_tmp5_ = g_cancellable_new ();
#line 503 "../src/BatchImport.vala"
		_g_object_unref0 (_tmp3_);
#line 503 "../src/BatchImport.vala"
		_tmp3_ = _tmp5_;
#line 6249 "BatchImport.c"
	}
#line 503 "../src/BatchImport.vala"
	_tmp6_ = _g_object_ref0 (_tmp3_);
#line 503 "../src/BatchImport.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 503 "../src/BatchImport.vala"
	self->priv->cancellable = _tmp6_;
#line 504 "../src/BatchImport.vala"
	if (import_roll != NULL) {
#line 6259 "BatchImport.c"
		BatchImportRoll* _tmp8_;
#line 504 "../src/BatchImport.vala"
		_tmp8_ = _batch_import_roll_ref0 (import_roll);
#line 504 "../src/BatchImport.vala"
		_batch_import_roll_unref0 (_tmp7_);
#line 504 "../src/BatchImport.vala"
		_tmp7_ = _tmp8_;
#line 6267 "BatchImport.c"
	} else {
		BatchImportRoll* _tmp9_;
#line 504 "../src/BatchImport.vala"
		_tmp9_ = batch_import_roll_new ();
#line 504 "../src/BatchImport.vala"
		_batch_import_roll_unref0 (_tmp7_);
#line 504 "../src/BatchImport.vala"
		_tmp7_ = _tmp9_;
#line 6276 "BatchImport.c"
	}
#line 504 "../src/BatchImport.vala"
	_tmp10_ = _batch_import_roll_ref0 (_tmp7_);
#line 504 "../src/BatchImport.vala"
	_batch_import_roll_unref0 (self->priv->import_roll);
#line 504 "../src/BatchImport.vala"
	self->priv->import_roll = _tmp10_;
#line 506 "../src/BatchImport.vala"
	if (skip_manifest != NULL) {
#line 6286 "BatchImport.c"
		GeeHashSet* _tmp11_;
#line 507 "../src/BatchImport.vala"
		_tmp11_ = gee_hash_set_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _file_hash_gee_hash_data_func, NULL, NULL, _file_equal_gee_equal_data_func, NULL, NULL);
#line 507 "../src/BatchImport.vala"
		_g_object_unref0 (self->priv->skipset);
#line 507 "../src/BatchImport.vala"
		self->priv->skipset = _tmp11_;
#line 6294 "BatchImport.c"
		{
			GeeList* _source_list = NULL;
			GeeList* _tmp12_;
			gint _source_size = 0;
			GeeList* _tmp13_;
			gint _tmp14_;
			gint _tmp15_;
			gint _source_index = 0;
#line 508 "../src/BatchImport.vala"
			_tmp12_ = skip_manifest->imported;
#line 508 "../src/BatchImport.vala"
			_source_list = _tmp12_;
#line 508 "../src/BatchImport.vala"
			_tmp13_ = _source_list;
#line 508 "../src/BatchImport.vala"
			_tmp14_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GEE_TYPE_COLLECTION, GeeCollection));
#line 508 "../src/BatchImport.vala"
			_tmp15_ = _tmp14_;
#line 508 "../src/BatchImport.vala"
			_source_size = _tmp15_;
#line 508 "../src/BatchImport.vala"
			_source_index = -1;
#line 508 "../src/BatchImport.vala"
			while (TRUE) {
#line 6319 "BatchImport.c"
				gint _tmp16_;
				gint _tmp17_;
				MediaSource* source = NULL;
				GeeList* _tmp18_;
				gpointer _tmp19_;
				GeeHashSet* _tmp20_;
				MediaSource* _tmp21_;
				GFile* _tmp22_;
				GFile* _tmp23_;
#line 508 "../src/BatchImport.vala"
				_source_index = _source_index + 1;
#line 508 "../src/BatchImport.vala"
				_tmp16_ = _source_index;
#line 508 "../src/BatchImport.vala"
				_tmp17_ = _source_size;
#line 508 "../src/BatchImport.vala"
				if (!(_tmp16_ < _tmp17_)) {
#line 508 "../src/BatchImport.vala"
					break;
#line 6339 "BatchImport.c"
				}
#line 508 "../src/BatchImport.vala"
				_tmp18_ = _source_list;
#line 508 "../src/BatchImport.vala"
				_tmp19_ = gee_list_get (_tmp18_, _source_index);
#line 508 "../src/BatchImport.vala"
				source = (MediaSource*) _tmp19_;
#line 509 "../src/BatchImport.vala"
				_tmp20_ = self->priv->skipset;
#line 509 "../src/BatchImport.vala"
				_tmp21_ = source;
#line 509 "../src/BatchImport.vala"
				_tmp22_ = media_source_get_file (_tmp21_);
#line 509 "../src/BatchImport.vala"
				_tmp23_ = _tmp22_;
#line 509 "../src/BatchImport.vala"
				gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp23_);
#line 509 "../src/BatchImport.vala"
				_g_object_unref0 (_tmp23_);
#line 508 "../src/BatchImport.vala"
				_g_object_unref0 (source);
#line 6361 "BatchImport.c"
			}
		}
	}
#line 514 "../src/BatchImport.vala"
	_tmp24_ = application_get_instance ();
#line 514 "../src/BatchImport.vala"
	_tmp25_ = _tmp24_;
#line 514 "../src/BatchImport.vala"
	g_signal_connect_object (_tmp25_, "exiting", (GCallback) _batch_import_user_halt_application_exiting, self, 0);
#line 514 "../src/BatchImport.vala"
	_application_unref0 (_tmp25_);
#line 517 "../src/BatchImport.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) BATCH_IMPORT_DISPLAY_QUEUE_TIMER_MSEC, _batch_import_display_imported_timer_gsource_func, g_object_ref (self), g_object_unref);
#line 494 "../src/BatchImport.vala"
	_batch_import_roll_unref0 (_tmp7_);
#line 494 "../src/BatchImport.vala"
	_g_object_unref0 (_tmp3_);
#line 494 "../src/BatchImport.vala"
	return self;
#line 6381 "BatchImport.c"
}

BatchImport*
batch_import_new (GeeIterable* jobs,
                  const gchar* name,
                  BatchImportImportReporter reporter,
                  gpointer reporter_target,
                  GeeArrayList* prefailed,
                  GeeArrayList* pre_already_imported,
                  GCancellable* cancellable,
                  BatchImportRoll* import_roll,
                  ImportManifest* skip_manifest)
{
#line 494 "../src/BatchImport.vala"
	return batch_import_construct (TYPE_BATCH_IMPORT, jobs, name, reporter, reporter_target, prefailed, pre_already_imported, cancellable, import_roll, skip_manifest);
#line 6397 "BatchImport.c"
}

gchar*
batch_import_get_name (BatchImport* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 527 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_BATCH_IMPORT (self), NULL);
#line 528 "../src/BatchImport.vala"
	_tmp0_ = self->priv->name;
#line 528 "../src/BatchImport.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 528 "../src/BatchImport.vala"
	result = _tmp1_;
#line 528 "../src/BatchImport.vala"
	return result;
#line 6416 "BatchImport.c"
}

void
batch_import_user_halt (BatchImport* self)
{
	GCancellable* _tmp0_;
#line 531 "../src/BatchImport.vala"
	g_return_if_fail (IS_BATCH_IMPORT (self));
#line 532 "../src/BatchImport.vala"
	_tmp0_ = self->priv->cancellable;
#line 532 "../src/BatchImport.vala"
	g_cancellable_cancel (_tmp0_);
#line 6429 "BatchImport.c"
}

gboolean
batch_import_get_untrash_duplicates (BatchImport* self)
{
	gboolean result;
#line 535 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_BATCH_IMPORT (self), FALSE);
#line 536 "../src/BatchImport.vala"
	result = self->priv->untrash_duplicates;
#line 536 "../src/BatchImport.vala"
	return result;
#line 6442 "BatchImport.c"
}

void
batch_import_set_untrash_duplicates (BatchImport* self,
                                     gboolean untrash_duplicates)
{
#line 539 "../src/BatchImport.vala"
	g_return_if_fail (IS_BATCH_IMPORT (self));
#line 540 "../src/BatchImport.vala"
	self->priv->untrash_duplicates = untrash_duplicates;
#line 6453 "BatchImport.c"
}

gboolean
batch_import_get_mark_duplicates_online (BatchImport* self)
{
	gboolean result;
#line 543 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_BATCH_IMPORT (self), FALSE);
#line 544 "../src/BatchImport.vala"
	result = self->priv->mark_duplicates_online;
#line 544 "../src/BatchImport.vala"
	return result;
#line 6466 "BatchImport.c"
}

void
batch_import_set_mark_duplicates_online (BatchImport* self,
                                         gboolean mark_duplicates_online)
{
#line 547 "../src/BatchImport.vala"
	g_return_if_fail (IS_BATCH_IMPORT (self));
#line 548 "../src/BatchImport.vala"
	self->priv->mark_duplicates_online = mark_duplicates_online;
#line 6477 "BatchImport.c"
}

static void
batch_import_log_status (BatchImport* self,
                         const gchar* where)
{
#line 551 "../src/BatchImport.vala"
	g_return_if_fail (IS_BATCH_IMPORT (self));
#line 551 "../src/BatchImport.vala"
	g_return_if_fail (where != NULL);
#line 6488 "BatchImport.c"
}

static gboolean
batch_import_report_failure (BatchImport* self,
                             BatchImportResult* import_result)
{
	gboolean proceed = FALSE;
	ImportManifest* _tmp0_;
	gboolean _tmp11_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 561 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_BATCH_IMPORT (self), FALSE);
#line 561 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_BATCH_IMPORT_RESULT (import_result), FALSE);
#line 562 "../src/BatchImport.vala"
	proceed = TRUE;
#line 564 "../src/BatchImport.vala"
	_tmp0_ = self->priv->manifest;
#line 564 "../src/BatchImport.vala"
	import_manifest_add_result (_tmp0_, import_result);
#line 566 "../src/BatchImport.vala"
	if (import_result->result != IMPORT_RESULT_SUCCESS) {
#line 6512 "BatchImport.c"
		gboolean _tmp1_ = FALSE;
		GFile* _tmp2_;
#line 567 "../src/BatchImport.vala"
		g_signal_emit (self, batch_import_signals[BATCH_IMPORT_IMPORT_JOB_FAILED_SIGNAL], 0, import_result);
#line 569 "../src/BatchImport.vala"
		_tmp2_ = import_result->file;
#line 569 "../src/BatchImport.vala"
		if (_tmp2_ != NULL) {
#line 569 "../src/BatchImport.vala"
			_tmp1_ = !import_result_is_abort (import_result->result);
#line 6523 "BatchImport.c"
		} else {
#line 569 "../src/BatchImport.vala"
			_tmp1_ = FALSE;
#line 6527 "BatchImport.c"
		}
#line 569 "../src/BatchImport.vala"
		if (_tmp1_) {
#line 6531 "BatchImport.c"
			guint64 filesize = 0ULL;
#line 570 "../src/BatchImport.vala"
			filesize = (guint64) 0;
#line 6535 "BatchImport.c"
			{
				guint64 _tmp3_ = 0ULL;
				GFile* _tmp4_;
#line 573 "../src/BatchImport.vala"
				_tmp4_ = import_result->file;
#line 573 "../src/BatchImport.vala"
				_tmp3_ = query_total_file_size (_tmp4_, NULL, &_inner_error0_);
#line 573 "../src/BatchImport.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6545 "BatchImport.c"
					goto __catch0_g_error;
				}
#line 573 "../src/BatchImport.vala"
				filesize = _tmp3_;
#line 6550 "BatchImport.c"
			}
			goto __finally0;
			__catch0_g_error:
			{
				GError* err = NULL;
				GFile* _tmp5_;
				gchar* _tmp6_;
				gchar* _tmp7_;
				GError* _tmp8_;
				const gchar* _tmp9_;
#line 571 "../src/BatchImport.vala"
				err = _inner_error0_;
#line 571 "../src/BatchImport.vala"
				_inner_error0_ = NULL;
#line 575 "../src/BatchImport.vala"
				_tmp5_ = import_result->file;
#line 575 "../src/BatchImport.vala"
				_tmp6_ = g_file_get_path (_tmp5_);
#line 575 "../src/BatchImport.vala"
				_tmp7_ = _tmp6_;
#line 575 "../src/BatchImport.vala"
				_tmp8_ = err;
#line 575 "../src/BatchImport.vala"
				_tmp9_ = _tmp8_->message;
#line 575 "../src/BatchImport.vala"
				g_warning ("BatchImport.vala:575: Unable to query file size of %s: %s", _tmp7_, _tmp9_);
#line 575 "../src/BatchImport.vala"
				_g_free0 (_tmp7_);
#line 571 "../src/BatchImport.vala"
				_g_error_free0 (err);
#line 6581 "BatchImport.c"
			}
			__finally0:
#line 571 "../src/BatchImport.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6586 "BatchImport.c"
				gboolean _tmp10_ = FALSE;
#line 571 "../src/BatchImport.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 571 "../src/BatchImport.vala"
				g_clear_error (&_inner_error0_);
#line 571 "../src/BatchImport.vala"
				return _tmp10_;
#line 6594 "BatchImport.c"
			}
#line 579 "../src/BatchImport.vala"
			batch_import_report_progress (self, filesize);
#line 6598 "BatchImport.c"
		}
	}
#line 584 "../src/BatchImport.vala"
	if (import_result_is_nonuser_abort (import_result->result)) {
#line 584 "../src/BatchImport.vala"
		_tmp11_ = proceed;
#line 6605 "BatchImport.c"
	} else {
#line 584 "../src/BatchImport.vala"
		_tmp11_ = FALSE;
#line 6609 "BatchImport.c"
	}
#line 584 "../src/BatchImport.vala"
	if (_tmp11_) {
#line 6613 "BatchImport.c"
		const gchar* _tmp12_;
#line 585 "../src/BatchImport.vala"
		_tmp12_ = import_result->errmsg;
#line 585 "../src/BatchImport.vala"
		g_signal_emit (self, batch_import_signals[BATCH_IMPORT_FATAL_ERROR_SIGNAL], 0, import_result->result, _tmp12_);
#line 586 "../src/BatchImport.vala"
		proceed = FALSE;
#line 6621 "BatchImport.c"
	}
#line 589 "../src/BatchImport.vala"
	result = proceed;
#line 589 "../src/BatchImport.vala"
	return result;
#line 6627 "BatchImport.c"
}

static void
batch_import_report_progress (BatchImport* self,
                              guint64 increment_of_progress)
{
#line 592 "../src/BatchImport.vala"
	g_return_if_fail (IS_BATCH_IMPORT (self));
#line 593 "../src/BatchImport.vala"
	self->priv->completed_bytes = self->priv->completed_bytes + increment_of_progress;
#line 597 "../src/BatchImport.vala"
	if (self->priv->completed_bytes == ((guint64) 0)) {
#line 6640 "BatchImport.c"
		gulong now = 0UL;
#line 598 "../src/BatchImport.vala"
		now = now_ms ();
#line 599 "../src/BatchImport.vala"
		if ((now - self->priv->last_preparing_ms) > ((gulong) 250)) {
#line 600 "../src/BatchImport.vala"
			self->priv->last_preparing_ms = now;
#line 601 "../src/BatchImport.vala"
			g_signal_emit (self, batch_import_signals[BATCH_IMPORT_PREPARING_SIGNAL], 0);
#line 6650 "BatchImport.c"
		}
	} else {
#line 603 "../src/BatchImport.vala"
		if (increment_of_progress > ((guint64) 0)) {
#line 6655 "BatchImport.c"
			gulong now = 0UL;
#line 604 "../src/BatchImport.vala"
			now = now_ms ();
#line 605 "../src/BatchImport.vala"
			if ((now - self->priv->last_preparing_ms) > ((gulong) 250)) {
#line 606 "../src/BatchImport.vala"
				self->priv->last_preparing_ms = now;
#line 607 "../src/BatchImport.vala"
				g_signal_emit (self, batch_import_signals[BATCH_IMPORT_PROGRESS_SIGNAL], 0, self->priv->completed_bytes, self->priv->total_bytes);
#line 6665 "BatchImport.c"
			}
		}
	}
}

static gboolean
batch_import_report_failures (BatchImport* self,
                              BackgroundImportJob* background_job)
{
	gboolean proceed = FALSE;
	gboolean result;
#line 612 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_BATCH_IMPORT (self), FALSE);
#line 612 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_BACKGROUND_IMPORT_JOB (background_job), FALSE);
#line 613 "../src/BatchImport.vala"
	proceed = TRUE;
#line 6683 "BatchImport.c"
	{
		GeeList* _import_result_list = NULL;
		GeeList* _tmp0_;
		gint _import_result_size = 0;
		GeeList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _import_result_index = 0;
#line 615 "../src/BatchImport.vala"
		_tmp0_ = background_job->failed;
#line 615 "../src/BatchImport.vala"
		_import_result_list = _tmp0_;
#line 615 "../src/BatchImport.vala"
		_tmp1_ = _import_result_list;
#line 615 "../src/BatchImport.vala"
		_tmp2_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_COLLECTION, GeeCollection));
#line 615 "../src/BatchImport.vala"
		_tmp3_ = _tmp2_;
#line 615 "../src/BatchImport.vala"
		_import_result_size = _tmp3_;
#line 615 "../src/BatchImport.vala"
		_import_result_index = -1;
#line 615 "../src/BatchImport.vala"
		while (TRUE) {
#line 6708 "BatchImport.c"
			gint _tmp4_;
			gint _tmp5_;
			BatchImportResult* import_result = NULL;
			GeeList* _tmp6_;
			gpointer _tmp7_;
			BatchImportResult* _tmp8_;
#line 615 "../src/BatchImport.vala"
			_import_result_index = _import_result_index + 1;
#line 615 "../src/BatchImport.vala"
			_tmp4_ = _import_result_index;
#line 615 "../src/BatchImport.vala"
			_tmp5_ = _import_result_size;
#line 615 "../src/BatchImport.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 615 "../src/BatchImport.vala"
				break;
#line 6725 "BatchImport.c"
			}
#line 615 "../src/BatchImport.vala"
			_tmp6_ = _import_result_list;
#line 615 "../src/BatchImport.vala"
			_tmp7_ = gee_list_get (_tmp6_, _import_result_index);
#line 615 "../src/BatchImport.vala"
			import_result = (BatchImportResult*) _tmp7_;
#line 616 "../src/BatchImport.vala"
			_tmp8_ = import_result;
#line 616 "../src/BatchImport.vala"
			if (!batch_import_report_failure (self, _tmp8_)) {
#line 617 "../src/BatchImport.vala"
				proceed = FALSE;
#line 6739 "BatchImport.c"
			}
#line 615 "../src/BatchImport.vala"
			_batch_import_result_unref0 (import_result);
#line 6743 "BatchImport.c"
		}
	}
#line 620 "../src/BatchImport.vala"
	result = proceed;
#line 620 "../src/BatchImport.vala"
	return result;
#line 6750 "BatchImport.c"
}

static void
batch_import_report_completed (BatchImport* self,
                               const gchar* where)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	ImportManifest* _tmp2_;
	GTimer* _tmp3_;
	BatchImportImportReporter _tmp4_;
	gpointer _tmp4__target;
	ImportManifest* _tmp8_;
	BatchImportRoll* _tmp9_;
#line 623 "../src/BatchImport.vala"
	g_return_if_fail (IS_BATCH_IMPORT (self));
#line 623 "../src/BatchImport.vala"
	g_return_if_fail (where != NULL);
#line 624 "../src/BatchImport.vala"
	if (self->priv->completed) {
#line 625 "../src/BatchImport.vala"
		g_error ("BatchImport.vala:625: Attempted to complete already-completed import: " \
"%s", where);
#line 6773 "BatchImport.c"
	}
#line 627 "../src/BatchImport.vala"
	self->priv->completed = TRUE;
#line 629 "../src/BatchImport.vala"
	batch_import_flush_ready_sources (self);
#line 631 "../src/BatchImport.vala"
	_tmp0_ = g_strdup_printf ("Import completed: %s", where);
#line 631 "../src/BatchImport.vala"
	_tmp1_ = _tmp0_;
#line 631 "../src/BatchImport.vala"
	batch_import_log_status (self, _tmp1_);
#line 631 "../src/BatchImport.vala"
	_g_free0 (_tmp1_);
#line 632 "../src/BatchImport.vala"
	_tmp2_ = self->priv->manifest;
#line 632 "../src/BatchImport.vala"
	_tmp3_ = _tmp2_->timer;
#line 632 "../src/BatchImport.vala"
	g_debug ("BatchImport.vala:632: Import complete after %f", g_timer_elapsed (_tmp3_, NULL));
#line 635 "../src/BatchImport.vala"
	_tmp4_ = self->priv->reporter;
#line 635 "../src/BatchImport.vala"
	_tmp4__target = self->priv->reporter_target;
#line 635 "../src/BatchImport.vala"
	if (_tmp4_ != NULL) {
#line 6799 "BatchImport.c"
		BatchImportImportReporter _tmp5_;
		gpointer _tmp5__target;
		ImportManifest* _tmp6_;
		BatchImportRoll* _tmp7_;
#line 636 "../src/BatchImport.vala"
		_tmp5_ = self->priv->reporter;
#line 636 "../src/BatchImport.vala"
		_tmp5__target = self->priv->reporter_target;
#line 636 "../src/BatchImport.vala"
		_tmp6_ = self->priv->manifest;
#line 636 "../src/BatchImport.vala"
		_tmp7_ = self->priv->import_roll;
#line 636 "../src/BatchImport.vala"
		_tmp5_ (_tmp6_, _tmp7_, _tmp5__target);
#line 6814 "BatchImport.c"
	}
#line 638 "../src/BatchImport.vala"
	_tmp8_ = self->priv->manifest;
#line 638 "../src/BatchImport.vala"
	_tmp9_ = self->priv->import_roll;
#line 638 "../src/BatchImport.vala"
	g_signal_emit (self, batch_import_signals[BATCH_IMPORT_IMPORT_COMPLETE_SIGNAL], 0, _tmp8_, _tmp9_);
#line 6822 "BatchImport.c"
}

static void
batch_import_file_import_complete (BatchImport* self)
{
	gint _tmp0_;
	gboolean _tmp1_ = FALSE;
#line 642 "../src/BatchImport.vala"
	g_return_if_fail (IS_BATCH_IMPORT (self));
#line 644 "../src/BatchImport.vala"
	_tmp0_ = self->priv->file_imports_completed;
#line 644 "../src/BatchImport.vala"
	self->priv->file_imports_completed = _tmp0_ + 1;
#line 645 "../src/BatchImport.vala"
	if (self->priv->file_imports_to_perform != -1) {
#line 646 "../src/BatchImport.vala"
		_vala_assert (self->priv->file_imports_completed <= self->priv->file_imports_to_perform, "file_imports_completed <= file_imports_to_perform");
#line 6840 "BatchImport.c"
	}
#line 650 "../src/BatchImport.vala"
	if (self->priv->file_imports_to_perform != -1) {
#line 650 "../src/BatchImport.vala"
		_tmp1_ = self->priv->file_imports_completed == self->priv->file_imports_to_perform;
#line 6846 "BatchImport.c"
	} else {
#line 650 "../src/BatchImport.vala"
		_tmp1_ = FALSE;
#line 6850 "BatchImport.c"
	}
#line 650 "../src/BatchImport.vala"
	if (_tmp1_) {
#line 651 "../src/BatchImport.vala"
		batch_import_report_completed (self, "completed preparing files, all outstanding imports completed");
#line 6856 "BatchImport.c"
	}
}

static void
_batch_import_on_work_sniffed_out_completion_callback (BackgroundJob* job,
                                                       gpointer self)
{
#line 661 "../src/BatchImport.vala"
	batch_import_on_work_sniffed_out ((BatchImport*) self, job);
#line 6866 "BatchImport.c"
}

static void
_batch_import_on_sniffer_cancelled_cancellation_callback (BackgroundJob* job,
                                                          gpointer self)
{
#line 661 "../src/BatchImport.vala"
	batch_import_on_sniffer_cancelled ((BatchImport*) self, job);
#line 6875 "BatchImport.c"
}

static gboolean
_batch_import_on_sniffer_working_gsource_func (gpointer self)
{
	gboolean result;
	result = batch_import_on_sniffer_working ((BatchImport*) self);
#line 663 "../src/BatchImport.vala"
	return result;
#line 6885 "BatchImport.c"
}

void
batch_import_schedule (BatchImport* self)
{
	Workers* _tmp0_;
	GeeIterable* _tmp1_;
	GCancellable* _tmp2_;
	GeeHashSet* _tmp3_;
	WorkSniffer* _tmp4_;
	WorkSniffer* _tmp5_;
#line 654 "../src/BatchImport.vala"
	g_return_if_fail (IS_BATCH_IMPORT (self));
#line 655 "../src/BatchImport.vala"
	_vala_assert (self->priv->scheduled == FALSE, "scheduled == false");
#line 656 "../src/BatchImport.vala"
	self->priv->scheduled = TRUE;
#line 658 "../src/BatchImport.vala"
	g_signal_emit (self, batch_import_signals[BATCH_IMPORT_STARTING_SIGNAL], 0);
#line 661 "../src/BatchImport.vala"
	_tmp0_ = batch_import_feeder_workers;
#line 661 "../src/BatchImport.vala"
	_tmp1_ = self->priv->jobs;
#line 661 "../src/BatchImport.vala"
	_tmp2_ = self->priv->cancellable;
#line 661 "../src/BatchImport.vala"
	_tmp3_ = self->priv->skipset;
#line 661 "../src/BatchImport.vala"
	_tmp4_ = work_sniffer_new (self, _tmp1_, _batch_import_on_work_sniffed_out_completion_callback, self, _tmp2_, _batch_import_on_sniffer_cancelled_cancellation_callback, self, _tmp3_);
#line 661 "../src/BatchImport.vala"
	_tmp5_ = _tmp4_;
#line 661 "../src/BatchImport.vala"
	workers_enqueue (_tmp0_, G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_BACKGROUND_JOB, BackgroundJob));
#line 661 "../src/BatchImport.vala"
	_background_job_unref0 (_tmp5_);
#line 663 "../src/BatchImport.vala"
	self->priv->throbber_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) BATCH_IMPORT_WORK_SNIFFER_THROBBER_MSEC, _batch_import_on_sniffer_working_gsource_func, g_object_ref (self), g_object_unref);
#line 6923 "BatchImport.c"
}

static gboolean
batch_import_on_sniffer_working (BatchImport* self)
{
	gboolean result;
#line 670 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_BATCH_IMPORT (self), FALSE);
#line 671 "../src/BatchImport.vala"
	batch_import_report_progress (self, (guint64) 0);
#line 673 "../src/BatchImport.vala"
	result = TRUE;
#line 673 "../src/BatchImport.vala"
	return result;
#line 6938 "BatchImport.c"
}

static gpointer
_background_job_ref0 (gpointer self)
{
#line 679 "../src/BatchImport.vala"
	return self ? background_job_ref (self) : NULL;
#line 6946 "BatchImport.c"
}

static void
_batch_import_on_file_prepared_notification_callback (BackgroundJob* job,
                                                      NotificationObject* user,
                                                      gpointer self)
{
#line 696 "../src/BatchImport.vala"
	batch_import_on_file_prepared ((BatchImport*) self, job, user);
#line 6956 "BatchImport.c"
}

static void
_batch_import_on_files_prepared_completion_callback (BackgroundJob* job,
                                                     gpointer self)
{
#line 696 "../src/BatchImport.vala"
	batch_import_on_files_prepared ((BatchImport*) self, job);
#line 6965 "BatchImport.c"
}

static void
_batch_import_on_file_prepare_cancelled_cancellation_callback (BackgroundJob* job,
                                                               gpointer self)
{
#line 696 "../src/BatchImport.vala"
	batch_import_on_file_prepare_cancelled ((BatchImport*) self, job);
#line 6974 "BatchImport.c"
}

static void
batch_import_on_work_sniffed_out (BatchImport* self,
                                  BackgroundJob* j)
{
	WorkSniffer* sniffer = NULL;
	WorkSniffer* _tmp0_;
	gboolean _tmp1_ = FALSE;
	WorkSniffer* _tmp2_;
	WorkSniffer* _tmp7_;
	PrepareFilesJob* prepare_files_job = NULL;
	WorkSniffer* _tmp8_;
	GeeList* _tmp9_;
	GCancellable* _tmp10_;
	PrepareFilesJob* _tmp11_;
	Workers* _tmp12_;
	PrepareFilesJob* _tmp13_;
#line 676 "../src/BatchImport.vala"
	g_return_if_fail (IS_BATCH_IMPORT (self));
#line 676 "../src/BatchImport.vala"
	g_return_if_fail (IS_BACKGROUND_JOB (j));
#line 677 "../src/BatchImport.vala"
	_vala_assert (!self->priv->completed, "!completed");
#line 679 "../src/BatchImport.vala"
	_tmp0_ = _background_job_ref0 (G_TYPE_CHECK_INSTANCE_CAST (j, TYPE_WORK_SNIFFER, WorkSniffer));
#line 679 "../src/BatchImport.vala"
	sniffer = _tmp0_;
#line 681 "../src/BatchImport.vala"
	batch_import_log_status (self, "on_work_sniffed_out");
#line 683 "../src/BatchImport.vala"
	_tmp2_ = sniffer;
#line 683 "../src/BatchImport.vala"
	if (!batch_import_report_failures (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_BACKGROUND_IMPORT_JOB, BackgroundImportJob))) {
#line 683 "../src/BatchImport.vala"
		_tmp1_ = TRUE;
#line 7011 "BatchImport.c"
	} else {
		WorkSniffer* _tmp3_;
		GeeList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
#line 683 "../src/BatchImport.vala"
		_tmp3_ = sniffer;
#line 683 "../src/BatchImport.vala"
		_tmp4_ = _tmp3_->files_to_prepare;
#line 683 "../src/BatchImport.vala"
		_tmp5_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_COLLECTION, GeeCollection));
#line 683 "../src/BatchImport.vala"
		_tmp6_ = _tmp5_;
#line 683 "../src/BatchImport.vala"
		_tmp1_ = _tmp6_ == 0;
#line 7027 "BatchImport.c"
	}
#line 683 "../src/BatchImport.vala"
	if (_tmp1_) {
#line 684 "../src/BatchImport.vala"
		batch_import_report_completed (self, "work sniffed out: nothing to do");
#line 686 "../src/BatchImport.vala"
		_background_job_unref0 (sniffer);
#line 686 "../src/BatchImport.vala"
		return;
#line 7037 "BatchImport.c"
	}
#line 689 "../src/BatchImport.vala"
	_tmp7_ = sniffer;
#line 689 "../src/BatchImport.vala"
	self->priv->total_bytes = _tmp7_->total_bytes;
#line 696 "../src/BatchImport.vala"
	_tmp8_ = sniffer;
#line 696 "../src/BatchImport.vala"
	_tmp9_ = _tmp8_->files_to_prepare;
#line 696 "../src/BatchImport.vala"
	_tmp10_ = self->priv->cancellable;
#line 696 "../src/BatchImport.vala"
	_tmp11_ = prepare_files_job_new (self, _tmp9_, _batch_import_on_file_prepared_notification_callback, self, _batch_import_on_files_prepared_completion_callback, self, _tmp10_, _batch_import_on_file_prepare_cancelled_cancellation_callback, self);
#line 696 "../src/BatchImport.vala"
	prepare_files_job = _tmp11_;
#line 699 "../src/BatchImport.vala"
	_tmp12_ = batch_import_feeder_workers;
#line 699 "../src/BatchImport.vala"
	_tmp13_ = prepare_files_job;
#line 699 "../src/BatchImport.vala"
	workers_enqueue (_tmp12_, G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, TYPE_BACKGROUND_JOB, BackgroundJob));
#line 701 "../src/BatchImport.vala"
	if (self->priv->throbber_id > ((guint) 0)) {
#line 702 "../src/BatchImport.vala"
		g_source_remove (self->priv->throbber_id);
#line 703 "../src/BatchImport.vala"
		self->priv->throbber_id = (guint) 0;
#line 7065 "BatchImport.c"
	}
#line 676 "../src/BatchImport.vala"
	_background_job_unref0 (prepare_files_job);
#line 676 "../src/BatchImport.vala"
	_background_job_unref0 (sniffer);
#line 7071 "BatchImport.c"
}

static void
batch_import_on_sniffer_cancelled (BatchImport* self,
                                   BackgroundJob* j)
{
	WorkSniffer* sniffer = NULL;
	WorkSniffer* _tmp0_;
	WorkSniffer* _tmp1_;
#line 707 "../src/BatchImport.vala"
	g_return_if_fail (IS_BATCH_IMPORT (self));
#line 707 "../src/BatchImport.vala"
	g_return_if_fail (IS_BACKGROUND_JOB (j));
#line 708 "../src/BatchImport.vala"
	_vala_assert (!self->priv->completed, "!completed");
#line 710 "../src/BatchImport.vala"
	_tmp0_ = _background_job_ref0 (G_TYPE_CHECK_INSTANCE_CAST (j, TYPE_WORK_SNIFFER, WorkSniffer));
#line 710 "../src/BatchImport.vala"
	sniffer = _tmp0_;
#line 712 "../src/BatchImport.vala"
	batch_import_log_status (self, "on_sniffer_cancelled");
#line 714 "../src/BatchImport.vala"
	_tmp1_ = sniffer;
#line 714 "../src/BatchImport.vala"
	batch_import_report_failures (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_BACKGROUND_IMPORT_JOB, BackgroundImportJob));
#line 715 "../src/BatchImport.vala"
	batch_import_report_completed (self, "work sniffer cancelled");
#line 717 "../src/BatchImport.vala"
	if (self->priv->throbber_id > ((guint) 0)) {
#line 718 "../src/BatchImport.vala"
		g_source_remove (self->priv->throbber_id);
#line 719 "../src/BatchImport.vala"
		self->priv->throbber_id = (guint) 0;
#line 7105 "BatchImport.c"
	}
#line 707 "../src/BatchImport.vala"
	_background_job_unref0 (sniffer);
#line 7109 "BatchImport.c"
}

static void
_batch_import_on_thumbnail_writer_completed_completion_callback (BackgroundJob* job,
                                                                 gpointer self)
{
#line 733 "../src/BatchImport.vala"
	batch_import_on_thumbnail_writer_completed ((BatchImport*) self, job);
#line 7118 "BatchImport.c"
}

static void
_batch_import_on_thumbnail_writer_cancelled_cancellation_callback (BackgroundJob* job,
                                                                   gpointer self)
{
#line 733 "../src/BatchImport.vala"
	batch_import_on_thumbnail_writer_cancelled ((BatchImport*) self, job);
#line 7127 "BatchImport.c"
}

static void
_batch_import_on_import_files_completed_completion_callback (BackgroundJob* job,
                                                             gpointer self)
{
#line 738 "../src/BatchImport.vala"
	batch_import_on_import_files_completed ((BatchImport*) self, job);
#line 7136 "BatchImport.c"
}

static void
_batch_import_on_import_files_cancelled_cancellation_callback (BackgroundJob* job,
                                                               gpointer self)
{
#line 738 "../src/BatchImport.vala"
	batch_import_on_import_files_cancelled ((BatchImport*) self, job);
#line 7145 "BatchImport.c"
}

static void
batch_import_flush_import_jobs (BatchImport* self)
{
#line 727 "../src/BatchImport.vala"
	g_return_if_fail (IS_BATCH_IMPORT (self));
#line 732 "../src/BatchImport.vala"
	while (TRUE) {
#line 7155 "BatchImport.c"
		gboolean _tmp0_ = FALSE;
		GeeList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		Workers* _tmp5_;
		GeeList* _tmp6_;
		gpointer _tmp7_;
		CompletedImportObject* _tmp8_;
		GCancellable* _tmp9_;
		ThumbnailWriterJob* _tmp10_;
		ThumbnailWriterJob* _tmp11_;
#line 732 "../src/BatchImport.vala"
		_tmp1_ = self->priv->ready_thumbnails;
#line 732 "../src/BatchImport.vala"
		_tmp2_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_COLLECTION, GeeCollection));
#line 732 "../src/BatchImport.vala"
		_tmp3_ = _tmp2_;
#line 732 "../src/BatchImport.vala"
		if (_tmp3_ > 0) {
#line 7175 "BatchImport.c"
			Workers* _tmp4_;
#line 732 "../src/BatchImport.vala"
			_tmp4_ = batch_import_import_workers;
#line 732 "../src/BatchImport.vala"
			_tmp0_ = ((guint) workers_get_pending_job_count (_tmp4_)) < self->priv->max_outstanding_import_jobs;
#line 7181 "BatchImport.c"
		} else {
#line 732 "../src/BatchImport.vala"
			_tmp0_ = FALSE;
#line 7185 "BatchImport.c"
		}
#line 732 "../src/BatchImport.vala"
		if (!_tmp0_) {
#line 732 "../src/BatchImport.vala"
			break;
#line 7191 "BatchImport.c"
		}
#line 733 "../src/BatchImport.vala"
		_tmp5_ = batch_import_import_workers;
#line 733 "../src/BatchImport.vala"
		_tmp6_ = self->priv->ready_thumbnails;
#line 733 "../src/BatchImport.vala"
		_tmp7_ = gee_list_remove_at (_tmp6_, 0);
#line 733 "../src/BatchImport.vala"
		_tmp8_ = (CompletedImportObject*) _tmp7_;
#line 733 "../src/BatchImport.vala"
		_tmp9_ = self->priv->cancellable;
#line 733 "../src/BatchImport.vala"
		_tmp10_ = thumbnail_writer_job_new (self, _tmp8_, _batch_import_on_thumbnail_writer_completed_completion_callback, self, _tmp9_, _batch_import_on_thumbnail_writer_cancelled_cancellation_callback, self);
#line 733 "../src/BatchImport.vala"
		_tmp11_ = _tmp10_;
#line 733 "../src/BatchImport.vala"
		workers_enqueue (_tmp5_, G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, TYPE_BACKGROUND_JOB, BackgroundJob));
#line 733 "../src/BatchImport.vala"
		_background_job_unref0 (_tmp11_);
#line 733 "../src/BatchImport.vala"
		_completed_import_object_unref0 (_tmp8_);
#line 7213 "BatchImport.c"
	}
#line 737 "../src/BatchImport.vala"
	while (TRUE) {
#line 7217 "BatchImport.c"
		gboolean _tmp12_ = FALSE;
		GeeList* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
		Workers* _tmp17_;
		GeeList* _tmp18_;
		gpointer _tmp19_;
		PreparedFile* _tmp20_;
		BatchImportRoll* _tmp21_;
		ImportID _tmp22_;
		GCancellable* _tmp23_;
		PreparedFileImportJob* _tmp24_;
		PreparedFileImportJob* _tmp25_;
#line 737 "../src/BatchImport.vala"
		_tmp13_ = self->priv->ready_files;
#line 737 "../src/BatchImport.vala"
		_tmp14_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GEE_TYPE_COLLECTION, GeeCollection));
#line 737 "../src/BatchImport.vala"
		_tmp15_ = _tmp14_;
#line 737 "../src/BatchImport.vala"
		if (_tmp15_ > 0) {
#line 7239 "BatchImport.c"
			Workers* _tmp16_;
#line 737 "../src/BatchImport.vala"
			_tmp16_ = batch_import_import_workers;
#line 737 "../src/BatchImport.vala"
			_tmp12_ = ((guint) workers_get_pending_job_count (_tmp16_)) < self->priv->max_outstanding_import_jobs;
#line 7245 "BatchImport.c"
		} else {
#line 737 "../src/BatchImport.vala"
			_tmp12_ = FALSE;
#line 7249 "BatchImport.c"
		}
#line 737 "../src/BatchImport.vala"
		if (!_tmp12_) {
#line 737 "../src/BatchImport.vala"
			break;
#line 7255 "BatchImport.c"
		}
#line 738 "../src/BatchImport.vala"
		_tmp17_ = batch_import_import_workers;
#line 738 "../src/BatchImport.vala"
		_tmp18_ = self->priv->ready_files;
#line 738 "../src/BatchImport.vala"
		_tmp19_ = gee_list_remove_at (_tmp18_, 0);
#line 738 "../src/BatchImport.vala"
		_tmp20_ = (PreparedFile*) _tmp19_;
#line 738 "../src/BatchImport.vala"
		_tmp21_ = self->priv->import_roll;
#line 738 "../src/BatchImport.vala"
		_tmp22_ = _tmp21_->import_id;
#line 738 "../src/BatchImport.vala"
		_tmp23_ = self->priv->cancellable;
#line 738 "../src/BatchImport.vala"
		_tmp24_ = prepared_file_import_job_new (self, _tmp20_, &_tmp22_, _batch_import_on_import_files_completed_completion_callback, self, _tmp23_, _batch_import_on_import_files_cancelled_cancellation_callback, self);
#line 738 "../src/BatchImport.vala"
		_tmp25_ = _tmp24_;
#line 738 "../src/BatchImport.vala"
		workers_enqueue (_tmp17_, G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, TYPE_BACKGROUND_JOB, BackgroundJob));
#line 738 "../src/BatchImport.vala"
		_background_job_unref0 (_tmp25_);
#line 738 "../src/BatchImport.vala"
		_prepared_file_unref0 (_tmp20_);
#line 7281 "BatchImport.c"
	}
}

static GFile*
batch_import_get_in_current_import (BatchImport* self,
                                    PreparedFile* prepared_file)
{
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	const gchar* _tmp7_;
	GFile* result;
#line 746 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_BATCH_IMPORT (self), NULL);
#line 746 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_PREPARED_FILE (prepared_file), NULL);
#line 748 "../src/BatchImport.vala"
	_tmp1_ = prepared_file->full_md5;
#line 748 "../src/BatchImport.vala"
	if (_tmp1_ != NULL) {
#line 7301 "BatchImport.c"
		GeeHashMap* _tmp2_;
		const gchar* _tmp3_;
#line 749 "../src/BatchImport.vala"
		_tmp2_ = self->priv->imported_full_md5_table;
#line 749 "../src/BatchImport.vala"
		_tmp3_ = prepared_file->full_md5;
#line 749 "../src/BatchImport.vala"
		_tmp0_ = gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp3_);
#line 7310 "BatchImport.c"
	} else {
#line 748 "../src/BatchImport.vala"
		_tmp0_ = FALSE;
#line 7314 "BatchImport.c"
	}
#line 748 "../src/BatchImport.vala"
	if (_tmp0_) {
#line 7318 "BatchImport.c"
		GeeHashMap* _tmp4_;
		const gchar* _tmp5_;
		gpointer _tmp6_;
#line 751 "../src/BatchImport.vala"
		_tmp4_ = self->priv->imported_full_md5_table;
#line 751 "../src/BatchImport.vala"
		_tmp5_ = prepared_file->full_md5;
#line 751 "../src/BatchImport.vala"
		_tmp6_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp5_);
#line 751 "../src/BatchImport.vala"
		result = (GFile*) _tmp6_;
#line 751 "../src/BatchImport.vala"
		return result;
#line 7332 "BatchImport.c"
	}
#line 755 "../src/BatchImport.vala"
	_tmp7_ = prepared_file->full_md5;
#line 755 "../src/BatchImport.vala"
	if (_tmp7_ != NULL) {
#line 7338 "BatchImport.c"
		GeeHashMap* _tmp8_;
		const gchar* _tmp9_;
		GFile* _tmp10_;
#line 756 "../src/BatchImport.vala"
		_tmp8_ = self->priv->imported_full_md5_table;
#line 756 "../src/BatchImport.vala"
		_tmp9_ = prepared_file->full_md5;
#line 756 "../src/BatchImport.vala"
		_tmp10_ = prepared_file->file;
#line 756 "../src/BatchImport.vala"
		gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp9_, _tmp10_);
#line 7350 "BatchImport.c"
	}
#line 758 "../src/BatchImport.vala"
	result = NULL;
#line 758 "../src/BatchImport.vala"
	return result;
#line 7356 "BatchImport.c"
}

static gpointer
_notification_object_ref0 (gpointer self)
{
#line 765 "../src/BatchImport.vala"
	return self ? notification_object_ref (self) : NULL;
#line 7364 "BatchImport.c"
}

static void
batch_import_on_file_prepared (BatchImport* self,
                               BackgroundJob* j,
                               NotificationObject* user)
{
	PreparedFileCluster* cluster = NULL;
	PreparedFileCluster* _tmp0_;
	GeeArrayList* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	GeeArrayList* _tmp6_;
#line 762 "../src/BatchImport.vala"
	g_return_if_fail (IS_BATCH_IMPORT (self));
#line 762 "../src/BatchImport.vala"
	g_return_if_fail (IS_BACKGROUND_JOB (j));
#line 762 "../src/BatchImport.vala"
	g_return_if_fail ((user == NULL) || IS_NOTIFICATION_OBJECT (user));
#line 763 "../src/BatchImport.vala"
	_vala_assert (!self->priv->completed, "!completed");
#line 765 "../src/BatchImport.vala"
	_tmp0_ = _notification_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (user, TYPE_PREPARED_FILE_CLUSTER, PreparedFileCluster));
#line 765 "../src/BatchImport.vala"
	cluster = _tmp0_;
#line 767 "../src/BatchImport.vala"
	_tmp1_ = cluster->list;
#line 767 "../src/BatchImport.vala"
	_tmp2_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 767 "../src/BatchImport.vala"
	_tmp3_ = _tmp2_;
#line 767 "../src/BatchImport.vala"
	_tmp4_ = g_strdup_printf ("on_file_prepared (%d files)", _tmp3_);
#line 767 "../src/BatchImport.vala"
	_tmp5_ = _tmp4_;
#line 767 "../src/BatchImport.vala"
	batch_import_log_status (self, _tmp5_);
#line 767 "../src/BatchImport.vala"
	_g_free0 (_tmp5_);
#line 769 "../src/BatchImport.vala"
	_tmp6_ = cluster->list;
#line 769 "../src/BatchImport.vala"
	batch_import_process_prepared_files (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_LIST, GeeList), NULL, NULL);
#line 762 "../src/BatchImport.vala"
	_notification_object_unref0 (cluster);
#line 7412 "BatchImport.c"
}

static void
batch_import_process_prepared_files_data_free (gpointer _data)
{
	BatchImportProcessPreparedFilesData* _data_;
	_data_ = _data;
#line 418 "../src/BatchImport.vala"
	_g_object_unref0 (_data_->list);
#line 418 "../src/BatchImport.vala"
	_g_object_unref0 (_data_->self);
#line 418 "../src/BatchImport.vala"
	g_slice_free (BatchImportProcessPreparedFilesData, _data_);
#line 7426 "BatchImport.c"
}

static void
batch_import_process_prepared_files (BatchImport* self,
                                     GeeList* list,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_)
{
	BatchImportProcessPreparedFilesData* _data_;
	BatchImport* _tmp0_;
	GeeList* _tmp1_;
#line 418 "../src/BatchImport.vala"
	g_return_if_fail (IS_BATCH_IMPORT (self));
#line 418 "../src/BatchImport.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (list, GEE_TYPE_LIST));
#line 418 "../src/BatchImport.vala"
	_data_ = g_slice_new0 (BatchImportProcessPreparedFilesData);
#line 418 "../src/BatchImport.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 418 "../src/BatchImport.vala"
	g_task_set_task_data (_data_->_async_result, _data_, batch_import_process_prepared_files_data_free);
#line 418 "../src/BatchImport.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 418 "../src/BatchImport.vala"
	_data_->self = _tmp0_;
#line 418 "../src/BatchImport.vala"
	_tmp1_ = _g_object_ref0 (list);
#line 418 "../src/BatchImport.vala"
	_g_object_unref0 (_data_->list);
#line 418 "../src/BatchImport.vala"
	_data_->list = _tmp1_;
#line 418 "../src/BatchImport.vala"
	batch_import_process_prepared_files_co (_data_);
#line 7460 "BatchImport.c"
}

static void
batch_import_process_prepared_files_finish (BatchImport* self,
                                            GAsyncResult* _res_)
{
	BatchImportProcessPreparedFilesData* _data_;
#line 418 "../src/BatchImport.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 7470 "BatchImport.c"
}

static gboolean
_batch_import_process_prepared_files_co_gsource_func (gpointer self)
{
	gboolean result;
	result = batch_import_process_prepared_files_co (self);
#line 776 "../src/BatchImport.vala"
	return result;
#line 7480 "BatchImport.c"
}

static gboolean
batch_import_process_prepared_files_co (BatchImportProcessPreparedFilesData* _data_)
{
#line 774 "../src/BatchImport.vala"
	switch (_data_->_state_) {
#line 774 "../src/BatchImport.vala"
		case 0:
#line 7490 "BatchImport.c"
		goto _state_0;
#line 774 "../src/BatchImport.vala"
		case 1:
#line 7494 "BatchImport.c"
		goto _state_1;
		default:
#line 774 "../src/BatchImport.vala"
		g_assert_not_reached ();
#line 7499 "BatchImport.c"
	}
	_state_0:
	{
#line 775 "../src/BatchImport.vala"
		_data_->_prepared_file_list = _data_->list;
#line 775 "../src/BatchImport.vala"
		_data_->_tmp0_ = _data_->_prepared_file_list;
#line 775 "../src/BatchImport.vala"
		_data_->_tmp1_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp0_, GEE_TYPE_COLLECTION, GeeCollection));
#line 775 "../src/BatchImport.vala"
		_data_->_tmp2_ = _data_->_tmp1_;
#line 775 "../src/BatchImport.vala"
		_data_->_prepared_file_size = _data_->_tmp2_;
#line 775 "../src/BatchImport.vala"
		_data_->_prepared_file_index = -1;
#line 775 "../src/BatchImport.vala"
		while (TRUE) {
#line 775 "../src/BatchImport.vala"
			_data_->_prepared_file_index = _data_->_prepared_file_index + 1;
#line 775 "../src/BatchImport.vala"
			_data_->_tmp3_ = _data_->_prepared_file_index;
#line 775 "../src/BatchImport.vala"
			_data_->_tmp4_ = _data_->_prepared_file_size;
#line 775 "../src/BatchImport.vala"
			if (!(_data_->_tmp3_ < _data_->_tmp4_)) {
#line 775 "../src/BatchImport.vala"
				break;
#line 7527 "BatchImport.c"
			}
#line 775 "../src/BatchImport.vala"
			_data_->_tmp5_ = _data_->_prepared_file_list;
#line 775 "../src/BatchImport.vala"
			_data_->_tmp6_ = gee_list_get (_data_->_tmp5_, _data_->_prepared_file_index);
#line 775 "../src/BatchImport.vala"
			_data_->prepared_file = (PreparedFile*) _data_->_tmp6_;
#line 776 "../src/BatchImport.vala"
			g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _batch_import_process_prepared_files_co_gsource_func, _data_, NULL);
#line 777 "../src/BatchImport.vala"
			_data_->_state_ = 1;
#line 777 "../src/BatchImport.vala"
			return FALSE;
#line 7541 "BatchImport.c"
			_state_1:
			;
#line 779 "../src/BatchImport.vala"
			_data_->import_result = NULL;
#line 784 "../src/BatchImport.vala"
			_data_->_tmp7_ = library_photo_global;
#line 784 "../src/BatchImport.vala"
			_data_->_tmp8_ = _data_->prepared_file;
#line 784 "../src/BatchImport.vala"
			_data_->_tmp9_ = _data_->_tmp8_->file;
#line 784 "../src/BatchImport.vala"
			_data_->_tmp10_ = 0;
#line 784 "../src/BatchImport.vala"
			_data_->_tmp11_ = library_photo_source_collection_get_state_by_file (_data_->_tmp7_, _data_->_tmp9_, &_data_->_tmp10_);
#line 784 "../src/BatchImport.vala"
			_data_->photo_state = _data_->_tmp10_;
#line 784 "../src/BatchImport.vala"
			_data_->photo = _data_->_tmp11_;
#line 786 "../src/BatchImport.vala"
			_data_->_tmp12_ = _data_->photo;
#line 786 "../src/BatchImport.vala"
			if (_data_->_tmp12_ != NULL) {
#line 787 "../src/BatchImport.vala"
				switch (_data_->photo_state) {
#line 787 "../src/BatchImport.vala"
					case LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_ONLINE:
#line 787 "../src/BatchImport.vala"
					case LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_OFFLINE:
#line 787 "../src/BatchImport.vala"
					case LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_EDITABLE:
#line 787 "../src/BatchImport.vala"
					case LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_DEVELOPER:
#line 7574 "BatchImport.c"
					{
#line 792 "../src/BatchImport.vala"
						_data_->_tmp13_ = _data_->prepared_file;
#line 792 "../src/BatchImport.vala"
						_data_->_tmp14_ = _data_->_tmp13_->job;
#line 792 "../src/BatchImport.vala"
						_data_->_tmp15_ = _data_->prepared_file;
#line 792 "../src/BatchImport.vala"
						_data_->_tmp16_ = _data_->_tmp15_->file;
#line 792 "../src/BatchImport.vala"
						_data_->_tmp17_ = _data_->prepared_file;
#line 792 "../src/BatchImport.vala"
						_data_->_tmp18_ = _data_->_tmp17_->file;
#line 792 "../src/BatchImport.vala"
						_data_->_tmp19_ = g_file_get_path (_data_->_tmp18_);
#line 792 "../src/BatchImport.vala"
						_data_->_tmp20_ = _data_->_tmp19_;
#line 792 "../src/BatchImport.vala"
						_data_->_tmp21_ = _data_->prepared_file;
#line 792 "../src/BatchImport.vala"
						_data_->_tmp22_ = _data_->_tmp21_->file;
#line 792 "../src/BatchImport.vala"
						_data_->_tmp23_ = g_file_get_path (_data_->_tmp22_);
#line 792 "../src/BatchImport.vala"
						_data_->_tmp24_ = _data_->_tmp23_;
#line 792 "../src/BatchImport.vala"
						_data_->_tmp25_ = _data_->photo;
#line 792 "../src/BatchImport.vala"
						_data_->_tmp26_ = media_source_get_master_file (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp25_, TYPE_MEDIA_SOURCE, MediaSource));
#line 792 "../src/BatchImport.vala"
						_data_->_tmp27_ = _data_->_tmp26_;
#line 792 "../src/BatchImport.vala"
						_data_->_tmp28_ = duplicated_file_create_from_file (_data_->_tmp27_);
#line 792 "../src/BatchImport.vala"
						_data_->_tmp29_ = _data_->_tmp28_;
#line 792 "../src/BatchImport.vala"
						_data_->_tmp30_ = batch_import_result_new (_data_->_tmp14_, _data_->_tmp16_, _data_->_tmp20_, _data_->_tmp24_, _data_->_tmp29_, IMPORT_RESULT_PHOTO_EXISTS);
#line 792 "../src/BatchImport.vala"
						_batch_import_result_unref0 (_data_->import_result);
#line 792 "../src/BatchImport.vala"
						_data_->import_result = _data_->_tmp30_;
#line 792 "../src/BatchImport.vala"
						_g_object_unref0 (_data_->_tmp29_);
#line 792 "../src/BatchImport.vala"
						_g_object_unref0 (_data_->_tmp27_);
#line 792 "../src/BatchImport.vala"
						_g_free0 (_data_->_tmp24_);
#line 792 "../src/BatchImport.vala"
						_g_free0 (_data_->_tmp20_);
#line 797 "../src/BatchImport.vala"
						if (_data_->photo_state == LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_OFFLINE) {
#line 798 "../src/BatchImport.vala"
							_data_->_tmp31_ = _data_->photo;
#line 798 "../src/BatchImport.vala"
							media_source_mark_online (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp31_, TYPE_MEDIA_SOURCE, MediaSource));
#line 7630 "BatchImport.c"
						}
#line 799 "../src/BatchImport.vala"
						break;
#line 7634 "BatchImport.c"
					}
#line 787 "../src/BatchImport.vala"
					case LIBRARY_PHOTO_SOURCE_COLLECTION_STATE_TRASH:
#line 7638 "BatchImport.c"
					{
#line 803 "../src/BatchImport.vala"
						break;
#line 7642 "BatchImport.c"
					}
					default:
					{
#line 806 "../src/BatchImport.vala"
						_data_->_tmp32_ = g_enum_get_value (g_type_class_ref (LIBRARY_PHOTO_SOURCE_COLLECTION_TYPE_STATE), _data_->photo_state);
#line 806 "../src/BatchImport.vala"
						g_error ("BatchImport.vala:806: Unknown LibraryPhotoSourceCollection state: %s", (_data_->_tmp32_ != NULL) ? _data_->_tmp32_->value_name : NULL);
#line 7650 "BatchImport.c"
					}
				}
			}
#line 810 "../src/BatchImport.vala"
			_data_->_tmp33_ = _data_->import_result;
#line 810 "../src/BatchImport.vala"
			if (_data_->_tmp33_ != NULL) {
#line 811 "../src/BatchImport.vala"
				_data_->_tmp34_ = _data_->import_result;
#line 811 "../src/BatchImport.vala"
				batch_import_report_failure (_data_->self, _data_->_tmp34_);
#line 812 "../src/BatchImport.vala"
				batch_import_file_import_complete (_data_->self);
#line 814 "../src/BatchImport.vala"
				_g_object_unref0 (_data_->photo);
#line 814 "../src/BatchImport.vala"
				_batch_import_result_unref0 (_data_->import_result);
#line 814 "../src/BatchImport.vala"
				_prepared_file_unref0 (_data_->prepared_file);
#line 814 "../src/BatchImport.vala"
				continue;
#line 7672 "BatchImport.c"
			}
#line 818 "../src/BatchImport.vala"
			_data_->_tmp35_ = video_global;
#line 818 "../src/BatchImport.vala"
			_data_->_tmp36_ = _data_->prepared_file;
#line 818 "../src/BatchImport.vala"
			_data_->_tmp37_ = _data_->_tmp36_->file;
#line 818 "../src/BatchImport.vala"
			_data_->_tmp38_ = 0;
#line 818 "../src/BatchImport.vala"
			_data_->_tmp39_ = video_source_collection_get_state_by_file (_data_->_tmp35_, _data_->_tmp37_, &_data_->_tmp38_);
#line 818 "../src/BatchImport.vala"
			_data_->video_state = _data_->_tmp38_;
#line 818 "../src/BatchImport.vala"
			_data_->video = _data_->_tmp39_;
#line 819 "../src/BatchImport.vala"
			_data_->_tmp40_ = _data_->video;
#line 819 "../src/BatchImport.vala"
			if (_data_->_tmp40_ != NULL) {
#line 820 "../src/BatchImport.vala"
				switch (_data_->video_state) {
#line 820 "../src/BatchImport.vala"
					case VIDEO_SOURCE_COLLECTION_STATE_ONLINE:
#line 820 "../src/BatchImport.vala"
					case VIDEO_SOURCE_COLLECTION_STATE_OFFLINE:
#line 7698 "BatchImport.c"
					{
#line 823 "../src/BatchImport.vala"
						_data_->_tmp41_ = _data_->prepared_file;
#line 823 "../src/BatchImport.vala"
						_data_->_tmp42_ = _data_->_tmp41_->job;
#line 823 "../src/BatchImport.vala"
						_data_->_tmp43_ = _data_->prepared_file;
#line 823 "../src/BatchImport.vala"
						_data_->_tmp44_ = _data_->_tmp43_->file;
#line 823 "../src/BatchImport.vala"
						_data_->_tmp45_ = _data_->prepared_file;
#line 823 "../src/BatchImport.vala"
						_data_->_tmp46_ = _data_->_tmp45_->file;
#line 823 "../src/BatchImport.vala"
						_data_->_tmp47_ = g_file_get_path (_data_->_tmp46_);
#line 823 "../src/BatchImport.vala"
						_data_->_tmp48_ = _data_->_tmp47_;
#line 823 "../src/BatchImport.vala"
						_data_->_tmp49_ = _data_->prepared_file;
#line 823 "../src/BatchImport.vala"
						_data_->_tmp50_ = _data_->_tmp49_->file;
#line 823 "../src/BatchImport.vala"
						_data_->_tmp51_ = g_file_get_path (_data_->_tmp50_);
#line 823 "../src/BatchImport.vala"
						_data_->_tmp52_ = _data_->_tmp51_;
#line 823 "../src/BatchImport.vala"
						_data_->_tmp53_ = _data_->video;
#line 823 "../src/BatchImport.vala"
						_data_->_tmp54_ = media_source_get_master_file (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp53_, TYPE_MEDIA_SOURCE, MediaSource));
#line 823 "../src/BatchImport.vala"
						_data_->_tmp55_ = _data_->_tmp54_;
#line 823 "../src/BatchImport.vala"
						_data_->_tmp56_ = duplicated_file_create_from_file (_data_->_tmp55_);
#line 823 "../src/BatchImport.vala"
						_data_->_tmp57_ = _data_->_tmp56_;
#line 823 "../src/BatchImport.vala"
						_data_->_tmp58_ = batch_import_result_new (_data_->_tmp42_, _data_->_tmp44_, _data_->_tmp48_, _data_->_tmp52_, _data_->_tmp57_, IMPORT_RESULT_PHOTO_EXISTS);
#line 823 "../src/BatchImport.vala"
						_batch_import_result_unref0 (_data_->import_result);
#line 823 "../src/BatchImport.vala"
						_data_->import_result = _data_->_tmp58_;
#line 823 "../src/BatchImport.vala"
						_g_object_unref0 (_data_->_tmp57_);
#line 823 "../src/BatchImport.vala"
						_g_object_unref0 (_data_->_tmp55_);
#line 823 "../src/BatchImport.vala"
						_g_free0 (_data_->_tmp52_);
#line 823 "../src/BatchImport.vala"
						_g_free0 (_data_->_tmp48_);
#line 828 "../src/BatchImport.vala"
						if (_data_->video_state == VIDEO_SOURCE_COLLECTION_STATE_OFFLINE) {
#line 829 "../src/BatchImport.vala"
							_data_->_tmp59_ = _data_->video;
#line 829 "../src/BatchImport.vala"
							media_source_mark_online (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp59_, TYPE_MEDIA_SOURCE, MediaSource));
#line 7754 "BatchImport.c"
						}
#line 830 "../src/BatchImport.vala"
						break;
#line 7758 "BatchImport.c"
					}
#line 820 "../src/BatchImport.vala"
					case VIDEO_SOURCE_COLLECTION_STATE_TRASH:
#line 7762 "BatchImport.c"
					{
#line 834 "../src/BatchImport.vala"
						break;
#line 7766 "BatchImport.c"
					}
					default:
					{
#line 837 "../src/BatchImport.vala"
						_data_->_tmp60_ = g_enum_get_value (g_type_class_ref (VIDEO_SOURCE_COLLECTION_TYPE_STATE), _data_->video_state);
#line 837 "../src/BatchImport.vala"
						g_error ("BatchImport.vala:837: Unknown VideoSourceCollection state: %s", (_data_->_tmp60_ != NULL) ? _data_->_tmp60_->value_name : NULL);
#line 7774 "BatchImport.c"
					}
				}
			}
#line 841 "../src/BatchImport.vala"
			_data_->_tmp61_ = _data_->import_result;
#line 841 "../src/BatchImport.vala"
			if (_data_->_tmp61_ != NULL) {
#line 842 "../src/BatchImport.vala"
				_data_->_tmp62_ = _data_->import_result;
#line 842 "../src/BatchImport.vala"
				batch_import_report_failure (_data_->self, _data_->_tmp62_);
#line 843 "../src/BatchImport.vala"
				batch_import_file_import_complete (_data_->self);
#line 845 "../src/BatchImport.vala"
				_g_object_unref0 (_data_->video);
#line 845 "../src/BatchImport.vala"
				_g_object_unref0 (_data_->photo);
#line 845 "../src/BatchImport.vala"
				_batch_import_result_unref0 (_data_->import_result);
#line 845 "../src/BatchImport.vala"
				_prepared_file_unref0 (_data_->prepared_file);
#line 845 "../src/BatchImport.vala"
				continue;
#line 7798 "BatchImport.c"
			}
#line 850 "../src/BatchImport.vala"
			_data_->_tmp64_ = _data_->prepared_file;
#line 850 "../src/BatchImport.vala"
			if (_data_->_tmp64_->is_video) {
#line 850 "../src/BatchImport.vala"
				_data_->_tmp65_ = _data_->prepared_file;
#line 850 "../src/BatchImport.vala"
				_data_->_tmp66_ = _data_->_tmp65_->file;
#line 850 "../src/BatchImport.vala"
				_data_->_tmp67_ = _data_->prepared_file;
#line 850 "../src/BatchImport.vala"
				_data_->_tmp68_ = _data_->_tmp67_->full_md5;
#line 850 "../src/BatchImport.vala"
				_data_->_tmp63_ = video_is_duplicate (_data_->_tmp66_, _data_->_tmp68_);
#line 7814 "BatchImport.c"
			} else {
#line 850 "../src/BatchImport.vala"
				_data_->_tmp63_ = FALSE;
#line 7818 "BatchImport.c"
			}
#line 850 "../src/BatchImport.vala"
			if (_data_->_tmp63_) {
#line 851 "../src/BatchImport.vala"
				_data_->_tmp69_ = video_table_get_instance ();
#line 851 "../src/BatchImport.vala"
				_data_->_tmp70_ = _data_->_tmp69_;
#line 851 "../src/BatchImport.vala"
				_data_->_tmp71_ = _data_->prepared_file;
#line 851 "../src/BatchImport.vala"
				_data_->_tmp72_ = _data_->_tmp71_->file;
#line 851 "../src/BatchImport.vala"
				_data_->_tmp73_ = _data_->prepared_file;
#line 851 "../src/BatchImport.vala"
				_data_->_tmp74_ = _data_->_tmp73_->full_md5;
#line 851 "../src/BatchImport.vala"
				_data_->_tmp75_ = 0;
#line 851 "../src/BatchImport.vala"
				_data_->_tmp76_ = video_table_get_duplicate_ids (_data_->_tmp70_, _data_->_tmp72_, _data_->_tmp74_, &_data_->_tmp75_);
#line 851 "../src/BatchImport.vala"
				_data_->_tmp77_ = _data_->_tmp76_;
#line 851 "../src/BatchImport.vala"
				_data_->_tmp77__length1 = _data_->_tmp75_;
#line 851 "../src/BatchImport.vala"
				_database_table_unref0 (_data_->_tmp70_);
#line 851 "../src/BatchImport.vala"
				_data_->duplicate_ids = _data_->_tmp77_;
#line 851 "../src/BatchImport.vala"
				_data_->duplicate_ids_length1 = _data_->_tmp77__length1;
#line 851 "../src/BatchImport.vala"
				_data_->_duplicate_ids_size_ = _data_->duplicate_ids_length1;
#line 854 "../src/BatchImport.vala"
				_data_->_tmp78_ = _data_->duplicate_ids;
#line 854 "../src/BatchImport.vala"
				_data_->_tmp78__length1 = _data_->duplicate_ids_length1;
#line 854 "../src/BatchImport.vala"
				_vala_assert (_data_->_tmp78__length1 > 0, "duplicate_ids.length > 0");
#line 856 "../src/BatchImport.vala"
				_data_->_tmp79_ = _data_->duplicate_ids;
#line 856 "../src/BatchImport.vala"
				_data_->_tmp79__length1 = _data_->duplicate_ids_length1;
#line 856 "../src/BatchImport.vala"
				_data_->_tmp80_ = _data_->_tmp79_[0];
#line 856 "../src/BatchImport.vala"
				_data_->_tmp81_ = duplicated_file_create_from_video_id (&_data_->_tmp80_);
#line 856 "../src/BatchImport.vala"
				_data_->duplicated_file = _data_->_tmp81_;
#line 859 "../src/BatchImport.vala"
				_data_->result_code = IMPORT_RESULT_PHOTO_EXISTS;
#line 860 "../src/BatchImport.vala"
				if (_data_->self->priv->mark_duplicates_online) {
#line 861 "../src/BatchImport.vala"
					_data_->_tmp82_ = video_global;
#line 861 "../src/BatchImport.vala"
					_data_->_tmp83_ = media_source_collection_get_offline_bin (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp82_, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 861 "../src/BatchImport.vala"
					_data_->_tmp84_ = _data_->_tmp83_;
#line 861 "../src/BatchImport.vala"
					_data_->_tmp85_ = _data_->prepared_file;
#line 861 "../src/BatchImport.vala"
					_data_->_tmp86_ = _data_->_tmp85_->file;
#line 861 "../src/BatchImport.vala"
					_data_->_tmp87_ = media_source_holding_tank_fetch_by_master_file (_data_->_tmp84_, _data_->_tmp86_);
#line 861 "../src/BatchImport.vala"
					_data_->_tmp88_ = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp87_, TYPE_VIDEO, Video);
#line 861 "../src/BatchImport.vala"
					_source_holding_tank_unref0 (_data_->_tmp84_);
#line 861 "../src/BatchImport.vala"
					_data_->dupe_video = _data_->_tmp88_;
#line 863 "../src/BatchImport.vala"
					_data_->_tmp89_ = _data_->dupe_video;
#line 863 "../src/BatchImport.vala"
					if (_data_->_tmp89_ == NULL) {
#line 864 "../src/BatchImport.vala"
						_data_->_tmp90_ = video_global;
#line 864 "../src/BatchImport.vala"
						_data_->_tmp91_ = media_source_collection_get_offline_bin (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp90_, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection));
#line 864 "../src/BatchImport.vala"
						_data_->_tmp92_ = _data_->_tmp91_;
#line 864 "../src/BatchImport.vala"
						_data_->_tmp93_ = _data_->prepared_file;
#line 864 "../src/BatchImport.vala"
						_data_->_tmp94_ = _data_->_tmp93_->full_md5;
#line 864 "../src/BatchImport.vala"
						_data_->_tmp95_ = media_source_holding_tank_fetch_by_md5 (_data_->_tmp92_, _data_->_tmp94_);
#line 864 "../src/BatchImport.vala"
						_g_object_unref0 (_data_->dupe_video);
#line 864 "../src/BatchImport.vala"
						_data_->dupe_video = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp95_, TYPE_VIDEO, Video);
#line 864 "../src/BatchImport.vala"
						_source_holding_tank_unref0 (_data_->_tmp92_);
#line 7910 "BatchImport.c"
					}
#line 866 "../src/BatchImport.vala"
					_data_->_tmp96_ = _data_->dupe_video;
#line 866 "../src/BatchImport.vala"
					if (_data_->_tmp96_ != NULL) {
#line 867 "../src/BatchImport.vala"
						_data_->_tmp97_ = _data_->prepared_file;
#line 867 "../src/BatchImport.vala"
						_data_->_tmp98_ = _data_->_tmp97_->file;
#line 867 "../src/BatchImport.vala"
						_data_->_tmp99_ = g_file_get_path (_data_->_tmp98_);
#line 867 "../src/BatchImport.vala"
						_data_->_tmp100_ = _data_->_tmp99_;
#line 867 "../src/BatchImport.vala"
						g_debug ("BatchImport.vala:867: duplicate video found offline, marking as online" \
": %s", _data_->_tmp100_);
#line 867 "../src/BatchImport.vala"
						_g_free0 (_data_->_tmp100_);
#line 870 "../src/BatchImport.vala"
						_data_->_tmp101_ = _data_->dupe_video;
#line 870 "../src/BatchImport.vala"
						_data_->_tmp102_ = _data_->prepared_file;
#line 870 "../src/BatchImport.vala"
						_data_->_tmp103_ = _data_->_tmp102_->file;
#line 870 "../src/BatchImport.vala"
						monitorable_set_master_file (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp101_, TYPE_MONITORABLE, Monitorable), _data_->_tmp103_);
#line 871 "../src/BatchImport.vala"
						_data_->_tmp104_ = _data_->dupe_video;
#line 871 "../src/BatchImport.vala"
						media_source_mark_online (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp104_, TYPE_MEDIA_SOURCE, MediaSource));
#line 873 "../src/BatchImport.vala"
						_g_object_unref0 (_data_->duplicated_file);
#line 873 "../src/BatchImport.vala"
						_data_->duplicated_file = NULL;
#line 875 "../src/BatchImport.vala"
						_data_->_tmp105_ = _data_->self->priv->manifest;
#line 875 "../src/BatchImport.vala"
						_data_->_tmp106_ = _data_->_tmp105_->imported;
#line 875 "../src/BatchImport.vala"
						_data_->_tmp107_ = _data_->dupe_video;
#line 875 "../src/BatchImport.vala"
						gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp106_, GEE_TYPE_COLLECTION, GeeCollection), G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp107_, TYPE_MEDIA_SOURCE, MediaSource));
#line 876 "../src/BatchImport.vala"
						_data_->_tmp108_ = _data_->dupe_video;
#line 876 "../src/BatchImport.vala"
						batch_import_report_progress (_data_->self, media_source_get_filesize (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp108_, TYPE_MEDIA_SOURCE, MediaSource)));
#line 877 "../src/BatchImport.vala"
						batch_import_file_import_complete (_data_->self);
#line 879 "../src/BatchImport.vala"
						_data_->result_code = IMPORT_RESULT_SUCCESS;
#line 7960 "BatchImport.c"
					}
#line 860 "../src/BatchImport.vala"
					_g_object_unref0 (_data_->dupe_video);
#line 7964 "BatchImport.c"
				}
#line 883 "../src/BatchImport.vala"
				_data_->_tmp109_ = _data_->prepared_file;
#line 883 "../src/BatchImport.vala"
				_data_->_tmp110_ = _data_->_tmp109_->job;
#line 883 "../src/BatchImport.vala"
				_data_->_tmp111_ = _data_->prepared_file;
#line 883 "../src/BatchImport.vala"
				_data_->_tmp112_ = _data_->_tmp111_->file;
#line 883 "../src/BatchImport.vala"
				_data_->_tmp113_ = _data_->prepared_file;
#line 883 "../src/BatchImport.vala"
				_data_->_tmp114_ = _data_->_tmp113_->file;
#line 883 "../src/BatchImport.vala"
				_data_->_tmp115_ = g_file_get_path (_data_->_tmp114_);
#line 883 "../src/BatchImport.vala"
				_data_->_tmp116_ = _data_->_tmp115_;
#line 883 "../src/BatchImport.vala"
				_data_->_tmp117_ = _data_->prepared_file;
#line 883 "../src/BatchImport.vala"
				_data_->_tmp118_ = _data_->_tmp117_->file;
#line 883 "../src/BatchImport.vala"
				_data_->_tmp119_ = g_file_get_path (_data_->_tmp118_);
#line 883 "../src/BatchImport.vala"
				_data_->_tmp120_ = _data_->_tmp119_;
#line 883 "../src/BatchImport.vala"
				_data_->_tmp121_ = _data_->duplicated_file;
#line 883 "../src/BatchImport.vala"
				_data_->_tmp122_ = batch_import_result_new (_data_->_tmp110_, _data_->_tmp112_, _data_->_tmp116_, _data_->_tmp120_, _data_->_tmp121_, _data_->result_code);
#line 883 "../src/BatchImport.vala"
				_batch_import_result_unref0 (_data_->import_result);
#line 883 "../src/BatchImport.vala"
				_data_->import_result = _data_->_tmp122_;
#line 883 "../src/BatchImport.vala"
				_g_free0 (_data_->_tmp120_);
#line 883 "../src/BatchImport.vala"
				_g_free0 (_data_->_tmp116_);
#line 887 "../src/BatchImport.vala"
				if (_data_->result_code == IMPORT_RESULT_SUCCESS) {
#line 888 "../src/BatchImport.vala"
					_data_->_tmp123_ = _data_->self->priv->manifest;
#line 888 "../src/BatchImport.vala"
					_data_->_tmp124_ = _data_->import_result;
#line 888 "../src/BatchImport.vala"
					import_manifest_add_result (_data_->_tmp123_, _data_->_tmp124_);
#line 890 "../src/BatchImport.vala"
					_g_object_unref0 (_data_->duplicated_file);
#line 890 "../src/BatchImport.vala"
					_data_->duplicate_ids = (g_free (_data_->duplicate_ids), NULL);
#line 890 "../src/BatchImport.vala"
					_g_object_unref0 (_data_->video);
#line 890 "../src/BatchImport.vala"
					_g_object_unref0 (_data_->photo);
#line 890 "../src/BatchImport.vala"
					_batch_import_result_unref0 (_data_->import_result);
#line 890 "../src/BatchImport.vala"
					_prepared_file_unref0 (_data_->prepared_file);
#line 890 "../src/BatchImport.vala"
					continue;
#line 8024 "BatchImport.c"
				}
#line 850 "../src/BatchImport.vala"
				_g_object_unref0 (_data_->duplicated_file);
#line 850 "../src/BatchImport.vala"
				_data_->duplicate_ids = (g_free (_data_->duplicate_ids), NULL);
#line 8030 "BatchImport.c"
			}
#line 894 "../src/BatchImport.vala"
			_data_->_tmp125_ = _data_->prepared_file;
#line 894 "../src/BatchImport.vala"
			_data_->_tmp126_ = batch_import_get_in_current_import (_data_->self, _data_->_tmp125_);
#line 894 "../src/BatchImport.vala"
			_data_->_tmp127_ = _data_->_tmp126_;
#line 894 "../src/BatchImport.vala"
			_data_->_tmp128_ = _data_->_tmp127_ != NULL;
#line 894 "../src/BatchImport.vala"
			_g_object_unref0 (_data_->_tmp127_);
#line 894 "../src/BatchImport.vala"
			if (_data_->_tmp128_) {
#line 897 "../src/BatchImport.vala"
				_data_->_tmp129_ = _data_->prepared_file;
#line 897 "../src/BatchImport.vala"
				_data_->_tmp130_ = _data_->_tmp129_->job;
#line 897 "../src/BatchImport.vala"
				_data_->_tmp131_ = _data_->prepared_file;
#line 897 "../src/BatchImport.vala"
				_data_->_tmp132_ = _data_->_tmp131_->file;
#line 897 "../src/BatchImport.vala"
				_data_->_tmp133_ = _data_->prepared_file;
#line 897 "../src/BatchImport.vala"
				_data_->_tmp134_ = _data_->_tmp133_->file;
#line 897 "../src/BatchImport.vala"
				_data_->_tmp135_ = g_file_get_path (_data_->_tmp134_);
#line 897 "../src/BatchImport.vala"
				_data_->_tmp136_ = _data_->_tmp135_;
#line 897 "../src/BatchImport.vala"
				_data_->_tmp137_ = _data_->prepared_file;
#line 897 "../src/BatchImport.vala"
				_data_->_tmp138_ = _data_->_tmp137_->file;
#line 897 "../src/BatchImport.vala"
				_data_->_tmp139_ = g_file_get_path (_data_->_tmp138_);
#line 897 "../src/BatchImport.vala"
				_data_->_tmp140_ = _data_->_tmp139_;
#line 897 "../src/BatchImport.vala"
				_data_->_tmp141_ = _data_->prepared_file;
#line 897 "../src/BatchImport.vala"
				_data_->_tmp142_ = batch_import_get_in_current_import (_data_->self, _data_->_tmp141_);
#line 897 "../src/BatchImport.vala"
				_data_->_tmp143_ = _data_->_tmp142_;
#line 897 "../src/BatchImport.vala"
				_data_->_tmp144_ = duplicated_file_create_from_file (_data_->_tmp143_);
#line 897 "../src/BatchImport.vala"
				_data_->_tmp145_ = _data_->_tmp144_;
#line 897 "../src/BatchImport.vala"
				_data_->_tmp146_ = batch_import_result_new (_data_->_tmp130_, _data_->_tmp132_, _data_->_tmp136_, _data_->_tmp140_, _data_->_tmp145_, IMPORT_RESULT_PHOTO_EXISTS);
#line 897 "../src/BatchImport.vala"
				_batch_import_result_unref0 (_data_->import_result);
#line 897 "../src/BatchImport.vala"
				_data_->import_result = _data_->_tmp146_;
#line 897 "../src/BatchImport.vala"
				_g_object_unref0 (_data_->_tmp145_);
#line 897 "../src/BatchImport.vala"
				_g_object_unref0 (_data_->_tmp143_);
#line 897 "../src/BatchImport.vala"
				_g_free0 (_data_->_tmp140_);
#line 897 "../src/BatchImport.vala"
				_g_free0 (_data_->_tmp136_);
#line 8092 "BatchImport.c"
			} else {
#line 901 "../src/BatchImport.vala"
				_data_->_tmp147_ = _data_->prepared_file;
#line 901 "../src/BatchImport.vala"
				_data_->_tmp148_ = _data_->_tmp147_->file;
#line 901 "../src/BatchImport.vala"
				_data_->_tmp149_ = _data_->prepared_file;
#line 901 "../src/BatchImport.vala"
				_data_->_tmp150_ = _data_->_tmp149_->full_md5;
#line 901 "../src/BatchImport.vala"
				_data_->_tmp151_ = _data_->prepared_file;
#line 901 "../src/BatchImport.vala"
				if (photo_is_duplicate (_data_->_tmp148_, NULL, _data_->_tmp150_, _data_->_tmp151_->file_format)) {
#line 903 "../src/BatchImport.vala"
					if (_data_->self->priv->untrash_duplicates) {
#line 906 "../src/BatchImport.vala"
						_data_->_tmp152_ = library_photo_global;
#line 906 "../src/BatchImport.vala"
						_data_->_tmp153_ = _data_->prepared_file;
#line 906 "../src/BatchImport.vala"
						_data_->_tmp154_ = _data_->_tmp153_->file;
#line 906 "../src/BatchImport.vala"
						_data_->_tmp155_ = library_photo_source_collection_get_trashed_by_file (_data_->_tmp152_, _data_->_tmp154_);
#line 906 "../src/BatchImport.vala"
						_g_object_unref0 (_data_->photo);
#line 906 "../src/BatchImport.vala"
						_data_->photo = _data_->_tmp155_;
#line 908 "../src/BatchImport.vala"
						_data_->_tmp157_ = _data_->photo;
#line 908 "../src/BatchImport.vala"
						if (_data_->_tmp157_ == NULL) {
#line 908 "../src/BatchImport.vala"
							_data_->_tmp158_ = _data_->prepared_file;
#line 908 "../src/BatchImport.vala"
							_data_->_tmp159_ = _data_->_tmp158_->full_md5;
#line 908 "../src/BatchImport.vala"
							_data_->_tmp156_ = _data_->_tmp159_ != NULL;
#line 8130 "BatchImport.c"
						} else {
#line 908 "../src/BatchImport.vala"
							_data_->_tmp156_ = FALSE;
#line 8134 "BatchImport.c"
						}
#line 908 "../src/BatchImport.vala"
						if (_data_->_tmp156_) {
#line 909 "../src/BatchImport.vala"
							_data_->_tmp160_ = library_photo_global;
#line 909 "../src/BatchImport.vala"
							_data_->_tmp161_ = _data_->prepared_file;
#line 909 "../src/BatchImport.vala"
							_data_->_tmp162_ = _data_->_tmp161_->full_md5;
#line 909 "../src/BatchImport.vala"
							_data_->_tmp163_ = library_photo_source_collection_get_trashed_by_md5 (_data_->_tmp160_, _data_->_tmp162_);
#line 909 "../src/BatchImport.vala"
							_g_object_unref0 (_data_->photo);
#line 909 "../src/BatchImport.vala"
							_data_->photo = _data_->_tmp163_;
#line 8150 "BatchImport.c"
						}
#line 911 "../src/BatchImport.vala"
						_data_->_tmp164_ = _data_->photo;
#line 911 "../src/BatchImport.vala"
						if (_data_->_tmp164_ != NULL) {
#line 912 "../src/BatchImport.vala"
							_data_->_tmp165_ = _data_->prepared_file;
#line 912 "../src/BatchImport.vala"
							_data_->_tmp166_ = _data_->_tmp165_->file;
#line 912 "../src/BatchImport.vala"
							_data_->_tmp167_ = g_file_get_path (_data_->_tmp166_);
#line 912 "../src/BatchImport.vala"
							_data_->_tmp168_ = _data_->_tmp167_;
#line 912 "../src/BatchImport.vala"
							g_debug ("BatchImport.vala:912: duplicate linked photo found in trash, untrashin" \
"g and removing transforms for %s", _data_->_tmp168_);
#line 912 "../src/BatchImport.vala"
							_g_free0 (_data_->_tmp168_);
#line 915 "../src/BatchImport.vala"
							_data_->_tmp169_ = _data_->photo;
#line 915 "../src/BatchImport.vala"
							_data_->_tmp170_ = _data_->prepared_file;
#line 915 "../src/BatchImport.vala"
							_data_->_tmp171_ = _data_->_tmp170_->file;
#line 915 "../src/BatchImport.vala"
							monitorable_set_master_file (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp169_, TYPE_MONITORABLE, Monitorable), _data_->_tmp171_);
#line 916 "../src/BatchImport.vala"
							_data_->_tmp172_ = _data_->photo;
#line 916 "../src/BatchImport.vala"
							media_source_untrash (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp172_, TYPE_MEDIA_SOURCE, MediaSource));
#line 917 "../src/BatchImport.vala"
							_data_->_tmp173_ = _data_->photo;
#line 917 "../src/BatchImport.vala"
							photo_remove_all_transformations (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp173_, TYPE_PHOTO, Photo), TRUE);
#line 8184 "BatchImport.c"
						}
					}
#line 921 "../src/BatchImport.vala"
					_data_->_tmp175_ = _data_->photo;
#line 921 "../src/BatchImport.vala"
					if (_data_->_tmp175_ == NULL) {
#line 921 "../src/BatchImport.vala"
						_data_->_tmp174_ = _data_->self->priv->mark_duplicates_online;
#line 8193 "BatchImport.c"
					} else {
#line 921 "../src/BatchImport.vala"
						_data_->_tmp174_ = FALSE;
#line 8197 "BatchImport.c"
					}
#line 921 "../src/BatchImport.vala"
					if (_data_->_tmp174_) {
#line 923 "../src/BatchImport.vala"
						_data_->_tmp176_ = library_photo_global;
#line 923 "../src/BatchImport.vala"
						_data_->_tmp177_ = _data_->prepared_file;
#line 923 "../src/BatchImport.vala"
						_data_->_tmp178_ = _data_->_tmp177_->file;
#line 923 "../src/BatchImport.vala"
						_data_->_tmp179_ = library_photo_source_collection_get_offline_by_file (_data_->_tmp176_, _data_->_tmp178_);
#line 923 "../src/BatchImport.vala"
						_g_object_unref0 (_data_->photo);
#line 923 "../src/BatchImport.vala"
						_data_->photo = _data_->_tmp179_;
#line 925 "../src/BatchImport.vala"
						_data_->_tmp181_ = _data_->photo;
#line 925 "../src/BatchImport.vala"
						if (_data_->_tmp181_ == NULL) {
#line 925 "../src/BatchImport.vala"
							_data_->_tmp182_ = _data_->prepared_file;
#line 925 "../src/BatchImport.vala"
							_data_->_tmp183_ = _data_->_tmp182_->full_md5;
#line 925 "../src/BatchImport.vala"
							_data_->_tmp180_ = _data_->_tmp183_ != NULL;
#line 8223 "BatchImport.c"
						} else {
#line 925 "../src/BatchImport.vala"
							_data_->_tmp180_ = FALSE;
#line 8227 "BatchImport.c"
						}
#line 925 "../src/BatchImport.vala"
						if (_data_->_tmp180_) {
#line 926 "../src/BatchImport.vala"
							_data_->_tmp184_ = library_photo_global;
#line 926 "../src/BatchImport.vala"
							_data_->_tmp185_ = _data_->prepared_file;
#line 926 "../src/BatchImport.vala"
							_data_->_tmp186_ = _data_->_tmp185_->full_md5;
#line 926 "../src/BatchImport.vala"
							_data_->_tmp187_ = library_photo_source_collection_get_offline_by_md5 (_data_->_tmp184_, _data_->_tmp186_);
#line 926 "../src/BatchImport.vala"
							_g_object_unref0 (_data_->photo);
#line 926 "../src/BatchImport.vala"
							_data_->photo = _data_->_tmp187_;
#line 8243 "BatchImport.c"
						}
#line 928 "../src/BatchImport.vala"
						_data_->_tmp188_ = _data_->photo;
#line 928 "../src/BatchImport.vala"
						if (_data_->_tmp188_ != NULL) {
#line 929 "../src/BatchImport.vala"
							_data_->_tmp189_ = _data_->prepared_file;
#line 929 "../src/BatchImport.vala"
							_data_->_tmp190_ = _data_->_tmp189_->file;
#line 929 "../src/BatchImport.vala"
							_data_->_tmp191_ = g_file_get_path (_data_->_tmp190_);
#line 929 "../src/BatchImport.vala"
							_data_->_tmp192_ = _data_->_tmp191_;
#line 929 "../src/BatchImport.vala"
							g_debug ("BatchImport.vala:929: duplicate photo found marked offline, marking on" \
"line: %s", _data_->_tmp192_);
#line 929 "../src/BatchImport.vala"
							_g_free0 (_data_->_tmp192_);
#line 932 "../src/BatchImport.vala"
							_data_->_tmp193_ = _data_->photo;
#line 932 "../src/BatchImport.vala"
							_data_->_tmp194_ = _data_->prepared_file;
#line 932 "../src/BatchImport.vala"
							_data_->_tmp195_ = _data_->_tmp194_->file;
#line 932 "../src/BatchImport.vala"
							monitorable_set_master_file (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp193_, TYPE_MONITORABLE, Monitorable), _data_->_tmp195_);
#line 933 "../src/BatchImport.vala"
							_data_->_tmp196_ = _data_->photo;
#line 933 "../src/BatchImport.vala"
							media_source_mark_online (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp196_, TYPE_MEDIA_SOURCE, MediaSource));
#line 8273 "BatchImport.c"
						}
					}
#line 937 "../src/BatchImport.vala"
					_data_->_tmp197_ = _data_->photo;
#line 937 "../src/BatchImport.vala"
					if (_data_->_tmp197_ != NULL) {
#line 938 "../src/BatchImport.vala"
						_data_->_tmp198_ = _data_->prepared_file;
#line 938 "../src/BatchImport.vala"
						_data_->_tmp199_ = _data_->_tmp198_->job;
#line 938 "../src/BatchImport.vala"
						_data_->_tmp200_ = _data_->prepared_file;
#line 938 "../src/BatchImport.vala"
						_data_->_tmp201_ = _data_->_tmp200_->file;
#line 938 "../src/BatchImport.vala"
						_data_->_tmp202_ = _data_->prepared_file;
#line 938 "../src/BatchImport.vala"
						_data_->_tmp203_ = _data_->_tmp202_->file;
#line 938 "../src/BatchImport.vala"
						_data_->_tmp204_ = g_file_get_path (_data_->_tmp203_);
#line 938 "../src/BatchImport.vala"
						_data_->_tmp205_ = _data_->_tmp204_;
#line 938 "../src/BatchImport.vala"
						_data_->_tmp206_ = _data_->prepared_file;
#line 938 "../src/BatchImport.vala"
						_data_->_tmp207_ = _data_->_tmp206_->file;
#line 938 "../src/BatchImport.vala"
						_data_->_tmp208_ = g_file_get_path (_data_->_tmp207_);
#line 938 "../src/BatchImport.vala"
						_data_->_tmp209_ = _data_->_tmp208_;
#line 938 "../src/BatchImport.vala"
						_data_->_tmp210_ = batch_import_result_new (_data_->_tmp199_, _data_->_tmp201_, _data_->_tmp205_, _data_->_tmp209_, NULL, IMPORT_RESULT_SUCCESS);
#line 938 "../src/BatchImport.vala"
						_batch_import_result_unref0 (_data_->import_result);
#line 938 "../src/BatchImport.vala"
						_data_->import_result = _data_->_tmp210_;
#line 938 "../src/BatchImport.vala"
						_g_free0 (_data_->_tmp209_);
#line 938 "../src/BatchImport.vala"
						_g_free0 (_data_->_tmp205_);
#line 942 "../src/BatchImport.vala"
						_data_->_tmp211_ = _data_->self->priv->manifest;
#line 942 "../src/BatchImport.vala"
						_data_->_tmp212_ = _data_->_tmp211_->imported;
#line 942 "../src/BatchImport.vala"
						_data_->_tmp213_ = _data_->photo;
#line 942 "../src/BatchImport.vala"
						gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp212_, GEE_TYPE_COLLECTION, GeeCollection), G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp213_, TYPE_MEDIA_SOURCE, MediaSource));
#line 943 "../src/BatchImport.vala"
						_data_->_tmp214_ = _data_->self->priv->manifest;
#line 943 "../src/BatchImport.vala"
						_data_->_tmp215_ = _data_->import_result;
#line 943 "../src/BatchImport.vala"
						import_manifest_add_result (_data_->_tmp214_, _data_->_tmp215_);
#line 945 "../src/BatchImport.vala"
						_data_->_tmp216_ = _data_->photo;
#line 945 "../src/BatchImport.vala"
						batch_import_report_progress (_data_->self, media_source_get_filesize (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp216_, TYPE_MEDIA_SOURCE, MediaSource)));
#line 946 "../src/BatchImport.vala"
						batch_import_file_import_complete (_data_->self);
#line 948 "../src/BatchImport.vala"
						_g_object_unref0 (_data_->video);
#line 948 "../src/BatchImport.vala"
						_g_object_unref0 (_data_->photo);
#line 948 "../src/BatchImport.vala"
						_batch_import_result_unref0 (_data_->import_result);
#line 948 "../src/BatchImport.vala"
						_prepared_file_unref0 (_data_->prepared_file);
#line 948 "../src/BatchImport.vala"
						continue;
#line 8344 "BatchImport.c"
					}
#line 951 "../src/BatchImport.vala"
					_data_->_tmp217_ = _data_->prepared_file;
#line 951 "../src/BatchImport.vala"
					_data_->_tmp218_ = _data_->_tmp217_->file;
#line 951 "../src/BatchImport.vala"
					_data_->_tmp219_ = g_file_get_path (_data_->_tmp218_);
#line 951 "../src/BatchImport.vala"
					_data_->_tmp220_ = _data_->_tmp219_;
#line 951 "../src/BatchImport.vala"
					g_debug ("BatchImport.vala:951: duplicate photo detected, not importing %s", _data_->_tmp220_);
#line 951 "../src/BatchImport.vala"
					_g_free0 (_data_->_tmp220_);
#line 953 "../src/BatchImport.vala"
					_data_->_tmp221_ = photo_table_get_instance ();
#line 953 "../src/BatchImport.vala"
					_data_->_tmp222_ = _data_->_tmp221_;
#line 953 "../src/BatchImport.vala"
					_data_->_tmp223_ = _data_->prepared_file;
#line 953 "../src/BatchImport.vala"
					_data_->_tmp224_ = _data_->_tmp223_->file;
#line 953 "../src/BatchImport.vala"
					_data_->_tmp225_ = _data_->prepared_file;
#line 953 "../src/BatchImport.vala"
					_data_->_tmp226_ = _data_->_tmp225_->full_md5;
#line 953 "../src/BatchImport.vala"
					_data_->_tmp227_ = _data_->prepared_file;
#line 953 "../src/BatchImport.vala"
					_data_->_tmp228_ = 0;
#line 953 "../src/BatchImport.vala"
					_data_->_tmp229_ = photo_table_get_duplicate_ids (_data_->_tmp222_, _data_->_tmp224_, NULL, _data_->_tmp226_, _data_->_tmp227_->file_format, &_data_->_tmp228_);
#line 953 "../src/BatchImport.vala"
					_data_->_tmp230_ = _data_->_tmp229_;
#line 953 "../src/BatchImport.vala"
					_data_->_tmp230__length1 = _data_->_tmp228_;
#line 953 "../src/BatchImport.vala"
					_database_table_unref0 (_data_->_tmp222_);
#line 953 "../src/BatchImport.vala"
					_data_->photo_ids = _data_->_tmp230_;
#line 953 "../src/BatchImport.vala"
					_data_->photo_ids_length1 = _data_->_tmp230__length1;
#line 953 "../src/BatchImport.vala"
					_data_->_photo_ids_size_ = _data_->photo_ids_length1;
#line 956 "../src/BatchImport.vala"
					_data_->_tmp231_ = _data_->photo_ids;
#line 956 "../src/BatchImport.vala"
					_data_->_tmp231__length1 = _data_->photo_ids_length1;
#line 956 "../src/BatchImport.vala"
					_vala_assert (_data_->_tmp231__length1 > 0, "photo_ids.length > 0");
#line 958 "../src/BatchImport.vala"
					_data_->_tmp232_ = _data_->photo_ids;
#line 958 "../src/BatchImport.vala"
					_data_->_tmp232__length1 = _data_->photo_ids_length1;
#line 958 "../src/BatchImport.vala"
					_data_->_tmp233_ = _data_->_tmp232_[0];
#line 958 "../src/BatchImport.vala"
					_data_->_tmp234_ = duplicated_file_create_from_photo_id (&_data_->_tmp233_);
#line 958 "../src/BatchImport.vala"
					_data_->_vala1_duplicated_file = _data_->_tmp234_;
#line 960 "../src/BatchImport.vala"
					_data_->_tmp235_ = _data_->prepared_file;
#line 960 "../src/BatchImport.vala"
					_data_->_tmp236_ = _data_->_tmp235_->job;
#line 960 "../src/BatchImport.vala"
					_data_->_tmp237_ = _data_->prepared_file;
#line 960 "../src/BatchImport.vala"
					_data_->_tmp238_ = _data_->_tmp237_->file;
#line 960 "../src/BatchImport.vala"
					_data_->_tmp239_ = _data_->prepared_file;
#line 960 "../src/BatchImport.vala"
					_data_->_tmp240_ = _data_->_tmp239_->file;
#line 960 "../src/BatchImport.vala"
					_data_->_tmp241_ = g_file_get_path (_data_->_tmp240_);
#line 960 "../src/BatchImport.vala"
					_data_->_tmp242_ = _data_->_tmp241_;
#line 960 "../src/BatchImport.vala"
					_data_->_tmp243_ = _data_->prepared_file;
#line 960 "../src/BatchImport.vala"
					_data_->_tmp244_ = _data_->_tmp243_->file;
#line 960 "../src/BatchImport.vala"
					_data_->_tmp245_ = g_file_get_path (_data_->_tmp244_);
#line 960 "../src/BatchImport.vala"
					_data_->_tmp246_ = _data_->_tmp245_;
#line 960 "../src/BatchImport.vala"
					_data_->_tmp247_ = _data_->_vala1_duplicated_file;
#line 960 "../src/BatchImport.vala"
					_data_->_tmp248_ = batch_import_result_new (_data_->_tmp236_, _data_->_tmp238_, _data_->_tmp242_, _data_->_tmp246_, _data_->_tmp247_, IMPORT_RESULT_PHOTO_EXISTS);
#line 960 "../src/BatchImport.vala"
					_batch_import_result_unref0 (_data_->import_result);
#line 960 "../src/BatchImport.vala"
					_data_->import_result = _data_->_tmp248_;
#line 960 "../src/BatchImport.vala"
					_g_free0 (_data_->_tmp246_);
#line 960 "../src/BatchImport.vala"
					_g_free0 (_data_->_tmp242_);
#line 901 "../src/BatchImport.vala"
					_g_object_unref0 (_data_->_vala1_duplicated_file);
#line 901 "../src/BatchImport.vala"
					_data_->photo_ids = (g_free (_data_->photo_ids), NULL);
#line 8444 "BatchImport.c"
				}
			}
#line 965 "../src/BatchImport.vala"
			_data_->_tmp249_ = _data_->import_result;
#line 965 "../src/BatchImport.vala"
			if (_data_->_tmp249_ != NULL) {
#line 966 "../src/BatchImport.vala"
				_data_->_tmp250_ = _data_->import_result;
#line 966 "../src/BatchImport.vala"
				batch_import_report_failure (_data_->self, _data_->_tmp250_);
#line 967 "../src/BatchImport.vala"
				batch_import_file_import_complete (_data_->self);
#line 969 "../src/BatchImport.vala"
				_g_object_unref0 (_data_->video);
#line 969 "../src/BatchImport.vala"
				_g_object_unref0 (_data_->photo);
#line 969 "../src/BatchImport.vala"
				_batch_import_result_unref0 (_data_->import_result);
#line 969 "../src/BatchImport.vala"
				_prepared_file_unref0 (_data_->prepared_file);
#line 969 "../src/BatchImport.vala"
				continue;
#line 8467 "BatchImport.c"
			}
#line 972 "../src/BatchImport.vala"
			batch_import_report_progress (_data_->self, (guint64) 0);
#line 973 "../src/BatchImport.vala"
			_data_->_tmp251_ = _data_->self->priv->ready_files;
#line 973 "../src/BatchImport.vala"
			_data_->_tmp252_ = _data_->prepared_file;
#line 973 "../src/BatchImport.vala"
			gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp251_, GEE_TYPE_COLLECTION, GeeCollection), _data_->_tmp252_);
#line 775 "../src/BatchImport.vala"
			_g_object_unref0 (_data_->video);
#line 775 "../src/BatchImport.vala"
			_g_object_unref0 (_data_->photo);
#line 775 "../src/BatchImport.vala"
			_batch_import_result_unref0 (_data_->import_result);
#line 775 "../src/BatchImport.vala"
			_prepared_file_unref0 (_data_->prepared_file);
#line 8485 "BatchImport.c"
		}
	}
#line 976 "../src/BatchImport.vala"
	batch_import_flush_import_jobs (_data_->self);
#line 774 "../src/BatchImport.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 774 "../src/BatchImport.vala"
	if (_data_->_state_ != 0) {
#line 774 "../src/BatchImport.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 774 "../src/BatchImport.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 8498 "BatchImport.c"
		}
	}
#line 774 "../src/BatchImport.vala"
	g_object_unref (_data_->_async_result);
#line 774 "../src/BatchImport.vala"
	return FALSE;
#line 8505 "BatchImport.c"
}

static void
batch_import_done_preparing_files (BatchImport* self,
                                   BackgroundJob* j,
                                   const gchar* caller)
{
	PrepareFilesJob* prepare_files_job = NULL;
	PrepareFilesJob* _tmp0_;
	PrepareFilesJob* _tmp1_;
	PrepareFilesJob* _tmp2_;
	gboolean _tmp3_ = FALSE;
#line 979 "../src/BatchImport.vala"
	g_return_if_fail (IS_BATCH_IMPORT (self));
#line 979 "../src/BatchImport.vala"
	g_return_if_fail (IS_BACKGROUND_JOB (j));
#line 979 "../src/BatchImport.vala"
	g_return_if_fail (caller != NULL);
#line 980 "../src/BatchImport.vala"
	_vala_assert (!self->priv->completed, "!completed");
#line 982 "../src/BatchImport.vala"
	_tmp0_ = _background_job_ref0 (G_TYPE_CHECK_INSTANCE_CAST (j, TYPE_PREPARE_FILES_JOB, PrepareFilesJob));
#line 982 "../src/BatchImport.vala"
	prepare_files_job = _tmp0_;
#line 984 "../src/BatchImport.vala"
	_tmp1_ = prepare_files_job;
#line 984 "../src/BatchImport.vala"
	batch_import_report_failures (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_BACKGROUND_IMPORT_JOB, BackgroundImportJob));
#line 987 "../src/BatchImport.vala"
	_tmp2_ = prepare_files_job;
#line 987 "../src/BatchImport.vala"
	self->priv->file_imports_to_perform = _tmp2_->prepared_files;
#line 988 "../src/BatchImport.vala"
	_vala_assert (self->priv->file_imports_to_perform >= self->priv->file_imports_completed, "file_imports_to_perform >= file_imports_completed");
#line 990 "../src/BatchImport.vala"
	batch_import_log_status (self, caller);
#line 993 "../src/BatchImport.vala"
	batch_import_flush_import_jobs (self);
#line 997 "../src/BatchImport.vala"
	if (self->priv->file_imports_to_perform == 0) {
#line 997 "../src/BatchImport.vala"
		_tmp3_ = !self->priv->completed;
#line 8548 "BatchImport.c"
	} else {
#line 997 "../src/BatchImport.vala"
		_tmp3_ = FALSE;
#line 8552 "BatchImport.c"
	}
#line 997 "../src/BatchImport.vala"
	if (_tmp3_) {
#line 998 "../src/BatchImport.vala"
		batch_import_report_completed (self, "no files prepared for import");
#line 8558 "BatchImport.c"
	} else {
		gboolean _tmp4_ = FALSE;
#line 999 "../src/BatchImport.vala"
		if (self->priv->file_imports_completed == self->priv->file_imports_to_perform) {
#line 999 "../src/BatchImport.vala"
			_tmp4_ = !self->priv->completed;
#line 8565 "BatchImport.c"
		} else {
#line 999 "../src/BatchImport.vala"
			_tmp4_ = FALSE;
#line 8569 "BatchImport.c"
		}
#line 999 "../src/BatchImport.vala"
		if (_tmp4_) {
#line 1000 "../src/BatchImport.vala"
			batch_import_report_completed (self, "completed preparing files, all outstanding imports completed");
#line 8575 "BatchImport.c"
		}
	}
#line 979 "../src/BatchImport.vala"
	_background_job_unref0 (prepare_files_job);
#line 8580 "BatchImport.c"
}

static void
batch_import_on_files_prepared (BatchImport* self,
                                BackgroundJob* j)
{
#line 1003 "../src/BatchImport.vala"
	g_return_if_fail (IS_BATCH_IMPORT (self));
#line 1003 "../src/BatchImport.vala"
	g_return_if_fail (IS_BACKGROUND_JOB (j));
#line 1004 "../src/BatchImport.vala"
	batch_import_done_preparing_files (self, j, "on_files_prepared");
#line 8593 "BatchImport.c"
}

static void
batch_import_on_file_prepare_cancelled (BatchImport* self,
                                        BackgroundJob* j)
{
#line 1007 "../src/BatchImport.vala"
	g_return_if_fail (IS_BATCH_IMPORT (self));
#line 1007 "../src/BatchImport.vala"
	g_return_if_fail (IS_BACKGROUND_JOB (j));
#line 1008 "../src/BatchImport.vala"
	batch_import_done_preparing_files (self, j, "on_file_prepare_cancelled");
#line 8606 "BatchImport.c"
}

static void
batch_import_on_import_files_completed (BatchImport* self,
                                        BackgroundJob* j)
{
	PreparedFileImportJob* job = NULL;
	PreparedFileImportJob* _tmp0_;
	PreparedFileImportJob* _tmp1_;
	PreparedFile* _tmp2_;
	PreparedFileImportJob* _tmp3_;
	BatchImportResult* _tmp4_;
	PreparedFileImportJob* _tmp9_;
	ReadyForImport* _tmp10_;
	GError* _inner_error0_ = NULL;
#line 1015 "../src/BatchImport.vala"
	g_return_if_fail (IS_BATCH_IMPORT (self));
#line 1015 "../src/BatchImport.vala"
	g_return_if_fail (IS_BACKGROUND_JOB (j));
#line 1016 "../src/BatchImport.vala"
	_vala_assert (!self->priv->completed, "!completed");
#line 1018 "../src/BatchImport.vala"
	_tmp0_ = _background_job_ref0 (G_TYPE_CHECK_INSTANCE_CAST (j, TYPE_PREPARED_FILE_IMPORT_JOB, PreparedFileImportJob));
#line 1018 "../src/BatchImport.vala"
	job = _tmp0_;
#line 1020 "../src/BatchImport.vala"
	batch_import_log_status (self, "on_import_files_completed");
#line 1023 "../src/BatchImport.vala"
	_tmp1_ = job;
#line 1023 "../src/BatchImport.vala"
	_tmp2_ = _tmp1_->not_ready;
#line 1023 "../src/BatchImport.vala"
	_vala_assert (_tmp2_ == NULL, "job.not_ready == null");
#line 1026 "../src/BatchImport.vala"
	_tmp3_ = job;
#line 1026 "../src/BatchImport.vala"
	_tmp4_ = _tmp3_->failed;
#line 1026 "../src/BatchImport.vala"
	if (_tmp4_ != NULL) {
#line 8646 "BatchImport.c"
		PreparedFileImportJob* _tmp5_;
		BatchImportResult* _tmp6_;
		PreparedFileImportJob* _tmp7_;
		BatchImportResult* _tmp8_;
#line 1027 "../src/BatchImport.vala"
		_tmp5_ = job;
#line 1027 "../src/BatchImport.vala"
		_tmp6_ = _tmp5_->failed;
#line 1027 "../src/BatchImport.vala"
		_vala_assert (_tmp6_->result != IMPORT_RESULT_SUCCESS, "job.failed.result != ImportResult.SUCCESS");
#line 1029 "../src/BatchImport.vala"
		_tmp7_ = job;
#line 1029 "../src/BatchImport.vala"
		_tmp8_ = _tmp7_->failed;
#line 1029 "../src/BatchImport.vala"
		batch_import_report_failure (self, _tmp8_);
#line 1030 "../src/BatchImport.vala"
		batch_import_file_import_complete (self);
#line 8665 "BatchImport.c"
	}
#line 1035 "../src/BatchImport.vala"
	_tmp9_ = job;
#line 1035 "../src/BatchImport.vala"
	_tmp10_ = _tmp9_->ready;
#line 1035 "../src/BatchImport.vala"
	if (_tmp10_ != NULL) {
#line 8673 "BatchImport.c"
		PreparedFileImportJob* _tmp11_;
		ReadyForImport* _tmp12_;
		BatchImportResult* _tmp13_;
		Tombstone* tombstone = NULL;
		TombstoneSourceCollection* _tmp14_;
		PreparedFileImportJob* _tmp15_;
		ReadyForImport* _tmp16_;
		GFile* _tmp17_;
		Tombstone* _tmp18_;
		Tombstone* _tmp19_;
		MediaSource* source = NULL;
		PreparedFileImportJob* _tmp22_;
		ReadyForImport* _tmp23_;
		PreparedFileImportJob* _tmp75_;
		ReadyForImport* _tmp76_;
		BatchImportResult* _tmp77_;
#line 1036 "../src/BatchImport.vala"
		_tmp11_ = job;
#line 1036 "../src/BatchImport.vala"
		_tmp12_ = _tmp11_->ready;
#line 1036 "../src/BatchImport.vala"
		_tmp13_ = _tmp12_->batch_result;
#line 1036 "../src/BatchImport.vala"
		_vala_assert (_tmp13_->result == IMPORT_RESULT_SUCCESS, "job.ready.batch_result.result == ImportResult.SUCCESS");
#line 1038 "../src/BatchImport.vala"
		_tmp14_ = tombstone_global;
#line 1038 "../src/BatchImport.vala"
		_tmp15_ = job;
#line 1038 "../src/BatchImport.vala"
		_tmp16_ = _tmp15_->ready;
#line 1038 "../src/BatchImport.vala"
		_tmp17_ = _tmp16_->final_file;
#line 1038 "../src/BatchImport.vala"
		_tmp18_ = tombstone_source_collection_locate (_tmp14_, _tmp17_);
#line 1038 "../src/BatchImport.vala"
		tombstone = _tmp18_;
#line 1039 "../src/BatchImport.vala"
		_tmp19_ = tombstone;
#line 1039 "../src/BatchImport.vala"
		if (_tmp19_ != NULL) {
#line 8714 "BatchImport.c"
			TombstoneSourceCollection* _tmp20_;
			Tombstone* _tmp21_;
#line 1040 "../src/BatchImport.vala"
			_tmp20_ = tombstone_global;
#line 1040 "../src/BatchImport.vala"
			_tmp21_ = tombstone;
#line 1040 "../src/BatchImport.vala"
			tombstone_source_collection_resurrect (_tmp20_, _tmp21_);
#line 8723 "BatchImport.c"
		}
#line 1043 "../src/BatchImport.vala"
		source = NULL;
#line 1044 "../src/BatchImport.vala"
		_tmp22_ = job;
#line 1044 "../src/BatchImport.vala"
		_tmp23_ = _tmp22_->ready;
#line 1044 "../src/BatchImport.vala"
		if (_tmp23_->is_video) {
#line 8733 "BatchImport.c"
			PreparedFileImportJob* _tmp24_;
			ReadyForImport* _tmp25_;
			BatchImportResult* _tmp26_;
			PreparedFileImportJob* _tmp27_;
			ReadyForImport* _tmp28_;
			VideoImportParams* _tmp29_;
			Video* _tmp30_ = NULL;
			ImportResult _tmp31_;
#line 1045 "../src/BatchImport.vala"
			_tmp24_ = job;
#line 1045 "../src/BatchImport.vala"
			_tmp25_ = _tmp24_->ready;
#line 1045 "../src/BatchImport.vala"
			_tmp26_ = _tmp25_->batch_result;
#line 1045 "../src/BatchImport.vala"
			_tmp27_ = job;
#line 1045 "../src/BatchImport.vala"
			_tmp28_ = _tmp27_->ready;
#line 1045 "../src/BatchImport.vala"
			_tmp29_ = _tmp28_->video_import_params;
#line 1045 "../src/BatchImport.vala"
			_tmp31_ = video_import_create (_tmp29_, &_tmp30_);
#line 1045 "../src/BatchImport.vala"
			_g_object_unref0 (source);
#line 1045 "../src/BatchImport.vala"
			source = G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, TYPE_MEDIA_SOURCE, MediaSource);
#line 1045 "../src/BatchImport.vala"
			_tmp26_->result = _tmp31_;
#line 8762 "BatchImport.c"
		} else {
			PreparedFileImportJob* _tmp32_;
			ReadyForImport* _tmp33_;
			BatchImportResult* _tmp34_;
			PreparedFileImportJob* _tmp35_;
			ReadyForImport* _tmp36_;
			PhotoImportParams* _tmp37_;
			LibraryPhoto* _tmp38_ = NULL;
			ImportResult _tmp39_;
			Photo* photo = NULL;
			MediaSource* _tmp40_;
			Photo* _tmp41_;
			PreparedFileImportJob* _tmp42_;
			ReadyForImport* _tmp43_;
			PhotoImportParams* _tmp44_;
			GFile* _tmp45_;
			Photo* _tmp67_;
#line 1048 "../src/BatchImport.vala"
			_tmp32_ = job;
#line 1048 "../src/BatchImport.vala"
			_tmp33_ = _tmp32_->ready;
#line 1048 "../src/BatchImport.vala"
			_tmp34_ = _tmp33_->batch_result;
#line 1048 "../src/BatchImport.vala"
			_tmp35_ = job;
#line 1048 "../src/BatchImport.vala"
			_tmp36_ = _tmp35_->ready;
#line 1048 "../src/BatchImport.vala"
			_tmp37_ = _tmp36_->photo_import_params;
#line 1048 "../src/BatchImport.vala"
			_tmp39_ = library_photo_import_create (_tmp37_, &_tmp38_);
#line 1048 "../src/BatchImport.vala"
			_g_object_unref0 (source);
#line 1048 "../src/BatchImport.vala"
			source = G_TYPE_CHECK_INSTANCE_CAST (_tmp38_, TYPE_MEDIA_SOURCE, MediaSource);
#line 1048 "../src/BatchImport.vala"
			_tmp34_->result = _tmp39_;
#line 1050 "../src/BatchImport.vala"
			_tmp40_ = source;
#line 1050 "../src/BatchImport.vala"
			_tmp41_ = _g_object_ref0 (IS_PHOTO (_tmp40_) ? ((Photo*) _tmp40_) : NULL);
#line 1050 "../src/BatchImport.vala"
			photo = _tmp41_;
#line 1052 "../src/BatchImport.vala"
			_tmp42_ = job;
#line 1052 "../src/BatchImport.vala"
			_tmp43_ = _tmp42_->ready;
#line 1052 "../src/BatchImport.vala"
			_tmp44_ = _tmp43_->photo_import_params;
#line 1052 "../src/BatchImport.vala"
			_tmp45_ = _tmp44_->final_associated_file;
#line 1052 "../src/BatchImport.vala"
			if (_tmp45_ != NULL) {
#line 8816 "BatchImport.c"
				BackingPhotoRow* bpr = NULL;
				BackingPhotoRow* _tmp46_;
				BackingPhotoRow* _tmp47_;
				BackingPhotoRow* _tmp48_;
				PreparedFileImportJob* _tmp49_;
				ReadyForImport* _tmp50_;
				PhotoImportParams* _tmp51_;
				GFile* _tmp52_;
				gchar* _tmp53_;
				MediaSource* _tmp54_;
				GFile* _tmp55_;
				GFile* _tmp56_;
				gchar* _tmp57_;
				gchar* _tmp58_;
				BackingPhotoRow* _tmp59_;
				const gchar* _tmp60_;
#line 1054 "../src/BatchImport.vala"
				_tmp46_ = backing_photo_row_new ();
#line 1054 "../src/BatchImport.vala"
				bpr = _tmp46_;
#line 1055 "../src/BatchImport.vala"
				_tmp47_ = bpr;
#line 1055 "../src/BatchImport.vala"
				_tmp47_->file_format = PHOTO_FILE_FORMAT_JFIF;
#line 1056 "../src/BatchImport.vala"
				_tmp48_ = bpr;
#line 1056 "../src/BatchImport.vala"
				_tmp49_ = job;
#line 1056 "../src/BatchImport.vala"
				_tmp50_ = _tmp49_->ready;
#line 1056 "../src/BatchImport.vala"
				_tmp51_ = _tmp50_->photo_import_params;
#line 1056 "../src/BatchImport.vala"
				_tmp52_ = _tmp51_->final_associated_file;
#line 1056 "../src/BatchImport.vala"
				_tmp53_ = g_file_get_path (_tmp52_);
#line 1056 "../src/BatchImport.vala"
				_g_free0 (_tmp48_->filepath);
#line 1056 "../src/BatchImport.vala"
				_tmp48_->filepath = _tmp53_;
#line 1057 "../src/BatchImport.vala"
				_tmp54_ = source;
#line 1057 "../src/BatchImport.vala"
				_tmp55_ = media_source_get_file (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (_tmp54_, TYPE_PHOTO, Photo), TYPE_MEDIA_SOURCE, MediaSource));
#line 1057 "../src/BatchImport.vala"
				_tmp56_ = _tmp55_;
#line 1057 "../src/BatchImport.vala"
				_tmp57_ = g_file_get_path (_tmp56_);
#line 1057 "../src/BatchImport.vala"
				_tmp58_ = _tmp57_;
#line 1057 "../src/BatchImport.vala"
				_tmp59_ = bpr;
#line 1057 "../src/BatchImport.vala"
				_tmp60_ = _tmp59_->filepath;
#line 1057 "../src/BatchImport.vala"
				g_debug ("BatchImport.vala:1057: Associating %s with sibling %s", _tmp58_, _tmp60_);
#line 1057 "../src/BatchImport.vala"
				_g_free0 (_tmp58_);
#line 1057 "../src/BatchImport.vala"
				_g_object_unref0 (_tmp56_);
#line 8877 "BatchImport.c"
				{
					MediaSource* _tmp61_;
					BackingPhotoRow* _tmp62_;
#line 1060 "../src/BatchImport.vala"
					_tmp61_ = source;
#line 1060 "../src/BatchImport.vala"
					_tmp62_ = bpr;
#line 1060 "../src/BatchImport.vala"
					photo_add_backing_photo_for_development (G_TYPE_CHECK_INSTANCE_CAST (_tmp61_, TYPE_PHOTO, Photo), RAW_DEVELOPER_CAMERA, _tmp62_, TRUE, &_inner_error0_);
#line 1060 "../src/BatchImport.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8889 "BatchImport.c"
						goto __catch0_g_error;
					}
				}
				goto __finally0;
				__catch0_g_error:
				{
					GError* e = NULL;
					BackingPhotoRow* _tmp63_;
					const gchar* _tmp64_;
					GError* _tmp65_;
					const gchar* _tmp66_;
#line 1059 "../src/BatchImport.vala"
					e = _inner_error0_;
#line 1059 "../src/BatchImport.vala"
					_inner_error0_ = NULL;
#line 1062 "../src/BatchImport.vala"
					_tmp63_ = bpr;
#line 1062 "../src/BatchImport.vala"
					_tmp64_ = _tmp63_->filepath;
#line 1062 "../src/BatchImport.vala"
					_tmp65_ = e;
#line 1062 "../src/BatchImport.vala"
					_tmp66_ = _tmp65_->message;
#line 1062 "../src/BatchImport.vala"
					g_warning ("BatchImport.vala:1062: Unable to associate JPEG with RAW. File: %s Err" \
"or: %s", _tmp64_, _tmp66_);
#line 1059 "../src/BatchImport.vala"
					_g_error_free0 (e);
#line 8917 "BatchImport.c"
				}
				__finally0:
#line 1059 "../src/BatchImport.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1059 "../src/BatchImport.vala"
					_backing_photo_row_unref0 (bpr);
#line 1059 "../src/BatchImport.vala"
					_g_object_unref0 (photo);
#line 1059 "../src/BatchImport.vala"
					_g_object_unref0 (source);
#line 1059 "../src/BatchImport.vala"
					_g_object_unref0 (tombstone);
#line 1059 "../src/BatchImport.vala"
					_background_job_unref0 (job);
#line 1059 "../src/BatchImport.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1059 "../src/BatchImport.vala"
					g_clear_error (&_inner_error0_);
#line 1059 "../src/BatchImport.vala"
					return;
#line 8938 "BatchImport.c"
				}
#line 1052 "../src/BatchImport.vala"
				_backing_photo_row_unref0 (bpr);
#line 8942 "BatchImport.c"
			}
#line 1068 "../src/BatchImport.vala"
			_tmp67_ = photo;
#line 1068 "../src/BatchImport.vala"
			if (photo_get_master_file_format (_tmp67_) == PHOTO_FILE_FORMAT_RAW) {
#line 8948 "BatchImport.c"
				RawDeveloper d = 0;
				ConfigFacade* _tmp68_;
				ConfigFacade* _tmp69_;
				RawDeveloper _tmp70_;
				gboolean _tmp71_ = FALSE;
				Photo* _tmp73_;
				Photo* _tmp74_;
#line 1069 "../src/BatchImport.vala"
				_tmp68_ = config_facade_get_instance ();
#line 1069 "../src/BatchImport.vala"
				_tmp69_ = _tmp68_;
#line 1069 "../src/BatchImport.vala"
				_tmp70_ = configuration_facade_get_default_raw_developer (G_TYPE_CHECK_INSTANCE_CAST (_tmp69_, TYPE_CONFIGURATION_FACADE, ConfigurationFacade));
#line 1069 "../src/BatchImport.vala"
				_g_object_unref0 (_tmp69_);
#line 1069 "../src/BatchImport.vala"
				d = _tmp70_;
#line 1070 "../src/BatchImport.vala"
				if (d == RAW_DEVELOPER_CAMERA) {
#line 8968 "BatchImport.c"
					Photo* _tmp72_;
#line 1070 "../src/BatchImport.vala"
					_tmp72_ = photo;
#line 1070 "../src/BatchImport.vala"
					_tmp71_ = !photo_is_raw_developer_available (_tmp72_, d);
#line 8974 "BatchImport.c"
				} else {
#line 1070 "../src/BatchImport.vala"
					_tmp71_ = FALSE;
#line 8978 "BatchImport.c"
				}
#line 1070 "../src/BatchImport.vala"
				if (_tmp71_) {
#line 1071 "../src/BatchImport.vala"
					d = RAW_DEVELOPER_EMBEDDED;
#line 8984 "BatchImport.c"
				}
#line 1073 "../src/BatchImport.vala"
				_tmp73_ = photo;
#line 1073 "../src/BatchImport.vala"
				photo_set_default_raw_developer (_tmp73_, d);
#line 1074 "../src/BatchImport.vala"
				_tmp74_ = photo;
#line 1074 "../src/BatchImport.vala"
				photo_set_raw_developer (_tmp74_, d, FALSE);
#line 8994 "BatchImport.c"
			}
#line 1044 "../src/BatchImport.vala"
			_g_object_unref0 (photo);
#line 8998 "BatchImport.c"
		}
#line 1078 "../src/BatchImport.vala"
		_tmp75_ = job;
#line 1078 "../src/BatchImport.vala"
		_tmp76_ = _tmp75_->ready;
#line 1078 "../src/BatchImport.vala"
		_tmp77_ = _tmp76_->batch_result;
#line 1078 "../src/BatchImport.vala"
		if (_tmp77_->result != IMPORT_RESULT_SUCCESS) {
#line 9008 "BatchImport.c"
			PreparedFileImportJob* _tmp78_;
			ReadyForImport* _tmp79_;
			BatchImportResult* _tmp80_;
			gchar* _tmp81_;
			gchar* _tmp82_;
			PreparedFileImportJob* _tmp83_;
			ReadyForImport* _tmp84_;
			BatchImportResult* _tmp85_;
#line 1079 "../src/BatchImport.vala"
			_tmp78_ = job;
#line 1079 "../src/BatchImport.vala"
			_tmp79_ = _tmp78_->ready;
#line 1079 "../src/BatchImport.vala"
			_tmp80_ = _tmp79_->batch_result;
#line 1079 "../src/BatchImport.vala"
			_tmp81_ = import_result_to_string (_tmp80_->result);
#line 1079 "../src/BatchImport.vala"
			_tmp82_ = _tmp81_;
#line 1079 "../src/BatchImport.vala"
			g_debug ("BatchImport.vala:1079: on_import_file_completed: %s", _tmp82_);
#line 1079 "../src/BatchImport.vala"
			_g_free0 (_tmp82_);
#line 1081 "../src/BatchImport.vala"
			_tmp83_ = job;
#line 1081 "../src/BatchImport.vala"
			_tmp84_ = _tmp83_->ready;
#line 1081 "../src/BatchImport.vala"
			_tmp85_ = _tmp84_->batch_result;
#line 1081 "../src/BatchImport.vala"
			batch_import_report_failure (self, _tmp85_);
#line 1082 "../src/BatchImport.vala"
			batch_import_file_import_complete (self);
#line 9041 "BatchImport.c"
		} else {
			GeeList* _tmp86_;
			MediaSource* _tmp87_;
			PreparedFileImportJob* _tmp88_;
			ReadyForImport* _tmp89_;
			Thumbnails* _tmp90_;
			Thumbnails* _tmp91_;
			PreparedFileImportJob* _tmp92_;
			ReadyForImport* _tmp93_;
			PreparedFile* _tmp94_;
			BatchImportJob* _tmp95_;
			PreparedFileImportJob* _tmp96_;
			ReadyForImport* _tmp97_;
			BatchImportResult* _tmp98_;
			CompletedImportObject* _tmp99_;
			CompletedImportObject* _tmp100_;
#line 1084 "../src/BatchImport.vala"
			_tmp86_ = self->priv->ready_thumbnails;
#line 1084 "../src/BatchImport.vala"
			_tmp87_ = source;
#line 1084 "../src/BatchImport.vala"
			_tmp88_ = job;
#line 1084 "../src/BatchImport.vala"
			_tmp89_ = _tmp88_->ready;
#line 1084 "../src/BatchImport.vala"
			_tmp90_ = ready_for_import_get_thumbnails (_tmp89_);
#line 1084 "../src/BatchImport.vala"
			_tmp91_ = _tmp90_;
#line 1084 "../src/BatchImport.vala"
			_tmp92_ = job;
#line 1084 "../src/BatchImport.vala"
			_tmp93_ = _tmp92_->ready;
#line 1084 "../src/BatchImport.vala"
			_tmp94_ = _tmp93_->prepared_file;
#line 1084 "../src/BatchImport.vala"
			_tmp95_ = _tmp94_->job;
#line 1084 "../src/BatchImport.vala"
			_tmp96_ = job;
#line 1084 "../src/BatchImport.vala"
			_tmp97_ = _tmp96_->ready;
#line 1084 "../src/BatchImport.vala"
			_tmp98_ = _tmp97_->batch_result;
#line 1084 "../src/BatchImport.vala"
			_tmp99_ = completed_import_object_new (_tmp87_, _tmp91_, _tmp95_, _tmp98_);
#line 1084 "../src/BatchImport.vala"
			_tmp100_ = _tmp99_;
#line 1084 "../src/BatchImport.vala"
			gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp86_, GEE_TYPE_COLLECTION, GeeCollection), _tmp100_);
#line 1084 "../src/BatchImport.vala"
			_completed_import_object_unref0 (_tmp100_);
#line 1084 "../src/BatchImport.vala"
			_thumbnails_unref0 (_tmp91_);
#line 9094 "BatchImport.c"
		}
#line 1035 "../src/BatchImport.vala"
		_g_object_unref0 (source);
#line 1035 "../src/BatchImport.vala"
		_g_object_unref0 (tombstone);
#line 9100 "BatchImport.c"
	}
#line 1089 "../src/BatchImport.vala"
	batch_import_flush_import_jobs (self);
#line 1015 "../src/BatchImport.vala"
	_background_job_unref0 (job);
#line 9106 "BatchImport.c"
}

static void
batch_import_on_import_files_cancelled (BatchImport* self,
                                        BackgroundJob* j)
{
	PreparedFileImportJob* job = NULL;
	PreparedFileImportJob* _tmp0_;
	PreparedFileImportJob* _tmp1_;
	PreparedFile* _tmp2_;
	PreparedFileImportJob* _tmp21_;
	BatchImportResult* _tmp22_;
	PreparedFileImportJob* _tmp25_;
	ReadyForImport* _tmp26_;
#line 1092 "../src/BatchImport.vala"
	g_return_if_fail (IS_BATCH_IMPORT (self));
#line 1092 "../src/BatchImport.vala"
	g_return_if_fail (IS_BACKGROUND_JOB (j));
#line 1093 "../src/BatchImport.vala"
	_vala_assert (!self->priv->completed, "!completed");
#line 1095 "../src/BatchImport.vala"
	_tmp0_ = _background_job_ref0 (G_TYPE_CHECK_INSTANCE_CAST (j, TYPE_PREPARED_FILE_IMPORT_JOB, PreparedFileImportJob));
#line 1095 "../src/BatchImport.vala"
	job = _tmp0_;
#line 1097 "../src/BatchImport.vala"
	batch_import_log_status (self, "on_import_files_cancelled");
#line 1099 "../src/BatchImport.vala"
	_tmp1_ = job;
#line 1099 "../src/BatchImport.vala"
	_tmp2_ = _tmp1_->not_ready;
#line 1099 "../src/BatchImport.vala"
	if (_tmp2_ != NULL) {
#line 9139 "BatchImport.c"
		PreparedFileImportJob* _tmp3_;
		PreparedFile* _tmp4_;
		BatchImportJob* _tmp5_;
		PreparedFileImportJob* _tmp6_;
		PreparedFile* _tmp7_;
		GFile* _tmp8_;
		PreparedFileImportJob* _tmp9_;
		PreparedFile* _tmp10_;
		GFile* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		PreparedFileImportJob* _tmp14_;
		PreparedFile* _tmp15_;
		GFile* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		BatchImportResult* _tmp19_;
		BatchImportResult* _tmp20_;
#line 1100 "../src/BatchImport.vala"
		_tmp3_ = job;
#line 1100 "../src/BatchImport.vala"
		_tmp4_ = _tmp3_->not_ready;
#line 1100 "../src/BatchImport.vala"
		_tmp5_ = _tmp4_->job;
#line 1100 "../src/BatchImport.vala"
		_tmp6_ = job;
#line 1100 "../src/BatchImport.vala"
		_tmp7_ = _tmp6_->not_ready;
#line 1100 "../src/BatchImport.vala"
		_tmp8_ = _tmp7_->file;
#line 1100 "../src/BatchImport.vala"
		_tmp9_ = job;
#line 1100 "../src/BatchImport.vala"
		_tmp10_ = _tmp9_->not_ready;
#line 1100 "../src/BatchImport.vala"
		_tmp11_ = _tmp10_->file;
#line 1100 "../src/BatchImport.vala"
		_tmp12_ = g_file_get_path (_tmp11_);
#line 1100 "../src/BatchImport.vala"
		_tmp13_ = _tmp12_;
#line 1100 "../src/BatchImport.vala"
		_tmp14_ = job;
#line 1100 "../src/BatchImport.vala"
		_tmp15_ = _tmp14_->not_ready;
#line 1100 "../src/BatchImport.vala"
		_tmp16_ = _tmp15_->file;
#line 1100 "../src/BatchImport.vala"
		_tmp17_ = g_file_get_path (_tmp16_);
#line 1100 "../src/BatchImport.vala"
		_tmp18_ = _tmp17_;
#line 1100 "../src/BatchImport.vala"
		_tmp19_ = batch_import_result_new (_tmp5_, _tmp8_, _tmp13_, _tmp18_, NULL, IMPORT_RESULT_USER_ABORT);
#line 1100 "../src/BatchImport.vala"
		_tmp20_ = _tmp19_;
#line 1100 "../src/BatchImport.vala"
		batch_import_report_failure (self, _tmp20_);
#line 1100 "../src/BatchImport.vala"
		_batch_import_result_unref0 (_tmp20_);
#line 1100 "../src/BatchImport.vala"
		_g_free0 (_tmp18_);
#line 1100 "../src/BatchImport.vala"
		_g_free0 (_tmp13_);
#line 1103 "../src/BatchImport.vala"
		batch_import_file_import_complete (self);
#line 9204 "BatchImport.c"
	}
#line 1106 "../src/BatchImport.vala"
	_tmp21_ = job;
#line 1106 "../src/BatchImport.vala"
	_tmp22_ = _tmp21_->failed;
#line 1106 "../src/BatchImport.vala"
	if (_tmp22_ != NULL) {
#line 9212 "BatchImport.c"
		PreparedFileImportJob* _tmp23_;
		BatchImportResult* _tmp24_;
#line 1107 "../src/BatchImport.vala"
		_tmp23_ = job;
#line 1107 "../src/BatchImport.vala"
		_tmp24_ = _tmp23_->failed;
#line 1107 "../src/BatchImport.vala"
		batch_import_report_failure (self, _tmp24_);
#line 1108 "../src/BatchImport.vala"
		batch_import_file_import_complete (self);
#line 9223 "BatchImport.c"
	}
#line 1111 "../src/BatchImport.vala"
	_tmp25_ = job;
#line 1111 "../src/BatchImport.vala"
	_tmp26_ = _tmp25_->ready;
#line 1111 "../src/BatchImport.vala"
	if (_tmp26_ != NULL) {
#line 9231 "BatchImport.c"
		PreparedFileImportJob* _tmp27_;
		ReadyForImport* _tmp28_;
		BatchImportResult* _tmp29_;
		BatchImportResult* _tmp30_;
#line 1112 "../src/BatchImport.vala"
		_tmp27_ = job;
#line 1112 "../src/BatchImport.vala"
		_tmp28_ = _tmp27_->ready;
#line 1112 "../src/BatchImport.vala"
		_tmp29_ = ready_for_import_abort (_tmp28_);
#line 1112 "../src/BatchImport.vala"
		_tmp30_ = _tmp29_;
#line 1112 "../src/BatchImport.vala"
		batch_import_report_failure (self, _tmp30_);
#line 1112 "../src/BatchImport.vala"
		_batch_import_result_unref0 (_tmp30_);
#line 1113 "../src/BatchImport.vala"
		batch_import_file_import_complete (self);
#line 9250 "BatchImport.c"
	}
#line 1116 "../src/BatchImport.vala"
	batch_import_flush_import_jobs (self);
#line 1092 "../src/BatchImport.vala"
	_background_job_unref0 (job);
#line 9256 "BatchImport.c"
}

static gpointer
_completed_import_object_ref0 (gpointer self)
{
#line 1130 "../src/BatchImport.vala"
	return self ? completed_import_object_ref (self) : NULL;
#line 9264 "BatchImport.c"
}

static void
batch_import_on_thumbnail_writer_completed (BatchImport* self,
                                            BackgroundJob* j)
{
	ThumbnailWriterJob* job = NULL;
	ThumbnailWriterJob* _tmp0_;
	CompletedImportObject* completed = NULL;
	ThumbnailWriterJob* _tmp1_;
	CompletedImportObject* _tmp2_;
	CompletedImportObject* _tmp3_;
	CompletedImportObject* _tmp4_;
	BatchImportResult* _tmp5_;
#line 1126 "../src/BatchImport.vala"
	g_return_if_fail (IS_BATCH_IMPORT (self));
#line 1126 "../src/BatchImport.vala"
	g_return_if_fail (IS_BACKGROUND_JOB (j));
#line 1127 "../src/BatchImport.vala"
	_vala_assert (!self->priv->completed, "!completed");
#line 1129 "../src/BatchImport.vala"
	_tmp0_ = _background_job_ref0 (G_TYPE_CHECK_INSTANCE_CAST (j, TYPE_THUMBNAIL_WRITER_JOB, ThumbnailWriterJob));
#line 1129 "../src/BatchImport.vala"
	job = _tmp0_;
#line 1130 "../src/BatchImport.vala"
	_tmp1_ = job;
#line 1130 "../src/BatchImport.vala"
	_tmp2_ = _tmp1_->completed_import_source;
#line 1130 "../src/BatchImport.vala"
	_tmp3_ = _completed_import_object_ref0 (_tmp2_);
#line 1130 "../src/BatchImport.vala"
	completed = _tmp3_;
#line 1132 "../src/BatchImport.vala"
	batch_import_log_status (self, "on_thumbnail_writer_completed");
#line 1134 "../src/BatchImport.vala"
	_tmp4_ = completed;
#line 1134 "../src/BatchImport.vala"
	_tmp5_ = _tmp4_->batch_result;
#line 1134 "../src/BatchImport.vala"
	if (_tmp5_->result != IMPORT_RESULT_SUCCESS) {
#line 9305 "BatchImport.c"
		CompletedImportObject* _tmp6_;
		MediaSource* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		CompletedImportObject* _tmp10_;
		BatchImportResult* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		CompletedImportObject* _tmp14_;
		MediaSource* _tmp15_;
		CompletedImportObject* _tmp22_;
		BatchImportResult* _tmp23_;
#line 1135 "../src/BatchImport.vala"
		_tmp6_ = completed;
#line 1135 "../src/BatchImport.vala"
		_tmp7_ = _tmp6_->source;
#line 1135 "../src/BatchImport.vala"
		_tmp8_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_DATA_OBJECT, DataObject));
#line 1135 "../src/BatchImport.vala"
		_tmp9_ = _tmp8_;
#line 1135 "../src/BatchImport.vala"
		_tmp10_ = completed;
#line 1135 "../src/BatchImport.vala"
		_tmp11_ = _tmp10_->batch_result;
#line 1135 "../src/BatchImport.vala"
		_tmp12_ = import_result_to_string (_tmp11_->result);
#line 1135 "../src/BatchImport.vala"
		_tmp13_ = _tmp12_;
#line 1135 "../src/BatchImport.vala"
		g_warning ("BatchImport.vala:1135: Failed to import %s: unable to write thumbnails" \
" (%s)", _tmp9_, _tmp13_);
#line 1135 "../src/BatchImport.vala"
		_g_free0 (_tmp13_);
#line 1135 "../src/BatchImport.vala"
		_g_free0 (_tmp9_);
#line 1138 "../src/BatchImport.vala"
		_tmp14_ = completed;
#line 1138 "../src/BatchImport.vala"
		_tmp15_ = _tmp14_->source;
#line 1138 "../src/BatchImport.vala"
		if (IS_LIBRARY_PHOTO (_tmp15_)) {
#line 9346 "BatchImport.c"
			CompletedImportObject* _tmp16_;
			MediaSource* _tmp17_;
#line 1139 "../src/BatchImport.vala"
			_tmp16_ = completed;
#line 1139 "../src/BatchImport.vala"
			_tmp17_ = _tmp16_->source;
#line 1139 "../src/BatchImport.vala"
			library_photo_import_failed (IS_LIBRARY_PHOTO (_tmp17_) ? ((LibraryPhoto*) _tmp17_) : NULL);
#line 9355 "BatchImport.c"
		} else {
			CompletedImportObject* _tmp18_;
			MediaSource* _tmp19_;
#line 1140 "../src/BatchImport.vala"
			_tmp18_ = completed;
#line 1140 "../src/BatchImport.vala"
			_tmp19_ = _tmp18_->source;
#line 1140 "../src/BatchImport.vala"
			if (IS_VIDEO (_tmp19_)) {
#line 9365 "BatchImport.c"
				CompletedImportObject* _tmp20_;
				MediaSource* _tmp21_;
#line 1141 "../src/BatchImport.vala"
				_tmp20_ = completed;
#line 1141 "../src/BatchImport.vala"
				_tmp21_ = _tmp20_->source;
#line 1141 "../src/BatchImport.vala"
				video_import_failed (IS_VIDEO (_tmp21_) ? ((Video*) _tmp21_) : NULL);
#line 9374 "BatchImport.c"
			}
		}
#line 1143 "../src/BatchImport.vala"
		_tmp22_ = completed;
#line 1143 "../src/BatchImport.vala"
		_tmp23_ = _tmp22_->batch_result;
#line 1143 "../src/BatchImport.vala"
		batch_import_report_failure (self, _tmp23_);
#line 1144 "../src/BatchImport.vala"
		batch_import_file_import_complete (self);
#line 9385 "BatchImport.c"
	} else {
		ImportManifest* _tmp24_;
		GeeList* _tmp25_;
		CompletedImportObject* _tmp26_;
		MediaSource* _tmp27_;
		ImportManifest* _tmp28_;
		CompletedImportObject* _tmp29_;
		BatchImportResult* _tmp30_;
		GeeList* _tmp31_;
		CompletedImportObject* _tmp32_;
#line 1146 "../src/BatchImport.vala"
		_tmp24_ = self->priv->manifest;
#line 1146 "../src/BatchImport.vala"
		_tmp25_ = _tmp24_->imported;
#line 1146 "../src/BatchImport.vala"
		_tmp26_ = completed;
#line 1146 "../src/BatchImport.vala"
		_tmp27_ = _tmp26_->source;
#line 1146 "../src/BatchImport.vala"
		gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, GEE_TYPE_COLLECTION, GeeCollection), _tmp27_);
#line 1147 "../src/BatchImport.vala"
		_tmp28_ = self->priv->manifest;
#line 1147 "../src/BatchImport.vala"
		_tmp29_ = completed;
#line 1147 "../src/BatchImport.vala"
		_tmp30_ = _tmp29_->batch_result;
#line 1147 "../src/BatchImport.vala"
		import_manifest_add_result (_tmp28_, _tmp30_);
#line 1149 "../src/BatchImport.vala"
		_tmp31_ = self->priv->display_imported_queue;
#line 1149 "../src/BatchImport.vala"
		_tmp32_ = completed;
#line 1149 "../src/BatchImport.vala"
		gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, GEE_TYPE_COLLECTION, GeeCollection), _tmp32_);
#line 9420 "BatchImport.c"
	}
#line 1152 "../src/BatchImport.vala"
	batch_import_flush_import_jobs (self);
#line 1126 "../src/BatchImport.vala"
	_completed_import_object_unref0 (completed);
#line 1126 "../src/BatchImport.vala"
	_background_job_unref0 (job);
#line 9428 "BatchImport.c"
}

static void
batch_import_on_thumbnail_writer_cancelled (BatchImport* self,
                                            BackgroundJob* j)
{
	ThumbnailWriterJob* job = NULL;
	ThumbnailWriterJob* _tmp0_;
	CompletedImportObject* completed = NULL;
	ThumbnailWriterJob* _tmp1_;
	CompletedImportObject* _tmp2_;
	CompletedImportObject* _tmp3_;
	CompletedImportObject* _tmp4_;
	MediaSource* _tmp5_;
	CompletedImportObject* _tmp12_;
	BatchImportResult* _tmp13_;
#line 1155 "../src/BatchImport.vala"
	g_return_if_fail (IS_BATCH_IMPORT (self));
#line 1155 "../src/BatchImport.vala"
	g_return_if_fail (IS_BACKGROUND_JOB (j));
#line 1156 "../src/BatchImport.vala"
	_vala_assert (!self->priv->completed, "!completed");
#line 1158 "../src/BatchImport.vala"
	_tmp0_ = _background_job_ref0 (G_TYPE_CHECK_INSTANCE_CAST (j, TYPE_THUMBNAIL_WRITER_JOB, ThumbnailWriterJob));
#line 1158 "../src/BatchImport.vala"
	job = _tmp0_;
#line 1159 "../src/BatchImport.vala"
	_tmp1_ = job;
#line 1159 "../src/BatchImport.vala"
	_tmp2_ = _tmp1_->completed_import_source;
#line 1159 "../src/BatchImport.vala"
	_tmp3_ = _completed_import_object_ref0 (_tmp2_);
#line 1159 "../src/BatchImport.vala"
	completed = _tmp3_;
#line 1161 "../src/BatchImport.vala"
	batch_import_log_status (self, "on_thumbnail_writer_cancelled");
#line 1163 "../src/BatchImport.vala"
	_tmp4_ = completed;
#line 1163 "../src/BatchImport.vala"
	_tmp5_ = _tmp4_->source;
#line 1163 "../src/BatchImport.vala"
	if (IS_LIBRARY_PHOTO (_tmp5_)) {
#line 9471 "BatchImport.c"
		CompletedImportObject* _tmp6_;
		MediaSource* _tmp7_;
#line 1164 "../src/BatchImport.vala"
		_tmp6_ = completed;
#line 1164 "../src/BatchImport.vala"
		_tmp7_ = _tmp6_->source;
#line 1164 "../src/BatchImport.vala"
		library_photo_import_failed (IS_LIBRARY_PHOTO (_tmp7_) ? ((LibraryPhoto*) _tmp7_) : NULL);
#line 9480 "BatchImport.c"
	} else {
		CompletedImportObject* _tmp8_;
		MediaSource* _tmp9_;
#line 1165 "../src/BatchImport.vala"
		_tmp8_ = completed;
#line 1165 "../src/BatchImport.vala"
		_tmp9_ = _tmp8_->source;
#line 1165 "../src/BatchImport.vala"
		if (IS_VIDEO (_tmp9_)) {
#line 9490 "BatchImport.c"
			CompletedImportObject* _tmp10_;
			MediaSource* _tmp11_;
#line 1166 "../src/BatchImport.vala"
			_tmp10_ = completed;
#line 1166 "../src/BatchImport.vala"
			_tmp11_ = _tmp10_->source;
#line 1166 "../src/BatchImport.vala"
			video_import_failed (IS_VIDEO (_tmp11_) ? ((Video*) _tmp11_) : NULL);
#line 9499 "BatchImport.c"
		}
	}
#line 1168 "../src/BatchImport.vala"
	_tmp12_ = completed;
#line 1168 "../src/BatchImport.vala"
	_tmp13_ = _tmp12_->batch_result;
#line 1168 "../src/BatchImport.vala"
	batch_import_report_failure (self, _tmp13_);
#line 1169 "../src/BatchImport.vala"
	batch_import_file_import_complete (self);
#line 1171 "../src/BatchImport.vala"
	batch_import_flush_import_jobs (self);
#line 1155 "../src/BatchImport.vala"
	_completed_import_object_unref0 (completed);
#line 1155 "../src/BatchImport.vala"
	_background_job_unref0 (job);
#line 9516 "BatchImport.c"
}

static void
batch_import_flush_ready_sources (BatchImport* self)
{
	GeeList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GeeList* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GeeArrayList* all = NULL;
	GeeArrayList* _tmp8_;
	GeeArrayList* photos = NULL;
	GeeArrayList* _tmp9_;
	GeeArrayList* videos = NULL;
	GeeArrayList* _tmp10_;
	GeeHashMap* completion_list = NULL;
	GeeHashMap* _tmp11_;
	MediaCollectionRegistry* _tmp38_;
	MediaCollectionRegistry* _tmp39_;
	EventSourceCollection* _tmp40_;
	TagSourceCollection* _tmp41_;
	LibraryPhotoSourceCollection* _tmp42_;
	GeeArrayList* _tmp43_;
	VideoSourceCollection* _tmp44_;
	GeeArrayList* _tmp45_;
	GeeArrayList* _tmp66_;
	BatchImportRoll* _tmp67_;
	ViewCollection* _tmp68_;
	TagSourceCollection* _tmp69_;
	EventSourceCollection* _tmp70_;
	MediaCollectionRegistry* _tmp71_;
	MediaCollectionRegistry* _tmp72_;
	GeeList* _tmp73_;
	GError* _inner_error0_ = NULL;
#line 1178 "../src/BatchImport.vala"
	g_return_if_fail (IS_BATCH_IMPORT (self));
#line 1179 "../src/BatchImport.vala"
	_tmp0_ = self->priv->ready_sources;
#line 1179 "../src/BatchImport.vala"
	_tmp1_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1179 "../src/BatchImport.vala"
	_tmp2_ = _tmp1_;
#line 1179 "../src/BatchImport.vala"
	if (_tmp2_ == 0) {
#line 1180 "../src/BatchImport.vala"
		return;
#line 9567 "BatchImport.c"
	}
#line 1185 "../src/BatchImport.vala"
	_tmp3_ = self->priv->ready_sources;
#line 1185 "../src/BatchImport.vala"
	_tmp4_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1185 "../src/BatchImport.vala"
	_tmp5_ = _tmp4_;
#line 1185 "../src/BatchImport.vala"
	_tmp6_ = g_strdup_printf ("flush_ready_sources (%d)", _tmp5_);
#line 1185 "../src/BatchImport.vala"
	_tmp7_ = _tmp6_;
#line 1185 "../src/BatchImport.vala"
	batch_import_log_status (self, _tmp7_);
#line 1185 "../src/BatchImport.vala"
	_g_free0 (_tmp7_);
#line 1187 "../src/BatchImport.vala"
	_tmp8_ = gee_array_list_new (TYPE_MEDIA_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1187 "../src/BatchImport.vala"
	all = _tmp8_;
#line 1188 "../src/BatchImport.vala"
	_tmp9_ = gee_array_list_new (TYPE_LIBRARY_PHOTO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1188 "../src/BatchImport.vala"
	photos = _tmp9_;
#line 1189 "../src/BatchImport.vala"
	_tmp10_ = gee_array_list_new (TYPE_VIDEO, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1189 "../src/BatchImport.vala"
	videos = _tmp10_;
#line 1190 "../src/BatchImport.vala"
	_tmp11_ = gee_hash_map_new (TYPE_MEDIA_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_BATCH_IMPORT_JOB, (GBoxedCopyFunc) batch_import_job_ref, (GDestroyNotify) batch_import_job_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 1190 "../src/BatchImport.vala"
	completion_list = _tmp11_;
#line 9599 "BatchImport.c"
	{
		GeeList* _completed_list = NULL;
		GeeList* _tmp12_;
		gint _completed_size = 0;
		GeeList* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
		gint _completed_index = 0;
#line 1192 "../src/BatchImport.vala"
		_tmp12_ = self->priv->ready_sources;
#line 1192 "../src/BatchImport.vala"
		_completed_list = _tmp12_;
#line 1192 "../src/BatchImport.vala"
		_tmp13_ = _completed_list;
#line 1192 "../src/BatchImport.vala"
		_tmp14_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1192 "../src/BatchImport.vala"
		_tmp15_ = _tmp14_;
#line 1192 "../src/BatchImport.vala"
		_completed_size = _tmp15_;
#line 1192 "../src/BatchImport.vala"
		_completed_index = -1;
#line 1192 "../src/BatchImport.vala"
		while (TRUE) {
#line 9624 "BatchImport.c"
			gint _tmp16_;
			gint _tmp17_;
			CompletedImportObject* completed = NULL;
			GeeList* _tmp18_;
			gpointer _tmp19_;
			GeeArrayList* _tmp20_;
			CompletedImportObject* _tmp21_;
			MediaSource* _tmp22_;
			CompletedImportObject* _tmp23_;
			MediaSource* _tmp24_;
			GeeHashMap* _tmp33_;
			CompletedImportObject* _tmp34_;
			MediaSource* _tmp35_;
			CompletedImportObject* _tmp36_;
			BatchImportJob* _tmp37_;
#line 1192 "../src/BatchImport.vala"
			_completed_index = _completed_index + 1;
#line 1192 "../src/BatchImport.vala"
			_tmp16_ = _completed_index;
#line 1192 "../src/BatchImport.vala"
			_tmp17_ = _completed_size;
#line 1192 "../src/BatchImport.vala"
			if (!(_tmp16_ < _tmp17_)) {
#line 1192 "../src/BatchImport.vala"
				break;
#line 9650 "BatchImport.c"
			}
#line 1192 "../src/BatchImport.vala"
			_tmp18_ = _completed_list;
#line 1192 "../src/BatchImport.vala"
			_tmp19_ = gee_list_get (_tmp18_, _completed_index);
#line 1192 "../src/BatchImport.vala"
			completed = (CompletedImportObject*) _tmp19_;
#line 1193 "../src/BatchImport.vala"
			_tmp20_ = all;
#line 1193 "../src/BatchImport.vala"
			_tmp21_ = completed;
#line 1193 "../src/BatchImport.vala"
			_tmp22_ = _tmp21_->source;
#line 1193 "../src/BatchImport.vala"
			gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp22_);
#line 1195 "../src/BatchImport.vala"
			_tmp23_ = completed;
#line 1195 "../src/BatchImport.vala"
			_tmp24_ = _tmp23_->source;
#line 1195 "../src/BatchImport.vala"
			if (IS_LIBRARY_PHOTO (_tmp24_)) {
#line 9672 "BatchImport.c"
				GeeArrayList* _tmp25_;
				CompletedImportObject* _tmp26_;
				MediaSource* _tmp27_;
#line 1196 "../src/BatchImport.vala"
				_tmp25_ = photos;
#line 1196 "../src/BatchImport.vala"
				_tmp26_ = completed;
#line 1196 "../src/BatchImport.vala"
				_tmp27_ = _tmp26_->source;
#line 1196 "../src/BatchImport.vala"
				gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp27_, TYPE_LIBRARY_PHOTO, LibraryPhoto));
#line 9684 "BatchImport.c"
			} else {
				CompletedImportObject* _tmp28_;
				MediaSource* _tmp29_;
#line 1197 "../src/BatchImport.vala"
				_tmp28_ = completed;
#line 1197 "../src/BatchImport.vala"
				_tmp29_ = _tmp28_->source;
#line 1197 "../src/BatchImport.vala"
				if (IS_VIDEO (_tmp29_)) {
#line 9694 "BatchImport.c"
					GeeArrayList* _tmp30_;
					CompletedImportObject* _tmp31_;
					MediaSource* _tmp32_;
#line 1198 "../src/BatchImport.vala"
					_tmp30_ = videos;
#line 1198 "../src/BatchImport.vala"
					_tmp31_ = completed;
#line 1198 "../src/BatchImport.vala"
					_tmp32_ = _tmp31_->source;
#line 1198 "../src/BatchImport.vala"
					gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp32_, TYPE_VIDEO, Video));
#line 9706 "BatchImport.c"
				}
			}
#line 1200 "../src/BatchImport.vala"
			_tmp33_ = completion_list;
#line 1200 "../src/BatchImport.vala"
			_tmp34_ = completed;
#line 1200 "../src/BatchImport.vala"
			_tmp35_ = _tmp34_->source;
#line 1200 "../src/BatchImport.vala"
			_tmp36_ = completed;
#line 1200 "../src/BatchImport.vala"
			_tmp37_ = _tmp36_->original_job;
#line 1200 "../src/BatchImport.vala"
			gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp33_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp35_, _tmp37_);
#line 1192 "../src/BatchImport.vala"
			_completed_import_object_unref0 (completed);
#line 9723 "BatchImport.c"
		}
	}
#line 1203 "../src/BatchImport.vala"
	_tmp38_ = media_collection_registry_get_instance ();
#line 1203 "../src/BatchImport.vala"
	_tmp39_ = _tmp38_;
#line 1203 "../src/BatchImport.vala"
	media_collection_registry_begin_transaction_on_all (_tmp39_);
#line 1203 "../src/BatchImport.vala"
	_media_collection_registry_unref0 (_tmp39_);
#line 1204 "../src/BatchImport.vala"
	_tmp40_ = event_global;
#line 1204 "../src/BatchImport.vala"
	data_collection_freeze_notifications (G_TYPE_CHECK_INSTANCE_CAST (_tmp40_, TYPE_DATA_COLLECTION, DataCollection));
#line 1205 "../src/BatchImport.vala"
	_tmp41_ = tag_global;
#line 1205 "../src/BatchImport.vala"
	data_collection_freeze_notifications (G_TYPE_CHECK_INSTANCE_CAST (_tmp41_, TYPE_DATA_COLLECTION, DataCollection));
#line 1207 "../src/BatchImport.vala"
	_tmp42_ = library_photo_global;
#line 1207 "../src/BatchImport.vala"
	_tmp43_ = photos;
#line 1207 "../src/BatchImport.vala"
	media_source_collection_import_many (G_TYPE_CHECK_INSTANCE_CAST (_tmp42_, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp43_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1208 "../src/BatchImport.vala"
	_tmp44_ = video_global;
#line 1208 "../src/BatchImport.vala"
	_tmp45_ = videos;
#line 1208 "../src/BatchImport.vala"
	media_source_collection_import_many (G_TYPE_CHECK_INSTANCE_CAST (_tmp44_, TYPE_MEDIA_SOURCE_COLLECTION, MediaSourceCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp45_, GEE_TYPE_COLLECTION, GeeCollection));
#line 9754 "BatchImport.c"
	{
		GeeIterator* _media_it = NULL;
		GeeHashMap* _tmp46_;
		GeeSet* _tmp47_;
		GeeSet* _tmp48_;
		GeeSet* _tmp49_;
		GeeIterator* _tmp50_;
		GeeIterator* _tmp51_;
#line 1211 "../src/BatchImport.vala"
		_tmp46_ = completion_list;
#line 1211 "../src/BatchImport.vala"
		_tmp47_ = gee_abstract_map_get_keys (G_TYPE_CHECK_INSTANCE_CAST (_tmp46_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap));
#line 1211 "../src/BatchImport.vala"
		_tmp48_ = _tmp47_;
#line 1211 "../src/BatchImport.vala"
		_tmp49_ = _tmp48_;
#line 1211 "../src/BatchImport.vala"
		_tmp50_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp49_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1211 "../src/BatchImport.vala"
		_tmp51_ = _tmp50_;
#line 1211 "../src/BatchImport.vala"
		_g_object_unref0 (_tmp49_);
#line 1211 "../src/BatchImport.vala"
		_media_it = _tmp51_;
#line 1211 "../src/BatchImport.vala"
		while (TRUE) {
#line 9781 "BatchImport.c"
			GeeIterator* _tmp52_;
			MediaSource* media = NULL;
			GeeIterator* _tmp53_;
			gpointer _tmp54_;
#line 1211 "../src/BatchImport.vala"
			_tmp52_ = _media_it;
#line 1211 "../src/BatchImport.vala"
			if (!gee_iterator_next (_tmp52_)) {
#line 1211 "../src/BatchImport.vala"
				break;
#line 9792 "BatchImport.c"
			}
#line 1211 "../src/BatchImport.vala"
			_tmp53_ = _media_it;
#line 1211 "../src/BatchImport.vala"
			_tmp54_ = gee_iterator_get (_tmp53_);
#line 1211 "../src/BatchImport.vala"
			media = (MediaSource*) _tmp54_;
#line 9800 "BatchImport.c"
			{
				GeeHashMap* _tmp55_;
				MediaSource* _tmp56_;
				gpointer _tmp57_;
				BatchImportJob* _tmp58_;
				MediaSource* _tmp59_;
				BatchImportRoll* _tmp60_;
#line 1213 "../src/BatchImport.vala"
				_tmp55_ = completion_list;
#line 1213 "../src/BatchImport.vala"
				_tmp56_ = media;
#line 1213 "../src/BatchImport.vala"
				_tmp57_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp55_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp56_);
#line 1213 "../src/BatchImport.vala"
				_tmp58_ = (BatchImportJob*) _tmp57_;
#line 1213 "../src/BatchImport.vala"
				_tmp59_ = media;
#line 1213 "../src/BatchImport.vala"
				_tmp60_ = self->priv->import_roll;
#line 1213 "../src/BatchImport.vala"
				batch_import_job_complete (_tmp58_, _tmp59_, _tmp60_, &_inner_error0_);
#line 1213 "../src/BatchImport.vala"
				_batch_import_job_unref0 (_tmp58_);
#line 1213 "../src/BatchImport.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 9826 "BatchImport.c"
					goto __catch0_g_error;
				}
			}
			goto __finally0;
			__catch0_g_error:
			{
				GError* err = NULL;
				MediaSource* _tmp61_;
				gchar* _tmp62_;
				gchar* _tmp63_;
				GError* _tmp64_;
				const gchar* _tmp65_;
#line 1212 "../src/BatchImport.vala"
				err = _inner_error0_;
#line 1212 "../src/BatchImport.vala"
				_inner_error0_ = NULL;
#line 1215 "../src/BatchImport.vala"
				_tmp61_ = media;
#line 1215 "../src/BatchImport.vala"
				_tmp62_ = data_object_to_string (G_TYPE_CHECK_INSTANCE_CAST (_tmp61_, TYPE_DATA_OBJECT, DataObject));
#line 1215 "../src/BatchImport.vala"
				_tmp63_ = _tmp62_;
#line 1215 "../src/BatchImport.vala"
				_tmp64_ = err;
#line 1215 "../src/BatchImport.vala"
				_tmp65_ = _tmp64_->message;
#line 1215 "../src/BatchImport.vala"
				g_warning ("BatchImport.vala:1215: Completion error when finalizing import of %s: " \
"%s", _tmp63_, _tmp65_);
#line 1215 "../src/BatchImport.vala"
				_g_free0 (_tmp63_);
#line 1212 "../src/BatchImport.vala"
				_g_error_free0 (err);
#line 9859 "BatchImport.c"
			}
			__finally0:
#line 1212 "../src/BatchImport.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1212 "../src/BatchImport.vala"
				_g_object_unref0 (media);
#line 1212 "../src/BatchImport.vala"
				_g_object_unref0 (_media_it);
#line 1212 "../src/BatchImport.vala"
				_g_object_unref0 (completion_list);
#line 1212 "../src/BatchImport.vala"
				_g_object_unref0 (videos);
#line 1212 "../src/BatchImport.vala"
				_g_object_unref0 (photos);
#line 1212 "../src/BatchImport.vala"
				_g_object_unref0 (all);
#line 1212 "../src/BatchImport.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1212 "../src/BatchImport.vala"
				g_clear_error (&_inner_error0_);
#line 1212 "../src/BatchImport.vala"
				return;
#line 9882 "BatchImport.c"
			}
#line 1211 "../src/BatchImport.vala"
			_g_object_unref0 (media);
#line 9886 "BatchImport.c"
		}
#line 1211 "../src/BatchImport.vala"
		_g_object_unref0 (_media_it);
#line 9890 "BatchImport.c"
	}
#line 1221 "../src/BatchImport.vala"
	_tmp66_ = all;
#line 1221 "../src/BatchImport.vala"
	_tmp67_ = self->priv->import_roll;
#line 1221 "../src/BatchImport.vala"
	_tmp68_ = _tmp67_->generated_events;
#line 1221 "../src/BatchImport.vala"
	event_generate_many_events (G_TYPE_CHECK_INSTANCE_CAST (_tmp66_, GEE_TYPE_COLLECTION, GeeCollection), _tmp68_);
#line 1223 "../src/BatchImport.vala"
	_tmp69_ = tag_global;
#line 1223 "../src/BatchImport.vala"
	data_collection_thaw_notifications (G_TYPE_CHECK_INSTANCE_CAST (_tmp69_, TYPE_DATA_COLLECTION, DataCollection));
#line 1224 "../src/BatchImport.vala"
	_tmp70_ = event_global;
#line 1224 "../src/BatchImport.vala"
	data_collection_thaw_notifications (G_TYPE_CHECK_INSTANCE_CAST (_tmp70_, TYPE_DATA_COLLECTION, DataCollection));
#line 1225 "../src/BatchImport.vala"
	_tmp71_ = media_collection_registry_get_instance ();
#line 1225 "../src/BatchImport.vala"
	_tmp72_ = _tmp71_;
#line 1225 "../src/BatchImport.vala"
	media_collection_registry_commit_transaction_on_all (_tmp72_);
#line 1225 "../src/BatchImport.vala"
	_media_collection_registry_unref0 (_tmp72_);
#line 1227 "../src/BatchImport.vala"
	_tmp73_ = self->priv->ready_sources;
#line 1227 "../src/BatchImport.vala"
	gee_collection_clear (G_TYPE_CHECK_INSTANCE_CAST (_tmp73_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1178 "../src/BatchImport.vala"
	_g_object_unref0 (completion_list);
#line 1178 "../src/BatchImport.vala"
	_g_object_unref0 (videos);
#line 1178 "../src/BatchImport.vala"
	_g_object_unref0 (photos);
#line 1178 "../src/BatchImport.vala"
	_g_object_unref0 (all);
#line 9928 "BatchImport.c"
}

static gboolean
batch_import_display_imported_timer (BatchImport* self)
{
	GeeList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GCancellable* _tmp3_;
	gint total = 0;
	GCancellable* _tmp7_;
	GeeList* _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	gboolean _tmp38_ = FALSE;
	GeeList* _tmp39_;
	gint _tmp40_;
	gint _tmp41_;
	gboolean result;
#line 1232 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_BATCH_IMPORT (self), FALSE);
#line 1233 "../src/BatchImport.vala"
	_tmp0_ = self->priv->display_imported_queue;
#line 1233 "../src/BatchImport.vala"
	_tmp1_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1233 "../src/BatchImport.vala"
	_tmp2_ = _tmp1_;
#line 1233 "../src/BatchImport.vala"
	if (_tmp2_ == 0) {
#line 1234 "../src/BatchImport.vala"
		result = !self->priv->completed;
#line 1234 "../src/BatchImport.vala"
		return result;
#line 9962 "BatchImport.c"
	}
#line 1236 "../src/BatchImport.vala"
	_tmp3_ = self->priv->cancellable;
#line 1236 "../src/BatchImport.vala"
	if (g_cancellable_is_cancelled (_tmp3_)) {
#line 9968 "BatchImport.c"
		GeeList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
#line 1237 "../src/BatchImport.vala"
		_tmp4_ = self->priv->display_imported_queue;
#line 1237 "../src/BatchImport.vala"
		_tmp5_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1237 "../src/BatchImport.vala"
		_tmp6_ = _tmp5_;
#line 1237 "../src/BatchImport.vala"
		g_debug ("BatchImport.vala:1237: Importing %d photos at once", _tmp6_);
#line 9980 "BatchImport.c"
	}
#line 1239 "../src/BatchImport.vala"
	batch_import_log_status (self, "display_imported_timer");
#line 1249 "../src/BatchImport.vala"
	total = 1;
#line 1250 "../src/BatchImport.vala"
	_tmp7_ = self->priv->cancellable;
#line 1250 "../src/BatchImport.vala"
	if (!g_cancellable_is_cancelled (_tmp7_)) {
#line 9990 "BatchImport.c"
		GeeList* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
#line 1251 "../src/BatchImport.vala"
		_tmp8_ = self->priv->display_imported_queue;
#line 1251 "../src/BatchImport.vala"
		_tmp9_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1251 "../src/BatchImport.vala"
		_tmp10_ = _tmp9_;
#line 1251 "../src/BatchImport.vala"
		if (_tmp10_ > BATCH_IMPORT_DISPLAY_QUEUE_HYSTERESIS_OVERFLOW) {
#line 10002 "BatchImport.c"
			GeeList* _tmp11_;
			gint _tmp12_;
			gint _tmp13_;
#line 1252 "../src/BatchImport.vala"
			_tmp11_ = self->priv->display_imported_queue;
#line 1252 "../src/BatchImport.vala"
			_tmp12_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1252 "../src/BatchImport.vala"
			_tmp13_ = _tmp12_;
#line 1252 "../src/BatchImport.vala"
			total = 1 << CLAMP ((_tmp13_ / BATCH_IMPORT_DISPLAY_QUEUE_HYSTERESIS_OVERFLOW) + 2, 0, 16);
#line 10014 "BatchImport.c"
		}
	} else {
#line 1256 "../src/BatchImport.vala"
		total = BATCH_IMPORT_DISPLAY_QUEUE_HYSTERESIS_OVERFLOW;
#line 10019 "BatchImport.c"
	}
#line 1259 "../src/BatchImport.vala"
	_tmp14_ = self->priv->display_imported_queue;
#line 1259 "../src/BatchImport.vala"
	_tmp15_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1259 "../src/BatchImport.vala"
	_tmp16_ = _tmp15_;
#line 1259 "../src/BatchImport.vala"
	total = MIN (total, _tmp16_);
#line 1269 "../src/BatchImport.vala"
	while (TRUE) {
#line 10031 "BatchImport.c"
		gint _tmp17_;
		CompletedImportObject* completed_object = NULL;
		GeeList* _tmp18_;
		gpointer _tmp19_;
		GdkPixbuf* user_preview = NULL;
		CompletedImportObject* _tmp20_;
		GdkPixbuf* _tmp21_;
		GdkPixbuf* _tmp22_;
		CompletedImportObject* _tmp23_;
		CompletedImportObject* _tmp24_;
		GeeList* _tmp25_;
		CompletedImportObject* _tmp26_;
		CompletedImportObject* _tmp27_;
		MediaSource* _tmp28_;
		GdkPixbuf* _tmp29_;
		CompletedImportObject* _tmp30_;
		MediaSource* _tmp31_;
#line 1269 "../src/BatchImport.vala"
		_tmp17_ = total;
#line 1269 "../src/BatchImport.vala"
		total = _tmp17_ - 1;
#line 1269 "../src/BatchImport.vala"
		if (!(_tmp17_ > 0)) {
#line 1269 "../src/BatchImport.vala"
			break;
#line 10057 "BatchImport.c"
		}
#line 1270 "../src/BatchImport.vala"
		_tmp18_ = self->priv->display_imported_queue;
#line 1270 "../src/BatchImport.vala"
		_tmp19_ = gee_list_remove_at (_tmp18_, 0);
#line 1270 "../src/BatchImport.vala"
		completed_object = (CompletedImportObject*) _tmp19_;
#line 1273 "../src/BatchImport.vala"
		_tmp20_ = completed_object;
#line 1273 "../src/BatchImport.vala"
		_tmp21_ = _tmp20_->user_preview;
#line 1273 "../src/BatchImport.vala"
		_tmp22_ = _g_object_ref0 (_tmp21_);
#line 1273 "../src/BatchImport.vala"
		user_preview = _tmp22_;
#line 1276 "../src/BatchImport.vala"
		_tmp23_ = completed_object;
#line 1276 "../src/BatchImport.vala"
		_g_object_unref0 (_tmp23_->user_preview);
#line 1276 "../src/BatchImport.vala"
		_tmp23_->user_preview = NULL;
#line 1277 "../src/BatchImport.vala"
		_tmp24_ = completed_object;
#line 1277 "../src/BatchImport.vala"
		_thumbnails_unref0 (_tmp24_->thumbnails);
#line 1277 "../src/BatchImport.vala"
		_tmp24_->thumbnails = NULL;
#line 1282 "../src/BatchImport.vala"
		_tmp25_ = self->priv->ready_sources;
#line 1282 "../src/BatchImport.vala"
		_tmp26_ = completed_object;
#line 1282 "../src/BatchImport.vala"
		gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, GEE_TYPE_COLLECTION, GeeCollection), _tmp26_);
#line 1284 "../src/BatchImport.vala"
		_tmp27_ = completed_object;
#line 1284 "../src/BatchImport.vala"
		_tmp28_ = _tmp27_->source;
#line 1284 "../src/BatchImport.vala"
		_tmp29_ = user_preview;
#line 1284 "../src/BatchImport.vala"
		g_signal_emit (self, batch_import_signals[BATCH_IMPORT_IMPORTED_SIGNAL], 0, _tmp28_, _tmp29_, total);
#line 1287 "../src/BatchImport.vala"
		_tmp30_ = completed_object;
#line 1287 "../src/BatchImport.vala"
		_tmp31_ = _tmp30_->source;
#line 1287 "../src/BatchImport.vala"
		if (IS_PHOTO_SOURCE (_tmp31_)) {
#line 10105 "BatchImport.c"
			PhotoSource* photo_source = NULL;
			CompletedImportObject* _tmp32_;
			MediaSource* _tmp33_;
			PhotoSource* _tmp34_;
			PhotoSource* _tmp35_;
#line 1288 "../src/BatchImport.vala"
			_tmp32_ = completed_object;
#line 1288 "../src/BatchImport.vala"
			_tmp33_ = _tmp32_->source;
#line 1288 "../src/BatchImport.vala"
			_tmp34_ = _g_object_ref0 (IS_PHOTO_SOURCE (_tmp33_) ? ((PhotoSource*) _tmp33_) : NULL);
#line 1288 "../src/BatchImport.vala"
			photo_source = _tmp34_;
#line 1289 "../src/BatchImport.vala"
			_tmp35_ = photo_source;
#line 1289 "../src/BatchImport.vala"
			batch_import_report_progress (self, media_source_get_master_filesize (G_TYPE_CHECK_INSTANCE_CAST (_tmp35_, TYPE_MEDIA_SOURCE, MediaSource)));
#line 1287 "../src/BatchImport.vala"
			_g_object_unref0 (photo_source);
#line 10125 "BatchImport.c"
		} else {
			CompletedImportObject* _tmp36_;
			MediaSource* _tmp37_;
#line 1291 "../src/BatchImport.vala"
			_tmp36_ = completed_object;
#line 1291 "../src/BatchImport.vala"
			_tmp37_ = _tmp36_->source;
#line 1291 "../src/BatchImport.vala"
			batch_import_report_progress (self, media_source_get_filesize (_tmp37_));
#line 10135 "BatchImport.c"
		}
#line 1293 "../src/BatchImport.vala"
		batch_import_file_import_complete (self);
#line 1269 "../src/BatchImport.vala"
		_g_object_unref0 (user_preview);
#line 1269 "../src/BatchImport.vala"
		_completed_import_object_unref0 (completed_object);
#line 10143 "BatchImport.c"
	}
#line 1296 "../src/BatchImport.vala"
	_tmp39_ = self->priv->ready_sources;
#line 1296 "../src/BatchImport.vala"
	_tmp40_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1296 "../src/BatchImport.vala"
	_tmp41_ = _tmp40_;
#line 1296 "../src/BatchImport.vala"
	if (_tmp41_ >= BATCH_IMPORT_READY_SOURCES_COUNT_OVERFLOW) {
#line 1296 "../src/BatchImport.vala"
		_tmp38_ = TRUE;
#line 10155 "BatchImport.c"
	} else {
		GCancellable* _tmp42_;
#line 1296 "../src/BatchImport.vala"
		_tmp42_ = self->priv->cancellable;
#line 1296 "../src/BatchImport.vala"
		_tmp38_ = g_cancellable_is_cancelled (_tmp42_);
#line 10162 "BatchImport.c"
	}
#line 1296 "../src/BatchImport.vala"
	if (_tmp38_) {
#line 1297 "../src/BatchImport.vala"
		batch_import_flush_ready_sources (self);
#line 10168 "BatchImport.c"
	}
#line 1299 "../src/BatchImport.vala"
	result = TRUE;
#line 1299 "../src/BatchImport.vala"
	return result;
#line 10174 "BatchImport.c"
}

static void
g_cclosure_user_marshal_VOID__UINT64_UINT64 (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__UINT64_UINT64) (gpointer data1, guint64 arg_1, guint64 arg_2, gpointer data2);
	register GMarshalFunc_VOID__UINT64_UINT64 callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 418 "../src/BatchImport.vala"
	g_return_if_fail (n_param_values == 3);
#line 418 "../src/BatchImport.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 418 "../src/BatchImport.vala"
		data1 = closure->data;
#line 418 "../src/BatchImport.vala"
		data2 = param_values->data[0].v_pointer;
#line 10199 "BatchImport.c"
	} else {
#line 418 "../src/BatchImport.vala"
		data1 = param_values->data[0].v_pointer;
#line 418 "../src/BatchImport.vala"
		data2 = closure->data;
#line 10205 "BatchImport.c"
	}
#line 418 "../src/BatchImport.vala"
	callback = (GMarshalFunc_VOID__UINT64_UINT64) (marshal_data ? marshal_data : cc->callback);
#line 418 "../src/BatchImport.vala"
	callback (data1, g_value_get_uint64 (param_values + 1), g_value_get_uint64 (param_values + 2), data2);
#line 10211 "BatchImport.c"
}

static void
g_cclosure_user_marshal_VOID__OBJECT_OBJECT_INT (GClosure * closure,
                                                 GValue * return_value,
                                                 guint n_param_values,
                                                 const GValue * param_values,
                                                 gpointer invocation_hint,
                                                 gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT_INT) (gpointer data1, gpointer arg_1, gpointer arg_2, gint arg_3, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 418 "../src/BatchImport.vala"
	g_return_if_fail (n_param_values == 4);
#line 418 "../src/BatchImport.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 418 "../src/BatchImport.vala"
		data1 = closure->data;
#line 418 "../src/BatchImport.vala"
		data2 = param_values->data[0].v_pointer;
#line 10236 "BatchImport.c"
	} else {
#line 418 "../src/BatchImport.vala"
		data1 = param_values->data[0].v_pointer;
#line 418 "../src/BatchImport.vala"
		data2 = closure->data;
#line 10242 "BatchImport.c"
	}
#line 418 "../src/BatchImport.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT_INT) (marshal_data ? marshal_data : cc->callback);
#line 418 "../src/BatchImport.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), g_value_get_int (param_values + 3), data2);
#line 10248 "BatchImport.c"
}

static void
g_cclosure_user_marshal_VOID__ENUM_STRING (GClosure * closure,
                                           GValue * return_value,
                                           guint n_param_values,
                                           const GValue * param_values,
                                           gpointer invocation_hint,
                                           gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__ENUM_STRING) (gpointer data1, gint arg_1, const char* arg_2, gpointer data2);
	register GMarshalFunc_VOID__ENUM_STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 418 "../src/BatchImport.vala"
	g_return_if_fail (n_param_values == 3);
#line 418 "../src/BatchImport.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 418 "../src/BatchImport.vala"
		data1 = closure->data;
#line 418 "../src/BatchImport.vala"
		data2 = param_values->data[0].v_pointer;
#line 10273 "BatchImport.c"
	} else {
#line 418 "../src/BatchImport.vala"
		data1 = param_values->data[0].v_pointer;
#line 418 "../src/BatchImport.vala"
		data2 = closure->data;
#line 10279 "BatchImport.c"
	}
#line 418 "../src/BatchImport.vala"
	callback = (GMarshalFunc_VOID__ENUM_STRING) (marshal_data ? marshal_data : cc->callback);
#line 418 "../src/BatchImport.vala"
	callback (data1, g_value_get_enum (param_values + 1), g_value_get_string (param_values + 2), data2);
#line 10285 "BatchImport.c"
}

static void
g_cclosure_user_marshal_VOID__BATCH_IMPORT_RESULT (GClosure * closure,
                                                   GValue * return_value,
                                                   guint n_param_values,
                                                   const GValue * param_values,
                                                   gpointer invocation_hint,
                                                   gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__BATCH_IMPORT_RESULT) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_VOID__BATCH_IMPORT_RESULT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 418 "../src/BatchImport.vala"
	g_return_if_fail (n_param_values == 2);
#line 418 "../src/BatchImport.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 418 "../src/BatchImport.vala"
		data1 = closure->data;
#line 418 "../src/BatchImport.vala"
		data2 = param_values->data[0].v_pointer;
#line 10310 "BatchImport.c"
	} else {
#line 418 "../src/BatchImport.vala"
		data1 = param_values->data[0].v_pointer;
#line 418 "../src/BatchImport.vala"
		data2 = closure->data;
#line 10316 "BatchImport.c"
	}
#line 418 "../src/BatchImport.vala"
	callback = (GMarshalFunc_VOID__BATCH_IMPORT_RESULT) (marshal_data ? marshal_data : cc->callback);
#line 418 "../src/BatchImport.vala"
	callback (data1, value_get_batch_import_result (param_values + 1), data2);
#line 10322 "BatchImport.c"
}

static void
g_cclosure_user_marshal_VOID__IMPORT_MANIFEST_BATCH_IMPORT_ROLL (GClosure * closure,
                                                                 GValue * return_value,
                                                                 guint n_param_values,
                                                                 const GValue * param_values,
                                                                 gpointer invocation_hint,
                                                                 gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__IMPORT_MANIFEST_BATCH_IMPORT_ROLL) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__IMPORT_MANIFEST_BATCH_IMPORT_ROLL callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 418 "../src/BatchImport.vala"
	g_return_if_fail (n_param_values == 3);
#line 418 "../src/BatchImport.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 418 "../src/BatchImport.vala"
		data1 = closure->data;
#line 418 "../src/BatchImport.vala"
		data2 = param_values->data[0].v_pointer;
#line 10347 "BatchImport.c"
	} else {
#line 418 "../src/BatchImport.vala"
		data1 = param_values->data[0].v_pointer;
#line 418 "../src/BatchImport.vala"
		data2 = closure->data;
#line 10353 "BatchImport.c"
	}
#line 418 "../src/BatchImport.vala"
	callback = (GMarshalFunc_VOID__IMPORT_MANIFEST_BATCH_IMPORT_ROLL) (marshal_data ? marshal_data : cc->callback);
#line 418 "../src/BatchImport.vala"
	callback (data1, value_get_import_manifest (param_values + 1), value_get_batch_import_roll (param_values + 2), data2);
#line 10359 "BatchImport.c"
}

static void
batch_import_class_init (BatchImportClass * klass,
                         gpointer klass_data)
{
	Workers* _tmp0_;
	Workers* _tmp1_;
#line 418 "../src/BatchImport.vala"
	batch_import_parent_class = g_type_class_peek_parent (klass);
#line 418 "../src/BatchImport.vala"
	g_type_class_adjust_private_offset (klass, &BatchImport_private_offset);
#line 418 "../src/BatchImport.vala"
	G_OBJECT_CLASS (klass)->finalize = batch_import_finalize;
#line 418 "../src/BatchImport.vala"
	batch_import_signals[BATCH_IMPORT_STARTING_SIGNAL] = g_signal_new ("starting", TYPE_BATCH_IMPORT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 418 "../src/BatchImport.vala"
	batch_import_signals[BATCH_IMPORT_PREPARING_SIGNAL] = g_signal_new ("preparing", TYPE_BATCH_IMPORT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 418 "../src/BatchImport.vala"
	batch_import_signals[BATCH_IMPORT_PROGRESS_SIGNAL] = g_signal_new ("progress", TYPE_BATCH_IMPORT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__UINT64_UINT64, G_TYPE_NONE, 2, G_TYPE_UINT64, G_TYPE_UINT64);
#line 418 "../src/BatchImport.vala"
	batch_import_signals[BATCH_IMPORT_IMPORTED_SIGNAL] = g_signal_new ("imported", TYPE_BATCH_IMPORT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT_INT, G_TYPE_NONE, 3, TYPE_MEDIA_SOURCE, gdk_pixbuf_get_type (), G_TYPE_INT);
#line 418 "../src/BatchImport.vala"
	batch_import_signals[BATCH_IMPORT_FATAL_ERROR_SIGNAL] = g_signal_new ("fatal-error", TYPE_BATCH_IMPORT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__ENUM_STRING, G_TYPE_NONE, 2, TYPE_IMPORT_RESULT, G_TYPE_STRING);
#line 418 "../src/BatchImport.vala"
	batch_import_signals[BATCH_IMPORT_IMPORT_JOB_FAILED_SIGNAL] = g_signal_new ("import-job-failed", TYPE_BATCH_IMPORT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__BATCH_IMPORT_RESULT, G_TYPE_NONE, 1, TYPE_BATCH_IMPORT_RESULT);
#line 418 "../src/BatchImport.vala"
	batch_import_signals[BATCH_IMPORT_IMPORT_COMPLETE_SIGNAL] = g_signal_new ("import-complete", TYPE_BATCH_IMPORT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__IMPORT_MANIFEST_BATCH_IMPORT_ROLL, G_TYPE_NONE, 2, TYPE_IMPORT_MANIFEST, TYPE_BATCH_IMPORT_ROLL);
#line 429 "../src/BatchImport.vala"
	_tmp0_ = workers_new ((guint) 1, FALSE);
#line 429 "../src/BatchImport.vala"
	batch_import_feeder_workers = _tmp0_;
#line 430 "../src/BatchImport.vala"
	_tmp1_ = workers_new (workers_thread_per_cpu_minus_one (), FALSE);
#line 430 "../src/BatchImport.vala"
	batch_import_import_workers = _tmp1_;
#line 10396 "BatchImport.c"
}

static void
batch_import_instance_init (BatchImport * self,
                            gpointer klass)
{
	GeeHashMap* _tmp0_;
	GeeLinkedList* _tmp1_;
	GeeLinkedList* _tmp2_;
	GeeLinkedList* _tmp3_;
	GeeLinkedList* _tmp4_;
#line 418 "../src/BatchImport.vala"
	self->priv = batch_import_get_instance_private (self);
#line 435 "../src/BatchImport.vala"
	self->priv->completed_bytes = (guint64) 0;
#line 436 "../src/BatchImport.vala"
	self->priv->total_bytes = (guint64) 0;
#line 439 "../src/BatchImport.vala"
	self->priv->scheduled = FALSE;
#line 440 "../src/BatchImport.vala"
	self->priv->completed = FALSE;
#line 441 "../src/BatchImport.vala"
	self->priv->file_imports_to_perform = -1;
#line 442 "../src/BatchImport.vala"
	self->priv->file_imports_completed = 0;
#line 443 "../src/BatchImport.vala"
	self->priv->cancellable = NULL;
#line 444 "../src/BatchImport.vala"
	self->priv->last_preparing_ms = (gulong) 0;
#line 447 "../src/BatchImport.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 447 "../src/BatchImport.vala"
	self->priv->imported_full_md5_table = _tmp0_;
#line 449 "../src/BatchImport.vala"
	self->priv->throbber_id = (guint) 0;
#line 450 "../src/BatchImport.vala"
	self->priv->max_outstanding_import_jobs = workers_thread_per_cpu_minus_one ();
#line 451 "../src/BatchImport.vala"
	self->priv->untrash_duplicates = TRUE;
#line 452 "../src/BatchImport.vala"
	self->priv->mark_duplicates_online = TRUE;
#line 456 "../src/BatchImport.vala"
	_tmp1_ = gee_linked_list_new (TYPE_PREPARED_FILE, (GBoxedCopyFunc) prepared_file_ref, (GDestroyNotify) prepared_file_unref, NULL, NULL, NULL);
#line 456 "../src/BatchImport.vala"
	self->priv->ready_files = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_LIST, GeeList);
#line 457 "../src/BatchImport.vala"
	_tmp2_ = gee_linked_list_new (TYPE_COMPLETED_IMPORT_OBJECT, (GBoxedCopyFunc) completed_import_object_ref, (GDestroyNotify) completed_import_object_unref, NULL, NULL, NULL);
#line 457 "../src/BatchImport.vala"
	self->priv->ready_thumbnails = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_LIST, GeeList);
#line 459 "../src/BatchImport.vala"
	_tmp3_ = gee_linked_list_new (TYPE_COMPLETED_IMPORT_OBJECT, (GBoxedCopyFunc) completed_import_object_ref, (GDestroyNotify) completed_import_object_unref, NULL, NULL, NULL);
#line 459 "../src/BatchImport.vala"
	self->priv->display_imported_queue = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_LIST, GeeList);
#line 461 "../src/BatchImport.vala"
	_tmp4_ = gee_linked_list_new (TYPE_COMPLETED_IMPORT_OBJECT, (GBoxedCopyFunc) completed_import_object_ref, (GDestroyNotify) completed_import_object_unref, NULL, NULL, NULL);
#line 461 "../src/BatchImport.vala"
	self->priv->ready_sources = G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_LIST, GeeList);
#line 10454 "BatchImport.c"
}

static void
batch_import_finalize (GObject * obj)
{
	BatchImport * self;
	Application* _tmp0_;
	Application* _tmp1_;
	guint _tmp2_;
#line 418 "../src/BatchImport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BATCH_IMPORT, BatchImport);
#line 524 "../src/BatchImport.vala"
	_tmp0_ = application_get_instance ();
#line 524 "../src/BatchImport.vala"
	_tmp1_ = _tmp0_;
#line 524 "../src/BatchImport.vala"
	g_signal_parse_name ("exiting", TYPE_APPLICATION, &_tmp2_, NULL, FALSE);
#line 524 "../src/BatchImport.vala"
	g_signal_handlers_disconnect_matched (_tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _batch_import_user_halt_application_exiting, self);
#line 524 "../src/BatchImport.vala"
	_application_unref0 (_tmp1_);
#line 432 "../src/BatchImport.vala"
	_g_object_unref0 (self->priv->jobs);
#line 433 "../src/BatchImport.vala"
	_batch_import_roll_unref0 (self->priv->import_roll);
#line 434 "../src/BatchImport.vala"
	_g_free0 (self->priv->name);
#line 438 "../src/BatchImport.vala"
	_import_manifest_unref0 (self->priv->manifest);
#line 443 "../src/BatchImport.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 445 "../src/BatchImport.vala"
	_g_object_unref0 (self->priv->skipset);
#line 447 "../src/BatchImport.vala"
	_g_object_unref0 (self->priv->imported_full_md5_table);
#line 456 "../src/BatchImport.vala"
	_g_object_unref0 (self->priv->ready_files);
#line 457 "../src/BatchImport.vala"
	_g_object_unref0 (self->priv->ready_thumbnails);
#line 459 "../src/BatchImport.vala"
	_g_object_unref0 (self->priv->display_imported_queue);
#line 461 "../src/BatchImport.vala"
	_g_object_unref0 (self->priv->ready_sources);
#line 418 "../src/BatchImport.vala"
	G_OBJECT_CLASS (batch_import_parent_class)->finalize (obj);
#line 10500 "BatchImport.c"
}

static GType
batch_import_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BatchImportClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) batch_import_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BatchImport), 0, (GInstanceInitFunc) batch_import_instance_init, NULL };
	GType batch_import_type_id;
	batch_import_type_id = g_type_register_static (G_TYPE_OBJECT, "BatchImport", &g_define_type_info, 0);
	BatchImport_private_offset = g_type_add_instance_private (batch_import_type_id, sizeof (BatchImportPrivate));
	return batch_import_type_id;
}

GType
batch_import_get_type (void)
{
	static volatile gsize batch_import_type_id__once = 0;
	if (g_once_init_enter (&batch_import_type_id__once)) {
		GType batch_import_type_id;
		batch_import_type_id = batch_import_get_type_once ();
		g_once_init_leave (&batch_import_type_id__once, batch_import_type_id);
	}
	return batch_import_type_id__once;
}

static inline gpointer
duplicated_file_get_instance_private (DuplicatedFile* self)
{
	return G_STRUCT_MEMBER_P (self, DuplicatedFile_private_offset);
}

static DuplicatedFile*
duplicated_file_construct (GType object_type)
{
	DuplicatedFile * self = NULL;
#line 1308 "../src/BatchImport.vala"
	self = (DuplicatedFile*) g_object_new (object_type, NULL);
#line 1309 "../src/BatchImport.vala"
	_video_id_free0 (self->priv->video_id);
#line 1309 "../src/BatchImport.vala"
	self->priv->video_id = NULL;
#line 1310 "../src/BatchImport.vala"
	_photo_id_free0 (self->priv->photo_id);
#line 1310 "../src/BatchImport.vala"
	self->priv->photo_id = NULL;
#line 1311 "../src/BatchImport.vala"
	_g_object_unref0 (self->priv->file);
#line 1311 "../src/BatchImport.vala"
	self->priv->file = NULL;
#line 1308 "../src/BatchImport.vala"
	return self;
#line 10551 "BatchImport.c"
}

static DuplicatedFile*
duplicated_file_new (void)
{
#line 1308 "../src/BatchImport.vala"
	return duplicated_file_construct (TYPE_DUPLICATED_FILE);
#line 10559 "BatchImport.c"
}

static gpointer
_photo_id_dup0 (gpointer self)
{
#line 1318 "../src/BatchImport.vala"
	return self ? photo_id_dup (self) : NULL;
#line 10567 "BatchImport.c"
}

DuplicatedFile*
duplicated_file_create_from_photo_id (PhotoID* photo_id)
{
	DuplicatedFile* _result_ = NULL;
	DuplicatedFile* _tmp0_;
	PhotoID _tmp1_;
	PhotoID* _tmp2_;
	DuplicatedFile* result;
#line 1314 "../src/BatchImport.vala"
	g_return_val_if_fail (photo_id != NULL, NULL);
#line 1315 "../src/BatchImport.vala"
	_vala_assert (photo_id_is_valid (photo_id), "photo_id.is_valid()");
#line 1317 "../src/BatchImport.vala"
	_tmp0_ = duplicated_file_new ();
#line 1317 "../src/BatchImport.vala"
	_result_ = _tmp0_;
#line 1318 "../src/BatchImport.vala"
	_tmp1_ = *photo_id;
#line 1318 "../src/BatchImport.vala"
	_tmp2_ = _photo_id_dup0 (&_tmp1_);
#line 1318 "../src/BatchImport.vala"
	_photo_id_free0 (_result_->priv->photo_id);
#line 1318 "../src/BatchImport.vala"
	_result_->priv->photo_id = _tmp2_;
#line 1319 "../src/BatchImport.vala"
	result = _result_;
#line 1319 "../src/BatchImport.vala"
	return result;
#line 10598 "BatchImport.c"
}

static gpointer
_video_id_dup0 (gpointer self)
{
#line 1326 "../src/BatchImport.vala"
	return self ? video_id_dup (self) : NULL;
#line 10606 "BatchImport.c"
}

DuplicatedFile*
duplicated_file_create_from_video_id (VideoID* video_id)
{
	DuplicatedFile* _result_ = NULL;
	DuplicatedFile* _tmp0_;
	VideoID _tmp1_;
	VideoID* _tmp2_;
	DuplicatedFile* result;
#line 1322 "../src/BatchImport.vala"
	g_return_val_if_fail (video_id != NULL, NULL);
#line 1323 "../src/BatchImport.vala"
	_vala_assert (video_id_is_valid (video_id), "video_id.is_valid()");
#line 1325 "../src/BatchImport.vala"
	_tmp0_ = duplicated_file_new ();
#line 1325 "../src/BatchImport.vala"
	_result_ = _tmp0_;
#line 1326 "../src/BatchImport.vala"
	_tmp1_ = *video_id;
#line 1326 "../src/BatchImport.vala"
	_tmp2_ = _video_id_dup0 (&_tmp1_);
#line 1326 "../src/BatchImport.vala"
	_video_id_free0 (_result_->priv->video_id);
#line 1326 "../src/BatchImport.vala"
	_result_->priv->video_id = _tmp2_;
#line 1327 "../src/BatchImport.vala"
	result = _result_;
#line 1327 "../src/BatchImport.vala"
	return result;
#line 10637 "BatchImport.c"
}

DuplicatedFile*
duplicated_file_create_from_file (GFile* file)
{
	DuplicatedFile* _result_ = NULL;
	DuplicatedFile* _tmp0_;
	GFile* _tmp1_;
	DuplicatedFile* result;
#line 1330 "../src/BatchImport.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 1331 "../src/BatchImport.vala"
	_tmp0_ = duplicated_file_new ();
#line 1331 "../src/BatchImport.vala"
	_result_ = _tmp0_;
#line 1333 "../src/BatchImport.vala"
	_tmp1_ = _g_object_ref0 (file);
#line 1333 "../src/BatchImport.vala"
	_g_object_unref0 (_result_->priv->file);
#line 1333 "../src/BatchImport.vala"
	_result_->priv->file = _tmp1_;
#line 1335 "../src/BatchImport.vala"
	result = _result_;
#line 1335 "../src/BatchImport.vala"
	return result;
#line 10663 "BatchImport.c"
}

GFile*
duplicated_file_get_file (DuplicatedFile* self)
{
	GFile* _tmp0_;
	GFile* result;
#line 1338 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_DUPLICATED_FILE (self), NULL);
#line 1339 "../src/BatchImport.vala"
	_tmp0_ = self->priv->file;
#line 1339 "../src/BatchImport.vala"
	if (_tmp0_ != NULL) {
#line 10677 "BatchImport.c"
		GFile* _tmp1_;
		GFile* _tmp2_;
#line 1340 "../src/BatchImport.vala"
		_tmp1_ = self->priv->file;
#line 1340 "../src/BatchImport.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 1340 "../src/BatchImport.vala"
		result = _tmp2_;
#line 1340 "../src/BatchImport.vala"
		return result;
#line 10688 "BatchImport.c"
	} else {
		PhotoID* _tmp3_;
#line 1341 "../src/BatchImport.vala"
		_tmp3_ = self->priv->photo_id;
#line 1341 "../src/BatchImport.vala"
		if (_tmp3_ != NULL) {
#line 10695 "BatchImport.c"
			Photo* photo_object = NULL;
			LibraryPhotoSourceCollection* _tmp4_;
			PhotoID* _tmp5_;
			PhotoID _tmp6_;
			LibraryPhoto* _tmp7_;
			Photo* _tmp8_;
			GFile* _tmp9_;
			GFile* _tmp10_;
			GFile* _tmp11_;
#line 1342 "../src/BatchImport.vala"
			_tmp4_ = library_photo_global;
#line 1342 "../src/BatchImport.vala"
			_tmp5_ = self->priv->photo_id;
#line 1342 "../src/BatchImport.vala"
			_tmp6_ = *_tmp5_;
#line 1342 "../src/BatchImport.vala"
			_tmp7_ = library_photo_source_collection_fetch (_tmp4_, &_tmp6_);
#line 1342 "../src/BatchImport.vala"
			photo_object = G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_PHOTO, Photo);
#line 1343 "../src/BatchImport.vala"
			_tmp8_ = photo_object;
#line 1343 "../src/BatchImport.vala"
			_tmp9_ = media_source_get_master_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, TYPE_MEDIA_SOURCE, MediaSource));
#line 1343 "../src/BatchImport.vala"
			_g_object_unref0 (self->priv->file);
#line 1343 "../src/BatchImport.vala"
			self->priv->file = _tmp9_;
#line 1344 "../src/BatchImport.vala"
			_tmp10_ = self->priv->file;
#line 1344 "../src/BatchImport.vala"
			_tmp11_ = _g_object_ref0 (_tmp10_);
#line 1344 "../src/BatchImport.vala"
			result = _tmp11_;
#line 1344 "../src/BatchImport.vala"
			_g_object_unref0 (photo_object);
#line 1344 "../src/BatchImport.vala"
			return result;
#line 10733 "BatchImport.c"
		} else {
			VideoID* _tmp12_;
#line 1345 "../src/BatchImport.vala"
			_tmp12_ = self->priv->video_id;
#line 1345 "../src/BatchImport.vala"
			if (_tmp12_ != NULL) {
#line 10740 "BatchImport.c"
				Video* video_object = NULL;
				VideoSourceCollection* _tmp13_;
				VideoID* _tmp14_;
				VideoID _tmp15_;
				Video* _tmp16_;
				Video* _tmp17_;
				GFile* _tmp18_;
				GFile* _tmp19_;
				GFile* _tmp20_;
#line 1346 "../src/BatchImport.vala"
				_tmp13_ = video_global;
#line 1346 "../src/BatchImport.vala"
				_tmp14_ = self->priv->video_id;
#line 1346 "../src/BatchImport.vala"
				_tmp15_ = *_tmp14_;
#line 1346 "../src/BatchImport.vala"
				_tmp16_ = video_source_collection_fetch (_tmp13_, &_tmp15_);
#line 1346 "../src/BatchImport.vala"
				video_object = G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, TYPE_VIDEO, Video);
#line 1347 "../src/BatchImport.vala"
				_tmp17_ = video_object;
#line 1347 "../src/BatchImport.vala"
				_tmp18_ = media_source_get_master_file (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, TYPE_MEDIA_SOURCE, MediaSource));
#line 1347 "../src/BatchImport.vala"
				_g_object_unref0 (self->priv->file);
#line 1347 "../src/BatchImport.vala"
				self->priv->file = _tmp18_;
#line 1348 "../src/BatchImport.vala"
				_tmp19_ = self->priv->file;
#line 1348 "../src/BatchImport.vala"
				_tmp20_ = _g_object_ref0 (_tmp19_);
#line 1348 "../src/BatchImport.vala"
				result = _tmp20_;
#line 1348 "../src/BatchImport.vala"
				_g_object_unref0 (video_object);
#line 1348 "../src/BatchImport.vala"
				return result;
#line 10778 "BatchImport.c"
			} else {
#line 1350 "../src/BatchImport.vala"
				g_assert_not_reached ();
#line 10782 "BatchImport.c"
			}
		}
	}
}

static void
duplicated_file_class_init (DuplicatedFileClass * klass,
                            gpointer klass_data)
{
#line 1303 "../src/BatchImport.vala"
	duplicated_file_parent_class = g_type_class_peek_parent (klass);
#line 1303 "../src/BatchImport.vala"
	g_type_class_adjust_private_offset (klass, &DuplicatedFile_private_offset);
#line 1303 "../src/BatchImport.vala"
	G_OBJECT_CLASS (klass)->finalize = duplicated_file_finalize;
#line 10798 "BatchImport.c"
}

static void
duplicated_file_instance_init (DuplicatedFile * self,
                               gpointer klass)
{
#line 1303 "../src/BatchImport.vala"
	self->priv = duplicated_file_get_instance_private (self);
#line 10807 "BatchImport.c"
}

static void
duplicated_file_finalize (GObject * obj)
{
	DuplicatedFile * self;
#line 1303 "../src/BatchImport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DUPLICATED_FILE, DuplicatedFile);
#line 1304 "../src/BatchImport.vala"
	_video_id_free0 (self->priv->video_id);
#line 1305 "../src/BatchImport.vala"
	_photo_id_free0 (self->priv->photo_id);
#line 1306 "../src/BatchImport.vala"
	_g_object_unref0 (self->priv->file);
#line 1303 "../src/BatchImport.vala"
	G_OBJECT_CLASS (duplicated_file_parent_class)->finalize (obj);
#line 10824 "BatchImport.c"
}

static GType
duplicated_file_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DuplicatedFileClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) duplicated_file_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DuplicatedFile), 0, (GInstanceInitFunc) duplicated_file_instance_init, NULL };
	GType duplicated_file_type_id;
	duplicated_file_type_id = g_type_register_static (G_TYPE_OBJECT, "DuplicatedFile", &g_define_type_info, 0);
	DuplicatedFile_private_offset = g_type_add_instance_private (duplicated_file_type_id, sizeof (DuplicatedFilePrivate));
	return duplicated_file_type_id;
}

GType
duplicated_file_get_type (void)
{
	static volatile gsize duplicated_file_type_id__once = 0;
	if (g_once_init_enter (&duplicated_file_type_id__once)) {
		GType duplicated_file_type_id;
		duplicated_file_type_id = duplicated_file_get_type_once ();
		g_once_init_leave (&duplicated_file_type_id__once, duplicated_file_type_id);
	}
	return duplicated_file_type_id__once;
}

BackgroundImportJob*
background_import_job_construct (GType object_type,
                                 BatchImport* owner,
                                 CompletionCallback callback,
                                 gpointer callback_target,
                                 GCancellable* cancellable,
                                 CancellationCallback cancellation,
                                 gpointer cancellation_target)
{
	BackgroundImportJob* self = NULL;
#line 1377 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_BATCH_IMPORT (owner), NULL);
#line 1377 "../src/BatchImport.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()), NULL);
#line 1379 "../src/BatchImport.vala"
	self = (BackgroundImportJob*) background_job_construct (object_type, G_TYPE_CHECK_INSTANCE_CAST (owner, G_TYPE_OBJECT, GObject), callback, callback_target, cancellable, cancellation, cancellation_target, NULL);
#line 1377 "../src/BatchImport.vala"
	return self;
#line 10867 "BatchImport.c"
}

ImportResult
background_import_job_abort_check (BackgroundImportJob* self)
{
	gboolean _tmp0_ = FALSE;
	ImportResult result;
#line 1384 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_BACKGROUND_IMPORT_JOB (self), 0);
#line 1385 "../src/BatchImport.vala"
	if (self->abort_flag == IMPORT_RESULT_SUCCESS) {
#line 1385 "../src/BatchImport.vala"
		_tmp0_ = background_job_is_cancelled (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_BACKGROUND_JOB, BackgroundJob));
#line 10881 "BatchImport.c"
	} else {
#line 1385 "../src/BatchImport.vala"
		_tmp0_ = FALSE;
#line 10885 "BatchImport.c"
	}
#line 1385 "../src/BatchImport.vala"
	if (_tmp0_) {
#line 1386 "../src/BatchImport.vala"
		self->abort_flag = IMPORT_RESULT_USER_ABORT;
#line 10891 "BatchImport.c"
	}
#line 1388 "../src/BatchImport.vala"
	result = self->abort_flag;
#line 1388 "../src/BatchImport.vala"
	return result;
#line 10897 "BatchImport.c"
}

void
background_import_job_abort (BackgroundImportJob* self,
                             ImportResult _result_)
{
#line 1391 "../src/BatchImport.vala"
	g_return_if_fail (IS_BACKGROUND_IMPORT_JOB (self));
#line 1393 "../src/BatchImport.vala"
	if (self->abort_flag == IMPORT_RESULT_SUCCESS) {
#line 1394 "../src/BatchImport.vala"
		self->abort_flag = _result_;
#line 10910 "BatchImport.c"
	}
}

void
background_import_job_report_failure (BackgroundImportJob* self,
                                      BatchImportJob* job,
                                      GFile* file,
                                      const gchar* src_identifier,
                                      const gchar* dest_identifier,
                                      ImportResult _result_)
{
	GeeList* _tmp2_;
	BatchImportResult* _tmp3_;
	BatchImportResult* _tmp4_;
#line 1397 "../src/BatchImport.vala"
	g_return_if_fail (IS_BACKGROUND_IMPORT_JOB (self));
#line 1397 "../src/BatchImport.vala"
	g_return_if_fail (IS_BATCH_IMPORT_JOB (job));
#line 1397 "../src/BatchImport.vala"
	g_return_if_fail ((file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()));
#line 1397 "../src/BatchImport.vala"
	g_return_if_fail (src_identifier != NULL);
#line 1397 "../src/BatchImport.vala"
	g_return_if_fail (dest_identifier != NULL);
#line 1399 "../src/BatchImport.vala"
	_vala_assert (_result_ != IMPORT_RESULT_SUCCESS, "result != ImportResult.SUCCESS");
#line 1402 "../src/BatchImport.vala"
	if (import_result_is_abort (_result_)) {
#line 1403 "../src/BatchImport.vala"
		background_import_job_abort (self, _result_);
#line 10941 "BatchImport.c"
	} else {
		gchar* _tmp0_;
		gchar* _tmp1_;
#line 1405 "../src/BatchImport.vala"
		_tmp0_ = import_result_to_string (_result_);
#line 1405 "../src/BatchImport.vala"
		_tmp1_ = _tmp0_;
#line 1405 "../src/BatchImport.vala"
		g_warning ("BatchImport.vala:1405: Import failure %s: %s", src_identifier, _tmp1_);
#line 1405 "../src/BatchImport.vala"
		_g_free0 (_tmp1_);
#line 10953 "BatchImport.c"
	}
#line 1407 "../src/BatchImport.vala"
	_tmp2_ = self->failed;
#line 1407 "../src/BatchImport.vala"
	_tmp3_ = batch_import_result_new (job, file, src_identifier, dest_identifier, NULL, _result_);
#line 1407 "../src/BatchImport.vala"
	_tmp4_ = _tmp3_;
#line 1407 "../src/BatchImport.vala"
	gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_COLLECTION, GeeCollection), _tmp4_);
#line 1407 "../src/BatchImport.vala"
	_batch_import_result_unref0 (_tmp4_);
#line 10965 "BatchImport.c"
}

void
background_import_job_report_error (BackgroundImportJob* self,
                                    BatchImportJob* job,
                                    GFile* file,
                                    const gchar* src_identifier,
                                    const gchar* dest_identifier,
                                    GError* err,
                                    ImportResult default_result)
{
	ImportResult _result_ = 0;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GeeList* _tmp3_;
	BatchImportResult* _tmp4_;
	BatchImportResult* _tmp5_;
#line 1411 "../src/BatchImport.vala"
	g_return_if_fail (IS_BACKGROUND_IMPORT_JOB (self));
#line 1411 "../src/BatchImport.vala"
	g_return_if_fail (IS_BATCH_IMPORT_JOB (job));
#line 1411 "../src/BatchImport.vala"
	g_return_if_fail ((file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()));
#line 1411 "../src/BatchImport.vala"
	g_return_if_fail (src_identifier != NULL);
#line 1411 "../src/BatchImport.vala"
	g_return_if_fail (dest_identifier != NULL);
#line 1411 "../src/BatchImport.vala"
	g_return_if_fail (err != NULL);
#line 1413 "../src/BatchImport.vala"
	_result_ = import_result_convert_error (err, default_result);
#line 1415 "../src/BatchImport.vala"
	_tmp0_ = err->message;
#line 1415 "../src/BatchImport.vala"
	_tmp1_ = import_result_to_string (_result_);
#line 1415 "../src/BatchImport.vala"
	_tmp2_ = _tmp1_;
#line 1415 "../src/BatchImport.vala"
	g_warning ("BatchImport.vala:1415: Import error %s: %s (%s)", src_identifier, _tmp0_, _tmp2_);
#line 1415 "../src/BatchImport.vala"
	_g_free0 (_tmp2_);
#line 1417 "../src/BatchImport.vala"
	if (import_result_is_abort (_result_)) {
#line 1418 "../src/BatchImport.vala"
		background_import_job_abort (self, _result_);
#line 11012 "BatchImport.c"
	}
#line 1420 "../src/BatchImport.vala"
	_tmp3_ = self->failed;
#line 1420 "../src/BatchImport.vala"
	_tmp4_ = batch_import_result_new_from_error (job, file, src_identifier, dest_identifier, err, default_result);
#line 1420 "../src/BatchImport.vala"
	_tmp5_ = _tmp4_;
#line 1420 "../src/BatchImport.vala"
	gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_COLLECTION, GeeCollection), _tmp5_);
#line 1420 "../src/BatchImport.vala"
	_batch_import_result_unref0 (_tmp5_);
#line 11024 "BatchImport.c"
}

static void
background_import_job_class_init (BackgroundImportJobClass * klass,
                                  gpointer klass_data)
{
#line 1373 "../src/BatchImport.vala"
	background_import_job_parent_class = g_type_class_peek_parent (klass);
#line 1373 "../src/BatchImport.vala"
	((BackgroundJobClass *) klass)->finalize = background_import_job_finalize;
#line 11035 "BatchImport.c"
}

static void
background_import_job_instance_init (BackgroundImportJob * self,
                                     gpointer klass)
{
	GeeArrayList* _tmp0_;
#line 1374 "../src/BatchImport.vala"
	self->abort_flag = IMPORT_RESULT_SUCCESS;
#line 1375 "../src/BatchImport.vala"
	_tmp0_ = gee_array_list_new (TYPE_BATCH_IMPORT_RESULT, (GBoxedCopyFunc) batch_import_result_ref, (GDestroyNotify) batch_import_result_unref, NULL, NULL, NULL);
#line 1375 "../src/BatchImport.vala"
	self->failed = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_LIST, GeeList);
#line 11049 "BatchImport.c"
}

static void
background_import_job_finalize (BackgroundJob * obj)
{
	BackgroundImportJob * self;
#line 1373 "../src/BatchImport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BACKGROUND_IMPORT_JOB, BackgroundImportJob);
#line 1375 "../src/BatchImport.vala"
	_g_object_unref0 (self->failed);
#line 1373 "../src/BatchImport.vala"
	BACKGROUND_JOB_CLASS (background_import_job_parent_class)->finalize (obj);
#line 11062 "BatchImport.c"
}

static GType
background_import_job_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BackgroundImportJobClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) background_import_job_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BackgroundImportJob), 0, (GInstanceInitFunc) background_import_job_instance_init, NULL };
	GType background_import_job_type_id;
	background_import_job_type_id = g_type_register_static (TYPE_BACKGROUND_JOB, "BackgroundImportJob", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	return background_import_job_type_id;
}

GType
background_import_job_get_type (void)
{
	static volatile gsize background_import_job_type_id__once = 0;
	if (g_once_init_enter (&background_import_job_type_id__once)) {
		GType background_import_job_type_id;
		background_import_job_type_id = background_import_job_get_type_once ();
		g_once_init_leave (&background_import_job_type_id__once, background_import_job_type_id);
	}
	return background_import_job_type_id__once;
}

FileToPrepare*
file_to_prepare_construct (GType object_type,
                           BatchImportJob* job,
                           GFile* file,
                           gboolean copy_to_library)
{
	FileToPrepare* self = NULL;
	BatchImportJob* _tmp0_;
	GFile* _tmp1_;
#line 1431 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_BATCH_IMPORT_JOB (job), NULL);
#line 1431 "../src/BatchImport.vala"
	g_return_val_if_fail ((file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 1431 "../src/BatchImport.vala"
	self = (FileToPrepare*) g_type_create_instance (object_type);
#line 1432 "../src/BatchImport.vala"
	_tmp0_ = _batch_import_job_ref0 (job);
#line 1432 "../src/BatchImport.vala"
	_batch_import_job_unref0 (self->job);
#line 1432 "../src/BatchImport.vala"
	self->job = _tmp0_;
#line 1433 "../src/BatchImport.vala"
	_tmp1_ = _g_object_ref0 (file);
#line 1433 "../src/BatchImport.vala"
	_g_object_unref0 (self->file);
#line 1433 "../src/BatchImport.vala"
	self->file = _tmp1_;
#line 1434 "../src/BatchImport.vala"
	self->copy_to_library = copy_to_library;
#line 1431 "../src/BatchImport.vala"
	return self;
#line 11117 "BatchImport.c"
}

FileToPrepare*
file_to_prepare_new (BatchImportJob* job,
                     GFile* file,
                     gboolean copy_to_library)
{
#line 1431 "../src/BatchImport.vala"
	return file_to_prepare_construct (TYPE_FILE_TO_PREPARE, job, file, copy_to_library);
#line 11127 "BatchImport.c"
}

static gpointer
_file_to_prepare_ref0 (gpointer self)
{
#line 1438 "../src/BatchImport.vala"
	return self ? file_to_prepare_ref (self) : NULL;
#line 11135 "BatchImport.c"
}

void
file_to_prepare_set_associated (FileToPrepare* self,
                                FileToPrepare* a)
{
	FileToPrepare* _tmp0_;
#line 1437 "../src/BatchImport.vala"
	g_return_if_fail (IS_FILE_TO_PREPARE (self));
#line 1437 "../src/BatchImport.vala"
	g_return_if_fail ((a == NULL) || IS_FILE_TO_PREPARE (a));
#line 1438 "../src/BatchImport.vala"
	_tmp0_ = _file_to_prepare_ref0 (a);
#line 1438 "../src/BatchImport.vala"
	_file_to_prepare_unref0 (self->associated);
#line 1438 "../src/BatchImport.vala"
	self->associated = _tmp0_;
#line 11153 "BatchImport.c"
}

gchar*
file_to_prepare_get_parent_path (FileToPrepare* self)
{
	gchar* _tmp0_ = NULL;
	GFile* _tmp1_;
	gchar* result;
#line 1441 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_FILE_TO_PREPARE (self), NULL);
#line 1442 "../src/BatchImport.vala"
	_tmp1_ = self->file;
#line 1442 "../src/BatchImport.vala"
	if (_tmp1_ != NULL) {
#line 11168 "BatchImport.c"
		GFile* _tmp2_;
		GFile* _tmp3_;
		GFile* _tmp4_;
		gchar* _tmp5_;
#line 1442 "../src/BatchImport.vala"
		_tmp2_ = self->file;
#line 1442 "../src/BatchImport.vala"
		_tmp3_ = g_file_get_parent (_tmp2_);
#line 1442 "../src/BatchImport.vala"
		_tmp4_ = _tmp3_;
#line 1442 "../src/BatchImport.vala"
		_tmp5_ = g_file_get_path (_tmp4_);
#line 1442 "../src/BatchImport.vala"
		_g_free0 (_tmp0_);
#line 1442 "../src/BatchImport.vala"
		_tmp0_ = _tmp5_;
#line 1442 "../src/BatchImport.vala"
		_g_object_unref0 (_tmp4_);
#line 11187 "BatchImport.c"
	} else {
		BatchImportJob* _tmp6_;
		gchar* _tmp7_;
#line 1442 "../src/BatchImport.vala"
		_tmp6_ = self->job;
#line 1442 "../src/BatchImport.vala"
		_tmp7_ = batch_import_job_get_path (_tmp6_);
#line 1442 "../src/BatchImport.vala"
		_g_free0 (_tmp0_);
#line 1442 "../src/BatchImport.vala"
		_tmp0_ = _tmp7_;
#line 11199 "BatchImport.c"
	}
#line 1442 "../src/BatchImport.vala"
	result = _tmp0_;
#line 1442 "../src/BatchImport.vala"
	return result;
#line 11205 "BatchImport.c"
}

gchar*
file_to_prepare_get_path (FileToPrepare* self)
{
	gchar* _tmp0_ = NULL;
	GFile* _tmp1_;
	gchar* result;
#line 1445 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_FILE_TO_PREPARE (self), NULL);
#line 1446 "../src/BatchImport.vala"
	_tmp1_ = self->file;
#line 1446 "../src/BatchImport.vala"
	if (_tmp1_ != NULL) {
#line 11220 "BatchImport.c"
		GFile* _tmp2_;
		gchar* _tmp3_;
#line 1446 "../src/BatchImport.vala"
		_tmp2_ = self->file;
#line 1446 "../src/BatchImport.vala"
		_tmp3_ = g_file_get_path (_tmp2_);
#line 1446 "../src/BatchImport.vala"
		_g_free0 (_tmp0_);
#line 1446 "../src/BatchImport.vala"
		_tmp0_ = _tmp3_;
#line 11231 "BatchImport.c"
	} else {
		BatchImportJob* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		GFile* _tmp7_;
		GFile* _tmp8_;
		BatchImportJob* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		GFile* _tmp12_;
		GFile* _tmp13_;
		gchar* _tmp14_;
#line 1446 "../src/BatchImport.vala"
		_tmp4_ = self->job;
#line 1446 "../src/BatchImport.vala"
		_tmp5_ = batch_import_job_get_path (_tmp4_);
#line 1446 "../src/BatchImport.vala"
		_tmp6_ = _tmp5_;
#line 1446 "../src/BatchImport.vala"
		_tmp7_ = g_file_new_for_path (_tmp6_);
#line 1446 "../src/BatchImport.vala"
		_tmp8_ = _tmp7_;
#line 1446 "../src/BatchImport.vala"
		_tmp9_ = self->job;
#line 1446 "../src/BatchImport.vala"
		_tmp10_ = batch_import_job_get_basename (_tmp9_);
#line 1446 "../src/BatchImport.vala"
		_tmp11_ = _tmp10_;
#line 1446 "../src/BatchImport.vala"
		_tmp12_ = g_file_get_child (_tmp8_, _tmp11_);
#line 1446 "../src/BatchImport.vala"
		_tmp13_ = _tmp12_;
#line 1446 "../src/BatchImport.vala"
		_tmp14_ = g_file_get_path (_tmp13_);
#line 1446 "../src/BatchImport.vala"
		_g_free0 (_tmp0_);
#line 1446 "../src/BatchImport.vala"
		_tmp0_ = _tmp14_;
#line 1446 "../src/BatchImport.vala"
		_g_object_unref0 (_tmp13_);
#line 1446 "../src/BatchImport.vala"
		_g_free0 (_tmp11_);
#line 1446 "../src/BatchImport.vala"
		_g_object_unref0 (_tmp8_);
#line 1446 "../src/BatchImport.vala"
		_g_free0 (_tmp6_);
#line 11278 "BatchImport.c"
	}
#line 1446 "../src/BatchImport.vala"
	result = _tmp0_;
#line 1446 "../src/BatchImport.vala"
	return result;
#line 11284 "BatchImport.c"
}

gchar*
file_to_prepare_get_basename (FileToPrepare* self)
{
	gchar* _tmp0_ = NULL;
	GFile* _tmp1_;
	gchar* result;
#line 1450 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_FILE_TO_PREPARE (self), NULL);
#line 1451 "../src/BatchImport.vala"
	_tmp1_ = self->file;
#line 1451 "../src/BatchImport.vala"
	if (_tmp1_ != NULL) {
#line 11299 "BatchImport.c"
		GFile* _tmp2_;
		gchar* _tmp3_;
#line 1451 "../src/BatchImport.vala"
		_tmp2_ = self->file;
#line 1451 "../src/BatchImport.vala"
		_tmp3_ = g_file_get_basename (_tmp2_);
#line 1451 "../src/BatchImport.vala"
		_g_free0 (_tmp0_);
#line 1451 "../src/BatchImport.vala"
		_tmp0_ = _tmp3_;
#line 11310 "BatchImport.c"
	} else {
		BatchImportJob* _tmp4_;
		gchar* _tmp5_;
#line 1451 "../src/BatchImport.vala"
		_tmp4_ = self->job;
#line 1451 "../src/BatchImport.vala"
		_tmp5_ = batch_import_job_get_basename (_tmp4_);
#line 1451 "../src/BatchImport.vala"
		_g_free0 (_tmp0_);
#line 1451 "../src/BatchImport.vala"
		_tmp0_ = _tmp5_;
#line 11322 "BatchImport.c"
	}
#line 1451 "../src/BatchImport.vala"
	result = _tmp0_;
#line 1451 "../src/BatchImport.vala"
	return result;
#line 11328 "BatchImport.c"
}

gboolean
file_to_prepare_is_directory (FileToPrepare* self)
{
	gboolean _tmp0_ = FALSE;
	GFile* _tmp1_;
	gboolean result;
#line 1454 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_FILE_TO_PREPARE (self), FALSE);
#line 1455 "../src/BatchImport.vala"
	_tmp1_ = self->file;
#line 1455 "../src/BatchImport.vala"
	if (_tmp1_ != NULL) {
#line 11343 "BatchImport.c"
		GFile* _tmp2_;
#line 1455 "../src/BatchImport.vala"
		_tmp2_ = self->file;
#line 1455 "../src/BatchImport.vala"
		_tmp0_ = g_file_query_file_type (_tmp2_, G_FILE_QUERY_INFO_NONE, NULL) == G_FILE_TYPE_DIRECTORY;
#line 11349 "BatchImport.c"
	} else {
		BatchImportJob* _tmp3_;
#line 1456 "../src/BatchImport.vala"
		_tmp3_ = self->job;
#line 1456 "../src/BatchImport.vala"
		_tmp0_ = batch_import_job_is_directory (_tmp3_);
#line 11356 "BatchImport.c"
	}
#line 1455 "../src/BatchImport.vala"
	result = _tmp0_;
#line 1455 "../src/BatchImport.vala"
	return result;
#line 11362 "BatchImport.c"
}

static void
value_file_to_prepare_init (GValue* value)
{
#line 1425 "../src/BatchImport.vala"
	value->data[0].v_pointer = NULL;
#line 11370 "BatchImport.c"
}

static void
value_file_to_prepare_free_value (GValue* value)
{
#line 1425 "../src/BatchImport.vala"
	if (value->data[0].v_pointer) {
#line 1425 "../src/BatchImport.vala"
		file_to_prepare_unref (value->data[0].v_pointer);
#line 11380 "BatchImport.c"
	}
}

static void
value_file_to_prepare_copy_value (const GValue* src_value,
                                  GValue* dest_value)
{
#line 1425 "../src/BatchImport.vala"
	if (src_value->data[0].v_pointer) {
#line 1425 "../src/BatchImport.vala"
		dest_value->data[0].v_pointer = file_to_prepare_ref (src_value->data[0].v_pointer);
#line 11392 "BatchImport.c"
	} else {
#line 1425 "../src/BatchImport.vala"
		dest_value->data[0].v_pointer = NULL;
#line 11396 "BatchImport.c"
	}
}

static gpointer
value_file_to_prepare_peek_pointer (const GValue* value)
{
#line 1425 "../src/BatchImport.vala"
	return value->data[0].v_pointer;
#line 11405 "BatchImport.c"
}

static gchar*
value_file_to_prepare_collect_value (GValue* value,
                                     guint n_collect_values,
                                     GTypeCValue* collect_values,
                                     guint collect_flags)
{
#line 1425 "../src/BatchImport.vala"
	if (collect_values[0].v_pointer) {
#line 11416 "BatchImport.c"
		FileToPrepare * object;
		object = collect_values[0].v_pointer;
#line 1425 "../src/BatchImport.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1425 "../src/BatchImport.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 11423 "BatchImport.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1425 "../src/BatchImport.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 11427 "BatchImport.c"
		}
#line 1425 "../src/BatchImport.vala"
		value->data[0].v_pointer = file_to_prepare_ref (object);
#line 11431 "BatchImport.c"
	} else {
#line 1425 "../src/BatchImport.vala"
		value->data[0].v_pointer = NULL;
#line 11435 "BatchImport.c"
	}
#line 1425 "../src/BatchImport.vala"
	return NULL;
#line 11439 "BatchImport.c"
}

static gchar*
value_file_to_prepare_lcopy_value (const GValue* value,
                                   guint n_collect_values,
                                   GTypeCValue* collect_values,
                                   guint collect_flags)
{
	FileToPrepare ** object_p;
	object_p = collect_values[0].v_pointer;
#line 1425 "../src/BatchImport.vala"
	if (!object_p) {
#line 1425 "../src/BatchImport.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 11454 "BatchImport.c"
	}
#line 1425 "../src/BatchImport.vala"
	if (!value->data[0].v_pointer) {
#line 1425 "../src/BatchImport.vala"
		*object_p = NULL;
#line 11460 "BatchImport.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1425 "../src/BatchImport.vala"
		*object_p = value->data[0].v_pointer;
#line 11464 "BatchImport.c"
	} else {
#line 1425 "../src/BatchImport.vala"
		*object_p = file_to_prepare_ref (value->data[0].v_pointer);
#line 11468 "BatchImport.c"
	}
#line 1425 "../src/BatchImport.vala"
	return NULL;
#line 11472 "BatchImport.c"
}

GParamSpec*
param_spec_file_to_prepare (const gchar* name,
                            const gchar* nick,
                            const gchar* blurb,
                            GType object_type,
                            GParamFlags flags)
{
	ParamSpecFileToPrepare* spec;
#line 1425 "../src/BatchImport.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_FILE_TO_PREPARE), NULL);
#line 1425 "../src/BatchImport.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1425 "../src/BatchImport.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1425 "../src/BatchImport.vala"
	return G_PARAM_SPEC (spec);
#line 11491 "BatchImport.c"
}

gpointer
value_get_file_to_prepare (const GValue* value)
{
#line 1425 "../src/BatchImport.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_FILE_TO_PREPARE), NULL);
#line 1425 "../src/BatchImport.vala"
	return value->data[0].v_pointer;
#line 11501 "BatchImport.c"
}

void
value_set_file_to_prepare (GValue* value,
                           gpointer v_object)
{
	FileToPrepare * old;
#line 1425 "../src/BatchImport.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_FILE_TO_PREPARE));
#line 1425 "../src/BatchImport.vala"
	old = value->data[0].v_pointer;
#line 1425 "../src/BatchImport.vala"
	if (v_object) {
#line 1425 "../src/BatchImport.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_FILE_TO_PREPARE));
#line 1425 "../src/BatchImport.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1425 "../src/BatchImport.vala"
		value->data[0].v_pointer = v_object;
#line 1425 "../src/BatchImport.vala"
		file_to_prepare_ref (value->data[0].v_pointer);
#line 11523 "BatchImport.c"
	} else {
#line 1425 "../src/BatchImport.vala"
		value->data[0].v_pointer = NULL;
#line 11527 "BatchImport.c"
	}
#line 1425 "../src/BatchImport.vala"
	if (old) {
#line 1425 "../src/BatchImport.vala"
		file_to_prepare_unref (old);
#line 11533 "BatchImport.c"
	}
}

void
value_take_file_to_prepare (GValue* value,
                            gpointer v_object)
{
	FileToPrepare * old;
#line 1425 "../src/BatchImport.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_FILE_TO_PREPARE));
#line 1425 "../src/BatchImport.vala"
	old = value->data[0].v_pointer;
#line 1425 "../src/BatchImport.vala"
	if (v_object) {
#line 1425 "../src/BatchImport.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_FILE_TO_PREPARE));
#line 1425 "../src/BatchImport.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1425 "../src/BatchImport.vala"
		value->data[0].v_pointer = v_object;
#line 11554 "BatchImport.c"
	} else {
#line 1425 "../src/BatchImport.vala"
		value->data[0].v_pointer = NULL;
#line 11558 "BatchImport.c"
	}
#line 1425 "../src/BatchImport.vala"
	if (old) {
#line 1425 "../src/BatchImport.vala"
		file_to_prepare_unref (old);
#line 11564 "BatchImport.c"
	}
}

static void
file_to_prepare_class_init (FileToPrepareClass * klass,
                            gpointer klass_data)
{
#line 1425 "../src/BatchImport.vala"
	file_to_prepare_parent_class = g_type_class_peek_parent (klass);
#line 1425 "../src/BatchImport.vala"
	((FileToPrepareClass *) klass)->finalize = file_to_prepare_finalize;
#line 11576 "BatchImport.c"
}

static void
file_to_prepare_instance_init (FileToPrepare * self,
                               gpointer klass)
{
#line 1429 "../src/BatchImport.vala"
	self->associated = NULL;
#line 1425 "../src/BatchImport.vala"
	self->ref_count = 1;
#line 11587 "BatchImport.c"
}

static void
file_to_prepare_finalize (FileToPrepare * obj)
{
	FileToPrepare * self;
#line 1425 "../src/BatchImport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_FILE_TO_PREPARE, FileToPrepare);
#line 1425 "../src/BatchImport.vala"
	g_signal_handlers_destroy (self);
#line 1426 "../src/BatchImport.vala"
	_batch_import_job_unref0 (self->job);
#line 1427 "../src/BatchImport.vala"
	_g_object_unref0 (self->file);
#line 1429 "../src/BatchImport.vala"
	_file_to_prepare_unref0 (self->associated);
#line 11604 "BatchImport.c"
}

static GType
file_to_prepare_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_file_to_prepare_init, value_file_to_prepare_free_value, value_file_to_prepare_copy_value, value_file_to_prepare_peek_pointer, "p", value_file_to_prepare_collect_value, "p", value_file_to_prepare_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (FileToPrepareClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) file_to_prepare_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FileToPrepare), 0, (GInstanceInitFunc) file_to_prepare_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType file_to_prepare_type_id;
	file_to_prepare_type_id = g_type_register_fundamental (g_type_fundamental_next (), "FileToPrepare", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return file_to_prepare_type_id;
}

GType
file_to_prepare_get_type (void)
{
	static volatile gsize file_to_prepare_type_id__once = 0;
	if (g_once_init_enter (&file_to_prepare_type_id__once)) {
		GType file_to_prepare_type_id;
		file_to_prepare_type_id = file_to_prepare_get_type_once ();
		g_once_init_leave (&file_to_prepare_type_id__once, file_to_prepare_type_id);
	}
	return file_to_prepare_type_id__once;
}

gpointer
file_to_prepare_ref (gpointer instance)
{
	FileToPrepare * self;
	self = instance;
#line 1425 "../src/BatchImport.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1425 "../src/BatchImport.vala"
	return instance;
#line 11639 "BatchImport.c"
}

void
file_to_prepare_unref (gpointer instance)
{
	FileToPrepare * self;
	self = instance;
#line 1425 "../src/BatchImport.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1425 "../src/BatchImport.vala"
		FILE_TO_PREPARE_GET_CLASS (self)->finalize (self);
#line 1425 "../src/BatchImport.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 11653 "BatchImport.c"
	}
}

static inline gpointer
work_sniffer_get_instance_private (WorkSniffer* self)
{
	return G_STRUCT_MEMBER_P (self, WorkSniffer_private_offset);
}

WorkSniffer*
work_sniffer_construct (GType object_type,
                        BatchImport* owner,
                        GeeIterable* jobs,
                        CompletionCallback callback,
                        gpointer callback_target,
                        GCancellable* cancellable,
                        CancellationCallback cancellation,
                        gpointer cancellation_target,
                        GeeHashSet* skipset)
{
	WorkSniffer* self = NULL;
	GeeIterable* _tmp0_;
	GeeHashSet* _tmp1_;
#line 1467 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_BATCH_IMPORT (owner), NULL);
#line 1467 "../src/BatchImport.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (jobs, GEE_TYPE_ITERABLE), NULL);
#line 1467 "../src/BatchImport.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()), NULL);
#line 1467 "../src/BatchImport.vala"
	g_return_val_if_fail ((skipset == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (skipset, GEE_TYPE_HASH_SET), NULL);
#line 1469 "../src/BatchImport.vala"
	self = (WorkSniffer*) background_import_job_construct (object_type, owner, callback, callback_target, cancellable, cancellation, cancellation_target);
#line 1471 "../src/BatchImport.vala"
	_tmp0_ = _g_object_ref0 (jobs);
#line 1471 "../src/BatchImport.vala"
	_g_object_unref0 (self->priv->jobs);
#line 1471 "../src/BatchImport.vala"
	self->priv->jobs = _tmp0_;
#line 1472 "../src/BatchImport.vala"
	_tmp1_ = _g_object_ref0 (skipset);
#line 1472 "../src/BatchImport.vala"
	_g_object_unref0 (self->priv->skipset);
#line 1472 "../src/BatchImport.vala"
	self->priv->skipset = _tmp1_;
#line 1467 "../src/BatchImport.vala"
	return self;
#line 11701 "BatchImport.c"
}

WorkSniffer*
work_sniffer_new (BatchImport* owner,
                  GeeIterable* jobs,
                  CompletionCallback callback,
                  gpointer callback_target,
                  GCancellable* cancellable,
                  CancellationCallback cancellation,
                  gpointer cancellation_target,
                  GeeHashSet* skipset)
{
#line 1467 "../src/BatchImport.vala"
	return work_sniffer_construct (TYPE_WORK_SNIFFER, owner, jobs, callback, callback_target, cancellable, cancellation, cancellation_target, skipset);
#line 11716 "BatchImport.c"
}

static gint
__lambda12_ (WorkSniffer* self,
             FileToPrepare* a,
             FileToPrepare* b)
{
	FileToPrepare* file_a = NULL;
	FileToPrepare* _tmp0_;
	FileToPrepare* file_b = NULL;
	FileToPrepare* _tmp1_;
	gchar* sa = NULL;
	FileToPrepare* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* sb = NULL;
	FileToPrepare* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	gint result;
#line 1507 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_FILE_TO_PREPARE (a), 0);
#line 1507 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_FILE_TO_PREPARE (b), 0);
#line 1508 "../src/BatchImport.vala"
	_tmp0_ = _file_to_prepare_ref0 (G_TYPE_CHECK_INSTANCE_CAST (a, TYPE_FILE_TO_PREPARE, FileToPrepare));
#line 1508 "../src/BatchImport.vala"
	file_a = _tmp0_;
#line 1509 "../src/BatchImport.vala"
	_tmp1_ = _file_to_prepare_ref0 (G_TYPE_CHECK_INSTANCE_CAST (b, TYPE_FILE_TO_PREPARE, FileToPrepare));
#line 1509 "../src/BatchImport.vala"
	file_b = _tmp1_;
#line 1510 "../src/BatchImport.vala"
	_tmp2_ = file_a;
#line 1510 "../src/BatchImport.vala"
	_tmp3_ = file_to_prepare_get_path (_tmp2_);
#line 1510 "../src/BatchImport.vala"
	sa = _tmp3_;
#line 1511 "../src/BatchImport.vala"
	_tmp4_ = sa;
#line 1511 "../src/BatchImport.vala"
	if (!g_utf8_validate (_tmp4_, (gssize) -1, NULL)) {
#line 11761 "BatchImport.c"
		const gchar* _tmp5_;
		gchar* _tmp6_;
#line 1512 "../src/BatchImport.vala"
		_tmp5_ = sa;
#line 1512 "../src/BatchImport.vala"
		_tmp6_ = g_uri_escape_string (_tmp5_, G_URI_RESERVED_CHARS_ALLOWED_IN_PATH, TRUE);
#line 1512 "../src/BatchImport.vala"
		_g_free0 (sa);
#line 1512 "../src/BatchImport.vala"
		sa = _tmp6_;
#line 11772 "BatchImport.c"
	}
#line 1514 "../src/BatchImport.vala"
	_tmp7_ = file_b;
#line 1514 "../src/BatchImport.vala"
	_tmp8_ = file_to_prepare_get_path (_tmp7_);
#line 1514 "../src/BatchImport.vala"
	sb = _tmp8_;
#line 1515 "../src/BatchImport.vala"
	_tmp9_ = sb;
#line 1515 "../src/BatchImport.vala"
	if (!g_utf8_validate (_tmp9_, (gssize) -1, NULL)) {
#line 11784 "BatchImport.c"
		const gchar* _tmp10_;
		gchar* _tmp11_;
#line 1516 "../src/BatchImport.vala"
		_tmp10_ = sa;
#line 1516 "../src/BatchImport.vala"
		_tmp11_ = g_uri_escape_string (_tmp10_, G_URI_RESERVED_CHARS_ALLOWED_IN_PATH, TRUE);
#line 1516 "../src/BatchImport.vala"
		_g_free0 (sb);
#line 1516 "../src/BatchImport.vala"
		sb = _tmp11_;
#line 11795 "BatchImport.c"
	}
#line 1518 "../src/BatchImport.vala"
	_tmp12_ = sa;
#line 1518 "../src/BatchImport.vala"
	_tmp13_ = sb;
#line 1518 "../src/BatchImport.vala"
	result = utf8_cs_compare (_tmp12_, _tmp13_);
#line 1518 "../src/BatchImport.vala"
	_g_free0 (sb);
#line 1518 "../src/BatchImport.vala"
	_g_free0 (sa);
#line 1518 "../src/BatchImport.vala"
	_file_to_prepare_unref0 (file_b);
#line 1518 "../src/BatchImport.vala"
	_file_to_prepare_unref0 (file_a);
#line 1518 "../src/BatchImport.vala"
	return result;
#line 11813 "BatchImport.c"
}

static gint
___lambda12__gcompare_data_func (gconstpointer a,
                                 gconstpointer b,
                                 gpointer self)
{
	gint result;
	result = __lambda12_ ((WorkSniffer*) self, (FileToPrepare*) a, (FileToPrepare*) b);
#line 1507 "../src/BatchImport.vala"
	return result;
#line 11825 "BatchImport.c"
}

static void
work_sniffer_real_execute (BackgroundJob* base)
{
	WorkSniffer * self;
	GeeList* sorted = NULL;
	GeeArrayList* _tmp21_;
	GeeList* _tmp33_;
	GError* _inner_error0_ = NULL;
#line 1475 "../src/BatchImport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_WORK_SNIFFER, WorkSniffer);
#line 11838 "BatchImport.c"
	{
		GeeIterator* _job_it = NULL;
		GeeIterable* _tmp0_;
		GeeIterator* _tmp1_;
#line 1479 "../src/BatchImport.vala"
		_tmp0_ = self->priv->jobs;
#line 1479 "../src/BatchImport.vala"
		_tmp1_ = gee_iterable_iterator (_tmp0_);
#line 1479 "../src/BatchImport.vala"
		_job_it = _tmp1_;
#line 1479 "../src/BatchImport.vala"
		while (TRUE) {
#line 11851 "BatchImport.c"
			GeeIterator* _tmp2_;
			BatchImportJob* job = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			ImportResult _result_ = 0;
#line 1479 "../src/BatchImport.vala"
			_tmp2_ = _job_it;
#line 1479 "../src/BatchImport.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 1479 "../src/BatchImport.vala"
				break;
#line 11863 "BatchImport.c"
			}
#line 1479 "../src/BatchImport.vala"
			_tmp3_ = _job_it;
#line 1479 "../src/BatchImport.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 1479 "../src/BatchImport.vala"
			job = (BatchImportJob*) _tmp4_;
#line 1480 "../src/BatchImport.vala"
			_result_ = background_import_job_abort_check (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_BACKGROUND_IMPORT_JOB, BackgroundImportJob));
#line 1481 "../src/BatchImport.vala"
			if (_result_ != IMPORT_RESULT_SUCCESS) {
#line 11875 "BatchImport.c"
				BatchImportJob* _tmp5_;
				BatchImportJob* _tmp6_;
				gchar* _tmp7_;
				gchar* _tmp8_;
				BatchImportJob* _tmp9_;
				gchar* _tmp10_;
				gchar* _tmp11_;
#line 1482 "../src/BatchImport.vala"
				_tmp5_ = job;
#line 1482 "../src/BatchImport.vala"
				_tmp6_ = job;
#line 1482 "../src/BatchImport.vala"
				_tmp7_ = batch_import_job_get_source_identifier (_tmp6_);
#line 1482 "../src/BatchImport.vala"
				_tmp8_ = _tmp7_;
#line 1482 "../src/BatchImport.vala"
				_tmp9_ = job;
#line 1482 "../src/BatchImport.vala"
				_tmp10_ = batch_import_job_get_dest_identifier (_tmp9_);
#line 1482 "../src/BatchImport.vala"
				_tmp11_ = _tmp10_;
#line 1482 "../src/BatchImport.vala"
				background_import_job_report_failure (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_BACKGROUND_IMPORT_JOB, BackgroundImportJob), _tmp5_, NULL, _tmp8_, _tmp11_, _result_);
#line 1482 "../src/BatchImport.vala"
				_g_free0 (_tmp11_);
#line 1482 "../src/BatchImport.vala"
				_g_free0 (_tmp8_);
#line 1485 "../src/BatchImport.vala"
				_batch_import_job_unref0 (job);
#line 1485 "../src/BatchImport.vala"
				continue;
#line 11907 "BatchImport.c"
			}
			{
				BatchImportJob* _tmp12_;
#line 1489 "../src/BatchImport.vala"
				_tmp12_ = job;
#line 1489 "../src/BatchImport.vala"
				work_sniffer_sniff_job (self, _tmp12_, &_inner_error0_);
#line 1489 "../src/BatchImport.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 11917 "BatchImport.c"
					goto __catch0_g_error;
				}
			}
			goto __finally0;
			__catch0_g_error:
			{
				GError* err = NULL;
				BatchImportJob* _tmp13_;
				BatchImportJob* _tmp14_;
				gchar* _tmp15_;
				gchar* _tmp16_;
				BatchImportJob* _tmp17_;
				gchar* _tmp18_;
				gchar* _tmp19_;
				GError* _tmp20_;
#line 1488 "../src/BatchImport.vala"
				err = _inner_error0_;
#line 1488 "../src/BatchImport.vala"
				_inner_error0_ = NULL;
#line 1491 "../src/BatchImport.vala"
				_tmp13_ = job;
#line 1491 "../src/BatchImport.vala"
				_tmp14_ = job;
#line 1491 "../src/BatchImport.vala"
				_tmp15_ = batch_import_job_get_source_identifier (_tmp14_);
#line 1491 "../src/BatchImport.vala"
				_tmp16_ = _tmp15_;
#line 1491 "../src/BatchImport.vala"
				_tmp17_ = job;
#line 1491 "../src/BatchImport.vala"
				_tmp18_ = batch_import_job_get_dest_identifier (_tmp17_);
#line 1491 "../src/BatchImport.vala"
				_tmp19_ = _tmp18_;
#line 1491 "../src/BatchImport.vala"
				_tmp20_ = err;
#line 1491 "../src/BatchImport.vala"
				background_import_job_report_error (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_BACKGROUND_IMPORT_JOB, BackgroundImportJob), _tmp13_, NULL, _tmp16_, _tmp19_, _tmp20_, IMPORT_RESULT_FILE_ERROR);
#line 1491 "../src/BatchImport.vala"
				_g_free0 (_tmp19_);
#line 1491 "../src/BatchImport.vala"
				_g_free0 (_tmp16_);
#line 1488 "../src/BatchImport.vala"
				_g_error_free0 (err);
#line 11961 "BatchImport.c"
			}
			__finally0:
#line 1488 "../src/BatchImport.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1488 "../src/BatchImport.vala"
				_batch_import_job_unref0 (job);
#line 1488 "../src/BatchImport.vala"
				_g_object_unref0 (_job_it);
#line 1488 "../src/BatchImport.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1488 "../src/BatchImport.vala"
				g_clear_error (&_inner_error0_);
#line 1488 "../src/BatchImport.vala"
				return;
#line 11976 "BatchImport.c"
			}
#line 1495 "../src/BatchImport.vala"
			if (background_job_is_cancelled (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_BACKGROUND_JOB, BackgroundJob))) {
#line 1496 "../src/BatchImport.vala"
				_batch_import_job_unref0 (job);
#line 1496 "../src/BatchImport.vala"
				break;
#line 11984 "BatchImport.c"
			}
#line 1479 "../src/BatchImport.vala"
			_batch_import_job_unref0 (job);
#line 11988 "BatchImport.c"
		}
#line 1479 "../src/BatchImport.vala"
		_g_object_unref0 (_job_it);
#line 11992 "BatchImport.c"
	}
#line 1502 "../src/BatchImport.vala"
	_tmp21_ = gee_array_list_new (TYPE_FILE_TO_PREPARE, (GBoxedCopyFunc) file_to_prepare_ref, (GDestroyNotify) file_to_prepare_unref, NULL, NULL, NULL);
#line 1502 "../src/BatchImport.vala"
	sorted = G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, GEE_TYPE_LIST, GeeList);
#line 11998 "BatchImport.c"
	{
		GeeList* _ftp_list = NULL;
		GeeList* _tmp22_;
		gint _ftp_size = 0;
		GeeList* _tmp23_;
		gint _tmp24_;
		gint _tmp25_;
		gint _ftp_index = 0;
#line 1503 "../src/BatchImport.vala"
		_tmp22_ = self->files_to_prepare;
#line 1503 "../src/BatchImport.vala"
		_ftp_list = _tmp22_;
#line 1503 "../src/BatchImport.vala"
		_tmp23_ = _ftp_list;
#line 1503 "../src/BatchImport.vala"
		_tmp24_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1503 "../src/BatchImport.vala"
		_tmp25_ = _tmp24_;
#line 1503 "../src/BatchImport.vala"
		_ftp_size = _tmp25_;
#line 1503 "../src/BatchImport.vala"
		_ftp_index = -1;
#line 1503 "../src/BatchImport.vala"
		while (TRUE) {
#line 12023 "BatchImport.c"
			gint _tmp26_;
			gint _tmp27_;
			FileToPrepare* ftp = NULL;
			GeeList* _tmp28_;
			gpointer _tmp29_;
			FileToPrepare* _tmp30_;
#line 1503 "../src/BatchImport.vala"
			_ftp_index = _ftp_index + 1;
#line 1503 "../src/BatchImport.vala"
			_tmp26_ = _ftp_index;
#line 1503 "../src/BatchImport.vala"
			_tmp27_ = _ftp_size;
#line 1503 "../src/BatchImport.vala"
			if (!(_tmp26_ < _tmp27_)) {
#line 1503 "../src/BatchImport.vala"
				break;
#line 12040 "BatchImport.c"
			}
#line 1503 "../src/BatchImport.vala"
			_tmp28_ = _ftp_list;
#line 1503 "../src/BatchImport.vala"
			_tmp29_ = gee_list_get (_tmp28_, _ftp_index);
#line 1503 "../src/BatchImport.vala"
			ftp = (FileToPrepare*) _tmp29_;
#line 1504 "../src/BatchImport.vala"
			_tmp30_ = ftp;
#line 1504 "../src/BatchImport.vala"
			if (!file_to_prepare_is_directory (_tmp30_)) {
#line 12052 "BatchImport.c"
				GeeList* _tmp31_;
				FileToPrepare* _tmp32_;
#line 1505 "../src/BatchImport.vala"
				_tmp31_ = sorted;
#line 1505 "../src/BatchImport.vala"
				_tmp32_ = ftp;
#line 1505 "../src/BatchImport.vala"
				gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, GEE_TYPE_COLLECTION, GeeCollection), _tmp32_);
#line 12061 "BatchImport.c"
			}
#line 1503 "../src/BatchImport.vala"
			_file_to_prepare_unref0 (ftp);
#line 12065 "BatchImport.c"
		}
	}
#line 1507 "../src/BatchImport.vala"
	_tmp33_ = sorted;
#line 1507 "../src/BatchImport.vala"
	gee_list_sort (_tmp33_, ___lambda12__gcompare_data_func, background_job_ref (self), background_job_unref);
#line 12072 "BatchImport.c"
	{
		gint i = 0;
#line 1523 "../src/BatchImport.vala"
		i = 0;
#line 12077 "BatchImport.c"
		{
			gboolean _tmp34_ = FALSE;
#line 1523 "../src/BatchImport.vala"
			_tmp34_ = TRUE;
#line 1523 "../src/BatchImport.vala"
			while (TRUE) {
#line 12084 "BatchImport.c"
				GeeList* _tmp36_;
				gint _tmp37_;
				gint _tmp38_;
				gchar* name = NULL;
				gchar* ext = NULL;
				FileToPrepare* ftp = NULL;
				GeeList* _tmp39_;
				gpointer _tmp40_;
				FileToPrepare* _tmp41_;
				gchar* _tmp42_;
				gchar* _tmp43_;
				gchar* _tmp44_ = NULL;
				gchar* _tmp45_ = NULL;
				const gchar* _tmp46_;
				RawFileFormatProperties* _tmp47_;
				RawFileFormatProperties* _tmp48_;
				const gchar* _tmp49_;
				gboolean _tmp50_;
#line 1523 "../src/BatchImport.vala"
				if (!_tmp34_) {
#line 12105 "BatchImport.c"
					gint _tmp35_;
#line 1523 "../src/BatchImport.vala"
					i = i + 1;
#line 1523 "../src/BatchImport.vala"
					_tmp35_ = i;
#line 12111 "BatchImport.c"
				}
#line 1523 "../src/BatchImport.vala"
				_tmp34_ = FALSE;
#line 1523 "../src/BatchImport.vala"
				_tmp36_ = sorted;
#line 1523 "../src/BatchImport.vala"
				_tmp37_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp36_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1523 "../src/BatchImport.vala"
				_tmp38_ = _tmp37_;
#line 1523 "../src/BatchImport.vala"
				if (!(i < _tmp38_)) {
#line 1523 "../src/BatchImport.vala"
					break;
#line 12125 "BatchImport.c"
				}
#line 1525 "../src/BatchImport.vala"
				_tmp39_ = sorted;
#line 1525 "../src/BatchImport.vala"
				_tmp40_ = gee_list_get (_tmp39_, i);
#line 1525 "../src/BatchImport.vala"
				ftp = (FileToPrepare*) _tmp40_;
#line 1526 "../src/BatchImport.vala"
				_tmp41_ = ftp;
#line 1526 "../src/BatchImport.vala"
				_tmp42_ = file_to_prepare_get_basename (_tmp41_);
#line 1526 "../src/BatchImport.vala"
				_tmp43_ = _tmp42_;
#line 1526 "../src/BatchImport.vala"
				disassemble_filename (_tmp43_, &_tmp44_, &_tmp45_);
#line 1526 "../src/BatchImport.vala"
				_g_free0 (name);
#line 1526 "../src/BatchImport.vala"
				name = _tmp44_;
#line 1526 "../src/BatchImport.vala"
				_g_free0 (ext);
#line 1526 "../src/BatchImport.vala"
				ext = _tmp45_;
#line 1526 "../src/BatchImport.vala"
				_g_free0 (_tmp43_);
#line 1528 "../src/BatchImport.vala"
				_tmp46_ = ext;
#line 1528 "../src/BatchImport.vala"
				if (is_string_empty (_tmp46_)) {
#line 1529 "../src/BatchImport.vala"
					_file_to_prepare_unref0 (ftp);
#line 1529 "../src/BatchImport.vala"
					_g_free0 (ext);
#line 1529 "../src/BatchImport.vala"
					_g_free0 (name);
#line 1529 "../src/BatchImport.vala"
					continue;
#line 12163 "BatchImport.c"
				}
#line 1531 "../src/BatchImport.vala"
				_tmp47_ = raw_file_format_properties_get_instance ();
#line 1531 "../src/BatchImport.vala"
				_tmp48_ = _tmp47_;
#line 1531 "../src/BatchImport.vala"
				_tmp49_ = ext;
#line 1531 "../src/BatchImport.vala"
				_tmp50_ = photo_file_format_properties_is_recognized_extension (G_TYPE_CHECK_INSTANCE_CAST (_tmp48_, TYPE_PHOTO_FILE_FORMAT_PROPERTIES, PhotoFileFormatProperties), _tmp49_);
#line 1531 "../src/BatchImport.vala"
				_photo_file_format_properties_unref0 (_tmp48_);
#line 1531 "../src/BatchImport.vala"
				if (_tmp50_) {
#line 12177 "BatchImport.c"
					gboolean _tmp51_ = FALSE;
#line 1534 "../src/BatchImport.vala"
					if (i > 0) {
#line 12181 "BatchImport.c"
						FileToPrepare* _tmp52_;
						GeeList* _tmp53_;
						gpointer _tmp54_;
						FileToPrepare* _tmp55_;
#line 1534 "../src/BatchImport.vala"
						_tmp52_ = ftp;
#line 1534 "../src/BatchImport.vala"
						_tmp53_ = sorted;
#line 1534 "../src/BatchImport.vala"
						_tmp54_ = gee_list_get (_tmp53_, i - 1);
#line 1534 "../src/BatchImport.vala"
						_tmp55_ = (FileToPrepare*) _tmp54_;
#line 1534 "../src/BatchImport.vala"
						_tmp51_ = work_sniffer_is_paired (self, _tmp52_, _tmp55_);
#line 1534 "../src/BatchImport.vala"
						_file_to_prepare_unref0 (_tmp55_);
#line 12198 "BatchImport.c"
					} else {
#line 1534 "../src/BatchImport.vala"
						_tmp51_ = FALSE;
#line 12202 "BatchImport.c"
					}
#line 1534 "../src/BatchImport.vala"
					if (_tmp51_) {
#line 12206 "BatchImport.c"
						FileToPrepare* associated_file = NULL;
						GeeList* _tmp56_;
						gpointer _tmp57_;
						GeeList* _tmp58_;
						FileToPrepare* _tmp59_;
						FileToPrepare* _tmp60_;
						FileToPrepare* _tmp61_;
#line 1535 "../src/BatchImport.vala"
						_tmp56_ = sorted;
#line 1535 "../src/BatchImport.vala"
						_tmp57_ = gee_list_get (_tmp56_, i - 1);
#line 1535 "../src/BatchImport.vala"
						associated_file = (FileToPrepare*) _tmp57_;
#line 1536 "../src/BatchImport.vala"
						_tmp58_ = self->files_to_prepare;
#line 1536 "../src/BatchImport.vala"
						_tmp59_ = associated_file;
#line 1536 "../src/BatchImport.vala"
						gee_collection_remove (G_TYPE_CHECK_INSTANCE_CAST (_tmp58_, GEE_TYPE_COLLECTION, GeeCollection), _tmp59_);
#line 1537 "../src/BatchImport.vala"
						_tmp60_ = ftp;
#line 1537 "../src/BatchImport.vala"
						_tmp61_ = associated_file;
#line 1537 "../src/BatchImport.vala"
						file_to_prepare_set_associated (_tmp60_, _tmp61_);
#line 1534 "../src/BatchImport.vala"
						_file_to_prepare_unref0 (associated_file);
#line 12234 "BatchImport.c"
					} else {
						gboolean _tmp62_ = FALSE;
						GeeList* _tmp63_;
						gint _tmp64_;
						gint _tmp65_;
#line 1538 "../src/BatchImport.vala"
						_tmp63_ = sorted;
#line 1538 "../src/BatchImport.vala"
						_tmp64_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp63_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1538 "../src/BatchImport.vala"
						_tmp65_ = _tmp64_;
#line 1538 "../src/BatchImport.vala"
						if (i < (_tmp65_ - 1)) {
#line 12248 "BatchImport.c"
							FileToPrepare* _tmp66_;
							GeeList* _tmp67_;
							gpointer _tmp68_;
							FileToPrepare* _tmp69_;
#line 1538 "../src/BatchImport.vala"
							_tmp66_ = ftp;
#line 1538 "../src/BatchImport.vala"
							_tmp67_ = sorted;
#line 1538 "../src/BatchImport.vala"
							_tmp68_ = gee_list_get (_tmp67_, i + 1);
#line 1538 "../src/BatchImport.vala"
							_tmp69_ = (FileToPrepare*) _tmp68_;
#line 1538 "../src/BatchImport.vala"
							_tmp62_ = work_sniffer_is_paired (self, _tmp66_, _tmp69_);
#line 1538 "../src/BatchImport.vala"
							_file_to_prepare_unref0 (_tmp69_);
#line 12265 "BatchImport.c"
						} else {
#line 1538 "../src/BatchImport.vala"
							_tmp62_ = FALSE;
#line 12269 "BatchImport.c"
						}
#line 1538 "../src/BatchImport.vala"
						if (_tmp62_) {
#line 12273 "BatchImport.c"
							FileToPrepare* associated_file = NULL;
							GeeList* _tmp70_;
							gpointer _tmp71_;
							GeeList* _tmp72_;
							FileToPrepare* _tmp73_;
							FileToPrepare* _tmp74_;
							FileToPrepare* _tmp75_;
#line 1539 "../src/BatchImport.vala"
							_tmp70_ = sorted;
#line 1539 "../src/BatchImport.vala"
							_tmp71_ = gee_list_get (_tmp70_, i + 1);
#line 1539 "../src/BatchImport.vala"
							associated_file = (FileToPrepare*) _tmp71_;
#line 1540 "../src/BatchImport.vala"
							_tmp72_ = self->files_to_prepare;
#line 1540 "../src/BatchImport.vala"
							_tmp73_ = associated_file;
#line 1540 "../src/BatchImport.vala"
							gee_collection_remove (G_TYPE_CHECK_INSTANCE_CAST (_tmp72_, GEE_TYPE_COLLECTION, GeeCollection), _tmp73_);
#line 1541 "../src/BatchImport.vala"
							_tmp74_ = ftp;
#line 1541 "../src/BatchImport.vala"
							_tmp75_ = associated_file;
#line 1541 "../src/BatchImport.vala"
							file_to_prepare_set_associated (_tmp74_, _tmp75_);
#line 1538 "../src/BatchImport.vala"
							_file_to_prepare_unref0 (associated_file);
#line 12301 "BatchImport.c"
						}
					}
				}
#line 1523 "../src/BatchImport.vala"
				_file_to_prepare_unref0 (ftp);
#line 1523 "../src/BatchImport.vala"
				_g_free0 (ext);
#line 1523 "../src/BatchImport.vala"
				_g_free0 (name);
#line 12311 "BatchImport.c"
			}
		}
	}
#line 1475 "../src/BatchImport.vala"
	_g_object_unref0 (sorted);
#line 12317 "BatchImport.c"
}

static gboolean
work_sniffer_is_paired (WorkSniffer* self,
                        FileToPrepare* raw,
                        FileToPrepare* maybe_paired)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_;
	gchar* name = NULL;
	gchar* ext = NULL;
	gchar* test_name = NULL;
	gchar* test_ext = NULL;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
	JfifFileFormatProperties* _tmp9_;
	JfifFileFormatProperties* _tmp10_;
	const gchar* _tmp11_;
	gboolean _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_ = NULL;
	gchar* _tmp16_ = NULL;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	gboolean result;
#line 1550 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_WORK_SNIFFER (self), FALSE);
#line 1550 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_FILE_TO_PREPARE (raw), FALSE);
#line 1550 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_FILE_TO_PREPARE (maybe_paired), FALSE);
#line 1551 "../src/BatchImport.vala"
	_tmp0_ = file_to_prepare_get_parent_path (raw);
#line 1551 "../src/BatchImport.vala"
	_tmp1_ = _tmp0_;
#line 1551 "../src/BatchImport.vala"
	_tmp2_ = file_to_prepare_get_parent_path (maybe_paired);
#line 1551 "../src/BatchImport.vala"
	_tmp3_ = _tmp2_;
#line 1551 "../src/BatchImport.vala"
	_tmp4_ = g_strcmp0 (_tmp1_, _tmp3_) != 0;
#line 1551 "../src/BatchImport.vala"
	_g_free0 (_tmp3_);
#line 1551 "../src/BatchImport.vala"
	_g_free0 (_tmp1_);
#line 1551 "../src/BatchImport.vala"
	if (_tmp4_) {
#line 1552 "../src/BatchImport.vala"
		result = FALSE;
#line 1552 "../src/BatchImport.vala"
		return result;
#line 12375 "BatchImport.c"
	}
#line 1555 "../src/BatchImport.vala"
	_tmp5_ = file_to_prepare_get_basename (maybe_paired);
#line 1555 "../src/BatchImport.vala"
	_tmp6_ = _tmp5_;
#line 1555 "../src/BatchImport.vala"
	disassemble_filename (_tmp6_, &_tmp7_, &_tmp8_);
#line 1555 "../src/BatchImport.vala"
	_g_free0 (test_name);
#line 1555 "../src/BatchImport.vala"
	test_name = _tmp7_;
#line 1555 "../src/BatchImport.vala"
	_g_free0 (test_ext);
#line 1555 "../src/BatchImport.vala"
	test_ext = _tmp8_;
#line 1555 "../src/BatchImport.vala"
	_g_free0 (_tmp6_);
#line 1557 "../src/BatchImport.vala"
	_tmp9_ = jfif_file_format_properties_get_instance ();
#line 1557 "../src/BatchImport.vala"
	_tmp10_ = _tmp9_;
#line 1557 "../src/BatchImport.vala"
	_tmp11_ = test_ext;
#line 1557 "../src/BatchImport.vala"
	_tmp12_ = !photo_file_format_properties_is_recognized_extension (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, TYPE_PHOTO_FILE_FORMAT_PROPERTIES, PhotoFileFormatProperties), _tmp11_);
#line 1557 "../src/BatchImport.vala"
	_photo_file_format_properties_unref0 (_tmp10_);
#line 1557 "../src/BatchImport.vala"
	if (_tmp12_) {
#line 1558 "../src/BatchImport.vala"
		result = FALSE;
#line 1558 "../src/BatchImport.vala"
		_g_free0 (test_ext);
#line 1558 "../src/BatchImport.vala"
		_g_free0 (test_name);
#line 1558 "../src/BatchImport.vala"
		_g_free0 (ext);
#line 1558 "../src/BatchImport.vala"
		_g_free0 (name);
#line 1558 "../src/BatchImport.vala"
		return result;
#line 12417 "BatchImport.c"
	}
#line 1560 "../src/BatchImport.vala"
	_tmp13_ = file_to_prepare_get_basename (raw);
#line 1560 "../src/BatchImport.vala"
	_tmp14_ = _tmp13_;
#line 1560 "../src/BatchImport.vala"
	disassemble_filename (_tmp14_, &_tmp15_, &_tmp16_);
#line 1560 "../src/BatchImport.vala"
	_g_free0 (name);
#line 1560 "../src/BatchImport.vala"
	name = _tmp15_;
#line 1560 "../src/BatchImport.vala"
	_g_free0 (ext);
#line 1560 "../src/BatchImport.vala"
	ext = _tmp16_;
#line 1560 "../src/BatchImport.vala"
	_g_free0 (_tmp14_);
#line 1562 "../src/BatchImport.vala"
	_tmp17_ = name;
#line 1562 "../src/BatchImport.vala"
	_tmp18_ = test_name;
#line 1562 "../src/BatchImport.vala"
	result = g_strcmp0 (_tmp17_, _tmp18_) == 0;
#line 1562 "../src/BatchImport.vala"
	_g_free0 (test_ext);
#line 1562 "../src/BatchImport.vala"
	_g_free0 (test_name);
#line 1562 "../src/BatchImport.vala"
	_g_free0 (ext);
#line 1562 "../src/BatchImport.vala"
	_g_free0 (name);
#line 1562 "../src/BatchImport.vala"
	return result;
#line 12451 "BatchImport.c"
}

static void
work_sniffer_sniff_job (WorkSniffer* self,
                        BatchImportJob* job,
                        GError** error)
{
	guint64 size = 0ULL;
	GFile* file_or_dir = NULL;
	gboolean determined_size = FALSE;
	guint64 _tmp0_ = 0ULL;
	GFile* _tmp1_ = NULL;
	gboolean _tmp2_;
	GError* _inner_error0_ = NULL;
#line 1565 "../src/BatchImport.vala"
	g_return_if_fail (IS_WORK_SNIFFER (self));
#line 1565 "../src/BatchImport.vala"
	g_return_if_fail (IS_BATCH_IMPORT_JOB (job));
#line 1568 "../src/BatchImport.vala"
	_tmp2_ = batch_import_job_determine_file_size (job, &_tmp0_, &_tmp1_);
#line 1568 "../src/BatchImport.vala"
	size = _tmp0_;
#line 1568 "../src/BatchImport.vala"
	_g_object_unref0 (file_or_dir);
#line 1568 "../src/BatchImport.vala"
	file_or_dir = _tmp1_;
#line 1568 "../src/BatchImport.vala"
	determined_size = _tmp2_;
#line 1569 "../src/BatchImport.vala"
	if (determined_size) {
#line 1570 "../src/BatchImport.vala"
		self->total_bytes = self->total_bytes + size;
#line 12484 "BatchImport.c"
	}
#line 1572 "../src/BatchImport.vala"
	if (batch_import_job_is_directory (job)) {
#line 12488 "BatchImport.c"
		GFile* dir = NULL;
		gboolean copy_to_library = FALSE;
		gboolean _tmp3_ = FALSE;
		GFile* _tmp4_ = NULL;
		gboolean _tmp5_ = FALSE;
		gboolean _tmp6_;
		GFile* _tmp11_;
#line 1577 "../src/BatchImport.vala"
		_tmp6_ = batch_import_job_prepare (job, &_tmp4_, &_tmp5_, &_inner_error0_);
#line 1577 "../src/BatchImport.vala"
		_g_object_unref0 (dir);
#line 1577 "../src/BatchImport.vala"
		dir = _tmp4_;
#line 1577 "../src/BatchImport.vala"
		copy_to_library = _tmp5_;
#line 1577 "../src/BatchImport.vala"
		_tmp3_ = _tmp6_;
#line 1577 "../src/BatchImport.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1577 "../src/BatchImport.vala"
			g_propagate_error (error, _inner_error0_);
#line 1577 "../src/BatchImport.vala"
			_g_object_unref0 (dir);
#line 1577 "../src/BatchImport.vala"
			_g_object_unref0 (file_or_dir);
#line 1577 "../src/BatchImport.vala"
			return;
#line 12516 "BatchImport.c"
		}
#line 1577 "../src/BatchImport.vala"
		if (!_tmp3_) {
#line 12520 "BatchImport.c"
			gchar* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
			gchar* _tmp10_;
#line 1578 "../src/BatchImport.vala"
			_tmp7_ = batch_import_job_get_source_identifier (job);
#line 1578 "../src/BatchImport.vala"
			_tmp8_ = _tmp7_;
#line 1578 "../src/BatchImport.vala"
			_tmp9_ = batch_import_job_get_dest_identifier (job);
#line 1578 "../src/BatchImport.vala"
			_tmp10_ = _tmp9_;
#line 1578 "../src/BatchImport.vala"
			background_import_job_report_failure (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_BACKGROUND_IMPORT_JOB, BackgroundImportJob), job, NULL, _tmp8_, _tmp10_, IMPORT_RESULT_FILE_ERROR);
#line 1578 "../src/BatchImport.vala"
			_g_free0 (_tmp10_);
#line 1578 "../src/BatchImport.vala"
			_g_free0 (_tmp8_);
#line 1581 "../src/BatchImport.vala"
			_g_object_unref0 (dir);
#line 1581 "../src/BatchImport.vala"
			_g_object_unref0 (file_or_dir);
#line 1581 "../src/BatchImport.vala"
			return;
#line 12545 "BatchImport.c"
		}
#line 1583 "../src/BatchImport.vala"
		_tmp11_ = dir;
#line 1583 "../src/BatchImport.vala"
		_vala_assert (query_is_directory (_tmp11_), "query_is_directory(dir)");
#line 12551 "BatchImport.c"
		{
			GFile* _tmp12_;
#line 1586 "../src/BatchImport.vala"
			_tmp12_ = dir;
#line 1586 "../src/BatchImport.vala"
			work_sniffer_search_dir (self, job, _tmp12_, copy_to_library, batch_import_job_recurse (job), &_inner_error0_);
#line 1586 "../src/BatchImport.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 12560 "BatchImport.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* err = NULL;
			GFile* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
			GFile* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
			GError* _tmp19_;
#line 1585 "../src/BatchImport.vala"
			err = _inner_error0_;
#line 1585 "../src/BatchImport.vala"
			_inner_error0_ = NULL;
#line 1588 "../src/BatchImport.vala"
			_tmp13_ = dir;
#line 1588 "../src/BatchImport.vala"
			_tmp14_ = batch_import_job_get_source_identifier (job);
#line 1588 "../src/BatchImport.vala"
			_tmp15_ = _tmp14_;
#line 1588 "../src/BatchImport.vala"
			_tmp16_ = dir;
#line 1588 "../src/BatchImport.vala"
			_tmp17_ = g_file_get_path (_tmp16_);
#line 1588 "../src/BatchImport.vala"
			_tmp18_ = _tmp17_;
#line 1588 "../src/BatchImport.vala"
			_tmp19_ = err;
#line 1588 "../src/BatchImport.vala"
			background_import_job_report_error (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_BACKGROUND_IMPORT_JOB, BackgroundImportJob), job, _tmp13_, _tmp15_, _tmp18_, _tmp19_, IMPORT_RESULT_FILE_ERROR);
#line 1588 "../src/BatchImport.vala"
			_g_free0 (_tmp18_);
#line 1588 "../src/BatchImport.vala"
			_g_free0 (_tmp15_);
#line 1585 "../src/BatchImport.vala"
			_g_error_free0 (err);
#line 12601 "BatchImport.c"
		}
		__finally0:
#line 1585 "../src/BatchImport.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1585 "../src/BatchImport.vala"
			g_propagate_error (error, _inner_error0_);
#line 1585 "../src/BatchImport.vala"
			_g_object_unref0 (dir);
#line 1585 "../src/BatchImport.vala"
			_g_object_unref0 (file_or_dir);
#line 1585 "../src/BatchImport.vala"
			return;
#line 12614 "BatchImport.c"
		}
#line 1572 "../src/BatchImport.vala"
		_g_object_unref0 (dir);
#line 12618 "BatchImport.c"
	} else {
		gboolean _tmp25_ = FALSE;
		gboolean _tmp26_ = FALSE;
		GFile* _tmp27_;
		GeeList* _tmp31_;
		FileToPrepare* _tmp32_;
		FileToPrepare* _tmp33_;
#line 1593 "../src/BatchImport.vala"
		if (!determined_size) {
#line 12628 "BatchImport.c"
			guint64 _tmp20_ = 0ULL;
			GFile* _tmp21_;
			GCancellable* _tmp22_;
			GCancellable* _tmp23_;
			guint64 _tmp24_;
#line 1594 "../src/BatchImport.vala"
			_tmp21_ = file_or_dir;
#line 1594 "../src/BatchImport.vala"
			_tmp22_ = background_job_get_cancellable (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_BACKGROUND_JOB, BackgroundJob));
#line 1594 "../src/BatchImport.vala"
			_tmp23_ = _tmp22_;
#line 1594 "../src/BatchImport.vala"
			_tmp24_ = query_total_file_size (_tmp21_, _tmp23_, &_inner_error0_);
#line 1594 "../src/BatchImport.vala"
			_g_object_unref0 (_tmp23_);
#line 1594 "../src/BatchImport.vala"
			_tmp20_ = _tmp24_;
#line 1594 "../src/BatchImport.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1594 "../src/BatchImport.vala"
				g_propagate_error (error, _inner_error0_);
#line 1594 "../src/BatchImport.vala"
				_g_object_unref0 (file_or_dir);
#line 1594 "../src/BatchImport.vala"
				return;
#line 12654 "BatchImport.c"
			}
#line 1594 "../src/BatchImport.vala"
			self->total_bytes = self->total_bytes + _tmp20_;
#line 12658 "BatchImport.c"
		}
#line 1597 "../src/BatchImport.vala"
		_tmp27_ = file_or_dir;
#line 1597 "../src/BatchImport.vala"
		if (_tmp27_ != NULL) {
#line 12664 "BatchImport.c"
			GeeHashSet* _tmp28_;
#line 1597 "../src/BatchImport.vala"
			_tmp28_ = self->priv->skipset;
#line 1597 "../src/BatchImport.vala"
			_tmp26_ = _tmp28_ != NULL;
#line 12670 "BatchImport.c"
		} else {
#line 1597 "../src/BatchImport.vala"
			_tmp26_ = FALSE;
#line 12674 "BatchImport.c"
		}
#line 1597 "../src/BatchImport.vala"
		if (_tmp26_) {
#line 12678 "BatchImport.c"
			GeeHashSet* _tmp29_;
			GFile* _tmp30_;
#line 1597 "../src/BatchImport.vala"
			_tmp29_ = self->priv->skipset;
#line 1597 "../src/BatchImport.vala"
			_tmp30_ = file_or_dir;
#line 1597 "../src/BatchImport.vala"
			_tmp25_ = gee_abstract_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp30_);
#line 12687 "BatchImport.c"
		} else {
#line 1597 "../src/BatchImport.vala"
			_tmp25_ = FALSE;
#line 12691 "BatchImport.c"
		}
#line 1597 "../src/BatchImport.vala"
		if (_tmp25_) {
#line 1598 "../src/BatchImport.vala"
			_g_object_unref0 (file_or_dir);
#line 1598 "../src/BatchImport.vala"
			return;
#line 12699 "BatchImport.c"
		}
#line 1601 "../src/BatchImport.vala"
		_tmp31_ = self->files_to_prepare;
#line 1601 "../src/BatchImport.vala"
		_tmp32_ = file_to_prepare_new (job, NULL, TRUE);
#line 1601 "../src/BatchImport.vala"
		_tmp33_ = _tmp32_;
#line 1601 "../src/BatchImport.vala"
		gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, GEE_TYPE_COLLECTION, GeeCollection), _tmp33_);
#line 1601 "../src/BatchImport.vala"
		_file_to_prepare_unref0 (_tmp33_);
#line 12711 "BatchImport.c"
	}
#line 1565 "../src/BatchImport.vala"
	_g_object_unref0 (file_or_dir);
#line 12715 "BatchImport.c"
}

void
work_sniffer_search_dir (WorkSniffer* self,
                         BatchImportJob* job,
                         GFile* dir,
                         gboolean copy_to_library,
                         gboolean recurse,
                         GError** error)
{
	GFile* _tmp0_;
	GFile* _tmp1_;
	gboolean _tmp2_;
	GFileEnumerator* enumerator = NULL;
	GFileEnumerator* _tmp5_;
	GFileInfo* info = NULL;
	GError* _inner_error0_ = NULL;
#line 1605 "../src/BatchImport.vala"
	g_return_if_fail (IS_WORK_SNIFFER (self));
#line 1605 "../src/BatchImport.vala"
	g_return_if_fail (IS_BATCH_IMPORT_JOB (job));
#line 1605 "../src/BatchImport.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (dir, g_file_get_type ()));
#line 1606 "../src/BatchImport.vala"
	_tmp0_ = g_file_get_child (dir, ".nomedia");
#line 1606 "../src/BatchImport.vala"
	_tmp1_ = _tmp0_;
#line 1606 "../src/BatchImport.vala"
	_tmp2_ = g_file_query_exists (_tmp1_, NULL);
#line 1606 "../src/BatchImport.vala"
	_g_object_unref0 (_tmp1_);
#line 1606 "../src/BatchImport.vala"
	if (_tmp2_) {
#line 12749 "BatchImport.c"
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 1607 "../src/BatchImport.vala"
		_tmp3_ = g_file_get_path (dir);
#line 1607 "../src/BatchImport.vala"
		_tmp4_ = _tmp3_;
#line 1607 "../src/BatchImport.vala"
		g_debug ("BatchImport.vala:1607: Folder %s contains \".nomedia\" file, ignoring.", _tmp4_);
#line 1607 "../src/BatchImport.vala"
		_g_free0 (_tmp4_);
#line 1608 "../src/BatchImport.vala"
		return;
#line 12762 "BatchImport.c"
	}
#line 1611 "../src/BatchImport.vala"
	_tmp5_ = g_file_enumerate_children (dir, "standard::*", G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 1611 "../src/BatchImport.vala"
	enumerator = _tmp5_;
#line 1611 "../src/BatchImport.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1611 "../src/BatchImport.vala"
		g_propagate_error (error, _inner_error0_);
#line 1611 "../src/BatchImport.vala"
		return;
#line 12774 "BatchImport.c"
	}
#line 1614 "../src/BatchImport.vala"
	info = NULL;
#line 1615 "../src/BatchImport.vala"
	while (TRUE) {
#line 12780 "BatchImport.c"
		GFileInfo* _tmp6_ = NULL;
		GFileEnumerator* _tmp7_;
		GCancellable* _tmp8_;
		GCancellable* _tmp9_;
		GFileInfo* _tmp10_;
		GFileInfo* _tmp11_;
		GFileInfo* _tmp12_;
		GFileInfo* _tmp13_;
		GFile* child = NULL;
		GFileInfo* _tmp14_;
		const gchar* _tmp15_;
		GFile* _tmp16_;
		GFileType file_type = 0;
		GFileInfo* _tmp17_;
#line 1615 "../src/BatchImport.vala"
		_tmp7_ = enumerator;
#line 1615 "../src/BatchImport.vala"
		_tmp8_ = background_job_get_cancellable (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_BACKGROUND_JOB, BackgroundJob));
#line 1615 "../src/BatchImport.vala"
		_tmp9_ = _tmp8_;
#line 1615 "../src/BatchImport.vala"
		_tmp10_ = g_file_enumerator_next_file (_tmp7_, _tmp9_, &_inner_error0_);
#line 1615 "../src/BatchImport.vala"
		_tmp11_ = _tmp10_;
#line 1615 "../src/BatchImport.vala"
		_g_object_unref0 (_tmp9_);
#line 1615 "../src/BatchImport.vala"
		_tmp6_ = _tmp11_;
#line 1615 "../src/BatchImport.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1615 "../src/BatchImport.vala"
			g_propagate_error (error, _inner_error0_);
#line 1615 "../src/BatchImport.vala"
			_g_object_unref0 (info);
#line 1615 "../src/BatchImport.vala"
			_g_object_unref0 (enumerator);
#line 1615 "../src/BatchImport.vala"
			return;
#line 12819 "BatchImport.c"
		}
#line 1615 "../src/BatchImport.vala"
		_tmp12_ = _tmp6_;
#line 1615 "../src/BatchImport.vala"
		_tmp6_ = NULL;
#line 1615 "../src/BatchImport.vala"
		_g_object_unref0 (info);
#line 1615 "../src/BatchImport.vala"
		info = _tmp12_;
#line 1615 "../src/BatchImport.vala"
		_tmp13_ = info;
#line 1615 "../src/BatchImport.vala"
		if (!(_tmp13_ != NULL)) {
#line 1615 "../src/BatchImport.vala"
			_g_object_unref0 (_tmp6_);
#line 1615 "../src/BatchImport.vala"
			break;
#line 12837 "BatchImport.c"
		}
#line 1617 "../src/BatchImport.vala"
		if (background_job_is_cancelled (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_BACKGROUND_JOB, BackgroundJob))) {
#line 1618 "../src/BatchImport.vala"
			_g_object_unref0 (_tmp6_);
#line 1618 "../src/BatchImport.vala"
			break;
#line 12845 "BatchImport.c"
		}
#line 1620 "../src/BatchImport.vala"
		_tmp14_ = info;
#line 1620 "../src/BatchImport.vala"
		_tmp15_ = g_file_info_get_name (_tmp14_);
#line 1620 "../src/BatchImport.vala"
		_tmp16_ = g_file_get_child (dir, _tmp15_);
#line 1620 "../src/BatchImport.vala"
		child = _tmp16_;
#line 1621 "../src/BatchImport.vala"
		_tmp17_ = info;
#line 1621 "../src/BatchImport.vala"
		file_type = g_file_info_get_file_type (_tmp17_);
#line 1623 "../src/BatchImport.vala"
		if (file_type == G_FILE_TYPE_DIRECTORY) {
#line 12861 "BatchImport.c"
			GFileInfo* _tmp18_;
			const gchar* _tmp19_;
#line 1624 "../src/BatchImport.vala"
			if (!recurse) {
#line 1625 "../src/BatchImport.vala"
				_g_object_unref0 (child);
#line 1625 "../src/BatchImport.vala"
				_g_object_unref0 (_tmp6_);
#line 1625 "../src/BatchImport.vala"
				continue;
#line 12872 "BatchImport.c"
			}
#line 1627 "../src/BatchImport.vala"
			_tmp18_ = info;
#line 1627 "../src/BatchImport.vala"
			_tmp19_ = g_file_info_get_name (_tmp18_);
#line 1627 "../src/BatchImport.vala"
			if (g_str_has_prefix (_tmp19_, ".")) {
#line 1628 "../src/BatchImport.vala"
				_g_object_unref0 (child);
#line 1628 "../src/BatchImport.vala"
				_g_object_unref0 (_tmp6_);
#line 1628 "../src/BatchImport.vala"
				continue;
#line 12886 "BatchImport.c"
			}
			{
				GFile* _tmp20_;
#line 1631 "../src/BatchImport.vala"
				_tmp20_ = child;
#line 1631 "../src/BatchImport.vala"
				work_sniffer_search_dir (self, job, _tmp20_, copy_to_library, recurse, &_inner_error0_);
#line 1631 "../src/BatchImport.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 12896 "BatchImport.c"
					goto __catch0_g_error;
				}
			}
			goto __finally0;
			__catch0_g_error:
			{
				GError* err = NULL;
				GFile* _tmp21_;
				GFile* _tmp22_;
				gchar* _tmp23_;
				gchar* _tmp24_;
				GFile* _tmp25_;
				gchar* _tmp26_;
				gchar* _tmp27_;
				GError* _tmp28_;
#line 1630 "../src/BatchImport.vala"
				err = _inner_error0_;
#line 1630 "../src/BatchImport.vala"
				_inner_error0_ = NULL;
#line 1633 "../src/BatchImport.vala"
				_tmp21_ = child;
#line 1633 "../src/BatchImport.vala"
				_tmp22_ = child;
#line 1633 "../src/BatchImport.vala"
				_tmp23_ = g_file_get_path (_tmp22_);
#line 1633 "../src/BatchImport.vala"
				_tmp24_ = _tmp23_;
#line 1633 "../src/BatchImport.vala"
				_tmp25_ = child;
#line 1633 "../src/BatchImport.vala"
				_tmp26_ = g_file_get_path (_tmp25_);
#line 1633 "../src/BatchImport.vala"
				_tmp27_ = _tmp26_;
#line 1633 "../src/BatchImport.vala"
				_tmp28_ = err;
#line 1633 "../src/BatchImport.vala"
				background_import_job_report_error (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_BACKGROUND_IMPORT_JOB, BackgroundImportJob), job, _tmp21_, _tmp24_, _tmp27_, _tmp28_, IMPORT_RESULT_FILE_ERROR);
#line 1633 "../src/BatchImport.vala"
				_g_free0 (_tmp27_);
#line 1633 "../src/BatchImport.vala"
				_g_free0 (_tmp24_);
#line 1630 "../src/BatchImport.vala"
				_g_error_free0 (err);
#line 12940 "BatchImport.c"
			}
			__finally0:
#line 1630 "../src/BatchImport.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1630 "../src/BatchImport.vala"
				g_propagate_error (error, _inner_error0_);
#line 1630 "../src/BatchImport.vala"
				_g_object_unref0 (child);
#line 1630 "../src/BatchImport.vala"
				_g_object_unref0 (_tmp6_);
#line 1630 "../src/BatchImport.vala"
				_g_object_unref0 (info);
#line 1630 "../src/BatchImport.vala"
				_g_object_unref0 (enumerator);
#line 1630 "../src/BatchImport.vala"
				return;
#line 12957 "BatchImport.c"
			}
		} else {
#line 1636 "../src/BatchImport.vala"
			if (file_type == G_FILE_TYPE_REGULAR) {
#line 12962 "BatchImport.c"
				gboolean _tmp29_ = FALSE;
				GeeHashSet* _tmp30_;
				gboolean _tmp33_ = FALSE;
				gboolean _tmp34_ = FALSE;
				GFile* _tmp35_;
#line 1637 "../src/BatchImport.vala"
				_tmp30_ = self->priv->skipset;
#line 1637 "../src/BatchImport.vala"
				if (_tmp30_ != NULL) {
#line 12972 "BatchImport.c"
					GeeHashSet* _tmp31_;
					GFile* _tmp32_;
#line 1637 "../src/BatchImport.vala"
					_tmp31_ = self->priv->skipset;
#line 1637 "../src/BatchImport.vala"
					_tmp32_ = child;
#line 1637 "../src/BatchImport.vala"
					_tmp29_ = gee_abstract_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp32_);
#line 12981 "BatchImport.c"
				} else {
#line 1637 "../src/BatchImport.vala"
					_tmp29_ = FALSE;
#line 12985 "BatchImport.c"
				}
#line 1637 "../src/BatchImport.vala"
				if (_tmp29_) {
#line 1638 "../src/BatchImport.vala"
					_g_object_unref0 (child);
#line 1638 "../src/BatchImport.vala"
					_g_object_unref0 (_tmp6_);
#line 1638 "../src/BatchImport.vala"
					continue;
#line 12995 "BatchImport.c"
				}
#line 1640 "../src/BatchImport.vala"
				_tmp35_ = child;
#line 1640 "../src/BatchImport.vala"
				if (photo_is_file_image (_tmp35_)) {
#line 13001 "BatchImport.c"
					GFile* _tmp36_;
#line 1640 "../src/BatchImport.vala"
					_tmp36_ = child;
#line 1640 "../src/BatchImport.vala"
					_tmp34_ = photo_file_format_is_file_supported (_tmp36_);
#line 13007 "BatchImport.c"
				} else {
#line 1640 "../src/BatchImport.vala"
					_tmp34_ = FALSE;
#line 13011 "BatchImport.c"
				}
#line 1640 "../src/BatchImport.vala"
				if (_tmp34_) {
#line 1640 "../src/BatchImport.vala"
					_tmp33_ = TRUE;
#line 13017 "BatchImport.c"
				} else {
					GFile* _tmp37_;
#line 1641 "../src/BatchImport.vala"
					_tmp37_ = child;
#line 1641 "../src/BatchImport.vala"
					_tmp33_ = video_reader_is_supported_video_file (_tmp37_);
#line 13024 "BatchImport.c"
				}
#line 1640 "../src/BatchImport.vala"
				if (_tmp33_) {
#line 13028 "BatchImport.c"
					GFileInfo* _tmp38_;
					GeeList* _tmp39_;
					GFile* _tmp40_;
					FileToPrepare* _tmp41_;
					FileToPrepare* _tmp42_;
#line 1642 "../src/BatchImport.vala"
					_tmp38_ = info;
#line 1642 "../src/BatchImport.vala"
					self->total_bytes = self->total_bytes + g_file_info_get_size (_tmp38_);
#line 1643 "../src/BatchImport.vala"
					_tmp39_ = self->files_to_prepare;
#line 1643 "../src/BatchImport.vala"
					_tmp40_ = child;
#line 1643 "../src/BatchImport.vala"
					_tmp41_ = file_to_prepare_new (job, _tmp40_, copy_to_library);
#line 1643 "../src/BatchImport.vala"
					_tmp42_ = _tmp41_;
#line 1643 "../src/BatchImport.vala"
					gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, GEE_TYPE_COLLECTION, GeeCollection), _tmp42_);
#line 1643 "../src/BatchImport.vala"
					_file_to_prepare_unref0 (_tmp42_);
#line 1645 "../src/BatchImport.vala"
					_g_object_unref0 (child);
#line 1645 "../src/BatchImport.vala"
					_g_object_unref0 (_tmp6_);
#line 1645 "../src/BatchImport.vala"
					continue;
#line 13056 "BatchImport.c"
				}
			} else {
				GFile* _tmp43_;
				gchar* _tmp44_;
				gchar* _tmp45_;
#line 1648 "../src/BatchImport.vala"
				_tmp43_ = child;
#line 1648 "../src/BatchImport.vala"
				_tmp44_ = g_file_get_path (_tmp43_);
#line 1648 "../src/BatchImport.vala"
				_tmp45_ = _tmp44_;
#line 1648 "../src/BatchImport.vala"
				g_warning ("BatchImport.vala:1648: Ignoring import of %s file type %d", _tmp45_, (gint) file_type);
#line 1648 "../src/BatchImport.vala"
				_g_free0 (_tmp45_);
#line 13072 "BatchImport.c"
			}
		}
#line 1615 "../src/BatchImport.vala"
		_g_object_unref0 (child);
#line 1615 "../src/BatchImport.vala"
		_g_object_unref0 (_tmp6_);
#line 13079 "BatchImport.c"
	}
#line 1605 "../src/BatchImport.vala"
	_g_object_unref0 (info);
#line 1605 "../src/BatchImport.vala"
	_g_object_unref0 (enumerator);
#line 13085 "BatchImport.c"
}

static void
work_sniffer_class_init (WorkSnifferClass * klass,
                         gpointer klass_data)
{
#line 1460 "../src/BatchImport.vala"
	work_sniffer_parent_class = g_type_class_peek_parent (klass);
#line 1460 "../src/BatchImport.vala"
	((BackgroundJobClass *) klass)->finalize = work_sniffer_finalize;
#line 1460 "../src/BatchImport.vala"
	g_type_class_adjust_private_offset (klass, &WorkSniffer_private_offset);
#line 1460 "../src/BatchImport.vala"
	((BackgroundJobClass *) klass)->execute = (void (*) (BackgroundJob*)) work_sniffer_real_execute;
#line 13100 "BatchImport.c"
}

static void
work_sniffer_instance_init (WorkSniffer * self,
                            gpointer klass)
{
	GeeArrayList* _tmp0_;
#line 1460 "../src/BatchImport.vala"
	self->priv = work_sniffer_get_instance_private (self);
#line 1461 "../src/BatchImport.vala"
	_tmp0_ = gee_array_list_new (TYPE_FILE_TO_PREPARE, (GBoxedCopyFunc) file_to_prepare_ref, (GDestroyNotify) file_to_prepare_unref, NULL, NULL, NULL);
#line 1461 "../src/BatchImport.vala"
	self->files_to_prepare = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_LIST, GeeList);
#line 1462 "../src/BatchImport.vala"
	self->total_bytes = (guint64) 0;
#line 13116 "BatchImport.c"
}

static void
work_sniffer_finalize (BackgroundJob * obj)
{
	WorkSniffer * self;
#line 1460 "../src/BatchImport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_WORK_SNIFFER, WorkSniffer);
#line 1461 "../src/BatchImport.vala"
	_g_object_unref0 (self->files_to_prepare);
#line 1464 "../src/BatchImport.vala"
	_g_object_unref0 (self->priv->jobs);
#line 1465 "../src/BatchImport.vala"
	_g_object_unref0 (self->priv->skipset);
#line 1460 "../src/BatchImport.vala"
	BACKGROUND_JOB_CLASS (work_sniffer_parent_class)->finalize (obj);
#line 13133 "BatchImport.c"
}

static GType
work_sniffer_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WorkSnifferClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) work_sniffer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WorkSniffer), 0, (GInstanceInitFunc) work_sniffer_instance_init, NULL };
	GType work_sniffer_type_id;
	work_sniffer_type_id = g_type_register_static (TYPE_BACKGROUND_IMPORT_JOB, "WorkSniffer", &g_define_type_info, 0);
	WorkSniffer_private_offset = g_type_add_instance_private (work_sniffer_type_id, sizeof (WorkSnifferPrivate));
	return work_sniffer_type_id;
}

GType
work_sniffer_get_type (void)
{
	static volatile gsize work_sniffer_type_id__once = 0;
	if (g_once_init_enter (&work_sniffer_type_id__once)) {
		GType work_sniffer_type_id;
		work_sniffer_type_id = work_sniffer_get_type_once ();
		g_once_init_leave (&work_sniffer_type_id__once, work_sniffer_type_id);
	}
	return work_sniffer_type_id__once;
}

PreparedFile*
prepared_file_construct (GType object_type,
                         BatchImportJob* job,
                         GFile* file,
                         GFile* associated_file,
                         const gchar* source_id,
                         const gchar* dest_id,
                         gboolean copy_to_library,
                         const gchar* exif_md5,
                         const gchar* thumbnail_md5,
                         const gchar* full_md5,
                         PhotoFileFormat file_format,
                         guint64 filesize,
                         gboolean is_video)
{
	PreparedFile* self = NULL;
	BatchImportJob* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
#line 1669 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_BATCH_IMPORT_JOB (job), NULL);
#line 1669 "../src/BatchImport.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), NULL);
#line 1669 "../src/BatchImport.vala"
	g_return_val_if_fail ((associated_file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (associated_file, g_file_get_type ()), NULL);
#line 1669 "../src/BatchImport.vala"
	g_return_val_if_fail (source_id != NULL, NULL);
#line 1669 "../src/BatchImport.vala"
	g_return_val_if_fail (dest_id != NULL, NULL);
#line 1669 "../src/BatchImport.vala"
	self = (PreparedFile*) g_type_create_instance (object_type);
#line 1672 "../src/BatchImport.vala"
	_tmp0_ = _batch_import_job_ref0 (job);
#line 1672 "../src/BatchImport.vala"
	_batch_import_job_unref0 (self->job);
#line 1672 "../src/BatchImport.vala"
	self->job = _tmp0_;
#line 1673 "../src/BatchImport.vala"
	self->result = IMPORT_RESULT_SUCCESS;
#line 1674 "../src/BatchImport.vala"
	_tmp1_ = _g_object_ref0 (file);
#line 1674 "../src/BatchImport.vala"
	_g_object_unref0 (self->file);
#line 1674 "../src/BatchImport.vala"
	self->file = _tmp1_;
#line 1675 "../src/BatchImport.vala"
	_tmp2_ = _g_object_ref0 (associated_file);
#line 1675 "../src/BatchImport.vala"
	_g_object_unref0 (self->associated_file);
#line 1675 "../src/BatchImport.vala"
	self->associated_file = _tmp2_;
#line 1676 "../src/BatchImport.vala"
	_tmp3_ = g_strdup (source_id);
#line 1676 "../src/BatchImport.vala"
	_g_free0 (self->source_id);
#line 1676 "../src/BatchImport.vala"
	self->source_id = _tmp3_;
#line 1677 "../src/BatchImport.vala"
	_tmp4_ = g_strdup (dest_id);
#line 1677 "../src/BatchImport.vala"
	_g_free0 (self->dest_id);
#line 1677 "../src/BatchImport.vala"
	self->dest_id = _tmp4_;
#line 1678 "../src/BatchImport.vala"
	self->copy_to_library = copy_to_library;
#line 1679 "../src/BatchImport.vala"
	_tmp5_ = g_strdup (exif_md5);
#line 1679 "../src/BatchImport.vala"
	_g_free0 (self->exif_md5);
#line 1679 "../src/BatchImport.vala"
	self->exif_md5 = _tmp5_;
#line 1680 "../src/BatchImport.vala"
	_tmp6_ = g_strdup (thumbnail_md5);
#line 1680 "../src/BatchImport.vala"
	_g_free0 (self->thumbnail_md5);
#line 1680 "../src/BatchImport.vala"
	self->thumbnail_md5 = _tmp6_;
#line 1681 "../src/BatchImport.vala"
	_tmp7_ = g_strdup (full_md5);
#line 1681 "../src/BatchImport.vala"
	_g_free0 (self->full_md5);
#line 1681 "../src/BatchImport.vala"
	self->full_md5 = _tmp7_;
#line 1682 "../src/BatchImport.vala"
	self->file_format = file_format;
#line 1683 "../src/BatchImport.vala"
	self->filesize = filesize;
#line 1684 "../src/BatchImport.vala"
	self->is_video = is_video;
#line 1669 "../src/BatchImport.vala"
	return self;
#line 13254 "BatchImport.c"
}

PreparedFile*
prepared_file_new (BatchImportJob* job,
                   GFile* file,
                   GFile* associated_file,
                   const gchar* source_id,
                   const gchar* dest_id,
                   gboolean copy_to_library,
                   const gchar* exif_md5,
                   const gchar* thumbnail_md5,
                   const gchar* full_md5,
                   PhotoFileFormat file_format,
                   guint64 filesize,
                   gboolean is_video)
{
#line 1669 "../src/BatchImport.vala"
	return prepared_file_construct (TYPE_PREPARED_FILE, job, file, associated_file, source_id, dest_id, copy_to_library, exif_md5, thumbnail_md5, full_md5, file_format, filesize, is_video);
#line 13273 "BatchImport.c"
}

static void
value_prepared_file_init (GValue* value)
{
#line 1654 "../src/BatchImport.vala"
	value->data[0].v_pointer = NULL;
#line 13281 "BatchImport.c"
}

static void
value_prepared_file_free_value (GValue* value)
{
#line 1654 "../src/BatchImport.vala"
	if (value->data[0].v_pointer) {
#line 1654 "../src/BatchImport.vala"
		prepared_file_unref (value->data[0].v_pointer);
#line 13291 "BatchImport.c"
	}
}

static void
value_prepared_file_copy_value (const GValue* src_value,
                                GValue* dest_value)
{
#line 1654 "../src/BatchImport.vala"
	if (src_value->data[0].v_pointer) {
#line 1654 "../src/BatchImport.vala"
		dest_value->data[0].v_pointer = prepared_file_ref (src_value->data[0].v_pointer);
#line 13303 "BatchImport.c"
	} else {
#line 1654 "../src/BatchImport.vala"
		dest_value->data[0].v_pointer = NULL;
#line 13307 "BatchImport.c"
	}
}

static gpointer
value_prepared_file_peek_pointer (const GValue* value)
{
#line 1654 "../src/BatchImport.vala"
	return value->data[0].v_pointer;
#line 13316 "BatchImport.c"
}

static gchar*
value_prepared_file_collect_value (GValue* value,
                                   guint n_collect_values,
                                   GTypeCValue* collect_values,
                                   guint collect_flags)
{
#line 1654 "../src/BatchImport.vala"
	if (collect_values[0].v_pointer) {
#line 13327 "BatchImport.c"
		PreparedFile * object;
		object = collect_values[0].v_pointer;
#line 1654 "../src/BatchImport.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1654 "../src/BatchImport.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 13334 "BatchImport.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1654 "../src/BatchImport.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 13338 "BatchImport.c"
		}
#line 1654 "../src/BatchImport.vala"
		value->data[0].v_pointer = prepared_file_ref (object);
#line 13342 "BatchImport.c"
	} else {
#line 1654 "../src/BatchImport.vala"
		value->data[0].v_pointer = NULL;
#line 13346 "BatchImport.c"
	}
#line 1654 "../src/BatchImport.vala"
	return NULL;
#line 13350 "BatchImport.c"
}

static gchar*
value_prepared_file_lcopy_value (const GValue* value,
                                 guint n_collect_values,
                                 GTypeCValue* collect_values,
                                 guint collect_flags)
{
	PreparedFile ** object_p;
	object_p = collect_values[0].v_pointer;
#line 1654 "../src/BatchImport.vala"
	if (!object_p) {
#line 1654 "../src/BatchImport.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 13365 "BatchImport.c"
	}
#line 1654 "../src/BatchImport.vala"
	if (!value->data[0].v_pointer) {
#line 1654 "../src/BatchImport.vala"
		*object_p = NULL;
#line 13371 "BatchImport.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1654 "../src/BatchImport.vala"
		*object_p = value->data[0].v_pointer;
#line 13375 "BatchImport.c"
	} else {
#line 1654 "../src/BatchImport.vala"
		*object_p = prepared_file_ref (value->data[0].v_pointer);
#line 13379 "BatchImport.c"
	}
#line 1654 "../src/BatchImport.vala"
	return NULL;
#line 13383 "BatchImport.c"
}

GParamSpec*
param_spec_prepared_file (const gchar* name,
                          const gchar* nick,
                          const gchar* blurb,
                          GType object_type,
                          GParamFlags flags)
{
	ParamSpecPreparedFile* spec;
#line 1654 "../src/BatchImport.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_PREPARED_FILE), NULL);
#line 1654 "../src/BatchImport.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1654 "../src/BatchImport.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1654 "../src/BatchImport.vala"
	return G_PARAM_SPEC (spec);
#line 13402 "BatchImport.c"
}

gpointer
value_get_prepared_file (const GValue* value)
{
#line 1654 "../src/BatchImport.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PREPARED_FILE), NULL);
#line 1654 "../src/BatchImport.vala"
	return value->data[0].v_pointer;
#line 13412 "BatchImport.c"
}

void
value_set_prepared_file (GValue* value,
                         gpointer v_object)
{
	PreparedFile * old;
#line 1654 "../src/BatchImport.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PREPARED_FILE));
#line 1654 "../src/BatchImport.vala"
	old = value->data[0].v_pointer;
#line 1654 "../src/BatchImport.vala"
	if (v_object) {
#line 1654 "../src/BatchImport.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PREPARED_FILE));
#line 1654 "../src/BatchImport.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1654 "../src/BatchImport.vala"
		value->data[0].v_pointer = v_object;
#line 1654 "../src/BatchImport.vala"
		prepared_file_ref (value->data[0].v_pointer);
#line 13434 "BatchImport.c"
	} else {
#line 1654 "../src/BatchImport.vala"
		value->data[0].v_pointer = NULL;
#line 13438 "BatchImport.c"
	}
#line 1654 "../src/BatchImport.vala"
	if (old) {
#line 1654 "../src/BatchImport.vala"
		prepared_file_unref (old);
#line 13444 "BatchImport.c"
	}
}

void
value_take_prepared_file (GValue* value,
                          gpointer v_object)
{
	PreparedFile * old;
#line 1654 "../src/BatchImport.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_PREPARED_FILE));
#line 1654 "../src/BatchImport.vala"
	old = value->data[0].v_pointer;
#line 1654 "../src/BatchImport.vala"
	if (v_object) {
#line 1654 "../src/BatchImport.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_PREPARED_FILE));
#line 1654 "../src/BatchImport.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1654 "../src/BatchImport.vala"
		value->data[0].v_pointer = v_object;
#line 13465 "BatchImport.c"
	} else {
#line 1654 "../src/BatchImport.vala"
		value->data[0].v_pointer = NULL;
#line 13469 "BatchImport.c"
	}
#line 1654 "../src/BatchImport.vala"
	if (old) {
#line 1654 "../src/BatchImport.vala"
		prepared_file_unref (old);
#line 13475 "BatchImport.c"
	}
}

static void
prepared_file_class_init (PreparedFileClass * klass,
                          gpointer klass_data)
{
#line 1654 "../src/BatchImport.vala"
	prepared_file_parent_class = g_type_class_peek_parent (klass);
#line 1654 "../src/BatchImport.vala"
	((PreparedFileClass *) klass)->finalize = prepared_file_finalize;
#line 13487 "BatchImport.c"
}

static void
prepared_file_instance_init (PreparedFile * self,
                             gpointer klass)
{
#line 1658 "../src/BatchImport.vala"
	self->associated_file = NULL;
#line 1654 "../src/BatchImport.vala"
	self->ref_count = 1;
#line 13498 "BatchImport.c"
}

static void
prepared_file_finalize (PreparedFile * obj)
{
	PreparedFile * self;
#line 1654 "../src/BatchImport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PREPARED_FILE, PreparedFile);
#line 1654 "../src/BatchImport.vala"
	g_signal_handlers_destroy (self);
#line 1655 "../src/BatchImport.vala"
	_batch_import_job_unref0 (self->job);
#line 1657 "../src/BatchImport.vala"
	_g_object_unref0 (self->file);
#line 1658 "../src/BatchImport.vala"
	_g_object_unref0 (self->associated_file);
#line 1659 "../src/BatchImport.vala"
	_g_free0 (self->source_id);
#line 1660 "../src/BatchImport.vala"
	_g_free0 (self->dest_id);
#line 1662 "../src/BatchImport.vala"
	_g_free0 (self->exif_md5);
#line 1663 "../src/BatchImport.vala"
	_g_free0 (self->thumbnail_md5);
#line 1664 "../src/BatchImport.vala"
	_g_free0 (self->full_md5);
#line 13525 "BatchImport.c"
}

static GType
prepared_file_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_prepared_file_init, value_prepared_file_free_value, value_prepared_file_copy_value, value_prepared_file_peek_pointer, "p", value_prepared_file_collect_value, "p", value_prepared_file_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (PreparedFileClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) prepared_file_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PreparedFile), 0, (GInstanceInitFunc) prepared_file_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType prepared_file_type_id;
	prepared_file_type_id = g_type_register_fundamental (g_type_fundamental_next (), "PreparedFile", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return prepared_file_type_id;
}

GType
prepared_file_get_type (void)
{
	static volatile gsize prepared_file_type_id__once = 0;
	if (g_once_init_enter (&prepared_file_type_id__once)) {
		GType prepared_file_type_id;
		prepared_file_type_id = prepared_file_get_type_once ();
		g_once_init_leave (&prepared_file_type_id__once, prepared_file_type_id);
	}
	return prepared_file_type_id__once;
}

gpointer
prepared_file_ref (gpointer instance)
{
	PreparedFile * self;
	self = instance;
#line 1654 "../src/BatchImport.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1654 "../src/BatchImport.vala"
	return instance;
#line 13560 "BatchImport.c"
}

void
prepared_file_unref (gpointer instance)
{
	PreparedFile * self;
	self = instance;
#line 1654 "../src/BatchImport.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1654 "../src/BatchImport.vala"
		PREPARED_FILE_GET_CLASS (self)->finalize (self);
#line 1654 "../src/BatchImport.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 13574 "BatchImport.c"
	}
}

PreparedFileCluster*
prepared_file_cluster_construct (GType object_type,
                                 GeeArrayList* list)
{
	PreparedFileCluster* self = NULL;
	GeeArrayList* _tmp0_;
#line 1691 "../src/BatchImport.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (list, GEE_TYPE_ARRAY_LIST), NULL);
#line 1691 "../src/BatchImport.vala"
	self = (PreparedFileCluster*) interlocked_notification_object_construct (object_type);
#line 1692 "../src/BatchImport.vala"
	_tmp0_ = _g_object_ref0 (list);
#line 1692 "../src/BatchImport.vala"
	_g_object_unref0 (self->list);
#line 1692 "../src/BatchImport.vala"
	self->list = _tmp0_;
#line 1691 "../src/BatchImport.vala"
	return self;
#line 13596 "BatchImport.c"
}

PreparedFileCluster*
prepared_file_cluster_new (GeeArrayList* list)
{
#line 1691 "../src/BatchImport.vala"
	return prepared_file_cluster_construct (TYPE_PREPARED_FILE_CLUSTER, list);
#line 13604 "BatchImport.c"
}

static void
prepared_file_cluster_class_init (PreparedFileClusterClass * klass,
                                  gpointer klass_data)
{
#line 1688 "../src/BatchImport.vala"
	prepared_file_cluster_parent_class = g_type_class_peek_parent (klass);
#line 1688 "../src/BatchImport.vala"
	((NotificationObjectClass *) klass)->finalize = prepared_file_cluster_finalize;
#line 13615 "BatchImport.c"
}

static void
prepared_file_cluster_instance_init (PreparedFileCluster * self,
                                     gpointer klass)
{
}

static void
prepared_file_cluster_finalize (NotificationObject * obj)
{
	PreparedFileCluster * self;
#line 1688 "../src/BatchImport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PREPARED_FILE_CLUSTER, PreparedFileCluster);
#line 1689 "../src/BatchImport.vala"
	_g_object_unref0 (self->list);
#line 1688 "../src/BatchImport.vala"
	NOTIFICATION_OBJECT_CLASS (prepared_file_cluster_parent_class)->finalize (obj);
#line 13634 "BatchImport.c"
}

static GType
prepared_file_cluster_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PreparedFileClusterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) prepared_file_cluster_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PreparedFileCluster), 0, (GInstanceInitFunc) prepared_file_cluster_instance_init, NULL };
	GType prepared_file_cluster_type_id;
	prepared_file_cluster_type_id = g_type_register_static (TYPE_INTERLOCKED_NOTIFICATION_OBJECT, "PreparedFileCluster", &g_define_type_info, 0);
	return prepared_file_cluster_type_id;
}

GType
prepared_file_cluster_get_type (void)
{
	static volatile gsize prepared_file_cluster_type_id__once = 0;
	if (g_once_init_enter (&prepared_file_cluster_type_id__once)) {
		GType prepared_file_cluster_type_id;
		prepared_file_cluster_type_id = prepared_file_cluster_get_type_once ();
		g_once_init_leave (&prepared_file_cluster_type_id__once, prepared_file_cluster_type_id);
	}
	return prepared_file_cluster_type_id__once;
}

static inline gpointer
prepare_files_job_get_instance_private (PrepareFilesJob* self)
{
	return G_STRUCT_MEMBER_P (self, PrepareFilesJob_private_offset);
}

PrepareFilesJob*
prepare_files_job_construct (GType object_type,
                             BatchImport* owner,
                             GeeList* files_to_prepare,
                             NotificationCallback notification,
                             gpointer notification_target,
                             CompletionCallback callback,
                             gpointer callback_target,
                             GCancellable* cancellable,
                             CancellationCallback cancellation,
                             gpointer cancellation_target)
{
	PrepareFilesJob* self = NULL;
	GeeList* _tmp0_;
	GFile* _tmp1_;
#line 1709 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_BATCH_IMPORT (owner), NULL);
#line 1709 "../src/BatchImport.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (files_to_prepare, GEE_TYPE_LIST), NULL);
#line 1709 "../src/BatchImport.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()), NULL);
#line 1712 "../src/BatchImport.vala"
	self = (PrepareFilesJob*) background_import_job_construct (object_type, owner, callback, callback_target, cancellable, cancellation, cancellation_target);
#line 1714 "../src/BatchImport.vala"
	_tmp0_ = _g_object_ref0 (files_to_prepare);
#line 1714 "../src/BatchImport.vala"
	_g_object_unref0 (self->priv->files_to_prepare);
#line 1714 "../src/BatchImport.vala"
	self->priv->files_to_prepare = _tmp0_;
#line 1715 "../src/BatchImport.vala"
	self->priv->notification = notification;
#line 1715 "../src/BatchImport.vala"
	self->priv->notification_target = notification_target;
#line 1716 "../src/BatchImport.vala"
	_tmp1_ = app_dirs_get_import_dir ();
#line 1716 "../src/BatchImport.vala"
	_g_object_unref0 (self->priv->library_dir);
#line 1716 "../src/BatchImport.vala"
	self->priv->library_dir = _tmp1_;
#line 1717 "../src/BatchImport.vala"
	self->priv->fail_every = prepare_files_job_get_test_variable ("SHOTWELL_FAIL_EVERY");
#line 1718 "../src/BatchImport.vala"
	self->priv->skip_every = prepare_files_job_get_test_variable ("SHOTWELL_SKIP_EVERY");
#line 1720 "../src/BatchImport.vala"
	background_job_set_notification_priority (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_BACKGROUND_JOB, BackgroundJob), G_PRIORITY_LOW);
#line 1709 "../src/BatchImport.vala"
	return self;
#line 13711 "BatchImport.c"
}

PrepareFilesJob*
prepare_files_job_new (BatchImport* owner,
                       GeeList* files_to_prepare,
                       NotificationCallback notification,
                       gpointer notification_target,
                       CompletionCallback callback,
                       gpointer callback_target,
                       GCancellable* cancellable,
                       CancellationCallback cancellation,
                       gpointer cancellation_target)
{
#line 1709 "../src/BatchImport.vala"
	return prepare_files_job_construct (TYPE_PREPARE_FILES_JOB, owner, files_to_prepare, notification, notification_target, callback, callback_target, cancellable, cancellation, cancellation_target);
#line 13727 "BatchImport.c"
}

static gint
prepare_files_job_get_test_variable (const gchar* name)
{
	gchar* value = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp2_ = 0;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
	gint result;
#line 1723 "../src/BatchImport.vala"
	g_return_val_if_fail (name != NULL, 0);
#line 1724 "../src/BatchImport.vala"
	_tmp0_ = g_getenv (name);
#line 1724 "../src/BatchImport.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 1724 "../src/BatchImport.vala"
	value = _tmp1_;
#line 1726 "../src/BatchImport.vala"
	_tmp4_ = value;
#line 1726 "../src/BatchImport.vala"
	if (_tmp4_ == NULL) {
#line 1726 "../src/BatchImport.vala"
		_tmp3_ = TRUE;
#line 13754 "BatchImport.c"
	} else {
		const gchar* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
#line 1726 "../src/BatchImport.vala"
		_tmp5_ = value;
#line 1726 "../src/BatchImport.vala"
		_tmp6_ = strlen (_tmp5_);
#line 1726 "../src/BatchImport.vala"
		_tmp7_ = _tmp6_;
#line 1726 "../src/BatchImport.vala"
		_tmp3_ = _tmp7_ == 0;
#line 13767 "BatchImport.c"
	}
#line 1726 "../src/BatchImport.vala"
	if (_tmp3_) {
#line 1726 "../src/BatchImport.vala"
		_tmp2_ = 0;
#line 13773 "BatchImport.c"
	} else {
		const gchar* _tmp8_;
#line 1726 "../src/BatchImport.vala"
		_tmp8_ = value;
#line 1726 "../src/BatchImport.vala"
		_tmp2_ = atoi (_tmp8_);
#line 13780 "BatchImport.c"
	}
#line 1726 "../src/BatchImport.vala"
	result = _tmp2_;
#line 1726 "../src/BatchImport.vala"
	_g_free0 (value);
#line 1726 "../src/BatchImport.vala"
	return result;
#line 13788 "BatchImport.c"
}

static void
prepare_files_job_real_execute (BackgroundJob* base)
{
	PrepareFilesJob * self;
	GTimer* timer = NULL;
	GTimer* _tmp0_;
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp79_;
	gint _tmp80_;
	gint _tmp81_;
#line 1729 "../src/BatchImport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PREPARE_FILES_JOB, PrepareFilesJob);
#line 1730 "../src/BatchImport.vala"
	_tmp0_ = g_timer_new ();
#line 1730 "../src/BatchImport.vala"
	timer = _tmp0_;
#line 1732 "../src/BatchImport.vala"
	_tmp1_ = gee_array_list_new (TYPE_PREPARED_FILE, (GBoxedCopyFunc) prepared_file_ref, (GDestroyNotify) prepared_file_unref, NULL, NULL, NULL);
#line 1732 "../src/BatchImport.vala"
	list = _tmp1_;
#line 13812 "BatchImport.c"
	{
		GeeList* _file_to_prepare_list = NULL;
		GeeList* _tmp2_;
		gint _file_to_prepare_size = 0;
		GeeList* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _file_to_prepare_index = 0;
#line 1733 "../src/BatchImport.vala"
		_tmp2_ = self->priv->files_to_prepare;
#line 1733 "../src/BatchImport.vala"
		_file_to_prepare_list = _tmp2_;
#line 1733 "../src/BatchImport.vala"
		_tmp3_ = _file_to_prepare_list;
#line 1733 "../src/BatchImport.vala"
		_tmp4_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1733 "../src/BatchImport.vala"
		_tmp5_ = _tmp4_;
#line 1733 "../src/BatchImport.vala"
		_file_to_prepare_size = _tmp5_;
#line 1733 "../src/BatchImport.vala"
		_file_to_prepare_index = -1;
#line 1733 "../src/BatchImport.vala"
		while (TRUE) {
#line 13837 "BatchImport.c"
			gint _tmp6_;
			gint _tmp7_;
			FileToPrepare* file_to_prepare = NULL;
			GeeList* _tmp8_;
			gpointer _tmp9_;
			ImportResult _result_ = 0;
			BatchImportJob* job = NULL;
			FileToPrepare* _tmp20_;
			BatchImportJob* _tmp21_;
			BatchImportJob* _tmp22_;
			GFile* file = NULL;
			FileToPrepare* _tmp23_;
			GFile* _tmp24_;
			GFile* _tmp25_;
			GFile* _tmp26_ = NULL;
			FileToPrepare* _tmp27_;
			FileToPrepare* _tmp28_;
			GFile* associated = NULL;
			GFile* _tmp32_;
			gboolean copy_to_library = FALSE;
			FileToPrepare* _tmp33_;
			GFile* _tmp34_;
			gboolean _tmp39_ = FALSE;
			GFile* _tmp40_;
			PreparedFile* prepared_file = NULL;
			BatchImportJob* _tmp48_;
			GFile* _tmp49_;
			GFile* _tmp50_;
			PreparedFile* _tmp51_ = NULL;
			ImportResult _tmp52_;
			gboolean _tmp64_ = FALSE;
			GeeArrayList* _tmp65_;
			gint _tmp66_;
			gint _tmp67_;
#line 1733 "../src/BatchImport.vala"
			_file_to_prepare_index = _file_to_prepare_index + 1;
#line 1733 "../src/BatchImport.vala"
			_tmp6_ = _file_to_prepare_index;
#line 1733 "../src/BatchImport.vala"
			_tmp7_ = _file_to_prepare_size;
#line 1733 "../src/BatchImport.vala"
			if (!(_tmp6_ < _tmp7_)) {
#line 1733 "../src/BatchImport.vala"
				break;
#line 13882 "BatchImport.c"
			}
#line 1733 "../src/BatchImport.vala"
			_tmp8_ = _file_to_prepare_list;
#line 1733 "../src/BatchImport.vala"
			_tmp9_ = gee_list_get (_tmp8_, _file_to_prepare_index);
#line 1733 "../src/BatchImport.vala"
			file_to_prepare = (FileToPrepare*) _tmp9_;
#line 1734 "../src/BatchImport.vala"
			_result_ = background_import_job_abort_check (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_BACKGROUND_IMPORT_JOB, BackgroundImportJob));
#line 1735 "../src/BatchImport.vala"
			if (_result_ != IMPORT_RESULT_SUCCESS) {
#line 13894 "BatchImport.c"
				FileToPrepare* _tmp10_;
				BatchImportJob* _tmp11_;
				FileToPrepare* _tmp12_;
				BatchImportJob* _tmp13_;
				gchar* _tmp14_;
				gchar* _tmp15_;
				FileToPrepare* _tmp16_;
				BatchImportJob* _tmp17_;
				gchar* _tmp18_;
				gchar* _tmp19_;
#line 1736 "../src/BatchImport.vala"
				_tmp10_ = file_to_prepare;
#line 1736 "../src/BatchImport.vala"
				_tmp11_ = _tmp10_->job;
#line 1736 "../src/BatchImport.vala"
				_tmp12_ = file_to_prepare;
#line 1736 "../src/BatchImport.vala"
				_tmp13_ = _tmp12_->job;
#line 1736 "../src/BatchImport.vala"
				_tmp14_ = batch_import_job_get_dest_identifier (_tmp13_);
#line 1736 "../src/BatchImport.vala"
				_tmp15_ = _tmp14_;
#line 1736 "../src/BatchImport.vala"
				_tmp16_ = file_to_prepare;
#line 1736 "../src/BatchImport.vala"
				_tmp17_ = _tmp16_->job;
#line 1736 "../src/BatchImport.vala"
				_tmp18_ = batch_import_job_get_source_identifier (_tmp17_);
#line 1736 "../src/BatchImport.vala"
				_tmp19_ = _tmp18_;
#line 1736 "../src/BatchImport.vala"
				background_import_job_report_failure (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_BACKGROUND_IMPORT_JOB, BackgroundImportJob), _tmp11_, NULL, _tmp15_, _tmp19_, _result_);
#line 1736 "../src/BatchImport.vala"
				_g_free0 (_tmp19_);
#line 1736 "../src/BatchImport.vala"
				_g_free0 (_tmp15_);
#line 1739 "../src/BatchImport.vala"
				_file_to_prepare_unref0 (file_to_prepare);
#line 1739 "../src/BatchImport.vala"
				continue;
#line 13935 "BatchImport.c"
			}
#line 1742 "../src/BatchImport.vala"
			_tmp20_ = file_to_prepare;
#line 1742 "../src/BatchImport.vala"
			_tmp21_ = _tmp20_->job;
#line 1742 "../src/BatchImport.vala"
			_tmp22_ = _batch_import_job_ref0 (_tmp21_);
#line 1742 "../src/BatchImport.vala"
			job = _tmp22_;
#line 1743 "../src/BatchImport.vala"
			_tmp23_ = file_to_prepare;
#line 1743 "../src/BatchImport.vala"
			_tmp24_ = _tmp23_->file;
#line 1743 "../src/BatchImport.vala"
			_tmp25_ = _g_object_ref0 (_tmp24_);
#line 1743 "../src/BatchImport.vala"
			file = _tmp25_;
#line 1744 "../src/BatchImport.vala"
			_tmp27_ = file_to_prepare;
#line 1744 "../src/BatchImport.vala"
			_tmp28_ = _tmp27_->associated;
#line 1744 "../src/BatchImport.vala"
			if (_tmp28_ != NULL) {
#line 13959 "BatchImport.c"
				FileToPrepare* _tmp29_;
				FileToPrepare* _tmp30_;
				GFile* _tmp31_;
#line 1744 "../src/BatchImport.vala"
				_tmp29_ = file_to_prepare;
#line 1744 "../src/BatchImport.vala"
				_tmp30_ = _tmp29_->associated;
#line 1744 "../src/BatchImport.vala"
				_tmp31_ = _tmp30_->file;
#line 1744 "../src/BatchImport.vala"
				_tmp26_ = _tmp31_;
#line 13971 "BatchImport.c"
			} else {
#line 1744 "../src/BatchImport.vala"
				_tmp26_ = NULL;
#line 13975 "BatchImport.c"
			}
#line 1744 "../src/BatchImport.vala"
			_tmp32_ = _g_object_ref0 (_tmp26_);
#line 1744 "../src/BatchImport.vala"
			associated = _tmp32_;
#line 1745 "../src/BatchImport.vala"
			_tmp33_ = file_to_prepare;
#line 1745 "../src/BatchImport.vala"
			copy_to_library = _tmp33_->copy_to_library;
#line 1748 "../src/BatchImport.vala"
			_tmp34_ = file;
#line 1748 "../src/BatchImport.vala"
			if (_tmp34_ == NULL) {
#line 13989 "BatchImport.c"
				BatchImportJob* _tmp35_;
				GFile* _tmp36_ = NULL;
				gboolean _tmp37_ = FALSE;
				gboolean _tmp38_;
#line 1749 "../src/BatchImport.vala"
				_tmp35_ = job;
#line 1749 "../src/BatchImport.vala"
				_tmp38_ = prepare_files_job_create_file (self, _tmp35_, &_tmp36_, &_tmp37_);
#line 1749 "../src/BatchImport.vala"
				_g_object_unref0 (file);
#line 1749 "../src/BatchImport.vala"
				file = _tmp36_;
#line 1749 "../src/BatchImport.vala"
				copy_to_library = _tmp37_;
#line 1749 "../src/BatchImport.vala"
				if (!_tmp38_) {
#line 1750 "../src/BatchImport.vala"
					_g_object_unref0 (associated);
#line 1750 "../src/BatchImport.vala"
					_g_object_unref0 (file);
#line 1750 "../src/BatchImport.vala"
					_batch_import_job_unref0 (job);
#line 1750 "../src/BatchImport.vala"
					_file_to_prepare_unref0 (file_to_prepare);
#line 1750 "../src/BatchImport.vala"
					continue;
#line 14016 "BatchImport.c"
				}
			}
#line 1753 "../src/BatchImport.vala"
			_tmp40_ = associated;
#line 1753 "../src/BatchImport.vala"
			if (_tmp40_ == NULL) {
#line 14023 "BatchImport.c"
				FileToPrepare* _tmp41_;
				FileToPrepare* _tmp42_;
#line 1753 "../src/BatchImport.vala"
				_tmp41_ = file_to_prepare;
#line 1753 "../src/BatchImport.vala"
				_tmp42_ = _tmp41_->associated;
#line 1753 "../src/BatchImport.vala"
				_tmp39_ = _tmp42_ != NULL;
#line 14032 "BatchImport.c"
			} else {
#line 1753 "../src/BatchImport.vala"
				_tmp39_ = FALSE;
#line 14036 "BatchImport.c"
			}
#line 1753 "../src/BatchImport.vala"
			if (_tmp39_) {
#line 14040 "BatchImport.c"
				FileToPrepare* _tmp43_;
				FileToPrepare* _tmp44_;
				BatchImportJob* _tmp45_;
				GFile* _tmp46_ = NULL;
				gboolean _tmp47_ = FALSE;
#line 1754 "../src/BatchImport.vala"
				_tmp43_ = file_to_prepare;
#line 1754 "../src/BatchImport.vala"
				_tmp44_ = _tmp43_->associated;
#line 1754 "../src/BatchImport.vala"
				_tmp45_ = _tmp44_->job;
#line 1754 "../src/BatchImport.vala"
				prepare_files_job_create_file (self, _tmp45_, &_tmp46_, &_tmp47_);
#line 1754 "../src/BatchImport.vala"
				_g_object_unref0 (associated);
#line 1754 "../src/BatchImport.vala"
				associated = _tmp46_;
#line 1754 "../src/BatchImport.vala"
				copy_to_library = _tmp47_;
#line 14060 "BatchImport.c"
			}
#line 1758 "../src/BatchImport.vala"
			_tmp48_ = job;
#line 1758 "../src/BatchImport.vala"
			_tmp49_ = file;
#line 1758 "../src/BatchImport.vala"
			_tmp50_ = associated;
#line 1758 "../src/BatchImport.vala"
			_tmp52_ = prepare_files_job_prepare_file (self, _tmp48_, _tmp49_, _tmp50_, copy_to_library, &_tmp51_);
#line 1758 "../src/BatchImport.vala"
			_prepared_file_unref0 (prepared_file);
#line 1758 "../src/BatchImport.vala"
			prepared_file = _tmp51_;
#line 1758 "../src/BatchImport.vala"
			_result_ = _tmp52_;
#line 1759 "../src/BatchImport.vala"
			if (_result_ == IMPORT_RESULT_SUCCESS) {
#line 14078 "BatchImport.c"
				gint _tmp53_;
				GeeArrayList* _tmp54_;
				PreparedFile* _tmp55_;
#line 1760 "../src/BatchImport.vala"
				_tmp53_ = self->prepared_files;
#line 1760 "../src/BatchImport.vala"
				self->prepared_files = _tmp53_ + 1;
#line 1761 "../src/BatchImport.vala"
				_tmp54_ = list;
#line 1761 "../src/BatchImport.vala"
				_tmp55_ = prepared_file;
#line 1761 "../src/BatchImport.vala"
				gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp54_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp55_);
#line 14092 "BatchImport.c"
			} else {
				BatchImportJob* _tmp56_;
				GFile* _tmp57_;
				BatchImportJob* _tmp58_;
				gchar* _tmp59_;
				gchar* _tmp60_;
				GFile* _tmp61_;
				gchar* _tmp62_;
				gchar* _tmp63_;
#line 1763 "../src/BatchImport.vala"
				_tmp56_ = job;
#line 1763 "../src/BatchImport.vala"
				_tmp57_ = file;
#line 1763 "../src/BatchImport.vala"
				_tmp58_ = job;
#line 1763 "../src/BatchImport.vala"
				_tmp59_ = batch_import_job_get_source_identifier (_tmp58_);
#line 1763 "../src/BatchImport.vala"
				_tmp60_ = _tmp59_;
#line 1763 "../src/BatchImport.vala"
				_tmp61_ = file;
#line 1763 "../src/BatchImport.vala"
				_tmp62_ = g_file_get_path (_tmp61_);
#line 1763 "../src/BatchImport.vala"
				_tmp63_ = _tmp62_;
#line 1763 "../src/BatchImport.vala"
				background_import_job_report_failure (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_BACKGROUND_IMPORT_JOB, BackgroundImportJob), _tmp56_, _tmp57_, _tmp60_, _tmp63_, _result_);
#line 1763 "../src/BatchImport.vala"
				_g_free0 (_tmp63_);
#line 1763 "../src/BatchImport.vala"
				_g_free0 (_tmp60_);
#line 14124 "BatchImport.c"
			}
#line 1767 "../src/BatchImport.vala"
			_tmp65_ = list;
#line 1767 "../src/BatchImport.vala"
			_tmp66_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp65_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 1767 "../src/BatchImport.vala"
			_tmp67_ = _tmp66_;
#line 1767 "../src/BatchImport.vala"
			if (_tmp67_ >= BATCH_IMPORT_REPORT_EVERY_N_PREPARED_FILES) {
#line 1767 "../src/BatchImport.vala"
				_tmp64_ = TRUE;
#line 14136 "BatchImport.c"
			} else {
				gboolean _tmp68_ = FALSE;
				GTimer* _tmp69_;
#line 1768 "../src/BatchImport.vala"
				_tmp69_ = timer;
#line 1768 "../src/BatchImport.vala"
				if ((g_timer_elapsed (_tmp69_, NULL) * 1000.0) > ((gdouble) BATCH_IMPORT_REPORT_PREPARED_FILES_EVERY_N_MSEC)) {
#line 14144 "BatchImport.c"
					GeeArrayList* _tmp70_;
					gint _tmp71_;
					gint _tmp72_;
#line 1768 "../src/BatchImport.vala"
					_tmp70_ = list;
#line 1768 "../src/BatchImport.vala"
					_tmp71_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp70_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 1768 "../src/BatchImport.vala"
					_tmp72_ = _tmp71_;
#line 1768 "../src/BatchImport.vala"
					_tmp68_ = _tmp72_ > 0;
#line 14156 "BatchImport.c"
				} else {
#line 1768 "../src/BatchImport.vala"
					_tmp68_ = FALSE;
#line 14160 "BatchImport.c"
				}
#line 1768 "../src/BatchImport.vala"
				_tmp64_ = _tmp68_;
#line 14164 "BatchImport.c"
			}
#line 1767 "../src/BatchImport.vala"
			if (_tmp64_) {
#line 14168 "BatchImport.c"
				PreparedFileCluster* cluster = NULL;
				GeeArrayList* _tmp73_;
				PreparedFileCluster* _tmp74_;
				GeeArrayList* _tmp75_;
				NotificationCallback _tmp76_;
				gpointer _tmp76__target;
				PreparedFileCluster* _tmp77_;
				GTimer* _tmp78_;
#line 1772 "../src/BatchImport.vala"
				_tmp73_ = list;
#line 1772 "../src/BatchImport.vala"
				_tmp74_ = prepared_file_cluster_new (_tmp73_);
#line 1772 "../src/BatchImport.vala"
				cluster = _tmp74_;
#line 1773 "../src/BatchImport.vala"
				_tmp75_ = gee_array_list_new (TYPE_PREPARED_FILE, (GBoxedCopyFunc) prepared_file_ref, (GDestroyNotify) prepared_file_unref, NULL, NULL, NULL);
#line 1773 "../src/BatchImport.vala"
				_g_object_unref0 (list);
#line 1773 "../src/BatchImport.vala"
				list = _tmp75_;
#line 1774 "../src/BatchImport.vala"
				_tmp76_ = self->priv->notification;
#line 1774 "../src/BatchImport.vala"
				_tmp76__target = self->priv->notification_target;
#line 1774 "../src/BatchImport.vala"
				_tmp77_ = cluster;
#line 1774 "../src/BatchImport.vala"
				background_job_notify (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_BACKGROUND_JOB, BackgroundJob), _tmp76_, _tmp76__target, G_TYPE_CHECK_INSTANCE_CAST (_tmp77_, TYPE_NOTIFICATION_OBJECT, NotificationObject));
#line 1775 "../src/BatchImport.vala"
				_tmp78_ = timer;
#line 1775 "../src/BatchImport.vala"
				g_timer_start (_tmp78_);
#line 1767 "../src/BatchImport.vala"
				_notification_object_unref0 (cluster);
#line 14203 "BatchImport.c"
			}
#line 1733 "../src/BatchImport.vala"
			_prepared_file_unref0 (prepared_file);
#line 1733 "../src/BatchImport.vala"
			_g_object_unref0 (associated);
#line 1733 "../src/BatchImport.vala"
			_g_object_unref0 (file);
#line 1733 "../src/BatchImport.vala"
			_batch_import_job_unref0 (job);
#line 1733 "../src/BatchImport.vala"
			_file_to_prepare_unref0 (file_to_prepare);
#line 14215 "BatchImport.c"
		}
	}
#line 1779 "../src/BatchImport.vala"
	_tmp79_ = list;
#line 1779 "../src/BatchImport.vala"
	_tmp80_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp79_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 1779 "../src/BatchImport.vala"
	_tmp81_ = _tmp80_;
#line 1779 "../src/BatchImport.vala"
	if (_tmp81_ > 0) {
#line 14226 "BatchImport.c"
		ImportResult _result_ = 0;
#line 1780 "../src/BatchImport.vala"
		_result_ = background_import_job_abort_check (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_BACKGROUND_IMPORT_JOB, BackgroundImportJob));
#line 1781 "../src/BatchImport.vala"
		if (_result_ == IMPORT_RESULT_SUCCESS) {
#line 14232 "BatchImport.c"
			NotificationCallback _tmp82_;
			gpointer _tmp82__target;
			GeeArrayList* _tmp83_;
			PreparedFileCluster* _tmp84_;
			PreparedFileCluster* _tmp85_;
#line 1782 "../src/BatchImport.vala"
			_tmp82_ = self->priv->notification;
#line 1782 "../src/BatchImport.vala"
			_tmp82__target = self->priv->notification_target;
#line 1782 "../src/BatchImport.vala"
			_tmp83_ = list;
#line 1782 "../src/BatchImport.vala"
			_tmp84_ = prepared_file_cluster_new (_tmp83_);
#line 1782 "../src/BatchImport.vala"
			_tmp85_ = _tmp84_;
#line 1782 "../src/BatchImport.vala"
			background_job_notify (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_BACKGROUND_JOB, BackgroundJob), _tmp82_, _tmp82__target, G_TYPE_CHECK_INSTANCE_CAST (_tmp85_, TYPE_NOTIFICATION_OBJECT, NotificationObject));
#line 1782 "../src/BatchImport.vala"
			_notification_object_unref0 (_tmp85_);
#line 14252 "BatchImport.c"
		} else {
			GeeArrayList* _tmp86_;
			gint _tmp87_;
			gint _tmp88_;
			GeeArrayList* _tmp89_;
			gint _tmp90_;
			gint _tmp91_;
#line 1785 "../src/BatchImport.vala"
			_tmp86_ = list;
#line 1785 "../src/BatchImport.vala"
			_tmp87_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp86_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 1785 "../src/BatchImport.vala"
			_tmp88_ = _tmp87_;
#line 1785 "../src/BatchImport.vala"
			_vala_assert (self->prepared_files >= _tmp88_, "prepared_files >= list.size");
#line 1786 "../src/BatchImport.vala"
			_tmp89_ = list;
#line 1786 "../src/BatchImport.vala"
			_tmp90_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp89_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 1786 "../src/BatchImport.vala"
			_tmp91_ = _tmp90_;
#line 1786 "../src/BatchImport.vala"
			self->prepared_files = self->prepared_files - _tmp91_;
#line 14276 "BatchImport.c"
			{
				GeeArrayList* _prepared_file_list = NULL;
				GeeArrayList* _tmp92_;
				gint _prepared_file_size = 0;
				GeeArrayList* _tmp93_;
				gint _tmp94_;
				gint _tmp95_;
				gint _prepared_file_index = 0;
#line 1788 "../src/BatchImport.vala"
				_tmp92_ = list;
#line 1788 "../src/BatchImport.vala"
				_prepared_file_list = _tmp92_;
#line 1788 "../src/BatchImport.vala"
				_tmp93_ = _prepared_file_list;
#line 1788 "../src/BatchImport.vala"
				_tmp94_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp93_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 1788 "../src/BatchImport.vala"
				_tmp95_ = _tmp94_;
#line 1788 "../src/BatchImport.vala"
				_prepared_file_size = _tmp95_;
#line 1788 "../src/BatchImport.vala"
				_prepared_file_index = -1;
#line 1788 "../src/BatchImport.vala"
				while (TRUE) {
#line 14301 "BatchImport.c"
					gint _tmp96_;
					gint _tmp97_;
					PreparedFile* prepared_file = NULL;
					GeeArrayList* _tmp98_;
					gpointer _tmp99_;
					PreparedFile* _tmp100_;
					BatchImportJob* _tmp101_;
					PreparedFile* _tmp102_;
					GFile* _tmp103_;
					PreparedFile* _tmp104_;
					BatchImportJob* _tmp105_;
					gchar* _tmp106_;
					gchar* _tmp107_;
					PreparedFile* _tmp108_;
					GFile* _tmp109_;
					gchar* _tmp110_;
					gchar* _tmp111_;
#line 1788 "../src/BatchImport.vala"
					_prepared_file_index = _prepared_file_index + 1;
#line 1788 "../src/BatchImport.vala"
					_tmp96_ = _prepared_file_index;
#line 1788 "../src/BatchImport.vala"
					_tmp97_ = _prepared_file_size;
#line 1788 "../src/BatchImport.vala"
					if (!(_tmp96_ < _tmp97_)) {
#line 1788 "../src/BatchImport.vala"
						break;
#line 14329 "BatchImport.c"
					}
#line 1788 "../src/BatchImport.vala"
					_tmp98_ = _prepared_file_list;
#line 1788 "../src/BatchImport.vala"
					_tmp99_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp98_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _prepared_file_index);
#line 1788 "../src/BatchImport.vala"
					prepared_file = (PreparedFile*) _tmp99_;
#line 1789 "../src/BatchImport.vala"
					_tmp100_ = prepared_file;
#line 1789 "../src/BatchImport.vala"
					_tmp101_ = _tmp100_->job;
#line 1789 "../src/BatchImport.vala"
					_tmp102_ = prepared_file;
#line 1789 "../src/BatchImport.vala"
					_tmp103_ = _tmp102_->file;
#line 1789 "../src/BatchImport.vala"
					_tmp104_ = prepared_file;
#line 1789 "../src/BatchImport.vala"
					_tmp105_ = _tmp104_->job;
#line 1789 "../src/BatchImport.vala"
					_tmp106_ = batch_import_job_get_source_identifier (_tmp105_);
#line 1789 "../src/BatchImport.vala"
					_tmp107_ = _tmp106_;
#line 1789 "../src/BatchImport.vala"
					_tmp108_ = prepared_file;
#line 1789 "../src/BatchImport.vala"
					_tmp109_ = _tmp108_->file;
#line 1789 "../src/BatchImport.vala"
					_tmp110_ = g_file_get_path (_tmp109_);
#line 1789 "../src/BatchImport.vala"
					_tmp111_ = _tmp110_;
#line 1789 "../src/BatchImport.vala"
					background_import_job_report_failure (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_BACKGROUND_IMPORT_JOB, BackgroundImportJob), _tmp101_, _tmp103_, _tmp107_, _tmp111_, _result_);
#line 1789 "../src/BatchImport.vala"
					_g_free0 (_tmp111_);
#line 1789 "../src/BatchImport.vala"
					_g_free0 (_tmp107_);
#line 1788 "../src/BatchImport.vala"
					_prepared_file_unref0 (prepared_file);
#line 14369 "BatchImport.c"
				}
			}
		}
	}
#line 1729 "../src/BatchImport.vala"
	_g_object_unref0 (list);
#line 1729 "../src/BatchImport.vala"
	_g_timer_destroy0 (timer);
#line 14378 "BatchImport.c"
}

static gboolean
prepare_files_job_create_file (PrepareFilesJob* self,
                               BatchImportJob* job,
                               GFile** file,
                               gboolean* copy_to_library)
{
	GFile* _vala_file = NULL;
	gboolean _vala_copy_to_library = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 1798 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_PREPARE_FILES_JOB (self), FALSE);
#line 1798 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_BATCH_IMPORT_JOB (job), FALSE);
#line 14395 "BatchImport.c"
	{
		gboolean _tmp0_ = FALSE;
		GFile* _tmp1_ = NULL;
		gboolean _tmp2_ = FALSE;
		gboolean _tmp3_;
#line 1800 "../src/BatchImport.vala"
		_tmp3_ = batch_import_job_prepare (job, &_tmp1_, &_tmp2_, &_inner_error0_);
#line 1800 "../src/BatchImport.vala"
		_g_object_unref0 (_vala_file);
#line 1800 "../src/BatchImport.vala"
		_vala_file = _tmp1_;
#line 1800 "../src/BatchImport.vala"
		_vala_copy_to_library = _tmp2_;
#line 1800 "../src/BatchImport.vala"
		_tmp0_ = _tmp3_;
#line 1800 "../src/BatchImport.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 14413 "BatchImport.c"
			goto __catch0_g_error;
		}
#line 1800 "../src/BatchImport.vala"
		if (!_tmp0_) {
#line 14418 "BatchImport.c"
			gchar* _tmp4_;
			gchar* _tmp5_;
			gchar* _tmp6_;
			gchar* _tmp7_;
#line 1801 "../src/BatchImport.vala"
			_tmp4_ = batch_import_job_get_source_identifier (job);
#line 1801 "../src/BatchImport.vala"
			_tmp5_ = _tmp4_;
#line 1801 "../src/BatchImport.vala"
			_tmp6_ = batch_import_job_get_dest_identifier (job);
#line 1801 "../src/BatchImport.vala"
			_tmp7_ = _tmp6_;
#line 1801 "../src/BatchImport.vala"
			background_import_job_report_failure (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_BACKGROUND_IMPORT_JOB, BackgroundImportJob), job, NULL, _tmp5_, _tmp7_, IMPORT_RESULT_FILE_ERROR);
#line 1801 "../src/BatchImport.vala"
			_g_free0 (_tmp7_);
#line 1801 "../src/BatchImport.vala"
			_g_free0 (_tmp5_);
#line 1804 "../src/BatchImport.vala"
			result = FALSE;
#line 1804 "../src/BatchImport.vala"
			if (file) {
#line 1804 "../src/BatchImport.vala"
				*file = _vala_file;
#line 14443 "BatchImport.c"
			} else {
#line 1804 "../src/BatchImport.vala"
				_g_object_unref0 (_vala_file);
#line 14447 "BatchImport.c"
			}
#line 1804 "../src/BatchImport.vala"
			if (copy_to_library) {
#line 1804 "../src/BatchImport.vala"
				*copy_to_library = _vala_copy_to_library;
#line 14453 "BatchImport.c"
			}
#line 1804 "../src/BatchImport.vala"
			return result;
#line 14457 "BatchImport.c"
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		GError* _tmp12_;
#line 1799 "../src/BatchImport.vala"
		err = _inner_error0_;
#line 1799 "../src/BatchImport.vala"
		_inner_error0_ = NULL;
#line 1807 "../src/BatchImport.vala"
		_tmp8_ = batch_import_job_get_source_identifier (job);
#line 1807 "../src/BatchImport.vala"
		_tmp9_ = _tmp8_;
#line 1807 "../src/BatchImport.vala"
		_tmp10_ = batch_import_job_get_dest_identifier (job);
#line 1807 "../src/BatchImport.vala"
		_tmp11_ = _tmp10_;
#line 1807 "../src/BatchImport.vala"
		_tmp12_ = err;
#line 1807 "../src/BatchImport.vala"
		background_import_job_report_error (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_BACKGROUND_IMPORT_JOB, BackgroundImportJob), job, NULL, _tmp9_, _tmp11_, _tmp12_, IMPORT_RESULT_FILE_ERROR);
#line 1807 "../src/BatchImport.vala"
		_g_free0 (_tmp11_);
#line 1807 "../src/BatchImport.vala"
		_g_free0 (_tmp9_);
#line 1810 "../src/BatchImport.vala"
		result = FALSE;
#line 1810 "../src/BatchImport.vala"
		_g_error_free0 (err);
#line 1810 "../src/BatchImport.vala"
		if (file) {
#line 1810 "../src/BatchImport.vala"
			*file = _vala_file;
#line 14497 "BatchImport.c"
		} else {
#line 1810 "../src/BatchImport.vala"
			_g_object_unref0 (_vala_file);
#line 14501 "BatchImport.c"
		}
#line 1810 "../src/BatchImport.vala"
		if (copy_to_library) {
#line 1810 "../src/BatchImport.vala"
			*copy_to_library = _vala_copy_to_library;
#line 14507 "BatchImport.c"
		}
#line 1810 "../src/BatchImport.vala"
		return result;
#line 14511 "BatchImport.c"
	}
	__finally0:
#line 1799 "../src/BatchImport.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 14516 "BatchImport.c"
		gboolean _tmp13_ = FALSE;
#line 1799 "../src/BatchImport.vala"
		_g_object_unref0 (_vala_file);
#line 1799 "../src/BatchImport.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1799 "../src/BatchImport.vala"
		g_clear_error (&_inner_error0_);
#line 1799 "../src/BatchImport.vala"
		return _tmp13_;
#line 14526 "BatchImport.c"
	}
#line 1812 "../src/BatchImport.vala"
	result = TRUE;
#line 1812 "../src/BatchImport.vala"
	if (file) {
#line 1812 "../src/BatchImport.vala"
		*file = _vala_file;
#line 14534 "BatchImport.c"
	} else {
#line 1812 "../src/BatchImport.vala"
		_g_object_unref0 (_vala_file);
#line 14538 "BatchImport.c"
	}
#line 1812 "../src/BatchImport.vala"
	if (copy_to_library) {
#line 1812 "../src/BatchImport.vala"
		*copy_to_library = _vala_copy_to_library;
#line 14544 "BatchImport.c"
	}
#line 1812 "../src/BatchImport.vala"
	return result;
#line 14548 "BatchImport.c"
}

static ImportResult
prepare_files_job_prepare_file (PrepareFilesJob* self,
                                BatchImportJob* job,
                                GFile* file,
                                GFile* associated_file,
                                gboolean copy_to_library,
                                PreparedFile** prepared_file)
{
	PreparedFile* _vala_prepared_file = NULL;
	gboolean is_video = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gint _tmp2_;
	gchar* exif_only_md5 = NULL;
	gchar* thumbnail_md5 = NULL;
	gchar* full_md5 = NULL;
	PhotoFileFormat file_format = 0;
	guint64 filesize = 0ULL;
	gboolean is_in_library_dir = FALSE;
	GFile* _tmp39_;
	gboolean _tmp40_ = FALSE;
	gchar* _tmp41_;
	gchar* _tmp42_;
	gchar* _tmp43_;
	gchar* _tmp44_;
	const gchar* _tmp45_;
	const gchar* _tmp46_;
	const gchar* _tmp47_;
	PreparedFile* _tmp48_;
	GError* _inner_error0_ = NULL;
	ImportResult result;
#line 1815 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_PREPARE_FILES_JOB (self), 0);
#line 1815 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_BATCH_IMPORT_JOB (job), 0);
#line 1815 "../src/BatchImport.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (file, g_file_get_type ()), 0);
#line 1815 "../src/BatchImport.vala"
	g_return_val_if_fail ((associated_file == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (associated_file, g_file_get_type ()), 0);
#line 1817 "../src/BatchImport.vala"
	_prepared_file_unref0 (_vala_prepared_file);
#line 1817 "../src/BatchImport.vala"
	_vala_prepared_file = NULL;
#line 1819 "../src/BatchImport.vala"
	is_video = video_reader_is_supported_video_file (file);
#line 1821 "../src/BatchImport.vala"
	if (!is_video) {
#line 1821 "../src/BatchImport.vala"
		_tmp0_ = !photo_is_file_image (file);
#line 14600 "BatchImport.c"
	} else {
#line 1821 "../src/BatchImport.vala"
		_tmp0_ = FALSE;
#line 14604 "BatchImport.c"
	}
#line 1821 "../src/BatchImport.vala"
	if (_tmp0_) {
#line 1822 "../src/BatchImport.vala"
		result = IMPORT_RESULT_NOT_AN_IMAGE;
#line 1822 "../src/BatchImport.vala"
		if (prepared_file) {
#line 1822 "../src/BatchImport.vala"
			*prepared_file = _vala_prepared_file;
#line 14614 "BatchImport.c"
		} else {
#line 1822 "../src/BatchImport.vala"
			_prepared_file_unref0 (_vala_prepared_file);
#line 14618 "BatchImport.c"
		}
#line 1822 "../src/BatchImport.vala"
		return result;
#line 14622 "BatchImport.c"
	}
#line 1824 "../src/BatchImport.vala"
	if (!is_video) {
#line 1824 "../src/BatchImport.vala"
		_tmp1_ = !photo_file_format_is_file_supported (file);
#line 14628 "BatchImport.c"
	} else {
#line 1824 "../src/BatchImport.vala"
		_tmp1_ = FALSE;
#line 14632 "BatchImport.c"
	}
#line 1824 "../src/BatchImport.vala"
	if (_tmp1_) {
#line 1825 "../src/BatchImport.vala"
		result = IMPORT_RESULT_UNSUPPORTED_FORMAT;
#line 1825 "../src/BatchImport.vala"
		if (prepared_file) {
#line 1825 "../src/BatchImport.vala"
			*prepared_file = _vala_prepared_file;
#line 14642 "BatchImport.c"
		} else {
#line 1825 "../src/BatchImport.vala"
			_prepared_file_unref0 (_vala_prepared_file);
#line 14646 "BatchImport.c"
		}
#line 1825 "../src/BatchImport.vala"
		return result;
#line 14650 "BatchImport.c"
	}
#line 1827 "../src/BatchImport.vala"
	_tmp2_ = self->priv->import_file_count;
#line 1827 "../src/BatchImport.vala"
	self->priv->import_file_count = _tmp2_ + 1;
#line 1830 "../src/BatchImport.vala"
	if (self->priv->fail_every > 0) {
#line 1831 "../src/BatchImport.vala"
		if ((self->priv->import_file_count % self->priv->fail_every) == 0) {
#line 1832 "../src/BatchImport.vala"
			result = IMPORT_RESULT_FILE_ERROR;
#line 1832 "../src/BatchImport.vala"
			if (prepared_file) {
#line 1832 "../src/BatchImport.vala"
				*prepared_file = _vala_prepared_file;
#line 14666 "BatchImport.c"
			} else {
#line 1832 "../src/BatchImport.vala"
				_prepared_file_unref0 (_vala_prepared_file);
#line 14670 "BatchImport.c"
			}
#line 1832 "../src/BatchImport.vala"
			return result;
#line 14674 "BatchImport.c"
		}
	}
#line 1836 "../src/BatchImport.vala"
	if (self->priv->skip_every > 0) {
#line 1837 "../src/BatchImport.vala"
		if ((self->priv->import_file_count % self->priv->skip_every) == 0) {
#line 1838 "../src/BatchImport.vala"
			result = IMPORT_RESULT_NOT_A_FILE;
#line 1838 "../src/BatchImport.vala"
			if (prepared_file) {
#line 1838 "../src/BatchImport.vala"
				*prepared_file = _vala_prepared_file;
#line 14687 "BatchImport.c"
			} else {
#line 1838 "../src/BatchImport.vala"
				_prepared_file_unref0 (_vala_prepared_file);
#line 14691 "BatchImport.c"
			}
#line 1838 "../src/BatchImport.vala"
			return result;
#line 14695 "BatchImport.c"
		}
	}
#line 1841 "../src/BatchImport.vala"
	exif_only_md5 = NULL;
#line 1842 "../src/BatchImport.vala"
	thumbnail_md5 = NULL;
#line 1843 "../src/BatchImport.vala"
	full_md5 = NULL;
#line 14704 "BatchImport.c"
	{
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 1846 "../src/BatchImport.vala"
		_tmp4_ = md5_file (file, &_inner_error0_);
#line 1846 "../src/BatchImport.vala"
		_tmp3_ = _tmp4_;
#line 1846 "../src/BatchImport.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 14715 "BatchImport.c"
			goto __catch0_g_error;
		}
#line 1846 "../src/BatchImport.vala"
		_tmp5_ = _tmp3_;
#line 1846 "../src/BatchImport.vala"
		_tmp3_ = NULL;
#line 1846 "../src/BatchImport.vala"
		_g_free0 (full_md5);
#line 1846 "../src/BatchImport.vala"
		full_md5 = _tmp5_;
#line 1845 "../src/BatchImport.vala"
		_g_free0 (_tmp3_);
#line 14728 "BatchImport.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		gchar* _tmp6_;
		gchar* _tmp7_;
		GError* _tmp8_;
		const gchar* _tmp9_;
		GError* _tmp10_;
#line 1845 "../src/BatchImport.vala"
		err = _inner_error0_;
#line 1845 "../src/BatchImport.vala"
		_inner_error0_ = NULL;
#line 1851 "../src/BatchImport.vala"
		_tmp6_ = g_file_get_path (file);
#line 1851 "../src/BatchImport.vala"
		_tmp7_ = _tmp6_;
#line 1851 "../src/BatchImport.vala"
		_tmp8_ = err;
#line 1851 "../src/BatchImport.vala"
		_tmp9_ = _tmp8_->message;
#line 1851 "../src/BatchImport.vala"
		g_warning ("BatchImport.vala:1851: Unable to perform MD5 checksum on file %s: %s", _tmp7_, _tmp9_);
#line 1851 "../src/BatchImport.vala"
		_g_free0 (_tmp7_);
#line 1854 "../src/BatchImport.vala"
		_tmp10_ = err;
#line 1854 "../src/BatchImport.vala"
		result = import_result_convert_error (_tmp10_, IMPORT_RESULT_FILE_ERROR);
#line 1854 "../src/BatchImport.vala"
		_g_error_free0 (err);
#line 1854 "../src/BatchImport.vala"
		_g_free0 (full_md5);
#line 1854 "../src/BatchImport.vala"
		_g_free0 (thumbnail_md5);
#line 1854 "../src/BatchImport.vala"
		_g_free0 (exif_only_md5);
#line 1854 "../src/BatchImport.vala"
		if (prepared_file) {
#line 1854 "../src/BatchImport.vala"
			*prepared_file = _vala_prepared_file;
#line 14771 "BatchImport.c"
		} else {
#line 1854 "../src/BatchImport.vala"
			_prepared_file_unref0 (_vala_prepared_file);
#line 14775 "BatchImport.c"
		}
#line 1854 "../src/BatchImport.vala"
		return result;
#line 14779 "BatchImport.c"
	}
	__finally0:
#line 1845 "../src/BatchImport.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1845 "../src/BatchImport.vala"
		_g_free0 (full_md5);
#line 1845 "../src/BatchImport.vala"
		_g_free0 (thumbnail_md5);
#line 1845 "../src/BatchImport.vala"
		_g_free0 (exif_only_md5);
#line 1845 "../src/BatchImport.vala"
		_prepared_file_unref0 (_vala_prepared_file);
#line 1845 "../src/BatchImport.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1845 "../src/BatchImport.vala"
		g_clear_error (&_inner_error0_);
#line 1845 "../src/BatchImport.vala"
		return 0;
#line 14798 "BatchImport.c"
	}
#line 1859 "../src/BatchImport.vala"
	file_format = photo_file_format_get_by_file_extension (file);
#line 1860 "../src/BatchImport.vala"
	if (!is_video) {
#line 14804 "BatchImport.c"
		PhotoFileReader* reader = NULL;
		gchar* _tmp13_;
		gchar* _tmp14_;
		PhotoFileReader* _tmp15_;
		PhotoFileReader* _tmp16_;
		PhotoMetadata* metadata = NULL;
		PhotoMetadata* _tmp25_;
#line 1861 "../src/BatchImport.vala"
		if (file_format == PHOTO_FILE_FORMAT_UNKNOWN) {
#line 14814 "BatchImport.c"
			gchar* _tmp11_;
			gchar* _tmp12_;
#line 1862 "../src/BatchImport.vala"
			_tmp11_ = g_file_get_path (file);
#line 1862 "../src/BatchImport.vala"
			_tmp12_ = _tmp11_;
#line 1862 "../src/BatchImport.vala"
			g_warning ("BatchImport.vala:1862: Skipping %s: unrecognized file extension", _tmp12_);
#line 1862 "../src/BatchImport.vala"
			_g_free0 (_tmp12_);
#line 1864 "../src/BatchImport.vala"
			result = IMPORT_RESULT_UNSUPPORTED_FORMAT;
#line 1864 "../src/BatchImport.vala"
			_g_free0 (full_md5);
#line 1864 "../src/BatchImport.vala"
			_g_free0 (thumbnail_md5);
#line 1864 "../src/BatchImport.vala"
			_g_free0 (exif_only_md5);
#line 1864 "../src/BatchImport.vala"
			if (prepared_file) {
#line 1864 "../src/BatchImport.vala"
				*prepared_file = _vala_prepared_file;
#line 14837 "BatchImport.c"
			} else {
#line 1864 "../src/BatchImport.vala"
				_prepared_file_unref0 (_vala_prepared_file);
#line 14841 "BatchImport.c"
			}
#line 1864 "../src/BatchImport.vala"
			return result;
#line 14845 "BatchImport.c"
		}
#line 1866 "../src/BatchImport.vala"
		_tmp13_ = g_file_get_path (file);
#line 1866 "../src/BatchImport.vala"
		_tmp14_ = _tmp13_;
#line 1866 "../src/BatchImport.vala"
		_tmp15_ = photo_file_format_create_reader (file_format, _tmp14_);
#line 1866 "../src/BatchImport.vala"
		_tmp16_ = _tmp15_;
#line 1866 "../src/BatchImport.vala"
		_g_free0 (_tmp14_);
#line 1866 "../src/BatchImport.vala"
		reader = _tmp16_;
#line 1867 "../src/BatchImport.vala"
		metadata = NULL;
#line 14861 "BatchImport.c"
		{
			PhotoMetadata* _tmp17_ = NULL;
			PhotoFileReader* _tmp18_;
			PhotoMetadata* _tmp19_;
			PhotoMetadata* _tmp20_;
#line 1869 "../src/BatchImport.vala"
			_tmp18_ = reader;
#line 1869 "../src/BatchImport.vala"
			_tmp19_ = photo_file_reader_read_metadata (_tmp18_, &_inner_error0_);
#line 1869 "../src/BatchImport.vala"
			_tmp17_ = _tmp19_;
#line 1869 "../src/BatchImport.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 14875 "BatchImport.c"
				goto __catch1_g_error;
			}
#line 1869 "../src/BatchImport.vala"
			_tmp20_ = _tmp17_;
#line 1869 "../src/BatchImport.vala"
			_tmp17_ = NULL;
#line 1869 "../src/BatchImport.vala"
			_media_metadata_unref0 (metadata);
#line 1869 "../src/BatchImport.vala"
			metadata = _tmp20_;
#line 1868 "../src/BatchImport.vala"
			_media_metadata_unref0 (_tmp17_);
#line 14888 "BatchImport.c"
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* err = NULL;
			gchar* _tmp21_;
			gchar* _tmp22_;
			GError* _tmp23_;
			const gchar* _tmp24_;
#line 1868 "../src/BatchImport.vala"
			err = _inner_error0_;
#line 1868 "../src/BatchImport.vala"
			_inner_error0_ = NULL;
#line 1871 "../src/BatchImport.vala"
			_tmp21_ = g_file_get_path (file);
#line 1871 "../src/BatchImport.vala"
			_tmp22_ = _tmp21_;
#line 1871 "../src/BatchImport.vala"
			_tmp23_ = err;
#line 1871 "../src/BatchImport.vala"
			_tmp24_ = _tmp23_->message;
#line 1871 "../src/BatchImport.vala"
			g_warning ("BatchImport.vala:1871: Unable to read metadata for %s (%s): continuing" \
" to attempt import", _tmp22_, _tmp24_);
#line 1871 "../src/BatchImport.vala"
			_g_free0 (_tmp22_);
#line 1868 "../src/BatchImport.vala"
			_g_error_free0 (err);
#line 14916 "BatchImport.c"
		}
		__finally1:
#line 1868 "../src/BatchImport.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1868 "../src/BatchImport.vala"
			_media_metadata_unref0 (metadata);
#line 1868 "../src/BatchImport.vala"
			_photo_file_adapter_unref0 (reader);
#line 1868 "../src/BatchImport.vala"
			_g_free0 (full_md5);
#line 1868 "../src/BatchImport.vala"
			_g_free0 (thumbnail_md5);
#line 1868 "../src/BatchImport.vala"
			_g_free0 (exif_only_md5);
#line 1868 "../src/BatchImport.vala"
			_prepared_file_unref0 (_vala_prepared_file);
#line 1868 "../src/BatchImport.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1868 "../src/BatchImport.vala"
			g_clear_error (&_inner_error0_);
#line 1868 "../src/BatchImport.vala"
			return 0;
#line 14939 "BatchImport.c"
		}
#line 1875 "../src/BatchImport.vala"
		_tmp25_ = metadata;
#line 1875 "../src/BatchImport.vala"
		if (_tmp25_ != NULL) {
#line 14945 "BatchImport.c"
			PhotoMetadata* _tmp26_;
			gchar* _tmp27_;
			PhotoMetadata* _tmp28_;
			gchar* _tmp29_;
#line 1876 "../src/BatchImport.vala"
			_tmp26_ = metadata;
#line 1876 "../src/BatchImport.vala"
			_tmp27_ = photo_metadata_exif_hash (_tmp26_);
#line 1876 "../src/BatchImport.vala"
			_g_free0 (exif_only_md5);
#line 1876 "../src/BatchImport.vala"
			exif_only_md5 = _tmp27_;
#line 1877 "../src/BatchImport.vala"
			_tmp28_ = metadata;
#line 1877 "../src/BatchImport.vala"
			_tmp29_ = photo_metadata_thumbnail_hash (_tmp28_);
#line 1877 "../src/BatchImport.vala"
			_g_free0 (thumbnail_md5);
#line 1877 "../src/BatchImport.vala"
			thumbnail_md5 = _tmp29_;
#line 14966 "BatchImport.c"
		}
#line 1860 "../src/BatchImport.vala"
		_media_metadata_unref0 (metadata);
#line 1860 "../src/BatchImport.vala"
		_photo_file_adapter_unref0 (reader);
#line 14972 "BatchImport.c"
	}
#line 1881 "../src/BatchImport.vala"
	filesize = (guint64) 0;
#line 14976 "BatchImport.c"
	{
		guint64 _tmp30_ = 0ULL;
		GCancellable* _tmp31_;
		GCancellable* _tmp32_;
		guint64 _tmp33_;
#line 1883 "../src/BatchImport.vala"
		_tmp31_ = background_job_get_cancellable (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_BACKGROUND_JOB, BackgroundJob));
#line 1883 "../src/BatchImport.vala"
		_tmp32_ = _tmp31_;
#line 1883 "../src/BatchImport.vala"
		_tmp33_ = query_total_file_size (file, _tmp32_, &_inner_error0_);
#line 1883 "../src/BatchImport.vala"
		_g_object_unref0 (_tmp32_);
#line 1883 "../src/BatchImport.vala"
		_tmp30_ = _tmp33_;
#line 1883 "../src/BatchImport.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 14994 "BatchImport.c"
			goto __catch2_g_error;
		}
#line 1883 "../src/BatchImport.vala"
		filesize = _tmp30_;
#line 14999 "BatchImport.c"
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError* err = NULL;
		gchar* _tmp34_;
		gchar* _tmp35_;
		GError* _tmp36_;
		const gchar* _tmp37_;
		GError* _tmp38_;
#line 1882 "../src/BatchImport.vala"
		err = _inner_error0_;
#line 1882 "../src/BatchImport.vala"
		_inner_error0_ = NULL;
#line 1885 "../src/BatchImport.vala"
		_tmp34_ = g_file_get_path (file);
#line 1885 "../src/BatchImport.vala"
		_tmp35_ = _tmp34_;
#line 1885 "../src/BatchImport.vala"
		_tmp36_ = err;
#line 1885 "../src/BatchImport.vala"
		_tmp37_ = _tmp36_->message;
#line 1885 "../src/BatchImport.vala"
		g_warning ("BatchImport.vala:1885: Unable to query file size of %s: %s", _tmp35_, _tmp37_);
#line 1885 "../src/BatchImport.vala"
		_g_free0 (_tmp35_);
#line 1887 "../src/BatchImport.vala"
		_tmp38_ = err;
#line 1887 "../src/BatchImport.vala"
		result = import_result_convert_error (_tmp38_, IMPORT_RESULT_FILE_ERROR);
#line 1887 "../src/BatchImport.vala"
		_g_error_free0 (err);
#line 1887 "../src/BatchImport.vala"
		_g_free0 (full_md5);
#line 1887 "../src/BatchImport.vala"
		_g_free0 (thumbnail_md5);
#line 1887 "../src/BatchImport.vala"
		_g_free0 (exif_only_md5);
#line 1887 "../src/BatchImport.vala"
		if (prepared_file) {
#line 1887 "../src/BatchImport.vala"
			*prepared_file = _vala_prepared_file;
#line 15042 "BatchImport.c"
		} else {
#line 1887 "../src/BatchImport.vala"
			_prepared_file_unref0 (_vala_prepared_file);
#line 15046 "BatchImport.c"
		}
#line 1887 "../src/BatchImport.vala"
		return result;
#line 15050 "BatchImport.c"
	}
	__finally2:
#line 1882 "../src/BatchImport.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1882 "../src/BatchImport.vala"
		_g_free0 (full_md5);
#line 1882 "../src/BatchImport.vala"
		_g_free0 (thumbnail_md5);
#line 1882 "../src/BatchImport.vala"
		_g_free0 (exif_only_md5);
#line 1882 "../src/BatchImport.vala"
		_prepared_file_unref0 (_vala_prepared_file);
#line 1882 "../src/BatchImport.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1882 "../src/BatchImport.vala"
		g_clear_error (&_inner_error0_);
#line 1882 "../src/BatchImport.vala"
		return 0;
#line 15069 "BatchImport.c"
	}
#line 1891 "../src/BatchImport.vala"
	_tmp39_ = self->priv->library_dir;
#line 1891 "../src/BatchImport.vala"
	is_in_library_dir = g_file_has_prefix (file, _tmp39_);
#line 1895 "../src/BatchImport.vala"
	if (copy_to_library) {
#line 1895 "../src/BatchImport.vala"
		_tmp40_ = !is_in_library_dir;
#line 15079 "BatchImport.c"
	} else {
#line 1895 "../src/BatchImport.vala"
		_tmp40_ = FALSE;
#line 15083 "BatchImport.c"
	}
#line 1894 "../src/BatchImport.vala"
	_tmp41_ = batch_import_job_get_source_identifier (job);
#line 1894 "../src/BatchImport.vala"
	_tmp42_ = _tmp41_;
#line 1894 "../src/BatchImport.vala"
	_tmp43_ = batch_import_job_get_dest_identifier (job);
#line 1894 "../src/BatchImport.vala"
	_tmp44_ = _tmp43_;
#line 1894 "../src/BatchImport.vala"
	_tmp45_ = exif_only_md5;
#line 1894 "../src/BatchImport.vala"
	_tmp46_ = thumbnail_md5;
#line 1894 "../src/BatchImport.vala"
	_tmp47_ = full_md5;
#line 1894 "../src/BatchImport.vala"
	_tmp48_ = prepared_file_new (job, file, associated_file, _tmp42_, _tmp44_, _tmp40_, _tmp45_, _tmp46_, _tmp47_, file_format, filesize, is_video);
#line 1894 "../src/BatchImport.vala"
	_prepared_file_unref0 (_vala_prepared_file);
#line 1894 "../src/BatchImport.vala"
	_vala_prepared_file = _tmp48_;
#line 1894 "../src/BatchImport.vala"
	_g_free0 (_tmp44_);
#line 1894 "../src/BatchImport.vala"
	_g_free0 (_tmp42_);
#line 1898 "../src/BatchImport.vala"
	result = IMPORT_RESULT_SUCCESS;
#line 1898 "../src/BatchImport.vala"
	_g_free0 (full_md5);
#line 1898 "../src/BatchImport.vala"
	_g_free0 (thumbnail_md5);
#line 1898 "../src/BatchImport.vala"
	_g_free0 (exif_only_md5);
#line 1898 "../src/BatchImport.vala"
	if (prepared_file) {
#line 1898 "../src/BatchImport.vala"
		*prepared_file = _vala_prepared_file;
#line 15121 "BatchImport.c"
	} else {
#line 1898 "../src/BatchImport.vala"
		_prepared_file_unref0 (_vala_prepared_file);
#line 15125 "BatchImport.c"
	}
#line 1898 "../src/BatchImport.vala"
	return result;
#line 15129 "BatchImport.c"
}

static void
prepare_files_job_class_init (PrepareFilesJobClass * klass,
                              gpointer klass_data)
{
#line 1696 "../src/BatchImport.vala"
	prepare_files_job_parent_class = g_type_class_peek_parent (klass);
#line 1696 "../src/BatchImport.vala"
	((BackgroundJobClass *) klass)->finalize = prepare_files_job_finalize;
#line 1696 "../src/BatchImport.vala"
	g_type_class_adjust_private_offset (klass, &PrepareFilesJob_private_offset);
#line 1696 "../src/BatchImport.vala"
	((BackgroundJobClass *) klass)->execute = (void (*) (BackgroundJob*)) prepare_files_job_real_execute;
#line 15144 "BatchImport.c"
}

static void
prepare_files_job_instance_init (PrepareFilesJob * self,
                                 gpointer klass)
{
#line 1696 "../src/BatchImport.vala"
	self->priv = prepare_files_job_get_instance_private (self);
#line 1698 "../src/BatchImport.vala"
	self->prepared_files = 0;
#line 1705 "../src/BatchImport.vala"
	self->priv->import_file_count = 0;
#line 1706 "../src/BatchImport.vala"
	self->priv->fail_every = 0;
#line 1707 "../src/BatchImport.vala"
	self->priv->skip_every = 0;
#line 15161 "BatchImport.c"
}

static void
prepare_files_job_finalize (BackgroundJob * obj)
{
	PrepareFilesJob * self;
#line 1696 "../src/BatchImport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PREPARE_FILES_JOB, PrepareFilesJob);
#line 1700 "../src/BatchImport.vala"
	_g_object_unref0 (self->priv->files_to_prepare);
#line 1702 "../src/BatchImport.vala"
	_g_object_unref0 (self->priv->library_dir);
#line 1696 "../src/BatchImport.vala"
	BACKGROUND_JOB_CLASS (prepare_files_job_parent_class)->finalize (obj);
#line 15176 "BatchImport.c"
}

static GType
prepare_files_job_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PrepareFilesJobClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) prepare_files_job_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PrepareFilesJob), 0, (GInstanceInitFunc) prepare_files_job_instance_init, NULL };
	GType prepare_files_job_type_id;
	prepare_files_job_type_id = g_type_register_static (TYPE_BACKGROUND_IMPORT_JOB, "PrepareFilesJob", &g_define_type_info, 0);
	PrepareFilesJob_private_offset = g_type_add_instance_private (prepare_files_job_type_id, sizeof (PrepareFilesJobPrivate));
	return prepare_files_job_type_id;
}

GType
prepare_files_job_get_type (void)
{
	static volatile gsize prepare_files_job_type_id__once = 0;
	if (g_once_init_enter (&prepare_files_job_type_id__once)) {
		GType prepare_files_job_type_id;
		prepare_files_job_type_id = prepare_files_job_get_type_once ();
		g_once_init_leave (&prepare_files_job_type_id__once, prepare_files_job_type_id);
	}
	return prepare_files_job_type_id__once;
}

static gpointer
_prepared_file_ref0 (gpointer self)
{
#line 1919 "../src/BatchImport.vala"
	return self ? prepared_file_ref (self) : NULL;
#line 15206 "BatchImport.c"
}

static gpointer
_batch_import_result_ref0 (gpointer self)
{
#line 1920 "../src/BatchImport.vala"
	return self ? batch_import_result_ref (self) : NULL;
#line 15214 "BatchImport.c"
}

static gpointer
_video_import_params_ref0 (gpointer self)
{
#line 1921 "../src/BatchImport.vala"
	return self ? video_import_params_ref (self) : NULL;
#line 15222 "BatchImport.c"
}

static gpointer
_photo_import_params_ref0 (gpointer self)
{
#line 1922 "../src/BatchImport.vala"
	return self ? photo_import_params_ref (self) : NULL;
#line 15230 "BatchImport.c"
}

ReadyForImport*
ready_for_import_construct (GType object_type,
                            GFile* final_file,
                            PreparedFile* prepared_file,
                            PhotoImportParams* photo_import_params,
                            VideoImportParams* video_import_params,
                            BatchImportResult* batch_result)
{
	ReadyForImport* self = NULL;
	GFile* _tmp2_;
	PreparedFile* _tmp3_;
	BatchImportResult* _tmp4_;
	VideoImportParams* _tmp5_;
	PhotoImportParams* _tmp6_;
#line 1910 "../src/BatchImport.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (final_file, g_file_get_type ()), NULL);
#line 1910 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_PREPARED_FILE (prepared_file), NULL);
#line 1910 "../src/BatchImport.vala"
	g_return_val_if_fail ((photo_import_params == NULL) || IS_PHOTO_IMPORT_PARAMS (photo_import_params), NULL);
#line 1910 "../src/BatchImport.vala"
	g_return_val_if_fail ((video_import_params == NULL) || IS_VIDEO_IMPORT_PARAMS (video_import_params), NULL);
#line 1910 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_BATCH_IMPORT_RESULT (batch_result), NULL);
#line 1910 "../src/BatchImport.vala"
	self = (ReadyForImport*) g_type_create_instance (object_type);
#line 1913 "../src/BatchImport.vala"
	if (prepared_file->is_video) {
#line 15261 "BatchImport.c"
		gboolean _tmp0_ = FALSE;
#line 1914 "../src/BatchImport.vala"
		if (video_import_params != NULL) {
#line 1914 "../src/BatchImport.vala"
			_tmp0_ = photo_import_params == NULL;
#line 15267 "BatchImport.c"
		} else {
#line 1914 "../src/BatchImport.vala"
			_tmp0_ = FALSE;
#line 15271 "BatchImport.c"
		}
#line 1914 "../src/BatchImport.vala"
		_vala_assert (_tmp0_, "(video_import_params != null) && (photo_import_params == null)");
#line 15275 "BatchImport.c"
	} else {
		gboolean _tmp1_ = FALSE;
#line 1916 "../src/BatchImport.vala"
		if (video_import_params == NULL) {
#line 1916 "../src/BatchImport.vala"
			_tmp1_ = photo_import_params != NULL;
#line 15282 "BatchImport.c"
		} else {
#line 1916 "../src/BatchImport.vala"
			_tmp1_ = FALSE;
#line 15286 "BatchImport.c"
		}
#line 1916 "../src/BatchImport.vala"
		_vala_assert (_tmp1_, "(video_import_params == null) && (photo_import_params != null)");
#line 15290 "BatchImport.c"
	}
#line 1918 "../src/BatchImport.vala"
	_tmp2_ = _g_object_ref0 (final_file);
#line 1918 "../src/BatchImport.vala"
	_g_object_unref0 (self->final_file);
#line 1918 "../src/BatchImport.vala"
	self->final_file = _tmp2_;
#line 1919 "../src/BatchImport.vala"
	_tmp3_ = _prepared_file_ref0 (prepared_file);
#line 1919 "../src/BatchImport.vala"
	_prepared_file_unref0 (self->prepared_file);
#line 1919 "../src/BatchImport.vala"
	self->prepared_file = _tmp3_;
#line 1920 "../src/BatchImport.vala"
	_tmp4_ = _batch_import_result_ref0 (batch_result);
#line 1920 "../src/BatchImport.vala"
	_batch_import_result_unref0 (self->batch_result);
#line 1920 "../src/BatchImport.vala"
	self->batch_result = _tmp4_;
#line 1921 "../src/BatchImport.vala"
	_tmp5_ = _video_import_params_ref0 (video_import_params);
#line 1921 "../src/BatchImport.vala"
	_video_import_params_unref0 (self->video_import_params);
#line 1921 "../src/BatchImport.vala"
	self->video_import_params = _tmp5_;
#line 1922 "../src/BatchImport.vala"
	_tmp6_ = _photo_import_params_ref0 (photo_import_params);
#line 1922 "../src/BatchImport.vala"
	_photo_import_params_unref0 (self->photo_import_params);
#line 1922 "../src/BatchImport.vala"
	self->photo_import_params = _tmp6_;
#line 1923 "../src/BatchImport.vala"
	self->is_video = prepared_file->is_video;
#line 1910 "../src/BatchImport.vala"
	return self;
#line 15326 "BatchImport.c"
}

ReadyForImport*
ready_for_import_new (GFile* final_file,
                      PreparedFile* prepared_file,
                      PhotoImportParams* photo_import_params,
                      VideoImportParams* video_import_params,
                      BatchImportResult* batch_result)
{
#line 1910 "../src/BatchImport.vala"
	return ready_for_import_construct (TYPE_READY_FOR_IMPORT, final_file, prepared_file, photo_import_params, video_import_params, batch_result);
#line 15338 "BatchImport.c"
}

BatchImportResult*
ready_for_import_abort (ReadyForImport* self)
{
	gboolean _tmp0_ = FALSE;
	GFile* _tmp1_;
	PreparedFile* _tmp14_;
	BatchImportJob* _tmp15_;
	PreparedFile* _tmp16_;
	GFile* _tmp17_;
	PreparedFile* _tmp18_;
	BatchImportJob* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	PreparedFile* _tmp22_;
	BatchImportJob* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	BatchImportResult* _tmp26_;
	BatchImportResult* _tmp27_;
	BatchImportResult* _tmp28_;
	GError* _inner_error0_ = NULL;
	BatchImportResult* result;
#line 1926 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_READY_FOR_IMPORT (self), NULL);
#line 1928 "../src/BatchImport.vala"
	_tmp1_ = self->final_file;
#line 1928 "../src/BatchImport.vala"
	if (_tmp1_ != NULL) {
#line 15369 "BatchImport.c"
		GFile* _tmp2_;
		PreparedFile* _tmp3_;
		GFile* _tmp4_;
#line 1928 "../src/BatchImport.vala"
		_tmp2_ = self->final_file;
#line 1928 "../src/BatchImport.vala"
		_tmp3_ = self->prepared_file;
#line 1928 "../src/BatchImport.vala"
		_tmp4_ = _tmp3_->file;
#line 1928 "../src/BatchImport.vala"
		_tmp0_ = _tmp2_ != _tmp4_;
#line 15381 "BatchImport.c"
	} else {
#line 1928 "../src/BatchImport.vala"
		_tmp0_ = FALSE;
#line 15385 "BatchImport.c"
	}
#line 1928 "../src/BatchImport.vala"
	if (_tmp0_) {
#line 15389 "BatchImport.c"
		GFile* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 1929 "../src/BatchImport.vala"
		_tmp5_ = self->final_file;
#line 1929 "../src/BatchImport.vala"
		_tmp6_ = g_file_get_path (_tmp5_);
#line 1929 "../src/BatchImport.vala"
		_tmp7_ = _tmp6_;
#line 1929 "../src/BatchImport.vala"
		g_debug ("BatchImport.vala:1929: Deleting aborted import copy %s", _tmp7_);
#line 1929 "../src/BatchImport.vala"
		_g_free0 (_tmp7_);
#line 15403 "BatchImport.c"
		{
			GFile* _tmp8_;
#line 1931 "../src/BatchImport.vala"
			_tmp8_ = self->final_file;
#line 1931 "../src/BatchImport.vala"
			g_file_delete (_tmp8_, NULL, &_inner_error0_);
#line 1931 "../src/BatchImport.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 15412 "BatchImport.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* err = NULL;
			GFile* _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
			GError* _tmp12_;
			const gchar* _tmp13_;
#line 1930 "../src/BatchImport.vala"
			err = _inner_error0_;
#line 1930 "../src/BatchImport.vala"
			_inner_error0_ = NULL;
#line 1933 "../src/BatchImport.vala"
			_tmp9_ = self->final_file;
#line 1933 "../src/BatchImport.vala"
			_tmp10_ = g_file_get_path (_tmp9_);
#line 1933 "../src/BatchImport.vala"
			_tmp11_ = _tmp10_;
#line 1933 "../src/BatchImport.vala"
			_tmp12_ = err;
#line 1933 "../src/BatchImport.vala"
			_tmp13_ = _tmp12_->message;
#line 1933 "../src/BatchImport.vala"
			g_warning ("BatchImport.vala:1933: Unable to delete copy of imported file (aborted" \
" import) %s: %s", _tmp11_, _tmp13_);
#line 1933 "../src/BatchImport.vala"
			_g_free0 (_tmp11_);
#line 1930 "../src/BatchImport.vala"
			_g_error_free0 (err);
#line 15445 "BatchImport.c"
		}
		__finally0:
#line 1930 "../src/BatchImport.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1930 "../src/BatchImport.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1930 "../src/BatchImport.vala"
			g_clear_error (&_inner_error0_);
#line 1930 "../src/BatchImport.vala"
			return NULL;
#line 15456 "BatchImport.c"
		}
	}
#line 1938 "../src/BatchImport.vala"
	_tmp14_ = self->prepared_file;
#line 1938 "../src/BatchImport.vala"
	_tmp15_ = _tmp14_->job;
#line 1938 "../src/BatchImport.vala"
	_tmp16_ = self->prepared_file;
#line 1938 "../src/BatchImport.vala"
	_tmp17_ = _tmp16_->file;
#line 1938 "../src/BatchImport.vala"
	_tmp18_ = self->prepared_file;
#line 1938 "../src/BatchImport.vala"
	_tmp19_ = _tmp18_->job;
#line 1938 "../src/BatchImport.vala"
	_tmp20_ = batch_import_job_get_source_identifier (_tmp19_);
#line 1938 "../src/BatchImport.vala"
	_tmp21_ = _tmp20_;
#line 1938 "../src/BatchImport.vala"
	_tmp22_ = self->prepared_file;
#line 1938 "../src/BatchImport.vala"
	_tmp23_ = _tmp22_->job;
#line 1938 "../src/BatchImport.vala"
	_tmp24_ = batch_import_job_get_dest_identifier (_tmp23_);
#line 1938 "../src/BatchImport.vala"
	_tmp25_ = _tmp24_;
#line 1938 "../src/BatchImport.vala"
	_tmp26_ = batch_import_result_new (_tmp15_, _tmp17_, _tmp21_, _tmp25_, NULL, IMPORT_RESULT_USER_ABORT);
#line 1938 "../src/BatchImport.vala"
	_batch_import_result_unref0 (self->batch_result);
#line 1938 "../src/BatchImport.vala"
	self->batch_result = _tmp26_;
#line 1938 "../src/BatchImport.vala"
	_g_free0 (_tmp25_);
#line 1938 "../src/BatchImport.vala"
	_g_free0 (_tmp21_);
#line 1942 "../src/BatchImport.vala"
	_tmp27_ = self->batch_result;
#line 1942 "../src/BatchImport.vala"
	_tmp28_ = _batch_import_result_ref0 (_tmp27_);
#line 1942 "../src/BatchImport.vala"
	result = _tmp28_;
#line 1942 "../src/BatchImport.vala"
	return result;
#line 15501 "BatchImport.c"
}

static gpointer
_thumbnails_ref0 (gpointer self)
{
#line 1946 "../src/BatchImport.vala"
	return self ? thumbnails_ref (self) : NULL;
#line 15509 "BatchImport.c"
}

Thumbnails*
ready_for_import_get_thumbnails (ReadyForImport* self)
{
	Thumbnails* _tmp0_ = NULL;
	PhotoImportParams* _tmp1_;
	Thumbnails* _tmp6_;
	Thumbnails* result;
#line 1945 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_READY_FOR_IMPORT (self), NULL);
#line 1946 "../src/BatchImport.vala"
	_tmp1_ = self->photo_import_params;
#line 1946 "../src/BatchImport.vala"
	if (_tmp1_ != NULL) {
#line 15525 "BatchImport.c"
		PhotoImportParams* _tmp2_;
		Thumbnails* _tmp3_;
#line 1946 "../src/BatchImport.vala"
		_tmp2_ = self->photo_import_params;
#line 1946 "../src/BatchImport.vala"
		_tmp3_ = _tmp2_->thumbnails;
#line 1946 "../src/BatchImport.vala"
		_tmp0_ = _tmp3_;
#line 15534 "BatchImport.c"
	} else {
		VideoImportParams* _tmp4_;
		Thumbnails* _tmp5_;
#line 1947 "../src/BatchImport.vala"
		_tmp4_ = self->video_import_params;
#line 1947 "../src/BatchImport.vala"
		_tmp5_ = _tmp4_->thumbnails;
#line 1947 "../src/BatchImport.vala"
		_tmp0_ = _tmp5_;
#line 15544 "BatchImport.c"
	}
#line 1946 "../src/BatchImport.vala"
	_tmp6_ = _thumbnails_ref0 (_tmp0_);
#line 1946 "../src/BatchImport.vala"
	result = _tmp6_;
#line 1946 "../src/BatchImport.vala"
	return result;
#line 15552 "BatchImport.c"
}

static void
value_ready_for_import_init (GValue* value)
{
#line 1902 "../src/BatchImport.vala"
	value->data[0].v_pointer = NULL;
#line 15560 "BatchImport.c"
}

static void
value_ready_for_import_free_value (GValue* value)
{
#line 1902 "../src/BatchImport.vala"
	if (value->data[0].v_pointer) {
#line 1902 "../src/BatchImport.vala"
		ready_for_import_unref (value->data[0].v_pointer);
#line 15570 "BatchImport.c"
	}
}

static void
value_ready_for_import_copy_value (const GValue* src_value,
                                   GValue* dest_value)
{
#line 1902 "../src/BatchImport.vala"
	if (src_value->data[0].v_pointer) {
#line 1902 "../src/BatchImport.vala"
		dest_value->data[0].v_pointer = ready_for_import_ref (src_value->data[0].v_pointer);
#line 15582 "BatchImport.c"
	} else {
#line 1902 "../src/BatchImport.vala"
		dest_value->data[0].v_pointer = NULL;
#line 15586 "BatchImport.c"
	}
}

static gpointer
value_ready_for_import_peek_pointer (const GValue* value)
{
#line 1902 "../src/BatchImport.vala"
	return value->data[0].v_pointer;
#line 15595 "BatchImport.c"
}

static gchar*
value_ready_for_import_collect_value (GValue* value,
                                      guint n_collect_values,
                                      GTypeCValue* collect_values,
                                      guint collect_flags)
{
#line 1902 "../src/BatchImport.vala"
	if (collect_values[0].v_pointer) {
#line 15606 "BatchImport.c"
		ReadyForImport * object;
		object = collect_values[0].v_pointer;
#line 1902 "../src/BatchImport.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1902 "../src/BatchImport.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 15613 "BatchImport.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1902 "../src/BatchImport.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 15617 "BatchImport.c"
		}
#line 1902 "../src/BatchImport.vala"
		value->data[0].v_pointer = ready_for_import_ref (object);
#line 15621 "BatchImport.c"
	} else {
#line 1902 "../src/BatchImport.vala"
		value->data[0].v_pointer = NULL;
#line 15625 "BatchImport.c"
	}
#line 1902 "../src/BatchImport.vala"
	return NULL;
#line 15629 "BatchImport.c"
}

static gchar*
value_ready_for_import_lcopy_value (const GValue* value,
                                    guint n_collect_values,
                                    GTypeCValue* collect_values,
                                    guint collect_flags)
{
	ReadyForImport ** object_p;
	object_p = collect_values[0].v_pointer;
#line 1902 "../src/BatchImport.vala"
	if (!object_p) {
#line 1902 "../src/BatchImport.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 15644 "BatchImport.c"
	}
#line 1902 "../src/BatchImport.vala"
	if (!value->data[0].v_pointer) {
#line 1902 "../src/BatchImport.vala"
		*object_p = NULL;
#line 15650 "BatchImport.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1902 "../src/BatchImport.vala"
		*object_p = value->data[0].v_pointer;
#line 15654 "BatchImport.c"
	} else {
#line 1902 "../src/BatchImport.vala"
		*object_p = ready_for_import_ref (value->data[0].v_pointer);
#line 15658 "BatchImport.c"
	}
#line 1902 "../src/BatchImport.vala"
	return NULL;
#line 15662 "BatchImport.c"
}

GParamSpec*
param_spec_ready_for_import (const gchar* name,
                             const gchar* nick,
                             const gchar* blurb,
                             GType object_type,
                             GParamFlags flags)
{
	ParamSpecReadyForImport* spec;
#line 1902 "../src/BatchImport.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_READY_FOR_IMPORT), NULL);
#line 1902 "../src/BatchImport.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1902 "../src/BatchImport.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1902 "../src/BatchImport.vala"
	return G_PARAM_SPEC (spec);
#line 15681 "BatchImport.c"
}

gpointer
value_get_ready_for_import (const GValue* value)
{
#line 1902 "../src/BatchImport.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_READY_FOR_IMPORT), NULL);
#line 1902 "../src/BatchImport.vala"
	return value->data[0].v_pointer;
#line 15691 "BatchImport.c"
}

void
value_set_ready_for_import (GValue* value,
                            gpointer v_object)
{
	ReadyForImport * old;
#line 1902 "../src/BatchImport.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_READY_FOR_IMPORT));
#line 1902 "../src/BatchImport.vala"
	old = value->data[0].v_pointer;
#line 1902 "../src/BatchImport.vala"
	if (v_object) {
#line 1902 "../src/BatchImport.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_READY_FOR_IMPORT));
#line 1902 "../src/BatchImport.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1902 "../src/BatchImport.vala"
		value->data[0].v_pointer = v_object;
#line 1902 "../src/BatchImport.vala"
		ready_for_import_ref (value->data[0].v_pointer);
#line 15713 "BatchImport.c"
	} else {
#line 1902 "../src/BatchImport.vala"
		value->data[0].v_pointer = NULL;
#line 15717 "BatchImport.c"
	}
#line 1902 "../src/BatchImport.vala"
	if (old) {
#line 1902 "../src/BatchImport.vala"
		ready_for_import_unref (old);
#line 15723 "BatchImport.c"
	}
}

void
value_take_ready_for_import (GValue* value,
                             gpointer v_object)
{
	ReadyForImport * old;
#line 1902 "../src/BatchImport.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_READY_FOR_IMPORT));
#line 1902 "../src/BatchImport.vala"
	old = value->data[0].v_pointer;
#line 1902 "../src/BatchImport.vala"
	if (v_object) {
#line 1902 "../src/BatchImport.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_READY_FOR_IMPORT));
#line 1902 "../src/BatchImport.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1902 "../src/BatchImport.vala"
		value->data[0].v_pointer = v_object;
#line 15744 "BatchImport.c"
	} else {
#line 1902 "../src/BatchImport.vala"
		value->data[0].v_pointer = NULL;
#line 15748 "BatchImport.c"
	}
#line 1902 "../src/BatchImport.vala"
	if (old) {
#line 1902 "../src/BatchImport.vala"
		ready_for_import_unref (old);
#line 15754 "BatchImport.c"
	}
}

static void
ready_for_import_class_init (ReadyForImportClass * klass,
                             gpointer klass_data)
{
#line 1902 "../src/BatchImport.vala"
	ready_for_import_parent_class = g_type_class_peek_parent (klass);
#line 1902 "../src/BatchImport.vala"
	((ReadyForImportClass *) klass)->finalize = ready_for_import_finalize;
#line 15766 "BatchImport.c"
}

static void
ready_for_import_instance_init (ReadyForImport * self,
                                gpointer klass)
{
#line 1902 "../src/BatchImport.vala"
	self->ref_count = 1;
#line 15775 "BatchImport.c"
}

static void
ready_for_import_finalize (ReadyForImport * obj)
{
	ReadyForImport * self;
#line 1902 "../src/BatchImport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_READY_FOR_IMPORT, ReadyForImport);
#line 1902 "../src/BatchImport.vala"
	g_signal_handlers_destroy (self);
#line 1903 "../src/BatchImport.vala"
	_g_object_unref0 (self->final_file);
#line 1904 "../src/BatchImport.vala"
	_prepared_file_unref0 (self->prepared_file);
#line 1905 "../src/BatchImport.vala"
	_photo_import_params_unref0 (self->photo_import_params);
#line 1906 "../src/BatchImport.vala"
	_video_import_params_unref0 (self->video_import_params);
#line 1907 "../src/BatchImport.vala"
	_batch_import_result_unref0 (self->batch_result);
#line 15796 "BatchImport.c"
}

static GType
ready_for_import_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_ready_for_import_init, value_ready_for_import_free_value, value_ready_for_import_copy_value, value_ready_for_import_peek_pointer, "p", value_ready_for_import_collect_value, "p", value_ready_for_import_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (ReadyForImportClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) ready_for_import_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ReadyForImport), 0, (GInstanceInitFunc) ready_for_import_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType ready_for_import_type_id;
	ready_for_import_type_id = g_type_register_fundamental (g_type_fundamental_next (), "ReadyForImport", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return ready_for_import_type_id;
}

GType
ready_for_import_get_type (void)
{
	static volatile gsize ready_for_import_type_id__once = 0;
	if (g_once_init_enter (&ready_for_import_type_id__once)) {
		GType ready_for_import_type_id;
		ready_for_import_type_id = ready_for_import_get_type_once ();
		g_once_init_leave (&ready_for_import_type_id__once, ready_for_import_type_id);
	}
	return ready_for_import_type_id__once;
}

gpointer
ready_for_import_ref (gpointer instance)
{
	ReadyForImport * self;
	self = instance;
#line 1902 "../src/BatchImport.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1902 "../src/BatchImport.vala"
	return instance;
#line 15831 "BatchImport.c"
}

void
ready_for_import_unref (gpointer instance)
{
	ReadyForImport * self;
	self = instance;
#line 1902 "../src/BatchImport.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1902 "../src/BatchImport.vala"
		READY_FOR_IMPORT_GET_CLASS (self)->finalize (self);
#line 1902 "../src/BatchImport.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 15845 "BatchImport.c"
	}
}

static inline gpointer
prepared_file_import_job_get_instance_private (PreparedFileImportJob* self)
{
	return G_STRUCT_MEMBER_P (self, PreparedFileImportJob_private_offset);
}

PreparedFileImportJob*
prepared_file_import_job_construct (GType object_type,
                                    BatchImport* owner,
                                    PreparedFile* prepared_file,
                                    ImportID* import_id,
                                    CompletionCallback callback,
                                    gpointer callback_target,
                                    GCancellable* cancellable,
                                    CancellationCallback cancellation,
                                    gpointer cancellation_target)
{
	PreparedFileImportJob* self = NULL;
	ImportID _tmp0_;
	PreparedFile* _tmp1_;
#line 1958 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_BATCH_IMPORT (owner), NULL);
#line 1958 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_PREPARED_FILE (prepared_file), NULL);
#line 1958 "../src/BatchImport.vala"
	g_return_val_if_fail (import_id != NULL, NULL);
#line 1958 "../src/BatchImport.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()), NULL);
#line 1960 "../src/BatchImport.vala"
	self = (PreparedFileImportJob*) background_job_construct (object_type, G_TYPE_CHECK_INSTANCE_CAST (owner, G_TYPE_OBJECT, GObject), callback, callback_target, cancellable, cancellation, cancellation_target, NULL);
#line 1962 "../src/BatchImport.vala"
	_tmp0_ = *import_id;
#line 1962 "../src/BatchImport.vala"
	self->priv->import_id = _tmp0_;
#line 1963 "../src/BatchImport.vala"
	_tmp1_ = _prepared_file_ref0 (prepared_file);
#line 1963 "../src/BatchImport.vala"
	_prepared_file_unref0 (self->not_ready);
#line 1963 "../src/BatchImport.vala"
	self->not_ready = _tmp1_;
#line 1965 "../src/BatchImport.vala"
	background_job_set_completion_priority (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_BACKGROUND_JOB, BackgroundJob), G_PRIORITY_LOW);
#line 1958 "../src/BatchImport.vala"
	return self;
#line 15893 "BatchImport.c"
}

PreparedFileImportJob*
prepared_file_import_job_new (BatchImport* owner,
                              PreparedFile* prepared_file,
                              ImportID* import_id,
                              CompletionCallback callback,
                              gpointer callback_target,
                              GCancellable* cancellable,
                              CancellationCallback cancellation,
                              gpointer cancellation_target)
{
#line 1958 "../src/BatchImport.vala"
	return prepared_file_import_job_construct (TYPE_PREPARED_FILE_IMPORT_JOB, owner, prepared_file, import_id, callback, callback_target, cancellable, cancellation, cancellation_target);
#line 15908 "BatchImport.c"
}

static void
prepared_file_import_job_real_execute (BackgroundJob* base)
{
	PreparedFileImportJob * self;
	PreparedFile* prepared_file = NULL;
	PreparedFile* _tmp0_;
	PreparedFile* _tmp1_;
	GFile* final_file = NULL;
	PreparedFile* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GFile* final_associated_file = NULL;
	PreparedFile* _tmp5_;
	GFile* _tmp6_;
	GFile* _tmp7_;
	PreparedFile* _tmp8_;
	GFile* _tmp50_;
	GFile* _tmp54_;
	gchar* _tmp55_;
	gchar* _tmp56_;
	ImportResult _result_ = 0;
	VideoImportParams* video_import_params = NULL;
	PhotoImportParams* photo_import_params = NULL;
	PreparedFile* _tmp57_;
	gboolean _tmp83_ = FALSE;
	BatchImportResult* batch_result = NULL;
	PreparedFile* _tmp96_;
	BatchImportJob* _tmp97_;
	GFile* _tmp98_;
	GFile* _tmp99_;
	gchar* _tmp100_;
	gchar* _tmp101_;
	GFile* _tmp102_;
	gchar* _tmp103_;
	gchar* _tmp104_;
	BatchImportResult* _tmp105_;
	BatchImportResult* _tmp106_;
	BatchImportResult* _tmp107_;
	GError* _inner_error0_ = NULL;
#line 1968 "../src/BatchImport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_PREPARED_FILE_IMPORT_JOB, PreparedFileImportJob);
#line 1969 "../src/BatchImport.vala"
	_tmp0_ = self->not_ready;
#line 1969 "../src/BatchImport.vala"
	_tmp1_ = _prepared_file_ref0 (_tmp0_);
#line 1969 "../src/BatchImport.vala"
	prepared_file = _tmp1_;
#line 1970 "../src/BatchImport.vala"
	_prepared_file_unref0 (self->not_ready);
#line 1970 "../src/BatchImport.vala"
	self->not_ready = NULL;
#line 1972 "../src/BatchImport.vala"
	_tmp2_ = prepared_file;
#line 1972 "../src/BatchImport.vala"
	_tmp3_ = _tmp2_->file;
#line 1972 "../src/BatchImport.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 1972 "../src/BatchImport.vala"
	final_file = _tmp4_;
#line 1973 "../src/BatchImport.vala"
	_tmp5_ = prepared_file;
#line 1973 "../src/BatchImport.vala"
	_tmp6_ = _tmp5_->associated_file;
#line 1973 "../src/BatchImport.vala"
	_tmp7_ = _g_object_ref0 (_tmp6_);
#line 1973 "../src/BatchImport.vala"
	final_associated_file = _tmp7_;
#line 1975 "../src/BatchImport.vala"
	_tmp8_ = prepared_file;
#line 1975 "../src/BatchImport.vala"
	if (_tmp8_->copy_to_library) {
#line 15982 "BatchImport.c"
		{
			GFile* _tmp9_ = NULL;
			PreparedFile* _tmp10_;
			GFile* _tmp11_;
			GFile* _tmp12_;
			GFile* _tmp13_;
			GFile* _tmp14_;
			GFile* _tmp28_;
#line 1978 "../src/BatchImport.vala"
			_tmp10_ = prepared_file;
#line 1978 "../src/BatchImport.vala"
			_tmp11_ = _tmp10_->file;
#line 1978 "../src/BatchImport.vala"
			_tmp12_ = library_files_duplicate (_tmp11_, NULL, NULL, TRUE, &_inner_error0_);
#line 1978 "../src/BatchImport.vala"
			_tmp9_ = _tmp12_;
#line 1978 "../src/BatchImport.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 16001 "BatchImport.c"
				goto __catch0_g_error;
			}
#line 1978 "../src/BatchImport.vala"
			_tmp13_ = _tmp9_;
#line 1978 "../src/BatchImport.vala"
			_tmp9_ = NULL;
#line 1978 "../src/BatchImport.vala"
			_g_object_unref0 (final_file);
#line 1978 "../src/BatchImport.vala"
			final_file = _tmp13_;
#line 1979 "../src/BatchImport.vala"
			_tmp14_ = final_file;
#line 1979 "../src/BatchImport.vala"
			if (_tmp14_ == NULL) {
#line 16016 "BatchImport.c"
				PreparedFile* _tmp15_;
				BatchImportJob* _tmp16_;
				PreparedFile* _tmp17_;
				GFile* _tmp18_;
				PreparedFile* _tmp19_;
				GFile* _tmp20_;
				gchar* _tmp21_;
				gchar* _tmp22_;
				PreparedFile* _tmp23_;
				GFile* _tmp24_;
				gchar* _tmp25_;
				gchar* _tmp26_;
				BatchImportResult* _tmp27_;
#line 1980 "../src/BatchImport.vala"
				_tmp15_ = prepared_file;
#line 1980 "../src/BatchImport.vala"
				_tmp16_ = _tmp15_->job;
#line 1980 "../src/BatchImport.vala"
				_tmp17_ = prepared_file;
#line 1980 "../src/BatchImport.vala"
				_tmp18_ = _tmp17_->file;
#line 1980 "../src/BatchImport.vala"
				_tmp19_ = prepared_file;
#line 1980 "../src/BatchImport.vala"
				_tmp20_ = _tmp19_->file;
#line 1980 "../src/BatchImport.vala"
				_tmp21_ = g_file_get_path (_tmp20_);
#line 1980 "../src/BatchImport.vala"
				_tmp22_ = _tmp21_;
#line 1980 "../src/BatchImport.vala"
				_tmp23_ = prepared_file;
#line 1980 "../src/BatchImport.vala"
				_tmp24_ = _tmp23_->file;
#line 1980 "../src/BatchImport.vala"
				_tmp25_ = g_file_get_path (_tmp24_);
#line 1980 "../src/BatchImport.vala"
				_tmp26_ = _tmp25_;
#line 1980 "../src/BatchImport.vala"
				_tmp27_ = batch_import_result_new (_tmp16_, _tmp18_, _tmp22_, _tmp26_, NULL, IMPORT_RESULT_FILE_ERROR);
#line 1980 "../src/BatchImport.vala"
				_batch_import_result_unref0 (self->failed);
#line 1980 "../src/BatchImport.vala"
				self->failed = _tmp27_;
#line 1980 "../src/BatchImport.vala"
				_g_free0 (_tmp26_);
#line 1980 "../src/BatchImport.vala"
				_g_free0 (_tmp22_);
#line 1984 "../src/BatchImport.vala"
				_g_object_unref0 (_tmp9_);
#line 1984 "../src/BatchImport.vala"
				_g_object_unref0 (final_associated_file);
#line 1984 "../src/BatchImport.vala"
				_g_object_unref0 (final_file);
#line 1984 "../src/BatchImport.vala"
				_prepared_file_unref0 (prepared_file);
#line 1984 "../src/BatchImport.vala"
				return;
#line 16074 "BatchImport.c"
			}
#line 1988 "../src/BatchImport.vala"
			_tmp28_ = final_associated_file;
#line 1988 "../src/BatchImport.vala"
			if (_tmp28_ != NULL) {
#line 16080 "BatchImport.c"
				GFile* _tmp29_ = NULL;
				PreparedFile* _tmp30_;
				GFile* _tmp31_;
				GFile* _tmp32_;
				GFile* _tmp33_;
#line 1989 "../src/BatchImport.vala"
				_tmp30_ = prepared_file;
#line 1989 "../src/BatchImport.vala"
				_tmp31_ = _tmp30_->associated_file;
#line 1989 "../src/BatchImport.vala"
				_tmp32_ = library_files_duplicate (_tmp31_, NULL, NULL, TRUE, &_inner_error0_);
#line 1989 "../src/BatchImport.vala"
				_tmp29_ = _tmp32_;
#line 1989 "../src/BatchImport.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1989 "../src/BatchImport.vala"
					_g_object_unref0 (_tmp9_);
#line 16098 "BatchImport.c"
					goto __catch0_g_error;
				}
#line 1989 "../src/BatchImport.vala"
				_tmp33_ = _tmp29_;
#line 1989 "../src/BatchImport.vala"
				_tmp29_ = NULL;
#line 1989 "../src/BatchImport.vala"
				_g_object_unref0 (final_associated_file);
#line 1989 "../src/BatchImport.vala"
				final_associated_file = _tmp33_;
#line 1988 "../src/BatchImport.vala"
				_g_object_unref0 (_tmp29_);
#line 16111 "BatchImport.c"
			}
#line 1976 "../src/BatchImport.vala"
			_g_object_unref0 (_tmp9_);
#line 16115 "BatchImport.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* err = NULL;
			gchar* _tmp34_ = NULL;
			GFile* _tmp35_;
			gchar* filename = NULL;
			gchar* _tmp41_;
			PreparedFile* _tmp42_;
			BatchImportJob* _tmp43_;
			PreparedFile* _tmp44_;
			GFile* _tmp45_;
			const gchar* _tmp46_;
			const gchar* _tmp47_;
			GError* _tmp48_;
			BatchImportResult* _tmp49_;
#line 1976 "../src/BatchImport.vala"
			err = _inner_error0_;
#line 1976 "../src/BatchImport.vala"
			_inner_error0_ = NULL;
#line 1992 "../src/BatchImport.vala"
			_tmp35_ = final_file;
#line 1992 "../src/BatchImport.vala"
			if (_tmp35_ != NULL) {
#line 16141 "BatchImport.c"
				GFile* _tmp36_;
				gchar* _tmp37_;
#line 1992 "../src/BatchImport.vala"
				_tmp36_ = final_file;
#line 1992 "../src/BatchImport.vala"
				_tmp37_ = g_file_get_path (_tmp36_);
#line 1992 "../src/BatchImport.vala"
				_g_free0 (_tmp34_);
#line 1992 "../src/BatchImport.vala"
				_tmp34_ = _tmp37_;
#line 16152 "BatchImport.c"
			} else {
				PreparedFile* _tmp38_;
				const gchar* _tmp39_;
				gchar* _tmp40_;
#line 1992 "../src/BatchImport.vala"
				_tmp38_ = prepared_file;
#line 1992 "../src/BatchImport.vala"
				_tmp39_ = _tmp38_->source_id;
#line 1992 "../src/BatchImport.vala"
				_tmp40_ = g_strdup (_tmp39_);
#line 1992 "../src/BatchImport.vala"
				_g_free0 (_tmp34_);
#line 1992 "../src/BatchImport.vala"
				_tmp34_ = _tmp40_;
#line 16167 "BatchImport.c"
			}
#line 1992 "../src/BatchImport.vala"
			_tmp41_ = g_strdup (_tmp34_);
#line 1992 "../src/BatchImport.vala"
			filename = _tmp41_;
#line 1993 "../src/BatchImport.vala"
			_tmp42_ = prepared_file;
#line 1993 "../src/BatchImport.vala"
			_tmp43_ = _tmp42_->job;
#line 1993 "../src/BatchImport.vala"
			_tmp44_ = prepared_file;
#line 1993 "../src/BatchImport.vala"
			_tmp45_ = _tmp44_->file;
#line 1993 "../src/BatchImport.vala"
			_tmp46_ = filename;
#line 1993 "../src/BatchImport.vala"
			_tmp47_ = filename;
#line 1993 "../src/BatchImport.vala"
			_tmp48_ = err;
#line 1993 "../src/BatchImport.vala"
			_tmp49_ = batch_import_result_new_from_error (_tmp43_, _tmp45_, _tmp46_, _tmp47_, _tmp48_, IMPORT_RESULT_FILE_ERROR);
#line 1993 "../src/BatchImport.vala"
			_batch_import_result_unref0 (self->failed);
#line 1993 "../src/BatchImport.vala"
			self->failed = _tmp49_;
#line 1996 "../src/BatchImport.vala"
			_g_free0 (filename);
#line 1996 "../src/BatchImport.vala"
			_g_free0 (_tmp34_);
#line 1996 "../src/BatchImport.vala"
			_g_error_free0 (err);
#line 1996 "../src/BatchImport.vala"
			_g_object_unref0 (final_associated_file);
#line 1996 "../src/BatchImport.vala"
			_g_object_unref0 (final_file);
#line 1996 "../src/BatchImport.vala"
			_prepared_file_unref0 (prepared_file);
#line 1996 "../src/BatchImport.vala"
			return;
#line 16207 "BatchImport.c"
		}
		__finally0:
#line 1976 "../src/BatchImport.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1976 "../src/BatchImport.vala"
			_g_object_unref0 (final_associated_file);
#line 1976 "../src/BatchImport.vala"
			_g_object_unref0 (final_file);
#line 1976 "../src/BatchImport.vala"
			_prepared_file_unref0 (prepared_file);
#line 1976 "../src/BatchImport.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1976 "../src/BatchImport.vala"
			g_clear_error (&_inner_error0_);
#line 1976 "../src/BatchImport.vala"
			return;
#line 16224 "BatchImport.c"
		}
	}
#line 2002 "../src/BatchImport.vala"
	_tmp50_ = final_associated_file;
#line 2002 "../src/BatchImport.vala"
	if (_tmp50_ == NULL) {
#line 16231 "BatchImport.c"
		PreparedFile* _tmp51_;
		BatchImportJob* _tmp52_;
		GFile* _tmp53_;
#line 2003 "../src/BatchImport.vala"
		_tmp51_ = prepared_file;
#line 2003 "../src/BatchImport.vala"
		_tmp52_ = _tmp51_->job;
#line 2003 "../src/BatchImport.vala"
		_tmp53_ = batch_import_job_get_associated_file (_tmp52_);
#line 2003 "../src/BatchImport.vala"
		_g_object_unref0 (final_associated_file);
#line 2003 "../src/BatchImport.vala"
		final_associated_file = _tmp53_;
#line 16245 "BatchImport.c"
	}
#line 2006 "../src/BatchImport.vala"
	_tmp54_ = final_file;
#line 2006 "../src/BatchImport.vala"
	_tmp55_ = g_file_get_path (_tmp54_);
#line 2006 "../src/BatchImport.vala"
	_tmp56_ = _tmp55_;
#line 2006 "../src/BatchImport.vala"
	g_debug ("BatchImport.vala:2006: Importing %s", _tmp56_);
#line 2006 "../src/BatchImport.vala"
	_g_free0 (_tmp56_);
#line 2008 "../src/BatchImport.vala"
	_result_ = IMPORT_RESULT_SUCCESS;
#line 2009 "../src/BatchImport.vala"
	video_import_params = NULL;
#line 2010 "../src/BatchImport.vala"
	photo_import_params = NULL;
#line 2011 "../src/BatchImport.vala"
	_tmp57_ = prepared_file;
#line 2011 "../src/BatchImport.vala"
	if (_tmp57_->is_video) {
#line 16267 "BatchImport.c"
		GFile* _tmp58_;
		ImportID _tmp59_;
		PreparedFile* _tmp60_;
		const gchar* _tmp61_;
		Thumbnails* _tmp62_;
		Thumbnails* _tmp63_;
		PreparedFile* _tmp64_;
		BatchImportJob* _tmp65_;
		GDateTime* _tmp66_;
		GDateTime* _tmp67_;
		VideoImportParams* _tmp68_;
		VideoImportParams* _tmp69_;
#line 2012 "../src/BatchImport.vala"
		_tmp58_ = final_file;
#line 2012 "../src/BatchImport.vala"
		_tmp59_ = self->priv->import_id;
#line 2012 "../src/BatchImport.vala"
		_tmp60_ = prepared_file;
#line 2012 "../src/BatchImport.vala"
		_tmp61_ = _tmp60_->full_md5;
#line 2012 "../src/BatchImport.vala"
		_tmp62_ = thumbnails_new ();
#line 2012 "../src/BatchImport.vala"
		_tmp63_ = _tmp62_;
#line 2012 "../src/BatchImport.vala"
		_tmp64_ = prepared_file;
#line 2012 "../src/BatchImport.vala"
		_tmp65_ = _tmp64_->job;
#line 2012 "../src/BatchImport.vala"
		_tmp66_ = batch_import_job_get_exposure_time_override (_tmp65_);
#line 2012 "../src/BatchImport.vala"
		_tmp67_ = _tmp66_;
#line 2012 "../src/BatchImport.vala"
		_tmp68_ = video_import_params_new (_tmp58_, &_tmp59_, _tmp61_, _tmp63_, _tmp67_);
#line 2012 "../src/BatchImport.vala"
		_video_import_params_unref0 (video_import_params);
#line 2012 "../src/BatchImport.vala"
		video_import_params = _tmp68_;
#line 2012 "../src/BatchImport.vala"
		_g_date_time_unref0 (_tmp67_);
#line 2012 "../src/BatchImport.vala"
		_thumbnails_unref0 (_tmp63_);
#line 2016 "../src/BatchImport.vala"
		_tmp69_ = video_import_params;
#line 2016 "../src/BatchImport.vala"
		_result_ = video_reader_prepare_for_import (_tmp69_);
#line 16314 "BatchImport.c"
	} else {
		GFile* _tmp70_;
		GFile* _tmp71_;
		ImportID _tmp72_;
		PreparedFile* _tmp73_;
		const gchar* _tmp74_;
		PreparedFile* _tmp75_;
		const gchar* _tmp76_;
		PreparedFile* _tmp77_;
		const gchar* _tmp78_;
		Thumbnails* _tmp79_;
		Thumbnails* _tmp80_;
		PhotoImportParams* _tmp81_;
		PhotoImportParams* _tmp82_;
#line 2018 "../src/BatchImport.vala"
		_tmp70_ = final_file;
#line 2018 "../src/BatchImport.vala"
		_tmp71_ = final_associated_file;
#line 2018 "../src/BatchImport.vala"
		_tmp72_ = self->priv->import_id;
#line 2018 "../src/BatchImport.vala"
		_tmp73_ = prepared_file;
#line 2018 "../src/BatchImport.vala"
		_tmp74_ = _tmp73_->exif_md5;
#line 2018 "../src/BatchImport.vala"
		_tmp75_ = prepared_file;
#line 2018 "../src/BatchImport.vala"
		_tmp76_ = _tmp75_->thumbnail_md5;
#line 2018 "../src/BatchImport.vala"
		_tmp77_ = prepared_file;
#line 2018 "../src/BatchImport.vala"
		_tmp78_ = _tmp77_->full_md5;
#line 2018 "../src/BatchImport.vala"
		_tmp79_ = thumbnails_new ();
#line 2018 "../src/BatchImport.vala"
		_tmp80_ = _tmp79_;
#line 2018 "../src/BatchImport.vala"
		_tmp81_ = photo_import_params_new (_tmp70_, _tmp71_, &_tmp72_, PHOTO_FILE_SNIFFER_OPTIONS_GET_ALL, _tmp74_, _tmp76_, _tmp78_, _tmp80_);
#line 2018 "../src/BatchImport.vala"
		_photo_import_params_unref0 (photo_import_params);
#line 2018 "../src/BatchImport.vala"
		photo_import_params = _tmp81_;
#line 2018 "../src/BatchImport.vala"
		_thumbnails_unref0 (_tmp80_);
#line 2022 "../src/BatchImport.vala"
		_tmp82_ = photo_import_params;
#line 2022 "../src/BatchImport.vala"
		_result_ = photo_prepare_for_import (_tmp82_);
#line 16363 "BatchImport.c"
	}
#line 2025 "../src/BatchImport.vala"
	if (_result_ != IMPORT_RESULT_SUCCESS) {
#line 16367 "BatchImport.c"
		GFile* _tmp84_;
		PreparedFile* _tmp85_;
		GFile* _tmp86_;
#line 2025 "../src/BatchImport.vala"
		_tmp84_ = final_file;
#line 2025 "../src/BatchImport.vala"
		_tmp85_ = prepared_file;
#line 2025 "../src/BatchImport.vala"
		_tmp86_ = _tmp85_->file;
#line 2025 "../src/BatchImport.vala"
		_tmp83_ = _tmp84_ != _tmp86_;
#line 16379 "BatchImport.c"
	} else {
#line 2025 "../src/BatchImport.vala"
		_tmp83_ = FALSE;
#line 16383 "BatchImport.c"
	}
#line 2025 "../src/BatchImport.vala"
	if (_tmp83_) {
#line 16387 "BatchImport.c"
		GFile* _tmp87_;
		gchar* _tmp88_;
		gchar* _tmp89_;
#line 2026 "../src/BatchImport.vala"
		_tmp87_ = final_file;
#line 2026 "../src/BatchImport.vala"
		_tmp88_ = g_file_get_path (_tmp87_);
#line 2026 "../src/BatchImport.vala"
		_tmp89_ = _tmp88_;
#line 2026 "../src/BatchImport.vala"
		g_debug ("BatchImport.vala:2026: Deleting failed imported copy %s", _tmp89_);
#line 2026 "../src/BatchImport.vala"
		_g_free0 (_tmp89_);
#line 16401 "BatchImport.c"
		{
			GFile* _tmp90_;
#line 2028 "../src/BatchImport.vala"
			_tmp90_ = final_file;
#line 2028 "../src/BatchImport.vala"
			g_file_delete (_tmp90_, NULL, &_inner_error0_);
#line 2028 "../src/BatchImport.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 16410 "BatchImport.c"
				goto __catch1_g_error;
			}
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* err = NULL;
			GFile* _tmp91_;
			gchar* _tmp92_;
			gchar* _tmp93_;
			GError* _tmp94_;
			const gchar* _tmp95_;
#line 2027 "../src/BatchImport.vala"
			err = _inner_error0_;
#line 2027 "../src/BatchImport.vala"
			_inner_error0_ = NULL;
#line 2031 "../src/BatchImport.vala"
			_tmp91_ = final_file;
#line 2031 "../src/BatchImport.vala"
			_tmp92_ = g_file_get_path (_tmp91_);
#line 2031 "../src/BatchImport.vala"
			_tmp93_ = _tmp92_;
#line 2031 "../src/BatchImport.vala"
			_tmp94_ = err;
#line 2031 "../src/BatchImport.vala"
			_tmp95_ = _tmp94_->message;
#line 2031 "../src/BatchImport.vala"
			g_warning ("BatchImport.vala:2031: Unable to delete copy of imported file %s: %s", _tmp93_, _tmp95_);
#line 2031 "../src/BatchImport.vala"
			_g_free0 (_tmp93_);
#line 2027 "../src/BatchImport.vala"
			_g_error_free0 (err);
#line 16443 "BatchImport.c"
		}
		__finally1:
#line 2027 "../src/BatchImport.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2027 "../src/BatchImport.vala"
			_photo_import_params_unref0 (photo_import_params);
#line 2027 "../src/BatchImport.vala"
			_video_import_params_unref0 (video_import_params);
#line 2027 "../src/BatchImport.vala"
			_g_object_unref0 (final_associated_file);
#line 2027 "../src/BatchImport.vala"
			_g_object_unref0 (final_file);
#line 2027 "../src/BatchImport.vala"
			_prepared_file_unref0 (prepared_file);
#line 2027 "../src/BatchImport.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2027 "../src/BatchImport.vala"
			g_clear_error (&_inner_error0_);
#line 2027 "../src/BatchImport.vala"
			return;
#line 16464 "BatchImport.c"
		}
	}
#line 2036 "../src/BatchImport.vala"
	_tmp96_ = prepared_file;
#line 2036 "../src/BatchImport.vala"
	_tmp97_ = _tmp96_->job;
#line 2036 "../src/BatchImport.vala"
	_tmp98_ = final_file;
#line 2036 "../src/BatchImport.vala"
	_tmp99_ = final_file;
#line 2036 "../src/BatchImport.vala"
	_tmp100_ = g_file_get_path (_tmp99_);
#line 2036 "../src/BatchImport.vala"
	_tmp101_ = _tmp100_;
#line 2036 "../src/BatchImport.vala"
	_tmp102_ = final_file;
#line 2036 "../src/BatchImport.vala"
	_tmp103_ = g_file_get_path (_tmp102_);
#line 2036 "../src/BatchImport.vala"
	_tmp104_ = _tmp103_;
#line 2036 "../src/BatchImport.vala"
	_tmp105_ = batch_import_result_new (_tmp97_, _tmp98_, _tmp101_, _tmp104_, NULL, _result_);
#line 2036 "../src/BatchImport.vala"
	_tmp106_ = _tmp105_;
#line 2036 "../src/BatchImport.vala"
	_g_free0 (_tmp104_);
#line 2036 "../src/BatchImport.vala"
	_g_free0 (_tmp101_);
#line 2036 "../src/BatchImport.vala"
	batch_result = _tmp106_;
#line 2038 "../src/BatchImport.vala"
	_tmp107_ = batch_result;
#line 2038 "../src/BatchImport.vala"
	if (_tmp107_->result != IMPORT_RESULT_SUCCESS) {
#line 16499 "BatchImport.c"
		BatchImportResult* _tmp108_;
		BatchImportResult* _tmp109_;
#line 2039 "../src/BatchImport.vala"
		_tmp108_ = batch_result;
#line 2039 "../src/BatchImport.vala"
		_tmp109_ = _batch_import_result_ref0 (_tmp108_);
#line 2039 "../src/BatchImport.vala"
		_batch_import_result_unref0 (self->failed);
#line 2039 "../src/BatchImport.vala"
		self->failed = _tmp109_;
#line 16510 "BatchImport.c"
	} else {
		GFile* _tmp110_;
		PreparedFile* _tmp111_;
		PhotoImportParams* _tmp112_;
		VideoImportParams* _tmp113_;
		BatchImportResult* _tmp114_;
		ReadyForImport* _tmp115_;
#line 2041 "../src/BatchImport.vala"
		_tmp110_ = final_file;
#line 2041 "../src/BatchImport.vala"
		_tmp111_ = prepared_file;
#line 2041 "../src/BatchImport.vala"
		_tmp112_ = photo_import_params;
#line 2041 "../src/BatchImport.vala"
		_tmp113_ = video_import_params;
#line 2041 "../src/BatchImport.vala"
		_tmp114_ = batch_result;
#line 2041 "../src/BatchImport.vala"
		_tmp115_ = ready_for_import_new (_tmp110_, _tmp111_, _tmp112_, _tmp113_, _tmp114_);
#line 2041 "../src/BatchImport.vala"
		_ready_for_import_unref0 (self->ready);
#line 2041 "../src/BatchImport.vala"
		self->ready = _tmp115_;
#line 16534 "BatchImport.c"
	}
#line 1968 "../src/BatchImport.vala"
	_batch_import_result_unref0 (batch_result);
#line 1968 "../src/BatchImport.vala"
	_photo_import_params_unref0 (photo_import_params);
#line 1968 "../src/BatchImport.vala"
	_video_import_params_unref0 (video_import_params);
#line 1968 "../src/BatchImport.vala"
	_g_object_unref0 (final_associated_file);
#line 1968 "../src/BatchImport.vala"
	_g_object_unref0 (final_file);
#line 1968 "../src/BatchImport.vala"
	_prepared_file_unref0 (prepared_file);
#line 16548 "BatchImport.c"
}

static void
prepared_file_import_job_class_init (PreparedFileImportJobClass * klass,
                                     gpointer klass_data)
{
#line 1951 "../src/BatchImport.vala"
	prepared_file_import_job_parent_class = g_type_class_peek_parent (klass);
#line 1951 "../src/BatchImport.vala"
	((BackgroundJobClass *) klass)->finalize = prepared_file_import_job_finalize;
#line 1951 "../src/BatchImport.vala"
	g_type_class_adjust_private_offset (klass, &PreparedFileImportJob_private_offset);
#line 1951 "../src/BatchImport.vala"
	((BackgroundJobClass *) klass)->execute = (void (*) (BackgroundJob*)) prepared_file_import_job_real_execute;
#line 16563 "BatchImport.c"
}

static void
prepared_file_import_job_instance_init (PreparedFileImportJob * self,
                                        gpointer klass)
{
#line 1951 "../src/BatchImport.vala"
	self->priv = prepared_file_import_job_get_instance_private (self);
#line 1953 "../src/BatchImport.vala"
	self->ready = NULL;
#line 1954 "../src/BatchImport.vala"
	self->failed = NULL;
#line 16576 "BatchImport.c"
}

static void
prepared_file_import_job_finalize (BackgroundJob * obj)
{
	PreparedFileImportJob * self;
#line 1951 "../src/BatchImport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PREPARED_FILE_IMPORT_JOB, PreparedFileImportJob);
#line 1952 "../src/BatchImport.vala"
	_prepared_file_unref0 (self->not_ready);
#line 1953 "../src/BatchImport.vala"
	_ready_for_import_unref0 (self->ready);
#line 1954 "../src/BatchImport.vala"
	_batch_import_result_unref0 (self->failed);
#line 1951 "../src/BatchImport.vala"
	BACKGROUND_JOB_CLASS (prepared_file_import_job_parent_class)->finalize (obj);
#line 16593 "BatchImport.c"
}

static GType
prepared_file_import_job_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PreparedFileImportJobClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) prepared_file_import_job_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PreparedFileImportJob), 0, (GInstanceInitFunc) prepared_file_import_job_instance_init, NULL };
	GType prepared_file_import_job_type_id;
	prepared_file_import_job_type_id = g_type_register_static (TYPE_BACKGROUND_JOB, "PreparedFileImportJob", &g_define_type_info, 0);
	PreparedFileImportJob_private_offset = g_type_add_instance_private (prepared_file_import_job_type_id, sizeof (PreparedFileImportJobPrivate));
	return prepared_file_import_job_type_id;
}

GType
prepared_file_import_job_get_type (void)
{
	static volatile gsize prepared_file_import_job_type_id__once = 0;
	if (g_once_init_enter (&prepared_file_import_job_type_id__once)) {
		GType prepared_file_import_job_type_id;
		prepared_file_import_job_type_id = prepared_file_import_job_get_type_once ();
		g_once_init_leave (&prepared_file_import_job_type_id__once, prepared_file_import_job_type_id);
	}
	return prepared_file_import_job_type_id__once;
}

CompletedImportObject*
completed_import_object_construct (GType object_type,
                                   MediaSource* source,
                                   Thumbnails* thumbnails,
                                   BatchImportJob* original_job,
                                   BatchImportResult* import_result)
{
	CompletedImportObject* self = NULL;
	Thumbnails* _tmp0_;
	BatchImportResult* _tmp1_;
	MediaSource* _tmp2_;
	BatchImportJob* _tmp3_;
	GdkPixbuf* _tmp4_;
#line 2053 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_MEDIA_SOURCE (source), NULL);
#line 2053 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_THUMBNAILS (thumbnails), NULL);
#line 2053 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_BATCH_IMPORT_JOB (original_job), NULL);
#line 2053 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_BATCH_IMPORT_RESULT (import_result), NULL);
#line 2053 "../src/BatchImport.vala"
	self = (CompletedImportObject*) g_type_create_instance (object_type);
#line 2055 "../src/BatchImport.vala"
	_tmp0_ = _thumbnails_ref0 (thumbnails);
#line 2055 "../src/BatchImport.vala"
	_thumbnails_unref0 (self->thumbnails);
#line 2055 "../src/BatchImport.vala"
	self->thumbnails = _tmp0_;
#line 2056 "../src/BatchImport.vala"
	_tmp1_ = _batch_import_result_ref0 (import_result);
#line 2056 "../src/BatchImport.vala"
	_batch_import_result_unref0 (self->batch_result);
#line 2056 "../src/BatchImport.vala"
	self->batch_result = _tmp1_;
#line 2057 "../src/BatchImport.vala"
	_tmp2_ = _g_object_ref0 (source);
#line 2057 "../src/BatchImport.vala"
	_g_object_unref0 (self->source);
#line 2057 "../src/BatchImport.vala"
	self->source = _tmp2_;
#line 2058 "../src/BatchImport.vala"
	_tmp3_ = _batch_import_job_ref0 (original_job);
#line 2058 "../src/BatchImport.vala"
	_batch_import_job_unref0 (self->original_job);
#line 2058 "../src/BatchImport.vala"
	self->original_job = _tmp3_;
#line 2059 "../src/BatchImport.vala"
	_tmp4_ = thumbnails_get (thumbnails, THUMBNAIL_CACHE_SIZE_LARGEST);
#line 2059 "../src/BatchImport.vala"
	_g_object_unref0 (self->user_preview);
#line 2059 "../src/BatchImport.vala"
	self->user_preview = _tmp4_;
#line 2053 "../src/BatchImport.vala"
	return self;
#line 16673 "BatchImport.c"
}

CompletedImportObject*
completed_import_object_new (MediaSource* source,
                             Thumbnails* thumbnails,
                             BatchImportJob* original_job,
                             BatchImportResult* import_result)
{
#line 2053 "../src/BatchImport.vala"
	return completed_import_object_construct (TYPE_COMPLETED_IMPORT_OBJECT, source, thumbnails, original_job, import_result);
#line 16684 "BatchImport.c"
}

static void
value_completed_import_object_init (GValue* value)
{
#line 2046 "../src/BatchImport.vala"
	value->data[0].v_pointer = NULL;
#line 16692 "BatchImport.c"
}

static void
value_completed_import_object_free_value (GValue* value)
{
#line 2046 "../src/BatchImport.vala"
	if (value->data[0].v_pointer) {
#line 2046 "../src/BatchImport.vala"
		completed_import_object_unref (value->data[0].v_pointer);
#line 16702 "BatchImport.c"
	}
}

static void
value_completed_import_object_copy_value (const GValue* src_value,
                                          GValue* dest_value)
{
#line 2046 "../src/BatchImport.vala"
	if (src_value->data[0].v_pointer) {
#line 2046 "../src/BatchImport.vala"
		dest_value->data[0].v_pointer = completed_import_object_ref (src_value->data[0].v_pointer);
#line 16714 "BatchImport.c"
	} else {
#line 2046 "../src/BatchImport.vala"
		dest_value->data[0].v_pointer = NULL;
#line 16718 "BatchImport.c"
	}
}

static gpointer
value_completed_import_object_peek_pointer (const GValue* value)
{
#line 2046 "../src/BatchImport.vala"
	return value->data[0].v_pointer;
#line 16727 "BatchImport.c"
}

static gchar*
value_completed_import_object_collect_value (GValue* value,
                                             guint n_collect_values,
                                             GTypeCValue* collect_values,
                                             guint collect_flags)
{
#line 2046 "../src/BatchImport.vala"
	if (collect_values[0].v_pointer) {
#line 16738 "BatchImport.c"
		CompletedImportObject * object;
		object = collect_values[0].v_pointer;
#line 2046 "../src/BatchImport.vala"
		if (object->parent_instance.g_class == NULL) {
#line 2046 "../src/BatchImport.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 16745 "BatchImport.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 2046 "../src/BatchImport.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 16749 "BatchImport.c"
		}
#line 2046 "../src/BatchImport.vala"
		value->data[0].v_pointer = completed_import_object_ref (object);
#line 16753 "BatchImport.c"
	} else {
#line 2046 "../src/BatchImport.vala"
		value->data[0].v_pointer = NULL;
#line 16757 "BatchImport.c"
	}
#line 2046 "../src/BatchImport.vala"
	return NULL;
#line 16761 "BatchImport.c"
}

static gchar*
value_completed_import_object_lcopy_value (const GValue* value,
                                           guint n_collect_values,
                                           GTypeCValue* collect_values,
                                           guint collect_flags)
{
	CompletedImportObject ** object_p;
	object_p = collect_values[0].v_pointer;
#line 2046 "../src/BatchImport.vala"
	if (!object_p) {
#line 2046 "../src/BatchImport.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 16776 "BatchImport.c"
	}
#line 2046 "../src/BatchImport.vala"
	if (!value->data[0].v_pointer) {
#line 2046 "../src/BatchImport.vala"
		*object_p = NULL;
#line 16782 "BatchImport.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 2046 "../src/BatchImport.vala"
		*object_p = value->data[0].v_pointer;
#line 16786 "BatchImport.c"
	} else {
#line 2046 "../src/BatchImport.vala"
		*object_p = completed_import_object_ref (value->data[0].v_pointer);
#line 16790 "BatchImport.c"
	}
#line 2046 "../src/BatchImport.vala"
	return NULL;
#line 16794 "BatchImport.c"
}

GParamSpec*
param_spec_completed_import_object (const gchar* name,
                                    const gchar* nick,
                                    const gchar* blurb,
                                    GType object_type,
                                    GParamFlags flags)
{
	ParamSpecCompletedImportObject* spec;
#line 2046 "../src/BatchImport.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_COMPLETED_IMPORT_OBJECT), NULL);
#line 2046 "../src/BatchImport.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 2046 "../src/BatchImport.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 2046 "../src/BatchImport.vala"
	return G_PARAM_SPEC (spec);
#line 16813 "BatchImport.c"
}

gpointer
value_get_completed_import_object (const GValue* value)
{
#line 2046 "../src/BatchImport.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_COMPLETED_IMPORT_OBJECT), NULL);
#line 2046 "../src/BatchImport.vala"
	return value->data[0].v_pointer;
#line 16823 "BatchImport.c"
}

void
value_set_completed_import_object (GValue* value,
                                   gpointer v_object)
{
	CompletedImportObject * old;
#line 2046 "../src/BatchImport.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_COMPLETED_IMPORT_OBJECT));
#line 2046 "../src/BatchImport.vala"
	old = value->data[0].v_pointer;
#line 2046 "../src/BatchImport.vala"
	if (v_object) {
#line 2046 "../src/BatchImport.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_COMPLETED_IMPORT_OBJECT));
#line 2046 "../src/BatchImport.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 2046 "../src/BatchImport.vala"
		value->data[0].v_pointer = v_object;
#line 2046 "../src/BatchImport.vala"
		completed_import_object_ref (value->data[0].v_pointer);
#line 16845 "BatchImport.c"
	} else {
#line 2046 "../src/BatchImport.vala"
		value->data[0].v_pointer = NULL;
#line 16849 "BatchImport.c"
	}
#line 2046 "../src/BatchImport.vala"
	if (old) {
#line 2046 "../src/BatchImport.vala"
		completed_import_object_unref (old);
#line 16855 "BatchImport.c"
	}
}

void
value_take_completed_import_object (GValue* value,
                                    gpointer v_object)
{
	CompletedImportObject * old;
#line 2046 "../src/BatchImport.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_COMPLETED_IMPORT_OBJECT));
#line 2046 "../src/BatchImport.vala"
	old = value->data[0].v_pointer;
#line 2046 "../src/BatchImport.vala"
	if (v_object) {
#line 2046 "../src/BatchImport.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_COMPLETED_IMPORT_OBJECT));
#line 2046 "../src/BatchImport.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 2046 "../src/BatchImport.vala"
		value->data[0].v_pointer = v_object;
#line 16876 "BatchImport.c"
	} else {
#line 2046 "../src/BatchImport.vala"
		value->data[0].v_pointer = NULL;
#line 16880 "BatchImport.c"
	}
#line 2046 "../src/BatchImport.vala"
	if (old) {
#line 2046 "../src/BatchImport.vala"
		completed_import_object_unref (old);
#line 16886 "BatchImport.c"
	}
}

static void
completed_import_object_class_init (CompletedImportObjectClass * klass,
                                    gpointer klass_data)
{
#line 2046 "../src/BatchImport.vala"
	completed_import_object_parent_class = g_type_class_peek_parent (klass);
#line 2046 "../src/BatchImport.vala"
	((CompletedImportObjectClass *) klass)->finalize = completed_import_object_finalize;
#line 16898 "BatchImport.c"
}

static void
completed_import_object_instance_init (CompletedImportObject * self,
                                       gpointer klass)
{
#line 2046 "../src/BatchImport.vala"
	self->ref_count = 1;
#line 16907 "BatchImport.c"
}

static void
completed_import_object_finalize (CompletedImportObject * obj)
{
	CompletedImportObject * self;
#line 2046 "../src/BatchImport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_COMPLETED_IMPORT_OBJECT, CompletedImportObject);
#line 2046 "../src/BatchImport.vala"
	g_signal_handlers_destroy (self);
#line 2047 "../src/BatchImport.vala"
	_thumbnails_unref0 (self->thumbnails);
#line 2048 "../src/BatchImport.vala"
	_batch_import_result_unref0 (self->batch_result);
#line 2049 "../src/BatchImport.vala"
	_g_object_unref0 (self->source);
#line 2050 "../src/BatchImport.vala"
	_batch_import_job_unref0 (self->original_job);
#line 2051 "../src/BatchImport.vala"
	_g_object_unref0 (self->user_preview);
#line 16928 "BatchImport.c"
}

static GType
completed_import_object_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_completed_import_object_init, value_completed_import_object_free_value, value_completed_import_object_copy_value, value_completed_import_object_peek_pointer, "p", value_completed_import_object_collect_value, "p", value_completed_import_object_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (CompletedImportObjectClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) completed_import_object_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CompletedImportObject), 0, (GInstanceInitFunc) completed_import_object_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType completed_import_object_type_id;
	completed_import_object_type_id = g_type_register_fundamental (g_type_fundamental_next (), "CompletedImportObject", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return completed_import_object_type_id;
}

GType
completed_import_object_get_type (void)
{
	static volatile gsize completed_import_object_type_id__once = 0;
	if (g_once_init_enter (&completed_import_object_type_id__once)) {
		GType completed_import_object_type_id;
		completed_import_object_type_id = completed_import_object_get_type_once ();
		g_once_init_leave (&completed_import_object_type_id__once, completed_import_object_type_id);
	}
	return completed_import_object_type_id__once;
}

gpointer
completed_import_object_ref (gpointer instance)
{
	CompletedImportObject * self;
	self = instance;
#line 2046 "../src/BatchImport.vala"
	g_atomic_int_inc (&self->ref_count);
#line 2046 "../src/BatchImport.vala"
	return instance;
#line 16963 "BatchImport.c"
}

void
completed_import_object_unref (gpointer instance)
{
	CompletedImportObject * self;
	self = instance;
#line 2046 "../src/BatchImport.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 2046 "../src/BatchImport.vala"
		COMPLETED_IMPORT_OBJECT_GET_CLASS (self)->finalize (self);
#line 2046 "../src/BatchImport.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 16977 "BatchImport.c"
	}
}

ThumbnailWriterJob*
thumbnail_writer_job_construct (GType object_type,
                                BatchImport* owner,
                                CompletedImportObject* completed_import_source,
                                CompletionCallback callback,
                                gpointer callback_target,
                                GCancellable* cancellable,
                                CancellationCallback cancel_callback,
                                gpointer cancel_callback_target)
{
	ThumbnailWriterJob* self = NULL;
	Thumbnails* _tmp0_;
	CompletedImportObject* _tmp1_;
#line 2066 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_BATCH_IMPORT (owner), NULL);
#line 2066 "../src/BatchImport.vala"
	g_return_val_if_fail (IS_COMPLETED_IMPORT_OBJECT (completed_import_source), NULL);
#line 2066 "../src/BatchImport.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (cancellable, g_cancellable_get_type ()), NULL);
#line 2068 "../src/BatchImport.vala"
	self = (ThumbnailWriterJob*) background_import_job_construct (object_type, owner, callback, callback_target, cancellable, cancel_callback, cancel_callback_target);
#line 2070 "../src/BatchImport.vala"
	_tmp0_ = completed_import_source->thumbnails;
#line 2070 "../src/BatchImport.vala"
	_vala_assert (_tmp0_ != NULL, "completed_import_source.thumbnails != null");
#line 2071 "../src/BatchImport.vala"
	_tmp1_ = _completed_import_object_ref0 (completed_import_source);
#line 2071 "../src/BatchImport.vala"
	_completed_import_object_unref0 (self->completed_import_source);
#line 2071 "../src/BatchImport.vala"
	self->completed_import_source = _tmp1_;
#line 2073 "../src/BatchImport.vala"
	background_job_set_completion_priority (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_BACKGROUND_JOB, BackgroundJob), G_PRIORITY_LOW);
#line 2066 "../src/BatchImport.vala"
	return self;
#line 17016 "BatchImport.c"
}

ThumbnailWriterJob*
thumbnail_writer_job_new (BatchImport* owner,
                          CompletedImportObject* completed_import_source,
                          CompletionCallback callback,
                          gpointer callback_target,
                          GCancellable* cancellable,
                          CancellationCallback cancel_callback,
                          gpointer cancel_callback_target)
{
#line 2066 "../src/BatchImport.vala"
	return thumbnail_writer_job_construct (TYPE_THUMBNAIL_WRITER_JOB, owner, completed_import_source, callback, callback_target, cancellable, cancel_callback, cancel_callback_target);
#line 17030 "BatchImport.c"
}

static void
thumbnail_writer_job_real_execute (BackgroundJob* base)
{
	ThumbnailWriterJob * self;
	CompletedImportObject* _tmp9_;
	GError* _inner_error0_ = NULL;
#line 2076 "../src/BatchImport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_THUMBNAIL_WRITER_JOB, ThumbnailWriterJob);
#line 17041 "BatchImport.c"
	{
		CompletedImportObject* _tmp0_;
		MediaSource* _tmp1_;
		CompletedImportObject* _tmp2_;
		Thumbnails* _tmp3_;
		CompletedImportObject* _tmp4_;
		BatchImportResult* _tmp5_;
#line 2078 "../src/BatchImport.vala"
		_tmp0_ = self->completed_import_source;
#line 2078 "../src/BatchImport.vala"
		_tmp1_ = _tmp0_->source;
#line 2078 "../src/BatchImport.vala"
		_tmp2_ = self->completed_import_source;
#line 2078 "../src/BatchImport.vala"
		_tmp3_ = _tmp2_->thumbnails;
#line 2078 "../src/BatchImport.vala"
		thumbnail_cache_import_thumbnails (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_THUMBNAIL_SOURCE, ThumbnailSource), _tmp3_, TRUE, &_inner_error0_);
#line 2078 "../src/BatchImport.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 17061 "BatchImport.c"
			goto __catch0_g_error;
		}
#line 2080 "../src/BatchImport.vala"
		_tmp4_ = self->completed_import_source;
#line 2080 "../src/BatchImport.vala"
		_tmp5_ = _tmp4_->batch_result;
#line 2080 "../src/BatchImport.vala"
		_tmp5_->result = IMPORT_RESULT_SUCCESS;
#line 17070 "BatchImport.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		CompletedImportObject* _tmp6_;
		BatchImportResult* _tmp7_;
		GError* _tmp8_;
#line 2077 "../src/BatchImport.vala"
		err = _inner_error0_;
#line 2077 "../src/BatchImport.vala"
		_inner_error0_ = NULL;
#line 2082 "../src/BatchImport.vala"
		_tmp6_ = self->completed_import_source;
#line 2082 "../src/BatchImport.vala"
		_tmp7_ = _tmp6_->batch_result;
#line 2082 "../src/BatchImport.vala"
		_tmp8_ = err;
#line 2082 "../src/BatchImport.vala"
		_tmp7_->result = import_result_convert_error (_tmp8_, IMPORT_RESULT_FILE_ERROR);
#line 2077 "../src/BatchImport.vala"
		_g_error_free0 (err);
#line 17093 "BatchImport.c"
	}
	__finally0:
#line 2077 "../src/BatchImport.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2077 "../src/BatchImport.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2077 "../src/BatchImport.vala"
		g_clear_error (&_inner_error0_);
#line 2077 "../src/BatchImport.vala"
		return;
#line 17104 "BatchImport.c"
	}
#line 2087 "../src/BatchImport.vala"
	_tmp9_ = self->completed_import_source;
#line 2087 "../src/BatchImport.vala"
	_thumbnails_unref0 (_tmp9_->thumbnails);
#line 2087 "../src/BatchImport.vala"
	_tmp9_->thumbnails = NULL;
#line 17112 "BatchImport.c"
}

static void
thumbnail_writer_job_class_init (ThumbnailWriterJobClass * klass,
                                 gpointer klass_data)
{
#line 2063 "../src/BatchImport.vala"
	thumbnail_writer_job_parent_class = g_type_class_peek_parent (klass);
#line 2063 "../src/BatchImport.vala"
	((BackgroundJobClass *) klass)->finalize = thumbnail_writer_job_finalize;
#line 2063 "../src/BatchImport.vala"
	((BackgroundJobClass *) klass)->execute = (void (*) (BackgroundJob*)) thumbnail_writer_job_real_execute;
#line 17125 "BatchImport.c"
}

static void
thumbnail_writer_job_instance_init (ThumbnailWriterJob * self,
                                    gpointer klass)
{
}

static void
thumbnail_writer_job_finalize (BackgroundJob * obj)
{
	ThumbnailWriterJob * self;
#line 2063 "../src/BatchImport.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_THUMBNAIL_WRITER_JOB, ThumbnailWriterJob);
#line 2064 "../src/BatchImport.vala"
	_completed_import_object_unref0 (self->completed_import_source);
#line 2063 "../src/BatchImport.vala"
	BACKGROUND_JOB_CLASS (thumbnail_writer_job_parent_class)->finalize (obj);
#line 17144 "BatchImport.c"
}

static GType
thumbnail_writer_job_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ThumbnailWriterJobClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) thumbnail_writer_job_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ThumbnailWriterJob), 0, (GInstanceInitFunc) thumbnail_writer_job_instance_init, NULL };
	GType thumbnail_writer_job_type_id;
	thumbnail_writer_job_type_id = g_type_register_static (TYPE_BACKGROUND_IMPORT_JOB, "ThumbnailWriterJob", &g_define_type_info, 0);
	return thumbnail_writer_job_type_id;
}

GType
thumbnail_writer_job_get_type (void)
{
	static volatile gsize thumbnail_writer_job_type_id__once = 0;
	if (g_once_init_enter (&thumbnail_writer_job_type_id__once)) {
		GType thumbnail_writer_job_type_id;
		thumbnail_writer_job_type_id = thumbnail_writer_job_get_type_once ();
		g_once_init_leave (&thumbnail_writer_job_type_id__once, thumbnail_writer_job_type_id);
	}
	return thumbnail_writer_job_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

