/* ViewCollection.c generated by valac 0.56.14, the Vala compiler
 * generated from ViewCollection.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */
/* A ViewCollection holds DataView objects, which are view instances wrapping DataSource objects.*/
/* Thus, multiple views can exist of a single SourceCollection, each view displaying all or some*/
/* of that SourceCollection.  A view collection also has a notion of order*/
/* (first/last/next/previous) that can be overridden by child classes.  It also understands hidden*/
/* objects, which are withheld entirely from the collection until they're made visible.  Currently*/
/* the only way to hide objects is with a ViewFilter.*/
/**/
/* A ViewCollection may also be locked.  When locked, it will not (a) remove hidden items from the*/
/* collection and (b) remove DataViews representing unlinked DataSources.  This allows for the*/
/* ViewCollection to be "frozen" while manipulating items within it.  When the collection is*/
/* unlocked, all changes are applied at once.*/
/**/
/* The default implementation provides a browser which orders the view in the order they're*/
/* stored in DataCollection, which is not specified.*/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <gobject/gvaluecollector.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_DATA_COLLECTION (data_collection_get_type ())
#define DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_COLLECTION, DataCollection))
#define DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_COLLECTION, DataCollectionClass))
#define IS_DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_COLLECTION))
#define IS_DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_COLLECTION))
#define DATA_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_COLLECTION, DataCollectionClass))

typedef struct _DataCollection DataCollection;
typedef struct _DataCollectionClass DataCollectionClass;
typedef struct _DataCollectionPrivate DataCollectionPrivate;

#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;

#define TYPE_ALTERATION (alteration_get_type ())
#define ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ALTERATION, Alteration))
#define ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ALTERATION, AlterationClass))
#define IS_ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ALTERATION))
#define IS_ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ALTERATION))
#define ALTERATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ALTERATION, AlterationClass))

typedef struct _Alteration Alteration;
typedef struct _AlterationClass AlterationClass;
typedef gint64 (*Comparator) (void* a, void* b, gpointer user_data);
typedef gboolean (*ComparatorPredicate) (DataObject* object, Alteration* alteration, gpointer user_data);
typedef gboolean (*ProgressMonitor) (guint64 current, guint64 total, gboolean do_event_loop, gpointer user_data);

#define TYPE_MARKER (marker_get_type ())
#define MARKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MARKER, Marker))
#define IS_MARKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MARKER))
#define MARKER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MARKER, MarkerIface))

typedef struct _Marker Marker;
typedef struct _MarkerIface MarkerIface;

#define TYPE_VIEW_COLLECTION (view_collection_get_type ())
#define VIEW_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIEW_COLLECTION, ViewCollection))
#define VIEW_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIEW_COLLECTION, ViewCollectionClass))
#define IS_VIEW_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIEW_COLLECTION))
#define IS_VIEW_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIEW_COLLECTION))
#define VIEW_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIEW_COLLECTION, ViewCollectionClass))

typedef struct _ViewCollection ViewCollection;
typedef struct _ViewCollectionClass ViewCollectionClass;
typedef struct _ViewCollectionPrivate ViewCollectionPrivate;

#define TYPE_DATA_VIEW (data_view_get_type ())
#define DATA_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_VIEW, DataView))
#define DATA_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_VIEW, DataViewClass))
#define IS_DATA_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_VIEW))
#define IS_DATA_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_VIEW))
#define DATA_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_VIEW, DataViewClass))

typedef struct _DataView DataView;
typedef struct _DataViewClass DataViewClass;

#define TYPE_VIEW_FILTER (view_filter_get_type ())
#define VIEW_FILTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIEW_FILTER, ViewFilter))
#define VIEW_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIEW_FILTER, ViewFilterClass))
#define IS_VIEW_FILTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIEW_FILTER))
#define IS_VIEW_FILTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIEW_FILTER))
#define VIEW_FILTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIEW_FILTER, ViewFilterClass))

typedef struct _ViewFilter ViewFilter;
typedef struct _ViewFilterClass ViewFilterClass;

#define TYPE_SOURCE_COLLECTION (source_collection_get_type ())
#define SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOURCE_COLLECTION, SourceCollection))
#define SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOURCE_COLLECTION, SourceCollectionClass))
#define IS_SOURCE_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOURCE_COLLECTION))
#define IS_SOURCE_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOURCE_COLLECTION))
#define SOURCE_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOURCE_COLLECTION, SourceCollectionClass))

typedef struct _SourceCollection SourceCollection;
typedef struct _SourceCollectionClass SourceCollectionClass;

#define VIEW_COLLECTION_TYPE_MONITOR (view_collection_monitor_get_type ())
#define VIEW_COLLECTION_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VIEW_COLLECTION_TYPE_MONITOR, ViewCollectionMonitor))
#define VIEW_COLLECTION_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VIEW_COLLECTION_TYPE_MONITOR, ViewCollectionMonitorClass))
#define VIEW_COLLECTION_IS_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VIEW_COLLECTION_TYPE_MONITOR))
#define VIEW_COLLECTION_IS_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VIEW_COLLECTION_TYPE_MONITOR))
#define VIEW_COLLECTION_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VIEW_COLLECTION_TYPE_MONITOR, ViewCollectionMonitorClass))

typedef struct _ViewCollectionMonitor ViewCollectionMonitor;
typedef struct _ViewCollectionMonitorClass ViewCollectionMonitorClass;

#define VIEW_COLLECTION_TYPE_MONITOR_IMPL (view_collection_monitor_impl_get_type ())
#define VIEW_COLLECTION_MONITOR_IMPL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VIEW_COLLECTION_TYPE_MONITOR_IMPL, ViewCollectionMonitorImpl))
#define VIEW_COLLECTION_MONITOR_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VIEW_COLLECTION_TYPE_MONITOR_IMPL, ViewCollectionMonitorImplClass))
#define VIEW_COLLECTION_IS_MONITOR_IMPL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VIEW_COLLECTION_TYPE_MONITOR_IMPL))
#define VIEW_COLLECTION_IS_MONITOR_IMPL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VIEW_COLLECTION_TYPE_MONITOR_IMPL))
#define VIEW_COLLECTION_MONITOR_IMPL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VIEW_COLLECTION_TYPE_MONITOR_IMPL, ViewCollectionMonitorImplClass))

typedef struct _ViewCollectionMonitorImpl ViewCollectionMonitorImpl;
typedef struct _ViewCollectionMonitorImplClass ViewCollectionMonitorImplClass;

#define TYPE_DATA_SOURCE (data_source_get_type ())
#define DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SOURCE, DataSource))
#define DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SOURCE, DataSourceClass))
#define IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SOURCE))
#define IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SOURCE))
#define DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SOURCE, DataSourceClass))

typedef struct _DataSource DataSource;
typedef struct _DataSourceClass DataSourceClass;
typedef DataView* (*CreateView) (DataSource* source, gpointer user_data);
typedef gboolean (*CreateViewPredicate) (DataSource* source, gpointer user_data);

#define TYPE_DATA_SET (data_set_get_type ())
#define DATA_SET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SET, DataSet))
#define DATA_SET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SET, DataSetClass))
#define IS_DATA_SET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SET))
#define IS_DATA_SET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SET))
#define DATA_SET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SET, DataSetClass))

typedef struct _DataSet DataSet;
typedef struct _DataSetClass DataSetClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))
#define _data_set_unref0(var) ((var == NULL) ? NULL : (var = (data_set_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _view_filter_unref0(var) ((var == NULL) ? NULL : (var = (view_filter_unref (var), NULL)))

#define TYPE_VIEW_MANAGER (view_manager_get_type ())
#define VIEW_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VIEW_MANAGER, ViewManager))
#define VIEW_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VIEW_MANAGER, ViewManagerClass))
#define IS_VIEW_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VIEW_MANAGER))
#define IS_VIEW_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VIEW_MANAGER))
#define VIEW_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VIEW_MANAGER, ViewManagerClass))

typedef struct _ViewManager ViewManager;
typedef struct _ViewManagerClass ViewManagerClass;
typedef struct _ViewCollectionMonitorPrivate ViewCollectionMonitorPrivate;
typedef struct _ViewCollectionMonitorImplPrivate ViewCollectionMonitorImplPrivate;
#define _view_collection_monitor_unref0(var) ((var == NULL) ? NULL : (var = (view_collection_monitor_unref (var), NULL)))

#define TYPE_THUMBNAIL_SOURCE (thumbnail_source_get_type ())
#define THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSource))
#define THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))
#define IS_THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL_SOURCE))
#define IS_THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL_SOURCE))
#define THUMBNAIL_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))

typedef struct _ThumbnailSource ThumbnailSource;
typedef struct _ThumbnailSourceClass ThumbnailSourceClass;

#define TYPE_MEDIA_SOURCE (media_source_get_type ())
#define MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE, MediaSource))
#define MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE, MediaSourceClass))
#define IS_MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE))
#define IS_MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE))
#define MEDIA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE, MediaSourceClass))

typedef struct _MediaSource MediaSource;
typedef struct _MediaSourceClass MediaSourceClass;

#define TYPE_PHOTO_SOURCE (photo_source_get_type ())
#define PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_SOURCE, PhotoSource))
#define PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_SOURCE, PhotoSourceClass))
#define IS_PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_SOURCE))
#define IS_PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_SOURCE))
#define PHOTO_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_SOURCE, PhotoSourceClass))

typedef struct _PhotoSource PhotoSource;
typedef struct _PhotoSourceClass PhotoSourceClass;

#define TYPE_PHOTO (photo_get_type ())
#define PHOTO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO, Photo))
#define PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO, PhotoClass))
#define IS_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO))
#define IS_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO))
#define PHOTO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO, PhotoClass))

typedef struct _Photo Photo;
typedef struct _PhotoClass PhotoClass;

#define TYPE_THUMBNAIL_VIEW (thumbnail_view_get_type ())
#define THUMBNAIL_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL_VIEW, ThumbnailView))
#define THUMBNAIL_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL_VIEW, ThumbnailViewClass))
#define IS_THUMBNAIL_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL_VIEW))
#define IS_THUMBNAIL_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL_VIEW))
#define THUMBNAIL_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL_VIEW, ThumbnailViewClass))

typedef struct _ThumbnailView ThumbnailView;
typedef struct _ThumbnailViewClass ThumbnailViewClass;

#define TYPE_PHOTO_VIEW (photo_view_get_type ())
#define PHOTO_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_VIEW, PhotoView))
#define PHOTO_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_VIEW, PhotoViewClass))
#define IS_PHOTO_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_VIEW))
#define IS_PHOTO_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_VIEW))
#define PHOTO_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_VIEW, PhotoViewClass))

typedef struct _PhotoView PhotoView;
typedef struct _PhotoViewClass PhotoViewClass;
#define _alteration_unref0(var) ((var == NULL) ? NULL : (var = (alteration_unref (var), NULL)))
typedef enum  {
	RATING_REJECTED = -1,
	RATING_UNRATED = 0,
	RATING_ONE = 1,
	RATING_TWO = 2,
	RATING_THREE = 3,
	RATING_FOUR = 4,
	RATING_FIVE = 5
} Rating;

#define TYPE_RATING (rating_get_type ())
typedef gboolean (*MarkedAction) (DataObject* object, GObject* user, gpointer user_data);

#define VIEW_COLLECTION_TYPE_TOGGLE_LISTS (view_collection_toggle_lists_get_type ())
#define VIEW_COLLECTION_TOGGLE_LISTS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VIEW_COLLECTION_TYPE_TOGGLE_LISTS, ViewCollectionToggleLists))
#define VIEW_COLLECTION_TOGGLE_LISTS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VIEW_COLLECTION_TYPE_TOGGLE_LISTS, ViewCollectionToggleListsClass))
#define VIEW_COLLECTION_IS_TOGGLE_LISTS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VIEW_COLLECTION_TYPE_TOGGLE_LISTS))
#define VIEW_COLLECTION_IS_TOGGLE_LISTS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VIEW_COLLECTION_TYPE_TOGGLE_LISTS))
#define VIEW_COLLECTION_TOGGLE_LISTS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VIEW_COLLECTION_TYPE_TOGGLE_LISTS, ViewCollectionToggleListsClass))

typedef struct _ViewCollectionToggleLists ViewCollectionToggleLists;
typedef struct _ViewCollectionToggleListsClass ViewCollectionToggleListsClass;
typedef struct _ViewCollectionToggleListsPrivate ViewCollectionToggleListsPrivate;
typedef struct _ViewCollectionParamSpecMonitor ViewCollectionParamSpecMonitor;
#define _view_manager_unref0(var) ((var == NULL) ? NULL : (var = (view_manager_unref (var), NULL)))
enum  {
	VIEW_COLLECTION_TOGGLE_LISTS_0_PROPERTY,
	VIEW_COLLECTION_TOGGLE_LISTS_NUM_PROPERTIES
};
static GParamSpec* view_collection_toggle_lists_properties[VIEW_COLLECTION_TOGGLE_LISTS_NUM_PROPERTIES];
enum  {
	VIEW_COLLECTION_ITEMS_SELECTED_SIGNAL,
	VIEW_COLLECTION_ITEMS_UNSELECTED_SIGNAL,
	VIEW_COLLECTION_ITEMS_STATE_CHANGED_SIGNAL,
	VIEW_COLLECTION_SELECTION_GROUP_ALTERED_SIGNAL,
	VIEW_COLLECTION_ITEMS_SHOWN_SIGNAL,
	VIEW_COLLECTION_ITEMS_HIDDEN_SIGNAL,
	VIEW_COLLECTION_ITEMS_VISIBILITY_CHANGED_SIGNAL,
	VIEW_COLLECTION_ITEM_VIEW_ALTERED_SIGNAL,
	VIEW_COLLECTION_ITEM_GEOMETRY_ALTERED_SIGNAL,
	VIEW_COLLECTION_VIEWS_ALTERED_SIGNAL,
	VIEW_COLLECTION_GEOMETRIES_ALTERED_SIGNAL,
	VIEW_COLLECTION_VIEW_FILTER_INSTALLED_SIGNAL,
	VIEW_COLLECTION_VIEW_FILTER_REMOVED_SIGNAL,
	VIEW_COLLECTION_NUM_SIGNALS
};
static guint view_collection_signals[VIEW_COLLECTION_NUM_SIGNALS] = {0};
typedef struct _ViewManagerPrivate ViewManagerPrivate;
typedef struct _ParamSpecViewManager ParamSpecViewManager;
typedef struct _ViewFilterPrivate ViewFilterPrivate;
typedef struct _ParamSpecViewFilter ParamSpecViewFilter;
enum  {
	VIEW_FILTER_REFRESH_SIGNAL,
	VIEW_FILTER_NUM_SIGNALS
};
static guint view_filter_signals[VIEW_FILTER_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _MarkerIface {
	GTypeInterface parent_iface;
	void (*mark) (Marker* self, DataObject* object);
	void (*unmark) (Marker* self, DataObject* object);
	gboolean (*toggle) (Marker* self, DataObject* object);
	void (*mark_many) (Marker* self, GeeCollection* list);
	void (*unmark_many) (Marker* self, GeeCollection* list);
	void (*mark_all) (Marker* self);
	gint (*get_count) (Marker* self);
	GeeCollection* (*get_all) (Marker* self);
};

struct _DataCollection {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DataCollectionPrivate * priv;
};

struct _DataCollectionClass {
	GTypeClass parent_class;
	void (*finalize) (DataCollection *self);
	gchar* (*to_string) (DataCollection* self);
	void (*notify_items_added) (DataCollection* self, GeeIterable* added);
	void (*notify_items_removed) (DataCollection* self, GeeIterable* removed);
	void (*notify_contents_altered) (DataCollection* self, GeeIterable* added, GeeIterable* removed);
	void (*notify_items_altered) (DataCollection* self, GeeMap* items);
	void (*notify_ordering_changed) (DataCollection* self);
	void (*notify_property_set) (DataCollection* self, const gchar* name, GValue* old, GValue* val);
	void (*notify_property_cleared) (DataCollection* self, const gchar* name);
	gboolean (*valid_type) (DataCollection* self, DataObject* object);
	void (*set_comparator) (DataCollection* self, Comparator comparator, gpointer comparator_target, ComparatorPredicate predicate, gpointer predicate_target);
	void (*reset_comparator) (DataCollection* self);
	GeeCollection* (*get_all) (DataCollection* self);
	gint (*get_count) (DataCollection* self);
	DataObject* (*get_at) (DataCollection* self, gint index);
	gint (*index_of) (DataCollection* self, DataObject* object);
	gboolean (*contains) (DataCollection* self, DataObject* object);
	gboolean (*add) (DataCollection* self, DataObject* object);
	GeeCollection* (*add_many) (DataCollection* self, GeeCollection* objects, ProgressMonitor monitor, gpointer monitor_target);
	void (*remove_marked) (DataCollection* self, Marker* m);
	void (*clear) (DataCollection* self);
	void (*close) (DataCollection* self);
	void (*notify_frozen) (DataCollection* self);
	void (*notify_thawed) (DataCollection* self);
	void (*items_added) (DataCollection* self, GeeIterable* added);
	void (*items_removed) (DataCollection* self, GeeIterable* removed);
	void (*contents_altered) (DataCollection* self, GeeIterable* added, GeeIterable* removed);
	void (*items_altered) (DataCollection* self, GeeMap* items);
	void (*ordering_changed) (DataCollection* self);
	void (*property_set) (DataCollection* self, const gchar* name, GValue* old, GValue* val);
	void (*property_cleared) (DataCollection* self, const gchar* name);
	void (*frozen) (DataCollection* self);
	void (*thawed) (DataCollection* self);
};

struct _ViewCollection {
	DataCollection parent_instance;
	ViewCollectionPrivate * priv;
};

struct _ViewCollectionClass {
	DataCollectionClass parent_class;
	void (*notify_items_selected_unselected) (ViewCollection* self, GeeCollection* selected, GeeCollection* unselected);
	void (*notify_selection_group_altered) (ViewCollection* self);
	void (*notify_item_view_altered) (ViewCollection* self, DataView* view);
	void (*notify_views_altered) (ViewCollection* self, GeeCollection* views);
	void (*notify_item_geometry_altered) (ViewCollection* self, DataView* view);
	void (*notify_geometries_altered) (ViewCollection* self, GeeCollection* views);
	void (*notify_items_shown) (ViewCollection* self, GeeCollection* shown);
	void (*notify_items_hidden) (ViewCollection* self, GeeCollection* hidden);
	void (*notify_items_visibility_changed) (ViewCollection* self, GeeCollection* changed);
	void (*notify_view_filter_installed) (ViewCollection* self, ViewFilter* filter);
	void (*notify_view_filter_removed) (ViewCollection* self, ViewFilter* filter);
	DataView* (*get_first) (ViewCollection* self);
	DataView* (*get_first_unrejected) (ViewCollection* self);
	DataView* (*get_first_photo) (ViewCollection* self);
	DataView* (*get_last) (ViewCollection* self);
	DataView* (*get_next) (ViewCollection* self, DataView* view, gboolean** wrapped);
	DataView* (*get_previous) (ViewCollection* self, DataView* view);
	void (*items_selected) (ViewCollection* self, GeeIterable* selected);
	void (*items_unselected) (ViewCollection* self, GeeIterable* unselected);
	void (*items_state_changed) (ViewCollection* self, GeeIterable* changed);
	void (*selection_group_altered) (ViewCollection* self);
	void (*items_shown) (ViewCollection* self, GeeCollection* visible);
	void (*items_hidden) (ViewCollection* self, GeeCollection* hidden);
	void (*items_visibility_changed) (ViewCollection* self, GeeCollection* changed);
	void (*item_view_altered) (ViewCollection* self, DataView* view);
	void (*item_geometry_altered) (ViewCollection* self, DataView* view);
	void (*views_altered) (ViewCollection* self, GeeCollection* views);
	void (*geometries_altered) (ViewCollection* self, GeeCollection* views);
	void (*view_filter_installed) (ViewCollection* self, ViewFilter* filer);
	void (*view_filter_removed) (ViewCollection* self, ViewFilter* filer);
};

struct _ViewCollectionPrivate {
	GeeHashMultiMap* monitors;
	ViewCollection* mirroring;
	CreateView mirroring_ctor;
	gpointer mirroring_ctor_target;
	CreateViewPredicate should_mirror;
	gpointer should_mirror_target;
	GeeSet* filters;
	DataSet* selected;
	DataSet* visible;
	GeeHashSet* frozen_views_altered;
	GeeHashSet* frozen_geometries_altered;
	GeeHashMap* source_map;
};

struct _ViewCollectionMonitor {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ViewCollectionMonitorPrivate * priv;
};

struct _ViewCollectionMonitorClass {
	GTypeClass parent_class;
	void (*finalize) (ViewCollectionMonitor *self);
};

struct _ViewCollectionMonitorImpl {
	ViewCollectionMonitor parent_instance;
	ViewCollectionMonitorImplPrivate * priv;
	ViewCollection* owner;
	SourceCollection* sources;
	ViewManager* manager;
	Alteration* prereq;
};

struct _ViewCollectionMonitorImplClass {
	ViewCollectionMonitorClass parent_class;
};

struct _ViewCollectionToggleLists {
	GObject parent_instance;
	ViewCollectionToggleListsPrivate * priv;
	GeeArrayList* selected;
	GeeArrayList* unselected;
};

struct _ViewCollectionToggleListsClass {
	GObjectClass parent_class;
};

struct _ViewCollectionParamSpecMonitor {
	GParamSpec parent_instance;
};

struct _ViewManager {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ViewManagerPrivate * priv;
};

struct _ViewManagerClass {
	GTypeClass parent_class;
	void (*finalize) (ViewManager *self);
	gboolean (*include_in_view) (ViewManager* self, DataSource* source);
	DataView* (*create_view) (ViewManager* self, DataSource* source);
};

struct _ParamSpecViewManager {
	GParamSpec parent_instance;
};

struct _ViewFilter {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ViewFilterPrivate * priv;
};

struct _ViewFilterClass {
	GTypeClass parent_class;
	void (*finalize) (ViewFilter *self);
	gboolean (*predicate) (ViewFilter* self, DataView* view);
	void (*refresh) (ViewFilter* self);
};

struct _ParamSpecViewFilter {
	GParamSpec parent_instance;
};

static gint ViewCollection_private_offset;
static gpointer view_collection_parent_class = NULL;
static gpointer view_collection_monitor_parent_class = NULL;
static gpointer view_collection_monitor_impl_parent_class = NULL;
static gpointer view_collection_toggle_lists_parent_class = NULL;
static gpointer view_manager_parent_class = NULL;
static gpointer view_filter_parent_class = NULL;

VALA_EXTERN gpointer data_collection_ref (gpointer instance);
VALA_EXTERN void data_collection_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_data_collection (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
VALA_EXTERN void value_set_data_collection (GValue* value,
                                gpointer v_object);
VALA_EXTERN void value_take_data_collection (GValue* value,
                                 gpointer v_object);
VALA_EXTERN gpointer value_get_data_collection (const GValue* value);
VALA_EXTERN GType data_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DataCollection, data_collection_unref)
VALA_EXTERN GType data_object_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DataObject, g_object_unref)
VALA_EXTERN gpointer alteration_ref (gpointer instance);
VALA_EXTERN void alteration_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_alteration (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags);
VALA_EXTERN void value_set_alteration (GValue* value,
                           gpointer v_object);
VALA_EXTERN void value_take_alteration (GValue* value,
                            gpointer v_object);
VALA_EXTERN gpointer value_get_alteration (const GValue* value);
VALA_EXTERN GType alteration_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Alteration, alteration_unref)
VALA_EXTERN GType marker_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Marker, g_object_unref)
VALA_EXTERN GType view_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ViewCollection, data_collection_unref)
VALA_EXTERN GType data_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DataView, g_object_unref)
VALA_EXTERN gpointer view_filter_ref (gpointer instance);
VALA_EXTERN void view_filter_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_view_filter (const gchar* name,
                                    const gchar* nick,
                                    const gchar* blurb,
                                    GType object_type,
                                    GParamFlags flags);
VALA_EXTERN void value_set_view_filter (GValue* value,
                            gpointer v_object);
VALA_EXTERN void value_take_view_filter (GValue* value,
                             gpointer v_object);
VALA_EXTERN gpointer value_get_view_filter (const GValue* value);
VALA_EXTERN GType view_filter_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ViewFilter, view_filter_unref)
VALA_EXTERN GType source_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SourceCollection, data_collection_unref)
VALA_EXTERN gpointer view_collection_monitor_ref (gpointer instance);
VALA_EXTERN void view_collection_monitor_unref (gpointer instance);
VALA_EXTERN GParamSpec* view_collection_param_spec_monitor (const gchar* name,
                                                const gchar* nick,
                                                const gchar* blurb,
                                                GType object_type,
                                                GParamFlags flags);
VALA_EXTERN void view_collection_value_set_monitor (GValue* value,
                                        gpointer v_object);
VALA_EXTERN void view_collection_value_take_monitor (GValue* value,
                                         gpointer v_object);
VALA_EXTERN gpointer view_collection_value_get_monitor (const GValue* value);
VALA_EXTERN GType view_collection_monitor_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ViewCollectionMonitor, view_collection_monitor_unref)
static GType view_collection_monitor_impl_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ViewCollectionMonitorImpl, view_collection_monitor_unref)
VALA_EXTERN GType data_source_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DataSource, g_object_unref)
VALA_EXTERN gpointer data_set_ref (gpointer instance);
VALA_EXTERN void data_set_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_data_set (const gchar* name,
                                 const gchar* nick,
                                 const gchar* blurb,
                                 GType object_type,
                                 GParamFlags flags);
VALA_EXTERN void value_set_data_set (GValue* value,
                         gpointer v_object);
VALA_EXTERN void value_take_data_set (GValue* value,
                          gpointer v_object);
VALA_EXTERN gpointer value_get_data_set (const GValue* value);
VALA_EXTERN GType data_set_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DataSet, data_set_unref)
VALA_EXTERN void view_collection_notify_items_selected_unselected (ViewCollection* self,
                                                       GeeCollection* selected,
                                                       GeeCollection* unselected);
VALA_EXTERN void view_collection_notify_selection_group_altered (ViewCollection* self);
VALA_EXTERN void view_collection_notify_item_view_altered (ViewCollection* self,
                                               DataView* view);
VALA_EXTERN void view_collection_notify_views_altered (ViewCollection* self,
                                           GeeCollection* views);
VALA_EXTERN void view_collection_notify_item_geometry_altered (ViewCollection* self,
                                                   DataView* view);
VALA_EXTERN void view_collection_notify_geometries_altered (ViewCollection* self,
                                                GeeCollection* views);
VALA_EXTERN void view_collection_notify_items_shown (ViewCollection* self,
                                         GeeCollection* shown);
VALA_EXTERN void view_collection_notify_items_hidden (ViewCollection* self,
                                          GeeCollection* hidden);
VALA_EXTERN void view_collection_notify_items_visibility_changed (ViewCollection* self,
                                                      GeeCollection* changed);
VALA_EXTERN void view_collection_notify_view_filter_installed (ViewCollection* self,
                                                   ViewFilter* filter);
VALA_EXTERN void view_collection_notify_view_filter_removed (ViewCollection* self,
                                                 ViewFilter* filter);
VALA_EXTERN void data_collection_clear (DataCollection* self);
VALA_EXTERN void data_collection_close (DataCollection* self);
VALA_EXTERN gboolean data_collection_valid_type (DataCollection* self,
                                     DataObject* object);
VALA_EXTERN gboolean data_collection_add (DataCollection* self,
                              DataObject* object);
VALA_EXTERN GeeCollection* data_collection_add_many (DataCollection* self,
                                         GeeCollection* objects,
                                         ProgressMonitor monitor,
                                         gpointer monitor_target);
VALA_EXTERN void data_collection_notify_items_added (DataCollection* self,
                                         GeeIterable* added);
VALA_EXTERN void data_collection_notify_items_removed (DataCollection* self,
                                           GeeIterable* removed);
VALA_EXTERN void data_collection_items_altered (DataCollection* self,
                                    GeeMap* items);
VALA_EXTERN void data_collection_set_comparator (DataCollection* self,
                                     Comparator comparator,
                                     gpointer comparator_target,
                                     ComparatorPredicate predicate,
                                     gpointer predicate_target);
VALA_EXTERN void data_collection_reset_comparator (DataCollection* self);
VALA_EXTERN GeeCollection* data_collection_get_all (DataCollection* self);
VALA_EXTERN gint data_collection_get_count (DataCollection* self);
VALA_EXTERN DataObject* data_collection_get_at (DataCollection* self,
                                    gint index);
VALA_EXTERN gint data_collection_index_of (DataCollection* self,
                               DataObject* object);
VALA_EXTERN gboolean data_collection_contains (DataCollection* self,
                                   DataObject* object);
VALA_EXTERN DataView* view_collection_get_first (ViewCollection* self);
VALA_EXTERN DataView* view_collection_get_first_unrejected (ViewCollection* self);
VALA_EXTERN DataView* view_collection_get_first_photo (ViewCollection* self);
VALA_EXTERN DataView* view_collection_get_last (ViewCollection* self);
VALA_EXTERN DataView* view_collection_get_next (ViewCollection* self,
                                    DataView* view,
                                    gboolean** wrapped);
VALA_EXTERN DataView* view_collection_get_previous (ViewCollection* self,
                                        DataView* view);
VALA_EXTERN void data_collection_notify_thawed (DataCollection* self);
VALA_EXTERN DataSet* data_set_new (void);
VALA_EXTERN DataSet* data_set_construct (GType object_type);
VALA_EXTERN ViewCollection* view_collection_new (const gchar* name);
VALA_EXTERN ViewCollection* view_collection_construct (GType object_type,
                                           const gchar* name);
VALA_EXTERN DataCollection* data_collection_new (const gchar* name);
VALA_EXTERN DataCollection* data_collection_construct (GType object_type,
                                           const gchar* name);
static void view_collection_real_notify_items_selected_unselected (ViewCollection* self,
                                                            GeeCollection* selected,
                                                            GeeCollection* unselected);
static void view_collection_real_notify_selection_group_altered (ViewCollection* self);
static void view_collection_real_notify_item_view_altered (ViewCollection* self,
                                                    DataView* view);
static void view_collection_real_notify_views_altered (ViewCollection* self,
                                                GeeCollection* views);
static void view_collection_real_notify_item_geometry_altered (ViewCollection* self,
                                                        DataView* view);
static void view_collection_real_notify_geometries_altered (ViewCollection* self,
                                                     GeeCollection* views);
static void view_collection_real_notify_items_shown (ViewCollection* self,
                                              GeeCollection* shown);
static void view_collection_real_notify_items_hidden (ViewCollection* self,
                                               GeeCollection* hidden);
static void view_collection_real_notify_items_visibility_changed (ViewCollection* self,
                                                           GeeCollection* changed);
static void view_collection_real_notify_view_filter_installed (ViewCollection* self,
                                                        ViewFilter* filter);
static void view_collection_real_notify_view_filter_removed (ViewCollection* self,
                                                      ViewFilter* filter);
static void view_collection_real_clear (DataCollection* base);
VALA_EXTERN gchar* data_collection_to_string (DataCollection* self);
static void view_collection_real_close (DataCollection* base);
VALA_EXTERN void view_collection_halt_all_monitoring (ViewCollection* self);
VALA_EXTERN void view_collection_halt_mirroring (ViewCollection* self);
static void view_collection_on_view_filter_refresh (ViewCollection* self);
static void _view_collection_on_view_filter_refresh_view_filter_refresh (ViewFilter* _sender,
                                                                  gpointer self);
VALA_EXTERN gpointer view_manager_ref (gpointer instance);
VALA_EXTERN void view_manager_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_view_manager (const gchar* name,
                                     const gchar* nick,
                                     const gchar* blurb,
                                     GType object_type,
                                     GParamFlags flags);
VALA_EXTERN void value_set_view_manager (GValue* value,
                             gpointer v_object);
VALA_EXTERN void value_take_view_manager (GValue* value,
                              gpointer v_object);
VALA_EXTERN gpointer value_get_view_manager (const GValue* value);
VALA_EXTERN GType view_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ViewManager, view_manager_unref)
VALA_EXTERN ViewCollectionMonitor* view_collection_monitor_source_collection (ViewCollection* self,
                                                                  SourceCollection* sources,
                                                                  ViewManager* manager,
                                                                  Alteration* prereq,
                                                                  GeeCollection* initial,
                                                                  ProgressMonitor progress_monitor,
                                                                  gpointer progress_monitor_target);
VALA_EXTERN void data_collection_freeze_notifications (DataCollection* self);
static ViewCollectionMonitorImpl* view_collection_monitor_impl_new (ViewCollection* owner,
                                                             SourceCollection* sources,
                                                             ViewManager* manager,
                                                             Alteration* prereq);
static ViewCollectionMonitorImpl* view_collection_monitor_impl_construct (GType object_type,
                                                                   ViewCollection* owner,
                                                                   SourceCollection* sources,
                                                                   ViewManager* manager,
                                                                   Alteration* prereq);
VALA_EXTERN DataView* view_manager_create_view (ViewManager* self,
                                    DataSource* source);
static void view_collection_add_sources (ViewCollection* self,
                                  SourceCollection* sources,
                                  GeeIterable* added,
                                  ProgressMonitor progress_monitor,
                                  gpointer progress_monitor_target);
VALA_EXTERN void data_collection_thaw_notifications (DataCollection* self);
VALA_EXTERN void view_collection_halt_monitoring (ViewCollection* self,
                                      ViewCollectionMonitor* m);
VALA_EXTERN void view_collection_mirror (ViewCollection* self,
                             ViewCollection* to_mirror,
                             CreateView mirroring_ctor,
                             gpointer mirroring_ctor_target,
                             CreateViewPredicate should_mirror,
                             gpointer should_mirror_target);
VALA_EXTERN Comparator data_collection_get_comparator (DataCollection* self,
                                           gpointer* result_target);
VALA_EXTERN ComparatorPredicate data_collection_get_comparator_predicate (DataCollection* self,
                                                              gpointer* result_target);
static void view_collection_on_mirror_contents_added (ViewCollection* self,
                                               GeeIterable* added);
static void _view_collection_on_mirror_contents_added_data_collection_items_added (DataCollection* _sender,
                                                                            GeeIterable* added,
                                                                            gpointer self);
static void view_collection_on_mirror_contents_removed (ViewCollection* self,
                                                 GeeIterable* removed);
static void _view_collection_on_mirror_contents_removed_data_collection_items_removed (DataCollection* _sender,
                                                                                GeeIterable* removed,
                                                                                gpointer self);
VALA_EXTERN void view_collection_copy_into (ViewCollection* self,
                                ViewCollection* to_copy,
                                CreateView copying_ctor,
                                gpointer copying_ctor_target,
                                CreateViewPredicate should_copy,
                                gpointer should_copy_target);
VALA_EXTERN DataSource* data_view_get_source (DataView* self);
VALA_EXTERN GType thumbnail_source_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ThumbnailSource, g_object_unref)
VALA_EXTERN GType media_source_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MediaSource, g_object_unref)
VALA_EXTERN GType photo_source_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoSource, g_object_unref)
VALA_EXTERN GType photo_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Photo, g_object_unref)
VALA_EXTERN ViewCollection* view_collection_shuffled_copy (ViewCollection* self,
                                               Photo* start);
VALA_EXTERN PhotoView* photo_view_new (PhotoSource* source);
VALA_EXTERN PhotoView* photo_view_construct (GType object_type,
                                 PhotoSource* source);
VALA_EXTERN GType thumbnail_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ThumbnailView, g_object_unref)
VALA_EXTERN GType photo_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoView, g_object_unref)
VALA_EXTERN gboolean view_collection_is_view_filter_installed (ViewCollection* self,
                                                   ViewFilter* f);
VALA_EXTERN void view_collection_install_view_filter (ViewCollection* self,
                                          ViewFilter* f);
VALA_EXTERN void view_collection_remove_view_filter (ViewCollection* self,
                                         ViewFilter* f);
static void view_collection_filter_altered_items (ViewCollection* self,
                                           GeeCollection* views);
static gboolean view_collection_is_in_filter (ViewCollection* self,
                                       DataView* view);
VALA_EXTERN gboolean view_filter_predicate (ViewFilter* self,
                                DataView* view);
static gboolean view_collection_real_valid_type (DataCollection* base,
                                          DataObject* object);
static void view_collection_on_sources_added (ViewCollection* self,
                                       DataCollection* sources,
                                       GeeIterable* added);
VALA_EXTERN gboolean view_manager_include_in_view (ViewManager* self,
                                       DataSource* source);
static DataView* _view_manager_create_view_create_view (DataSource* source,
                                                 gpointer self);
static gboolean view_collection_real_add (DataCollection* base,
                                   DataObject* object);
VALA_EXTERN void data_view_internal_set_visible (DataView* self,
                                     gboolean visible);
VALA_EXTERN GeeCollection* data_collection_get_singleton (DataObject* object);
static GeeCollection* view_collection_real_add_many (DataCollection* base,
                                              GeeCollection* objects,
                                              ProgressMonitor monitor,
                                              gpointer monitor_target);
static void view_collection_on_sources_removed (ViewCollection* self,
                                         GeeIterable* removed);
VALA_EXTERN Marker* data_collection_start_marking (DataCollection* self);
VALA_EXTERN void marker_mark (Marker* self,
                  DataObject* object);
VALA_EXTERN gint marker_get_count (Marker* self);
VALA_EXTERN void data_collection_remove_marked (DataCollection* self,
                                    Marker* m);
static void view_collection_on_sources_altered (ViewCollection* self,
                                         DataCollection* collection,
                                         GeeMap* items);
VALA_EXTERN gboolean alteration_contains_any (Alteration* self,
                                  Alteration* other);
VALA_EXTERN gboolean view_collection_has_view_for_source (ViewCollection* self,
                                              DataSource* source);
VALA_EXTERN DataView* view_collection_get_view_for_source (ViewCollection* self,
                                               DataSource* source);
VALA_EXTERN gboolean data_set_contains (DataSet* self,
                            DataObject* object);
VALA_EXTERN gboolean data_set_resort_object (DataSet* self,
                                 DataObject* object,
                                 Alteration* alteration);
static gboolean view_collection_is_visible (ViewCollection* self,
                                     DataView* view);
VALA_EXTERN Marker* data_collection_mark_many (DataCollection* self,
                                   GeeCollection* objects);
VALA_EXTERN void data_collection_notify_ordering_changed (DataCollection* self);
static void view_collection_real_notify_items_added (DataCollection* base,
                                              GeeIterable* added);
VALA_EXTERN gboolean data_view_is_selected (DataView* self);
VALA_EXTERN gboolean data_view_is_visible (DataView* self);
static gboolean view_collection_add_many_visible (ViewCollection* self,
                                           GeeCollection* many);
static void view_collection_add_many_selected (ViewCollection* self,
                                        GeeCollection* views);
static void view_collection_real_notify_items_removed (DataCollection* base,
                                                GeeIterable* removed);
VALA_EXTERN gboolean data_set_remove (DataSet* self,
                          DataObject* object);
static void view_collection_remove_many_selected (ViewCollection* self,
                                           GeeCollection* views);
static void view_collection_show_items (ViewCollection* self,
                                 GeeList* to_show);
static void view_collection_hide_items (ViewCollection* self,
                                 GeeList* to_hide);
static void view_collection_real_items_altered (DataCollection* base,
                                         GeeMap* map);
static void view_collection_real_set_comparator (DataCollection* base,
                                          Comparator comparator,
                                          gpointer comparator_target,
                                          ComparatorPredicate predicate,
                                          gpointer predicate_target);
VALA_EXTERN void data_set_set_comparator (DataSet* self,
                              Comparator user_comparator,
                              gpointer user_comparator_target,
                              ComparatorPredicate comparator_predicate,
                              gpointer comparator_predicate_target);
static void view_collection_real_reset_comparator (DataCollection* base);
VALA_EXTERN void data_set_reset_comparator (DataSet* self);
static GeeCollection* view_collection_real_get_all (DataCollection* base);
VALA_EXTERN GeeList* data_set_get_all (DataSet* self);
VALA_EXTERN GeeCollection* view_collection_get_all_unfiltered (ViewCollection* self);
static gint view_collection_real_get_count (DataCollection* base);
VALA_EXTERN gint data_set_get_count (DataSet* self);
VALA_EXTERN gint view_collection_get_unfiltered_count (ViewCollection* self);
static DataObject* view_collection_real_get_at (DataCollection* base,
                                         gint index);
VALA_EXTERN DataObject* data_set_get_at (DataSet* self,
                             gint index);
static gint view_collection_real_index_of (DataCollection* base,
                                    DataObject* object);
VALA_EXTERN gint data_set_index_of (DataSet* self,
                        DataObject* object);
static gboolean view_collection_real_contains (DataCollection* base,
                                        DataObject* object);
static DataView* view_collection_real_get_first (ViewCollection* self);
static DataView* view_collection_real_get_first_unrejected (ViewCollection* self);
VALA_EXTERN GType rating_get_type (void) G_GNUC_CONST ;
VALA_EXTERN Rating media_source_get_rating (MediaSource* self);
static DataView* view_collection_real_get_first_photo (ViewCollection* self);
static DataView* view_collection_real_get_last (ViewCollection* self);
static DataView* view_collection_real_get_next (ViewCollection* self,
                                         DataView* view,
                                         gboolean** wrapped);
static gboolean* _bool_dup (gboolean* self);
static DataView* view_collection_real_get_previous (ViewCollection* self,
                                             DataView* view);
VALA_EXTERN gboolean view_collection_get_immediate_neighbors (ViewCollection* self,
                                                  DataSource* home,
                                                  DataSource** next,
                                                  DataSource** prev,
                                                  const gchar* type_selector);
VALA_EXTERN gchar* data_source_get_typename (DataSource* self);
VALA_EXTERN GeeSet* view_collection_get_extended_neighbors (ViewCollection* self,
                                                DataSource* home,
                                                const gchar* typename);
VALA_EXTERN gboolean data_set_add_many (DataSet* self,
                            GeeCollection* objects);
VALA_EXTERN gboolean data_set_remove_many (DataSet* self,
                               GeeCollection* objects);
VALA_EXTERN void view_collection_select_marked (ViewCollection* self,
                                    Marker* marker);
VALA_EXTERN void data_collection_act_on_marked (DataCollection* self,
                                    Marker* m,
                                    MarkedAction action,
                                    gpointer action_target,
                                    ProgressMonitor monitor,
                                    gpointer monitor_target,
                                    GObject* user);
static gboolean view_collection_select_item (ViewCollection* self,
                                      DataObject* object,
                                      GObject* user);
static gboolean _view_collection_select_item_marked_action (DataObject* object,
                                                     GObject* user,
                                                     gpointer self);
VALA_EXTERN void view_collection_select_all (ViewCollection* self);
VALA_EXTERN void marker_mark_all (Marker* self);
VALA_EXTERN void data_view_internal_set_selected (DataView* self,
                                      gboolean selected);
VALA_EXTERN void view_collection_unselect_marked (ViewCollection* self,
                                      Marker* marker);
static gboolean view_collection_unselect_item (ViewCollection* self,
                                        DataObject* object,
                                        GObject* user);
static gboolean _view_collection_unselect_item_marked_action (DataObject* object,
                                                       GObject* user,
                                                       gpointer self);
VALA_EXTERN void view_collection_unselect_all (ViewCollection* self);
VALA_EXTERN void marker_mark_many (Marker* self,
                       GeeCollection* list);
VALA_EXTERN GeeList* view_collection_get_selected (ViewCollection* self);
VALA_EXTERN void view_collection_unselect_all_but (ViewCollection* self,
                                       DataView* exception);
VALA_EXTERN void view_collection_unselect_and_select_marked (ViewCollection* self,
                                                 Marker* unselect,
                                                 Marker* select);
VALA_EXTERN void view_collection_toggle_marked (ViewCollection* self,
                                    Marker* marker);
static GType view_collection_toggle_lists_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ViewCollectionToggleLists, g_object_unref)
static ViewCollectionToggleLists* view_collection_toggle_lists_new (void);
static ViewCollectionToggleLists* view_collection_toggle_lists_construct (GType object_type);
static gboolean view_collection_toggle_item (ViewCollection* self,
                                      DataObject* object,
                                      GObject* user);
static gboolean _view_collection_toggle_item_marked_action (DataObject* object,
                                                     GObject* user,
                                                     gpointer self);
VALA_EXTERN gboolean data_view_internal_toggle (DataView* self);
VALA_EXTERN gint view_collection_get_selected_count (ViewCollection* self);
VALA_EXTERN DataView* view_collection_get_selected_at (ViewCollection* self,
                                           gint index);
VALA_EXTERN DataSet* data_collection_get_dataset_copy (DataCollection* self);
VALA_EXTERN gboolean view_collection_has_view_for_source_with_filtered (ViewCollection* self,
                                                            DataSource* source);
VALA_EXTERN DataView* view_collection_get_view_for_source_filtered (ViewCollection* self,
                                                        DataSource* source);
VALA_EXTERN GeeCollection* view_collection_get_sources (ViewCollection* self);
VALA_EXTERN gboolean view_collection_has_source_of_type (ViewCollection* self,
                                             GType t);
VALA_EXTERN gint view_collection_get_sources_of_type_count (ViewCollection* self,
                                                GType t);
VALA_EXTERN GeeList* view_collection_get_sources_of_type (ViewCollection* self,
                                              GType t);
VALA_EXTERN GeeList* view_collection_get_selected_sources (ViewCollection* self);
VALA_EXTERN DataSource* view_collection_get_selected_source_at (ViewCollection* self,
                                                    gint index);
VALA_EXTERN GeeList* view_collection_get_selected_sources_of_type (ViewCollection* self,
                                                       GType t);
VALA_EXTERN gint view_collection_index_of_source (ViewCollection* self,
                                      DataSource* source);
VALA_EXTERN void view_collection_internal_notify_view_altered (ViewCollection* self,
                                                   DataView* view);
VALA_EXTERN gboolean data_collection_are_notifications_frozen (DataCollection* self);
VALA_EXTERN void view_collection_internal_notify_geometry_altered (ViewCollection* self,
                                                       DataView* view);
static void view_collection_real_notify_thawed (DataCollection* base);
VALA_EXTERN gboolean view_collection_are_items_filtered_out (ViewCollection* self);
static void view_collection_real_items_selected (ViewCollection* self,
                                          GeeIterable* selected);
static void view_collection_real_items_unselected (ViewCollection* self,
                                            GeeIterable* unselected);
static void view_collection_real_items_state_changed (ViewCollection* self,
                                               GeeIterable* changed);
static void view_collection_real_selection_group_altered (ViewCollection* self);
static void view_collection_real_items_shown (ViewCollection* self,
                                       GeeCollection* visible);
static void view_collection_real_items_hidden (ViewCollection* self,
                                        GeeCollection* hidden);
static void view_collection_real_items_visibility_changed (ViewCollection* self,
                                                    GeeCollection* changed);
static void view_collection_real_item_view_altered (ViewCollection* self,
                                             DataView* view);
static void view_collection_real_item_geometry_altered (ViewCollection* self,
                                                 DataView* view);
static void view_collection_real_views_altered (ViewCollection* self,
                                         GeeCollection* views);
static void view_collection_real_geometries_altered (ViewCollection* self,
                                              GeeCollection* views);
static void view_collection_real_view_filter_installed (ViewCollection* self,
                                                 ViewFilter* filer);
static void g_cclosure_user_marshal_VOID__VIEW_FILTER (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data);
static void view_collection_real_view_filter_removed (ViewCollection* self,
                                               ViewFilter* filer);
VALA_EXTERN ViewCollectionMonitor* view_collection_monitor_new (void);
VALA_EXTERN ViewCollectionMonitor* view_collection_monitor_construct (GType object_type);
static void view_collection_monitor_finalize (ViewCollectionMonitor * obj);
static GType view_collection_monitor_get_type_once (void);
static void _view_collection_on_sources_added_data_collection_items_added (DataCollection* _sender,
                                                                    GeeIterable* added,
                                                                    gpointer self);
static void _view_collection_on_sources_removed_data_collection_items_removed (DataCollection* _sender,
                                                                        GeeIterable* removed,
                                                                        gpointer self);
static void _view_collection_on_sources_altered_data_collection_items_altered (DataCollection* _sender,
                                                                        GeeMap* items,
                                                                        gpointer self);
static void view_collection_monitor_impl_finalize (ViewCollectionMonitor * obj);
static GType view_collection_monitor_impl_get_type_once (void);
static void view_collection_toggle_lists_finalize (GObject * obj);
static GType view_collection_toggle_lists_get_type_once (void);
static void view_collection_finalize (DataCollection * obj);
static GType view_collection_get_type_once (void);
static gboolean view_manager_real_include_in_view (ViewManager* self,
                                            DataSource* source);
static DataView* view_manager_real_create_view (ViewManager* self,
                                         DataSource* source);
VALA_EXTERN ViewManager* view_manager_construct (GType object_type);
static void view_manager_finalize (ViewManager * obj);
static GType view_manager_get_type_once (void);
static gboolean view_filter_real_predicate (ViewFilter* self,
                                     DataView* view);
VALA_EXTERN ViewFilter* view_filter_construct (GType object_type);
static void view_filter_real_refresh (ViewFilter* self);
static void view_filter_finalize (ViewFilter * obj);
static GType view_filter_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
view_collection_get_instance_private (ViewCollection* self)
{
	return G_STRUCT_MEMBER_P (self, ViewCollection_private_offset);
}

ViewCollection*
view_collection_construct (GType object_type,
                           const gchar* name)
{
	ViewCollection* self = NULL;
#line 125 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 126 "../src/core/ViewCollection.vala"
	self = (ViewCollection*) data_collection_construct (object_type, name);
#line 125 "../src/core/ViewCollection.vala"
	return self;
#line 1056 "ViewCollection.c"
}

ViewCollection*
view_collection_new (const gchar* name)
{
#line 125 "../src/core/ViewCollection.vala"
	return view_collection_construct (TYPE_VIEW_COLLECTION, name);
#line 1064 "ViewCollection.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 142 "../src/core/ViewCollection.vala"
	return self ? g_object_ref (self) : NULL;
#line 1072 "ViewCollection.c"
}

static void
view_collection_real_notify_items_selected_unselected (ViewCollection* self,
                                                       GeeCollection* selected,
                                                       GeeCollection* unselected)
{
	gboolean _tmp0_ = FALSE;
	gboolean has_selected = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean has_unselected = FALSE;
	GeeCollection* sum = NULL;
	gboolean _tmp6_ = FALSE;
	GeeCollection* _tmp14_;
#line 129 "../src/core/ViewCollection.vala"
	g_return_if_fail ((selected == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (selected, GEE_TYPE_COLLECTION));
#line 129 "../src/core/ViewCollection.vala"
	g_return_if_fail ((unselected == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (unselected, GEE_TYPE_COLLECTION));
#line 131 "../src/core/ViewCollection.vala"
	if (selected != NULL) {
#line 1093 "ViewCollection.c"
		gint _tmp1_;
		gint _tmp2_;
#line 131 "../src/core/ViewCollection.vala"
		_tmp1_ = gee_collection_get_size (selected);
#line 131 "../src/core/ViewCollection.vala"
		_tmp2_ = _tmp1_;
#line 131 "../src/core/ViewCollection.vala"
		_tmp0_ = _tmp2_ > 0;
#line 1102 "ViewCollection.c"
	} else {
#line 131 "../src/core/ViewCollection.vala"
		_tmp0_ = FALSE;
#line 1106 "ViewCollection.c"
	}
#line 131 "../src/core/ViewCollection.vala"
	has_selected = _tmp0_;
#line 132 "../src/core/ViewCollection.vala"
	if (unselected != NULL) {
#line 1112 "ViewCollection.c"
		gint _tmp4_;
		gint _tmp5_;
#line 132 "../src/core/ViewCollection.vala"
		_tmp4_ = gee_collection_get_size (unselected);
#line 132 "../src/core/ViewCollection.vala"
		_tmp5_ = _tmp4_;
#line 132 "../src/core/ViewCollection.vala"
		_tmp3_ = _tmp5_ > 0;
#line 1121 "ViewCollection.c"
	} else {
#line 132 "../src/core/ViewCollection.vala"
		_tmp3_ = FALSE;
#line 1125 "ViewCollection.c"
	}
#line 132 "../src/core/ViewCollection.vala"
	has_unselected = _tmp3_;
#line 134 "../src/core/ViewCollection.vala"
	if (has_selected) {
#line 135 "../src/core/ViewCollection.vala"
		g_signal_emit (self, view_collection_signals[VIEW_COLLECTION_ITEMS_SELECTED_SIGNAL], 0, G_TYPE_CHECK_INSTANCE_CAST (selected, GEE_TYPE_ITERABLE, GeeIterable));
#line 1133 "ViewCollection.c"
	}
#line 137 "../src/core/ViewCollection.vala"
	if (has_unselected) {
#line 138 "../src/core/ViewCollection.vala"
		g_signal_emit (self, view_collection_signals[VIEW_COLLECTION_ITEMS_UNSELECTED_SIGNAL], 0, G_TYPE_CHECK_INSTANCE_CAST (unselected, GEE_TYPE_ITERABLE, GeeIterable));
#line 1139 "ViewCollection.c"
	}
#line 141 "../src/core/ViewCollection.vala"
	if (has_selected) {
#line 141 "../src/core/ViewCollection.vala"
		_tmp6_ = !has_unselected;
#line 1145 "ViewCollection.c"
	} else {
#line 141 "../src/core/ViewCollection.vala"
		_tmp6_ = FALSE;
#line 1149 "ViewCollection.c"
	}
#line 141 "../src/core/ViewCollection.vala"
	if (_tmp6_) {
#line 1153 "ViewCollection.c"
		GeeCollection* _tmp7_;
#line 142 "../src/core/ViewCollection.vala"
		_tmp7_ = _g_object_ref0 (selected);
#line 142 "../src/core/ViewCollection.vala"
		_g_object_unref0 (sum);
#line 142 "../src/core/ViewCollection.vala"
		sum = _tmp7_;
#line 1161 "ViewCollection.c"
	} else {
		gboolean _tmp8_ = FALSE;
#line 143 "../src/core/ViewCollection.vala"
		if (!has_selected) {
#line 143 "../src/core/ViewCollection.vala"
			_tmp8_ = has_unselected;
#line 1168 "ViewCollection.c"
		} else {
#line 143 "../src/core/ViewCollection.vala"
			_tmp8_ = FALSE;
#line 1172 "ViewCollection.c"
		}
#line 143 "../src/core/ViewCollection.vala"
		if (_tmp8_) {
#line 1176 "ViewCollection.c"
			GeeCollection* _tmp9_;
#line 144 "../src/core/ViewCollection.vala"
			_tmp9_ = _g_object_ref0 (unselected);
#line 144 "../src/core/ViewCollection.vala"
			_g_object_unref0 (sum);
#line 144 "../src/core/ViewCollection.vala"
			sum = _tmp9_;
#line 1184 "ViewCollection.c"
		} else {
			gboolean _tmp10_ = FALSE;
#line 145 "../src/core/ViewCollection.vala"
			if (!has_selected) {
#line 145 "../src/core/ViewCollection.vala"
				_tmp10_ = !has_unselected;
#line 1191 "ViewCollection.c"
			} else {
#line 145 "../src/core/ViewCollection.vala"
				_tmp10_ = FALSE;
#line 1195 "ViewCollection.c"
			}
#line 145 "../src/core/ViewCollection.vala"
			if (_tmp10_) {
#line 146 "../src/core/ViewCollection.vala"
				_g_object_unref0 (sum);
#line 146 "../src/core/ViewCollection.vala"
				sum = NULL;
#line 1203 "ViewCollection.c"
			} else {
				GeeHashSet* _tmp11_;
				GeeCollection* _tmp12_;
				GeeCollection* _tmp13_;
#line 148 "../src/core/ViewCollection.vala"
				_tmp11_ = gee_hash_set_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 148 "../src/core/ViewCollection.vala"
				_g_object_unref0 (sum);
#line 148 "../src/core/ViewCollection.vala"
				sum = G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, GEE_TYPE_COLLECTION, GeeCollection);
#line 149 "../src/core/ViewCollection.vala"
				_tmp12_ = sum;
#line 149 "../src/core/ViewCollection.vala"
				gee_collection_add_all (_tmp12_, selected);
#line 150 "../src/core/ViewCollection.vala"
				_tmp13_ = sum;
#line 150 "../src/core/ViewCollection.vala"
				gee_collection_add_all (_tmp13_, unselected);
#line 1222 "ViewCollection.c"
			}
		}
	}
#line 153 "../src/core/ViewCollection.vala"
	_tmp14_ = sum;
#line 153 "../src/core/ViewCollection.vala"
	if (_tmp14_ != NULL) {
#line 1230 "ViewCollection.c"
		GeeCollection* _tmp15_;
#line 154 "../src/core/ViewCollection.vala"
		_tmp15_ = sum;
#line 154 "../src/core/ViewCollection.vala"
		g_signal_emit (self, view_collection_signals[VIEW_COLLECTION_ITEMS_STATE_CHANGED_SIGNAL], 0, G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, GEE_TYPE_ITERABLE, GeeIterable));
#line 155 "../src/core/ViewCollection.vala"
		view_collection_notify_selection_group_altered (self);
#line 1238 "ViewCollection.c"
	}
#line 129 "../src/core/ViewCollection.vala"
	_g_object_unref0 (sum);
#line 1242 "ViewCollection.c"
}

void
view_collection_notify_items_selected_unselected (ViewCollection* self,
                                                  GeeCollection* selected,
                                                  GeeCollection* unselected)
{
	ViewCollectionClass* _klass_;
#line 129 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 129 "../src/core/ViewCollection.vala"
	_klass_ = VIEW_COLLECTION_GET_CLASS (self);
#line 129 "../src/core/ViewCollection.vala"
	if (_klass_->notify_items_selected_unselected) {
#line 129 "../src/core/ViewCollection.vala"
		_klass_->notify_items_selected_unselected (self, selected, unselected);
#line 1259 "ViewCollection.c"
	}
}

static void
view_collection_real_notify_selection_group_altered (ViewCollection* self)
{
#line 160 "../src/core/ViewCollection.vala"
	g_signal_emit (self, view_collection_signals[VIEW_COLLECTION_SELECTION_GROUP_ALTERED_SIGNAL], 0);
#line 1268 "ViewCollection.c"
}

void
view_collection_notify_selection_group_altered (ViewCollection* self)
{
	ViewCollectionClass* _klass_;
#line 159 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 159 "../src/core/ViewCollection.vala"
	_klass_ = VIEW_COLLECTION_GET_CLASS (self);
#line 159 "../src/core/ViewCollection.vala"
	if (_klass_->notify_selection_group_altered) {
#line 159 "../src/core/ViewCollection.vala"
		_klass_->notify_selection_group_altered (self);
#line 1283 "ViewCollection.c"
	}
}

static void
view_collection_real_notify_item_view_altered (ViewCollection* self,
                                               DataView* view)
{
#line 163 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 164 "../src/core/ViewCollection.vala"
	g_signal_emit (self, view_collection_signals[VIEW_COLLECTION_ITEM_VIEW_ALTERED_SIGNAL], 0, view);
#line 1295 "ViewCollection.c"
}

void
view_collection_notify_item_view_altered (ViewCollection* self,
                                          DataView* view)
{
	ViewCollectionClass* _klass_;
#line 163 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 163 "../src/core/ViewCollection.vala"
	_klass_ = VIEW_COLLECTION_GET_CLASS (self);
#line 163 "../src/core/ViewCollection.vala"
	if (_klass_->notify_item_view_altered) {
#line 163 "../src/core/ViewCollection.vala"
		_klass_->notify_item_view_altered (self, view);
#line 1311 "ViewCollection.c"
	}
}

static void
view_collection_real_notify_views_altered (ViewCollection* self,
                                           GeeCollection* views)
{
#line 167 "../src/core/ViewCollection.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (views, GEE_TYPE_COLLECTION));
#line 168 "../src/core/ViewCollection.vala"
	g_signal_emit (self, view_collection_signals[VIEW_COLLECTION_VIEWS_ALTERED_SIGNAL], 0, views);
#line 1323 "ViewCollection.c"
}

void
view_collection_notify_views_altered (ViewCollection* self,
                                      GeeCollection* views)
{
	ViewCollectionClass* _klass_;
#line 167 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 167 "../src/core/ViewCollection.vala"
	_klass_ = VIEW_COLLECTION_GET_CLASS (self);
#line 167 "../src/core/ViewCollection.vala"
	if (_klass_->notify_views_altered) {
#line 167 "../src/core/ViewCollection.vala"
		_klass_->notify_views_altered (self, views);
#line 1339 "ViewCollection.c"
	}
}

static void
view_collection_real_notify_item_geometry_altered (ViewCollection* self,
                                                   DataView* view)
{
#line 171 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 172 "../src/core/ViewCollection.vala"
	g_signal_emit (self, view_collection_signals[VIEW_COLLECTION_ITEM_GEOMETRY_ALTERED_SIGNAL], 0, view);
#line 1351 "ViewCollection.c"
}

void
view_collection_notify_item_geometry_altered (ViewCollection* self,
                                              DataView* view)
{
	ViewCollectionClass* _klass_;
#line 171 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 171 "../src/core/ViewCollection.vala"
	_klass_ = VIEW_COLLECTION_GET_CLASS (self);
#line 171 "../src/core/ViewCollection.vala"
	if (_klass_->notify_item_geometry_altered) {
#line 171 "../src/core/ViewCollection.vala"
		_klass_->notify_item_geometry_altered (self, view);
#line 1367 "ViewCollection.c"
	}
}

static void
view_collection_real_notify_geometries_altered (ViewCollection* self,
                                                GeeCollection* views)
{
#line 175 "../src/core/ViewCollection.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (views, GEE_TYPE_COLLECTION));
#line 176 "../src/core/ViewCollection.vala"
	g_signal_emit (self, view_collection_signals[VIEW_COLLECTION_GEOMETRIES_ALTERED_SIGNAL], 0, views);
#line 1379 "ViewCollection.c"
}

void
view_collection_notify_geometries_altered (ViewCollection* self,
                                           GeeCollection* views)
{
	ViewCollectionClass* _klass_;
#line 175 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 175 "../src/core/ViewCollection.vala"
	_klass_ = VIEW_COLLECTION_GET_CLASS (self);
#line 175 "../src/core/ViewCollection.vala"
	if (_klass_->notify_geometries_altered) {
#line 175 "../src/core/ViewCollection.vala"
		_klass_->notify_geometries_altered (self, views);
#line 1395 "ViewCollection.c"
	}
}

static void
view_collection_real_notify_items_shown (ViewCollection* self,
                                         GeeCollection* shown)
{
#line 179 "../src/core/ViewCollection.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (shown, GEE_TYPE_COLLECTION));
#line 180 "../src/core/ViewCollection.vala"
	g_signal_emit (self, view_collection_signals[VIEW_COLLECTION_ITEMS_SHOWN_SIGNAL], 0, shown);
#line 1407 "ViewCollection.c"
}

void
view_collection_notify_items_shown (ViewCollection* self,
                                    GeeCollection* shown)
{
	ViewCollectionClass* _klass_;
#line 179 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 179 "../src/core/ViewCollection.vala"
	_klass_ = VIEW_COLLECTION_GET_CLASS (self);
#line 179 "../src/core/ViewCollection.vala"
	if (_klass_->notify_items_shown) {
#line 179 "../src/core/ViewCollection.vala"
		_klass_->notify_items_shown (self, shown);
#line 1423 "ViewCollection.c"
	}
}

static void
view_collection_real_notify_items_hidden (ViewCollection* self,
                                          GeeCollection* hidden)
{
#line 183 "../src/core/ViewCollection.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (hidden, GEE_TYPE_COLLECTION));
#line 184 "../src/core/ViewCollection.vala"
	g_signal_emit (self, view_collection_signals[VIEW_COLLECTION_ITEMS_HIDDEN_SIGNAL], 0, hidden);
#line 1435 "ViewCollection.c"
}

void
view_collection_notify_items_hidden (ViewCollection* self,
                                     GeeCollection* hidden)
{
	ViewCollectionClass* _klass_;
#line 183 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 183 "../src/core/ViewCollection.vala"
	_klass_ = VIEW_COLLECTION_GET_CLASS (self);
#line 183 "../src/core/ViewCollection.vala"
	if (_klass_->notify_items_hidden) {
#line 183 "../src/core/ViewCollection.vala"
		_klass_->notify_items_hidden (self, hidden);
#line 1451 "ViewCollection.c"
	}
}

static void
view_collection_real_notify_items_visibility_changed (ViewCollection* self,
                                                      GeeCollection* changed)
{
#line 187 "../src/core/ViewCollection.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (changed, GEE_TYPE_COLLECTION));
#line 188 "../src/core/ViewCollection.vala"
	g_signal_emit (self, view_collection_signals[VIEW_COLLECTION_ITEMS_VISIBILITY_CHANGED_SIGNAL], 0, changed);
#line 1463 "ViewCollection.c"
}

void
view_collection_notify_items_visibility_changed (ViewCollection* self,
                                                 GeeCollection* changed)
{
	ViewCollectionClass* _klass_;
#line 187 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 187 "../src/core/ViewCollection.vala"
	_klass_ = VIEW_COLLECTION_GET_CLASS (self);
#line 187 "../src/core/ViewCollection.vala"
	if (_klass_->notify_items_visibility_changed) {
#line 187 "../src/core/ViewCollection.vala"
		_klass_->notify_items_visibility_changed (self, changed);
#line 1479 "ViewCollection.c"
	}
}

static void
view_collection_real_notify_view_filter_installed (ViewCollection* self,
                                                   ViewFilter* filter)
{
#line 191 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_FILTER (filter));
#line 192 "../src/core/ViewCollection.vala"
	g_signal_emit (self, view_collection_signals[VIEW_COLLECTION_VIEW_FILTER_INSTALLED_SIGNAL], 0, filter);
#line 1491 "ViewCollection.c"
}

void
view_collection_notify_view_filter_installed (ViewCollection* self,
                                              ViewFilter* filter)
{
	ViewCollectionClass* _klass_;
#line 191 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 191 "../src/core/ViewCollection.vala"
	_klass_ = VIEW_COLLECTION_GET_CLASS (self);
#line 191 "../src/core/ViewCollection.vala"
	if (_klass_->notify_view_filter_installed) {
#line 191 "../src/core/ViewCollection.vala"
		_klass_->notify_view_filter_installed (self, filter);
#line 1507 "ViewCollection.c"
	}
}

static void
view_collection_real_notify_view_filter_removed (ViewCollection* self,
                                                 ViewFilter* filter)
{
#line 195 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_FILTER (filter));
#line 196 "../src/core/ViewCollection.vala"
	g_signal_emit (self, view_collection_signals[VIEW_COLLECTION_VIEW_FILTER_REMOVED_SIGNAL], 0, filter);
#line 1519 "ViewCollection.c"
}

void
view_collection_notify_view_filter_removed (ViewCollection* self,
                                            ViewFilter* filter)
{
	ViewCollectionClass* _klass_;
#line 195 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 195 "../src/core/ViewCollection.vala"
	_klass_ = VIEW_COLLECTION_GET_CLASS (self);
#line 195 "../src/core/ViewCollection.vala"
	if (_klass_->notify_view_filter_removed) {
#line 195 "../src/core/ViewCollection.vala"
		_klass_->notify_view_filter_removed (self, filter);
#line 1535 "ViewCollection.c"
	}
}

static void
view_collection_real_clear (DataCollection* base)
{
	ViewCollection * self;
	gboolean _tmp0_ = FALSE;
	GeeHashMultiMap* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 199 "../src/core/ViewCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIEW_COLLECTION, ViewCollection);
#line 202 "../src/core/ViewCollection.vala"
	_tmp1_ = self->priv->monitors;
#line 202 "../src/core/ViewCollection.vala"
	_tmp2_ = gee_multi_map_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_MULTI_MAP, GeeMultiMap));
#line 202 "../src/core/ViewCollection.vala"
	_tmp3_ = _tmp2_;
#line 202 "../src/core/ViewCollection.vala"
	if (_tmp3_ > 0) {
#line 202 "../src/core/ViewCollection.vala"
		_tmp0_ = TRUE;
#line 1559 "ViewCollection.c"
	} else {
		ViewCollection* _tmp4_;
#line 202 "../src/core/ViewCollection.vala"
		_tmp4_ = self->priv->mirroring;
#line 202 "../src/core/ViewCollection.vala"
		_tmp0_ = _tmp4_ != NULL;
#line 1566 "ViewCollection.c"
	}
#line 202 "../src/core/ViewCollection.vala"
	if (_tmp0_) {
#line 1570 "ViewCollection.c"
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 203 "../src/core/ViewCollection.vala"
		_tmp5_ = data_collection_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 203 "../src/core/ViewCollection.vala"
		_tmp6_ = _tmp5_;
#line 203 "../src/core/ViewCollection.vala"
		g_warning ("ViewCollection.vala:203: Cannot clear %s: monitoring or mirroring in e" \
"ffect", _tmp6_);
#line 203 "../src/core/ViewCollection.vala"
		_g_free0 (_tmp6_);
#line 205 "../src/core/ViewCollection.vala"
		return;
#line 1583 "ViewCollection.c"
	}
#line 208 "../src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->clear (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 1587 "ViewCollection.c"
}

static void
_view_collection_on_view_filter_refresh_view_filter_refresh (ViewFilter* _sender,
                                                             gpointer self)
{
#line 215 "../src/core/ViewCollection.vala"
	view_collection_on_view_filter_refresh ((ViewCollection*) self);
#line 1596 "ViewCollection.c"
}

static void
view_collection_real_close (DataCollection* base)
{
	ViewCollection * self;
	GeeSet* _tmp7_;
#line 211 "../src/core/ViewCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIEW_COLLECTION, ViewCollection);
#line 212 "../src/core/ViewCollection.vala"
	view_collection_halt_all_monitoring (self);
#line 213 "../src/core/ViewCollection.vala"
	view_collection_halt_mirroring (self);
#line 1610 "ViewCollection.c"
	{
		GeeIterator* _f_it = NULL;
		GeeSet* _tmp0_;
		GeeIterator* _tmp1_;
#line 214 "../src/core/ViewCollection.vala"
		_tmp0_ = self->priv->filters;
#line 214 "../src/core/ViewCollection.vala"
		_tmp1_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ITERABLE, GeeIterable));
#line 214 "../src/core/ViewCollection.vala"
		_f_it = _tmp1_;
#line 214 "../src/core/ViewCollection.vala"
		while (TRUE) {
#line 1623 "ViewCollection.c"
			GeeIterator* _tmp2_;
			ViewFilter* f = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			ViewFilter* _tmp5_;
			guint _tmp6_;
#line 214 "../src/core/ViewCollection.vala"
			_tmp2_ = _f_it;
#line 214 "../src/core/ViewCollection.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 214 "../src/core/ViewCollection.vala"
				break;
#line 1636 "ViewCollection.c"
			}
#line 214 "../src/core/ViewCollection.vala"
			_tmp3_ = _f_it;
#line 214 "../src/core/ViewCollection.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 214 "../src/core/ViewCollection.vala"
			f = (ViewFilter*) _tmp4_;
#line 215 "../src/core/ViewCollection.vala"
			_tmp5_ = f;
#line 215 "../src/core/ViewCollection.vala"
			g_signal_parse_name ("refresh", TYPE_VIEW_FILTER, &_tmp6_, NULL, FALSE);
#line 215 "../src/core/ViewCollection.vala"
			g_signal_handlers_disconnect_matched (_tmp5_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp6_, 0, NULL, (GCallback) _view_collection_on_view_filter_refresh_view_filter_refresh, self);
#line 214 "../src/core/ViewCollection.vala"
			_view_filter_unref0 (f);
#line 1652 "ViewCollection.c"
		}
#line 214 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_f_it);
#line 1656 "ViewCollection.c"
	}
#line 216 "../src/core/ViewCollection.vala"
	_tmp7_ = self->priv->filters;
#line 216 "../src/core/ViewCollection.vala"
	gee_collection_clear (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_COLLECTION, GeeCollection));
#line 218 "../src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->close (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 1664 "ViewCollection.c"
}

ViewCollectionMonitor*
view_collection_monitor_source_collection (ViewCollection* self,
                                           SourceCollection* sources,
                                           ViewManager* manager,
                                           Alteration* prereq,
                                           GeeCollection* initial,
                                           ProgressMonitor progress_monitor,
                                           gpointer progress_monitor_target)
{
	ViewCollectionMonitorImpl* monitor = NULL;
	ViewCollectionMonitorImpl* _tmp0_;
	GeeHashMultiMap* _tmp1_;
	ViewCollectionMonitorImpl* _tmp2_;
	gboolean _tmp3_ = FALSE;
	ViewCollectionMonitor* result;
#line 221 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 221 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_SOURCE_COLLECTION (sources), NULL);
#line 221 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_MANAGER (manager), NULL);
#line 221 "../src/core/ViewCollection.vala"
	g_return_val_if_fail ((prereq == NULL) || IS_ALTERATION (prereq), NULL);
#line 221 "../src/core/ViewCollection.vala"
	g_return_val_if_fail ((initial == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (initial, GEE_TYPE_COLLECTION), NULL);
#line 225 "../src/core/ViewCollection.vala"
	view_collection_halt_mirroring (self);
#line 227 "../src/core/ViewCollection.vala"
	data_collection_freeze_notifications (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 230 "../src/core/ViewCollection.vala"
	_tmp0_ = view_collection_monitor_impl_new (self, sources, manager, prereq);
#line 230 "../src/core/ViewCollection.vala"
	monitor = _tmp0_;
#line 231 "../src/core/ViewCollection.vala"
	_tmp1_ = self->priv->monitors;
#line 231 "../src/core/ViewCollection.vala"
	_tmp2_ = monitor;
#line 231 "../src/core/ViewCollection.vala"
	gee_multi_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_MULTI_MAP, GeeMultiMap), sources, _tmp2_);
#line 233 "../src/core/ViewCollection.vala"
	if (initial != NULL) {
#line 1708 "ViewCollection.c"
		gint _tmp4_;
		gint _tmp5_;
#line 233 "../src/core/ViewCollection.vala"
		_tmp4_ = gee_collection_get_size (initial);
#line 233 "../src/core/ViewCollection.vala"
		_tmp5_ = _tmp4_;
#line 233 "../src/core/ViewCollection.vala"
		_tmp3_ = _tmp5_ > 0;
#line 1717 "ViewCollection.c"
	} else {
#line 233 "../src/core/ViewCollection.vala"
		_tmp3_ = FALSE;
#line 1721 "ViewCollection.c"
	}
#line 233 "../src/core/ViewCollection.vala"
	if (_tmp3_) {
#line 1725 "ViewCollection.c"
		GeeArrayList* created_views = NULL;
		GeeArrayList* _tmp6_;
		GeeArrayList* _tmp15_;
		GeeCollection* _tmp16_;
		GeeCollection* _tmp17_;
#line 235 "../src/core/ViewCollection.vala"
		_tmp6_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 235 "../src/core/ViewCollection.vala"
		created_views = _tmp6_;
#line 1735 "ViewCollection.c"
		{
			GeeIterator* _source_it = NULL;
			GeeIterator* _tmp7_;
#line 236 "../src/core/ViewCollection.vala"
			_tmp7_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (initial, GEE_TYPE_ITERABLE, GeeIterable));
#line 236 "../src/core/ViewCollection.vala"
			_source_it = _tmp7_;
#line 236 "../src/core/ViewCollection.vala"
			while (TRUE) {
#line 1745 "ViewCollection.c"
				GeeIterator* _tmp8_;
				DataSource* source = NULL;
				GeeIterator* _tmp9_;
				gpointer _tmp10_;
				GeeArrayList* _tmp11_;
				DataSource* _tmp12_;
				DataView* _tmp13_;
				DataView* _tmp14_;
#line 236 "../src/core/ViewCollection.vala"
				_tmp8_ = _source_it;
#line 236 "../src/core/ViewCollection.vala"
				if (!gee_iterator_next (_tmp8_)) {
#line 236 "../src/core/ViewCollection.vala"
					break;
#line 1760 "ViewCollection.c"
				}
#line 236 "../src/core/ViewCollection.vala"
				_tmp9_ = _source_it;
#line 236 "../src/core/ViewCollection.vala"
				_tmp10_ = gee_iterator_get (_tmp9_);
#line 236 "../src/core/ViewCollection.vala"
				source = (DataSource*) _tmp10_;
#line 237 "../src/core/ViewCollection.vala"
				_tmp11_ = created_views;
#line 237 "../src/core/ViewCollection.vala"
				_tmp12_ = source;
#line 237 "../src/core/ViewCollection.vala"
				_tmp13_ = view_manager_create_view (manager, _tmp12_);
#line 237 "../src/core/ViewCollection.vala"
				_tmp14_ = _tmp13_;
#line 237 "../src/core/ViewCollection.vala"
				gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp14_);
#line 237 "../src/core/ViewCollection.vala"
				_g_object_unref0 (_tmp14_);
#line 236 "../src/core/ViewCollection.vala"
				_g_object_unref0 (source);
#line 1782 "ViewCollection.c"
			}
#line 236 "../src/core/ViewCollection.vala"
			_g_object_unref0 (_source_it);
#line 1786 "ViewCollection.c"
		}
#line 239 "../src/core/ViewCollection.vala"
		_tmp15_ = created_views;
#line 239 "../src/core/ViewCollection.vala"
		_tmp16_ = data_collection_add_many (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, GEE_TYPE_COLLECTION, GeeCollection), progress_monitor, progress_monitor_target);
#line 239 "../src/core/ViewCollection.vala"
		_tmp17_ = _tmp16_;
#line 239 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp17_);
#line 233 "../src/core/ViewCollection.vala"
		_g_object_unref0 (created_views);
#line 1798 "ViewCollection.c"
	} else {
		GeeCollection* _tmp18_;
		GeeIterable* _tmp19_;
#line 242 "../src/core/ViewCollection.vala"
		_tmp18_ = data_collection_get_all (G_TYPE_CHECK_INSTANCE_CAST (sources, TYPE_DATA_COLLECTION, DataCollection));
#line 242 "../src/core/ViewCollection.vala"
		_tmp19_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, GEE_TYPE_ITERABLE, GeeIterable);
#line 242 "../src/core/ViewCollection.vala"
		view_collection_add_sources (self, sources, _tmp19_, progress_monitor, progress_monitor_target);
#line 242 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp19_);
#line 1810 "ViewCollection.c"
	}
#line 245 "../src/core/ViewCollection.vala"
	data_collection_thaw_notifications (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 247 "../src/core/ViewCollection.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (monitor, VIEW_COLLECTION_TYPE_MONITOR, ViewCollectionMonitor);
#line 247 "../src/core/ViewCollection.vala"
	return result;
#line 1818 "ViewCollection.c"
}

static gpointer
_view_collection_monitor_ref0 (gpointer self)
{
#line 251 "../src/core/ViewCollection.vala"
	return self ? view_collection_monitor_ref (self) : NULL;
#line 1826 "ViewCollection.c"
}

void
view_collection_halt_monitoring (ViewCollection* self,
                                 ViewCollectionMonitor* m)
{
	ViewCollectionMonitorImpl* monitor = NULL;
	ViewCollectionMonitorImpl* _tmp0_;
	gboolean removed = FALSE;
	GeeHashMultiMap* _tmp1_;
	SourceCollection* _tmp2_;
#line 250 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 250 "../src/core/ViewCollection.vala"
	g_return_if_fail (VIEW_COLLECTION_IS_MONITOR (m));
#line 251 "../src/core/ViewCollection.vala"
	_tmp0_ = _view_collection_monitor_ref0 (G_TYPE_CHECK_INSTANCE_CAST (m, VIEW_COLLECTION_TYPE_MONITOR_IMPL, ViewCollectionMonitorImpl));
#line 251 "../src/core/ViewCollection.vala"
	monitor = _tmp0_;
#line 253 "../src/core/ViewCollection.vala"
	_tmp1_ = self->priv->monitors;
#line 253 "../src/core/ViewCollection.vala"
	_tmp2_ = monitor->sources;
#line 253 "../src/core/ViewCollection.vala"
	removed = gee_multi_map_remove (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_MULTI_MAP, GeeMultiMap), _tmp2_, monitor);
#line 254 "../src/core/ViewCollection.vala"
	_vala_assert (removed, "removed");
#line 250 "../src/core/ViewCollection.vala"
	_view_collection_monitor_unref0 (monitor);
#line 1856 "ViewCollection.c"
}

void
view_collection_halt_all_monitoring (ViewCollection* self)
{
	GeeHashMultiMap* _tmp0_;
#line 257 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 258 "../src/core/ViewCollection.vala"
	_tmp0_ = self->priv->monitors;
#line 258 "../src/core/ViewCollection.vala"
	gee_multi_map_clear (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_MULTI_MAP, GeeMultiMap));
#line 1869 "ViewCollection.c"
}

static gpointer
_data_collection_ref0 (gpointer self)
{
#line 267 "../src/core/ViewCollection.vala"
	return self ? data_collection_ref (self) : NULL;
#line 1877 "ViewCollection.c"
}

static void
_view_collection_on_mirror_contents_added_data_collection_items_added (DataCollection* _sender,
                                                                       GeeIterable* added,
                                                                       gpointer self)
{
#line 275 "../src/core/ViewCollection.vala"
	view_collection_on_mirror_contents_added ((ViewCollection*) self, added);
#line 1887 "ViewCollection.c"
}

static void
_view_collection_on_mirror_contents_removed_data_collection_items_removed (DataCollection* _sender,
                                                                           GeeIterable* removed,
                                                                           gpointer self)
{
#line 276 "../src/core/ViewCollection.vala"
	view_collection_on_mirror_contents_removed ((ViewCollection*) self, removed);
#line 1897 "ViewCollection.c"
}

void
view_collection_mirror (ViewCollection* self,
                        ViewCollection* to_mirror,
                        CreateView mirroring_ctor,
                        gpointer mirroring_ctor_target,
                        CreateViewPredicate should_mirror,
                        gpointer should_mirror_target)
{
	ViewCollection* _tmp0_;
	gpointer _tmp1_ = NULL;
	Comparator _tmp2_;
	gpointer _tmp3_ = NULL;
	ComparatorPredicate _tmp4_;
	ViewCollection* _tmp5_;
	GeeCollection* _tmp6_;
	GeeCollection* _tmp7_;
	ViewCollection* _tmp8_;
	ViewCollection* _tmp9_;
#line 261 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 261 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (to_mirror));
#line 263 "../src/core/ViewCollection.vala"
	view_collection_halt_mirroring (self);
#line 264 "../src/core/ViewCollection.vala"
	view_collection_halt_all_monitoring (self);
#line 265 "../src/core/ViewCollection.vala"
	data_collection_clear (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 267 "../src/core/ViewCollection.vala"
	_tmp0_ = _data_collection_ref0 (to_mirror);
#line 267 "../src/core/ViewCollection.vala"
	_data_collection_unref0 (self->priv->mirroring);
#line 267 "../src/core/ViewCollection.vala"
	self->priv->mirroring = _tmp0_;
#line 268 "../src/core/ViewCollection.vala"
	self->priv->mirroring_ctor = mirroring_ctor;
#line 268 "../src/core/ViewCollection.vala"
	self->priv->mirroring_ctor_target = mirroring_ctor_target;
#line 269 "../src/core/ViewCollection.vala"
	self->priv->should_mirror = should_mirror;
#line 269 "../src/core/ViewCollection.vala"
	self->priv->should_mirror_target = should_mirror_target;
#line 270 "../src/core/ViewCollection.vala"
	_tmp2_ = data_collection_get_comparator (G_TYPE_CHECK_INSTANCE_CAST (to_mirror, TYPE_DATA_COLLECTION, DataCollection), &_tmp1_);
#line 270 "../src/core/ViewCollection.vala"
	_tmp4_ = data_collection_get_comparator_predicate (G_TYPE_CHECK_INSTANCE_CAST (to_mirror, TYPE_DATA_COLLECTION, DataCollection), &_tmp3_);
#line 270 "../src/core/ViewCollection.vala"
	data_collection_set_comparator (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), _tmp2_, _tmp1_, _tmp4_, _tmp3_);
#line 273 "../src/core/ViewCollection.vala"
	_tmp5_ = self->priv->mirroring;
#line 273 "../src/core/ViewCollection.vala"
	_tmp6_ = data_collection_get_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_DATA_COLLECTION, DataCollection));
#line 273 "../src/core/ViewCollection.vala"
	_tmp7_ = _tmp6_;
#line 273 "../src/core/ViewCollection.vala"
	view_collection_on_mirror_contents_added (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_ITERABLE, GeeIterable));
#line 273 "../src/core/ViewCollection.vala"
	_g_object_unref0 (_tmp7_);
#line 275 "../src/core/ViewCollection.vala"
	_tmp8_ = self->priv->mirroring;
#line 275 "../src/core/ViewCollection.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, TYPE_DATA_COLLECTION, DataCollection), "items-added", (GCallback) _view_collection_on_mirror_contents_added_data_collection_items_added, self);
#line 276 "../src/core/ViewCollection.vala"
	_tmp9_ = self->priv->mirroring;
#line 276 "../src/core/ViewCollection.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, TYPE_DATA_COLLECTION, DataCollection), "items-removed", (GCallback) _view_collection_on_mirror_contents_removed_data_collection_items_removed, self);
#line 1966 "ViewCollection.c"
}

void
view_collection_halt_mirroring (ViewCollection* self)
{
	ViewCollection* _tmp0_;
#line 279 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 280 "../src/core/ViewCollection.vala"
	_tmp0_ = self->priv->mirroring;
#line 280 "../src/core/ViewCollection.vala"
	if (_tmp0_ != NULL) {
#line 1979 "ViewCollection.c"
		ViewCollection* _tmp1_;
		guint _tmp2_;
		ViewCollection* _tmp3_;
		guint _tmp4_;
#line 281 "../src/core/ViewCollection.vala"
		_tmp1_ = self->priv->mirroring;
#line 281 "../src/core/ViewCollection.vala"
		g_signal_parse_name ("items-added", TYPE_DATA_COLLECTION, &_tmp2_, NULL, FALSE);
#line 281 "../src/core/ViewCollection.vala"
		g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_DATA_COLLECTION, DataCollection), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _view_collection_on_mirror_contents_added_data_collection_items_added, self);
#line 282 "../src/core/ViewCollection.vala"
		_tmp3_ = self->priv->mirroring;
#line 282 "../src/core/ViewCollection.vala"
		g_signal_parse_name ("items-removed", TYPE_DATA_COLLECTION, &_tmp4_, NULL, FALSE);
#line 282 "../src/core/ViewCollection.vala"
		g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_DATA_COLLECTION, DataCollection), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _view_collection_on_mirror_contents_removed_data_collection_items_removed, self);
#line 1996 "ViewCollection.c"
	}
#line 285 "../src/core/ViewCollection.vala"
	_data_collection_unref0 (self->priv->mirroring);
#line 285 "../src/core/ViewCollection.vala"
	self->priv->mirroring = NULL;
#line 2002 "ViewCollection.c"
}

void
view_collection_copy_into (ViewCollection* self,
                           ViewCollection* to_copy,
                           CreateView copying_ctor,
                           gpointer copying_ctor_target,
                           CreateViewPredicate should_copy,
                           gpointer should_copy_target)
{
	GeeArrayList* copy_view = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp20_;
	GeeCollection* _tmp21_;
	GeeCollection* _tmp22_;
#line 288 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 288 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (to_copy));
#line 291 "../src/core/ViewCollection.vala"
	_tmp0_ = gee_array_list_new (TYPE_DATA_OBJECT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 291 "../src/core/ViewCollection.vala"
	copy_view = _tmp0_;
#line 2026 "ViewCollection.c"
	{
		GeeIterator* _object_it = NULL;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 292 "../src/core/ViewCollection.vala"
		_tmp1_ = data_collection_get_all (G_TYPE_CHECK_INSTANCE_CAST (to_copy, TYPE_DATA_COLLECTION, DataCollection));
#line 292 "../src/core/ViewCollection.vala"
		_tmp2_ = _tmp1_;
#line 292 "../src/core/ViewCollection.vala"
		_tmp3_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ITERABLE, GeeIterable));
#line 292 "../src/core/ViewCollection.vala"
		_tmp4_ = _tmp3_;
#line 292 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp2_);
#line 292 "../src/core/ViewCollection.vala"
		_object_it = _tmp4_;
#line 292 "../src/core/ViewCollection.vala"
		while (TRUE) {
#line 2047 "ViewCollection.c"
			GeeIterator* _tmp5_;
			DataObject* object = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			DataView* view = NULL;
			DataObject* _tmp8_;
			DataView* _tmp9_;
			DataView* _tmp10_;
			DataSource* _tmp11_;
			DataSource* _tmp12_;
			gboolean _tmp13_;
#line 292 "../src/core/ViewCollection.vala"
			_tmp5_ = _object_it;
#line 292 "../src/core/ViewCollection.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 292 "../src/core/ViewCollection.vala"
				break;
#line 2065 "ViewCollection.c"
			}
#line 292 "../src/core/ViewCollection.vala"
			_tmp6_ = _object_it;
#line 292 "../src/core/ViewCollection.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 292 "../src/core/ViewCollection.vala"
			object = (DataObject*) _tmp7_;
#line 293 "../src/core/ViewCollection.vala"
			_tmp8_ = object;
#line 293 "../src/core/ViewCollection.vala"
			_tmp9_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, TYPE_DATA_VIEW, DataView));
#line 293 "../src/core/ViewCollection.vala"
			view = _tmp9_;
#line 294 "../src/core/ViewCollection.vala"
			_tmp10_ = view;
#line 294 "../src/core/ViewCollection.vala"
			_tmp11_ = data_view_get_source (_tmp10_);
#line 294 "../src/core/ViewCollection.vala"
			_tmp12_ = _tmp11_;
#line 294 "../src/core/ViewCollection.vala"
			_tmp13_ = should_copy (_tmp12_, should_copy_target);
#line 294 "../src/core/ViewCollection.vala"
			_g_object_unref0 (_tmp12_);
#line 294 "../src/core/ViewCollection.vala"
			if (_tmp13_) {
#line 2091 "ViewCollection.c"
				GeeArrayList* _tmp14_;
				DataView* _tmp15_;
				DataSource* _tmp16_;
				DataSource* _tmp17_;
				DataView* _tmp18_;
				DataView* _tmp19_;
#line 295 "../src/core/ViewCollection.vala"
				_tmp14_ = copy_view;
#line 295 "../src/core/ViewCollection.vala"
				_tmp15_ = view;
#line 295 "../src/core/ViewCollection.vala"
				_tmp16_ = data_view_get_source (_tmp15_);
#line 295 "../src/core/ViewCollection.vala"
				_tmp17_ = _tmp16_;
#line 295 "../src/core/ViewCollection.vala"
				_tmp18_ = copying_ctor (_tmp17_, copying_ctor_target);
#line 295 "../src/core/ViewCollection.vala"
				_tmp19_ = _tmp18_;
#line 295 "../src/core/ViewCollection.vala"
				gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, TYPE_DATA_OBJECT, DataObject));
#line 295 "../src/core/ViewCollection.vala"
				_g_object_unref0 (_tmp19_);
#line 295 "../src/core/ViewCollection.vala"
				_g_object_unref0 (_tmp17_);
#line 2116 "ViewCollection.c"
			}
#line 292 "../src/core/ViewCollection.vala"
			_g_object_unref0 (view);
#line 292 "../src/core/ViewCollection.vala"
			_g_object_unref0 (object);
#line 2122 "ViewCollection.c"
		}
#line 292 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_object_it);
#line 2126 "ViewCollection.c"
	}
#line 298 "../src/core/ViewCollection.vala"
	_tmp20_ = copy_view;
#line 298 "../src/core/ViewCollection.vala"
	_tmp21_ = data_collection_add_many (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, GEE_TYPE_COLLECTION, GeeCollection), NULL, NULL);
#line 298 "../src/core/ViewCollection.vala"
	_tmp22_ = _tmp21_;
#line 298 "../src/core/ViewCollection.vala"
	_g_object_unref0 (_tmp22_);
#line 288 "../src/core/ViewCollection.vala"
	_g_object_unref0 (copy_view);
#line 2138 "ViewCollection.c"
}

ViewCollection*
view_collection_shuffled_copy (ViewCollection* self,
                               Photo* start)
{
	ViewCollection* shuffled = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	ViewCollection* _tmp4_;
	ViewCollection* _tmp5_;
	GeeCollection* data = NULL;
	GeeCollection* _tmp6_;
	GeeArrayList* data_copy = NULL;
	GeeArrayList* _tmp7_;
	ViewCollection* _tmp46_;
	GeeArrayList* _tmp47_;
	GeeCollection* _tmp48_;
	GeeCollection* _tmp49_;
	ViewCollection* result;
#line 302 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 302 "../src/core/ViewCollection.vala"
	g_return_val_if_fail ((start == NULL) || IS_PHOTO (start), NULL);
#line 303 "../src/core/ViewCollection.vala"
	_tmp0_ = data_collection_to_string (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 303 "../src/core/ViewCollection.vala"
	_tmp1_ = _tmp0_;
#line 303 "../src/core/ViewCollection.vala"
	_tmp2_ = g_strconcat ("shuffled copy of ", _tmp1_, NULL);
#line 303 "../src/core/ViewCollection.vala"
	_tmp3_ = _tmp2_;
#line 303 "../src/core/ViewCollection.vala"
	_tmp4_ = view_collection_new (_tmp3_);
#line 303 "../src/core/ViewCollection.vala"
	_tmp5_ = _tmp4_;
#line 303 "../src/core/ViewCollection.vala"
	_g_free0 (_tmp3_);
#line 303 "../src/core/ViewCollection.vala"
	_g_free0 (_tmp1_);
#line 303 "../src/core/ViewCollection.vala"
	shuffled = _tmp5_;
#line 305 "../src/core/ViewCollection.vala"
	_tmp6_ = data_collection_get_all (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 305 "../src/core/ViewCollection.vala"
	data = _tmp6_;
#line 306 "../src/core/ViewCollection.vala"
	_tmp7_ = gee_array_list_new (TYPE_DATA_OBJECT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 306 "../src/core/ViewCollection.vala"
	data_copy = _tmp7_;
#line 2191 "ViewCollection.c"
	{
		GeeIterator* _object_it = NULL;
		GeeCollection* _tmp8_;
		GeeIterator* _tmp9_;
#line 307 "../src/core/ViewCollection.vala"
		_tmp8_ = data;
#line 307 "../src/core/ViewCollection.vala"
		_tmp9_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEE_TYPE_ITERABLE, GeeIterable));
#line 307 "../src/core/ViewCollection.vala"
		_object_it = _tmp9_;
#line 307 "../src/core/ViewCollection.vala"
		while (TRUE) {
#line 2204 "ViewCollection.c"
			GeeIterator* _tmp10_;
			DataObject* object = NULL;
			GeeIterator* _tmp11_;
			gpointer _tmp12_;
			DataView* view = NULL;
			DataObject* _tmp13_;
			DataView* _tmp14_;
			gboolean _tmp15_ = FALSE;
			DataView* _tmp16_;
			DataSource* _tmp17_;
			DataSource* _tmp18_;
			gboolean _tmp19_;
#line 307 "../src/core/ViewCollection.vala"
			_tmp10_ = _object_it;
#line 307 "../src/core/ViewCollection.vala"
			if (!gee_iterator_next (_tmp10_)) {
#line 307 "../src/core/ViewCollection.vala"
				break;
#line 2223 "ViewCollection.c"
			}
#line 307 "../src/core/ViewCollection.vala"
			_tmp11_ = _object_it;
#line 307 "../src/core/ViewCollection.vala"
			_tmp12_ = gee_iterator_get (_tmp11_);
#line 307 "../src/core/ViewCollection.vala"
			object = (DataObject*) _tmp12_;
#line 308 "../src/core/ViewCollection.vala"
			_tmp13_ = object;
#line 308 "../src/core/ViewCollection.vala"
			_tmp14_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, TYPE_DATA_VIEW, DataView));
#line 308 "../src/core/ViewCollection.vala"
			view = _tmp14_;
#line 309 "../src/core/ViewCollection.vala"
			_tmp16_ = view;
#line 309 "../src/core/ViewCollection.vala"
			_tmp17_ = data_view_get_source (_tmp16_);
#line 309 "../src/core/ViewCollection.vala"
			_tmp18_ = _tmp17_;
#line 309 "../src/core/ViewCollection.vala"
			_tmp19_ = IS_PHOTO_SOURCE (_tmp18_);
#line 309 "../src/core/ViewCollection.vala"
			_g_object_unref0 (_tmp18_);
#line 309 "../src/core/ViewCollection.vala"
			if (_tmp19_) {
#line 2249 "ViewCollection.c"
				gboolean _tmp20_ = FALSE;
#line 310 "../src/core/ViewCollection.vala"
				if (start == NULL) {
#line 310 "../src/core/ViewCollection.vala"
					_tmp20_ = TRUE;
#line 2255 "ViewCollection.c"
				} else {
					DataView* _tmp21_;
					DataSource* _tmp22_;
					DataSource* _tmp23_;
#line 310 "../src/core/ViewCollection.vala"
					_tmp21_ = view;
#line 310 "../src/core/ViewCollection.vala"
					_tmp22_ = data_view_get_source (_tmp21_);
#line 310 "../src/core/ViewCollection.vala"
					_tmp23_ = _tmp22_;
#line 310 "../src/core/ViewCollection.vala"
					_tmp20_ = _tmp23_ != G_TYPE_CHECK_INSTANCE_CAST (start, TYPE_DATA_SOURCE, DataSource);
#line 310 "../src/core/ViewCollection.vala"
					_g_object_unref0 (_tmp23_);
#line 2270 "ViewCollection.c"
				}
#line 310 "../src/core/ViewCollection.vala"
				_tmp15_ = _tmp20_;
#line 2274 "ViewCollection.c"
			} else {
#line 309 "../src/core/ViewCollection.vala"
				_tmp15_ = FALSE;
#line 2278 "ViewCollection.c"
			}
#line 309 "../src/core/ViewCollection.vala"
			if (_tmp15_) {
#line 2282 "ViewCollection.c"
				GeeArrayList* _tmp24_;
				DataObject* _tmp25_;
				DataSource* _tmp26_;
				PhotoSource* _tmp27_;
				PhotoView* _tmp28_;
				PhotoView* _tmp29_;
#line 311 "../src/core/ViewCollection.vala"
				_tmp24_ = data_copy;
#line 311 "../src/core/ViewCollection.vala"
				_tmp25_ = object;
#line 311 "../src/core/ViewCollection.vala"
				_tmp26_ = data_view_get_source (G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, TYPE_DATA_VIEW, DataView));
#line 311 "../src/core/ViewCollection.vala"
				_tmp27_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, TYPE_PHOTO_SOURCE, PhotoSource);
#line 311 "../src/core/ViewCollection.vala"
				_tmp28_ = photo_view_new (_tmp27_);
#line 311 "../src/core/ViewCollection.vala"
				_tmp29_ = _tmp28_;
#line 311 "../src/core/ViewCollection.vala"
				gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, TYPE_DATA_OBJECT, DataObject));
#line 311 "../src/core/ViewCollection.vala"
				_g_object_unref0 (_tmp29_);
#line 311 "../src/core/ViewCollection.vala"
				_g_object_unref0 (_tmp27_);
#line 2307 "ViewCollection.c"
			}
#line 307 "../src/core/ViewCollection.vala"
			_g_object_unref0 (view);
#line 307 "../src/core/ViewCollection.vala"
			_g_object_unref0 (object);
#line 2313 "ViewCollection.c"
		}
#line 307 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_object_it);
#line 2317 "ViewCollection.c"
	}
	{
		gint ctr = 0;
		GeeArrayList* _tmp30_;
		gint _tmp31_;
		gint _tmp32_;
#line 315 "../src/core/ViewCollection.vala"
		_tmp30_ = data_copy;
#line 315 "../src/core/ViewCollection.vala"
		_tmp31_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 315 "../src/core/ViewCollection.vala"
		_tmp32_ = _tmp31_;
#line 315 "../src/core/ViewCollection.vala"
		ctr = _tmp32_ - 1;
#line 2332 "ViewCollection.c"
		{
			gboolean _tmp33_ = FALSE;
#line 315 "../src/core/ViewCollection.vala"
			_tmp33_ = TRUE;
#line 315 "../src/core/ViewCollection.vala"
			while (TRUE) {
#line 2339 "ViewCollection.c"
				gint rand = 0;
				DataObject* temp = NULL;
				GeeArrayList* _tmp35_;
				gpointer _tmp36_;
				GeeArrayList* _tmp37_;
				GeeArrayList* _tmp38_;
				gpointer _tmp39_;
				DataObject* _tmp40_;
				GeeArrayList* _tmp41_;
				DataObject* _tmp42_;
#line 315 "../src/core/ViewCollection.vala"
				if (!_tmp33_) {
#line 2352 "ViewCollection.c"
					gint _tmp34_;
#line 315 "../src/core/ViewCollection.vala"
					_tmp34_ = ctr;
#line 315 "../src/core/ViewCollection.vala"
					ctr = _tmp34_ - 1;
#line 2358 "ViewCollection.c"
				}
#line 315 "../src/core/ViewCollection.vala"
				_tmp33_ = FALSE;
#line 315 "../src/core/ViewCollection.vala"
				if (!(ctr > 0)) {
#line 315 "../src/core/ViewCollection.vala"
					break;
#line 2366 "ViewCollection.c"
				}
#line 316 "../src/core/ViewCollection.vala"
				rand = (gint) g_random_int_range ((gint32) 0, (gint32) (ctr + 1));
#line 317 "../src/core/ViewCollection.vala"
				_tmp35_ = data_copy;
#line 317 "../src/core/ViewCollection.vala"
				_tmp36_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp35_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), rand);
#line 317 "../src/core/ViewCollection.vala"
				temp = (DataObject*) _tmp36_;
#line 318 "../src/core/ViewCollection.vala"
				_tmp37_ = data_copy;
#line 318 "../src/core/ViewCollection.vala"
				_tmp38_ = data_copy;
#line 318 "../src/core/ViewCollection.vala"
				_tmp39_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp38_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), ctr);
#line 318 "../src/core/ViewCollection.vala"
				_tmp40_ = (DataObject*) _tmp39_;
#line 318 "../src/core/ViewCollection.vala"
				gee_abstract_list_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp37_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), rand, _tmp40_);
#line 318 "../src/core/ViewCollection.vala"
				_g_object_unref0 (_tmp40_);
#line 319 "../src/core/ViewCollection.vala"
				_tmp41_ = data_copy;
#line 319 "../src/core/ViewCollection.vala"
				_tmp42_ = temp;
#line 319 "../src/core/ViewCollection.vala"
				gee_abstract_list_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp41_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), ctr, _tmp42_);
#line 315 "../src/core/ViewCollection.vala"
				_g_object_unref0 (temp);
#line 2396 "ViewCollection.c"
			}
		}
	}
#line 322 "../src/core/ViewCollection.vala"
	if (start != NULL) {
#line 2402 "ViewCollection.c"
		ViewCollection* _tmp43_;
		PhotoView* _tmp44_;
		PhotoView* _tmp45_;
#line 323 "../src/core/ViewCollection.vala"
		_tmp43_ = shuffled;
#line 323 "../src/core/ViewCollection.vala"
		_tmp44_ = photo_view_new (G_TYPE_CHECK_INSTANCE_CAST (start, TYPE_PHOTO_SOURCE, PhotoSource));
#line 323 "../src/core/ViewCollection.vala"
		_tmp45_ = _tmp44_;
#line 323 "../src/core/ViewCollection.vala"
		data_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp43_, TYPE_DATA_COLLECTION, DataCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp45_, TYPE_DATA_OBJECT, DataObject));
#line 323 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp45_);
#line 2416 "ViewCollection.c"
	}
#line 324 "../src/core/ViewCollection.vala"
	_tmp46_ = shuffled;
#line 324 "../src/core/ViewCollection.vala"
	_tmp47_ = data_copy;
#line 324 "../src/core/ViewCollection.vala"
	_tmp48_ = data_collection_add_many (G_TYPE_CHECK_INSTANCE_CAST (_tmp46_, TYPE_DATA_COLLECTION, DataCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp47_, GEE_TYPE_COLLECTION, GeeCollection), NULL, NULL);
#line 324 "../src/core/ViewCollection.vala"
	_tmp49_ = _tmp48_;
#line 324 "../src/core/ViewCollection.vala"
	_g_object_unref0 (_tmp49_);
#line 325 "../src/core/ViewCollection.vala"
	result = shuffled;
#line 325 "../src/core/ViewCollection.vala"
	_g_object_unref0 (data_copy);
#line 325 "../src/core/ViewCollection.vala"
	_g_object_unref0 (data);
#line 325 "../src/core/ViewCollection.vala"
	return result;
#line 2436 "ViewCollection.c"
}

gboolean
view_collection_is_view_filter_installed (ViewCollection* self,
                                          ViewFilter* f)
{
	GeeSet* _tmp0_;
	gboolean result;
#line 328 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 328 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_FILTER (f), FALSE);
#line 329 "../src/core/ViewCollection.vala"
	_tmp0_ = self->priv->filters;
#line 329 "../src/core/ViewCollection.vala"
	result = gee_collection_contains (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection), f);
#line 329 "../src/core/ViewCollection.vala"
	return result;
#line 2455 "ViewCollection.c"
}

void
view_collection_install_view_filter (ViewCollection* self,
                                     ViewFilter* f)
{
	GeeSet* _tmp0_;
#line 332 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 332 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_FILTER (f));
#line 333 "../src/core/ViewCollection.vala"
	if (view_collection_is_view_filter_installed (self, f)) {
#line 334 "../src/core/ViewCollection.vala"
		return;
#line 2471 "ViewCollection.c"
	}
#line 336 "../src/core/ViewCollection.vala"
	_tmp0_ = self->priv->filters;
#line 336 "../src/core/ViewCollection.vala"
	gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection), f);
#line 337 "../src/core/ViewCollection.vala"
	g_signal_connect (f, "refresh", (GCallback) _view_collection_on_view_filter_refresh_view_filter_refresh, self);
#line 340 "../src/core/ViewCollection.vala"
	view_collection_on_view_filter_refresh (self);
#line 343 "../src/core/ViewCollection.vala"
	view_collection_notify_view_filter_installed (self, f);
#line 2483 "ViewCollection.c"
}

void
view_collection_remove_view_filter (ViewCollection* self,
                                    ViewFilter* f)
{
	GeeSet* _tmp0_;
	guint _tmp1_;
#line 346 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 346 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_FILTER (f));
#line 347 "../src/core/ViewCollection.vala"
	if (!view_collection_is_view_filter_installed (self, f)) {
#line 348 "../src/core/ViewCollection.vala"
		return;
#line 2500 "ViewCollection.c"
	}
#line 350 "../src/core/ViewCollection.vala"
	_tmp0_ = self->priv->filters;
#line 350 "../src/core/ViewCollection.vala"
	gee_collection_remove (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection), f);
#line 351 "../src/core/ViewCollection.vala"
	g_signal_parse_name ("refresh", TYPE_VIEW_FILTER, &_tmp1_, NULL, FALSE);
#line 351 "../src/core/ViewCollection.vala"
	g_signal_handlers_disconnect_matched (f, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _view_collection_on_view_filter_refresh_view_filter_refresh, self);
#line 354 "../src/core/ViewCollection.vala"
	view_collection_on_view_filter_refresh (self);
#line 357 "../src/core/ViewCollection.vala"
	view_collection_notify_view_filter_removed (self, f);
#line 2514 "ViewCollection.c"
}

static void
view_collection_on_view_filter_refresh (ViewCollection* self)
{
	GeeCollection* _tmp0_;
	GeeCollection* _tmp1_;
#line 360 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 361 "../src/core/ViewCollection.vala"
	_tmp0_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_all (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 361 "../src/core/ViewCollection.vala"
	_tmp1_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection);
#line 361 "../src/core/ViewCollection.vala"
	view_collection_filter_altered_items (self, _tmp1_);
#line 361 "../src/core/ViewCollection.vala"
	_g_object_unref0 (_tmp1_);
#line 2532 "ViewCollection.c"
}

static gboolean
view_collection_is_in_filter (ViewCollection* self,
                              DataView* view)
{
	gboolean result;
#line 365 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 365 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_VIEW (view), FALSE);
#line 2544 "ViewCollection.c"
	{
		GeeIterator* _f_it = NULL;
		GeeSet* _tmp0_;
		GeeIterator* _tmp1_;
#line 366 "../src/core/ViewCollection.vala"
		_tmp0_ = self->priv->filters;
#line 366 "../src/core/ViewCollection.vala"
		_tmp1_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ITERABLE, GeeIterable));
#line 366 "../src/core/ViewCollection.vala"
		_f_it = _tmp1_;
#line 366 "../src/core/ViewCollection.vala"
		while (TRUE) {
#line 2557 "ViewCollection.c"
			GeeIterator* _tmp2_;
			ViewFilter* f = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			ViewFilter* _tmp5_;
#line 366 "../src/core/ViewCollection.vala"
			_tmp2_ = _f_it;
#line 366 "../src/core/ViewCollection.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 366 "../src/core/ViewCollection.vala"
				break;
#line 2569 "ViewCollection.c"
			}
#line 366 "../src/core/ViewCollection.vala"
			_tmp3_ = _f_it;
#line 366 "../src/core/ViewCollection.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 366 "../src/core/ViewCollection.vala"
			f = (ViewFilter*) _tmp4_;
#line 367 "../src/core/ViewCollection.vala"
			_tmp5_ = f;
#line 367 "../src/core/ViewCollection.vala"
			if (!view_filter_predicate (_tmp5_, view)) {
#line 368 "../src/core/ViewCollection.vala"
				result = FALSE;
#line 368 "../src/core/ViewCollection.vala"
				_view_filter_unref0 (f);
#line 368 "../src/core/ViewCollection.vala"
				_g_object_unref0 (_f_it);
#line 368 "../src/core/ViewCollection.vala"
				return result;
#line 2589 "ViewCollection.c"
			}
#line 366 "../src/core/ViewCollection.vala"
			_view_filter_unref0 (f);
#line 2593 "ViewCollection.c"
		}
#line 366 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_f_it);
#line 2597 "ViewCollection.c"
	}
#line 370 "../src/core/ViewCollection.vala"
	result = TRUE;
#line 370 "../src/core/ViewCollection.vala"
	return result;
#line 2603 "ViewCollection.c"
}

static gboolean
view_collection_real_valid_type (DataCollection* base,
                                 DataObject* object)
{
	ViewCollection * self;
	gboolean result;
#line 373 "../src/core/ViewCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIEW_COLLECTION, ViewCollection);
#line 373 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 374 "../src/core/ViewCollection.vala"
	result = IS_DATA_VIEW (object);
#line 374 "../src/core/ViewCollection.vala"
	return result;
#line 2620 "ViewCollection.c"
}

static void
view_collection_on_sources_added (ViewCollection* self,
                                  DataCollection* sources,
                                  GeeIterable* added)
{
#line 377 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 377 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (sources));
#line 377 "../src/core/ViewCollection.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (added, GEE_TYPE_ITERABLE));
#line 378 "../src/core/ViewCollection.vala"
	view_collection_add_sources (self, G_TYPE_CHECK_INSTANCE_CAST (sources, TYPE_SOURCE_COLLECTION, SourceCollection), added, NULL, NULL);
#line 2636 "ViewCollection.c"
}

static DataView*
_view_manager_create_view_create_view (DataSource* source,
                                       gpointer self)
{
	DataView* result;
	result = view_manager_create_view ((ViewManager*) self, source);
#line 391 "../src/core/ViewCollection.vala"
	return result;
#line 2647 "ViewCollection.c"
}

static void
view_collection_add_sources (ViewCollection* self,
                             SourceCollection* sources,
                             GeeIterable* added,
                             ProgressMonitor progress_monitor,
                             gpointer progress_monitor_target)
{
	DataView* created_view = NULL;
	GeeArrayList* created_views = NULL;
	DataView* _tmp32_;
#line 381 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 381 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_SOURCE_COLLECTION (sources));
#line 381 "../src/core/ViewCollection.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (added, GEE_TYPE_ITERABLE));
#line 385 "../src/core/ViewCollection.vala"
	created_view = NULL;
#line 386 "../src/core/ViewCollection.vala"
	created_views = NULL;
#line 2670 "ViewCollection.c"
	{
		GeeIterator* _source_it = NULL;
		GeeIterator* _tmp0_;
#line 387 "../src/core/ViewCollection.vala"
		_tmp0_ = gee_iterable_iterator (added);
#line 387 "../src/core/ViewCollection.vala"
		_source_it = _tmp0_;
#line 387 "../src/core/ViewCollection.vala"
		while (TRUE) {
#line 2680 "ViewCollection.c"
			GeeIterator* _tmp1_;
			DataSource* source = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			CreateView factory = NULL;
			gpointer factory_target;
			GDestroyNotify factory_target_destroy_notify;
			CreateView _tmp17_;
			gpointer _tmp17__target;
#line 387 "../src/core/ViewCollection.vala"
			_tmp1_ = _source_it;
#line 387 "../src/core/ViewCollection.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 387 "../src/core/ViewCollection.vala"
				break;
#line 2696 "ViewCollection.c"
			}
#line 387 "../src/core/ViewCollection.vala"
			_tmp2_ = _source_it;
#line 387 "../src/core/ViewCollection.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 387 "../src/core/ViewCollection.vala"
			source = (DataSource*) _tmp3_;
#line 388 "../src/core/ViewCollection.vala"
			factory = NULL;
#line 388 "../src/core/ViewCollection.vala"
			factory_target = NULL;
#line 388 "../src/core/ViewCollection.vala"
			factory_target_destroy_notify = NULL;
#line 2710 "ViewCollection.c"
			{
				GeeIterator* _monitor_it = NULL;
				GeeHashMultiMap* _tmp4_;
				GeeCollection* _tmp5_;
				GeeCollection* _tmp6_;
				GeeIterator* _tmp7_;
				GeeIterator* _tmp8_;
#line 389 "../src/core/ViewCollection.vala"
				_tmp4_ = self->priv->monitors;
#line 389 "../src/core/ViewCollection.vala"
				_tmp5_ = gee_multi_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_MULTI_MAP, GeeMultiMap), sources);
#line 389 "../src/core/ViewCollection.vala"
				_tmp6_ = _tmp5_;
#line 389 "../src/core/ViewCollection.vala"
				_tmp7_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_ITERABLE, GeeIterable));
#line 389 "../src/core/ViewCollection.vala"
				_tmp8_ = _tmp7_;
#line 389 "../src/core/ViewCollection.vala"
				_g_object_unref0 (_tmp6_);
#line 389 "../src/core/ViewCollection.vala"
				_monitor_it = _tmp8_;
#line 389 "../src/core/ViewCollection.vala"
				while (TRUE) {
#line 2734 "ViewCollection.c"
					GeeIterator* _tmp9_;
					ViewCollectionMonitorImpl* monitor = NULL;
					GeeIterator* _tmp10_;
					gpointer _tmp11_;
					ViewCollectionMonitorImpl* _tmp12_;
					ViewManager* _tmp13_;
					DataSource* _tmp14_;
#line 389 "../src/core/ViewCollection.vala"
					_tmp9_ = _monitor_it;
#line 389 "../src/core/ViewCollection.vala"
					if (!gee_iterator_next (_tmp9_)) {
#line 389 "../src/core/ViewCollection.vala"
						break;
#line 2748 "ViewCollection.c"
					}
#line 389 "../src/core/ViewCollection.vala"
					_tmp10_ = _monitor_it;
#line 389 "../src/core/ViewCollection.vala"
					_tmp11_ = gee_iterator_get (_tmp10_);
#line 389 "../src/core/ViewCollection.vala"
					monitor = (ViewCollectionMonitorImpl*) _tmp11_;
#line 390 "../src/core/ViewCollection.vala"
					_tmp12_ = monitor;
#line 390 "../src/core/ViewCollection.vala"
					_tmp13_ = _tmp12_->manager;
#line 390 "../src/core/ViewCollection.vala"
					_tmp14_ = source;
#line 390 "../src/core/ViewCollection.vala"
					if (view_manager_include_in_view (_tmp13_, _tmp14_)) {
#line 2764 "ViewCollection.c"
						ViewCollectionMonitorImpl* _tmp15_;
						ViewManager* _tmp16_;
#line 391 "../src/core/ViewCollection.vala"
						_tmp15_ = monitor;
#line 391 "../src/core/ViewCollection.vala"
						_tmp16_ = _tmp15_->manager;
#line 391 "../src/core/ViewCollection.vala"
						(factory_target_destroy_notify == NULL) ? NULL : (factory_target_destroy_notify (factory_target), NULL);
#line 391 "../src/core/ViewCollection.vala"
						factory = NULL;
#line 391 "../src/core/ViewCollection.vala"
						factory_target = NULL;
#line 391 "../src/core/ViewCollection.vala"
						factory_target_destroy_notify = NULL;
#line 391 "../src/core/ViewCollection.vala"
						factory = _view_manager_create_view_create_view;
#line 391 "../src/core/ViewCollection.vala"
						factory_target = view_manager_ref (_tmp16_);
#line 391 "../src/core/ViewCollection.vala"
						factory_target_destroy_notify = view_manager_unref;
#line 393 "../src/core/ViewCollection.vala"
						_view_collection_monitor_unref0 (monitor);
#line 393 "../src/core/ViewCollection.vala"
						break;
#line 2789 "ViewCollection.c"
					}
#line 389 "../src/core/ViewCollection.vala"
					_view_collection_monitor_unref0 (monitor);
#line 2793 "ViewCollection.c"
				}
#line 389 "../src/core/ViewCollection.vala"
				_g_object_unref0 (_monitor_it);
#line 2797 "ViewCollection.c"
			}
#line 397 "../src/core/ViewCollection.vala"
			_tmp17_ = factory;
#line 397 "../src/core/ViewCollection.vala"
			_tmp17__target = factory_target;
#line 397 "../src/core/ViewCollection.vala"
			if (_tmp17_ != NULL) {
#line 2805 "ViewCollection.c"
				DataView* new_view = NULL;
				CreateView _tmp18_;
				gpointer _tmp18__target;
				DataSource* _tmp19_;
				DataView* _tmp20_;
				GeeArrayList* _tmp21_;
#line 398 "../src/core/ViewCollection.vala"
				_tmp18_ = factory;
#line 398 "../src/core/ViewCollection.vala"
				_tmp18__target = factory_target;
#line 398 "../src/core/ViewCollection.vala"
				_tmp19_ = source;
#line 398 "../src/core/ViewCollection.vala"
				_tmp20_ = _tmp18_ (_tmp19_, _tmp18__target);
#line 398 "../src/core/ViewCollection.vala"
				new_view = _tmp20_;
#line 402 "../src/core/ViewCollection.vala"
				_tmp21_ = created_views;
#line 402 "../src/core/ViewCollection.vala"
				if (_tmp21_ != NULL) {
#line 2826 "ViewCollection.c"
					GeeArrayList* _tmp22_;
					DataView* _tmp23_;
#line 403 "../src/core/ViewCollection.vala"
					_tmp22_ = created_views;
#line 403 "../src/core/ViewCollection.vala"
					_tmp23_ = new_view;
#line 403 "../src/core/ViewCollection.vala"
					gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp23_);
#line 2835 "ViewCollection.c"
				} else {
					DataView* _tmp24_;
#line 404 "../src/core/ViewCollection.vala"
					_tmp24_ = created_view;
#line 404 "../src/core/ViewCollection.vala"
					if (_tmp24_ == NULL) {
#line 2842 "ViewCollection.c"
						DataView* _tmp25_;
						DataView* _tmp26_;
#line 405 "../src/core/ViewCollection.vala"
						_tmp25_ = new_view;
#line 405 "../src/core/ViewCollection.vala"
						_tmp26_ = _g_object_ref0 (_tmp25_);
#line 405 "../src/core/ViewCollection.vala"
						_g_object_unref0 (created_view);
#line 405 "../src/core/ViewCollection.vala"
						created_view = _tmp26_;
#line 2853 "ViewCollection.c"
					} else {
						GeeArrayList* _tmp27_;
						GeeArrayList* _tmp28_;
						DataView* _tmp29_;
						GeeArrayList* _tmp30_;
						DataView* _tmp31_;
#line 407 "../src/core/ViewCollection.vala"
						_tmp27_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 407 "../src/core/ViewCollection.vala"
						_g_object_unref0 (created_views);
#line 407 "../src/core/ViewCollection.vala"
						created_views = _tmp27_;
#line 408 "../src/core/ViewCollection.vala"
						_tmp28_ = created_views;
#line 408 "../src/core/ViewCollection.vala"
						_tmp29_ = created_view;
#line 408 "../src/core/ViewCollection.vala"
						gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp29_);
#line 409 "../src/core/ViewCollection.vala"
						_g_object_unref0 (created_view);
#line 409 "../src/core/ViewCollection.vala"
						created_view = NULL;
#line 410 "../src/core/ViewCollection.vala"
						_tmp30_ = created_views;
#line 410 "../src/core/ViewCollection.vala"
						_tmp31_ = new_view;
#line 410 "../src/core/ViewCollection.vala"
						gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp31_);
#line 2882 "ViewCollection.c"
					}
				}
#line 397 "../src/core/ViewCollection.vala"
				_g_object_unref0 (new_view);
#line 2887 "ViewCollection.c"
			}
#line 387 "../src/core/ViewCollection.vala"
			(factory_target_destroy_notify == NULL) ? NULL : (factory_target_destroy_notify (factory_target), NULL);
#line 387 "../src/core/ViewCollection.vala"
			factory = NULL;
#line 387 "../src/core/ViewCollection.vala"
			factory_target = NULL;
#line 387 "../src/core/ViewCollection.vala"
			factory_target_destroy_notify = NULL;
#line 387 "../src/core/ViewCollection.vala"
			_g_object_unref0 (source);
#line 2899 "ViewCollection.c"
		}
#line 387 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_source_it);
#line 2903 "ViewCollection.c"
	}
#line 415 "../src/core/ViewCollection.vala"
	_tmp32_ = created_view;
#line 415 "../src/core/ViewCollection.vala"
	if (_tmp32_ != NULL) {
#line 2909 "ViewCollection.c"
		DataView* _tmp33_;
#line 416 "../src/core/ViewCollection.vala"
		_tmp33_ = created_view;
#line 416 "../src/core/ViewCollection.vala"
		data_collection_add (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp33_, TYPE_DATA_OBJECT, DataObject));
#line 2915 "ViewCollection.c"
	} else {
		gboolean _tmp34_ = FALSE;
		GeeArrayList* _tmp35_;
#line 417 "../src/core/ViewCollection.vala"
		_tmp35_ = created_views;
#line 417 "../src/core/ViewCollection.vala"
		if (_tmp35_ != NULL) {
#line 2923 "ViewCollection.c"
			GeeArrayList* _tmp36_;
			gint _tmp37_;
			gint _tmp38_;
#line 417 "../src/core/ViewCollection.vala"
			_tmp36_ = created_views;
#line 417 "../src/core/ViewCollection.vala"
			_tmp37_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp36_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 417 "../src/core/ViewCollection.vala"
			_tmp38_ = _tmp37_;
#line 417 "../src/core/ViewCollection.vala"
			_tmp34_ = _tmp38_ > 0;
#line 2935 "ViewCollection.c"
		} else {
#line 417 "../src/core/ViewCollection.vala"
			_tmp34_ = FALSE;
#line 2939 "ViewCollection.c"
		}
#line 417 "../src/core/ViewCollection.vala"
		if (_tmp34_) {
#line 2943 "ViewCollection.c"
			GeeArrayList* _tmp39_;
			GeeCollection* _tmp40_;
			GeeCollection* _tmp41_;
#line 418 "../src/core/ViewCollection.vala"
			_tmp39_ = created_views;
#line 418 "../src/core/ViewCollection.vala"
			_tmp40_ = data_collection_add_many (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, GEE_TYPE_COLLECTION, GeeCollection), progress_monitor, progress_monitor_target);
#line 418 "../src/core/ViewCollection.vala"
			_tmp41_ = _tmp40_;
#line 418 "../src/core/ViewCollection.vala"
			_g_object_unref0 (_tmp41_);
#line 2955 "ViewCollection.c"
		}
	}
#line 381 "../src/core/ViewCollection.vala"
	_g_object_unref0 (created_views);
#line 381 "../src/core/ViewCollection.vala"
	_g_object_unref0 (created_view);
#line 2962 "ViewCollection.c"
}

static gboolean
view_collection_real_add (DataCollection* base,
                          DataObject* object)
{
	ViewCollection * self;
	GeeCollection* _tmp0_;
	GeeCollection* _tmp1_;
	gboolean result;
#line 421 "../src/core/ViewCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIEW_COLLECTION, ViewCollection);
#line 421 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 422 "../src/core/ViewCollection.vala"
	data_view_internal_set_visible (G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DATA_VIEW, DataView), TRUE);
#line 424 "../src/core/ViewCollection.vala"
	if (!DATA_COLLECTION_CLASS (view_collection_parent_class)->add (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), object)) {
#line 425 "../src/core/ViewCollection.vala"
		result = FALSE;
#line 425 "../src/core/ViewCollection.vala"
		return result;
#line 2985 "ViewCollection.c"
	}
#line 427 "../src/core/ViewCollection.vala"
	_tmp0_ = data_collection_get_singleton (object);
#line 427 "../src/core/ViewCollection.vala"
	_tmp1_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection);
#line 427 "../src/core/ViewCollection.vala"
	view_collection_filter_altered_items (self, _tmp1_);
#line 427 "../src/core/ViewCollection.vala"
	_g_object_unref0 (_tmp1_);
#line 429 "../src/core/ViewCollection.vala"
	result = TRUE;
#line 429 "../src/core/ViewCollection.vala"
	return result;
#line 2999 "ViewCollection.c"
}

static GeeCollection*
view_collection_real_add_many (DataCollection* base,
                               GeeCollection* objects,
                               ProgressMonitor monitor,
                               gpointer monitor_target)
{
	ViewCollection * self;
	GeeCollection* return_list = NULL;
	GeeCollection* _tmp5_;
	GeeCollection* result;
#line 432 "../src/core/ViewCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIEW_COLLECTION, ViewCollection);
#line 432 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (objects, GEE_TYPE_COLLECTION), NULL);
#line 3016 "ViewCollection.c"
	{
		GeeIterator* _object_it = NULL;
		GeeIterator* _tmp0_;
#line 434 "../src/core/ViewCollection.vala"
		_tmp0_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (objects, GEE_TYPE_ITERABLE, GeeIterable));
#line 434 "../src/core/ViewCollection.vala"
		_object_it = _tmp0_;
#line 434 "../src/core/ViewCollection.vala"
		while (TRUE) {
#line 3026 "ViewCollection.c"
			GeeIterator* _tmp1_;
			DataObject* object = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			DataObject* _tmp4_;
#line 434 "../src/core/ViewCollection.vala"
			_tmp1_ = _object_it;
#line 434 "../src/core/ViewCollection.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 434 "../src/core/ViewCollection.vala"
				break;
#line 3038 "ViewCollection.c"
			}
#line 434 "../src/core/ViewCollection.vala"
			_tmp2_ = _object_it;
#line 434 "../src/core/ViewCollection.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 434 "../src/core/ViewCollection.vala"
			object = (DataObject*) _tmp3_;
#line 435 "../src/core/ViewCollection.vala"
			_tmp4_ = object;
#line 435 "../src/core/ViewCollection.vala"
			data_view_internal_set_visible (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_DATA_VIEW, DataView), TRUE);
#line 434 "../src/core/ViewCollection.vala"
			_g_object_unref0 (object);
#line 3052 "ViewCollection.c"
		}
#line 434 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_object_it);
#line 3056 "ViewCollection.c"
	}
#line 437 "../src/core/ViewCollection.vala"
	_tmp5_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->add_many (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), objects, monitor, monitor_target);
#line 437 "../src/core/ViewCollection.vala"
	return_list = _tmp5_;
#line 439 "../src/core/ViewCollection.vala"
	view_collection_filter_altered_items (self, G_TYPE_CHECK_INSTANCE_CAST (return_list, GEE_TYPE_COLLECTION, GeeCollection));
#line 441 "../src/core/ViewCollection.vala"
	result = return_list;
#line 441 "../src/core/ViewCollection.vala"
	return result;
#line 3068 "ViewCollection.c"
}

static void
view_collection_on_sources_removed (ViewCollection* self,
                                    GeeIterable* removed)
{
	Marker* marker = NULL;
	gboolean _tmp12_ = FALSE;
	Marker* _tmp13_;
#line 444 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 444 "../src/core/ViewCollection.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (removed, GEE_TYPE_ITERABLE));
#line 446 "../src/core/ViewCollection.vala"
	marker = NULL;
#line 3084 "ViewCollection.c"
	{
		GeeIterator* _source_it = NULL;
		GeeIterator* _tmp0_;
#line 447 "../src/core/ViewCollection.vala"
		_tmp0_ = gee_iterable_iterator (removed);
#line 447 "../src/core/ViewCollection.vala"
		_source_it = _tmp0_;
#line 447 "../src/core/ViewCollection.vala"
		while (TRUE) {
#line 3094 "ViewCollection.c"
			GeeIterator* _tmp1_;
			DataSource* source = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			DataView* view = NULL;
			GeeHashMap* _tmp4_;
			DataSource* _tmp5_;
			gpointer _tmp6_;
			DataView* _tmp7_;
#line 447 "../src/core/ViewCollection.vala"
			_tmp1_ = _source_it;
#line 447 "../src/core/ViewCollection.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 447 "../src/core/ViewCollection.vala"
				break;
#line 3110 "ViewCollection.c"
			}
#line 447 "../src/core/ViewCollection.vala"
			_tmp2_ = _source_it;
#line 447 "../src/core/ViewCollection.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 447 "../src/core/ViewCollection.vala"
			source = (DataSource*) _tmp3_;
#line 448 "../src/core/ViewCollection.vala"
			_tmp4_ = self->priv->source_map;
#line 448 "../src/core/ViewCollection.vala"
			_tmp5_ = source;
#line 448 "../src/core/ViewCollection.vala"
			_tmp6_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp5_);
#line 448 "../src/core/ViewCollection.vala"
			view = (DataView*) _tmp6_;
#line 451 "../src/core/ViewCollection.vala"
			_tmp7_ = view;
#line 451 "../src/core/ViewCollection.vala"
			if (_tmp7_ != NULL) {
#line 3130 "ViewCollection.c"
				Marker* _tmp8_;
				Marker* _tmp10_;
				DataView* _tmp11_;
#line 452 "../src/core/ViewCollection.vala"
				_tmp8_ = marker;
#line 452 "../src/core/ViewCollection.vala"
				if (_tmp8_ == NULL) {
#line 3138 "ViewCollection.c"
					Marker* _tmp9_;
#line 453 "../src/core/ViewCollection.vala"
					_tmp9_ = data_collection_start_marking (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 453 "../src/core/ViewCollection.vala"
					_g_object_unref0 (marker);
#line 453 "../src/core/ViewCollection.vala"
					marker = _tmp9_;
#line 3146 "ViewCollection.c"
				}
#line 455 "../src/core/ViewCollection.vala"
				_tmp10_ = marker;
#line 455 "../src/core/ViewCollection.vala"
				_tmp11_ = view;
#line 455 "../src/core/ViewCollection.vala"
				marker_mark (_tmp10_, G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, TYPE_DATA_OBJECT, DataObject));
#line 3154 "ViewCollection.c"
			}
#line 447 "../src/core/ViewCollection.vala"
			_g_object_unref0 (view);
#line 447 "../src/core/ViewCollection.vala"
			_g_object_unref0 (source);
#line 3160 "ViewCollection.c"
		}
#line 447 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_source_it);
#line 3164 "ViewCollection.c"
	}
#line 459 "../src/core/ViewCollection.vala"
	_tmp13_ = marker;
#line 459 "../src/core/ViewCollection.vala"
	if (_tmp13_ != NULL) {
#line 3170 "ViewCollection.c"
		Marker* _tmp14_;
#line 459 "../src/core/ViewCollection.vala"
		_tmp14_ = marker;
#line 459 "../src/core/ViewCollection.vala"
		_tmp12_ = marker_get_count (_tmp14_) != 0;
#line 3176 "ViewCollection.c"
	} else {
#line 459 "../src/core/ViewCollection.vala"
		_tmp12_ = FALSE;
#line 3180 "ViewCollection.c"
	}
#line 459 "../src/core/ViewCollection.vala"
	if (_tmp12_) {
#line 3184 "ViewCollection.c"
		Marker* _tmp15_;
#line 460 "../src/core/ViewCollection.vala"
		_tmp15_ = marker;
#line 460 "../src/core/ViewCollection.vala"
		data_collection_remove_marked (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), _tmp15_);
#line 3190 "ViewCollection.c"
	}
#line 444 "../src/core/ViewCollection.vala"
	_g_object_unref0 (marker);
#line 3194 "ViewCollection.c"
}

static void
view_collection_on_sources_altered (ViewCollection* self,
                                    DataCollection* collection,
                                    GeeMap* items)
{
	GeeArrayList* to_add = NULL;
	GeeArrayList* to_remove = NULL;
	gboolean ordering_changed = FALSE;
	GeeArrayList* _tmp68_;
	GeeArrayList* _tmp72_;
#line 463 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 463 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_DATA_COLLECTION (collection));
#line 463 "../src/core/ViewCollection.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (items, GEE_TYPE_MAP));
#line 466 "../src/core/ViewCollection.vala"
	to_add = NULL;
#line 467 "../src/core/ViewCollection.vala"
	to_remove = NULL;
#line 468 "../src/core/ViewCollection.vala"
	ordering_changed = FALSE;
#line 3219 "ViewCollection.c"
	{
		GeeIterator* _object_it = NULL;
		GeeSet* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 469 "../src/core/ViewCollection.vala"
		_tmp0_ = gee_map_get_keys (items);
#line 469 "../src/core/ViewCollection.vala"
		_tmp1_ = _tmp0_;
#line 469 "../src/core/ViewCollection.vala"
		_tmp2_ = _tmp1_;
#line 469 "../src/core/ViewCollection.vala"
		_tmp3_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ITERABLE, GeeIterable));
#line 469 "../src/core/ViewCollection.vala"
		_tmp4_ = _tmp3_;
#line 469 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp2_);
#line 469 "../src/core/ViewCollection.vala"
		_object_it = _tmp4_;
#line 469 "../src/core/ViewCollection.vala"
		while (TRUE) {
#line 3243 "ViewCollection.c"
			GeeIterator* _tmp5_;
			DataObject* object = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			Alteration* alteration = NULL;
			DataObject* _tmp8_;
			gpointer _tmp9_;
			DataSource* source = NULL;
			DataObject* _tmp10_;
			DataSource* _tmp11_;
			ViewCollectionMonitorImpl* monitor = NULL;
			gboolean ignored = FALSE;
			gboolean _tmp32_ = FALSE;
			ViewCollectionMonitorImpl* _tmp33_;
#line 469 "../src/core/ViewCollection.vala"
			_tmp5_ = _object_it;
#line 469 "../src/core/ViewCollection.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 469 "../src/core/ViewCollection.vala"
				break;
#line 3264 "ViewCollection.c"
			}
#line 469 "../src/core/ViewCollection.vala"
			_tmp6_ = _object_it;
#line 469 "../src/core/ViewCollection.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 469 "../src/core/ViewCollection.vala"
			object = (DataObject*) _tmp7_;
#line 470 "../src/core/ViewCollection.vala"
			_tmp8_ = object;
#line 470 "../src/core/ViewCollection.vala"
			_tmp9_ = gee_map_get (items, _tmp8_);
#line 470 "../src/core/ViewCollection.vala"
			alteration = (Alteration*) _tmp9_;
#line 471 "../src/core/ViewCollection.vala"
			_tmp10_ = object;
#line 471 "../src/core/ViewCollection.vala"
			_tmp11_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, TYPE_DATA_SOURCE, DataSource));
#line 471 "../src/core/ViewCollection.vala"
			source = _tmp11_;
#line 473 "../src/core/ViewCollection.vala"
			monitor = NULL;
#line 474 "../src/core/ViewCollection.vala"
			ignored = TRUE;
#line 3288 "ViewCollection.c"
			{
				GeeIterator* _monitor_impl_it = NULL;
				GeeHashMultiMap* _tmp12_;
				GeeCollection* _tmp13_;
				GeeCollection* _tmp14_;
				GeeIterator* _tmp15_;
				GeeIterator* _tmp16_;
#line 475 "../src/core/ViewCollection.vala"
				_tmp12_ = self->priv->monitors;
#line 475 "../src/core/ViewCollection.vala"
				_tmp13_ = gee_multi_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GEE_TYPE_MULTI_MAP, GeeMultiMap), G_TYPE_CHECK_INSTANCE_CAST (collection, TYPE_SOURCE_COLLECTION, SourceCollection));
#line 475 "../src/core/ViewCollection.vala"
				_tmp14_ = _tmp13_;
#line 475 "../src/core/ViewCollection.vala"
				_tmp15_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, GEE_TYPE_ITERABLE, GeeIterable));
#line 475 "../src/core/ViewCollection.vala"
				_tmp16_ = _tmp15_;
#line 475 "../src/core/ViewCollection.vala"
				_g_object_unref0 (_tmp14_);
#line 475 "../src/core/ViewCollection.vala"
				_monitor_impl_it = _tmp16_;
#line 475 "../src/core/ViewCollection.vala"
				while (TRUE) {
#line 3312 "ViewCollection.c"
					GeeIterator* _tmp17_;
					ViewCollectionMonitorImpl* monitor_impl = NULL;
					GeeIterator* _tmp18_;
					gpointer _tmp19_;
					gboolean _tmp20_ = FALSE;
					ViewCollectionMonitorImpl* _tmp21_;
					Alteration* _tmp22_;
					ViewCollectionMonitorImpl* _tmp26_;
					ViewManager* _tmp27_;
					DataSource* _tmp28_;
#line 475 "../src/core/ViewCollection.vala"
					_tmp17_ = _monitor_impl_it;
#line 475 "../src/core/ViewCollection.vala"
					if (!gee_iterator_next (_tmp17_)) {
#line 475 "../src/core/ViewCollection.vala"
						break;
#line 3329 "ViewCollection.c"
					}
#line 475 "../src/core/ViewCollection.vala"
					_tmp18_ = _monitor_impl_it;
#line 475 "../src/core/ViewCollection.vala"
					_tmp19_ = gee_iterator_get (_tmp18_);
#line 475 "../src/core/ViewCollection.vala"
					monitor_impl = (ViewCollectionMonitorImpl*) _tmp19_;
#line 476 "../src/core/ViewCollection.vala"
					_tmp21_ = monitor_impl;
#line 476 "../src/core/ViewCollection.vala"
					_tmp22_ = _tmp21_->prereq;
#line 476 "../src/core/ViewCollection.vala"
					if (_tmp22_ != NULL) {
#line 3343 "ViewCollection.c"
						Alteration* _tmp23_;
						ViewCollectionMonitorImpl* _tmp24_;
						Alteration* _tmp25_;
#line 476 "../src/core/ViewCollection.vala"
						_tmp23_ = alteration;
#line 476 "../src/core/ViewCollection.vala"
						_tmp24_ = monitor_impl;
#line 476 "../src/core/ViewCollection.vala"
						_tmp25_ = _tmp24_->prereq;
#line 476 "../src/core/ViewCollection.vala"
						_tmp20_ = !alteration_contains_any (_tmp23_, _tmp25_);
#line 3355 "ViewCollection.c"
					} else {
#line 476 "../src/core/ViewCollection.vala"
						_tmp20_ = FALSE;
#line 3359 "ViewCollection.c"
					}
#line 476 "../src/core/ViewCollection.vala"
					if (_tmp20_) {
#line 477 "../src/core/ViewCollection.vala"
						_view_collection_monitor_unref0 (monitor_impl);
#line 477 "../src/core/ViewCollection.vala"
						continue;
#line 3367 "ViewCollection.c"
					}
#line 479 "../src/core/ViewCollection.vala"
					ignored = FALSE;
#line 481 "../src/core/ViewCollection.vala"
					_tmp26_ = monitor_impl;
#line 481 "../src/core/ViewCollection.vala"
					_tmp27_ = _tmp26_->manager;
#line 481 "../src/core/ViewCollection.vala"
					_tmp28_ = source;
#line 481 "../src/core/ViewCollection.vala"
					if (view_manager_include_in_view (_tmp27_, _tmp28_)) {
#line 3379 "ViewCollection.c"
						ViewCollectionMonitorImpl* _tmp29_;
						ViewCollectionMonitorImpl* _tmp30_;
#line 482 "../src/core/ViewCollection.vala"
						_tmp29_ = monitor_impl;
#line 482 "../src/core/ViewCollection.vala"
						_tmp30_ = _view_collection_monitor_ref0 (_tmp29_);
#line 482 "../src/core/ViewCollection.vala"
						_view_collection_monitor_unref0 (monitor);
#line 482 "../src/core/ViewCollection.vala"
						monitor = _tmp30_;
#line 484 "../src/core/ViewCollection.vala"
						_view_collection_monitor_unref0 (monitor_impl);
#line 484 "../src/core/ViewCollection.vala"
						break;
#line 3394 "ViewCollection.c"
					}
#line 475 "../src/core/ViewCollection.vala"
					_view_collection_monitor_unref0 (monitor_impl);
#line 3398 "ViewCollection.c"
				}
#line 475 "../src/core/ViewCollection.vala"
				_g_object_unref0 (_monitor_impl_it);
#line 3402 "ViewCollection.c"
			}
#line 488 "../src/core/ViewCollection.vala"
			if (ignored) {
#line 3406 "ViewCollection.c"
				ViewCollectionMonitorImpl* _tmp31_;
#line 489 "../src/core/ViewCollection.vala"
				_tmp31_ = monitor;
#line 489 "../src/core/ViewCollection.vala"
				_vala_assert (_tmp31_ == NULL, "monitor == null");
#line 491 "../src/core/ViewCollection.vala"
				_view_collection_monitor_unref0 (monitor);
#line 491 "../src/core/ViewCollection.vala"
				_g_object_unref0 (source);
#line 491 "../src/core/ViewCollection.vala"
				_alteration_unref0 (alteration);
#line 491 "../src/core/ViewCollection.vala"
				_g_object_unref0 (object);
#line 491 "../src/core/ViewCollection.vala"
				continue;
#line 3422 "ViewCollection.c"
			}
#line 494 "../src/core/ViewCollection.vala"
			_tmp33_ = monitor;
#line 494 "../src/core/ViewCollection.vala"
			if (_tmp33_ != NULL) {
#line 3428 "ViewCollection.c"
				DataSource* _tmp34_;
#line 494 "../src/core/ViewCollection.vala"
				_tmp34_ = source;
#line 494 "../src/core/ViewCollection.vala"
				_tmp32_ = !view_collection_has_view_for_source (self, _tmp34_);
#line 3434 "ViewCollection.c"
			} else {
#line 494 "../src/core/ViewCollection.vala"
				_tmp32_ = FALSE;
#line 3438 "ViewCollection.c"
			}
#line 494 "../src/core/ViewCollection.vala"
			if (_tmp32_) {
#line 3442 "ViewCollection.c"
				GeeArrayList* _tmp35_;
				GeeArrayList* _tmp37_;
				ViewCollectionMonitorImpl* _tmp38_;
				ViewManager* _tmp39_;
				DataSource* _tmp40_;
				DataView* _tmp41_;
				DataView* _tmp42_;
#line 495 "../src/core/ViewCollection.vala"
				_tmp35_ = to_add;
#line 495 "../src/core/ViewCollection.vala"
				if (_tmp35_ == NULL) {
#line 3454 "ViewCollection.c"
					GeeArrayList* _tmp36_;
#line 496 "../src/core/ViewCollection.vala"
					_tmp36_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 496 "../src/core/ViewCollection.vala"
					_g_object_unref0 (to_add);
#line 496 "../src/core/ViewCollection.vala"
					to_add = _tmp36_;
#line 3462 "ViewCollection.c"
				}
#line 498 "../src/core/ViewCollection.vala"
				_tmp37_ = to_add;
#line 498 "../src/core/ViewCollection.vala"
				_tmp38_ = monitor;
#line 498 "../src/core/ViewCollection.vala"
				_tmp39_ = _tmp38_->manager;
#line 498 "../src/core/ViewCollection.vala"
				_tmp40_ = source;
#line 498 "../src/core/ViewCollection.vala"
				_tmp41_ = view_manager_create_view (_tmp39_, _tmp40_);
#line 498 "../src/core/ViewCollection.vala"
				_tmp42_ = _tmp41_;
#line 498 "../src/core/ViewCollection.vala"
				gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp37_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp42_);
#line 498 "../src/core/ViewCollection.vala"
				_g_object_unref0 (_tmp42_);
#line 3480 "ViewCollection.c"
			} else {
				gboolean _tmp43_ = FALSE;
				ViewCollectionMonitorImpl* _tmp44_;
#line 499 "../src/core/ViewCollection.vala"
				_tmp44_ = monitor;
#line 499 "../src/core/ViewCollection.vala"
				if (_tmp44_ == NULL) {
#line 3488 "ViewCollection.c"
					DataSource* _tmp45_;
#line 499 "../src/core/ViewCollection.vala"
					_tmp45_ = source;
#line 499 "../src/core/ViewCollection.vala"
					_tmp43_ = view_collection_has_view_for_source (self, _tmp45_);
#line 3494 "ViewCollection.c"
				} else {
#line 499 "../src/core/ViewCollection.vala"
					_tmp43_ = FALSE;
#line 3498 "ViewCollection.c"
				}
#line 499 "../src/core/ViewCollection.vala"
				if (_tmp43_) {
#line 3502 "ViewCollection.c"
					GeeArrayList* _tmp46_;
					GeeArrayList* _tmp48_;
					DataSource* _tmp49_;
					DataView* _tmp50_;
					DataView* _tmp51_;
#line 500 "../src/core/ViewCollection.vala"
					_tmp46_ = to_remove;
#line 500 "../src/core/ViewCollection.vala"
					if (_tmp46_ == NULL) {
#line 3512 "ViewCollection.c"
						GeeArrayList* _tmp47_;
#line 501 "../src/core/ViewCollection.vala"
						_tmp47_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 501 "../src/core/ViewCollection.vala"
						_g_object_unref0 (to_remove);
#line 501 "../src/core/ViewCollection.vala"
						to_remove = _tmp47_;
#line 3520 "ViewCollection.c"
					}
#line 503 "../src/core/ViewCollection.vala"
					_tmp48_ = to_remove;
#line 503 "../src/core/ViewCollection.vala"
					_tmp49_ = source;
#line 503 "../src/core/ViewCollection.vala"
					_tmp50_ = view_collection_get_view_for_source (self, _tmp49_);
#line 503 "../src/core/ViewCollection.vala"
					_tmp51_ = _tmp50_;
#line 503 "../src/core/ViewCollection.vala"
					gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp48_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp51_);
#line 503 "../src/core/ViewCollection.vala"
					_g_object_unref0 (_tmp51_);
#line 3534 "ViewCollection.c"
				} else {
					gboolean _tmp52_ = FALSE;
					ViewCollectionMonitorImpl* _tmp53_;
#line 504 "../src/core/ViewCollection.vala"
					_tmp53_ = monitor;
#line 504 "../src/core/ViewCollection.vala"
					if (_tmp53_ != NULL) {
#line 3542 "ViewCollection.c"
						DataSource* _tmp54_;
#line 504 "../src/core/ViewCollection.vala"
						_tmp54_ = source;
#line 504 "../src/core/ViewCollection.vala"
						_tmp52_ = view_collection_has_view_for_source (self, _tmp54_);
#line 3548 "ViewCollection.c"
					} else {
#line 504 "../src/core/ViewCollection.vala"
						_tmp52_ = FALSE;
#line 3552 "ViewCollection.c"
					}
#line 504 "../src/core/ViewCollection.vala"
					if (_tmp52_) {
#line 3556 "ViewCollection.c"
						DataView* view = NULL;
						DataSource* _tmp55_;
						DataView* _tmp56_;
						DataSet* _tmp57_;
						DataView* _tmp58_;
						gboolean _tmp62_ = FALSE;
						DataSet* _tmp63_;
#line 505 "../src/core/ViewCollection.vala"
						_tmp55_ = source;
#line 505 "../src/core/ViewCollection.vala"
						_tmp56_ = view_collection_get_view_for_source (self, _tmp55_);
#line 505 "../src/core/ViewCollection.vala"
						view = _tmp56_;
#line 507 "../src/core/ViewCollection.vala"
						_tmp57_ = self->priv->selected;
#line 507 "../src/core/ViewCollection.vala"
						_tmp58_ = view;
#line 507 "../src/core/ViewCollection.vala"
						if (data_set_contains (_tmp57_, G_TYPE_CHECK_INSTANCE_CAST (_tmp58_, TYPE_DATA_OBJECT, DataObject))) {
#line 3576 "ViewCollection.c"
							DataSet* _tmp59_;
							DataView* _tmp60_;
							Alteration* _tmp61_;
#line 508 "../src/core/ViewCollection.vala"
							_tmp59_ = self->priv->selected;
#line 508 "../src/core/ViewCollection.vala"
							_tmp60_ = view;
#line 508 "../src/core/ViewCollection.vala"
							_tmp61_ = alteration;
#line 508 "../src/core/ViewCollection.vala"
							data_set_resort_object (_tmp59_, G_TYPE_CHECK_INSTANCE_CAST (_tmp60_, TYPE_DATA_OBJECT, DataObject), _tmp61_);
#line 3588 "ViewCollection.c"
						}
#line 510 "../src/core/ViewCollection.vala"
						_tmp63_ = self->priv->visible;
#line 510 "../src/core/ViewCollection.vala"
						if (_tmp63_ != NULL) {
#line 3594 "ViewCollection.c"
							DataView* _tmp64_;
#line 510 "../src/core/ViewCollection.vala"
							_tmp64_ = view;
#line 510 "../src/core/ViewCollection.vala"
							_tmp62_ = view_collection_is_visible (self, _tmp64_);
#line 3600 "ViewCollection.c"
						} else {
#line 510 "../src/core/ViewCollection.vala"
							_tmp62_ = FALSE;
#line 3604 "ViewCollection.c"
						}
#line 510 "../src/core/ViewCollection.vala"
						if (_tmp62_) {
#line 3608 "ViewCollection.c"
							DataSet* _tmp65_;
							DataView* _tmp66_;
							Alteration* _tmp67_;
#line 511 "../src/core/ViewCollection.vala"
							_tmp65_ = self->priv->visible;
#line 511 "../src/core/ViewCollection.vala"
							_tmp66_ = view;
#line 511 "../src/core/ViewCollection.vala"
							_tmp67_ = alteration;
#line 511 "../src/core/ViewCollection.vala"
							if (data_set_resort_object (_tmp65_, G_TYPE_CHECK_INSTANCE_CAST (_tmp66_, TYPE_DATA_OBJECT, DataObject), _tmp67_)) {
#line 512 "../src/core/ViewCollection.vala"
								ordering_changed = TRUE;
#line 3622 "ViewCollection.c"
							}
						}
#line 504 "../src/core/ViewCollection.vala"
						_g_object_unref0 (view);
#line 3627 "ViewCollection.c"
					}
				}
			}
#line 469 "../src/core/ViewCollection.vala"
			_view_collection_monitor_unref0 (monitor);
#line 469 "../src/core/ViewCollection.vala"
			_g_object_unref0 (source);
#line 469 "../src/core/ViewCollection.vala"
			_alteration_unref0 (alteration);
#line 469 "../src/core/ViewCollection.vala"
			_g_object_unref0 (object);
#line 3639 "ViewCollection.c"
		}
#line 469 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_object_it);
#line 3643 "ViewCollection.c"
	}
#line 517 "../src/core/ViewCollection.vala"
	_tmp68_ = to_add;
#line 517 "../src/core/ViewCollection.vala"
	if (_tmp68_ != NULL) {
#line 3649 "ViewCollection.c"
		GeeArrayList* _tmp69_;
		GeeCollection* _tmp70_;
		GeeCollection* _tmp71_;
#line 518 "../src/core/ViewCollection.vala"
		_tmp69_ = to_add;
#line 518 "../src/core/ViewCollection.vala"
		_tmp70_ = data_collection_add_many (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp69_, GEE_TYPE_COLLECTION, GeeCollection), NULL, NULL);
#line 518 "../src/core/ViewCollection.vala"
		_tmp71_ = _tmp70_;
#line 518 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp71_);
#line 3661 "ViewCollection.c"
	}
#line 520 "../src/core/ViewCollection.vala"
	_tmp72_ = to_remove;
#line 520 "../src/core/ViewCollection.vala"
	if (_tmp72_ != NULL) {
#line 3667 "ViewCollection.c"
		GeeArrayList* _tmp73_;
		Marker* _tmp74_;
		Marker* _tmp75_;
#line 521 "../src/core/ViewCollection.vala"
		_tmp73_ = to_remove;
#line 521 "../src/core/ViewCollection.vala"
		_tmp74_ = data_collection_mark_many (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp73_, GEE_TYPE_COLLECTION, GeeCollection));
#line 521 "../src/core/ViewCollection.vala"
		_tmp75_ = _tmp74_;
#line 521 "../src/core/ViewCollection.vala"
		data_collection_remove_marked (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), _tmp75_);
#line 521 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp75_);
#line 3681 "ViewCollection.c"
	}
#line 523 "../src/core/ViewCollection.vala"
	if (ordering_changed) {
#line 524 "../src/core/ViewCollection.vala"
		data_collection_notify_ordering_changed (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 3687 "ViewCollection.c"
	}
#line 463 "../src/core/ViewCollection.vala"
	_g_object_unref0 (to_remove);
#line 463 "../src/core/ViewCollection.vala"
	_g_object_unref0 (to_add);
#line 3693 "ViewCollection.c"
}

static void
view_collection_on_mirror_contents_added (ViewCollection* self,
                                          GeeIterable* added)
{
	GeeArrayList* to_add = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
#line 527 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 527 "../src/core/ViewCollection.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (added, GEE_TYPE_ITERABLE));
#line 528 "../src/core/ViewCollection.vala"
	_tmp0_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 528 "../src/core/ViewCollection.vala"
	to_add = _tmp0_;
#line 3713 "ViewCollection.c"
	{
		GeeIterator* _object_it = NULL;
		GeeIterator* _tmp1_;
#line 529 "../src/core/ViewCollection.vala"
		_tmp1_ = gee_iterable_iterator (added);
#line 529 "../src/core/ViewCollection.vala"
		_object_it = _tmp1_;
#line 529 "../src/core/ViewCollection.vala"
		while (TRUE) {
#line 3723 "ViewCollection.c"
			GeeIterator* _tmp2_;
			DataObject* object = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			DataSource* source = NULL;
			DataObject* _tmp5_;
			DataSource* _tmp6_;
			gboolean _tmp7_ = FALSE;
			CreateViewPredicate _tmp8_;
			gpointer _tmp8__target;
#line 529 "../src/core/ViewCollection.vala"
			_tmp2_ = _object_it;
#line 529 "../src/core/ViewCollection.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 529 "../src/core/ViewCollection.vala"
				break;
#line 3740 "ViewCollection.c"
			}
#line 529 "../src/core/ViewCollection.vala"
			_tmp3_ = _object_it;
#line 529 "../src/core/ViewCollection.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 529 "../src/core/ViewCollection.vala"
			object = (DataObject*) _tmp4_;
#line 530 "../src/core/ViewCollection.vala"
			_tmp5_ = object;
#line 530 "../src/core/ViewCollection.vala"
			_tmp6_ = data_view_get_source (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_DATA_VIEW, DataView));
#line 530 "../src/core/ViewCollection.vala"
			source = _tmp6_;
#line 532 "../src/core/ViewCollection.vala"
			_tmp8_ = self->priv->should_mirror;
#line 532 "../src/core/ViewCollection.vala"
			_tmp8__target = self->priv->should_mirror_target;
#line 532 "../src/core/ViewCollection.vala"
			if (_tmp8_ == NULL) {
#line 532 "../src/core/ViewCollection.vala"
				_tmp7_ = TRUE;
#line 3762 "ViewCollection.c"
			} else {
				CreateViewPredicate _tmp9_;
				gpointer _tmp9__target;
				DataSource* _tmp10_;
#line 532 "../src/core/ViewCollection.vala"
				_tmp9_ = self->priv->should_mirror;
#line 532 "../src/core/ViewCollection.vala"
				_tmp9__target = self->priv->should_mirror_target;
#line 532 "../src/core/ViewCollection.vala"
				_tmp10_ = source;
#line 532 "../src/core/ViewCollection.vala"
				_tmp7_ = _tmp9_ (_tmp10_, _tmp9__target);
#line 3775 "ViewCollection.c"
			}
#line 532 "../src/core/ViewCollection.vala"
			if (_tmp7_) {
#line 3779 "ViewCollection.c"
				GeeArrayList* _tmp11_;
				CreateView _tmp12_;
				gpointer _tmp12__target;
				DataSource* _tmp13_;
				DataView* _tmp14_;
				DataView* _tmp15_;
#line 533 "../src/core/ViewCollection.vala"
				_tmp11_ = to_add;
#line 533 "../src/core/ViewCollection.vala"
				_tmp12_ = self->priv->mirroring_ctor;
#line 533 "../src/core/ViewCollection.vala"
				_tmp12__target = self->priv->mirroring_ctor_target;
#line 533 "../src/core/ViewCollection.vala"
				_tmp13_ = source;
#line 533 "../src/core/ViewCollection.vala"
				_tmp14_ = _tmp12_ (_tmp13_, _tmp12__target);
#line 533 "../src/core/ViewCollection.vala"
				_tmp15_ = _tmp14_;
#line 533 "../src/core/ViewCollection.vala"
				gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp15_);
#line 533 "../src/core/ViewCollection.vala"
				_g_object_unref0 (_tmp15_);
#line 3802 "ViewCollection.c"
			}
#line 529 "../src/core/ViewCollection.vala"
			_g_object_unref0 (source);
#line 529 "../src/core/ViewCollection.vala"
			_g_object_unref0 (object);
#line 3808 "ViewCollection.c"
		}
#line 529 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_object_it);
#line 3812 "ViewCollection.c"
	}
#line 536 "../src/core/ViewCollection.vala"
	_tmp16_ = to_add;
#line 536 "../src/core/ViewCollection.vala"
	_tmp17_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 536 "../src/core/ViewCollection.vala"
	_tmp18_ = _tmp17_;
#line 536 "../src/core/ViewCollection.vala"
	if (_tmp18_ > 0) {
#line 3822 "ViewCollection.c"
		GeeArrayList* _tmp19_;
		GeeCollection* _tmp20_;
		GeeCollection* _tmp21_;
#line 537 "../src/core/ViewCollection.vala"
		_tmp19_ = to_add;
#line 537 "../src/core/ViewCollection.vala"
		_tmp20_ = data_collection_add_many (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, GEE_TYPE_COLLECTION, GeeCollection), NULL, NULL);
#line 537 "../src/core/ViewCollection.vala"
		_tmp21_ = _tmp20_;
#line 537 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp21_);
#line 3834 "ViewCollection.c"
	}
#line 527 "../src/core/ViewCollection.vala"
	_g_object_unref0 (to_add);
#line 3838 "ViewCollection.c"
}

static void
view_collection_on_mirror_contents_removed (ViewCollection* self,
                                            GeeIterable* removed)
{
	Marker* marker = NULL;
	Marker* _tmp0_;
	Marker* _tmp15_;
#line 540 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 540 "../src/core/ViewCollection.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (removed, GEE_TYPE_ITERABLE));
#line 541 "../src/core/ViewCollection.vala"
	_tmp0_ = data_collection_start_marking (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 541 "../src/core/ViewCollection.vala"
	marker = _tmp0_;
#line 3856 "ViewCollection.c"
	{
		GeeIterator* _object_it = NULL;
		GeeIterator* _tmp1_;
#line 542 "../src/core/ViewCollection.vala"
		_tmp1_ = gee_iterable_iterator (removed);
#line 542 "../src/core/ViewCollection.vala"
		_object_it = _tmp1_;
#line 542 "../src/core/ViewCollection.vala"
		while (TRUE) {
#line 3866 "ViewCollection.c"
			GeeIterator* _tmp2_;
			DataObject* object = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			DataView* view = NULL;
			DataObject* _tmp5_;
			DataView* _tmp6_;
			DataView* our_view = NULL;
			DataView* _tmp7_;
			DataSource* _tmp8_;
			DataSource* _tmp9_;
			DataView* _tmp10_;
			DataView* _tmp11_;
			DataView* _tmp12_;
			Marker* _tmp13_;
			DataView* _tmp14_;
#line 542 "../src/core/ViewCollection.vala"
			_tmp2_ = _object_it;
#line 542 "../src/core/ViewCollection.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 542 "../src/core/ViewCollection.vala"
				break;
#line 3889 "ViewCollection.c"
			}
#line 542 "../src/core/ViewCollection.vala"
			_tmp3_ = _object_it;
#line 542 "../src/core/ViewCollection.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 542 "../src/core/ViewCollection.vala"
			object = (DataObject*) _tmp4_;
#line 543 "../src/core/ViewCollection.vala"
			_tmp5_ = object;
#line 543 "../src/core/ViewCollection.vala"
			_tmp6_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_DATA_VIEW, DataView));
#line 543 "../src/core/ViewCollection.vala"
			view = _tmp6_;
#line 545 "../src/core/ViewCollection.vala"
			_tmp7_ = view;
#line 545 "../src/core/ViewCollection.vala"
			_tmp8_ = data_view_get_source (_tmp7_);
#line 545 "../src/core/ViewCollection.vala"
			_tmp9_ = _tmp8_;
#line 545 "../src/core/ViewCollection.vala"
			_tmp10_ = view_collection_get_view_for_source (self, _tmp9_);
#line 545 "../src/core/ViewCollection.vala"
			_tmp11_ = _tmp10_;
#line 545 "../src/core/ViewCollection.vala"
			_g_object_unref0 (_tmp9_);
#line 545 "../src/core/ViewCollection.vala"
			our_view = _tmp11_;
#line 546 "../src/core/ViewCollection.vala"
			_tmp12_ = our_view;
#line 546 "../src/core/ViewCollection.vala"
			_vala_assert (_tmp12_ != NULL, "our_view != null");
#line 548 "../src/core/ViewCollection.vala"
			_tmp13_ = marker;
#line 548 "../src/core/ViewCollection.vala"
			_tmp14_ = our_view;
#line 548 "../src/core/ViewCollection.vala"
			marker_mark (_tmp13_, G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, TYPE_DATA_OBJECT, DataObject));
#line 542 "../src/core/ViewCollection.vala"
			_g_object_unref0 (our_view);
#line 542 "../src/core/ViewCollection.vala"
			_g_object_unref0 (view);
#line 542 "../src/core/ViewCollection.vala"
			_g_object_unref0 (object);
#line 3933 "ViewCollection.c"
		}
#line 542 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_object_it);
#line 3937 "ViewCollection.c"
	}
#line 551 "../src/core/ViewCollection.vala"
	_tmp15_ = marker;
#line 551 "../src/core/ViewCollection.vala"
	data_collection_remove_marked (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), _tmp15_);
#line 540 "../src/core/ViewCollection.vala"
	_g_object_unref0 (marker);
#line 3945 "ViewCollection.c"
}

static void
view_collection_real_notify_items_added (DataCollection* base,
                                         GeeIterable* added)
{
	ViewCollection * self;
	GeeArrayList* added_visible = NULL;
	GeeArrayList* added_selected = NULL;
	GeeArrayList* _tmp25_;
	GeeArrayList* _tmp27_;
#line 555 "../src/core/ViewCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIEW_COLLECTION, ViewCollection);
#line 555 "../src/core/ViewCollection.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (added, GEE_TYPE_ITERABLE));
#line 556 "../src/core/ViewCollection.vala"
	added_visible = NULL;
#line 557 "../src/core/ViewCollection.vala"
	added_selected = NULL;
#line 3965 "ViewCollection.c"
	{
		GeeIterator* _object_it = NULL;
		GeeIterator* _tmp0_;
#line 559 "../src/core/ViewCollection.vala"
		_tmp0_ = gee_iterable_iterator (added);
#line 559 "../src/core/ViewCollection.vala"
		_object_it = _tmp0_;
#line 559 "../src/core/ViewCollection.vala"
		while (TRUE) {
#line 3975 "ViewCollection.c"
			GeeIterator* _tmp1_;
			DataObject* object = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			DataView* view = NULL;
			DataObject* _tmp4_;
			DataView* _tmp5_;
			GeeHashMap* _tmp6_;
			DataView* _tmp7_;
			DataSource* _tmp8_;
			DataSource* _tmp9_;
			DataView* _tmp10_;
			gboolean _tmp11_ = FALSE;
			DataView* _tmp12_;
			gboolean _tmp18_ = FALSE;
			DataView* _tmp19_;
#line 559 "../src/core/ViewCollection.vala"
			_tmp1_ = _object_it;
#line 559 "../src/core/ViewCollection.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 559 "../src/core/ViewCollection.vala"
				break;
#line 3998 "ViewCollection.c"
			}
#line 559 "../src/core/ViewCollection.vala"
			_tmp2_ = _object_it;
#line 559 "../src/core/ViewCollection.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 559 "../src/core/ViewCollection.vala"
			object = (DataObject*) _tmp3_;
#line 560 "../src/core/ViewCollection.vala"
			_tmp4_ = object;
#line 560 "../src/core/ViewCollection.vala"
			_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_DATA_VIEW, DataView));
#line 560 "../src/core/ViewCollection.vala"
			view = _tmp5_;
#line 561 "../src/core/ViewCollection.vala"
			_tmp6_ = self->priv->source_map;
#line 561 "../src/core/ViewCollection.vala"
			_tmp7_ = view;
#line 561 "../src/core/ViewCollection.vala"
			_tmp8_ = data_view_get_source (_tmp7_);
#line 561 "../src/core/ViewCollection.vala"
			_tmp9_ = _tmp8_;
#line 561 "../src/core/ViewCollection.vala"
			_tmp10_ = view;
#line 561 "../src/core/ViewCollection.vala"
			gee_abstract_map_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp9_, _tmp10_);
#line 561 "../src/core/ViewCollection.vala"
			_g_object_unref0 (_tmp9_);
#line 563 "../src/core/ViewCollection.vala"
			_tmp12_ = view;
#line 563 "../src/core/ViewCollection.vala"
			if (data_view_is_selected (_tmp12_)) {
#line 4030 "ViewCollection.c"
				DataView* _tmp13_;
#line 563 "../src/core/ViewCollection.vala"
				_tmp13_ = view;
#line 563 "../src/core/ViewCollection.vala"
				_tmp11_ = data_view_is_visible (_tmp13_);
#line 4036 "ViewCollection.c"
			} else {
#line 563 "../src/core/ViewCollection.vala"
				_tmp11_ = FALSE;
#line 4040 "ViewCollection.c"
			}
#line 563 "../src/core/ViewCollection.vala"
			if (_tmp11_) {
#line 4044 "ViewCollection.c"
				GeeArrayList* _tmp14_;
				GeeArrayList* _tmp16_;
				DataView* _tmp17_;
#line 564 "../src/core/ViewCollection.vala"
				_tmp14_ = added_selected;
#line 564 "../src/core/ViewCollection.vala"
				if (_tmp14_ == NULL) {
#line 4052 "ViewCollection.c"
					GeeArrayList* _tmp15_;
#line 565 "../src/core/ViewCollection.vala"
					_tmp15_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 565 "../src/core/ViewCollection.vala"
					_g_object_unref0 (added_selected);
#line 565 "../src/core/ViewCollection.vala"
					added_selected = _tmp15_;
#line 4060 "ViewCollection.c"
				}
#line 567 "../src/core/ViewCollection.vala"
				_tmp16_ = added_selected;
#line 567 "../src/core/ViewCollection.vala"
				_tmp17_ = view;
#line 567 "../src/core/ViewCollection.vala"
				gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp17_);
#line 4068 "ViewCollection.c"
			}
#line 571 "../src/core/ViewCollection.vala"
			_tmp19_ = view;
#line 571 "../src/core/ViewCollection.vala"
			if (data_view_is_visible (_tmp19_)) {
#line 4074 "ViewCollection.c"
				DataSet* _tmp20_;
#line 571 "../src/core/ViewCollection.vala"
				_tmp20_ = self->priv->visible;
#line 571 "../src/core/ViewCollection.vala"
				_tmp18_ = _tmp20_ != NULL;
#line 4080 "ViewCollection.c"
			} else {
#line 571 "../src/core/ViewCollection.vala"
				_tmp18_ = FALSE;
#line 4084 "ViewCollection.c"
			}
#line 571 "../src/core/ViewCollection.vala"
			if (_tmp18_) {
#line 4088 "ViewCollection.c"
				GeeArrayList* _tmp21_;
				GeeArrayList* _tmp23_;
				DataView* _tmp24_;
#line 572 "../src/core/ViewCollection.vala"
				_tmp21_ = added_visible;
#line 572 "../src/core/ViewCollection.vala"
				if (_tmp21_ == NULL) {
#line 4096 "ViewCollection.c"
					GeeArrayList* _tmp22_;
#line 573 "../src/core/ViewCollection.vala"
					_tmp22_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 573 "../src/core/ViewCollection.vala"
					_g_object_unref0 (added_visible);
#line 573 "../src/core/ViewCollection.vala"
					added_visible = _tmp22_;
#line 4104 "ViewCollection.c"
				}
#line 575 "../src/core/ViewCollection.vala"
				_tmp23_ = added_visible;
#line 575 "../src/core/ViewCollection.vala"
				_tmp24_ = view;
#line 575 "../src/core/ViewCollection.vala"
				gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp24_);
#line 4112 "ViewCollection.c"
			}
#line 559 "../src/core/ViewCollection.vala"
			_g_object_unref0 (view);
#line 559 "../src/core/ViewCollection.vala"
			_g_object_unref0 (object);
#line 4118 "ViewCollection.c"
		}
#line 559 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_object_it);
#line 4122 "ViewCollection.c"
	}
#line 579 "../src/core/ViewCollection.vala"
	_tmp25_ = added_visible;
#line 579 "../src/core/ViewCollection.vala"
	if (_tmp25_ != NULL) {
#line 4128 "ViewCollection.c"
		gboolean is_added = FALSE;
		GeeArrayList* _tmp26_;
#line 580 "../src/core/ViewCollection.vala"
		_tmp26_ = added_visible;
#line 580 "../src/core/ViewCollection.vala"
		is_added = view_collection_add_many_visible (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, GEE_TYPE_COLLECTION, GeeCollection));
#line 581 "../src/core/ViewCollection.vala"
		_vala_assert (is_added, "is_added");
#line 4137 "ViewCollection.c"
	}
#line 584 "../src/core/ViewCollection.vala"
	_tmp27_ = added_selected;
#line 584 "../src/core/ViewCollection.vala"
	if (_tmp27_ != NULL) {
#line 4143 "ViewCollection.c"
		GeeArrayList* _tmp28_;
		GeeArrayList* _tmp29_;
#line 585 "../src/core/ViewCollection.vala"
		_tmp28_ = added_selected;
#line 585 "../src/core/ViewCollection.vala"
		view_collection_add_many_selected (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, GEE_TYPE_COLLECTION, GeeCollection));
#line 586 "../src/core/ViewCollection.vala"
		_tmp29_ = added_selected;
#line 586 "../src/core/ViewCollection.vala"
		view_collection_notify_items_selected_unselected (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, GEE_TYPE_COLLECTION, GeeCollection), NULL);
#line 4154 "ViewCollection.c"
	}
#line 589 "../src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->notify_items_added (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), added);
#line 555 "../src/core/ViewCollection.vala"
	_g_object_unref0 (added_selected);
#line 555 "../src/core/ViewCollection.vala"
	_g_object_unref0 (added_visible);
#line 4162 "ViewCollection.c"
}

static void
view_collection_real_notify_items_removed (DataCollection* base,
                                           GeeIterable* removed)
{
	ViewCollection * self;
	GeeArrayList* selected_removed = NULL;
	GeeArrayList* _tmp30_;
#line 593 "../src/core/ViewCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIEW_COLLECTION, ViewCollection);
#line 593 "../src/core/ViewCollection.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (removed, GEE_TYPE_ITERABLE));
#line 594 "../src/core/ViewCollection.vala"
	selected_removed = NULL;
#line 4178 "ViewCollection.c"
	{
		GeeIterator* _object_it = NULL;
		GeeIterator* _tmp0_;
#line 595 "../src/core/ViewCollection.vala"
		_tmp0_ = gee_iterable_iterator (removed);
#line 595 "../src/core/ViewCollection.vala"
		_object_it = _tmp0_;
#line 595 "../src/core/ViewCollection.vala"
		while (TRUE) {
#line 4188 "ViewCollection.c"
			GeeIterator* _tmp1_;
			DataObject* object = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			DataView* view = NULL;
			DataObject* _tmp4_;
			DataView* _tmp5_;
			GeeHashMap* _tmp6_;
			DataView* _tmp7_;
			DataSource* _tmp8_;
			DataSource* _tmp9_;
			gboolean _tmp10_;
#line 595 "../src/core/ViewCollection.vala"
			_tmp1_ = _object_it;
#line 595 "../src/core/ViewCollection.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 595 "../src/core/ViewCollection.vala"
				break;
#line 4207 "ViewCollection.c"
			}
#line 595 "../src/core/ViewCollection.vala"
			_tmp2_ = _object_it;
#line 595 "../src/core/ViewCollection.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 595 "../src/core/ViewCollection.vala"
			object = (DataObject*) _tmp3_;
#line 596 "../src/core/ViewCollection.vala"
			_tmp4_ = object;
#line 596 "../src/core/ViewCollection.vala"
			_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_DATA_VIEW, DataView));
#line 596 "../src/core/ViewCollection.vala"
			view = _tmp5_;
#line 602 "../src/core/ViewCollection.vala"
			_tmp6_ = self->priv->source_map;
#line 602 "../src/core/ViewCollection.vala"
			_tmp7_ = view;
#line 602 "../src/core/ViewCollection.vala"
			_tmp8_ = data_view_get_source (_tmp7_);
#line 602 "../src/core/ViewCollection.vala"
			_tmp9_ = _tmp8_;
#line 602 "../src/core/ViewCollection.vala"
			_tmp10_ = gee_abstract_map_has_key (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp9_);
#line 602 "../src/core/ViewCollection.vala"
			_g_object_unref0 (_tmp9_);
#line 602 "../src/core/ViewCollection.vala"
			if (_tmp10_) {
#line 4235 "ViewCollection.c"
				gboolean is_removed = FALSE;
				GeeHashMap* _tmp11_;
				DataView* _tmp12_;
				DataSource* _tmp13_;
				DataSource* _tmp14_;
				gboolean _tmp15_;
				DataView* _tmp16_;
				gboolean _tmp25_ = FALSE;
				DataView* _tmp26_;
#line 603 "../src/core/ViewCollection.vala"
				_tmp11_ = self->priv->source_map;
#line 603 "../src/core/ViewCollection.vala"
				_tmp12_ = view;
#line 603 "../src/core/ViewCollection.vala"
				_tmp13_ = data_view_get_source (_tmp12_);
#line 603 "../src/core/ViewCollection.vala"
				_tmp14_ = _tmp13_;
#line 603 "../src/core/ViewCollection.vala"
				_tmp15_ = gee_abstract_map_unset (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), _tmp14_, NULL);
#line 603 "../src/core/ViewCollection.vala"
				_g_object_unref0 (_tmp14_);
#line 603 "../src/core/ViewCollection.vala"
				is_removed = _tmp15_;
#line 604 "../src/core/ViewCollection.vala"
				_vala_assert (is_removed, "is_removed");
#line 606 "../src/core/ViewCollection.vala"
				_tmp16_ = view;
#line 606 "../src/core/ViewCollection.vala"
				if (data_view_is_selected (_tmp16_)) {
#line 4265 "ViewCollection.c"
					DataSet* _tmp17_;
					DataView* _tmp18_;
					DataView* _tmp19_;
					DataView* _tmp20_;
#line 608 "../src/core/ViewCollection.vala"
					_tmp17_ = self->priv->selected;
#line 608 "../src/core/ViewCollection.vala"
					_tmp18_ = view;
#line 608 "../src/core/ViewCollection.vala"
					_tmp19_ = view;
#line 608 "../src/core/ViewCollection.vala"
					_vala_assert (data_set_contains (_tmp17_, G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, TYPE_DATA_OBJECT, DataObject)) == data_view_is_visible (_tmp19_), "selected.contains(view) == view.is_visible()");
#line 610 "../src/core/ViewCollection.vala"
					_tmp20_ = view;
#line 610 "../src/core/ViewCollection.vala"
					if (data_view_is_visible (_tmp20_)) {
#line 4282 "ViewCollection.c"
						GeeArrayList* _tmp21_;
						GeeArrayList* _tmp23_;
						DataView* _tmp24_;
#line 611 "../src/core/ViewCollection.vala"
						_tmp21_ = selected_removed;
#line 611 "../src/core/ViewCollection.vala"
						if (_tmp21_ == NULL) {
#line 4290 "ViewCollection.c"
							GeeArrayList* _tmp22_;
#line 612 "../src/core/ViewCollection.vala"
							_tmp22_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 612 "../src/core/ViewCollection.vala"
							_g_object_unref0 (selected_removed);
#line 612 "../src/core/ViewCollection.vala"
							selected_removed = _tmp22_;
#line 4298 "ViewCollection.c"
						}
#line 614 "../src/core/ViewCollection.vala"
						_tmp23_ = selected_removed;
#line 614 "../src/core/ViewCollection.vala"
						_tmp24_ = view;
#line 614 "../src/core/ViewCollection.vala"
						gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp24_);
#line 4306 "ViewCollection.c"
					}
				}
#line 618 "../src/core/ViewCollection.vala"
				_tmp26_ = view;
#line 618 "../src/core/ViewCollection.vala"
				if (data_view_is_visible (_tmp26_)) {
#line 4313 "ViewCollection.c"
					DataSet* _tmp27_;
#line 618 "../src/core/ViewCollection.vala"
					_tmp27_ = self->priv->visible;
#line 618 "../src/core/ViewCollection.vala"
					_tmp25_ = _tmp27_ != NULL;
#line 4319 "ViewCollection.c"
				} else {
#line 618 "../src/core/ViewCollection.vala"
					_tmp25_ = FALSE;
#line 4323 "ViewCollection.c"
				}
#line 618 "../src/core/ViewCollection.vala"
				if (_tmp25_) {
#line 4327 "ViewCollection.c"
					DataSet* _tmp28_;
					DataView* _tmp29_;
#line 619 "../src/core/ViewCollection.vala"
					_tmp28_ = self->priv->visible;
#line 619 "../src/core/ViewCollection.vala"
					_tmp29_ = view;
#line 619 "../src/core/ViewCollection.vala"
					is_removed = data_set_remove (_tmp28_, G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, TYPE_DATA_OBJECT, DataObject));
#line 620 "../src/core/ViewCollection.vala"
					_vala_assert (is_removed, "is_removed");
#line 4338 "ViewCollection.c"
				}
			}
#line 595 "../src/core/ViewCollection.vala"
			_g_object_unref0 (view);
#line 595 "../src/core/ViewCollection.vala"
			_g_object_unref0 (object);
#line 4345 "ViewCollection.c"
		}
#line 595 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_object_it);
#line 4349 "ViewCollection.c"
	}
#line 625 "../src/core/ViewCollection.vala"
	_tmp30_ = selected_removed;
#line 625 "../src/core/ViewCollection.vala"
	if (_tmp30_ != NULL) {
#line 4355 "ViewCollection.c"
		GeeArrayList* _tmp31_;
#line 626 "../src/core/ViewCollection.vala"
		_tmp31_ = selected_removed;
#line 626 "../src/core/ViewCollection.vala"
		view_collection_remove_many_selected (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, GEE_TYPE_COLLECTION, GeeCollection));
#line 631 "../src/core/ViewCollection.vala"
		view_collection_notify_selection_group_altered (self);
#line 4363 "ViewCollection.c"
	}
#line 634 "../src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->notify_items_removed (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), removed);
#line 593 "../src/core/ViewCollection.vala"
	_g_object_unref0 (selected_removed);
#line 4369 "ViewCollection.c"
}

static void
view_collection_filter_altered_items (ViewCollection* self,
                                      GeeCollection* views)
{
	GeeArrayList* to_show = NULL;
	GeeArrayList* to_hide = NULL;
	GeeArrayList* _tmp15_;
	GeeArrayList* _tmp17_;
#line 637 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 637 "../src/core/ViewCollection.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (views, GEE_TYPE_COLLECTION));
#line 640 "../src/core/ViewCollection.vala"
	to_show = NULL;
#line 641 "../src/core/ViewCollection.vala"
	to_hide = NULL;
#line 4388 "ViewCollection.c"
	{
		GeeIterator* _view_it = NULL;
		GeeIterator* _tmp0_;
#line 646 "../src/core/ViewCollection.vala"
		_tmp0_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (views, GEE_TYPE_ITERABLE, GeeIterable));
#line 646 "../src/core/ViewCollection.vala"
		_view_it = _tmp0_;
#line 646 "../src/core/ViewCollection.vala"
		while (TRUE) {
#line 4398 "ViewCollection.c"
			GeeIterator* _tmp1_;
			DataView* view = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			DataView* _tmp4_;
#line 646 "../src/core/ViewCollection.vala"
			_tmp1_ = _view_it;
#line 646 "../src/core/ViewCollection.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 646 "../src/core/ViewCollection.vala"
				break;
#line 4410 "ViewCollection.c"
			}
#line 646 "../src/core/ViewCollection.vala"
			_tmp2_ = _view_it;
#line 646 "../src/core/ViewCollection.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 646 "../src/core/ViewCollection.vala"
			view = (DataView*) _tmp3_;
#line 647 "../src/core/ViewCollection.vala"
			_tmp4_ = view;
#line 647 "../src/core/ViewCollection.vala"
			if (view_collection_is_in_filter (self, _tmp4_)) {
#line 4422 "ViewCollection.c"
				DataView* _tmp5_;
#line 648 "../src/core/ViewCollection.vala"
				_tmp5_ = view;
#line 648 "../src/core/ViewCollection.vala"
				if (!data_view_is_visible (_tmp5_)) {
#line 4428 "ViewCollection.c"
					GeeArrayList* _tmp6_;
					GeeArrayList* _tmp8_;
					DataView* _tmp9_;
#line 649 "../src/core/ViewCollection.vala"
					_tmp6_ = to_show;
#line 649 "../src/core/ViewCollection.vala"
					if (_tmp6_ == NULL) {
#line 4436 "ViewCollection.c"
						GeeArrayList* _tmp7_;
#line 650 "../src/core/ViewCollection.vala"
						_tmp7_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 650 "../src/core/ViewCollection.vala"
						_g_object_unref0 (to_show);
#line 650 "../src/core/ViewCollection.vala"
						to_show = _tmp7_;
#line 4444 "ViewCollection.c"
					}
#line 652 "../src/core/ViewCollection.vala"
					_tmp8_ = to_show;
#line 652 "../src/core/ViewCollection.vala"
					_tmp9_ = view;
#line 652 "../src/core/ViewCollection.vala"
					gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp9_);
#line 4452 "ViewCollection.c"
				}
			} else {
				DataView* _tmp10_;
#line 655 "../src/core/ViewCollection.vala"
				_tmp10_ = view;
#line 655 "../src/core/ViewCollection.vala"
				if (data_view_is_visible (_tmp10_)) {
#line 4460 "ViewCollection.c"
					GeeArrayList* _tmp11_;
					GeeArrayList* _tmp13_;
					DataView* _tmp14_;
#line 656 "../src/core/ViewCollection.vala"
					_tmp11_ = to_hide;
#line 656 "../src/core/ViewCollection.vala"
					if (_tmp11_ == NULL) {
#line 4468 "ViewCollection.c"
						GeeArrayList* _tmp12_;
#line 657 "../src/core/ViewCollection.vala"
						_tmp12_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 657 "../src/core/ViewCollection.vala"
						_g_object_unref0 (to_hide);
#line 657 "../src/core/ViewCollection.vala"
						to_hide = _tmp12_;
#line 4476 "ViewCollection.c"
					}
#line 659 "../src/core/ViewCollection.vala"
					_tmp13_ = to_hide;
#line 659 "../src/core/ViewCollection.vala"
					_tmp14_ = view;
#line 659 "../src/core/ViewCollection.vala"
					gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp14_);
#line 4484 "ViewCollection.c"
				}
			}
#line 646 "../src/core/ViewCollection.vala"
			_g_object_unref0 (view);
#line 4489 "ViewCollection.c"
		}
#line 646 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_view_it);
#line 4493 "ViewCollection.c"
	}
#line 668 "../src/core/ViewCollection.vala"
	_tmp15_ = to_show;
#line 668 "../src/core/ViewCollection.vala"
	if (_tmp15_ != NULL) {
#line 4499 "ViewCollection.c"
		GeeArrayList* _tmp16_;
#line 669 "../src/core/ViewCollection.vala"
		_tmp16_ = to_show;
#line 669 "../src/core/ViewCollection.vala"
		view_collection_show_items (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, GEE_TYPE_LIST, GeeList));
#line 4505 "ViewCollection.c"
	}
#line 671 "../src/core/ViewCollection.vala"
	_tmp17_ = to_hide;
#line 671 "../src/core/ViewCollection.vala"
	if (_tmp17_ != NULL) {
#line 4511 "ViewCollection.c"
		GeeArrayList* _tmp18_;
#line 672 "../src/core/ViewCollection.vala"
		_tmp18_ = to_hide;
#line 672 "../src/core/ViewCollection.vala"
		view_collection_hide_items (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, GEE_TYPE_LIST, GeeList));
#line 4517 "ViewCollection.c"
	}
#line 637 "../src/core/ViewCollection.vala"
	_g_object_unref0 (to_hide);
#line 637 "../src/core/ViewCollection.vala"
	_g_object_unref0 (to_show);
#line 4523 "ViewCollection.c"
}

static void
view_collection_real_items_altered (DataCollection* base,
                                    GeeMap* map)
{
	ViewCollection * self;
	GeeSet* _tmp0_;
	GeeSet* _tmp1_;
	GeeCollection* _tmp2_;
#line 675 "../src/core/ViewCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIEW_COLLECTION, ViewCollection);
#line 675 "../src/core/ViewCollection.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (map, GEE_TYPE_MAP));
#line 677 "../src/core/ViewCollection.vala"
	_tmp0_ = gee_map_get_keys (map);
#line 677 "../src/core/ViewCollection.vala"
	_tmp1_ = _tmp0_;
#line 677 "../src/core/ViewCollection.vala"
	_tmp2_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_COLLECTION, GeeCollection);
#line 677 "../src/core/ViewCollection.vala"
	view_collection_filter_altered_items (self, _tmp2_);
#line 677 "../src/core/ViewCollection.vala"
	_g_object_unref0 (_tmp2_);
#line 679 "../src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->items_altered (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), map);
#line 4550 "ViewCollection.c"
}

static void
view_collection_real_set_comparator (DataCollection* base,
                                     Comparator comparator,
                                     gpointer comparator_target,
                                     ComparatorPredicate predicate,
                                     gpointer predicate_target)
{
	ViewCollection * self;
	DataSet* _tmp0_;
	DataSet* _tmp1_;
#line 682 "../src/core/ViewCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIEW_COLLECTION, ViewCollection);
#line 683 "../src/core/ViewCollection.vala"
	_tmp0_ = self->priv->selected;
#line 683 "../src/core/ViewCollection.vala"
	data_set_set_comparator (_tmp0_, comparator, comparator_target, predicate, predicate_target);
#line 684 "../src/core/ViewCollection.vala"
	_tmp1_ = self->priv->visible;
#line 684 "../src/core/ViewCollection.vala"
	if (_tmp1_ != NULL) {
#line 4573 "ViewCollection.c"
		DataSet* _tmp2_;
#line 685 "../src/core/ViewCollection.vala"
		_tmp2_ = self->priv->visible;
#line 685 "../src/core/ViewCollection.vala"
		data_set_set_comparator (_tmp2_, comparator, comparator_target, predicate, predicate_target);
#line 4579 "ViewCollection.c"
	}
#line 687 "../src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->set_comparator (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), comparator, comparator_target, predicate, predicate_target);
#line 4583 "ViewCollection.c"
}

static void
view_collection_real_reset_comparator (DataCollection* base)
{
	ViewCollection * self;
	DataSet* _tmp0_;
	DataSet* _tmp1_;
#line 690 "../src/core/ViewCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIEW_COLLECTION, ViewCollection);
#line 691 "../src/core/ViewCollection.vala"
	_tmp0_ = self->priv->selected;
#line 691 "../src/core/ViewCollection.vala"
	data_set_reset_comparator (_tmp0_);
#line 692 "../src/core/ViewCollection.vala"
	_tmp1_ = self->priv->visible;
#line 692 "../src/core/ViewCollection.vala"
	if (_tmp1_ != NULL) {
#line 4602 "ViewCollection.c"
		DataSet* _tmp2_;
#line 693 "../src/core/ViewCollection.vala"
		_tmp2_ = self->priv->visible;
#line 693 "../src/core/ViewCollection.vala"
		data_set_reset_comparator (_tmp2_);
#line 4608 "ViewCollection.c"
	}
#line 695 "../src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->reset_comparator (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 4612 "ViewCollection.c"
}

static GeeCollection*
view_collection_real_get_all (DataCollection* base)
{
	ViewCollection * self;
	GeeCollection* _tmp0_ = NULL;
	DataSet* _tmp1_;
	GeeCollection* result;
#line 698 "../src/core/ViewCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIEW_COLLECTION, ViewCollection);
#line 699 "../src/core/ViewCollection.vala"
	_tmp1_ = self->priv->visible;
#line 699 "../src/core/ViewCollection.vala"
	if (_tmp1_ != NULL) {
#line 4628 "ViewCollection.c"
		DataSet* _tmp2_;
		GeeList* _tmp3_;
#line 699 "../src/core/ViewCollection.vala"
		_tmp2_ = self->priv->visible;
#line 699 "../src/core/ViewCollection.vala"
		_tmp3_ = data_set_get_all (_tmp2_);
#line 699 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp0_);
#line 699 "../src/core/ViewCollection.vala"
		_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_COLLECTION, GeeCollection);
#line 4639 "ViewCollection.c"
	} else {
		GeeCollection* _tmp4_;
#line 699 "../src/core/ViewCollection.vala"
		_tmp4_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_all (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 699 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp0_);
#line 699 "../src/core/ViewCollection.vala"
		_tmp0_ = _tmp4_;
#line 4648 "ViewCollection.c"
	}
#line 699 "../src/core/ViewCollection.vala"
	result = _tmp0_;
#line 699 "../src/core/ViewCollection.vala"
	return result;
#line 4654 "ViewCollection.c"
}

GeeCollection*
view_collection_get_all_unfiltered (ViewCollection* self)
{
	GeeCollection* _tmp0_;
	GeeCollection* result;
#line 702 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 703 "../src/core/ViewCollection.vala"
	_tmp0_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_all (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 703 "../src/core/ViewCollection.vala"
	result = _tmp0_;
#line 703 "../src/core/ViewCollection.vala"
	return result;
#line 4670 "ViewCollection.c"
}

static gint
view_collection_real_get_count (DataCollection* base)
{
	ViewCollection * self;
	gint _tmp0_ = 0;
	DataSet* _tmp1_;
	gint result;
#line 706 "../src/core/ViewCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIEW_COLLECTION, ViewCollection);
#line 707 "../src/core/ViewCollection.vala"
	_tmp1_ = self->priv->visible;
#line 707 "../src/core/ViewCollection.vala"
	if (_tmp1_ != NULL) {
#line 4686 "ViewCollection.c"
		DataSet* _tmp2_;
#line 707 "../src/core/ViewCollection.vala"
		_tmp2_ = self->priv->visible;
#line 707 "../src/core/ViewCollection.vala"
		_tmp0_ = data_set_get_count (_tmp2_);
#line 4692 "ViewCollection.c"
	} else {
#line 707 "../src/core/ViewCollection.vala"
		_tmp0_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_count (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 4696 "ViewCollection.c"
	}
#line 707 "../src/core/ViewCollection.vala"
	result = _tmp0_;
#line 707 "../src/core/ViewCollection.vala"
	return result;
#line 4702 "ViewCollection.c"
}

gint
view_collection_get_unfiltered_count (ViewCollection* self)
{
	gint result;
#line 710 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), 0);
#line 711 "../src/core/ViewCollection.vala"
	result = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_count (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 711 "../src/core/ViewCollection.vala"
	return result;
#line 4715 "ViewCollection.c"
}

static DataObject*
view_collection_real_get_at (DataCollection* base,
                             gint index)
{
	ViewCollection * self;
	DataObject* _tmp0_ = NULL;
	DataSet* _tmp1_;
	DataObject* result;
#line 714 "../src/core/ViewCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIEW_COLLECTION, ViewCollection);
#line 715 "../src/core/ViewCollection.vala"
	_tmp1_ = self->priv->visible;
#line 715 "../src/core/ViewCollection.vala"
	if (_tmp1_ != NULL) {
#line 4732 "ViewCollection.c"
		DataSet* _tmp2_;
		DataObject* _tmp3_;
#line 715 "../src/core/ViewCollection.vala"
		_tmp2_ = self->priv->visible;
#line 715 "../src/core/ViewCollection.vala"
		_tmp3_ = data_set_get_at (_tmp2_, index);
#line 715 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp0_);
#line 715 "../src/core/ViewCollection.vala"
		_tmp0_ = _tmp3_;
#line 4743 "ViewCollection.c"
	} else {
		DataObject* _tmp4_;
#line 715 "../src/core/ViewCollection.vala"
		_tmp4_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_at (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), index);
#line 715 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp0_);
#line 715 "../src/core/ViewCollection.vala"
		_tmp0_ = _tmp4_;
#line 4752 "ViewCollection.c"
	}
#line 715 "../src/core/ViewCollection.vala"
	result = _tmp0_;
#line 715 "../src/core/ViewCollection.vala"
	return result;
#line 4758 "ViewCollection.c"
}

static gint
view_collection_real_index_of (DataCollection* base,
                               DataObject* object)
{
	ViewCollection * self;
	gint _tmp0_ = 0;
	DataSet* _tmp1_;
	gint result;
#line 718 "../src/core/ViewCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIEW_COLLECTION, ViewCollection);
#line 718 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), 0);
#line 719 "../src/core/ViewCollection.vala"
	_tmp1_ = self->priv->visible;
#line 719 "../src/core/ViewCollection.vala"
	if (_tmp1_ != NULL) {
#line 4777 "ViewCollection.c"
		DataSet* _tmp2_;
#line 719 "../src/core/ViewCollection.vala"
		_tmp2_ = self->priv->visible;
#line 719 "../src/core/ViewCollection.vala"
		_tmp0_ = data_set_index_of (_tmp2_, object);
#line 4783 "ViewCollection.c"
	} else {
#line 719 "../src/core/ViewCollection.vala"
		_tmp0_ = DATA_COLLECTION_CLASS (view_collection_parent_class)->index_of (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), object);
#line 4787 "ViewCollection.c"
	}
#line 719 "../src/core/ViewCollection.vala"
	result = _tmp0_;
#line 719 "../src/core/ViewCollection.vala"
	return result;
#line 4793 "ViewCollection.c"
}

static gboolean
view_collection_real_contains (DataCollection* base,
                               DataObject* object)
{
	ViewCollection * self;
	gboolean result;
#line 722 "../src/core/ViewCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIEW_COLLECTION, ViewCollection);
#line 722 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 725 "../src/core/ViewCollection.vala"
	if (!DATA_COLLECTION_CLASS (view_collection_parent_class)->contains (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), object)) {
#line 726 "../src/core/ViewCollection.vala"
		result = FALSE;
#line 726 "../src/core/ViewCollection.vala"
		return result;
#line 4812 "ViewCollection.c"
	}
#line 729 "../src/core/ViewCollection.vala"
	result = view_collection_is_visible (self, G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DATA_VIEW, DataView));
#line 729 "../src/core/ViewCollection.vala"
	return result;
#line 4818 "ViewCollection.c"
}

static DataView*
view_collection_real_get_first (ViewCollection* self)
{
	DataView* _tmp0_ = NULL;
	DataView* result;
#line 733 "../src/core/ViewCollection.vala"
	if (data_collection_get_count (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection)) > 0) {
#line 4828 "ViewCollection.c"
		DataObject* _tmp1_;
#line 733 "../src/core/ViewCollection.vala"
		_tmp1_ = data_collection_get_at (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), 0);
#line 733 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp0_);
#line 733 "../src/core/ViewCollection.vala"
		_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_DATA_VIEW, DataView);
#line 4836 "ViewCollection.c"
	} else {
#line 733 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp0_);
#line 733 "../src/core/ViewCollection.vala"
		_tmp0_ = NULL;
#line 4842 "ViewCollection.c"
	}
#line 733 "../src/core/ViewCollection.vala"
	result = _tmp0_;
#line 733 "../src/core/ViewCollection.vala"
	return result;
#line 4848 "ViewCollection.c"
}

DataView*
view_collection_get_first (ViewCollection* self)
{
	ViewCollectionClass* _klass_;
#line 732 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 732 "../src/core/ViewCollection.vala"
	_klass_ = VIEW_COLLECTION_GET_CLASS (self);
#line 732 "../src/core/ViewCollection.vala"
	if (_klass_->get_first) {
#line 732 "../src/core/ViewCollection.vala"
		return _klass_->get_first (self);
#line 4863 "ViewCollection.c"
	}
#line 732 "../src/core/ViewCollection.vala"
	return NULL;
#line 4867 "ViewCollection.c"
}

/**
     * @brief A helper method for places in the app that need a
     *  non-rejected media source (namely Events, when looking to
     *  automatically choose a thumbnail).
     *
     * @note If every view in this collection is rejected, we
     *  return the first view; this is intentional.  This prevents
     *  pathological events that have nothing but rejected images
     *  in them from breaking.
     */
static DataView*
view_collection_real_get_first_unrejected (ViewCollection* self)
{
	DataView* dv = NULL;
	DataView* _tmp0_;
	gint num_views = 0;
	DataView* _tmp12_;
	DataView* result;
#line 748 "../src/core/ViewCollection.vala"
	if (data_collection_get_count (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection)) < 1) {
#line 749 "../src/core/ViewCollection.vala"
		result = NULL;
#line 749 "../src/core/ViewCollection.vala"
		return result;
#line 4894 "ViewCollection.c"
	}
#line 752 "../src/core/ViewCollection.vala"
	_tmp0_ = view_collection_get_first (self);
#line 752 "../src/core/ViewCollection.vala"
	dv = _tmp0_;
#line 753 "../src/core/ViewCollection.vala"
	num_views = data_collection_get_count (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 755 "../src/core/ViewCollection.vala"
	while (TRUE) {
#line 4904 "ViewCollection.c"
		gboolean _tmp1_ = FALSE;
		DataView* _tmp2_;
		MediaSource* tmp = NULL;
		DataView* _tmp4_;
		DataSource* _tmp5_;
		MediaSource* _tmp6_;
		gboolean _tmp7_ = FALSE;
		MediaSource* _tmp8_;
#line 755 "../src/core/ViewCollection.vala"
		_tmp2_ = dv;
#line 755 "../src/core/ViewCollection.vala"
		if (_tmp2_ != NULL) {
#line 4917 "ViewCollection.c"
			DataView* _tmp3_;
#line 755 "../src/core/ViewCollection.vala"
			_tmp3_ = dv;
#line 755 "../src/core/ViewCollection.vala"
			_tmp1_ = data_collection_index_of (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_DATA_OBJECT, DataObject)) < (num_views - 1);
#line 4923 "ViewCollection.c"
		} else {
#line 755 "../src/core/ViewCollection.vala"
			_tmp1_ = FALSE;
#line 4927 "ViewCollection.c"
		}
#line 755 "../src/core/ViewCollection.vala"
		if (!_tmp1_) {
#line 755 "../src/core/ViewCollection.vala"
			break;
#line 4933 "ViewCollection.c"
		}
#line 756 "../src/core/ViewCollection.vala"
		_tmp4_ = dv;
#line 756 "../src/core/ViewCollection.vala"
		_tmp5_ = data_view_get_source (_tmp4_);
#line 756 "../src/core/ViewCollection.vala"
		_tmp6_ = IS_MEDIA_SOURCE (_tmp5_) ? ((MediaSource*) _tmp5_) : NULL;
#line 756 "../src/core/ViewCollection.vala"
		if (_tmp6_ == NULL) {
#line 756 "../src/core/ViewCollection.vala"
			_g_object_unref0 (_tmp5_);
#line 4945 "ViewCollection.c"
		}
#line 756 "../src/core/ViewCollection.vala"
		tmp = _tmp6_;
#line 758 "../src/core/ViewCollection.vala"
		_tmp8_ = tmp;
#line 758 "../src/core/ViewCollection.vala"
		if (_tmp8_ != NULL) {
#line 4953 "ViewCollection.c"
			MediaSource* _tmp9_;
#line 758 "../src/core/ViewCollection.vala"
			_tmp9_ = tmp;
#line 758 "../src/core/ViewCollection.vala"
			_tmp7_ = media_source_get_rating (_tmp9_) != RATING_REJECTED;
#line 4959 "ViewCollection.c"
		} else {
#line 758 "../src/core/ViewCollection.vala"
			_tmp7_ = FALSE;
#line 4963 "ViewCollection.c"
		}
#line 758 "../src/core/ViewCollection.vala"
		if (_tmp7_) {
#line 760 "../src/core/ViewCollection.vala"
			result = dv;
#line 760 "../src/core/ViewCollection.vala"
			_g_object_unref0 (tmp);
#line 760 "../src/core/ViewCollection.vala"
			return result;
#line 4973 "ViewCollection.c"
		} else {
			DataView* _tmp10_;
			DataView* _tmp11_;
#line 762 "../src/core/ViewCollection.vala"
			_tmp10_ = dv;
#line 762 "../src/core/ViewCollection.vala"
			_tmp11_ = view_collection_get_next (self, _tmp10_, NULL);
#line 762 "../src/core/ViewCollection.vala"
			_g_object_unref0 (dv);
#line 762 "../src/core/ViewCollection.vala"
			dv = _tmp11_;
#line 4985 "ViewCollection.c"
		}
#line 755 "../src/core/ViewCollection.vala"
		_g_object_unref0 (tmp);
#line 4989 "ViewCollection.c"
	}
#line 768 "../src/core/ViewCollection.vala"
	_tmp12_ = view_collection_get_first (self);
#line 768 "../src/core/ViewCollection.vala"
	result = _tmp12_;
#line 768 "../src/core/ViewCollection.vala"
	_g_object_unref0 (dv);
#line 768 "../src/core/ViewCollection.vala"
	return result;
#line 4999 "ViewCollection.c"
}

DataView*
view_collection_get_first_unrejected (ViewCollection* self)
{
	ViewCollectionClass* _klass_;
#line 746 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 746 "../src/core/ViewCollection.vala"
	_klass_ = VIEW_COLLECTION_GET_CLASS (self);
#line 746 "../src/core/ViewCollection.vala"
	if (_klass_->get_first_unrejected) {
#line 746 "../src/core/ViewCollection.vala"
		return _klass_->get_first_unrejected (self);
#line 5014 "ViewCollection.c"
	}
#line 746 "../src/core/ViewCollection.vala"
	return NULL;
#line 5018 "ViewCollection.c"
}

static DataView*
view_collection_real_get_first_photo (ViewCollection* self)
{
	DataView* dv = NULL;
	DataView* _tmp0_;
	gint num_views = 0;
	DataView* result;
#line 772 "../src/core/ViewCollection.vala"
	if (data_collection_get_count (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection)) < 1) {
#line 773 "../src/core/ViewCollection.vala"
		result = NULL;
#line 773 "../src/core/ViewCollection.vala"
		return result;
#line 5034 "ViewCollection.c"
	}
#line 775 "../src/core/ViewCollection.vala"
	_tmp0_ = view_collection_get_first (self);
#line 775 "../src/core/ViewCollection.vala"
	dv = _tmp0_;
#line 776 "../src/core/ViewCollection.vala"
	num_views = data_collection_get_count (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 778 "../src/core/ViewCollection.vala"
	while (TRUE) {
#line 5044 "ViewCollection.c"
		gboolean _tmp1_ = FALSE;
		DataView* _tmp2_;
		DataView* _tmp4_;
		DataSource* _tmp5_;
		DataSource* _tmp6_;
		gboolean _tmp7_;
#line 778 "../src/core/ViewCollection.vala"
		_tmp2_ = dv;
#line 778 "../src/core/ViewCollection.vala"
		if (_tmp2_ != NULL) {
#line 5055 "ViewCollection.c"
			DataView* _tmp3_;
#line 778 "../src/core/ViewCollection.vala"
			_tmp3_ = dv;
#line 778 "../src/core/ViewCollection.vala"
			_tmp1_ = data_collection_index_of (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_DATA_OBJECT, DataObject)) < num_views;
#line 5061 "ViewCollection.c"
		} else {
#line 778 "../src/core/ViewCollection.vala"
			_tmp1_ = FALSE;
#line 5065 "ViewCollection.c"
		}
#line 778 "../src/core/ViewCollection.vala"
		if (!_tmp1_) {
#line 778 "../src/core/ViewCollection.vala"
			break;
#line 5071 "ViewCollection.c"
		}
#line 779 "../src/core/ViewCollection.vala"
		_tmp4_ = dv;
#line 779 "../src/core/ViewCollection.vala"
		_tmp5_ = data_view_get_source (_tmp4_);
#line 779 "../src/core/ViewCollection.vala"
		_tmp6_ = _tmp5_;
#line 779 "../src/core/ViewCollection.vala"
		_tmp7_ = IS_PHOTO_SOURCE (_tmp6_);
#line 779 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp6_);
#line 779 "../src/core/ViewCollection.vala"
		if (_tmp7_) {
#line 780 "../src/core/ViewCollection.vala"
			result = dv;
#line 780 "../src/core/ViewCollection.vala"
			return result;
#line 5089 "ViewCollection.c"
		} else {
			DataView* _tmp8_;
			DataView* _tmp9_;
#line 782 "../src/core/ViewCollection.vala"
			_tmp8_ = dv;
#line 782 "../src/core/ViewCollection.vala"
			_tmp9_ = view_collection_get_next (self, _tmp8_, NULL);
#line 782 "../src/core/ViewCollection.vala"
			_g_object_unref0 (dv);
#line 782 "../src/core/ViewCollection.vala"
			dv = _tmp9_;
#line 5101 "ViewCollection.c"
		}
	}
#line 785 "../src/core/ViewCollection.vala"
	result = NULL;
#line 785 "../src/core/ViewCollection.vala"
	_g_object_unref0 (dv);
#line 785 "../src/core/ViewCollection.vala"
	return result;
#line 5110 "ViewCollection.c"
}

DataView*
view_collection_get_first_photo (ViewCollection* self)
{
	ViewCollectionClass* _klass_;
#line 771 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 771 "../src/core/ViewCollection.vala"
	_klass_ = VIEW_COLLECTION_GET_CLASS (self);
#line 771 "../src/core/ViewCollection.vala"
	if (_klass_->get_first_photo) {
#line 771 "../src/core/ViewCollection.vala"
		return _klass_->get_first_photo (self);
#line 5125 "ViewCollection.c"
	}
#line 771 "../src/core/ViewCollection.vala"
	return NULL;
#line 5129 "ViewCollection.c"
}

static DataView*
view_collection_real_get_last (ViewCollection* self)
{
	DataView* _tmp0_ = NULL;
	DataView* result;
#line 789 "../src/core/ViewCollection.vala"
	if (data_collection_get_count (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection)) > 0) {
#line 5139 "ViewCollection.c"
		DataObject* _tmp1_;
#line 789 "../src/core/ViewCollection.vala"
		_tmp1_ = data_collection_get_at (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), data_collection_get_count (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection)) - 1);
#line 789 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp0_);
#line 789 "../src/core/ViewCollection.vala"
		_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_DATA_VIEW, DataView);
#line 5147 "ViewCollection.c"
	} else {
#line 789 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp0_);
#line 789 "../src/core/ViewCollection.vala"
		_tmp0_ = NULL;
#line 5153 "ViewCollection.c"
	}
#line 789 "../src/core/ViewCollection.vala"
	result = _tmp0_;
#line 789 "../src/core/ViewCollection.vala"
	return result;
#line 5159 "ViewCollection.c"
}

DataView*
view_collection_get_last (ViewCollection* self)
{
	ViewCollectionClass* _klass_;
#line 788 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 788 "../src/core/ViewCollection.vala"
	_klass_ = VIEW_COLLECTION_GET_CLASS (self);
#line 788 "../src/core/ViewCollection.vala"
	if (_klass_->get_last) {
#line 788 "../src/core/ViewCollection.vala"
		return _klass_->get_last (self);
#line 5174 "ViewCollection.c"
	}
#line 788 "../src/core/ViewCollection.vala"
	return NULL;
#line 5178 "ViewCollection.c"
}

static gboolean*
_bool_dup (gboolean* self)
{
	gboolean* dup;
#line 793 "../src/core/ViewCollection.vala"
	dup = g_new0 (gboolean, 1);
#line 793 "../src/core/ViewCollection.vala"
	memcpy (dup, self, sizeof (gboolean));
#line 793 "../src/core/ViewCollection.vala"
	return dup;
#line 5191 "ViewCollection.c"
}

static gpointer
__bool_dup0 (gpointer self)
{
#line 793 "../src/core/ViewCollection.vala"
	return self ? _bool_dup (self) : NULL;
#line 5199 "ViewCollection.c"
}

static DataView*
view_collection_real_get_next (ViewCollection* self,
                               DataView* view,
                               gboolean** wrapped)
{
	gboolean* _vala_wrapped = NULL;
	gboolean _tmp0_;
	gboolean* _tmp1_;
	gint index = 0;
	gint _tmp2_;
	DataObject* _tmp5_;
	DataView* result;
#line 792 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_VIEW (view), NULL);
#line 793 "../src/core/ViewCollection.vala"
	_tmp0_ = FALSE;
#line 793 "../src/core/ViewCollection.vala"
	_tmp1_ = __bool_dup0 (&_tmp0_);
#line 793 "../src/core/ViewCollection.vala"
	_g_free0 (_vala_wrapped);
#line 793 "../src/core/ViewCollection.vala"
	_vala_wrapped = _tmp1_;
#line 794 "../src/core/ViewCollection.vala"
	if (data_collection_get_count (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection)) == 0) {
#line 795 "../src/core/ViewCollection.vala"
		result = NULL;
#line 795 "../src/core/ViewCollection.vala"
		if (wrapped) {
#line 795 "../src/core/ViewCollection.vala"
			*wrapped = _vala_wrapped;
#line 5232 "ViewCollection.c"
		} else {
#line 795 "../src/core/ViewCollection.vala"
			_g_free0 (_vala_wrapped);
#line 5236 "ViewCollection.c"
		}
#line 795 "../src/core/ViewCollection.vala"
		return result;
#line 5240 "ViewCollection.c"
	}
#line 797 "../src/core/ViewCollection.vala"
	index = data_collection_index_of (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), G_TYPE_CHECK_INSTANCE_CAST (view, TYPE_DATA_OBJECT, DataObject));
#line 798 "../src/core/ViewCollection.vala"
	if (index < 0) {
#line 799 "../src/core/ViewCollection.vala"
		result = NULL;
#line 799 "../src/core/ViewCollection.vala"
		if (wrapped) {
#line 799 "../src/core/ViewCollection.vala"
			*wrapped = _vala_wrapped;
#line 5252 "ViewCollection.c"
		} else {
#line 799 "../src/core/ViewCollection.vala"
			_g_free0 (_vala_wrapped);
#line 5256 "ViewCollection.c"
		}
#line 799 "../src/core/ViewCollection.vala"
		return result;
#line 5260 "ViewCollection.c"
	}
#line 801 "../src/core/ViewCollection.vala"
	_tmp2_ = index;
#line 801 "../src/core/ViewCollection.vala"
	index = _tmp2_ + 1;
#line 802 "../src/core/ViewCollection.vala"
	if (index >= data_collection_get_count (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection))) {
#line 5268 "ViewCollection.c"
		gboolean _tmp3_;
		gboolean* _tmp4_;
#line 803 "../src/core/ViewCollection.vala"
		index = 0;
#line 804 "../src/core/ViewCollection.vala"
		_tmp3_ = TRUE;
#line 804 "../src/core/ViewCollection.vala"
		_tmp4_ = __bool_dup0 (&_tmp3_);
#line 804 "../src/core/ViewCollection.vala"
		_g_free0 (_vala_wrapped);
#line 804 "../src/core/ViewCollection.vala"
		_vala_wrapped = _tmp4_;
#line 5281 "ViewCollection.c"
	}
#line 807 "../src/core/ViewCollection.vala"
	_tmp5_ = data_collection_get_at (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), index);
#line 807 "../src/core/ViewCollection.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_DATA_VIEW, DataView);
#line 807 "../src/core/ViewCollection.vala"
	if (wrapped) {
#line 807 "../src/core/ViewCollection.vala"
		*wrapped = _vala_wrapped;
#line 5291 "ViewCollection.c"
	} else {
#line 807 "../src/core/ViewCollection.vala"
		_g_free0 (_vala_wrapped);
#line 5295 "ViewCollection.c"
	}
#line 807 "../src/core/ViewCollection.vala"
	return result;
#line 5299 "ViewCollection.c"
}

DataView*
view_collection_get_next (ViewCollection* self,
                          DataView* view,
                          gboolean** wrapped)
{
	ViewCollectionClass* _klass_;
#line 792 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 792 "../src/core/ViewCollection.vala"
	_klass_ = VIEW_COLLECTION_GET_CLASS (self);
#line 792 "../src/core/ViewCollection.vala"
	if (_klass_->get_next) {
#line 792 "../src/core/ViewCollection.vala"
		return _klass_->get_next (self, view, wrapped);
#line 5316 "ViewCollection.c"
	}
#line 792 "../src/core/ViewCollection.vala"
	return NULL;
#line 5320 "ViewCollection.c"
}

static DataView*
view_collection_real_get_previous (ViewCollection* self,
                                   DataView* view)
{
	gint index = 0;
	gint _tmp0_;
	DataObject* _tmp1_;
	DataView* result;
#line 810 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_VIEW (view), NULL);
#line 811 "../src/core/ViewCollection.vala"
	if (data_collection_get_count (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection)) == 0) {
#line 812 "../src/core/ViewCollection.vala"
		result = NULL;
#line 812 "../src/core/ViewCollection.vala"
		return result;
#line 5339 "ViewCollection.c"
	}
#line 814 "../src/core/ViewCollection.vala"
	index = data_collection_index_of (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), G_TYPE_CHECK_INSTANCE_CAST (view, TYPE_DATA_OBJECT, DataObject));
#line 815 "../src/core/ViewCollection.vala"
	if (index < 0) {
#line 816 "../src/core/ViewCollection.vala"
		result = NULL;
#line 816 "../src/core/ViewCollection.vala"
		return result;
#line 5349 "ViewCollection.c"
	}
#line 818 "../src/core/ViewCollection.vala"
	_tmp0_ = index;
#line 818 "../src/core/ViewCollection.vala"
	index = _tmp0_ - 1;
#line 819 "../src/core/ViewCollection.vala"
	if (index < 0) {
#line 820 "../src/core/ViewCollection.vala"
		index = data_collection_get_count (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection)) - 1;
#line 5359 "ViewCollection.c"
	}
#line 822 "../src/core/ViewCollection.vala"
	_tmp1_ = data_collection_get_at (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), index);
#line 822 "../src/core/ViewCollection.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_DATA_VIEW, DataView);
#line 822 "../src/core/ViewCollection.vala"
	return result;
#line 5367 "ViewCollection.c"
}

DataView*
view_collection_get_previous (ViewCollection* self,
                              DataView* view)
{
	ViewCollectionClass* _klass_;
#line 810 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 810 "../src/core/ViewCollection.vala"
	_klass_ = VIEW_COLLECTION_GET_CLASS (self);
#line 810 "../src/core/ViewCollection.vala"
	if (_klass_->get_previous) {
#line 810 "../src/core/ViewCollection.vala"
		return _klass_->get_previous (self, view);
#line 5383 "ViewCollection.c"
	}
#line 810 "../src/core/ViewCollection.vala"
	return NULL;
#line 5387 "ViewCollection.c"
}

gboolean
view_collection_get_immediate_neighbors (ViewCollection* self,
                                         DataSource* home,
                                         DataSource** next,
                                         DataSource** prev,
                                         const gchar* type_selector)
{
	DataSource* _vala_next = NULL;
	DataSource* _vala_prev = NULL;
	DataView* home_view = NULL;
	DataView* _tmp0_;
	DataView* _tmp1_;
	DataView* next_view = NULL;
	DataView* _tmp2_;
	DataView* _tmp3_;
	DataView* prev_view = NULL;
	DataView* _tmp16_;
	DataView* _tmp17_;
	gboolean result;
#line 825 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 825 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (home), FALSE);
#line 827 "../src/core/ViewCollection.vala"
	_g_object_unref0 (_vala_next);
#line 827 "../src/core/ViewCollection.vala"
	_vala_next = NULL;
#line 828 "../src/core/ViewCollection.vala"
	_g_object_unref0 (_vala_prev);
#line 828 "../src/core/ViewCollection.vala"
	_vala_prev = NULL;
#line 830 "../src/core/ViewCollection.vala"
	_tmp0_ = view_collection_get_view_for_source (self, home);
#line 830 "../src/core/ViewCollection.vala"
	home_view = _tmp0_;
#line 831 "../src/core/ViewCollection.vala"
	_tmp1_ = home_view;
#line 831 "../src/core/ViewCollection.vala"
	if (_tmp1_ == NULL) {
#line 832 "../src/core/ViewCollection.vala"
		result = FALSE;
#line 832 "../src/core/ViewCollection.vala"
		_g_object_unref0 (home_view);
#line 832 "../src/core/ViewCollection.vala"
		if (next) {
#line 832 "../src/core/ViewCollection.vala"
			*next = _vala_next;
#line 5437 "ViewCollection.c"
		} else {
#line 832 "../src/core/ViewCollection.vala"
			_g_object_unref0 (_vala_next);
#line 5441 "ViewCollection.c"
		}
#line 832 "../src/core/ViewCollection.vala"
		if (prev) {
#line 832 "../src/core/ViewCollection.vala"
			*prev = _vala_prev;
#line 5447 "ViewCollection.c"
		} else {
#line 832 "../src/core/ViewCollection.vala"
			_g_object_unref0 (_vala_prev);
#line 5451 "ViewCollection.c"
		}
#line 832 "../src/core/ViewCollection.vala"
		return result;
#line 5455 "ViewCollection.c"
	}
#line 834 "../src/core/ViewCollection.vala"
	_tmp2_ = home_view;
#line 834 "../src/core/ViewCollection.vala"
	_tmp3_ = view_collection_get_next (self, _tmp2_, NULL);
#line 834 "../src/core/ViewCollection.vala"
	next_view = _tmp3_;
#line 835 "../src/core/ViewCollection.vala"
	while (TRUE) {
#line 5465 "ViewCollection.c"
		DataView* _tmp4_;
		DataView* _tmp5_;
		gboolean _tmp6_ = FALSE;
		DataView* _tmp14_;
		DataView* _tmp15_;
#line 835 "../src/core/ViewCollection.vala"
		_tmp4_ = next_view;
#line 835 "../src/core/ViewCollection.vala"
		_tmp5_ = home_view;
#line 835 "../src/core/ViewCollection.vala"
		if (!(_tmp4_ != _tmp5_)) {
#line 835 "../src/core/ViewCollection.vala"
			break;
#line 5479 "ViewCollection.c"
		}
#line 836 "../src/core/ViewCollection.vala"
		if (type_selector == NULL) {
#line 836 "../src/core/ViewCollection.vala"
			_tmp6_ = TRUE;
#line 5485 "ViewCollection.c"
		} else {
			DataView* _tmp7_;
			DataSource* _tmp8_;
			DataSource* _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
#line 836 "../src/core/ViewCollection.vala"
			_tmp7_ = next_view;
#line 836 "../src/core/ViewCollection.vala"
			_tmp8_ = data_view_get_source (_tmp7_);
#line 836 "../src/core/ViewCollection.vala"
			_tmp9_ = _tmp8_;
#line 836 "../src/core/ViewCollection.vala"
			_tmp10_ = data_source_get_typename (_tmp9_);
#line 836 "../src/core/ViewCollection.vala"
			_tmp11_ = _tmp10_;
#line 836 "../src/core/ViewCollection.vala"
			_tmp6_ = g_strcmp0 (_tmp11_, type_selector) == 0;
#line 836 "../src/core/ViewCollection.vala"
			_g_free0 (_tmp11_);
#line 836 "../src/core/ViewCollection.vala"
			_g_object_unref0 (_tmp9_);
#line 5508 "ViewCollection.c"
		}
#line 836 "../src/core/ViewCollection.vala"
		if (_tmp6_) {
#line 5512 "ViewCollection.c"
			DataView* _tmp12_;
			DataSource* _tmp13_;
#line 837 "../src/core/ViewCollection.vala"
			_tmp12_ = next_view;
#line 837 "../src/core/ViewCollection.vala"
			_tmp13_ = data_view_get_source (_tmp12_);
#line 837 "../src/core/ViewCollection.vala"
			_g_object_unref0 (_vala_next);
#line 837 "../src/core/ViewCollection.vala"
			_vala_next = _tmp13_;
#line 838 "../src/core/ViewCollection.vala"
			break;
#line 5525 "ViewCollection.c"
		}
#line 840 "../src/core/ViewCollection.vala"
		_tmp14_ = next_view;
#line 840 "../src/core/ViewCollection.vala"
		_tmp15_ = view_collection_get_next (self, _tmp14_, NULL);
#line 840 "../src/core/ViewCollection.vala"
		_g_object_unref0 (next_view);
#line 840 "../src/core/ViewCollection.vala"
		next_view = _tmp15_;
#line 5535 "ViewCollection.c"
	}
#line 843 "../src/core/ViewCollection.vala"
	_tmp16_ = home_view;
#line 843 "../src/core/ViewCollection.vala"
	_tmp17_ = view_collection_get_previous (self, _tmp16_);
#line 843 "../src/core/ViewCollection.vala"
	prev_view = _tmp17_;
#line 844 "../src/core/ViewCollection.vala"
	while (TRUE) {
#line 5545 "ViewCollection.c"
		DataView* _tmp18_;
		DataView* _tmp19_;
		gboolean _tmp20_ = FALSE;
		DataView* _tmp28_;
		DataView* _tmp29_;
#line 844 "../src/core/ViewCollection.vala"
		_tmp18_ = prev_view;
#line 844 "../src/core/ViewCollection.vala"
		_tmp19_ = home_view;
#line 844 "../src/core/ViewCollection.vala"
		if (!(_tmp18_ != _tmp19_)) {
#line 844 "../src/core/ViewCollection.vala"
			break;
#line 5559 "ViewCollection.c"
		}
#line 845 "../src/core/ViewCollection.vala"
		if (type_selector == NULL) {
#line 845 "../src/core/ViewCollection.vala"
			_tmp20_ = TRUE;
#line 5565 "ViewCollection.c"
		} else {
			DataView* _tmp21_;
			DataSource* _tmp22_;
			DataSource* _tmp23_;
			gchar* _tmp24_;
			gchar* _tmp25_;
#line 845 "../src/core/ViewCollection.vala"
			_tmp21_ = prev_view;
#line 845 "../src/core/ViewCollection.vala"
			_tmp22_ = data_view_get_source (_tmp21_);
#line 845 "../src/core/ViewCollection.vala"
			_tmp23_ = _tmp22_;
#line 845 "../src/core/ViewCollection.vala"
			_tmp24_ = data_source_get_typename (_tmp23_);
#line 845 "../src/core/ViewCollection.vala"
			_tmp25_ = _tmp24_;
#line 845 "../src/core/ViewCollection.vala"
			_tmp20_ = g_strcmp0 (_tmp25_, type_selector) == 0;
#line 845 "../src/core/ViewCollection.vala"
			_g_free0 (_tmp25_);
#line 845 "../src/core/ViewCollection.vala"
			_g_object_unref0 (_tmp23_);
#line 5588 "ViewCollection.c"
		}
#line 845 "../src/core/ViewCollection.vala"
		if (_tmp20_) {
#line 5592 "ViewCollection.c"
			DataView* _tmp26_;
			DataSource* _tmp27_;
#line 846 "../src/core/ViewCollection.vala"
			_tmp26_ = prev_view;
#line 846 "../src/core/ViewCollection.vala"
			_tmp27_ = data_view_get_source (_tmp26_);
#line 846 "../src/core/ViewCollection.vala"
			_g_object_unref0 (_vala_prev);
#line 846 "../src/core/ViewCollection.vala"
			_vala_prev = _tmp27_;
#line 847 "../src/core/ViewCollection.vala"
			break;
#line 5605 "ViewCollection.c"
		}
#line 849 "../src/core/ViewCollection.vala"
		_tmp28_ = prev_view;
#line 849 "../src/core/ViewCollection.vala"
		_tmp29_ = view_collection_get_previous (self, _tmp28_);
#line 849 "../src/core/ViewCollection.vala"
		_g_object_unref0 (prev_view);
#line 849 "../src/core/ViewCollection.vala"
		prev_view = _tmp29_;
#line 5615 "ViewCollection.c"
	}
#line 852 "../src/core/ViewCollection.vala"
	result = TRUE;
#line 852 "../src/core/ViewCollection.vala"
	_g_object_unref0 (prev_view);
#line 852 "../src/core/ViewCollection.vala"
	_g_object_unref0 (next_view);
#line 852 "../src/core/ViewCollection.vala"
	_g_object_unref0 (home_view);
#line 852 "../src/core/ViewCollection.vala"
	if (next) {
#line 852 "../src/core/ViewCollection.vala"
		*next = _vala_next;
#line 5629 "ViewCollection.c"
	} else {
#line 852 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_vala_next);
#line 5633 "ViewCollection.c"
	}
#line 852 "../src/core/ViewCollection.vala"
	if (prev) {
#line 852 "../src/core/ViewCollection.vala"
		*prev = _vala_prev;
#line 5639 "ViewCollection.c"
	} else {
#line 852 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_vala_prev);
#line 5643 "ViewCollection.c"
	}
#line 852 "../src/core/ViewCollection.vala"
	return result;
#line 5647 "ViewCollection.c"
}

GeeSet*
view_collection_get_extended_neighbors (ViewCollection* self,
                                        DataSource* home,
                                        const gchar* typename)
{
	GeeSet* neighbors = NULL;
	GeeHashSet* _tmp0_;
	DataSource* next = NULL;
	DataSource* prev = NULL;
	DataSource* _tmp1_ = NULL;
	DataSource* _tmp2_ = NULL;
	gboolean _tmp3_;
	DataSource* _tmp4_;
	DataSource* _tmp13_;
	GeeSet* _tmp22_;
	GeeSet* result;
#line 856 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 856 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (home), NULL);
#line 858 "../src/core/ViewCollection.vala"
	_tmp0_ = gee_hash_set_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 858 "../src/core/ViewCollection.vala"
	neighbors = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_SET, GeeSet);
#line 862 "../src/core/ViewCollection.vala"
	_tmp3_ = view_collection_get_immediate_neighbors (self, home, &_tmp1_, &_tmp2_, typename);
#line 862 "../src/core/ViewCollection.vala"
	_g_object_unref0 (next);
#line 862 "../src/core/ViewCollection.vala"
	next = _tmp1_;
#line 862 "../src/core/ViewCollection.vala"
	_g_object_unref0 (prev);
#line 862 "../src/core/ViewCollection.vala"
	prev = _tmp2_;
#line 862 "../src/core/ViewCollection.vala"
	if (!_tmp3_) {
#line 863 "../src/core/ViewCollection.vala"
		result = neighbors;
#line 863 "../src/core/ViewCollection.vala"
		_g_object_unref0 (prev);
#line 863 "../src/core/ViewCollection.vala"
		_g_object_unref0 (next);
#line 863 "../src/core/ViewCollection.vala"
		return result;
#line 5694 "ViewCollection.c"
	}
#line 866 "../src/core/ViewCollection.vala"
	_tmp4_ = next;
#line 866 "../src/core/ViewCollection.vala"
	if (_tmp4_ != NULL) {
#line 5700 "ViewCollection.c"
		GeeSet* _tmp5_;
		DataSource* _tmp6_;
		DataSource* next_next = NULL;
		DataSource* next_prev = NULL;
		DataSource* _tmp7_;
		DataSource* _tmp8_ = NULL;
		DataSource* _tmp9_ = NULL;
		DataSource* _tmp10_;
#line 867 "../src/core/ViewCollection.vala"
		_tmp5_ = neighbors;
#line 867 "../src/core/ViewCollection.vala"
		_tmp6_ = next;
#line 867 "../src/core/ViewCollection.vala"
		gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_COLLECTION, GeeCollection), _tmp6_);
#line 870 "../src/core/ViewCollection.vala"
		_tmp7_ = next;
#line 870 "../src/core/ViewCollection.vala"
		view_collection_get_immediate_neighbors (self, _tmp7_, &_tmp8_, &_tmp9_, typename);
#line 870 "../src/core/ViewCollection.vala"
		_g_object_unref0 (next_next);
#line 870 "../src/core/ViewCollection.vala"
		next_next = _tmp8_;
#line 870 "../src/core/ViewCollection.vala"
		_g_object_unref0 (next_prev);
#line 870 "../src/core/ViewCollection.vala"
		next_prev = _tmp9_;
#line 873 "../src/core/ViewCollection.vala"
		_tmp10_ = next_next;
#line 873 "../src/core/ViewCollection.vala"
		if (_tmp10_ != NULL) {
#line 5731 "ViewCollection.c"
			GeeSet* _tmp11_;
			DataSource* _tmp12_;
#line 874 "../src/core/ViewCollection.vala"
			_tmp11_ = neighbors;
#line 874 "../src/core/ViewCollection.vala"
			_tmp12_ = next_next;
#line 874 "../src/core/ViewCollection.vala"
			gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, GEE_TYPE_COLLECTION, GeeCollection), _tmp12_);
#line 5740 "ViewCollection.c"
		}
#line 866 "../src/core/ViewCollection.vala"
		_g_object_unref0 (next_prev);
#line 866 "../src/core/ViewCollection.vala"
		_g_object_unref0 (next_next);
#line 5746 "ViewCollection.c"
	}
#line 878 "../src/core/ViewCollection.vala"
	_tmp13_ = prev;
#line 878 "../src/core/ViewCollection.vala"
	if (_tmp13_ != NULL) {
#line 5752 "ViewCollection.c"
		GeeSet* _tmp14_;
		DataSource* _tmp15_;
		DataSource* next_prev = NULL;
		DataSource* prev_prev = NULL;
		DataSource* _tmp16_;
		DataSource* _tmp17_ = NULL;
		DataSource* _tmp18_ = NULL;
		DataSource* _tmp19_;
#line 879 "../src/core/ViewCollection.vala"
		_tmp14_ = neighbors;
#line 879 "../src/core/ViewCollection.vala"
		_tmp15_ = prev;
#line 879 "../src/core/ViewCollection.vala"
		gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, GEE_TYPE_COLLECTION, GeeCollection), _tmp15_);
#line 882 "../src/core/ViewCollection.vala"
		_tmp16_ = prev;
#line 882 "../src/core/ViewCollection.vala"
		view_collection_get_immediate_neighbors (self, _tmp16_, &_tmp17_, &_tmp18_, typename);
#line 882 "../src/core/ViewCollection.vala"
		_g_object_unref0 (next_prev);
#line 882 "../src/core/ViewCollection.vala"
		next_prev = _tmp17_;
#line 882 "../src/core/ViewCollection.vala"
		_g_object_unref0 (prev_prev);
#line 882 "../src/core/ViewCollection.vala"
		prev_prev = _tmp18_;
#line 885 "../src/core/ViewCollection.vala"
		_tmp19_ = prev_prev;
#line 885 "../src/core/ViewCollection.vala"
		if (_tmp19_ != NULL) {
#line 5783 "ViewCollection.c"
			GeeSet* _tmp20_;
			DataSource* _tmp21_;
#line 886 "../src/core/ViewCollection.vala"
			_tmp20_ = neighbors;
#line 886 "../src/core/ViewCollection.vala"
			_tmp21_ = prev_prev;
#line 886 "../src/core/ViewCollection.vala"
			gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, GEE_TYPE_COLLECTION, GeeCollection), _tmp21_);
#line 5792 "ViewCollection.c"
		}
#line 878 "../src/core/ViewCollection.vala"
		_g_object_unref0 (prev_prev);
#line 878 "../src/core/ViewCollection.vala"
		_g_object_unref0 (next_prev);
#line 5798 "ViewCollection.c"
	}
#line 890 "../src/core/ViewCollection.vala"
	_tmp22_ = neighbors;
#line 890 "../src/core/ViewCollection.vala"
	gee_collection_remove (G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, GEE_TYPE_COLLECTION, GeeCollection), home);
#line 892 "../src/core/ViewCollection.vala"
	result = neighbors;
#line 892 "../src/core/ViewCollection.vala"
	_g_object_unref0 (prev);
#line 892 "../src/core/ViewCollection.vala"
	_g_object_unref0 (next);
#line 892 "../src/core/ViewCollection.vala"
	return result;
#line 5812 "ViewCollection.c"
}

static void
view_collection_add_many_selected (ViewCollection* self,
                                   GeeCollection* views)
{
	gint _tmp0_;
	gint _tmp1_;
	gboolean added = FALSE;
	DataSet* _tmp7_;
#line 897 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 897 "../src/core/ViewCollection.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (views, GEE_TYPE_COLLECTION));
#line 898 "../src/core/ViewCollection.vala"
	_tmp0_ = gee_collection_get_size (views);
#line 898 "../src/core/ViewCollection.vala"
	_tmp1_ = _tmp0_;
#line 898 "../src/core/ViewCollection.vala"
	if (_tmp1_ == 0) {
#line 899 "../src/core/ViewCollection.vala"
		return;
#line 5835 "ViewCollection.c"
	}
	{
		GeeIterator* _view_it = NULL;
		GeeIterator* _tmp2_;
#line 901 "../src/core/ViewCollection.vala"
		_tmp2_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (views, GEE_TYPE_ITERABLE, GeeIterable));
#line 901 "../src/core/ViewCollection.vala"
		_view_it = _tmp2_;
#line 901 "../src/core/ViewCollection.vala"
		while (TRUE) {
#line 5846 "ViewCollection.c"
			GeeIterator* _tmp3_;
			DataView* view = NULL;
			GeeIterator* _tmp4_;
			gpointer _tmp5_;
			DataView* _tmp6_;
#line 901 "../src/core/ViewCollection.vala"
			_tmp3_ = _view_it;
#line 901 "../src/core/ViewCollection.vala"
			if (!gee_iterator_next (_tmp3_)) {
#line 901 "../src/core/ViewCollection.vala"
				break;
#line 5858 "ViewCollection.c"
			}
#line 901 "../src/core/ViewCollection.vala"
			_tmp4_ = _view_it;
#line 901 "../src/core/ViewCollection.vala"
			_tmp5_ = gee_iterator_get (_tmp4_);
#line 901 "../src/core/ViewCollection.vala"
			view = (DataView*) _tmp5_;
#line 902 "../src/core/ViewCollection.vala"
			_tmp6_ = view;
#line 902 "../src/core/ViewCollection.vala"
			_vala_assert (data_view_is_visible (_tmp6_), "view.is_visible()");
#line 901 "../src/core/ViewCollection.vala"
			_g_object_unref0 (view);
#line 5872 "ViewCollection.c"
		}
#line 901 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_view_it);
#line 5876 "ViewCollection.c"
	}
#line 904 "../src/core/ViewCollection.vala"
	_tmp7_ = self->priv->selected;
#line 904 "../src/core/ViewCollection.vala"
	added = data_set_add_many (_tmp7_, views);
#line 905 "../src/core/ViewCollection.vala"
	_vala_assert (added, "added");
#line 5884 "ViewCollection.c"
}

static void
view_collection_remove_many_selected (ViewCollection* self,
                                      GeeCollection* views)
{
	gint _tmp0_;
	gint _tmp1_;
	gboolean removed = FALSE;
	DataSet* _tmp2_;
#line 908 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 908 "../src/core/ViewCollection.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (views, GEE_TYPE_COLLECTION));
#line 909 "../src/core/ViewCollection.vala"
	_tmp0_ = gee_collection_get_size (views);
#line 909 "../src/core/ViewCollection.vala"
	_tmp1_ = _tmp0_;
#line 909 "../src/core/ViewCollection.vala"
	if (_tmp1_ == 0) {
#line 910 "../src/core/ViewCollection.vala"
		return;
#line 5907 "ViewCollection.c"
	}
#line 912 "../src/core/ViewCollection.vala"
	_tmp2_ = self->priv->selected;
#line 912 "../src/core/ViewCollection.vala"
	removed = data_set_remove_many (_tmp2_, views);
#line 913 "../src/core/ViewCollection.vala"
	_vala_assert (removed, "removed");
#line 5915 "ViewCollection.c"
}

static gboolean
_view_collection_select_item_marked_action (DataObject* object,
                                            GObject* user,
                                            gpointer self)
{
	gboolean result;
	result = view_collection_select_item ((ViewCollection*) self, object, user);
#line 919 "../src/core/ViewCollection.vala"
	return result;
#line 5927 "ViewCollection.c"
}

void
view_collection_select_marked (ViewCollection* self,
                               Marker* marker)
{
	GeeArrayList* selected = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
#line 917 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 917 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_MARKER (marker));
#line 918 "../src/core/ViewCollection.vala"
	_tmp0_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 918 "../src/core/ViewCollection.vala"
	selected = _tmp0_;
#line 919 "../src/core/ViewCollection.vala"
	_tmp1_ = selected;
#line 919 "../src/core/ViewCollection.vala"
	data_collection_act_on_marked (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), marker, _view_collection_select_item_marked_action, self, NULL, NULL, G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, G_TYPE_OBJECT, GObject));
#line 921 "../src/core/ViewCollection.vala"
	_tmp2_ = selected;
#line 921 "../src/core/ViewCollection.vala"
	_tmp3_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 921 "../src/core/ViewCollection.vala"
	_tmp4_ = _tmp3_;
#line 921 "../src/core/ViewCollection.vala"
	if (_tmp4_ > 0) {
#line 5960 "ViewCollection.c"
		GeeArrayList* _tmp5_;
		GeeArrayList* _tmp6_;
#line 922 "../src/core/ViewCollection.vala"
		_tmp5_ = selected;
#line 922 "../src/core/ViewCollection.vala"
		view_collection_add_many_selected (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_COLLECTION, GeeCollection));
#line 923 "../src/core/ViewCollection.vala"
		_tmp6_ = selected;
#line 923 "../src/core/ViewCollection.vala"
		view_collection_notify_items_selected_unselected (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_COLLECTION, GeeCollection), NULL);
#line 5971 "ViewCollection.c"
	}
#line 917 "../src/core/ViewCollection.vala"
	_g_object_unref0 (selected);
#line 5975 "ViewCollection.c"
}

void
view_collection_select_all (ViewCollection* self)
{
	Marker* marker = NULL;
	Marker* _tmp0_;
#line 928 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 929 "../src/core/ViewCollection.vala"
	_tmp0_ = data_collection_start_marking (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 929 "../src/core/ViewCollection.vala"
	marker = _tmp0_;
#line 930 "../src/core/ViewCollection.vala"
	marker_mark_all (marker);
#line 931 "../src/core/ViewCollection.vala"
	view_collection_select_marked (self, marker);
#line 928 "../src/core/ViewCollection.vala"
	_g_object_unref0 (marker);
#line 5995 "ViewCollection.c"
}

static gboolean
view_collection_select_item (ViewCollection* self,
                             DataObject* object,
                             GObject* user)
{
	DataView* view = NULL;
	DataView* _tmp0_;
	DataView* _tmp1_;
	DataView* _tmp5_;
	DataView* _tmp6_;
	gboolean result;
#line 934 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 934 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 934 "../src/core/ViewCollection.vala"
	g_return_val_if_fail ((user == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (user, G_TYPE_OBJECT), FALSE);
#line 935 "../src/core/ViewCollection.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DATA_VIEW, DataView));
#line 935 "../src/core/ViewCollection.vala"
	view = _tmp0_;
#line 936 "../src/core/ViewCollection.vala"
	_tmp1_ = view;
#line 936 "../src/core/ViewCollection.vala"
	if (data_view_is_selected (_tmp1_)) {
#line 6023 "ViewCollection.c"
		DataView* _tmp2_;
#line 937 "../src/core/ViewCollection.vala"
		_tmp2_ = view;
#line 937 "../src/core/ViewCollection.vala"
		if (data_view_is_visible (_tmp2_)) {
#line 6029 "ViewCollection.c"
			DataSet* _tmp3_;
			DataView* _tmp4_;
#line 938 "../src/core/ViewCollection.vala"
			_tmp3_ = self->priv->selected;
#line 938 "../src/core/ViewCollection.vala"
			_tmp4_ = view;
#line 938 "../src/core/ViewCollection.vala"
			_vala_assert (data_set_contains (_tmp3_, G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_DATA_OBJECT, DataObject)), "selected.contains(view)");
#line 6038 "ViewCollection.c"
		}
#line 940 "../src/core/ViewCollection.vala"
		result = TRUE;
#line 940 "../src/core/ViewCollection.vala"
		_g_object_unref0 (view);
#line 940 "../src/core/ViewCollection.vala"
		return result;
#line 6046 "ViewCollection.c"
	}
#line 943 "../src/core/ViewCollection.vala"
	_tmp5_ = view;
#line 943 "../src/core/ViewCollection.vala"
	data_view_internal_set_selected (_tmp5_, TRUE);
#line 947 "../src/core/ViewCollection.vala"
	_tmp6_ = view;
#line 947 "../src/core/ViewCollection.vala"
	if (data_view_is_visible (_tmp6_)) {
#line 6056 "ViewCollection.c"
		DataView* _tmp7_;
#line 948 "../src/core/ViewCollection.vala"
		_tmp7_ = view;
#line 948 "../src/core/ViewCollection.vala"
		gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (user, GEE_TYPE_ARRAY_LIST, GeeArrayList), GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp7_);
#line 6062 "ViewCollection.c"
	}
#line 950 "../src/core/ViewCollection.vala"
	result = TRUE;
#line 950 "../src/core/ViewCollection.vala"
	_g_object_unref0 (view);
#line 950 "../src/core/ViewCollection.vala"
	return result;
#line 6070 "ViewCollection.c"
}

static gboolean
_view_collection_unselect_item_marked_action (DataObject* object,
                                              GObject* user,
                                              gpointer self)
{
	gboolean result;
	result = view_collection_unselect_item ((ViewCollection*) self, object, user);
#line 956 "../src/core/ViewCollection.vala"
	return result;
#line 6082 "ViewCollection.c"
}

void
view_collection_unselect_marked (ViewCollection* self,
                                 Marker* marker)
{
	GeeArrayList* unselected = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
#line 954 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 954 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_MARKER (marker));
#line 955 "../src/core/ViewCollection.vala"
	_tmp0_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 955 "../src/core/ViewCollection.vala"
	unselected = _tmp0_;
#line 956 "../src/core/ViewCollection.vala"
	_tmp1_ = unselected;
#line 956 "../src/core/ViewCollection.vala"
	data_collection_act_on_marked (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), marker, _view_collection_unselect_item_marked_action, self, NULL, NULL, G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, G_TYPE_OBJECT, GObject));
#line 958 "../src/core/ViewCollection.vala"
	_tmp2_ = unselected;
#line 958 "../src/core/ViewCollection.vala"
	_tmp3_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 958 "../src/core/ViewCollection.vala"
	_tmp4_ = _tmp3_;
#line 958 "../src/core/ViewCollection.vala"
	if (_tmp4_ > 0) {
#line 6115 "ViewCollection.c"
		GeeArrayList* _tmp5_;
		GeeArrayList* _tmp6_;
#line 959 "../src/core/ViewCollection.vala"
		_tmp5_ = unselected;
#line 959 "../src/core/ViewCollection.vala"
		view_collection_remove_many_selected (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_COLLECTION, GeeCollection));
#line 960 "../src/core/ViewCollection.vala"
		_tmp6_ = unselected;
#line 960 "../src/core/ViewCollection.vala"
		view_collection_notify_items_selected_unselected (self, NULL, G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_COLLECTION, GeeCollection));
#line 6126 "ViewCollection.c"
	}
#line 954 "../src/core/ViewCollection.vala"
	_g_object_unref0 (unselected);
#line 6130 "ViewCollection.c"
}

void
view_collection_unselect_all (ViewCollection* self)
{
	DataSet* _tmp0_;
	Marker* marker = NULL;
	Marker* _tmp1_;
	Marker* _tmp2_;
	GeeList* _tmp3_;
	GeeList* _tmp4_;
	Marker* _tmp5_;
#line 965 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 966 "../src/core/ViewCollection.vala"
	_tmp0_ = self->priv->selected;
#line 966 "../src/core/ViewCollection.vala"
	if (data_set_get_count (_tmp0_) == 0) {
#line 967 "../src/core/ViewCollection.vala"
		return;
#line 6151 "ViewCollection.c"
	}
#line 969 "../src/core/ViewCollection.vala"
	_tmp1_ = data_collection_start_marking (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 969 "../src/core/ViewCollection.vala"
	marker = _tmp1_;
#line 970 "../src/core/ViewCollection.vala"
	_tmp2_ = marker;
#line 970 "../src/core/ViewCollection.vala"
	_tmp3_ = view_collection_get_selected (self);
#line 970 "../src/core/ViewCollection.vala"
	_tmp4_ = _tmp3_;
#line 970 "../src/core/ViewCollection.vala"
	marker_mark_many (_tmp2_, G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_COLLECTION, GeeCollection));
#line 970 "../src/core/ViewCollection.vala"
	_g_object_unref0 (_tmp4_);
#line 972 "../src/core/ViewCollection.vala"
	_tmp5_ = marker;
#line 972 "../src/core/ViewCollection.vala"
	view_collection_unselect_marked (self, _tmp5_);
#line 965 "../src/core/ViewCollection.vala"
	_g_object_unref0 (marker);
#line 6173 "ViewCollection.c"
}

void
view_collection_unselect_all_but (ViewCollection* self,
                                  DataView* exception)
{
	Marker* marker = NULL;
	Marker* _tmp0_;
	Marker* _tmp13_;
#line 976 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 976 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (exception));
#line 977 "../src/core/ViewCollection.vala"
	_tmp0_ = data_collection_start_marking (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 977 "../src/core/ViewCollection.vala"
	marker = _tmp0_;
#line 6191 "ViewCollection.c"
	{
		GeeIterator* _object_it = NULL;
		GeeCollection* _tmp1_;
		GeeCollection* _tmp2_;
		GeeIterator* _tmp3_;
		GeeIterator* _tmp4_;
#line 978 "../src/core/ViewCollection.vala"
		_tmp1_ = data_collection_get_all (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 978 "../src/core/ViewCollection.vala"
		_tmp2_ = _tmp1_;
#line 978 "../src/core/ViewCollection.vala"
		_tmp3_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_ITERABLE, GeeIterable));
#line 978 "../src/core/ViewCollection.vala"
		_tmp4_ = _tmp3_;
#line 978 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp2_);
#line 978 "../src/core/ViewCollection.vala"
		_object_it = _tmp4_;
#line 978 "../src/core/ViewCollection.vala"
		while (TRUE) {
#line 6212 "ViewCollection.c"
			GeeIterator* _tmp5_;
			DataObject* object = NULL;
			GeeIterator* _tmp6_;
			gpointer _tmp7_;
			DataView* view = NULL;
			DataObject* _tmp8_;
			DataView* _tmp9_;
			DataView* _tmp10_;
#line 978 "../src/core/ViewCollection.vala"
			_tmp5_ = _object_it;
#line 978 "../src/core/ViewCollection.vala"
			if (!gee_iterator_next (_tmp5_)) {
#line 978 "../src/core/ViewCollection.vala"
				break;
#line 6227 "ViewCollection.c"
			}
#line 978 "../src/core/ViewCollection.vala"
			_tmp6_ = _object_it;
#line 978 "../src/core/ViewCollection.vala"
			_tmp7_ = gee_iterator_get (_tmp6_);
#line 978 "../src/core/ViewCollection.vala"
			object = (DataObject*) _tmp7_;
#line 979 "../src/core/ViewCollection.vala"
			_tmp8_ = object;
#line 979 "../src/core/ViewCollection.vala"
			_tmp9_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, TYPE_DATA_VIEW, DataView));
#line 979 "../src/core/ViewCollection.vala"
			view = _tmp9_;
#line 980 "../src/core/ViewCollection.vala"
			_tmp10_ = view;
#line 980 "../src/core/ViewCollection.vala"
			if (_tmp10_ != exception) {
#line 6245 "ViewCollection.c"
				Marker* _tmp11_;
				DataView* _tmp12_;
#line 981 "../src/core/ViewCollection.vala"
				_tmp11_ = marker;
#line 981 "../src/core/ViewCollection.vala"
				_tmp12_ = view;
#line 981 "../src/core/ViewCollection.vala"
				marker_mark (_tmp11_, G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, TYPE_DATA_OBJECT, DataObject));
#line 6254 "ViewCollection.c"
			}
#line 978 "../src/core/ViewCollection.vala"
			_g_object_unref0 (view);
#line 978 "../src/core/ViewCollection.vala"
			_g_object_unref0 (object);
#line 6260 "ViewCollection.c"
		}
#line 978 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_object_it);
#line 6264 "ViewCollection.c"
	}
#line 984 "../src/core/ViewCollection.vala"
	_tmp13_ = marker;
#line 984 "../src/core/ViewCollection.vala"
	view_collection_unselect_marked (self, _tmp13_);
#line 976 "../src/core/ViewCollection.vala"
	_g_object_unref0 (marker);
#line 6272 "ViewCollection.c"
}

static gboolean
view_collection_unselect_item (ViewCollection* self,
                               DataObject* object,
                               GObject* user)
{
	DataView* view = NULL;
	DataView* _tmp0_;
	DataView* _tmp1_;
	DataView* _tmp4_;
	DataView* _tmp5_;
	gboolean result;
#line 987 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 987 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 987 "../src/core/ViewCollection.vala"
	g_return_val_if_fail ((user == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (user, G_TYPE_OBJECT), FALSE);
#line 988 "../src/core/ViewCollection.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DATA_VIEW, DataView));
#line 988 "../src/core/ViewCollection.vala"
	view = _tmp0_;
#line 989 "../src/core/ViewCollection.vala"
	_tmp1_ = view;
#line 989 "../src/core/ViewCollection.vala"
	if (!data_view_is_selected (_tmp1_)) {
#line 6300 "ViewCollection.c"
		DataSet* _tmp2_;
		DataView* _tmp3_;
#line 990 "../src/core/ViewCollection.vala"
		_tmp2_ = self->priv->selected;
#line 990 "../src/core/ViewCollection.vala"
		_tmp3_ = view;
#line 990 "../src/core/ViewCollection.vala"
		_vala_assert (!data_set_contains (_tmp2_, G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_DATA_OBJECT, DataObject)), "!selected.contains(view)");
#line 992 "../src/core/ViewCollection.vala"
		result = TRUE;
#line 992 "../src/core/ViewCollection.vala"
		_g_object_unref0 (view);
#line 992 "../src/core/ViewCollection.vala"
		return result;
#line 6315 "ViewCollection.c"
	}
#line 995 "../src/core/ViewCollection.vala"
	_tmp4_ = view;
#line 995 "../src/core/ViewCollection.vala"
	data_view_internal_set_selected (_tmp4_, FALSE);
#line 996 "../src/core/ViewCollection.vala"
	_tmp5_ = view;
#line 996 "../src/core/ViewCollection.vala"
	gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (user, GEE_TYPE_ARRAY_LIST, GeeArrayList), GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp5_);
#line 998 "../src/core/ViewCollection.vala"
	result = TRUE;
#line 998 "../src/core/ViewCollection.vala"
	_g_object_unref0 (view);
#line 998 "../src/core/ViewCollection.vala"
	return result;
#line 6331 "ViewCollection.c"
}

void
view_collection_unselect_and_select_marked (ViewCollection* self,
                                            Marker* unselect,
                                            Marker* select)
{
	GeeArrayList* unselected = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* selected = NULL;
	GeeArrayList* _tmp1_;
#line 1002 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1002 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_MARKER (unselect));
#line 1002 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_MARKER (select));
#line 1003 "../src/core/ViewCollection.vala"
	_tmp0_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1003 "../src/core/ViewCollection.vala"
	unselected = _tmp0_;
#line 1004 "../src/core/ViewCollection.vala"
	data_collection_act_on_marked (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), unselect, _view_collection_unselect_item_marked_action, self, NULL, NULL, G_TYPE_CHECK_INSTANCE_CAST (unselected, G_TYPE_OBJECT, GObject));
#line 1006 "../src/core/ViewCollection.vala"
	view_collection_remove_many_selected (self, G_TYPE_CHECK_INSTANCE_CAST (unselected, GEE_TYPE_COLLECTION, GeeCollection));
#line 1008 "../src/core/ViewCollection.vala"
	_tmp1_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1008 "../src/core/ViewCollection.vala"
	selected = _tmp1_;
#line 1009 "../src/core/ViewCollection.vala"
	data_collection_act_on_marked (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), select, _view_collection_select_item_marked_action, self, NULL, NULL, G_TYPE_CHECK_INSTANCE_CAST (selected, G_TYPE_OBJECT, GObject));
#line 1011 "../src/core/ViewCollection.vala"
	view_collection_add_many_selected (self, G_TYPE_CHECK_INSTANCE_CAST (selected, GEE_TYPE_COLLECTION, GeeCollection));
#line 1013 "../src/core/ViewCollection.vala"
	view_collection_notify_items_selected_unselected (self, G_TYPE_CHECK_INSTANCE_CAST (selected, GEE_TYPE_COLLECTION, GeeCollection), G_TYPE_CHECK_INSTANCE_CAST (unselected, GEE_TYPE_COLLECTION, GeeCollection));
#line 1002 "../src/core/ViewCollection.vala"
	_g_object_unref0 (selected);
#line 1002 "../src/core/ViewCollection.vala"
	_g_object_unref0 (unselected);
#line 6371 "ViewCollection.c"
}

static gboolean
_view_collection_toggle_item_marked_action (DataObject* object,
                                            GObject* user,
                                            gpointer self)
{
	gboolean result;
	result = view_collection_toggle_item ((ViewCollection*) self, object, user);
#line 1020 "../src/core/ViewCollection.vala"
	return result;
#line 6383 "ViewCollection.c"
}

void
view_collection_toggle_marked (ViewCollection* self,
                               Marker* marker)
{
	ViewCollectionToggleLists* lists = NULL;
	ViewCollectionToggleLists* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
	GeeArrayList* _tmp4_;
#line 1018 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1018 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_MARKER (marker));
#line 1019 "../src/core/ViewCollection.vala"
	_tmp0_ = view_collection_toggle_lists_new ();
#line 1019 "../src/core/ViewCollection.vala"
	lists = _tmp0_;
#line 1020 "../src/core/ViewCollection.vala"
	data_collection_act_on_marked (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), marker, _view_collection_toggle_item_marked_action, self, NULL, NULL, G_TYPE_CHECK_INSTANCE_CAST (lists, G_TYPE_OBJECT, GObject));
#line 1023 "../src/core/ViewCollection.vala"
	_tmp1_ = lists->selected;
#line 1023 "../src/core/ViewCollection.vala"
	view_collection_add_many_selected (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1024 "../src/core/ViewCollection.vala"
	_tmp2_ = lists->unselected;
#line 1024 "../src/core/ViewCollection.vala"
	view_collection_remove_many_selected (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1026 "../src/core/ViewCollection.vala"
	_tmp3_ = lists->selected;
#line 1026 "../src/core/ViewCollection.vala"
	_tmp4_ = lists->unselected;
#line 1026 "../src/core/ViewCollection.vala"
	view_collection_notify_items_selected_unselected (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_COLLECTION, GeeCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1018 "../src/core/ViewCollection.vala"
	_g_object_unref0 (lists);
#line 6422 "ViewCollection.c"
}

static gboolean
view_collection_toggle_item (ViewCollection* self,
                             DataObject* object,
                             GObject* user)
{
	DataView* view = NULL;
	DataView* _tmp0_;
	ViewCollectionToggleLists* lists = NULL;
	ViewCollectionToggleLists* _tmp1_;
	DataView* _tmp2_;
	gboolean result;
#line 1029 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 1029 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_OBJECT (object), FALSE);
#line 1029 "../src/core/ViewCollection.vala"
	g_return_val_if_fail ((user == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (user, G_TYPE_OBJECT), FALSE);
#line 1030 "../src/core/ViewCollection.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DATA_VIEW, DataView));
#line 1030 "../src/core/ViewCollection.vala"
	view = _tmp0_;
#line 1031 "../src/core/ViewCollection.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (user, VIEW_COLLECTION_TYPE_TOGGLE_LISTS, ViewCollectionToggleLists));
#line 1031 "../src/core/ViewCollection.vala"
	lists = _tmp1_;
#line 1037 "../src/core/ViewCollection.vala"
	_tmp2_ = view;
#line 1037 "../src/core/ViewCollection.vala"
	if (data_view_internal_toggle (_tmp2_)) {
#line 6454 "ViewCollection.c"
		DataView* _tmp3_;
#line 1038 "../src/core/ViewCollection.vala"
		_tmp3_ = view;
#line 1038 "../src/core/ViewCollection.vala"
		if (data_view_is_visible (_tmp3_)) {
#line 6460 "ViewCollection.c"
			ViewCollectionToggleLists* _tmp4_;
			GeeArrayList* _tmp5_;
			DataView* _tmp6_;
#line 1039 "../src/core/ViewCollection.vala"
			_tmp4_ = lists;
#line 1039 "../src/core/ViewCollection.vala"
			_tmp5_ = _tmp4_->selected;
#line 1039 "../src/core/ViewCollection.vala"
			_tmp6_ = view;
#line 1039 "../src/core/ViewCollection.vala"
			gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp6_);
#line 6472 "ViewCollection.c"
		}
	} else {
		ViewCollectionToggleLists* _tmp7_;
		GeeArrayList* _tmp8_;
		DataView* _tmp9_;
#line 1041 "../src/core/ViewCollection.vala"
		_tmp7_ = lists;
#line 1041 "../src/core/ViewCollection.vala"
		_tmp8_ = _tmp7_->unselected;
#line 1041 "../src/core/ViewCollection.vala"
		_tmp9_ = view;
#line 1041 "../src/core/ViewCollection.vala"
		gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp9_);
#line 6486 "ViewCollection.c"
	}
#line 1044 "../src/core/ViewCollection.vala"
	result = TRUE;
#line 1044 "../src/core/ViewCollection.vala"
	_g_object_unref0 (lists);
#line 1044 "../src/core/ViewCollection.vala"
	_g_object_unref0 (view);
#line 1044 "../src/core/ViewCollection.vala"
	return result;
#line 6496 "ViewCollection.c"
}

gint
view_collection_get_selected_count (ViewCollection* self)
{
	DataSet* _tmp0_;
	gint result;
#line 1047 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), 0);
#line 1048 "../src/core/ViewCollection.vala"
	_tmp0_ = self->priv->selected;
#line 1048 "../src/core/ViewCollection.vala"
	result = data_set_get_count (_tmp0_);
#line 1048 "../src/core/ViewCollection.vala"
	return result;
#line 6512 "ViewCollection.c"
}

GeeList*
view_collection_get_selected (ViewCollection* self)
{
	DataSet* _tmp0_;
	GeeList* _tmp1_;
	GeeList* result;
#line 1051 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 1052 "../src/core/ViewCollection.vala"
	_tmp0_ = self->priv->selected;
#line 1052 "../src/core/ViewCollection.vala"
	_tmp1_ = data_set_get_all (_tmp0_);
#line 1052 "../src/core/ViewCollection.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_LIST, GeeList);
#line 1052 "../src/core/ViewCollection.vala"
	return result;
#line 6531 "ViewCollection.c"
}

DataView*
view_collection_get_selected_at (ViewCollection* self,
                                 gint index)
{
	DataSet* _tmp0_;
	DataObject* _tmp1_;
	DataView* result;
#line 1055 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 1056 "../src/core/ViewCollection.vala"
	_tmp0_ = self->priv->selected;
#line 1056 "../src/core/ViewCollection.vala"
	_tmp1_ = data_set_get_at (_tmp0_, index);
#line 1056 "../src/core/ViewCollection.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_DATA_VIEW, DataView);
#line 1056 "../src/core/ViewCollection.vala"
	return result;
#line 6551 "ViewCollection.c"
}

static gboolean
view_collection_is_visible (ViewCollection* self,
                            DataView* view)
{
	gboolean _tmp0_ = FALSE;
	DataSet* _tmp1_;
	gboolean result;
#line 1059 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 1059 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_VIEW (view), FALSE);
#line 1060 "../src/core/ViewCollection.vala"
	_tmp1_ = self->priv->visible;
#line 1060 "../src/core/ViewCollection.vala"
	if (_tmp1_ != NULL) {
#line 6569 "ViewCollection.c"
		DataSet* _tmp2_;
#line 1060 "../src/core/ViewCollection.vala"
		_tmp2_ = self->priv->visible;
#line 1060 "../src/core/ViewCollection.vala"
		_tmp0_ = data_set_contains (_tmp2_, G_TYPE_CHECK_INSTANCE_CAST (view, TYPE_DATA_OBJECT, DataObject));
#line 6575 "ViewCollection.c"
	} else {
#line 1060 "../src/core/ViewCollection.vala"
		_tmp0_ = TRUE;
#line 6579 "ViewCollection.c"
	}
#line 1060 "../src/core/ViewCollection.vala"
	result = _tmp0_;
#line 1060 "../src/core/ViewCollection.vala"
	return result;
#line 6585 "ViewCollection.c"
}

static gboolean
view_collection_add_many_visible (ViewCollection* self,
                                  GeeCollection* many)
{
	DataSet* _tmp0_;
	DataSet* _tmp1_;
	DataSet* _tmp2_;
	gboolean result;
#line 1063 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 1063 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (many, GEE_TYPE_COLLECTION), FALSE);
#line 1064 "../src/core/ViewCollection.vala"
	_tmp0_ = self->priv->visible;
#line 1064 "../src/core/ViewCollection.vala"
	if (_tmp0_ == NULL) {
#line 1065 "../src/core/ViewCollection.vala"
		result = TRUE;
#line 1065 "../src/core/ViewCollection.vala"
		return result;
#line 6608 "ViewCollection.c"
	}
#line 1067 "../src/core/ViewCollection.vala"
	_tmp1_ = self->priv->visible;
#line 1067 "../src/core/ViewCollection.vala"
	if (!data_set_add_many (_tmp1_, many)) {
#line 1068 "../src/core/ViewCollection.vala"
		result = FALSE;
#line 1068 "../src/core/ViewCollection.vala"
		return result;
#line 6618 "ViewCollection.c"
	}
#line 1071 "../src/core/ViewCollection.vala"
	_tmp2_ = self->priv->visible;
#line 1071 "../src/core/ViewCollection.vala"
	if (data_set_get_count (_tmp2_) == DATA_COLLECTION_CLASS (view_collection_parent_class)->get_count (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection))) {
#line 1072 "../src/core/ViewCollection.vala"
		_data_set_unref0 (self->priv->visible);
#line 1072 "../src/core/ViewCollection.vala"
		self->priv->visible = NULL;
#line 6628 "ViewCollection.c"
	}
#line 1074 "../src/core/ViewCollection.vala"
	result = TRUE;
#line 1074 "../src/core/ViewCollection.vala"
	return result;
#line 6634 "ViewCollection.c"
}

static void
view_collection_hide_items (ViewCollection* self,
                            GeeList* to_hide)
{
	GeeArrayList* unselected = NULL;
	GeeArrayList* _tmp0_;
	gint count = 0;
	gint _tmp1_;
	gint _tmp2_;
	DataSet* _tmp14_;
	gboolean removed = FALSE;
	DataSet* _tmp16_;
	GeeArrayList* _tmp17_;
	GeeArrayList* _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	gint _tmp22_;
	gint _tmp23_;
#line 1078 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1078 "../src/core/ViewCollection.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (to_hide, GEE_TYPE_LIST));
#line 1079 "../src/core/ViewCollection.vala"
	_tmp0_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1079 "../src/core/ViewCollection.vala"
	unselected = _tmp0_;
#line 1081 "../src/core/ViewCollection.vala"
	_tmp1_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (to_hide, GEE_TYPE_COLLECTION, GeeCollection));
#line 1081 "../src/core/ViewCollection.vala"
	_tmp2_ = _tmp1_;
#line 1081 "../src/core/ViewCollection.vala"
	count = _tmp2_;
#line 6669 "ViewCollection.c"
	{
		gint ctr = 0;
#line 1082 "../src/core/ViewCollection.vala"
		ctr = 0;
#line 6674 "ViewCollection.c"
		{
			gboolean _tmp3_ = FALSE;
#line 1082 "../src/core/ViewCollection.vala"
			_tmp3_ = TRUE;
#line 1082 "../src/core/ViewCollection.vala"
			while (TRUE) {
#line 6681 "ViewCollection.c"
				DataView* view = NULL;
				gpointer _tmp5_;
				DataView* _tmp6_;
				DataView* _tmp7_;
				DataView* _tmp13_;
#line 1082 "../src/core/ViewCollection.vala"
				if (!_tmp3_) {
#line 6689 "ViewCollection.c"
					gint _tmp4_;
#line 1082 "../src/core/ViewCollection.vala"
					_tmp4_ = ctr;
#line 1082 "../src/core/ViewCollection.vala"
					ctr = _tmp4_ + 1;
#line 6695 "ViewCollection.c"
				}
#line 1082 "../src/core/ViewCollection.vala"
				_tmp3_ = FALSE;
#line 1082 "../src/core/ViewCollection.vala"
				if (!(ctr < count)) {
#line 1082 "../src/core/ViewCollection.vala"
					break;
#line 6703 "ViewCollection.c"
				}
#line 1083 "../src/core/ViewCollection.vala"
				_tmp5_ = gee_list_get (to_hide, ctr);
#line 1083 "../src/core/ViewCollection.vala"
				view = (DataView*) _tmp5_;
#line 1084 "../src/core/ViewCollection.vala"
				_tmp6_ = view;
#line 1084 "../src/core/ViewCollection.vala"
				_vala_assert (data_view_is_visible (_tmp6_), "view.is_visible()");
#line 1086 "../src/core/ViewCollection.vala"
				_tmp7_ = view;
#line 1086 "../src/core/ViewCollection.vala"
				if (data_view_is_selected (_tmp7_)) {
#line 6717 "ViewCollection.c"
					DataView* _tmp8_;
					GeeArrayList* _tmp9_;
					DataView* _tmp10_;
#line 1087 "../src/core/ViewCollection.vala"
					_tmp8_ = view;
#line 1087 "../src/core/ViewCollection.vala"
					data_view_internal_set_selected (_tmp8_, FALSE);
#line 1088 "../src/core/ViewCollection.vala"
					_tmp9_ = unselected;
#line 1088 "../src/core/ViewCollection.vala"
					_tmp10_ = view;
#line 1088 "../src/core/ViewCollection.vala"
					gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp10_);
#line 6731 "ViewCollection.c"
				} else {
					DataSet* _tmp11_;
					DataView* _tmp12_;
#line 1090 "../src/core/ViewCollection.vala"
					_tmp11_ = self->priv->selected;
#line 1090 "../src/core/ViewCollection.vala"
					_tmp12_ = view;
#line 1090 "../src/core/ViewCollection.vala"
					_vala_assert (!data_set_contains (_tmp11_, G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, TYPE_DATA_OBJECT, DataObject)), "!selected.contains(view)");
#line 6741 "ViewCollection.c"
				}
#line 1093 "../src/core/ViewCollection.vala"
				_tmp13_ = view;
#line 1093 "../src/core/ViewCollection.vala"
				data_view_internal_set_visible (_tmp13_, FALSE);
#line 1082 "../src/core/ViewCollection.vala"
				_g_object_unref0 (view);
#line 6749 "ViewCollection.c"
			}
		}
	}
#line 1096 "../src/core/ViewCollection.vala"
	_tmp14_ = self->priv->visible;
#line 1096 "../src/core/ViewCollection.vala"
	if (_tmp14_ == NULL) {
#line 6757 "ViewCollection.c"
		DataSet* _tmp15_;
#line 1098 "../src/core/ViewCollection.vala"
		_tmp15_ = data_collection_get_dataset_copy (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 1098 "../src/core/ViewCollection.vala"
		_data_set_unref0 (self->priv->visible);
#line 1098 "../src/core/ViewCollection.vala"
		self->priv->visible = _tmp15_;
#line 6765 "ViewCollection.c"
	}
#line 1101 "../src/core/ViewCollection.vala"
	_tmp16_ = self->priv->visible;
#line 1101 "../src/core/ViewCollection.vala"
	removed = data_set_remove_many (_tmp16_, G_TYPE_CHECK_INSTANCE_CAST (to_hide, GEE_TYPE_COLLECTION, GeeCollection));
#line 1102 "../src/core/ViewCollection.vala"
	_vala_assert (removed, "removed");
#line 1104 "../src/core/ViewCollection.vala"
	_tmp17_ = unselected;
#line 1104 "../src/core/ViewCollection.vala"
	view_collection_remove_many_selected (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1106 "../src/core/ViewCollection.vala"
	_tmp18_ = unselected;
#line 1106 "../src/core/ViewCollection.vala"
	_tmp19_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 1106 "../src/core/ViewCollection.vala"
	_tmp20_ = _tmp19_;
#line 1106 "../src/core/ViewCollection.vala"
	if (_tmp20_ > 0) {
#line 6785 "ViewCollection.c"
		GeeArrayList* _tmp21_;
#line 1107 "../src/core/ViewCollection.vala"
		_tmp21_ = unselected;
#line 1107 "../src/core/ViewCollection.vala"
		view_collection_notify_items_selected_unselected (self, NULL, G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, GEE_TYPE_COLLECTION, GeeCollection));
#line 6791 "ViewCollection.c"
	}
#line 1109 "../src/core/ViewCollection.vala"
	_tmp22_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (to_hide, GEE_TYPE_COLLECTION, GeeCollection));
#line 1109 "../src/core/ViewCollection.vala"
	_tmp23_ = _tmp22_;
#line 1109 "../src/core/ViewCollection.vala"
	if (_tmp23_ > 0) {
#line 1110 "../src/core/ViewCollection.vala"
		view_collection_notify_items_hidden (self, G_TYPE_CHECK_INSTANCE_CAST (to_hide, GEE_TYPE_COLLECTION, GeeCollection));
#line 1111 "../src/core/ViewCollection.vala"
		view_collection_notify_items_visibility_changed (self, G_TYPE_CHECK_INSTANCE_CAST (to_hide, GEE_TYPE_COLLECTION, GeeCollection));
#line 6803 "ViewCollection.c"
	}
#line 1078 "../src/core/ViewCollection.vala"
	_g_object_unref0 (unselected);
#line 6807 "ViewCollection.c"
}

static void
view_collection_show_items (ViewCollection* self,
                            GeeList* to_show)
{
	GeeArrayList* added_selected = NULL;
	GeeArrayList* _tmp0_;
	gint count = 0;
	gint _tmp1_;
	gint _tmp2_;
	gboolean added = FALSE;
	GeeArrayList* _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
#line 1116 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1116 "../src/core/ViewCollection.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (to_show, GEE_TYPE_LIST));
#line 1117 "../src/core/ViewCollection.vala"
	_tmp0_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1117 "../src/core/ViewCollection.vala"
	added_selected = _tmp0_;
#line 1119 "../src/core/ViewCollection.vala"
	_tmp1_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (to_show, GEE_TYPE_COLLECTION, GeeCollection));
#line 1119 "../src/core/ViewCollection.vala"
	_tmp2_ = _tmp1_;
#line 1119 "../src/core/ViewCollection.vala"
	count = _tmp2_;
#line 6837 "ViewCollection.c"
	{
		gint ctr = 0;
#line 1120 "../src/core/ViewCollection.vala"
		ctr = 0;
#line 6842 "ViewCollection.c"
		{
			gboolean _tmp3_ = FALSE;
#line 1120 "../src/core/ViewCollection.vala"
			_tmp3_ = TRUE;
#line 1120 "../src/core/ViewCollection.vala"
			while (TRUE) {
#line 6849 "ViewCollection.c"
				DataView* view = NULL;
				gpointer _tmp5_;
				DataView* _tmp6_;
				DataView* _tmp7_;
				DataView* _tmp8_;
#line 1120 "../src/core/ViewCollection.vala"
				if (!_tmp3_) {
#line 6857 "ViewCollection.c"
					gint _tmp4_;
#line 1120 "../src/core/ViewCollection.vala"
					_tmp4_ = ctr;
#line 1120 "../src/core/ViewCollection.vala"
					ctr = _tmp4_ + 1;
#line 6863 "ViewCollection.c"
				}
#line 1120 "../src/core/ViewCollection.vala"
				_tmp3_ = FALSE;
#line 1120 "../src/core/ViewCollection.vala"
				if (!(ctr < count)) {
#line 1120 "../src/core/ViewCollection.vala"
					break;
#line 6871 "ViewCollection.c"
				}
#line 1121 "../src/core/ViewCollection.vala"
				_tmp5_ = gee_list_get (to_show, ctr);
#line 1121 "../src/core/ViewCollection.vala"
				view = (DataView*) _tmp5_;
#line 1122 "../src/core/ViewCollection.vala"
				_tmp6_ = view;
#line 1122 "../src/core/ViewCollection.vala"
				_vala_assert (!data_view_is_visible (_tmp6_), "!view.is_visible()");
#line 1124 "../src/core/ViewCollection.vala"
				_tmp7_ = view;
#line 1124 "../src/core/ViewCollection.vala"
				data_view_internal_set_visible (_tmp7_, TRUE);
#line 1127 "../src/core/ViewCollection.vala"
				_tmp8_ = view;
#line 1127 "../src/core/ViewCollection.vala"
				if (data_view_is_selected (_tmp8_)) {
#line 6889 "ViewCollection.c"
					DataSet* _tmp9_;
					DataView* _tmp10_;
					GeeArrayList* _tmp11_;
					DataView* _tmp12_;
#line 1128 "../src/core/ViewCollection.vala"
					_tmp9_ = self->priv->selected;
#line 1128 "../src/core/ViewCollection.vala"
					_tmp10_ = view;
#line 1128 "../src/core/ViewCollection.vala"
					_vala_assert (!data_set_contains (_tmp9_, G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, TYPE_DATA_OBJECT, DataObject)), "!selected.contains(view)");
#line 1129 "../src/core/ViewCollection.vala"
					_tmp11_ = added_selected;
#line 1129 "../src/core/ViewCollection.vala"
					_tmp12_ = view;
#line 1129 "../src/core/ViewCollection.vala"
					gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp12_);
#line 6906 "ViewCollection.c"
				}
#line 1120 "../src/core/ViewCollection.vala"
				_g_object_unref0 (view);
#line 6910 "ViewCollection.c"
			}
		}
	}
#line 1133 "../src/core/ViewCollection.vala"
	added = view_collection_add_many_visible (self, G_TYPE_CHECK_INSTANCE_CAST (to_show, GEE_TYPE_COLLECTION, GeeCollection));
#line 1134 "../src/core/ViewCollection.vala"
	_vala_assert (added, "added");
#line 1136 "../src/core/ViewCollection.vala"
	_tmp13_ = added_selected;
#line 1136 "../src/core/ViewCollection.vala"
	view_collection_add_many_selected (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1138 "../src/core/ViewCollection.vala"
	_tmp14_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (to_show, GEE_TYPE_COLLECTION, GeeCollection));
#line 1138 "../src/core/ViewCollection.vala"
	_tmp15_ = _tmp14_;
#line 1138 "../src/core/ViewCollection.vala"
	if (_tmp15_ > 0) {
#line 1139 "../src/core/ViewCollection.vala"
		view_collection_notify_items_shown (self, G_TYPE_CHECK_INSTANCE_CAST (to_show, GEE_TYPE_COLLECTION, GeeCollection));
#line 1140 "../src/core/ViewCollection.vala"
		view_collection_notify_items_visibility_changed (self, G_TYPE_CHECK_INSTANCE_CAST (to_show, GEE_TYPE_COLLECTION, GeeCollection));
#line 6932 "ViewCollection.c"
	}
#line 1116 "../src/core/ViewCollection.vala"
	_g_object_unref0 (added_selected);
#line 6936 "ViewCollection.c"
}

gboolean
view_collection_has_view_for_source (ViewCollection* self,
                                     DataSource* source)
{
	DataView* _tmp0_;
	DataView* _tmp1_;
	gboolean _tmp2_;
	gboolean result;
#line 1145 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 1145 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), FALSE);
#line 1146 "../src/core/ViewCollection.vala"
	_tmp0_ = view_collection_get_view_for_source (self, source);
#line 1146 "../src/core/ViewCollection.vala"
	_tmp1_ = _tmp0_;
#line 1146 "../src/core/ViewCollection.vala"
	_tmp2_ = _tmp1_ != NULL;
#line 1146 "../src/core/ViewCollection.vala"
	_g_object_unref0 (_tmp1_);
#line 1146 "../src/core/ViewCollection.vala"
	result = _tmp2_;
#line 1146 "../src/core/ViewCollection.vala"
	return result;
#line 6963 "ViewCollection.c"
}

DataView*
view_collection_get_view_for_source (ViewCollection* self,
                                     DataSource* source)
{
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	DataView* result;
#line 1150 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 1150 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), NULL);
#line 1151 "../src/core/ViewCollection.vala"
	_tmp0_ = self->priv->source_map;
#line 1151 "../src/core/ViewCollection.vala"
	_tmp1_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), source);
#line 1151 "../src/core/ViewCollection.vala"
	result = (DataView*) _tmp1_;
#line 1151 "../src/core/ViewCollection.vala"
	return result;
#line 6985 "ViewCollection.c"
}

gboolean
view_collection_has_view_for_source_with_filtered (ViewCollection* self,
                                                   DataSource* source)
{
	DataView* _tmp0_;
	DataView* _tmp1_;
	gboolean _tmp2_;
	gboolean result;
#line 1155 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 1155 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), FALSE);
#line 1156 "../src/core/ViewCollection.vala"
	_tmp0_ = view_collection_get_view_for_source_filtered (self, source);
#line 1156 "../src/core/ViewCollection.vala"
	_tmp1_ = _tmp0_;
#line 1156 "../src/core/ViewCollection.vala"
	_tmp2_ = _tmp1_ != NULL;
#line 1156 "../src/core/ViewCollection.vala"
	_g_object_unref0 (_tmp1_);
#line 1156 "../src/core/ViewCollection.vala"
	result = _tmp2_;
#line 1156 "../src/core/ViewCollection.vala"
	return result;
#line 7012 "ViewCollection.c"
}

DataView*
view_collection_get_view_for_source_filtered (ViewCollection* self,
                                              DataSource* source)
{
	DataView* view = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	gboolean _tmp2_ = FALSE;
	DataView* _tmp3_;
	DataView* result;
#line 1160 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 1160 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), NULL);
#line 1161 "../src/core/ViewCollection.vala"
	_tmp0_ = self->priv->source_map;
#line 1161 "../src/core/ViewCollection.vala"
	_tmp1_ = gee_abstract_map_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap), source);
#line 1161 "../src/core/ViewCollection.vala"
	view = (DataView*) _tmp1_;
#line 1163 "../src/core/ViewCollection.vala"
	_tmp3_ = view;
#line 1163 "../src/core/ViewCollection.vala"
	if (_tmp3_ != NULL) {
#line 7039 "ViewCollection.c"
		DataView* _tmp4_;
#line 1163 "../src/core/ViewCollection.vala"
		_tmp4_ = view;
#line 1163 "../src/core/ViewCollection.vala"
		_tmp2_ = !view_collection_is_in_filter (self, _tmp4_);
#line 7045 "ViewCollection.c"
	} else {
#line 1163 "../src/core/ViewCollection.vala"
		_tmp2_ = FALSE;
#line 7049 "ViewCollection.c"
	}
#line 1163 "../src/core/ViewCollection.vala"
	if (_tmp2_) {
#line 1164 "../src/core/ViewCollection.vala"
		result = NULL;
#line 1164 "../src/core/ViewCollection.vala"
		_g_object_unref0 (view);
#line 1164 "../src/core/ViewCollection.vala"
		return result;
#line 7059 "ViewCollection.c"
	}
#line 1165 "../src/core/ViewCollection.vala"
	result = view;
#line 1165 "../src/core/ViewCollection.vala"
	return result;
#line 7065 "ViewCollection.c"
}

GeeCollection*
view_collection_get_sources (ViewCollection* self)
{
	GeeHashMap* _tmp0_;
	GeeSet* _tmp1_;
	GeeSet* _tmp2_;
	GeeSet* _tmp3_;
	GeeSet* _tmp4_;
	GeeSet* _tmp5_;
	GeeCollection* _tmp6_;
	GeeCollection* result;
#line 1169 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 1170 "../src/core/ViewCollection.vala"
	_tmp0_ = self->priv->source_map;
#line 1170 "../src/core/ViewCollection.vala"
	_tmp1_ = gee_abstract_map_get_keys (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap));
#line 1170 "../src/core/ViewCollection.vala"
	_tmp2_ = _tmp1_;
#line 1170 "../src/core/ViewCollection.vala"
	_tmp3_ = _tmp2_;
#line 1170 "../src/core/ViewCollection.vala"
	_tmp4_ = gee_set_get_read_only_view (_tmp3_);
#line 1170 "../src/core/ViewCollection.vala"
	_tmp5_ = _tmp4_;
#line 1170 "../src/core/ViewCollection.vala"
	_tmp6_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GEE_TYPE_COLLECTION, GeeCollection);
#line 1170 "../src/core/ViewCollection.vala"
	_g_object_unref0 (_tmp3_);
#line 1170 "../src/core/ViewCollection.vala"
	result = _tmp6_;
#line 1170 "../src/core/ViewCollection.vala"
	return result;
#line 7101 "ViewCollection.c"
}

gboolean
view_collection_has_source_of_type (ViewCollection* self,
                                    GType t)
{
	gboolean result;
#line 1174 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 1175 "../src/core/ViewCollection.vala"
	_vala_assert (g_type_is_a (t, TYPE_DATA_SOURCE), "t.is_a(typeof(DataSource))");
#line 7113 "ViewCollection.c"
	{
		GeeIterator* _source_it = NULL;
		GeeHashMap* _tmp0_;
		GeeSet* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeIterator* _tmp4_;
		GeeIterator* _tmp5_;
#line 1177 "../src/core/ViewCollection.vala"
		_tmp0_ = self->priv->source_map;
#line 1177 "../src/core/ViewCollection.vala"
		_tmp1_ = gee_abstract_map_get_keys (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_ABSTRACT_MAP, GeeAbstractMap));
#line 1177 "../src/core/ViewCollection.vala"
		_tmp2_ = _tmp1_;
#line 1177 "../src/core/ViewCollection.vala"
		_tmp3_ = _tmp2_;
#line 1177 "../src/core/ViewCollection.vala"
		_tmp4_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1177 "../src/core/ViewCollection.vala"
		_tmp5_ = _tmp4_;
#line 1177 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp3_);
#line 1177 "../src/core/ViewCollection.vala"
		_source_it = _tmp5_;
#line 1177 "../src/core/ViewCollection.vala"
		while (TRUE) {
#line 7140 "ViewCollection.c"
			GeeIterator* _tmp6_;
			DataSource* source = NULL;
			GeeIterator* _tmp7_;
			gpointer _tmp8_;
			DataSource* _tmp9_;
#line 1177 "../src/core/ViewCollection.vala"
			_tmp6_ = _source_it;
#line 1177 "../src/core/ViewCollection.vala"
			if (!gee_iterator_next (_tmp6_)) {
#line 1177 "../src/core/ViewCollection.vala"
				break;
#line 7152 "ViewCollection.c"
			}
#line 1177 "../src/core/ViewCollection.vala"
			_tmp7_ = _source_it;
#line 1177 "../src/core/ViewCollection.vala"
			_tmp8_ = gee_iterator_get (_tmp7_);
#line 1177 "../src/core/ViewCollection.vala"
			source = (DataSource*) _tmp8_;
#line 1178 "../src/core/ViewCollection.vala"
			_tmp9_ = source;
#line 1178 "../src/core/ViewCollection.vala"
			if (g_type_is_a (G_TYPE_FROM_INSTANCE (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, G_TYPE_OBJECT, GObject)), t)) {
#line 1179 "../src/core/ViewCollection.vala"
				result = TRUE;
#line 1179 "../src/core/ViewCollection.vala"
				_g_object_unref0 (source);
#line 1179 "../src/core/ViewCollection.vala"
				_g_object_unref0 (_source_it);
#line 1179 "../src/core/ViewCollection.vala"
				return result;
#line 7172 "ViewCollection.c"
			}
#line 1177 "../src/core/ViewCollection.vala"
			_g_object_unref0 (source);
#line 7176 "ViewCollection.c"
		}
#line 1177 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_source_it);
#line 7180 "ViewCollection.c"
	}
#line 1182 "../src/core/ViewCollection.vala"
	result = FALSE;
#line 1182 "../src/core/ViewCollection.vala"
	return result;
#line 7186 "ViewCollection.c"
}

gint
view_collection_get_sources_of_type_count (ViewCollection* self,
                                           GType t)
{
	gint count = 0;
	gint result;
#line 1185 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), 0);
#line 1186 "../src/core/ViewCollection.vala"
	_vala_assert (g_type_is_a (t, TYPE_DATA_SOURCE), "t.is_a(typeof(DataSource))");
#line 1188 "../src/core/ViewCollection.vala"
	count = 0;
#line 7201 "ViewCollection.c"
	{
		GeeIterator* _object_it = NULL;
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_;
		GeeIterator* _tmp3_;
#line 1189 "../src/core/ViewCollection.vala"
		_tmp0_ = data_collection_get_all (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 1189 "../src/core/ViewCollection.vala"
		_tmp1_ = _tmp0_;
#line 1189 "../src/core/ViewCollection.vala"
		_tmp2_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1189 "../src/core/ViewCollection.vala"
		_tmp3_ = _tmp2_;
#line 1189 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp1_);
#line 1189 "../src/core/ViewCollection.vala"
		_object_it = _tmp3_;
#line 1189 "../src/core/ViewCollection.vala"
		while (TRUE) {
#line 7222 "ViewCollection.c"
			GeeIterator* _tmp4_;
			DataObject* object = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			DataObject* _tmp7_;
			DataSource* _tmp8_;
			DataSource* _tmp9_;
			gboolean _tmp10_;
#line 1189 "../src/core/ViewCollection.vala"
			_tmp4_ = _object_it;
#line 1189 "../src/core/ViewCollection.vala"
			if (!gee_iterator_next (_tmp4_)) {
#line 1189 "../src/core/ViewCollection.vala"
				break;
#line 7237 "ViewCollection.c"
			}
#line 1189 "../src/core/ViewCollection.vala"
			_tmp5_ = _object_it;
#line 1189 "../src/core/ViewCollection.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 1189 "../src/core/ViewCollection.vala"
			object = (DataObject*) _tmp6_;
#line 1190 "../src/core/ViewCollection.vala"
			_tmp7_ = object;
#line 1190 "../src/core/ViewCollection.vala"
			_tmp8_ = data_view_get_source (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_DATA_VIEW, DataView));
#line 1190 "../src/core/ViewCollection.vala"
			_tmp9_ = _tmp8_;
#line 1190 "../src/core/ViewCollection.vala"
			_tmp10_ = g_type_is_a (G_TYPE_FROM_INSTANCE (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, G_TYPE_OBJECT, GObject)), t);
#line 1190 "../src/core/ViewCollection.vala"
			_g_object_unref0 (_tmp9_);
#line 1190 "../src/core/ViewCollection.vala"
			if (_tmp10_) {
#line 7257 "ViewCollection.c"
				gint _tmp11_;
#line 1191 "../src/core/ViewCollection.vala"
				_tmp11_ = count;
#line 1191 "../src/core/ViewCollection.vala"
				count = _tmp11_ + 1;
#line 7263 "ViewCollection.c"
			}
#line 1189 "../src/core/ViewCollection.vala"
			_g_object_unref0 (object);
#line 7267 "ViewCollection.c"
		}
#line 1189 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_object_it);
#line 7271 "ViewCollection.c"
	}
#line 1194 "../src/core/ViewCollection.vala"
	result = count;
#line 1194 "../src/core/ViewCollection.vala"
	return result;
#line 7277 "ViewCollection.c"
}

GeeList*
view_collection_get_sources_of_type (ViewCollection* self,
                                     GType t)
{
	GeeList* sources = NULL;
	GeeList* result;
#line 1197 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 1198 "../src/core/ViewCollection.vala"
	_vala_assert (g_type_is_a (t, TYPE_DATA_SOURCE), "t.is_a(typeof(DataSource))");
#line 1200 "../src/core/ViewCollection.vala"
	sources = NULL;
#line 7292 "ViewCollection.c"
	{
		GeeIterator* _object_it = NULL;
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
		GeeIterator* _tmp2_;
		GeeIterator* _tmp3_;
#line 1201 "../src/core/ViewCollection.vala"
		_tmp0_ = data_collection_get_all (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 1201 "../src/core/ViewCollection.vala"
		_tmp1_ = _tmp0_;
#line 1201 "../src/core/ViewCollection.vala"
		_tmp2_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1201 "../src/core/ViewCollection.vala"
		_tmp3_ = _tmp2_;
#line 1201 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp1_);
#line 1201 "../src/core/ViewCollection.vala"
		_object_it = _tmp3_;
#line 1201 "../src/core/ViewCollection.vala"
		while (TRUE) {
#line 7313 "ViewCollection.c"
			GeeIterator* _tmp4_;
			DataObject* object = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			DataSource* source = NULL;
			DataObject* _tmp7_;
			DataSource* _tmp8_;
			DataSource* _tmp9_;
#line 1201 "../src/core/ViewCollection.vala"
			_tmp4_ = _object_it;
#line 1201 "../src/core/ViewCollection.vala"
			if (!gee_iterator_next (_tmp4_)) {
#line 1201 "../src/core/ViewCollection.vala"
				break;
#line 7328 "ViewCollection.c"
			}
#line 1201 "../src/core/ViewCollection.vala"
			_tmp5_ = _object_it;
#line 1201 "../src/core/ViewCollection.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 1201 "../src/core/ViewCollection.vala"
			object = (DataObject*) _tmp6_;
#line 1202 "../src/core/ViewCollection.vala"
			_tmp7_ = object;
#line 1202 "../src/core/ViewCollection.vala"
			_tmp8_ = data_view_get_source (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_DATA_VIEW, DataView));
#line 1202 "../src/core/ViewCollection.vala"
			source = _tmp8_;
#line 1203 "../src/core/ViewCollection.vala"
			_tmp9_ = source;
#line 1203 "../src/core/ViewCollection.vala"
			if (g_type_is_a (G_TYPE_FROM_INSTANCE (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, G_TYPE_OBJECT, GObject)), t)) {
#line 7346 "ViewCollection.c"
				GeeList* _tmp10_;
				GeeList* _tmp12_;
				DataSource* _tmp13_;
#line 1204 "../src/core/ViewCollection.vala"
				_tmp10_ = sources;
#line 1204 "../src/core/ViewCollection.vala"
				if (_tmp10_ == NULL) {
#line 7354 "ViewCollection.c"
					GeeArrayList* _tmp11_;
#line 1205 "../src/core/ViewCollection.vala"
					_tmp11_ = gee_array_list_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1205 "../src/core/ViewCollection.vala"
					_g_object_unref0 (sources);
#line 1205 "../src/core/ViewCollection.vala"
					sources = G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, GEE_TYPE_LIST, GeeList);
#line 7362 "ViewCollection.c"
				}
#line 1207 "../src/core/ViewCollection.vala"
				_tmp12_ = sources;
#line 1207 "../src/core/ViewCollection.vala"
				_tmp13_ = source;
#line 1207 "../src/core/ViewCollection.vala"
				gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GEE_TYPE_COLLECTION, GeeCollection), _tmp13_);
#line 7370 "ViewCollection.c"
			}
#line 1201 "../src/core/ViewCollection.vala"
			_g_object_unref0 (source);
#line 1201 "../src/core/ViewCollection.vala"
			_g_object_unref0 (object);
#line 7376 "ViewCollection.c"
		}
#line 1201 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_object_it);
#line 7380 "ViewCollection.c"
	}
#line 1211 "../src/core/ViewCollection.vala"
	result = sources;
#line 1211 "../src/core/ViewCollection.vala"
	return result;
#line 7386 "ViewCollection.c"
}

GeeList*
view_collection_get_selected_sources (ViewCollection* self)
{
	GeeList* sources = NULL;
	GeeArrayList* _tmp0_;
	gint count = 0;
	DataSet* _tmp1_;
	GeeList* result;
#line 1214 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 1215 "../src/core/ViewCollection.vala"
	_tmp0_ = gee_array_list_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1215 "../src/core/ViewCollection.vala"
	sources = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_LIST, GeeList);
#line 1217 "../src/core/ViewCollection.vala"
	_tmp1_ = self->priv->selected;
#line 1217 "../src/core/ViewCollection.vala"
	count = data_set_get_count (_tmp1_);
#line 7407 "ViewCollection.c"
	{
		gint ctr = 0;
#line 1218 "../src/core/ViewCollection.vala"
		ctr = 0;
#line 7412 "ViewCollection.c"
		{
			gboolean _tmp2_ = FALSE;
#line 1218 "../src/core/ViewCollection.vala"
			_tmp2_ = TRUE;
#line 1218 "../src/core/ViewCollection.vala"
			while (TRUE) {
#line 7419 "ViewCollection.c"
				GeeList* _tmp4_;
				DataSet* _tmp5_;
				DataObject* _tmp6_;
				DataView* _tmp7_;
				DataSource* _tmp8_;
				DataSource* _tmp9_;
#line 1218 "../src/core/ViewCollection.vala"
				if (!_tmp2_) {
#line 7428 "ViewCollection.c"
					gint _tmp3_;
#line 1218 "../src/core/ViewCollection.vala"
					_tmp3_ = ctr;
#line 1218 "../src/core/ViewCollection.vala"
					ctr = _tmp3_ + 1;
#line 7434 "ViewCollection.c"
				}
#line 1218 "../src/core/ViewCollection.vala"
				_tmp2_ = FALSE;
#line 1218 "../src/core/ViewCollection.vala"
				if (!(ctr < count)) {
#line 1218 "../src/core/ViewCollection.vala"
					break;
#line 7442 "ViewCollection.c"
				}
#line 1219 "../src/core/ViewCollection.vala"
				_tmp4_ = sources;
#line 1219 "../src/core/ViewCollection.vala"
				_tmp5_ = self->priv->selected;
#line 1219 "../src/core/ViewCollection.vala"
				_tmp6_ = data_set_get_at (_tmp5_, ctr);
#line 1219 "../src/core/ViewCollection.vala"
				_tmp7_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_DATA_VIEW, DataView);
#line 1219 "../src/core/ViewCollection.vala"
				_tmp8_ = data_view_get_source (_tmp7_);
#line 1219 "../src/core/ViewCollection.vala"
				_tmp9_ = _tmp8_;
#line 1219 "../src/core/ViewCollection.vala"
				gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_COLLECTION, GeeCollection), _tmp9_);
#line 1219 "../src/core/ViewCollection.vala"
				_g_object_unref0 (_tmp9_);
#line 1219 "../src/core/ViewCollection.vala"
				_g_object_unref0 (_tmp7_);
#line 7462 "ViewCollection.c"
			}
		}
	}
#line 1221 "../src/core/ViewCollection.vala"
	result = sources;
#line 1221 "../src/core/ViewCollection.vala"
	return result;
#line 7470 "ViewCollection.c"
}

DataSource*
view_collection_get_selected_source_at (ViewCollection* self,
                                        gint index)
{
	DataObject* object = NULL;
	DataSet* _tmp0_;
	DataObject* _tmp1_;
	DataSource* _tmp2_ = NULL;
	DataObject* _tmp3_;
	DataSource* result;
#line 1224 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 1225 "../src/core/ViewCollection.vala"
	_tmp0_ = self->priv->selected;
#line 1225 "../src/core/ViewCollection.vala"
	_tmp1_ = data_set_get_at (_tmp0_, index);
#line 1225 "../src/core/ViewCollection.vala"
	object = _tmp1_;
#line 1227 "../src/core/ViewCollection.vala"
	_tmp3_ = object;
#line 1227 "../src/core/ViewCollection.vala"
	if (_tmp3_ != NULL) {
#line 7495 "ViewCollection.c"
		DataObject* _tmp4_;
		DataSource* _tmp5_;
#line 1227 "../src/core/ViewCollection.vala"
		_tmp4_ = object;
#line 1227 "../src/core/ViewCollection.vala"
		_tmp5_ = data_view_get_source (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_DATA_VIEW, DataView));
#line 1227 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp2_);
#line 1227 "../src/core/ViewCollection.vala"
		_tmp2_ = _tmp5_;
#line 7506 "ViewCollection.c"
	} else {
#line 1227 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp2_);
#line 1227 "../src/core/ViewCollection.vala"
		_tmp2_ = NULL;
#line 7512 "ViewCollection.c"
	}
#line 1227 "../src/core/ViewCollection.vala"
	result = _tmp2_;
#line 1227 "../src/core/ViewCollection.vala"
	_g_object_unref0 (object);
#line 1227 "../src/core/ViewCollection.vala"
	return result;
#line 7520 "ViewCollection.c"
}

GeeList*
view_collection_get_selected_sources_of_type (ViewCollection* self,
                                              GType t)
{
	GeeList* sources = NULL;
	GeeList* result;
#line 1230 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), NULL);
#line 1231 "../src/core/ViewCollection.vala"
	sources = NULL;
#line 7533 "ViewCollection.c"
	{
		GeeList* _view_list = NULL;
		GeeList* _tmp0_;
		gint _view_size = 0;
		GeeList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _view_index = 0;
#line 1232 "../src/core/ViewCollection.vala"
		_tmp0_ = view_collection_get_selected (self);
#line 1232 "../src/core/ViewCollection.vala"
		_view_list = _tmp0_;
#line 1232 "../src/core/ViewCollection.vala"
		_tmp1_ = _view_list;
#line 1232 "../src/core/ViewCollection.vala"
		_tmp2_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1232 "../src/core/ViewCollection.vala"
		_tmp3_ = _tmp2_;
#line 1232 "../src/core/ViewCollection.vala"
		_view_size = _tmp3_;
#line 1232 "../src/core/ViewCollection.vala"
		_view_index = -1;
#line 1232 "../src/core/ViewCollection.vala"
		while (TRUE) {
#line 7558 "ViewCollection.c"
			gint _tmp4_;
			gint _tmp5_;
			DataView* view = NULL;
			GeeList* _tmp6_;
			gpointer _tmp7_;
			DataSource* source = NULL;
			DataView* _tmp8_;
			DataSource* _tmp9_;
			DataSource* _tmp10_;
#line 1232 "../src/core/ViewCollection.vala"
			_view_index = _view_index + 1;
#line 1232 "../src/core/ViewCollection.vala"
			_tmp4_ = _view_index;
#line 1232 "../src/core/ViewCollection.vala"
			_tmp5_ = _view_size;
#line 1232 "../src/core/ViewCollection.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 1232 "../src/core/ViewCollection.vala"
				break;
#line 7578 "ViewCollection.c"
			}
#line 1232 "../src/core/ViewCollection.vala"
			_tmp6_ = _view_list;
#line 1232 "../src/core/ViewCollection.vala"
			_tmp7_ = gee_list_get (_tmp6_, _view_index);
#line 1232 "../src/core/ViewCollection.vala"
			view = (DataView*) _tmp7_;
#line 1233 "../src/core/ViewCollection.vala"
			_tmp8_ = view;
#line 1233 "../src/core/ViewCollection.vala"
			_tmp9_ = data_view_get_source (_tmp8_);
#line 1233 "../src/core/ViewCollection.vala"
			source = _tmp9_;
#line 1234 "../src/core/ViewCollection.vala"
			_tmp10_ = source;
#line 1234 "../src/core/ViewCollection.vala"
			if (g_type_is_a (G_TYPE_FROM_INSTANCE (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, G_TYPE_OBJECT, GObject)), t)) {
#line 7596 "ViewCollection.c"
				GeeList* _tmp11_;
				GeeList* _tmp13_;
				DataSource* _tmp14_;
#line 1235 "../src/core/ViewCollection.vala"
				_tmp11_ = sources;
#line 1235 "../src/core/ViewCollection.vala"
				if (_tmp11_ == NULL) {
#line 7604 "ViewCollection.c"
					GeeArrayList* _tmp12_;
#line 1236 "../src/core/ViewCollection.vala"
					_tmp12_ = gee_array_list_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1236 "../src/core/ViewCollection.vala"
					_g_object_unref0 (sources);
#line 1236 "../src/core/ViewCollection.vala"
					sources = G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GEE_TYPE_LIST, GeeList);
#line 7612 "ViewCollection.c"
				}
#line 1238 "../src/core/ViewCollection.vala"
				_tmp13_ = sources;
#line 1238 "../src/core/ViewCollection.vala"
				_tmp14_ = source;
#line 1238 "../src/core/ViewCollection.vala"
				gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GEE_TYPE_COLLECTION, GeeCollection), _tmp14_);
#line 7620 "ViewCollection.c"
			}
#line 1232 "../src/core/ViewCollection.vala"
			_g_object_unref0 (source);
#line 1232 "../src/core/ViewCollection.vala"
			_g_object_unref0 (view);
#line 7626 "ViewCollection.c"
		}
#line 1232 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_view_list);
#line 7630 "ViewCollection.c"
	}
#line 1242 "../src/core/ViewCollection.vala"
	result = sources;
#line 1242 "../src/core/ViewCollection.vala"
	return result;
#line 7636 "ViewCollection.c"
}

gint
view_collection_index_of_source (ViewCollection* self,
                                 DataSource* source)
{
	DataView* view = NULL;
	DataView* _tmp0_;
	gint _tmp1_ = 0;
	DataView* _tmp2_;
	gint result;
#line 1246 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), 0);
#line 1246 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), 0);
#line 1247 "../src/core/ViewCollection.vala"
	_tmp0_ = view_collection_get_view_for_source (self, source);
#line 1247 "../src/core/ViewCollection.vala"
	view = _tmp0_;
#line 1249 "../src/core/ViewCollection.vala"
	_tmp2_ = view;
#line 1249 "../src/core/ViewCollection.vala"
	if (_tmp2_ != NULL) {
#line 7660 "ViewCollection.c"
		DataView* _tmp3_;
#line 1249 "../src/core/ViewCollection.vala"
		_tmp3_ = view;
#line 1249 "../src/core/ViewCollection.vala"
		_tmp1_ = data_collection_index_of (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_DATA_OBJECT, DataObject));
#line 7666 "ViewCollection.c"
	} else {
#line 1249 "../src/core/ViewCollection.vala"
		_tmp1_ = -1;
#line 7670 "ViewCollection.c"
	}
#line 1249 "../src/core/ViewCollection.vala"
	result = _tmp1_;
#line 1249 "../src/core/ViewCollection.vala"
	_g_object_unref0 (view);
#line 1249 "../src/core/ViewCollection.vala"
	return result;
#line 7678 "ViewCollection.c"
}

void
view_collection_internal_notify_view_altered (ViewCollection* self,
                                              DataView* view)
{
#line 1253 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1253 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 1254 "../src/core/ViewCollection.vala"
	if (!data_collection_are_notifications_frozen (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection))) {
#line 7691 "ViewCollection.c"
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
#line 1255 "../src/core/ViewCollection.vala"
		view_collection_notify_item_view_altered (self, view);
#line 1256 "../src/core/ViewCollection.vala"
		_tmp0_ = data_collection_get_singleton (G_TYPE_CHECK_INSTANCE_CAST (view, TYPE_DATA_OBJECT, DataObject));
#line 1256 "../src/core/ViewCollection.vala"
		_tmp1_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection);
#line 1256 "../src/core/ViewCollection.vala"
		view_collection_notify_views_altered (self, _tmp1_);
#line 1256 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp1_);
#line 7704 "ViewCollection.c"
	} else {
		GeeHashSet* _tmp2_;
		GeeHashSet* _tmp4_;
#line 1258 "../src/core/ViewCollection.vala"
		_tmp2_ = self->priv->frozen_views_altered;
#line 1258 "../src/core/ViewCollection.vala"
		if (_tmp2_ == NULL) {
#line 7712 "ViewCollection.c"
			GeeHashSet* _tmp3_;
#line 1259 "../src/core/ViewCollection.vala"
			_tmp3_ = gee_hash_set_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 1259 "../src/core/ViewCollection.vala"
			_g_object_unref0 (self->priv->frozen_views_altered);
#line 1259 "../src/core/ViewCollection.vala"
			self->priv->frozen_views_altered = _tmp3_;
#line 7720 "ViewCollection.c"
		}
#line 1260 "../src/core/ViewCollection.vala"
		_tmp4_ = self->priv->frozen_views_altered;
#line 1260 "../src/core/ViewCollection.vala"
		gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), view);
#line 7726 "ViewCollection.c"
	}
}

void
view_collection_internal_notify_geometry_altered (ViewCollection* self,
                                                  DataView* view)
{
#line 1265 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_COLLECTION (self));
#line 1265 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 1266 "../src/core/ViewCollection.vala"
	if (!data_collection_are_notifications_frozen (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection))) {
#line 7740 "ViewCollection.c"
		GeeCollection* _tmp0_;
		GeeCollection* _tmp1_;
#line 1267 "../src/core/ViewCollection.vala"
		view_collection_notify_item_geometry_altered (self, view);
#line 1268 "../src/core/ViewCollection.vala"
		_tmp0_ = data_collection_get_singleton (G_TYPE_CHECK_INSTANCE_CAST (view, TYPE_DATA_OBJECT, DataObject));
#line 1268 "../src/core/ViewCollection.vala"
		_tmp1_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_COLLECTION, GeeCollection);
#line 1268 "../src/core/ViewCollection.vala"
		view_collection_notify_geometries_altered (self, _tmp1_);
#line 1268 "../src/core/ViewCollection.vala"
		_g_object_unref0 (_tmp1_);
#line 7753 "ViewCollection.c"
	} else {
		GeeHashSet* _tmp2_;
		GeeHashSet* _tmp4_;
#line 1270 "../src/core/ViewCollection.vala"
		_tmp2_ = self->priv->frozen_geometries_altered;
#line 1270 "../src/core/ViewCollection.vala"
		if (_tmp2_ == NULL) {
#line 7761 "ViewCollection.c"
			GeeHashSet* _tmp3_;
#line 1271 "../src/core/ViewCollection.vala"
			_tmp3_ = gee_hash_set_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 1271 "../src/core/ViewCollection.vala"
			_g_object_unref0 (self->priv->frozen_geometries_altered);
#line 1271 "../src/core/ViewCollection.vala"
			self->priv->frozen_geometries_altered = _tmp3_;
#line 7769 "ViewCollection.c"
		}
#line 1272 "../src/core/ViewCollection.vala"
		_tmp4_ = self->priv->frozen_geometries_altered;
#line 1272 "../src/core/ViewCollection.vala"
		gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), view);
#line 7775 "ViewCollection.c"
	}
}

static void
view_collection_real_notify_thawed (DataCollection* base)
{
	ViewCollection * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp8_;
#line 1276 "../src/core/ViewCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_VIEW_COLLECTION, ViewCollection);
#line 1277 "../src/core/ViewCollection.vala"
	_tmp0_ = self->priv->frozen_views_altered;
#line 1277 "../src/core/ViewCollection.vala"
	if (_tmp0_ != NULL) {
#line 7791 "ViewCollection.c"
		GeeHashSet* _tmp7_;
		{
			GeeIterator* _view_it = NULL;
			GeeHashSet* _tmp1_;
			GeeIterator* _tmp2_;
#line 1278 "../src/core/ViewCollection.vala"
			_tmp1_ = self->priv->frozen_views_altered;
#line 1278 "../src/core/ViewCollection.vala"
			_tmp2_ = gee_abstract_collection_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 1278 "../src/core/ViewCollection.vala"
			_view_it = _tmp2_;
#line 1278 "../src/core/ViewCollection.vala"
			while (TRUE) {
#line 7805 "ViewCollection.c"
				GeeIterator* _tmp3_;
				DataView* view = NULL;
				GeeIterator* _tmp4_;
				gpointer _tmp5_;
				DataView* _tmp6_;
#line 1278 "../src/core/ViewCollection.vala"
				_tmp3_ = _view_it;
#line 1278 "../src/core/ViewCollection.vala"
				if (!gee_iterator_next (_tmp3_)) {
#line 1278 "../src/core/ViewCollection.vala"
					break;
#line 7817 "ViewCollection.c"
				}
#line 1278 "../src/core/ViewCollection.vala"
				_tmp4_ = _view_it;
#line 1278 "../src/core/ViewCollection.vala"
				_tmp5_ = gee_iterator_get (_tmp4_);
#line 1278 "../src/core/ViewCollection.vala"
				view = (DataView*) _tmp5_;
#line 1279 "../src/core/ViewCollection.vala"
				_tmp6_ = view;
#line 1279 "../src/core/ViewCollection.vala"
				view_collection_notify_item_view_altered (self, _tmp6_);
#line 1278 "../src/core/ViewCollection.vala"
				_g_object_unref0 (view);
#line 7831 "ViewCollection.c"
			}
#line 1278 "../src/core/ViewCollection.vala"
			_g_object_unref0 (_view_it);
#line 7835 "ViewCollection.c"
		}
#line 1280 "../src/core/ViewCollection.vala"
		_tmp7_ = self->priv->frozen_views_altered;
#line 1280 "../src/core/ViewCollection.vala"
		view_collection_notify_views_altered (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1281 "../src/core/ViewCollection.vala"
		_g_object_unref0 (self->priv->frozen_views_altered);
#line 1281 "../src/core/ViewCollection.vala"
		self->priv->frozen_views_altered = NULL;
#line 7845 "ViewCollection.c"
	}
#line 1284 "../src/core/ViewCollection.vala"
	_tmp8_ = self->priv->frozen_geometries_altered;
#line 1284 "../src/core/ViewCollection.vala"
	if (_tmp8_ != NULL) {
#line 7851 "ViewCollection.c"
		GeeHashSet* _tmp15_;
		{
			GeeIterator* _view_it = NULL;
			GeeHashSet* _tmp9_;
			GeeIterator* _tmp10_;
#line 1285 "../src/core/ViewCollection.vala"
			_tmp9_ = self->priv->frozen_geometries_altered;
#line 1285 "../src/core/ViewCollection.vala"
			_tmp10_ = gee_abstract_collection_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 1285 "../src/core/ViewCollection.vala"
			_view_it = _tmp10_;
#line 1285 "../src/core/ViewCollection.vala"
			while (TRUE) {
#line 7865 "ViewCollection.c"
				GeeIterator* _tmp11_;
				DataView* view = NULL;
				GeeIterator* _tmp12_;
				gpointer _tmp13_;
				DataView* _tmp14_;
#line 1285 "../src/core/ViewCollection.vala"
				_tmp11_ = _view_it;
#line 1285 "../src/core/ViewCollection.vala"
				if (!gee_iterator_next (_tmp11_)) {
#line 1285 "../src/core/ViewCollection.vala"
					break;
#line 7877 "ViewCollection.c"
				}
#line 1285 "../src/core/ViewCollection.vala"
				_tmp12_ = _view_it;
#line 1285 "../src/core/ViewCollection.vala"
				_tmp13_ = gee_iterator_get (_tmp12_);
#line 1285 "../src/core/ViewCollection.vala"
				view = (DataView*) _tmp13_;
#line 1286 "../src/core/ViewCollection.vala"
				_tmp14_ = view;
#line 1286 "../src/core/ViewCollection.vala"
				view_collection_notify_item_geometry_altered (self, _tmp14_);
#line 1285 "../src/core/ViewCollection.vala"
				_g_object_unref0 (view);
#line 7891 "ViewCollection.c"
			}
#line 1285 "../src/core/ViewCollection.vala"
			_g_object_unref0 (_view_it);
#line 7895 "ViewCollection.c"
		}
#line 1287 "../src/core/ViewCollection.vala"
		_tmp15_ = self->priv->frozen_geometries_altered;
#line 1287 "../src/core/ViewCollection.vala"
		view_collection_notify_geometries_altered (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1288 "../src/core/ViewCollection.vala"
		_g_object_unref0 (self->priv->frozen_geometries_altered);
#line 1288 "../src/core/ViewCollection.vala"
		self->priv->frozen_geometries_altered = NULL;
#line 7905 "ViewCollection.c"
	}
#line 1291 "../src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->notify_thawed (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 7909 "ViewCollection.c"
}

gboolean
view_collection_are_items_filtered_out (ViewCollection* self)
{
	gboolean result;
#line 1294 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (self), FALSE);
#line 1295 "../src/core/ViewCollection.vala"
	result = DATA_COLLECTION_CLASS (view_collection_parent_class)->get_count (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection)) != data_collection_get_count (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DATA_COLLECTION, DataCollection));
#line 1295 "../src/core/ViewCollection.vala"
	return result;
#line 7922 "ViewCollection.c"
}

static void
view_collection_real_items_selected (ViewCollection* self,
                                     GeeIterable* selected)
{
#line 75 "../src/core/ViewCollection.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (selected, GEE_TYPE_ITERABLE));
#line 7931 "ViewCollection.c"
}

static void
view_collection_real_items_unselected (ViewCollection* self,
                                       GeeIterable* unselected)
{
#line 79 "../src/core/ViewCollection.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (unselected, GEE_TYPE_ITERABLE));
#line 7940 "ViewCollection.c"
}

static void
view_collection_real_items_state_changed (ViewCollection* self,
                                          GeeIterable* changed)
{
#line 83 "../src/core/ViewCollection.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (changed, GEE_TYPE_ITERABLE));
#line 7949 "ViewCollection.c"
}

static void
view_collection_real_selection_group_altered (ViewCollection* self)
{
}

static void
view_collection_real_items_shown (ViewCollection* self,
                                  GeeCollection* visible)
{
#line 94 "../src/core/ViewCollection.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (visible, GEE_TYPE_COLLECTION));
#line 7963 "ViewCollection.c"
}

static void
view_collection_real_items_hidden (ViewCollection* self,
                                   GeeCollection* hidden)
{
#line 98 "../src/core/ViewCollection.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (hidden, GEE_TYPE_COLLECTION));
#line 7972 "ViewCollection.c"
}

static void
view_collection_real_items_visibility_changed (ViewCollection* self,
                                               GeeCollection* changed)
{
#line 102 "../src/core/ViewCollection.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (changed, GEE_TYPE_COLLECTION));
#line 7981 "ViewCollection.c"
}

static void
view_collection_real_item_view_altered (ViewCollection* self,
                                        DataView* view)
{
#line 106 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 7990 "ViewCollection.c"
}

static void
view_collection_real_item_geometry_altered (ViewCollection* self,
                                            DataView* view)
{
#line 110 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_DATA_VIEW (view));
#line 7999 "ViewCollection.c"
}

static void
view_collection_real_views_altered (ViewCollection* self,
                                    GeeCollection* views)
{
#line 113 "../src/core/ViewCollection.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (views, GEE_TYPE_COLLECTION));
#line 8008 "ViewCollection.c"
}

static void
view_collection_real_geometries_altered (ViewCollection* self,
                                         GeeCollection* views)
{
#line 116 "../src/core/ViewCollection.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (views, GEE_TYPE_COLLECTION));
#line 8017 "ViewCollection.c"
}

static void
view_collection_real_view_filter_installed (ViewCollection* self,
                                            ViewFilter* filer)
{
#line 119 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_FILTER (filer));
#line 8026 "ViewCollection.c"
}

static void
g_cclosure_user_marshal_VOID__VIEW_FILTER (GClosure * closure,
                                           GValue * return_value,
                                           guint n_param_values,
                                           const GValue * param_values,
                                           gpointer invocation_hint,
                                           gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__VIEW_FILTER) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_VOID__VIEW_FILTER callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 21 "../src/core/ViewCollection.vala"
	g_return_if_fail (n_param_values == 2);
#line 21 "../src/core/ViewCollection.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 21 "../src/core/ViewCollection.vala"
		data1 = closure->data;
#line 21 "../src/core/ViewCollection.vala"
		data2 = param_values->data[0].v_pointer;
#line 8051 "ViewCollection.c"
	} else {
#line 21 "../src/core/ViewCollection.vala"
		data1 = param_values->data[0].v_pointer;
#line 21 "../src/core/ViewCollection.vala"
		data2 = closure->data;
#line 8057 "ViewCollection.c"
	}
#line 21 "../src/core/ViewCollection.vala"
	callback = (GMarshalFunc_VOID__VIEW_FILTER) (marshal_data ? marshal_data : cc->callback);
#line 21 "../src/core/ViewCollection.vala"
	callback (data1, value_get_view_filter (param_values + 1), data2);
#line 8063 "ViewCollection.c"
}

static void
view_collection_real_view_filter_removed (ViewCollection* self,
                                          ViewFilter* filer)
{
#line 122 "../src/core/ViewCollection.vala"
	g_return_if_fail (IS_VIEW_FILTER (filer));
#line 8072 "ViewCollection.c"
}

ViewCollectionMonitor*
view_collection_monitor_construct (GType object_type)
{
	ViewCollectionMonitor* self = NULL;
#line 22 "../src/core/ViewCollection.vala"
	self = (ViewCollectionMonitor*) g_type_create_instance (object_type);
#line 22 "../src/core/ViewCollection.vala"
	return self;
#line 8083 "ViewCollection.c"
}

ViewCollectionMonitor*
view_collection_monitor_new (void)
{
#line 22 "../src/core/ViewCollection.vala"
	return view_collection_monitor_construct (VIEW_COLLECTION_TYPE_MONITOR);
#line 8091 "ViewCollection.c"
}

static void
view_collection_value_monitor_init (GValue* value)
{
#line 22 "../src/core/ViewCollection.vala"
	value->data[0].v_pointer = NULL;
#line 8099 "ViewCollection.c"
}

static void
view_collection_value_monitor_free_value (GValue* value)
{
#line 22 "../src/core/ViewCollection.vala"
	if (value->data[0].v_pointer) {
#line 22 "../src/core/ViewCollection.vala"
		view_collection_monitor_unref (value->data[0].v_pointer);
#line 8109 "ViewCollection.c"
	}
}

static void
view_collection_value_monitor_copy_value (const GValue* src_value,
                                          GValue* dest_value)
{
#line 22 "../src/core/ViewCollection.vala"
	if (src_value->data[0].v_pointer) {
#line 22 "../src/core/ViewCollection.vala"
		dest_value->data[0].v_pointer = view_collection_monitor_ref (src_value->data[0].v_pointer);
#line 8121 "ViewCollection.c"
	} else {
#line 22 "../src/core/ViewCollection.vala"
		dest_value->data[0].v_pointer = NULL;
#line 8125 "ViewCollection.c"
	}
}

static gpointer
view_collection_value_monitor_peek_pointer (const GValue* value)
{
#line 22 "../src/core/ViewCollection.vala"
	return value->data[0].v_pointer;
#line 8134 "ViewCollection.c"
}

static gchar*
view_collection_value_monitor_collect_value (GValue* value,
                                             guint n_collect_values,
                                             GTypeCValue* collect_values,
                                             guint collect_flags)
{
#line 22 "../src/core/ViewCollection.vala"
	if (collect_values[0].v_pointer) {
#line 8145 "ViewCollection.c"
		ViewCollectionMonitor * object;
		object = collect_values[0].v_pointer;
#line 22 "../src/core/ViewCollection.vala"
		if (object->parent_instance.g_class == NULL) {
#line 22 "../src/core/ViewCollection.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 8152 "ViewCollection.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 22 "../src/core/ViewCollection.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 8156 "ViewCollection.c"
		}
#line 22 "../src/core/ViewCollection.vala"
		value->data[0].v_pointer = view_collection_monitor_ref (object);
#line 8160 "ViewCollection.c"
	} else {
#line 22 "../src/core/ViewCollection.vala"
		value->data[0].v_pointer = NULL;
#line 8164 "ViewCollection.c"
	}
#line 22 "../src/core/ViewCollection.vala"
	return NULL;
#line 8168 "ViewCollection.c"
}

static gchar*
view_collection_value_monitor_lcopy_value (const GValue* value,
                                           guint n_collect_values,
                                           GTypeCValue* collect_values,
                                           guint collect_flags)
{
	ViewCollectionMonitor ** object_p;
	object_p = collect_values[0].v_pointer;
#line 22 "../src/core/ViewCollection.vala"
	if (!object_p) {
#line 22 "../src/core/ViewCollection.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 8183 "ViewCollection.c"
	}
#line 22 "../src/core/ViewCollection.vala"
	if (!value->data[0].v_pointer) {
#line 22 "../src/core/ViewCollection.vala"
		*object_p = NULL;
#line 8189 "ViewCollection.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 22 "../src/core/ViewCollection.vala"
		*object_p = value->data[0].v_pointer;
#line 8193 "ViewCollection.c"
	} else {
#line 22 "../src/core/ViewCollection.vala"
		*object_p = view_collection_monitor_ref (value->data[0].v_pointer);
#line 8197 "ViewCollection.c"
	}
#line 22 "../src/core/ViewCollection.vala"
	return NULL;
#line 8201 "ViewCollection.c"
}

GParamSpec*
view_collection_param_spec_monitor (const gchar* name,
                                    const gchar* nick,
                                    const gchar* blurb,
                                    GType object_type,
                                    GParamFlags flags)
{
	ViewCollectionParamSpecMonitor* spec;
#line 22 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (g_type_is_a (object_type, VIEW_COLLECTION_TYPE_MONITOR), NULL);
#line 22 "../src/core/ViewCollection.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 22 "../src/core/ViewCollection.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 22 "../src/core/ViewCollection.vala"
	return G_PARAM_SPEC (spec);
#line 8220 "ViewCollection.c"
}

gpointer
view_collection_value_get_monitor (const GValue* value)
{
#line 22 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, VIEW_COLLECTION_TYPE_MONITOR), NULL);
#line 22 "../src/core/ViewCollection.vala"
	return value->data[0].v_pointer;
#line 8230 "ViewCollection.c"
}

void
view_collection_value_set_monitor (GValue* value,
                                   gpointer v_object)
{
	ViewCollectionMonitor * old;
#line 22 "../src/core/ViewCollection.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, VIEW_COLLECTION_TYPE_MONITOR));
#line 22 "../src/core/ViewCollection.vala"
	old = value->data[0].v_pointer;
#line 22 "../src/core/ViewCollection.vala"
	if (v_object) {
#line 22 "../src/core/ViewCollection.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, VIEW_COLLECTION_TYPE_MONITOR));
#line 22 "../src/core/ViewCollection.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 22 "../src/core/ViewCollection.vala"
		value->data[0].v_pointer = v_object;
#line 22 "../src/core/ViewCollection.vala"
		view_collection_monitor_ref (value->data[0].v_pointer);
#line 8252 "ViewCollection.c"
	} else {
#line 22 "../src/core/ViewCollection.vala"
		value->data[0].v_pointer = NULL;
#line 8256 "ViewCollection.c"
	}
#line 22 "../src/core/ViewCollection.vala"
	if (old) {
#line 22 "../src/core/ViewCollection.vala"
		view_collection_monitor_unref (old);
#line 8262 "ViewCollection.c"
	}
}

void
view_collection_value_take_monitor (GValue* value,
                                    gpointer v_object)
{
	ViewCollectionMonitor * old;
#line 22 "../src/core/ViewCollection.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, VIEW_COLLECTION_TYPE_MONITOR));
#line 22 "../src/core/ViewCollection.vala"
	old = value->data[0].v_pointer;
#line 22 "../src/core/ViewCollection.vala"
	if (v_object) {
#line 22 "../src/core/ViewCollection.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, VIEW_COLLECTION_TYPE_MONITOR));
#line 22 "../src/core/ViewCollection.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 22 "../src/core/ViewCollection.vala"
		value->data[0].v_pointer = v_object;
#line 8283 "ViewCollection.c"
	} else {
#line 22 "../src/core/ViewCollection.vala"
		value->data[0].v_pointer = NULL;
#line 8287 "ViewCollection.c"
	}
#line 22 "../src/core/ViewCollection.vala"
	if (old) {
#line 22 "../src/core/ViewCollection.vala"
		view_collection_monitor_unref (old);
#line 8293 "ViewCollection.c"
	}
}

static void
view_collection_monitor_class_init (ViewCollectionMonitorClass * klass,
                                    gpointer klass_data)
{
#line 22 "../src/core/ViewCollection.vala"
	view_collection_monitor_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/core/ViewCollection.vala"
	((ViewCollectionMonitorClass *) klass)->finalize = view_collection_monitor_finalize;
#line 8305 "ViewCollection.c"
}

static void
view_collection_monitor_instance_init (ViewCollectionMonitor * self,
                                       gpointer klass)
{
#line 22 "../src/core/ViewCollection.vala"
	self->ref_count = 1;
#line 8314 "ViewCollection.c"
}

static void
view_collection_monitor_finalize (ViewCollectionMonitor * obj)
{
	ViewCollectionMonitor * self;
#line 22 "../src/core/ViewCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VIEW_COLLECTION_TYPE_MONITOR, ViewCollectionMonitor);
#line 22 "../src/core/ViewCollection.vala"
	g_signal_handlers_destroy (self);
#line 8325 "ViewCollection.c"
}

static GType
view_collection_monitor_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { view_collection_value_monitor_init, view_collection_value_monitor_free_value, view_collection_value_monitor_copy_value, view_collection_value_monitor_peek_pointer, "p", view_collection_value_monitor_collect_value, "p", view_collection_value_monitor_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (ViewCollectionMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) view_collection_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ViewCollectionMonitor), 0, (GInstanceInitFunc) view_collection_monitor_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType view_collection_monitor_type_id;
	view_collection_monitor_type_id = g_type_register_fundamental (g_type_fundamental_next (), "ViewCollectionMonitor", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return view_collection_monitor_type_id;
}

GType
view_collection_monitor_get_type (void)
{
	static volatile gsize view_collection_monitor_type_id__once = 0;
	if (g_once_init_enter (&view_collection_monitor_type_id__once)) {
		GType view_collection_monitor_type_id;
		view_collection_monitor_type_id = view_collection_monitor_get_type_once ();
		g_once_init_leave (&view_collection_monitor_type_id__once, view_collection_monitor_type_id);
	}
	return view_collection_monitor_type_id__once;
}

gpointer
view_collection_monitor_ref (gpointer instance)
{
	ViewCollectionMonitor * self;
	self = instance;
#line 22 "../src/core/ViewCollection.vala"
	g_atomic_int_inc (&self->ref_count);
#line 22 "../src/core/ViewCollection.vala"
	return instance;
#line 8360 "ViewCollection.c"
}

void
view_collection_monitor_unref (gpointer instance)
{
	ViewCollectionMonitor * self;
	self = instance;
#line 22 "../src/core/ViewCollection.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 22 "../src/core/ViewCollection.vala"
		VIEW_COLLECTION_MONITOR_GET_CLASS (self)->finalize (self);
#line 22 "../src/core/ViewCollection.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 8374 "ViewCollection.c"
	}
}

static void
_view_collection_on_sources_added_data_collection_items_added (DataCollection* _sender,
                                                               GeeIterable* added,
                                                               gpointer self)
{
#line 44 "../src/core/ViewCollection.vala"
	view_collection_on_sources_added ((ViewCollection*) self, _sender, added);
#line 8385 "ViewCollection.c"
}

static void
_view_collection_on_sources_removed_data_collection_items_removed (DataCollection* _sender,
                                                                   GeeIterable* removed,
                                                                   gpointer self)
{
#line 45 "../src/core/ViewCollection.vala"
	view_collection_on_sources_removed ((ViewCollection*) self, removed);
#line 8395 "ViewCollection.c"
}

static void
_view_collection_on_sources_altered_data_collection_items_altered (DataCollection* _sender,
                                                                   GeeMap* items,
                                                                   gpointer self)
{
#line 46 "../src/core/ViewCollection.vala"
	view_collection_on_sources_altered ((ViewCollection*) self, _sender, items);
#line 8405 "ViewCollection.c"
}

static gpointer
_view_manager_ref0 (gpointer self)
{
#line 35 "../src/core/ViewCollection.vala"
	return self ? view_manager_ref (self) : NULL;
#line 8413 "ViewCollection.c"
}

static gpointer
_alteration_ref0 (gpointer self)
{
#line 36 "../src/core/ViewCollection.vala"
	return self ? alteration_ref (self) : NULL;
#line 8421 "ViewCollection.c"
}

static ViewCollectionMonitorImpl*
view_collection_monitor_impl_construct (GType object_type,
                                        ViewCollection* owner,
                                        SourceCollection* sources,
                                        ViewManager* manager,
                                        Alteration* prereq)
{
	ViewCollectionMonitorImpl* self = NULL;
	ViewCollection* _tmp0_;
	SourceCollection* _tmp1_;
	ViewManager* _tmp2_;
	Alteration* _tmp3_;
#line 31 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_COLLECTION (owner), NULL);
#line 31 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_SOURCE_COLLECTION (sources), NULL);
#line 31 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_MANAGER (manager), NULL);
#line 31 "../src/core/ViewCollection.vala"
	g_return_val_if_fail ((prereq == NULL) || IS_ALTERATION (prereq), NULL);
#line 31 "../src/core/ViewCollection.vala"
	self = (ViewCollectionMonitorImpl*) view_collection_monitor_construct (object_type);
#line 33 "../src/core/ViewCollection.vala"
	_tmp0_ = _data_collection_ref0 (owner);
#line 33 "../src/core/ViewCollection.vala"
	_data_collection_unref0 (self->owner);
#line 33 "../src/core/ViewCollection.vala"
	self->owner = _tmp0_;
#line 34 "../src/core/ViewCollection.vala"
	_tmp1_ = _data_collection_ref0 (sources);
#line 34 "../src/core/ViewCollection.vala"
	_data_collection_unref0 (self->sources);
#line 34 "../src/core/ViewCollection.vala"
	self->sources = _tmp1_;
#line 35 "../src/core/ViewCollection.vala"
	_tmp2_ = _view_manager_ref0 (manager);
#line 35 "../src/core/ViewCollection.vala"
	_view_manager_unref0 (self->manager);
#line 35 "../src/core/ViewCollection.vala"
	self->manager = _tmp2_;
#line 36 "../src/core/ViewCollection.vala"
	_tmp3_ = _alteration_ref0 (prereq);
#line 36 "../src/core/ViewCollection.vala"
	_alteration_unref0 (self->prereq);
#line 36 "../src/core/ViewCollection.vala"
	self->prereq = _tmp3_;
#line 38 "../src/core/ViewCollection.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (sources, TYPE_DATA_COLLECTION, DataCollection), "items-added", (GCallback) _view_collection_on_sources_added_data_collection_items_added, owner);
#line 39 "../src/core/ViewCollection.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (sources, TYPE_DATA_COLLECTION, DataCollection), "items-removed", (GCallback) _view_collection_on_sources_removed_data_collection_items_removed, owner);
#line 40 "../src/core/ViewCollection.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (sources, TYPE_DATA_COLLECTION, DataCollection), "items-altered", (GCallback) _view_collection_on_sources_altered_data_collection_items_altered, owner);
#line 31 "../src/core/ViewCollection.vala"
	return self;
#line 8478 "ViewCollection.c"
}

static ViewCollectionMonitorImpl*
view_collection_monitor_impl_new (ViewCollection* owner,
                                  SourceCollection* sources,
                                  ViewManager* manager,
                                  Alteration* prereq)
{
#line 31 "../src/core/ViewCollection.vala"
	return view_collection_monitor_impl_construct (VIEW_COLLECTION_TYPE_MONITOR_IMPL, owner, sources, manager, prereq);
#line 8489 "ViewCollection.c"
}

static void
view_collection_monitor_impl_class_init (ViewCollectionMonitorImplClass * klass,
                                         gpointer klass_data)
{
#line 25 "../src/core/ViewCollection.vala"
	view_collection_monitor_impl_parent_class = g_type_class_peek_parent (klass);
#line 25 "../src/core/ViewCollection.vala"
	((ViewCollectionMonitorClass *) klass)->finalize = view_collection_monitor_impl_finalize;
#line 8500 "ViewCollection.c"
}

static void
view_collection_monitor_impl_instance_init (ViewCollectionMonitorImpl * self,
                                            gpointer klass)
{
}

static void
view_collection_monitor_impl_finalize (ViewCollectionMonitor * obj)
{
	ViewCollectionMonitorImpl * self;
	SourceCollection* _tmp0_;
	ViewCollection* _tmp1_;
	guint _tmp2_;
	SourceCollection* _tmp3_;
	ViewCollection* _tmp4_;
	guint _tmp5_;
	SourceCollection* _tmp6_;
	ViewCollection* _tmp7_;
	guint _tmp8_;
#line 25 "../src/core/ViewCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VIEW_COLLECTION_TYPE_MONITOR_IMPL, ViewCollectionMonitorImpl);
#line 44 "../src/core/ViewCollection.vala"
	_tmp0_ = self->sources;
#line 44 "../src/core/ViewCollection.vala"
	_tmp1_ = self->owner;
#line 44 "../src/core/ViewCollection.vala"
	g_signal_parse_name ("items-added", TYPE_DATA_COLLECTION, &_tmp2_, NULL, FALSE);
#line 44 "../src/core/ViewCollection.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, TYPE_DATA_COLLECTION, DataCollection), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _view_collection_on_sources_added_data_collection_items_added, _tmp1_);
#line 45 "../src/core/ViewCollection.vala"
	_tmp3_ = self->sources;
#line 45 "../src/core/ViewCollection.vala"
	_tmp4_ = self->owner;
#line 45 "../src/core/ViewCollection.vala"
	g_signal_parse_name ("items-removed", TYPE_DATA_COLLECTION, &_tmp5_, NULL, FALSE);
#line 45 "../src/core/ViewCollection.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_DATA_COLLECTION, DataCollection), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _view_collection_on_sources_removed_data_collection_items_removed, _tmp4_);
#line 46 "../src/core/ViewCollection.vala"
	_tmp6_ = self->sources;
#line 46 "../src/core/ViewCollection.vala"
	_tmp7_ = self->owner;
#line 46 "../src/core/ViewCollection.vala"
	g_signal_parse_name ("items-altered", TYPE_DATA_COLLECTION, &_tmp8_, NULL, FALSE);
#line 46 "../src/core/ViewCollection.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_DATA_COLLECTION, DataCollection), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp8_, 0, NULL, (GCallback) _view_collection_on_sources_altered_data_collection_items_altered, _tmp7_);
#line 26 "../src/core/ViewCollection.vala"
	_data_collection_unref0 (self->owner);
#line 27 "../src/core/ViewCollection.vala"
	_data_collection_unref0 (self->sources);
#line 28 "../src/core/ViewCollection.vala"
	_view_manager_unref0 (self->manager);
#line 29 "../src/core/ViewCollection.vala"
	_alteration_unref0 (self->prereq);
#line 25 "../src/core/ViewCollection.vala"
	VIEW_COLLECTION_MONITOR_CLASS (view_collection_monitor_impl_parent_class)->finalize (obj);
#line 8558 "ViewCollection.c"
}

static GType
view_collection_monitor_impl_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ViewCollectionMonitorImplClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) view_collection_monitor_impl_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ViewCollectionMonitorImpl), 0, (GInstanceInitFunc) view_collection_monitor_impl_instance_init, NULL };
	GType view_collection_monitor_impl_type_id;
	view_collection_monitor_impl_type_id = g_type_register_static (VIEW_COLLECTION_TYPE_MONITOR, "ViewCollectionMonitorImpl", &g_define_type_info, 0);
	return view_collection_monitor_impl_type_id;
}

static GType
view_collection_monitor_impl_get_type (void)
{
	static volatile gsize view_collection_monitor_impl_type_id__once = 0;
	if (g_once_init_enter (&view_collection_monitor_impl_type_id__once)) {
		GType view_collection_monitor_impl_type_id;
		view_collection_monitor_impl_type_id = view_collection_monitor_impl_get_type_once ();
		g_once_init_leave (&view_collection_monitor_impl_type_id__once, view_collection_monitor_impl_type_id);
	}
	return view_collection_monitor_impl_type_id__once;
}

static ViewCollectionToggleLists*
view_collection_toggle_lists_construct (GType object_type)
{
	ViewCollectionToggleLists * self = NULL;
#line 50 "../src/core/ViewCollection.vala"
	self = (ViewCollectionToggleLists*) g_object_new (object_type, NULL);
#line 50 "../src/core/ViewCollection.vala"
	return self;
#line 8590 "ViewCollection.c"
}

static ViewCollectionToggleLists*
view_collection_toggle_lists_new (void)
{
#line 50 "../src/core/ViewCollection.vala"
	return view_collection_toggle_lists_construct (VIEW_COLLECTION_TYPE_TOGGLE_LISTS);
#line 8598 "ViewCollection.c"
}

static void
view_collection_toggle_lists_class_init (ViewCollectionToggleListsClass * klass,
                                         gpointer klass_data)
{
#line 50 "../src/core/ViewCollection.vala"
	view_collection_toggle_lists_parent_class = g_type_class_peek_parent (klass);
#line 50 "../src/core/ViewCollection.vala"
	G_OBJECT_CLASS (klass)->finalize = view_collection_toggle_lists_finalize;
#line 8609 "ViewCollection.c"
}

static void
view_collection_toggle_lists_instance_init (ViewCollectionToggleLists * self,
                                            gpointer klass)
{
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
#line 51 "../src/core/ViewCollection.vala"
	_tmp0_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 51 "../src/core/ViewCollection.vala"
	self->selected = _tmp0_;
#line 52 "../src/core/ViewCollection.vala"
	_tmp1_ = gee_array_list_new (TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 52 "../src/core/ViewCollection.vala"
	self->unselected = _tmp1_;
#line 8626 "ViewCollection.c"
}

static void
view_collection_toggle_lists_finalize (GObject * obj)
{
	ViewCollectionToggleLists * self;
#line 50 "../src/core/ViewCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VIEW_COLLECTION_TYPE_TOGGLE_LISTS, ViewCollectionToggleLists);
#line 51 "../src/core/ViewCollection.vala"
	_g_object_unref0 (self->selected);
#line 52 "../src/core/ViewCollection.vala"
	_g_object_unref0 (self->unselected);
#line 50 "../src/core/ViewCollection.vala"
	G_OBJECT_CLASS (view_collection_toggle_lists_parent_class)->finalize (obj);
#line 8641 "ViewCollection.c"
}

static GType
view_collection_toggle_lists_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ViewCollectionToggleListsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) view_collection_toggle_lists_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ViewCollectionToggleLists), 0, (GInstanceInitFunc) view_collection_toggle_lists_instance_init, NULL };
	GType view_collection_toggle_lists_type_id;
	view_collection_toggle_lists_type_id = g_type_register_static (G_TYPE_OBJECT, "ViewCollectionToggleLists", &g_define_type_info, 0);
	return view_collection_toggle_lists_type_id;
}

static GType
view_collection_toggle_lists_get_type (void)
{
	static volatile gsize view_collection_toggle_lists_type_id__once = 0;
	if (g_once_init_enter (&view_collection_toggle_lists_type_id__once)) {
		GType view_collection_toggle_lists_type_id;
		view_collection_toggle_lists_type_id = view_collection_toggle_lists_get_type_once ();
		g_once_init_leave (&view_collection_toggle_lists_type_id__once, view_collection_toggle_lists_type_id);
	}
	return view_collection_toggle_lists_type_id__once;
}

static void
view_collection_class_init (ViewCollectionClass * klass,
                            gpointer klass_data)
{
#line 21 "../src/core/ViewCollection.vala"
	view_collection_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/core/ViewCollection.vala"
	((DataCollectionClass *) klass)->finalize = view_collection_finalize;
#line 21 "../src/core/ViewCollection.vala"
	g_type_class_adjust_private_offset (klass, &ViewCollection_private_offset);
#line 21 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->notify_items_selected_unselected = (void (*) (ViewCollection*, GeeCollection*, GeeCollection*)) view_collection_real_notify_items_selected_unselected;
#line 21 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->notify_selection_group_altered = (void (*) (ViewCollection*)) view_collection_real_notify_selection_group_altered;
#line 21 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->notify_item_view_altered = (void (*) (ViewCollection*, DataView*)) view_collection_real_notify_item_view_altered;
#line 21 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->notify_views_altered = (void (*) (ViewCollection*, GeeCollection*)) view_collection_real_notify_views_altered;
#line 21 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->notify_item_geometry_altered = (void (*) (ViewCollection*, DataView*)) view_collection_real_notify_item_geometry_altered;
#line 21 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->notify_geometries_altered = (void (*) (ViewCollection*, GeeCollection*)) view_collection_real_notify_geometries_altered;
#line 21 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->notify_items_shown = (void (*) (ViewCollection*, GeeCollection*)) view_collection_real_notify_items_shown;
#line 21 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->notify_items_hidden = (void (*) (ViewCollection*, GeeCollection*)) view_collection_real_notify_items_hidden;
#line 21 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->notify_items_visibility_changed = (void (*) (ViewCollection*, GeeCollection*)) view_collection_real_notify_items_visibility_changed;
#line 21 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->notify_view_filter_installed = (void (*) (ViewCollection*, ViewFilter*)) view_collection_real_notify_view_filter_installed;
#line 21 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->notify_view_filter_removed = (void (*) (ViewCollection*, ViewFilter*)) view_collection_real_notify_view_filter_removed;
#line 21 "../src/core/ViewCollection.vala"
	((DataCollectionClass *) klass)->clear = (void (*) (DataCollection*)) view_collection_real_clear;
#line 21 "../src/core/ViewCollection.vala"
	((DataCollectionClass *) klass)->close = (void (*) (DataCollection*)) view_collection_real_close;
#line 21 "../src/core/ViewCollection.vala"
	((DataCollectionClass *) klass)->valid_type = (gboolean (*) (DataCollection*, DataObject*)) view_collection_real_valid_type;
#line 21 "../src/core/ViewCollection.vala"
	((DataCollectionClass *) klass)->add = (gboolean (*) (DataCollection*, DataObject*)) view_collection_real_add;
#line 21 "../src/core/ViewCollection.vala"
	((DataCollectionClass *) klass)->add_many = (GeeCollection* (*) (DataCollection*, GeeCollection*, ProgressMonitor, gpointer)) view_collection_real_add_many;
#line 21 "../src/core/ViewCollection.vala"
	((DataCollectionClass *) klass)->notify_items_added = (void (*) (DataCollection*, GeeIterable*)) view_collection_real_notify_items_added;
#line 21 "../src/core/ViewCollection.vala"
	((DataCollectionClass *) klass)->notify_items_removed = (void (*) (DataCollection*, GeeIterable*)) view_collection_real_notify_items_removed;
#line 21 "../src/core/ViewCollection.vala"
	((DataCollectionClass *) klass)->items_altered = (void (*) (DataCollection*, GeeMap*)) view_collection_real_items_altered;
#line 21 "../src/core/ViewCollection.vala"
	((DataCollectionClass *) klass)->set_comparator = (void (*) (DataCollection*, Comparator, gpointer, ComparatorPredicate, gpointer)) view_collection_real_set_comparator;
#line 21 "../src/core/ViewCollection.vala"
	((DataCollectionClass *) klass)->reset_comparator = (void (*) (DataCollection*)) view_collection_real_reset_comparator;
#line 21 "../src/core/ViewCollection.vala"
	((DataCollectionClass *) klass)->get_all = (GeeCollection* (*) (DataCollection*)) view_collection_real_get_all;
#line 21 "../src/core/ViewCollection.vala"
	((DataCollectionClass *) klass)->get_count = (gint (*) (DataCollection*)) view_collection_real_get_count;
#line 21 "../src/core/ViewCollection.vala"
	((DataCollectionClass *) klass)->get_at = (DataObject* (*) (DataCollection*, gint)) view_collection_real_get_at;
#line 21 "../src/core/ViewCollection.vala"
	((DataCollectionClass *) klass)->index_of = (gint (*) (DataCollection*, DataObject*)) view_collection_real_index_of;
#line 21 "../src/core/ViewCollection.vala"
	((DataCollectionClass *) klass)->contains = (gboolean (*) (DataCollection*, DataObject*)) view_collection_real_contains;
#line 21 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->get_first = (DataView* (*) (ViewCollection*)) view_collection_real_get_first;
#line 21 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->get_first_unrejected = (DataView* (*) (ViewCollection*)) view_collection_real_get_first_unrejected;
#line 21 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->get_first_photo = (DataView* (*) (ViewCollection*)) view_collection_real_get_first_photo;
#line 21 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->get_last = (DataView* (*) (ViewCollection*)) view_collection_real_get_last;
#line 21 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->get_next = (DataView* (*) (ViewCollection*, DataView*, gboolean**)) view_collection_real_get_next;
#line 21 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->get_previous = (DataView* (*) (ViewCollection*, DataView*)) view_collection_real_get_previous;
#line 21 "../src/core/ViewCollection.vala"
	((DataCollectionClass *) klass)->notify_thawed = (void (*) (DataCollection*)) view_collection_real_notify_thawed;
#line 21 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->items_selected = view_collection_real_items_selected;
#line 21 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->items_unselected = view_collection_real_items_unselected;
#line 21 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->items_state_changed = view_collection_real_items_state_changed;
#line 21 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->selection_group_altered = view_collection_real_selection_group_altered;
#line 21 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->items_shown = view_collection_real_items_shown;
#line 21 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->items_hidden = view_collection_real_items_hidden;
#line 21 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->items_visibility_changed = view_collection_real_items_visibility_changed;
#line 21 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->item_view_altered = view_collection_real_item_view_altered;
#line 21 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->item_geometry_altered = view_collection_real_item_geometry_altered;
#line 21 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->views_altered = view_collection_real_views_altered;
#line 21 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->geometries_altered = view_collection_real_geometries_altered;
#line 21 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->view_filter_installed = view_collection_real_view_filter_installed;
#line 21 "../src/core/ViewCollection.vala"
	((ViewCollectionClass *) klass)->view_filter_removed = view_collection_real_view_filter_removed;
#line 21 "../src/core/ViewCollection.vala"
	view_collection_signals[VIEW_COLLECTION_ITEMS_SELECTED_SIGNAL] = g_signal_new ("items-selected", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_selected), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_ITERABLE);
#line 21 "../src/core/ViewCollection.vala"
	view_collection_signals[VIEW_COLLECTION_ITEMS_UNSELECTED_SIGNAL] = g_signal_new ("items-unselected", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_unselected), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_ITERABLE);
#line 21 "../src/core/ViewCollection.vala"
	view_collection_signals[VIEW_COLLECTION_ITEMS_STATE_CHANGED_SIGNAL] = g_signal_new ("items-state-changed", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_state_changed), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_ITERABLE);
#line 21 "../src/core/ViewCollection.vala"
	view_collection_signals[VIEW_COLLECTION_SELECTION_GROUP_ALTERED_SIGNAL] = g_signal_new ("selection-group-altered", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, selection_group_altered), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 21 "../src/core/ViewCollection.vala"
	view_collection_signals[VIEW_COLLECTION_ITEMS_SHOWN_SIGNAL] = g_signal_new ("items-shown", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_shown), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
#line 21 "../src/core/ViewCollection.vala"
	view_collection_signals[VIEW_COLLECTION_ITEMS_HIDDEN_SIGNAL] = g_signal_new ("items-hidden", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_hidden), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
#line 21 "../src/core/ViewCollection.vala"
	view_collection_signals[VIEW_COLLECTION_ITEMS_VISIBILITY_CHANGED_SIGNAL] = g_signal_new ("items-visibility-changed", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, items_visibility_changed), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
#line 21 "../src/core/ViewCollection.vala"
	view_collection_signals[VIEW_COLLECTION_ITEM_VIEW_ALTERED_SIGNAL] = g_signal_new ("item-view-altered", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, item_view_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_DATA_VIEW);
#line 21 "../src/core/ViewCollection.vala"
	view_collection_signals[VIEW_COLLECTION_ITEM_GEOMETRY_ALTERED_SIGNAL] = g_signal_new ("item-geometry-altered", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, item_geometry_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_DATA_VIEW);
#line 21 "../src/core/ViewCollection.vala"
	view_collection_signals[VIEW_COLLECTION_VIEWS_ALTERED_SIGNAL] = g_signal_new ("views-altered", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, views_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
#line 21 "../src/core/ViewCollection.vala"
	view_collection_signals[VIEW_COLLECTION_GEOMETRIES_ALTERED_SIGNAL] = g_signal_new ("geometries-altered", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, geometries_altered), NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEE_TYPE_COLLECTION);
#line 21 "../src/core/ViewCollection.vala"
	view_collection_signals[VIEW_COLLECTION_VIEW_FILTER_INSTALLED_SIGNAL] = g_signal_new ("view-filter-installed", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, view_filter_installed), NULL, NULL, g_cclosure_user_marshal_VOID__VIEW_FILTER, G_TYPE_NONE, 1, TYPE_VIEW_FILTER);
#line 21 "../src/core/ViewCollection.vala"
	view_collection_signals[VIEW_COLLECTION_VIEW_FILTER_REMOVED_SIGNAL] = g_signal_new ("view-filter-removed", TYPE_VIEW_COLLECTION, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewCollectionClass, view_filter_removed), NULL, NULL, g_cclosure_user_marshal_VOID__VIEW_FILTER, G_TYPE_NONE, 1, TYPE_VIEW_FILTER);
#line 8793 "ViewCollection.c"
}

static void
view_collection_instance_init (ViewCollection * self,
                               gpointer klass)
{
	GeeHashMultiMap* _tmp0_;
	GeeHashSet* _tmp1_;
	DataSet* _tmp2_;
	GeeHashMap* _tmp3_;
#line 21 "../src/core/ViewCollection.vala"
	self->priv = view_collection_get_instance_private (self);
#line 59 "../src/core/ViewCollection.vala"
	_tmp0_ = gee_hash_multi_map_new (TYPE_SOURCE_COLLECTION, (GBoxedCopyFunc) data_collection_ref, (GDestroyNotify) data_collection_unref, VIEW_COLLECTION_TYPE_MONITOR_IMPL, (GBoxedCopyFunc) view_collection_monitor_ref, (GDestroyNotify) view_collection_monitor_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 59 "../src/core/ViewCollection.vala"
	self->priv->monitors = _tmp0_;
#line 61 "../src/core/ViewCollection.vala"
	self->priv->mirroring = NULL;
#line 62 "../src/core/ViewCollection.vala"
	self->priv->mirroring_ctor = NULL;
#line 62 "../src/core/ViewCollection.vala"
	self->priv->mirroring_ctor_target = NULL;
#line 63 "../src/core/ViewCollection.vala"
	self->priv->should_mirror = NULL;
#line 63 "../src/core/ViewCollection.vala"
	self->priv->should_mirror_target = NULL;
#line 64 "../src/core/ViewCollection.vala"
	_tmp1_ = gee_hash_set_new (TYPE_VIEW_FILTER, (GBoxedCopyFunc) view_filter_ref, (GDestroyNotify) view_filter_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 64 "../src/core/ViewCollection.vala"
	self->priv->filters = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_SET, GeeSet);
#line 65 "../src/core/ViewCollection.vala"
	_tmp2_ = data_set_new ();
#line 65 "../src/core/ViewCollection.vala"
	self->priv->selected = _tmp2_;
#line 66 "../src/core/ViewCollection.vala"
	self->priv->visible = NULL;
#line 67 "../src/core/ViewCollection.vala"
	self->priv->frozen_views_altered = NULL;
#line 68 "../src/core/ViewCollection.vala"
	self->priv->frozen_geometries_altered = NULL;
#line 72 "../src/core/ViewCollection.vala"
	_tmp3_ = gee_hash_map_new (TYPE_DATA_SOURCE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_DATA_VIEW, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 72 "../src/core/ViewCollection.vala"
	self->priv->source_map = _tmp3_;
#line 8838 "ViewCollection.c"
}

static void
view_collection_finalize (DataCollection * obj)
{
	ViewCollection * self;
#line 21 "../src/core/ViewCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_VIEW_COLLECTION, ViewCollection);
#line 59 "../src/core/ViewCollection.vala"
	_g_object_unref0 (self->priv->monitors);
#line 61 "../src/core/ViewCollection.vala"
	_data_collection_unref0 (self->priv->mirroring);
#line 64 "../src/core/ViewCollection.vala"
	_g_object_unref0 (self->priv->filters);
#line 65 "../src/core/ViewCollection.vala"
	_data_set_unref0 (self->priv->selected);
#line 66 "../src/core/ViewCollection.vala"
	_data_set_unref0 (self->priv->visible);
#line 67 "../src/core/ViewCollection.vala"
	_g_object_unref0 (self->priv->frozen_views_altered);
#line 68 "../src/core/ViewCollection.vala"
	_g_object_unref0 (self->priv->frozen_geometries_altered);
#line 72 "../src/core/ViewCollection.vala"
	_g_object_unref0 (self->priv->source_map);
#line 21 "../src/core/ViewCollection.vala"
	DATA_COLLECTION_CLASS (view_collection_parent_class)->finalize (obj);
#line 8865 "ViewCollection.c"
}

static GType
view_collection_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ViewCollectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) view_collection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ViewCollection), 0, (GInstanceInitFunc) view_collection_instance_init, NULL };
	GType view_collection_type_id;
	view_collection_type_id = g_type_register_static (TYPE_DATA_COLLECTION, "ViewCollection", &g_define_type_info, 0);
	ViewCollection_private_offset = g_type_add_instance_private (view_collection_type_id, sizeof (ViewCollectionPrivate));
	return view_collection_type_id;
}

GType
view_collection_get_type (void)
{
	static volatile gsize view_collection_type_id__once = 0;
	if (g_once_init_enter (&view_collection_type_id__once)) {
		GType view_collection_type_id;
		view_collection_type_id = view_collection_get_type_once ();
		g_once_init_leave (&view_collection_type_id__once, view_collection_type_id);
	}
	return view_collection_type_id__once;
}

static gboolean
view_manager_real_include_in_view (ViewManager* self,
                                   DataSource* source)
{
	gboolean result;
#line 1305 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_DATA_SOURCE (source), FALSE);
#line 1306 "../src/core/ViewCollection.vala"
	result = TRUE;
#line 1306 "../src/core/ViewCollection.vala"
	return result;
#line 8901 "ViewCollection.c"
}

gboolean
view_manager_include_in_view (ViewManager* self,
                              DataSource* source)
{
	ViewManagerClass* _klass_;
#line 1305 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_MANAGER (self), FALSE);
#line 1305 "../src/core/ViewCollection.vala"
	_klass_ = VIEW_MANAGER_GET_CLASS (self);
#line 1305 "../src/core/ViewCollection.vala"
	if (_klass_->include_in_view) {
#line 1305 "../src/core/ViewCollection.vala"
		return _klass_->include_in_view (self, source);
#line 8917 "ViewCollection.c"
	}
#line 1305 "../src/core/ViewCollection.vala"
	return FALSE;
#line 8921 "ViewCollection.c"
}

static DataView*
view_manager_real_create_view (ViewManager* self,
                               DataSource* source)
{
#line 1311 "../src/core/ViewCollection.vala"
	g_critical ("Type `%s' does not implement abstract method `view_manager_create_view'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 1311 "../src/core/ViewCollection.vala"
	return NULL;
#line 8932 "ViewCollection.c"
}

DataView*
view_manager_create_view (ViewManager* self,
                          DataSource* source)
{
	ViewManagerClass* _klass_;
#line 1311 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_MANAGER (self), NULL);
#line 1311 "../src/core/ViewCollection.vala"
	_klass_ = VIEW_MANAGER_GET_CLASS (self);
#line 1311 "../src/core/ViewCollection.vala"
	if (_klass_->create_view) {
#line 1311 "../src/core/ViewCollection.vala"
		return _klass_->create_view (self, source);
#line 8948 "ViewCollection.c"
	}
#line 1311 "../src/core/ViewCollection.vala"
	return NULL;
#line 8952 "ViewCollection.c"
}

ViewManager*
view_manager_construct (GType object_type)
{
	ViewManager* self = NULL;
#line 1301 "../src/core/ViewCollection.vala"
	self = (ViewManager*) g_type_create_instance (object_type);
#line 1301 "../src/core/ViewCollection.vala"
	return self;
#line 8963 "ViewCollection.c"
}

static void
value_view_manager_init (GValue* value)
{
#line 1301 "../src/core/ViewCollection.vala"
	value->data[0].v_pointer = NULL;
#line 8971 "ViewCollection.c"
}

static void
value_view_manager_free_value (GValue* value)
{
#line 1301 "../src/core/ViewCollection.vala"
	if (value->data[0].v_pointer) {
#line 1301 "../src/core/ViewCollection.vala"
		view_manager_unref (value->data[0].v_pointer);
#line 8981 "ViewCollection.c"
	}
}

static void
value_view_manager_copy_value (const GValue* src_value,
                               GValue* dest_value)
{
#line 1301 "../src/core/ViewCollection.vala"
	if (src_value->data[0].v_pointer) {
#line 1301 "../src/core/ViewCollection.vala"
		dest_value->data[0].v_pointer = view_manager_ref (src_value->data[0].v_pointer);
#line 8993 "ViewCollection.c"
	} else {
#line 1301 "../src/core/ViewCollection.vala"
		dest_value->data[0].v_pointer = NULL;
#line 8997 "ViewCollection.c"
	}
}

static gpointer
value_view_manager_peek_pointer (const GValue* value)
{
#line 1301 "../src/core/ViewCollection.vala"
	return value->data[0].v_pointer;
#line 9006 "ViewCollection.c"
}

static gchar*
value_view_manager_collect_value (GValue* value,
                                  guint n_collect_values,
                                  GTypeCValue* collect_values,
                                  guint collect_flags)
{
#line 1301 "../src/core/ViewCollection.vala"
	if (collect_values[0].v_pointer) {
#line 9017 "ViewCollection.c"
		ViewManager * object;
		object = collect_values[0].v_pointer;
#line 1301 "../src/core/ViewCollection.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1301 "../src/core/ViewCollection.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 9024 "ViewCollection.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1301 "../src/core/ViewCollection.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 9028 "ViewCollection.c"
		}
#line 1301 "../src/core/ViewCollection.vala"
		value->data[0].v_pointer = view_manager_ref (object);
#line 9032 "ViewCollection.c"
	} else {
#line 1301 "../src/core/ViewCollection.vala"
		value->data[0].v_pointer = NULL;
#line 9036 "ViewCollection.c"
	}
#line 1301 "../src/core/ViewCollection.vala"
	return NULL;
#line 9040 "ViewCollection.c"
}

static gchar*
value_view_manager_lcopy_value (const GValue* value,
                                guint n_collect_values,
                                GTypeCValue* collect_values,
                                guint collect_flags)
{
	ViewManager ** object_p;
	object_p = collect_values[0].v_pointer;
#line 1301 "../src/core/ViewCollection.vala"
	if (!object_p) {
#line 1301 "../src/core/ViewCollection.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 9055 "ViewCollection.c"
	}
#line 1301 "../src/core/ViewCollection.vala"
	if (!value->data[0].v_pointer) {
#line 1301 "../src/core/ViewCollection.vala"
		*object_p = NULL;
#line 9061 "ViewCollection.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1301 "../src/core/ViewCollection.vala"
		*object_p = value->data[0].v_pointer;
#line 9065 "ViewCollection.c"
	} else {
#line 1301 "../src/core/ViewCollection.vala"
		*object_p = view_manager_ref (value->data[0].v_pointer);
#line 9069 "ViewCollection.c"
	}
#line 1301 "../src/core/ViewCollection.vala"
	return NULL;
#line 9073 "ViewCollection.c"
}

GParamSpec*
param_spec_view_manager (const gchar* name,
                         const gchar* nick,
                         const gchar* blurb,
                         GType object_type,
                         GParamFlags flags)
{
	ParamSpecViewManager* spec;
#line 1301 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_VIEW_MANAGER), NULL);
#line 1301 "../src/core/ViewCollection.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1301 "../src/core/ViewCollection.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1301 "../src/core/ViewCollection.vala"
	return G_PARAM_SPEC (spec);
#line 9092 "ViewCollection.c"
}

gpointer
value_get_view_manager (const GValue* value)
{
#line 1301 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIEW_MANAGER), NULL);
#line 1301 "../src/core/ViewCollection.vala"
	return value->data[0].v_pointer;
#line 9102 "ViewCollection.c"
}

void
value_set_view_manager (GValue* value,
                        gpointer v_object)
{
	ViewManager * old;
#line 1301 "../src/core/ViewCollection.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIEW_MANAGER));
#line 1301 "../src/core/ViewCollection.vala"
	old = value->data[0].v_pointer;
#line 1301 "../src/core/ViewCollection.vala"
	if (v_object) {
#line 1301 "../src/core/ViewCollection.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_VIEW_MANAGER));
#line 1301 "../src/core/ViewCollection.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1301 "../src/core/ViewCollection.vala"
		value->data[0].v_pointer = v_object;
#line 1301 "../src/core/ViewCollection.vala"
		view_manager_ref (value->data[0].v_pointer);
#line 9124 "ViewCollection.c"
	} else {
#line 1301 "../src/core/ViewCollection.vala"
		value->data[0].v_pointer = NULL;
#line 9128 "ViewCollection.c"
	}
#line 1301 "../src/core/ViewCollection.vala"
	if (old) {
#line 1301 "../src/core/ViewCollection.vala"
		view_manager_unref (old);
#line 9134 "ViewCollection.c"
	}
}

void
value_take_view_manager (GValue* value,
                         gpointer v_object)
{
	ViewManager * old;
#line 1301 "../src/core/ViewCollection.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIEW_MANAGER));
#line 1301 "../src/core/ViewCollection.vala"
	old = value->data[0].v_pointer;
#line 1301 "../src/core/ViewCollection.vala"
	if (v_object) {
#line 1301 "../src/core/ViewCollection.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_VIEW_MANAGER));
#line 1301 "../src/core/ViewCollection.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1301 "../src/core/ViewCollection.vala"
		value->data[0].v_pointer = v_object;
#line 9155 "ViewCollection.c"
	} else {
#line 1301 "../src/core/ViewCollection.vala"
		value->data[0].v_pointer = NULL;
#line 9159 "ViewCollection.c"
	}
#line 1301 "../src/core/ViewCollection.vala"
	if (old) {
#line 1301 "../src/core/ViewCollection.vala"
		view_manager_unref (old);
#line 9165 "ViewCollection.c"
	}
}

static void
view_manager_class_init (ViewManagerClass * klass,
                         gpointer klass_data)
{
#line 1301 "../src/core/ViewCollection.vala"
	view_manager_parent_class = g_type_class_peek_parent (klass);
#line 1301 "../src/core/ViewCollection.vala"
	((ViewManagerClass *) klass)->finalize = view_manager_finalize;
#line 1301 "../src/core/ViewCollection.vala"
	((ViewManagerClass *) klass)->include_in_view = (gboolean (*) (ViewManager*, DataSource*)) view_manager_real_include_in_view;
#line 1301 "../src/core/ViewCollection.vala"
	((ViewManagerClass *) klass)->create_view = (DataView* (*) (ViewManager*, DataSource*)) view_manager_real_create_view;
#line 9181 "ViewCollection.c"
}

static void
view_manager_instance_init (ViewManager * self,
                            gpointer klass)
{
#line 1301 "../src/core/ViewCollection.vala"
	self->ref_count = 1;
#line 9190 "ViewCollection.c"
}

static void
view_manager_finalize (ViewManager * obj)
{
	ViewManager * self;
#line 1301 "../src/core/ViewCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_VIEW_MANAGER, ViewManager);
#line 1301 "../src/core/ViewCollection.vala"
	g_signal_handlers_destroy (self);
#line 9201 "ViewCollection.c"
}

static GType
view_manager_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_view_manager_init, value_view_manager_free_value, value_view_manager_copy_value, value_view_manager_peek_pointer, "p", value_view_manager_collect_value, "p", value_view_manager_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (ViewManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) view_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ViewManager), 0, (GInstanceInitFunc) view_manager_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType view_manager_type_id;
	view_manager_type_id = g_type_register_fundamental (g_type_fundamental_next (), "ViewManager", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
	return view_manager_type_id;
}

GType
view_manager_get_type (void)
{
	static volatile gsize view_manager_type_id__once = 0;
	if (g_once_init_enter (&view_manager_type_id__once)) {
		GType view_manager_type_id;
		view_manager_type_id = view_manager_get_type_once ();
		g_once_init_leave (&view_manager_type_id__once, view_manager_type_id);
	}
	return view_manager_type_id__once;
}

gpointer
view_manager_ref (gpointer instance)
{
	ViewManager * self;
	self = instance;
#line 1301 "../src/core/ViewCollection.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1301 "../src/core/ViewCollection.vala"
	return instance;
#line 9236 "ViewCollection.c"
}

void
view_manager_unref (gpointer instance)
{
	ViewManager * self;
	self = instance;
#line 1301 "../src/core/ViewCollection.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1301 "../src/core/ViewCollection.vala"
		VIEW_MANAGER_GET_CLASS (self)->finalize (self);
#line 1301 "../src/core/ViewCollection.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 9250 "ViewCollection.c"
	}
}

static gboolean
view_filter_real_predicate (ViewFilter* self,
                            DataView* view)
{
	gboolean _tmp0_ = FALSE;
#line 1333 "../src/core/ViewCollection.vala"
	g_critical ("Type `%s' does not implement abstract method `view_filter_predicate'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 1333 "../src/core/ViewCollection.vala"
	return _tmp0_;
#line 9263 "ViewCollection.c"
}

gboolean
view_filter_predicate (ViewFilter* self,
                       DataView* view)
{
	ViewFilterClass* _klass_;
#line 1333 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (IS_VIEW_FILTER (self), FALSE);
#line 1333 "../src/core/ViewCollection.vala"
	_klass_ = VIEW_FILTER_GET_CLASS (self);
#line 1333 "../src/core/ViewCollection.vala"
	if (_klass_->predicate) {
#line 1333 "../src/core/ViewCollection.vala"
		return _klass_->predicate (self, view);
#line 9279 "ViewCollection.c"
	}
#line 1333 "../src/core/ViewCollection.vala"
	return FALSE;
#line 9283 "ViewCollection.c"
}

ViewFilter*
view_filter_construct (GType object_type)
{
	ViewFilter* self = NULL;
#line 1326 "../src/core/ViewCollection.vala"
	self = (ViewFilter*) g_type_create_instance (object_type);
#line 1326 "../src/core/ViewCollection.vala"
	return self;
#line 9294 "ViewCollection.c"
}

static void
view_filter_real_refresh (ViewFilter* self)
{
}

static void
value_view_filter_init (GValue* value)
{
#line 1326 "../src/core/ViewCollection.vala"
	value->data[0].v_pointer = NULL;
#line 9307 "ViewCollection.c"
}

static void
value_view_filter_free_value (GValue* value)
{
#line 1326 "../src/core/ViewCollection.vala"
	if (value->data[0].v_pointer) {
#line 1326 "../src/core/ViewCollection.vala"
		view_filter_unref (value->data[0].v_pointer);
#line 9317 "ViewCollection.c"
	}
}

static void
value_view_filter_copy_value (const GValue* src_value,
                              GValue* dest_value)
{
#line 1326 "../src/core/ViewCollection.vala"
	if (src_value->data[0].v_pointer) {
#line 1326 "../src/core/ViewCollection.vala"
		dest_value->data[0].v_pointer = view_filter_ref (src_value->data[0].v_pointer);
#line 9329 "ViewCollection.c"
	} else {
#line 1326 "../src/core/ViewCollection.vala"
		dest_value->data[0].v_pointer = NULL;
#line 9333 "ViewCollection.c"
	}
}

static gpointer
value_view_filter_peek_pointer (const GValue* value)
{
#line 1326 "../src/core/ViewCollection.vala"
	return value->data[0].v_pointer;
#line 9342 "ViewCollection.c"
}

static gchar*
value_view_filter_collect_value (GValue* value,
                                 guint n_collect_values,
                                 GTypeCValue* collect_values,
                                 guint collect_flags)
{
#line 1326 "../src/core/ViewCollection.vala"
	if (collect_values[0].v_pointer) {
#line 9353 "ViewCollection.c"
		ViewFilter * object;
		object = collect_values[0].v_pointer;
#line 1326 "../src/core/ViewCollection.vala"
		if (object->parent_instance.g_class == NULL) {
#line 1326 "../src/core/ViewCollection.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 9360 "ViewCollection.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 1326 "../src/core/ViewCollection.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 9364 "ViewCollection.c"
		}
#line 1326 "../src/core/ViewCollection.vala"
		value->data[0].v_pointer = view_filter_ref (object);
#line 9368 "ViewCollection.c"
	} else {
#line 1326 "../src/core/ViewCollection.vala"
		value->data[0].v_pointer = NULL;
#line 9372 "ViewCollection.c"
	}
#line 1326 "../src/core/ViewCollection.vala"
	return NULL;
#line 9376 "ViewCollection.c"
}

static gchar*
value_view_filter_lcopy_value (const GValue* value,
                               guint n_collect_values,
                               GTypeCValue* collect_values,
                               guint collect_flags)
{
	ViewFilter ** object_p;
	object_p = collect_values[0].v_pointer;
#line 1326 "../src/core/ViewCollection.vala"
	if (!object_p) {
#line 1326 "../src/core/ViewCollection.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 9391 "ViewCollection.c"
	}
#line 1326 "../src/core/ViewCollection.vala"
	if (!value->data[0].v_pointer) {
#line 1326 "../src/core/ViewCollection.vala"
		*object_p = NULL;
#line 9397 "ViewCollection.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 1326 "../src/core/ViewCollection.vala"
		*object_p = value->data[0].v_pointer;
#line 9401 "ViewCollection.c"
	} else {
#line 1326 "../src/core/ViewCollection.vala"
		*object_p = view_filter_ref (value->data[0].v_pointer);
#line 9405 "ViewCollection.c"
	}
#line 1326 "../src/core/ViewCollection.vala"
	return NULL;
#line 9409 "ViewCollection.c"
}

GParamSpec*
param_spec_view_filter (const gchar* name,
                        const gchar* nick,
                        const gchar* blurb,
                        GType object_type,
                        GParamFlags flags)
{
	ParamSpecViewFilter* spec;
#line 1326 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_VIEW_FILTER), NULL);
#line 1326 "../src/core/ViewCollection.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 1326 "../src/core/ViewCollection.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 1326 "../src/core/ViewCollection.vala"
	return G_PARAM_SPEC (spec);
#line 9428 "ViewCollection.c"
}

gpointer
value_get_view_filter (const GValue* value)
{
#line 1326 "../src/core/ViewCollection.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIEW_FILTER), NULL);
#line 1326 "../src/core/ViewCollection.vala"
	return value->data[0].v_pointer;
#line 9438 "ViewCollection.c"
}

void
value_set_view_filter (GValue* value,
                       gpointer v_object)
{
	ViewFilter * old;
#line 1326 "../src/core/ViewCollection.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIEW_FILTER));
#line 1326 "../src/core/ViewCollection.vala"
	old = value->data[0].v_pointer;
#line 1326 "../src/core/ViewCollection.vala"
	if (v_object) {
#line 1326 "../src/core/ViewCollection.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_VIEW_FILTER));
#line 1326 "../src/core/ViewCollection.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1326 "../src/core/ViewCollection.vala"
		value->data[0].v_pointer = v_object;
#line 1326 "../src/core/ViewCollection.vala"
		view_filter_ref (value->data[0].v_pointer);
#line 9460 "ViewCollection.c"
	} else {
#line 1326 "../src/core/ViewCollection.vala"
		value->data[0].v_pointer = NULL;
#line 9464 "ViewCollection.c"
	}
#line 1326 "../src/core/ViewCollection.vala"
	if (old) {
#line 1326 "../src/core/ViewCollection.vala"
		view_filter_unref (old);
#line 9470 "ViewCollection.c"
	}
}

void
value_take_view_filter (GValue* value,
                        gpointer v_object)
{
	ViewFilter * old;
#line 1326 "../src/core/ViewCollection.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_VIEW_FILTER));
#line 1326 "../src/core/ViewCollection.vala"
	old = value->data[0].v_pointer;
#line 1326 "../src/core/ViewCollection.vala"
	if (v_object) {
#line 1326 "../src/core/ViewCollection.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_VIEW_FILTER));
#line 1326 "../src/core/ViewCollection.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 1326 "../src/core/ViewCollection.vala"
		value->data[0].v_pointer = v_object;
#line 9491 "ViewCollection.c"
	} else {
#line 1326 "../src/core/ViewCollection.vala"
		value->data[0].v_pointer = NULL;
#line 9495 "ViewCollection.c"
	}
#line 1326 "../src/core/ViewCollection.vala"
	if (old) {
#line 1326 "../src/core/ViewCollection.vala"
		view_filter_unref (old);
#line 9501 "ViewCollection.c"
	}
}

static void
view_filter_class_init (ViewFilterClass * klass,
                        gpointer klass_data)
{
#line 1326 "../src/core/ViewCollection.vala"
	view_filter_parent_class = g_type_class_peek_parent (klass);
#line 1326 "../src/core/ViewCollection.vala"
	((ViewFilterClass *) klass)->finalize = view_filter_finalize;
#line 1326 "../src/core/ViewCollection.vala"
	((ViewFilterClass *) klass)->predicate = (gboolean (*) (ViewFilter*, DataView*)) view_filter_real_predicate;
#line 1326 "../src/core/ViewCollection.vala"
	((ViewFilterClass *) klass)->refresh = view_filter_real_refresh;
#line 1326 "../src/core/ViewCollection.vala"
	view_filter_signals[VIEW_FILTER_REFRESH_SIGNAL] = g_signal_new ("refresh", TYPE_VIEW_FILTER, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (ViewFilterClass, refresh), NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 9519 "ViewCollection.c"
}

static void
view_filter_instance_init (ViewFilter * self,
                           gpointer klass)
{
#line 1326 "../src/core/ViewCollection.vala"
	self->ref_count = 1;
#line 9528 "ViewCollection.c"
}

static void
view_filter_finalize (ViewFilter * obj)
{
	ViewFilter * self;
#line 1326 "../src/core/ViewCollection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_VIEW_FILTER, ViewFilter);
#line 1326 "../src/core/ViewCollection.vala"
	g_signal_handlers_destroy (self);
#line 9539 "ViewCollection.c"
}

static GType
view_filter_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_view_filter_init, value_view_filter_free_value, value_view_filter_copy_value, value_view_filter_peek_pointer, "p", value_view_filter_collect_value, "p", value_view_filter_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (ViewFilterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) view_filter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ViewFilter), 0, (GInstanceInitFunc) view_filter_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType view_filter_type_id;
	view_filter_type_id = g_type_register_fundamental (g_type_fundamental_next (), "ViewFilter", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
	return view_filter_type_id;
}

GType
view_filter_get_type (void)
{
	static volatile gsize view_filter_type_id__once = 0;
	if (g_once_init_enter (&view_filter_type_id__once)) {
		GType view_filter_type_id;
		view_filter_type_id = view_filter_get_type_once ();
		g_once_init_leave (&view_filter_type_id__once, view_filter_type_id);
	}
	return view_filter_type_id__once;
}

gpointer
view_filter_ref (gpointer instance)
{
	ViewFilter * self;
	self = instance;
#line 1326 "../src/core/ViewCollection.vala"
	g_atomic_int_inc (&self->ref_count);
#line 1326 "../src/core/ViewCollection.vala"
	return instance;
#line 9574 "ViewCollection.c"
}

void
view_filter_unref (gpointer instance)
{
	ViewFilter * self;
	self = instance;
#line 1326 "../src/core/ViewCollection.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 1326 "../src/core/ViewCollection.vala"
		VIEW_FILTER_GET_CLASS (self)->finalize (self);
#line 1326 "../src/core/ViewCollection.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 9588 "ViewCollection.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

