/* EditingTools.c generated by valac 0.56.14, the Vala compiler
 * generated from EditingTools.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */
/* This file is the master unit file for the EditingTools unit.  It should be edited to include
 * whatever code is deemed necessary.
 *
 * The init() and terminate() methods are mandatory.
 *
 * If the unit needs to be configured prior to initialization, add the proper parameters to
 * the preconfigure() method, implement it, and ensure in init() that it's been called.
 */

#include <glib.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <cairo-gobject.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gobject/gvaluecollector.h>
#include <glib/gi18n-lib.h>
#include <gee.h>
#include "shotwell-graphics-processor.h"

#define EDITING_TOOLS_EDITING_TOOL_WINDOW_FRAME_BORDER 6
#define RESOURCES_TRANSIENT_WINDOW_OPACITY 0.90
#define RESOURCES_ONIMAGE_FONT_BACKGROUND "rgba(255,255,255,0.5)"
#define RESOURCES_ONIMAGE_FONT_COLOR "#000000"
#define EDITING_TOOLS_CROP_TOOL_CROP_INIT_X_PCT 0.15
#define EDITING_TOOLS_CROP_TOOL_CROP_INIT_Y_PCT 0.15
#define EDITING_TOOLS_CROP_TOOL_CROP_MIN_SIZE 8
#define EDITING_TOOLS_CROP_TOOL_CROP_EXTERIOR_SATURATION 0.00f
#define EDITING_TOOLS_CROP_TOOL_CROP_EXTERIOR_RED_SHIFT -32
#define EDITING_TOOLS_CROP_TOOL_CROP_EXTERIOR_GREEN_SHIFT -32
#define EDITING_TOOLS_CROP_TOOL_CROP_EXTERIOR_BLUE_SHIFT -32
#define EDITING_TOOLS_CROP_TOOL_CROP_EXTERIOR_ALPHA_SHIFT 0
#define EDITING_TOOLS_CROP_TOOL_ANY_ASPECT_RATIO (-1.0f)
#define EDITING_TOOLS_CROP_TOOL_SCREEN_ASPECT_RATIO (-2.0f)
#define EDITING_TOOLS_CROP_TOOL_ORIGINAL_ASPECT_RATIO (-3.0f)
#define EDITING_TOOLS_CROP_TOOL_CUSTOM_ASPECT_RATIO (-4.0f)
#define EDITING_TOOLS_CROP_TOOL_COMPUTE_FROM_BASIS (-5.0f)
#define EDITING_TOOLS_CROP_TOOL_SEPARATOR (-6.0f)
#define EDITING_TOOLS_CROP_TOOL_MIN_ASPECT_RATIO (1.0f / 64.0f)
#define EDITING_TOOLS_CROP_TOOL_MAX_ASPECT_RATIO 64.0f
#define RESOURCES_CROP_LABEL _ ("Crop")
#define RESOURCES_CROP_TOOLTIP _ ("Crop the photo’s size")
#define EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_CONTROL_SPACING 8
#define RESOURCES_CANCEL_LABEL _ ("_Cancel")
#define EDITING_TOOLS_REDEYE_INSTANCE_MIN_RADIUS 4
#define EDITING_TOOLS_REDEYE_INSTANCE_MAX_RADIUS 32
#define EDITING_TOOLS_REDEYE_INSTANCE_DEFAULT_RADIUS 10
#define RESOURCES_RED_EYE_LABEL _ ("Red-eye")
#define RESOURCES_RED_EYE_TOOLTIP _ ("Reduce or eliminate any red-eye effects in the photo")
#define EDITING_TOOLS_REDEYE_TOOL_REDEYE_TOOL_WINDOW_CONTROL_SPACING 8
#define RESOURCES_APPLY_LABEL _ ("_Apply")
#define EDITING_TOOLS_ADJUST_TOOL_SLIDER_WIDTH 200
#define EDITING_TOOLS_ADJUST_TOOL_SLIDER_DELAY_MSEC ((guint) 100)
#define RESOURCES_ADJUST_LABEL _ ("Adjust")
#define RESOURCES_ADJUST_TOOLTIP _ ("Adjust the photo’s color and tone")
#define RESOURCES_OK_LABEL _ ("_OK")
#define RESOURCES_ENHANCE_LABEL _ ("Enhance")
#define RESOURCES_ENHANCE_TOOLTIP _ ("Automatically improve the photo’s appearance")
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define EDITING_TOOLS_TYPE_EDITING_TOOL_WINDOW (editing_tools_editing_tool_window_get_type ())
#define EDITING_TOOLS_EDITING_TOOL_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), EDITING_TOOLS_TYPE_EDITING_TOOL_WINDOW, EditingToolsEditingToolWindow))
#define EDITING_TOOLS_EDITING_TOOL_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), EDITING_TOOLS_TYPE_EDITING_TOOL_WINDOW, EditingToolsEditingToolWindowClass))
#define EDITING_TOOLS_IS_EDITING_TOOL_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), EDITING_TOOLS_TYPE_EDITING_TOOL_WINDOW))
#define EDITING_TOOLS_IS_EDITING_TOOL_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), EDITING_TOOLS_TYPE_EDITING_TOOL_WINDOW))
#define EDITING_TOOLS_EDITING_TOOL_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), EDITING_TOOLS_TYPE_EDITING_TOOL_WINDOW, EditingToolsEditingToolWindowClass))

typedef struct _EditingToolsEditingToolWindow EditingToolsEditingToolWindow;
typedef struct _EditingToolsEditingToolWindowClass EditingToolsEditingToolWindowClass;
typedef struct _EditingToolsEditingToolWindowPrivate EditingToolsEditingToolWindowPrivate;
enum  {
	EDITING_TOOLS_EDITING_TOOL_WINDOW_0_PROPERTY,
	EDITING_TOOLS_EDITING_TOOL_WINDOW_NUM_PROPERTIES
};
static GParamSpec* editing_tools_editing_tool_window_properties[EDITING_TOOLS_EDITING_TOOL_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_PAGE_WINDOW (page_window_get_type ())
#define PAGE_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE_WINDOW, PageWindow))
#define PAGE_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE_WINDOW, PageWindowClass))
#define IS_PAGE_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE_WINDOW))
#define IS_PAGE_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE_WINDOW))
#define PAGE_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE_WINDOW, PageWindowClass))

typedef struct _PageWindow PageWindow;
typedef struct _PageWindowClass PageWindowClass;

#define TYPE_APP_WINDOW (app_window_get_type ())
#define APP_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_APP_WINDOW, AppWindow))
#define APP_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_APP_WINDOW, AppWindowClass))
#define IS_APP_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_APP_WINDOW))
#define IS_APP_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_APP_WINDOW))
#define APP_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_APP_WINDOW, AppWindowClass))

typedef struct _AppWindow AppWindow;
typedef struct _AppWindowClass AppWindowClass;

#define EDITING_TOOLS_TYPE_PHOTO_CANVAS (editing_tools_photo_canvas_get_type ())
#define EDITING_TOOLS_PHOTO_CANVAS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), EDITING_TOOLS_TYPE_PHOTO_CANVAS, EditingToolsPhotoCanvas))
#define EDITING_TOOLS_PHOTO_CANVAS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), EDITING_TOOLS_TYPE_PHOTO_CANVAS, EditingToolsPhotoCanvasClass))
#define EDITING_TOOLS_IS_PHOTO_CANVAS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), EDITING_TOOLS_TYPE_PHOTO_CANVAS))
#define EDITING_TOOLS_IS_PHOTO_CANVAS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), EDITING_TOOLS_TYPE_PHOTO_CANVAS))
#define EDITING_TOOLS_PHOTO_CANVAS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), EDITING_TOOLS_TYPE_PHOTO_CANVAS, EditingToolsPhotoCanvasClass))

typedef struct _EditingToolsPhotoCanvas EditingToolsPhotoCanvas;
typedef struct _EditingToolsPhotoCanvasClass EditingToolsPhotoCanvasClass;
typedef struct _EditingToolsPhotoCanvasPrivate EditingToolsPhotoCanvasPrivate;

#define TYPE_DATA_OBJECT (data_object_get_type ())
#define DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_OBJECT, DataObject))
#define DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_OBJECT, DataObjectClass))
#define IS_DATA_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_OBJECT))
#define IS_DATA_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_OBJECT))
#define DATA_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_OBJECT, DataObjectClass))

typedef struct _DataObject DataObject;
typedef struct _DataObjectClass DataObjectClass;

#define TYPE_DATA_SOURCE (data_source_get_type ())
#define DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_SOURCE, DataSource))
#define DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_SOURCE, DataSourceClass))
#define IS_DATA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_SOURCE))
#define IS_DATA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_SOURCE))
#define DATA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_SOURCE, DataSourceClass))

typedef struct _DataSource DataSource;
typedef struct _DataSourceClass DataSourceClass;

#define TYPE_THUMBNAIL_SOURCE (thumbnail_source_get_type ())
#define THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSource))
#define THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))
#define IS_THUMBNAIL_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THUMBNAIL_SOURCE))
#define IS_THUMBNAIL_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THUMBNAIL_SOURCE))
#define THUMBNAIL_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THUMBNAIL_SOURCE, ThumbnailSourceClass))

typedef struct _ThumbnailSource ThumbnailSource;
typedef struct _ThumbnailSourceClass ThumbnailSourceClass;

#define TYPE_MEDIA_SOURCE (media_source_get_type ())
#define MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_SOURCE, MediaSource))
#define MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_SOURCE, MediaSourceClass))
#define IS_MEDIA_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_SOURCE))
#define IS_MEDIA_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_SOURCE))
#define MEDIA_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_SOURCE, MediaSourceClass))

typedef struct _MediaSource MediaSource;
typedef struct _MediaSourceClass MediaSourceClass;

#define TYPE_PHOTO_SOURCE (photo_source_get_type ())
#define PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO_SOURCE, PhotoSource))
#define PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO_SOURCE, PhotoSourceClass))
#define IS_PHOTO_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO_SOURCE))
#define IS_PHOTO_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO_SOURCE))
#define PHOTO_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO_SOURCE, PhotoSourceClass))

typedef struct _PhotoSource PhotoSource;
typedef struct _PhotoSourceClass PhotoSourceClass;

#define TYPE_PHOTO (photo_get_type ())
#define PHOTO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PHOTO, Photo))
#define PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PHOTO, PhotoClass))
#define IS_PHOTO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PHOTO))
#define IS_PHOTO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PHOTO))
#define PHOTO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PHOTO, PhotoClass))

typedef struct _Photo Photo;
typedef struct _PhotoClass PhotoClass;

#define TYPE_DIMENSIONS (dimensions_get_type ())
typedef struct _Dimensions Dimensions;
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
typedef enum  {
	PHOTO_EXCEPTION_NONE = 0,
	PHOTO_EXCEPTION_ORIENTATION = 1 << 0,
	PHOTO_EXCEPTION_CROP = 1 << 1,
	PHOTO_EXCEPTION_REDEYE = 1 << 2,
	PHOTO_EXCEPTION_ADJUST = 1 << 3,
	PHOTO_EXCEPTION_STRAIGHTEN = 1 << 4,
	PHOTO_EXCEPTION_ALL = 0xFFFFFFFFLL
} PhotoException;

#define PHOTO_TYPE_EXCEPTION (photo_exception_get_type ())

#define TYPE_SCALING (scaling_get_type ())
typedef struct _Scaling Scaling;
typedef enum  {
	SCALE_CONSTRAINT_ORIGINAL,
	SCALE_CONSTRAINT_DIMENSIONS,
	SCALE_CONSTRAINT_WIDTH,
	SCALE_CONSTRAINT_HEIGHT,
	SCALE_CONSTRAINT_FILL_VIEWPORT
} ScaleConstraint;

#define TYPE_SCALE_CONSTRAINT (scale_constraint_get_type ())

#define TYPE_BOX (box_get_type ())
typedef struct _Box Box;
typedef struct _EditingToolsParamSpecPhotoCanvas EditingToolsParamSpecPhotoCanvas;
enum  {
	EDITING_TOOLS_PHOTO_CANVAS_NEW_SURFACE_SIGNAL,
	EDITING_TOOLS_PHOTO_CANVAS_RESIZED_SCALED_PIXBUF_SIGNAL,
	EDITING_TOOLS_PHOTO_CANVAS_NUM_SIGNALS
};
static guint editing_tools_photo_canvas_signals[EDITING_TOOLS_PHOTO_CANVAS_NUM_SIGNALS] = {0};

#define EDITING_TOOLS_TYPE_EDITING_TOOL (editing_tools_editing_tool_get_type ())
#define EDITING_TOOLS_EDITING_TOOL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool))
#define EDITING_TOOLS_EDITING_TOOL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingToolClass))
#define EDITING_TOOLS_IS_EDITING_TOOL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), EDITING_TOOLS_TYPE_EDITING_TOOL))
#define EDITING_TOOLS_IS_EDITING_TOOL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), EDITING_TOOLS_TYPE_EDITING_TOOL))
#define EDITING_TOOLS_EDITING_TOOL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingToolClass))

typedef struct _EditingToolsEditingTool EditingToolsEditingTool;
typedef struct _EditingToolsEditingToolClass EditingToolsEditingToolClass;
typedef struct _EditingToolsEditingToolPrivate EditingToolsEditingToolPrivate;
#define _editing_tools_photo_canvas_unref0(var) ((var == NULL) ? NULL : (var = (editing_tools_photo_canvas_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_COMMAND (command_get_type ())
#define COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMMAND, Command))
#define COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COMMAND, CommandClass))
#define IS_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMMAND))
#define IS_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COMMAND))
#define COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COMMAND, CommandClass))

typedef struct _Command Command;
typedef struct _CommandClass CommandClass;
typedef EditingToolsEditingTool* (*EditingToolsEditingToolFactory) (void);
typedef struct _EditingToolsParamSpecEditingTool EditingToolsParamSpecEditingTool;
enum  {
	EDITING_TOOLS_EDITING_TOOL_ACTIVATED_SIGNAL,
	EDITING_TOOLS_EDITING_TOOL_DEACTIVATED_SIGNAL,
	EDITING_TOOLS_EDITING_TOOL_APPLIED_SIGNAL,
	EDITING_TOOLS_EDITING_TOOL_CANCELLED_SIGNAL,
	EDITING_TOOLS_EDITING_TOOL_ABORTED_SIGNAL,
	EDITING_TOOLS_EDITING_TOOL_NUM_SIGNALS
};
static guint editing_tools_editing_tool_signals[EDITING_TOOLS_EDITING_TOOL_NUM_SIGNALS] = {0};

#define EDITING_TOOLS_TYPE_CROP_TOOL (editing_tools_crop_tool_get_type ())
#define EDITING_TOOLS_CROP_TOOL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), EDITING_TOOLS_TYPE_CROP_TOOL, EditingToolsCropTool))
#define EDITING_TOOLS_CROP_TOOL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), EDITING_TOOLS_TYPE_CROP_TOOL, EditingToolsCropToolClass))
#define EDITING_TOOLS_IS_CROP_TOOL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), EDITING_TOOLS_TYPE_CROP_TOOL))
#define EDITING_TOOLS_IS_CROP_TOOL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), EDITING_TOOLS_TYPE_CROP_TOOL))
#define EDITING_TOOLS_CROP_TOOL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), EDITING_TOOLS_TYPE_CROP_TOOL, EditingToolsCropToolClass))

typedef struct _EditingToolsCropTool EditingToolsCropTool;
typedef struct _EditingToolsCropToolClass EditingToolsCropToolClass;
typedef struct _EditingToolsCropToolPrivate EditingToolsCropToolPrivate;

#define EDITING_TOOLS_CROP_TOOL_TYPE_CROP_TOOL_WINDOW (editing_tools_crop_tool_crop_tool_window_get_type ())
#define EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), EDITING_TOOLS_CROP_TOOL_TYPE_CROP_TOOL_WINDOW, EditingToolsCropToolCropToolWindow))
#define EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), EDITING_TOOLS_CROP_TOOL_TYPE_CROP_TOOL_WINDOW, EditingToolsCropToolCropToolWindowClass))
#define EDITING_TOOLS_CROP_TOOL_IS_CROP_TOOL_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), EDITING_TOOLS_CROP_TOOL_TYPE_CROP_TOOL_WINDOW))
#define EDITING_TOOLS_CROP_TOOL_IS_CROP_TOOL_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), EDITING_TOOLS_CROP_TOOL_TYPE_CROP_TOOL_WINDOW))
#define EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), EDITING_TOOLS_CROP_TOOL_TYPE_CROP_TOOL_WINDOW, EditingToolsCropToolCropToolWindowClass))

typedef struct _EditingToolsCropToolCropToolWindow EditingToolsCropToolCropToolWindow;
typedef struct _EditingToolsCropToolCropToolWindowClass EditingToolsCropToolCropToolWindowClass;
typedef enum  {
	BOX_LOCATION_OUTSIDE,
	BOX_LOCATION_INSIDE,
	BOX_LOCATION_TOP_SIDE,
	BOX_LOCATION_LEFT_SIDE,
	BOX_LOCATION_RIGHT_SIDE,
	BOX_LOCATION_BOTTOM_SIDE,
	BOX_LOCATION_TOP_LEFT,
	BOX_LOCATION_BOTTOM_LEFT,
	BOX_LOCATION_TOP_RIGHT,
	BOX_LOCATION_BOTTOM_RIGHT
} BoxLocation;

#define TYPE_BOX_LOCATION (box_location_get_type ())

#define EDITING_TOOLS_CROP_TOOL_TYPE_CONSTRAINT_DESCRIPTION (editing_tools_crop_tool_constraint_description_get_type ())
#define EDITING_TOOLS_CROP_TOOL_CONSTRAINT_DESCRIPTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), EDITING_TOOLS_CROP_TOOL_TYPE_CONSTRAINT_DESCRIPTION, EditingToolsCropToolConstraintDescription))
#define EDITING_TOOLS_CROP_TOOL_CONSTRAINT_DESCRIPTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), EDITING_TOOLS_CROP_TOOL_TYPE_CONSTRAINT_DESCRIPTION, EditingToolsCropToolConstraintDescriptionClass))
#define EDITING_TOOLS_CROP_TOOL_IS_CONSTRAINT_DESCRIPTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), EDITING_TOOLS_CROP_TOOL_TYPE_CONSTRAINT_DESCRIPTION))
#define EDITING_TOOLS_CROP_TOOL_IS_CONSTRAINT_DESCRIPTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), EDITING_TOOLS_CROP_TOOL_TYPE_CONSTRAINT_DESCRIPTION))
#define EDITING_TOOLS_CROP_TOOL_CONSTRAINT_DESCRIPTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), EDITING_TOOLS_CROP_TOOL_TYPE_CONSTRAINT_DESCRIPTION, EditingToolsCropToolConstraintDescriptionClass))

typedef struct _EditingToolsCropToolConstraintDescription EditingToolsCropToolConstraintDescription;
typedef struct _EditingToolsCropToolConstraintDescriptionClass EditingToolsCropToolConstraintDescriptionClass;
typedef enum  {
	EDITING_TOOLS_CROP_TOOL_RETICLE_ORIENTATION_LANDSCAPE,
	EDITING_TOOLS_CROP_TOOL_RETICLE_ORIENTATION_PORTRAIT
} EditingToolsCropToolReticleOrientation;

#define EDITING_TOOLS_CROP_TOOL_TYPE_RETICLE_ORIENTATION (editing_tools_crop_tool_reticle_orientation_get_type ())
typedef enum  {
	EDITING_TOOLS_CROP_TOOL_CONSTRAINT_MODE_NORMAL,
	EDITING_TOOLS_CROP_TOOL_CONSTRAINT_MODE_CUSTOM
} EditingToolsCropToolConstraintMode;

#define EDITING_TOOLS_CROP_TOOL_TYPE_CONSTRAINT_MODE (editing_tools_crop_tool_constraint_mode_get_type ())
typedef struct _EditingToolsCropToolConstraintDescriptionPrivate EditingToolsCropToolConstraintDescriptionPrivate;
#define _editing_tools_crop_tool_constraint_description_unref0(var) ((var == NULL) ? NULL : (var = (editing_tools_crop_tool_constraint_description_unref (var), NULL)))
typedef struct _EditingToolsCropToolCropToolWindowPrivate EditingToolsCropToolCropToolWindowPrivate;

#define TYPE_CONFIGURATION_FACADE (configuration_facade_get_type ())
#define CONFIGURATION_FACADE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONFIGURATION_FACADE, ConfigurationFacade))
#define CONFIGURATION_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONFIGURATION_FACADE, ConfigurationFacadeClass))
#define IS_CONFIGURATION_FACADE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONFIGURATION_FACADE))
#define IS_CONFIGURATION_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONFIGURATION_FACADE))
#define CONFIGURATION_FACADE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONFIGURATION_FACADE, ConfigurationFacadeClass))

typedef struct _ConfigurationFacade ConfigurationFacade;
typedef struct _ConfigurationFacadeClass ConfigurationFacadeClass;

#define CONFIG_TYPE_FACADE (config_facade_get_type ())
#define CONFIG_FACADE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CONFIG_TYPE_FACADE, ConfigFacade))
#define CONFIG_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CONFIG_TYPE_FACADE, ConfigFacadeClass))
#define CONFIG_IS_FACADE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CONFIG_TYPE_FACADE))
#define CONFIG_IS_FACADE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CONFIG_TYPE_FACADE))
#define CONFIG_FACADE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CONFIG_TYPE_FACADE, ConfigFacadeClass))

typedef struct _ConfigFacade ConfigFacade;
typedef struct _ConfigFacadeClass ConfigFacadeClass;
typedef enum  {
	BACKING_FETCH_MODE_SOURCE,
	BACKING_FETCH_MODE_BASELINE,
	BACKING_FETCH_MODE_MASTER,
	BACKING_FETCH_MODE_UNMODIFIED
} BackingFetchMode;

#define TYPE_BACKING_FETCH_MODE (backing_fetch_mode_get_type ())

#define TYPE_PAGE_COMMAND (page_command_get_type ())
#define PAGE_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE_COMMAND, PageCommand))
#define PAGE_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE_COMMAND, PageCommandClass))
#define IS_PAGE_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE_COMMAND))
#define IS_PAGE_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE_COMMAND))
#define PAGE_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE_COMMAND, PageCommandClass))

typedef struct _PageCommand PageCommand;
typedef struct _PageCommandClass PageCommandClass;

#define TYPE_SINGLE_DATA_SOURCE_COMMAND (single_data_source_command_get_type ())
#define SINGLE_DATA_SOURCE_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SINGLE_DATA_SOURCE_COMMAND, SingleDataSourceCommand))
#define SINGLE_DATA_SOURCE_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SINGLE_DATA_SOURCE_COMMAND, SingleDataSourceCommandClass))
#define IS_SINGLE_DATA_SOURCE_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SINGLE_DATA_SOURCE_COMMAND))
#define IS_SINGLE_DATA_SOURCE_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SINGLE_DATA_SOURCE_COMMAND))
#define SINGLE_DATA_SOURCE_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SINGLE_DATA_SOURCE_COMMAND, SingleDataSourceCommandClass))

typedef struct _SingleDataSourceCommand SingleDataSourceCommand;
typedef struct _SingleDataSourceCommandClass SingleDataSourceCommandClass;

#define TYPE_GENERIC_PHOTO_TRANSFORMATION_COMMAND (generic_photo_transformation_command_get_type ())
#define GENERIC_PHOTO_TRANSFORMATION_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GENERIC_PHOTO_TRANSFORMATION_COMMAND, GenericPhotoTransformationCommand))
#define GENERIC_PHOTO_TRANSFORMATION_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GENERIC_PHOTO_TRANSFORMATION_COMMAND, GenericPhotoTransformationCommandClass))
#define IS_GENERIC_PHOTO_TRANSFORMATION_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GENERIC_PHOTO_TRANSFORMATION_COMMAND))
#define IS_GENERIC_PHOTO_TRANSFORMATION_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GENERIC_PHOTO_TRANSFORMATION_COMMAND))
#define GENERIC_PHOTO_TRANSFORMATION_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GENERIC_PHOTO_TRANSFORMATION_COMMAND, GenericPhotoTransformationCommandClass))

typedef struct _GenericPhotoTransformationCommand GenericPhotoTransformationCommand;
typedef struct _GenericPhotoTransformationCommandClass GenericPhotoTransformationCommandClass;

#define TYPE_CROP_COMMAND (crop_command_get_type ())
#define CROP_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CROP_COMMAND, CropCommand))
#define CROP_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CROP_COMMAND, CropCommandClass))
#define IS_CROP_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CROP_COMMAND))
#define IS_CROP_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CROP_COMMAND))
#define CROP_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CROP_COMMAND, CropCommandClass))

typedef struct _CropCommand CropCommand;
typedef struct _CropCommandClass CropCommandClass;
typedef enum  {
	BOX_COMPLEMENTS_NONE,
	BOX_COMPLEMENTS_VERTICAL,
	BOX_COMPLEMENTS_HORIZONTAL,
	BOX_COMPLEMENTS_BOTH
} BoxComplements;

#define TYPE_BOX_COMPLEMENTS (box_complements_get_type ())
typedef struct _EditingToolsCropToolParamSpecConstraintDescription EditingToolsCropToolParamSpecConstraintDescription;
enum  {
	EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_0_PROPERTY,
	EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_NUM_PROPERTIES
};
static GParamSpec* editing_tools_crop_tool_crop_tool_window_properties[EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_NUM_PROPERTIES];

#define EDITING_TOOLS_TYPE_REDEYE_INSTANCE (editing_tools_redeye_instance_get_type ())
typedef struct _EditingToolsRedeyeInstance EditingToolsRedeyeInstance;

#define EDITING_TOOLS_TYPE_REDEYE_TOOL (editing_tools_redeye_tool_get_type ())
#define EDITING_TOOLS_REDEYE_TOOL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), EDITING_TOOLS_TYPE_REDEYE_TOOL, EditingToolsRedeyeTool))
#define EDITING_TOOLS_REDEYE_TOOL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), EDITING_TOOLS_TYPE_REDEYE_TOOL, EditingToolsRedeyeToolClass))
#define EDITING_TOOLS_IS_REDEYE_TOOL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), EDITING_TOOLS_TYPE_REDEYE_TOOL))
#define EDITING_TOOLS_IS_REDEYE_TOOL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), EDITING_TOOLS_TYPE_REDEYE_TOOL))
#define EDITING_TOOLS_REDEYE_TOOL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), EDITING_TOOLS_TYPE_REDEYE_TOOL, EditingToolsRedeyeToolClass))

typedef struct _EditingToolsRedeyeTool EditingToolsRedeyeTool;
typedef struct _EditingToolsRedeyeToolClass EditingToolsRedeyeToolClass;
typedef struct _EditingToolsRedeyeToolPrivate EditingToolsRedeyeToolPrivate;

#define EDITING_TOOLS_REDEYE_TOOL_TYPE_REDEYE_TOOL_WINDOW (editing_tools_redeye_tool_redeye_tool_window_get_type ())
#define EDITING_TOOLS_REDEYE_TOOL_REDEYE_TOOL_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), EDITING_TOOLS_REDEYE_TOOL_TYPE_REDEYE_TOOL_WINDOW, EditingToolsRedeyeToolRedeyeToolWindow))
#define EDITING_TOOLS_REDEYE_TOOL_REDEYE_TOOL_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), EDITING_TOOLS_REDEYE_TOOL_TYPE_REDEYE_TOOL_WINDOW, EditingToolsRedeyeToolRedeyeToolWindowClass))
#define EDITING_TOOLS_REDEYE_TOOL_IS_REDEYE_TOOL_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), EDITING_TOOLS_REDEYE_TOOL_TYPE_REDEYE_TOOL_WINDOW))
#define EDITING_TOOLS_REDEYE_TOOL_IS_REDEYE_TOOL_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), EDITING_TOOLS_REDEYE_TOOL_TYPE_REDEYE_TOOL_WINDOW))
#define EDITING_TOOLS_REDEYE_TOOL_REDEYE_TOOL_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), EDITING_TOOLS_REDEYE_TOOL_TYPE_REDEYE_TOOL_WINDOW, EditingToolsRedeyeToolRedeyeToolWindowClass))

typedef struct _EditingToolsRedeyeToolRedeyeToolWindow EditingToolsRedeyeToolRedeyeToolWindow;
typedef struct _EditingToolsRedeyeToolRedeyeToolWindowClass EditingToolsRedeyeToolRedeyeToolWindowClass;
typedef struct _EditingToolsRedeyeToolRedeyeToolWindowPrivate EditingToolsRedeyeToolRedeyeToolWindowPrivate;

#define TYPE_REDEYE_COMMAND (redeye_command_get_type ())
#define REDEYE_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_REDEYE_COMMAND, RedeyeCommand))
#define REDEYE_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_REDEYE_COMMAND, RedeyeCommandClass))
#define IS_REDEYE_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_REDEYE_COMMAND))
#define IS_REDEYE_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_REDEYE_COMMAND))
#define REDEYE_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_REDEYE_COMMAND, RedeyeCommandClass))

typedef struct _RedeyeCommand RedeyeCommand;
typedef struct _RedeyeCommandClass RedeyeCommandClass;

#define TYPE_COMMAND_MANAGER (command_manager_get_type ())
#define COMMAND_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMMAND_MANAGER, CommandManager))
#define COMMAND_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COMMAND_MANAGER, CommandManagerClass))
#define IS_COMMAND_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMMAND_MANAGER))
#define IS_COMMAND_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COMMAND_MANAGER))
#define COMMAND_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COMMAND_MANAGER, CommandManagerClass))

typedef struct _CommandManager CommandManager;
typedef struct _CommandManagerClass CommandManagerClass;
#define _command_manager_unref0(var) ((var == NULL) ? NULL : (var = (command_manager_unref (var), NULL)))

#define TYPE_ALTERATION (alteration_get_type ())
#define ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ALTERATION, Alteration))
#define ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ALTERATION, AlterationClass))
#define IS_ALTERATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ALTERATION))
#define IS_ALTERATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ALTERATION))
#define ALTERATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ALTERATION, AlterationClass))

typedef struct _Alteration Alteration;
typedef struct _AlterationClass AlterationClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_DATA_COLLECTION (data_collection_get_type ())
#define DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DATA_COLLECTION, DataCollection))
#define DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DATA_COLLECTION, DataCollectionClass))
#define IS_DATA_COLLECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DATA_COLLECTION))
#define IS_DATA_COLLECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DATA_COLLECTION))
#define DATA_COLLECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DATA_COLLECTION, DataCollectionClass))

typedef struct _DataCollection DataCollection;
typedef struct _DataCollectionClass DataCollectionClass;
#define _data_collection_unref0(var) ((var == NULL) ? NULL : (var = (data_collection_unref (var), NULL)))
enum  {
	EDITING_TOOLS_REDEYE_TOOL_REDEYE_TOOL_WINDOW_0_PROPERTY,
	EDITING_TOOLS_REDEYE_TOOL_REDEYE_TOOL_WINDOW_NUM_PROPERTIES
};
static GParamSpec* editing_tools_redeye_tool_redeye_tool_window_properties[EDITING_TOOLS_REDEYE_TOOL_REDEYE_TOOL_WINDOW_NUM_PROPERTIES];

#define EDITING_TOOLS_TYPE_ADJUST_TOOL (editing_tools_adjust_tool_get_type ())
#define EDITING_TOOLS_ADJUST_TOOL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), EDITING_TOOLS_TYPE_ADJUST_TOOL, EditingToolsAdjustTool))
#define EDITING_TOOLS_ADJUST_TOOL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), EDITING_TOOLS_TYPE_ADJUST_TOOL, EditingToolsAdjustToolClass))
#define EDITING_TOOLS_IS_ADJUST_TOOL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), EDITING_TOOLS_TYPE_ADJUST_TOOL))
#define EDITING_TOOLS_IS_ADJUST_TOOL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), EDITING_TOOLS_TYPE_ADJUST_TOOL))
#define EDITING_TOOLS_ADJUST_TOOL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), EDITING_TOOLS_TYPE_ADJUST_TOOL, EditingToolsAdjustToolClass))

typedef struct _EditingToolsAdjustTool EditingToolsAdjustTool;
typedef struct _EditingToolsAdjustToolClass EditingToolsAdjustToolClass;
typedef struct _EditingToolsAdjustToolPrivate EditingToolsAdjustToolPrivate;

#define EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_TOOL_WINDOW (editing_tools_adjust_tool_adjust_tool_window_get_type ())
#define EDITING_TOOLS_ADJUST_TOOL_ADJUST_TOOL_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_TOOL_WINDOW, EditingToolsAdjustToolAdjustToolWindow))
#define EDITING_TOOLS_ADJUST_TOOL_ADJUST_TOOL_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_TOOL_WINDOW, EditingToolsAdjustToolAdjustToolWindowClass))
#define EDITING_TOOLS_ADJUST_TOOL_IS_ADJUST_TOOL_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_TOOL_WINDOW))
#define EDITING_TOOLS_ADJUST_TOOL_IS_ADJUST_TOOL_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_TOOL_WINDOW))
#define EDITING_TOOLS_ADJUST_TOOL_ADJUST_TOOL_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_TOOL_WINDOW, EditingToolsAdjustToolAdjustToolWindowClass))

typedef struct _EditingToolsAdjustToolAdjustToolWindow EditingToolsAdjustToolAdjustToolWindow;
typedef struct _EditingToolsAdjustToolAdjustToolWindowClass EditingToolsAdjustToolAdjustToolWindowClass;

#define TYPE_ONE_SHOT_SCHEDULER (one_shot_scheduler_get_type ())
#define ONE_SHOT_SCHEDULER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ONE_SHOT_SCHEDULER, OneShotScheduler))
#define ONE_SHOT_SCHEDULER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ONE_SHOT_SCHEDULER, OneShotSchedulerClass))
#define IS_ONE_SHOT_SCHEDULER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ONE_SHOT_SCHEDULER))
#define IS_ONE_SHOT_SCHEDULER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ONE_SHOT_SCHEDULER))
#define ONE_SHOT_SCHEDULER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ONE_SHOT_SCHEDULER, OneShotSchedulerClass))

typedef struct _OneShotScheduler OneShotScheduler;
typedef struct _OneShotSchedulerClass OneShotSchedulerClass;
#define _pixel_transformer_unref0(var) ((var == NULL) ? NULL : (var = (pixel_transformer_unref (var), NULL)))
#define _pixel_transformation_bundle_unref0(var) ((var == NULL) ? NULL : (var = (pixel_transformation_bundle_unref (var), NULL)))
#define _one_shot_scheduler_unref0(var) ((var == NULL) ? NULL : (var = (one_shot_scheduler_unref (var), NULL)))
typedef struct _EditingToolsAdjustToolAdjustToolWindowPrivate EditingToolsAdjustToolAdjustToolWindowPrivate;

#define TYPE_RGB_HISTOGRAM_MANIPULATOR (rgb_histogram_manipulator_get_type ())
#define RGB_HISTOGRAM_MANIPULATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_RGB_HISTOGRAM_MANIPULATOR, RGBHistogramManipulator))
#define RGB_HISTOGRAM_MANIPULATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_RGB_HISTOGRAM_MANIPULATOR, RGBHistogramManipulatorClass))
#define IS_RGB_HISTOGRAM_MANIPULATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_RGB_HISTOGRAM_MANIPULATOR))
#define IS_RGB_HISTOGRAM_MANIPULATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_RGB_HISTOGRAM_MANIPULATOR))
#define RGB_HISTOGRAM_MANIPULATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_RGB_HISTOGRAM_MANIPULATOR, RGBHistogramManipulatorClass))

typedef struct _RGBHistogramManipulator RGBHistogramManipulator;
typedef struct _RGBHistogramManipulatorClass RGBHistogramManipulatorClass;
#define _pixel_transformation_unref0(var) ((var == NULL) ? NULL : (var = (pixel_transformation_unref (var), NULL)))

#define EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_TOOL_COMMAND (editing_tools_adjust_tool_adjust_tool_command_get_type ())
#define EDITING_TOOLS_ADJUST_TOOL_ADJUST_TOOL_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_TOOL_COMMAND, EditingToolsAdjustToolAdjustToolCommand))
#define EDITING_TOOLS_ADJUST_TOOL_ADJUST_TOOL_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_TOOL_COMMAND, EditingToolsAdjustToolAdjustToolCommandClass))
#define EDITING_TOOLS_ADJUST_TOOL_IS_ADJUST_TOOL_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_TOOL_COMMAND))
#define EDITING_TOOLS_ADJUST_TOOL_IS_ADJUST_TOOL_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_TOOL_COMMAND))
#define EDITING_TOOLS_ADJUST_TOOL_ADJUST_TOOL_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_TOOL_COMMAND, EditingToolsAdjustToolAdjustToolCommandClass))

typedef struct _EditingToolsAdjustToolAdjustToolCommand EditingToolsAdjustToolAdjustToolCommand;
typedef struct _EditingToolsAdjustToolAdjustToolCommandClass EditingToolsAdjustToolAdjustToolCommandClass;

#define EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_RESET_COMMAND (editing_tools_adjust_tool_adjust_reset_command_get_type ())
#define EDITING_TOOLS_ADJUST_TOOL_ADJUST_RESET_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_RESET_COMMAND, EditingToolsAdjustToolAdjustResetCommand))
#define EDITING_TOOLS_ADJUST_TOOL_ADJUST_RESET_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_RESET_COMMAND, EditingToolsAdjustToolAdjustResetCommandClass))
#define EDITING_TOOLS_ADJUST_TOOL_IS_ADJUST_RESET_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_RESET_COMMAND))
#define EDITING_TOOLS_ADJUST_TOOL_IS_ADJUST_RESET_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_RESET_COMMAND))
#define EDITING_TOOLS_ADJUST_TOOL_ADJUST_RESET_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_RESET_COMMAND, EditingToolsAdjustToolAdjustResetCommandClass))

typedef struct _EditingToolsAdjustToolAdjustResetCommand EditingToolsAdjustToolAdjustResetCommand;
typedef struct _EditingToolsAdjustToolAdjustResetCommandClass EditingToolsAdjustToolAdjustResetCommandClass;

#define TYPE_ADJUST_COLORS_SINGLE_COMMAND (adjust_colors_single_command_get_type ())
#define ADJUST_COLORS_SINGLE_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ADJUST_COLORS_SINGLE_COMMAND, AdjustColorsSingleCommand))
#define ADJUST_COLORS_SINGLE_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ADJUST_COLORS_SINGLE_COMMAND, AdjustColorsSingleCommandClass))
#define IS_ADJUST_COLORS_SINGLE_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ADJUST_COLORS_SINGLE_COMMAND))
#define IS_ADJUST_COLORS_SINGLE_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ADJUST_COLORS_SINGLE_COMMAND))
#define ADJUST_COLORS_SINGLE_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ADJUST_COLORS_SINGLE_COMMAND, AdjustColorsSingleCommandClass))

typedef struct _AdjustColorsSingleCommand AdjustColorsSingleCommand;
typedef struct _AdjustColorsSingleCommandClass AdjustColorsSingleCommandClass;

#define EDITING_TOOLS_ADJUST_TOOL_TYPE_SLIDER_ADJUSTMENT_COMMAND (editing_tools_adjust_tool_slider_adjustment_command_get_type ())
#define EDITING_TOOLS_ADJUST_TOOL_SLIDER_ADJUSTMENT_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), EDITING_TOOLS_ADJUST_TOOL_TYPE_SLIDER_ADJUSTMENT_COMMAND, EditingToolsAdjustToolSliderAdjustmentCommand))
#define EDITING_TOOLS_ADJUST_TOOL_SLIDER_ADJUSTMENT_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), EDITING_TOOLS_ADJUST_TOOL_TYPE_SLIDER_ADJUSTMENT_COMMAND, EditingToolsAdjustToolSliderAdjustmentCommandClass))
#define EDITING_TOOLS_ADJUST_TOOL_IS_SLIDER_ADJUSTMENT_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), EDITING_TOOLS_ADJUST_TOOL_TYPE_SLIDER_ADJUSTMENT_COMMAND))
#define EDITING_TOOLS_ADJUST_TOOL_IS_SLIDER_ADJUSTMENT_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), EDITING_TOOLS_ADJUST_TOOL_TYPE_SLIDER_ADJUSTMENT_COMMAND))
#define EDITING_TOOLS_ADJUST_TOOL_SLIDER_ADJUSTMENT_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), EDITING_TOOLS_ADJUST_TOOL_TYPE_SLIDER_ADJUSTMENT_COMMAND, EditingToolsAdjustToolSliderAdjustmentCommandClass))

typedef struct _EditingToolsAdjustToolSliderAdjustmentCommand EditingToolsAdjustToolSliderAdjustmentCommand;
typedef struct _EditingToolsAdjustToolSliderAdjustmentCommandClass EditingToolsAdjustToolSliderAdjustmentCommandClass;
typedef void (*OneShotCallback) (gpointer user_data);

#define EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_ENHANCE_COMMAND (editing_tools_adjust_tool_adjust_enhance_command_get_type ())
#define EDITING_TOOLS_ADJUST_TOOL_ADJUST_ENHANCE_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_ENHANCE_COMMAND, EditingToolsAdjustToolAdjustEnhanceCommand))
#define EDITING_TOOLS_ADJUST_TOOL_ADJUST_ENHANCE_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_ENHANCE_COMMAND, EditingToolsAdjustToolAdjustEnhanceCommandClass))
#define EDITING_TOOLS_ADJUST_TOOL_IS_ADJUST_ENHANCE_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_ENHANCE_COMMAND))
#define EDITING_TOOLS_ADJUST_TOOL_IS_ADJUST_ENHANCE_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_ENHANCE_COMMAND))
#define EDITING_TOOLS_ADJUST_TOOL_ADJUST_ENHANCE_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_ENHANCE_COMMAND, EditingToolsAdjustToolAdjustEnhanceCommandClass))

typedef struct _EditingToolsAdjustToolAdjustEnhanceCommand EditingToolsAdjustToolAdjustEnhanceCommand;
typedef struct _EditingToolsAdjustToolAdjustEnhanceCommandClass EditingToolsAdjustToolAdjustEnhanceCommandClass;
enum  {
	EDITING_TOOLS_ADJUST_TOOL_ADJUST_TOOL_WINDOW_0_PROPERTY,
	EDITING_TOOLS_ADJUST_TOOL_ADJUST_TOOL_WINDOW_NUM_PROPERTIES
};
static GParamSpec* editing_tools_adjust_tool_adjust_tool_window_properties[EDITING_TOOLS_ADJUST_TOOL_ADJUST_TOOL_WINDOW_NUM_PROPERTIES];

#define TYPE_COMMAND_DESCRIPTION (command_description_get_type ())
#define COMMAND_DESCRIPTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMMAND_DESCRIPTION, CommandDescription))
#define IS_COMMAND_DESCRIPTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMMAND_DESCRIPTION))
#define COMMAND_DESCRIPTION_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_COMMAND_DESCRIPTION, CommandDescriptionIface))

typedef struct _CommandDescription CommandDescription;
typedef struct _CommandDescriptionIface CommandDescriptionIface;
typedef struct _CommandPrivate CommandPrivate;
typedef struct _EditingToolsAdjustToolAdjustToolCommandPrivate EditingToolsAdjustToolAdjustToolCommandPrivate;
enum  {
	EDITING_TOOLS_ADJUST_TOOL_ADJUST_TOOL_COMMAND_0_PROPERTY,
	EDITING_TOOLS_ADJUST_TOOL_ADJUST_TOOL_COMMAND_NUM_PROPERTIES
};
static GParamSpec* editing_tools_adjust_tool_adjust_tool_command_properties[EDITING_TOOLS_ADJUST_TOOL_ADJUST_TOOL_COMMAND_NUM_PROPERTIES];
typedef struct _EditingToolsAdjustToolAdjustResetCommandPrivate EditingToolsAdjustToolAdjustResetCommandPrivate;
enum  {
	EDITING_TOOLS_ADJUST_TOOL_ADJUST_RESET_COMMAND_0_PROPERTY,
	EDITING_TOOLS_ADJUST_TOOL_ADJUST_RESET_COMMAND_NUM_PROPERTIES
};
static GParamSpec* editing_tools_adjust_tool_adjust_reset_command_properties[EDITING_TOOLS_ADJUST_TOOL_ADJUST_RESET_COMMAND_NUM_PROPERTIES];
typedef struct _EditingToolsAdjustToolSliderAdjustmentCommandPrivate EditingToolsAdjustToolSliderAdjustmentCommandPrivate;
enum  {
	EDITING_TOOLS_ADJUST_TOOL_SLIDER_ADJUSTMENT_COMMAND_0_PROPERTY,
	EDITING_TOOLS_ADJUST_TOOL_SLIDER_ADJUSTMENT_COMMAND_NUM_PROPERTIES
};
static GParamSpec* editing_tools_adjust_tool_slider_adjustment_command_properties[EDITING_TOOLS_ADJUST_TOOL_SLIDER_ADJUSTMENT_COMMAND_NUM_PROPERTIES];
typedef struct _EditingToolsAdjustToolAdjustEnhanceCommandPrivate EditingToolsAdjustToolAdjustEnhanceCommandPrivate;
enum  {
	EDITING_TOOLS_ADJUST_TOOL_ADJUST_ENHANCE_COMMAND_0_PROPERTY,
	EDITING_TOOLS_ADJUST_TOOL_ADJUST_ENHANCE_COMMAND_NUM_PROPERTIES
};
static GParamSpec* editing_tools_adjust_tool_adjust_enhance_command_properties[EDITING_TOOLS_ADJUST_TOOL_ADJUST_ENHANCE_COMMAND_NUM_PROPERTIES];

#define TYPE_ENHANCE_SINGLE_COMMAND (enhance_single_command_get_type ())
#define ENHANCE_SINGLE_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ENHANCE_SINGLE_COMMAND, EnhanceSingleCommand))
#define ENHANCE_SINGLE_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ENHANCE_SINGLE_COMMAND, EnhanceSingleCommandClass))
#define IS_ENHANCE_SINGLE_COMMAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ENHANCE_SINGLE_COMMAND))
#define IS_ENHANCE_SINGLE_COMMAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ENHANCE_SINGLE_COMMAND))
#define ENHANCE_SINGLE_COMMAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ENHANCE_SINGLE_COMMAND, EnhanceSingleCommandClass))

typedef struct _EnhanceSingleCommand EnhanceSingleCommand;
typedef struct _EnhanceSingleCommandClass EnhanceSingleCommandClass;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _EditingToolsEditingToolWindow {
	GtkWindow parent_instance;
	EditingToolsEditingToolWindowPrivate * priv;
};

struct _EditingToolsEditingToolWindowClass {
	GtkWindowClass parent_class;
};

struct _EditingToolsEditingToolWindowPrivate {
	GtkFrame* layout_frame;
	gboolean user_moved;
};

struct _EditingToolsPhotoCanvas {
	GTypeInstance parent_instance;
	volatile int ref_count;
	EditingToolsPhotoCanvasPrivate * priv;
};

struct _EditingToolsPhotoCanvasClass {
	GTypeClass parent_class;
	void (*finalize) (EditingToolsPhotoCanvas *self);
	void (*repaint) (EditingToolsPhotoCanvas* self);
};

struct _Dimensions {
	gint width;
	gint height;
};

struct _EditingToolsPhotoCanvasPrivate {
	GtkWindow* container;
	GdkWindow* drawing_window;
	Photo* photo;
	cairo_t* default_ctx;
	Dimensions surface_dim;
	cairo_surface_t* scaled;
	GdkPixbuf* scaled_pixbuf;
	GdkRectangle scaled_position;
};

struct _Scaling {
	ScaleConstraint constraint;
	gint scale;
	Dimensions viewport;
	gboolean scale_up;
};

struct _Box {
	gint left;
	gint top;
	gint right;
	gint bottom;
};

struct _EditingToolsParamSpecPhotoCanvas {
	GParamSpec parent_instance;
};

struct _EditingToolsEditingTool {
	GTypeInstance parent_instance;
	volatile int ref_count;
	EditingToolsEditingToolPrivate * priv;
	EditingToolsPhotoCanvas* canvas;
	cairo_surface_t* surface;
	gchar* name;
};

struct _EditingToolsEditingToolClass {
	GTypeClass parent_class;
	void (*finalize) (EditingToolsEditingTool *self);
	void (*activate) (EditingToolsEditingTool* self, EditingToolsPhotoCanvas* canvas);
	void (*deactivate) (EditingToolsEditingTool* self);
	EditingToolsEditingToolWindow* (*get_tool_window) (EditingToolsEditingTool* self);
	GdkPixbuf* (*get_display_pixbuf) (EditingToolsEditingTool* self, Scaling* scaling, Photo* photo, Dimensions* max_dim, GError** error);
	void (*on_left_click) (EditingToolsEditingTool* self, gint x, gint y);
	void (*on_left_released) (EditingToolsEditingTool* self, gint x, gint y);
	void (*on_motion) (EditingToolsEditingTool* self, gint x, gint y, GdkModifierType mask);
	gboolean (*on_leave_notify_event) (EditingToolsEditingTool* self);
	gboolean (*on_keypress) (EditingToolsEditingTool* self, GdkEventKey* event);
	void (*paint) (EditingToolsEditingTool* self, cairo_t* ctx);
};

struct _EditingToolsEditingToolPrivate {
	EditingToolsEditingToolWindow* tool_window;
};

struct _EditingToolsParamSpecEditingTool {
	GParamSpec parent_instance;
};

struct _EditingToolsCropTool {
	EditingToolsEditingTool parent_instance;
	EditingToolsCropToolPrivate * priv;
};

struct _EditingToolsCropToolClass {
	EditingToolsEditingToolClass parent_class;
};

struct _EditingToolsCropToolPrivate {
	EditingToolsCropToolCropToolWindow* crop_tool_window;
	GdkCursorType current_cursor_type;
	BoxLocation in_manipulation;
	cairo_t* wide_black_ctx;
	cairo_t* wide_white_ctx;
	cairo_t* thin_white_ctx;
	cairo_t* text_ctx;
	cairo_surface_t* crop_surface;
	Box scaled_crop;
	gint last_grab_x;
	gint last_grab_y;
	EditingToolsCropToolConstraintDescription** constraints;
	gint constraints_length1;
	gint _constraints_size_;
	GtkListStore* constraint_list;
	EditingToolsCropToolReticleOrientation reticle_orientation;
	EditingToolsCropToolConstraintMode constraint_mode;
	gboolean entry_insert_in_progress;
	gfloat custom_aspect_ratio;
	gint custom_width;
	gint custom_height;
	gint custom_init_width;
	gint custom_init_height;
	gfloat pre_aspect_ratio;
};

struct _EditingToolsCropToolConstraintDescription {
	GTypeInstance parent_instance;
	volatile int ref_count;
	EditingToolsCropToolConstraintDescriptionPrivate * priv;
	gchar* name;
	gint basis_width;
	gint basis_height;
	gboolean is_pivotable;
	gfloat aspect_ratio;
};

struct _EditingToolsCropToolConstraintDescriptionClass {
	GTypeClass parent_class;
	void (*finalize) (EditingToolsCropToolConstraintDescription *self);
};

struct _EditingToolsCropToolCropToolWindow {
	EditingToolsEditingToolWindow parent_instance;
	EditingToolsCropToolCropToolWindowPrivate * priv;
	GtkButton* ok_button;
	GtkButton* cancel_button;
	GtkComboBox* constraint_combo;
	GtkButton* pivot_reticle_button;
	GtkEntry* custom_width_entry;
	GtkEntry* custom_height_entry;
	GtkLabel* custom_mulsign_label;
	GtkEntry* most_recently_edited;
	GtkBox* response_layout;
	GtkBox* layout;
	gint normal_width;
	gint normal_height;
};

struct _EditingToolsCropToolCropToolWindowClass {
	EditingToolsEditingToolWindowClass parent_class;
};

struct _EditingToolsCropToolParamSpecConstraintDescription {
	GParamSpec parent_instance;
};

struct _EditingToolsRedeyeInstance {
	GdkPoint center;
	gint radius;
};

struct _EditingToolsRedeyeTool {
	EditingToolsEditingTool parent_instance;
	EditingToolsRedeyeToolPrivate * priv;
};

struct _EditingToolsRedeyeToolClass {
	EditingToolsEditingToolClass parent_class;
};

struct _EditingToolsRedeyeToolPrivate {
	cairo_t* thin_white_ctx;
	cairo_t* wider_gray_ctx;
	EditingToolsRedeyeToolRedeyeToolWindow* redeye_tool_window;
	EditingToolsRedeyeInstance user_interaction_instance;
	gboolean is_reticle_move_in_progress;
	GdkPoint reticle_move_mouse_start_point;
	GdkPoint reticle_move_anchor;
	GdkRectangle old_scaled_pixbuf_position;
	GdkPixbuf* current_pixbuf;
};

struct _EditingToolsRedeyeToolRedeyeToolWindow {
	EditingToolsEditingToolWindow parent_instance;
	EditingToolsRedeyeToolRedeyeToolWindowPrivate * priv;
	GtkButton* apply_button;
	GtkButton* close_button;
	GtkScale* slider;
};

struct _EditingToolsRedeyeToolRedeyeToolWindowClass {
	EditingToolsEditingToolWindowClass parent_class;
};

struct _EditingToolsRedeyeToolRedeyeToolWindowPrivate {
	GtkLabel* slider_label;
};

struct _EditingToolsAdjustTool {
	EditingToolsEditingTool parent_instance;
	EditingToolsAdjustToolPrivate * priv;
};

struct _EditingToolsAdjustToolClass {
	EditingToolsEditingToolClass parent_class;
};

struct _EditingToolsAdjustToolPrivate {
	EditingToolsAdjustToolAdjustToolWindow* adjust_tool_window;
	gboolean suppress_effect_redraw;
	GdkPixbuf* draw_to_pixbuf;
	GdkPixbuf* histogram_pixbuf;
	GdkPixbuf* virgin_histogram_pixbuf;
	PixelTransformer* transformer;
	PixelTransformer* histogram_transformer;
	PixelTransformationBundle* transformations;
	gfloat* fp_pixel_cache;
	gint fp_pixel_cache_length1;
	gint _fp_pixel_cache_size_;
	gboolean disable_histogram_refresh;
	OneShotScheduler* temperature_scheduler;
	OneShotScheduler* tint_scheduler;
	OneShotScheduler* contrast_scheduler;
	OneShotScheduler* saturation_scheduler;
	OneShotScheduler* exposure_scheduler;
	OneShotScheduler* shadows_scheduler;
	OneShotScheduler* highlights_scheduler;
};

struct _EditingToolsAdjustToolAdjustToolWindow {
	EditingToolsEditingToolWindow parent_instance;
	EditingToolsAdjustToolAdjustToolWindowPrivate * priv;
	GtkScale* exposure_slider;
	GtkScale* contrast_slider;
	GtkScale* saturation_slider;
	GtkScale* tint_slider;
	GtkScale* temperature_slider;
	GtkScale* shadows_slider;
	GtkScale* highlights_slider;
	GtkButton* ok_button;
	GtkButton* reset_button;
	GtkButton* cancel_button;
	RGBHistogramManipulator* histogram_manipulator;
};

struct _EditingToolsAdjustToolAdjustToolWindowClass {
	EditingToolsEditingToolWindowClass parent_class;
};

struct _CommandDescriptionIface {
	GTypeInterface parent_iface;
	gchar* (*get_name) (CommandDescription* self);
	gchar* (*get_explanation) (CommandDescription* self);
};

struct _Command {
	GObject parent_instance;
	CommandPrivate * priv;
};

struct _CommandClass {
	GObjectClass parent_class;
	void (*prepare) (Command* self);
	void (*execute) (Command* self);
	void (*undo) (Command* self);
	void (*redo) (Command* self);
	gboolean (*compress) (Command* self, Command* command);
	gchar* (*get_name) (Command* self);
	gchar* (*get_explanation) (Command* self);
};

struct _EditingToolsAdjustToolAdjustToolCommand {
	Command parent_instance;
	EditingToolsAdjustToolAdjustToolCommandPrivate * priv;
	EditingToolsAdjustTool* owner;
};

struct _EditingToolsAdjustToolAdjustToolCommandClass {
	CommandClass parent_class;
};

struct _EditingToolsAdjustToolAdjustResetCommand {
	EditingToolsAdjustToolAdjustToolCommand parent_instance;
	EditingToolsAdjustToolAdjustResetCommandPrivate * priv;
};

struct _EditingToolsAdjustToolAdjustResetCommandClass {
	EditingToolsAdjustToolAdjustToolCommandClass parent_class;
};

struct _EditingToolsAdjustToolAdjustResetCommandPrivate {
	PixelTransformationBundle* original;
	PixelTransformationBundle* reset;
};

struct _EditingToolsAdjustToolSliderAdjustmentCommand {
	EditingToolsAdjustToolAdjustToolCommand parent_instance;
	EditingToolsAdjustToolSliderAdjustmentCommandPrivate * priv;
};

struct _EditingToolsAdjustToolSliderAdjustmentCommandClass {
	EditingToolsAdjustToolAdjustToolCommandClass parent_class;
};

struct _EditingToolsAdjustToolSliderAdjustmentCommandPrivate {
	PixelTransformationType transformation_type;
	PixelTransformation* new_transformation;
	PixelTransformation* old_transformation;
};

struct _EditingToolsAdjustToolAdjustEnhanceCommand {
	EditingToolsAdjustToolAdjustToolCommand parent_instance;
	EditingToolsAdjustToolAdjustEnhanceCommandPrivate * priv;
};

struct _EditingToolsAdjustToolAdjustEnhanceCommandClass {
	EditingToolsAdjustToolAdjustToolCommandClass parent_class;
};

struct _EditingToolsAdjustToolAdjustEnhanceCommandPrivate {
	Photo* photo;
	PixelTransformationBundle* original;
	PixelTransformationBundle* enhanced;
};

static gint EditingToolsEditingToolWindow_private_offset;
static gpointer editing_tools_editing_tool_window_parent_class = NULL;
static gint EditingToolsPhotoCanvas_private_offset;
static gpointer editing_tools_photo_canvas_parent_class = NULL;
static gint EditingToolsEditingTool_private_offset;
static gpointer editing_tools_editing_tool_parent_class = NULL;
static gint EditingToolsCropTool_private_offset;
static gpointer editing_tools_crop_tool_parent_class = NULL;
static gpointer editing_tools_crop_tool_constraint_description_parent_class = NULL;
static gpointer editing_tools_crop_tool_crop_tool_window_parent_class = NULL;
static gint EditingToolsRedeyeTool_private_offset;
static gpointer editing_tools_redeye_tool_parent_class = NULL;
static gint EditingToolsRedeyeToolRedeyeToolWindow_private_offset;
static gpointer editing_tools_redeye_tool_redeye_tool_window_parent_class = NULL;
static gint EditingToolsAdjustTool_private_offset;
static gpointer editing_tools_adjust_tool_parent_class = NULL;
static gpointer editing_tools_adjust_tool_adjust_tool_window_parent_class = NULL;
static gpointer editing_tools_adjust_tool_adjust_tool_command_parent_class = NULL;
static gint EditingToolsAdjustToolAdjustResetCommand_private_offset;
static gpointer editing_tools_adjust_tool_adjust_reset_command_parent_class = NULL;
static gint EditingToolsAdjustToolSliderAdjustmentCommand_private_offset;
static gpointer editing_tools_adjust_tool_slider_adjustment_command_parent_class = NULL;
static gint EditingToolsAdjustToolAdjustEnhanceCommand_private_offset;
static gpointer editing_tools_adjust_tool_adjust_enhance_command_parent_class = NULL;

VALA_EXTERN void editing_tools_preconfigure (void);
VALA_EXTERN void editing_tools_init (GError** error);
VALA_EXTERN void editing_tools_terminate (void);
VALA_EXTERN GType editing_tools_editing_tool_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (EditingToolsEditingToolWindow, g_object_unref)
VALA_EXTERN EditingToolsEditingToolWindow* editing_tools_editing_tool_window_construct (GType object_type,
                                                                            GtkWindow* container);
static void editing_tools_editing_tool_window_suppress_warnings (EditingToolsEditingToolWindow* self,
                                                          const gchar* log_domain,
                                                          GLogLevelFlags log_levels,
                                                          const gchar* message);
static void _editing_tools_editing_tool_window_suppress_warnings_glog_func (const gchar* log_domain,
                                                                     GLogLevelFlags log_levels,
                                                                     const gchar* message,
                                                                     gpointer self);
static void editing_tools_editing_tool_window_real_add (GtkContainer* base,
                                                 GtkWidget* widget);
VALA_EXTERN gboolean editing_tools_editing_tool_window_has_user_moved (EditingToolsEditingToolWindow* self);
static gboolean editing_tools_editing_tool_window_real_key_press_event (GtkWidget* base,
                                                                 GdkEventKey* event);
VALA_EXTERN GType page_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PageWindow, g_object_unref)
VALA_EXTERN GType app_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AppWindow, g_object_unref)
VALA_EXTERN AppWindow* app_window_get_instance (void);
static gboolean editing_tools_editing_tool_window_real_button_press_event (GtkWidget* base,
                                                                    GdkEventButton* event);
static void editing_tools_editing_tool_window_real_realize (GtkWidget* base);
static void editing_tools_editing_tool_window_finalize (GObject * obj);
static GType editing_tools_editing_tool_window_get_type_once (void);
VALA_EXTERN gpointer editing_tools_photo_canvas_ref (gpointer instance);
VALA_EXTERN void editing_tools_photo_canvas_unref (gpointer instance);
VALA_EXTERN GParamSpec* editing_tools_param_spec_photo_canvas (const gchar* name,
                                                   const gchar* nick,
                                                   const gchar* blurb,
                                                   GType object_type,
                                                   GParamFlags flags);
VALA_EXTERN void editing_tools_value_set_photo_canvas (GValue* value,
                                           gpointer v_object);
VALA_EXTERN void editing_tools_value_take_photo_canvas (GValue* value,
                                            gpointer v_object);
VALA_EXTERN gpointer editing_tools_value_get_photo_canvas (const GValue* value);
VALA_EXTERN GType editing_tools_photo_canvas_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (EditingToolsPhotoCanvas, editing_tools_photo_canvas_unref)
VALA_EXTERN GType data_object_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DataObject, g_object_unref)
VALA_EXTERN GType data_source_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DataSource, g_object_unref)
VALA_EXTERN GType thumbnail_source_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ThumbnailSource, g_object_unref)
VALA_EXTERN GType media_source_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MediaSource, g_object_unref)
VALA_EXTERN GType photo_source_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PhotoSource, g_object_unref)
VALA_EXTERN GType photo_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Photo, g_object_unref)
VALA_EXTERN GType dimensions_get_type (void) G_GNUC_CONST ;
VALA_EXTERN Dimensions* dimensions_dup (const Dimensions* self);
VALA_EXTERN void dimensions_free (Dimensions* self);
VALA_EXTERN void editing_tools_photo_canvas_repaint (EditingToolsPhotoCanvas* self);
VALA_EXTERN EditingToolsPhotoCanvas* editing_tools_photo_canvas_construct (GType object_type,
                                                               GtkWindow* container,
                                                               GdkWindow* drawing_window,
                                                               Photo* photo,
                                                               cairo_t* default_ctx,
                                                               Dimensions* surface_dim,
                                                               GdkPixbuf* scaled,
                                                               GdkRectangle* scaled_position);
static cairo_surface_t* editing_tools_photo_canvas_pixbuf_to_surface (EditingToolsPhotoCanvas* self,
                                                               cairo_t* default_ctx,
                                                               GdkPixbuf* pixbuf,
                                                               GdkRectangle* pos);
VALA_EXTERN void editing_tools_photo_canvas_unscaled_to_raw_rect (EditingToolsPhotoCanvas* self,
                                                      GdkRectangle* rectangle,
                                                      GdkRectangle* result);
VALA_EXTERN void photo_unscaled_to_raw_rect (Photo* self,
                                 GdkRectangle* unscaled_rect,
                                 GdkRectangle* result);
VALA_EXTERN void editing_tools_photo_canvas_active_to_unscaled_point (EditingToolsPhotoCanvas* self,
                                                          GdkPoint* active_point,
                                                          GdkPoint* result);
VALA_EXTERN void editing_tools_photo_canvas_get_scaled_pixbuf_position (EditingToolsPhotoCanvas* self,
                                                            GdkRectangle* result);
VALA_EXTERN GType photo_exception_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void media_source_get_dimensions (MediaSource* self,
                                  PhotoException disallowed_steps,
                                  Dimensions* result);
VALA_EXTERN void editing_tools_photo_canvas_active_to_unscaled_rect (EditingToolsPhotoCanvas* self,
                                                         GdkRectangle* active_rect,
                                                         GdkRectangle* result);
VALA_EXTERN void editing_tools_photo_canvas_user_to_active_point (EditingToolsPhotoCanvas* self,
                                                      GdkPoint* user_point,
                                                      GdkPoint* result);
VALA_EXTERN void editing_tools_photo_canvas_user_to_active_rect (EditingToolsPhotoCanvas* self,
                                                     GdkRectangle* user_rect,
                                                     GdkRectangle* result);
VALA_EXTERN Photo* editing_tools_photo_canvas_get_photo (EditingToolsPhotoCanvas* self);
VALA_EXTERN GtkWindow* editing_tools_photo_canvas_get_container (EditingToolsPhotoCanvas* self);
VALA_EXTERN GdkWindow* editing_tools_photo_canvas_get_drawing_window (EditingToolsPhotoCanvas* self);
VALA_EXTERN cairo_t* editing_tools_photo_canvas_get_default_ctx (EditingToolsPhotoCanvas* self);
VALA_EXTERN void editing_tools_photo_canvas_get_surface_dim (EditingToolsPhotoCanvas* self,
                                                 Dimensions* result);
VALA_EXTERN GType scaling_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType scale_constraint_get_type (void) G_GNUC_CONST ;
VALA_EXTERN Scaling* scaling_dup (const Scaling* self);
VALA_EXTERN void scaling_free (Scaling* self);
VALA_EXTERN void editing_tools_photo_canvas_get_scaling (EditingToolsPhotoCanvas* self,
                                             Scaling* result);
VALA_EXTERN void scaling_for_viewport (Dimensions* viewport,
                           gboolean scale_up,
                           Scaling* result);
VALA_EXTERN void editing_tools_photo_canvas_set_surface (EditingToolsPhotoCanvas* self,
                                             cairo_t* default_ctx,
                                             Dimensions* surface_dim);
VALA_EXTERN cairo_surface_t* editing_tools_photo_canvas_get_scaled_surface (EditingToolsPhotoCanvas* self);
VALA_EXTERN GdkPixbuf* editing_tools_photo_canvas_get_scaled_pixbuf (EditingToolsPhotoCanvas* self);
VALA_EXTERN void editing_tools_photo_canvas_resized_pixbuf (EditingToolsPhotoCanvas* self,
                                                Dimensions* old_dim,
                                                GdkPixbuf* scaled,
                                                GdkRectangle* scaled_position);
static void editing_tools_photo_canvas_real_repaint (EditingToolsPhotoCanvas* self);
VALA_EXTERN void editing_tools_photo_canvas_paint_pixbuf (EditingToolsPhotoCanvas* self,
                                              GdkPixbuf* pixbuf);
VALA_EXTERN void set_source_color_from_string (cairo_t* ctx,
                                   const gchar* spec);
VALA_EXTERN void paint_pixmap_with_background (cairo_t* ctx,
                                   GdkPixbuf* pixbuf,
                                   gint x,
                                   gint y);
VALA_EXTERN void editing_tools_photo_canvas_paint_surface (EditingToolsPhotoCanvas* self,
                                               cairo_surface_t* surface,
                                               gboolean over);
VALA_EXTERN GType box_get_type (void) G_GNUC_CONST ;
VALA_EXTERN Box* box_dup (const Box* self);
VALA_EXTERN void box_free (Box* self);
VALA_EXTERN void editing_tools_photo_canvas_paint_surface_area (EditingToolsPhotoCanvas* self,
                                                    cairo_surface_t* surface,
                                                    Box* source_area,
                                                    gboolean over);
VALA_EXTERN gint box_get_width (Box *self);
VALA_EXTERN gint box_get_height (Box *self);
VALA_EXTERN void editing_tools_photo_canvas_draw_box (EditingToolsPhotoCanvas* self,
                                          cairo_t* ctx,
                                          Box* box);
VALA_EXTERN void box_get_rectangle (Box *self,
                        GdkRectangle* result);
VALA_EXTERN void editing_tools_photo_canvas_draw_text (EditingToolsPhotoCanvas* self,
                                           cairo_t* ctx,
                                           const gchar* text,
                                           gint x,
                                           gint y,
                                           gboolean use_scaled_pos);
VALA_EXTERN void editing_tools_photo_canvas_draw_horizontal_line (EditingToolsPhotoCanvas* self,
                                                      cairo_t* ctx,
                                                      gint x,
                                                      gint y,
                                                      gint width,
                                                      gboolean use_scaled_pos);
VALA_EXTERN void editing_tools_photo_canvas_draw_vertical_line (EditingToolsPhotoCanvas* self,
                                                    cairo_t* ctx,
                                                    gint x,
                                                    gint y,
                                                    gint height,
                                                    gboolean use_scaled_pos);
VALA_EXTERN void editing_tools_photo_canvas_erase_horizontal_line (EditingToolsPhotoCanvas* self,
                                                       gint x,
                                                       gint y,
                                                       gint width);
VALA_EXTERN gdouble application_get_scale (void);
VALA_EXTERN void editing_tools_photo_canvas_draw_circle (EditingToolsPhotoCanvas* self,
                                             cairo_t* ctx,
                                             gint active_center_x,
                                             gint active_center_y,
                                             gint radius);
VALA_EXTERN void editing_tools_photo_canvas_erase_vertical_line (EditingToolsPhotoCanvas* self,
                                                     gint x,
                                                     gint y,
                                                     gint height);
VALA_EXTERN void editing_tools_photo_canvas_erase_box (EditingToolsPhotoCanvas* self,
                                           Box* box);
VALA_EXTERN void editing_tools_photo_canvas_invalidate_area (EditingToolsPhotoCanvas* self,
                                                 Box* area);
VALA_EXTERN void editing_tools_photo_canvas_set_cursor (EditingToolsPhotoCanvas* self,
                                            GdkCursorType cursor_type);
static void g_cclosure_user_marshal_VOID__BOXED_BOXED (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__BOXED_OBJECT_BOXED (GClosure * closure,
                                                       GValue * return_value,
                                                       guint n_param_values,
                                                       const GValue * param_values,
                                                       gpointer invocation_hint,
                                                       gpointer marshal_data);
static void editing_tools_photo_canvas_finalize (EditingToolsPhotoCanvas * obj);
static GType editing_tools_photo_canvas_get_type_once (void);
VALA_EXTERN gpointer editing_tools_editing_tool_ref (gpointer instance);
VALA_EXTERN void editing_tools_editing_tool_unref (gpointer instance);
VALA_EXTERN GParamSpec* editing_tools_param_spec_editing_tool (const gchar* name,
                                                   const gchar* nick,
                                                   const gchar* blurb,
                                                   GType object_type,
                                                   GParamFlags flags);
VALA_EXTERN void editing_tools_value_set_editing_tool (GValue* value,
                                           gpointer v_object);
VALA_EXTERN void editing_tools_value_take_editing_tool (GValue* value,
                                            gpointer v_object);
VALA_EXTERN gpointer editing_tools_value_get_editing_tool (const GValue* value);
VALA_EXTERN GType editing_tools_editing_tool_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (EditingToolsEditingTool, editing_tools_editing_tool_unref)
VALA_EXTERN void editing_tools_editing_tool_activate (EditingToolsEditingTool* self,
                                          EditingToolsPhotoCanvas* canvas);
VALA_EXTERN void editing_tools_editing_tool_deactivate (EditingToolsEditingTool* self);
VALA_EXTERN EditingToolsEditingToolWindow* editing_tools_editing_tool_get_tool_window (EditingToolsEditingTool* self);
VALA_EXTERN GdkPixbuf* editing_tools_editing_tool_get_display_pixbuf (EditingToolsEditingTool* self,
                                                          Scaling* scaling,
                                                          Photo* photo,
                                                          Dimensions* max_dim,
                                                          GError** error);
VALA_EXTERN void editing_tools_editing_tool_on_left_click (EditingToolsEditingTool* self,
                                               gint x,
                                               gint y);
VALA_EXTERN void editing_tools_editing_tool_on_left_released (EditingToolsEditingTool* self,
                                                  gint x,
                                                  gint y);
VALA_EXTERN void editing_tools_editing_tool_on_motion (EditingToolsEditingTool* self,
                                           gint x,
                                           gint y,
                                           GdkModifierType mask);
VALA_EXTERN gboolean editing_tools_editing_tool_on_leave_notify_event (EditingToolsEditingTool* self);
VALA_EXTERN gboolean editing_tools_editing_tool_on_keypress (EditingToolsEditingTool* self,
                                                 GdkEventKey* event);
VALA_EXTERN void editing_tools_editing_tool_paint (EditingToolsEditingTool* self,
                                       cairo_t* ctx);
VALA_EXTERN EditingToolsEditingTool* editing_tools_editing_tool_construct (GType object_type,
                                                               const gchar* name);
static void editing_tools_editing_tool_real_activate (EditingToolsEditingTool* self,
                                               EditingToolsPhotoCanvas* canvas);
static gboolean _editing_tools_editing_tool_on_keypress_gtk_widget_key_press_event (GtkWidget* _sender,
                                                                             GdkEventKey* event,
                                                                             gpointer self);
static void editing_tools_editing_tool_real_deactivate (EditingToolsEditingTool* self);
VALA_EXTERN gboolean editing_tools_editing_tool_is_activated (EditingToolsEditingTool* self);
static EditingToolsEditingToolWindow* editing_tools_editing_tool_real_get_tool_window (EditingToolsEditingTool* self);
static GdkPixbuf* editing_tools_editing_tool_real_get_display_pixbuf (EditingToolsEditingTool* self,
                                                               Scaling* scaling,
                                                               Photo* photo,
                                                               Dimensions* max_dim,
                                                               GError** error);
VALA_EXTERN void dimensions_init (Dimensions *self,
                      gint width,
                      gint height);
static void editing_tools_editing_tool_real_on_left_click (EditingToolsEditingTool* self,
                                                    gint x,
                                                    gint y);
static void editing_tools_editing_tool_real_on_left_released (EditingToolsEditingTool* self,
                                                       gint x,
                                                       gint y);
static void editing_tools_editing_tool_real_on_motion (EditingToolsEditingTool* self,
                                                gint x,
                                                gint y,
                                                GdkModifierType mask);
static gboolean editing_tools_editing_tool_real_on_leave_notify_event (EditingToolsEditingTool* self);
static gboolean editing_tools_editing_tool_real_on_keypress (EditingToolsEditingTool* self,
                                                      GdkEventKey* event);
VALA_EXTERN void editing_tools_editing_tool_notify_cancel (EditingToolsEditingTool* self);
static void editing_tools_editing_tool_real_paint (EditingToolsEditingTool* self,
                                            cairo_t* ctx);
VALA_EXTERN GType command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Command, g_object_unref)
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT_BOXED_BOOLEAN (GClosure * closure,
                                                                GValue * return_value,
                                                                guint n_param_values,
                                                                const GValue * param_values,
                                                                gpointer invocation_hint,
                                                                gpointer marshal_data);
static void editing_tools_editing_tool_finalize (EditingToolsEditingTool * obj);
static GType editing_tools_editing_tool_get_type_once (void);
VALA_EXTERN GType editing_tools_crop_tool_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (EditingToolsCropTool, editing_tools_editing_tool_unref)
static GType editing_tools_crop_tool_crop_tool_window_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (EditingToolsCropToolCropToolWindow, g_object_unref)
VALA_EXTERN GType box_location_get_type (void) G_GNUC_CONST ;
static gpointer editing_tools_crop_tool_constraint_description_ref (gpointer instance);
static void editing_tools_crop_tool_constraint_description_unref (gpointer instance);
static GParamSpec* editing_tools_crop_tool_param_spec_constraint_description (const gchar* name,
                                                                       const gchar* nick,
                                                                       const gchar* blurb,
                                                                       GType object_type,
                                                                       GParamFlags flags) G_GNUC_UNUSED ;
static void editing_tools_crop_tool_value_set_constraint_description (GValue* value,
                                                               gpointer v_object) G_GNUC_UNUSED ;
static void editing_tools_crop_tool_value_take_constraint_description (GValue* value,
                                                                gpointer v_object) G_GNUC_UNUSED ;
static gpointer editing_tools_crop_tool_value_get_constraint_description (const GValue* value) G_GNUC_UNUSED ;
static GType editing_tools_crop_tool_constraint_description_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (EditingToolsCropToolConstraintDescription, editing_tools_crop_tool_constraint_description_unref)
static GType editing_tools_crop_tool_reticle_orientation_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static GType editing_tools_crop_tool_constraint_mode_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static EditingToolsCropToolReticleOrientation editing_tools_crop_tool_reticle_orientation_toggle (EditingToolsCropToolReticleOrientation self);
static EditingToolsCropToolConstraintDescription** editing_tools_crop_tool_create_constraints (gint* result_length1);
static GtkListStore* editing_tools_crop_tool_create_constraint_list (EditingToolsCropToolConstraintDescription** constraint_data,
                                                              gint constraint_data_length1);
static EditingToolsCropTool* editing_tools_crop_tool_new (void);
static EditingToolsCropTool* editing_tools_crop_tool_construct (GType object_type);
VALA_EXTERN EditingToolsCropTool* editing_tools_crop_tool_factory (void);
VALA_EXTERN gboolean editing_tools_crop_tool_is_available (Photo* photo,
                                               Scaling* scaling);
VALA_EXTERN void scaling_get_scaled_dimensions (Scaling *self,
                                    Dimensions* original,
                                    Dimensions* result);
VALA_EXTERN void photo_get_original_dimensions (Photo* self,
                                    Dimensions* result);
static EditingToolsCropToolConstraintDescription* editing_tools_crop_tool_constraint_description_new (const gchar* new_name,
                                                                                               gint new_basis_width,
                                                                                               gint new_basis_height,
                                                                                               gboolean new_pivotable,
                                                                                               gfloat new_aspect_ratio);
static EditingToolsCropToolConstraintDescription* editing_tools_crop_tool_constraint_description_construct (GType object_type,
                                                                                                     const gchar* new_name,
                                                                                                     gint new_basis_width,
                                                                                                     gint new_basis_height,
                                                                                                     gboolean new_pivotable,
                                                                                                     gfloat new_aspect_ratio);
static void _vala_array_add5 (EditingToolsCropToolConstraintDescription** * array,
                       gint* length,
                       gint* size,
                       EditingToolsCropToolConstraintDescription* value);
static void _vala_array_add6 (EditingToolsCropToolConstraintDescription** * array,
                       gint* length,
                       gint* size,
                       EditingToolsCropToolConstraintDescription* value);
static void _vala_array_add7 (EditingToolsCropToolConstraintDescription** * array,
                       gint* length,
                       gint* size,
                       EditingToolsCropToolConstraintDescription* value);
static void _vala_array_add8 (EditingToolsCropToolConstraintDescription** * array,
                       gint* length,
                       gint* size,
                       EditingToolsCropToolConstraintDescription* value);
static void _vala_array_add9 (EditingToolsCropToolConstraintDescription** * array,
                       gint* length,
                       gint* size,
                       EditingToolsCropToolConstraintDescription* value);
static void _vala_array_add10 (EditingToolsCropToolConstraintDescription** * array,
                        gint* length,
                        gint* size,
                        EditingToolsCropToolConstraintDescription* value);
static void _vala_array_add11 (EditingToolsCropToolConstraintDescription** * array,
                        gint* length,
                        gint* size,
                        EditingToolsCropToolConstraintDescription* value);
static void _vala_array_add12 (EditingToolsCropToolConstraintDescription** * array,
                        gint* length,
                        gint* size,
                        EditingToolsCropToolConstraintDescription* value);
static void _vala_array_add13 (EditingToolsCropToolConstraintDescription** * array,
                        gint* length,
                        gint* size,
                        EditingToolsCropToolConstraintDescription* value);
static void _vala_array_add14 (EditingToolsCropToolConstraintDescription** * array,
                        gint* length,
                        gint* size,
                        EditingToolsCropToolConstraintDescription* value);
static void _vala_array_add15 (EditingToolsCropToolConstraintDescription** * array,
                        gint* length,
                        gint* size,
                        EditingToolsCropToolConstraintDescription* value);
static void _vala_array_add16 (EditingToolsCropToolConstraintDescription** * array,
                        gint* length,
                        gint* size,
                        EditingToolsCropToolConstraintDescription* value);
static void _vala_array_add17 (EditingToolsCropToolConstraintDescription** * array,
                        gint* length,
                        gint* size,
                        EditingToolsCropToolConstraintDescription* value);
static void _vala_array_add18 (EditingToolsCropToolConstraintDescription** * array,
                        gint* length,
                        gint* size,
                        EditingToolsCropToolConstraintDescription* value);
static void _vala_array_add19 (EditingToolsCropToolConstraintDescription** * array,
                        gint* length,
                        gint* size,
                        EditingToolsCropToolConstraintDescription* value);
static void _vala_array_add20 (EditingToolsCropToolConstraintDescription** * array,
                        gint* length,
                        gint* size,
                        EditingToolsCropToolConstraintDescription* value);
static void _vala_array_add21 (EditingToolsCropToolConstraintDescription** * array,
                        gint* length,
                        gint* size,
                        EditingToolsCropToolConstraintDescription* value);
static void _vala_array_add22 (EditingToolsCropToolConstraintDescription** * array,
                        gint* length,
                        gint* size,
                        EditingToolsCropToolConstraintDescription* value);
static void _vala_array_add23 (EditingToolsCropToolConstraintDescription** * array,
                        gint* length,
                        gint* size,
                        EditingToolsCropToolConstraintDescription* value);
static void _vala_array_add24 (EditingToolsCropToolConstraintDescription** * array,
                        gint* length,
                        gint* size,
                        EditingToolsCropToolConstraintDescription* value);
static void _vala_array_add25 (EditingToolsCropToolConstraintDescription** * array,
                        gint* length,
                        gint* size,
                        EditingToolsCropToolConstraintDescription* value);
static void _vala_array_add26 (EditingToolsCropToolConstraintDescription** * array,
                        gint* length,
                        gint* size,
                        EditingToolsCropToolConstraintDescription* value);
static void _vala_array_add27 (EditingToolsCropToolConstraintDescription** * array,
                        gint* length,
                        gint* size,
                        EditingToolsCropToolConstraintDescription* value);
static void _vala_array_add28 (EditingToolsCropToolConstraintDescription** * array,
                        gint* length,
                        gint* size,
                        EditingToolsCropToolConstraintDescription* value);
static void _vala_array_add29 (EditingToolsCropToolConstraintDescription** * array,
                        gint* length,
                        gint* size,
                        EditingToolsCropToolConstraintDescription* value);
static void _vala_array_add30 (EditingToolsCropToolConstraintDescription** * array,
                        gint* length,
                        gint* size,
                        EditingToolsCropToolConstraintDescription* value);
static void _vala_array_add31 (EditingToolsCropToolConstraintDescription** * array,
                        gint* length,
                        gint* size,
                        EditingToolsCropToolConstraintDescription* value);
static void _vala_array_add32 (EditingToolsCropToolConstraintDescription** * array,
                        gint* length,
                        gint* size,
                        EditingToolsCropToolConstraintDescription* value);
static void _vala_array_add33 (EditingToolsCropToolConstraintDescription** * array,
                        gint* length,
                        gint* size,
                        EditingToolsCropToolConstraintDescription* value);
static void editing_tools_crop_tool_update_pivot_button_state (EditingToolsCropTool* self);
static EditingToolsCropToolConstraintDescription* editing_tools_crop_tool_get_selected_constraint (EditingToolsCropTool* self);
VALA_EXTERN void scaling_get_screen_dimensions (GtkWindow* window,
                                    Dimensions* result);
static gboolean editing_tools_crop_tool_on_width_entry_focus_out (EditingToolsCropTool* self,
                                                           GdkEventFocus* event);
static gboolean editing_tools_crop_tool_on_custom_entry_focus_out (EditingToolsCropTool* self,
                                                            GdkEventFocus* event);
static gboolean editing_tools_crop_tool_on_height_entry_focus_out (EditingToolsCropTool* self,
                                                            GdkEventFocus* event);
static void editing_tools_crop_tool_constrain_crop (EditingToolsCropTool* self,
                                             Box* crop,
                                             Box* result);
static void editing_tools_crop_tool_crop_resized (EditingToolsCropTool* self,
                                           Box* new_crop);
static void editing_tools_crop_tool_on_width_insert_text (EditingToolsCropTool* self,
                                                   const gchar* text,
                                                   gint length,
                                                   gint* position);
static void editing_tools_crop_tool_on_entry_insert_text (EditingToolsCropTool* self,
                                                   GtkEntry* sender,
                                                   const gchar* text,
                                                   gint length,
                                                   gint* position);
static void editing_tools_crop_tool_on_height_insert_text (EditingToolsCropTool* self,
                                                    const gchar* text,
                                                    gint length,
                                                    gint* position);
static gfloat editing_tools_crop_tool_get_constraint_aspect_ratio (EditingToolsCropTool* self);
static gfloat editing_tools_crop_tool_get_constraint_aspect_ratio_for_constraint (EditingToolsCropTool* self,
                                                                           EditingToolsCropToolConstraintDescription* constraint,
                                                                           Photo* photo);
static void editing_tools_crop_tool_constraint_changed (EditingToolsCropTool* self);
static void editing_tools_crop_tool_set_custom_constraint_mode (EditingToolsCropTool* self);
static void editing_tools_crop_tool_set_normal_constraint_mode (EditingToolsCropTool* self);
VALA_EXTERN GType configuration_facade_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ConfigurationFacade, g_object_unref)
VALA_EXTERN GType config_facade_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ConfigFacade, g_object_unref)
VALA_EXTERN ConfigFacade* config_facade_get_instance (void);
VALA_EXTERN gint configuration_facade_get_last_crop_width (ConfigurationFacade* self);
VALA_EXTERN gint configuration_facade_get_last_crop_height (ConfigurationFacade* self);
VALA_EXTERN void box_adjust_height (Box *self,
                        gint height);
VALA_EXTERN void box_adjust_width (Box *self,
                       gint width);
static void editing_tools_crop_tool_get_photo_dimensions (EditingToolsCropTool* self,
                                                   Dimensions* result);
VALA_EXTERN gboolean photo_get_straighten (Photo* self,
                               gdouble* theta);
VALA_EXTERN void clamp_inside_rotated_image (Box* src,
                                 gint img_w,
                                 gint img_h,
                                 gdouble angle_deg,
                                 gboolean preserve_geom,
                                 Box* result);
static EditingToolsCropToolConstraintDescription* editing_tools_crop_tool_get_last_constraint (EditingToolsCropTool* self,
                                                                                        gint* index);
VALA_EXTERN gint configuration_facade_get_last_crop_menu_choice (ConfigurationFacade* self);
static void editing_tools_crop_tool_real_activate (EditingToolsEditingTool* base,
                                            EditingToolsPhotoCanvas* canvas);
static void editing_tools_crop_tool_bind_canvas_handlers (EditingToolsCropTool* self,
                                                   EditingToolsPhotoCanvas* canvas);
static void editing_tools_crop_tool_prepare_ctx (EditingToolsCropTool* self,
                                          cairo_t* ctx,
                                          Dimensions* dim);
static EditingToolsCropToolCropToolWindow* editing_tools_crop_tool_crop_tool_window_new (GtkWindow* container);
static EditingToolsCropToolCropToolWindow* editing_tools_crop_tool_crop_tool_window_construct (GType object_type,
                                                                                        GtkWindow* container);
VALA_EXTERN gboolean photo_has_crop (Photo* self);
static gboolean editing_tools_crop_tool_constraint_description_is_separator (EditingToolsCropToolConstraintDescription* self);
static void editing_tools_crop_tool_bind_window_handlers (EditingToolsCropTool* self);
VALA_EXTERN gboolean photo_get_crop (Photo* self,
                         Box* crop,
                         PhotoException exceptions);
VALA_EXTERN void box_init (Box *self,
               gint left,
               gint top,
               gint right,
               gint bottom);
VALA_EXTERN void box_get_scaled_similar (Box *self,
                             Dimensions* original,
                             Dimensions* scaled,
                             Box* result);
VALA_EXTERN void dimensions_for_rectangle (GdkRectangle* rect,
                               Dimensions* result);
static void _editing_tools_crop_tool_prepare_ctx_editing_tools_photo_canvas_new_surface (EditingToolsPhotoCanvas* _sender,
                                                                                  cairo_t* ctx,
                                                                                  Dimensions* dim,
                                                                                  gpointer self);
static void editing_tools_crop_tool_on_resized_pixbuf (EditingToolsCropTool* self,
                                                Dimensions* old_dim,
                                                GdkPixbuf* scaled,
                                                GdkRectangle* scaled_position);
static void _editing_tools_crop_tool_on_resized_pixbuf_editing_tools_photo_canvas_resized_scaled_pixbuf (EditingToolsPhotoCanvas* _sender,
                                                                                                  Dimensions* old_dim,
                                                                                                  GdkPixbuf* scaled,
                                                                                                  GdkRectangle* scaled_position,
                                                                                                  gpointer self);
static void editing_tools_crop_tool_unbind_canvas_handlers (EditingToolsCropTool* self,
                                                     EditingToolsPhotoCanvas* canvas);
static void editing_tools_crop_tool_on_crop_ok (EditingToolsCropTool* self);
static void _editing_tools_crop_tool_on_crop_ok_gtk_button_clicked (GtkButton* _sender,
                                                             gpointer self);
static void _editing_tools_editing_tool_notify_cancel_gtk_button_clicked (GtkButton* _sender,
                                                                   gpointer self);
static void _editing_tools_crop_tool_constraint_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                        gpointer self);
static void editing_tools_crop_tool_on_pivot_button_clicked (EditingToolsCropTool* self);
static void _editing_tools_crop_tool_on_pivot_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                          gpointer self);
static gboolean _editing_tools_crop_tool_on_width_entry_focus_out_gtk_widget_focus_out_event (GtkWidget* _sender,
                                                                                       GdkEventFocus* event,
                                                                                       gpointer self);
static gboolean _editing_tools_crop_tool_on_height_entry_focus_out_gtk_widget_focus_out_event (GtkWidget* _sender,
                                                                                        GdkEventFocus* event,
                                                                                        gpointer self);
static void _editing_tools_crop_tool_on_width_insert_text_gtk_editable_insert_text (GtkEditable* _sender,
                                                                             const gchar* new_text,
                                                                             gint new_text_length,
                                                                             gint* position,
                                                                             gpointer self);
static void _editing_tools_crop_tool_on_height_insert_text_gtk_editable_insert_text (GtkEditable* _sender,
                                                                              const gchar* new_text,
                                                                              gint new_text_length,
                                                                              gint* position,
                                                                              gpointer self);
static void editing_tools_crop_tool_unbind_window_handlers (EditingToolsCropTool* self);
static gboolean editing_tools_crop_tool_real_on_keypress (EditingToolsEditingTool* base,
                                                   GdkEventKey* event);
static void editing_tools_crop_tool_real_deactivate (EditingToolsEditingTool* base);
static EditingToolsEditingToolWindow* editing_tools_crop_tool_real_get_tool_window (EditingToolsEditingTool* base);
static GdkPixbuf* editing_tools_crop_tool_real_get_display_pixbuf (EditingToolsEditingTool* base,
                                                            Scaling* scaling,
                                                            Photo* photo,
                                                            Dimensions* max_dim,
                                                            GError** error);
VALA_EXTERN GType backing_fetch_mode_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GdkPixbuf* photo_get_pixbuf_with_options (Photo* self,
                                          Scaling* scaling,
                                          PhotoException exceptions,
                                          BackingFetchMode fetch_mode,
                                          GError** error);
VALA_EXTERN void dimensions_for_pixbuf (GdkPixbuf* pixbuf,
                            Dimensions* result);
static void editing_tools_crop_tool_real_on_left_click (EditingToolsEditingTool* base,
                                                 gint x,
                                                 gint y);
VALA_EXTERN void box_get_offset (Box *self,
                     gint xofs,
                     gint yofs,
                     Box* result);
VALA_EXTERN BoxLocation box_approx_location (Box *self,
                                 gint x,
                                 gint y);
static void editing_tools_crop_tool_real_on_left_released (EditingToolsEditingTool* base,
                                                    gint x,
                                                    gint y);
static void editing_tools_crop_tool_update_cursor (EditingToolsCropTool* self,
                                            gint x,
                                            gint y);
static void editing_tools_crop_tool_real_on_motion (EditingToolsEditingTool* base,
                                             gint x,
                                             gint y,
                                             GdkModifierType mask);
static gboolean editing_tools_crop_tool_on_canvas_manipulation (EditingToolsCropTool* self,
                                                         gint x,
                                                         gint y);
static void editing_tools_crop_tool_real_paint (EditingToolsEditingTool* base,
                                         cairo_t* default_ctx);
static void editing_tools_crop_tool_paint_crop_tool (EditingToolsCropTool* self,
                                              Box* crop);
VALA_EXTERN void configuration_facade_set_last_crop_menu_choice (ConfigurationFacade* self,
                                                     gint choice);
VALA_EXTERN void configuration_facade_set_last_crop_width (ConfigurationFacade* self,
                                               gint choice);
VALA_EXTERN void configuration_facade_set_last_crop_height (ConfigurationFacade* self,
                                                gint choice);
VALA_EXTERN CropCommand* crop_command_new (Photo* photo,
                               Box* crop,
                               const gchar* name,
                               const gchar* explanation);
VALA_EXTERN CropCommand* crop_command_construct (GType object_type,
                                     Photo* photo,
                                     Box* crop,
                                     const gchar* name,
                                     const gchar* explanation);
VALA_EXTERN GType page_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PageCommand, g_object_unref)
VALA_EXTERN GType single_data_source_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SingleDataSourceCommand, g_object_unref)
VALA_EXTERN GType generic_photo_transformation_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GenericPhotoTransformationCommand, g_object_unref)
VALA_EXTERN GType crop_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CropCommand, g_object_unref)
VALA_EXTERN void box_get_dimensions (Box *self,
                         Dimensions* result);
static gint editing_tools_crop_tool_eval_radial_line (EditingToolsCropTool* self,
                                               gdouble center_x,
                                               gdouble center_y,
                                               gdouble bounds_x,
                                               gdouble bounds_y,
                                               gdouble user_x);
static gboolean _box_equal (const Box * s1,
                     const Box * s2);
static void editing_tools_crop_tool_crop_moved (EditingToolsCropTool* self,
                                         Box* new_crop);
VALA_EXTERN gboolean box_equals (Box *self,
                     Box* box);
VALA_EXTERN GType box_complements_get_type (void) G_GNUC_CONST ;
VALA_EXTERN BoxComplements box_resized_complements (Box *self,
                                        Box* resized,
                                        Box* horizontal,
                                        gboolean* horizontal_enlarged,
                                        Box* vertical,
                                        gboolean* vertical_enlarged);
static void editing_tools_crop_tool_set_area_alpha (EditingToolsCropTool* self,
                                             Box* area,
                                             gdouble alpha);
VALA_EXTERN void box_get_reduced (Box *self,
                      gint amount,
                      Box* result);
static void editing_tools_crop_tool_constraint_description_finalize (EditingToolsCropToolConstraintDescription * obj);
static GType editing_tools_crop_tool_constraint_description_get_type_once (void);
static gboolean editing_tools_crop_tool_crop_tool_window_constraint_combo_separator_func (GtkTreeModel* model,
                                                                                   GtkTreeIter* iter);
static gboolean _editing_tools_crop_tool_crop_tool_window_constraint_combo_separator_func_gtk_tree_view_row_separator_func (GtkTreeModel* model,
                                                                                                                     GtkTreeIter* iter,
                                                                                                                     gpointer self);
static void editing_tools_crop_tool_crop_tool_window_finalize (GObject * obj);
static GType editing_tools_crop_tool_crop_tool_window_get_type_once (void);
static void editing_tools_crop_tool_finalize (EditingToolsEditingTool * obj);
static GType editing_tools_crop_tool_get_type_once (void);
VALA_EXTERN GType editing_tools_redeye_instance_get_type (void) G_GNUC_CONST ;
VALA_EXTERN EditingToolsRedeyeInstance* editing_tools_redeye_instance_dup (const EditingToolsRedeyeInstance* self);
VALA_EXTERN void editing_tools_redeye_instance_free (EditingToolsRedeyeInstance* self);
static void editing_tools_redeye_instance_init (EditingToolsRedeyeInstance *self);
VALA_EXTERN void editing_tools_redeye_instance_to_bounds_rect (EditingToolsRedeyeInstance* inst,
                                                   GdkRectangle* result);
VALA_EXTERN void editing_tools_redeye_instance_from_bounds_rect (GdkRectangle* rect,
                                                     EditingToolsRedeyeInstance* result);
VALA_EXTERN GType editing_tools_redeye_tool_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (EditingToolsRedeyeTool, editing_tools_editing_tool_unref)
static GType editing_tools_redeye_tool_redeye_tool_window_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (EditingToolsRedeyeToolRedeyeToolWindow, g_object_unref)
static EditingToolsRedeyeTool* editing_tools_redeye_tool_new (void);
static EditingToolsRedeyeTool* editing_tools_redeye_tool_construct (GType object_type);
VALA_EXTERN EditingToolsRedeyeTool* editing_tools_redeye_tool_factory (void);
VALA_EXTERN gboolean editing_tools_redeye_tool_is_available (Photo* photo,
                                                 Scaling* scaling);
static void editing_tools_redeye_tool_new_interaction_instance (EditingToolsRedeyeTool* self,
                                                         EditingToolsPhotoCanvas* canvas,
                                                         EditingToolsRedeyeInstance* result);
static void editing_tools_redeye_tool_prepare_ctx (EditingToolsRedeyeTool* self,
                                            cairo_t* ctx,
                                            Dimensions* dim);
static void editing_tools_redeye_tool_draw_redeye_instance (EditingToolsRedeyeTool* self,
                                                     EditingToolsRedeyeInstance* inst);
static gboolean editing_tools_redeye_tool_on_size_slider_adjust (EditingToolsRedeyeTool* self,
                                                          GtkScrollType type);
static void editing_tools_redeye_tool_on_apply (EditingToolsRedeyeTool* self);
VALA_EXTERN void derotate_point_arb (GdkPoint* source_point,
                         gint img_w,
                         gint img_h,
                         gdouble angle,
                         GdkPoint* result);
VALA_EXTERN GType redeye_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (RedeyeCommand, g_object_unref)
VALA_EXTERN RedeyeCommand* redeye_command_new (Photo* photo,
                                   EditingToolsRedeyeInstance* redeye_instance,
                                   const gchar* name,
                                   const gchar* explanation);
VALA_EXTERN RedeyeCommand* redeye_command_construct (GType object_type,
                                         Photo* photo,
                                         EditingToolsRedeyeInstance* redeye_instance,
                                         const gchar* name,
                                         const gchar* explanation);
VALA_EXTERN gpointer command_manager_ref (gpointer instance);
VALA_EXTERN void command_manager_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_command_manager (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
VALA_EXTERN void value_set_command_manager (GValue* value,
                                gpointer v_object);
VALA_EXTERN void value_take_command_manager (GValue* value,
                                 gpointer v_object);
VALA_EXTERN gpointer value_get_command_manager (const GValue* value);
VALA_EXTERN GType command_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CommandManager, command_manager_unref)
VALA_EXTERN CommandManager* app_window_get_command_manager (void);
VALA_EXTERN void command_manager_execute (CommandManager* self,
                              Command* command);
VALA_EXTERN gpointer alteration_ref (gpointer instance);
VALA_EXTERN void alteration_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_alteration (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags);
VALA_EXTERN void value_set_alteration (GValue* value,
                           gpointer v_object);
VALA_EXTERN void value_take_alteration (GValue* value,
                            gpointer v_object);
VALA_EXTERN gpointer value_get_alteration (const GValue* value);
VALA_EXTERN GType alteration_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Alteration, alteration_unref)
static void editing_tools_redeye_tool_on_photos_altered (EditingToolsRedeyeTool* self,
                                                  GeeMap* map);
VALA_EXTERN GdkPixbuf* photo_source_get_pixbuf (PhotoSource* self,
                                    Scaling* scaling,
                                    GError** error);
static void editing_tools_redeye_tool_on_close (EditingToolsRedeyeTool* self);
static void editing_tools_redeye_tool_on_canvas_resize (EditingToolsRedeyeTool* self);
static void editing_tools_redeye_tool_real_activate (EditingToolsEditingTool* base,
                                              EditingToolsPhotoCanvas* canvas);
static void editing_tools_redeye_tool_bind_canvas_handlers (EditingToolsRedeyeTool* self,
                                                     EditingToolsPhotoCanvas* canvas);
static EditingToolsRedeyeToolRedeyeToolWindow* editing_tools_redeye_tool_redeye_tool_window_new (GtkWindow* container);
static EditingToolsRedeyeToolRedeyeToolWindow* editing_tools_redeye_tool_redeye_tool_window_construct (GType object_type,
                                                                                                GtkWindow* container);
static void editing_tools_redeye_tool_bind_window_handlers (EditingToolsRedeyeTool* self);
VALA_EXTERN gpointer data_collection_ref (gpointer instance);
VALA_EXTERN void data_collection_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_data_collection (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
VALA_EXTERN void value_set_data_collection (GValue* value,
                                gpointer v_object);
VALA_EXTERN void value_take_data_collection (GValue* value,
                                 gpointer v_object);
VALA_EXTERN gpointer value_get_data_collection (const GValue* value);
VALA_EXTERN GType data_collection_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (DataCollection, data_collection_unref)
VALA_EXTERN DataCollection* data_object_get_membership (DataObject* self);
static void _editing_tools_redeye_tool_on_photos_altered_data_collection_items_altered (DataCollection* _sender,
                                                                                 GeeMap* items,
                                                                                 gpointer self);
static void editing_tools_redeye_tool_real_deactivate (EditingToolsEditingTool* base);
static void editing_tools_redeye_tool_unbind_canvas_handlers (EditingToolsRedeyeTool* self,
                                                       EditingToolsPhotoCanvas* canvas);
static void editing_tools_redeye_tool_unbind_window_handlers (EditingToolsRedeyeTool* self);
static void _editing_tools_redeye_tool_prepare_ctx_editing_tools_photo_canvas_new_surface (EditingToolsPhotoCanvas* _sender,
                                                                                    cairo_t* ctx,
                                                                                    Dimensions* dim,
                                                                                    gpointer self);
static void _editing_tools_redeye_tool_on_canvas_resize_editing_tools_photo_canvas_resized_scaled_pixbuf (EditingToolsPhotoCanvas* _sender,
                                                                                                   Dimensions* old_dim,
                                                                                                   GdkPixbuf* scaled,
                                                                                                   GdkRectangle* scaled_position,
                                                                                                   gpointer self);
static void _editing_tools_redeye_tool_on_apply_gtk_button_clicked (GtkButton* _sender,
                                                             gpointer self);
static void _editing_tools_redeye_tool_on_close_gtk_button_clicked (GtkButton* _sender,
                                                             gpointer self);
static gboolean _editing_tools_redeye_tool_on_size_slider_adjust_gtk_range_change_value (GtkRange* _sender,
                                                                                  GtkScrollType scroll,
                                                                                  gdouble new_value,
                                                                                  gpointer self);
static EditingToolsEditingToolWindow* editing_tools_redeye_tool_real_get_tool_window (EditingToolsEditingTool* base);
static void editing_tools_redeye_tool_real_paint (EditingToolsEditingTool* base,
                                           cairo_t* ctx);
static void editing_tools_redeye_tool_real_on_left_click (EditingToolsEditingTool* base,
                                                   gint x,
                                                   gint y);
VALA_EXTERN gboolean coord_in_rectangle (gint x,
                             gint y,
                             GdkRectangle* rect);
static void editing_tools_redeye_tool_real_on_left_released (EditingToolsEditingTool* base,
                                                      gint x,
                                                      gint y);
static void editing_tools_redeye_tool_real_on_motion (EditingToolsEditingTool* base,
                                               gint x,
                                               gint y,
                                               GdkModifierType mask);
static gboolean editing_tools_redeye_tool_real_on_keypress (EditingToolsEditingTool* base,
                                                     GdkEventKey* event);
static void editing_tools_redeye_tool_redeye_tool_window_finalize (GObject * obj);
static GType editing_tools_redeye_tool_redeye_tool_window_get_type_once (void);
static void editing_tools_redeye_tool_finalize (EditingToolsEditingTool * obj);
static GType editing_tools_redeye_tool_get_type_once (void);
VALA_EXTERN GType editing_tools_adjust_tool_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (EditingToolsAdjustTool, editing_tools_editing_tool_unref)
static GType editing_tools_adjust_tool_adjust_tool_window_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (EditingToolsAdjustToolAdjustToolWindow, g_object_unref)
VALA_EXTERN gpointer one_shot_scheduler_ref (gpointer instance);
VALA_EXTERN void one_shot_scheduler_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_one_shot_scheduler (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags);
VALA_EXTERN void value_set_one_shot_scheduler (GValue* value,
                                   gpointer v_object);
VALA_EXTERN void value_take_one_shot_scheduler (GValue* value,
                                    gpointer v_object);
VALA_EXTERN gpointer value_get_one_shot_scheduler (const GValue* value);
VALA_EXTERN GType one_shot_scheduler_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (OneShotScheduler, one_shot_scheduler_unref)
static EditingToolsAdjustTool* editing_tools_adjust_tool_new (void);
static EditingToolsAdjustTool* editing_tools_adjust_tool_construct (GType object_type);
VALA_EXTERN EditingToolsAdjustTool* editing_tools_adjust_tool_factory (void);
VALA_EXTERN gboolean editing_tools_adjust_tool_is_available (Photo* photo,
                                                 Scaling* scaling);
static void editing_tools_adjust_tool_real_activate (EditingToolsEditingTool* base,
                                              EditingToolsPhotoCanvas* canvas);
static EditingToolsAdjustToolAdjustToolWindow* editing_tools_adjust_tool_adjust_tool_window_new (GtkWindow* container);
static EditingToolsAdjustToolAdjustToolWindow* editing_tools_adjust_tool_adjust_tool_window_construct (GType object_type,
                                                                                                GtkWindow* container);
VALA_EXTERN PixelTransformationBundle* photo_get_color_adjustments (Photo* self);
VALA_EXTERN GType rgb_histogram_manipulator_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (RGBHistogramManipulator, g_object_unref)
VALA_EXTERN void rgb_histogram_manipulator_set_left_nub_position (RGBHistogramManipulator* self,
                                                      gint user_nub_pos);
VALA_EXTERN void rgb_histogram_manipulator_set_right_nub_position (RGBHistogramManipulator* self,
                                                       gint user_nub_pos);
static void editing_tools_adjust_tool_bind_canvas_handlers (EditingToolsAdjustTool* self,
                                                     EditingToolsPhotoCanvas* canvas);
static void editing_tools_adjust_tool_bind_window_handlers (EditingToolsAdjustTool* self);
static void editing_tools_adjust_tool_init_fp_pixel_cache (EditingToolsAdjustTool* self,
                                                    GdkPixbuf* source);
static void editing_tools_adjust_tool_on_photos_altered (EditingToolsAdjustTool* self,
                                                  GeeMap* map);
static void _editing_tools_adjust_tool_on_photos_altered_data_collection_items_altered (DataCollection* _sender,
                                                                                 GeeMap* items,
                                                                                 gpointer self);
static EditingToolsEditingToolWindow* editing_tools_adjust_tool_real_get_tool_window (EditingToolsEditingTool* base);
static void editing_tools_adjust_tool_real_deactivate (EditingToolsEditingTool* base);
static void editing_tools_adjust_tool_unbind_canvas_handlers (EditingToolsAdjustTool* self,
                                                       EditingToolsPhotoCanvas* canvas);
static void editing_tools_adjust_tool_unbind_window_handlers (EditingToolsAdjustTool* self);
static void editing_tools_adjust_tool_real_paint (EditingToolsEditingTool* base,
                                           cairo_t* ctx);
VALA_EXTERN void rgb_histogram_manipulator_update_histogram (RGBHistogramManipulator* self,
                                                 GdkPixbuf* source_pixbuf);
static GdkPixbuf* editing_tools_adjust_tool_real_get_display_pixbuf (EditingToolsEditingTool* base,
                                                              Scaling* scaling,
                                                              Photo* photo,
                                                              Dimensions* max_dim,
                                                              GError** error);
VALA_EXTERN gboolean photo_has_color_adjustments (Photo* self);
static void editing_tools_adjust_tool_on_reset (EditingToolsAdjustTool* self);
static GType editing_tools_adjust_tool_adjust_tool_command_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (EditingToolsAdjustToolAdjustToolCommand, g_object_unref)
static GType editing_tools_adjust_tool_adjust_reset_command_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (EditingToolsAdjustToolAdjustResetCommand, g_object_unref)
static EditingToolsAdjustToolAdjustResetCommand* editing_tools_adjust_tool_adjust_reset_command_new (EditingToolsAdjustTool* owner,
                                                                                              PixelTransformationBundle* current);
static EditingToolsAdjustToolAdjustResetCommand* editing_tools_adjust_tool_adjust_reset_command_construct (GType object_type,
                                                                                                    EditingToolsAdjustTool* owner,
                                                                                                    PixelTransformationBundle* current);
static void editing_tools_adjust_tool_on_ok (EditingToolsAdjustTool* self);
VALA_EXTERN AdjustColorsSingleCommand* adjust_colors_single_command_new (Photo* photo,
                                                             PixelTransformationBundle* transformations,
                                                             const gchar* name,
                                                             const gchar* explanation);
VALA_EXTERN AdjustColorsSingleCommand* adjust_colors_single_command_construct (GType object_type,
                                                                   Photo* photo,
                                                                   PixelTransformationBundle* transformations,
                                                                   const gchar* name,
                                                                   const gchar* explanation);
VALA_EXTERN GType adjust_colors_single_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AdjustColorsSingleCommand, g_object_unref)
static void editing_tools_adjust_tool_update_transformations (EditingToolsAdjustTool* self,
                                                       PixelTransformationBundle* new_transformations);
static void editing_tools_adjust_tool_update_transformation (EditingToolsAdjustTool* self,
                                                      PixelTransformation* new_transformation);
static void editing_tools_adjust_tool_slider_updated (EditingToolsAdjustTool* self,
                                               PixelTransformation* new_transformation,
                                               const gchar* name);
static GType editing_tools_adjust_tool_slider_adjustment_command_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (EditingToolsAdjustToolSliderAdjustmentCommand, g_object_unref)
static EditingToolsAdjustToolSliderAdjustmentCommand* editing_tools_adjust_tool_slider_adjustment_command_new (EditingToolsAdjustTool* owner,
                                                                                                        PixelTransformation* old_transformation,
                                                                                                        PixelTransformation* new_transformation,
                                                                                                        const gchar* name);
static EditingToolsAdjustToolSliderAdjustmentCommand* editing_tools_adjust_tool_slider_adjustment_command_construct (GType object_type,
                                                                                                              EditingToolsAdjustTool* owner,
                                                                                                              PixelTransformation* old_transformation,
                                                                                                              PixelTransformation* new_transformation,
                                                                                                              const gchar* name);
static void editing_tools_adjust_tool_on_temperature_adjustment (EditingToolsAdjustTool* self);
static void editing_tools_adjust_tool_on_delayed_temperature_adjustment (EditingToolsAdjustTool* self);
static void _editing_tools_adjust_tool_on_delayed_temperature_adjustment_one_shot_callback (gpointer self);
VALA_EXTERN OneShotScheduler* one_shot_scheduler_new (const gchar* name,
                                          OneShotCallback callback,
                                          gpointer callback_target);
VALA_EXTERN OneShotScheduler* one_shot_scheduler_construct (GType object_type,
                                                const gchar* name,
                                                OneShotCallback callback,
                                                gpointer callback_target);
VALA_EXTERN void one_shot_scheduler_after_timeout (OneShotScheduler* self,
                                       guint msec,
                                       gboolean reschedule);
static void editing_tools_adjust_tool_on_tint_adjustment (EditingToolsAdjustTool* self);
static void editing_tools_adjust_tool_on_delayed_tint_adjustment (EditingToolsAdjustTool* self);
static void _editing_tools_adjust_tool_on_delayed_tint_adjustment_one_shot_callback (gpointer self);
static void editing_tools_adjust_tool_on_contrast_adjustment (EditingToolsAdjustTool* self);
static void editing_tools_adjust_tool_on_delayed_contrast_adjustment (EditingToolsAdjustTool* self);
static void _editing_tools_adjust_tool_on_delayed_contrast_adjustment_one_shot_callback (gpointer self);
static void editing_tools_adjust_tool_on_saturation_adjustment (EditingToolsAdjustTool* self);
static void editing_tools_adjust_tool_on_delayed_saturation_adjustment (EditingToolsAdjustTool* self);
static void _editing_tools_adjust_tool_on_delayed_saturation_adjustment_one_shot_callback (gpointer self);
static void editing_tools_adjust_tool_on_exposure_adjustment (EditingToolsAdjustTool* self);
static void editing_tools_adjust_tool_on_delayed_exposure_adjustment (EditingToolsAdjustTool* self);
static void _editing_tools_adjust_tool_on_delayed_exposure_adjustment_one_shot_callback (gpointer self);
static void editing_tools_adjust_tool_on_shadows_adjustment (EditingToolsAdjustTool* self);
static void editing_tools_adjust_tool_on_delayed_shadows_adjustment (EditingToolsAdjustTool* self);
static void _editing_tools_adjust_tool_on_delayed_shadows_adjustment_one_shot_callback (gpointer self);
static void editing_tools_adjust_tool_on_highlights_adjustment (EditingToolsAdjustTool* self);
static void editing_tools_adjust_tool_on_delayed_highlights_adjustment (EditingToolsAdjustTool* self);
static void _editing_tools_adjust_tool_on_delayed_highlights_adjustment_one_shot_callback (gpointer self);
static void editing_tools_adjust_tool_on_histogram_constraint (EditingToolsAdjustTool* self);
VALA_EXTERN gint rgb_histogram_manipulator_get_left_nub_position (RGBHistogramManipulator* self);
VALA_EXTERN gint rgb_histogram_manipulator_get_right_nub_position (RGBHistogramManipulator* self);
static void editing_tools_adjust_tool_on_canvas_resize (EditingToolsAdjustTool* self);
static gboolean editing_tools_adjust_tool_on_hscale_reset (EditingToolsAdjustTool* self,
                                                    GtkWidget* widget,
                                                    GdkEventButton* event);
VALA_EXTERN gboolean has_only_key_modifier (GdkModifierType field,
                                GdkModifierType mask);
static void _editing_tools_adjust_tool_on_canvas_resize_editing_tools_photo_canvas_resized_scaled_pixbuf (EditingToolsPhotoCanvas* _sender,
                                                                                                   Dimensions* old_dim,
                                                                                                   GdkPixbuf* scaled,
                                                                                                   GdkRectangle* scaled_position,
                                                                                                   gpointer self);
static void _editing_tools_adjust_tool_on_ok_gtk_button_clicked (GtkButton* _sender,
                                                          gpointer self);
static void _editing_tools_adjust_tool_on_reset_gtk_button_clicked (GtkButton* _sender,
                                                             gpointer self);
static void _editing_tools_adjust_tool_on_exposure_adjustment_gtk_range_value_changed (GtkRange* _sender,
                                                                                gpointer self);
static void _editing_tools_adjust_tool_on_contrast_adjustment_gtk_range_value_changed (GtkRange* _sender,
                                                                                gpointer self);
static void _editing_tools_adjust_tool_on_saturation_adjustment_gtk_range_value_changed (GtkRange* _sender,
                                                                                  gpointer self);
static void _editing_tools_adjust_tool_on_tint_adjustment_gtk_range_value_changed (GtkRange* _sender,
                                                                            gpointer self);
static void _editing_tools_adjust_tool_on_temperature_adjustment_gtk_range_value_changed (GtkRange* _sender,
                                                                                   gpointer self);
static void _editing_tools_adjust_tool_on_shadows_adjustment_gtk_range_value_changed (GtkRange* _sender,
                                                                               gpointer self);
static void _editing_tools_adjust_tool_on_highlights_adjustment_gtk_range_value_changed (GtkRange* _sender,
                                                                                  gpointer self);
static void _editing_tools_adjust_tool_on_histogram_constraint_rgb_histogram_manipulator_nub_position_changed (RGBHistogramManipulator* _sender,
                                                                                                        gpointer self);
static gboolean _editing_tools_adjust_tool_on_hscale_reset_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                                   GdkEventButton* event,
                                                                                   gpointer self);
VALA_EXTERN gboolean editing_tools_adjust_tool_enhance (EditingToolsAdjustTool* self);
static GType editing_tools_adjust_tool_adjust_enhance_command_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (EditingToolsAdjustToolAdjustEnhanceCommand, g_object_unref)
static EditingToolsAdjustToolAdjustEnhanceCommand* editing_tools_adjust_tool_adjust_enhance_command_new (EditingToolsAdjustTool* owner,
                                                                                                  Photo* photo);
static EditingToolsAdjustToolAdjustEnhanceCommand* editing_tools_adjust_tool_adjust_enhance_command_construct (GType object_type,
                                                                                                        EditingToolsAdjustTool* owner,
                                                                                                        Photo* photo);
static void editing_tools_adjust_tool_set_adjustments (EditingToolsAdjustTool* self,
                                                PixelTransformationBundle* new_adjustments);
static void editing_tools_adjust_tool_update_slider (EditingToolsAdjustTool* self,
                                              PixelTransformation* transformation);
static gboolean editing_tools_adjust_tool_real_on_keypress (EditingToolsEditingTool* base,
                                                     GdkEventKey* event);
VALA_EXTERN RGBHistogramManipulator* rgb_histogram_manipulator_new (void);
VALA_EXTERN RGBHistogramManipulator* rgb_histogram_manipulator_construct (GType object_type);
static void editing_tools_adjust_tool_adjust_tool_window_finalize (GObject * obj);
static GType editing_tools_adjust_tool_adjust_tool_window_get_type_once (void);
VALA_EXTERN GType command_description_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CommandDescription, g_object_unref)
static void editing_tools_adjust_tool_adjust_tool_command_on_owner_deactivated (EditingToolsAdjustToolAdjustToolCommand* self);
static void _editing_tools_adjust_tool_adjust_tool_command_on_owner_deactivated_editing_tools_editing_tool_deactivated (EditingToolsEditingTool* _sender,
                                                                                                                 gpointer self);
static EditingToolsAdjustToolAdjustToolCommand* editing_tools_adjust_tool_adjust_tool_command_construct (GType object_type,
                                                                                                  EditingToolsAdjustTool* owner,
                                                                                                  const gchar* name,
                                                                                                  const gchar* explanation);
VALA_EXTERN Command* command_construct (GType object_type,
                            const gchar* name,
                            const gchar* explanation);
VALA_EXTERN void command_manager_reset (CommandManager* self);
static void editing_tools_adjust_tool_adjust_tool_command_finalize (GObject * obj);
static GType editing_tools_adjust_tool_adjust_tool_command_get_type_once (void);
VALA_EXTERN void command_execute (Command* self);
VALA_EXTERN void command_undo (Command* self);
VALA_EXTERN gboolean command_compress (Command* self,
                           Command* command);
static void editing_tools_adjust_tool_adjust_reset_command_real_execute (Command* base);
static void editing_tools_adjust_tool_adjust_reset_command_real_undo (Command* base);
static gboolean editing_tools_adjust_tool_adjust_reset_command_real_compress (Command* base,
                                                                       Command* command);
static void editing_tools_adjust_tool_adjust_reset_command_finalize (GObject * obj);
static GType editing_tools_adjust_tool_adjust_reset_command_get_type_once (void);
VALA_EXTERN void command_redo (Command* self);
static void editing_tools_adjust_tool_slider_adjustment_command_real_execute (Command* base);
static void editing_tools_adjust_tool_slider_adjustment_command_real_undo (Command* base);
static void editing_tools_adjust_tool_slider_adjustment_command_real_redo (Command* base);
static gboolean editing_tools_adjust_tool_slider_adjustment_command_real_compress (Command* base,
                                                                            Command* command);
static void editing_tools_adjust_tool_slider_adjustment_command_finalize (GObject * obj);
static GType editing_tools_adjust_tool_slider_adjustment_command_get_type_once (void);
static void editing_tools_adjust_tool_adjust_enhance_command_real_execute (Command* base);
VALA_EXTERN PixelTransformationBundle* photo_get_enhance_transformations (Photo* self);
static void editing_tools_adjust_tool_adjust_enhance_command_real_undo (Command* base);
static gboolean editing_tools_adjust_tool_adjust_enhance_command_real_compress (Command* base,
                                                                         Command* command);
VALA_EXTERN GType enhance_single_command_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (EnhanceSingleCommand, g_object_unref)
VALA_EXTERN DataSource* single_data_source_command_get_source (SingleDataSourceCommand* self);
VALA_EXTERN gboolean data_source_equals (DataSource* self,
                             DataSource* source);
static void editing_tools_adjust_tool_adjust_enhance_command_finalize (GObject * obj);
static GType editing_tools_adjust_tool_adjust_enhance_command_get_type_once (void);
static void editing_tools_adjust_tool_finalize (EditingToolsEditingTool * obj);
static GType editing_tools_adjust_tool_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

void
editing_tools_preconfigure (void)
{
}

void
editing_tools_init (GError** error)
{
}

void
editing_tools_terminate (void)
{
}

static inline gpointer
editing_tools_editing_tool_window_get_instance_private (EditingToolsEditingToolWindow* self)
{
	return G_STRUCT_MEMBER_P (self, EditingToolsEditingToolWindow_private_offset);
}

static void
_editing_tools_editing_tool_window_suppress_warnings_glog_func (const gchar* log_domain,
                                                                GLogLevelFlags log_levels,
                                                                const gchar* message,
                                                                gpointer self)
{
#line 56 "../src/editing_tools/EditingTools.vala"
	editing_tools_editing_tool_window_suppress_warnings ((EditingToolsEditingToolWindow*) self, log_domain, log_levels, message);
#line 2084 "EditingTools.c"
}

EditingToolsEditingToolWindow*
editing_tools_editing_tool_window_construct (GType object_type,
                                             GtkWindow* container)
{
	EditingToolsEditingToolWindow * self = NULL;
	GtkFrame* outer_frame = NULL;
	GtkFrame* _tmp0_;
	GtkFrame* _tmp1_;
	GtkFrame* _tmp2_;
	GtkFrame* _tmp3_;
#line 34 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (container, gtk_window_get_type ()), NULL);
#line 34 "../src/editing_tools/EditingTools.vala"
	self = (EditingToolsEditingToolWindow*) g_object_new (object_type, NULL);
#line 35 "../src/editing_tools/EditingTools.vala"
	gtk_window_set_decorated (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow), FALSE);
#line 36 "../src/editing_tools/EditingTools.vala"
	gtk_window_set_transient_for (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow), container);
#line 38 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = (GtkFrame*) gtk_frame_new (NULL);
#line 38 "../src/editing_tools/EditingTools.vala"
	g_object_ref_sink (_tmp0_);
#line 38 "../src/editing_tools/EditingTools.vala"
	outer_frame = _tmp0_;
#line 39 "../src/editing_tools/EditingTools.vala"
	gtk_container_set_border_width (G_TYPE_CHECK_INSTANCE_CAST (outer_frame, gtk_container_get_type (), GtkContainer), (guint) 0);
#line 40 "../src/editing_tools/EditingTools.vala"
	gtk_frame_set_shadow_type (outer_frame, GTK_SHADOW_OUT);
#line 42 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = self->priv->layout_frame;
#line 42 "../src/editing_tools/EditingTools.vala"
	gtk_container_set_border_width (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_container_get_type (), GtkContainer), (guint) EDITING_TOOLS_EDITING_TOOL_WINDOW_FRAME_BORDER);
#line 43 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = self->priv->layout_frame;
#line 43 "../src/editing_tools/EditingTools.vala"
	gtk_frame_set_shadow_type (_tmp2_, GTK_SHADOW_NONE);
#line 45 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = self->priv->layout_frame;
#line 45 "../src/editing_tools/EditingTools.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (outer_frame, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_widget_get_type (), GtkWidget));
#line 46 "../src/editing_tools/EditingTools.vala"
	GTK_CONTAINER_CLASS (editing_tools_editing_tool_window_parent_class)->add (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow), gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (outer_frame, gtk_widget_get_type (), GtkWidget));
#line 48 "../src/editing_tools/EditingTools.vala"
	gtk_widget_add_events (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), (gint) (GDK_BUTTON_PRESS_MASK | GDK_KEY_PRESS_MASK));
#line 49 "../src/editing_tools/EditingTools.vala"
	gtk_window_set_focus_on_map (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow), TRUE);
#line 50 "../src/editing_tools/EditingTools.vala"
	gtk_window_set_accept_focus (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow), TRUE);
#line 51 "../src/editing_tools/EditingTools.vala"
	gtk_widget_set_can_focus (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), TRUE);
#line 56 "../src/editing_tools/EditingTools.vala"
	g_log_set_handler ("Gdk", G_LOG_LEVEL_WARNING, _editing_tools_editing_tool_window_suppress_warnings_glog_func, self);
#line 34 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (outer_frame);
#line 34 "../src/editing_tools/EditingTools.vala"
	return self;
#line 2143 "EditingTools.c"
}

static void
editing_tools_editing_tool_window_real_add (GtkContainer* base,
                                            GtkWidget* widget)
{
	EditingToolsEditingToolWindow * self;
	GtkFrame* _tmp0_;
#line 63 "../src/editing_tools/EditingTools.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, EDITING_TOOLS_TYPE_EDITING_TOOL_WINDOW, EditingToolsEditingToolWindow);
#line 63 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (widget, gtk_widget_get_type ()));
#line 64 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->layout_frame;
#line 64 "../src/editing_tools/EditingTools.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_container_get_type (), GtkContainer), widget);
#line 2160 "EditingTools.c"
}

gboolean
editing_tools_editing_tool_window_has_user_moved (EditingToolsEditingToolWindow* self)
{
	gboolean result;
#line 67 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (EDITING_TOOLS_IS_EDITING_TOOL_WINDOW (self), FALSE);
#line 68 "../src/editing_tools/EditingTools.vala"
	result = self->priv->user_moved;
#line 68 "../src/editing_tools/EditingTools.vala"
	return result;
#line 2173 "EditingTools.c"
}

static gboolean
editing_tools_editing_tool_window_real_key_press_event (GtkWidget* base,
                                                        GdkEventKey* event)
{
	EditingToolsEditingToolWindow * self;
	AppWindow* _tmp0_;
	AppWindow* _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_;
	gboolean result;
#line 71 "../src/editing_tools/EditingTools.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, EDITING_TOOLS_TYPE_EDITING_TOOL_WINDOW, EditingToolsEditingToolWindow);
#line 71 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 72 "../src/editing_tools/EditingTools.vala"
	if (GTK_WIDGET_CLASS (editing_tools_editing_tool_window_parent_class)->key_press_event (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow), gtk_widget_get_type (), GtkWidget), event)) {
#line 73 "../src/editing_tools/EditingTools.vala"
		result = TRUE;
#line 73 "../src/editing_tools/EditingTools.vala"
		return result;
#line 2196 "EditingTools.c"
	}
#line 75 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = app_window_get_instance ();
#line 75 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = _tmp0_;
#line 75 "../src/editing_tools/EditingTools.vala"
	g_signal_emit_by_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_widget_get_type (), GtkWidget), "key-press-event", event, &_tmp2_);
#line 75 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = _tmp2_;
#line 75 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (_tmp1_);
#line 75 "../src/editing_tools/EditingTools.vala"
	result = _tmp3_;
#line 75 "../src/editing_tools/EditingTools.vala"
	return result;
#line 2212 "EditingTools.c"
}

static gboolean
editing_tools_editing_tool_window_real_button_press_event (GtkWidget* base,
                                                           GdkEventButton* event)
{
	EditingToolsEditingToolWindow * self;
	gboolean result;
#line 78 "../src/editing_tools/EditingTools.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, EDITING_TOOLS_TYPE_EDITING_TOOL_WINDOW, EditingToolsEditingToolWindow);
#line 78 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 80 "../src/editing_tools/EditingTools.vala"
	if (event->button != ((guint) 1)) {
#line 2227 "EditingTools.c"
		gboolean _tmp0_ = FALSE;
#line 81 "../src/editing_tools/EditingTools.vala"
		if (GTK_WIDGET_CLASS (editing_tools_editing_tool_window_parent_class)->button_press_event != NULL) {
#line 81 "../src/editing_tools/EditingTools.vala"
			_tmp0_ = GTK_WIDGET_CLASS (editing_tools_editing_tool_window_parent_class)->button_press_event (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow), gtk_widget_get_type (), GtkWidget), event);
#line 2233 "EditingTools.c"
		} else {
#line 81 "../src/editing_tools/EditingTools.vala"
			_tmp0_ = TRUE;
#line 2237 "EditingTools.c"
		}
#line 81 "../src/editing_tools/EditingTools.vala"
		result = _tmp0_;
#line 81 "../src/editing_tools/EditingTools.vala"
		return result;
#line 2243 "EditingTools.c"
	}
#line 83 "../src/editing_tools/EditingTools.vala"
	gtk_window_begin_move_drag (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow), (gint) event->button, (gint) event->x_root, (gint) event->y_root, event->time);
#line 84 "../src/editing_tools/EditingTools.vala"
	self->priv->user_moved = TRUE;
#line 86 "../src/editing_tools/EditingTools.vala"
	result = TRUE;
#line 86 "../src/editing_tools/EditingTools.vala"
	return result;
#line 2253 "EditingTools.c"
}

static void
editing_tools_editing_tool_window_real_realize (GtkWidget* base)
{
	EditingToolsEditingToolWindow * self;
#line 89 "../src/editing_tools/EditingTools.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, EDITING_TOOLS_TYPE_EDITING_TOOL_WINDOW, EditingToolsEditingToolWindow);
#line 91 "../src/editing_tools/EditingTools.vala"
	gtk_widget_set_opacity (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget), RESOURCES_TRANSIENT_WINDOW_OPACITY);
#line 93 "../src/editing_tools/EditingTools.vala"
	GTK_WIDGET_CLASS (editing_tools_editing_tool_window_parent_class)->realize (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow), gtk_widget_get_type (), GtkWidget));
#line 2266 "EditingTools.c"
}

static void
editing_tools_editing_tool_window_suppress_warnings (EditingToolsEditingToolWindow* self,
                                                     const gchar* log_domain,
                                                     GLogLevelFlags log_levels,
                                                     const gchar* message)
{
#line 96 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_EDITING_TOOL_WINDOW (self));
#line 96 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (message != NULL);
#line 2279 "EditingTools.c"
}

static void
editing_tools_editing_tool_window_class_init (EditingToolsEditingToolWindowClass * klass,
                                              gpointer klass_data)
{
#line 28 "../src/editing_tools/EditingTools.vala"
	editing_tools_editing_tool_window_parent_class = g_type_class_peek_parent (klass);
#line 28 "../src/editing_tools/EditingTools.vala"
	g_type_class_adjust_private_offset (klass, &EditingToolsEditingToolWindow_private_offset);
#line 28 "../src/editing_tools/EditingTools.vala"
	((GtkContainerClass *) klass)->add = (void (*) (GtkContainer*, GtkWidget*)) editing_tools_editing_tool_window_real_add;
#line 28 "../src/editing_tools/EditingTools.vala"
	((GtkWidgetClass *) klass)->key_press_event = (gboolean (*) (GtkWidget*, GdkEventKey*)) editing_tools_editing_tool_window_real_key_press_event;
#line 28 "../src/editing_tools/EditingTools.vala"
	((GtkWidgetClass *) klass)->button_press_event = (gboolean (*) (GtkWidget*, GdkEventButton*)) editing_tools_editing_tool_window_real_button_press_event;
#line 28 "../src/editing_tools/EditingTools.vala"
	((GtkWidgetClass *) klass)->realize = (void (*) (GtkWidget*)) editing_tools_editing_tool_window_real_realize;
#line 28 "../src/editing_tools/EditingTools.vala"
	G_OBJECT_CLASS (klass)->finalize = editing_tools_editing_tool_window_finalize;
#line 2300 "EditingTools.c"
}

static void
editing_tools_editing_tool_window_instance_init (EditingToolsEditingToolWindow * self,
                                                 gpointer klass)
{
	GtkFrame* _tmp0_;
#line 28 "../src/editing_tools/EditingTools.vala"
	self->priv = editing_tools_editing_tool_window_get_instance_private (self);
#line 31 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = (GtkFrame*) gtk_frame_new (NULL);
#line 31 "../src/editing_tools/EditingTools.vala"
	g_object_ref_sink (_tmp0_);
#line 31 "../src/editing_tools/EditingTools.vala"
	self->priv->layout_frame = _tmp0_;
#line 32 "../src/editing_tools/EditingTools.vala"
	self->priv->user_moved = FALSE;
#line 2318 "EditingTools.c"
}

static void
editing_tools_editing_tool_window_finalize (GObject * obj)
{
	EditingToolsEditingToolWindow * self;
	GLogFunc _tmp0_;
	gpointer _tmp0__target;
#line 28 "../src/editing_tools/EditingTools.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, EDITING_TOOLS_TYPE_EDITING_TOOL_WINDOW, EditingToolsEditingToolWindow);
#line 60 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = g_log_default_handler;
#line 60 "../src/editing_tools/EditingTools.vala"
	_tmp0__target = NULL;
#line 60 "../src/editing_tools/EditingTools.vala"
	g_log_set_handler ("Gdk", G_LOG_LEVEL_WARNING, _tmp0_, _tmp0__target);
#line 31 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->priv->layout_frame);
#line 28 "../src/editing_tools/EditingTools.vala"
	G_OBJECT_CLASS (editing_tools_editing_tool_window_parent_class)->finalize (obj);
#line 2339 "EditingTools.c"
}

static GType
editing_tools_editing_tool_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (EditingToolsEditingToolWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) editing_tools_editing_tool_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EditingToolsEditingToolWindow), 0, (GInstanceInitFunc) editing_tools_editing_tool_window_instance_init, NULL };
	GType editing_tools_editing_tool_window_type_id;
	editing_tools_editing_tool_window_type_id = g_type_register_static (gtk_window_get_type (), "EditingToolsEditingToolWindow", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	EditingToolsEditingToolWindow_private_offset = g_type_add_instance_private (editing_tools_editing_tool_window_type_id, sizeof (EditingToolsEditingToolWindowPrivate));
	return editing_tools_editing_tool_window_type_id;
}

GType
editing_tools_editing_tool_window_get_type (void)
{
	static volatile gsize editing_tools_editing_tool_window_type_id__once = 0;
	if (g_once_init_enter (&editing_tools_editing_tool_window_type_id__once)) {
		GType editing_tools_editing_tool_window_type_id;
		editing_tools_editing_tool_window_type_id = editing_tools_editing_tool_window_get_type_once ();
		g_once_init_leave (&editing_tools_editing_tool_window_type_id__once, editing_tools_editing_tool_window_type_id);
	}
	return editing_tools_editing_tool_window_type_id__once;
}

static inline gpointer
editing_tools_photo_canvas_get_instance_private (EditingToolsPhotoCanvas* self)
{
	return G_STRUCT_MEMBER_P (self, EditingToolsPhotoCanvas_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 116 "../src/editing_tools/EditingTools.vala"
	return self ? g_object_ref (self) : NULL;
#line 2375 "EditingTools.c"
}

static gpointer
_cairo_reference0 (gpointer self)
{
#line 119 "../src/editing_tools/EditingTools.vala"
	return self ? cairo_reference (self) : NULL;
#line 2383 "EditingTools.c"
}

EditingToolsPhotoCanvas*
editing_tools_photo_canvas_construct (GType object_type,
                                      GtkWindow* container,
                                      GdkWindow* drawing_window,
                                      Photo* photo,
                                      cairo_t* default_ctx,
                                      Dimensions* surface_dim,
                                      GdkPixbuf* scaled,
                                      GdkRectangle* scaled_position)
{
	EditingToolsPhotoCanvas* self = NULL;
	GtkWindow* _tmp0_;
	GdkWindow* _tmp1_;
	Photo* _tmp2_;
	cairo_t* _tmp3_;
	Dimensions _tmp4_;
	GdkRectangle _tmp5_;
	GdkPixbuf* _tmp6_;
	GdkRectangle _tmp7_;
	cairo_surface_t* _tmp8_;
#line 114 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (container, gtk_window_get_type ()), NULL);
#line 114 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (drawing_window, gdk_window_get_type ()), NULL);
#line 114 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (IS_PHOTO (photo), NULL);
#line 114 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (default_ctx != NULL, NULL);
#line 114 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (surface_dim != NULL, NULL);
#line 114 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (scaled, gdk_pixbuf_get_type ()), NULL);
#line 114 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (scaled_position != NULL, NULL);
#line 114 "../src/editing_tools/EditingTools.vala"
	self = (EditingToolsPhotoCanvas*) g_type_create_instance (object_type);
#line 116 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = _g_object_ref0 (container);
#line 116 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->priv->container);
#line 116 "../src/editing_tools/EditingTools.vala"
	self->priv->container = _tmp0_;
#line 117 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = _g_object_ref0 (drawing_window);
#line 117 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->priv->drawing_window);
#line 117 "../src/editing_tools/EditingTools.vala"
	self->priv->drawing_window = _tmp1_;
#line 118 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = _g_object_ref0 (photo);
#line 118 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->priv->photo);
#line 118 "../src/editing_tools/EditingTools.vala"
	self->priv->photo = _tmp2_;
#line 119 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = _cairo_reference0 (default_ctx);
#line 119 "../src/editing_tools/EditingTools.vala"
	_cairo_destroy0 (self->priv->default_ctx);
#line 119 "../src/editing_tools/EditingTools.vala"
	self->priv->default_ctx = _tmp3_;
#line 120 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = *surface_dim;
#line 120 "../src/editing_tools/EditingTools.vala"
	self->priv->surface_dim = _tmp4_;
#line 121 "../src/editing_tools/EditingTools.vala"
	_tmp5_ = *scaled_position;
#line 121 "../src/editing_tools/EditingTools.vala"
	self->priv->scaled_position = _tmp5_;
#line 122 "../src/editing_tools/EditingTools.vala"
	_tmp6_ = _g_object_ref0 (scaled);
#line 122 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->priv->scaled_pixbuf);
#line 122 "../src/editing_tools/EditingTools.vala"
	self->priv->scaled_pixbuf = _tmp6_;
#line 123 "../src/editing_tools/EditingTools.vala"
	_tmp7_ = *scaled_position;
#line 123 "../src/editing_tools/EditingTools.vala"
	_tmp8_ = editing_tools_photo_canvas_pixbuf_to_surface (self, default_ctx, scaled, &_tmp7_);
#line 123 "../src/editing_tools/EditingTools.vala"
	_cairo_surface_destroy0 (self->priv->scaled);
#line 123 "../src/editing_tools/EditingTools.vala"
	self->priv->scaled = _tmp8_;
#line 114 "../src/editing_tools/EditingTools.vala"
	return self;
#line 2470 "EditingTools.c"
}

void
editing_tools_photo_canvas_unscaled_to_raw_rect (EditingToolsPhotoCanvas* self,
                                                 GdkRectangle* rectangle,
                                                 GdkRectangle* result)
{
	Photo* _tmp0_;
	GdkRectangle _tmp1_;
	GdkRectangle _tmp2_ = {0};
#line 131 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_PHOTO_CANVAS (self));
#line 131 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (rectangle != NULL);
#line 132 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->photo;
#line 132 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = *rectangle;
#line 132 "../src/editing_tools/EditingTools.vala"
	photo_unscaled_to_raw_rect (_tmp0_, &_tmp1_, &_tmp2_);
#line 132 "../src/editing_tools/EditingTools.vala"
	*result = _tmp2_;
#line 132 "../src/editing_tools/EditingTools.vala"
	return;
#line 2495 "EditingTools.c"
}

void
editing_tools_photo_canvas_active_to_unscaled_point (EditingToolsPhotoCanvas* self,
                                                     GdkPoint* active_point,
                                                     GdkPoint* result)
{
	GdkRectangle scaled_position = {0};
	GdkRectangle _tmp0_ = {0};
	Dimensions unscaled_dims = {0};
	Photo* _tmp1_;
	Dimensions _tmp2_ = {0};
	gdouble scale_factor_x = 0.0;
	Dimensions _tmp3_;
	GdkRectangle _tmp4_;
	gdouble scale_factor_y = 0.0;
	Dimensions _tmp5_;
	GdkRectangle _tmp6_;
	GdkPoint _result_ = {0};
	GdkPoint _tmp7_ = {0};
	GdkPoint _tmp8_;
	GdkPoint _tmp9_;
#line 135 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_PHOTO_CANVAS (self));
#line 135 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (active_point != NULL);
#line 136 "../src/editing_tools/EditingTools.vala"
	editing_tools_photo_canvas_get_scaled_pixbuf_position (self, &_tmp0_);
#line 136 "../src/editing_tools/EditingTools.vala"
	scaled_position = _tmp0_;
#line 137 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = self->priv->photo;
#line 137 "../src/editing_tools/EditingTools.vala"
	media_source_get_dimensions (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_MEDIA_SOURCE, MediaSource), PHOTO_EXCEPTION_NONE, &_tmp2_);
#line 137 "../src/editing_tools/EditingTools.vala"
	unscaled_dims = _tmp2_;
#line 139 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = unscaled_dims;
#line 139 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = scaled_position;
#line 139 "../src/editing_tools/EditingTools.vala"
	scale_factor_x = ((gdouble) _tmp3_.width) / ((gdouble) _tmp4_.width);
#line 141 "../src/editing_tools/EditingTools.vala"
	_tmp5_ = unscaled_dims;
#line 141 "../src/editing_tools/EditingTools.vala"
	_tmp6_ = scaled_position;
#line 141 "../src/editing_tools/EditingTools.vala"
	scale_factor_y = ((gdouble) _tmp5_.height) / ((gdouble) _tmp6_.height);
#line 144 "../src/editing_tools/EditingTools.vala"
	_tmp7_.x = 0;
#line 144 "../src/editing_tools/EditingTools.vala"
	_result_ = _tmp7_;
#line 145 "../src/editing_tools/EditingTools.vala"
	_tmp8_ = *active_point;
#line 145 "../src/editing_tools/EditingTools.vala"
	_result_.x = (gint) ((((gdouble) _tmp8_.x) * scale_factor_x) + 0.5);
#line 146 "../src/editing_tools/EditingTools.vala"
	_tmp9_ = *active_point;
#line 146 "../src/editing_tools/EditingTools.vala"
	_result_.y = (gint) ((((gdouble) _tmp9_.y) * scale_factor_y) + 0.5);
#line 148 "../src/editing_tools/EditingTools.vala"
	*result = _result_;
#line 148 "../src/editing_tools/EditingTools.vala"
	return;
#line 2560 "EditingTools.c"
}

void
editing_tools_photo_canvas_active_to_unscaled_rect (EditingToolsPhotoCanvas* self,
                                                    GdkRectangle* active_rect,
                                                    GdkRectangle* result)
{
	GdkPoint upper_left = {0};
	GdkPoint _tmp0_ = {0};
	GdkPoint lower_right = {0};
	GdkPoint _tmp1_ = {0};
	GdkRectangle _tmp2_;
	GdkRectangle _tmp3_;
	GdkPoint _tmp4_;
	GdkRectangle _tmp5_;
	GdkPoint _tmp6_;
	GdkRectangle _tmp7_;
	GdkPoint _tmp8_;
	GdkPoint _tmp9_ = {0};
	GdkPoint _tmp10_;
	GdkPoint _tmp11_ = {0};
	GdkRectangle unscaled_rect = {0};
	GdkPoint _tmp12_;
	GdkPoint _tmp13_;
	GdkPoint _tmp14_;
	GdkPoint _tmp15_;
	GdkPoint _tmp16_;
	GdkPoint _tmp17_;
#line 151 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_PHOTO_CANVAS (self));
#line 151 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (active_rect != NULL);
#line 152 "../src/editing_tools/EditingTools.vala"
	_tmp0_.x = 0;
#line 152 "../src/editing_tools/EditingTools.vala"
	upper_left = _tmp0_;
#line 153 "../src/editing_tools/EditingTools.vala"
	_tmp1_.x = 0;
#line 153 "../src/editing_tools/EditingTools.vala"
	lower_right = _tmp1_;
#line 154 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = *active_rect;
#line 154 "../src/editing_tools/EditingTools.vala"
	upper_left.x = _tmp2_.x;
#line 155 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = *active_rect;
#line 155 "../src/editing_tools/EditingTools.vala"
	upper_left.y = _tmp3_.y;
#line 156 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = upper_left;
#line 156 "../src/editing_tools/EditingTools.vala"
	_tmp5_ = *active_rect;
#line 156 "../src/editing_tools/EditingTools.vala"
	lower_right.x = _tmp4_.x + _tmp5_.width;
#line 157 "../src/editing_tools/EditingTools.vala"
	_tmp6_ = upper_left;
#line 157 "../src/editing_tools/EditingTools.vala"
	_tmp7_ = *active_rect;
#line 157 "../src/editing_tools/EditingTools.vala"
	lower_right.y = _tmp6_.y + _tmp7_.height;
#line 159 "../src/editing_tools/EditingTools.vala"
	_tmp8_ = upper_left;
#line 159 "../src/editing_tools/EditingTools.vala"
	editing_tools_photo_canvas_active_to_unscaled_point (self, &_tmp8_, &_tmp9_);
#line 159 "../src/editing_tools/EditingTools.vala"
	upper_left = _tmp9_;
#line 160 "../src/editing_tools/EditingTools.vala"
	_tmp10_ = lower_right;
#line 160 "../src/editing_tools/EditingTools.vala"
	editing_tools_photo_canvas_active_to_unscaled_point (self, &_tmp10_, &_tmp11_);
#line 160 "../src/editing_tools/EditingTools.vala"
	lower_right = _tmp11_;
#line 162 "../src/editing_tools/EditingTools.vala"
	memset (&unscaled_rect, 0, sizeof (GdkRectangle));
#line 163 "../src/editing_tools/EditingTools.vala"
	_tmp12_ = upper_left;
#line 163 "../src/editing_tools/EditingTools.vala"
	unscaled_rect.x = _tmp12_.x;
#line 164 "../src/editing_tools/EditingTools.vala"
	_tmp13_ = upper_left;
#line 164 "../src/editing_tools/EditingTools.vala"
	unscaled_rect.y = _tmp13_.y;
#line 165 "../src/editing_tools/EditingTools.vala"
	_tmp14_ = lower_right;
#line 165 "../src/editing_tools/EditingTools.vala"
	_tmp15_ = upper_left;
#line 165 "../src/editing_tools/EditingTools.vala"
	unscaled_rect.width = _tmp14_.x - _tmp15_.x;
#line 166 "../src/editing_tools/EditingTools.vala"
	_tmp16_ = lower_right;
#line 166 "../src/editing_tools/EditingTools.vala"
	_tmp17_ = upper_left;
#line 166 "../src/editing_tools/EditingTools.vala"
	unscaled_rect.height = _tmp16_.y - _tmp17_.y;
#line 168 "../src/editing_tools/EditingTools.vala"
	*result = unscaled_rect;
#line 168 "../src/editing_tools/EditingTools.vala"
	return;
#line 2659 "EditingTools.c"
}

void
editing_tools_photo_canvas_user_to_active_point (EditingToolsPhotoCanvas* self,
                                                 GdkPoint* user_point,
                                                 GdkPoint* result)
{
	GdkRectangle active_offsets = {0};
	GdkRectangle _tmp0_ = {0};
	GdkPoint _result_ = {0};
	GdkPoint _tmp1_ = {0};
	GdkPoint _tmp2_;
	GdkRectangle _tmp3_;
	GdkPoint _tmp4_;
	GdkRectangle _tmp5_;
#line 171 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_PHOTO_CANVAS (self));
#line 171 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (user_point != NULL);
#line 172 "../src/editing_tools/EditingTools.vala"
	editing_tools_photo_canvas_get_scaled_pixbuf_position (self, &_tmp0_);
#line 172 "../src/editing_tools/EditingTools.vala"
	active_offsets = _tmp0_;
#line 174 "../src/editing_tools/EditingTools.vala"
	_tmp1_.x = 0;
#line 174 "../src/editing_tools/EditingTools.vala"
	_result_ = _tmp1_;
#line 175 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = *user_point;
#line 175 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = active_offsets;
#line 175 "../src/editing_tools/EditingTools.vala"
	_result_.x = _tmp2_.x - _tmp3_.x;
#line 176 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = *user_point;
#line 176 "../src/editing_tools/EditingTools.vala"
	_tmp5_ = active_offsets;
#line 176 "../src/editing_tools/EditingTools.vala"
	_result_.y = _tmp4_.y - _tmp5_.y;
#line 178 "../src/editing_tools/EditingTools.vala"
	*result = _result_;
#line 178 "../src/editing_tools/EditingTools.vala"
	return;
#line 2703 "EditingTools.c"
}

void
editing_tools_photo_canvas_user_to_active_rect (EditingToolsPhotoCanvas* self,
                                                GdkRectangle* user_rect,
                                                GdkRectangle* result)
{
	GdkPoint upper_left = {0};
	GdkPoint _tmp0_ = {0};
	GdkPoint lower_right = {0};
	GdkPoint _tmp1_ = {0};
	GdkRectangle _tmp2_;
	GdkRectangle _tmp3_;
	GdkPoint _tmp4_;
	GdkRectangle _tmp5_;
	GdkPoint _tmp6_;
	GdkRectangle _tmp7_;
	GdkPoint _tmp8_;
	GdkPoint _tmp9_ = {0};
	GdkPoint _tmp10_;
	GdkPoint _tmp11_ = {0};
	GdkRectangle active_rect = {0};
	GdkPoint _tmp12_;
	GdkPoint _tmp13_;
	GdkPoint _tmp14_;
	GdkPoint _tmp15_;
	GdkPoint _tmp16_;
	GdkPoint _tmp17_;
#line 181 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_PHOTO_CANVAS (self));
#line 181 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (user_rect != NULL);
#line 182 "../src/editing_tools/EditingTools.vala"
	_tmp0_.x = 0;
#line 182 "../src/editing_tools/EditingTools.vala"
	upper_left = _tmp0_;
#line 183 "../src/editing_tools/EditingTools.vala"
	_tmp1_.x = 0;
#line 183 "../src/editing_tools/EditingTools.vala"
	lower_right = _tmp1_;
#line 184 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = *user_rect;
#line 184 "../src/editing_tools/EditingTools.vala"
	upper_left.x = _tmp2_.x;
#line 185 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = *user_rect;
#line 185 "../src/editing_tools/EditingTools.vala"
	upper_left.y = _tmp3_.y;
#line 186 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = upper_left;
#line 186 "../src/editing_tools/EditingTools.vala"
	_tmp5_ = *user_rect;
#line 186 "../src/editing_tools/EditingTools.vala"
	lower_right.x = _tmp4_.x + _tmp5_.width;
#line 187 "../src/editing_tools/EditingTools.vala"
	_tmp6_ = upper_left;
#line 187 "../src/editing_tools/EditingTools.vala"
	_tmp7_ = *user_rect;
#line 187 "../src/editing_tools/EditingTools.vala"
	lower_right.y = _tmp6_.y + _tmp7_.height;
#line 189 "../src/editing_tools/EditingTools.vala"
	_tmp8_ = upper_left;
#line 189 "../src/editing_tools/EditingTools.vala"
	editing_tools_photo_canvas_user_to_active_point (self, &_tmp8_, &_tmp9_);
#line 189 "../src/editing_tools/EditingTools.vala"
	upper_left = _tmp9_;
#line 190 "../src/editing_tools/EditingTools.vala"
	_tmp10_ = lower_right;
#line 190 "../src/editing_tools/EditingTools.vala"
	editing_tools_photo_canvas_user_to_active_point (self, &_tmp10_, &_tmp11_);
#line 190 "../src/editing_tools/EditingTools.vala"
	lower_right = _tmp11_;
#line 192 "../src/editing_tools/EditingTools.vala"
	memset (&active_rect, 0, sizeof (GdkRectangle));
#line 193 "../src/editing_tools/EditingTools.vala"
	_tmp12_ = upper_left;
#line 193 "../src/editing_tools/EditingTools.vala"
	active_rect.x = _tmp12_.x;
#line 194 "../src/editing_tools/EditingTools.vala"
	_tmp13_ = upper_left;
#line 194 "../src/editing_tools/EditingTools.vala"
	active_rect.y = _tmp13_.y;
#line 195 "../src/editing_tools/EditingTools.vala"
	_tmp14_ = lower_right;
#line 195 "../src/editing_tools/EditingTools.vala"
	_tmp15_ = upper_left;
#line 195 "../src/editing_tools/EditingTools.vala"
	active_rect.width = _tmp14_.x - _tmp15_.x;
#line 196 "../src/editing_tools/EditingTools.vala"
	_tmp16_ = lower_right;
#line 196 "../src/editing_tools/EditingTools.vala"
	_tmp17_ = upper_left;
#line 196 "../src/editing_tools/EditingTools.vala"
	active_rect.height = _tmp16_.y - _tmp17_.y;
#line 198 "../src/editing_tools/EditingTools.vala"
	*result = active_rect;
#line 198 "../src/editing_tools/EditingTools.vala"
	return;
#line 2802 "EditingTools.c"
}

Photo*
editing_tools_photo_canvas_get_photo (EditingToolsPhotoCanvas* self)
{
	Photo* _tmp0_;
	Photo* _tmp1_;
	Photo* result;
#line 201 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (EDITING_TOOLS_IS_PHOTO_CANVAS (self), NULL);
#line 202 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->photo;
#line 202 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 202 "../src/editing_tools/EditingTools.vala"
	result = _tmp1_;
#line 202 "../src/editing_tools/EditingTools.vala"
	return result;
#line 2821 "EditingTools.c"
}

GtkWindow*
editing_tools_photo_canvas_get_container (EditingToolsPhotoCanvas* self)
{
	GtkWindow* _tmp0_;
	GtkWindow* _tmp1_;
	GtkWindow* result;
#line 205 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (EDITING_TOOLS_IS_PHOTO_CANVAS (self), NULL);
#line 206 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->container;
#line 206 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 206 "../src/editing_tools/EditingTools.vala"
	result = _tmp1_;
#line 206 "../src/editing_tools/EditingTools.vala"
	return result;
#line 2840 "EditingTools.c"
}

GdkWindow*
editing_tools_photo_canvas_get_drawing_window (EditingToolsPhotoCanvas* self)
{
	GdkWindow* _tmp0_;
	GdkWindow* _tmp1_;
	GdkWindow* result;
#line 209 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (EDITING_TOOLS_IS_PHOTO_CANVAS (self), NULL);
#line 210 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->drawing_window;
#line 210 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 210 "../src/editing_tools/EditingTools.vala"
	result = _tmp1_;
#line 210 "../src/editing_tools/EditingTools.vala"
	return result;
#line 2859 "EditingTools.c"
}

cairo_t*
editing_tools_photo_canvas_get_default_ctx (EditingToolsPhotoCanvas* self)
{
	cairo_t* _tmp0_;
	cairo_t* _tmp1_;
	cairo_t* result;
#line 213 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (EDITING_TOOLS_IS_PHOTO_CANVAS (self), NULL);
#line 214 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->default_ctx;
#line 214 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = _cairo_reference0 (_tmp0_);
#line 214 "../src/editing_tools/EditingTools.vala"
	result = _tmp1_;
#line 214 "../src/editing_tools/EditingTools.vala"
	return result;
#line 2878 "EditingTools.c"
}

void
editing_tools_photo_canvas_get_surface_dim (EditingToolsPhotoCanvas* self,
                                            Dimensions* result)
{
	Dimensions _tmp0_;
#line 217 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_PHOTO_CANVAS (self));
#line 218 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->surface_dim;
#line 218 "../src/editing_tools/EditingTools.vala"
	*result = _tmp0_;
#line 218 "../src/editing_tools/EditingTools.vala"
	return;
#line 2894 "EditingTools.c"
}

void
editing_tools_photo_canvas_get_scaling (EditingToolsPhotoCanvas* self,
                                        Scaling* result)
{
	Dimensions _tmp0_;
	Scaling _tmp1_ = {0};
#line 221 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_PHOTO_CANVAS (self));
#line 222 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->surface_dim;
#line 222 "../src/editing_tools/EditingTools.vala"
	scaling_for_viewport (&_tmp0_, FALSE, &_tmp1_);
#line 222 "../src/editing_tools/EditingTools.vala"
	*result = _tmp1_;
#line 222 "../src/editing_tools/EditingTools.vala"
	return;
#line 2913 "EditingTools.c"
}

void
editing_tools_photo_canvas_set_surface (EditingToolsPhotoCanvas* self,
                                        cairo_t* default_ctx,
                                        Dimensions* surface_dim)
{
	cairo_t* _tmp0_;
	Dimensions _tmp1_;
	Dimensions _tmp2_;
#line 225 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_PHOTO_CANVAS (self));
#line 225 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (default_ctx != NULL);
#line 225 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (surface_dim != NULL);
#line 226 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = _cairo_reference0 (default_ctx);
#line 226 "../src/editing_tools/EditingTools.vala"
	_cairo_destroy0 (self->priv->default_ctx);
#line 226 "../src/editing_tools/EditingTools.vala"
	self->priv->default_ctx = _tmp0_;
#line 227 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = *surface_dim;
#line 227 "../src/editing_tools/EditingTools.vala"
	self->priv->surface_dim = _tmp1_;
#line 229 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = *surface_dim;
#line 229 "../src/editing_tools/EditingTools.vala"
	g_signal_emit (self, editing_tools_photo_canvas_signals[EDITING_TOOLS_PHOTO_CANVAS_NEW_SURFACE_SIGNAL], 0, default_ctx, &_tmp2_);
#line 2944 "EditingTools.c"
}

static gpointer
_cairo_surface_reference0 (gpointer self)
{
#line 233 "../src/editing_tools/EditingTools.vala"
	return self ? cairo_surface_reference (self) : NULL;
#line 2952 "EditingTools.c"
}

cairo_surface_t*
editing_tools_photo_canvas_get_scaled_surface (EditingToolsPhotoCanvas* self)
{
	cairo_surface_t* _tmp0_;
	cairo_surface_t* _tmp1_;
	cairo_surface_t* result;
#line 232 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (EDITING_TOOLS_IS_PHOTO_CANVAS (self), NULL);
#line 233 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->scaled;
#line 233 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = _cairo_surface_reference0 (_tmp0_);
#line 233 "../src/editing_tools/EditingTools.vala"
	result = _tmp1_;
#line 233 "../src/editing_tools/EditingTools.vala"
	return result;
#line 2971 "EditingTools.c"
}

GdkPixbuf*
editing_tools_photo_canvas_get_scaled_pixbuf (EditingToolsPhotoCanvas* self)
{
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp1_;
	GdkPixbuf* result;
#line 236 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (EDITING_TOOLS_IS_PHOTO_CANVAS (self), NULL);
#line 237 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->scaled_pixbuf;
#line 237 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 237 "../src/editing_tools/EditingTools.vala"
	result = _tmp1_;
#line 237 "../src/editing_tools/EditingTools.vala"
	return result;
#line 2990 "EditingTools.c"
}

void
editing_tools_photo_canvas_get_scaled_pixbuf_position (EditingToolsPhotoCanvas* self,
                                                       GdkRectangle* result)
{
	GdkRectangle _tmp0_;
#line 240 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_PHOTO_CANVAS (self));
#line 241 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->scaled_position;
#line 241 "../src/editing_tools/EditingTools.vala"
	*result = _tmp0_;
#line 241 "../src/editing_tools/EditingTools.vala"
	return;
#line 3006 "EditingTools.c"
}

void
editing_tools_photo_canvas_resized_pixbuf (EditingToolsPhotoCanvas* self,
                                           Dimensions* old_dim,
                                           GdkPixbuf* scaled,
                                           GdkRectangle* scaled_position)
{
	cairo_t* _tmp0_;
	GdkRectangle _tmp1_;
	cairo_surface_t* _tmp2_;
	GdkPixbuf* _tmp3_;
	GdkRectangle _tmp4_;
	Dimensions _tmp5_;
	GdkRectangle _tmp6_;
#line 244 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_PHOTO_CANVAS (self));
#line 244 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (old_dim != NULL);
#line 244 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (scaled, gdk_pixbuf_get_type ()));
#line 244 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (scaled_position != NULL);
#line 245 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->default_ctx;
#line 245 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = *scaled_position;
#line 245 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = editing_tools_photo_canvas_pixbuf_to_surface (self, _tmp0_, scaled, &_tmp1_);
#line 245 "../src/editing_tools/EditingTools.vala"
	_cairo_surface_destroy0 (self->priv->scaled);
#line 245 "../src/editing_tools/EditingTools.vala"
	self->priv->scaled = _tmp2_;
#line 246 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = _g_object_ref0 (scaled);
#line 246 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->priv->scaled_pixbuf);
#line 246 "../src/editing_tools/EditingTools.vala"
	self->priv->scaled_pixbuf = _tmp3_;
#line 247 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = *scaled_position;
#line 247 "../src/editing_tools/EditingTools.vala"
	self->priv->scaled_position = _tmp4_;
#line 249 "../src/editing_tools/EditingTools.vala"
	_tmp5_ = *old_dim;
#line 249 "../src/editing_tools/EditingTools.vala"
	_tmp6_ = *scaled_position;
#line 249 "../src/editing_tools/EditingTools.vala"
	g_signal_emit (self, editing_tools_photo_canvas_signals[EDITING_TOOLS_PHOTO_CANVAS_RESIZED_SCALED_PIXBUF_SIGNAL], 0, &_tmp5_, scaled, &_tmp6_);
#line 3056 "EditingTools.c"
}

static void
editing_tools_photo_canvas_real_repaint (EditingToolsPhotoCanvas* self)
{
#line 252 "../src/editing_tools/EditingTools.vala"
	g_critical ("Type `%s' does not implement abstract method `editing_tools_photo_canvas_repaint'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 252 "../src/editing_tools/EditingTools.vala"
	return;
#line 3066 "EditingTools.c"
}

void
editing_tools_photo_canvas_repaint (EditingToolsPhotoCanvas* self)
{
	EditingToolsPhotoCanvasClass* _klass_;
#line 252 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_PHOTO_CANVAS (self));
#line 252 "../src/editing_tools/EditingTools.vala"
	_klass_ = EDITING_TOOLS_PHOTO_CANVAS_GET_CLASS (self);
#line 252 "../src/editing_tools/EditingTools.vala"
	if (_klass_->repaint) {
#line 252 "../src/editing_tools/EditingTools.vala"
		_klass_->repaint (self);
#line 3081 "EditingTools.c"
	}
}

void
editing_tools_photo_canvas_paint_pixbuf (EditingToolsPhotoCanvas* self,
                                         GdkPixbuf* pixbuf)
{
	cairo_t* _tmp0_;
	cairo_t* _tmp1_;
	cairo_t* _tmp2_;
	Dimensions _tmp3_;
	Dimensions _tmp4_;
	cairo_t* _tmp5_;
	cairo_t* _tmp6_;
	GdkRectangle _tmp7_;
	GdkRectangle _tmp8_;
	cairo_t* _tmp9_;
#line 260 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_PHOTO_CANVAS (self));
#line 260 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (pixbuf, gdk_pixbuf_get_type ()));
#line 261 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->default_ctx;
#line 261 "../src/editing_tools/EditingTools.vala"
	cairo_save (_tmp0_);
#line 264 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = self->priv->default_ctx;
#line 264 "../src/editing_tools/EditingTools.vala"
	set_source_color_from_string (_tmp1_, "#000");
#line 265 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = self->priv->default_ctx;
#line 265 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = self->priv->surface_dim;
#line 265 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = self->priv->surface_dim;
#line 265 "../src/editing_tools/EditingTools.vala"
	cairo_rectangle (_tmp2_, (gdouble) 0, (gdouble) 0, (gdouble) _tmp3_.width, (gdouble) _tmp4_.height);
#line 266 "../src/editing_tools/EditingTools.vala"
	_tmp5_ = self->priv->default_ctx;
#line 266 "../src/editing_tools/EditingTools.vala"
	cairo_fill (_tmp5_);
#line 269 "../src/editing_tools/EditingTools.vala"
	_tmp6_ = self->priv->default_ctx;
#line 269 "../src/editing_tools/EditingTools.vala"
	_tmp7_ = self->priv->scaled_position;
#line 269 "../src/editing_tools/EditingTools.vala"
	_tmp8_ = self->priv->scaled_position;
#line 269 "../src/editing_tools/EditingTools.vala"
	paint_pixmap_with_background (_tmp6_, pixbuf, _tmp7_.x, _tmp8_.y);
#line 270 "../src/editing_tools/EditingTools.vala"
	_tmp9_ = self->priv->default_ctx;
#line 270 "../src/editing_tools/EditingTools.vala"
	cairo_restore (_tmp9_);
#line 3135 "EditingTools.c"
}

void
editing_tools_photo_canvas_paint_surface (EditingToolsPhotoCanvas* self,
                                          cairo_surface_t* surface,
                                          gboolean over)
{
	cairo_t* _tmp0_;
	cairo_t* _tmp3_;
	cairo_surface_t* _tmp4_;
	GdkRectangle _tmp5_;
	GdkRectangle _tmp6_;
	cairo_t* _tmp7_;
	cairo_t* _tmp8_;
	GdkRectangle _tmp9_;
	GdkRectangle _tmp10_;
	cairo_t* _tmp11_;
	cairo_t* _tmp12_;
#line 274 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_PHOTO_CANVAS (self));
#line 274 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (surface != NULL);
#line 275 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->default_ctx;
#line 275 "../src/editing_tools/EditingTools.vala"
	cairo_save (_tmp0_);
#line 276 "../src/editing_tools/EditingTools.vala"
	if (over == FALSE) {
#line 3164 "EditingTools.c"
		cairo_t* _tmp1_;
#line 277 "../src/editing_tools/EditingTools.vala"
		_tmp1_ = self->priv->default_ctx;
#line 277 "../src/editing_tools/EditingTools.vala"
		cairo_set_operator (_tmp1_, CAIRO_OPERATOR_SOURCE);
#line 3170 "EditingTools.c"
	} else {
		cairo_t* _tmp2_;
#line 279 "../src/editing_tools/EditingTools.vala"
		_tmp2_ = self->priv->default_ctx;
#line 279 "../src/editing_tools/EditingTools.vala"
		cairo_set_operator (_tmp2_, CAIRO_OPERATOR_OVER);
#line 3177 "EditingTools.c"
	}
#line 281 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = self->priv->default_ctx;
#line 281 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = self->priv->scaled;
#line 281 "../src/editing_tools/EditingTools.vala"
	_tmp5_ = self->priv->scaled_position;
#line 281 "../src/editing_tools/EditingTools.vala"
	_tmp6_ = self->priv->scaled_position;
#line 281 "../src/editing_tools/EditingTools.vala"
	cairo_set_source_surface (_tmp3_, _tmp4_, (gdouble) _tmp5_.x, (gdouble) _tmp6_.y);
#line 282 "../src/editing_tools/EditingTools.vala"
	_tmp7_ = self->priv->default_ctx;
#line 282 "../src/editing_tools/EditingTools.vala"
	cairo_paint (_tmp7_);
#line 283 "../src/editing_tools/EditingTools.vala"
	_tmp8_ = self->priv->default_ctx;
#line 283 "../src/editing_tools/EditingTools.vala"
	_tmp9_ = self->priv->scaled_position;
#line 283 "../src/editing_tools/EditingTools.vala"
	_tmp10_ = self->priv->scaled_position;
#line 283 "../src/editing_tools/EditingTools.vala"
	cairo_set_source_surface (_tmp8_, surface, (gdouble) _tmp9_.x, (gdouble) _tmp10_.y);
#line 284 "../src/editing_tools/EditingTools.vala"
	_tmp11_ = self->priv->default_ctx;
#line 284 "../src/editing_tools/EditingTools.vala"
	cairo_paint (_tmp11_);
#line 285 "../src/editing_tools/EditingTools.vala"
	_tmp12_ = self->priv->default_ctx;
#line 285 "../src/editing_tools/EditingTools.vala"
	cairo_restore (_tmp12_);
#line 3209 "EditingTools.c"
}

void
editing_tools_photo_canvas_paint_surface_area (EditingToolsPhotoCanvas* self,
                                               cairo_surface_t* surface,
                                               Box* source_area,
                                               gboolean over)
{
	cairo_t* _tmp0_;
	cairo_t* _tmp3_;
	cairo_surface_t* _tmp4_;
	GdkRectangle _tmp5_;
	GdkRectangle _tmp6_;
	cairo_t* _tmp7_;
	GdkRectangle _tmp8_;
	Box _tmp9_;
	GdkRectangle _tmp10_;
	Box _tmp11_;
	cairo_t* _tmp12_;
	cairo_t* _tmp13_;
	GdkRectangle _tmp14_;
	GdkRectangle _tmp15_;
	cairo_t* _tmp16_;
	GdkRectangle _tmp17_;
	Box _tmp18_;
	GdkRectangle _tmp19_;
	Box _tmp20_;
	cairo_t* _tmp21_;
	cairo_t* _tmp22_;
#line 288 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_PHOTO_CANVAS (self));
#line 288 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (surface != NULL);
#line 288 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (source_area != NULL);
#line 289 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->default_ctx;
#line 289 "../src/editing_tools/EditingTools.vala"
	cairo_save (_tmp0_);
#line 290 "../src/editing_tools/EditingTools.vala"
	if (over == FALSE) {
#line 3251 "EditingTools.c"
		cairo_t* _tmp1_;
#line 291 "../src/editing_tools/EditingTools.vala"
		_tmp1_ = self->priv->default_ctx;
#line 291 "../src/editing_tools/EditingTools.vala"
		cairo_set_operator (_tmp1_, CAIRO_OPERATOR_SOURCE);
#line 3257 "EditingTools.c"
	} else {
		cairo_t* _tmp2_;
#line 293 "../src/editing_tools/EditingTools.vala"
		_tmp2_ = self->priv->default_ctx;
#line 293 "../src/editing_tools/EditingTools.vala"
		cairo_set_operator (_tmp2_, CAIRO_OPERATOR_OVER);
#line 3264 "EditingTools.c"
	}
#line 295 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = self->priv->default_ctx;
#line 295 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = self->priv->scaled;
#line 295 "../src/editing_tools/EditingTools.vala"
	_tmp5_ = self->priv->scaled_position;
#line 295 "../src/editing_tools/EditingTools.vala"
	_tmp6_ = self->priv->scaled_position;
#line 295 "../src/editing_tools/EditingTools.vala"
	cairo_set_source_surface (_tmp3_, _tmp4_, (gdouble) _tmp5_.x, (gdouble) _tmp6_.y);
#line 296 "../src/editing_tools/EditingTools.vala"
	_tmp7_ = self->priv->default_ctx;
#line 296 "../src/editing_tools/EditingTools.vala"
	_tmp8_ = self->priv->scaled_position;
#line 296 "../src/editing_tools/EditingTools.vala"
	_tmp9_ = *source_area;
#line 296 "../src/editing_tools/EditingTools.vala"
	_tmp10_ = self->priv->scaled_position;
#line 296 "../src/editing_tools/EditingTools.vala"
	_tmp11_ = *source_area;
#line 296 "../src/editing_tools/EditingTools.vala"
	cairo_rectangle (_tmp7_, (gdouble) (_tmp8_.x + _tmp9_.left), (gdouble) (_tmp10_.y + _tmp11_.top), (gdouble) box_get_width (source_area), (gdouble) box_get_height (source_area));
#line 299 "../src/editing_tools/EditingTools.vala"
	_tmp12_ = self->priv->default_ctx;
#line 299 "../src/editing_tools/EditingTools.vala"
	cairo_fill (_tmp12_);
#line 301 "../src/editing_tools/EditingTools.vala"
	_tmp13_ = self->priv->default_ctx;
#line 301 "../src/editing_tools/EditingTools.vala"
	_tmp14_ = self->priv->scaled_position;
#line 301 "../src/editing_tools/EditingTools.vala"
	_tmp15_ = self->priv->scaled_position;
#line 301 "../src/editing_tools/EditingTools.vala"
	cairo_set_source_surface (_tmp13_, surface, (gdouble) _tmp14_.x, (gdouble) _tmp15_.y);
#line 302 "../src/editing_tools/EditingTools.vala"
	_tmp16_ = self->priv->default_ctx;
#line 302 "../src/editing_tools/EditingTools.vala"
	_tmp17_ = self->priv->scaled_position;
#line 302 "../src/editing_tools/EditingTools.vala"
	_tmp18_ = *source_area;
#line 302 "../src/editing_tools/EditingTools.vala"
	_tmp19_ = self->priv->scaled_position;
#line 302 "../src/editing_tools/EditingTools.vala"
	_tmp20_ = *source_area;
#line 302 "../src/editing_tools/EditingTools.vala"
	cairo_rectangle (_tmp16_, (gdouble) (_tmp17_.x + _tmp18_.left), (gdouble) (_tmp19_.y + _tmp20_.top), (gdouble) box_get_width (source_area), (gdouble) box_get_height (source_area));
#line 305 "../src/editing_tools/EditingTools.vala"
	_tmp21_ = self->priv->default_ctx;
#line 305 "../src/editing_tools/EditingTools.vala"
	cairo_fill (_tmp21_);
#line 306 "../src/editing_tools/EditingTools.vala"
	_tmp22_ = self->priv->default_ctx;
#line 306 "../src/editing_tools/EditingTools.vala"
	cairo_restore (_tmp22_);
#line 3320 "EditingTools.c"
}

void
editing_tools_photo_canvas_draw_box (EditingToolsPhotoCanvas* self,
                                     cairo_t* ctx,
                                     Box* box)
{
	GdkRectangle rect = {0};
	GdkRectangle _tmp0_ = {0};
	GdkRectangle _tmp1_;
	GdkRectangle _tmp2_;
	GdkRectangle _tmp3_;
	GdkRectangle _tmp4_;
	GdkRectangle _tmp5_;
	GdkRectangle _tmp6_;
#line 309 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_PHOTO_CANVAS (self));
#line 309 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (ctx != NULL);
#line 309 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (box != NULL);
#line 310 "../src/editing_tools/EditingTools.vala"
	box_get_rectangle (box, &_tmp0_);
#line 310 "../src/editing_tools/EditingTools.vala"
	rect = _tmp0_;
#line 311 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = self->priv->scaled_position;
#line 311 "../src/editing_tools/EditingTools.vala"
	rect.x = rect.x + _tmp1_.x;
#line 312 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = self->priv->scaled_position;
#line 312 "../src/editing_tools/EditingTools.vala"
	rect.y = rect.y + _tmp2_.y;
#line 314 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = rect;
#line 314 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = rect;
#line 314 "../src/editing_tools/EditingTools.vala"
	_tmp5_ = rect;
#line 314 "../src/editing_tools/EditingTools.vala"
	_tmp6_ = rect;
#line 314 "../src/editing_tools/EditingTools.vala"
	cairo_rectangle (ctx, _tmp3_.x + 0.5, _tmp4_.y + 0.5, (gdouble) (_tmp5_.width - 1), (gdouble) (_tmp6_.height - 1));
#line 315 "../src/editing_tools/EditingTools.vala"
	cairo_stroke (ctx);
#line 3366 "EditingTools.c"
}

void
editing_tools_photo_canvas_draw_text (EditingToolsPhotoCanvas* self,
                                      cairo_t* ctx,
                                      const gchar* text,
                                      gint x,
                                      gint y,
                                      gboolean use_scaled_pos)
{
	cairo_text_extents_t extents = {0};
	cairo_text_extents_t _tmp2_ = {0};
	cairo_text_extents_t _tmp3_;
	gint pane_border = 0;
	cairo_text_extents_t _tmp4_;
	cairo_text_extents_t _tmp5_;
	cairo_text_extents_t _tmp6_;
#line 318 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_PHOTO_CANVAS (self));
#line 318 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (ctx != NULL);
#line 318 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (text != NULL);
#line 319 "../src/editing_tools/EditingTools.vala"
	if (use_scaled_pos) {
#line 3392 "EditingTools.c"
		GdkRectangle _tmp0_;
		GdkRectangle _tmp1_;
#line 320 "../src/editing_tools/EditingTools.vala"
		_tmp0_ = self->priv->scaled_position;
#line 320 "../src/editing_tools/EditingTools.vala"
		x = x + _tmp0_.x;
#line 321 "../src/editing_tools/EditingTools.vala"
		_tmp1_ = self->priv->scaled_position;
#line 321 "../src/editing_tools/EditingTools.vala"
		y = y + _tmp1_.y;
#line 3403 "EditingTools.c"
	}
#line 324 "../src/editing_tools/EditingTools.vala"
	cairo_text_extents (ctx, text, &_tmp2_);
#line 324 "../src/editing_tools/EditingTools.vala"
	extents = _tmp2_;
#line 325 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = extents;
#line 325 "../src/editing_tools/EditingTools.vala"
	x = x - (((gint) _tmp3_.width) / 2);
#line 327 "../src/editing_tools/EditingTools.vala"
	set_source_color_from_string (ctx, RESOURCES_ONIMAGE_FONT_BACKGROUND);
#line 329 "../src/editing_tools/EditingTools.vala"
	pane_border = 5;
#line 330 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = extents;
#line 330 "../src/editing_tools/EditingTools.vala"
	_tmp5_ = extents;
#line 330 "../src/editing_tools/EditingTools.vala"
	_tmp6_ = extents;
#line 330 "../src/editing_tools/EditingTools.vala"
	cairo_rectangle (ctx, (gdouble) (x - pane_border), (y - pane_border) - _tmp4_.height, _tmp5_.width + (2 * pane_border), _tmp6_.height + (2 * pane_border));
#line 333 "../src/editing_tools/EditingTools.vala"
	cairo_fill (ctx);
#line 335 "../src/editing_tools/EditingTools.vala"
	cairo_move_to (ctx, (gdouble) x, (gdouble) y);
#line 336 "../src/editing_tools/EditingTools.vala"
	set_source_color_from_string (ctx, RESOURCES_ONIMAGE_FONT_COLOR);
#line 337 "../src/editing_tools/EditingTools.vala"
	cairo_show_text (ctx, text);
#line 3433 "EditingTools.c"
}

/**
     * Draw a horizontal line into the specified Cairo context at the specified position, taking
     * into account the scaled position of the image unless directed otherwise.
     *
     * @param ctx The drawing context of the surface we're drawing to.
     * @param x The horizontal position to place the line at.
     * @param y The vertical position to place the line at.
     * @param width The length of the line.
     * @param use_scaled_pos Whether to use absolute window positioning or take into account the 
     *      position of the scaled image.
     */
void
editing_tools_photo_canvas_draw_horizontal_line (EditingToolsPhotoCanvas* self,
                                                 cairo_t* ctx,
                                                 gint x,
                                                 gint y,
                                                 gint width,
                                                 gboolean use_scaled_pos)
{
#line 351 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_PHOTO_CANVAS (self));
#line 351 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (ctx != NULL);
#line 352 "../src/editing_tools/EditingTools.vala"
	if (use_scaled_pos) {
#line 3461 "EditingTools.c"
		GdkRectangle _tmp0_;
		GdkRectangle _tmp1_;
#line 353 "../src/editing_tools/EditingTools.vala"
		_tmp0_ = self->priv->scaled_position;
#line 353 "../src/editing_tools/EditingTools.vala"
		x = x + _tmp0_.x;
#line 354 "../src/editing_tools/EditingTools.vala"
		_tmp1_ = self->priv->scaled_position;
#line 354 "../src/editing_tools/EditingTools.vala"
		y = y + _tmp1_.y;
#line 3472 "EditingTools.c"
	}
#line 357 "../src/editing_tools/EditingTools.vala"
	cairo_move_to (ctx, x + 0.5, y + 0.5);
#line 358 "../src/editing_tools/EditingTools.vala"
	cairo_line_to (ctx, (gdouble) ((x + width) - 1), y + 0.5);
#line 359 "../src/editing_tools/EditingTools.vala"
	cairo_stroke (ctx);
#line 3480 "EditingTools.c"
}

/**
     * Draw a vertical line into the specified Cairo context at the specified position, taking
     * into account the scaled position of the image unless directed otherwise.
     *
     * @param ctx The drawing context of the surface we're drawing to.
     * @param x The horizontal position to place the line at.
     * @param y The vertical position to place the line at.
     * @param width The length of the line.
     * @param use_scaled_pos Whether to use absolute window positioning or take into account the 
     *      position of the scaled image.
     */
void
editing_tools_photo_canvas_draw_vertical_line (EditingToolsPhotoCanvas* self,
                                               cairo_t* ctx,
                                               gint x,
                                               gint y,
                                               gint height,
                                               gboolean use_scaled_pos)
{
#line 373 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_PHOTO_CANVAS (self));
#line 373 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (ctx != NULL);
#line 374 "../src/editing_tools/EditingTools.vala"
	if (use_scaled_pos) {
#line 3508 "EditingTools.c"
		GdkRectangle _tmp0_;
		GdkRectangle _tmp1_;
#line 375 "../src/editing_tools/EditingTools.vala"
		_tmp0_ = self->priv->scaled_position;
#line 375 "../src/editing_tools/EditingTools.vala"
		x = x + _tmp0_.x;
#line 376 "../src/editing_tools/EditingTools.vala"
		_tmp1_ = self->priv->scaled_position;
#line 376 "../src/editing_tools/EditingTools.vala"
		y = y + _tmp1_.y;
#line 3519 "EditingTools.c"
	}
#line 379 "../src/editing_tools/EditingTools.vala"
	cairo_move_to (ctx, x + 0.5, y + 0.5);
#line 380 "../src/editing_tools/EditingTools.vala"
	cairo_line_to (ctx, x + 0.5, (gdouble) ((y + height) - 1));
#line 381 "../src/editing_tools/EditingTools.vala"
	cairo_stroke (ctx);
#line 3527 "EditingTools.c"
}

void
editing_tools_photo_canvas_erase_horizontal_line (EditingToolsPhotoCanvas* self,
                                                  gint x,
                                                  gint y,
                                                  gint width)
{
	gdouble scale = 0.0;
	cairo_t* _tmp0_;
	cairo_t* _tmp1_;
	cairo_t* _tmp2_;
	cairo_surface_t* _tmp3_;
	GdkRectangle _tmp4_;
	GdkRectangle _tmp5_;
	cairo_t* _tmp6_;
	GdkRectangle _tmp7_;
	GdkRectangle _tmp8_;
	cairo_t* _tmp9_;
	cairo_t* _tmp10_;
#line 384 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_PHOTO_CANVAS (self));
#line 385 "../src/editing_tools/EditingTools.vala"
	scale = application_get_scale ();
#line 386 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->default_ctx;
#line 386 "../src/editing_tools/EditingTools.vala"
	cairo_save (_tmp0_);
#line 388 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = self->priv->default_ctx;
#line 388 "../src/editing_tools/EditingTools.vala"
	cairo_set_operator (_tmp1_, CAIRO_OPERATOR_SOURCE);
#line 389 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = self->priv->default_ctx;
#line 389 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = self->priv->scaled;
#line 389 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = self->priv->scaled_position;
#line 389 "../src/editing_tools/EditingTools.vala"
	_tmp5_ = self->priv->scaled_position;
#line 389 "../src/editing_tools/EditingTools.vala"
	cairo_set_source_surface (_tmp2_, _tmp3_, (gdouble) _tmp4_.x, (gdouble) _tmp5_.y);
#line 390 "../src/editing_tools/EditingTools.vala"
	_tmp6_ = self->priv->default_ctx;
#line 390 "../src/editing_tools/EditingTools.vala"
	_tmp7_ = self->priv->scaled_position;
#line 390 "../src/editing_tools/EditingTools.vala"
	_tmp8_ = self->priv->scaled_position;
#line 390 "../src/editing_tools/EditingTools.vala"
	cairo_rectangle (_tmp6_, (gdouble) (_tmp7_.x + x), (gdouble) (_tmp8_.y + y), (gdouble) (width - 1), 1 * scale);
#line 392 "../src/editing_tools/EditingTools.vala"
	_tmp9_ = self->priv->default_ctx;
#line 392 "../src/editing_tools/EditingTools.vala"
	cairo_fill (_tmp9_);
#line 394 "../src/editing_tools/EditingTools.vala"
	_tmp10_ = self->priv->default_ctx;
#line 394 "../src/editing_tools/EditingTools.vala"
	cairo_restore (_tmp10_);
#line 3586 "EditingTools.c"
}

void
editing_tools_photo_canvas_draw_circle (EditingToolsPhotoCanvas* self,
                                        cairo_t* ctx,
                                        gint active_center_x,
                                        gint active_center_y,
                                        gint radius)
{
	gint center_x = 0;
	GdkRectangle _tmp0_;
	gint center_y = 0;
	GdkRectangle _tmp1_;
#line 397 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_PHOTO_CANVAS (self));
#line 397 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (ctx != NULL);
#line 399 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->scaled_position;
#line 399 "../src/editing_tools/EditingTools.vala"
	center_x = active_center_x + _tmp0_.x;
#line 400 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = self->priv->scaled_position;
#line 400 "../src/editing_tools/EditingTools.vala"
	center_y = active_center_y + _tmp1_.y;
#line 402 "../src/editing_tools/EditingTools.vala"
	cairo_arc (ctx, (gdouble) center_x, (gdouble) center_y, (gdouble) radius, (gdouble) 0, 2 * G_PI);
#line 403 "../src/editing_tools/EditingTools.vala"
	cairo_stroke (ctx);
#line 3616 "EditingTools.c"
}

void
editing_tools_photo_canvas_erase_vertical_line (EditingToolsPhotoCanvas* self,
                                                gint x,
                                                gint y,
                                                gint height)
{
	cairo_t* _tmp0_;
	gdouble scale = 0.0;
	cairo_t* _tmp1_;
	cairo_t* _tmp2_;
	cairo_surface_t* _tmp3_;
	GdkRectangle _tmp4_;
	GdkRectangle _tmp5_;
	cairo_t* _tmp6_;
	GdkRectangle _tmp7_;
	GdkRectangle _tmp8_;
	cairo_t* _tmp9_;
	cairo_t* _tmp10_;
#line 406 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_PHOTO_CANVAS (self));
#line 407 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->default_ctx;
#line 407 "../src/editing_tools/EditingTools.vala"
	cairo_save (_tmp0_);
#line 409 "../src/editing_tools/EditingTools.vala"
	scale = application_get_scale ();
#line 415 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = self->priv->default_ctx;
#line 415 "../src/editing_tools/EditingTools.vala"
	cairo_set_operator (_tmp1_, CAIRO_OPERATOR_SOURCE);
#line 416 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = self->priv->default_ctx;
#line 416 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = self->priv->scaled;
#line 416 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = self->priv->scaled_position;
#line 416 "../src/editing_tools/EditingTools.vala"
	_tmp5_ = self->priv->scaled_position;
#line 416 "../src/editing_tools/EditingTools.vala"
	cairo_set_source_surface (_tmp2_, _tmp3_, (gdouble) _tmp4_.x, (gdouble) _tmp5_.y);
#line 417 "../src/editing_tools/EditingTools.vala"
	_tmp6_ = self->priv->default_ctx;
#line 417 "../src/editing_tools/EditingTools.vala"
	_tmp7_ = self->priv->scaled_position;
#line 417 "../src/editing_tools/EditingTools.vala"
	_tmp8_ = self->priv->scaled_position;
#line 417 "../src/editing_tools/EditingTools.vala"
	cairo_rectangle (_tmp6_, (gdouble) (_tmp7_.x + x), (gdouble) (_tmp8_.y + y), 1 * scale, (gdouble) height);
#line 419 "../src/editing_tools/EditingTools.vala"
	_tmp9_ = self->priv->default_ctx;
#line 419 "../src/editing_tools/EditingTools.vala"
	cairo_fill (_tmp9_);
#line 421 "../src/editing_tools/EditingTools.vala"
	_tmp10_ = self->priv->default_ctx;
#line 421 "../src/editing_tools/EditingTools.vala"
	cairo_restore (_tmp10_);
#line 3675 "EditingTools.c"
}

void
editing_tools_photo_canvas_erase_box (EditingToolsPhotoCanvas* self,
                                      Box* box)
{
	Box _tmp0_;
	Box _tmp1_;
	Box _tmp2_;
	Box _tmp3_;
	Box _tmp4_;
	Box _tmp5_;
	Box _tmp6_;
	Box _tmp7_;
#line 424 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_PHOTO_CANVAS (self));
#line 424 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (box != NULL);
#line 425 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = *box;
#line 425 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = *box;
#line 425 "../src/editing_tools/EditingTools.vala"
	editing_tools_photo_canvas_erase_horizontal_line (self, _tmp0_.left, _tmp1_.top, box_get_width (box));
#line 426 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = *box;
#line 426 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = *box;
#line 426 "../src/editing_tools/EditingTools.vala"
	editing_tools_photo_canvas_erase_horizontal_line (self, _tmp2_.left, _tmp3_.bottom, box_get_width (box));
#line 428 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = *box;
#line 428 "../src/editing_tools/EditingTools.vala"
	_tmp5_ = *box;
#line 428 "../src/editing_tools/EditingTools.vala"
	editing_tools_photo_canvas_erase_vertical_line (self, _tmp4_.left, _tmp5_.top, box_get_height (box));
#line 429 "../src/editing_tools/EditingTools.vala"
	_tmp6_ = *box;
#line 429 "../src/editing_tools/EditingTools.vala"
	_tmp7_ = *box;
#line 429 "../src/editing_tools/EditingTools.vala"
	editing_tools_photo_canvas_erase_vertical_line (self, _tmp6_.right, _tmp7_.top, box_get_height (box));
#line 3718 "EditingTools.c"
}

void
editing_tools_photo_canvas_invalidate_area (EditingToolsPhotoCanvas* self,
                                            Box* area)
{
	GdkRectangle rect = {0};
	GdkRectangle _tmp0_ = {0};
	GdkRectangle _tmp1_;
	GdkRectangle _tmp2_;
	GdkWindow* _tmp3_;
	GdkRectangle _tmp4_;
#line 432 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_PHOTO_CANVAS (self));
#line 432 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (area != NULL);
#line 433 "../src/editing_tools/EditingTools.vala"
	box_get_rectangle (area, &_tmp0_);
#line 433 "../src/editing_tools/EditingTools.vala"
	rect = _tmp0_;
#line 435 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = self->priv->scaled_position;
#line 435 "../src/editing_tools/EditingTools.vala"
	rect.x = rect.x + _tmp1_.x;
#line 436 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = self->priv->scaled_position;
#line 436 "../src/editing_tools/EditingTools.vala"
	rect.y = rect.y + _tmp2_.y;
#line 438 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = self->priv->drawing_window;
#line 438 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = rect;
#line 438 "../src/editing_tools/EditingTools.vala"
	gdk_window_invalidate_rect (_tmp3_, &_tmp4_, FALSE);
#line 3753 "EditingTools.c"
}

void
editing_tools_photo_canvas_set_cursor (EditingToolsPhotoCanvas* self,
                                       GdkCursorType cursor_type)
{
	GdkDisplay* display = NULL;
	GdkWindow* _tmp0_;
	GdkWindow* _tmp1_;
	GdkDisplay* _tmp2_;
	GdkDisplay* _tmp3_;
	GdkDisplay* _tmp4_;
	GdkCursor* cursor = NULL;
	GdkCursor* _tmp5_;
	GdkWindow* _tmp6_;
	GdkWindow* _tmp7_;
#line 441 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_PHOTO_CANVAS (self));
#line 442 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = editing_tools_photo_canvas_get_drawing_window (self);
#line 442 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = _tmp0_;
#line 442 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = gdk_window_get_display (_tmp1_);
#line 442 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 442 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = _tmp3_;
#line 442 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (_tmp1_);
#line 442 "../src/editing_tools/EditingTools.vala"
	display = _tmp4_;
#line 443 "../src/editing_tools/EditingTools.vala"
	_tmp5_ = gdk_cursor_new_for_display (display, cursor_type);
#line 443 "../src/editing_tools/EditingTools.vala"
	cursor = _tmp5_;
#line 444 "../src/editing_tools/EditingTools.vala"
	_tmp6_ = editing_tools_photo_canvas_get_drawing_window (self);
#line 444 "../src/editing_tools/EditingTools.vala"
	_tmp7_ = _tmp6_;
#line 444 "../src/editing_tools/EditingTools.vala"
	gdk_window_set_cursor (_tmp7_, cursor);
#line 444 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (_tmp7_);
#line 441 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (cursor);
#line 441 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (display);
#line 3802 "EditingTools.c"
}

static cairo_surface_t*
editing_tools_photo_canvas_pixbuf_to_surface (EditingToolsPhotoCanvas* self,
                                              cairo_t* default_ctx,
                                              GdkPixbuf* pixbuf,
                                              GdkRectangle* pos)
{
	cairo_surface_t* surface = NULL;
	cairo_surface_t* _tmp0_;
	GdkRectangle _tmp1_;
	GdkRectangle _tmp2_;
	cairo_surface_t* _tmp3_;
	cairo_t* ctx = NULL;
	cairo_t* _tmp4_;
	cairo_surface_t* result;
#line 447 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (EDITING_TOOLS_IS_PHOTO_CANVAS (self), NULL);
#line 447 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (default_ctx != NULL, NULL);
#line 447 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (pixbuf, gdk_pixbuf_get_type ()), NULL);
#line 447 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (pos != NULL, NULL);
#line 449 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = cairo_get_target (default_ctx);
#line 449 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = *pos;
#line 449 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = *pos;
#line 449 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = cairo_surface_create_similar (_tmp0_, CAIRO_CONTENT_COLOR_ALPHA, _tmp1_.width, _tmp2_.height);
#line 449 "../src/editing_tools/EditingTools.vala"
	surface = _tmp3_;
#line 451 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = cairo_create (surface);
#line 451 "../src/editing_tools/EditingTools.vala"
	ctx = _tmp4_;
#line 452 "../src/editing_tools/EditingTools.vala"
	paint_pixmap_with_background (ctx, pixbuf, 0, 0);
#line 453 "../src/editing_tools/EditingTools.vala"
	cairo_paint (ctx);
#line 454 "../src/editing_tools/EditingTools.vala"
	result = surface;
#line 454 "../src/editing_tools/EditingTools.vala"
	_cairo_destroy0 (ctx);
#line 454 "../src/editing_tools/EditingTools.vala"
	return result;
#line 3851 "EditingTools.c"
}

static void
g_cclosure_user_marshal_VOID__BOXED_BOXED (GClosure * closure,
                                           GValue * return_value,
                                           guint n_param_values,
                                           const GValue * param_values,
                                           gpointer invocation_hint,
                                           gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__BOXED_BOXED) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__BOXED_BOXED callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 104 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (n_param_values == 3);
#line 104 "../src/editing_tools/EditingTools.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 104 "../src/editing_tools/EditingTools.vala"
		data1 = closure->data;
#line 104 "../src/editing_tools/EditingTools.vala"
		data2 = param_values->data[0].v_pointer;
#line 3876 "EditingTools.c"
	} else {
#line 104 "../src/editing_tools/EditingTools.vala"
		data1 = param_values->data[0].v_pointer;
#line 104 "../src/editing_tools/EditingTools.vala"
		data2 = closure->data;
#line 3882 "EditingTools.c"
	}
#line 104 "../src/editing_tools/EditingTools.vala"
	callback = (GMarshalFunc_VOID__BOXED_BOXED) (marshal_data ? marshal_data : cc->callback);
#line 104 "../src/editing_tools/EditingTools.vala"
	callback (data1, g_value_get_boxed (param_values + 1), g_value_get_boxed (param_values + 2), data2);
#line 3888 "EditingTools.c"
}

static void
g_cclosure_user_marshal_VOID__BOXED_OBJECT_BOXED (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__BOXED_OBJECT_BOXED) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer arg_3, gpointer data2);
	register GMarshalFunc_VOID__BOXED_OBJECT_BOXED callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 104 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (n_param_values == 4);
#line 104 "../src/editing_tools/EditingTools.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 104 "../src/editing_tools/EditingTools.vala"
		data1 = closure->data;
#line 104 "../src/editing_tools/EditingTools.vala"
		data2 = param_values->data[0].v_pointer;
#line 3913 "EditingTools.c"
	} else {
#line 104 "../src/editing_tools/EditingTools.vala"
		data1 = param_values->data[0].v_pointer;
#line 104 "../src/editing_tools/EditingTools.vala"
		data2 = closure->data;
#line 3919 "EditingTools.c"
	}
#line 104 "../src/editing_tools/EditingTools.vala"
	callback = (GMarshalFunc_VOID__BOXED_OBJECT_BOXED) (marshal_data ? marshal_data : cc->callback);
#line 104 "../src/editing_tools/EditingTools.vala"
	callback (data1, g_value_get_boxed (param_values + 1), g_value_get_object (param_values + 2), g_value_get_boxed (param_values + 3), data2);
#line 3925 "EditingTools.c"
}

static void
editing_tools_value_photo_canvas_init (GValue* value)
{
#line 104 "../src/editing_tools/EditingTools.vala"
	value->data[0].v_pointer = NULL;
#line 3933 "EditingTools.c"
}

static void
editing_tools_value_photo_canvas_free_value (GValue* value)
{
#line 104 "../src/editing_tools/EditingTools.vala"
	if (value->data[0].v_pointer) {
#line 104 "../src/editing_tools/EditingTools.vala"
		editing_tools_photo_canvas_unref (value->data[0].v_pointer);
#line 3943 "EditingTools.c"
	}
}

static void
editing_tools_value_photo_canvas_copy_value (const GValue* src_value,
                                             GValue* dest_value)
{
#line 104 "../src/editing_tools/EditingTools.vala"
	if (src_value->data[0].v_pointer) {
#line 104 "../src/editing_tools/EditingTools.vala"
		dest_value->data[0].v_pointer = editing_tools_photo_canvas_ref (src_value->data[0].v_pointer);
#line 3955 "EditingTools.c"
	} else {
#line 104 "../src/editing_tools/EditingTools.vala"
		dest_value->data[0].v_pointer = NULL;
#line 3959 "EditingTools.c"
	}
}

static gpointer
editing_tools_value_photo_canvas_peek_pointer (const GValue* value)
{
#line 104 "../src/editing_tools/EditingTools.vala"
	return value->data[0].v_pointer;
#line 3968 "EditingTools.c"
}

static gchar*
editing_tools_value_photo_canvas_collect_value (GValue* value,
                                                guint n_collect_values,
                                                GTypeCValue* collect_values,
                                                guint collect_flags)
{
#line 104 "../src/editing_tools/EditingTools.vala"
	if (collect_values[0].v_pointer) {
#line 3979 "EditingTools.c"
		EditingToolsPhotoCanvas * object;
		object = collect_values[0].v_pointer;
#line 104 "../src/editing_tools/EditingTools.vala"
		if (object->parent_instance.g_class == NULL) {
#line 104 "../src/editing_tools/EditingTools.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 3986 "EditingTools.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 104 "../src/editing_tools/EditingTools.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 3990 "EditingTools.c"
		}
#line 104 "../src/editing_tools/EditingTools.vala"
		value->data[0].v_pointer = editing_tools_photo_canvas_ref (object);
#line 3994 "EditingTools.c"
	} else {
#line 104 "../src/editing_tools/EditingTools.vala"
		value->data[0].v_pointer = NULL;
#line 3998 "EditingTools.c"
	}
#line 104 "../src/editing_tools/EditingTools.vala"
	return NULL;
#line 4002 "EditingTools.c"
}

static gchar*
editing_tools_value_photo_canvas_lcopy_value (const GValue* value,
                                              guint n_collect_values,
                                              GTypeCValue* collect_values,
                                              guint collect_flags)
{
	EditingToolsPhotoCanvas ** object_p;
	object_p = collect_values[0].v_pointer;
#line 104 "../src/editing_tools/EditingTools.vala"
	if (!object_p) {
#line 104 "../src/editing_tools/EditingTools.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 4017 "EditingTools.c"
	}
#line 104 "../src/editing_tools/EditingTools.vala"
	if (!value->data[0].v_pointer) {
#line 104 "../src/editing_tools/EditingTools.vala"
		*object_p = NULL;
#line 4023 "EditingTools.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 104 "../src/editing_tools/EditingTools.vala"
		*object_p = value->data[0].v_pointer;
#line 4027 "EditingTools.c"
	} else {
#line 104 "../src/editing_tools/EditingTools.vala"
		*object_p = editing_tools_photo_canvas_ref (value->data[0].v_pointer);
#line 4031 "EditingTools.c"
	}
#line 104 "../src/editing_tools/EditingTools.vala"
	return NULL;
#line 4035 "EditingTools.c"
}

GParamSpec*
editing_tools_param_spec_photo_canvas (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags)
{
	EditingToolsParamSpecPhotoCanvas* spec;
#line 104 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (g_type_is_a (object_type, EDITING_TOOLS_TYPE_PHOTO_CANVAS), NULL);
#line 104 "../src/editing_tools/EditingTools.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 104 "../src/editing_tools/EditingTools.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 104 "../src/editing_tools/EditingTools.vala"
	return G_PARAM_SPEC (spec);
#line 4054 "EditingTools.c"
}

gpointer
editing_tools_value_get_photo_canvas (const GValue* value)
{
#line 104 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, EDITING_TOOLS_TYPE_PHOTO_CANVAS), NULL);
#line 104 "../src/editing_tools/EditingTools.vala"
	return value->data[0].v_pointer;
#line 4064 "EditingTools.c"
}

void
editing_tools_value_set_photo_canvas (GValue* value,
                                      gpointer v_object)
{
	EditingToolsPhotoCanvas * old;
#line 104 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, EDITING_TOOLS_TYPE_PHOTO_CANVAS));
#line 104 "../src/editing_tools/EditingTools.vala"
	old = value->data[0].v_pointer;
#line 104 "../src/editing_tools/EditingTools.vala"
	if (v_object) {
#line 104 "../src/editing_tools/EditingTools.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, EDITING_TOOLS_TYPE_PHOTO_CANVAS));
#line 104 "../src/editing_tools/EditingTools.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 104 "../src/editing_tools/EditingTools.vala"
		value->data[0].v_pointer = v_object;
#line 104 "../src/editing_tools/EditingTools.vala"
		editing_tools_photo_canvas_ref (value->data[0].v_pointer);
#line 4086 "EditingTools.c"
	} else {
#line 104 "../src/editing_tools/EditingTools.vala"
		value->data[0].v_pointer = NULL;
#line 4090 "EditingTools.c"
	}
#line 104 "../src/editing_tools/EditingTools.vala"
	if (old) {
#line 104 "../src/editing_tools/EditingTools.vala"
		editing_tools_photo_canvas_unref (old);
#line 4096 "EditingTools.c"
	}
}

void
editing_tools_value_take_photo_canvas (GValue* value,
                                       gpointer v_object)
{
	EditingToolsPhotoCanvas * old;
#line 104 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, EDITING_TOOLS_TYPE_PHOTO_CANVAS));
#line 104 "../src/editing_tools/EditingTools.vala"
	old = value->data[0].v_pointer;
#line 104 "../src/editing_tools/EditingTools.vala"
	if (v_object) {
#line 104 "../src/editing_tools/EditingTools.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, EDITING_TOOLS_TYPE_PHOTO_CANVAS));
#line 104 "../src/editing_tools/EditingTools.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 104 "../src/editing_tools/EditingTools.vala"
		value->data[0].v_pointer = v_object;
#line 4117 "EditingTools.c"
	} else {
#line 104 "../src/editing_tools/EditingTools.vala"
		value->data[0].v_pointer = NULL;
#line 4121 "EditingTools.c"
	}
#line 104 "../src/editing_tools/EditingTools.vala"
	if (old) {
#line 104 "../src/editing_tools/EditingTools.vala"
		editing_tools_photo_canvas_unref (old);
#line 4127 "EditingTools.c"
	}
}

static void
editing_tools_photo_canvas_class_init (EditingToolsPhotoCanvasClass * klass,
                                       gpointer klass_data)
{
#line 104 "../src/editing_tools/EditingTools.vala"
	editing_tools_photo_canvas_parent_class = g_type_class_peek_parent (klass);
#line 104 "../src/editing_tools/EditingTools.vala"
	((EditingToolsPhotoCanvasClass *) klass)->finalize = editing_tools_photo_canvas_finalize;
#line 104 "../src/editing_tools/EditingTools.vala"
	g_type_class_adjust_private_offset (klass, &EditingToolsPhotoCanvas_private_offset);
#line 104 "../src/editing_tools/EditingTools.vala"
	((EditingToolsPhotoCanvasClass *) klass)->repaint = (void (*) (EditingToolsPhotoCanvas*)) editing_tools_photo_canvas_real_repaint;
#line 104 "../src/editing_tools/EditingTools.vala"
	editing_tools_photo_canvas_signals[EDITING_TOOLS_PHOTO_CANVAS_NEW_SURFACE_SIGNAL] = g_signal_new ("new-surface", EDITING_TOOLS_TYPE_PHOTO_CANVAS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__BOXED_BOXED, G_TYPE_NONE, 2, cairo_gobject_context_get_type (), TYPE_DIMENSIONS);
#line 104 "../src/editing_tools/EditingTools.vala"
	editing_tools_photo_canvas_signals[EDITING_TOOLS_PHOTO_CANVAS_RESIZED_SCALED_PIXBUF_SIGNAL] = g_signal_new ("resized-scaled-pixbuf", EDITING_TOOLS_TYPE_PHOTO_CANVAS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__BOXED_OBJECT_BOXED, G_TYPE_NONE, 3, TYPE_DIMENSIONS, gdk_pixbuf_get_type (), gdk_rectangle_get_type ());
#line 4147 "EditingTools.c"
}

static void
editing_tools_photo_canvas_instance_init (EditingToolsPhotoCanvas * self,
                                          gpointer klass)
{
#line 104 "../src/editing_tools/EditingTools.vala"
	self->priv = editing_tools_photo_canvas_get_instance_private (self);
#line 104 "../src/editing_tools/EditingTools.vala"
	self->ref_count = 1;
#line 4158 "EditingTools.c"
}

static void
editing_tools_photo_canvas_finalize (EditingToolsPhotoCanvas * obj)
{
	EditingToolsPhotoCanvas * self;
#line 104 "../src/editing_tools/EditingTools.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, EDITING_TOOLS_TYPE_PHOTO_CANVAS, EditingToolsPhotoCanvas);
#line 104 "../src/editing_tools/EditingTools.vala"
	g_signal_handlers_destroy (self);
#line 105 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->priv->container);
#line 106 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->priv->drawing_window);
#line 107 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->priv->photo);
#line 108 "../src/editing_tools/EditingTools.vala"
	_cairo_destroy0 (self->priv->default_ctx);
#line 110 "../src/editing_tools/EditingTools.vala"
	_cairo_surface_destroy0 (self->priv->scaled);
#line 111 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->priv->scaled_pixbuf);
#line 4181 "EditingTools.c"
}

static GType
editing_tools_photo_canvas_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { editing_tools_value_photo_canvas_init, editing_tools_value_photo_canvas_free_value, editing_tools_value_photo_canvas_copy_value, editing_tools_value_photo_canvas_peek_pointer, "p", editing_tools_value_photo_canvas_collect_value, "p", editing_tools_value_photo_canvas_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (EditingToolsPhotoCanvasClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) editing_tools_photo_canvas_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EditingToolsPhotoCanvas), 0, (GInstanceInitFunc) editing_tools_photo_canvas_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType editing_tools_photo_canvas_type_id;
	editing_tools_photo_canvas_type_id = g_type_register_fundamental (g_type_fundamental_next (), "EditingToolsPhotoCanvas", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
	EditingToolsPhotoCanvas_private_offset = g_type_add_instance_private (editing_tools_photo_canvas_type_id, sizeof (EditingToolsPhotoCanvasPrivate));
	return editing_tools_photo_canvas_type_id;
}

GType
editing_tools_photo_canvas_get_type (void)
{
	static volatile gsize editing_tools_photo_canvas_type_id__once = 0;
	if (g_once_init_enter (&editing_tools_photo_canvas_type_id__once)) {
		GType editing_tools_photo_canvas_type_id;
		editing_tools_photo_canvas_type_id = editing_tools_photo_canvas_get_type_once ();
		g_once_init_leave (&editing_tools_photo_canvas_type_id__once, editing_tools_photo_canvas_type_id);
	}
	return editing_tools_photo_canvas_type_id__once;
}

gpointer
editing_tools_photo_canvas_ref (gpointer instance)
{
	EditingToolsPhotoCanvas * self;
	self = instance;
#line 104 "../src/editing_tools/EditingTools.vala"
	g_atomic_int_inc (&self->ref_count);
#line 104 "../src/editing_tools/EditingTools.vala"
	return instance;
#line 4217 "EditingTools.c"
}

void
editing_tools_photo_canvas_unref (gpointer instance)
{
	EditingToolsPhotoCanvas * self;
	self = instance;
#line 104 "../src/editing_tools/EditingTools.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 104 "../src/editing_tools/EditingTools.vala"
		EDITING_TOOLS_PHOTO_CANVAS_GET_CLASS (self)->finalize (self);
#line 104 "../src/editing_tools/EditingTools.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 4231 "EditingTools.c"
	}
}

static inline gpointer
editing_tools_editing_tool_get_instance_private (EditingToolsEditingTool* self)
{
	return G_STRUCT_MEMBER_P (self, EditingToolsEditingTool_private_offset);
}

EditingToolsEditingTool*
editing_tools_editing_tool_construct (GType object_type,
                                      const gchar* name)
{
	EditingToolsEditingTool* self = NULL;
	gchar* _tmp0_;
#line 479 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 479 "../src/editing_tools/EditingTools.vala"
	self = (EditingToolsEditingTool*) g_type_create_instance (object_type);
#line 480 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = g_strdup (name);
#line 480 "../src/editing_tools/EditingTools.vala"
	_g_free0 (self->name);
#line 480 "../src/editing_tools/EditingTools.vala"
	self->name = _tmp0_;
#line 479 "../src/editing_tools/EditingTools.vala"
	return self;
#line 4259 "EditingTools.c"
}

static gpointer
_editing_tools_photo_canvas_ref0 (gpointer self)
{
#line 492 "../src/editing_tools/EditingTools.vala"
	return self ? editing_tools_photo_canvas_ref (self) : NULL;
#line 4267 "EditingTools.c"
}

static gboolean
_editing_tools_editing_tool_on_keypress_gtk_widget_key_press_event (GtkWidget* _sender,
                                                                    GdkEventKey* event,
                                                                    gpointer self)
{
	gboolean result;
	result = editing_tools_editing_tool_on_keypress ((EditingToolsEditingTool*) self, event);
#line 496 "../src/editing_tools/EditingTools.vala"
	return result;
#line 4279 "EditingTools.c"
}

static void
editing_tools_editing_tool_real_activate (EditingToolsEditingTool* self,
                                          EditingToolsPhotoCanvas* canvas)
{
	EditingToolsPhotoCanvas* _tmp0_;
	EditingToolsEditingToolWindow* _tmp1_;
	EditingToolsPhotoCanvas* _tmp2_;
	EditingToolsEditingToolWindow* _tmp3_;
	EditingToolsEditingToolWindow* _tmp4_;
#line 487 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_PHOTO_CANVAS (canvas));
#line 489 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->canvas;
#line 489 "../src/editing_tools/EditingTools.vala"
	_vala_assert (_tmp0_ == NULL, "this.canvas == null");
#line 490 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = self->priv->tool_window;
#line 490 "../src/editing_tools/EditingTools.vala"
	_vala_assert (_tmp1_ == NULL, "tool_window == null");
#line 492 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = _editing_tools_photo_canvas_ref0 (canvas);
#line 492 "../src/editing_tools/EditingTools.vala"
	_editing_tools_photo_canvas_unref0 (self->canvas);
#line 492 "../src/editing_tools/EditingTools.vala"
	self->canvas = _tmp2_;
#line 494 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = editing_tools_editing_tool_get_tool_window (self);
#line 494 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->priv->tool_window);
#line 494 "../src/editing_tools/EditingTools.vala"
	self->priv->tool_window = _tmp3_;
#line 495 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = self->priv->tool_window;
#line 495 "../src/editing_tools/EditingTools.vala"
	if (_tmp4_ != NULL) {
#line 4317 "EditingTools.c"
		EditingToolsEditingToolWindow* _tmp5_;
#line 496 "../src/editing_tools/EditingTools.vala"
		_tmp5_ = self->priv->tool_window;
#line 496 "../src/editing_tools/EditingTools.vala"
		g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gtk_widget_get_type (), GtkWidget), "key-press-event", (GCallback) _editing_tools_editing_tool_on_keypress_gtk_widget_key_press_event, self);
#line 4323 "EditingTools.c"
	}
#line 498 "../src/editing_tools/EditingTools.vala"
	g_signal_emit (self, editing_tools_editing_tool_signals[EDITING_TOOLS_EDITING_TOOL_ACTIVATED_SIGNAL], 0);
#line 4327 "EditingTools.c"
}

void
editing_tools_editing_tool_activate (EditingToolsEditingTool* self,
                                     EditingToolsPhotoCanvas* canvas)
{
	EditingToolsEditingToolClass* _klass_;
#line 487 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_EDITING_TOOL (self));
#line 487 "../src/editing_tools/EditingTools.vala"
	_klass_ = EDITING_TOOLS_EDITING_TOOL_GET_CLASS (self);
#line 487 "../src/editing_tools/EditingTools.vala"
	if (_klass_->activate) {
#line 487 "../src/editing_tools/EditingTools.vala"
		_klass_->activate (self, canvas);
#line 4343 "EditingTools.c"
	}
}

static void
editing_tools_editing_tool_real_deactivate (EditingToolsEditingTool* self)
{
	gboolean _tmp0_ = FALSE;
	EditingToolsPhotoCanvas* _tmp1_;
	EditingToolsEditingToolWindow* _tmp3_;
#line 504 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = self->canvas;
#line 504 "../src/editing_tools/EditingTools.vala"
	if (_tmp1_ == NULL) {
#line 4357 "EditingTools.c"
		EditingToolsEditingToolWindow* _tmp2_;
#line 504 "../src/editing_tools/EditingTools.vala"
		_tmp2_ = self->priv->tool_window;
#line 504 "../src/editing_tools/EditingTools.vala"
		_tmp0_ = _tmp2_ == NULL;
#line 4363 "EditingTools.c"
	} else {
#line 504 "../src/editing_tools/EditingTools.vala"
		_tmp0_ = FALSE;
#line 4367 "EditingTools.c"
	}
#line 504 "../src/editing_tools/EditingTools.vala"
	if (_tmp0_) {
#line 505 "../src/editing_tools/EditingTools.vala"
		return;
#line 4373 "EditingTools.c"
	}
#line 507 "../src/editing_tools/EditingTools.vala"
	_editing_tools_photo_canvas_unref0 (self->canvas);
#line 507 "../src/editing_tools/EditingTools.vala"
	self->canvas = NULL;
#line 509 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = self->priv->tool_window;
#line 509 "../src/editing_tools/EditingTools.vala"
	if (_tmp3_ != NULL) {
#line 4383 "EditingTools.c"
		EditingToolsEditingToolWindow* _tmp4_;
		guint _tmp5_;
#line 510 "../src/editing_tools/EditingTools.vala"
		_tmp4_ = self->priv->tool_window;
#line 510 "../src/editing_tools/EditingTools.vala"
		g_signal_parse_name ("key-press-event", gtk_widget_get_type (), &_tmp5_, NULL, FALSE);
#line 510 "../src/editing_tools/EditingTools.vala"
		g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_widget_get_type (), GtkWidget), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _editing_tools_editing_tool_on_keypress_gtk_widget_key_press_event, self);
#line 511 "../src/editing_tools/EditingTools.vala"
		_g_object_unref0 (self->priv->tool_window);
#line 511 "../src/editing_tools/EditingTools.vala"
		self->priv->tool_window = NULL;
#line 4396 "EditingTools.c"
	}
#line 514 "../src/editing_tools/EditingTools.vala"
	g_signal_emit (self, editing_tools_editing_tool_signals[EDITING_TOOLS_EDITING_TOOL_DEACTIVATED_SIGNAL], 0);
#line 4400 "EditingTools.c"
}

void
editing_tools_editing_tool_deactivate (EditingToolsEditingTool* self)
{
	EditingToolsEditingToolClass* _klass_;
#line 502 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_EDITING_TOOL (self));
#line 502 "../src/editing_tools/EditingTools.vala"
	_klass_ = EDITING_TOOLS_EDITING_TOOL_GET_CLASS (self);
#line 502 "../src/editing_tools/EditingTools.vala"
	if (_klass_->deactivate) {
#line 502 "../src/editing_tools/EditingTools.vala"
		_klass_->deactivate (self);
#line 4415 "EditingTools.c"
	}
}

gboolean
editing_tools_editing_tool_is_activated (EditingToolsEditingTool* self)
{
	EditingToolsPhotoCanvas* _tmp0_;
	gboolean result;
#line 517 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (EDITING_TOOLS_IS_EDITING_TOOL (self), FALSE);
#line 518 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->canvas;
#line 518 "../src/editing_tools/EditingTools.vala"
	result = _tmp0_ != NULL;
#line 518 "../src/editing_tools/EditingTools.vala"
	return result;
#line 4432 "EditingTools.c"
}

static EditingToolsEditingToolWindow*
editing_tools_editing_tool_real_get_tool_window (EditingToolsEditingTool* self)
{
	EditingToolsEditingToolWindow* result;
#line 522 "../src/editing_tools/EditingTools.vala"
	result = NULL;
#line 522 "../src/editing_tools/EditingTools.vala"
	return result;
#line 4443 "EditingTools.c"
}

EditingToolsEditingToolWindow*
editing_tools_editing_tool_get_tool_window (EditingToolsEditingTool* self)
{
	EditingToolsEditingToolClass* _klass_;
#line 521 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (EDITING_TOOLS_IS_EDITING_TOOL (self), NULL);
#line 521 "../src/editing_tools/EditingTools.vala"
	_klass_ = EDITING_TOOLS_EDITING_TOOL_GET_CLASS (self);
#line 521 "../src/editing_tools/EditingTools.vala"
	if (_klass_->get_tool_window) {
#line 521 "../src/editing_tools/EditingTools.vala"
		return _klass_->get_tool_window (self);
#line 4458 "EditingTools.c"
	}
#line 521 "../src/editing_tools/EditingTools.vala"
	return NULL;
#line 4462 "EditingTools.c"
}

static GdkPixbuf*
editing_tools_editing_tool_real_get_display_pixbuf (EditingToolsEditingTool* self,
                                                    Scaling* scaling,
                                                    Photo* photo,
                                                    Dimensions* max_dim,
                                                    GError** error)
{
	Dimensions _vala_max_dim = {0};
	GdkPixbuf* result;
#line 536 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 536 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (IS_PHOTO (photo), NULL);
#line 538 "../src/editing_tools/EditingTools.vala"
	dimensions_init (&_vala_max_dim, 0, 0);
#line 540 "../src/editing_tools/EditingTools.vala"
	result = NULL;
#line 540 "../src/editing_tools/EditingTools.vala"
	if (max_dim) {
#line 540 "../src/editing_tools/EditingTools.vala"
		*max_dim = _vala_max_dim;
#line 4486 "EditingTools.c"
	}
#line 540 "../src/editing_tools/EditingTools.vala"
	return result;
#line 4490 "EditingTools.c"
}

GdkPixbuf*
editing_tools_editing_tool_get_display_pixbuf (EditingToolsEditingTool* self,
                                               Scaling* scaling,
                                               Photo* photo,
                                               Dimensions* max_dim,
                                               GError** error)
{
	EditingToolsEditingToolClass* _klass_;
#line 536 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (EDITING_TOOLS_IS_EDITING_TOOL (self), NULL);
#line 536 "../src/editing_tools/EditingTools.vala"
	_klass_ = EDITING_TOOLS_EDITING_TOOL_GET_CLASS (self);
#line 536 "../src/editing_tools/EditingTools.vala"
	if (_klass_->get_display_pixbuf) {
#line 536 "../src/editing_tools/EditingTools.vala"
		return _klass_->get_display_pixbuf (self, scaling, photo, max_dim, error);
#line 4509 "EditingTools.c"
	}
#line 536 "../src/editing_tools/EditingTools.vala"
	return NULL;
#line 4513 "EditingTools.c"
}

static void
editing_tools_editing_tool_real_on_left_click (EditingToolsEditingTool* self,
                                               gint x,
                                               gint y)
{
}

void
editing_tools_editing_tool_on_left_click (EditingToolsEditingTool* self,
                                          gint x,
                                          gint y)
{
	EditingToolsEditingToolClass* _klass_;
#line 543 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_EDITING_TOOL (self));
#line 543 "../src/editing_tools/EditingTools.vala"
	_klass_ = EDITING_TOOLS_EDITING_TOOL_GET_CLASS (self);
#line 543 "../src/editing_tools/EditingTools.vala"
	if (_klass_->on_left_click) {
#line 543 "../src/editing_tools/EditingTools.vala"
		_klass_->on_left_click (self, x, y);
#line 4537 "EditingTools.c"
	}
}

static void
editing_tools_editing_tool_real_on_left_released (EditingToolsEditingTool* self,
                                                  gint x,
                                                  gint y)
{
}

void
editing_tools_editing_tool_on_left_released (EditingToolsEditingTool* self,
                                             gint x,
                                             gint y)
{
	EditingToolsEditingToolClass* _klass_;
#line 546 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_EDITING_TOOL (self));
#line 546 "../src/editing_tools/EditingTools.vala"
	_klass_ = EDITING_TOOLS_EDITING_TOOL_GET_CLASS (self);
#line 546 "../src/editing_tools/EditingTools.vala"
	if (_klass_->on_left_released) {
#line 546 "../src/editing_tools/EditingTools.vala"
		_klass_->on_left_released (self, x, y);
#line 4562 "EditingTools.c"
	}
}

static void
editing_tools_editing_tool_real_on_motion (EditingToolsEditingTool* self,
                                           gint x,
                                           gint y,
                                           GdkModifierType mask)
{
}

void
editing_tools_editing_tool_on_motion (EditingToolsEditingTool* self,
                                      gint x,
                                      gint y,
                                      GdkModifierType mask)
{
	EditingToolsEditingToolClass* _klass_;
#line 549 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_EDITING_TOOL (self));
#line 549 "../src/editing_tools/EditingTools.vala"
	_klass_ = EDITING_TOOLS_EDITING_TOOL_GET_CLASS (self);
#line 549 "../src/editing_tools/EditingTools.vala"
	if (_klass_->on_motion) {
#line 549 "../src/editing_tools/EditingTools.vala"
		_klass_->on_motion (self, x, y, mask);
#line 4589 "EditingTools.c"
	}
}

static gboolean
editing_tools_editing_tool_real_on_leave_notify_event (EditingToolsEditingTool* self)
{
	gboolean result;
#line 553 "../src/editing_tools/EditingTools.vala"
	result = FALSE;
#line 553 "../src/editing_tools/EditingTools.vala"
	return result;
#line 4601 "EditingTools.c"
}

gboolean
editing_tools_editing_tool_on_leave_notify_event (EditingToolsEditingTool* self)
{
	EditingToolsEditingToolClass* _klass_;
#line 552 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (EDITING_TOOLS_IS_EDITING_TOOL (self), FALSE);
#line 552 "../src/editing_tools/EditingTools.vala"
	_klass_ = EDITING_TOOLS_EDITING_TOOL_GET_CLASS (self);
#line 552 "../src/editing_tools/EditingTools.vala"
	if (_klass_->on_leave_notify_event) {
#line 552 "../src/editing_tools/EditingTools.vala"
		return _klass_->on_leave_notify_event (self);
#line 4616 "EditingTools.c"
	}
#line 552 "../src/editing_tools/EditingTools.vala"
	return FALSE;
#line 4620 "EditingTools.c"
}

static gboolean
editing_tools_editing_tool_real_on_keypress (EditingToolsEditingTool* self,
                                             GdkEventKey* event)
{
	const gchar* _tmp0_;
	gboolean result;
#line 556 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 558 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = gdk_keyval_name (event->keyval);
#line 558 "../src/editing_tools/EditingTools.vala"
	if (g_strcmp0 (_tmp0_, "Escape") == 0) {
#line 559 "../src/editing_tools/EditingTools.vala"
		editing_tools_editing_tool_notify_cancel (self);
#line 561 "../src/editing_tools/EditingTools.vala"
		result = TRUE;
#line 561 "../src/editing_tools/EditingTools.vala"
		return result;
#line 4641 "EditingTools.c"
	}
#line 564 "../src/editing_tools/EditingTools.vala"
	result = FALSE;
#line 564 "../src/editing_tools/EditingTools.vala"
	return result;
#line 4647 "EditingTools.c"
}

gboolean
editing_tools_editing_tool_on_keypress (EditingToolsEditingTool* self,
                                        GdkEventKey* event)
{
	EditingToolsEditingToolClass* _klass_;
#line 556 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (EDITING_TOOLS_IS_EDITING_TOOL (self), FALSE);
#line 556 "../src/editing_tools/EditingTools.vala"
	_klass_ = EDITING_TOOLS_EDITING_TOOL_GET_CLASS (self);
#line 556 "../src/editing_tools/EditingTools.vala"
	if (_klass_->on_keypress) {
#line 556 "../src/editing_tools/EditingTools.vala"
		return _klass_->on_keypress (self, event);
#line 4663 "EditingTools.c"
	}
#line 556 "../src/editing_tools/EditingTools.vala"
	return FALSE;
#line 4667 "EditingTools.c"
}

static void
editing_tools_editing_tool_real_paint (EditingToolsEditingTool* self,
                                       cairo_t* ctx)
{
#line 567 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (ctx != NULL);
#line 4676 "EditingTools.c"
}

void
editing_tools_editing_tool_paint (EditingToolsEditingTool* self,
                                  cairo_t* ctx)
{
	EditingToolsEditingToolClass* _klass_;
#line 567 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_EDITING_TOOL (self));
#line 567 "../src/editing_tools/EditingTools.vala"
	_klass_ = EDITING_TOOLS_EDITING_TOOL_GET_CLASS (self);
#line 567 "../src/editing_tools/EditingTools.vala"
	if (_klass_->paint) {
#line 567 "../src/editing_tools/EditingTools.vala"
		_klass_->paint (self, ctx);
#line 4692 "EditingTools.c"
	}
}

void
editing_tools_editing_tool_notify_cancel (EditingToolsEditingTool* self)
{
#line 571 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_EDITING_TOOL (self));
#line 572 "../src/editing_tools/EditingTools.vala"
	g_signal_emit (self, editing_tools_editing_tool_signals[EDITING_TOOLS_EDITING_TOOL_CANCELLED_SIGNAL], 0);
#line 4703 "EditingTools.c"
}

static void
g_cclosure_user_marshal_VOID__OBJECT_OBJECT_BOXED_BOOLEAN (GClosure * closure,
                                                           GValue * return_value,
                                                           guint n_param_values,
                                                           const GValue * param_values,
                                                           gpointer invocation_hint,
                                                           gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT_BOXED_BOOLEAN) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer arg_3, gboolean arg_4, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT_BOXED_BOOLEAN callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 458 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (n_param_values == 5);
#line 458 "../src/editing_tools/EditingTools.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 458 "../src/editing_tools/EditingTools.vala"
		data1 = closure->data;
#line 458 "../src/editing_tools/EditingTools.vala"
		data2 = param_values->data[0].v_pointer;
#line 4728 "EditingTools.c"
	} else {
#line 458 "../src/editing_tools/EditingTools.vala"
		data1 = param_values->data[0].v_pointer;
#line 458 "../src/editing_tools/EditingTools.vala"
		data2 = closure->data;
#line 4734 "EditingTools.c"
	}
#line 458 "../src/editing_tools/EditingTools.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT_BOXED_BOOLEAN) (marshal_data ? marshal_data : cc->callback);
#line 458 "../src/editing_tools/EditingTools.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), g_value_get_boxed (param_values + 3), g_value_get_boolean (param_values + 4), data2);
#line 4740 "EditingTools.c"
}

static void
editing_tools_value_editing_tool_init (GValue* value)
{
#line 458 "../src/editing_tools/EditingTools.vala"
	value->data[0].v_pointer = NULL;
#line 4748 "EditingTools.c"
}

static void
editing_tools_value_editing_tool_free_value (GValue* value)
{
#line 458 "../src/editing_tools/EditingTools.vala"
	if (value->data[0].v_pointer) {
#line 458 "../src/editing_tools/EditingTools.vala"
		editing_tools_editing_tool_unref (value->data[0].v_pointer);
#line 4758 "EditingTools.c"
	}
}

static void
editing_tools_value_editing_tool_copy_value (const GValue* src_value,
                                             GValue* dest_value)
{
#line 458 "../src/editing_tools/EditingTools.vala"
	if (src_value->data[0].v_pointer) {
#line 458 "../src/editing_tools/EditingTools.vala"
		dest_value->data[0].v_pointer = editing_tools_editing_tool_ref (src_value->data[0].v_pointer);
#line 4770 "EditingTools.c"
	} else {
#line 458 "../src/editing_tools/EditingTools.vala"
		dest_value->data[0].v_pointer = NULL;
#line 4774 "EditingTools.c"
	}
}

static gpointer
editing_tools_value_editing_tool_peek_pointer (const GValue* value)
{
#line 458 "../src/editing_tools/EditingTools.vala"
	return value->data[0].v_pointer;
#line 4783 "EditingTools.c"
}

static gchar*
editing_tools_value_editing_tool_collect_value (GValue* value,
                                                guint n_collect_values,
                                                GTypeCValue* collect_values,
                                                guint collect_flags)
{
#line 458 "../src/editing_tools/EditingTools.vala"
	if (collect_values[0].v_pointer) {
#line 4794 "EditingTools.c"
		EditingToolsEditingTool * object;
		object = collect_values[0].v_pointer;
#line 458 "../src/editing_tools/EditingTools.vala"
		if (object->parent_instance.g_class == NULL) {
#line 458 "../src/editing_tools/EditingTools.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 4801 "EditingTools.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 458 "../src/editing_tools/EditingTools.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 4805 "EditingTools.c"
		}
#line 458 "../src/editing_tools/EditingTools.vala"
		value->data[0].v_pointer = editing_tools_editing_tool_ref (object);
#line 4809 "EditingTools.c"
	} else {
#line 458 "../src/editing_tools/EditingTools.vala"
		value->data[0].v_pointer = NULL;
#line 4813 "EditingTools.c"
	}
#line 458 "../src/editing_tools/EditingTools.vala"
	return NULL;
#line 4817 "EditingTools.c"
}

static gchar*
editing_tools_value_editing_tool_lcopy_value (const GValue* value,
                                              guint n_collect_values,
                                              GTypeCValue* collect_values,
                                              guint collect_flags)
{
	EditingToolsEditingTool ** object_p;
	object_p = collect_values[0].v_pointer;
#line 458 "../src/editing_tools/EditingTools.vala"
	if (!object_p) {
#line 458 "../src/editing_tools/EditingTools.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 4832 "EditingTools.c"
	}
#line 458 "../src/editing_tools/EditingTools.vala"
	if (!value->data[0].v_pointer) {
#line 458 "../src/editing_tools/EditingTools.vala"
		*object_p = NULL;
#line 4838 "EditingTools.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 458 "../src/editing_tools/EditingTools.vala"
		*object_p = value->data[0].v_pointer;
#line 4842 "EditingTools.c"
	} else {
#line 458 "../src/editing_tools/EditingTools.vala"
		*object_p = editing_tools_editing_tool_ref (value->data[0].v_pointer);
#line 4846 "EditingTools.c"
	}
#line 458 "../src/editing_tools/EditingTools.vala"
	return NULL;
#line 4850 "EditingTools.c"
}

GParamSpec*
editing_tools_param_spec_editing_tool (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags)
{
	EditingToolsParamSpecEditingTool* spec;
#line 458 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (g_type_is_a (object_type, EDITING_TOOLS_TYPE_EDITING_TOOL), NULL);
#line 458 "../src/editing_tools/EditingTools.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 458 "../src/editing_tools/EditingTools.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 458 "../src/editing_tools/EditingTools.vala"
	return G_PARAM_SPEC (spec);
#line 4869 "EditingTools.c"
}

gpointer
editing_tools_value_get_editing_tool (const GValue* value)
{
#line 458 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, EDITING_TOOLS_TYPE_EDITING_TOOL), NULL);
#line 458 "../src/editing_tools/EditingTools.vala"
	return value->data[0].v_pointer;
#line 4879 "EditingTools.c"
}

void
editing_tools_value_set_editing_tool (GValue* value,
                                      gpointer v_object)
{
	EditingToolsEditingTool * old;
#line 458 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, EDITING_TOOLS_TYPE_EDITING_TOOL));
#line 458 "../src/editing_tools/EditingTools.vala"
	old = value->data[0].v_pointer;
#line 458 "../src/editing_tools/EditingTools.vala"
	if (v_object) {
#line 458 "../src/editing_tools/EditingTools.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, EDITING_TOOLS_TYPE_EDITING_TOOL));
#line 458 "../src/editing_tools/EditingTools.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 458 "../src/editing_tools/EditingTools.vala"
		value->data[0].v_pointer = v_object;
#line 458 "../src/editing_tools/EditingTools.vala"
		editing_tools_editing_tool_ref (value->data[0].v_pointer);
#line 4901 "EditingTools.c"
	} else {
#line 458 "../src/editing_tools/EditingTools.vala"
		value->data[0].v_pointer = NULL;
#line 4905 "EditingTools.c"
	}
#line 458 "../src/editing_tools/EditingTools.vala"
	if (old) {
#line 458 "../src/editing_tools/EditingTools.vala"
		editing_tools_editing_tool_unref (old);
#line 4911 "EditingTools.c"
	}
}

void
editing_tools_value_take_editing_tool (GValue* value,
                                       gpointer v_object)
{
	EditingToolsEditingTool * old;
#line 458 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, EDITING_TOOLS_TYPE_EDITING_TOOL));
#line 458 "../src/editing_tools/EditingTools.vala"
	old = value->data[0].v_pointer;
#line 458 "../src/editing_tools/EditingTools.vala"
	if (v_object) {
#line 458 "../src/editing_tools/EditingTools.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, EDITING_TOOLS_TYPE_EDITING_TOOL));
#line 458 "../src/editing_tools/EditingTools.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 458 "../src/editing_tools/EditingTools.vala"
		value->data[0].v_pointer = v_object;
#line 4932 "EditingTools.c"
	} else {
#line 458 "../src/editing_tools/EditingTools.vala"
		value->data[0].v_pointer = NULL;
#line 4936 "EditingTools.c"
	}
#line 458 "../src/editing_tools/EditingTools.vala"
	if (old) {
#line 458 "../src/editing_tools/EditingTools.vala"
		editing_tools_editing_tool_unref (old);
#line 4942 "EditingTools.c"
	}
}

static void
editing_tools_editing_tool_class_init (EditingToolsEditingToolClass * klass,
                                       gpointer klass_data)
{
#line 458 "../src/editing_tools/EditingTools.vala"
	editing_tools_editing_tool_parent_class = g_type_class_peek_parent (klass);
#line 458 "../src/editing_tools/EditingTools.vala"
	((EditingToolsEditingToolClass *) klass)->finalize = editing_tools_editing_tool_finalize;
#line 458 "../src/editing_tools/EditingTools.vala"
	g_type_class_adjust_private_offset (klass, &EditingToolsEditingTool_private_offset);
#line 458 "../src/editing_tools/EditingTools.vala"
	((EditingToolsEditingToolClass *) klass)->activate = (void (*) (EditingToolsEditingTool*, EditingToolsPhotoCanvas*)) editing_tools_editing_tool_real_activate;
#line 458 "../src/editing_tools/EditingTools.vala"
	((EditingToolsEditingToolClass *) klass)->deactivate = (void (*) (EditingToolsEditingTool*)) editing_tools_editing_tool_real_deactivate;
#line 458 "../src/editing_tools/EditingTools.vala"
	((EditingToolsEditingToolClass *) klass)->get_tool_window = (EditingToolsEditingToolWindow* (*) (EditingToolsEditingTool*)) editing_tools_editing_tool_real_get_tool_window;
#line 458 "../src/editing_tools/EditingTools.vala"
	((EditingToolsEditingToolClass *) klass)->get_display_pixbuf = (GdkPixbuf* (*) (EditingToolsEditingTool*, Scaling*, Photo*, Dimensions*, GError**)) editing_tools_editing_tool_real_get_display_pixbuf;
#line 458 "../src/editing_tools/EditingTools.vala"
	((EditingToolsEditingToolClass *) klass)->on_left_click = (void (*) (EditingToolsEditingTool*, gint, gint)) editing_tools_editing_tool_real_on_left_click;
#line 458 "../src/editing_tools/EditingTools.vala"
	((EditingToolsEditingToolClass *) klass)->on_left_released = (void (*) (EditingToolsEditingTool*, gint, gint)) editing_tools_editing_tool_real_on_left_released;
#line 458 "../src/editing_tools/EditingTools.vala"
	((EditingToolsEditingToolClass *) klass)->on_motion = (void (*) (EditingToolsEditingTool*, gint, gint, GdkModifierType)) editing_tools_editing_tool_real_on_motion;
#line 458 "../src/editing_tools/EditingTools.vala"
	((EditingToolsEditingToolClass *) klass)->on_leave_notify_event = (gboolean (*) (EditingToolsEditingTool*)) editing_tools_editing_tool_real_on_leave_notify_event;
#line 458 "../src/editing_tools/EditingTools.vala"
	((EditingToolsEditingToolClass *) klass)->on_keypress = (gboolean (*) (EditingToolsEditingTool*, GdkEventKey*)) editing_tools_editing_tool_real_on_keypress;
#line 458 "../src/editing_tools/EditingTools.vala"
	((EditingToolsEditingToolClass *) klass)->paint = (void (*) (EditingToolsEditingTool*, cairo_t*)) editing_tools_editing_tool_real_paint;
#line 458 "../src/editing_tools/EditingTools.vala"
	editing_tools_editing_tool_signals[EDITING_TOOLS_EDITING_TOOL_ACTIVATED_SIGNAL] = g_signal_new ("activated", EDITING_TOOLS_TYPE_EDITING_TOOL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 458 "../src/editing_tools/EditingTools.vala"
	editing_tools_editing_tool_signals[EDITING_TOOLS_EDITING_TOOL_DEACTIVATED_SIGNAL] = g_signal_new ("deactivated", EDITING_TOOLS_TYPE_EDITING_TOOL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 458 "../src/editing_tools/EditingTools.vala"
	editing_tools_editing_tool_signals[EDITING_TOOLS_EDITING_TOOL_APPLIED_SIGNAL] = g_signal_new ("applied", EDITING_TOOLS_TYPE_EDITING_TOOL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT_BOXED_BOOLEAN, G_TYPE_NONE, 4, TYPE_COMMAND, gdk_pixbuf_get_type (), TYPE_DIMENSIONS, G_TYPE_BOOLEAN);
#line 458 "../src/editing_tools/EditingTools.vala"
	editing_tools_editing_tool_signals[EDITING_TOOLS_EDITING_TOOL_CANCELLED_SIGNAL] = g_signal_new ("cancelled", EDITING_TOOLS_TYPE_EDITING_TOOL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 458 "../src/editing_tools/EditingTools.vala"
	editing_tools_editing_tool_signals[EDITING_TOOLS_EDITING_TOOL_ABORTED_SIGNAL] = g_signal_new ("aborted", EDITING_TOOLS_TYPE_EDITING_TOOL, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 4986 "EditingTools.c"
}

static void
editing_tools_editing_tool_instance_init (EditingToolsEditingTool * self,
                                          gpointer klass)
{
#line 458 "../src/editing_tools/EditingTools.vala"
	self->priv = editing_tools_editing_tool_get_instance_private (self);
#line 459 "../src/editing_tools/EditingTools.vala"
	self->canvas = NULL;
#line 461 "../src/editing_tools/EditingTools.vala"
	self->priv->tool_window = NULL;
#line 458 "../src/editing_tools/EditingTools.vala"
	self->ref_count = 1;
#line 5001 "EditingTools.c"
}

static void
editing_tools_editing_tool_finalize (EditingToolsEditingTool * obj)
{
	EditingToolsEditingTool * self;
#line 458 "../src/editing_tools/EditingTools.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool);
#line 458 "../src/editing_tools/EditingTools.vala"
	g_signal_handlers_destroy (self);
#line 459 "../src/editing_tools/EditingTools.vala"
	_editing_tools_photo_canvas_unref0 (self->canvas);
#line 461 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->priv->tool_window);
#line 462 "../src/editing_tools/EditingTools.vala"
	_cairo_surface_destroy0 (self->surface);
#line 463 "../src/editing_tools/EditingTools.vala"
	_g_free0 (self->name);
#line 5020 "EditingTools.c"
}

static GType
editing_tools_editing_tool_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { editing_tools_value_editing_tool_init, editing_tools_value_editing_tool_free_value, editing_tools_value_editing_tool_copy_value, editing_tools_value_editing_tool_peek_pointer, "p", editing_tools_value_editing_tool_collect_value, "p", editing_tools_value_editing_tool_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (EditingToolsEditingToolClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) editing_tools_editing_tool_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EditingToolsEditingTool), 0, (GInstanceInitFunc) editing_tools_editing_tool_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType editing_tools_editing_tool_type_id;
	editing_tools_editing_tool_type_id = g_type_register_fundamental (g_type_fundamental_next (), "EditingToolsEditingTool", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
	EditingToolsEditingTool_private_offset = g_type_add_instance_private (editing_tools_editing_tool_type_id, sizeof (EditingToolsEditingToolPrivate));
	return editing_tools_editing_tool_type_id;
}

GType
editing_tools_editing_tool_get_type (void)
{
	static volatile gsize editing_tools_editing_tool_type_id__once = 0;
	if (g_once_init_enter (&editing_tools_editing_tool_type_id__once)) {
		GType editing_tools_editing_tool_type_id;
		editing_tools_editing_tool_type_id = editing_tools_editing_tool_get_type_once ();
		g_once_init_leave (&editing_tools_editing_tool_type_id__once, editing_tools_editing_tool_type_id);
	}
	return editing_tools_editing_tool_type_id__once;
}

gpointer
editing_tools_editing_tool_ref (gpointer instance)
{
	EditingToolsEditingTool * self;
	self = instance;
#line 458 "../src/editing_tools/EditingTools.vala"
	g_atomic_int_inc (&self->ref_count);
#line 458 "../src/editing_tools/EditingTools.vala"
	return instance;
#line 5056 "EditingTools.c"
}

void
editing_tools_editing_tool_unref (gpointer instance)
{
	EditingToolsEditingTool * self;
	self = instance;
#line 458 "../src/editing_tools/EditingTools.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 458 "../src/editing_tools/EditingTools.vala"
		EDITING_TOOLS_EDITING_TOOL_GET_CLASS (self)->finalize (self);
#line 458 "../src/editing_tools/EditingTools.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 5070 "EditingTools.c"
	}
}

static inline gpointer
editing_tools_crop_tool_get_instance_private (EditingToolsCropTool* self)
{
	return G_STRUCT_MEMBER_P (self, EditingToolsCropTool_private_offset);
}

static EditingToolsCropToolReticleOrientation
editing_tools_crop_tool_reticle_orientation_toggle (EditingToolsCropToolReticleOrientation self)
{
	EditingToolsCropToolReticleOrientation _tmp0_ = 0;
	EditingToolsCropToolReticleOrientation result;
#line 626 "../src/editing_tools/EditingTools.vala"
	if (self == EDITING_TOOLS_CROP_TOOL_RETICLE_ORIENTATION_LANDSCAPE) {
#line 626 "../src/editing_tools/EditingTools.vala"
		_tmp0_ = EDITING_TOOLS_CROP_TOOL_RETICLE_ORIENTATION_PORTRAIT;
#line 5089 "EditingTools.c"
	} else {
#line 627 "../src/editing_tools/EditingTools.vala"
		_tmp0_ = EDITING_TOOLS_CROP_TOOL_RETICLE_ORIENTATION_LANDSCAPE;
#line 5093 "EditingTools.c"
	}
#line 626 "../src/editing_tools/EditingTools.vala"
	result = _tmp0_;
#line 626 "../src/editing_tools/EditingTools.vala"
	return result;
#line 5099 "EditingTools.c"
}

static GType
editing_tools_crop_tool_reticle_orientation_get_type_once (void)
{
	static const GEnumValue values[] = {{EDITING_TOOLS_CROP_TOOL_RETICLE_ORIENTATION_LANDSCAPE, "EDITING_TOOLS_CROP_TOOL_RETICLE_ORIENTATION_LANDSCAPE", "landscape"}, {EDITING_TOOLS_CROP_TOOL_RETICLE_ORIENTATION_PORTRAIT, "EDITING_TOOLS_CROP_TOOL_RETICLE_ORIENTATION_PORTRAIT", "portrait"}, {0, NULL, NULL}};
	GType editing_tools_crop_tool_reticle_orientation_type_id;
	editing_tools_crop_tool_reticle_orientation_type_id = g_enum_register_static ("EditingToolsCropToolReticleOrientation", values);
	return editing_tools_crop_tool_reticle_orientation_type_id;
}

static GType
editing_tools_crop_tool_reticle_orientation_get_type (void)
{
	static volatile gsize editing_tools_crop_tool_reticle_orientation_type_id__once = 0;
	if (g_once_init_enter (&editing_tools_crop_tool_reticle_orientation_type_id__once)) {
		GType editing_tools_crop_tool_reticle_orientation_type_id;
		editing_tools_crop_tool_reticle_orientation_type_id = editing_tools_crop_tool_reticle_orientation_get_type_once ();
		g_once_init_leave (&editing_tools_crop_tool_reticle_orientation_type_id__once, editing_tools_crop_tool_reticle_orientation_type_id);
	}
	return editing_tools_crop_tool_reticle_orientation_type_id__once;
}

static GType
editing_tools_crop_tool_constraint_mode_get_type_once (void)
{
	static const GEnumValue values[] = {{EDITING_TOOLS_CROP_TOOL_CONSTRAINT_MODE_NORMAL, "EDITING_TOOLS_CROP_TOOL_CONSTRAINT_MODE_NORMAL", "normal"}, {EDITING_TOOLS_CROP_TOOL_CONSTRAINT_MODE_CUSTOM, "EDITING_TOOLS_CROP_TOOL_CONSTRAINT_MODE_CUSTOM", "custom"}, {0, NULL, NULL}};
	GType editing_tools_crop_tool_constraint_mode_type_id;
	editing_tools_crop_tool_constraint_mode_type_id = g_enum_register_static ("EditingToolsCropToolConstraintMode", values);
	return editing_tools_crop_tool_constraint_mode_type_id;
}

static GType
editing_tools_crop_tool_constraint_mode_get_type (void)
{
	static volatile gsize editing_tools_crop_tool_constraint_mode_type_id__once = 0;
	if (g_once_init_enter (&editing_tools_crop_tool_constraint_mode_type_id__once)) {
		GType editing_tools_crop_tool_constraint_mode_type_id;
		editing_tools_crop_tool_constraint_mode_type_id = editing_tools_crop_tool_constraint_mode_get_type_once ();
		g_once_init_leave (&editing_tools_crop_tool_constraint_mode_type_id__once, editing_tools_crop_tool_constraint_mode_type_id);
	}
	return editing_tools_crop_tool_constraint_mode_type_id__once;
}

static EditingToolsCropTool*
editing_tools_crop_tool_construct (GType object_type)
{
	EditingToolsCropTool* self = NULL;
#line 727 "../src/editing_tools/EditingTools.vala"
	self = (EditingToolsCropTool*) editing_tools_editing_tool_construct (object_type, "CropTool");
#line 726 "../src/editing_tools/EditingTools.vala"
	return self;
#line 5152 "EditingTools.c"
}

static EditingToolsCropTool*
editing_tools_crop_tool_new (void)
{
#line 726 "../src/editing_tools/EditingTools.vala"
	return editing_tools_crop_tool_construct (EDITING_TOOLS_TYPE_CROP_TOOL);
#line 5160 "EditingTools.c"
}

EditingToolsCropTool*
editing_tools_crop_tool_factory (void)
{
	EditingToolsCropTool* _tmp0_;
	EditingToolsCropTool* result;
#line 731 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = editing_tools_crop_tool_new ();
#line 731 "../src/editing_tools/EditingTools.vala"
	result = _tmp0_;
#line 731 "../src/editing_tools/EditingTools.vala"
	return result;
#line 5174 "EditingTools.c"
}

gboolean
editing_tools_crop_tool_is_available (Photo* photo,
                                      Scaling* scaling)
{
	Dimensions dim = {0};
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_ = {0};
	gboolean _tmp2_ = FALSE;
	Dimensions _tmp3_;
	gboolean result;
#line 734 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (IS_PHOTO (photo), FALSE);
#line 734 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (scaling != NULL, FALSE);
#line 735 "../src/editing_tools/EditingTools.vala"
	photo_get_original_dimensions (photo, &_tmp0_);
#line 735 "../src/editing_tools/EditingTools.vala"
	scaling_get_scaled_dimensions (scaling, &_tmp0_, &_tmp1_);
#line 735 "../src/editing_tools/EditingTools.vala"
	dim = _tmp1_;
#line 737 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = dim;
#line 737 "../src/editing_tools/EditingTools.vala"
	if (_tmp3_.width > EDITING_TOOLS_CROP_TOOL_CROP_MIN_SIZE) {
#line 5201 "EditingTools.c"
		Dimensions _tmp4_;
#line 737 "../src/editing_tools/EditingTools.vala"
		_tmp4_ = dim;
#line 737 "../src/editing_tools/EditingTools.vala"
		_tmp2_ = _tmp4_.height > EDITING_TOOLS_CROP_TOOL_CROP_MIN_SIZE;
#line 5207 "EditingTools.c"
	} else {
#line 737 "../src/editing_tools/EditingTools.vala"
		_tmp2_ = FALSE;
#line 5211 "EditingTools.c"
	}
#line 737 "../src/editing_tools/EditingTools.vala"
	result = _tmp2_;
#line 737 "../src/editing_tools/EditingTools.vala"
	return result;
#line 5217 "EditingTools.c"
}

static void
_vala_array_add5 (EditingToolsCropToolConstraintDescription** * array,
                  gint* length,
                  gint* size,
                  EditingToolsCropToolConstraintDescription* value)
{
#line 743 "../src/editing_tools/EditingTools.vala"
	if ((*length) == (*size)) {
#line 743 "../src/editing_tools/EditingTools.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 743 "../src/editing_tools/EditingTools.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 5232 "EditingTools.c"
	}
#line 743 "../src/editing_tools/EditingTools.vala"
	(*array)[(*length)++] = value;
#line 743 "../src/editing_tools/EditingTools.vala"
	(*array)[*length] = NULL;
#line 5238 "EditingTools.c"
}

static void
_vala_array_add6 (EditingToolsCropToolConstraintDescription** * array,
                  gint* length,
                  gint* size,
                  EditingToolsCropToolConstraintDescription* value)
{
#line 744 "../src/editing_tools/EditingTools.vala"
	if ((*length) == (*size)) {
#line 744 "../src/editing_tools/EditingTools.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 744 "../src/editing_tools/EditingTools.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 5253 "EditingTools.c"
	}
#line 744 "../src/editing_tools/EditingTools.vala"
	(*array)[(*length)++] = value;
#line 744 "../src/editing_tools/EditingTools.vala"
	(*array)[*length] = NULL;
#line 5259 "EditingTools.c"
}

static void
_vala_array_add7 (EditingToolsCropToolConstraintDescription** * array,
                  gint* length,
                  gint* size,
                  EditingToolsCropToolConstraintDescription* value)
{
#line 745 "../src/editing_tools/EditingTools.vala"
	if ((*length) == (*size)) {
#line 745 "../src/editing_tools/EditingTools.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 745 "../src/editing_tools/EditingTools.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 5274 "EditingTools.c"
	}
#line 745 "../src/editing_tools/EditingTools.vala"
	(*array)[(*length)++] = value;
#line 745 "../src/editing_tools/EditingTools.vala"
	(*array)[*length] = NULL;
#line 5280 "EditingTools.c"
}

static void
_vala_array_add8 (EditingToolsCropToolConstraintDescription** * array,
                  gint* length,
                  gint* size,
                  EditingToolsCropToolConstraintDescription* value)
{
#line 746 "../src/editing_tools/EditingTools.vala"
	if ((*length) == (*size)) {
#line 746 "../src/editing_tools/EditingTools.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 746 "../src/editing_tools/EditingTools.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 5295 "EditingTools.c"
	}
#line 746 "../src/editing_tools/EditingTools.vala"
	(*array)[(*length)++] = value;
#line 746 "../src/editing_tools/EditingTools.vala"
	(*array)[*length] = NULL;
#line 5301 "EditingTools.c"
}

static void
_vala_array_add9 (EditingToolsCropToolConstraintDescription** * array,
                  gint* length,
                  gint* size,
                  EditingToolsCropToolConstraintDescription* value)
{
#line 747 "../src/editing_tools/EditingTools.vala"
	if ((*length) == (*size)) {
#line 747 "../src/editing_tools/EditingTools.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 747 "../src/editing_tools/EditingTools.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 5316 "EditingTools.c"
	}
#line 747 "../src/editing_tools/EditingTools.vala"
	(*array)[(*length)++] = value;
#line 747 "../src/editing_tools/EditingTools.vala"
	(*array)[*length] = NULL;
#line 5322 "EditingTools.c"
}

static void
_vala_array_add10 (EditingToolsCropToolConstraintDescription** * array,
                   gint* length,
                   gint* size,
                   EditingToolsCropToolConstraintDescription* value)
{
#line 748 "../src/editing_tools/EditingTools.vala"
	if ((*length) == (*size)) {
#line 748 "../src/editing_tools/EditingTools.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 748 "../src/editing_tools/EditingTools.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 5337 "EditingTools.c"
	}
#line 748 "../src/editing_tools/EditingTools.vala"
	(*array)[(*length)++] = value;
#line 748 "../src/editing_tools/EditingTools.vala"
	(*array)[*length] = NULL;
#line 5343 "EditingTools.c"
}

static void
_vala_array_add11 (EditingToolsCropToolConstraintDescription** * array,
                   gint* length,
                   gint* size,
                   EditingToolsCropToolConstraintDescription* value)
{
#line 749 "../src/editing_tools/EditingTools.vala"
	if ((*length) == (*size)) {
#line 749 "../src/editing_tools/EditingTools.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 749 "../src/editing_tools/EditingTools.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 5358 "EditingTools.c"
	}
#line 749 "../src/editing_tools/EditingTools.vala"
	(*array)[(*length)++] = value;
#line 749 "../src/editing_tools/EditingTools.vala"
	(*array)[*length] = NULL;
#line 5364 "EditingTools.c"
}

static void
_vala_array_add12 (EditingToolsCropToolConstraintDescription** * array,
                   gint* length,
                   gint* size,
                   EditingToolsCropToolConstraintDescription* value)
{
#line 750 "../src/editing_tools/EditingTools.vala"
	if ((*length) == (*size)) {
#line 750 "../src/editing_tools/EditingTools.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 750 "../src/editing_tools/EditingTools.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 5379 "EditingTools.c"
	}
#line 750 "../src/editing_tools/EditingTools.vala"
	(*array)[(*length)++] = value;
#line 750 "../src/editing_tools/EditingTools.vala"
	(*array)[*length] = NULL;
#line 5385 "EditingTools.c"
}

static void
_vala_array_add13 (EditingToolsCropToolConstraintDescription** * array,
                   gint* length,
                   gint* size,
                   EditingToolsCropToolConstraintDescription* value)
{
#line 751 "../src/editing_tools/EditingTools.vala"
	if ((*length) == (*size)) {
#line 751 "../src/editing_tools/EditingTools.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 751 "../src/editing_tools/EditingTools.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 5400 "EditingTools.c"
	}
#line 751 "../src/editing_tools/EditingTools.vala"
	(*array)[(*length)++] = value;
#line 751 "../src/editing_tools/EditingTools.vala"
	(*array)[*length] = NULL;
#line 5406 "EditingTools.c"
}

static void
_vala_array_add14 (EditingToolsCropToolConstraintDescription** * array,
                   gint* length,
                   gint* size,
                   EditingToolsCropToolConstraintDescription* value)
{
#line 752 "../src/editing_tools/EditingTools.vala"
	if ((*length) == (*size)) {
#line 752 "../src/editing_tools/EditingTools.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 752 "../src/editing_tools/EditingTools.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 5421 "EditingTools.c"
	}
#line 752 "../src/editing_tools/EditingTools.vala"
	(*array)[(*length)++] = value;
#line 752 "../src/editing_tools/EditingTools.vala"
	(*array)[*length] = NULL;
#line 5427 "EditingTools.c"
}

static void
_vala_array_add15 (EditingToolsCropToolConstraintDescription** * array,
                   gint* length,
                   gint* size,
                   EditingToolsCropToolConstraintDescription* value)
{
#line 753 "../src/editing_tools/EditingTools.vala"
	if ((*length) == (*size)) {
#line 753 "../src/editing_tools/EditingTools.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 753 "../src/editing_tools/EditingTools.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 5442 "EditingTools.c"
	}
#line 753 "../src/editing_tools/EditingTools.vala"
	(*array)[(*length)++] = value;
#line 753 "../src/editing_tools/EditingTools.vala"
	(*array)[*length] = NULL;
#line 5448 "EditingTools.c"
}

static void
_vala_array_add16 (EditingToolsCropToolConstraintDescription** * array,
                   gint* length,
                   gint* size,
                   EditingToolsCropToolConstraintDescription* value)
{
#line 754 "../src/editing_tools/EditingTools.vala"
	if ((*length) == (*size)) {
#line 754 "../src/editing_tools/EditingTools.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 754 "../src/editing_tools/EditingTools.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 5463 "EditingTools.c"
	}
#line 754 "../src/editing_tools/EditingTools.vala"
	(*array)[(*length)++] = value;
#line 754 "../src/editing_tools/EditingTools.vala"
	(*array)[*length] = NULL;
#line 5469 "EditingTools.c"
}

static void
_vala_array_add17 (EditingToolsCropToolConstraintDescription** * array,
                   gint* length,
                   gint* size,
                   EditingToolsCropToolConstraintDescription* value)
{
#line 755 "../src/editing_tools/EditingTools.vala"
	if ((*length) == (*size)) {
#line 755 "../src/editing_tools/EditingTools.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 755 "../src/editing_tools/EditingTools.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 5484 "EditingTools.c"
	}
#line 755 "../src/editing_tools/EditingTools.vala"
	(*array)[(*length)++] = value;
#line 755 "../src/editing_tools/EditingTools.vala"
	(*array)[*length] = NULL;
#line 5490 "EditingTools.c"
}

static void
_vala_array_add18 (EditingToolsCropToolConstraintDescription** * array,
                   gint* length,
                   gint* size,
                   EditingToolsCropToolConstraintDescription* value)
{
#line 756 "../src/editing_tools/EditingTools.vala"
	if ((*length) == (*size)) {
#line 756 "../src/editing_tools/EditingTools.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 756 "../src/editing_tools/EditingTools.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 5505 "EditingTools.c"
	}
#line 756 "../src/editing_tools/EditingTools.vala"
	(*array)[(*length)++] = value;
#line 756 "../src/editing_tools/EditingTools.vala"
	(*array)[*length] = NULL;
#line 5511 "EditingTools.c"
}

static void
_vala_array_add19 (EditingToolsCropToolConstraintDescription** * array,
                   gint* length,
                   gint* size,
                   EditingToolsCropToolConstraintDescription* value)
{
#line 757 "../src/editing_tools/EditingTools.vala"
	if ((*length) == (*size)) {
#line 757 "../src/editing_tools/EditingTools.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 757 "../src/editing_tools/EditingTools.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 5526 "EditingTools.c"
	}
#line 757 "../src/editing_tools/EditingTools.vala"
	(*array)[(*length)++] = value;
#line 757 "../src/editing_tools/EditingTools.vala"
	(*array)[*length] = NULL;
#line 5532 "EditingTools.c"
}

static void
_vala_array_add20 (EditingToolsCropToolConstraintDescription** * array,
                   gint* length,
                   gint* size,
                   EditingToolsCropToolConstraintDescription* value)
{
#line 758 "../src/editing_tools/EditingTools.vala"
	if ((*length) == (*size)) {
#line 758 "../src/editing_tools/EditingTools.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 758 "../src/editing_tools/EditingTools.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 5547 "EditingTools.c"
	}
#line 758 "../src/editing_tools/EditingTools.vala"
	(*array)[(*length)++] = value;
#line 758 "../src/editing_tools/EditingTools.vala"
	(*array)[*length] = NULL;
#line 5553 "EditingTools.c"
}

static void
_vala_array_add21 (EditingToolsCropToolConstraintDescription** * array,
                   gint* length,
                   gint* size,
                   EditingToolsCropToolConstraintDescription* value)
{
#line 759 "../src/editing_tools/EditingTools.vala"
	if ((*length) == (*size)) {
#line 759 "../src/editing_tools/EditingTools.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 759 "../src/editing_tools/EditingTools.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 5568 "EditingTools.c"
	}
#line 759 "../src/editing_tools/EditingTools.vala"
	(*array)[(*length)++] = value;
#line 759 "../src/editing_tools/EditingTools.vala"
	(*array)[*length] = NULL;
#line 5574 "EditingTools.c"
}

static void
_vala_array_add22 (EditingToolsCropToolConstraintDescription** * array,
                   gint* length,
                   gint* size,
                   EditingToolsCropToolConstraintDescription* value)
{
#line 760 "../src/editing_tools/EditingTools.vala"
	if ((*length) == (*size)) {
#line 760 "../src/editing_tools/EditingTools.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 760 "../src/editing_tools/EditingTools.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 5589 "EditingTools.c"
	}
#line 760 "../src/editing_tools/EditingTools.vala"
	(*array)[(*length)++] = value;
#line 760 "../src/editing_tools/EditingTools.vala"
	(*array)[*length] = NULL;
#line 5595 "EditingTools.c"
}

static void
_vala_array_add23 (EditingToolsCropToolConstraintDescription** * array,
                   gint* length,
                   gint* size,
                   EditingToolsCropToolConstraintDescription* value)
{
#line 761 "../src/editing_tools/EditingTools.vala"
	if ((*length) == (*size)) {
#line 761 "../src/editing_tools/EditingTools.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 761 "../src/editing_tools/EditingTools.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 5610 "EditingTools.c"
	}
#line 761 "../src/editing_tools/EditingTools.vala"
	(*array)[(*length)++] = value;
#line 761 "../src/editing_tools/EditingTools.vala"
	(*array)[*length] = NULL;
#line 5616 "EditingTools.c"
}

static void
_vala_array_add24 (EditingToolsCropToolConstraintDescription** * array,
                   gint* length,
                   gint* size,
                   EditingToolsCropToolConstraintDescription* value)
{
#line 762 "../src/editing_tools/EditingTools.vala"
	if ((*length) == (*size)) {
#line 762 "../src/editing_tools/EditingTools.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 762 "../src/editing_tools/EditingTools.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 5631 "EditingTools.c"
	}
#line 762 "../src/editing_tools/EditingTools.vala"
	(*array)[(*length)++] = value;
#line 762 "../src/editing_tools/EditingTools.vala"
	(*array)[*length] = NULL;
#line 5637 "EditingTools.c"
}

static void
_vala_array_add25 (EditingToolsCropToolConstraintDescription** * array,
                   gint* length,
                   gint* size,
                   EditingToolsCropToolConstraintDescription* value)
{
#line 763 "../src/editing_tools/EditingTools.vala"
	if ((*length) == (*size)) {
#line 763 "../src/editing_tools/EditingTools.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 763 "../src/editing_tools/EditingTools.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 5652 "EditingTools.c"
	}
#line 763 "../src/editing_tools/EditingTools.vala"
	(*array)[(*length)++] = value;
#line 763 "../src/editing_tools/EditingTools.vala"
	(*array)[*length] = NULL;
#line 5658 "EditingTools.c"
}

static void
_vala_array_add26 (EditingToolsCropToolConstraintDescription** * array,
                   gint* length,
                   gint* size,
                   EditingToolsCropToolConstraintDescription* value)
{
#line 764 "../src/editing_tools/EditingTools.vala"
	if ((*length) == (*size)) {
#line 764 "../src/editing_tools/EditingTools.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 764 "../src/editing_tools/EditingTools.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 5673 "EditingTools.c"
	}
#line 764 "../src/editing_tools/EditingTools.vala"
	(*array)[(*length)++] = value;
#line 764 "../src/editing_tools/EditingTools.vala"
	(*array)[*length] = NULL;
#line 5679 "EditingTools.c"
}

static void
_vala_array_add27 (EditingToolsCropToolConstraintDescription** * array,
                   gint* length,
                   gint* size,
                   EditingToolsCropToolConstraintDescription* value)
{
#line 765 "../src/editing_tools/EditingTools.vala"
	if ((*length) == (*size)) {
#line 765 "../src/editing_tools/EditingTools.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 765 "../src/editing_tools/EditingTools.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 5694 "EditingTools.c"
	}
#line 765 "../src/editing_tools/EditingTools.vala"
	(*array)[(*length)++] = value;
#line 765 "../src/editing_tools/EditingTools.vala"
	(*array)[*length] = NULL;
#line 5700 "EditingTools.c"
}

static void
_vala_array_add28 (EditingToolsCropToolConstraintDescription** * array,
                   gint* length,
                   gint* size,
                   EditingToolsCropToolConstraintDescription* value)
{
#line 766 "../src/editing_tools/EditingTools.vala"
	if ((*length) == (*size)) {
#line 766 "../src/editing_tools/EditingTools.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 766 "../src/editing_tools/EditingTools.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 5715 "EditingTools.c"
	}
#line 766 "../src/editing_tools/EditingTools.vala"
	(*array)[(*length)++] = value;
#line 766 "../src/editing_tools/EditingTools.vala"
	(*array)[*length] = NULL;
#line 5721 "EditingTools.c"
}

static void
_vala_array_add29 (EditingToolsCropToolConstraintDescription** * array,
                   gint* length,
                   gint* size,
                   EditingToolsCropToolConstraintDescription* value)
{
#line 767 "../src/editing_tools/EditingTools.vala"
	if ((*length) == (*size)) {
#line 767 "../src/editing_tools/EditingTools.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 767 "../src/editing_tools/EditingTools.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 5736 "EditingTools.c"
	}
#line 767 "../src/editing_tools/EditingTools.vala"
	(*array)[(*length)++] = value;
#line 767 "../src/editing_tools/EditingTools.vala"
	(*array)[*length] = NULL;
#line 5742 "EditingTools.c"
}

static void
_vala_array_add30 (EditingToolsCropToolConstraintDescription** * array,
                   gint* length,
                   gint* size,
                   EditingToolsCropToolConstraintDescription* value)
{
#line 768 "../src/editing_tools/EditingTools.vala"
	if ((*length) == (*size)) {
#line 768 "../src/editing_tools/EditingTools.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 768 "../src/editing_tools/EditingTools.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 5757 "EditingTools.c"
	}
#line 768 "../src/editing_tools/EditingTools.vala"
	(*array)[(*length)++] = value;
#line 768 "../src/editing_tools/EditingTools.vala"
	(*array)[*length] = NULL;
#line 5763 "EditingTools.c"
}

static void
_vala_array_add31 (EditingToolsCropToolConstraintDescription** * array,
                   gint* length,
                   gint* size,
                   EditingToolsCropToolConstraintDescription* value)
{
#line 769 "../src/editing_tools/EditingTools.vala"
	if ((*length) == (*size)) {
#line 769 "../src/editing_tools/EditingTools.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 769 "../src/editing_tools/EditingTools.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 5778 "EditingTools.c"
	}
#line 769 "../src/editing_tools/EditingTools.vala"
	(*array)[(*length)++] = value;
#line 769 "../src/editing_tools/EditingTools.vala"
	(*array)[*length] = NULL;
#line 5784 "EditingTools.c"
}

static void
_vala_array_add32 (EditingToolsCropToolConstraintDescription** * array,
                   gint* length,
                   gint* size,
                   EditingToolsCropToolConstraintDescription* value)
{
#line 770 "../src/editing_tools/EditingTools.vala"
	if ((*length) == (*size)) {
#line 770 "../src/editing_tools/EditingTools.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 770 "../src/editing_tools/EditingTools.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 5799 "EditingTools.c"
	}
#line 770 "../src/editing_tools/EditingTools.vala"
	(*array)[(*length)++] = value;
#line 770 "../src/editing_tools/EditingTools.vala"
	(*array)[*length] = NULL;
#line 5805 "EditingTools.c"
}

static void
_vala_array_add33 (EditingToolsCropToolConstraintDescription** * array,
                   gint* length,
                   gint* size,
                   EditingToolsCropToolConstraintDescription* value)
{
#line 771 "../src/editing_tools/EditingTools.vala"
	if ((*length) == (*size)) {
#line 771 "../src/editing_tools/EditingTools.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 771 "../src/editing_tools/EditingTools.vala"
		*array = g_renew (EditingToolsCropToolConstraintDescription*, *array, (*size) + 1);
#line 5820 "EditingTools.c"
	}
#line 771 "../src/editing_tools/EditingTools.vala"
	(*array)[(*length)++] = value;
#line 771 "../src/editing_tools/EditingTools.vala"
	(*array)[*length] = NULL;
#line 5826 "EditingTools.c"
}

static EditingToolsCropToolConstraintDescription**
editing_tools_crop_tool_create_constraints (gint* result_length1)
{
	EditingToolsCropToolConstraintDescription** _result_ = NULL;
	EditingToolsCropToolConstraintDescription** _tmp0_;
	gint _result__length1;
	gint __result__size_;
	EditingToolsCropToolConstraintDescription* _tmp1_;
	EditingToolsCropToolConstraintDescription* _tmp2_;
	EditingToolsCropToolConstraintDescription* _tmp3_;
	EditingToolsCropToolConstraintDescription* _tmp4_;
	EditingToolsCropToolConstraintDescription* _tmp5_;
	EditingToolsCropToolConstraintDescription* _tmp6_;
	EditingToolsCropToolConstraintDescription* _tmp7_;
	EditingToolsCropToolConstraintDescription* _tmp8_;
	EditingToolsCropToolConstraintDescription* _tmp9_;
	EditingToolsCropToolConstraintDescription* _tmp10_;
	EditingToolsCropToolConstraintDescription* _tmp11_;
	EditingToolsCropToolConstraintDescription* _tmp12_;
	EditingToolsCropToolConstraintDescription* _tmp13_;
	EditingToolsCropToolConstraintDescription* _tmp14_;
	EditingToolsCropToolConstraintDescription* _tmp15_;
	EditingToolsCropToolConstraintDescription* _tmp16_;
	EditingToolsCropToolConstraintDescription* _tmp17_;
	EditingToolsCropToolConstraintDescription* _tmp18_;
	EditingToolsCropToolConstraintDescription* _tmp19_;
	EditingToolsCropToolConstraintDescription* _tmp20_;
	EditingToolsCropToolConstraintDescription* _tmp21_;
	EditingToolsCropToolConstraintDescription* _tmp22_;
	EditingToolsCropToolConstraintDescription* _tmp23_;
	EditingToolsCropToolConstraintDescription* _tmp24_;
	EditingToolsCropToolConstraintDescription* _tmp25_;
	EditingToolsCropToolConstraintDescription* _tmp26_;
	EditingToolsCropToolConstraintDescription* _tmp27_;
	EditingToolsCropToolConstraintDescription* _tmp28_;
	EditingToolsCropToolConstraintDescription* _tmp29_;
	EditingToolsCropToolConstraintDescription** _tmp30_;
	gint _tmp30__length1;
	EditingToolsCropToolConstraintDescription** result;
#line 741 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = g_new0 (EditingToolsCropToolConstraintDescription*, 0 + 1);
#line 741 "../src/editing_tools/EditingTools.vala"
	_result_ = _tmp0_;
#line 741 "../src/editing_tools/EditingTools.vala"
	_result__length1 = 0;
#line 741 "../src/editing_tools/EditingTools.vala"
	__result__size_ = _result__length1;
#line 743 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = editing_tools_crop_tool_constraint_description_new (_ ("Unconstrained"), 0, 0, FALSE, EDITING_TOOLS_CROP_TOOL_ANY_ASPECT_RATIO);
#line 743 "../src/editing_tools/EditingTools.vala"
	_vala_array_add5 (&_result_, &_result__length1, &__result__size_, _tmp1_);
#line 744 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = editing_tools_crop_tool_constraint_description_new (_ ("Square"), 1, 1, FALSE, EDITING_TOOLS_CROP_TOOL_COMPUTE_FROM_BASIS);
#line 744 "../src/editing_tools/EditingTools.vala"
	_vala_array_add6 (&_result_, &_result__length1, &__result__size_, _tmp2_);
#line 745 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = editing_tools_crop_tool_constraint_description_new (_ ("Screen"), 0, 0, TRUE, EDITING_TOOLS_CROP_TOOL_SCREEN_ASPECT_RATIO);
#line 745 "../src/editing_tools/EditingTools.vala"
	_vala_array_add7 (&_result_, &_result__length1, &__result__size_, _tmp3_);
#line 746 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = editing_tools_crop_tool_constraint_description_new (_ ("Original Size"), 0, 0, TRUE, EDITING_TOOLS_CROP_TOOL_ORIGINAL_ASPECT_RATIO);
#line 746 "../src/editing_tools/EditingTools.vala"
	_vala_array_add8 (&_result_, &_result__length1, &__result__size_, _tmp4_);
#line 747 "../src/editing_tools/EditingTools.vala"
	_tmp5_ = editing_tools_crop_tool_constraint_description_new (_ ("-"), 0, 0, FALSE, EDITING_TOOLS_CROP_TOOL_SEPARATOR);
#line 747 "../src/editing_tools/EditingTools.vala"
	_vala_array_add9 (&_result_, &_result__length1, &__result__size_, _tmp5_);
#line 748 "../src/editing_tools/EditingTools.vala"
	_tmp6_ = editing_tools_crop_tool_constraint_description_new (_ ("SD Video (4 ∶ 3)"), 4, 3, TRUE, EDITING_TOOLS_CROP_TOOL_COMPUTE_FROM_BASIS);
#line 748 "../src/editing_tools/EditingTools.vala"
	_vala_array_add10 (&_result_, &_result__length1, &__result__size_, _tmp6_);
#line 749 "../src/editing_tools/EditingTools.vala"
	_tmp7_ = editing_tools_crop_tool_constraint_description_new (_ ("HD Video (16 ∶ 9)"), 16, 9, TRUE, EDITING_TOOLS_CROP_TOOL_COMPUTE_FROM_BASIS);
#line 749 "../src/editing_tools/EditingTools.vala"
	_vala_array_add11 (&_result_, &_result__length1, &__result__size_, _tmp7_);
#line 750 "../src/editing_tools/EditingTools.vala"
	_tmp8_ = editing_tools_crop_tool_constraint_description_new (_ ("-"), 0, 0, FALSE, EDITING_TOOLS_CROP_TOOL_SEPARATOR);
#line 750 "../src/editing_tools/EditingTools.vala"
	_vala_array_add12 (&_result_, &_result__length1, &__result__size_, _tmp8_);
#line 751 "../src/editing_tools/EditingTools.vala"
	_tmp9_ = editing_tools_crop_tool_constraint_description_new (_ ("Wallet (2 × 3 in.)"), 3, 2, TRUE, EDITING_TOOLS_CROP_TOOL_COMPUTE_FROM_BASIS);
#line 751 "../src/editing_tools/EditingTools.vala"
	_vala_array_add13 (&_result_, &_result__length1, &__result__size_, _tmp9_);
#line 752 "../src/editing_tools/EditingTools.vala"
	_tmp10_ = editing_tools_crop_tool_constraint_description_new (_ ("Notecard (3 × 5 in.)"), 5, 3, TRUE, EDITING_TOOLS_CROP_TOOL_COMPUTE_FROM_BASIS);
#line 752 "../src/editing_tools/EditingTools.vala"
	_vala_array_add14 (&_result_, &_result__length1, &__result__size_, _tmp10_);
#line 753 "../src/editing_tools/EditingTools.vala"
	_tmp11_ = editing_tools_crop_tool_constraint_description_new (_ ("4 × 6 in."), 6, 4, TRUE, EDITING_TOOLS_CROP_TOOL_COMPUTE_FROM_BASIS);
#line 753 "../src/editing_tools/EditingTools.vala"
	_vala_array_add15 (&_result_, &_result__length1, &__result__size_, _tmp11_);
#line 754 "../src/editing_tools/EditingTools.vala"
	_tmp12_ = editing_tools_crop_tool_constraint_description_new (_ ("5 × 7 in."), 7, 5, TRUE, EDITING_TOOLS_CROP_TOOL_COMPUTE_FROM_BASIS);
#line 754 "../src/editing_tools/EditingTools.vala"
	_vala_array_add16 (&_result_, &_result__length1, &__result__size_, _tmp12_);
#line 755 "../src/editing_tools/EditingTools.vala"
	_tmp13_ = editing_tools_crop_tool_constraint_description_new (_ ("8 × 10 in."), 10, 8, TRUE, EDITING_TOOLS_CROP_TOOL_COMPUTE_FROM_BASIS);
#line 755 "../src/editing_tools/EditingTools.vala"
	_vala_array_add17 (&_result_, &_result__length1, &__result__size_, _tmp13_);
#line 756 "../src/editing_tools/EditingTools.vala"
	_tmp14_ = editing_tools_crop_tool_constraint_description_new (_ ("Letter (8.5 × 11 in.)"), 85, 110, TRUE, EDITING_TOOLS_CROP_TOOL_COMPUTE_FROM_BASIS);
#line 756 "../src/editing_tools/EditingTools.vala"
	_vala_array_add18 (&_result_, &_result__length1, &__result__size_, _tmp14_);
#line 757 "../src/editing_tools/EditingTools.vala"
	_tmp15_ = editing_tools_crop_tool_constraint_description_new (_ ("11 × 14 in."), 14, 11, TRUE, EDITING_TOOLS_CROP_TOOL_COMPUTE_FROM_BASIS);
#line 757 "../src/editing_tools/EditingTools.vala"
	_vala_array_add19 (&_result_, &_result__length1, &__result__size_, _tmp15_);
#line 758 "../src/editing_tools/EditingTools.vala"
	_tmp16_ = editing_tools_crop_tool_constraint_description_new (_ ("Tabloid (11 × 17 in.)"), 17, 11, TRUE, EDITING_TOOLS_CROP_TOOL_COMPUTE_FROM_BASIS);
#line 758 "../src/editing_tools/EditingTools.vala"
	_vala_array_add20 (&_result_, &_result__length1, &__result__size_, _tmp16_);
#line 759 "../src/editing_tools/EditingTools.vala"
	_tmp17_ = editing_tools_crop_tool_constraint_description_new (_ ("16 × 20 in."), 20, 16, TRUE, EDITING_TOOLS_CROP_TOOL_COMPUTE_FROM_BASIS);
#line 759 "../src/editing_tools/EditingTools.vala"
	_vala_array_add21 (&_result_, &_result__length1, &__result__size_, _tmp17_);
#line 760 "../src/editing_tools/EditingTools.vala"
	_tmp18_ = editing_tools_crop_tool_constraint_description_new (_ ("-"), 0, 0, FALSE, EDITING_TOOLS_CROP_TOOL_SEPARATOR);
#line 760 "../src/editing_tools/EditingTools.vala"
	_vala_array_add22 (&_result_, &_result__length1, &__result__size_, _tmp18_);
#line 761 "../src/editing_tools/EditingTools.vala"
	_tmp19_ = editing_tools_crop_tool_constraint_description_new (_ ("Metric Wallet (9 × 13 cm)"), 13, 9, TRUE, EDITING_TOOLS_CROP_TOOL_COMPUTE_FROM_BASIS);
#line 761 "../src/editing_tools/EditingTools.vala"
	_vala_array_add23 (&_result_, &_result__length1, &__result__size_, _tmp19_);
#line 762 "../src/editing_tools/EditingTools.vala"
	_tmp20_ = editing_tools_crop_tool_constraint_description_new (_ ("Postcard (10 × 15 cm)"), 15, 10, TRUE, EDITING_TOOLS_CROP_TOOL_COMPUTE_FROM_BASIS);
#line 762 "../src/editing_tools/EditingTools.vala"
	_vala_array_add24 (&_result_, &_result__length1, &__result__size_, _tmp20_);
#line 763 "../src/editing_tools/EditingTools.vala"
	_tmp21_ = editing_tools_crop_tool_constraint_description_new (_ ("13 × 18 cm"), 18, 13, TRUE, EDITING_TOOLS_CROP_TOOL_COMPUTE_FROM_BASIS);
#line 763 "../src/editing_tools/EditingTools.vala"
	_vala_array_add25 (&_result_, &_result__length1, &__result__size_, _tmp21_);
#line 764 "../src/editing_tools/EditingTools.vala"
	_tmp22_ = editing_tools_crop_tool_constraint_description_new (_ ("18 × 24 cm"), 24, 18, TRUE, EDITING_TOOLS_CROP_TOOL_COMPUTE_FROM_BASIS);
#line 764 "../src/editing_tools/EditingTools.vala"
	_vala_array_add26 (&_result_, &_result__length1, &__result__size_, _tmp22_);
#line 765 "../src/editing_tools/EditingTools.vala"
	_tmp23_ = editing_tools_crop_tool_constraint_description_new (_ ("A4 (210 × 297 mm)"), 210, 297, TRUE, EDITING_TOOLS_CROP_TOOL_COMPUTE_FROM_BASIS);
#line 765 "../src/editing_tools/EditingTools.vala"
	_vala_array_add27 (&_result_, &_result__length1, &__result__size_, _tmp23_);
#line 766 "../src/editing_tools/EditingTools.vala"
	_tmp24_ = editing_tools_crop_tool_constraint_description_new (_ ("20 × 30 cm"), 30, 20, TRUE, EDITING_TOOLS_CROP_TOOL_COMPUTE_FROM_BASIS);
#line 766 "../src/editing_tools/EditingTools.vala"
	_vala_array_add28 (&_result_, &_result__length1, &__result__size_, _tmp24_);
#line 767 "../src/editing_tools/EditingTools.vala"
	_tmp25_ = editing_tools_crop_tool_constraint_description_new (_ ("24 × 40 cm"), 40, 24, TRUE, EDITING_TOOLS_CROP_TOOL_COMPUTE_FROM_BASIS);
#line 767 "../src/editing_tools/EditingTools.vala"
	_vala_array_add29 (&_result_, &_result__length1, &__result__size_, _tmp25_);
#line 768 "../src/editing_tools/EditingTools.vala"
	_tmp26_ = editing_tools_crop_tool_constraint_description_new (_ ("30 × 40 cm"), 40, 30, TRUE, EDITING_TOOLS_CROP_TOOL_COMPUTE_FROM_BASIS);
#line 768 "../src/editing_tools/EditingTools.vala"
	_vala_array_add30 (&_result_, &_result__length1, &__result__size_, _tmp26_);
#line 769 "../src/editing_tools/EditingTools.vala"
	_tmp27_ = editing_tools_crop_tool_constraint_description_new (_ ("A3 (297 × 420 mm)"), 420, 297, TRUE, EDITING_TOOLS_CROP_TOOL_COMPUTE_FROM_BASIS);
#line 769 "../src/editing_tools/EditingTools.vala"
	_vala_array_add31 (&_result_, &_result__length1, &__result__size_, _tmp27_);
#line 770 "../src/editing_tools/EditingTools.vala"
	_tmp28_ = editing_tools_crop_tool_constraint_description_new (_ ("-"), 0, 0, FALSE, EDITING_TOOLS_CROP_TOOL_SEPARATOR);
#line 770 "../src/editing_tools/EditingTools.vala"
	_vala_array_add32 (&_result_, &_result__length1, &__result__size_, _tmp28_);
#line 771 "../src/editing_tools/EditingTools.vala"
	_tmp29_ = editing_tools_crop_tool_constraint_description_new (_ ("Custom"), 0, 0, TRUE, EDITING_TOOLS_CROP_TOOL_CUSTOM_ASPECT_RATIO);
#line 771 "../src/editing_tools/EditingTools.vala"
	_vala_array_add33 (&_result_, &_result__length1, &__result__size_, _tmp29_);
#line 773 "../src/editing_tools/EditingTools.vala"
	_tmp30_ = _result_;
#line 773 "../src/editing_tools/EditingTools.vala"
	_tmp30__length1 = _result__length1;
#line 773 "../src/editing_tools/EditingTools.vala"
	if (result_length1) {
#line 773 "../src/editing_tools/EditingTools.vala"
		*result_length1 = _tmp30__length1;
#line 6000 "EditingTools.c"
	}
#line 773 "../src/editing_tools/EditingTools.vala"
	result = _tmp30_;
#line 773 "../src/editing_tools/EditingTools.vala"
	return result;
#line 6006 "EditingTools.c"
}

static gpointer
_editing_tools_crop_tool_constraint_description_ref0 (gpointer self)
{
#line 780 "../src/editing_tools/EditingTools.vala"
	return self ? editing_tools_crop_tool_constraint_description_ref (self) : NULL;
#line 6014 "EditingTools.c"
}

static GtkListStore*
editing_tools_crop_tool_create_constraint_list (EditingToolsCropToolConstraintDescription** constraint_data,
                                                gint constraint_data_length1)
{
	GtkListStore* _result_ = NULL;
	GtkListStore* _tmp0_;
	GtkTreeIter iter = {0};
	GtkListStore* result;
#line 777 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = gtk_list_store_new (1, G_TYPE_STRING, G_TYPE_STRING, -1);
#line 777 "../src/editing_tools/EditingTools.vala"
	_result_ = _tmp0_;
#line 6029 "EditingTools.c"
	{
		EditingToolsCropToolConstraintDescription** constraint_collection = NULL;
		gint constraint_collection_length1 = 0;
		gint _constraint_collection_size_ = 0;
		gint constraint_it = 0;
#line 780 "../src/editing_tools/EditingTools.vala"
		constraint_collection = constraint_data;
#line 780 "../src/editing_tools/EditingTools.vala"
		constraint_collection_length1 = constraint_data_length1;
#line 780 "../src/editing_tools/EditingTools.vala"
		for (constraint_it = 0; constraint_it < constraint_collection_length1; constraint_it = constraint_it + 1) {
#line 6041 "EditingTools.c"
			EditingToolsCropToolConstraintDescription* _tmp1_;
			EditingToolsCropToolConstraintDescription* constraint = NULL;
#line 780 "../src/editing_tools/EditingTools.vala"
			_tmp1_ = _editing_tools_crop_tool_constraint_description_ref0 (constraint_collection[constraint_it]);
#line 780 "../src/editing_tools/EditingTools.vala"
			constraint = _tmp1_;
#line 6048 "EditingTools.c"
			{
				GtkListStore* _tmp2_;
				GtkTreeIter _tmp3_ = {0};
				GtkListStore* _tmp4_;
				GtkTreeIter _tmp5_;
				EditingToolsCropToolConstraintDescription* _tmp6_;
				const gchar* _tmp7_;
				GValue _tmp8_ = {0};
#line 781 "../src/editing_tools/EditingTools.vala"
				_tmp2_ = _result_;
#line 781 "../src/editing_tools/EditingTools.vala"
				gtk_list_store_append (_tmp2_, &_tmp3_);
#line 781 "../src/editing_tools/EditingTools.vala"
				iter = _tmp3_;
#line 782 "../src/editing_tools/EditingTools.vala"
				_tmp4_ = _result_;
#line 782 "../src/editing_tools/EditingTools.vala"
				_tmp5_ = iter;
#line 782 "../src/editing_tools/EditingTools.vala"
				_tmp6_ = constraint;
#line 782 "../src/editing_tools/EditingTools.vala"
				_tmp7_ = _tmp6_->name;
#line 782 "../src/editing_tools/EditingTools.vala"
				g_value_init (&_tmp8_, G_TYPE_STRING);
#line 782 "../src/editing_tools/EditingTools.vala"
				g_value_set_string (&_tmp8_, _tmp7_);
#line 782 "../src/editing_tools/EditingTools.vala"
				gtk_list_store_set_value (_tmp4_, &_tmp5_, 0, &_tmp8_);
#line 782 "../src/editing_tools/EditingTools.vala"
				G_IS_VALUE (&_tmp8_) ? (g_value_unset (&_tmp8_), NULL) : NULL;
#line 780 "../src/editing_tools/EditingTools.vala"
				_editing_tools_crop_tool_constraint_description_unref0 (constraint);
#line 6081 "EditingTools.c"
			}
		}
	}
#line 785 "../src/editing_tools/EditingTools.vala"
	result = _result_;
#line 785 "../src/editing_tools/EditingTools.vala"
	return result;
#line 6089 "EditingTools.c"
}

static void
editing_tools_crop_tool_update_pivot_button_state (EditingToolsCropTool* self)
{
	EditingToolsCropToolCropToolWindow* _tmp0_;
	GtkButton* _tmp1_;
	EditingToolsCropToolConstraintDescription* _tmp2_;
	EditingToolsCropToolConstraintDescription* _tmp3_;
#line 788 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_CROP_TOOL (self));
#line 789 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->crop_tool_window;
#line 789 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = _tmp0_->pivot_reticle_button;
#line 789 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = editing_tools_crop_tool_get_selected_constraint (self);
#line 789 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = _tmp2_;
#line 789 "../src/editing_tools/EditingTools.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_widget_get_type (), GtkWidget), _tmp3_->is_pivotable);
#line 789 "../src/editing_tools/EditingTools.vala"
	_editing_tools_crop_tool_constraint_description_unref0 (_tmp3_);
#line 6113 "EditingTools.c"
}

static EditingToolsCropToolConstraintDescription*
editing_tools_crop_tool_get_selected_constraint (EditingToolsCropTool* self)
{
	EditingToolsCropToolConstraintDescription* _result_ = NULL;
	EditingToolsCropToolConstraintDescription** _tmp0_;
	gint _tmp0__length1;
	EditingToolsCropToolCropToolWindow* _tmp1_;
	GtkComboBox* _tmp2_;
	EditingToolsCropToolConstraintDescription* _tmp3_;
	EditingToolsCropToolConstraintDescription* _tmp4_;
	EditingToolsCropToolConstraintDescription* _tmp5_;
	EditingToolsCropToolConstraintDescription* result;
#line 793 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (EDITING_TOOLS_IS_CROP_TOOL (self), NULL);
#line 794 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->constraints;
#line 794 "../src/editing_tools/EditingTools.vala"
	_tmp0__length1 = self->priv->constraints_length1;
#line 794 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = self->priv->crop_tool_window;
#line 794 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = _tmp1_->constraint_combo;
#line 794 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = _tmp0_[gtk_combo_box_get_active (_tmp2_)];
#line 794 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = _editing_tools_crop_tool_constraint_description_ref0 (_tmp3_);
#line 794 "../src/editing_tools/EditingTools.vala"
	_result_ = _tmp4_;
#line 796 "../src/editing_tools/EditingTools.vala"
	_tmp5_ = _result_;
#line 796 "../src/editing_tools/EditingTools.vala"
	if (_tmp5_->aspect_ratio == EDITING_TOOLS_CROP_TOOL_ORIGINAL_ASPECT_RATIO) {
#line 6148 "EditingTools.c"
		EditingToolsCropToolConstraintDescription* _tmp6_;
		EditingToolsPhotoCanvas* _tmp7_;
		GdkRectangle _tmp8_ = {0};
		EditingToolsCropToolConstraintDescription* _tmp9_;
		EditingToolsPhotoCanvas* _tmp10_;
		GdkRectangle _tmp11_ = {0};
#line 797 "../src/editing_tools/EditingTools.vala"
		_tmp6_ = _result_;
#line 797 "../src/editing_tools/EditingTools.vala"
		_tmp7_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 797 "../src/editing_tools/EditingTools.vala"
		editing_tools_photo_canvas_get_scaled_pixbuf_position (_tmp7_, &_tmp8_);
#line 797 "../src/editing_tools/EditingTools.vala"
		_tmp6_->basis_width = _tmp8_.width;
#line 798 "../src/editing_tools/EditingTools.vala"
		_tmp9_ = _result_;
#line 798 "../src/editing_tools/EditingTools.vala"
		_tmp10_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 798 "../src/editing_tools/EditingTools.vala"
		editing_tools_photo_canvas_get_scaled_pixbuf_position (_tmp10_, &_tmp11_);
#line 798 "../src/editing_tools/EditingTools.vala"
		_tmp9_->basis_height = _tmp11_.height;
#line 6171 "EditingTools.c"
	} else {
		EditingToolsCropToolConstraintDescription* _tmp12_;
#line 799 "../src/editing_tools/EditingTools.vala"
		_tmp12_ = _result_;
#line 799 "../src/editing_tools/EditingTools.vala"
		if (_tmp12_->aspect_ratio == EDITING_TOOLS_CROP_TOOL_SCREEN_ASPECT_RATIO) {
#line 6178 "EditingTools.c"
			Dimensions dim = {0};
			AppWindow* _tmp13_;
			AppWindow* _tmp14_;
			Dimensions _tmp15_ = {0};
			Dimensions _tmp16_;
			EditingToolsCropToolConstraintDescription* _tmp17_;
			Dimensions _tmp18_;
			EditingToolsCropToolConstraintDescription* _tmp19_;
			Dimensions _tmp20_;
#line 800 "../src/editing_tools/EditingTools.vala"
			_tmp13_ = app_window_get_instance ();
#line 800 "../src/editing_tools/EditingTools.vala"
			_tmp14_ = _tmp13_;
#line 800 "../src/editing_tools/EditingTools.vala"
			scaling_get_screen_dimensions (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, gtk_window_get_type (), GtkWindow), &_tmp15_);
#line 800 "../src/editing_tools/EditingTools.vala"
			_tmp16_ = _tmp15_;
#line 800 "../src/editing_tools/EditingTools.vala"
			_g_object_unref0 (_tmp14_);
#line 800 "../src/editing_tools/EditingTools.vala"
			dim = _tmp16_;
#line 801 "../src/editing_tools/EditingTools.vala"
			_tmp17_ = _result_;
#line 801 "../src/editing_tools/EditingTools.vala"
			_tmp18_ = dim;
#line 801 "../src/editing_tools/EditingTools.vala"
			_tmp17_->basis_width = _tmp18_.width;
#line 802 "../src/editing_tools/EditingTools.vala"
			_tmp19_ = _result_;
#line 802 "../src/editing_tools/EditingTools.vala"
			_tmp20_ = dim;
#line 802 "../src/editing_tools/EditingTools.vala"
			_tmp19_->basis_height = _tmp20_.height;
#line 6212 "EditingTools.c"
		}
	}
#line 805 "../src/editing_tools/EditingTools.vala"
	result = _result_;
#line 805 "../src/editing_tools/EditingTools.vala"
	return result;
#line 6219 "EditingTools.c"
}

static gboolean
editing_tools_crop_tool_on_width_entry_focus_out (EditingToolsCropTool* self,
                                                  GdkEventFocus* event)
{
	EditingToolsCropToolCropToolWindow* _tmp0_;
	EditingToolsCropToolCropToolWindow* _tmp1_;
	GtkEntry* _tmp2_;
	GtkEntry* _tmp3_;
	gboolean result;
#line 808 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (EDITING_TOOLS_IS_CROP_TOOL (self), FALSE);
#line 808 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 809 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->crop_tool_window;
#line 809 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = self->priv->crop_tool_window;
#line 809 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = _tmp1_->custom_width_entry;
#line 809 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 809 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (_tmp0_->most_recently_edited);
#line 809 "../src/editing_tools/EditingTools.vala"
	_tmp0_->most_recently_edited = _tmp3_;
#line 810 "../src/editing_tools/EditingTools.vala"
	result = editing_tools_crop_tool_on_custom_entry_focus_out (self, event);
#line 810 "../src/editing_tools/EditingTools.vala"
	return result;
#line 6251 "EditingTools.c"
}

static gboolean
editing_tools_crop_tool_on_height_entry_focus_out (EditingToolsCropTool* self,
                                                   GdkEventFocus* event)
{
	EditingToolsCropToolCropToolWindow* _tmp0_;
	EditingToolsCropToolCropToolWindow* _tmp1_;
	GtkEntry* _tmp2_;
	GtkEntry* _tmp3_;
	gboolean result;
#line 813 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (EDITING_TOOLS_IS_CROP_TOOL (self), FALSE);
#line 813 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 814 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->crop_tool_window;
#line 814 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = self->priv->crop_tool_window;
#line 814 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = _tmp1_->custom_height_entry;
#line 814 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 814 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (_tmp0_->most_recently_edited);
#line 814 "../src/editing_tools/EditingTools.vala"
	_tmp0_->most_recently_edited = _tmp3_;
#line 815 "../src/editing_tools/EditingTools.vala"
	result = editing_tools_crop_tool_on_custom_entry_focus_out (self, event);
#line 815 "../src/editing_tools/EditingTools.vala"
	return result;
#line 6283 "EditingTools.c"
}

static gboolean
editing_tools_crop_tool_on_custom_entry_focus_out (EditingToolsCropTool* self,
                                                   GdkEventFocus* event)
{
	gint width = 0;
	EditingToolsCropToolCropToolWindow* _tmp0_;
	GtkEntry* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint height = 0;
	EditingToolsCropToolCropToolWindow* _tmp4_;
	GtkEntry* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gboolean _tmp16_ = FALSE;
	Box new_crop = {0};
	Box _tmp41_;
	Box _tmp42_ = {0};
	Box _tmp43_;
	Box _tmp44_;
	EditingToolsPhotoCanvas* _tmp45_;
	Box _tmp46_;
	EditingToolsPhotoCanvas* _tmp47_;
	gboolean result;
#line 818 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (EDITING_TOOLS_IS_CROP_TOOL (self), FALSE);
#line 818 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 819 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->crop_tool_window;
#line 819 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = _tmp0_->custom_width_entry;
#line 819 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = gtk_entry_get_text (_tmp1_);
#line 819 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = _tmp2_;
#line 819 "../src/editing_tools/EditingTools.vala"
	width = atoi (_tmp3_);
#line 820 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = self->priv->crop_tool_window;
#line 820 "../src/editing_tools/EditingTools.vala"
	_tmp5_ = _tmp4_->custom_height_entry;
#line 820 "../src/editing_tools/EditingTools.vala"
	_tmp6_ = gtk_entry_get_text (_tmp5_);
#line 820 "../src/editing_tools/EditingTools.vala"
	_tmp7_ = _tmp6_;
#line 820 "../src/editing_tools/EditingTools.vala"
	height = atoi (_tmp7_);
#line 822 "../src/editing_tools/EditingTools.vala"
	if (width < 1) {
#line 6336 "EditingTools.c"
		EditingToolsCropToolCropToolWindow* _tmp8_;
		GtkEntry* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 823 "../src/editing_tools/EditingTools.vala"
		width = 1;
#line 824 "../src/editing_tools/EditingTools.vala"
		_tmp8_ = self->priv->crop_tool_window;
#line 824 "../src/editing_tools/EditingTools.vala"
		_tmp9_ = _tmp8_->custom_width_entry;
#line 824 "../src/editing_tools/EditingTools.vala"
		_tmp10_ = g_strdup_printf ("%d", width);
#line 824 "../src/editing_tools/EditingTools.vala"
		_tmp11_ = _tmp10_;
#line 824 "../src/editing_tools/EditingTools.vala"
		gtk_entry_set_text (_tmp9_, _tmp11_);
#line 824 "../src/editing_tools/EditingTools.vala"
		_g_free0 (_tmp11_);
#line 6355 "EditingTools.c"
	}
#line 827 "../src/editing_tools/EditingTools.vala"
	if (height < 1) {
#line 6359 "EditingTools.c"
		EditingToolsCropToolCropToolWindow* _tmp12_;
		GtkEntry* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
#line 828 "../src/editing_tools/EditingTools.vala"
		height = 1;
#line 829 "../src/editing_tools/EditingTools.vala"
		_tmp12_ = self->priv->crop_tool_window;
#line 829 "../src/editing_tools/EditingTools.vala"
		_tmp13_ = _tmp12_->custom_height_entry;
#line 829 "../src/editing_tools/EditingTools.vala"
		_tmp14_ = g_strdup_printf ("%d", height);
#line 829 "../src/editing_tools/EditingTools.vala"
		_tmp15_ = _tmp14_;
#line 829 "../src/editing_tools/EditingTools.vala"
		gtk_entry_set_text (_tmp13_, _tmp15_);
#line 829 "../src/editing_tools/EditingTools.vala"
		_g_free0 (_tmp15_);
#line 6378 "EditingTools.c"
	}
#line 832 "../src/editing_tools/EditingTools.vala"
	if (width == self->priv->custom_width) {
#line 832 "../src/editing_tools/EditingTools.vala"
		_tmp16_ = height == self->priv->custom_height;
#line 6384 "EditingTools.c"
	} else {
#line 832 "../src/editing_tools/EditingTools.vala"
		_tmp16_ = FALSE;
#line 6388 "EditingTools.c"
	}
#line 832 "../src/editing_tools/EditingTools.vala"
	if (_tmp16_) {
#line 833 "../src/editing_tools/EditingTools.vala"
		result = FALSE;
#line 833 "../src/editing_tools/EditingTools.vala"
		return result;
#line 6396 "EditingTools.c"
	}
#line 835 "../src/editing_tools/EditingTools.vala"
	self->priv->custom_aspect_ratio = ((gfloat) width) / ((gfloat) height);
#line 837 "../src/editing_tools/EditingTools.vala"
	if (self->priv->custom_aspect_ratio < EDITING_TOOLS_CROP_TOOL_MIN_ASPECT_RATIO) {
#line 6402 "EditingTools.c"
		EditingToolsCropToolCropToolWindow* _tmp17_;
		GtkEntry* _tmp18_;
		EditingToolsCropToolCropToolWindow* _tmp19_;
		GtkEntry* _tmp20_;
#line 838 "../src/editing_tools/EditingTools.vala"
		_tmp17_ = self->priv->crop_tool_window;
#line 838 "../src/editing_tools/EditingTools.vala"
		_tmp18_ = _tmp17_->most_recently_edited;
#line 838 "../src/editing_tools/EditingTools.vala"
		_tmp19_ = self->priv->crop_tool_window;
#line 838 "../src/editing_tools/EditingTools.vala"
		_tmp20_ = _tmp19_->custom_height_entry;
#line 838 "../src/editing_tools/EditingTools.vala"
		if (_tmp18_ == _tmp20_) {
#line 6417 "EditingTools.c"
			EditingToolsCropToolCropToolWindow* _tmp21_;
			GtkEntry* _tmp22_;
			gchar* _tmp23_;
			gchar* _tmp24_;
#line 839 "../src/editing_tools/EditingTools.vala"
			height = (gint) (width / EDITING_TOOLS_CROP_TOOL_MIN_ASPECT_RATIO);
#line 840 "../src/editing_tools/EditingTools.vala"
			_tmp21_ = self->priv->crop_tool_window;
#line 840 "../src/editing_tools/EditingTools.vala"
			_tmp22_ = _tmp21_->custom_height_entry;
#line 840 "../src/editing_tools/EditingTools.vala"
			_tmp23_ = g_strdup_printf ("%d", height);
#line 840 "../src/editing_tools/EditingTools.vala"
			_tmp24_ = _tmp23_;
#line 840 "../src/editing_tools/EditingTools.vala"
			gtk_entry_set_text (_tmp22_, _tmp24_);
#line 840 "../src/editing_tools/EditingTools.vala"
			_g_free0 (_tmp24_);
#line 6436 "EditingTools.c"
		} else {
			EditingToolsCropToolCropToolWindow* _tmp25_;
			GtkEntry* _tmp26_;
			gchar* _tmp27_;
			gchar* _tmp28_;
#line 842 "../src/editing_tools/EditingTools.vala"
			width = (gint) (height * EDITING_TOOLS_CROP_TOOL_MIN_ASPECT_RATIO);
#line 843 "../src/editing_tools/EditingTools.vala"
			_tmp25_ = self->priv->crop_tool_window;
#line 843 "../src/editing_tools/EditingTools.vala"
			_tmp26_ = _tmp25_->custom_width_entry;
#line 843 "../src/editing_tools/EditingTools.vala"
			_tmp27_ = g_strdup_printf ("%d", width);
#line 843 "../src/editing_tools/EditingTools.vala"
			_tmp28_ = _tmp27_;
#line 843 "../src/editing_tools/EditingTools.vala"
			gtk_entry_set_text (_tmp26_, _tmp28_);
#line 843 "../src/editing_tools/EditingTools.vala"
			_g_free0 (_tmp28_);
#line 6456 "EditingTools.c"
		}
	} else {
#line 845 "../src/editing_tools/EditingTools.vala"
		if (self->priv->custom_aspect_ratio > EDITING_TOOLS_CROP_TOOL_MAX_ASPECT_RATIO) {
#line 6461 "EditingTools.c"
			EditingToolsCropToolCropToolWindow* _tmp29_;
			GtkEntry* _tmp30_;
			EditingToolsCropToolCropToolWindow* _tmp31_;
			GtkEntry* _tmp32_;
#line 846 "../src/editing_tools/EditingTools.vala"
			_tmp29_ = self->priv->crop_tool_window;
#line 846 "../src/editing_tools/EditingTools.vala"
			_tmp30_ = _tmp29_->most_recently_edited;
#line 846 "../src/editing_tools/EditingTools.vala"
			_tmp31_ = self->priv->crop_tool_window;
#line 846 "../src/editing_tools/EditingTools.vala"
			_tmp32_ = _tmp31_->custom_height_entry;
#line 846 "../src/editing_tools/EditingTools.vala"
			if (_tmp30_ == _tmp32_) {
#line 6476 "EditingTools.c"
				EditingToolsCropToolCropToolWindow* _tmp33_;
				GtkEntry* _tmp34_;
				gchar* _tmp35_;
				gchar* _tmp36_;
#line 847 "../src/editing_tools/EditingTools.vala"
				height = (gint) (width / EDITING_TOOLS_CROP_TOOL_MAX_ASPECT_RATIO);
#line 848 "../src/editing_tools/EditingTools.vala"
				_tmp33_ = self->priv->crop_tool_window;
#line 848 "../src/editing_tools/EditingTools.vala"
				_tmp34_ = _tmp33_->custom_height_entry;
#line 848 "../src/editing_tools/EditingTools.vala"
				_tmp35_ = g_strdup_printf ("%d", height);
#line 848 "../src/editing_tools/EditingTools.vala"
				_tmp36_ = _tmp35_;
#line 848 "../src/editing_tools/EditingTools.vala"
				gtk_entry_set_text (_tmp34_, _tmp36_);
#line 848 "../src/editing_tools/EditingTools.vala"
				_g_free0 (_tmp36_);
#line 6495 "EditingTools.c"
			} else {
				EditingToolsCropToolCropToolWindow* _tmp37_;
				GtkEntry* _tmp38_;
				gchar* _tmp39_;
				gchar* _tmp40_;
#line 850 "../src/editing_tools/EditingTools.vala"
				width = (gint) (height * EDITING_TOOLS_CROP_TOOL_MAX_ASPECT_RATIO);
#line 851 "../src/editing_tools/EditingTools.vala"
				_tmp37_ = self->priv->crop_tool_window;
#line 851 "../src/editing_tools/EditingTools.vala"
				_tmp38_ = _tmp37_->custom_width_entry;
#line 851 "../src/editing_tools/EditingTools.vala"
				_tmp39_ = g_strdup_printf ("%d", width);
#line 851 "../src/editing_tools/EditingTools.vala"
				_tmp40_ = _tmp39_;
#line 851 "../src/editing_tools/EditingTools.vala"
				gtk_entry_set_text (_tmp38_, _tmp40_);
#line 851 "../src/editing_tools/EditingTools.vala"
				_g_free0 (_tmp40_);
#line 6515 "EditingTools.c"
			}
		}
	}
#line 855 "../src/editing_tools/EditingTools.vala"
	self->priv->custom_aspect_ratio = ((gfloat) width) / ((gfloat) height);
#line 857 "../src/editing_tools/EditingTools.vala"
	_tmp41_ = self->priv->scaled_crop;
#line 857 "../src/editing_tools/EditingTools.vala"
	editing_tools_crop_tool_constrain_crop (self, &_tmp41_, &_tmp42_);
#line 857 "../src/editing_tools/EditingTools.vala"
	new_crop = _tmp42_;
#line 859 "../src/editing_tools/EditingTools.vala"
	_tmp43_ = new_crop;
#line 859 "../src/editing_tools/EditingTools.vala"
	editing_tools_crop_tool_crop_resized (self, &_tmp43_);
#line 860 "../src/editing_tools/EditingTools.vala"
	_tmp44_ = new_crop;
#line 860 "../src/editing_tools/EditingTools.vala"
	self->priv->scaled_crop = _tmp44_;
#line 861 "../src/editing_tools/EditingTools.vala"
	_tmp45_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 861 "../src/editing_tools/EditingTools.vala"
	_tmp46_ = new_crop;
#line 861 "../src/editing_tools/EditingTools.vala"
	editing_tools_photo_canvas_invalidate_area (_tmp45_, &_tmp46_);
#line 862 "../src/editing_tools/EditingTools.vala"
	_tmp47_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 862 "../src/editing_tools/EditingTools.vala"
	editing_tools_photo_canvas_repaint (_tmp47_);
#line 864 "../src/editing_tools/EditingTools.vala"
	self->priv->custom_width = width;
#line 865 "../src/editing_tools/EditingTools.vala"
	self->priv->custom_height = height;
#line 867 "../src/editing_tools/EditingTools.vala"
	result = FALSE;
#line 867 "../src/editing_tools/EditingTools.vala"
	return result;
#line 6553 "EditingTools.c"
}

static void
editing_tools_crop_tool_on_width_insert_text (EditingToolsCropTool* self,
                                              const gchar* text,
                                              gint length,
                                              gint* position)
{
	EditingToolsCropToolCropToolWindow* _tmp0_;
	GtkEntry* _tmp1_;
#line 870 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_CROP_TOOL (self));
#line 870 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (text != NULL);
#line 871 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->crop_tool_window;
#line 871 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = _tmp0_->custom_width_entry;
#line 871 "../src/editing_tools/EditingTools.vala"
	editing_tools_crop_tool_on_entry_insert_text (self, _tmp1_, text, length, position);
#line 6574 "EditingTools.c"
}

static void
editing_tools_crop_tool_on_height_insert_text (EditingToolsCropTool* self,
                                               const gchar* text,
                                               gint length,
                                               gint* position)
{
	EditingToolsCropToolCropToolWindow* _tmp0_;
	GtkEntry* _tmp1_;
#line 874 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_CROP_TOOL (self));
#line 874 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (text != NULL);
#line 875 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->crop_tool_window;
#line 875 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = _tmp0_->custom_height_entry;
#line 875 "../src/editing_tools/EditingTools.vala"
	editing_tools_crop_tool_on_entry_insert_text (self, _tmp1_, text, length, position);
#line 6595 "EditingTools.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1240 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1241 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1241 "glib-2.0.vapi"
	result = _tmp0_;
#line 1241 "glib-2.0.vapi"
	return result;
#line 6612 "EditingTools.c"
}

static void
editing_tools_crop_tool_on_entry_insert_text (EditingToolsCropTool* self,
                                              GtkEntry* sender,
                                              const gchar* text,
                                              gint length,
                                              gint* position)
{
	gchar* new_text = NULL;
	gchar* _tmp2_;
	const gchar* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
#line 878 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_CROP_TOOL (self));
#line 878 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (sender, gtk_entry_get_type ()));
#line 878 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (text != NULL);
#line 879 "../src/editing_tools/EditingTools.vala"
	if (self->priv->entry_insert_in_progress) {
#line 880 "../src/editing_tools/EditingTools.vala"
		return;
#line 6637 "EditingTools.c"
	}
#line 882 "../src/editing_tools/EditingTools.vala"
	self->priv->entry_insert_in_progress = TRUE;
#line 884 "../src/editing_tools/EditingTools.vala"
	if (length == -1) {
#line 6643 "EditingTools.c"
		gint _tmp0_;
		gint _tmp1_;
#line 885 "../src/editing_tools/EditingTools.vala"
		_tmp0_ = strlen (text);
#line 885 "../src/editing_tools/EditingTools.vala"
		_tmp1_ = _tmp0_;
#line 885 "../src/editing_tools/EditingTools.vala"
		length = (gint) _tmp1_;
#line 6652 "EditingTools.c"
	}
#line 888 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = g_strdup ("");
#line 888 "../src/editing_tools/EditingTools.vala"
	new_text = _tmp2_;
#line 6658 "EditingTools.c"
	{
		gint ctr = 0;
#line 889 "../src/editing_tools/EditingTools.vala"
		ctr = 0;
#line 6663 "EditingTools.c"
		{
			gboolean _tmp3_ = FALSE;
#line 889 "../src/editing_tools/EditingTools.vala"
			_tmp3_ = TRUE;
#line 889 "../src/editing_tools/EditingTools.vala"
			while (TRUE) {
#line 889 "../src/editing_tools/EditingTools.vala"
				if (!_tmp3_) {
#line 6672 "EditingTools.c"
					gint _tmp4_;
#line 889 "../src/editing_tools/EditingTools.vala"
					_tmp4_ = ctr;
#line 889 "../src/editing_tools/EditingTools.vala"
					ctr = _tmp4_ + 1;
#line 6678 "EditingTools.c"
				}
#line 889 "../src/editing_tools/EditingTools.vala"
				_tmp3_ = FALSE;
#line 889 "../src/editing_tools/EditingTools.vala"
				if (!(ctr < length)) {
#line 889 "../src/editing_tools/EditingTools.vala"
					break;
#line 6686 "EditingTools.c"
				}
#line 890 "../src/editing_tools/EditingTools.vala"
				if (g_ascii_isdigit (string_get (text, (glong) ctr))) {
#line 6690 "EditingTools.c"
					const gchar* _tmp5_;
					gchar* _tmp6_;
					gchar* _tmp7_;
					gchar* _tmp8_;
#line 891 "../src/editing_tools/EditingTools.vala"
					_tmp5_ = new_text;
#line 891 "../src/editing_tools/EditingTools.vala"
					_tmp6_ = g_strdup_printf ("%c", (gchar) string_get (text, (glong) ctr));
#line 891 "../src/editing_tools/EditingTools.vala"
					_tmp7_ = _tmp6_;
#line 891 "../src/editing_tools/EditingTools.vala"
					_tmp8_ = g_strconcat (_tmp5_, _tmp7_, NULL);
#line 891 "../src/editing_tools/EditingTools.vala"
					_g_free0 (new_text);
#line 891 "../src/editing_tools/EditingTools.vala"
					new_text = _tmp8_;
#line 891 "../src/editing_tools/EditingTools.vala"
					_g_free0 (_tmp7_);
#line 6709 "EditingTools.c"
				}
			}
		}
	}
#line 895 "../src/editing_tools/EditingTools.vala"
	_tmp9_ = new_text;
#line 895 "../src/editing_tools/EditingTools.vala"
	_tmp10_ = strlen (_tmp9_);
#line 895 "../src/editing_tools/EditingTools.vala"
	_tmp11_ = _tmp10_;
#line 895 "../src/editing_tools/EditingTools.vala"
	if (_tmp11_ > 0) {
#line 6722 "EditingTools.c"
		const gchar* _tmp12_;
		const gchar* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
#line 896 "../src/editing_tools/EditingTools.vala"
		_tmp12_ = new_text;
#line 896 "../src/editing_tools/EditingTools.vala"
		_tmp13_ = new_text;
#line 896 "../src/editing_tools/EditingTools.vala"
		_tmp14_ = strlen (_tmp13_);
#line 896 "../src/editing_tools/EditingTools.vala"
		_tmp15_ = _tmp14_;
#line 896 "../src/editing_tools/EditingTools.vala"
		g_signal_emit_by_name (G_TYPE_CHECK_INSTANCE_CAST (sender, gtk_editable_get_type (), GtkEditable), "insert-text", _tmp12_, (gint) _tmp15_, position);
#line 6737 "EditingTools.c"
	}
#line 898 "../src/editing_tools/EditingTools.vala"
	g_signal_stop_emission_by_name (sender, "insert-text");
#line 900 "../src/editing_tools/EditingTools.vala"
	self->priv->entry_insert_in_progress = FALSE;
#line 878 "../src/editing_tools/EditingTools.vala"
	_g_free0 (new_text);
#line 6745 "EditingTools.c"
}

static gfloat
editing_tools_crop_tool_get_constraint_aspect_ratio (EditingToolsCropTool* self)
{
	gfloat _result_ = 0.0F;
	EditingToolsCropToolConstraintDescription* _tmp0_;
	EditingToolsCropToolConstraintDescription* _tmp1_;
	gfloat _tmp2_;
	gfloat result;
#line 903 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (EDITING_TOOLS_IS_CROP_TOOL (self), 0.0F);
#line 904 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = editing_tools_crop_tool_get_selected_constraint (self);
#line 904 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = _tmp0_;
#line 904 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = _tmp1_->aspect_ratio;
#line 904 "../src/editing_tools/EditingTools.vala"
	_editing_tools_crop_tool_constraint_description_unref0 (_tmp1_);
#line 904 "../src/editing_tools/EditingTools.vala"
	_result_ = _tmp2_;
#line 906 "../src/editing_tools/EditingTools.vala"
	if (_result_ == EDITING_TOOLS_CROP_TOOL_ORIGINAL_ASPECT_RATIO) {
#line 6770 "EditingTools.c"
		EditingToolsPhotoCanvas* _tmp3_;
		GdkRectangle _tmp4_ = {0};
		EditingToolsPhotoCanvas* _tmp5_;
		GdkRectangle _tmp6_ = {0};
#line 907 "../src/editing_tools/EditingTools.vala"
		_tmp3_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 907 "../src/editing_tools/EditingTools.vala"
		editing_tools_photo_canvas_get_scaled_pixbuf_position (_tmp3_, &_tmp4_);
#line 907 "../src/editing_tools/EditingTools.vala"
		_tmp5_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 907 "../src/editing_tools/EditingTools.vala"
		editing_tools_photo_canvas_get_scaled_pixbuf_position (_tmp5_, &_tmp6_);
#line 907 "../src/editing_tools/EditingTools.vala"
		_result_ = ((gfloat) _tmp4_.width) / ((gfloat) _tmp6_.height);
#line 6785 "EditingTools.c"
	} else {
#line 909 "../src/editing_tools/EditingTools.vala"
		if (_result_ == EDITING_TOOLS_CROP_TOOL_SCREEN_ASPECT_RATIO) {
#line 6789 "EditingTools.c"
			Dimensions dim = {0};
			AppWindow* _tmp7_;
			AppWindow* _tmp8_;
			Dimensions _tmp9_ = {0};
			Dimensions _tmp10_;
			Dimensions _tmp11_;
			Dimensions _tmp12_;
#line 910 "../src/editing_tools/EditingTools.vala"
			_tmp7_ = app_window_get_instance ();
#line 910 "../src/editing_tools/EditingTools.vala"
			_tmp8_ = _tmp7_;
#line 910 "../src/editing_tools/EditingTools.vala"
			scaling_get_screen_dimensions (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_window_get_type (), GtkWindow), &_tmp9_);
#line 910 "../src/editing_tools/EditingTools.vala"
			_tmp10_ = _tmp9_;
#line 910 "../src/editing_tools/EditingTools.vala"
			_g_object_unref0 (_tmp8_);
#line 910 "../src/editing_tools/EditingTools.vala"
			dim = _tmp10_;
#line 911 "../src/editing_tools/EditingTools.vala"
			_tmp11_ = dim;
#line 911 "../src/editing_tools/EditingTools.vala"
			_tmp12_ = dim;
#line 911 "../src/editing_tools/EditingTools.vala"
			_result_ = ((gfloat) _tmp11_.width) / ((gfloat) _tmp12_.height);
#line 6815 "EditingTools.c"
		} else {
#line 912 "../src/editing_tools/EditingTools.vala"
			if (_result_ == EDITING_TOOLS_CROP_TOOL_CUSTOM_ASPECT_RATIO) {
#line 913 "../src/editing_tools/EditingTools.vala"
				_result_ = self->priv->custom_aspect_ratio;
#line 6821 "EditingTools.c"
			}
		}
	}
#line 915 "../src/editing_tools/EditingTools.vala"
	if (self->priv->reticle_orientation == EDITING_TOOLS_CROP_TOOL_RETICLE_ORIENTATION_PORTRAIT) {
#line 916 "../src/editing_tools/EditingTools.vala"
		_result_ = 1.0f / _result_;
#line 6829 "EditingTools.c"
	}
#line 918 "../src/editing_tools/EditingTools.vala"
	result = _result_;
#line 918 "../src/editing_tools/EditingTools.vala"
	return result;
#line 6835 "EditingTools.c"
}

static gfloat
editing_tools_crop_tool_get_constraint_aspect_ratio_for_constraint (EditingToolsCropTool* self,
                                                                    EditingToolsCropToolConstraintDescription* constraint,
                                                                    Photo* photo)
{
	gfloat _result_ = 0.0F;
	gfloat result;
#line 921 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (EDITING_TOOLS_IS_CROP_TOOL (self), 0.0F);
#line 921 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (EDITING_TOOLS_CROP_TOOL_IS_CONSTRAINT_DESCRIPTION (constraint), 0.0F);
#line 921 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (IS_PHOTO (photo), 0.0F);
#line 922 "../src/editing_tools/EditingTools.vala"
	_result_ = constraint->aspect_ratio;
#line 924 "../src/editing_tools/EditingTools.vala"
	if (_result_ == EDITING_TOOLS_CROP_TOOL_ORIGINAL_ASPECT_RATIO) {
#line 6855 "EditingTools.c"
		Dimensions orig_dim = {0};
		Dimensions _tmp0_ = {0};
		Dimensions _tmp1_;
		Dimensions _tmp2_;
#line 925 "../src/editing_tools/EditingTools.vala"
		photo_get_original_dimensions (photo, &_tmp0_);
#line 925 "../src/editing_tools/EditingTools.vala"
		orig_dim = _tmp0_;
#line 926 "../src/editing_tools/EditingTools.vala"
		_tmp1_ = orig_dim;
#line 926 "../src/editing_tools/EditingTools.vala"
		_tmp2_ = orig_dim;
#line 926 "../src/editing_tools/EditingTools.vala"
		_result_ = ((gfloat) _tmp1_.width) / ((gfloat) _tmp2_.height);
#line 6870 "EditingTools.c"
	} else {
#line 927 "../src/editing_tools/EditingTools.vala"
		if (_result_ == EDITING_TOOLS_CROP_TOOL_SCREEN_ASPECT_RATIO) {
#line 6874 "EditingTools.c"
			Dimensions dim = {0};
			AppWindow* _tmp3_;
			AppWindow* _tmp4_;
			Dimensions _tmp5_ = {0};
			Dimensions _tmp6_;
			Dimensions _tmp7_;
			Dimensions _tmp8_;
#line 928 "../src/editing_tools/EditingTools.vala"
			_tmp3_ = app_window_get_instance ();
#line 928 "../src/editing_tools/EditingTools.vala"
			_tmp4_ = _tmp3_;
#line 928 "../src/editing_tools/EditingTools.vala"
			scaling_get_screen_dimensions (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_window_get_type (), GtkWindow), &_tmp5_);
#line 928 "../src/editing_tools/EditingTools.vala"
			_tmp6_ = _tmp5_;
#line 928 "../src/editing_tools/EditingTools.vala"
			_g_object_unref0 (_tmp4_);
#line 928 "../src/editing_tools/EditingTools.vala"
			dim = _tmp6_;
#line 929 "../src/editing_tools/EditingTools.vala"
			_tmp7_ = dim;
#line 929 "../src/editing_tools/EditingTools.vala"
			_tmp8_ = dim;
#line 929 "../src/editing_tools/EditingTools.vala"
			_result_ = ((gfloat) _tmp7_.width) / ((gfloat) _tmp8_.height);
#line 6900 "EditingTools.c"
		} else {
#line 930 "../src/editing_tools/EditingTools.vala"
			if (_result_ == EDITING_TOOLS_CROP_TOOL_CUSTOM_ASPECT_RATIO) {
#line 931 "../src/editing_tools/EditingTools.vala"
				_result_ = self->priv->custom_aspect_ratio;
#line 6906 "EditingTools.c"
			}
		}
	}
#line 933 "../src/editing_tools/EditingTools.vala"
	if (self->priv->reticle_orientation == EDITING_TOOLS_CROP_TOOL_RETICLE_ORIENTATION_PORTRAIT) {
#line 934 "../src/editing_tools/EditingTools.vala"
		_result_ = 1.0f / _result_;
#line 6914 "EditingTools.c"
	}
#line 936 "../src/editing_tools/EditingTools.vala"
	result = _result_;
#line 936 "../src/editing_tools/EditingTools.vala"
	return result;
#line 6920 "EditingTools.c"
}

static void
editing_tools_crop_tool_constraint_changed (EditingToolsCropTool* self)
{
	EditingToolsCropToolConstraintDescription* selected_constraint = NULL;
	EditingToolsCropToolConstraintDescription* _tmp0_;
	EditingToolsCropToolConstraintDescription* _tmp1_;
	EditingToolsCropToolConstraintDescription* _tmp7_;
	EditingToolsCropToolConstraintDescription* _tmp8_;
	gboolean _tmp9_;
#line 940 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_CROP_TOOL (self));
#line 941 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = editing_tools_crop_tool_get_selected_constraint (self);
#line 941 "../src/editing_tools/EditingTools.vala"
	selected_constraint = _tmp0_;
#line 942 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = selected_constraint;
#line 942 "../src/editing_tools/EditingTools.vala"
	if (_tmp1_->aspect_ratio == EDITING_TOOLS_CROP_TOOL_CUSTOM_ASPECT_RATIO) {
#line 943 "../src/editing_tools/EditingTools.vala"
		editing_tools_crop_tool_set_custom_constraint_mode (self);
#line 6944 "EditingTools.c"
	} else {
		EditingToolsCropToolConstraintDescription* _tmp2_;
#line 945 "../src/editing_tools/EditingTools.vala"
		editing_tools_crop_tool_set_normal_constraint_mode (self);
#line 947 "../src/editing_tools/EditingTools.vala"
		_tmp2_ = selected_constraint;
#line 947 "../src/editing_tools/EditingTools.vala"
		if (_tmp2_->aspect_ratio != EDITING_TOOLS_CROP_TOOL_ANY_ASPECT_RATIO) {
#line 6953 "EditingTools.c"
			ConfigFacade* _tmp3_;
			ConfigFacade* _tmp4_;
			ConfigFacade* _tmp5_;
			ConfigFacade* _tmp6_;
#line 951 "../src/editing_tools/EditingTools.vala"
			_tmp3_ = config_facade_get_instance ();
#line 951 "../src/editing_tools/EditingTools.vala"
			_tmp4_ = _tmp3_;
#line 951 "../src/editing_tools/EditingTools.vala"
			self->priv->custom_init_width = configuration_facade_get_last_crop_width (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_CONFIGURATION_FACADE, ConfigurationFacade));
#line 951 "../src/editing_tools/EditingTools.vala"
			_g_object_unref0 (_tmp4_);
#line 952 "../src/editing_tools/EditingTools.vala"
			_tmp5_ = config_facade_get_instance ();
#line 952 "../src/editing_tools/EditingTools.vala"
			_tmp6_ = _tmp5_;
#line 952 "../src/editing_tools/EditingTools.vala"
			self->priv->custom_init_height = configuration_facade_get_last_crop_height (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_CONFIGURATION_FACADE, ConfigurationFacade));
#line 952 "../src/editing_tools/EditingTools.vala"
			_g_object_unref0 (_tmp6_);
#line 953 "../src/editing_tools/EditingTools.vala"
			self->priv->custom_aspect_ratio = ((gfloat) self->priv->custom_init_width) / ((gfloat) self->priv->custom_init_height);
#line 6976 "EditingTools.c"
		}
	}
#line 957 "../src/editing_tools/EditingTools.vala"
	editing_tools_crop_tool_update_pivot_button_state (self);
#line 959 "../src/editing_tools/EditingTools.vala"
	_tmp7_ = editing_tools_crop_tool_get_selected_constraint (self);
#line 959 "../src/editing_tools/EditingTools.vala"
	_tmp8_ = _tmp7_;
#line 959 "../src/editing_tools/EditingTools.vala"
	_tmp9_ = !_tmp8_->is_pivotable;
#line 959 "../src/editing_tools/EditingTools.vala"
	_editing_tools_crop_tool_constraint_description_unref0 (_tmp8_);
#line 959 "../src/editing_tools/EditingTools.vala"
	if (_tmp9_) {
#line 960 "../src/editing_tools/EditingTools.vala"
		self->priv->reticle_orientation = EDITING_TOOLS_CROP_TOOL_RETICLE_ORIENTATION_LANDSCAPE;
#line 6993 "EditingTools.c"
	}
#line 962 "../src/editing_tools/EditingTools.vala"
	if (editing_tools_crop_tool_get_constraint_aspect_ratio (self) != self->priv->pre_aspect_ratio) {
#line 6997 "EditingTools.c"
		Box new_crop = {0};
		Box _tmp10_;
		Box _tmp11_ = {0};
		Box _tmp12_;
		Box _tmp13_;
		EditingToolsPhotoCanvas* _tmp14_;
		Box _tmp15_;
		EditingToolsPhotoCanvas* _tmp16_;
#line 963 "../src/editing_tools/EditingTools.vala"
		_tmp10_ = self->priv->scaled_crop;
#line 963 "../src/editing_tools/EditingTools.vala"
		editing_tools_crop_tool_constrain_crop (self, &_tmp10_, &_tmp11_);
#line 963 "../src/editing_tools/EditingTools.vala"
		new_crop = _tmp11_;
#line 965 "../src/editing_tools/EditingTools.vala"
		_tmp12_ = new_crop;
#line 965 "../src/editing_tools/EditingTools.vala"
		editing_tools_crop_tool_crop_resized (self, &_tmp12_);
#line 966 "../src/editing_tools/EditingTools.vala"
		_tmp13_ = new_crop;
#line 966 "../src/editing_tools/EditingTools.vala"
		self->priv->scaled_crop = _tmp13_;
#line 967 "../src/editing_tools/EditingTools.vala"
		_tmp14_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 967 "../src/editing_tools/EditingTools.vala"
		_tmp15_ = new_crop;
#line 967 "../src/editing_tools/EditingTools.vala"
		editing_tools_photo_canvas_invalidate_area (_tmp14_, &_tmp15_);
#line 968 "../src/editing_tools/EditingTools.vala"
		_tmp16_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 968 "../src/editing_tools/EditingTools.vala"
		editing_tools_photo_canvas_repaint (_tmp16_);
#line 970 "../src/editing_tools/EditingTools.vala"
		self->priv->pre_aspect_ratio = editing_tools_crop_tool_get_constraint_aspect_ratio (self);
#line 7032 "EditingTools.c"
	}
#line 940 "../src/editing_tools/EditingTools.vala"
	_editing_tools_crop_tool_constraint_description_unref0 (selected_constraint);
#line 7036 "EditingTools.c"
}

static void
editing_tools_crop_tool_set_custom_constraint_mode (EditingToolsCropTool* self)
{
	gboolean _tmp0_ = FALSE;
	EditingToolsCropToolCropToolWindow* _tmp1_;
	EditingToolsCropToolCropToolWindow* _tmp8_;
	GtkBox* _tmp9_;
	EditingToolsCropToolCropToolWindow* _tmp10_;
	GtkComboBox* _tmp11_;
	EditingToolsCropToolCropToolWindow* _tmp12_;
	GtkBox* _tmp13_;
	EditingToolsCropToolCropToolWindow* _tmp14_;
	GtkButton* _tmp15_;
	EditingToolsCropToolCropToolWindow* _tmp16_;
	GtkBox* _tmp17_;
	EditingToolsCropToolCropToolWindow* _tmp18_;
	GtkBox* _tmp19_;
	EditingToolsCropToolCropToolWindow* _tmp20_;
	GtkBox* _tmp21_;
	EditingToolsCropToolCropToolWindow* _tmp22_;
	GtkComboBox* _tmp23_;
	EditingToolsCropToolCropToolWindow* _tmp24_;
	GtkBox* _tmp25_;
	EditingToolsCropToolCropToolWindow* _tmp26_;
	GtkEntry* _tmp27_;
	EditingToolsCropToolCropToolWindow* _tmp28_;
	GtkBox* _tmp29_;
	EditingToolsCropToolCropToolWindow* _tmp30_;
	GtkLabel* _tmp31_;
	EditingToolsCropToolCropToolWindow* _tmp32_;
	GtkBox* _tmp33_;
	EditingToolsCropToolCropToolWindow* _tmp34_;
	GtkEntry* _tmp35_;
	EditingToolsCropToolCropToolWindow* _tmp36_;
	GtkBox* _tmp37_;
	EditingToolsCropToolCropToolWindow* _tmp38_;
	GtkButton* _tmp39_;
	EditingToolsCropToolCropToolWindow* _tmp40_;
	GtkBox* _tmp41_;
	EditingToolsCropToolCropToolWindow* _tmp42_;
	GtkBox* _tmp43_;
	EditingToolsCropToolCropToolWindow* _tmp60_;
#line 974 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_CROP_TOOL (self));
#line 975 "../src/editing_tools/EditingTools.vala"
	if (self->priv->constraint_mode == EDITING_TOOLS_CROP_TOOL_CONSTRAINT_MODE_CUSTOM) {
#line 976 "../src/editing_tools/EditingTools.vala"
		return;
#line 7087 "EditingTools.c"
	}
#line 978 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = self->priv->crop_tool_window;
#line 978 "../src/editing_tools/EditingTools.vala"
	if (_tmp1_->normal_width == -1) {
#line 978 "../src/editing_tools/EditingTools.vala"
		_tmp0_ = TRUE;
#line 7095 "EditingTools.c"
	} else {
		EditingToolsCropToolCropToolWindow* _tmp2_;
#line 978 "../src/editing_tools/EditingTools.vala"
		_tmp2_ = self->priv->crop_tool_window;
#line 978 "../src/editing_tools/EditingTools.vala"
		_tmp0_ = _tmp2_->normal_height == -1;
#line 7102 "EditingTools.c"
	}
#line 978 "../src/editing_tools/EditingTools.vala"
	if (_tmp0_) {
#line 7106 "EditingTools.c"
		EditingToolsCropToolCropToolWindow* _tmp3_;
		EditingToolsCropToolCropToolWindow* _tmp4_;
		EditingToolsCropToolCropToolWindow* _tmp5_;
		gint _tmp6_ = 0;
		gint _tmp7_ = 0;
#line 979 "../src/editing_tools/EditingTools.vala"
		_tmp3_ = self->priv->crop_tool_window;
#line 979 "../src/editing_tools/EditingTools.vala"
		_tmp4_ = self->priv->crop_tool_window;
#line 979 "../src/editing_tools/EditingTools.vala"
		_tmp5_ = self->priv->crop_tool_window;
#line 979 "../src/editing_tools/EditingTools.vala"
		gtk_window_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_window_get_type (), GtkWindow), &_tmp6_, &_tmp7_);
#line 979 "../src/editing_tools/EditingTools.vala"
		_tmp4_->normal_width = _tmp6_;
#line 979 "../src/editing_tools/EditingTools.vala"
		_tmp5_->normal_height = _tmp7_;
#line 7124 "EditingTools.c"
	}
#line 982 "../src/editing_tools/EditingTools.vala"
	_tmp8_ = self->priv->crop_tool_window;
#line 982 "../src/editing_tools/EditingTools.vala"
	_tmp9_ = _tmp8_->layout;
#line 982 "../src/editing_tools/EditingTools.vala"
	_tmp10_ = self->priv->crop_tool_window;
#line 982 "../src/editing_tools/EditingTools.vala"
	_tmp11_ = _tmp10_->constraint_combo;
#line 982 "../src/editing_tools/EditingTools.vala"
	gtk_container_remove (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, gtk_widget_get_type (), GtkWidget));
#line 983 "../src/editing_tools/EditingTools.vala"
	_tmp12_ = self->priv->crop_tool_window;
#line 983 "../src/editing_tools/EditingTools.vala"
	_tmp13_ = _tmp12_->layout;
#line 983 "../src/editing_tools/EditingTools.vala"
	_tmp14_ = self->priv->crop_tool_window;
#line 983 "../src/editing_tools/EditingTools.vala"
	_tmp15_ = _tmp14_->pivot_reticle_button;
#line 983 "../src/editing_tools/EditingTools.vala"
	gtk_container_remove (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, gtk_widget_get_type (), GtkWidget));
#line 984 "../src/editing_tools/EditingTools.vala"
	_tmp16_ = self->priv->crop_tool_window;
#line 984 "../src/editing_tools/EditingTools.vala"
	_tmp17_ = _tmp16_->layout;
#line 984 "../src/editing_tools/EditingTools.vala"
	_tmp18_ = self->priv->crop_tool_window;
#line 984 "../src/editing_tools/EditingTools.vala"
	_tmp19_ = _tmp18_->response_layout;
#line 984 "../src/editing_tools/EditingTools.vala"
	gtk_container_remove (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, gtk_widget_get_type (), GtkWidget));
#line 986 "../src/editing_tools/EditingTools.vala"
	_tmp20_ = self->priv->crop_tool_window;
#line 986 "../src/editing_tools/EditingTools.vala"
	_tmp21_ = _tmp20_->layout;
#line 986 "../src/editing_tools/EditingTools.vala"
	_tmp22_ = self->priv->crop_tool_window;
#line 986 "../src/editing_tools/EditingTools.vala"
	_tmp23_ = _tmp22_->constraint_combo;
#line 986 "../src/editing_tools/EditingTools.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, gtk_widget_get_type (), GtkWidget));
#line 987 "../src/editing_tools/EditingTools.vala"
	_tmp24_ = self->priv->crop_tool_window;
#line 987 "../src/editing_tools/EditingTools.vala"
	_tmp25_ = _tmp24_->layout;
#line 987 "../src/editing_tools/EditingTools.vala"
	_tmp26_ = self->priv->crop_tool_window;
#line 987 "../src/editing_tools/EditingTools.vala"
	_tmp27_ = _tmp26_->custom_width_entry;
#line 987 "../src/editing_tools/EditingTools.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp27_, gtk_widget_get_type (), GtkWidget));
#line 988 "../src/editing_tools/EditingTools.vala"
	_tmp28_ = self->priv->crop_tool_window;
#line 988 "../src/editing_tools/EditingTools.vala"
	_tmp29_ = _tmp28_->layout;
#line 988 "../src/editing_tools/EditingTools.vala"
	_tmp30_ = self->priv->crop_tool_window;
#line 988 "../src/editing_tools/EditingTools.vala"
	_tmp31_ = _tmp30_->custom_mulsign_label;
#line 988 "../src/editing_tools/EditingTools.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, gtk_widget_get_type (), GtkWidget));
#line 989 "../src/editing_tools/EditingTools.vala"
	_tmp32_ = self->priv->crop_tool_window;
#line 989 "../src/editing_tools/EditingTools.vala"
	_tmp33_ = _tmp32_->layout;
#line 989 "../src/editing_tools/EditingTools.vala"
	_tmp34_ = self->priv->crop_tool_window;
#line 989 "../src/editing_tools/EditingTools.vala"
	_tmp35_ = _tmp34_->custom_height_entry;
#line 989 "../src/editing_tools/EditingTools.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp33_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp35_, gtk_widget_get_type (), GtkWidget));
#line 990 "../src/editing_tools/EditingTools.vala"
	_tmp36_ = self->priv->crop_tool_window;
#line 990 "../src/editing_tools/EditingTools.vala"
	_tmp37_ = _tmp36_->layout;
#line 990 "../src/editing_tools/EditingTools.vala"
	_tmp38_ = self->priv->crop_tool_window;
#line 990 "../src/editing_tools/EditingTools.vala"
	_tmp39_ = _tmp38_->pivot_reticle_button;
#line 990 "../src/editing_tools/EditingTools.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp37_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, gtk_widget_get_type (), GtkWidget));
#line 991 "../src/editing_tools/EditingTools.vala"
	_tmp40_ = self->priv->crop_tool_window;
#line 991 "../src/editing_tools/EditingTools.vala"
	_tmp41_ = _tmp40_->layout;
#line 991 "../src/editing_tools/EditingTools.vala"
	_tmp42_ = self->priv->crop_tool_window;
#line 991 "../src/editing_tools/EditingTools.vala"
	_tmp43_ = _tmp42_->response_layout;
#line 991 "../src/editing_tools/EditingTools.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp41_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp43_, gtk_widget_get_type (), GtkWidget));
#line 993 "../src/editing_tools/EditingTools.vala"
	if (self->priv->reticle_orientation == EDITING_TOOLS_CROP_TOOL_RETICLE_ORIENTATION_LANDSCAPE) {
#line 7218 "EditingTools.c"
		EditingToolsCropToolCropToolWindow* _tmp44_;
		GtkEntry* _tmp45_;
		gchar* _tmp46_;
		gchar* _tmp47_;
		EditingToolsCropToolCropToolWindow* _tmp48_;
		GtkEntry* _tmp49_;
		gchar* _tmp50_;
		gchar* _tmp51_;
#line 994 "../src/editing_tools/EditingTools.vala"
		_tmp44_ = self->priv->crop_tool_window;
#line 994 "../src/editing_tools/EditingTools.vala"
		_tmp45_ = _tmp44_->custom_width_entry;
#line 994 "../src/editing_tools/EditingTools.vala"
		_tmp46_ = g_strdup_printf ("%d", self->priv->custom_init_width);
#line 994 "../src/editing_tools/EditingTools.vala"
		_tmp47_ = _tmp46_;
#line 994 "../src/editing_tools/EditingTools.vala"
		gtk_entry_set_text (_tmp45_, _tmp47_);
#line 994 "../src/editing_tools/EditingTools.vala"
		_g_free0 (_tmp47_);
#line 995 "../src/editing_tools/EditingTools.vala"
		_tmp48_ = self->priv->crop_tool_window;
#line 995 "../src/editing_tools/EditingTools.vala"
		_tmp49_ = _tmp48_->custom_height_entry;
#line 995 "../src/editing_tools/EditingTools.vala"
		_tmp50_ = g_strdup_printf ("%d", self->priv->custom_init_height);
#line 995 "../src/editing_tools/EditingTools.vala"
		_tmp51_ = _tmp50_;
#line 995 "../src/editing_tools/EditingTools.vala"
		gtk_entry_set_text (_tmp49_, _tmp51_);
#line 995 "../src/editing_tools/EditingTools.vala"
		_g_free0 (_tmp51_);
#line 7251 "EditingTools.c"
	} else {
		EditingToolsCropToolCropToolWindow* _tmp52_;
		GtkEntry* _tmp53_;
		gchar* _tmp54_;
		gchar* _tmp55_;
		EditingToolsCropToolCropToolWindow* _tmp56_;
		GtkEntry* _tmp57_;
		gchar* _tmp58_;
		gchar* _tmp59_;
#line 997 "../src/editing_tools/EditingTools.vala"
		_tmp52_ = self->priv->crop_tool_window;
#line 997 "../src/editing_tools/EditingTools.vala"
		_tmp53_ = _tmp52_->custom_width_entry;
#line 997 "../src/editing_tools/EditingTools.vala"
		_tmp54_ = g_strdup_printf ("%d", self->priv->custom_init_height);
#line 997 "../src/editing_tools/EditingTools.vala"
		_tmp55_ = _tmp54_;
#line 997 "../src/editing_tools/EditingTools.vala"
		gtk_entry_set_text (_tmp53_, _tmp55_);
#line 997 "../src/editing_tools/EditingTools.vala"
		_g_free0 (_tmp55_);
#line 998 "../src/editing_tools/EditingTools.vala"
		_tmp56_ = self->priv->crop_tool_window;
#line 998 "../src/editing_tools/EditingTools.vala"
		_tmp57_ = _tmp56_->custom_height_entry;
#line 998 "../src/editing_tools/EditingTools.vala"
		_tmp58_ = g_strdup_printf ("%d", self->priv->custom_init_width);
#line 998 "../src/editing_tools/EditingTools.vala"
		_tmp59_ = _tmp58_;
#line 998 "../src/editing_tools/EditingTools.vala"
		gtk_entry_set_text (_tmp57_, _tmp59_);
#line 998 "../src/editing_tools/EditingTools.vala"
		_g_free0 (_tmp59_);
#line 7285 "EditingTools.c"
	}
#line 1000 "../src/editing_tools/EditingTools.vala"
	self->priv->custom_aspect_ratio = ((gfloat) self->priv->custom_init_width) / ((gfloat) self->priv->custom_init_height);
#line 1002 "../src/editing_tools/EditingTools.vala"
	_tmp60_ = self->priv->crop_tool_window;
#line 1002 "../src/editing_tools/EditingTools.vala"
	gtk_widget_show_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp60_, gtk_widget_get_type (), GtkWidget));
#line 1004 "../src/editing_tools/EditingTools.vala"
	self->priv->constraint_mode = EDITING_TOOLS_CROP_TOOL_CONSTRAINT_MODE_CUSTOM;
#line 7295 "EditingTools.c"
}

static void
editing_tools_crop_tool_set_normal_constraint_mode (EditingToolsCropTool* self)
{
	EditingToolsCropToolCropToolWindow* _tmp0_;
	GtkBox* _tmp1_;
	EditingToolsCropToolCropToolWindow* _tmp2_;
	GtkComboBox* _tmp3_;
	EditingToolsCropToolCropToolWindow* _tmp4_;
	GtkBox* _tmp5_;
	EditingToolsCropToolCropToolWindow* _tmp6_;
	GtkEntry* _tmp7_;
	EditingToolsCropToolCropToolWindow* _tmp8_;
	GtkBox* _tmp9_;
	EditingToolsCropToolCropToolWindow* _tmp10_;
	GtkLabel* _tmp11_;
	EditingToolsCropToolCropToolWindow* _tmp12_;
	GtkBox* _tmp13_;
	EditingToolsCropToolCropToolWindow* _tmp14_;
	GtkEntry* _tmp15_;
	EditingToolsCropToolCropToolWindow* _tmp16_;
	GtkBox* _tmp17_;
	EditingToolsCropToolCropToolWindow* _tmp18_;
	GtkButton* _tmp19_;
	EditingToolsCropToolCropToolWindow* _tmp20_;
	GtkBox* _tmp21_;
	EditingToolsCropToolCropToolWindow* _tmp22_;
	GtkBox* _tmp23_;
	EditingToolsCropToolCropToolWindow* _tmp24_;
	GtkBox* _tmp25_;
	EditingToolsCropToolCropToolWindow* _tmp26_;
	GtkComboBox* _tmp27_;
	EditingToolsCropToolCropToolWindow* _tmp28_;
	GtkBox* _tmp29_;
	EditingToolsCropToolCropToolWindow* _tmp30_;
	GtkButton* _tmp31_;
	EditingToolsCropToolCropToolWindow* _tmp32_;
	GtkBox* _tmp33_;
	EditingToolsCropToolCropToolWindow* _tmp34_;
	GtkBox* _tmp35_;
	EditingToolsCropToolCropToolWindow* _tmp36_;
	EditingToolsCropToolCropToolWindow* _tmp37_;
	EditingToolsCropToolCropToolWindow* _tmp38_;
	EditingToolsCropToolCropToolWindow* _tmp39_;
#line 1007 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_CROP_TOOL (self));
#line 1008 "../src/editing_tools/EditingTools.vala"
	if (self->priv->constraint_mode == EDITING_TOOLS_CROP_TOOL_CONSTRAINT_MODE_NORMAL) {
#line 1009 "../src/editing_tools/EditingTools.vala"
		return;
#line 7347 "EditingTools.c"
	}
#line 1011 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->crop_tool_window;
#line 1011 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = _tmp0_->layout;
#line 1011 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = self->priv->crop_tool_window;
#line 1011 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = _tmp2_->constraint_combo;
#line 1011 "../src/editing_tools/EditingTools.vala"
	gtk_container_remove (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_widget_get_type (), GtkWidget));
#line 1012 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = self->priv->crop_tool_window;
#line 1012 "../src/editing_tools/EditingTools.vala"
	_tmp5_ = _tmp4_->layout;
#line 1012 "../src/editing_tools/EditingTools.vala"
	_tmp6_ = self->priv->crop_tool_window;
#line 1012 "../src/editing_tools/EditingTools.vala"
	_tmp7_ = _tmp6_->custom_width_entry;
#line 1012 "../src/editing_tools/EditingTools.vala"
	gtk_container_remove (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_widget_get_type (), GtkWidget));
#line 1013 "../src/editing_tools/EditingTools.vala"
	_tmp8_ = self->priv->crop_tool_window;
#line 1013 "../src/editing_tools/EditingTools.vala"
	_tmp9_ = _tmp8_->layout;
#line 1013 "../src/editing_tools/EditingTools.vala"
	_tmp10_ = self->priv->crop_tool_window;
#line 1013 "../src/editing_tools/EditingTools.vala"
	_tmp11_ = _tmp10_->custom_mulsign_label;
#line 1013 "../src/editing_tools/EditingTools.vala"
	gtk_container_remove (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, gtk_widget_get_type (), GtkWidget));
#line 1014 "../src/editing_tools/EditingTools.vala"
	_tmp12_ = self->priv->crop_tool_window;
#line 1014 "../src/editing_tools/EditingTools.vala"
	_tmp13_ = _tmp12_->layout;
#line 1014 "../src/editing_tools/EditingTools.vala"
	_tmp14_ = self->priv->crop_tool_window;
#line 1014 "../src/editing_tools/EditingTools.vala"
	_tmp15_ = _tmp14_->custom_height_entry;
#line 1014 "../src/editing_tools/EditingTools.vala"
	gtk_container_remove (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, gtk_widget_get_type (), GtkWidget));
#line 1015 "../src/editing_tools/EditingTools.vala"
	_tmp16_ = self->priv->crop_tool_window;
#line 1015 "../src/editing_tools/EditingTools.vala"
	_tmp17_ = _tmp16_->layout;
#line 1015 "../src/editing_tools/EditingTools.vala"
	_tmp18_ = self->priv->crop_tool_window;
#line 1015 "../src/editing_tools/EditingTools.vala"
	_tmp19_ = _tmp18_->pivot_reticle_button;
#line 1015 "../src/editing_tools/EditingTools.vala"
	gtk_container_remove (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, gtk_widget_get_type (), GtkWidget));
#line 1016 "../src/editing_tools/EditingTools.vala"
	_tmp20_ = self->priv->crop_tool_window;
#line 1016 "../src/editing_tools/EditingTools.vala"
	_tmp21_ = _tmp20_->layout;
#line 1016 "../src/editing_tools/EditingTools.vala"
	_tmp22_ = self->priv->crop_tool_window;
#line 1016 "../src/editing_tools/EditingTools.vala"
	_tmp23_ = _tmp22_->response_layout;
#line 1016 "../src/editing_tools/EditingTools.vala"
	gtk_container_remove (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, gtk_widget_get_type (), GtkWidget));
#line 1018 "../src/editing_tools/EditingTools.vala"
	_tmp24_ = self->priv->crop_tool_window;
#line 1018 "../src/editing_tools/EditingTools.vala"
	_tmp25_ = _tmp24_->layout;
#line 1018 "../src/editing_tools/EditingTools.vala"
	_tmp26_ = self->priv->crop_tool_window;
#line 1018 "../src/editing_tools/EditingTools.vala"
	_tmp27_ = _tmp26_->constraint_combo;
#line 1018 "../src/editing_tools/EditingTools.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp27_, gtk_widget_get_type (), GtkWidget));
#line 1019 "../src/editing_tools/EditingTools.vala"
	_tmp28_ = self->priv->crop_tool_window;
#line 1019 "../src/editing_tools/EditingTools.vala"
	_tmp29_ = _tmp28_->layout;
#line 1019 "../src/editing_tools/EditingTools.vala"
	_tmp30_ = self->priv->crop_tool_window;
#line 1019 "../src/editing_tools/EditingTools.vala"
	_tmp31_ = _tmp30_->pivot_reticle_button;
#line 1019 "../src/editing_tools/EditingTools.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, gtk_widget_get_type (), GtkWidget));
#line 1020 "../src/editing_tools/EditingTools.vala"
	_tmp32_ = self->priv->crop_tool_window;
#line 1020 "../src/editing_tools/EditingTools.vala"
	_tmp33_ = _tmp32_->layout;
#line 1020 "../src/editing_tools/EditingTools.vala"
	_tmp34_ = self->priv->crop_tool_window;
#line 1020 "../src/editing_tools/EditingTools.vala"
	_tmp35_ = _tmp34_->response_layout;
#line 1020 "../src/editing_tools/EditingTools.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp33_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp35_, gtk_widget_get_type (), GtkWidget));
#line 1022 "../src/editing_tools/EditingTools.vala"
	_tmp36_ = self->priv->crop_tool_window;
#line 1022 "../src/editing_tools/EditingTools.vala"
	_tmp37_ = self->priv->crop_tool_window;
#line 1022 "../src/editing_tools/EditingTools.vala"
	_tmp38_ = self->priv->crop_tool_window;
#line 1022 "../src/editing_tools/EditingTools.vala"
	gtk_window_resize (G_TYPE_CHECK_INSTANCE_CAST (_tmp36_, gtk_window_get_type (), GtkWindow), _tmp37_->normal_width, _tmp38_->normal_height);
#line 1025 "../src/editing_tools/EditingTools.vala"
	_tmp39_ = self->priv->crop_tool_window;
#line 1025 "../src/editing_tools/EditingTools.vala"
	gtk_widget_show_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, gtk_widget_get_type (), GtkWidget));
#line 1027 "../src/editing_tools/EditingTools.vala"
	self->priv->constraint_mode = EDITING_TOOLS_CROP_TOOL_CONSTRAINT_MODE_NORMAL;
#line 7453 "EditingTools.c"
}

static void
editing_tools_crop_tool_constrain_crop (EditingToolsCropTool* self,
                                        Box* crop,
                                        Box* result)
{
	gfloat user_aspect_ratio = 0.0F;
	gfloat old_area = 0.0F;
	Dimensions image_size = {0};
	Dimensions _tmp1_ = {0};
	gdouble angle = 0.0;
	EditingToolsPhotoCanvas* _tmp2_;
	Photo* _tmp3_;
	Photo* _tmp4_;
	gdouble _tmp5_ = 0.0;
	Box _tmp6_;
	Dimensions _tmp7_;
	Dimensions _tmp8_;
	Box _tmp9_ = {0};
	Box _tmp10_;
#line 1030 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_CROP_TOOL (self));
#line 1030 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (crop != NULL);
#line 1031 "../src/editing_tools/EditingTools.vala"
	user_aspect_ratio = editing_tools_crop_tool_get_constraint_aspect_ratio (self);
#line 1032 "../src/editing_tools/EditingTools.vala"
	if (user_aspect_ratio == EDITING_TOOLS_CROP_TOOL_ANY_ASPECT_RATIO) {
#line 7483 "EditingTools.c"
		Box _tmp0_;
#line 1033 "../src/editing_tools/EditingTools.vala"
		_tmp0_ = *crop;
#line 1033 "../src/editing_tools/EditingTools.vala"
		*result = _tmp0_;
#line 1033 "../src/editing_tools/EditingTools.vala"
		return;
#line 7491 "EditingTools.c"
	}
#line 1036 "../src/editing_tools/EditingTools.vala"
	old_area = (gfloat) (box_get_width (crop) * box_get_height (crop));
#line 1037 "../src/editing_tools/EditingTools.vala"
	box_adjust_height (crop, (gint) sqrt ((gdouble) (old_area / user_aspect_ratio)));
#line 1038 "../src/editing_tools/EditingTools.vala"
	box_adjust_width (crop, (gint) sqrt ((gdouble) (old_area * user_aspect_ratio)));
#line 1041 "../src/editing_tools/EditingTools.vala"
	editing_tools_crop_tool_get_photo_dimensions (self, &_tmp1_);
#line 1041 "../src/editing_tools/EditingTools.vala"
	image_size = _tmp1_;
#line 1043 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 1043 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = editing_tools_photo_canvas_get_photo (_tmp2_);
#line 1043 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = _tmp3_;
#line 1043 "../src/editing_tools/EditingTools.vala"
	photo_get_straighten (_tmp4_, &_tmp5_);
#line 1043 "../src/editing_tools/EditingTools.vala"
	angle = _tmp5_;
#line 1043 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (_tmp4_);
#line 1044 "../src/editing_tools/EditingTools.vala"
	_tmp6_ = *crop;
#line 1044 "../src/editing_tools/EditingTools.vala"
	_tmp7_ = image_size;
#line 1044 "../src/editing_tools/EditingTools.vala"
	_tmp8_ = image_size;
#line 1044 "../src/editing_tools/EditingTools.vala"
	clamp_inside_rotated_image (&_tmp6_, _tmp7_.width, _tmp8_.height, angle, FALSE, &_tmp9_);
#line 1044 "../src/editing_tools/EditingTools.vala"
	*crop = _tmp9_;
#line 1047 "../src/editing_tools/EditingTools.vala"
	if (((gfloat) box_get_width (crop)) >= (box_get_height (crop) * user_aspect_ratio)) {
#line 1048 "../src/editing_tools/EditingTools.vala"
		box_adjust_width (crop, (gint) (box_get_height (crop) * user_aspect_ratio));
#line 7529 "EditingTools.c"
	} else {
#line 1050 "../src/editing_tools/EditingTools.vala"
		box_adjust_height (crop, (gint) (box_get_width (crop) / user_aspect_ratio));
#line 7533 "EditingTools.c"
	}
#line 1052 "../src/editing_tools/EditingTools.vala"
	_tmp10_ = *crop;
#line 1052 "../src/editing_tools/EditingTools.vala"
	*result = _tmp10_;
#line 1052 "../src/editing_tools/EditingTools.vala"
	return;
#line 7541 "EditingTools.c"
}

static EditingToolsCropToolConstraintDescription*
editing_tools_crop_tool_get_last_constraint (EditingToolsCropTool* self,
                                             gint* index)
{
	gint _vala_index = 0;
	ConfigFacade* _tmp0_;
	ConfigFacade* _tmp1_;
	EditingToolsCropToolConstraintDescription* _tmp2_ = NULL;
	EditingToolsCropToolConstraintDescription** _tmp3_;
	gint _tmp3__length1;
	EditingToolsCropToolConstraintDescription* _tmp6_;
	EditingToolsCropToolConstraintDescription* result;
#line 1055 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (EDITING_TOOLS_IS_CROP_TOOL (self), NULL);
#line 1056 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = config_facade_get_instance ();
#line 1056 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = _tmp0_;
#line 1056 "../src/editing_tools/EditingTools.vala"
	_vala_index = configuration_facade_get_last_crop_menu_choice (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_CONFIGURATION_FACADE, ConfigurationFacade));
#line 1056 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (_tmp1_);
#line 1058 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = self->priv->constraints;
#line 1058 "../src/editing_tools/EditingTools.vala"
	_tmp3__length1 = self->priv->constraints_length1;
#line 1058 "../src/editing_tools/EditingTools.vala"
	if (_vala_index < _tmp3__length1) {
#line 7572 "EditingTools.c"
		EditingToolsCropToolConstraintDescription** _tmp4_;
		gint _tmp4__length1;
		EditingToolsCropToolConstraintDescription* _tmp5_;
#line 1058 "../src/editing_tools/EditingTools.vala"
		_tmp4_ = self->priv->constraints;
#line 1058 "../src/editing_tools/EditingTools.vala"
		_tmp4__length1 = self->priv->constraints_length1;
#line 1058 "../src/editing_tools/EditingTools.vala"
		_tmp5_ = _tmp4_[_vala_index];
#line 1058 "../src/editing_tools/EditingTools.vala"
		_tmp2_ = _tmp5_;
#line 7584 "EditingTools.c"
	} else {
#line 1058 "../src/editing_tools/EditingTools.vala"
		_tmp2_ = NULL;
#line 7588 "EditingTools.c"
	}
#line 1058 "../src/editing_tools/EditingTools.vala"
	_tmp6_ = _editing_tools_crop_tool_constraint_description_ref0 (_tmp2_);
#line 1058 "../src/editing_tools/EditingTools.vala"
	result = _tmp6_;
#line 1058 "../src/editing_tools/EditingTools.vala"
	if (index) {
#line 1058 "../src/editing_tools/EditingTools.vala"
		*index = _vala_index;
#line 7598 "EditingTools.c"
	}
#line 1058 "../src/editing_tools/EditingTools.vala"
	return result;
#line 7602 "EditingTools.c"
}

static void
editing_tools_crop_tool_real_activate (EditingToolsEditingTool* base,
                                       EditingToolsPhotoCanvas* canvas)
{
	EditingToolsCropTool * self;
	cairo_t* _tmp0_;
	cairo_t* _tmp1_;
	Dimensions _tmp2_ = {0};
	cairo_surface_t* _tmp3_;
	GdkRectangle _tmp4_ = {0};
	GdkRectangle _tmp5_ = {0};
	cairo_surface_t* _tmp6_;
	cairo_t* ctx = NULL;
	cairo_surface_t* _tmp7_;
	cairo_t* _tmp8_;
	cairo_t* _tmp9_;
	cairo_t* _tmp10_;
	GtkWindow* _tmp11_;
	GtkWindow* _tmp12_;
	EditingToolsCropToolCropToolWindow* _tmp13_;
	EditingToolsCropToolCropToolWindow* _tmp14_;
	GtkComboBox* _tmp15_;
	GtkListStore* _tmp16_;
	Photo* _tmp17_;
	Photo* _tmp18_;
	gboolean _tmp19_;
	Dimensions uncropped_dim = {0};
	Photo* _tmp40_;
	Photo* _tmp41_;
	Dimensions _tmp42_ = {0};
	Dimensions _tmp43_;
	Box crop = {0};
	Photo* _tmp44_;
	Photo* _tmp45_;
	Box _tmp46_ = {0};
	gboolean _tmp47_;
	gboolean _tmp48_;
	Dimensions _tmp53_;
	GdkRectangle _tmp54_ = {0};
	Dimensions _tmp55_ = {0};
	Box _tmp56_ = {0};
	ConfigFacade* _tmp57_;
	ConfigFacade* _tmp58_;
	ConfigFacade* _tmp59_;
	ConfigFacade* _tmp60_;
	EditingToolsCropToolCropToolWindow* _tmp61_;
	Photo* _tmp62_;
	Photo* _tmp63_;
	gboolean _tmp64_;
	Box new_crop = {0};
	Box _tmp71_;
	Box _tmp72_ = {0};
	Box _tmp73_;
	Box _tmp74_;
	Box _tmp75_;
#line 1061 "../src/editing_tools/EditingTools.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, EDITING_TOOLS_TYPE_CROP_TOOL, EditingToolsCropTool);
#line 1061 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_PHOTO_CANVAS (canvas));
#line 1062 "../src/editing_tools/EditingTools.vala"
	editing_tools_crop_tool_bind_canvas_handlers (self, canvas);
#line 1064 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = editing_tools_photo_canvas_get_default_ctx (canvas);
#line 1064 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = _tmp0_;
#line 1064 "../src/editing_tools/EditingTools.vala"
	editing_tools_photo_canvas_get_surface_dim (canvas, &_tmp2_);
#line 1064 "../src/editing_tools/EditingTools.vala"
	editing_tools_crop_tool_prepare_ctx (self, _tmp1_, &_tmp2_);
#line 1064 "../src/editing_tools/EditingTools.vala"
	_cairo_destroy0 (_tmp1_);
#line 1066 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = self->priv->crop_surface;
#line 1066 "../src/editing_tools/EditingTools.vala"
	if (_tmp3_ != NULL) {
#line 1067 "../src/editing_tools/EditingTools.vala"
		_cairo_surface_destroy0 (self->priv->crop_surface);
#line 1067 "../src/editing_tools/EditingTools.vala"
		self->priv->crop_surface = NULL;
#line 7684 "EditingTools.c"
	}
#line 1069 "../src/editing_tools/EditingTools.vala"
	editing_tools_photo_canvas_get_scaled_pixbuf_position (canvas, &_tmp4_);
#line 1069 "../src/editing_tools/EditingTools.vala"
	editing_tools_photo_canvas_get_scaled_pixbuf_position (canvas, &_tmp5_);
#line 1069 "../src/editing_tools/EditingTools.vala"
	_tmp6_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, _tmp4_.width, _tmp5_.height);
#line 1069 "../src/editing_tools/EditingTools.vala"
	_cairo_surface_destroy0 (self->priv->crop_surface);
#line 1069 "../src/editing_tools/EditingTools.vala"
	self->priv->crop_surface = _tmp6_;
#line 1073 "../src/editing_tools/EditingTools.vala"
	_tmp7_ = self->priv->crop_surface;
#line 1073 "../src/editing_tools/EditingTools.vala"
	_tmp8_ = cairo_create (_tmp7_);
#line 1073 "../src/editing_tools/EditingTools.vala"
	ctx = _tmp8_;
#line 1074 "../src/editing_tools/EditingTools.vala"
	_tmp9_ = ctx;
#line 1074 "../src/editing_tools/EditingTools.vala"
	cairo_set_source_rgba (_tmp9_, 0.0, 0.0, 0.0, 1.0);
#line 1075 "../src/editing_tools/EditingTools.vala"
	_tmp10_ = ctx;
#line 1075 "../src/editing_tools/EditingTools.vala"
	cairo_paint (_tmp10_);
#line 1078 "../src/editing_tools/EditingTools.vala"
	_tmp11_ = editing_tools_photo_canvas_get_container (canvas);
#line 1078 "../src/editing_tools/EditingTools.vala"
	_tmp12_ = _tmp11_;
#line 1078 "../src/editing_tools/EditingTools.vala"
	_tmp13_ = editing_tools_crop_tool_crop_tool_window_new (_tmp12_);
#line 1078 "../src/editing_tools/EditingTools.vala"
	g_object_ref_sink (_tmp13_);
#line 1078 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->priv->crop_tool_window);
#line 1078 "../src/editing_tools/EditingTools.vala"
	self->priv->crop_tool_window = _tmp13_;
#line 1078 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (_tmp12_);
#line 1081 "../src/editing_tools/EditingTools.vala"
	_tmp14_ = self->priv->crop_tool_window;
#line 1081 "../src/editing_tools/EditingTools.vala"
	_tmp15_ = _tmp14_->constraint_combo;
#line 1081 "../src/editing_tools/EditingTools.vala"
	_tmp16_ = self->priv->constraint_list;
#line 1081 "../src/editing_tools/EditingTools.vala"
	gtk_combo_box_set_model (_tmp15_, G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, gtk_tree_model_get_type (), GtkTreeModel));
#line 1082 "../src/editing_tools/EditingTools.vala"
	_tmp17_ = editing_tools_photo_canvas_get_photo (canvas);
#line 1082 "../src/editing_tools/EditingTools.vala"
	_tmp18_ = _tmp17_;
#line 1082 "../src/editing_tools/EditingTools.vala"
	_tmp19_ = !photo_has_crop (_tmp18_);
#line 1082 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (_tmp18_);
#line 1082 "../src/editing_tools/EditingTools.vala"
	if (_tmp19_) {
#line 7742 "EditingTools.c"
		gint index = 0;
		EditingToolsCropToolConstraintDescription* desc = NULL;
		gint _tmp20_ = 0;
		EditingToolsCropToolConstraintDescription* _tmp21_;
		gboolean _tmp22_ = FALSE;
		EditingToolsCropToolConstraintDescription* _tmp23_;
#line 1084 "../src/editing_tools/EditingTools.vala"
		_tmp21_ = editing_tools_crop_tool_get_last_constraint (self, &_tmp20_);
#line 1084 "../src/editing_tools/EditingTools.vala"
		index = _tmp20_;
#line 1084 "../src/editing_tools/EditingTools.vala"
		desc = _tmp21_;
#line 1085 "../src/editing_tools/EditingTools.vala"
		_tmp23_ = desc;
#line 1085 "../src/editing_tools/EditingTools.vala"
		if (_tmp23_ != NULL) {
#line 7759 "EditingTools.c"
			EditingToolsCropToolConstraintDescription* _tmp24_;
#line 1085 "../src/editing_tools/EditingTools.vala"
			_tmp24_ = desc;
#line 1085 "../src/editing_tools/EditingTools.vala"
			_tmp22_ = !editing_tools_crop_tool_constraint_description_is_separator (_tmp24_);
#line 7765 "EditingTools.c"
		} else {
#line 1085 "../src/editing_tools/EditingTools.vala"
			_tmp22_ = FALSE;
#line 7769 "EditingTools.c"
		}
#line 1085 "../src/editing_tools/EditingTools.vala"
		if (_tmp22_) {
#line 7773 "EditingTools.c"
			EditingToolsCropToolCropToolWindow* _tmp25_;
			GtkComboBox* _tmp26_;
#line 1086 "../src/editing_tools/EditingTools.vala"
			_tmp25_ = self->priv->crop_tool_window;
#line 1086 "../src/editing_tools/EditingTools.vala"
			_tmp26_ = _tmp25_->constraint_combo;
#line 1086 "../src/editing_tools/EditingTools.vala"
			gtk_combo_box_set_active (_tmp26_, index);
#line 7782 "EditingTools.c"
		}
#line 1082 "../src/editing_tools/EditingTools.vala"
		_editing_tools_crop_tool_constraint_description_unref0 (desc);
#line 7786 "EditingTools.c"
	} else {
		Photo* photo = NULL;
		Photo* _tmp27_;
		Dimensions cropped_dim = {0};
		Photo* _tmp28_;
		Dimensions _tmp29_ = {0};
		gfloat ratio = 0.0F;
		Dimensions _tmp30_;
		Dimensions _tmp31_;
#line 1090 "../src/editing_tools/EditingTools.vala"
		_tmp27_ = editing_tools_photo_canvas_get_photo (canvas);
#line 1090 "../src/editing_tools/EditingTools.vala"
		photo = _tmp27_;
#line 1091 "../src/editing_tools/EditingTools.vala"
		_tmp28_ = photo;
#line 1091 "../src/editing_tools/EditingTools.vala"
		media_source_get_dimensions (G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, TYPE_MEDIA_SOURCE, MediaSource), PHOTO_EXCEPTION_NONE, &_tmp29_);
#line 1091 "../src/editing_tools/EditingTools.vala"
		cropped_dim = _tmp29_;
#line 1092 "../src/editing_tools/EditingTools.vala"
		_tmp30_ = cropped_dim;
#line 1092 "../src/editing_tools/EditingTools.vala"
		_tmp31_ = cropped_dim;
#line 1092 "../src/editing_tools/EditingTools.vala"
		ratio = ((gfloat) _tmp30_.width) / ((gfloat) _tmp31_.height);
#line 7812 "EditingTools.c"
		{
			gint index = 0;
#line 1093 "../src/editing_tools/EditingTools.vala"
			index = 1;
#line 7817 "EditingTools.c"
			{
				gboolean _tmp32_ = FALSE;
#line 1093 "../src/editing_tools/EditingTools.vala"
				_tmp32_ = TRUE;
#line 1093 "../src/editing_tools/EditingTools.vala"
				while (TRUE) {
#line 7824 "EditingTools.c"
					EditingToolsCropToolConstraintDescription** _tmp34_;
					gint _tmp34__length1;
					EditingToolsCropToolConstraintDescription** _tmp35_;
					gint _tmp35__length1;
					EditingToolsCropToolConstraintDescription* _tmp36_;
					Photo* _tmp37_;
#line 1093 "../src/editing_tools/EditingTools.vala"
					if (!_tmp32_) {
#line 7833 "EditingTools.c"
						gint _tmp33_;
#line 1093 "../src/editing_tools/EditingTools.vala"
						_tmp33_ = index;
#line 1093 "../src/editing_tools/EditingTools.vala"
						index = _tmp33_ + 1;
#line 7839 "EditingTools.c"
					}
#line 1093 "../src/editing_tools/EditingTools.vala"
					_tmp32_ = FALSE;
#line 1093 "../src/editing_tools/EditingTools.vala"
					_tmp34_ = self->priv->constraints;
#line 1093 "../src/editing_tools/EditingTools.vala"
					_tmp34__length1 = self->priv->constraints_length1;
#line 1093 "../src/editing_tools/EditingTools.vala"
					if (!(index < _tmp34__length1)) {
#line 1093 "../src/editing_tools/EditingTools.vala"
						break;
#line 7851 "EditingTools.c"
					}
#line 1094 "../src/editing_tools/EditingTools.vala"
					_tmp35_ = self->priv->constraints;
#line 1094 "../src/editing_tools/EditingTools.vala"
					_tmp35__length1 = self->priv->constraints_length1;
#line 1094 "../src/editing_tools/EditingTools.vala"
					_tmp36_ = _tmp35_[index];
#line 1094 "../src/editing_tools/EditingTools.vala"
					_tmp37_ = photo;
#line 1094 "../src/editing_tools/EditingTools.vala"
					if (fabs ((gdouble) (ratio - editing_tools_crop_tool_get_constraint_aspect_ratio_for_constraint (self, _tmp36_, _tmp37_))) < 0.005) {
#line 7863 "EditingTools.c"
						EditingToolsCropToolCropToolWindow* _tmp38_;
						GtkComboBox* _tmp39_;
#line 1095 "../src/editing_tools/EditingTools.vala"
						_tmp38_ = self->priv->crop_tool_window;
#line 1095 "../src/editing_tools/EditingTools.vala"
						_tmp39_ = _tmp38_->constraint_combo;
#line 1095 "../src/editing_tools/EditingTools.vala"
						gtk_combo_box_set_active (_tmp39_, index);
#line 7872 "EditingTools.c"
					}
				}
			}
		}
#line 1082 "../src/editing_tools/EditingTools.vala"
		_g_object_unref0 (photo);
#line 7879 "EditingTools.c"
	}
#line 1100 "../src/editing_tools/EditingTools.vala"
	editing_tools_crop_tool_update_pivot_button_state (self);
#line 1101 "../src/editing_tools/EditingTools.vala"
	self->priv->reticle_orientation = EDITING_TOOLS_CROP_TOOL_RETICLE_ORIENTATION_LANDSCAPE;
#line 1103 "../src/editing_tools/EditingTools.vala"
	editing_tools_crop_tool_bind_window_handlers (self);
#line 1106 "../src/editing_tools/EditingTools.vala"
	_tmp40_ = editing_tools_photo_canvas_get_photo (canvas);
#line 1106 "../src/editing_tools/EditingTools.vala"
	_tmp41_ = _tmp40_;
#line 1106 "../src/editing_tools/EditingTools.vala"
	media_source_get_dimensions (G_TYPE_CHECK_INSTANCE_CAST (_tmp41_, TYPE_MEDIA_SOURCE, MediaSource), PHOTO_EXCEPTION_CROP, &_tmp42_);
#line 1106 "../src/editing_tools/EditingTools.vala"
	_tmp43_ = _tmp42_;
#line 1106 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (_tmp41_);
#line 1106 "../src/editing_tools/EditingTools.vala"
	uncropped_dim = _tmp43_;
#line 1109 "../src/editing_tools/EditingTools.vala"
	_tmp44_ = editing_tools_photo_canvas_get_photo (canvas);
#line 1109 "../src/editing_tools/EditingTools.vala"
	_tmp45_ = _tmp44_;
#line 1109 "../src/editing_tools/EditingTools.vala"
	_tmp47_ = photo_get_crop (_tmp45_, &_tmp46_, PHOTO_EXCEPTION_NONE);
#line 1109 "../src/editing_tools/EditingTools.vala"
	crop = _tmp46_;
#line 1109 "../src/editing_tools/EditingTools.vala"
	_tmp48_ = !_tmp47_;
#line 1109 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (_tmp45_);
#line 1109 "../src/editing_tools/EditingTools.vala"
	if (_tmp48_) {
#line 7913 "EditingTools.c"
		gint xofs = 0;
		Dimensions _tmp49_;
		gint yofs = 0;
		Dimensions _tmp50_;
		Dimensions _tmp51_;
		Dimensions _tmp52_;
#line 1110 "../src/editing_tools/EditingTools.vala"
		_tmp49_ = uncropped_dim;
#line 1110 "../src/editing_tools/EditingTools.vala"
		xofs = (gint) (_tmp49_.width * EDITING_TOOLS_CROP_TOOL_CROP_INIT_X_PCT);
#line 1111 "../src/editing_tools/EditingTools.vala"
		_tmp50_ = uncropped_dim;
#line 1111 "../src/editing_tools/EditingTools.vala"
		yofs = (gint) (_tmp50_.height * EDITING_TOOLS_CROP_TOOL_CROP_INIT_Y_PCT);
#line 1115 "../src/editing_tools/EditingTools.vala"
		_tmp51_ = uncropped_dim;
#line 1115 "../src/editing_tools/EditingTools.vala"
		_tmp52_ = uncropped_dim;
#line 1115 "../src/editing_tools/EditingTools.vala"
		box_init (&crop, xofs, yofs, _tmp51_.width - xofs, _tmp52_.height - yofs);
#line 7934 "EditingTools.c"
	}
#line 1120 "../src/editing_tools/EditingTools.vala"
	_tmp53_ = uncropped_dim;
#line 1120 "../src/editing_tools/EditingTools.vala"
	editing_tools_photo_canvas_get_scaled_pixbuf_position (canvas, &_tmp54_);
#line 1120 "../src/editing_tools/EditingTools.vala"
	dimensions_for_rectangle (&_tmp54_, &_tmp55_);
#line 1120 "../src/editing_tools/EditingTools.vala"
	box_get_scaled_similar (&crop, &_tmp53_, &_tmp55_, &_tmp56_);
#line 1120 "../src/editing_tools/EditingTools.vala"
	self->priv->scaled_crop = _tmp56_;
#line 1125 "../src/editing_tools/EditingTools.vala"
	_tmp57_ = config_facade_get_instance ();
#line 1125 "../src/editing_tools/EditingTools.vala"
	_tmp58_ = _tmp57_;
#line 1125 "../src/editing_tools/EditingTools.vala"
	self->priv->custom_width = configuration_facade_get_last_crop_width (G_TYPE_CHECK_INSTANCE_CAST (_tmp58_, TYPE_CONFIGURATION_FACADE, ConfigurationFacade));
#line 1125 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (_tmp58_);
#line 1126 "../src/editing_tools/EditingTools.vala"
	_tmp59_ = config_facade_get_instance ();
#line 1126 "../src/editing_tools/EditingTools.vala"
	_tmp60_ = _tmp59_;
#line 1126 "../src/editing_tools/EditingTools.vala"
	self->priv->custom_height = configuration_facade_get_last_crop_height (G_TYPE_CHECK_INSTANCE_CAST (_tmp60_, TYPE_CONFIGURATION_FACADE, ConfigurationFacade));
#line 1126 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (_tmp60_);
#line 1127 "../src/editing_tools/EditingTools.vala"
	self->priv->custom_init_width = self->priv->custom_width;
#line 1128 "../src/editing_tools/EditingTools.vala"
	self->priv->custom_init_height = self->priv->custom_height;
#line 1129 "../src/editing_tools/EditingTools.vala"
	self->priv->pre_aspect_ratio = ((gfloat) self->priv->custom_init_width) / ((gfloat) self->priv->custom_init_height);
#line 1131 "../src/editing_tools/EditingTools.vala"
	self->priv->constraint_mode = EDITING_TOOLS_CROP_TOOL_CONSTRAINT_MODE_NORMAL;
#line 1133 "../src/editing_tools/EditingTools.vala"
	EDITING_TOOLS_EDITING_TOOL_CLASS (editing_tools_crop_tool_parent_class)->activate (G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool), canvas);
#line 1135 "../src/editing_tools/EditingTools.vala"
	_tmp61_ = self->priv->crop_tool_window;
#line 1135 "../src/editing_tools/EditingTools.vala"
	gtk_widget_show_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp61_, gtk_widget_get_type (), GtkWidget));
#line 1138 "../src/editing_tools/EditingTools.vala"
	_tmp62_ = editing_tools_photo_canvas_get_photo (canvas);
#line 1138 "../src/editing_tools/EditingTools.vala"
	_tmp63_ = _tmp62_;
#line 1138 "../src/editing_tools/EditingTools.vala"
	_tmp64_ = !photo_has_crop (_tmp63_);
#line 1138 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (_tmp63_);
#line 1138 "../src/editing_tools/EditingTools.vala"
	if (_tmp64_) {
#line 7986 "EditingTools.c"
		EditingToolsCropToolConstraintDescription* desc = NULL;
		EditingToolsCropToolConstraintDescription* _tmp65_;
		gboolean _tmp66_ = FALSE;
		gboolean _tmp67_ = FALSE;
		EditingToolsCropToolConstraintDescription* _tmp68_;
#line 1139 "../src/editing_tools/EditingTools.vala"
		_tmp65_ = editing_tools_crop_tool_get_last_constraint (self, NULL);
#line 1139 "../src/editing_tools/EditingTools.vala"
		desc = _tmp65_;
#line 1140 "../src/editing_tools/EditingTools.vala"
		_tmp68_ = desc;
#line 1140 "../src/editing_tools/EditingTools.vala"
		if (_tmp68_ != NULL) {
#line 8000 "EditingTools.c"
			EditingToolsCropToolConstraintDescription* _tmp69_;
#line 1140 "../src/editing_tools/EditingTools.vala"
			_tmp69_ = desc;
#line 1140 "../src/editing_tools/EditingTools.vala"
			_tmp67_ = !editing_tools_crop_tool_constraint_description_is_separator (_tmp69_);
#line 8006 "EditingTools.c"
		} else {
#line 1140 "../src/editing_tools/EditingTools.vala"
			_tmp67_ = FALSE;
#line 8010 "EditingTools.c"
		}
#line 1140 "../src/editing_tools/EditingTools.vala"
		if (_tmp67_) {
#line 8014 "EditingTools.c"
			EditingToolsCropToolConstraintDescription* _tmp70_;
#line 1140 "../src/editing_tools/EditingTools.vala"
			_tmp70_ = desc;
#line 1140 "../src/editing_tools/EditingTools.vala"
			_tmp66_ = _tmp70_->aspect_ratio == EDITING_TOOLS_CROP_TOOL_CUSTOM_ASPECT_RATIO;
#line 8020 "EditingTools.c"
		} else {
#line 1140 "../src/editing_tools/EditingTools.vala"
			_tmp66_ = FALSE;
#line 8024 "EditingTools.c"
		}
#line 1140 "../src/editing_tools/EditingTools.vala"
		if (_tmp66_) {
#line 1141 "../src/editing_tools/EditingTools.vala"
			editing_tools_crop_tool_set_custom_constraint_mode (self);
#line 8030 "EditingTools.c"
		}
#line 1138 "../src/editing_tools/EditingTools.vala"
		_editing_tools_crop_tool_constraint_description_unref0 (desc);
#line 8034 "EditingTools.c"
	}
#line 1148 "../src/editing_tools/EditingTools.vala"
	_tmp71_ = self->priv->scaled_crop;
#line 1148 "../src/editing_tools/EditingTools.vala"
	editing_tools_crop_tool_constrain_crop (self, &_tmp71_, &_tmp72_);
#line 1148 "../src/editing_tools/EditingTools.vala"
	new_crop = _tmp72_;
#line 1150 "../src/editing_tools/EditingTools.vala"
	_tmp73_ = new_crop;
#line 1150 "../src/editing_tools/EditingTools.vala"
	editing_tools_crop_tool_crop_resized (self, &_tmp73_);
#line 1151 "../src/editing_tools/EditingTools.vala"
	_tmp74_ = new_crop;
#line 1151 "../src/editing_tools/EditingTools.vala"
	self->priv->scaled_crop = _tmp74_;
#line 1152 "../src/editing_tools/EditingTools.vala"
	_tmp75_ = new_crop;
#line 1152 "../src/editing_tools/EditingTools.vala"
	editing_tools_photo_canvas_invalidate_area (canvas, &_tmp75_);
#line 1153 "../src/editing_tools/EditingTools.vala"
	editing_tools_photo_canvas_repaint (canvas);
#line 1155 "../src/editing_tools/EditingTools.vala"
	self->priv->pre_aspect_ratio = editing_tools_crop_tool_get_constraint_aspect_ratio (self);
#line 1061 "../src/editing_tools/EditingTools.vala"
	_cairo_destroy0 (ctx);
#line 8060 "EditingTools.c"
}

static void
_editing_tools_crop_tool_prepare_ctx_editing_tools_photo_canvas_new_surface (EditingToolsPhotoCanvas* _sender,
                                                                             cairo_t* ctx,
                                                                             Dimensions* dim,
                                                                             gpointer self)
{
#line 1159 "../src/editing_tools/EditingTools.vala"
	editing_tools_crop_tool_prepare_ctx ((EditingToolsCropTool*) self, ctx, dim);
#line 8071 "EditingTools.c"
}

static void
_editing_tools_crop_tool_on_resized_pixbuf_editing_tools_photo_canvas_resized_scaled_pixbuf (EditingToolsPhotoCanvas* _sender,
                                                                                             Dimensions* old_dim,
                                                                                             GdkPixbuf* scaled,
                                                                                             GdkRectangle* scaled_position,
                                                                                             gpointer self)
{
#line 1160 "../src/editing_tools/EditingTools.vala"
	editing_tools_crop_tool_on_resized_pixbuf ((EditingToolsCropTool*) self, old_dim, scaled, scaled_position);
#line 8083 "EditingTools.c"
}

static void
editing_tools_crop_tool_bind_canvas_handlers (EditingToolsCropTool* self,
                                              EditingToolsPhotoCanvas* canvas)
{
#line 1158 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_CROP_TOOL (self));
#line 1158 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_PHOTO_CANVAS (canvas));
#line 1159 "../src/editing_tools/EditingTools.vala"
	g_signal_connect (canvas, "new-surface", (GCallback) _editing_tools_crop_tool_prepare_ctx_editing_tools_photo_canvas_new_surface, self);
#line 1160 "../src/editing_tools/EditingTools.vala"
	g_signal_connect (canvas, "resized-scaled-pixbuf", (GCallback) _editing_tools_crop_tool_on_resized_pixbuf_editing_tools_photo_canvas_resized_scaled_pixbuf, self);
#line 8098 "EditingTools.c"
}

static void
editing_tools_crop_tool_unbind_canvas_handlers (EditingToolsCropTool* self,
                                                EditingToolsPhotoCanvas* canvas)
{
	guint _tmp0_;
	guint _tmp1_;
#line 1163 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_CROP_TOOL (self));
#line 1163 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_PHOTO_CANVAS (canvas));
#line 1164 "../src/editing_tools/EditingTools.vala"
	g_signal_parse_name ("new-surface", EDITING_TOOLS_TYPE_PHOTO_CANVAS, &_tmp0_, NULL, FALSE);
#line 1164 "../src/editing_tools/EditingTools.vala"
	g_signal_handlers_disconnect_matched (canvas, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _editing_tools_crop_tool_prepare_ctx_editing_tools_photo_canvas_new_surface, self);
#line 1165 "../src/editing_tools/EditingTools.vala"
	g_signal_parse_name ("resized-scaled-pixbuf", EDITING_TOOLS_TYPE_PHOTO_CANVAS, &_tmp1_, NULL, FALSE);
#line 1165 "../src/editing_tools/EditingTools.vala"
	g_signal_handlers_disconnect_matched (canvas, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _editing_tools_crop_tool_on_resized_pixbuf_editing_tools_photo_canvas_resized_scaled_pixbuf, self);
#line 8119 "EditingTools.c"
}

static void
_editing_tools_crop_tool_on_crop_ok_gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self)
{
#line 1170 "../src/editing_tools/EditingTools.vala"
	editing_tools_crop_tool_on_crop_ok ((EditingToolsCropTool*) self);
#line 8128 "EditingTools.c"
}

static void
_editing_tools_editing_tool_notify_cancel_gtk_button_clicked (GtkButton* _sender,
                                                              gpointer self)
{
#line 1171 "../src/editing_tools/EditingTools.vala"
	editing_tools_editing_tool_notify_cancel ((EditingToolsEditingTool*) self);
#line 8137 "EditingTools.c"
}

static void
_editing_tools_crop_tool_constraint_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                   gpointer self)
{
#line 1172 "../src/editing_tools/EditingTools.vala"
	editing_tools_crop_tool_constraint_changed ((EditingToolsCropTool*) self);
#line 8146 "EditingTools.c"
}

static void
_editing_tools_crop_tool_on_pivot_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                     gpointer self)
{
#line 1173 "../src/editing_tools/EditingTools.vala"
	editing_tools_crop_tool_on_pivot_button_clicked ((EditingToolsCropTool*) self);
#line 8155 "EditingTools.c"
}

static gboolean
_editing_tools_crop_tool_on_width_entry_focus_out_gtk_widget_focus_out_event (GtkWidget* _sender,
                                                                              GdkEventFocus* event,
                                                                              gpointer self)
{
	gboolean result;
	result = editing_tools_crop_tool_on_width_entry_focus_out ((EditingToolsCropTool*) self, event);
#line 1176 "../src/editing_tools/EditingTools.vala"
	return result;
#line 8167 "EditingTools.c"
}

static gboolean
_editing_tools_crop_tool_on_height_entry_focus_out_gtk_widget_focus_out_event (GtkWidget* _sender,
                                                                               GdkEventFocus* event,
                                                                               gpointer self)
{
	gboolean result;
	result = editing_tools_crop_tool_on_height_entry_focus_out ((EditingToolsCropTool*) self, event);
#line 1177 "../src/editing_tools/EditingTools.vala"
	return result;
#line 8179 "EditingTools.c"
}

static void
_editing_tools_crop_tool_on_width_insert_text_gtk_editable_insert_text (GtkEditable* _sender,
                                                                        const gchar* new_text,
                                                                        gint new_text_length,
                                                                        gint* position,
                                                                        gpointer self)
{
#line 1178 "../src/editing_tools/EditingTools.vala"
	editing_tools_crop_tool_on_width_insert_text ((EditingToolsCropTool*) self, new_text, new_text_length, position);
#line 8191 "EditingTools.c"
}

static void
_editing_tools_crop_tool_on_height_insert_text_gtk_editable_insert_text (GtkEditable* _sender,
                                                                         const gchar* new_text,
                                                                         gint new_text_length,
                                                                         gint* position,
                                                                         gpointer self)
{
#line 1179 "../src/editing_tools/EditingTools.vala"
	editing_tools_crop_tool_on_height_insert_text ((EditingToolsCropTool*) self, new_text, new_text_length, position);
#line 8203 "EditingTools.c"
}

static void
editing_tools_crop_tool_bind_window_handlers (EditingToolsCropTool* self)
{
	EditingToolsCropToolCropToolWindow* _tmp0_;
	EditingToolsCropToolCropToolWindow* _tmp1_;
	GtkButton* _tmp2_;
	EditingToolsCropToolCropToolWindow* _tmp3_;
	GtkButton* _tmp4_;
	EditingToolsCropToolCropToolWindow* _tmp5_;
	GtkComboBox* _tmp6_;
	EditingToolsCropToolCropToolWindow* _tmp7_;
	GtkButton* _tmp8_;
	EditingToolsCropToolCropToolWindow* _tmp9_;
	GtkEntry* _tmp10_;
	EditingToolsCropToolCropToolWindow* _tmp11_;
	GtkEntry* _tmp12_;
	EditingToolsCropToolCropToolWindow* _tmp13_;
	GtkEntry* _tmp14_;
	EditingToolsCropToolCropToolWindow* _tmp15_;
	GtkEntry* _tmp16_;
#line 1168 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_CROP_TOOL (self));
#line 1169 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->crop_tool_window;
#line 1169 "../src/editing_tools/EditingTools.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget), "key-press-event", (GCallback) _editing_tools_editing_tool_on_keypress_gtk_widget_key_press_event, G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool));
#line 1170 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = self->priv->crop_tool_window;
#line 1170 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = _tmp1_->ok_button;
#line 1170 "../src/editing_tools/EditingTools.vala"
	g_signal_connect (_tmp2_, "clicked", (GCallback) _editing_tools_crop_tool_on_crop_ok_gtk_button_clicked, self);
#line 1171 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = self->priv->crop_tool_window;
#line 1171 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = _tmp3_->cancel_button;
#line 1171 "../src/editing_tools/EditingTools.vala"
	g_signal_connect (_tmp4_, "clicked", (GCallback) _editing_tools_editing_tool_notify_cancel_gtk_button_clicked, G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool));
#line 1172 "../src/editing_tools/EditingTools.vala"
	_tmp5_ = self->priv->crop_tool_window;
#line 1172 "../src/editing_tools/EditingTools.vala"
	_tmp6_ = _tmp5_->constraint_combo;
#line 1172 "../src/editing_tools/EditingTools.vala"
	g_signal_connect (_tmp6_, "changed", (GCallback) _editing_tools_crop_tool_constraint_changed_gtk_combo_box_changed, self);
#line 1173 "../src/editing_tools/EditingTools.vala"
	_tmp7_ = self->priv->crop_tool_window;
#line 1173 "../src/editing_tools/EditingTools.vala"
	_tmp8_ = _tmp7_->pivot_reticle_button;
#line 1173 "../src/editing_tools/EditingTools.vala"
	g_signal_connect (_tmp8_, "clicked", (GCallback) _editing_tools_crop_tool_on_pivot_button_clicked_gtk_button_clicked, self);
#line 1176 "../src/editing_tools/EditingTools.vala"
	_tmp9_ = self->priv->crop_tool_window;
#line 1176 "../src/editing_tools/EditingTools.vala"
	_tmp10_ = _tmp9_->custom_width_entry;
#line 1176 "../src/editing_tools/EditingTools.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, gtk_widget_get_type (), GtkWidget), "focus-out-event", (GCallback) _editing_tools_crop_tool_on_width_entry_focus_out_gtk_widget_focus_out_event, self);
#line 1177 "../src/editing_tools/EditingTools.vala"
	_tmp11_ = self->priv->crop_tool_window;
#line 1177 "../src/editing_tools/EditingTools.vala"
	_tmp12_ = _tmp11_->custom_height_entry;
#line 1177 "../src/editing_tools/EditingTools.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, gtk_widget_get_type (), GtkWidget), "focus-out-event", (GCallback) _editing_tools_crop_tool_on_height_entry_focus_out_gtk_widget_focus_out_event, self);
#line 1178 "../src/editing_tools/EditingTools.vala"
	_tmp13_ = self->priv->crop_tool_window;
#line 1178 "../src/editing_tools/EditingTools.vala"
	_tmp14_ = _tmp13_->custom_width_entry;
#line 1178 "../src/editing_tools/EditingTools.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, gtk_editable_get_type (), GtkEditable), "insert-text", (GCallback) _editing_tools_crop_tool_on_width_insert_text_gtk_editable_insert_text, self);
#line 1179 "../src/editing_tools/EditingTools.vala"
	_tmp15_ = self->priv->crop_tool_window;
#line 1179 "../src/editing_tools/EditingTools.vala"
	_tmp16_ = _tmp15_->custom_height_entry;
#line 1179 "../src/editing_tools/EditingTools.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, gtk_editable_get_type (), GtkEditable), "insert-text", (GCallback) _editing_tools_crop_tool_on_height_insert_text_gtk_editable_insert_text, self);
#line 8280 "EditingTools.c"
}

static void
editing_tools_crop_tool_unbind_window_handlers (EditingToolsCropTool* self)
{
	EditingToolsCropToolCropToolWindow* _tmp0_;
	guint _tmp1_;
	EditingToolsCropToolCropToolWindow* _tmp2_;
	GtkButton* _tmp3_;
	guint _tmp4_;
	EditingToolsCropToolCropToolWindow* _tmp5_;
	GtkButton* _tmp6_;
	guint _tmp7_;
	EditingToolsCropToolCropToolWindow* _tmp8_;
	GtkComboBox* _tmp9_;
	guint _tmp10_;
	EditingToolsCropToolCropToolWindow* _tmp11_;
	GtkButton* _tmp12_;
	guint _tmp13_;
	EditingToolsCropToolCropToolWindow* _tmp14_;
	GtkEntry* _tmp15_;
	guint _tmp16_;
	EditingToolsCropToolCropToolWindow* _tmp17_;
	GtkEntry* _tmp18_;
	guint _tmp19_;
	EditingToolsCropToolCropToolWindow* _tmp20_;
	GtkEntry* _tmp21_;
	guint _tmp22_;
#line 1182 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_CROP_TOOL (self));
#line 1183 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->crop_tool_window;
#line 1183 "../src/editing_tools/EditingTools.vala"
	g_signal_parse_name ("key-press-event", gtk_widget_get_type (), &_tmp1_, NULL, FALSE);
#line 1183 "../src/editing_tools/EditingTools.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _editing_tools_editing_tool_on_keypress_gtk_widget_key_press_event, G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool));
#line 1184 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = self->priv->crop_tool_window;
#line 1184 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = _tmp2_->ok_button;
#line 1184 "../src/editing_tools/EditingTools.vala"
	g_signal_parse_name ("clicked", gtk_button_get_type (), &_tmp4_, NULL, FALSE);
#line 1184 "../src/editing_tools/EditingTools.vala"
	g_signal_handlers_disconnect_matched (_tmp3_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _editing_tools_crop_tool_on_crop_ok_gtk_button_clicked, self);
#line 1185 "../src/editing_tools/EditingTools.vala"
	_tmp5_ = self->priv->crop_tool_window;
#line 1185 "../src/editing_tools/EditingTools.vala"
	_tmp6_ = _tmp5_->cancel_button;
#line 1185 "../src/editing_tools/EditingTools.vala"
	g_signal_parse_name ("clicked", gtk_button_get_type (), &_tmp7_, NULL, FALSE);
#line 1185 "../src/editing_tools/EditingTools.vala"
	g_signal_handlers_disconnect_matched (_tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _editing_tools_editing_tool_notify_cancel_gtk_button_clicked, G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool));
#line 1186 "../src/editing_tools/EditingTools.vala"
	_tmp8_ = self->priv->crop_tool_window;
#line 1186 "../src/editing_tools/EditingTools.vala"
	_tmp9_ = _tmp8_->constraint_combo;
#line 1186 "../src/editing_tools/EditingTools.vala"
	g_signal_parse_name ("changed", gtk_combo_box_get_type (), &_tmp10_, NULL, FALSE);
#line 1186 "../src/editing_tools/EditingTools.vala"
	g_signal_handlers_disconnect_matched (_tmp9_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp10_, 0, NULL, (GCallback) _editing_tools_crop_tool_constraint_changed_gtk_combo_box_changed, self);
#line 1187 "../src/editing_tools/EditingTools.vala"
	_tmp11_ = self->priv->crop_tool_window;
#line 1187 "../src/editing_tools/EditingTools.vala"
	_tmp12_ = _tmp11_->pivot_reticle_button;
#line 1187 "../src/editing_tools/EditingTools.vala"
	g_signal_parse_name ("clicked", gtk_button_get_type (), &_tmp13_, NULL, FALSE);
#line 1187 "../src/editing_tools/EditingTools.vala"
	g_signal_handlers_disconnect_matched (_tmp12_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp13_, 0, NULL, (GCallback) _editing_tools_crop_tool_on_pivot_button_clicked_gtk_button_clicked, self);
#line 1190 "../src/editing_tools/EditingTools.vala"
	_tmp14_ = self->priv->crop_tool_window;
#line 1190 "../src/editing_tools/EditingTools.vala"
	_tmp15_ = _tmp14_->custom_width_entry;
#line 1190 "../src/editing_tools/EditingTools.vala"
	g_signal_parse_name ("focus-out-event", gtk_widget_get_type (), &_tmp16_, NULL, FALSE);
#line 1190 "../src/editing_tools/EditingTools.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, gtk_widget_get_type (), GtkWidget), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp16_, 0, NULL, (GCallback) _editing_tools_crop_tool_on_width_entry_focus_out_gtk_widget_focus_out_event, self);
#line 1191 "../src/editing_tools/EditingTools.vala"
	_tmp17_ = self->priv->crop_tool_window;
#line 1191 "../src/editing_tools/EditingTools.vala"
	_tmp18_ = _tmp17_->custom_height_entry;
#line 1191 "../src/editing_tools/EditingTools.vala"
	g_signal_parse_name ("focus-out-event", gtk_widget_get_type (), &_tmp19_, NULL, FALSE);
#line 1191 "../src/editing_tools/EditingTools.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, gtk_widget_get_type (), GtkWidget), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp19_, 0, NULL, (GCallback) _editing_tools_crop_tool_on_height_entry_focus_out_gtk_widget_focus_out_event, self);
#line 1192 "../src/editing_tools/EditingTools.vala"
	_tmp20_ = self->priv->crop_tool_window;
#line 1192 "../src/editing_tools/EditingTools.vala"
	_tmp21_ = _tmp20_->custom_width_entry;
#line 1192 "../src/editing_tools/EditingTools.vala"
	g_signal_parse_name ("insert-text", gtk_editable_get_type (), &_tmp22_, NULL, FALSE);
#line 1192 "../src/editing_tools/EditingTools.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, gtk_editable_get_type (), GtkEditable), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp22_, 0, NULL, (GCallback) _editing_tools_crop_tool_on_width_insert_text_gtk_editable_insert_text, self);
#line 8373 "EditingTools.c"
}

static gboolean
editing_tools_crop_tool_real_on_keypress (EditingToolsEditingTool* base,
                                          GdkEventKey* event)
{
	EditingToolsCropTool * self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	gboolean result;
#line 1195 "../src/editing_tools/EditingTools.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, EDITING_TOOLS_TYPE_CROP_TOOL, EditingToolsCropTool);
#line 1195 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 1196 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = gdk_keyval_name (event->keyval);
#line 1196 "../src/editing_tools/EditingTools.vala"
	if (g_strcmp0 (_tmp2_, "KP_Enter") == 0) {
#line 1196 "../src/editing_tools/EditingTools.vala"
		_tmp1_ = TRUE;
#line 8395 "EditingTools.c"
	} else {
		const gchar* _tmp3_;
#line 1197 "../src/editing_tools/EditingTools.vala"
		_tmp3_ = gdk_keyval_name (event->keyval);
#line 1197 "../src/editing_tools/EditingTools.vala"
		_tmp1_ = g_strcmp0 (_tmp3_, "Enter") == 0;
#line 8402 "EditingTools.c"
	}
#line 1196 "../src/editing_tools/EditingTools.vala"
	if (_tmp1_) {
#line 1196 "../src/editing_tools/EditingTools.vala"
		_tmp0_ = TRUE;
#line 8408 "EditingTools.c"
	} else {
		const gchar* _tmp4_;
#line 1198 "../src/editing_tools/EditingTools.vala"
		_tmp4_ = gdk_keyval_name (event->keyval);
#line 1198 "../src/editing_tools/EditingTools.vala"
		_tmp0_ = g_strcmp0 (_tmp4_, "Return") == 0;
#line 8415 "EditingTools.c"
	}
#line 1196 "../src/editing_tools/EditingTools.vala"
	if (_tmp0_) {
#line 1199 "../src/editing_tools/EditingTools.vala"
		editing_tools_crop_tool_on_crop_ok (self);
#line 1200 "../src/editing_tools/EditingTools.vala"
		result = TRUE;
#line 1200 "../src/editing_tools/EditingTools.vala"
		return result;
#line 8425 "EditingTools.c"
	}
#line 1203 "../src/editing_tools/EditingTools.vala"
	result = EDITING_TOOLS_EDITING_TOOL_CLASS (editing_tools_crop_tool_parent_class)->on_keypress (G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool), event);
#line 1203 "../src/editing_tools/EditingTools.vala"
	return result;
#line 8431 "EditingTools.c"
}

static void
editing_tools_crop_tool_on_pivot_button_clicked (EditingToolsCropTool* self)
{
	EditingToolsCropToolConstraintDescription* _tmp0_;
	EditingToolsCropToolConstraintDescription* _tmp1_;
	gboolean _tmp2_;
#line 1206 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_CROP_TOOL (self));
#line 1207 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = editing_tools_crop_tool_get_selected_constraint (self);
#line 1207 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = _tmp0_;
#line 1207 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = _tmp1_->aspect_ratio == EDITING_TOOLS_CROP_TOOL_CUSTOM_ASPECT_RATIO;
#line 1207 "../src/editing_tools/EditingTools.vala"
	_editing_tools_crop_tool_constraint_description_unref0 (_tmp1_);
#line 1207 "../src/editing_tools/EditingTools.vala"
	if (_tmp2_) {
#line 8452 "EditingTools.c"
		gchar* width_text = NULL;
		EditingToolsCropToolCropToolWindow* _tmp3_;
		GtkEntry* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* height_text = NULL;
		EditingToolsCropToolCropToolWindow* _tmp7_;
		GtkEntry* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		EditingToolsCropToolCropToolWindow* _tmp11_;
		GtkEntry* _tmp12_;
		const gchar* _tmp13_;
		EditingToolsCropToolCropToolWindow* _tmp14_;
		GtkEntry* _tmp15_;
		const gchar* _tmp16_;
		gint temp = 0;
#line 1208 "../src/editing_tools/EditingTools.vala"
		_tmp3_ = self->priv->crop_tool_window;
#line 1208 "../src/editing_tools/EditingTools.vala"
		_tmp4_ = _tmp3_->custom_width_entry;
#line 1208 "../src/editing_tools/EditingTools.vala"
		_tmp5_ = gtk_entry_get_text (_tmp4_);
#line 1208 "../src/editing_tools/EditingTools.vala"
		_tmp6_ = g_strdup (_tmp5_);
#line 1208 "../src/editing_tools/EditingTools.vala"
		width_text = _tmp6_;
#line 1209 "../src/editing_tools/EditingTools.vala"
		_tmp7_ = self->priv->crop_tool_window;
#line 1209 "../src/editing_tools/EditingTools.vala"
		_tmp8_ = _tmp7_->custom_height_entry;
#line 1209 "../src/editing_tools/EditingTools.vala"
		_tmp9_ = gtk_entry_get_text (_tmp8_);
#line 1209 "../src/editing_tools/EditingTools.vala"
		_tmp10_ = g_strdup (_tmp9_);
#line 1209 "../src/editing_tools/EditingTools.vala"
		height_text = _tmp10_;
#line 1210 "../src/editing_tools/EditingTools.vala"
		_tmp11_ = self->priv->crop_tool_window;
#line 1210 "../src/editing_tools/EditingTools.vala"
		_tmp12_ = _tmp11_->custom_width_entry;
#line 1210 "../src/editing_tools/EditingTools.vala"
		_tmp13_ = height_text;
#line 1210 "../src/editing_tools/EditingTools.vala"
		gtk_entry_set_text (_tmp12_, _tmp13_);
#line 1211 "../src/editing_tools/EditingTools.vala"
		_tmp14_ = self->priv->crop_tool_window;
#line 1211 "../src/editing_tools/EditingTools.vala"
		_tmp15_ = _tmp14_->custom_height_entry;
#line 1211 "../src/editing_tools/EditingTools.vala"
		_tmp16_ = width_text;
#line 1211 "../src/editing_tools/EditingTools.vala"
		gtk_entry_set_text (_tmp15_, _tmp16_);
#line 1213 "../src/editing_tools/EditingTools.vala"
		temp = self->priv->custom_width;
#line 1214 "../src/editing_tools/EditingTools.vala"
		self->priv->custom_width = self->priv->custom_height;
#line 1215 "../src/editing_tools/EditingTools.vala"
		self->priv->custom_height = temp;
#line 1207 "../src/editing_tools/EditingTools.vala"
		_g_free0 (height_text);
#line 1207 "../src/editing_tools/EditingTools.vala"
		_g_free0 (width_text);
#line 8516 "EditingTools.c"
	}
#line 1217 "../src/editing_tools/EditingTools.vala"
	self->priv->reticle_orientation = editing_tools_crop_tool_reticle_orientation_toggle (self->priv->reticle_orientation);
#line 1218 "../src/editing_tools/EditingTools.vala"
	editing_tools_crop_tool_constraint_changed (self);
#line 8522 "EditingTools.c"
}

static void
editing_tools_crop_tool_real_deactivate (EditingToolsEditingTool* base)
{
	EditingToolsCropTool * self;
	EditingToolsPhotoCanvas* _tmp0_;
	EditingToolsCropToolCropToolWindow* _tmp2_;
	EditingToolsPhotoCanvas* _tmp5_;
#line 1221 "../src/editing_tools/EditingTools.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, EDITING_TOOLS_TYPE_CROP_TOOL, EditingToolsCropTool);
#line 1222 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 1222 "../src/editing_tools/EditingTools.vala"
	if (_tmp0_ != NULL) {
#line 8538 "EditingTools.c"
		EditingToolsPhotoCanvas* _tmp1_;
#line 1223 "../src/editing_tools/EditingTools.vala"
		_tmp1_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 1223 "../src/editing_tools/EditingTools.vala"
		editing_tools_crop_tool_unbind_canvas_handlers (self, _tmp1_);
#line 8544 "EditingTools.c"
	}
#line 1225 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = self->priv->crop_tool_window;
#line 1225 "../src/editing_tools/EditingTools.vala"
	if (_tmp2_ != NULL) {
#line 8550 "EditingTools.c"
		EditingToolsCropToolCropToolWindow* _tmp3_;
		EditingToolsCropToolCropToolWindow* _tmp4_;
#line 1226 "../src/editing_tools/EditingTools.vala"
		editing_tools_crop_tool_unbind_window_handlers (self);
#line 1227 "../src/editing_tools/EditingTools.vala"
		_tmp3_ = self->priv->crop_tool_window;
#line 1227 "../src/editing_tools/EditingTools.vala"
		gtk_widget_hide (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_widget_get_type (), GtkWidget));
#line 1228 "../src/editing_tools/EditingTools.vala"
		_tmp4_ = self->priv->crop_tool_window;
#line 1228 "../src/editing_tools/EditingTools.vala"
		gtk_widget_destroy (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_widget_get_type (), GtkWidget));
#line 1229 "../src/editing_tools/EditingTools.vala"
		_g_object_unref0 (self->priv->crop_tool_window);
#line 1229 "../src/editing_tools/EditingTools.vala"
		self->priv->crop_tool_window = NULL;
#line 8567 "EditingTools.c"
	}
#line 1233 "../src/editing_tools/EditingTools.vala"
	_tmp5_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 1233 "../src/editing_tools/EditingTools.vala"
	if (_tmp5_ != NULL) {
#line 8573 "EditingTools.c"
		EditingToolsPhotoCanvas* _tmp6_;
#line 1234 "../src/editing_tools/EditingTools.vala"
		_tmp6_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 1234 "../src/editing_tools/EditingTools.vala"
		editing_tools_photo_canvas_set_cursor (_tmp6_, GDK_LEFT_PTR);
#line 8579 "EditingTools.c"
	}
#line 1237 "../src/editing_tools/EditingTools.vala"
	_cairo_surface_destroy0 (self->priv->crop_surface);
#line 1237 "../src/editing_tools/EditingTools.vala"
	self->priv->crop_surface = NULL;
#line 1239 "../src/editing_tools/EditingTools.vala"
	EDITING_TOOLS_EDITING_TOOL_CLASS (editing_tools_crop_tool_parent_class)->deactivate (G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool));
#line 8587 "EditingTools.c"
}

static EditingToolsEditingToolWindow*
editing_tools_crop_tool_real_get_tool_window (EditingToolsEditingTool* base)
{
	EditingToolsCropTool * self;
	EditingToolsCropToolCropToolWindow* _tmp0_;
	EditingToolsEditingToolWindow* _tmp1_;
	EditingToolsEditingToolWindow* result;
#line 1242 "../src/editing_tools/EditingTools.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, EDITING_TOOLS_TYPE_CROP_TOOL, EditingToolsCropTool);
#line 1243 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->crop_tool_window;
#line 1243 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, EDITING_TOOLS_TYPE_EDITING_TOOL_WINDOW, EditingToolsEditingToolWindow));
#line 1243 "../src/editing_tools/EditingTools.vala"
	result = _tmp1_;
#line 1243 "../src/editing_tools/EditingTools.vala"
	return result;
#line 8607 "EditingTools.c"
}

static GdkPixbuf*
editing_tools_crop_tool_real_get_display_pixbuf (EditingToolsEditingTool* base,
                                                 Scaling* scaling,
                                                 Photo* photo,
                                                 Dimensions* max_dim,
                                                 GError** error)
{
	EditingToolsCropTool * self;
	Dimensions _vala_max_dim = {0};
	Dimensions _tmp0_ = {0};
	GdkPixbuf* _tmp1_ = NULL;
	Scaling _tmp2_;
	GdkPixbuf* _tmp3_;
	GdkPixbuf* _tmp4_;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result;
#line 1246 "../src/editing_tools/EditingTools.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, EDITING_TOOLS_TYPE_CROP_TOOL, EditingToolsCropTool);
#line 1246 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 1246 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (IS_PHOTO (photo), NULL);
#line 1248 "../src/editing_tools/EditingTools.vala"
	media_source_get_dimensions (G_TYPE_CHECK_INSTANCE_CAST (photo, TYPE_MEDIA_SOURCE, MediaSource), PHOTO_EXCEPTION_CROP, &_tmp0_);
#line 1248 "../src/editing_tools/EditingTools.vala"
	_vala_max_dim = _tmp0_;
#line 1250 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = *scaling;
#line 1250 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = photo_get_pixbuf_with_options (photo, &_tmp2_, PHOTO_EXCEPTION_CROP, BACKING_FETCH_MODE_BASELINE, &_inner_error0_);
#line 1250 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = _tmp3_;
#line 1250 "../src/editing_tools/EditingTools.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1250 "../src/editing_tools/EditingTools.vala"
		g_propagate_error (error, _inner_error0_);
#line 1250 "../src/editing_tools/EditingTools.vala"
		return NULL;
#line 8648 "EditingTools.c"
	}
#line 1250 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = _tmp1_;
#line 1250 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = NULL;
#line 1250 "../src/editing_tools/EditingTools.vala"
	result = _tmp4_;
#line 1250 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (_tmp1_);
#line 1250 "../src/editing_tools/EditingTools.vala"
	if (max_dim) {
#line 1250 "../src/editing_tools/EditingTools.vala"
		*max_dim = _vala_max_dim;
#line 8662 "EditingTools.c"
	}
#line 1250 "../src/editing_tools/EditingTools.vala"
	return result;
#line 8666 "EditingTools.c"
}

static void
editing_tools_crop_tool_prepare_ctx (EditingToolsCropTool* self,
                                     cairo_t* ctx,
                                     Dimensions* dim)
{
	gdouble scale = 0.0;
	cairo_surface_t* _tmp0_;
	cairo_t* _tmp1_;
	cairo_t* _tmp2_;
	cairo_t* _tmp3_;
	cairo_surface_t* _tmp4_;
	cairo_t* _tmp5_;
	cairo_t* _tmp6_;
	cairo_t* _tmp7_;
	cairo_surface_t* _tmp8_;
	cairo_t* _tmp9_;
	cairo_t* _tmp10_;
	cairo_t* _tmp11_;
	cairo_surface_t* _tmp12_;
	cairo_t* _tmp13_;
	cairo_t* _tmp14_;
	cairo_t* _tmp15_;
#line 1253 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_CROP_TOOL (self));
#line 1253 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (ctx != NULL);
#line 1253 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (dim != NULL);
#line 1254 "../src/editing_tools/EditingTools.vala"
	scale = application_get_scale ();
#line 1255 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = cairo_get_target (ctx);
#line 1255 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = cairo_create (_tmp0_);
#line 1255 "../src/editing_tools/EditingTools.vala"
	_cairo_destroy0 (self->priv->wide_black_ctx);
#line 1255 "../src/editing_tools/EditingTools.vala"
	self->priv->wide_black_ctx = _tmp1_;
#line 1256 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = self->priv->wide_black_ctx;
#line 1256 "../src/editing_tools/EditingTools.vala"
	set_source_color_from_string (_tmp2_, "#000");
#line 1257 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = self->priv->wide_black_ctx;
#line 1257 "../src/editing_tools/EditingTools.vala"
	cairo_set_line_width (_tmp3_, 1 * scale);
#line 1259 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = cairo_get_target (ctx);
#line 1259 "../src/editing_tools/EditingTools.vala"
	_tmp5_ = cairo_create (_tmp4_);
#line 1259 "../src/editing_tools/EditingTools.vala"
	_cairo_destroy0 (self->priv->wide_white_ctx);
#line 1259 "../src/editing_tools/EditingTools.vala"
	self->priv->wide_white_ctx = _tmp5_;
#line 1260 "../src/editing_tools/EditingTools.vala"
	_tmp6_ = self->priv->wide_white_ctx;
#line 1260 "../src/editing_tools/EditingTools.vala"
	set_source_color_from_string (_tmp6_, "#FFF");
#line 1261 "../src/editing_tools/EditingTools.vala"
	_tmp7_ = self->priv->wide_white_ctx;
#line 1261 "../src/editing_tools/EditingTools.vala"
	cairo_set_line_width (_tmp7_, 1 * scale);
#line 1263 "../src/editing_tools/EditingTools.vala"
	_tmp8_ = cairo_get_target (ctx);
#line 1263 "../src/editing_tools/EditingTools.vala"
	_tmp9_ = cairo_create (_tmp8_);
#line 1263 "../src/editing_tools/EditingTools.vala"
	_cairo_destroy0 (self->priv->thin_white_ctx);
#line 1263 "../src/editing_tools/EditingTools.vala"
	self->priv->thin_white_ctx = _tmp9_;
#line 1264 "../src/editing_tools/EditingTools.vala"
	_tmp10_ = self->priv->thin_white_ctx;
#line 1264 "../src/editing_tools/EditingTools.vala"
	set_source_color_from_string (_tmp10_, "#FFF");
#line 1265 "../src/editing_tools/EditingTools.vala"
	_tmp11_ = self->priv->thin_white_ctx;
#line 1265 "../src/editing_tools/EditingTools.vala"
	cairo_set_line_width (_tmp11_, 0.5 * scale);
#line 1267 "../src/editing_tools/EditingTools.vala"
	_tmp12_ = cairo_get_target (ctx);
#line 1267 "../src/editing_tools/EditingTools.vala"
	_tmp13_ = cairo_create (_tmp12_);
#line 1267 "../src/editing_tools/EditingTools.vala"
	_cairo_destroy0 (self->priv->text_ctx);
#line 1267 "../src/editing_tools/EditingTools.vala"
	self->priv->text_ctx = _tmp13_;
#line 1268 "../src/editing_tools/EditingTools.vala"
	_tmp14_ = self->priv->text_ctx;
#line 1268 "../src/editing_tools/EditingTools.vala"
	cairo_select_font_face (_tmp14_, "Sans", CAIRO_FONT_SLANT_NORMAL, CAIRO_FONT_WEIGHT_NORMAL);
#line 1269 "../src/editing_tools/EditingTools.vala"
	_tmp15_ = self->priv->text_ctx;
#line 1269 "../src/editing_tools/EditingTools.vala"
	cairo_set_font_size (_tmp15_, 10.0 * scale);
#line 8763 "EditingTools.c"
}

static void
editing_tools_crop_tool_on_resized_pixbuf (EditingToolsCropTool* self,
                                           Dimensions* old_dim,
                                           GdkPixbuf* scaled,
                                           GdkRectangle* scaled_position)
{
	Dimensions new_dim = {0};
	Dimensions _tmp0_ = {0};
	Dimensions uncropped_dim = {0};
	EditingToolsPhotoCanvas* _tmp1_;
	Photo* _tmp2_;
	Photo* _tmp3_;
	Dimensions _tmp4_ = {0};
	Dimensions _tmp5_;
	Box crop = {0};
	Dimensions _tmp6_;
	Dimensions _tmp7_;
	Box _tmp8_ = {0};
	Dimensions _tmp9_;
	Dimensions _tmp10_;
	Box _tmp11_ = {0};
	cairo_surface_t* _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	cairo_surface_t* _tmp17_;
	cairo_t* ctx = NULL;
	cairo_surface_t* _tmp18_;
	cairo_t* _tmp19_;
#line 1272 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_CROP_TOOL (self));
#line 1272 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (old_dim != NULL);
#line 1272 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (scaled, gdk_pixbuf_get_type ()));
#line 1272 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (scaled_position != NULL);
#line 1273 "../src/editing_tools/EditingTools.vala"
	dimensions_for_pixbuf (scaled, &_tmp0_);
#line 1273 "../src/editing_tools/EditingTools.vala"
	new_dim = _tmp0_;
#line 1274 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 1274 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = editing_tools_photo_canvas_get_photo (_tmp1_);
#line 1274 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = _tmp2_;
#line 1274 "../src/editing_tools/EditingTools.vala"
	media_source_get_dimensions (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_MEDIA_SOURCE, MediaSource), PHOTO_EXCEPTION_CROP, &_tmp4_);
#line 1274 "../src/editing_tools/EditingTools.vala"
	_tmp5_ = _tmp4_;
#line 1274 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (_tmp3_);
#line 1274 "../src/editing_tools/EditingTools.vala"
	uncropped_dim = _tmp5_;
#line 1277 "../src/editing_tools/EditingTools.vala"
	_tmp6_ = *old_dim;
#line 1277 "../src/editing_tools/EditingTools.vala"
	_tmp7_ = uncropped_dim;
#line 1277 "../src/editing_tools/EditingTools.vala"
	box_get_scaled_similar (&self->priv->scaled_crop, &_tmp6_, &_tmp7_, &_tmp8_);
#line 1277 "../src/editing_tools/EditingTools.vala"
	crop = _tmp8_;
#line 1280 "../src/editing_tools/EditingTools.vala"
	_tmp9_ = uncropped_dim;
#line 1280 "../src/editing_tools/EditingTools.vala"
	_tmp10_ = new_dim;
#line 1280 "../src/editing_tools/EditingTools.vala"
	box_get_scaled_similar (&crop, &_tmp9_, &_tmp10_, &_tmp11_);
#line 1280 "../src/editing_tools/EditingTools.vala"
	self->priv->scaled_crop = _tmp11_;
#line 1281 "../src/editing_tools/EditingTools.vala"
	_tmp12_ = self->priv->crop_surface;
#line 1281 "../src/editing_tools/EditingTools.vala"
	if (_tmp12_ != NULL) {
#line 1282 "../src/editing_tools/EditingTools.vala"
		_cairo_surface_destroy0 (self->priv->crop_surface);
#line 1282 "../src/editing_tools/EditingTools.vala"
		self->priv->crop_surface = NULL;
#line 8846 "EditingTools.c"
	}
#line 1284 "../src/editing_tools/EditingTools.vala"
	_tmp13_ = gdk_pixbuf_get_width (scaled);
#line 1284 "../src/editing_tools/EditingTools.vala"
	_tmp14_ = _tmp13_;
#line 1284 "../src/editing_tools/EditingTools.vala"
	_tmp15_ = gdk_pixbuf_get_height (scaled);
#line 1284 "../src/editing_tools/EditingTools.vala"
	_tmp16_ = _tmp15_;
#line 1284 "../src/editing_tools/EditingTools.vala"
	_tmp17_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, _tmp14_, _tmp16_);
#line 1284 "../src/editing_tools/EditingTools.vala"
	_cairo_surface_destroy0 (self->priv->crop_surface);
#line 1284 "../src/editing_tools/EditingTools.vala"
	self->priv->crop_surface = _tmp17_;
#line 1285 "../src/editing_tools/EditingTools.vala"
	_tmp18_ = self->priv->crop_surface;
#line 1285 "../src/editing_tools/EditingTools.vala"
	_tmp19_ = cairo_create (_tmp18_);
#line 1285 "../src/editing_tools/EditingTools.vala"
	ctx = _tmp19_;
#line 1286 "../src/editing_tools/EditingTools.vala"
	cairo_set_source_rgba (ctx, 0.0, 0.0, 0.0, 1.0);
#line 1287 "../src/editing_tools/EditingTools.vala"
	cairo_paint (ctx);
#line 1272 "../src/editing_tools/EditingTools.vala"
	_cairo_destroy0 (ctx);
#line 8874 "EditingTools.c"
}

static void
editing_tools_crop_tool_real_on_left_click (EditingToolsEditingTool* base,
                                            gint x,
                                            gint y)
{
	EditingToolsCropTool * self;
	GdkRectangle scaled_pixbuf_pos = {0};
	EditingToolsPhotoCanvas* _tmp0_;
	GdkRectangle _tmp1_ = {0};
	Box offset_scaled_crop = {0};
	GdkRectangle _tmp2_;
	GdkRectangle _tmp3_;
	Box _tmp4_ = {0};
	gint xmul = 0;
	gint ymul = 0;
	GdkRectangle _tmp5_;
	GdkRectangle _tmp6_;
	EditingToolsPhotoCanvas* _tmp7_;
#line 1291 "../src/editing_tools/EditingTools.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, EDITING_TOOLS_TYPE_CROP_TOOL, EditingToolsCropTool);
#line 1292 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 1292 "../src/editing_tools/EditingTools.vala"
	editing_tools_photo_canvas_get_scaled_pixbuf_position (_tmp0_, &_tmp1_);
#line 1292 "../src/editing_tools/EditingTools.vala"
	scaled_pixbuf_pos = _tmp1_;
#line 1295 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = scaled_pixbuf_pos;
#line 1295 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = scaled_pixbuf_pos;
#line 1295 "../src/editing_tools/EditingTools.vala"
	box_get_offset (&self->priv->scaled_crop, _tmp2_.x, _tmp3_.y, &_tmp4_);
#line 1295 "../src/editing_tools/EditingTools.vala"
	offset_scaled_crop = _tmp4_;
#line 1297 "../src/editing_tools/EditingTools.vala"
	xmul = (gint) lround (x * application_get_scale ());
#line 1298 "../src/editing_tools/EditingTools.vala"
	ymul = (gint) lround (y * application_get_scale ());
#line 1301 "../src/editing_tools/EditingTools.vala"
	self->priv->in_manipulation = box_approx_location (&offset_scaled_crop, xmul, ymul);
#line 1302 "../src/editing_tools/EditingTools.vala"
	_tmp5_ = scaled_pixbuf_pos;
#line 1302 "../src/editing_tools/EditingTools.vala"
	self->priv->last_grab_x = xmul - _tmp5_.x;
#line 1303 "../src/editing_tools/EditingTools.vala"
	_tmp6_ = scaled_pixbuf_pos;
#line 1303 "../src/editing_tools/EditingTools.vala"
	self->priv->last_grab_y = ymul - _tmp6_.y;
#line 1306 "../src/editing_tools/EditingTools.vala"
	_tmp7_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 1306 "../src/editing_tools/EditingTools.vala"
	editing_tools_photo_canvas_repaint (_tmp7_);
#line 8929 "EditingTools.c"
}

static void
editing_tools_crop_tool_real_on_left_released (EditingToolsEditingTool* base,
                                               gint x,
                                               gint y)
{
	EditingToolsCropTool * self;
	EditingToolsPhotoCanvas* _tmp0_;
#line 1309 "../src/editing_tools/EditingTools.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, EDITING_TOOLS_TYPE_CROP_TOOL, EditingToolsCropTool);
#line 1311 "../src/editing_tools/EditingTools.vala"
	if (self->priv->in_manipulation == BOX_LOCATION_OUTSIDE) {
#line 1312 "../src/editing_tools/EditingTools.vala"
		return;
#line 8945 "EditingTools.c"
	}
#line 1315 "../src/editing_tools/EditingTools.vala"
	self->priv->in_manipulation = BOX_LOCATION_OUTSIDE;
#line 1316 "../src/editing_tools/EditingTools.vala"
	self->priv->last_grab_x = -1;
#line 1317 "../src/editing_tools/EditingTools.vala"
	self->priv->last_grab_y = -1;
#line 1319 "../src/editing_tools/EditingTools.vala"
	editing_tools_crop_tool_update_cursor (self, x, y);
#line 1322 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 1322 "../src/editing_tools/EditingTools.vala"
	editing_tools_photo_canvas_repaint (_tmp0_);
#line 8959 "EditingTools.c"
}

static void
editing_tools_crop_tool_real_on_motion (EditingToolsEditingTool* base,
                                        gint x,
                                        gint y,
                                        GdkModifierType mask)
{
	EditingToolsCropTool * self;
	EditingToolsPhotoCanvas* _tmp0_;
#line 1325 "../src/editing_tools/EditingTools.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, EDITING_TOOLS_TYPE_CROP_TOOL, EditingToolsCropTool);
#line 1328 "../src/editing_tools/EditingTools.vala"
	if (self->priv->in_manipulation != BOX_LOCATION_OUTSIDE) {
#line 1329 "../src/editing_tools/EditingTools.vala"
		editing_tools_crop_tool_on_canvas_manipulation (self, (gint) lround (x * application_get_scale ()), (gint) lround (y * application_get_scale ()));
#line 8976 "EditingTools.c"
	}
#line 1332 "../src/editing_tools/EditingTools.vala"
	editing_tools_crop_tool_update_cursor (self, x, y);
#line 1333 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 1333 "../src/editing_tools/EditingTools.vala"
	editing_tools_photo_canvas_repaint (_tmp0_);
#line 8984 "EditingTools.c"
}

static void
editing_tools_crop_tool_real_paint (EditingToolsEditingTool* base,
                                    cairo_t* default_ctx)
{
	EditingToolsCropTool * self;
	gdouble scale = 0.0;
	gint w = 0;
	EditingToolsPhotoCanvas* _tmp0_;
	GdkWindow* _tmp1_;
	GdkWindow* _tmp2_;
	gint _tmp3_;
	gint h = 0;
	EditingToolsPhotoCanvas* _tmp4_;
	GdkWindow* _tmp5_;
	GdkWindow* _tmp6_;
	gint _tmp7_;
	cairo_t* ctx = NULL;
	cairo_surface_t* _tmp8_;
	cairo_t* _tmp9_;
	Box _tmp10_;
	Box _tmp11_;
	EditingToolsPhotoCanvas* _tmp12_;
	cairo_surface_t* _tmp13_;
	Box _tmp14_;
#line 1336 "../src/editing_tools/EditingTools.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, EDITING_TOOLS_TYPE_CROP_TOOL, EditingToolsCropTool);
#line 1336 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (default_ctx != NULL);
#line 1337 "../src/editing_tools/EditingTools.vala"
	scale = application_get_scale ();
#line 1339 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 1339 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = editing_tools_photo_canvas_get_drawing_window (_tmp0_);
#line 1339 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = _tmp1_;
#line 1339 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = gdk_window_get_width (_tmp2_);
#line 1339 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (_tmp2_);
#line 1339 "../src/editing_tools/EditingTools.vala"
	w = _tmp3_;
#line 1340 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 1340 "../src/editing_tools/EditingTools.vala"
	_tmp5_ = editing_tools_photo_canvas_get_drawing_window (_tmp4_);
#line 1340 "../src/editing_tools/EditingTools.vala"
	_tmp6_ = _tmp5_;
#line 1340 "../src/editing_tools/EditingTools.vala"
	_tmp7_ = gdk_window_get_height (_tmp6_);
#line 1340 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (_tmp6_);
#line 1340 "../src/editing_tools/EditingTools.vala"
	h = _tmp7_;
#line 1342 "../src/editing_tools/EditingTools.vala"
	cairo_set_source_rgba (default_ctx, 0.0, 0.0, 0.0, 1.0);
#line 1343 "../src/editing_tools/EditingTools.vala"
	cairo_rectangle (default_ctx, (gdouble) 0, (gdouble) 0, w * scale, h * scale);
#line 1344 "../src/editing_tools/EditingTools.vala"
	cairo_fill (default_ctx);
#line 1345 "../src/editing_tools/EditingTools.vala"
	cairo_paint (default_ctx);
#line 1347 "../src/editing_tools/EditingTools.vala"
	_tmp8_ = self->priv->crop_surface;
#line 1347 "../src/editing_tools/EditingTools.vala"
	_tmp9_ = cairo_create (_tmp8_);
#line 1347 "../src/editing_tools/EditingTools.vala"
	ctx = _tmp9_;
#line 1348 "../src/editing_tools/EditingTools.vala"
	cairo_set_operator (ctx, CAIRO_OPERATOR_SOURCE);
#line 1349 "../src/editing_tools/EditingTools.vala"
	cairo_set_source_rgba (ctx, 0.0, 0.0, 0.0, 0.5);
#line 1350 "../src/editing_tools/EditingTools.vala"
	cairo_paint (ctx);
#line 1353 "../src/editing_tools/EditingTools.vala"
	cairo_set_source_rgba (ctx, 0.0, 0.0, 0.0, 0.0);
#line 1354 "../src/editing_tools/EditingTools.vala"
	_tmp10_ = self->priv->scaled_crop;
#line 1354 "../src/editing_tools/EditingTools.vala"
	_tmp11_ = self->priv->scaled_crop;
#line 1354 "../src/editing_tools/EditingTools.vala"
	cairo_rectangle (ctx, (gdouble) _tmp10_.left, (gdouble) _tmp11_.top, (gdouble) box_get_width (&self->priv->scaled_crop), (gdouble) box_get_height (&self->priv->scaled_crop));
#line 1356 "../src/editing_tools/EditingTools.vala"
	cairo_fill (ctx);
#line 1357 "../src/editing_tools/EditingTools.vala"
	_tmp12_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 1357 "../src/editing_tools/EditingTools.vala"
	_tmp13_ = self->priv->crop_surface;
#line 1357 "../src/editing_tools/EditingTools.vala"
	editing_tools_photo_canvas_paint_surface (_tmp12_, _tmp13_, TRUE);
#line 1360 "../src/editing_tools/EditingTools.vala"
	_tmp14_ = self->priv->scaled_crop;
#line 1360 "../src/editing_tools/EditingTools.vala"
	editing_tools_crop_tool_paint_crop_tool (self, &_tmp14_);
#line 1336 "../src/editing_tools/EditingTools.vala"
	_cairo_destroy0 (ctx);
#line 9083 "EditingTools.c"
}

static void
editing_tools_crop_tool_on_crop_ok (EditingToolsCropTool* self)
{
	ConfigFacade* _tmp0_;
	ConfigFacade* _tmp1_;
	EditingToolsCropToolCropToolWindow* _tmp2_;
	GtkComboBox* _tmp3_;
	ConfigFacade* _tmp4_;
	ConfigFacade* _tmp5_;
	ConfigFacade* _tmp6_;
	ConfigFacade* _tmp7_;
	Box crop = {0};
	EditingToolsPhotoCanvas* _tmp8_;
	GdkRectangle _tmp9_ = {0};
	Dimensions _tmp10_ = {0};
	EditingToolsPhotoCanvas* _tmp11_;
	Photo* _tmp12_;
	Photo* _tmp13_;
	Dimensions _tmp14_ = {0};
	Box _tmp15_ = {0};
	Box _tmp16_;
	GdkPixbuf* cropped = NULL;
	EditingToolsPhotoCanvas* _tmp17_;
	GdkPixbuf* _tmp18_;
	GdkPixbuf* _tmp19_;
	Box _tmp20_;
	Box _tmp21_;
	GdkPixbuf* _tmp22_;
	GdkPixbuf* _tmp23_;
	EditingToolsPhotoCanvas* _tmp24_;
	Photo* _tmp25_;
	Photo* _tmp26_;
	Box _tmp27_;
	CropCommand* _tmp28_;
	CropCommand* _tmp29_;
	Dimensions _tmp30_ = {0};
#line 1363 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_CROP_TOOL (self));
#line 1367 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = config_facade_get_instance ();
#line 1367 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = _tmp0_;
#line 1367 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = self->priv->crop_tool_window;
#line 1367 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = _tmp2_->constraint_combo;
#line 1367 "../src/editing_tools/EditingTools.vala"
	configuration_facade_set_last_crop_menu_choice (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, TYPE_CONFIGURATION_FACADE, ConfigurationFacade), gtk_combo_box_get_active (_tmp3_));
#line 1367 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (_tmp1_);
#line 1369 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = config_facade_get_instance ();
#line 1369 "../src/editing_tools/EditingTools.vala"
	_tmp5_ = _tmp4_;
#line 1369 "../src/editing_tools/EditingTools.vala"
	configuration_facade_set_last_crop_width (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, TYPE_CONFIGURATION_FACADE, ConfigurationFacade), self->priv->custom_width);
#line 1369 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (_tmp5_);
#line 1370 "../src/editing_tools/EditingTools.vala"
	_tmp6_ = config_facade_get_instance ();
#line 1370 "../src/editing_tools/EditingTools.vala"
	_tmp7_ = _tmp6_;
#line 1370 "../src/editing_tools/EditingTools.vala"
	configuration_facade_set_last_crop_height (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_CONFIGURATION_FACADE, ConfigurationFacade), self->priv->custom_height);
#line 1370 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (_tmp7_);
#line 1373 "../src/editing_tools/EditingTools.vala"
	_tmp8_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 1373 "../src/editing_tools/EditingTools.vala"
	editing_tools_photo_canvas_get_scaled_pixbuf_position (_tmp8_, &_tmp9_);
#line 1373 "../src/editing_tools/EditingTools.vala"
	dimensions_for_rectangle (&_tmp9_, &_tmp10_);
#line 1373 "../src/editing_tools/EditingTools.vala"
	_tmp11_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 1373 "../src/editing_tools/EditingTools.vala"
	_tmp12_ = editing_tools_photo_canvas_get_photo (_tmp11_);
#line 1373 "../src/editing_tools/EditingTools.vala"
	_tmp13_ = _tmp12_;
#line 1373 "../src/editing_tools/EditingTools.vala"
	media_source_get_dimensions (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, TYPE_MEDIA_SOURCE, MediaSource), PHOTO_EXCEPTION_CROP, &_tmp14_);
#line 1373 "../src/editing_tools/EditingTools.vala"
	box_get_scaled_similar (&self->priv->scaled_crop, &_tmp10_, &_tmp14_, &_tmp15_);
#line 1373 "../src/editing_tools/EditingTools.vala"
	_tmp16_ = _tmp15_;
#line 1373 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (_tmp13_);
#line 1373 "../src/editing_tools/EditingTools.vala"
	crop = _tmp16_;
#line 1378 "../src/editing_tools/EditingTools.vala"
	_tmp17_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 1378 "../src/editing_tools/EditingTools.vala"
	_tmp18_ = editing_tools_photo_canvas_get_scaled_pixbuf (_tmp17_);
#line 1378 "../src/editing_tools/EditingTools.vala"
	_tmp19_ = _tmp18_;
#line 1378 "../src/editing_tools/EditingTools.vala"
	_tmp20_ = self->priv->scaled_crop;
#line 1378 "../src/editing_tools/EditingTools.vala"
	_tmp21_ = self->priv->scaled_crop;
#line 1378 "../src/editing_tools/EditingTools.vala"
	_tmp22_ = gdk_pixbuf_new_subpixbuf (_tmp19_, _tmp20_.left, _tmp21_.top, box_get_width (&self->priv->scaled_crop), box_get_height (&self->priv->scaled_crop));
#line 1378 "../src/editing_tools/EditingTools.vala"
	_tmp23_ = _tmp22_;
#line 1378 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (_tmp19_);
#line 1378 "../src/editing_tools/EditingTools.vala"
	cropped = _tmp23_;
#line 1383 "../src/editing_tools/EditingTools.vala"
	_tmp24_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 1383 "../src/editing_tools/EditingTools.vala"
	_tmp25_ = editing_tools_photo_canvas_get_photo (_tmp24_);
#line 1383 "../src/editing_tools/EditingTools.vala"
	_tmp26_ = _tmp25_;
#line 1383 "../src/editing_tools/EditingTools.vala"
	_tmp27_ = crop;
#line 1383 "../src/editing_tools/EditingTools.vala"
	_tmp28_ = crop_command_new (_tmp26_, &_tmp27_, RESOURCES_CROP_LABEL, RESOURCES_CROP_TOOLTIP);
#line 1383 "../src/editing_tools/EditingTools.vala"
	_tmp29_ = _tmp28_;
#line 1383 "../src/editing_tools/EditingTools.vala"
	box_get_dimensions (&crop, &_tmp30_);
#line 1383 "../src/editing_tools/EditingTools.vala"
	g_signal_emit (G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool), editing_tools_editing_tool_signals[EDITING_TOOLS_EDITING_TOOL_APPLIED_SIGNAL], 0, G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, TYPE_COMMAND, Command), cropped, &_tmp30_, TRUE);
#line 1383 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (_tmp29_);
#line 1383 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (_tmp26_);
#line 1363 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (cropped);
#line 9214 "EditingTools.c"
}

static void
editing_tools_crop_tool_update_cursor (EditingToolsCropTool* self,
                                       gint x,
                                       gint y)
{
	GdkRectangle scaled_pos = {0};
	EditingToolsPhotoCanvas* _tmp0_;
	GdkRectangle _tmp1_ = {0};
	Box offset_scaled_crop = {0};
	GdkRectangle _tmp2_;
	GdkRectangle _tmp3_;
	Box _tmp4_ = {0};
	GdkCursorType cursor_type = 0;
#line 1387 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_CROP_TOOL (self));
#line 1389 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 1389 "../src/editing_tools/EditingTools.vala"
	editing_tools_photo_canvas_get_scaled_pixbuf_position (_tmp0_, &_tmp1_);
#line 1389 "../src/editing_tools/EditingTools.vala"
	scaled_pos = _tmp1_;
#line 1390 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = scaled_pos;
#line 1390 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = scaled_pos;
#line 1390 "../src/editing_tools/EditingTools.vala"
	box_get_offset (&self->priv->scaled_crop, _tmp2_.x, _tmp3_.y, &_tmp4_);
#line 1390 "../src/editing_tools/EditingTools.vala"
	offset_scaled_crop = _tmp4_;
#line 1392 "../src/editing_tools/EditingTools.vala"
	cursor_type = GDK_LEFT_PTR;
#line 1393 "../src/editing_tools/EditingTools.vala"
	switch (box_approx_location (&offset_scaled_crop, (gint) lround (x * application_get_scale ()), (gint) lround (y * application_get_scale ()))) {
#line 1393 "../src/editing_tools/EditingTools.vala"
		case BOX_LOCATION_LEFT_SIDE:
#line 9252 "EditingTools.c"
		{
#line 1396 "../src/editing_tools/EditingTools.vala"
			cursor_type = GDK_LEFT_SIDE;
#line 1397 "../src/editing_tools/EditingTools.vala"
			break;
#line 9258 "EditingTools.c"
		}
#line 1393 "../src/editing_tools/EditingTools.vala"
		case BOX_LOCATION_TOP_SIDE:
#line 9262 "EditingTools.c"
		{
#line 1400 "../src/editing_tools/EditingTools.vala"
			cursor_type = GDK_TOP_SIDE;
#line 1401 "../src/editing_tools/EditingTools.vala"
			break;
#line 9268 "EditingTools.c"
		}
#line 1393 "../src/editing_tools/EditingTools.vala"
		case BOX_LOCATION_RIGHT_SIDE:
#line 9272 "EditingTools.c"
		{
#line 1404 "../src/editing_tools/EditingTools.vala"
			cursor_type = GDK_RIGHT_SIDE;
#line 1405 "../src/editing_tools/EditingTools.vala"
			break;
#line 9278 "EditingTools.c"
		}
#line 1393 "../src/editing_tools/EditingTools.vala"
		case BOX_LOCATION_BOTTOM_SIDE:
#line 9282 "EditingTools.c"
		{
#line 1408 "../src/editing_tools/EditingTools.vala"
			cursor_type = GDK_BOTTOM_SIDE;
#line 1409 "../src/editing_tools/EditingTools.vala"
			break;
#line 9288 "EditingTools.c"
		}
#line 1393 "../src/editing_tools/EditingTools.vala"
		case BOX_LOCATION_TOP_LEFT:
#line 9292 "EditingTools.c"
		{
#line 1412 "../src/editing_tools/EditingTools.vala"
			cursor_type = GDK_TOP_LEFT_CORNER;
#line 1413 "../src/editing_tools/EditingTools.vala"
			break;
#line 9298 "EditingTools.c"
		}
#line 1393 "../src/editing_tools/EditingTools.vala"
		case BOX_LOCATION_BOTTOM_LEFT:
#line 9302 "EditingTools.c"
		{
#line 1416 "../src/editing_tools/EditingTools.vala"
			cursor_type = GDK_BOTTOM_LEFT_CORNER;
#line 1417 "../src/editing_tools/EditingTools.vala"
			break;
#line 9308 "EditingTools.c"
		}
#line 1393 "../src/editing_tools/EditingTools.vala"
		case BOX_LOCATION_TOP_RIGHT:
#line 9312 "EditingTools.c"
		{
#line 1420 "../src/editing_tools/EditingTools.vala"
			cursor_type = GDK_TOP_RIGHT_CORNER;
#line 1421 "../src/editing_tools/EditingTools.vala"
			break;
#line 9318 "EditingTools.c"
		}
#line 1393 "../src/editing_tools/EditingTools.vala"
		case BOX_LOCATION_BOTTOM_RIGHT:
#line 9322 "EditingTools.c"
		{
#line 1424 "../src/editing_tools/EditingTools.vala"
			cursor_type = GDK_BOTTOM_RIGHT_CORNER;
#line 1425 "../src/editing_tools/EditingTools.vala"
			break;
#line 9328 "EditingTools.c"
		}
#line 1393 "../src/editing_tools/EditingTools.vala"
		case BOX_LOCATION_INSIDE:
#line 9332 "EditingTools.c"
		{
#line 1428 "../src/editing_tools/EditingTools.vala"
			cursor_type = GDK_FLEUR;
#line 1429 "../src/editing_tools/EditingTools.vala"
			break;
#line 9338 "EditingTools.c"
		}
		default:
		{
#line 1433 "../src/editing_tools/EditingTools.vala"
			break;
#line 9344 "EditingTools.c"
		}
	}
#line 1436 "../src/editing_tools/EditingTools.vala"
	if (cursor_type != self->priv->current_cursor_type) {
#line 9349 "EditingTools.c"
		EditingToolsPhotoCanvas* _tmp5_;
#line 1437 "../src/editing_tools/EditingTools.vala"
		_tmp5_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 1437 "../src/editing_tools/EditingTools.vala"
		editing_tools_photo_canvas_set_cursor (_tmp5_, cursor_type);
#line 1438 "../src/editing_tools/EditingTools.vala"
		self->priv->current_cursor_type = cursor_type;
#line 9357 "EditingTools.c"
	}
}

static gint
editing_tools_crop_tool_eval_radial_line (EditingToolsCropTool* self,
                                          gdouble center_x,
                                          gdouble center_y,
                                          gdouble bounds_x,
                                          gdouble bounds_y,
                                          gdouble user_x)
{
	gdouble decision_slope = 0.0;
	gdouble decision_intercept = 0.0;
	gint result;
#line 1442 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (EDITING_TOOLS_IS_CROP_TOOL (self), 0);
#line 1444 "../src/editing_tools/EditingTools.vala"
	decision_slope = (bounds_y - center_y) / (bounds_x - center_x);
#line 1445 "../src/editing_tools/EditingTools.vala"
	decision_intercept = bounds_y - (decision_slope * bounds_x);
#line 1447 "../src/editing_tools/EditingTools.vala"
	result = (gint) ((decision_slope * user_x) + decision_intercept);
#line 1447 "../src/editing_tools/EditingTools.vala"
	return result;
#line 9382 "EditingTools.c"
}

static void
editing_tools_crop_tool_get_photo_dimensions (EditingToolsCropTool* self,
                                              Dimensions* result)
{
	Dimensions photo_dims = {0};
	EditingToolsPhotoCanvas* _tmp0_;
	Photo* _tmp1_;
	Photo* _tmp2_;
	Dimensions _tmp3_ = {0};
	Dimensions _tmp4_;
	Dimensions surface_dims = {0};
	EditingToolsPhotoCanvas* _tmp5_;
	Dimensions _tmp6_ = {0};
	gdouble scale_factor = 0.0;
	Dimensions _tmp7_;
	Dimensions _tmp8_;
	Dimensions _tmp9_;
	Dimensions _tmp10_;
	EditingToolsPhotoCanvas* _tmp11_;
	Photo* _tmp12_;
	Photo* _tmp13_;
	Dimensions _tmp14_ = {0};
	Dimensions _tmp15_;
	Dimensions _tmp16_;
	Dimensions _tmp17_ = {0};
#line 1451 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_CROP_TOOL (self));
#line 1452 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 1452 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = editing_tools_photo_canvas_get_photo (_tmp0_);
#line 1452 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = _tmp1_;
#line 1452 "../src/editing_tools/EditingTools.vala"
	media_source_get_dimensions (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_MEDIA_SOURCE, MediaSource), PHOTO_EXCEPTION_CROP, &_tmp3_);
#line 1452 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = _tmp3_;
#line 1452 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (_tmp2_);
#line 1452 "../src/editing_tools/EditingTools.vala"
	photo_dims = _tmp4_;
#line 1453 "../src/editing_tools/EditingTools.vala"
	_tmp5_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 1453 "../src/editing_tools/EditingTools.vala"
	editing_tools_photo_canvas_get_surface_dim (_tmp5_, &_tmp6_);
#line 1453 "../src/editing_tools/EditingTools.vala"
	surface_dims = _tmp6_;
#line 1454 "../src/editing_tools/EditingTools.vala"
	_tmp7_ = surface_dims;
#line 1454 "../src/editing_tools/EditingTools.vala"
	_tmp8_ = photo_dims;
#line 1454 "../src/editing_tools/EditingTools.vala"
	_tmp9_ = surface_dims;
#line 1454 "../src/editing_tools/EditingTools.vala"
	_tmp10_ = photo_dims;
#line 1454 "../src/editing_tools/EditingTools.vala"
	scale_factor = MIN (((gdouble) _tmp7_.width) / _tmp8_.width, ((gdouble) _tmp9_.height) / _tmp10_.height);
#line 1456 "../src/editing_tools/EditingTools.vala"
	scale_factor = MIN (scale_factor, 1.0);
#line 1458 "../src/editing_tools/EditingTools.vala"
	_tmp11_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 1458 "../src/editing_tools/EditingTools.vala"
	_tmp12_ = editing_tools_photo_canvas_get_photo (_tmp11_);
#line 1458 "../src/editing_tools/EditingTools.vala"
	_tmp13_ = _tmp12_;
#line 1458 "../src/editing_tools/EditingTools.vala"
	media_source_get_dimensions (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, TYPE_MEDIA_SOURCE, MediaSource), PHOTO_EXCEPTION_CROP | PHOTO_EXCEPTION_STRAIGHTEN, &_tmp14_);
#line 1458 "../src/editing_tools/EditingTools.vala"
	photo_dims = _tmp14_;
#line 1458 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (_tmp13_);
#line 1461 "../src/editing_tools/EditingTools.vala"
	_tmp15_ = photo_dims;
#line 1461 "../src/editing_tools/EditingTools.vala"
	_tmp16_ = photo_dims;
#line 1461 "../src/editing_tools/EditingTools.vala"
	_tmp17_.width = (gint) (_tmp15_.width * scale_factor);
#line 1461 "../src/editing_tools/EditingTools.vala"
	_tmp17_.height = (gint) (_tmp16_.height * scale_factor);
#line 1461 "../src/editing_tools/EditingTools.vala"
	*result = _tmp17_;
#line 1461 "../src/editing_tools/EditingTools.vala"
	return;
#line 9468 "EditingTools.c"
}

static gboolean
_box_equal (const Box * s1,
            const Box * s2)
{
#line 1723 "../src/editing_tools/EditingTools.vala"
	if (s1 == s2) {
#line 1723 "../src/editing_tools/EditingTools.vala"
		return TRUE;
#line 9479 "EditingTools.c"
	}
#line 1723 "../src/editing_tools/EditingTools.vala"
	if (s1 == NULL) {
#line 1723 "../src/editing_tools/EditingTools.vala"
		return FALSE;
#line 9485 "EditingTools.c"
	}
#line 1723 "../src/editing_tools/EditingTools.vala"
	if (s2 == NULL) {
#line 1723 "../src/editing_tools/EditingTools.vala"
		return FALSE;
#line 9491 "EditingTools.c"
	}
#line 1723 "../src/editing_tools/EditingTools.vala"
	if (s1->left != s2->left) {
#line 1723 "../src/editing_tools/EditingTools.vala"
		return FALSE;
#line 9497 "EditingTools.c"
	}
#line 1723 "../src/editing_tools/EditingTools.vala"
	if (s1->top != s2->top) {
#line 1723 "../src/editing_tools/EditingTools.vala"
		return FALSE;
#line 9503 "EditingTools.c"
	}
#line 1723 "../src/editing_tools/EditingTools.vala"
	if (s1->right != s2->right) {
#line 1723 "../src/editing_tools/EditingTools.vala"
		return FALSE;
#line 9509 "EditingTools.c"
	}
#line 1723 "../src/editing_tools/EditingTools.vala"
	if (s1->bottom != s2->bottom) {
#line 1723 "../src/editing_tools/EditingTools.vala"
		return FALSE;
#line 9515 "EditingTools.c"
	}
#line 1723 "../src/editing_tools/EditingTools.vala"
	return TRUE;
#line 9519 "EditingTools.c"
}

static gboolean
editing_tools_crop_tool_on_canvas_manipulation (EditingToolsCropTool* self,
                                                gint x,
                                                gint y)
{
	GdkRectangle scaled_pos = {0};
	EditingToolsPhotoCanvas* _tmp0_;
	GdkRectangle _tmp1_ = {0};
	GdkRectangle _tmp2_;
	GdkRectangle _tmp5_;
	gint left = 0;
	Box _tmp8_;
	gint top = 0;
	Box _tmp9_;
	gint right = 0;
	Box _tmp10_;
	gint bottom = 0;
	Box _tmp11_;
	gint center_x = 0;
	gint center_y = 0;
	gint width = 0;
	gint height = 0;
	Dimensions photo_dims = {0};
	Dimensions _tmp16_ = {0};
	gdouble angle = 0.0;
	EditingToolsPhotoCanvas* _tmp17_;
	Photo* _tmp18_;
	Photo* _tmp19_;
	gdouble _tmp20_ = 0.0;
	Box new_crop = {0};
	Box _tmp36_;
	gboolean result;
#line 1465 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (EDITING_TOOLS_IS_CROP_TOOL (self), FALSE);
#line 1466 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 1466 "../src/editing_tools/EditingTools.vala"
	editing_tools_photo_canvas_get_scaled_pixbuf_position (_tmp0_, &_tmp1_);
#line 1466 "../src/editing_tools/EditingTools.vala"
	scaled_pos = _tmp1_;
#line 1470 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = scaled_pos;
#line 1470 "../src/editing_tools/EditingTools.vala"
	x = x - _tmp2_.x;
#line 1471 "../src/editing_tools/EditingTools.vala"
	if (x < 0) {
#line 1472 "../src/editing_tools/EditingTools.vala"
		x = 0;
#line 9570 "EditingTools.c"
	} else {
		GdkRectangle _tmp3_;
#line 1473 "../src/editing_tools/EditingTools.vala"
		_tmp3_ = scaled_pos;
#line 1473 "../src/editing_tools/EditingTools.vala"
		if (x >= _tmp3_.width) {
#line 9577 "EditingTools.c"
			GdkRectangle _tmp4_;
#line 1474 "../src/editing_tools/EditingTools.vala"
			_tmp4_ = scaled_pos;
#line 1474 "../src/editing_tools/EditingTools.vala"
			x = _tmp4_.width - 1;
#line 9583 "EditingTools.c"
		}
	}
#line 1476 "../src/editing_tools/EditingTools.vala"
	_tmp5_ = scaled_pos;
#line 1476 "../src/editing_tools/EditingTools.vala"
	y = y - _tmp5_.y;
#line 1477 "../src/editing_tools/EditingTools.vala"
	if (y < 0) {
#line 1478 "../src/editing_tools/EditingTools.vala"
		y = 0;
#line 9594 "EditingTools.c"
	} else {
		GdkRectangle _tmp6_;
#line 1479 "../src/editing_tools/EditingTools.vala"
		_tmp6_ = scaled_pos;
#line 1479 "../src/editing_tools/EditingTools.vala"
		if (y >= _tmp6_.height) {
#line 9601 "EditingTools.c"
			GdkRectangle _tmp7_;
#line 1480 "../src/editing_tools/EditingTools.vala"
			_tmp7_ = scaled_pos;
#line 1480 "../src/editing_tools/EditingTools.vala"
			y = _tmp7_.height - 1;
#line 9607 "EditingTools.c"
		}
	}
#line 1484 "../src/editing_tools/EditingTools.vala"
	_tmp8_ = self->priv->scaled_crop;
#line 1484 "../src/editing_tools/EditingTools.vala"
	left = _tmp8_.left;
#line 1485 "../src/editing_tools/EditingTools.vala"
	_tmp9_ = self->priv->scaled_crop;
#line 1485 "../src/editing_tools/EditingTools.vala"
	top = _tmp9_.top;
#line 1486 "../src/editing_tools/EditingTools.vala"
	_tmp10_ = self->priv->scaled_crop;
#line 1486 "../src/editing_tools/EditingTools.vala"
	right = _tmp10_.right;
#line 1487 "../src/editing_tools/EditingTools.vala"
	_tmp11_ = self->priv->scaled_crop;
#line 1487 "../src/editing_tools/EditingTools.vala"
	bottom = _tmp11_.bottom;
#line 1490 "../src/editing_tools/EditingTools.vala"
	center_x = (left + right) / 2;
#line 1491 "../src/editing_tools/EditingTools.vala"
	center_y = (top + bottom) / 2;
#line 1493 "../src/editing_tools/EditingTools.vala"
	switch (self->priv->in_manipulation) {
#line 1493 "../src/editing_tools/EditingTools.vala"
		case BOX_LOCATION_LEFT_SIDE:
#line 9634 "EditingTools.c"
		{
#line 1495 "../src/editing_tools/EditingTools.vala"
			left = x;
#line 1496 "../src/editing_tools/EditingTools.vala"
			if (editing_tools_crop_tool_get_constraint_aspect_ratio (self) != EDITING_TOOLS_CROP_TOOL_ANY_ASPECT_RATIO) {
#line 9640 "EditingTools.c"
				gfloat new_height = 0.0F;
#line 1497 "../src/editing_tools/EditingTools.vala"
				new_height = ((gfloat) (right - left)) / editing_tools_crop_tool_get_constraint_aspect_ratio (self);
#line 1498 "../src/editing_tools/EditingTools.vala"
				bottom = top + ((gint) new_height);
#line 9646 "EditingTools.c"
			}
#line 1500 "../src/editing_tools/EditingTools.vala"
			break;
#line 9650 "EditingTools.c"
		}
#line 1493 "../src/editing_tools/EditingTools.vala"
		case BOX_LOCATION_TOP_SIDE:
#line 9654 "EditingTools.c"
		{
#line 1503 "../src/editing_tools/EditingTools.vala"
			top = y;
#line 1504 "../src/editing_tools/EditingTools.vala"
			if (editing_tools_crop_tool_get_constraint_aspect_ratio (self) != EDITING_TOOLS_CROP_TOOL_ANY_ASPECT_RATIO) {
#line 9660 "EditingTools.c"
				gfloat new_width = 0.0F;
#line 1505 "../src/editing_tools/EditingTools.vala"
				new_width = ((gfloat) (bottom - top)) * editing_tools_crop_tool_get_constraint_aspect_ratio (self);
#line 1506 "../src/editing_tools/EditingTools.vala"
				right = left + ((gint) new_width);
#line 9666 "EditingTools.c"
			}
#line 1508 "../src/editing_tools/EditingTools.vala"
			break;
#line 9670 "EditingTools.c"
		}
#line 1493 "../src/editing_tools/EditingTools.vala"
		case BOX_LOCATION_RIGHT_SIDE:
#line 9674 "EditingTools.c"
		{
#line 1511 "../src/editing_tools/EditingTools.vala"
			right = x;
#line 1512 "../src/editing_tools/EditingTools.vala"
			if (editing_tools_crop_tool_get_constraint_aspect_ratio (self) != EDITING_TOOLS_CROP_TOOL_ANY_ASPECT_RATIO) {
#line 9680 "EditingTools.c"
				gfloat new_height = 0.0F;
#line 1513 "../src/editing_tools/EditingTools.vala"
				new_height = ((gfloat) (right - left)) / editing_tools_crop_tool_get_constraint_aspect_ratio (self);
#line 1514 "../src/editing_tools/EditingTools.vala"
				bottom = top + ((gint) new_height);
#line 9686 "EditingTools.c"
			}
#line 1516 "../src/editing_tools/EditingTools.vala"
			break;
#line 9690 "EditingTools.c"
		}
#line 1493 "../src/editing_tools/EditingTools.vala"
		case BOX_LOCATION_BOTTOM_SIDE:
#line 9694 "EditingTools.c"
		{
#line 1519 "../src/editing_tools/EditingTools.vala"
			bottom = y;
#line 1520 "../src/editing_tools/EditingTools.vala"
			if (editing_tools_crop_tool_get_constraint_aspect_ratio (self) != EDITING_TOOLS_CROP_TOOL_ANY_ASPECT_RATIO) {
#line 9700 "EditingTools.c"
				gfloat new_width = 0.0F;
#line 1521 "../src/editing_tools/EditingTools.vala"
				new_width = ((gfloat) (bottom - top)) * editing_tools_crop_tool_get_constraint_aspect_ratio (self);
#line 1522 "../src/editing_tools/EditingTools.vala"
				right = left + ((gint) new_width);
#line 9706 "EditingTools.c"
			}
#line 1524 "../src/editing_tools/EditingTools.vala"
			break;
#line 9710 "EditingTools.c"
		}
#line 1493 "../src/editing_tools/EditingTools.vala"
		case BOX_LOCATION_TOP_LEFT:
#line 9714 "EditingTools.c"
		{
#line 1527 "../src/editing_tools/EditingTools.vala"
			if (editing_tools_crop_tool_get_constraint_aspect_ratio (self) == EDITING_TOOLS_CROP_TOOL_ANY_ASPECT_RATIO) {
#line 1528 "../src/editing_tools/EditingTools.vala"
				top = y;
#line 1529 "../src/editing_tools/EditingTools.vala"
				left = x;
#line 9722 "EditingTools.c"
			} else {
#line 1531 "../src/editing_tools/EditingTools.vala"
				if (y < editing_tools_crop_tool_eval_radial_line (self, (gdouble) center_x, (gdouble) center_y, (gdouble) left, (gdouble) top, (gdouble) x)) {
#line 9726 "EditingTools.c"
					gfloat new_width = 0.0F;
#line 1532 "../src/editing_tools/EditingTools.vala"
					top = y;
#line 1533 "../src/editing_tools/EditingTools.vala"
					new_width = ((gfloat) (bottom - top)) * editing_tools_crop_tool_get_constraint_aspect_ratio (self);
#line 1534 "../src/editing_tools/EditingTools.vala"
					left = right - ((gint) new_width);
#line 9734 "EditingTools.c"
				} else {
					gfloat new_height = 0.0F;
#line 1536 "../src/editing_tools/EditingTools.vala"
					left = x;
#line 1537 "../src/editing_tools/EditingTools.vala"
					new_height = ((gfloat) (right - left)) / editing_tools_crop_tool_get_constraint_aspect_ratio (self);
#line 1538 "../src/editing_tools/EditingTools.vala"
					top = bottom - ((gint) new_height);
#line 9743 "EditingTools.c"
				}
			}
#line 1541 "../src/editing_tools/EditingTools.vala"
			break;
#line 9748 "EditingTools.c"
		}
#line 1493 "../src/editing_tools/EditingTools.vala"
		case BOX_LOCATION_BOTTOM_LEFT:
#line 9752 "EditingTools.c"
		{
#line 1544 "../src/editing_tools/EditingTools.vala"
			if (editing_tools_crop_tool_get_constraint_aspect_ratio (self) == EDITING_TOOLS_CROP_TOOL_ANY_ASPECT_RATIO) {
#line 1545 "../src/editing_tools/EditingTools.vala"
				bottom = y;
#line 1546 "../src/editing_tools/EditingTools.vala"
				left = x;
#line 9760 "EditingTools.c"
			} else {
#line 1548 "../src/editing_tools/EditingTools.vala"
				if (y < editing_tools_crop_tool_eval_radial_line (self, (gdouble) center_x, (gdouble) center_y, (gdouble) left, (gdouble) bottom, (gdouble) x)) {
#line 9764 "EditingTools.c"
					gfloat new_height = 0.0F;
#line 1549 "../src/editing_tools/EditingTools.vala"
					left = x;
#line 1550 "../src/editing_tools/EditingTools.vala"
					new_height = ((gfloat) (right - left)) / editing_tools_crop_tool_get_constraint_aspect_ratio (self);
#line 1551 "../src/editing_tools/EditingTools.vala"
					bottom = top + ((gint) new_height);
#line 9772 "EditingTools.c"
				} else {
					gfloat new_width = 0.0F;
#line 1553 "../src/editing_tools/EditingTools.vala"
					bottom = y;
#line 1554 "../src/editing_tools/EditingTools.vala"
					new_width = ((gfloat) (bottom - top)) * editing_tools_crop_tool_get_constraint_aspect_ratio (self);
#line 1555 "../src/editing_tools/EditingTools.vala"
					left = right - ((gint) new_width);
#line 9781 "EditingTools.c"
				}
			}
#line 1558 "../src/editing_tools/EditingTools.vala"
			break;
#line 9786 "EditingTools.c"
		}
#line 1493 "../src/editing_tools/EditingTools.vala"
		case BOX_LOCATION_TOP_RIGHT:
#line 9790 "EditingTools.c"
		{
#line 1561 "../src/editing_tools/EditingTools.vala"
			if (editing_tools_crop_tool_get_constraint_aspect_ratio (self) == EDITING_TOOLS_CROP_TOOL_ANY_ASPECT_RATIO) {
#line 1562 "../src/editing_tools/EditingTools.vala"
				top = y;
#line 1563 "../src/editing_tools/EditingTools.vala"
				right = x;
#line 9798 "EditingTools.c"
			} else {
#line 1565 "../src/editing_tools/EditingTools.vala"
				if (y < editing_tools_crop_tool_eval_radial_line (self, (gdouble) center_x, (gdouble) center_y, (gdouble) right, (gdouble) top, (gdouble) x)) {
#line 9802 "EditingTools.c"
					gfloat new_width = 0.0F;
#line 1566 "../src/editing_tools/EditingTools.vala"
					top = y;
#line 1567 "../src/editing_tools/EditingTools.vala"
					new_width = ((gfloat) (bottom - top)) * editing_tools_crop_tool_get_constraint_aspect_ratio (self);
#line 1568 "../src/editing_tools/EditingTools.vala"
					right = left + ((gint) new_width);
#line 9810 "EditingTools.c"
				} else {
					gfloat new_height = 0.0F;
#line 1570 "../src/editing_tools/EditingTools.vala"
					right = x;
#line 1571 "../src/editing_tools/EditingTools.vala"
					new_height = ((gfloat) (right - left)) / editing_tools_crop_tool_get_constraint_aspect_ratio (self);
#line 1572 "../src/editing_tools/EditingTools.vala"
					top = bottom - ((gint) new_height);
#line 9819 "EditingTools.c"
				}
			}
#line 1575 "../src/editing_tools/EditingTools.vala"
			break;
#line 9824 "EditingTools.c"
		}
#line 1493 "../src/editing_tools/EditingTools.vala"
		case BOX_LOCATION_BOTTOM_RIGHT:
#line 9828 "EditingTools.c"
		{
#line 1578 "../src/editing_tools/EditingTools.vala"
			if (editing_tools_crop_tool_get_constraint_aspect_ratio (self) == EDITING_TOOLS_CROP_TOOL_ANY_ASPECT_RATIO) {
#line 1579 "../src/editing_tools/EditingTools.vala"
				bottom = y;
#line 1580 "../src/editing_tools/EditingTools.vala"
				right = x;
#line 9836 "EditingTools.c"
			} else {
#line 1582 "../src/editing_tools/EditingTools.vala"
				if (y < editing_tools_crop_tool_eval_radial_line (self, (gdouble) center_x, (gdouble) center_y, (gdouble) right, (gdouble) bottom, (gdouble) x)) {
#line 9840 "EditingTools.c"
					gfloat new_height = 0.0F;
#line 1583 "../src/editing_tools/EditingTools.vala"
					right = x;
#line 1584 "../src/editing_tools/EditingTools.vala"
					new_height = ((gfloat) (right - left)) / editing_tools_crop_tool_get_constraint_aspect_ratio (self);
#line 1585 "../src/editing_tools/EditingTools.vala"
					bottom = top + ((gint) new_height);
#line 9848 "EditingTools.c"
				} else {
					gfloat new_width = 0.0F;
#line 1587 "../src/editing_tools/EditingTools.vala"
					bottom = y;
#line 1588 "../src/editing_tools/EditingTools.vala"
					new_width = ((gfloat) (bottom - top)) * editing_tools_crop_tool_get_constraint_aspect_ratio (self);
#line 1589 "../src/editing_tools/EditingTools.vala"
					right = left + ((gint) new_width);
#line 9857 "EditingTools.c"
				}
			}
#line 1592 "../src/editing_tools/EditingTools.vala"
			break;
#line 9862 "EditingTools.c"
		}
#line 1493 "../src/editing_tools/EditingTools.vala"
		case BOX_LOCATION_INSIDE:
#line 9866 "EditingTools.c"
		{
			gint delta_x = 0;
			gint delta_y = 0;
			gint width = 0;
			gint height = 0;
			GdkRectangle _tmp12_;
			GdkRectangle _tmp14_;
			gint adj_width = 0;
			gint adj_height = 0;
#line 1595 "../src/editing_tools/EditingTools.vala"
			_vala_assert (self->priv->last_grab_x >= 0, "last_grab_x >= 0");
#line 1596 "../src/editing_tools/EditingTools.vala"
			_vala_assert (self->priv->last_grab_y >= 0, "last_grab_y >= 0");
#line 1598 "../src/editing_tools/EditingTools.vala"
			delta_x = x - self->priv->last_grab_x;
#line 1599 "../src/editing_tools/EditingTools.vala"
			delta_y = y - self->priv->last_grab_y;
#line 1601 "../src/editing_tools/EditingTools.vala"
			self->priv->last_grab_x = x;
#line 1602 "../src/editing_tools/EditingTools.vala"
			self->priv->last_grab_y = y;
#line 1604 "../src/editing_tools/EditingTools.vala"
			width = (right - left) + 1;
#line 1605 "../src/editing_tools/EditingTools.vala"
			height = (bottom - top) + 1;
#line 1607 "../src/editing_tools/EditingTools.vala"
			left += delta_x;
#line 1608 "../src/editing_tools/EditingTools.vala"
			top += delta_y;
#line 1609 "../src/editing_tools/EditingTools.vala"
			right += delta_x;
#line 1610 "../src/editing_tools/EditingTools.vala"
			bottom += delta_y;
#line 1613 "../src/editing_tools/EditingTools.vala"
			if (left < 0) {
#line 1614 "../src/editing_tools/EditingTools.vala"
				left = 0;
#line 9904 "EditingTools.c"
			}
#line 1616 "../src/editing_tools/EditingTools.vala"
			if (top < 0) {
#line 1617 "../src/editing_tools/EditingTools.vala"
				top = 0;
#line 9910 "EditingTools.c"
			}
#line 1619 "../src/editing_tools/EditingTools.vala"
			_tmp12_ = scaled_pos;
#line 1619 "../src/editing_tools/EditingTools.vala"
			if (right >= _tmp12_.width) {
#line 9916 "EditingTools.c"
				GdkRectangle _tmp13_;
#line 1620 "../src/editing_tools/EditingTools.vala"
				_tmp13_ = scaled_pos;
#line 1620 "../src/editing_tools/EditingTools.vala"
				right = _tmp13_.width - 1;
#line 9922 "EditingTools.c"
			}
#line 1622 "../src/editing_tools/EditingTools.vala"
			_tmp14_ = scaled_pos;
#line 1622 "../src/editing_tools/EditingTools.vala"
			if (bottom >= _tmp14_.height) {
#line 9928 "EditingTools.c"
				GdkRectangle _tmp15_;
#line 1623 "../src/editing_tools/EditingTools.vala"
				_tmp15_ = scaled_pos;
#line 1623 "../src/editing_tools/EditingTools.vala"
				bottom = _tmp15_.height - 1;
#line 9934 "EditingTools.c"
			}
#line 1625 "../src/editing_tools/EditingTools.vala"
			adj_width = (right - left) + 1;
#line 1626 "../src/editing_tools/EditingTools.vala"
			adj_height = (bottom - top) + 1;
#line 1629 "../src/editing_tools/EditingTools.vala"
			if (adj_width != width) {
#line 1630 "../src/editing_tools/EditingTools.vala"
				if (delta_x < 0) {
#line 1631 "../src/editing_tools/EditingTools.vala"
					right = (left + width) - 1;
#line 9946 "EditingTools.c"
				} else {
#line 1633 "../src/editing_tools/EditingTools.vala"
					left = (right - width) + 1;
#line 9950 "EditingTools.c"
				}
			}
#line 1636 "../src/editing_tools/EditingTools.vala"
			if (adj_height != height) {
#line 1637 "../src/editing_tools/EditingTools.vala"
				if (delta_y < 0) {
#line 1638 "../src/editing_tools/EditingTools.vala"
					bottom = (top + height) - 1;
#line 9959 "EditingTools.c"
				} else {
#line 1640 "../src/editing_tools/EditingTools.vala"
					top = (bottom - height) + 1;
#line 9963 "EditingTools.c"
				}
			}
#line 1642 "../src/editing_tools/EditingTools.vala"
			break;
#line 9968 "EditingTools.c"
		}
		default:
		{
#line 1646 "../src/editing_tools/EditingTools.vala"
			result = FALSE;
#line 1646 "../src/editing_tools/EditingTools.vala"
			return result;
#line 9976 "EditingTools.c"
		}
	}
#line 1656 "../src/editing_tools/EditingTools.vala"
	width = (right - left) + 1;
#line 1657 "../src/editing_tools/EditingTools.vala"
	height = (bottom - top) + 1;
#line 1659 "../src/editing_tools/EditingTools.vala"
	editing_tools_crop_tool_get_photo_dimensions (self, &_tmp16_);
#line 1659 "../src/editing_tools/EditingTools.vala"
	photo_dims = _tmp16_;
#line 1661 "../src/editing_tools/EditingTools.vala"
	_tmp17_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 1661 "../src/editing_tools/EditingTools.vala"
	_tmp18_ = editing_tools_photo_canvas_get_photo (_tmp17_);
#line 1661 "../src/editing_tools/EditingTools.vala"
	_tmp19_ = _tmp18_;
#line 1661 "../src/editing_tools/EditingTools.vala"
	photo_get_straighten (_tmp19_, &_tmp20_);
#line 1661 "../src/editing_tools/EditingTools.vala"
	angle = _tmp20_;
#line 1661 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (_tmp19_);
#line 1664 "../src/editing_tools/EditingTools.vala"
	if (editing_tools_crop_tool_get_constraint_aspect_ratio (self) == EDITING_TOOLS_CROP_TOOL_ANY_ASPECT_RATIO) {
#line 10001 "EditingTools.c"
		Box _tmp21_ = {0};
		Dimensions _tmp22_;
		Dimensions _tmp23_;
		Box _tmp24_ = {0};
#line 1665 "../src/editing_tools/EditingTools.vala"
		width = (right - left) + 1;
#line 1666 "../src/editing_tools/EditingTools.vala"
		height = (bottom - top) + 1;
#line 1668 "../src/editing_tools/EditingTools.vala"
		switch (self->priv->in_manipulation) {
#line 1668 "../src/editing_tools/EditingTools.vala"
			case BOX_LOCATION_LEFT_SIDE:
#line 1668 "../src/editing_tools/EditingTools.vala"
			case BOX_LOCATION_TOP_LEFT:
#line 1668 "../src/editing_tools/EditingTools.vala"
			case BOX_LOCATION_BOTTOM_LEFT:
#line 10018 "EditingTools.c"
			{
#line 1672 "../src/editing_tools/EditingTools.vala"
				if (width < EDITING_TOOLS_CROP_TOOL_CROP_MIN_SIZE) {
#line 1673 "../src/editing_tools/EditingTools.vala"
					left = right - EDITING_TOOLS_CROP_TOOL_CROP_MIN_SIZE;
#line 10024 "EditingTools.c"
				}
#line 1674 "../src/editing_tools/EditingTools.vala"
				break;
#line 10028 "EditingTools.c"
			}
#line 1668 "../src/editing_tools/EditingTools.vala"
			case BOX_LOCATION_RIGHT_SIDE:
#line 1668 "../src/editing_tools/EditingTools.vala"
			case BOX_LOCATION_TOP_RIGHT:
#line 1668 "../src/editing_tools/EditingTools.vala"
			case BOX_LOCATION_BOTTOM_RIGHT:
#line 10036 "EditingTools.c"
			{
#line 1679 "../src/editing_tools/EditingTools.vala"
				if (width < EDITING_TOOLS_CROP_TOOL_CROP_MIN_SIZE) {
#line 1680 "../src/editing_tools/EditingTools.vala"
					right = left + EDITING_TOOLS_CROP_TOOL_CROP_MIN_SIZE;
#line 10042 "EditingTools.c"
				}
#line 1681 "../src/editing_tools/EditingTools.vala"
				break;
#line 10046 "EditingTools.c"
			}
			default:
			{
#line 1684 "../src/editing_tools/EditingTools.vala"
				break;
#line 10052 "EditingTools.c"
			}
		}
#line 1687 "../src/editing_tools/EditingTools.vala"
		switch (self->priv->in_manipulation) {
#line 1687 "../src/editing_tools/EditingTools.vala"
			case BOX_LOCATION_TOP_SIDE:
#line 1687 "../src/editing_tools/EditingTools.vala"
			case BOX_LOCATION_TOP_LEFT:
#line 1687 "../src/editing_tools/EditingTools.vala"
			case BOX_LOCATION_TOP_RIGHT:
#line 10063 "EditingTools.c"
			{
#line 1691 "../src/editing_tools/EditingTools.vala"
				if (height < EDITING_TOOLS_CROP_TOOL_CROP_MIN_SIZE) {
#line 1692 "../src/editing_tools/EditingTools.vala"
					top = bottom - EDITING_TOOLS_CROP_TOOL_CROP_MIN_SIZE;
#line 10069 "EditingTools.c"
				}
#line 1693 "../src/editing_tools/EditingTools.vala"
				break;
#line 10073 "EditingTools.c"
			}
#line 1687 "../src/editing_tools/EditingTools.vala"
			case BOX_LOCATION_BOTTOM_SIDE:
#line 1687 "../src/editing_tools/EditingTools.vala"
			case BOX_LOCATION_BOTTOM_LEFT:
#line 1687 "../src/editing_tools/EditingTools.vala"
			case BOX_LOCATION_BOTTOM_RIGHT:
#line 10081 "EditingTools.c"
			{
#line 1698 "../src/editing_tools/EditingTools.vala"
				if (height < EDITING_TOOLS_CROP_TOOL_CROP_MIN_SIZE) {
#line 1699 "../src/editing_tools/EditingTools.vala"
					bottom = top + EDITING_TOOLS_CROP_TOOL_CROP_MIN_SIZE;
#line 10087 "EditingTools.c"
				}
#line 1700 "../src/editing_tools/EditingTools.vala"
				break;
#line 10091 "EditingTools.c"
			}
			default:
			{
#line 1703 "../src/editing_tools/EditingTools.vala"
				break;
#line 10097 "EditingTools.c"
			}
		}
#line 1709 "../src/editing_tools/EditingTools.vala"
		box_init (&_tmp21_, left, top, right, bottom);
#line 1709 "../src/editing_tools/EditingTools.vala"
		_tmp22_ = photo_dims;
#line 1709 "../src/editing_tools/EditingTools.vala"
		_tmp23_ = photo_dims;
#line 1709 "../src/editing_tools/EditingTools.vala"
		clamp_inside_rotated_image (&_tmp21_, _tmp22_.width, _tmp23_.height, angle, self->priv->in_manipulation == BOX_LOCATION_INSIDE, &_tmp24_);
#line 1709 "../src/editing_tools/EditingTools.vala"
		new_crop = _tmp24_;
#line 10110 "EditingTools.c"
	} else {
		Box adjusted = {0};
		Box _tmp25_;
		Dimensions _tmp26_;
		Dimensions _tmp27_;
		Box _tmp28_ = {0};
		gboolean _tmp29_ = FALSE;
		gboolean _tmp30_ = FALSE;
		Box _tmp31_;
		Box _tmp32_;
#line 1718 "../src/editing_tools/EditingTools.vala"
		box_init (&new_crop, left, top, right, bottom);
#line 1719 "../src/editing_tools/EditingTools.vala"
		_tmp25_ = new_crop;
#line 1719 "../src/editing_tools/EditingTools.vala"
		_tmp26_ = photo_dims;
#line 1719 "../src/editing_tools/EditingTools.vala"
		_tmp27_ = photo_dims;
#line 1719 "../src/editing_tools/EditingTools.vala"
		clamp_inside_rotated_image (&_tmp25_, _tmp26_.width, _tmp27_.height, angle, self->priv->in_manipulation == BOX_LOCATION_INSIDE, &_tmp28_);
#line 1719 "../src/editing_tools/EditingTools.vala"
		adjusted = _tmp28_;
#line 1723 "../src/editing_tools/EditingTools.vala"
		_tmp31_ = adjusted;
#line 1723 "../src/editing_tools/EditingTools.vala"
		_tmp32_ = new_crop;
#line 1723 "../src/editing_tools/EditingTools.vala"
		if (_box_equal (&_tmp31_, &_tmp32_) != TRUE) {
#line 1723 "../src/editing_tools/EditingTools.vala"
			_tmp30_ = TRUE;
#line 10141 "EditingTools.c"
		} else {
#line 1723 "../src/editing_tools/EditingTools.vala"
			_tmp30_ = width < EDITING_TOOLS_CROP_TOOL_CROP_MIN_SIZE;
#line 10145 "EditingTools.c"
		}
#line 1723 "../src/editing_tools/EditingTools.vala"
		if (_tmp30_) {
#line 1723 "../src/editing_tools/EditingTools.vala"
			_tmp29_ = TRUE;
#line 10151 "EditingTools.c"
		} else {
#line 1723 "../src/editing_tools/EditingTools.vala"
			_tmp29_ = height < EDITING_TOOLS_CROP_TOOL_CROP_MIN_SIZE;
#line 10155 "EditingTools.c"
		}
#line 1723 "../src/editing_tools/EditingTools.vala"
		if (_tmp29_) {
#line 10159 "EditingTools.c"
			Box _tmp33_;
#line 1724 "../src/editing_tools/EditingTools.vala"
			_tmp33_ = self->priv->scaled_crop;
#line 1724 "../src/editing_tools/EditingTools.vala"
			new_crop = _tmp33_;
#line 10165 "EditingTools.c"
		}
	}
#line 1728 "../src/editing_tools/EditingTools.vala"
	if (self->priv->in_manipulation != BOX_LOCATION_INSIDE) {
#line 10170 "EditingTools.c"
		Box _tmp34_;
#line 1729 "../src/editing_tools/EditingTools.vala"
		_tmp34_ = new_crop;
#line 1729 "../src/editing_tools/EditingTools.vala"
		editing_tools_crop_tool_crop_resized (self, &_tmp34_);
#line 10176 "EditingTools.c"
	} else {
		Box _tmp35_;
#line 1731 "../src/editing_tools/EditingTools.vala"
		_tmp35_ = new_crop;
#line 1731 "../src/editing_tools/EditingTools.vala"
		editing_tools_crop_tool_crop_moved (self, &_tmp35_);
#line 10183 "EditingTools.c"
	}
#line 1734 "../src/editing_tools/EditingTools.vala"
	_tmp36_ = new_crop;
#line 1734 "../src/editing_tools/EditingTools.vala"
	self->priv->scaled_crop = _tmp36_;
#line 1736 "../src/editing_tools/EditingTools.vala"
	if (editing_tools_crop_tool_get_constraint_aspect_ratio (self) == EDITING_TOOLS_CROP_TOOL_ANY_ASPECT_RATIO) {
#line 1737 "../src/editing_tools/EditingTools.vala"
		self->priv->custom_init_width = box_get_width (&self->priv->scaled_crop);
#line 1738 "../src/editing_tools/EditingTools.vala"
		self->priv->custom_init_height = box_get_height (&self->priv->scaled_crop);
#line 1739 "../src/editing_tools/EditingTools.vala"
		self->priv->custom_aspect_ratio = ((gfloat) self->priv->custom_init_width) / ((gfloat) self->priv->custom_init_height);
#line 10197 "EditingTools.c"
	}
#line 1742 "../src/editing_tools/EditingTools.vala"
	result = FALSE;
#line 1742 "../src/editing_tools/EditingTools.vala"
	return result;
#line 10203 "EditingTools.c"
}

static void
editing_tools_crop_tool_crop_resized (EditingToolsCropTool* self,
                                      Box* new_crop)
{
	Box _tmp0_;
	EditingToolsPhotoCanvas* _tmp1_;
	Box _tmp2_;
	Box horizontal = {0};
	gboolean horizontal_enlarged = FALSE;
	Box vertical = {0};
	gboolean vertical_enlarged = FALSE;
	BoxComplements complements = 0;
	Box _tmp3_;
	Box _tmp4_ = {0};
	gboolean _tmp5_ = FALSE;
	Box _tmp6_ = {0};
	gboolean _tmp7_ = FALSE;
	BoxComplements _tmp8_;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp12_ = FALSE;
	Box _tmp15_;
	EditingToolsPhotoCanvas* _tmp16_;
	Box _tmp17_;
#line 1745 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_CROP_TOOL (self));
#line 1745 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (new_crop != NULL);
#line 1746 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = *new_crop;
#line 1746 "../src/editing_tools/EditingTools.vala"
	if (box_equals (&self->priv->scaled_crop, &_tmp0_)) {
#line 1748 "../src/editing_tools/EditingTools.vala"
		return;
#line 10239 "EditingTools.c"
	}
#line 1751 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 1751 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = self->priv->scaled_crop;
#line 1751 "../src/editing_tools/EditingTools.vala"
	editing_tools_photo_canvas_invalidate_area (_tmp1_, &_tmp2_);
#line 1757 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = *new_crop;
#line 1757 "../src/editing_tools/EditingTools.vala"
	_tmp8_ = box_resized_complements (&self->priv->scaled_crop, &_tmp3_, &_tmp4_, &_tmp5_, &_tmp6_, &_tmp7_);
#line 1757 "../src/editing_tools/EditingTools.vala"
	horizontal = _tmp4_;
#line 1757 "../src/editing_tools/EditingTools.vala"
	horizontal_enlarged = _tmp5_;
#line 1757 "../src/editing_tools/EditingTools.vala"
	vertical = _tmp6_;
#line 1757 "../src/editing_tools/EditingTools.vala"
	vertical_enlarged = _tmp7_;
#line 1757 "../src/editing_tools/EditingTools.vala"
	complements = _tmp8_;
#line 1761 "../src/editing_tools/EditingTools.vala"
	_vala_assert (complements != BOX_COMPLEMENTS_NONE, "complements != BoxComplements.NONE");
#line 1763 "../src/editing_tools/EditingTools.vala"
	if (complements == BOX_COMPLEMENTS_HORIZONTAL) {
#line 1763 "../src/editing_tools/EditingTools.vala"
		_tmp9_ = TRUE;
#line 10267 "EditingTools.c"
	} else {
#line 1763 "../src/editing_tools/EditingTools.vala"
		_tmp9_ = complements == BOX_COMPLEMENTS_BOTH;
#line 10271 "EditingTools.c"
	}
#line 1763 "../src/editing_tools/EditingTools.vala"
	if (_tmp9_) {
#line 10275 "EditingTools.c"
		gdouble _tmp10_ = 0.0;
		Box _tmp11_;
#line 1764 "../src/editing_tools/EditingTools.vala"
		if (horizontal_enlarged) {
#line 1764 "../src/editing_tools/EditingTools.vala"
			_tmp10_ = 0.0;
#line 10282 "EditingTools.c"
		} else {
#line 1764 "../src/editing_tools/EditingTools.vala"
			_tmp10_ = 0.5;
#line 10286 "EditingTools.c"
		}
#line 1764 "../src/editing_tools/EditingTools.vala"
		_tmp11_ = horizontal;
#line 1764 "../src/editing_tools/EditingTools.vala"
		editing_tools_crop_tool_set_area_alpha (self, &_tmp11_, _tmp10_);
#line 10292 "EditingTools.c"
	}
#line 1766 "../src/editing_tools/EditingTools.vala"
	if (complements == BOX_COMPLEMENTS_VERTICAL) {
#line 1766 "../src/editing_tools/EditingTools.vala"
		_tmp12_ = TRUE;
#line 10298 "EditingTools.c"
	} else {
#line 1766 "../src/editing_tools/EditingTools.vala"
		_tmp12_ = complements == BOX_COMPLEMENTS_BOTH;
#line 10302 "EditingTools.c"
	}
#line 1766 "../src/editing_tools/EditingTools.vala"
	if (_tmp12_) {
#line 10306 "EditingTools.c"
		gdouble _tmp13_ = 0.0;
		Box _tmp14_;
#line 1767 "../src/editing_tools/EditingTools.vala"
		if (vertical_enlarged) {
#line 1767 "../src/editing_tools/EditingTools.vala"
			_tmp13_ = 0.0;
#line 10313 "EditingTools.c"
		} else {
#line 1767 "../src/editing_tools/EditingTools.vala"
			_tmp13_ = 0.5;
#line 10317 "EditingTools.c"
		}
#line 1767 "../src/editing_tools/EditingTools.vala"
		_tmp14_ = vertical;
#line 1767 "../src/editing_tools/EditingTools.vala"
		editing_tools_crop_tool_set_area_alpha (self, &_tmp14_, _tmp13_);
#line 10323 "EditingTools.c"
	}
#line 1769 "../src/editing_tools/EditingTools.vala"
	_tmp15_ = *new_crop;
#line 1769 "../src/editing_tools/EditingTools.vala"
	editing_tools_crop_tool_paint_crop_tool (self, &_tmp15_);
#line 1770 "../src/editing_tools/EditingTools.vala"
	_tmp16_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 1770 "../src/editing_tools/EditingTools.vala"
	_tmp17_ = *new_crop;
#line 1770 "../src/editing_tools/EditingTools.vala"
	editing_tools_photo_canvas_invalidate_area (_tmp16_, &_tmp17_);
#line 10335 "EditingTools.c"
}

static void
editing_tools_crop_tool_crop_moved (EditingToolsCropTool* self,
                                    Box* new_crop)
{
	Box _tmp0_;
	EditingToolsPhotoCanvas* _tmp1_;
	Box _tmp2_;
	Box _tmp3_;
	Box _tmp4_;
	Box _tmp5_;
	EditingToolsPhotoCanvas* _tmp6_;
	Box _tmp7_;
#line 1773 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_CROP_TOOL (self));
#line 1773 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (new_crop != NULL);
#line 1774 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = *new_crop;
#line 1774 "../src/editing_tools/EditingTools.vala"
	if (box_equals (&self->priv->scaled_crop, &_tmp0_)) {
#line 1776 "../src/editing_tools/EditingTools.vala"
		return;
#line 10360 "EditingTools.c"
	}
#line 1779 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 1779 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = self->priv->scaled_crop;
#line 1779 "../src/editing_tools/EditingTools.vala"
	editing_tools_photo_canvas_invalidate_area (_tmp1_, &_tmp2_);
#line 1781 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = self->priv->scaled_crop;
#line 1781 "../src/editing_tools/EditingTools.vala"
	editing_tools_crop_tool_set_area_alpha (self, &_tmp3_, 0.5);
#line 1782 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = *new_crop;
#line 1782 "../src/editing_tools/EditingTools.vala"
	editing_tools_crop_tool_set_area_alpha (self, &_tmp4_, 0.0);
#line 1786 "../src/editing_tools/EditingTools.vala"
	_tmp5_ = *new_crop;
#line 1786 "../src/editing_tools/EditingTools.vala"
	editing_tools_crop_tool_paint_crop_tool (self, &_tmp5_);
#line 1787 "../src/editing_tools/EditingTools.vala"
	_tmp6_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 1787 "../src/editing_tools/EditingTools.vala"
	_tmp7_ = *new_crop;
#line 1787 "../src/editing_tools/EditingTools.vala"
	editing_tools_photo_canvas_invalidate_area (_tmp6_, &_tmp7_);
#line 10386 "EditingTools.c"
}

static void
editing_tools_crop_tool_set_area_alpha (EditingToolsCropTool* self,
                                        Box* area,
                                        gdouble alpha)
{
	cairo_t* ctx = NULL;
	cairo_surface_t* _tmp0_;
	cairo_t* _tmp1_;
	Box _tmp2_;
	Box _tmp3_;
	EditingToolsPhotoCanvas* _tmp4_;
	cairo_surface_t* _tmp5_;
	Box _tmp6_;
#line 1790 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_CROP_TOOL (self));
#line 1790 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (area != NULL);
#line 1791 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->crop_surface;
#line 1791 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = cairo_create (_tmp0_);
#line 1791 "../src/editing_tools/EditingTools.vala"
	ctx = _tmp1_;
#line 1792 "../src/editing_tools/EditingTools.vala"
	cairo_set_operator (ctx, CAIRO_OPERATOR_SOURCE);
#line 1793 "../src/editing_tools/EditingTools.vala"
	cairo_set_source_rgba (ctx, 0.0, 0.0, 0.0, alpha);
#line 1794 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = *area;
#line 1794 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = *area;
#line 1794 "../src/editing_tools/EditingTools.vala"
	cairo_rectangle (ctx, (gdouble) _tmp2_.left, (gdouble) _tmp3_.top, (gdouble) box_get_width (area), (gdouble) box_get_height (area));
#line 1795 "../src/editing_tools/EditingTools.vala"
	cairo_fill (ctx);
#line 1796 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 1796 "../src/editing_tools/EditingTools.vala"
	_tmp5_ = self->priv->crop_surface;
#line 1796 "../src/editing_tools/EditingTools.vala"
	_tmp6_ = *area;
#line 1796 "../src/editing_tools/EditingTools.vala"
	editing_tools_photo_canvas_paint_surface_area (_tmp4_, _tmp5_, &_tmp6_, TRUE);
#line 1790 "../src/editing_tools/EditingTools.vala"
	_cairo_destroy0 (ctx);
#line 10434 "EditingTools.c"
}

static void
editing_tools_crop_tool_paint_crop_tool (EditingToolsCropTool* self,
                                         Box* crop)
{
	EditingToolsPhotoCanvas* _tmp38_;
	cairo_t* _tmp39_;
	Box _tmp40_;
	EditingToolsPhotoCanvas* _tmp41_;
	cairo_t* _tmp42_;
	Box _tmp43_ = {0};
	EditingToolsPhotoCanvas* _tmp44_;
	cairo_t* _tmp45_;
	Box _tmp46_ = {0};
#line 1799 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_CROP_TOOL (self));
#line 1799 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (crop != NULL);
#line 1801 "../src/editing_tools/EditingTools.vala"
	if (self->priv->in_manipulation != BOX_LOCATION_OUTSIDE) {
#line 10456 "EditingTools.c"
		gint one_third_x = 0;
		gint one_third_y = 0;
		EditingToolsPhotoCanvas* _tmp0_;
		cairo_t* _tmp1_;
		Box _tmp2_;
		Box _tmp3_;
		EditingToolsPhotoCanvas* _tmp4_;
		cairo_t* _tmp5_;
		Box _tmp6_;
		Box _tmp7_;
		EditingToolsPhotoCanvas* _tmp8_;
		cairo_t* _tmp9_;
		Box _tmp10_;
		Box _tmp11_;
		EditingToolsPhotoCanvas* _tmp12_;
		cairo_t* _tmp13_;
		Box _tmp14_;
		Box _tmp15_;
		Box adj_crop = {0};
		EditingToolsPhotoCanvas* _tmp16_;
		GdkRectangle _tmp17_ = {0};
		Dimensions _tmp18_ = {0};
		EditingToolsPhotoCanvas* _tmp19_;
		Photo* _tmp20_;
		Photo* _tmp21_;
		Dimensions _tmp22_ = {0};
		Box _tmp23_ = {0};
		Box _tmp24_;
		gchar* text = NULL;
		gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		gchar* _tmp30_;
		gchar* _tmp31_;
		gchar* _tmp32_;
		gint x = 0;
		Box _tmp33_;
		gint y = 0;
		Box _tmp34_;
		EditingToolsPhotoCanvas* _tmp35_;
		cairo_t* _tmp36_;
		const gchar* _tmp37_;
#line 1802 "../src/editing_tools/EditingTools.vala"
		one_third_x = box_get_width (crop) / 3;
#line 1803 "../src/editing_tools/EditingTools.vala"
		one_third_y = box_get_height (crop) / 3;
#line 1805 "../src/editing_tools/EditingTools.vala"
		_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 1805 "../src/editing_tools/EditingTools.vala"
		_tmp1_ = self->priv->thin_white_ctx;
#line 1805 "../src/editing_tools/EditingTools.vala"
		_tmp2_ = *crop;
#line 1805 "../src/editing_tools/EditingTools.vala"
		_tmp3_ = *crop;
#line 1805 "../src/editing_tools/EditingTools.vala"
		editing_tools_photo_canvas_draw_horizontal_line (_tmp0_, _tmp1_, _tmp2_.left, _tmp3_.top + one_third_y, box_get_width (crop), TRUE);
#line 1806 "../src/editing_tools/EditingTools.vala"
		_tmp4_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 1806 "../src/editing_tools/EditingTools.vala"
		_tmp5_ = self->priv->thin_white_ctx;
#line 1806 "../src/editing_tools/EditingTools.vala"
		_tmp6_ = *crop;
#line 1806 "../src/editing_tools/EditingTools.vala"
		_tmp7_ = *crop;
#line 1806 "../src/editing_tools/EditingTools.vala"
		editing_tools_photo_canvas_draw_horizontal_line (_tmp4_, _tmp5_, _tmp6_.left, _tmp7_.top + (one_third_y * 2), box_get_width (crop), TRUE);
#line 1808 "../src/editing_tools/EditingTools.vala"
		_tmp8_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 1808 "../src/editing_tools/EditingTools.vala"
		_tmp9_ = self->priv->thin_white_ctx;
#line 1808 "../src/editing_tools/EditingTools.vala"
		_tmp10_ = *crop;
#line 1808 "../src/editing_tools/EditingTools.vala"
		_tmp11_ = *crop;
#line 1808 "../src/editing_tools/EditingTools.vala"
		editing_tools_photo_canvas_draw_vertical_line (_tmp8_, _tmp9_, _tmp10_.left + one_third_x, _tmp11_.top, box_get_height (crop), TRUE);
#line 1809 "../src/editing_tools/EditingTools.vala"
		_tmp12_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 1809 "../src/editing_tools/EditingTools.vala"
		_tmp13_ = self->priv->thin_white_ctx;
#line 1809 "../src/editing_tools/EditingTools.vala"
		_tmp14_ = *crop;
#line 1809 "../src/editing_tools/EditingTools.vala"
		_tmp15_ = *crop;
#line 1809 "../src/editing_tools/EditingTools.vala"
		editing_tools_photo_canvas_draw_vertical_line (_tmp12_, _tmp13_, _tmp14_.left + (one_third_x * 2), _tmp15_.top, box_get_height (crop), TRUE);
#line 1813 "../src/editing_tools/EditingTools.vala"
		_tmp16_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 1813 "../src/editing_tools/EditingTools.vala"
		editing_tools_photo_canvas_get_scaled_pixbuf_position (_tmp16_, &_tmp17_);
#line 1813 "../src/editing_tools/EditingTools.vala"
		dimensions_for_rectangle (&_tmp17_, &_tmp18_);
#line 1813 "../src/editing_tools/EditingTools.vala"
		_tmp19_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 1813 "../src/editing_tools/EditingTools.vala"
		_tmp20_ = editing_tools_photo_canvas_get_photo (_tmp19_);
#line 1813 "../src/editing_tools/EditingTools.vala"
		_tmp21_ = _tmp20_;
#line 1813 "../src/editing_tools/EditingTools.vala"
		media_source_get_dimensions (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, TYPE_MEDIA_SOURCE, MediaSource), PHOTO_EXCEPTION_CROP, &_tmp22_);
#line 1813 "../src/editing_tools/EditingTools.vala"
		box_get_scaled_similar (&self->priv->scaled_crop, &_tmp18_, &_tmp22_, &_tmp23_);
#line 1813 "../src/editing_tools/EditingTools.vala"
		_tmp24_ = _tmp23_;
#line 1813 "../src/editing_tools/EditingTools.vala"
		_g_object_unref0 (_tmp21_);
#line 1813 "../src/editing_tools/EditingTools.vala"
		adj_crop = _tmp24_;
#line 1816 "../src/editing_tools/EditingTools.vala"
		_tmp25_ = g_strdup_printf ("%i", box_get_width (&adj_crop));
#line 1816 "../src/editing_tools/EditingTools.vala"
		_tmp26_ = _tmp25_;
#line 1816 "../src/editing_tools/EditingTools.vala"
		_tmp27_ = g_strconcat (_tmp26_, "x", NULL);
#line 1816 "../src/editing_tools/EditingTools.vala"
		_tmp28_ = _tmp27_;
#line 1816 "../src/editing_tools/EditingTools.vala"
		_tmp29_ = g_strdup_printf ("%i", box_get_height (&adj_crop));
#line 1816 "../src/editing_tools/EditingTools.vala"
		_tmp30_ = _tmp29_;
#line 1816 "../src/editing_tools/EditingTools.vala"
		_tmp31_ = g_strconcat (_tmp28_, _tmp30_, NULL);
#line 1816 "../src/editing_tools/EditingTools.vala"
		_tmp32_ = _tmp31_;
#line 1816 "../src/editing_tools/EditingTools.vala"
		_g_free0 (_tmp30_);
#line 1816 "../src/editing_tools/EditingTools.vala"
		_g_free0 (_tmp28_);
#line 1816 "../src/editing_tools/EditingTools.vala"
		_g_free0 (_tmp26_);
#line 1816 "../src/editing_tools/EditingTools.vala"
		text = _tmp32_;
#line 1817 "../src/editing_tools/EditingTools.vala"
		_tmp33_ = *crop;
#line 1817 "../src/editing_tools/EditingTools.vala"
		x = _tmp33_.left + (box_get_width (crop) / 2);
#line 1818 "../src/editing_tools/EditingTools.vala"
		_tmp34_ = *crop;
#line 1818 "../src/editing_tools/EditingTools.vala"
		y = _tmp34_.top + (box_get_height (crop) / 2);
#line 1819 "../src/editing_tools/EditingTools.vala"
		_tmp35_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 1819 "../src/editing_tools/EditingTools.vala"
		_tmp36_ = self->priv->text_ctx;
#line 1819 "../src/editing_tools/EditingTools.vala"
		_tmp37_ = text;
#line 1819 "../src/editing_tools/EditingTools.vala"
		editing_tools_photo_canvas_draw_text (_tmp35_, _tmp36_, _tmp37_, x, y, TRUE);
#line 1801 "../src/editing_tools/EditingTools.vala"
		_g_free0 (text);
#line 10609 "EditingTools.c"
	}
#line 1823 "../src/editing_tools/EditingTools.vala"
	_tmp38_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 1823 "../src/editing_tools/EditingTools.vala"
	_tmp39_ = self->priv->wide_black_ctx;
#line 1823 "../src/editing_tools/EditingTools.vala"
	_tmp40_ = *crop;
#line 1823 "../src/editing_tools/EditingTools.vala"
	editing_tools_photo_canvas_draw_box (_tmp38_, _tmp39_, &_tmp40_);
#line 1824 "../src/editing_tools/EditingTools.vala"
	_tmp41_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 1824 "../src/editing_tools/EditingTools.vala"
	_tmp42_ = self->priv->wide_white_ctx;
#line 1824 "../src/editing_tools/EditingTools.vala"
	box_get_reduced (crop, 1, &_tmp43_);
#line 1824 "../src/editing_tools/EditingTools.vala"
	editing_tools_photo_canvas_draw_box (_tmp41_, _tmp42_, &_tmp43_);
#line 1825 "../src/editing_tools/EditingTools.vala"
	_tmp44_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 1825 "../src/editing_tools/EditingTools.vala"
	_tmp45_ = self->priv->wide_white_ctx;
#line 1825 "../src/editing_tools/EditingTools.vala"
	box_get_reduced (crop, 2, &_tmp46_);
#line 1825 "../src/editing_tools/EditingTools.vala"
	editing_tools_photo_canvas_draw_box (_tmp44_, _tmp45_, &_tmp46_);
#line 10635 "EditingTools.c"
}

static EditingToolsCropToolConstraintDescription*
editing_tools_crop_tool_constraint_description_construct (GType object_type,
                                                          const gchar* new_name,
                                                          gint new_basis_width,
                                                          gint new_basis_height,
                                                          gboolean new_pivotable,
                                                          gfloat new_aspect_ratio)
{
	EditingToolsCropToolConstraintDescription* self = NULL;
	gchar* _tmp0_;
#line 604 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (new_name != NULL, NULL);
#line 604 "../src/editing_tools/EditingTools.vala"
	self = (EditingToolsCropToolConstraintDescription*) g_type_create_instance (object_type);
#line 606 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = g_strdup (new_name);
#line 606 "../src/editing_tools/EditingTools.vala"
	_g_free0 (self->name);
#line 606 "../src/editing_tools/EditingTools.vala"
	self->name = _tmp0_;
#line 607 "../src/editing_tools/EditingTools.vala"
	self->basis_width = new_basis_width;
#line 608 "../src/editing_tools/EditingTools.vala"
	self->basis_height = new_basis_height;
#line 609 "../src/editing_tools/EditingTools.vala"
	if (new_aspect_ratio == EDITING_TOOLS_CROP_TOOL_COMPUTE_FROM_BASIS) {
#line 610 "../src/editing_tools/EditingTools.vala"
		self->aspect_ratio = ((gfloat) self->basis_width) / ((gfloat) self->basis_height);
#line 10666 "EditingTools.c"
	} else {
#line 612 "../src/editing_tools/EditingTools.vala"
		self->aspect_ratio = new_aspect_ratio;
#line 10670 "EditingTools.c"
	}
#line 613 "../src/editing_tools/EditingTools.vala"
	self->is_pivotable = new_pivotable;
#line 604 "../src/editing_tools/EditingTools.vala"
	return self;
#line 10676 "EditingTools.c"
}

static EditingToolsCropToolConstraintDescription*
editing_tools_crop_tool_constraint_description_new (const gchar* new_name,
                                                    gint new_basis_width,
                                                    gint new_basis_height,
                                                    gboolean new_pivotable,
                                                    gfloat new_aspect_ratio)
{
#line 604 "../src/editing_tools/EditingTools.vala"
	return editing_tools_crop_tool_constraint_description_construct (EDITING_TOOLS_CROP_TOOL_TYPE_CONSTRAINT_DESCRIPTION, new_name, new_basis_width, new_basis_height, new_pivotable, new_aspect_ratio);
#line 10688 "EditingTools.c"
}

static gboolean
editing_tools_crop_tool_constraint_description_is_separator (EditingToolsCropToolConstraintDescription* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 616 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (EDITING_TOOLS_CROP_TOOL_IS_CONSTRAINT_DESCRIPTION (self), FALSE);
#line 617 "../src/editing_tools/EditingTools.vala"
	if (!self->is_pivotable) {
#line 617 "../src/editing_tools/EditingTools.vala"
		_tmp0_ = self->aspect_ratio == EDITING_TOOLS_CROP_TOOL_SEPARATOR;
#line 10702 "EditingTools.c"
	} else {
#line 617 "../src/editing_tools/EditingTools.vala"
		_tmp0_ = FALSE;
#line 10706 "EditingTools.c"
	}
#line 617 "../src/editing_tools/EditingTools.vala"
	result = _tmp0_;
#line 617 "../src/editing_tools/EditingTools.vala"
	return result;
#line 10712 "EditingTools.c"
}

static void
editing_tools_crop_tool_value_constraint_description_init (GValue* value)
{
#line 597 "../src/editing_tools/EditingTools.vala"
	value->data[0].v_pointer = NULL;
#line 10720 "EditingTools.c"
}

static void
editing_tools_crop_tool_value_constraint_description_free_value (GValue* value)
{
#line 597 "../src/editing_tools/EditingTools.vala"
	if (value->data[0].v_pointer) {
#line 597 "../src/editing_tools/EditingTools.vala"
		editing_tools_crop_tool_constraint_description_unref (value->data[0].v_pointer);
#line 10730 "EditingTools.c"
	}
}

static void
editing_tools_crop_tool_value_constraint_description_copy_value (const GValue* src_value,
                                                                 GValue* dest_value)
{
#line 597 "../src/editing_tools/EditingTools.vala"
	if (src_value->data[0].v_pointer) {
#line 597 "../src/editing_tools/EditingTools.vala"
		dest_value->data[0].v_pointer = editing_tools_crop_tool_constraint_description_ref (src_value->data[0].v_pointer);
#line 10742 "EditingTools.c"
	} else {
#line 597 "../src/editing_tools/EditingTools.vala"
		dest_value->data[0].v_pointer = NULL;
#line 10746 "EditingTools.c"
	}
}

static gpointer
editing_tools_crop_tool_value_constraint_description_peek_pointer (const GValue* value)
{
#line 597 "../src/editing_tools/EditingTools.vala"
	return value->data[0].v_pointer;
#line 10755 "EditingTools.c"
}

static gchar*
editing_tools_crop_tool_value_constraint_description_collect_value (GValue* value,
                                                                    guint n_collect_values,
                                                                    GTypeCValue* collect_values,
                                                                    guint collect_flags)
{
#line 597 "../src/editing_tools/EditingTools.vala"
	if (collect_values[0].v_pointer) {
#line 10766 "EditingTools.c"
		EditingToolsCropToolConstraintDescription * object;
		object = collect_values[0].v_pointer;
#line 597 "../src/editing_tools/EditingTools.vala"
		if (object->parent_instance.g_class == NULL) {
#line 597 "../src/editing_tools/EditingTools.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 10773 "EditingTools.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 597 "../src/editing_tools/EditingTools.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 10777 "EditingTools.c"
		}
#line 597 "../src/editing_tools/EditingTools.vala"
		value->data[0].v_pointer = editing_tools_crop_tool_constraint_description_ref (object);
#line 10781 "EditingTools.c"
	} else {
#line 597 "../src/editing_tools/EditingTools.vala"
		value->data[0].v_pointer = NULL;
#line 10785 "EditingTools.c"
	}
#line 597 "../src/editing_tools/EditingTools.vala"
	return NULL;
#line 10789 "EditingTools.c"
}

static gchar*
editing_tools_crop_tool_value_constraint_description_lcopy_value (const GValue* value,
                                                                  guint n_collect_values,
                                                                  GTypeCValue* collect_values,
                                                                  guint collect_flags)
{
	EditingToolsCropToolConstraintDescription ** object_p;
	object_p = collect_values[0].v_pointer;
#line 597 "../src/editing_tools/EditingTools.vala"
	if (!object_p) {
#line 597 "../src/editing_tools/EditingTools.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 10804 "EditingTools.c"
	}
#line 597 "../src/editing_tools/EditingTools.vala"
	if (!value->data[0].v_pointer) {
#line 597 "../src/editing_tools/EditingTools.vala"
		*object_p = NULL;
#line 10810 "EditingTools.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 597 "../src/editing_tools/EditingTools.vala"
		*object_p = value->data[0].v_pointer;
#line 10814 "EditingTools.c"
	} else {
#line 597 "../src/editing_tools/EditingTools.vala"
		*object_p = editing_tools_crop_tool_constraint_description_ref (value->data[0].v_pointer);
#line 10818 "EditingTools.c"
	}
#line 597 "../src/editing_tools/EditingTools.vala"
	return NULL;
#line 10822 "EditingTools.c"
}

static GParamSpec*
editing_tools_crop_tool_param_spec_constraint_description (const gchar* name,
                                                           const gchar* nick,
                                                           const gchar* blurb,
                                                           GType object_type,
                                                           GParamFlags flags)
{
	EditingToolsCropToolParamSpecConstraintDescription* spec;
#line 597 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (g_type_is_a (object_type, EDITING_TOOLS_CROP_TOOL_TYPE_CONSTRAINT_DESCRIPTION), NULL);
#line 597 "../src/editing_tools/EditingTools.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 597 "../src/editing_tools/EditingTools.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 597 "../src/editing_tools/EditingTools.vala"
	return G_PARAM_SPEC (spec);
#line 10841 "EditingTools.c"
}

static gpointer
editing_tools_crop_tool_value_get_constraint_description (const GValue* value)
{
#line 597 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, EDITING_TOOLS_CROP_TOOL_TYPE_CONSTRAINT_DESCRIPTION), NULL);
#line 597 "../src/editing_tools/EditingTools.vala"
	return value->data[0].v_pointer;
#line 10851 "EditingTools.c"
}

static void
editing_tools_crop_tool_value_set_constraint_description (GValue* value,
                                                          gpointer v_object)
{
	EditingToolsCropToolConstraintDescription * old;
#line 597 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, EDITING_TOOLS_CROP_TOOL_TYPE_CONSTRAINT_DESCRIPTION));
#line 597 "../src/editing_tools/EditingTools.vala"
	old = value->data[0].v_pointer;
#line 597 "../src/editing_tools/EditingTools.vala"
	if (v_object) {
#line 597 "../src/editing_tools/EditingTools.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, EDITING_TOOLS_CROP_TOOL_TYPE_CONSTRAINT_DESCRIPTION));
#line 597 "../src/editing_tools/EditingTools.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 597 "../src/editing_tools/EditingTools.vala"
		value->data[0].v_pointer = v_object;
#line 597 "../src/editing_tools/EditingTools.vala"
		editing_tools_crop_tool_constraint_description_ref (value->data[0].v_pointer);
#line 10873 "EditingTools.c"
	} else {
#line 597 "../src/editing_tools/EditingTools.vala"
		value->data[0].v_pointer = NULL;
#line 10877 "EditingTools.c"
	}
#line 597 "../src/editing_tools/EditingTools.vala"
	if (old) {
#line 597 "../src/editing_tools/EditingTools.vala"
		editing_tools_crop_tool_constraint_description_unref (old);
#line 10883 "EditingTools.c"
	}
}

static void
editing_tools_crop_tool_value_take_constraint_description (GValue* value,
                                                           gpointer v_object)
{
	EditingToolsCropToolConstraintDescription * old;
#line 597 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, EDITING_TOOLS_CROP_TOOL_TYPE_CONSTRAINT_DESCRIPTION));
#line 597 "../src/editing_tools/EditingTools.vala"
	old = value->data[0].v_pointer;
#line 597 "../src/editing_tools/EditingTools.vala"
	if (v_object) {
#line 597 "../src/editing_tools/EditingTools.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, EDITING_TOOLS_CROP_TOOL_TYPE_CONSTRAINT_DESCRIPTION));
#line 597 "../src/editing_tools/EditingTools.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 597 "../src/editing_tools/EditingTools.vala"
		value->data[0].v_pointer = v_object;
#line 10904 "EditingTools.c"
	} else {
#line 597 "../src/editing_tools/EditingTools.vala"
		value->data[0].v_pointer = NULL;
#line 10908 "EditingTools.c"
	}
#line 597 "../src/editing_tools/EditingTools.vala"
	if (old) {
#line 597 "../src/editing_tools/EditingTools.vala"
		editing_tools_crop_tool_constraint_description_unref (old);
#line 10914 "EditingTools.c"
	}
}

static void
editing_tools_crop_tool_constraint_description_class_init (EditingToolsCropToolConstraintDescriptionClass * klass,
                                                           gpointer klass_data)
{
#line 597 "../src/editing_tools/EditingTools.vala"
	editing_tools_crop_tool_constraint_description_parent_class = g_type_class_peek_parent (klass);
#line 597 "../src/editing_tools/EditingTools.vala"
	((EditingToolsCropToolConstraintDescriptionClass *) klass)->finalize = editing_tools_crop_tool_constraint_description_finalize;
#line 10926 "EditingTools.c"
}

static void
editing_tools_crop_tool_constraint_description_instance_init (EditingToolsCropToolConstraintDescription * self,
                                                              gpointer klass)
{
#line 597 "../src/editing_tools/EditingTools.vala"
	self->ref_count = 1;
#line 10935 "EditingTools.c"
}

static void
editing_tools_crop_tool_constraint_description_finalize (EditingToolsCropToolConstraintDescription * obj)
{
	EditingToolsCropToolConstraintDescription * self;
#line 597 "../src/editing_tools/EditingTools.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, EDITING_TOOLS_CROP_TOOL_TYPE_CONSTRAINT_DESCRIPTION, EditingToolsCropToolConstraintDescription);
#line 597 "../src/editing_tools/EditingTools.vala"
	g_signal_handlers_destroy (self);
#line 598 "../src/editing_tools/EditingTools.vala"
	_g_free0 (self->name);
#line 10948 "EditingTools.c"
}

static GType
editing_tools_crop_tool_constraint_description_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { editing_tools_crop_tool_value_constraint_description_init, editing_tools_crop_tool_value_constraint_description_free_value, editing_tools_crop_tool_value_constraint_description_copy_value, editing_tools_crop_tool_value_constraint_description_peek_pointer, "p", editing_tools_crop_tool_value_constraint_description_collect_value, "p", editing_tools_crop_tool_value_constraint_description_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (EditingToolsCropToolConstraintDescriptionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) editing_tools_crop_tool_constraint_description_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EditingToolsCropToolConstraintDescription), 0, (GInstanceInitFunc) editing_tools_crop_tool_constraint_description_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType editing_tools_crop_tool_constraint_description_type_id;
	editing_tools_crop_tool_constraint_description_type_id = g_type_register_fundamental (g_type_fundamental_next (), "EditingToolsCropToolConstraintDescription", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return editing_tools_crop_tool_constraint_description_type_id;
}

static GType
editing_tools_crop_tool_constraint_description_get_type (void)
{
	static volatile gsize editing_tools_crop_tool_constraint_description_type_id__once = 0;
	if (g_once_init_enter (&editing_tools_crop_tool_constraint_description_type_id__once)) {
		GType editing_tools_crop_tool_constraint_description_type_id;
		editing_tools_crop_tool_constraint_description_type_id = editing_tools_crop_tool_constraint_description_get_type_once ();
		g_once_init_leave (&editing_tools_crop_tool_constraint_description_type_id__once, editing_tools_crop_tool_constraint_description_type_id);
	}
	return editing_tools_crop_tool_constraint_description_type_id__once;
}

static gpointer
editing_tools_crop_tool_constraint_description_ref (gpointer instance)
{
	EditingToolsCropToolConstraintDescription * self;
	self = instance;
#line 597 "../src/editing_tools/EditingTools.vala"
	g_atomic_int_inc (&self->ref_count);
#line 597 "../src/editing_tools/EditingTools.vala"
	return instance;
#line 10983 "EditingTools.c"
}

static void
editing_tools_crop_tool_constraint_description_unref (gpointer instance)
{
	EditingToolsCropToolConstraintDescription * self;
	self = instance;
#line 597 "../src/editing_tools/EditingTools.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 597 "../src/editing_tools/EditingTools.vala"
		EDITING_TOOLS_CROP_TOOL_CONSTRAINT_DESCRIPTION_GET_CLASS (self)->finalize (self);
#line 597 "../src/editing_tools/EditingTools.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 10997 "EditingTools.c"
	}
}

static gboolean
_editing_tools_crop_tool_crop_tool_window_constraint_combo_separator_func_gtk_tree_view_row_separator_func (GtkTreeModel* model,
                                                                                                            GtkTreeIter* iter,
                                                                                                            gpointer self)
{
	gboolean result;
	result = editing_tools_crop_tool_crop_tool_window_constraint_combo_separator_func (model, iter);
#line 665 "../src/editing_tools/EditingTools.vala"
	return result;
#line 11010 "EditingTools.c"
}

static EditingToolsCropToolCropToolWindow*
editing_tools_crop_tool_crop_tool_window_construct (GType object_type,
                                                    GtkWindow* container)
{
	EditingToolsCropToolCropToolWindow * self = NULL;
	GtkButton* _tmp0_;
	GtkButton* _tmp1_;
	GtkButton* _tmp2_;
	GtkButton* _tmp3_;
	GtkComboBox* _tmp4_;
	GtkCellRendererText* combo_text_renderer = NULL;
	GtkCellRendererText* _tmp5_;
	GtkComboBox* _tmp6_;
	GtkComboBox* _tmp7_;
	GtkComboBox* _tmp8_;
	GtkComboBox* _tmp9_;
	GtkImage* image = NULL;
	GtkImage* _tmp10_;
	GtkButton* _tmp11_;
	GtkButton* _tmp12_;
	GtkEntry* _tmp13_;
	GtkEntry* _tmp14_;
	GtkEntry* _tmp15_;
	GtkEntry* _tmp16_;
	GtkBox* _tmp17_;
	GtkBox* _tmp18_;
	GtkBox* _tmp19_;
	GtkButton* _tmp20_;
	GtkBox* _tmp21_;
	GtkButton* _tmp22_;
	GtkBox* _tmp23_;
	GtkBox* _tmp24_;
	GtkComboBox* _tmp25_;
	GtkBox* _tmp26_;
	GtkButton* _tmp27_;
	GtkBox* _tmp28_;
	GtkBox* _tmp29_;
	GtkBox* _tmp30_;
#line 652 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (container, gtk_window_get_type ()), NULL);
#line 653 "../src/editing_tools/EditingTools.vala"
	self = (EditingToolsCropToolCropToolWindow*) editing_tools_editing_tool_window_construct (object_type, container);
#line 655 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->cancel_button;
#line 655 "../src/editing_tools/EditingTools.vala"
	gtk_widget_set_tooltip_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget), _ ("Return to current photo dimensions"));
#line 656 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = self->cancel_button;
#line 656 "../src/editing_tools/EditingTools.vala"
	gtk_button_set_image_position (_tmp1_, GTK_POS_LEFT);
#line 658 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = self->ok_button;
#line 658 "../src/editing_tools/EditingTools.vala"
	gtk_widget_set_tooltip_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_widget_get_type (), GtkWidget), _ ("Set the crop for this photo"));
#line 659 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = self->ok_button;
#line 659 "../src/editing_tools/EditingTools.vala"
	gtk_button_set_image_position (_tmp3_, GTK_POS_LEFT);
#line 661 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = (GtkComboBox*) gtk_combo_box_new ();
#line 661 "../src/editing_tools/EditingTools.vala"
	g_object_ref_sink (_tmp4_);
#line 661 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->constraint_combo);
#line 661 "../src/editing_tools/EditingTools.vala"
	self->constraint_combo = _tmp4_;
#line 662 "../src/editing_tools/EditingTools.vala"
	_tmp5_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 662 "../src/editing_tools/EditingTools.vala"
	g_object_ref_sink (_tmp5_);
#line 662 "../src/editing_tools/EditingTools.vala"
	combo_text_renderer = _tmp5_;
#line 663 "../src/editing_tools/EditingTools.vala"
	_tmp6_ = self->constraint_combo;
#line 663 "../src/editing_tools/EditingTools.vala"
	gtk_cell_layout_pack_start (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gtk_cell_layout_get_type (), GtkCellLayout), G_TYPE_CHECK_INSTANCE_CAST (combo_text_renderer, gtk_cell_renderer_get_type (), GtkCellRenderer), TRUE);
#line 664 "../src/editing_tools/EditingTools.vala"
	_tmp7_ = self->constraint_combo;
#line 664 "../src/editing_tools/EditingTools.vala"
	gtk_cell_layout_add_attribute (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_cell_layout_get_type (), GtkCellLayout), G_TYPE_CHECK_INSTANCE_CAST (combo_text_renderer, gtk_cell_renderer_get_type (), GtkCellRenderer), "text", 0);
#line 665 "../src/editing_tools/EditingTools.vala"
	_tmp8_ = self->constraint_combo;
#line 665 "../src/editing_tools/EditingTools.vala"
	gtk_combo_box_set_row_separator_func (_tmp8_, _editing_tools_crop_tool_crop_tool_window_constraint_combo_separator_func_gtk_tree_view_row_separator_func, NULL, NULL);
#line 666 "../src/editing_tools/EditingTools.vala"
	_tmp9_ = self->constraint_combo;
#line 666 "../src/editing_tools/EditingTools.vala"
	gtk_combo_box_set_active (_tmp9_, 0);
#line 668 "../src/editing_tools/EditingTools.vala"
	_tmp10_ = (GtkImage*) gtk_image_new_from_icon_name ("crop-pivot-reticle-symbolic", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 668 "../src/editing_tools/EditingTools.vala"
	g_object_ref_sink (_tmp10_);
#line 668 "../src/editing_tools/EditingTools.vala"
	image = _tmp10_;
#line 669 "../src/editing_tools/EditingTools.vala"
	_tmp11_ = self->pivot_reticle_button;
#line 669 "../src/editing_tools/EditingTools.vala"
	gtk_button_set_image (_tmp11_, G_TYPE_CHECK_INSTANCE_CAST (image, gtk_widget_get_type (), GtkWidget));
#line 670 "../src/editing_tools/EditingTools.vala"
	_tmp12_ = self->pivot_reticle_button;
#line 670 "../src/editing_tools/EditingTools.vala"
	gtk_widget_set_tooltip_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, gtk_widget_get_type (), GtkWidget), _ ("Pivot the crop rectangle between portrait and landscape orientations"));
#line 672 "../src/editing_tools/EditingTools.vala"
	_tmp13_ = self->custom_width_entry;
#line 672 "../src/editing_tools/EditingTools.vala"
	gtk_entry_set_width_chars (_tmp13_, 4);
#line 673 "../src/editing_tools/EditingTools.vala"
	_tmp14_ = self->custom_width_entry;
#line 673 "../src/editing_tools/EditingTools.vala"
	g_object_set (_tmp14_, "editable", TRUE, NULL);
#line 674 "../src/editing_tools/EditingTools.vala"
	_tmp15_ = self->custom_height_entry;
#line 674 "../src/editing_tools/EditingTools.vala"
	gtk_entry_set_width_chars (_tmp15_, 4);
#line 675 "../src/editing_tools/EditingTools.vala"
	_tmp16_ = self->custom_height_entry;
#line 675 "../src/editing_tools/EditingTools.vala"
	g_object_set (_tmp16_, "editable", TRUE, NULL);
#line 677 "../src/editing_tools/EditingTools.vala"
	_tmp17_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_CONTROL_SPACING);
#line 677 "../src/editing_tools/EditingTools.vala"
	g_object_ref_sink (_tmp17_);
#line 677 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->response_layout);
#line 677 "../src/editing_tools/EditingTools.vala"
	self->response_layout = _tmp17_;
#line 678 "../src/editing_tools/EditingTools.vala"
	_tmp18_ = self->response_layout;
#line 678 "../src/editing_tools/EditingTools.vala"
	gtk_box_set_homogeneous (_tmp18_, TRUE);
#line 679 "../src/editing_tools/EditingTools.vala"
	_tmp19_ = self->response_layout;
#line 679 "../src/editing_tools/EditingTools.vala"
	_tmp20_ = self->cancel_button;
#line 679 "../src/editing_tools/EditingTools.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, gtk_widget_get_type (), GtkWidget));
#line 680 "../src/editing_tools/EditingTools.vala"
	_tmp21_ = self->response_layout;
#line 680 "../src/editing_tools/EditingTools.vala"
	_tmp22_ = self->ok_button;
#line 680 "../src/editing_tools/EditingTools.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, gtk_widget_get_type (), GtkWidget));
#line 682 "../src/editing_tools/EditingTools.vala"
	_tmp23_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, EDITING_TOOLS_CROP_TOOL_CROP_TOOL_WINDOW_CONTROL_SPACING);
#line 682 "../src/editing_tools/EditingTools.vala"
	g_object_ref_sink (_tmp23_);
#line 682 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->layout);
#line 682 "../src/editing_tools/EditingTools.vala"
	self->layout = _tmp23_;
#line 683 "../src/editing_tools/EditingTools.vala"
	_tmp24_ = self->layout;
#line 683 "../src/editing_tools/EditingTools.vala"
	_tmp25_ = self->constraint_combo;
#line 683 "../src/editing_tools/EditingTools.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, gtk_widget_get_type (), GtkWidget));
#line 684 "../src/editing_tools/EditingTools.vala"
	_tmp26_ = self->layout;
#line 684 "../src/editing_tools/EditingTools.vala"
	_tmp27_ = self->pivot_reticle_button;
#line 684 "../src/editing_tools/EditingTools.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp27_, gtk_widget_get_type (), GtkWidget));
#line 685 "../src/editing_tools/EditingTools.vala"
	_tmp28_ = self->layout;
#line 685 "../src/editing_tools/EditingTools.vala"
	_tmp29_ = self->response_layout;
#line 685 "../src/editing_tools/EditingTools.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, gtk_widget_get_type (), GtkWidget));
#line 687 "../src/editing_tools/EditingTools.vala"
	_tmp30_ = self->layout;
#line 687 "../src/editing_tools/EditingTools.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, gtk_widget_get_type (), GtkWidget));
#line 652 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (image);
#line 652 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (combo_text_renderer);
#line 652 "../src/editing_tools/EditingTools.vala"
	return self;
#line 11191 "EditingTools.c"
}

static EditingToolsCropToolCropToolWindow*
editing_tools_crop_tool_crop_tool_window_new (GtkWindow* container)
{
#line 652 "../src/editing_tools/EditingTools.vala"
	return editing_tools_crop_tool_crop_tool_window_construct (EDITING_TOOLS_CROP_TOOL_TYPE_CROP_TOOL_WINDOW, container);
#line 11199 "EditingTools.c"
}

static gboolean
editing_tools_crop_tool_crop_tool_window_constraint_combo_separator_func (GtkTreeModel* model,
                                                                          GtkTreeIter* iter)
{
	GValue val = {0};
	GtkTreeIter _tmp0_;
	GValue _tmp1_ = {0};
	gchar* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_;
	gboolean result;
#line 690 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (model, gtk_tree_model_get_type ()), FALSE);
#line 690 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 692 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = *iter;
#line 692 "../src/editing_tools/EditingTools.vala"
	gtk_tree_model_get_value (model, &_tmp0_, 0, &_tmp1_);
#line 692 "../src/editing_tools/EditingTools.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 692 "../src/editing_tools/EditingTools.vala"
	val = _tmp1_;
#line 694 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = g_value_dup_string (&val);
#line 694 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = _tmp2_;
#line 694 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = g_strcmp0 (_tmp3_, "-") == 0;
#line 694 "../src/editing_tools/EditingTools.vala"
	_g_free0 (_tmp3_);
#line 694 "../src/editing_tools/EditingTools.vala"
	result = _tmp4_;
#line 694 "../src/editing_tools/EditingTools.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 694 "../src/editing_tools/EditingTools.vala"
	return result;
#line 11239 "EditingTools.c"
}

static void
editing_tools_crop_tool_crop_tool_window_class_init (EditingToolsCropToolCropToolWindowClass * klass,
                                                     gpointer klass_data)
{
#line 636 "../src/editing_tools/EditingTools.vala"
	editing_tools_crop_tool_crop_tool_window_parent_class = g_type_class_peek_parent (klass);
#line 636 "../src/editing_tools/EditingTools.vala"
	G_OBJECT_CLASS (klass)->finalize = editing_tools_crop_tool_crop_tool_window_finalize;
#line 11250 "EditingTools.c"
}

static void
editing_tools_crop_tool_crop_tool_window_instance_init (EditingToolsCropToolCropToolWindow * self,
                                                        gpointer klass)
{
	GtkButton* _tmp0_;
	GtkButton* _tmp1_;
	GtkButton* _tmp2_;
	GtkEntry* _tmp3_;
	GtkEntry* _tmp4_;
	GtkLabel* _tmp5_;
#line 639 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = (GtkButton*) gtk_button_new_with_label (RESOURCES_CROP_LABEL);
#line 639 "../src/editing_tools/EditingTools.vala"
	g_object_ref_sink (_tmp0_);
#line 639 "../src/editing_tools/EditingTools.vala"
	self->ok_button = _tmp0_;
#line 640 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = (GtkButton*) gtk_button_new_with_mnemonic (RESOURCES_CANCEL_LABEL);
#line 640 "../src/editing_tools/EditingTools.vala"
	g_object_ref_sink (_tmp1_);
#line 640 "../src/editing_tools/EditingTools.vala"
	self->cancel_button = _tmp1_;
#line 642 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = (GtkButton*) gtk_button_new ();
#line 642 "../src/editing_tools/EditingTools.vala"
	g_object_ref_sink (_tmp2_);
#line 642 "../src/editing_tools/EditingTools.vala"
	self->pivot_reticle_button = _tmp2_;
#line 643 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = (GtkEntry*) gtk_entry_new ();
#line 643 "../src/editing_tools/EditingTools.vala"
	g_object_ref_sink (_tmp3_);
#line 643 "../src/editing_tools/EditingTools.vala"
	self->custom_width_entry = _tmp3_;
#line 644 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = (GtkEntry*) gtk_entry_new ();
#line 644 "../src/editing_tools/EditingTools.vala"
	g_object_ref_sink (_tmp4_);
#line 644 "../src/editing_tools/EditingTools.vala"
	self->custom_height_entry = _tmp4_;
#line 645 "../src/editing_tools/EditingTools.vala"
	_tmp5_ = (GtkLabel*) gtk_label_new_with_mnemonic ("x");
#line 645 "../src/editing_tools/EditingTools.vala"
	g_object_ref_sink (_tmp5_);
#line 645 "../src/editing_tools/EditingTools.vala"
	self->custom_mulsign_label = _tmp5_;
#line 646 "../src/editing_tools/EditingTools.vala"
	self->most_recently_edited = NULL;
#line 647 "../src/editing_tools/EditingTools.vala"
	self->response_layout = NULL;
#line 648 "../src/editing_tools/EditingTools.vala"
	self->layout = NULL;
#line 649 "../src/editing_tools/EditingTools.vala"
	self->normal_width = -1;
#line 650 "../src/editing_tools/EditingTools.vala"
	self->normal_height = -1;
#line 11309 "EditingTools.c"
}

static void
editing_tools_crop_tool_crop_tool_window_finalize (GObject * obj)
{
	EditingToolsCropToolCropToolWindow * self;
#line 636 "../src/editing_tools/EditingTools.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, EDITING_TOOLS_CROP_TOOL_TYPE_CROP_TOOL_WINDOW, EditingToolsCropToolCropToolWindow);
#line 639 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->ok_button);
#line 640 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->cancel_button);
#line 641 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->constraint_combo);
#line 642 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->pivot_reticle_button);
#line 643 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->custom_width_entry);
#line 644 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->custom_height_entry);
#line 645 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->custom_mulsign_label);
#line 646 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->most_recently_edited);
#line 647 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->response_layout);
#line 648 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->layout);
#line 636 "../src/editing_tools/EditingTools.vala"
	G_OBJECT_CLASS (editing_tools_crop_tool_crop_tool_window_parent_class)->finalize (obj);
#line 11340 "EditingTools.c"
}

static GType
editing_tools_crop_tool_crop_tool_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (EditingToolsCropToolCropToolWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) editing_tools_crop_tool_crop_tool_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EditingToolsCropToolCropToolWindow), 0, (GInstanceInitFunc) editing_tools_crop_tool_crop_tool_window_instance_init, NULL };
	GType editing_tools_crop_tool_crop_tool_window_type_id;
	editing_tools_crop_tool_crop_tool_window_type_id = g_type_register_static (EDITING_TOOLS_TYPE_EDITING_TOOL_WINDOW, "EditingToolsCropToolCropToolWindow", &g_define_type_info, 0);
	return editing_tools_crop_tool_crop_tool_window_type_id;
}

static GType
editing_tools_crop_tool_crop_tool_window_get_type (void)
{
	static volatile gsize editing_tools_crop_tool_crop_tool_window_type_id__once = 0;
	if (g_once_init_enter (&editing_tools_crop_tool_crop_tool_window_type_id__once)) {
		GType editing_tools_crop_tool_crop_tool_window_type_id;
		editing_tools_crop_tool_crop_tool_window_type_id = editing_tools_crop_tool_crop_tool_window_get_type_once ();
		g_once_init_leave (&editing_tools_crop_tool_crop_tool_window_type_id__once, editing_tools_crop_tool_crop_tool_window_type_id);
	}
	return editing_tools_crop_tool_crop_tool_window_type_id__once;
}

static void
editing_tools_crop_tool_class_init (EditingToolsCropToolClass * klass,
                                    gpointer klass_data)
{
#line 576 "../src/editing_tools/EditingTools.vala"
	editing_tools_crop_tool_parent_class = g_type_class_peek_parent (klass);
#line 576 "../src/editing_tools/EditingTools.vala"
	((EditingToolsEditingToolClass *) klass)->finalize = editing_tools_crop_tool_finalize;
#line 576 "../src/editing_tools/EditingTools.vala"
	g_type_class_adjust_private_offset (klass, &EditingToolsCropTool_private_offset);
#line 576 "../src/editing_tools/EditingTools.vala"
	((EditingToolsEditingToolClass *) klass)->activate = (void (*) (EditingToolsEditingTool*, EditingToolsPhotoCanvas*)) editing_tools_crop_tool_real_activate;
#line 576 "../src/editing_tools/EditingTools.vala"
	((EditingToolsEditingToolClass *) klass)->on_keypress = (gboolean (*) (EditingToolsEditingTool*, GdkEventKey*)) editing_tools_crop_tool_real_on_keypress;
#line 576 "../src/editing_tools/EditingTools.vala"
	((EditingToolsEditingToolClass *) klass)->deactivate = (void (*) (EditingToolsEditingTool*)) editing_tools_crop_tool_real_deactivate;
#line 576 "../src/editing_tools/EditingTools.vala"
	((EditingToolsEditingToolClass *) klass)->get_tool_window = (EditingToolsEditingToolWindow* (*) (EditingToolsEditingTool*)) editing_tools_crop_tool_real_get_tool_window;
#line 576 "../src/editing_tools/EditingTools.vala"
	((EditingToolsEditingToolClass *) klass)->get_display_pixbuf = (GdkPixbuf* (*) (EditingToolsEditingTool*, Scaling*, Photo*, Dimensions*, GError**)) editing_tools_crop_tool_real_get_display_pixbuf;
#line 576 "../src/editing_tools/EditingTools.vala"
	((EditingToolsEditingToolClass *) klass)->on_left_click = (void (*) (EditingToolsEditingTool*, gint, gint)) editing_tools_crop_tool_real_on_left_click;
#line 576 "../src/editing_tools/EditingTools.vala"
	((EditingToolsEditingToolClass *) klass)->on_left_released = (void (*) (EditingToolsEditingTool*, gint, gint)) editing_tools_crop_tool_real_on_left_released;
#line 576 "../src/editing_tools/EditingTools.vala"
	((EditingToolsEditingToolClass *) klass)->on_motion = (void (*) (EditingToolsEditingTool*, gint, gint, GdkModifierType)) editing_tools_crop_tool_real_on_motion;
#line 576 "../src/editing_tools/EditingTools.vala"
	((EditingToolsEditingToolClass *) klass)->paint = (void (*) (EditingToolsEditingTool*, cairo_t*)) editing_tools_crop_tool_real_paint;
#line 11392 "EditingTools.c"
}

static void
editing_tools_crop_tool_instance_init (EditingToolsCropTool * self,
                                       gpointer klass)
{
	gint _tmp0_ = 0;
	EditingToolsCropToolConstraintDescription** _tmp1_;
	gint _tmp2_ = 0;
	EditingToolsCropToolConstraintDescription** _tmp3_;
	EditingToolsCropToolConstraintDescription** _tmp4_;
	gint _tmp4__length1;
	GtkListStore* _tmp5_;
#line 576 "../src/editing_tools/EditingTools.vala"
	self->priv = editing_tools_crop_tool_get_instance_private (self);
#line 698 "../src/editing_tools/EditingTools.vala"
	self->priv->crop_tool_window = NULL;
#line 699 "../src/editing_tools/EditingTools.vala"
	self->priv->current_cursor_type = GDK_LEFT_PTR;
#line 700 "../src/editing_tools/EditingTools.vala"
	self->priv->in_manipulation = BOX_LOCATION_OUTSIDE;
#line 701 "../src/editing_tools/EditingTools.vala"
	self->priv->wide_black_ctx = NULL;
#line 702 "../src/editing_tools/EditingTools.vala"
	self->priv->wide_white_ctx = NULL;
#line 703 "../src/editing_tools/EditingTools.vala"
	self->priv->thin_white_ctx = NULL;
#line 704 "../src/editing_tools/EditingTools.vala"
	self->priv->text_ctx = NULL;
#line 707 "../src/editing_tools/EditingTools.vala"
	self->priv->crop_surface = NULL;
#line 711 "../src/editing_tools/EditingTools.vala"
	self->priv->last_grab_x = -1;
#line 712 "../src/editing_tools/EditingTools.vala"
	self->priv->last_grab_y = -1;
#line 714 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = editing_tools_crop_tool_create_constraints (&_tmp0_);
#line 714 "../src/editing_tools/EditingTools.vala"
	self->priv->constraints = _tmp1_;
#line 714 "../src/editing_tools/EditingTools.vala"
	self->priv->constraints_length1 = _tmp0_;
#line 714 "../src/editing_tools/EditingTools.vala"
	self->priv->_constraints_size_ = self->priv->constraints_length1;
#line 715 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = editing_tools_crop_tool_create_constraints (&_tmp2_);
#line 715 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = _tmp3_;
#line 715 "../src/editing_tools/EditingTools.vala"
	_tmp4__length1 = _tmp2_;
#line 715 "../src/editing_tools/EditingTools.vala"
	_tmp5_ = editing_tools_crop_tool_create_constraint_list (_tmp4_, (gint) _tmp2_);
#line 715 "../src/editing_tools/EditingTools.vala"
	self->priv->constraint_list = _tmp5_;
#line 715 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = (_vala_array_free (_tmp4_, _tmp4__length1, (GDestroyNotify) editing_tools_crop_tool_constraint_description_unref), NULL);
#line 716 "../src/editing_tools/EditingTools.vala"
	self->priv->reticle_orientation = EDITING_TOOLS_CROP_TOOL_RETICLE_ORIENTATION_LANDSCAPE;
#line 717 "../src/editing_tools/EditingTools.vala"
	self->priv->constraint_mode = EDITING_TOOLS_CROP_TOOL_CONSTRAINT_MODE_NORMAL;
#line 718 "../src/editing_tools/EditingTools.vala"
	self->priv->entry_insert_in_progress = FALSE;
#line 719 "../src/editing_tools/EditingTools.vala"
	self->priv->custom_aspect_ratio = 1.0f;
#line 720 "../src/editing_tools/EditingTools.vala"
	self->priv->custom_width = -1;
#line 721 "../src/editing_tools/EditingTools.vala"
	self->priv->custom_height = -1;
#line 722 "../src/editing_tools/EditingTools.vala"
	self->priv->custom_init_width = -1;
#line 723 "../src/editing_tools/EditingTools.vala"
	self->priv->custom_init_height = -1;
#line 724 "../src/editing_tools/EditingTools.vala"
	self->priv->pre_aspect_ratio = EDITING_TOOLS_CROP_TOOL_ANY_ASPECT_RATIO;
#line 11466 "EditingTools.c"
}

static void
editing_tools_crop_tool_finalize (EditingToolsEditingTool * obj)
{
	EditingToolsCropTool * self;
#line 576 "../src/editing_tools/EditingTools.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, EDITING_TOOLS_TYPE_CROP_TOOL, EditingToolsCropTool);
#line 698 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->priv->crop_tool_window);
#line 701 "../src/editing_tools/EditingTools.vala"
	_cairo_destroy0 (self->priv->wide_black_ctx);
#line 702 "../src/editing_tools/EditingTools.vala"
	_cairo_destroy0 (self->priv->wide_white_ctx);
#line 703 "../src/editing_tools/EditingTools.vala"
	_cairo_destroy0 (self->priv->thin_white_ctx);
#line 704 "../src/editing_tools/EditingTools.vala"
	_cairo_destroy0 (self->priv->text_ctx);
#line 707 "../src/editing_tools/EditingTools.vala"
	_cairo_surface_destroy0 (self->priv->crop_surface);
#line 714 "../src/editing_tools/EditingTools.vala"
	self->priv->constraints = (_vala_array_free (self->priv->constraints, self->priv->constraints_length1, (GDestroyNotify) editing_tools_crop_tool_constraint_description_unref), NULL);
#line 715 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->priv->constraint_list);
#line 576 "../src/editing_tools/EditingTools.vala"
	EDITING_TOOLS_EDITING_TOOL_CLASS (editing_tools_crop_tool_parent_class)->finalize (obj);
#line 11493 "EditingTools.c"
}

static GType
editing_tools_crop_tool_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (EditingToolsCropToolClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) editing_tools_crop_tool_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EditingToolsCropTool), 0, (GInstanceInitFunc) editing_tools_crop_tool_instance_init, NULL };
	GType editing_tools_crop_tool_type_id;
	editing_tools_crop_tool_type_id = g_type_register_static (EDITING_TOOLS_TYPE_EDITING_TOOL, "EditingToolsCropTool", &g_define_type_info, 0);
	EditingToolsCropTool_private_offset = g_type_add_instance_private (editing_tools_crop_tool_type_id, sizeof (EditingToolsCropToolPrivate));
	return editing_tools_crop_tool_type_id;
}

GType
editing_tools_crop_tool_get_type (void)
{
	static volatile gsize editing_tools_crop_tool_type_id__once = 0;
	if (g_once_init_enter (&editing_tools_crop_tool_type_id__once)) {
		GType editing_tools_crop_tool_type_id;
		editing_tools_crop_tool_type_id = editing_tools_crop_tool_get_type_once ();
		g_once_init_leave (&editing_tools_crop_tool_type_id__once, editing_tools_crop_tool_type_id);
	}
	return editing_tools_crop_tool_type_id__once;
}

static void
editing_tools_redeye_instance_init (EditingToolsRedeyeInstance *self)
{
	GdkPoint default_center = {0};
	GdkPoint _tmp0_;
#line 1838 "../src/editing_tools/EditingTools.vala"
	memset (self, 0, sizeof (EditingToolsRedeyeInstance));
#line 1839 "../src/editing_tools/EditingTools.vala"
	memset (&default_center, 0, sizeof (GdkPoint));
#line 1840 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = default_center;
#line 1840 "../src/editing_tools/EditingTools.vala"
	(*self).center = _tmp0_;
#line 1841 "../src/editing_tools/EditingTools.vala"
	(*self).radius = EDITING_TOOLS_REDEYE_INSTANCE_DEFAULT_RADIUS;
#line 11533 "EditingTools.c"
}

void
editing_tools_redeye_instance_to_bounds_rect (EditingToolsRedeyeInstance* inst,
                                              GdkRectangle* result)
{
	GdkRectangle _result_ = {0};
	EditingToolsRedeyeInstance _tmp0_;
	GdkPoint _tmp1_;
	EditingToolsRedeyeInstance _tmp2_;
	EditingToolsRedeyeInstance _tmp3_;
	GdkPoint _tmp4_;
	EditingToolsRedeyeInstance _tmp5_;
	EditingToolsRedeyeInstance _tmp6_;
	GdkRectangle _tmp7_;
#line 1844 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (inst != NULL);
#line 1845 "../src/editing_tools/EditingTools.vala"
	memset (&_result_, 0, sizeof (GdkRectangle));
#line 1846 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = *inst;
#line 1846 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = _tmp0_.center;
#line 1846 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = *inst;
#line 1846 "../src/editing_tools/EditingTools.vala"
	_result_.x = _tmp1_.x - _tmp2_.radius;
#line 1847 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = *inst;
#line 1847 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = _tmp3_.center;
#line 1847 "../src/editing_tools/EditingTools.vala"
	_tmp5_ = *inst;
#line 1847 "../src/editing_tools/EditingTools.vala"
	_result_.y = _tmp4_.y - _tmp5_.radius;
#line 1848 "../src/editing_tools/EditingTools.vala"
	_tmp6_ = *inst;
#line 1848 "../src/editing_tools/EditingTools.vala"
	_result_.width = 2 * _tmp6_.radius;
#line 1849 "../src/editing_tools/EditingTools.vala"
	_tmp7_ = _result_;
#line 1849 "../src/editing_tools/EditingTools.vala"
	_result_.height = _tmp7_.width;
#line 1851 "../src/editing_tools/EditingTools.vala"
	*result = _result_;
#line 1851 "../src/editing_tools/EditingTools.vala"
	return;
#line 11581 "EditingTools.c"
}

void
editing_tools_redeye_instance_from_bounds_rect (GdkRectangle* rect,
                                                EditingToolsRedeyeInstance* result)
{
	GdkRectangle in_rect = {0};
	GdkRectangle _tmp0_;
	EditingToolsRedeyeInstance _result_ = {0};
	GdkRectangle _tmp1_;
	GdkRectangle _tmp2_;
	GdkRectangle _tmp3_;
	EditingToolsRedeyeInstance _tmp4_;
	GdkRectangle _tmp5_;
	EditingToolsRedeyeInstance _tmp6_;
#line 1854 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (rect != NULL);
#line 1855 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = *rect;
#line 1855 "../src/editing_tools/EditingTools.vala"
	in_rect = _tmp0_;
#line 1857 "../src/editing_tools/EditingTools.vala"
	editing_tools_redeye_instance_init (&_result_);
#line 1858 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = in_rect;
#line 1858 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = in_rect;
#line 1858 "../src/editing_tools/EditingTools.vala"
	_result_.radius = (_tmp1_.width + _tmp2_.height) / 4;
#line 1859 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = in_rect;
#line 1859 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = _result_;
#line 1859 "../src/editing_tools/EditingTools.vala"
	_result_.center.x = _tmp3_.x + _tmp4_.radius;
#line 1860 "../src/editing_tools/EditingTools.vala"
	_tmp5_ = in_rect;
#line 1860 "../src/editing_tools/EditingTools.vala"
	_tmp6_ = _result_;
#line 1860 "../src/editing_tools/EditingTools.vala"
	_result_.center.y = _tmp5_.y + _tmp6_.radius;
#line 1862 "../src/editing_tools/EditingTools.vala"
	*result = _result_;
#line 1862 "../src/editing_tools/EditingTools.vala"
	return;
#line 11627 "EditingTools.c"
}

EditingToolsRedeyeInstance*
editing_tools_redeye_instance_dup (const EditingToolsRedeyeInstance* self)
{
	EditingToolsRedeyeInstance* dup;
#line 1830 "../src/editing_tools/EditingTools.vala"
	dup = g_new0 (EditingToolsRedeyeInstance, 1);
#line 1830 "../src/editing_tools/EditingTools.vala"
	memcpy (dup, self, sizeof (EditingToolsRedeyeInstance));
#line 1830 "../src/editing_tools/EditingTools.vala"
	return dup;
#line 11640 "EditingTools.c"
}

void
editing_tools_redeye_instance_free (EditingToolsRedeyeInstance* self)
{
#line 1830 "../src/editing_tools/EditingTools.vala"
	g_free (self);
#line 11648 "EditingTools.c"
}

static GType
editing_tools_redeye_instance_get_type_once (void)
{
	GType editing_tools_redeye_instance_type_id;
	editing_tools_redeye_instance_type_id = g_boxed_type_register_static ("EditingToolsRedeyeInstance", (GBoxedCopyFunc) editing_tools_redeye_instance_dup, (GBoxedFreeFunc) editing_tools_redeye_instance_free);
	return editing_tools_redeye_instance_type_id;
}

GType
editing_tools_redeye_instance_get_type (void)
{
	static volatile gsize editing_tools_redeye_instance_type_id__once = 0;
	if (g_once_init_enter (&editing_tools_redeye_instance_type_id__once)) {
		GType editing_tools_redeye_instance_type_id;
		editing_tools_redeye_instance_type_id = editing_tools_redeye_instance_get_type_once ();
		g_once_init_leave (&editing_tools_redeye_instance_type_id__once, editing_tools_redeye_instance_type_id);
	}
	return editing_tools_redeye_instance_type_id__once;
}

static inline gpointer
editing_tools_redeye_tool_get_instance_private (EditingToolsRedeyeTool* self)
{
	return G_STRUCT_MEMBER_P (self, EditingToolsRedeyeTool_private_offset);
}

static EditingToolsRedeyeTool*
editing_tools_redeye_tool_construct (GType object_type)
{
	EditingToolsRedeyeTool* self = NULL;
#line 1912 "../src/editing_tools/EditingTools.vala"
	self = (EditingToolsRedeyeTool*) editing_tools_editing_tool_construct (object_type, "RedeyeTool");
#line 1911 "../src/editing_tools/EditingTools.vala"
	return self;
#line 11685 "EditingTools.c"
}

static EditingToolsRedeyeTool*
editing_tools_redeye_tool_new (void)
{
#line 1911 "../src/editing_tools/EditingTools.vala"
	return editing_tools_redeye_tool_construct (EDITING_TOOLS_TYPE_REDEYE_TOOL);
#line 11693 "EditingTools.c"
}

EditingToolsRedeyeTool*
editing_tools_redeye_tool_factory (void)
{
	EditingToolsRedeyeTool* _tmp0_;
	EditingToolsRedeyeTool* result;
#line 1916 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = editing_tools_redeye_tool_new ();
#line 1916 "../src/editing_tools/EditingTools.vala"
	result = _tmp0_;
#line 1916 "../src/editing_tools/EditingTools.vala"
	return result;
#line 11707 "EditingTools.c"
}

gboolean
editing_tools_redeye_tool_is_available (Photo* photo,
                                        Scaling* scaling)
{
	Dimensions dim = {0};
	Dimensions _tmp0_ = {0};
	Dimensions _tmp1_ = {0};
	gboolean _tmp2_ = FALSE;
	Dimensions _tmp3_;
	gboolean result;
#line 1919 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (IS_PHOTO (photo), FALSE);
#line 1919 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (scaling != NULL, FALSE);
#line 1920 "../src/editing_tools/EditingTools.vala"
	media_source_get_dimensions (G_TYPE_CHECK_INSTANCE_CAST (photo, TYPE_MEDIA_SOURCE, MediaSource), PHOTO_EXCEPTION_NONE, &_tmp0_);
#line 1920 "../src/editing_tools/EditingTools.vala"
	scaling_get_scaled_dimensions (scaling, &_tmp0_, &_tmp1_);
#line 1920 "../src/editing_tools/EditingTools.vala"
	dim = _tmp1_;
#line 1922 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = dim;
#line 1922 "../src/editing_tools/EditingTools.vala"
	if (_tmp3_.width >= (EDITING_TOOLS_REDEYE_INSTANCE_MAX_RADIUS * 2)) {
#line 11734 "EditingTools.c"
		Dimensions _tmp4_;
#line 1923 "../src/editing_tools/EditingTools.vala"
		_tmp4_ = dim;
#line 1923 "../src/editing_tools/EditingTools.vala"
		_tmp2_ = _tmp4_.height >= (EDITING_TOOLS_REDEYE_INSTANCE_MAX_RADIUS * 2);
#line 11740 "EditingTools.c"
	} else {
#line 1922 "../src/editing_tools/EditingTools.vala"
		_tmp2_ = FALSE;
#line 11744 "EditingTools.c"
	}
#line 1922 "../src/editing_tools/EditingTools.vala"
	result = _tmp2_;
#line 1922 "../src/editing_tools/EditingTools.vala"
	return result;
#line 11750 "EditingTools.c"
}

static void
editing_tools_redeye_tool_new_interaction_instance (EditingToolsRedeyeTool* self,
                                                    EditingToolsPhotoCanvas* canvas,
                                                    EditingToolsRedeyeInstance* result)
{
	GdkRectangle photo_bounds = {0};
	GdkRectangle _tmp0_ = {0};
	GdkPoint photo_center = {0};
	GdkPoint _tmp1_ = {0};
	GdkRectangle _tmp2_;
	GdkRectangle _tmp3_;
	GdkRectangle _tmp4_;
	GdkRectangle _tmp5_;
	EditingToolsRedeyeInstance _result_ = {0};
	GdkPoint _tmp6_;
	GdkPoint _tmp7_;
#line 1926 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_REDEYE_TOOL (self));
#line 1926 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_PHOTO_CANVAS (canvas));
#line 1927 "../src/editing_tools/EditingTools.vala"
	editing_tools_photo_canvas_get_scaled_pixbuf_position (canvas, &_tmp0_);
#line 1927 "../src/editing_tools/EditingTools.vala"
	photo_bounds = _tmp0_;
#line 1928 "../src/editing_tools/EditingTools.vala"
	_tmp1_.x = 0;
#line 1928 "../src/editing_tools/EditingTools.vala"
	photo_center = _tmp1_;
#line 1929 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = photo_bounds;
#line 1929 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = photo_bounds;
#line 1929 "../src/editing_tools/EditingTools.vala"
	photo_center.x = _tmp2_.x + (_tmp3_.width / 2);
#line 1930 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = photo_bounds;
#line 1930 "../src/editing_tools/EditingTools.vala"
	_tmp5_ = photo_bounds;
#line 1930 "../src/editing_tools/EditingTools.vala"
	photo_center.y = _tmp4_.y + (_tmp5_.height / 2);
#line 1932 "../src/editing_tools/EditingTools.vala"
	editing_tools_redeye_instance_init (&_result_);
#line 1933 "../src/editing_tools/EditingTools.vala"
	_tmp6_ = photo_center;
#line 1933 "../src/editing_tools/EditingTools.vala"
	_result_.center.x = _tmp6_.x;
#line 1934 "../src/editing_tools/EditingTools.vala"
	_tmp7_ = photo_center;
#line 1934 "../src/editing_tools/EditingTools.vala"
	_result_.center.y = _tmp7_.y;
#line 1935 "../src/editing_tools/EditingTools.vala"
	_result_.radius = EDITING_TOOLS_REDEYE_INSTANCE_DEFAULT_RADIUS;
#line 1937 "../src/editing_tools/EditingTools.vala"
	*result = _result_;
#line 1937 "../src/editing_tools/EditingTools.vala"
	return;
#line 11809 "EditingTools.c"
}

static void
editing_tools_redeye_tool_prepare_ctx (EditingToolsRedeyeTool* self,
                                       cairo_t* ctx,
                                       Dimensions* dim)
{
	gdouble scale = 0.0;
	cairo_surface_t* _tmp0_;
	cairo_t* _tmp1_;
	cairo_t* _tmp2_;
	cairo_t* _tmp3_;
	cairo_surface_t* _tmp4_;
	cairo_t* _tmp5_;
	cairo_t* _tmp6_;
	cairo_t* _tmp7_;
#line 1940 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_REDEYE_TOOL (self));
#line 1940 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (ctx != NULL);
#line 1940 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (dim != NULL);
#line 1941 "../src/editing_tools/EditingTools.vala"
	scale = application_get_scale ();
#line 1942 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = cairo_get_target (ctx);
#line 1942 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = cairo_create (_tmp0_);
#line 1942 "../src/editing_tools/EditingTools.vala"
	_cairo_destroy0 (self->priv->wider_gray_ctx);
#line 1942 "../src/editing_tools/EditingTools.vala"
	self->priv->wider_gray_ctx = _tmp1_;
#line 1943 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = self->priv->wider_gray_ctx;
#line 1943 "../src/editing_tools/EditingTools.vala"
	set_source_color_from_string (_tmp2_, "#111");
#line 1944 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = self->priv->wider_gray_ctx;
#line 1944 "../src/editing_tools/EditingTools.vala"
	cairo_set_line_width (_tmp3_, 3 * scale);
#line 1946 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = cairo_get_target (ctx);
#line 1946 "../src/editing_tools/EditingTools.vala"
	_tmp5_ = cairo_create (_tmp4_);
#line 1946 "../src/editing_tools/EditingTools.vala"
	_cairo_destroy0 (self->priv->thin_white_ctx);
#line 1946 "../src/editing_tools/EditingTools.vala"
	self->priv->thin_white_ctx = _tmp5_;
#line 1947 "../src/editing_tools/EditingTools.vala"
	_tmp6_ = self->priv->thin_white_ctx;
#line 1947 "../src/editing_tools/EditingTools.vala"
	set_source_color_from_string (_tmp6_, "#FFF");
#line 1948 "../src/editing_tools/EditingTools.vala"
	_tmp7_ = self->priv->thin_white_ctx;
#line 1948 "../src/editing_tools/EditingTools.vala"
	cairo_set_line_width (_tmp7_, 1 * scale);
#line 11866 "EditingTools.c"
}

static void
editing_tools_redeye_tool_draw_redeye_instance (EditingToolsRedeyeTool* self,
                                                EditingToolsRedeyeInstance* inst)
{
	EditingToolsPhotoCanvas* _tmp0_;
	cairo_t* _tmp1_;
	EditingToolsRedeyeInstance _tmp2_;
	GdkPoint _tmp3_;
	EditingToolsRedeyeInstance _tmp4_;
	GdkPoint _tmp5_;
	EditingToolsRedeyeInstance _tmp6_;
	EditingToolsPhotoCanvas* _tmp7_;
	cairo_t* _tmp8_;
	EditingToolsRedeyeInstance _tmp9_;
	GdkPoint _tmp10_;
	EditingToolsRedeyeInstance _tmp11_;
	GdkPoint _tmp12_;
	EditingToolsRedeyeInstance _tmp13_;
#line 1951 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_REDEYE_TOOL (self));
#line 1951 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (inst != NULL);
#line 1952 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 1952 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = self->priv->wider_gray_ctx;
#line 1952 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = *inst;
#line 1952 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = _tmp2_.center;
#line 1952 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = *inst;
#line 1952 "../src/editing_tools/EditingTools.vala"
	_tmp5_ = _tmp4_.center;
#line 1952 "../src/editing_tools/EditingTools.vala"
	_tmp6_ = *inst;
#line 1952 "../src/editing_tools/EditingTools.vala"
	editing_tools_photo_canvas_draw_circle (_tmp0_, _tmp1_, _tmp3_.x, _tmp5_.y, _tmp6_.radius);
#line 1954 "../src/editing_tools/EditingTools.vala"
	_tmp7_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 1954 "../src/editing_tools/EditingTools.vala"
	_tmp8_ = self->priv->thin_white_ctx;
#line 1954 "../src/editing_tools/EditingTools.vala"
	_tmp9_ = *inst;
#line 1954 "../src/editing_tools/EditingTools.vala"
	_tmp10_ = _tmp9_.center;
#line 1954 "../src/editing_tools/EditingTools.vala"
	_tmp11_ = *inst;
#line 1954 "../src/editing_tools/EditingTools.vala"
	_tmp12_ = _tmp11_.center;
#line 1954 "../src/editing_tools/EditingTools.vala"
	_tmp13_ = *inst;
#line 1954 "../src/editing_tools/EditingTools.vala"
	editing_tools_photo_canvas_draw_circle (_tmp7_, _tmp8_, _tmp10_.x, _tmp12_.y, _tmp13_.radius);
#line 11923 "EditingTools.c"
}

static gboolean
editing_tools_redeye_tool_on_size_slider_adjust (EditingToolsRedeyeTool* self,
                                                 GtkScrollType type)
{
	EditingToolsRedeyeToolRedeyeToolWindow* _tmp0_;
	GtkScale* _tmp1_;
	EditingToolsPhotoCanvas* _tmp2_;
	gboolean result;
#line 1958 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (EDITING_TOOLS_IS_REDEYE_TOOL (self), FALSE);
#line 1959 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->redeye_tool_window;
#line 1959 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = _tmp0_->slider;
#line 1959 "../src/editing_tools/EditingTools.vala"
	self->priv->user_interaction_instance.radius = (gint) gtk_range_get_value (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_range_get_type (), GtkRange));
#line 1962 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 1962 "../src/editing_tools/EditingTools.vala"
	editing_tools_photo_canvas_repaint (_tmp2_);
#line 1964 "../src/editing_tools/EditingTools.vala"
	result = FALSE;
#line 1964 "../src/editing_tools/EditingTools.vala"
	return result;
#line 11950 "EditingTools.c"
}

static void
editing_tools_redeye_tool_on_apply (EditingToolsRedeyeTool* self)
{
	GdkRectangle bounds_rect_user = {0};
	EditingToolsRedeyeInstance _tmp0_;
	GdkRectangle _tmp1_ = {0};
	GdkRectangle bounds_rect_active = {0};
	EditingToolsPhotoCanvas* _tmp2_;
	GdkRectangle _tmp3_;
	GdkRectangle _tmp4_ = {0};
	GdkRectangle bounds_rect_unscaled = {0};
	EditingToolsPhotoCanvas* _tmp5_;
	GdkRectangle _tmp6_;
	GdkRectangle _tmp7_ = {0};
	GdkRectangle bounds_rect_raw = {0};
	EditingToolsPhotoCanvas* _tmp8_;
	GdkRectangle _tmp9_;
	GdkRectangle _tmp10_ = {0};
	EditingToolsRedeyeInstance instance_raw = {0};
	GdkRectangle _tmp11_;
	EditingToolsRedeyeInstance _tmp12_ = {0};
	Dimensions dimensions = {0};
	EditingToolsPhotoCanvas* _tmp13_;
	Photo* _tmp14_;
	Photo* _tmp15_;
	Dimensions _tmp16_ = {0};
	Dimensions _tmp17_;
	gdouble theta = 0.0;
	EditingToolsPhotoCanvas* _tmp18_;
	Photo* _tmp19_;
	Photo* _tmp20_;
	gdouble _tmp21_ = 0.0;
	EditingToolsRedeyeInstance _tmp22_;
	GdkPoint _tmp23_;
	Dimensions _tmp24_;
	Dimensions _tmp25_;
	GdkPoint _tmp26_ = {0};
	RedeyeCommand* command = NULL;
	EditingToolsPhotoCanvas* _tmp27_;
	Photo* _tmp28_;
	Photo* _tmp29_;
	EditingToolsRedeyeInstance _tmp30_;
	RedeyeCommand* _tmp31_;
	RedeyeCommand* _tmp32_;
	CommandManager* _tmp33_;
	CommandManager* _tmp34_;
#line 1967 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_REDEYE_TOOL (self));
#line 1968 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->user_interaction_instance;
#line 1968 "../src/editing_tools/EditingTools.vala"
	editing_tools_redeye_instance_to_bounds_rect (&_tmp0_, &_tmp1_);
#line 1968 "../src/editing_tools/EditingTools.vala"
	bounds_rect_user = _tmp1_;
#line 1971 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 1971 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = bounds_rect_user;
#line 1971 "../src/editing_tools/EditingTools.vala"
	editing_tools_photo_canvas_user_to_active_rect (_tmp2_, &_tmp3_, &_tmp4_);
#line 1971 "../src/editing_tools/EditingTools.vala"
	bounds_rect_active = _tmp4_;
#line 1973 "../src/editing_tools/EditingTools.vala"
	_tmp5_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 1973 "../src/editing_tools/EditingTools.vala"
	_tmp6_ = bounds_rect_active;
#line 1973 "../src/editing_tools/EditingTools.vala"
	editing_tools_photo_canvas_active_to_unscaled_rect (_tmp5_, &_tmp6_, &_tmp7_);
#line 1973 "../src/editing_tools/EditingTools.vala"
	bounds_rect_unscaled = _tmp7_;
#line 1975 "../src/editing_tools/EditingTools.vala"
	_tmp8_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 1975 "../src/editing_tools/EditingTools.vala"
	_tmp9_ = bounds_rect_unscaled;
#line 1975 "../src/editing_tools/EditingTools.vala"
	editing_tools_photo_canvas_unscaled_to_raw_rect (_tmp8_, &_tmp9_, &_tmp10_);
#line 1975 "../src/editing_tools/EditingTools.vala"
	bounds_rect_raw = _tmp10_;
#line 1978 "../src/editing_tools/EditingTools.vala"
	_tmp11_ = bounds_rect_raw;
#line 1978 "../src/editing_tools/EditingTools.vala"
	editing_tools_redeye_instance_from_bounds_rect (&_tmp11_, &_tmp12_);
#line 1978 "../src/editing_tools/EditingTools.vala"
	instance_raw = _tmp12_;
#line 1983 "../src/editing_tools/EditingTools.vala"
	_tmp13_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 1983 "../src/editing_tools/EditingTools.vala"
	_tmp14_ = editing_tools_photo_canvas_get_photo (_tmp13_);
#line 1983 "../src/editing_tools/EditingTools.vala"
	_tmp15_ = _tmp14_;
#line 1983 "../src/editing_tools/EditingTools.vala"
	media_source_get_dimensions (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, TYPE_MEDIA_SOURCE, MediaSource), PHOTO_EXCEPTION_STRAIGHTEN | PHOTO_EXCEPTION_CROP, &_tmp16_);
#line 1983 "../src/editing_tools/EditingTools.vala"
	_tmp17_ = _tmp16_;
#line 1983 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (_tmp15_);
#line 1983 "../src/editing_tools/EditingTools.vala"
	dimensions = _tmp17_;
#line 1986 "../src/editing_tools/EditingTools.vala"
	theta = 0.0;
#line 1988 "../src/editing_tools/EditingTools.vala"
	_tmp18_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 1988 "../src/editing_tools/EditingTools.vala"
	_tmp19_ = editing_tools_photo_canvas_get_photo (_tmp18_);
#line 1988 "../src/editing_tools/EditingTools.vala"
	_tmp20_ = _tmp19_;
#line 1988 "../src/editing_tools/EditingTools.vala"
	photo_get_straighten (_tmp20_, &_tmp21_);
#line 1988 "../src/editing_tools/EditingTools.vala"
	theta = _tmp21_;
#line 1988 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (_tmp20_);
#line 1990 "../src/editing_tools/EditingTools.vala"
	_tmp22_ = instance_raw;
#line 1990 "../src/editing_tools/EditingTools.vala"
	_tmp23_ = _tmp22_.center;
#line 1990 "../src/editing_tools/EditingTools.vala"
	_tmp24_ = dimensions;
#line 1990 "../src/editing_tools/EditingTools.vala"
	_tmp25_ = dimensions;
#line 1990 "../src/editing_tools/EditingTools.vala"
	derotate_point_arb (&_tmp23_, _tmp24_.width, _tmp25_.height, theta, &_tmp26_);
#line 1990 "../src/editing_tools/EditingTools.vala"
	instance_raw.center = _tmp26_;
#line 1993 "../src/editing_tools/EditingTools.vala"
	_tmp27_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 1993 "../src/editing_tools/EditingTools.vala"
	_tmp28_ = editing_tools_photo_canvas_get_photo (_tmp27_);
#line 1993 "../src/editing_tools/EditingTools.vala"
	_tmp29_ = _tmp28_;
#line 1993 "../src/editing_tools/EditingTools.vala"
	_tmp30_ = instance_raw;
#line 1993 "../src/editing_tools/EditingTools.vala"
	_tmp31_ = redeye_command_new (_tmp29_, &_tmp30_, RESOURCES_RED_EYE_LABEL, RESOURCES_RED_EYE_TOOLTIP);
#line 1993 "../src/editing_tools/EditingTools.vala"
	_tmp32_ = _tmp31_;
#line 1993 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (_tmp29_);
#line 1993 "../src/editing_tools/EditingTools.vala"
	command = _tmp32_;
#line 1995 "../src/editing_tools/EditingTools.vala"
	_tmp33_ = app_window_get_command_manager ();
#line 1995 "../src/editing_tools/EditingTools.vala"
	_tmp34_ = _tmp33_;
#line 1995 "../src/editing_tools/EditingTools.vala"
	command_manager_execute (_tmp34_, G_TYPE_CHECK_INSTANCE_CAST (command, TYPE_COMMAND, Command));
#line 1995 "../src/editing_tools/EditingTools.vala"
	_command_manager_unref0 (_tmp34_);
#line 1967 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (command);
#line 12103 "EditingTools.c"
}

static void
editing_tools_redeye_tool_on_photos_altered (EditingToolsRedeyeTool* self,
                                             GeeMap* map)
{
	EditingToolsPhotoCanvas* _tmp0_;
	Photo* _tmp1_;
	Photo* _tmp2_;
	gboolean _tmp3_;
	EditingToolsPhotoCanvas* _tmp15_;
	GError* _inner_error0_ = NULL;
#line 1998 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_REDEYE_TOOL (self));
#line 1998 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (map, GEE_TYPE_MAP));
#line 1999 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 1999 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = editing_tools_photo_canvas_get_photo (_tmp0_);
#line 1999 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = _tmp1_;
#line 1999 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = !gee_map_has_key (map, G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_DATA_OBJECT, DataObject));
#line 1999 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (_tmp2_);
#line 1999 "../src/editing_tools/EditingTools.vala"
	if (_tmp3_) {
#line 2000 "../src/editing_tools/EditingTools.vala"
		return;
#line 12134 "EditingTools.c"
	}
	{
		GdkPixbuf* _tmp4_ = NULL;
		EditingToolsPhotoCanvas* _tmp5_;
		Photo* _tmp6_;
		Photo* _tmp7_;
		EditingToolsPhotoCanvas* _tmp8_;
		Scaling _tmp9_ = {0};
		GdkPixbuf* _tmp10_;
		GdkPixbuf* _tmp11_;
		GdkPixbuf* _tmp12_;
#line 2003 "../src/editing_tools/EditingTools.vala"
		_tmp5_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 2003 "../src/editing_tools/EditingTools.vala"
		_tmp6_ = editing_tools_photo_canvas_get_photo (_tmp5_);
#line 2003 "../src/editing_tools/EditingTools.vala"
		_tmp7_ = _tmp6_;
#line 2003 "../src/editing_tools/EditingTools.vala"
		_tmp8_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 2003 "../src/editing_tools/EditingTools.vala"
		editing_tools_photo_canvas_get_scaling (_tmp8_, &_tmp9_);
#line 2003 "../src/editing_tools/EditingTools.vala"
		_tmp10_ = photo_source_get_pixbuf (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_PHOTO_SOURCE, PhotoSource), &_tmp9_, &_inner_error0_);
#line 2003 "../src/editing_tools/EditingTools.vala"
		_tmp11_ = _tmp10_;
#line 2003 "../src/editing_tools/EditingTools.vala"
		_g_object_unref0 (_tmp7_);
#line 2003 "../src/editing_tools/EditingTools.vala"
		_tmp4_ = _tmp11_;
#line 2003 "../src/editing_tools/EditingTools.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 12166 "EditingTools.c"
			goto __catch0_g_error;
		}
#line 2003 "../src/editing_tools/EditingTools.vala"
		_tmp12_ = _tmp4_;
#line 2003 "../src/editing_tools/EditingTools.vala"
		_tmp4_ = NULL;
#line 2003 "../src/editing_tools/EditingTools.vala"
		_g_object_unref0 (self->priv->current_pixbuf);
#line 2003 "../src/editing_tools/EditingTools.vala"
		self->priv->current_pixbuf = _tmp12_;
#line 2002 "../src/editing_tools/EditingTools.vala"
		_g_object_unref0 (_tmp4_);
#line 12179 "EditingTools.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp13_;
		const gchar* _tmp14_;
#line 2002 "../src/editing_tools/EditingTools.vala"
		err = _inner_error0_;
#line 2002 "../src/editing_tools/EditingTools.vala"
		_inner_error0_ = NULL;
#line 2005 "../src/editing_tools/EditingTools.vala"
		_tmp13_ = err;
#line 2005 "../src/editing_tools/EditingTools.vala"
		_tmp14_ = _tmp13_->message;
#line 2005 "../src/editing_tools/EditingTools.vala"
		g_warning ("EditingTools.vala:2005: %s", _tmp14_);
#line 2006 "../src/editing_tools/EditingTools.vala"
		g_signal_emit (G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool), editing_tools_editing_tool_signals[EDITING_TOOLS_EDITING_TOOL_ABORTED_SIGNAL], 0);
#line 2008 "../src/editing_tools/EditingTools.vala"
		_g_error_free0 (err);
#line 2008 "../src/editing_tools/EditingTools.vala"
		return;
#line 12203 "EditingTools.c"
	}
	__finally0:
#line 2002 "../src/editing_tools/EditingTools.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2002 "../src/editing_tools/EditingTools.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2002 "../src/editing_tools/EditingTools.vala"
		g_clear_error (&_inner_error0_);
#line 2002 "../src/editing_tools/EditingTools.vala"
		return;
#line 12214 "EditingTools.c"
	}
#line 2011 "../src/editing_tools/EditingTools.vala"
	_tmp15_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 2011 "../src/editing_tools/EditingTools.vala"
	editing_tools_photo_canvas_repaint (_tmp15_);
#line 12220 "EditingTools.c"
}

static void
editing_tools_redeye_tool_on_close (EditingToolsRedeyeTool* self)
{
	GdkPixbuf* _tmp0_;
	EditingToolsPhotoCanvas* _tmp1_;
	Photo* _tmp2_;
	Photo* _tmp3_;
	Dimensions _tmp4_ = {0};
#line 2014 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_REDEYE_TOOL (self));
#line 2015 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->current_pixbuf;
#line 2015 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 2015 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = editing_tools_photo_canvas_get_photo (_tmp1_);
#line 2015 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = _tmp2_;
#line 2015 "../src/editing_tools/EditingTools.vala"
	media_source_get_dimensions (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_MEDIA_SOURCE, MediaSource), PHOTO_EXCEPTION_NONE, &_tmp4_);
#line 2015 "../src/editing_tools/EditingTools.vala"
	g_signal_emit (G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool), editing_tools_editing_tool_signals[EDITING_TOOLS_EDITING_TOOL_APPLIED_SIGNAL], 0, NULL, _tmp0_, &_tmp4_, FALSE);
#line 2015 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (_tmp3_);
#line 12247 "EditingTools.c"
}

static void
editing_tools_redeye_tool_on_canvas_resize (EditingToolsRedeyeTool* self)
{
	GdkRectangle scaled_pixbuf_position = {0};
	EditingToolsPhotoCanvas* _tmp0_;
	GdkRectangle _tmp1_ = {0};
	GdkRectangle _tmp2_;
	GdkRectangle _tmp3_;
	gdouble scale_factor = 0.0;
	GdkRectangle _tmp4_;
	GdkRectangle _tmp5_;
	EditingToolsRedeyeInstance _tmp6_;
	GdkPoint _tmp7_;
	EditingToolsRedeyeInstance _tmp8_;
	GdkPoint _tmp9_;
	GdkRectangle _tmp10_;
	GdkRectangle _tmp11_;
	GdkRectangle _tmp12_;
#line 2018 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_REDEYE_TOOL (self));
#line 2019 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 2019 "../src/editing_tools/EditingTools.vala"
	editing_tools_photo_canvas_get_scaled_pixbuf_position (_tmp0_, &_tmp1_);
#line 2019 "../src/editing_tools/EditingTools.vala"
	scaled_pixbuf_position = _tmp1_;
#line 2022 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = self->priv->old_scaled_pixbuf_position;
#line 2022 "../src/editing_tools/EditingTools.vala"
	self->priv->user_interaction_instance.center.x = self->priv->user_interaction_instance.center.x - _tmp2_.x;
#line 2023 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = self->priv->old_scaled_pixbuf_position;
#line 2023 "../src/editing_tools/EditingTools.vala"
	self->priv->user_interaction_instance.center.y = self->priv->user_interaction_instance.center.y - _tmp3_.y;
#line 2025 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = scaled_pixbuf_position;
#line 2025 "../src/editing_tools/EditingTools.vala"
	_tmp5_ = self->priv->old_scaled_pixbuf_position;
#line 2025 "../src/editing_tools/EditingTools.vala"
	scale_factor = ((gdouble) _tmp4_.width) / ((gdouble) _tmp5_.width);
#line 2028 "../src/editing_tools/EditingTools.vala"
	_tmp6_ = self->priv->user_interaction_instance;
#line 2028 "../src/editing_tools/EditingTools.vala"
	_tmp7_ = _tmp6_.center;
#line 2028 "../src/editing_tools/EditingTools.vala"
	self->priv->user_interaction_instance.center.x = (gint) ((((gdouble) _tmp7_.x) * scale_factor) + 0.5);
#line 2031 "../src/editing_tools/EditingTools.vala"
	_tmp8_ = self->priv->user_interaction_instance;
#line 2031 "../src/editing_tools/EditingTools.vala"
	_tmp9_ = _tmp8_.center;
#line 2031 "../src/editing_tools/EditingTools.vala"
	self->priv->user_interaction_instance.center.y = (gint) ((((gdouble) _tmp9_.y) * scale_factor) + 0.5);
#line 2035 "../src/editing_tools/EditingTools.vala"
	_tmp10_ = scaled_pixbuf_position;
#line 2035 "../src/editing_tools/EditingTools.vala"
	self->priv->user_interaction_instance.center.x = self->priv->user_interaction_instance.center.x + _tmp10_.x;
#line 2036 "../src/editing_tools/EditingTools.vala"
	_tmp11_ = scaled_pixbuf_position;
#line 2036 "../src/editing_tools/EditingTools.vala"
	self->priv->user_interaction_instance.center.y = self->priv->user_interaction_instance.center.y + _tmp11_.y;
#line 2038 "../src/editing_tools/EditingTools.vala"
	_tmp12_ = scaled_pixbuf_position;
#line 2038 "../src/editing_tools/EditingTools.vala"
	self->priv->old_scaled_pixbuf_position = _tmp12_;
#line 2040 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->priv->current_pixbuf);
#line 2040 "../src/editing_tools/EditingTools.vala"
	self->priv->current_pixbuf = NULL;
#line 12318 "EditingTools.c"
}

static void
_editing_tools_redeye_tool_on_photos_altered_data_collection_items_altered (DataCollection* _sender,
                                                                            GeeMap* items,
                                                                            gpointer self)
{
#line 2060 "../src/editing_tools/EditingTools.vala"
	editing_tools_redeye_tool_on_photos_altered ((EditingToolsRedeyeTool*) self, items);
#line 12328 "EditingTools.c"
}

static void
editing_tools_redeye_tool_real_activate (EditingToolsEditingTool* base,
                                         EditingToolsPhotoCanvas* canvas)
{
	EditingToolsRedeyeTool * self;
	EditingToolsRedeyeInstance _tmp0_ = {0};
	cairo_t* _tmp1_;
	cairo_t* _tmp2_;
	Dimensions _tmp3_ = {0};
	GdkRectangle _tmp4_ = {0};
	GdkPixbuf* _tmp5_;
	GtkWindow* _tmp6_;
	GtkWindow* _tmp7_;
	EditingToolsRedeyeToolRedeyeToolWindow* _tmp8_;
	EditingToolsRedeyeToolRedeyeToolWindow* _tmp9_;
	GtkScale* _tmp10_;
	EditingToolsRedeyeInstance _tmp11_;
	DataCollection* owner = NULL;
	Photo* _tmp12_;
	Photo* _tmp13_;
	DataCollection* _tmp14_;
	DataCollection* _tmp15_;
	DataCollection* _tmp16_;
#line 2043 "../src/editing_tools/EditingTools.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, EDITING_TOOLS_TYPE_REDEYE_TOOL, EditingToolsRedeyeTool);
#line 2043 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_PHOTO_CANVAS (canvas));
#line 2044 "../src/editing_tools/EditingTools.vala"
	editing_tools_redeye_tool_new_interaction_instance (self, canvas, &_tmp0_);
#line 2044 "../src/editing_tools/EditingTools.vala"
	self->priv->user_interaction_instance = _tmp0_;
#line 2046 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = editing_tools_photo_canvas_get_default_ctx (canvas);
#line 2046 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = _tmp1_;
#line 2046 "../src/editing_tools/EditingTools.vala"
	editing_tools_photo_canvas_get_surface_dim (canvas, &_tmp3_);
#line 2046 "../src/editing_tools/EditingTools.vala"
	editing_tools_redeye_tool_prepare_ctx (self, _tmp2_, &_tmp3_);
#line 2046 "../src/editing_tools/EditingTools.vala"
	_cairo_destroy0 (_tmp2_);
#line 2048 "../src/editing_tools/EditingTools.vala"
	editing_tools_redeye_tool_bind_canvas_handlers (self, canvas);
#line 2050 "../src/editing_tools/EditingTools.vala"
	editing_tools_photo_canvas_get_scaled_pixbuf_position (canvas, &_tmp4_);
#line 2050 "../src/editing_tools/EditingTools.vala"
	self->priv->old_scaled_pixbuf_position = _tmp4_;
#line 2051 "../src/editing_tools/EditingTools.vala"
	_tmp5_ = editing_tools_photo_canvas_get_scaled_pixbuf (canvas);
#line 2051 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->priv->current_pixbuf);
#line 2051 "../src/editing_tools/EditingTools.vala"
	self->priv->current_pixbuf = _tmp5_;
#line 2053 "../src/editing_tools/EditingTools.vala"
	_tmp6_ = editing_tools_photo_canvas_get_container (canvas);
#line 2053 "../src/editing_tools/EditingTools.vala"
	_tmp7_ = _tmp6_;
#line 2053 "../src/editing_tools/EditingTools.vala"
	_tmp8_ = editing_tools_redeye_tool_redeye_tool_window_new (_tmp7_);
#line 2053 "../src/editing_tools/EditingTools.vala"
	g_object_ref_sink (_tmp8_);
#line 2053 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->priv->redeye_tool_window);
#line 2053 "../src/editing_tools/EditingTools.vala"
	self->priv->redeye_tool_window = _tmp8_;
#line 2053 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (_tmp7_);
#line 2054 "../src/editing_tools/EditingTools.vala"
	_tmp9_ = self->priv->redeye_tool_window;
#line 2054 "../src/editing_tools/EditingTools.vala"
	_tmp10_ = _tmp9_->slider;
#line 2054 "../src/editing_tools/EditingTools.vala"
	_tmp11_ = self->priv->user_interaction_instance;
#line 2054 "../src/editing_tools/EditingTools.vala"
	gtk_range_set_value (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, gtk_range_get_type (), GtkRange), (gdouble) _tmp11_.radius);
#line 2056 "../src/editing_tools/EditingTools.vala"
	editing_tools_redeye_tool_bind_window_handlers (self);
#line 2058 "../src/editing_tools/EditingTools.vala"
	_tmp12_ = editing_tools_photo_canvas_get_photo (canvas);
#line 2058 "../src/editing_tools/EditingTools.vala"
	_tmp13_ = _tmp12_;
#line 2058 "../src/editing_tools/EditingTools.vala"
	_tmp14_ = data_object_get_membership (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, TYPE_DATA_OBJECT, DataObject));
#line 2058 "../src/editing_tools/EditingTools.vala"
	_tmp15_ = _tmp14_;
#line 2058 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (_tmp13_);
#line 2058 "../src/editing_tools/EditingTools.vala"
	owner = _tmp15_;
#line 2059 "../src/editing_tools/EditingTools.vala"
	_tmp16_ = owner;
#line 2059 "../src/editing_tools/EditingTools.vala"
	if (_tmp16_ != NULL) {
#line 12424 "EditingTools.c"
		DataCollection* _tmp17_;
#line 2060 "../src/editing_tools/EditingTools.vala"
		_tmp17_ = owner;
#line 2060 "../src/editing_tools/EditingTools.vala"
		g_signal_connect (_tmp17_, "items-altered", (GCallback) _editing_tools_redeye_tool_on_photos_altered_data_collection_items_altered, self);
#line 12430 "EditingTools.c"
	}
#line 2062 "../src/editing_tools/EditingTools.vala"
	EDITING_TOOLS_EDITING_TOOL_CLASS (editing_tools_redeye_tool_parent_class)->activate (G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool), canvas);
#line 2043 "../src/editing_tools/EditingTools.vala"
	_data_collection_unref0 (owner);
#line 12436 "EditingTools.c"
}

static void
editing_tools_redeye_tool_real_deactivate (EditingToolsEditingTool* base)
{
	EditingToolsRedeyeTool * self;
	EditingToolsPhotoCanvas* _tmp0_;
	EditingToolsRedeyeToolRedeyeToolWindow* _tmp10_;
#line 2065 "../src/editing_tools/EditingTools.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, EDITING_TOOLS_TYPE_REDEYE_TOOL, EditingToolsRedeyeTool);
#line 2066 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 2066 "../src/editing_tools/EditingTools.vala"
	if (_tmp0_ != NULL) {
#line 12451 "EditingTools.c"
		DataCollection* owner = NULL;
		EditingToolsPhotoCanvas* _tmp1_;
		Photo* _tmp2_;
		Photo* _tmp3_;
		DataCollection* _tmp4_;
		DataCollection* _tmp5_;
		DataCollection* _tmp6_;
		EditingToolsPhotoCanvas* _tmp9_;
#line 2067 "../src/editing_tools/EditingTools.vala"
		_tmp1_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 2067 "../src/editing_tools/EditingTools.vala"
		_tmp2_ = editing_tools_photo_canvas_get_photo (_tmp1_);
#line 2067 "../src/editing_tools/EditingTools.vala"
		_tmp3_ = _tmp2_;
#line 2067 "../src/editing_tools/EditingTools.vala"
		_tmp4_ = data_object_get_membership (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_DATA_OBJECT, DataObject));
#line 2067 "../src/editing_tools/EditingTools.vala"
		_tmp5_ = _tmp4_;
#line 2067 "../src/editing_tools/EditingTools.vala"
		_g_object_unref0 (_tmp3_);
#line 2067 "../src/editing_tools/EditingTools.vala"
		owner = _tmp5_;
#line 2068 "../src/editing_tools/EditingTools.vala"
		_tmp6_ = owner;
#line 2068 "../src/editing_tools/EditingTools.vala"
		if (_tmp6_ != NULL) {
#line 12478 "EditingTools.c"
			DataCollection* _tmp7_;
			guint _tmp8_;
#line 2069 "../src/editing_tools/EditingTools.vala"
			_tmp7_ = owner;
#line 2069 "../src/editing_tools/EditingTools.vala"
			g_signal_parse_name ("items-altered", TYPE_DATA_COLLECTION, &_tmp8_, NULL, FALSE);
#line 2069 "../src/editing_tools/EditingTools.vala"
			g_signal_handlers_disconnect_matched (_tmp7_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp8_, 0, NULL, (GCallback) _editing_tools_redeye_tool_on_photos_altered_data_collection_items_altered, self);
#line 12487 "EditingTools.c"
		}
#line 2071 "../src/editing_tools/EditingTools.vala"
		_tmp9_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 2071 "../src/editing_tools/EditingTools.vala"
		editing_tools_redeye_tool_unbind_canvas_handlers (self, _tmp9_);
#line 2066 "../src/editing_tools/EditingTools.vala"
		_data_collection_unref0 (owner);
#line 12495 "EditingTools.c"
	}
#line 2074 "../src/editing_tools/EditingTools.vala"
	_tmp10_ = self->priv->redeye_tool_window;
#line 2074 "../src/editing_tools/EditingTools.vala"
	if (_tmp10_ != NULL) {
#line 12501 "EditingTools.c"
		EditingToolsRedeyeToolRedeyeToolWindow* _tmp11_;
		EditingToolsRedeyeToolRedeyeToolWindow* _tmp12_;
#line 2075 "../src/editing_tools/EditingTools.vala"
		editing_tools_redeye_tool_unbind_window_handlers (self);
#line 2076 "../src/editing_tools/EditingTools.vala"
		_tmp11_ = self->priv->redeye_tool_window;
#line 2076 "../src/editing_tools/EditingTools.vala"
		gtk_widget_hide (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, gtk_widget_get_type (), GtkWidget));
#line 2077 "../src/editing_tools/EditingTools.vala"
		_tmp12_ = self->priv->redeye_tool_window;
#line 2077 "../src/editing_tools/EditingTools.vala"
		gtk_widget_destroy (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, gtk_widget_get_type (), GtkWidget));
#line 2078 "../src/editing_tools/EditingTools.vala"
		_g_object_unref0 (self->priv->redeye_tool_window);
#line 2078 "../src/editing_tools/EditingTools.vala"
		self->priv->redeye_tool_window = NULL;
#line 12518 "EditingTools.c"
	}
#line 2081 "../src/editing_tools/EditingTools.vala"
	EDITING_TOOLS_EDITING_TOOL_CLASS (editing_tools_redeye_tool_parent_class)->deactivate (G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool));
#line 12522 "EditingTools.c"
}

static void
_editing_tools_redeye_tool_prepare_ctx_editing_tools_photo_canvas_new_surface (EditingToolsPhotoCanvas* _sender,
                                                                               cairo_t* ctx,
                                                                               Dimensions* dim,
                                                                               gpointer self)
{
#line 2085 "../src/editing_tools/EditingTools.vala"
	editing_tools_redeye_tool_prepare_ctx ((EditingToolsRedeyeTool*) self, ctx, dim);
#line 12533 "EditingTools.c"
}

static void
_editing_tools_redeye_tool_on_canvas_resize_editing_tools_photo_canvas_resized_scaled_pixbuf (EditingToolsPhotoCanvas* _sender,
                                                                                              Dimensions* old_dim,
                                                                                              GdkPixbuf* scaled,
                                                                                              GdkRectangle* scaled_position,
                                                                                              gpointer self)
{
#line 2086 "../src/editing_tools/EditingTools.vala"
	editing_tools_redeye_tool_on_canvas_resize ((EditingToolsRedeyeTool*) self);
#line 12545 "EditingTools.c"
}

static void
editing_tools_redeye_tool_bind_canvas_handlers (EditingToolsRedeyeTool* self,
                                                EditingToolsPhotoCanvas* canvas)
{
#line 2084 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_REDEYE_TOOL (self));
#line 2084 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_PHOTO_CANVAS (canvas));
#line 2085 "../src/editing_tools/EditingTools.vala"
	g_signal_connect (canvas, "new-surface", (GCallback) _editing_tools_redeye_tool_prepare_ctx_editing_tools_photo_canvas_new_surface, self);
#line 2086 "../src/editing_tools/EditingTools.vala"
	g_signal_connect (canvas, "resized-scaled-pixbuf", (GCallback) _editing_tools_redeye_tool_on_canvas_resize_editing_tools_photo_canvas_resized_scaled_pixbuf, self);
#line 12560 "EditingTools.c"
}

static void
editing_tools_redeye_tool_unbind_canvas_handlers (EditingToolsRedeyeTool* self,
                                                  EditingToolsPhotoCanvas* canvas)
{
	guint _tmp0_;
	guint _tmp1_;
#line 2089 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_REDEYE_TOOL (self));
#line 2089 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_PHOTO_CANVAS (canvas));
#line 2090 "../src/editing_tools/EditingTools.vala"
	g_signal_parse_name ("new-surface", EDITING_TOOLS_TYPE_PHOTO_CANVAS, &_tmp0_, NULL, FALSE);
#line 2090 "../src/editing_tools/EditingTools.vala"
	g_signal_handlers_disconnect_matched (canvas, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _editing_tools_redeye_tool_prepare_ctx_editing_tools_photo_canvas_new_surface, self);
#line 2091 "../src/editing_tools/EditingTools.vala"
	g_signal_parse_name ("resized-scaled-pixbuf", EDITING_TOOLS_TYPE_PHOTO_CANVAS, &_tmp1_, NULL, FALSE);
#line 2091 "../src/editing_tools/EditingTools.vala"
	g_signal_handlers_disconnect_matched (canvas, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _editing_tools_redeye_tool_on_canvas_resize_editing_tools_photo_canvas_resized_scaled_pixbuf, self);
#line 12581 "EditingTools.c"
}

static void
_editing_tools_redeye_tool_on_apply_gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self)
{
#line 2095 "../src/editing_tools/EditingTools.vala"
	editing_tools_redeye_tool_on_apply ((EditingToolsRedeyeTool*) self);
#line 12590 "EditingTools.c"
}

static void
_editing_tools_redeye_tool_on_close_gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self)
{
#line 2096 "../src/editing_tools/EditingTools.vala"
	editing_tools_redeye_tool_on_close ((EditingToolsRedeyeTool*) self);
#line 12599 "EditingTools.c"
}

static gboolean
_editing_tools_redeye_tool_on_size_slider_adjust_gtk_range_change_value (GtkRange* _sender,
                                                                         GtkScrollType scroll,
                                                                         gdouble new_value,
                                                                         gpointer self)
{
	gboolean result;
	result = editing_tools_redeye_tool_on_size_slider_adjust ((EditingToolsRedeyeTool*) self, scroll);
#line 2097 "../src/editing_tools/EditingTools.vala"
	return result;
#line 12612 "EditingTools.c"
}

static void
editing_tools_redeye_tool_bind_window_handlers (EditingToolsRedeyeTool* self)
{
	EditingToolsRedeyeToolRedeyeToolWindow* _tmp0_;
	GtkButton* _tmp1_;
	EditingToolsRedeyeToolRedeyeToolWindow* _tmp2_;
	GtkButton* _tmp3_;
	EditingToolsRedeyeToolRedeyeToolWindow* _tmp4_;
	GtkScale* _tmp5_;
#line 2094 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_REDEYE_TOOL (self));
#line 2095 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->redeye_tool_window;
#line 2095 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = _tmp0_->apply_button;
#line 2095 "../src/editing_tools/EditingTools.vala"
	g_signal_connect (_tmp1_, "clicked", (GCallback) _editing_tools_redeye_tool_on_apply_gtk_button_clicked, self);
#line 2096 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = self->priv->redeye_tool_window;
#line 2096 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = _tmp2_->close_button;
#line 2096 "../src/editing_tools/EditingTools.vala"
	g_signal_connect (_tmp3_, "clicked", (GCallback) _editing_tools_redeye_tool_on_close_gtk_button_clicked, self);
#line 2097 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = self->priv->redeye_tool_window;
#line 2097 "../src/editing_tools/EditingTools.vala"
	_tmp5_ = _tmp4_->slider;
#line 2097 "../src/editing_tools/EditingTools.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gtk_range_get_type (), GtkRange), "change-value", (GCallback) _editing_tools_redeye_tool_on_size_slider_adjust_gtk_range_change_value, self);
#line 12644 "EditingTools.c"
}

static void
editing_tools_redeye_tool_unbind_window_handlers (EditingToolsRedeyeTool* self)
{
	EditingToolsRedeyeToolRedeyeToolWindow* _tmp0_;
	GtkButton* _tmp1_;
	guint _tmp2_;
	EditingToolsRedeyeToolRedeyeToolWindow* _tmp3_;
	GtkButton* _tmp4_;
	guint _tmp5_;
	EditingToolsRedeyeToolRedeyeToolWindow* _tmp6_;
	GtkScale* _tmp7_;
	guint _tmp8_;
#line 2100 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_REDEYE_TOOL (self));
#line 2101 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->redeye_tool_window;
#line 2101 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = _tmp0_->apply_button;
#line 2101 "../src/editing_tools/EditingTools.vala"
	g_signal_parse_name ("clicked", gtk_button_get_type (), &_tmp2_, NULL, FALSE);
#line 2101 "../src/editing_tools/EditingTools.vala"
	g_signal_handlers_disconnect_matched (_tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _editing_tools_redeye_tool_on_apply_gtk_button_clicked, self);
#line 2102 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = self->priv->redeye_tool_window;
#line 2102 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = _tmp3_->close_button;
#line 2102 "../src/editing_tools/EditingTools.vala"
	g_signal_parse_name ("clicked", gtk_button_get_type (), &_tmp5_, NULL, FALSE);
#line 2102 "../src/editing_tools/EditingTools.vala"
	g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _editing_tools_redeye_tool_on_close_gtk_button_clicked, self);
#line 2103 "../src/editing_tools/EditingTools.vala"
	_tmp6_ = self->priv->redeye_tool_window;
#line 2103 "../src/editing_tools/EditingTools.vala"
	_tmp7_ = _tmp6_->slider;
#line 2103 "../src/editing_tools/EditingTools.vala"
	g_signal_parse_name ("change-value", gtk_range_get_type (), &_tmp8_, NULL, FALSE);
#line 2103 "../src/editing_tools/EditingTools.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_range_get_type (), GtkRange), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp8_, 0, NULL, (GCallback) _editing_tools_redeye_tool_on_size_slider_adjust_gtk_range_change_value, self);
#line 12685 "EditingTools.c"
}

static EditingToolsEditingToolWindow*
editing_tools_redeye_tool_real_get_tool_window (EditingToolsEditingTool* base)
{
	EditingToolsRedeyeTool * self;
	EditingToolsRedeyeToolRedeyeToolWindow* _tmp0_;
	EditingToolsEditingToolWindow* _tmp1_;
	EditingToolsEditingToolWindow* result;
#line 2106 "../src/editing_tools/EditingTools.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, EDITING_TOOLS_TYPE_REDEYE_TOOL, EditingToolsRedeyeTool);
#line 2107 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->redeye_tool_window;
#line 2107 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, EDITING_TOOLS_TYPE_EDITING_TOOL_WINDOW, EditingToolsEditingToolWindow));
#line 2107 "../src/editing_tools/EditingTools.vala"
	result = _tmp1_;
#line 2107 "../src/editing_tools/EditingTools.vala"
	return result;
#line 12705 "EditingTools.c"
}

static void
editing_tools_redeye_tool_real_paint (EditingToolsEditingTool* base,
                                      cairo_t* ctx)
{
	EditingToolsRedeyeTool * self;
	GdkPixbuf* _tmp0_ = NULL;
	GdkPixbuf* _tmp1_;
	EditingToolsPhotoCanvas* _tmp6_;
	EditingToolsRedeyeInstance active_inst = {0};
	EditingToolsRedeyeInstance _tmp7_;
	EditingToolsPhotoCanvas* _tmp8_;
	EditingToolsRedeyeInstance _tmp9_;
	GdkPoint _tmp10_;
	GdkPoint _tmp11_ = {0};
	EditingToolsRedeyeInstance _tmp12_;
#line 2110 "../src/editing_tools/EditingTools.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, EDITING_TOOLS_TYPE_REDEYE_TOOL, EditingToolsRedeyeTool);
#line 2110 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (ctx != NULL);
#line 2111 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = self->priv->current_pixbuf;
#line 2111 "../src/editing_tools/EditingTools.vala"
	if (_tmp1_ != NULL) {
#line 12731 "EditingTools.c"
		GdkPixbuf* _tmp2_;
		GdkPixbuf* _tmp3_;
#line 2111 "../src/editing_tools/EditingTools.vala"
		_tmp2_ = self->priv->current_pixbuf;
#line 2111 "../src/editing_tools/EditingTools.vala"
		_tmp3_ = _g_object_ref0 (_tmp2_);
#line 2111 "../src/editing_tools/EditingTools.vala"
		_g_object_unref0 (_tmp0_);
#line 2111 "../src/editing_tools/EditingTools.vala"
		_tmp0_ = _tmp3_;
#line 12742 "EditingTools.c"
	} else {
		EditingToolsPhotoCanvas* _tmp4_;
		GdkPixbuf* _tmp5_;
#line 2111 "../src/editing_tools/EditingTools.vala"
		_tmp4_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 2111 "../src/editing_tools/EditingTools.vala"
		_tmp5_ = editing_tools_photo_canvas_get_scaled_pixbuf (_tmp4_);
#line 2111 "../src/editing_tools/EditingTools.vala"
		_g_object_unref0 (_tmp0_);
#line 2111 "../src/editing_tools/EditingTools.vala"
		_tmp0_ = _tmp5_;
#line 12754 "EditingTools.c"
	}
#line 2111 "../src/editing_tools/EditingTools.vala"
	_tmp6_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 2111 "../src/editing_tools/EditingTools.vala"
	editing_tools_photo_canvas_paint_pixbuf (_tmp6_, _tmp0_);
#line 2115 "../src/editing_tools/EditingTools.vala"
	_tmp7_ = self->priv->user_interaction_instance;
#line 2115 "../src/editing_tools/EditingTools.vala"
	active_inst = _tmp7_;
#line 2116 "../src/editing_tools/EditingTools.vala"
	_tmp8_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 2116 "../src/editing_tools/EditingTools.vala"
	_tmp9_ = self->priv->user_interaction_instance;
#line 2116 "../src/editing_tools/EditingTools.vala"
	_tmp10_ = _tmp9_.center;
#line 2116 "../src/editing_tools/EditingTools.vala"
	editing_tools_photo_canvas_user_to_active_point (_tmp8_, &_tmp10_, &_tmp11_);
#line 2116 "../src/editing_tools/EditingTools.vala"
	active_inst.center = _tmp11_;
#line 2118 "../src/editing_tools/EditingTools.vala"
	_tmp12_ = active_inst;
#line 2118 "../src/editing_tools/EditingTools.vala"
	editing_tools_redeye_tool_draw_redeye_instance (self, &_tmp12_);
#line 2110 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (_tmp0_);
#line 12780 "EditingTools.c"
}

static void
editing_tools_redeye_tool_real_on_left_click (EditingToolsEditingTool* base,
                                              gint x,
                                              gint y)
{
	EditingToolsRedeyeTool * self;
	gdouble scale = 0.0;
	GdkRectangle bounds_rect = {0};
	EditingToolsRedeyeInstance _tmp0_;
	GdkRectangle _tmp1_ = {0};
	GdkRectangle _tmp2_;
#line 2121 "../src/editing_tools/EditingTools.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, EDITING_TOOLS_TYPE_REDEYE_TOOL, EditingToolsRedeyeTool);
#line 2122 "../src/editing_tools/EditingTools.vala"
	scale = application_get_scale ();
#line 2124 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->user_interaction_instance;
#line 2124 "../src/editing_tools/EditingTools.vala"
	editing_tools_redeye_instance_to_bounds_rect (&_tmp0_, &_tmp1_);
#line 2124 "../src/editing_tools/EditingTools.vala"
	bounds_rect = _tmp1_;
#line 2128 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = bounds_rect;
#line 2128 "../src/editing_tools/EditingTools.vala"
	if (coord_in_rectangle ((gint) lround (x * scale), (gint) lround (y * scale), &_tmp2_)) {
#line 12808 "EditingTools.c"
		EditingToolsRedeyeInstance _tmp3_;
		GdkPoint _tmp4_;
#line 2129 "../src/editing_tools/EditingTools.vala"
		g_print ("Motion in progress!!\n");
#line 2130 "../src/editing_tools/EditingTools.vala"
		self->priv->is_reticle_move_in_progress = TRUE;
#line 2131 "../src/editing_tools/EditingTools.vala"
		self->priv->reticle_move_mouse_start_point.x = (gint) lround (x * scale);
#line 2132 "../src/editing_tools/EditingTools.vala"
		self->priv->reticle_move_mouse_start_point.y = (gint) lround (y * scale);
#line 2133 "../src/editing_tools/EditingTools.vala"
		_tmp3_ = self->priv->user_interaction_instance;
#line 2133 "../src/editing_tools/EditingTools.vala"
		_tmp4_ = _tmp3_.center;
#line 2133 "../src/editing_tools/EditingTools.vala"
		self->priv->reticle_move_anchor = _tmp4_;
#line 12825 "EditingTools.c"
	}
}

static void
editing_tools_redeye_tool_real_on_left_released (EditingToolsEditingTool* base,
                                                 gint x,
                                                 gint y)
{
	EditingToolsRedeyeTool * self;
#line 2137 "../src/editing_tools/EditingTools.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, EDITING_TOOLS_TYPE_REDEYE_TOOL, EditingToolsRedeyeTool);
#line 2138 "../src/editing_tools/EditingTools.vala"
	self->priv->is_reticle_move_in_progress = FALSE;
#line 12839 "EditingTools.c"
}

static void
editing_tools_redeye_tool_real_on_motion (EditingToolsEditingTool* base,
                                          gint x,
                                          gint y,
                                          GdkModifierType mask)
{
	EditingToolsRedeyeTool * self;
	gdouble scale = 0.0;
#line 2141 "../src/editing_tools/EditingTools.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, EDITING_TOOLS_TYPE_REDEYE_TOOL, EditingToolsRedeyeTool);
#line 2142 "../src/editing_tools/EditingTools.vala"
	scale = application_get_scale ();
#line 2144 "../src/editing_tools/EditingTools.vala"
	if (self->priv->is_reticle_move_in_progress) {
#line 12856 "EditingTools.c"
		GdkRectangle active_region_rect = {0};
		EditingToolsPhotoCanvas* _tmp0_;
		GdkRectangle _tmp1_ = {0};
		gint x_clamp_low = 0;
		GdkRectangle _tmp2_;
		EditingToolsRedeyeInstance _tmp3_;
		gint y_clamp_low = 0;
		GdkRectangle _tmp4_;
		EditingToolsRedeyeInstance _tmp5_;
		gint x_clamp_high = 0;
		GdkRectangle _tmp6_;
		GdkRectangle _tmp7_;
		EditingToolsRedeyeInstance _tmp8_;
		gint y_clamp_high = 0;
		GdkRectangle _tmp9_;
		GdkRectangle _tmp10_;
		EditingToolsRedeyeInstance _tmp11_;
		gint delta_x = 0;
		GdkPoint _tmp12_;
		gint delta_y = 0;
		GdkPoint _tmp13_;
		GdkPoint _tmp14_;
		GdkPoint _tmp15_;
		GdkPoint _tmp16_;
		GdkPoint _tmp17_;
		EditingToolsPhotoCanvas* _tmp18_;
#line 2146 "../src/editing_tools/EditingTools.vala"
		_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 2146 "../src/editing_tools/EditingTools.vala"
		editing_tools_photo_canvas_get_scaled_pixbuf_position (_tmp0_, &_tmp1_);
#line 2146 "../src/editing_tools/EditingTools.vala"
		active_region_rect = _tmp1_;
#line 2149 "../src/editing_tools/EditingTools.vala"
		_tmp2_ = active_region_rect;
#line 2149 "../src/editing_tools/EditingTools.vala"
		_tmp3_ = self->priv->user_interaction_instance;
#line 2149 "../src/editing_tools/EditingTools.vala"
		x_clamp_low = (_tmp2_.x + _tmp3_.radius) + 1;
#line 2151 "../src/editing_tools/EditingTools.vala"
		_tmp4_ = active_region_rect;
#line 2151 "../src/editing_tools/EditingTools.vala"
		_tmp5_ = self->priv->user_interaction_instance;
#line 2151 "../src/editing_tools/EditingTools.vala"
		y_clamp_low = (_tmp4_.y + _tmp5_.radius) + 1;
#line 2153 "../src/editing_tools/EditingTools.vala"
		_tmp6_ = active_region_rect;
#line 2153 "../src/editing_tools/EditingTools.vala"
		_tmp7_ = active_region_rect;
#line 2153 "../src/editing_tools/EditingTools.vala"
		_tmp8_ = self->priv->user_interaction_instance;
#line 2153 "../src/editing_tools/EditingTools.vala"
		x_clamp_high = ((_tmp6_.x + _tmp7_.width) - _tmp8_.radius) - 1;
#line 2156 "../src/editing_tools/EditingTools.vala"
		_tmp9_ = active_region_rect;
#line 2156 "../src/editing_tools/EditingTools.vala"
		_tmp10_ = active_region_rect;
#line 2156 "../src/editing_tools/EditingTools.vala"
		_tmp11_ = self->priv->user_interaction_instance;
#line 2156 "../src/editing_tools/EditingTools.vala"
		y_clamp_high = ((_tmp9_.y + _tmp10_.height) - _tmp11_.radius) - 1;
#line 2160 "../src/editing_tools/EditingTools.vala"
		_tmp12_ = self->priv->reticle_move_mouse_start_point;
#line 2160 "../src/editing_tools/EditingTools.vala"
		delta_x = ((gint) lround (x * scale)) - _tmp12_.x;
#line 2161 "../src/editing_tools/EditingTools.vala"
		_tmp13_ = self->priv->reticle_move_mouse_start_point;
#line 2161 "../src/editing_tools/EditingTools.vala"
		delta_y = ((gint) lround (y * scale)) - _tmp13_.y;
#line 2163 "../src/editing_tools/EditingTools.vala"
		_tmp14_ = self->priv->reticle_move_anchor;
#line 2163 "../src/editing_tools/EditingTools.vala"
		self->priv->user_interaction_instance.center.x = _tmp14_.x + delta_x;
#line 2165 "../src/editing_tools/EditingTools.vala"
		_tmp15_ = self->priv->reticle_move_anchor;
#line 2165 "../src/editing_tools/EditingTools.vala"
		self->priv->user_interaction_instance.center.y = _tmp15_.y + delta_y;
#line 2168 "../src/editing_tools/EditingTools.vala"
		_tmp16_ = self->priv->reticle_move_anchor;
#line 2168 "../src/editing_tools/EditingTools.vala"
		self->priv->user_interaction_instance.center.x = CLAMP (_tmp16_.x + delta_x, x_clamp_low, x_clamp_high);
#line 2171 "../src/editing_tools/EditingTools.vala"
		_tmp17_ = self->priv->reticle_move_anchor;
#line 2171 "../src/editing_tools/EditingTools.vala"
		self->priv->user_interaction_instance.center.y = CLAMP (_tmp17_.y + delta_y, y_clamp_low, y_clamp_high);
#line 2175 "../src/editing_tools/EditingTools.vala"
		_tmp18_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 2175 "../src/editing_tools/EditingTools.vala"
		editing_tools_photo_canvas_repaint (_tmp18_);
#line 12945 "EditingTools.c"
	} else {
		GdkRectangle bounds = {0};
		EditingToolsRedeyeInstance _tmp19_;
		GdkRectangle _tmp20_ = {0};
		GdkRectangle _tmp21_;
#line 2177 "../src/editing_tools/EditingTools.vala"
		_tmp19_ = self->priv->user_interaction_instance;
#line 2177 "../src/editing_tools/EditingTools.vala"
		editing_tools_redeye_instance_to_bounds_rect (&_tmp19_, &_tmp20_);
#line 2177 "../src/editing_tools/EditingTools.vala"
		bounds = _tmp20_;
#line 2180 "../src/editing_tools/EditingTools.vala"
		_tmp21_ = bounds;
#line 2180 "../src/editing_tools/EditingTools.vala"
		if (coord_in_rectangle ((gint) lround (x * scale), (gint) lround (y * scale), &_tmp21_)) {
#line 12961 "EditingTools.c"
			EditingToolsPhotoCanvas* _tmp22_;
#line 2181 "../src/editing_tools/EditingTools.vala"
			_tmp22_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 2181 "../src/editing_tools/EditingTools.vala"
			editing_tools_photo_canvas_set_cursor (_tmp22_, GDK_FLEUR);
#line 12967 "EditingTools.c"
		} else {
			EditingToolsPhotoCanvas* _tmp23_;
#line 2183 "../src/editing_tools/EditingTools.vala"
			_tmp23_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 2183 "../src/editing_tools/EditingTools.vala"
			editing_tools_photo_canvas_set_cursor (_tmp23_, GDK_LEFT_PTR);
#line 12974 "EditingTools.c"
		}
	}
}

static gboolean
editing_tools_redeye_tool_real_on_keypress (EditingToolsEditingTool* base,
                                            GdkEventKey* event)
{
	EditingToolsRedeyeTool * self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	gboolean result;
#line 2188 "../src/editing_tools/EditingTools.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, EDITING_TOOLS_TYPE_REDEYE_TOOL, EditingToolsRedeyeTool);
#line 2188 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 2189 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = gdk_keyval_name (event->keyval);
#line 2189 "../src/editing_tools/EditingTools.vala"
	if (g_strcmp0 (_tmp2_, "KP_Enter") == 0) {
#line 2189 "../src/editing_tools/EditingTools.vala"
		_tmp1_ = TRUE;
#line 12998 "EditingTools.c"
	} else {
		const gchar* _tmp3_;
#line 2190 "../src/editing_tools/EditingTools.vala"
		_tmp3_ = gdk_keyval_name (event->keyval);
#line 2190 "../src/editing_tools/EditingTools.vala"
		_tmp1_ = g_strcmp0 (_tmp3_, "Enter") == 0;
#line 13005 "EditingTools.c"
	}
#line 2189 "../src/editing_tools/EditingTools.vala"
	if (_tmp1_) {
#line 2189 "../src/editing_tools/EditingTools.vala"
		_tmp0_ = TRUE;
#line 13011 "EditingTools.c"
	} else {
		const gchar* _tmp4_;
#line 2191 "../src/editing_tools/EditingTools.vala"
		_tmp4_ = gdk_keyval_name (event->keyval);
#line 2191 "../src/editing_tools/EditingTools.vala"
		_tmp0_ = g_strcmp0 (_tmp4_, "Return") == 0;
#line 13018 "EditingTools.c"
	}
#line 2189 "../src/editing_tools/EditingTools.vala"
	if (_tmp0_) {
#line 2192 "../src/editing_tools/EditingTools.vala"
		editing_tools_redeye_tool_on_close (self);
#line 2193 "../src/editing_tools/EditingTools.vala"
		result = TRUE;
#line 2193 "../src/editing_tools/EditingTools.vala"
		return result;
#line 13028 "EditingTools.c"
	}
#line 2196 "../src/editing_tools/EditingTools.vala"
	result = EDITING_TOOLS_EDITING_TOOL_CLASS (editing_tools_redeye_tool_parent_class)->on_keypress (G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool), event);
#line 2196 "../src/editing_tools/EditingTools.vala"
	return result;
#line 13034 "EditingTools.c"
}

static inline gpointer
editing_tools_redeye_tool_redeye_tool_window_get_instance_private (EditingToolsRedeyeToolRedeyeToolWindow* self)
{
	return G_STRUCT_MEMBER_P (self, EditingToolsRedeyeToolRedeyeToolWindow_private_offset);
}

static EditingToolsRedeyeToolRedeyeToolWindow*
editing_tools_redeye_tool_redeye_tool_window_construct (GType object_type,
                                                        GtkWindow* container)
{
	EditingToolsRedeyeToolRedeyeToolWindow * self = NULL;
	GtkScale* _tmp0_;
	GtkScale* _tmp1_;
	GtkButton* _tmp2_;
	GtkButton* _tmp3_;
	GtkButton* _tmp4_;
	GtkButton* _tmp5_;
	GtkBox* layout = NULL;
	GtkBox* _tmp6_;
	GtkLabel* _tmp7_;
	GtkScale* _tmp8_;
	GtkButton* _tmp9_;
	GtkButton* _tmp10_;
#line 1879 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (container, gtk_window_get_type ()), NULL);
#line 1880 "../src/editing_tools/EditingTools.vala"
	self = (EditingToolsRedeyeToolRedeyeToolWindow*) editing_tools_editing_tool_window_construct (object_type, container);
#line 1882 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->slider;
#line 1882 "../src/editing_tools/EditingTools.vala"
	gtk_widget_set_size_request (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget), 80, -1);
#line 1883 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = self->slider;
#line 1883 "../src/editing_tools/EditingTools.vala"
	gtk_scale_set_draw_value (_tmp1_, FALSE);
#line 1885 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = self->close_button;
#line 1885 "../src/editing_tools/EditingTools.vala"
	gtk_widget_set_tooltip_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_widget_get_type (), GtkWidget), _ ("Close the red-eye tool"));
#line 1886 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = self->close_button;
#line 1886 "../src/editing_tools/EditingTools.vala"
	gtk_button_set_image_position (_tmp3_, GTK_POS_LEFT);
#line 1888 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = self->apply_button;
#line 1888 "../src/editing_tools/EditingTools.vala"
	gtk_widget_set_tooltip_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_widget_get_type (), GtkWidget), _ ("Remove any red-eye effects in the selected region"));
#line 1889 "../src/editing_tools/EditingTools.vala"
	_tmp5_ = self->apply_button;
#line 1889 "../src/editing_tools/EditingTools.vala"
	gtk_button_set_image_position (_tmp5_, GTK_POS_LEFT);
#line 1891 "../src/editing_tools/EditingTools.vala"
	_tmp6_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, EDITING_TOOLS_REDEYE_TOOL_REDEYE_TOOL_WINDOW_CONTROL_SPACING);
#line 1891 "../src/editing_tools/EditingTools.vala"
	g_object_ref_sink (_tmp6_);
#line 1891 "../src/editing_tools/EditingTools.vala"
	layout = _tmp6_;
#line 1892 "../src/editing_tools/EditingTools.vala"
	_tmp7_ = self->priv->slider_label;
#line 1892 "../src/editing_tools/EditingTools.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (layout, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_widget_get_type (), GtkWidget));
#line 1893 "../src/editing_tools/EditingTools.vala"
	_tmp8_ = self->slider;
#line 1893 "../src/editing_tools/EditingTools.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (layout, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_widget_get_type (), GtkWidget));
#line 1894 "../src/editing_tools/EditingTools.vala"
	_tmp9_ = self->close_button;
#line 1894 "../src/editing_tools/EditingTools.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (layout, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, gtk_widget_get_type (), GtkWidget));
#line 1895 "../src/editing_tools/EditingTools.vala"
	_tmp10_ = self->apply_button;
#line 1895 "../src/editing_tools/EditingTools.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (layout, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, gtk_widget_get_type (), GtkWidget));
#line 1897 "../src/editing_tools/EditingTools.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (layout, gtk_widget_get_type (), GtkWidget));
#line 1879 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (layout);
#line 1879 "../src/editing_tools/EditingTools.vala"
	return self;
#line 13116 "EditingTools.c"
}

static EditingToolsRedeyeToolRedeyeToolWindow*
editing_tools_redeye_tool_redeye_tool_window_new (GtkWindow* container)
{
#line 1879 "../src/editing_tools/EditingTools.vala"
	return editing_tools_redeye_tool_redeye_tool_window_construct (EDITING_TOOLS_REDEYE_TOOL_TYPE_REDEYE_TOOL_WINDOW, container);
#line 13124 "EditingTools.c"
}

static void
editing_tools_redeye_tool_redeye_tool_window_class_init (EditingToolsRedeyeToolRedeyeToolWindowClass * klass,
                                                         gpointer klass_data)
{
#line 1867 "../src/editing_tools/EditingTools.vala"
	editing_tools_redeye_tool_redeye_tool_window_parent_class = g_type_class_peek_parent (klass);
#line 1867 "../src/editing_tools/EditingTools.vala"
	g_type_class_adjust_private_offset (klass, &EditingToolsRedeyeToolRedeyeToolWindow_private_offset);
#line 1867 "../src/editing_tools/EditingTools.vala"
	G_OBJECT_CLASS (klass)->finalize = editing_tools_redeye_tool_redeye_tool_window_finalize;
#line 13137 "EditingTools.c"
}

static void
editing_tools_redeye_tool_redeye_tool_window_instance_init (EditingToolsRedeyeToolRedeyeToolWindow * self,
                                                            gpointer klass)
{
	GtkLabel* _tmp0_;
	GtkButton* _tmp1_;
	GtkButton* _tmp2_;
	GtkScale* _tmp3_;
#line 1867 "../src/editing_tools/EditingTools.vala"
	self->priv = editing_tools_redeye_tool_redeye_tool_window_get_instance_private (self);
#line 1870 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = (GtkLabel*) gtk_label_new_with_mnemonic (_ ("Size:"));
#line 1870 "../src/editing_tools/EditingTools.vala"
	g_object_ref_sink (_tmp0_);
#line 1870 "../src/editing_tools/EditingTools.vala"
	self->priv->slider_label = _tmp0_;
#line 1872 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = (GtkButton*) gtk_button_new_with_mnemonic (RESOURCES_APPLY_LABEL);
#line 1872 "../src/editing_tools/EditingTools.vala"
	g_object_ref_sink (_tmp1_);
#line 1872 "../src/editing_tools/EditingTools.vala"
	self->apply_button = _tmp1_;
#line 1874 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = (GtkButton*) gtk_button_new_with_mnemonic (RESOURCES_CANCEL_LABEL);
#line 1874 "../src/editing_tools/EditingTools.vala"
	g_object_ref_sink (_tmp2_);
#line 1874 "../src/editing_tools/EditingTools.vala"
	self->close_button = _tmp2_;
#line 1876 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = (GtkScale*) gtk_scale_new_with_range (GTK_ORIENTATION_HORIZONTAL, (gdouble) EDITING_TOOLS_REDEYE_INSTANCE_MIN_RADIUS, (gdouble) EDITING_TOOLS_REDEYE_INSTANCE_MAX_RADIUS, 1.0);
#line 1876 "../src/editing_tools/EditingTools.vala"
	g_object_ref_sink (_tmp3_);
#line 1876 "../src/editing_tools/EditingTools.vala"
	self->slider = _tmp3_;
#line 13174 "EditingTools.c"
}

static void
editing_tools_redeye_tool_redeye_tool_window_finalize (GObject * obj)
{
	EditingToolsRedeyeToolRedeyeToolWindow * self;
#line 1867 "../src/editing_tools/EditingTools.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, EDITING_TOOLS_REDEYE_TOOL_TYPE_REDEYE_TOOL_WINDOW, EditingToolsRedeyeToolRedeyeToolWindow);
#line 1870 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->priv->slider_label);
#line 1872 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->apply_button);
#line 1874 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->close_button);
#line 1876 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->slider);
#line 1867 "../src/editing_tools/EditingTools.vala"
	G_OBJECT_CLASS (editing_tools_redeye_tool_redeye_tool_window_parent_class)->finalize (obj);
#line 13193 "EditingTools.c"
}

static GType
editing_tools_redeye_tool_redeye_tool_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (EditingToolsRedeyeToolRedeyeToolWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) editing_tools_redeye_tool_redeye_tool_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EditingToolsRedeyeToolRedeyeToolWindow), 0, (GInstanceInitFunc) editing_tools_redeye_tool_redeye_tool_window_instance_init, NULL };
	GType editing_tools_redeye_tool_redeye_tool_window_type_id;
	editing_tools_redeye_tool_redeye_tool_window_type_id = g_type_register_static (EDITING_TOOLS_TYPE_EDITING_TOOL_WINDOW, "EditingToolsRedeyeToolRedeyeToolWindow", &g_define_type_info, 0);
	EditingToolsRedeyeToolRedeyeToolWindow_private_offset = g_type_add_instance_private (editing_tools_redeye_tool_redeye_tool_window_type_id, sizeof (EditingToolsRedeyeToolRedeyeToolWindowPrivate));
	return editing_tools_redeye_tool_redeye_tool_window_type_id;
}

static GType
editing_tools_redeye_tool_redeye_tool_window_get_type (void)
{
	static volatile gsize editing_tools_redeye_tool_redeye_tool_window_type_id__once = 0;
	if (g_once_init_enter (&editing_tools_redeye_tool_redeye_tool_window_type_id__once)) {
		GType editing_tools_redeye_tool_redeye_tool_window_type_id;
		editing_tools_redeye_tool_redeye_tool_window_type_id = editing_tools_redeye_tool_redeye_tool_window_get_type_once ();
		g_once_init_leave (&editing_tools_redeye_tool_redeye_tool_window_type_id__once, editing_tools_redeye_tool_redeye_tool_window_type_id);
	}
	return editing_tools_redeye_tool_redeye_tool_window_type_id__once;
}

static void
editing_tools_redeye_tool_class_init (EditingToolsRedeyeToolClass * klass,
                                      gpointer klass_data)
{
#line 1866 "../src/editing_tools/EditingTools.vala"
	editing_tools_redeye_tool_parent_class = g_type_class_peek_parent (klass);
#line 1866 "../src/editing_tools/EditingTools.vala"
	((EditingToolsEditingToolClass *) klass)->finalize = editing_tools_redeye_tool_finalize;
#line 1866 "../src/editing_tools/EditingTools.vala"
	g_type_class_adjust_private_offset (klass, &EditingToolsRedeyeTool_private_offset);
#line 1866 "../src/editing_tools/EditingTools.vala"
	((EditingToolsEditingToolClass *) klass)->activate = (void (*) (EditingToolsEditingTool*, EditingToolsPhotoCanvas*)) editing_tools_redeye_tool_real_activate;
#line 1866 "../src/editing_tools/EditingTools.vala"
	((EditingToolsEditingToolClass *) klass)->deactivate = (void (*) (EditingToolsEditingTool*)) editing_tools_redeye_tool_real_deactivate;
#line 1866 "../src/editing_tools/EditingTools.vala"
	((EditingToolsEditingToolClass *) klass)->get_tool_window = (EditingToolsEditingToolWindow* (*) (EditingToolsEditingTool*)) editing_tools_redeye_tool_real_get_tool_window;
#line 1866 "../src/editing_tools/EditingTools.vala"
	((EditingToolsEditingToolClass *) klass)->paint = (void (*) (EditingToolsEditingTool*, cairo_t*)) editing_tools_redeye_tool_real_paint;
#line 1866 "../src/editing_tools/EditingTools.vala"
	((EditingToolsEditingToolClass *) klass)->on_left_click = (void (*) (EditingToolsEditingTool*, gint, gint)) editing_tools_redeye_tool_real_on_left_click;
#line 1866 "../src/editing_tools/EditingTools.vala"
	((EditingToolsEditingToolClass *) klass)->on_left_released = (void (*) (EditingToolsEditingTool*, gint, gint)) editing_tools_redeye_tool_real_on_left_released;
#line 1866 "../src/editing_tools/EditingTools.vala"
	((EditingToolsEditingToolClass *) klass)->on_motion = (void (*) (EditingToolsEditingTool*, gint, gint, GdkModifierType)) editing_tools_redeye_tool_real_on_motion;
#line 1866 "../src/editing_tools/EditingTools.vala"
	((EditingToolsEditingToolClass *) klass)->on_keypress = (gboolean (*) (EditingToolsEditingTool*, GdkEventKey*)) editing_tools_redeye_tool_real_on_keypress;
#line 13244 "EditingTools.c"
}

static void
editing_tools_redeye_tool_instance_init (EditingToolsRedeyeTool * self,
                                         gpointer klass)
{
#line 1866 "../src/editing_tools/EditingTools.vala"
	self->priv = editing_tools_redeye_tool_get_instance_private (self);
#line 1901 "../src/editing_tools/EditingTools.vala"
	self->priv->thin_white_ctx = NULL;
#line 1902 "../src/editing_tools/EditingTools.vala"
	self->priv->wider_gray_ctx = NULL;
#line 1903 "../src/editing_tools/EditingTools.vala"
	self->priv->redeye_tool_window = NULL;
#line 1905 "../src/editing_tools/EditingTools.vala"
	self->priv->is_reticle_move_in_progress = FALSE;
#line 1909 "../src/editing_tools/EditingTools.vala"
	self->priv->current_pixbuf = NULL;
#line 13263 "EditingTools.c"
}

static void
editing_tools_redeye_tool_finalize (EditingToolsEditingTool * obj)
{
	EditingToolsRedeyeTool * self;
#line 1866 "../src/editing_tools/EditingTools.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, EDITING_TOOLS_TYPE_REDEYE_TOOL, EditingToolsRedeyeTool);
#line 1901 "../src/editing_tools/EditingTools.vala"
	_cairo_destroy0 (self->priv->thin_white_ctx);
#line 1902 "../src/editing_tools/EditingTools.vala"
	_cairo_destroy0 (self->priv->wider_gray_ctx);
#line 1903 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->priv->redeye_tool_window);
#line 1909 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->priv->current_pixbuf);
#line 1866 "../src/editing_tools/EditingTools.vala"
	EDITING_TOOLS_EDITING_TOOL_CLASS (editing_tools_redeye_tool_parent_class)->finalize (obj);
#line 13282 "EditingTools.c"
}

static GType
editing_tools_redeye_tool_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (EditingToolsRedeyeToolClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) editing_tools_redeye_tool_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EditingToolsRedeyeTool), 0, (GInstanceInitFunc) editing_tools_redeye_tool_instance_init, NULL };
	GType editing_tools_redeye_tool_type_id;
	editing_tools_redeye_tool_type_id = g_type_register_static (EDITING_TOOLS_TYPE_EDITING_TOOL, "EditingToolsRedeyeTool", &g_define_type_info, 0);
	EditingToolsRedeyeTool_private_offset = g_type_add_instance_private (editing_tools_redeye_tool_type_id, sizeof (EditingToolsRedeyeToolPrivate));
	return editing_tools_redeye_tool_type_id;
}

GType
editing_tools_redeye_tool_get_type (void)
{
	static volatile gsize editing_tools_redeye_tool_type_id__once = 0;
	if (g_once_init_enter (&editing_tools_redeye_tool_type_id__once)) {
		GType editing_tools_redeye_tool_type_id;
		editing_tools_redeye_tool_type_id = editing_tools_redeye_tool_get_type_once ();
		g_once_init_leave (&editing_tools_redeye_tool_type_id__once, editing_tools_redeye_tool_type_id);
	}
	return editing_tools_redeye_tool_type_id__once;
}

static inline gpointer
editing_tools_adjust_tool_get_instance_private (EditingToolsAdjustTool* self)
{
	return G_STRUCT_MEMBER_P (self, EditingToolsAdjustTool_private_offset);
}

static EditingToolsAdjustTool*
editing_tools_adjust_tool_construct (GType object_type)
{
	EditingToolsAdjustTool* self = NULL;
#line 2514 "../src/editing_tools/EditingTools.vala"
	self = (EditingToolsAdjustTool*) editing_tools_editing_tool_construct (object_type, "AdjustTool");
#line 2513 "../src/editing_tools/EditingTools.vala"
	return self;
#line 13321 "EditingTools.c"
}

static EditingToolsAdjustTool*
editing_tools_adjust_tool_new (void)
{
#line 2513 "../src/editing_tools/EditingTools.vala"
	return editing_tools_adjust_tool_construct (EDITING_TOOLS_TYPE_ADJUST_TOOL);
#line 13329 "EditingTools.c"
}

EditingToolsAdjustTool*
editing_tools_adjust_tool_factory (void)
{
	EditingToolsAdjustTool* _tmp0_;
	EditingToolsAdjustTool* result;
#line 2518 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = editing_tools_adjust_tool_new ();
#line 2518 "../src/editing_tools/EditingTools.vala"
	result = _tmp0_;
#line 2518 "../src/editing_tools/EditingTools.vala"
	return result;
#line 13343 "EditingTools.c"
}

gboolean
editing_tools_adjust_tool_is_available (Photo* photo,
                                        Scaling* scaling)
{
	gboolean result;
#line 2521 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (IS_PHOTO (photo), FALSE);
#line 2521 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (scaling != NULL, FALSE);
#line 2522 "../src/editing_tools/EditingTools.vala"
	result = TRUE;
#line 2522 "../src/editing_tools/EditingTools.vala"
	return result;
#line 13359 "EditingTools.c"
}

static void
_editing_tools_adjust_tool_on_photos_altered_data_collection_items_altered (DataCollection* _sender,
                                                                            GeeMap* items,
                                                                            gpointer self)
{
#line 2611 "../src/editing_tools/EditingTools.vala"
	editing_tools_adjust_tool_on_photos_altered ((EditingToolsAdjustTool*) self, items);
#line 13369 "EditingTools.c"
}

static void
editing_tools_adjust_tool_real_activate (EditingToolsEditingTool* base,
                                         EditingToolsPhotoCanvas* canvas)
{
	EditingToolsAdjustTool * self;
	GtkWindow* _tmp0_;
	GtkWindow* _tmp1_;
	EditingToolsAdjustToolAdjustToolWindow* _tmp2_;
	Photo* photo = NULL;
	Photo* _tmp3_;
	Photo* _tmp4_;
	PixelTransformationBundle* _tmp5_;
	PixelTransformationBundle* _tmp6_;
	PixelTransformer* _tmp7_;
	PixelTransformer* _tmp8_;
	ExpansionTransformation* expansion_trans = NULL;
	PixelTransformationBundle* _tmp9_;
	PixelTransformation* _tmp10_;
	EditingToolsAdjustToolAdjustToolWindow* _tmp11_;
	RGBHistogramManipulator* _tmp12_;
	ExpansionTransformation* _tmp13_;
	EditingToolsAdjustToolAdjustToolWindow* _tmp14_;
	RGBHistogramManipulator* _tmp15_;
	ExpansionTransformation* _tmp16_;
	ShadowDetailTransformation* shadows_trans = NULL;
	PixelTransformationBundle* _tmp17_;
	PixelTransformation* _tmp18_;
	PixelTransformer* _tmp19_;
	ShadowDetailTransformation* _tmp20_;
	EditingToolsAdjustToolAdjustToolWindow* _tmp21_;
	GtkScale* _tmp22_;
	ShadowDetailTransformation* _tmp23_;
	HighlightDetailTransformation* highlights_trans = NULL;
	PixelTransformationBundle* _tmp24_;
	PixelTransformation* _tmp25_;
	PixelTransformer* _tmp26_;
	HighlightDetailTransformation* _tmp27_;
	EditingToolsAdjustToolAdjustToolWindow* _tmp28_;
	GtkScale* _tmp29_;
	HighlightDetailTransformation* _tmp30_;
	TemperatureTransformation* temp_trans = NULL;
	PixelTransformationBundle* _tmp31_;
	PixelTransformation* _tmp32_;
	PixelTransformer* _tmp33_;
	TemperatureTransformation* _tmp34_;
	EditingToolsAdjustToolAdjustToolWindow* _tmp35_;
	GtkScale* _tmp36_;
	TemperatureTransformation* _tmp37_;
	TintTransformation* tint_trans = NULL;
	PixelTransformationBundle* _tmp38_;
	PixelTransformation* _tmp39_;
	PixelTransformer* _tmp40_;
	TintTransformation* _tmp41_;
	EditingToolsAdjustToolAdjustToolWindow* _tmp42_;
	GtkScale* _tmp43_;
	TintTransformation* _tmp44_;
	SaturationTransformation* sat_trans = NULL;
	PixelTransformationBundle* _tmp45_;
	PixelTransformation* _tmp46_;
	PixelTransformer* _tmp47_;
	SaturationTransformation* _tmp48_;
	EditingToolsAdjustToolAdjustToolWindow* _tmp49_;
	GtkScale* _tmp50_;
	SaturationTransformation* _tmp51_;
	ExposureTransformation* exposure_trans = NULL;
	PixelTransformationBundle* _tmp52_;
	PixelTransformation* _tmp53_;
	PixelTransformer* _tmp54_;
	ExposureTransformation* _tmp55_;
	EditingToolsAdjustToolAdjustToolWindow* _tmp56_;
	GtkScale* _tmp57_;
	ExposureTransformation* _tmp58_;
	ContrastTransformation* contrast_trans = NULL;
	PixelTransformationBundle* _tmp59_;
	PixelTransformation* _tmp60_;
	PixelTransformer* _tmp61_;
	ContrastTransformation* _tmp62_;
	EditingToolsAdjustToolAdjustToolWindow* _tmp63_;
	GtkScale* _tmp64_;
	ContrastTransformation* _tmp65_;
	GdkPixbuf* _tmp66_;
	GdkPixbuf* _tmp67_;
	GdkPixbuf* _tmp68_;
	GdkPixbuf* _tmp69_;
	GdkPixbuf* _tmp70_;
	gboolean _tmp71_ = FALSE;
	GdkPixbuf* _tmp72_;
	gint _tmp73_;
	gint _tmp74_;
	gboolean _tmp78_ = FALSE;
	gboolean _tmp79_ = FALSE;
	GdkPixbuf* _tmp80_;
	gint _tmp81_;
	gint _tmp82_;
	GdkPixbuf* _tmp83_;
	gint _tmp84_;
	gint _tmp85_;
	GdkPixbuf* _tmp102_;
	GdkPixbuf* _tmp103_;
	DataCollection* owner = NULL;
	Photo* _tmp104_;
	Photo* _tmp105_;
	DataCollection* _tmp106_;
	DataCollection* _tmp107_;
	DataCollection* _tmp108_;
#line 2525 "../src/editing_tools/EditingTools.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, EDITING_TOOLS_TYPE_ADJUST_TOOL, EditingToolsAdjustTool);
#line 2525 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_PHOTO_CANVAS (canvas));
#line 2526 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = editing_tools_photo_canvas_get_container (canvas);
#line 2526 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = _tmp0_;
#line 2526 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = editing_tools_adjust_tool_adjust_tool_window_new (_tmp1_);
#line 2526 "../src/editing_tools/EditingTools.vala"
	g_object_ref_sink (_tmp2_);
#line 2526 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->priv->adjust_tool_window);
#line 2526 "../src/editing_tools/EditingTools.vala"
	self->priv->adjust_tool_window = _tmp2_;
#line 2526 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (_tmp1_);
#line 2528 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = editing_tools_photo_canvas_get_photo (canvas);
#line 2528 "../src/editing_tools/EditingTools.vala"
	photo = _tmp3_;
#line 2529 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = photo;
#line 2529 "../src/editing_tools/EditingTools.vala"
	_tmp5_ = photo_get_color_adjustments (_tmp4_);
#line 2529 "../src/editing_tools/EditingTools.vala"
	_pixel_transformation_bundle_unref0 (self->priv->transformations);
#line 2529 "../src/editing_tools/EditingTools.vala"
	self->priv->transformations = _tmp5_;
#line 2530 "../src/editing_tools/EditingTools.vala"
	_tmp6_ = self->priv->transformations;
#line 2530 "../src/editing_tools/EditingTools.vala"
	_tmp7_ = pixel_transformation_bundle_generate_transformer (_tmp6_);
#line 2530 "../src/editing_tools/EditingTools.vala"
	_pixel_transformer_unref0 (self->priv->transformer);
#line 2530 "../src/editing_tools/EditingTools.vala"
	self->priv->transformer = _tmp7_;
#line 2533 "../src/editing_tools/EditingTools.vala"
	_tmp8_ = pixel_transformer_new ();
#line 2533 "../src/editing_tools/EditingTools.vala"
	_pixel_transformer_unref0 (self->priv->histogram_transformer);
#line 2533 "../src/editing_tools/EditingTools.vala"
	self->priv->histogram_transformer = _tmp8_;
#line 2536 "../src/editing_tools/EditingTools.vala"
	_tmp9_ = self->priv->transformations;
#line 2536 "../src/editing_tools/EditingTools.vala"
	_tmp10_ = pixel_transformation_bundle_get_transformation (_tmp9_, PIXEL_TRANSFORMATION_TYPE_TONE_EXPANSION);
#line 2536 "../src/editing_tools/EditingTools.vala"
	expansion_trans = G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, TYPE_EXPANSION_TRANSFORMATION, ExpansionTransformation);
#line 2538 "../src/editing_tools/EditingTools.vala"
	_tmp11_ = self->priv->adjust_tool_window;
#line 2538 "../src/editing_tools/EditingTools.vala"
	_tmp12_ = _tmp11_->histogram_manipulator;
#line 2538 "../src/editing_tools/EditingTools.vala"
	_tmp13_ = expansion_trans;
#line 2538 "../src/editing_tools/EditingTools.vala"
	rgb_histogram_manipulator_set_left_nub_position (_tmp12_, expansion_transformation_get_black_point (_tmp13_));
#line 2540 "../src/editing_tools/EditingTools.vala"
	_tmp14_ = self->priv->adjust_tool_window;
#line 2540 "../src/editing_tools/EditingTools.vala"
	_tmp15_ = _tmp14_->histogram_manipulator;
#line 2540 "../src/editing_tools/EditingTools.vala"
	_tmp16_ = expansion_trans;
#line 2540 "../src/editing_tools/EditingTools.vala"
	rgb_histogram_manipulator_set_right_nub_position (_tmp15_, expansion_transformation_get_white_point (_tmp16_));
#line 2544 "../src/editing_tools/EditingTools.vala"
	_tmp17_ = self->priv->transformations;
#line 2544 "../src/editing_tools/EditingTools.vala"
	_tmp18_ = pixel_transformation_bundle_get_transformation (_tmp17_, PIXEL_TRANSFORMATION_TYPE_SHADOWS);
#line 2544 "../src/editing_tools/EditingTools.vala"
	shadows_trans = G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, TYPE_SHADOW_DETAIL_TRANSFORMATION, ShadowDetailTransformation);
#line 2546 "../src/editing_tools/EditingTools.vala"
	_tmp19_ = self->priv->histogram_transformer;
#line 2546 "../src/editing_tools/EditingTools.vala"
	_tmp20_ = shadows_trans;
#line 2546 "../src/editing_tools/EditingTools.vala"
	pixel_transformer_attach_transformation (_tmp19_, G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, TYPE_PIXEL_TRANSFORMATION, PixelTransformation));
#line 2547 "../src/editing_tools/EditingTools.vala"
	_tmp21_ = self->priv->adjust_tool_window;
#line 2547 "../src/editing_tools/EditingTools.vala"
	_tmp22_ = _tmp21_->shadows_slider;
#line 2547 "../src/editing_tools/EditingTools.vala"
	_tmp23_ = shadows_trans;
#line 2547 "../src/editing_tools/EditingTools.vala"
	gtk_range_set_value (G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, gtk_range_get_type (), GtkRange), (gdouble) shadow_detail_transformation_get_parameter (_tmp23_));
#line 2550 "../src/editing_tools/EditingTools.vala"
	_tmp24_ = self->priv->transformations;
#line 2550 "../src/editing_tools/EditingTools.vala"
	_tmp25_ = pixel_transformation_bundle_get_transformation (_tmp24_, PIXEL_TRANSFORMATION_TYPE_HIGHLIGHTS);
#line 2550 "../src/editing_tools/EditingTools.vala"
	highlights_trans = G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, TYPE_HIGHLIGHT_DETAIL_TRANSFORMATION, HighlightDetailTransformation);
#line 2552 "../src/editing_tools/EditingTools.vala"
	_tmp26_ = self->priv->histogram_transformer;
#line 2552 "../src/editing_tools/EditingTools.vala"
	_tmp27_ = highlights_trans;
#line 2552 "../src/editing_tools/EditingTools.vala"
	pixel_transformer_attach_transformation (_tmp26_, G_TYPE_CHECK_INSTANCE_CAST (_tmp27_, TYPE_PIXEL_TRANSFORMATION, PixelTransformation));
#line 2553 "../src/editing_tools/EditingTools.vala"
	_tmp28_ = self->priv->adjust_tool_window;
#line 2553 "../src/editing_tools/EditingTools.vala"
	_tmp29_ = _tmp28_->highlights_slider;
#line 2553 "../src/editing_tools/EditingTools.vala"
	_tmp30_ = highlights_trans;
#line 2553 "../src/editing_tools/EditingTools.vala"
	gtk_range_set_value (G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, gtk_range_get_type (), GtkRange), (gdouble) highlight_detail_transformation_get_parameter (_tmp30_));
#line 2556 "../src/editing_tools/EditingTools.vala"
	_tmp31_ = self->priv->transformations;
#line 2556 "../src/editing_tools/EditingTools.vala"
	_tmp32_ = pixel_transformation_bundle_get_transformation (_tmp31_, PIXEL_TRANSFORMATION_TYPE_TEMPERATURE);
#line 2556 "../src/editing_tools/EditingTools.vala"
	temp_trans = G_TYPE_CHECK_INSTANCE_CAST (_tmp32_, TYPE_TEMPERATURE_TRANSFORMATION, TemperatureTransformation);
#line 2558 "../src/editing_tools/EditingTools.vala"
	_tmp33_ = self->priv->histogram_transformer;
#line 2558 "../src/editing_tools/EditingTools.vala"
	_tmp34_ = temp_trans;
#line 2558 "../src/editing_tools/EditingTools.vala"
	pixel_transformer_attach_transformation (_tmp33_, G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, TYPE_PIXEL_TRANSFORMATION, PixelTransformation));
#line 2559 "../src/editing_tools/EditingTools.vala"
	_tmp35_ = self->priv->adjust_tool_window;
#line 2559 "../src/editing_tools/EditingTools.vala"
	_tmp36_ = _tmp35_->temperature_slider;
#line 2559 "../src/editing_tools/EditingTools.vala"
	_tmp37_ = temp_trans;
#line 2559 "../src/editing_tools/EditingTools.vala"
	gtk_range_set_value (G_TYPE_CHECK_INSTANCE_CAST (_tmp36_, gtk_range_get_type (), GtkRange), (gdouble) temperature_transformation_get_parameter (_tmp37_));
#line 2561 "../src/editing_tools/EditingTools.vala"
	_tmp38_ = self->priv->transformations;
#line 2561 "../src/editing_tools/EditingTools.vala"
	_tmp39_ = pixel_transformation_bundle_get_transformation (_tmp38_, PIXEL_TRANSFORMATION_TYPE_TINT);
#line 2561 "../src/editing_tools/EditingTools.vala"
	tint_trans = G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, TYPE_TINT_TRANSFORMATION, TintTransformation);
#line 2563 "../src/editing_tools/EditingTools.vala"
	_tmp40_ = self->priv->histogram_transformer;
#line 2563 "../src/editing_tools/EditingTools.vala"
	_tmp41_ = tint_trans;
#line 2563 "../src/editing_tools/EditingTools.vala"
	pixel_transformer_attach_transformation (_tmp40_, G_TYPE_CHECK_INSTANCE_CAST (_tmp41_, TYPE_PIXEL_TRANSFORMATION, PixelTransformation));
#line 2564 "../src/editing_tools/EditingTools.vala"
	_tmp42_ = self->priv->adjust_tool_window;
#line 2564 "../src/editing_tools/EditingTools.vala"
	_tmp43_ = _tmp42_->tint_slider;
#line 2564 "../src/editing_tools/EditingTools.vala"
	_tmp44_ = tint_trans;
#line 2564 "../src/editing_tools/EditingTools.vala"
	gtk_range_set_value (G_TYPE_CHECK_INSTANCE_CAST (_tmp43_, gtk_range_get_type (), GtkRange), (gdouble) tint_transformation_get_parameter (_tmp44_));
#line 2567 "../src/editing_tools/EditingTools.vala"
	_tmp45_ = self->priv->transformations;
#line 2567 "../src/editing_tools/EditingTools.vala"
	_tmp46_ = pixel_transformation_bundle_get_transformation (_tmp45_, PIXEL_TRANSFORMATION_TYPE_SATURATION);
#line 2567 "../src/editing_tools/EditingTools.vala"
	sat_trans = G_TYPE_CHECK_INSTANCE_CAST (_tmp46_, TYPE_SATURATION_TRANSFORMATION, SaturationTransformation);
#line 2569 "../src/editing_tools/EditingTools.vala"
	_tmp47_ = self->priv->histogram_transformer;
#line 2569 "../src/editing_tools/EditingTools.vala"
	_tmp48_ = sat_trans;
#line 2569 "../src/editing_tools/EditingTools.vala"
	pixel_transformer_attach_transformation (_tmp47_, G_TYPE_CHECK_INSTANCE_CAST (_tmp48_, TYPE_PIXEL_TRANSFORMATION, PixelTransformation));
#line 2570 "../src/editing_tools/EditingTools.vala"
	_tmp49_ = self->priv->adjust_tool_window;
#line 2570 "../src/editing_tools/EditingTools.vala"
	_tmp50_ = _tmp49_->saturation_slider;
#line 2570 "../src/editing_tools/EditingTools.vala"
	_tmp51_ = sat_trans;
#line 2570 "../src/editing_tools/EditingTools.vala"
	gtk_range_set_value (G_TYPE_CHECK_INSTANCE_CAST (_tmp50_, gtk_range_get_type (), GtkRange), (gdouble) saturation_transformation_get_parameter (_tmp51_));
#line 2573 "../src/editing_tools/EditingTools.vala"
	_tmp52_ = self->priv->transformations;
#line 2573 "../src/editing_tools/EditingTools.vala"
	_tmp53_ = pixel_transformation_bundle_get_transformation (_tmp52_, PIXEL_TRANSFORMATION_TYPE_EXPOSURE);
#line 2573 "../src/editing_tools/EditingTools.vala"
	exposure_trans = G_TYPE_CHECK_INSTANCE_CAST (_tmp53_, TYPE_EXPOSURE_TRANSFORMATION, ExposureTransformation);
#line 2575 "../src/editing_tools/EditingTools.vala"
	_tmp54_ = self->priv->histogram_transformer;
#line 2575 "../src/editing_tools/EditingTools.vala"
	_tmp55_ = exposure_trans;
#line 2575 "../src/editing_tools/EditingTools.vala"
	pixel_transformer_attach_transformation (_tmp54_, G_TYPE_CHECK_INSTANCE_CAST (_tmp55_, TYPE_PIXEL_TRANSFORMATION, PixelTransformation));
#line 2576 "../src/editing_tools/EditingTools.vala"
	_tmp56_ = self->priv->adjust_tool_window;
#line 2576 "../src/editing_tools/EditingTools.vala"
	_tmp57_ = _tmp56_->exposure_slider;
#line 2576 "../src/editing_tools/EditingTools.vala"
	_tmp58_ = exposure_trans;
#line 2576 "../src/editing_tools/EditingTools.vala"
	gtk_range_set_value (G_TYPE_CHECK_INSTANCE_CAST (_tmp57_, gtk_range_get_type (), GtkRange), (gdouble) exposure_transformation_get_parameter (_tmp58_));
#line 2579 "../src/editing_tools/EditingTools.vala"
	_tmp59_ = self->priv->transformations;
#line 2579 "../src/editing_tools/EditingTools.vala"
	_tmp60_ = pixel_transformation_bundle_get_transformation (_tmp59_, PIXEL_TRANSFORMATION_TYPE_CONTRAST);
#line 2579 "../src/editing_tools/EditingTools.vala"
	contrast_trans = G_TYPE_CHECK_INSTANCE_CAST (_tmp60_, TYPE_CONTRAST_TRANSFORMATION, ContrastTransformation);
#line 2581 "../src/editing_tools/EditingTools.vala"
	_tmp61_ = self->priv->histogram_transformer;
#line 2581 "../src/editing_tools/EditingTools.vala"
	_tmp62_ = contrast_trans;
#line 2581 "../src/editing_tools/EditingTools.vala"
	pixel_transformer_attach_transformation (_tmp61_, G_TYPE_CHECK_INSTANCE_CAST (_tmp62_, TYPE_PIXEL_TRANSFORMATION, PixelTransformation));
#line 2582 "../src/editing_tools/EditingTools.vala"
	_tmp63_ = self->priv->adjust_tool_window;
#line 2582 "../src/editing_tools/EditingTools.vala"
	_tmp64_ = _tmp63_->contrast_slider;
#line 2582 "../src/editing_tools/EditingTools.vala"
	_tmp65_ = contrast_trans;
#line 2582 "../src/editing_tools/EditingTools.vala"
	gtk_range_set_value (G_TYPE_CHECK_INSTANCE_CAST (_tmp64_, gtk_range_get_type (), GtkRange), (gdouble) contrast_transformation_get_parameter (_tmp65_));
#line 2584 "../src/editing_tools/EditingTools.vala"
	editing_tools_adjust_tool_bind_canvas_handlers (self, canvas);
#line 2585 "../src/editing_tools/EditingTools.vala"
	editing_tools_adjust_tool_bind_window_handlers (self);
#line 2587 "../src/editing_tools/EditingTools.vala"
	_tmp66_ = editing_tools_photo_canvas_get_scaled_pixbuf (canvas);
#line 2587 "../src/editing_tools/EditingTools.vala"
	_tmp67_ = _tmp66_;
#line 2587 "../src/editing_tools/EditingTools.vala"
	_tmp68_ = gdk_pixbuf_copy (_tmp67_);
#line 2587 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->priv->draw_to_pixbuf);
#line 2587 "../src/editing_tools/EditingTools.vala"
	self->priv->draw_to_pixbuf = _tmp68_;
#line 2587 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (_tmp67_);
#line 2588 "../src/editing_tools/EditingTools.vala"
	_tmp69_ = editing_tools_photo_canvas_get_scaled_pixbuf (canvas);
#line 2588 "../src/editing_tools/EditingTools.vala"
	_tmp70_ = _tmp69_;
#line 2588 "../src/editing_tools/EditingTools.vala"
	editing_tools_adjust_tool_init_fp_pixel_cache (self, _tmp70_);
#line 2588 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (_tmp70_);
#line 2594 "../src/editing_tools/EditingTools.vala"
	_tmp72_ = self->priv->draw_to_pixbuf;
#line 2594 "../src/editing_tools/EditingTools.vala"
	_tmp73_ = gdk_pixbuf_get_width (_tmp72_);
#line 2594 "../src/editing_tools/EditingTools.vala"
	_tmp74_ = _tmp73_;
#line 2594 "../src/editing_tools/EditingTools.vala"
	if (_tmp74_ == 1) {
#line 13715 "EditingTools.c"
		GdkPixbuf* _tmp75_;
		gint _tmp76_;
		gint _tmp77_;
#line 2594 "../src/editing_tools/EditingTools.vala"
		_tmp75_ = self->priv->draw_to_pixbuf;
#line 2594 "../src/editing_tools/EditingTools.vala"
		_tmp76_ = gdk_pixbuf_get_height (_tmp75_);
#line 2594 "../src/editing_tools/EditingTools.vala"
		_tmp77_ = _tmp76_;
#line 2594 "../src/editing_tools/EditingTools.vala"
		_tmp71_ = _tmp77_ == 1;
#line 13727 "EditingTools.c"
	} else {
#line 2594 "../src/editing_tools/EditingTools.vala"
		_tmp71_ = FALSE;
#line 13731 "EditingTools.c"
	}
#line 2594 "../src/editing_tools/EditingTools.vala"
	if (_tmp71_) {
#line 2595 "../src/editing_tools/EditingTools.vala"
		self->priv->disable_histogram_refresh = TRUE;
#line 13737 "EditingTools.c"
	}
#line 2600 "../src/editing_tools/EditingTools.vala"
	_tmp80_ = self->priv->draw_to_pixbuf;
#line 2600 "../src/editing_tools/EditingTools.vala"
	_tmp81_ = gdk_pixbuf_get_width (_tmp80_);
#line 2600 "../src/editing_tools/EditingTools.vala"
	_tmp82_ = _tmp81_;
#line 2600 "../src/editing_tools/EditingTools.vala"
	_tmp83_ = self->priv->draw_to_pixbuf;
#line 2600 "../src/editing_tools/EditingTools.vala"
	_tmp84_ = gdk_pixbuf_get_height (_tmp83_);
#line 2600 "../src/editing_tools/EditingTools.vala"
	_tmp85_ = _tmp84_;
#line 2600 "../src/editing_tools/EditingTools.vala"
	if ((_tmp82_ * _tmp85_) > 8192) {
#line 13753 "EditingTools.c"
		GdkPixbuf* _tmp86_;
		gint _tmp87_;
		gint _tmp88_;
#line 2600 "../src/editing_tools/EditingTools.vala"
		_tmp86_ = self->priv->draw_to_pixbuf;
#line 2600 "../src/editing_tools/EditingTools.vala"
		_tmp87_ = gdk_pixbuf_get_width (_tmp86_);
#line 2600 "../src/editing_tools/EditingTools.vala"
		_tmp88_ = _tmp87_;
#line 2600 "../src/editing_tools/EditingTools.vala"
		_tmp79_ = _tmp88_ > 1;
#line 13765 "EditingTools.c"
	} else {
#line 2600 "../src/editing_tools/EditingTools.vala"
		_tmp79_ = FALSE;
#line 13769 "EditingTools.c"
	}
#line 2600 "../src/editing_tools/EditingTools.vala"
	if (_tmp79_) {
#line 13773 "EditingTools.c"
		GdkPixbuf* _tmp89_;
		gint _tmp90_;
		gint _tmp91_;
#line 2601 "../src/editing_tools/EditingTools.vala"
		_tmp89_ = self->priv->draw_to_pixbuf;
#line 2601 "../src/editing_tools/EditingTools.vala"
		_tmp90_ = gdk_pixbuf_get_height (_tmp89_);
#line 2601 "../src/editing_tools/EditingTools.vala"
		_tmp91_ = _tmp90_;
#line 2601 "../src/editing_tools/EditingTools.vala"
		_tmp78_ = _tmp91_ > 1;
#line 13785 "EditingTools.c"
	} else {
#line 2600 "../src/editing_tools/EditingTools.vala"
		_tmp78_ = FALSE;
#line 13789 "EditingTools.c"
	}
#line 2600 "../src/editing_tools/EditingTools.vala"
	if (_tmp78_) {
#line 13793 "EditingTools.c"
		GdkPixbuf* _tmp92_;
		GdkPixbuf* _tmp93_;
		gint _tmp94_;
		gint _tmp95_;
		GdkPixbuf* _tmp96_;
		gint _tmp97_;
		gint _tmp98_;
		GdkPixbuf* _tmp99_;
#line 2602 "../src/editing_tools/EditingTools.vala"
		_tmp92_ = self->priv->draw_to_pixbuf;
#line 2602 "../src/editing_tools/EditingTools.vala"
		_tmp93_ = self->priv->draw_to_pixbuf;
#line 2602 "../src/editing_tools/EditingTools.vala"
		_tmp94_ = gdk_pixbuf_get_width (_tmp93_);
#line 2602 "../src/editing_tools/EditingTools.vala"
		_tmp95_ = _tmp94_;
#line 2602 "../src/editing_tools/EditingTools.vala"
		_tmp96_ = self->priv->draw_to_pixbuf;
#line 2602 "../src/editing_tools/EditingTools.vala"
		_tmp97_ = gdk_pixbuf_get_height (_tmp96_);
#line 2602 "../src/editing_tools/EditingTools.vala"
		_tmp98_ = _tmp97_;
#line 2602 "../src/editing_tools/EditingTools.vala"
		_tmp99_ = gdk_pixbuf_scale_simple (_tmp92_, _tmp95_ / 2, _tmp98_ / 2, GDK_INTERP_HYPER);
#line 2602 "../src/editing_tools/EditingTools.vala"
		_g_object_unref0 (self->priv->histogram_pixbuf);
#line 2602 "../src/editing_tools/EditingTools.vala"
		self->priv->histogram_pixbuf = _tmp99_;
#line 13822 "EditingTools.c"
	} else {
		GdkPixbuf* _tmp100_;
		GdkPixbuf* _tmp101_;
#line 2605 "../src/editing_tools/EditingTools.vala"
		_tmp100_ = self->priv->draw_to_pixbuf;
#line 2605 "../src/editing_tools/EditingTools.vala"
		_tmp101_ = gdk_pixbuf_copy (_tmp100_);
#line 2605 "../src/editing_tools/EditingTools.vala"
		_g_object_unref0 (self->priv->histogram_pixbuf);
#line 2605 "../src/editing_tools/EditingTools.vala"
		self->priv->histogram_pixbuf = _tmp101_;
#line 13834 "EditingTools.c"
	}
#line 2607 "../src/editing_tools/EditingTools.vala"
	_tmp102_ = self->priv->histogram_pixbuf;
#line 2607 "../src/editing_tools/EditingTools.vala"
	_tmp103_ = gdk_pixbuf_copy (_tmp102_);
#line 2607 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->priv->virgin_histogram_pixbuf);
#line 2607 "../src/editing_tools/EditingTools.vala"
	self->priv->virgin_histogram_pixbuf = _tmp103_;
#line 2609 "../src/editing_tools/EditingTools.vala"
	_tmp104_ = editing_tools_photo_canvas_get_photo (canvas);
#line 2609 "../src/editing_tools/EditingTools.vala"
	_tmp105_ = _tmp104_;
#line 2609 "../src/editing_tools/EditingTools.vala"
	_tmp106_ = data_object_get_membership (G_TYPE_CHECK_INSTANCE_CAST (_tmp105_, TYPE_DATA_OBJECT, DataObject));
#line 2609 "../src/editing_tools/EditingTools.vala"
	_tmp107_ = _tmp106_;
#line 2609 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (_tmp105_);
#line 2609 "../src/editing_tools/EditingTools.vala"
	owner = _tmp107_;
#line 2610 "../src/editing_tools/EditingTools.vala"
	_tmp108_ = owner;
#line 2610 "../src/editing_tools/EditingTools.vala"
	if (_tmp108_ != NULL) {
#line 13860 "EditingTools.c"
		DataCollection* _tmp109_;
#line 2611 "../src/editing_tools/EditingTools.vala"
		_tmp109_ = owner;
#line 2611 "../src/editing_tools/EditingTools.vala"
		g_signal_connect (_tmp109_, "items-altered", (GCallback) _editing_tools_adjust_tool_on_photos_altered_data_collection_items_altered, self);
#line 13866 "EditingTools.c"
	}
#line 2613 "../src/editing_tools/EditingTools.vala"
	EDITING_TOOLS_EDITING_TOOL_CLASS (editing_tools_adjust_tool_parent_class)->activate (G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool), canvas);
#line 2525 "../src/editing_tools/EditingTools.vala"
	_data_collection_unref0 (owner);
#line 2525 "../src/editing_tools/EditingTools.vala"
	_pixel_transformation_unref0 (contrast_trans);
#line 2525 "../src/editing_tools/EditingTools.vala"
	_pixel_transformation_unref0 (exposure_trans);
#line 2525 "../src/editing_tools/EditingTools.vala"
	_pixel_transformation_unref0 (sat_trans);
#line 2525 "../src/editing_tools/EditingTools.vala"
	_pixel_transformation_unref0 (tint_trans);
#line 2525 "../src/editing_tools/EditingTools.vala"
	_pixel_transformation_unref0 (temp_trans);
#line 2525 "../src/editing_tools/EditingTools.vala"
	_pixel_transformation_unref0 (highlights_trans);
#line 2525 "../src/editing_tools/EditingTools.vala"
	_pixel_transformation_unref0 (shadows_trans);
#line 2525 "../src/editing_tools/EditingTools.vala"
	_pixel_transformation_unref0 (expansion_trans);
#line 2525 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (photo);
#line 13890 "EditingTools.c"
}

static EditingToolsEditingToolWindow*
editing_tools_adjust_tool_real_get_tool_window (EditingToolsEditingTool* base)
{
	EditingToolsAdjustTool * self;
	EditingToolsAdjustToolAdjustToolWindow* _tmp0_;
	EditingToolsEditingToolWindow* _tmp1_;
	EditingToolsEditingToolWindow* result;
#line 2616 "../src/editing_tools/EditingTools.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, EDITING_TOOLS_TYPE_ADJUST_TOOL, EditingToolsAdjustTool);
#line 2617 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->adjust_tool_window;
#line 2617 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, EDITING_TOOLS_TYPE_EDITING_TOOL_WINDOW, EditingToolsEditingToolWindow));
#line 2617 "../src/editing_tools/EditingTools.vala"
	result = _tmp1_;
#line 2617 "../src/editing_tools/EditingTools.vala"
	return result;
#line 13910 "EditingTools.c"
}

static void
editing_tools_adjust_tool_real_deactivate (EditingToolsEditingTool* base)
{
	EditingToolsAdjustTool * self;
	EditingToolsPhotoCanvas* _tmp0_;
	EditingToolsAdjustToolAdjustToolWindow* _tmp10_;
#line 2620 "../src/editing_tools/EditingTools.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, EDITING_TOOLS_TYPE_ADJUST_TOOL, EditingToolsAdjustTool);
#line 2621 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 2621 "../src/editing_tools/EditingTools.vala"
	if (_tmp0_ != NULL) {
#line 13925 "EditingTools.c"
		DataCollection* owner = NULL;
		EditingToolsPhotoCanvas* _tmp1_;
		Photo* _tmp2_;
		Photo* _tmp3_;
		DataCollection* _tmp4_;
		DataCollection* _tmp5_;
		DataCollection* _tmp6_;
		EditingToolsPhotoCanvas* _tmp9_;
#line 2622 "../src/editing_tools/EditingTools.vala"
		_tmp1_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 2622 "../src/editing_tools/EditingTools.vala"
		_tmp2_ = editing_tools_photo_canvas_get_photo (_tmp1_);
#line 2622 "../src/editing_tools/EditingTools.vala"
		_tmp3_ = _tmp2_;
#line 2622 "../src/editing_tools/EditingTools.vala"
		_tmp4_ = data_object_get_membership (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_DATA_OBJECT, DataObject));
#line 2622 "../src/editing_tools/EditingTools.vala"
		_tmp5_ = _tmp4_;
#line 2622 "../src/editing_tools/EditingTools.vala"
		_g_object_unref0 (_tmp3_);
#line 2622 "../src/editing_tools/EditingTools.vala"
		owner = _tmp5_;
#line 2623 "../src/editing_tools/EditingTools.vala"
		_tmp6_ = owner;
#line 2623 "../src/editing_tools/EditingTools.vala"
		if (_tmp6_ != NULL) {
#line 13952 "EditingTools.c"
			DataCollection* _tmp7_;
			guint _tmp8_;
#line 2624 "../src/editing_tools/EditingTools.vala"
			_tmp7_ = owner;
#line 2624 "../src/editing_tools/EditingTools.vala"
			g_signal_parse_name ("items-altered", TYPE_DATA_COLLECTION, &_tmp8_, NULL, FALSE);
#line 2624 "../src/editing_tools/EditingTools.vala"
			g_signal_handlers_disconnect_matched (_tmp7_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp8_, 0, NULL, (GCallback) _editing_tools_adjust_tool_on_photos_altered_data_collection_items_altered, self);
#line 13961 "EditingTools.c"
		}
#line 2626 "../src/editing_tools/EditingTools.vala"
		_tmp9_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 2626 "../src/editing_tools/EditingTools.vala"
		editing_tools_adjust_tool_unbind_canvas_handlers (self, _tmp9_);
#line 2621 "../src/editing_tools/EditingTools.vala"
		_data_collection_unref0 (owner);
#line 13969 "EditingTools.c"
	}
#line 2629 "../src/editing_tools/EditingTools.vala"
	_tmp10_ = self->priv->adjust_tool_window;
#line 2629 "../src/editing_tools/EditingTools.vala"
	if (_tmp10_ != NULL) {
#line 13975 "EditingTools.c"
		EditingToolsAdjustToolAdjustToolWindow* _tmp11_;
		EditingToolsAdjustToolAdjustToolWindow* _tmp12_;
#line 2630 "../src/editing_tools/EditingTools.vala"
		editing_tools_adjust_tool_unbind_window_handlers (self);
#line 2631 "../src/editing_tools/EditingTools.vala"
		_tmp11_ = self->priv->adjust_tool_window;
#line 2631 "../src/editing_tools/EditingTools.vala"
		gtk_widget_hide (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, gtk_widget_get_type (), GtkWidget));
#line 2632 "../src/editing_tools/EditingTools.vala"
		_tmp12_ = self->priv->adjust_tool_window;
#line 2632 "../src/editing_tools/EditingTools.vala"
		gtk_widget_destroy (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, gtk_widget_get_type (), GtkWidget));
#line 2633 "../src/editing_tools/EditingTools.vala"
		_g_object_unref0 (self->priv->adjust_tool_window);
#line 2633 "../src/editing_tools/EditingTools.vala"
		self->priv->adjust_tool_window = NULL;
#line 13992 "EditingTools.c"
	}
#line 2636 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->priv->draw_to_pixbuf);
#line 2636 "../src/editing_tools/EditingTools.vala"
	self->priv->draw_to_pixbuf = NULL;
#line 2637 "../src/editing_tools/EditingTools.vala"
	self->priv->fp_pixel_cache = (g_free (self->priv->fp_pixel_cache), NULL);
#line 2637 "../src/editing_tools/EditingTools.vala"
	self->priv->fp_pixel_cache = NULL;
#line 2637 "../src/editing_tools/EditingTools.vala"
	self->priv->fp_pixel_cache_length1 = 0;
#line 2637 "../src/editing_tools/EditingTools.vala"
	self->priv->_fp_pixel_cache_size_ = self->priv->fp_pixel_cache_length1;
#line 2639 "../src/editing_tools/EditingTools.vala"
	EDITING_TOOLS_EDITING_TOOL_CLASS (editing_tools_adjust_tool_parent_class)->deactivate (G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool));
#line 14008 "EditingTools.c"
}

static void
editing_tools_adjust_tool_real_paint (EditingToolsEditingTool* base,
                                      cairo_t* ctx)
{
	EditingToolsAdjustTool * self;
	EditingToolsPhotoCanvas* _tmp8_;
	GdkPixbuf* _tmp9_;
#line 2642 "../src/editing_tools/EditingTools.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, EDITING_TOOLS_TYPE_ADJUST_TOOL, EditingToolsAdjustTool);
#line 2642 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (ctx != NULL);
#line 2643 "../src/editing_tools/EditingTools.vala"
	if (!self->priv->suppress_effect_redraw) {
#line 14024 "EditingTools.c"
		PixelTransformer* _tmp0_;
		GdkPixbuf* _tmp1_;
		PixelTransformer* _tmp2_;
		GdkPixbuf* _tmp3_;
		GdkPixbuf* _tmp4_;
#line 2644 "../src/editing_tools/EditingTools.vala"
		_tmp0_ = self->priv->transformer;
#line 2644 "../src/editing_tools/EditingTools.vala"
		_tmp1_ = self->priv->draw_to_pixbuf;
#line 2644 "../src/editing_tools/EditingTools.vala"
		pixel_transformer_transform_from_fp (_tmp0_, &self->priv->fp_pixel_cache, (gint*) (&self->priv->fp_pixel_cache_length1), _tmp1_);
#line 2644 "../src/editing_tools/EditingTools.vala"
		self->priv->_fp_pixel_cache_size_ = self->priv->fp_pixel_cache_length1;
#line 2645 "../src/editing_tools/EditingTools.vala"
		_tmp2_ = self->priv->histogram_transformer;
#line 2645 "../src/editing_tools/EditingTools.vala"
		_tmp3_ = self->priv->virgin_histogram_pixbuf;
#line 2645 "../src/editing_tools/EditingTools.vala"
		_tmp4_ = self->priv->histogram_pixbuf;
#line 2645 "../src/editing_tools/EditingTools.vala"
		pixel_transformer_transform_to_other_pixbuf (_tmp2_, _tmp3_, _tmp4_, NULL, -1);
#line 2647 "../src/editing_tools/EditingTools.vala"
		if (!self->priv->disable_histogram_refresh) {
#line 14048 "EditingTools.c"
			EditingToolsAdjustToolAdjustToolWindow* _tmp5_;
			RGBHistogramManipulator* _tmp6_;
			GdkPixbuf* _tmp7_;
#line 2648 "../src/editing_tools/EditingTools.vala"
			_tmp5_ = self->priv->adjust_tool_window;
#line 2648 "../src/editing_tools/EditingTools.vala"
			_tmp6_ = _tmp5_->histogram_manipulator;
#line 2648 "../src/editing_tools/EditingTools.vala"
			_tmp7_ = self->priv->histogram_pixbuf;
#line 2648 "../src/editing_tools/EditingTools.vala"
			rgb_histogram_manipulator_update_histogram (_tmp6_, _tmp7_);
#line 14060 "EditingTools.c"
		}
	}
#line 2651 "../src/editing_tools/EditingTools.vala"
	_tmp8_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 2651 "../src/editing_tools/EditingTools.vala"
	_tmp9_ = self->priv->draw_to_pixbuf;
#line 2651 "../src/editing_tools/EditingTools.vala"
	editing_tools_photo_canvas_paint_pixbuf (_tmp8_, _tmp9_);
#line 14069 "EditingTools.c"
}

static GdkPixbuf*
editing_tools_adjust_tool_real_get_display_pixbuf (EditingToolsEditingTool* base,
                                                   Scaling* scaling,
                                                   Photo* photo,
                                                   Dimensions* max_dim,
                                                   GError** error)
{
	EditingToolsAdjustTool * self;
	Dimensions _vala_max_dim = {0};
	Dimensions _tmp0_ = {0};
	GdkPixbuf* _tmp1_ = NULL;
	Scaling _tmp2_;
	GdkPixbuf* _tmp3_;
	GdkPixbuf* _tmp4_;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result;
#line 2654 "../src/editing_tools/EditingTools.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, EDITING_TOOLS_TYPE_ADJUST_TOOL, EditingToolsAdjustTool);
#line 2654 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (scaling != NULL, NULL);
#line 2654 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (IS_PHOTO (photo), NULL);
#line 2656 "../src/editing_tools/EditingTools.vala"
	if (!photo_has_color_adjustments (photo)) {
#line 2657 "../src/editing_tools/EditingTools.vala"
		dimensions_init (&_vala_max_dim, 0, 0);
#line 2659 "../src/editing_tools/EditingTools.vala"
		result = NULL;
#line 2659 "../src/editing_tools/EditingTools.vala"
		if (max_dim) {
#line 2659 "../src/editing_tools/EditingTools.vala"
			*max_dim = _vala_max_dim;
#line 14104 "EditingTools.c"
		}
#line 2659 "../src/editing_tools/EditingTools.vala"
		return result;
#line 14108 "EditingTools.c"
	}
#line 2662 "../src/editing_tools/EditingTools.vala"
	media_source_get_dimensions (G_TYPE_CHECK_INSTANCE_CAST (photo, TYPE_MEDIA_SOURCE, MediaSource), PHOTO_EXCEPTION_NONE, &_tmp0_);
#line 2662 "../src/editing_tools/EditingTools.vala"
	_vala_max_dim = _tmp0_;
#line 2664 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = *scaling;
#line 2664 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = photo_get_pixbuf_with_options (photo, &_tmp2_, PHOTO_EXCEPTION_ADJUST, BACKING_FETCH_MODE_BASELINE, &_inner_error0_);
#line 2664 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = _tmp3_;
#line 2664 "../src/editing_tools/EditingTools.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2664 "../src/editing_tools/EditingTools.vala"
		g_propagate_error (error, _inner_error0_);
#line 2664 "../src/editing_tools/EditingTools.vala"
		return NULL;
#line 14126 "EditingTools.c"
	}
#line 2664 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = _tmp1_;
#line 2664 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = NULL;
#line 2664 "../src/editing_tools/EditingTools.vala"
	result = _tmp4_;
#line 2664 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (_tmp1_);
#line 2664 "../src/editing_tools/EditingTools.vala"
	if (max_dim) {
#line 2664 "../src/editing_tools/EditingTools.vala"
		*max_dim = _vala_max_dim;
#line 14140 "EditingTools.c"
	}
#line 2664 "../src/editing_tools/EditingTools.vala"
	return result;
#line 14144 "EditingTools.c"
}

static void
editing_tools_adjust_tool_on_reset (EditingToolsAdjustTool* self)
{
	EditingToolsAdjustToolAdjustResetCommand* command = NULL;
	PixelTransformationBundle* _tmp0_;
	EditingToolsAdjustToolAdjustResetCommand* _tmp1_;
	CommandManager* _tmp2_;
	CommandManager* _tmp3_;
#line 2667 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_ADJUST_TOOL (self));
#line 2668 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->transformations;
#line 2668 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = editing_tools_adjust_tool_adjust_reset_command_new (self, _tmp0_);
#line 2668 "../src/editing_tools/EditingTools.vala"
	command = _tmp1_;
#line 2669 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = app_window_get_command_manager ();
#line 2669 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = _tmp2_;
#line 2669 "../src/editing_tools/EditingTools.vala"
	command_manager_execute (_tmp3_, G_TYPE_CHECK_INSTANCE_CAST (command, TYPE_COMMAND, Command));
#line 2669 "../src/editing_tools/EditingTools.vala"
	_command_manager_unref0 (_tmp3_);
#line 2667 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (command);
#line 14173 "EditingTools.c"
}

static void
editing_tools_adjust_tool_on_ok (EditingToolsAdjustTool* self)
{
	EditingToolsEditingToolWindow* _tmp0_;
	EditingToolsEditingToolWindow* _tmp1_;
	EditingToolsPhotoCanvas* _tmp2_;
	Photo* _tmp3_;
	Photo* _tmp4_;
	PixelTransformationBundle* _tmp5_;
	AdjustColorsSingleCommand* _tmp6_;
	AdjustColorsSingleCommand* _tmp7_;
	GdkPixbuf* _tmp8_;
	EditingToolsPhotoCanvas* _tmp9_;
	Photo* _tmp10_;
	Photo* _tmp11_;
	Dimensions _tmp12_ = {0};
#line 2672 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_ADJUST_TOOL (self));
#line 2673 "../src/editing_tools/EditingTools.vala"
	self->priv->suppress_effect_redraw = TRUE;
#line 2675 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = editing_tools_editing_tool_get_tool_window (G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool));
#line 2675 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = _tmp0_;
#line 2675 "../src/editing_tools/EditingTools.vala"
	gtk_widget_hide (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_widget_get_type (), GtkWidget));
#line 2675 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (_tmp1_);
#line 2677 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 2677 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = editing_tools_photo_canvas_get_photo (_tmp2_);
#line 2677 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = _tmp3_;
#line 2677 "../src/editing_tools/EditingTools.vala"
	_tmp5_ = self->priv->transformations;
#line 2677 "../src/editing_tools/EditingTools.vala"
	_tmp6_ = adjust_colors_single_command_new (_tmp4_, _tmp5_, RESOURCES_ADJUST_LABEL, RESOURCES_ADJUST_TOOLTIP);
#line 2677 "../src/editing_tools/EditingTools.vala"
	_tmp7_ = _tmp6_;
#line 2677 "../src/editing_tools/EditingTools.vala"
	_tmp8_ = self->priv->draw_to_pixbuf;
#line 2677 "../src/editing_tools/EditingTools.vala"
	_tmp9_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 2677 "../src/editing_tools/EditingTools.vala"
	_tmp10_ = editing_tools_photo_canvas_get_photo (_tmp9_);
#line 2677 "../src/editing_tools/EditingTools.vala"
	_tmp11_ = _tmp10_;
#line 2677 "../src/editing_tools/EditingTools.vala"
	media_source_get_dimensions (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, TYPE_MEDIA_SOURCE, MediaSource), PHOTO_EXCEPTION_NONE, &_tmp12_);
#line 2677 "../src/editing_tools/EditingTools.vala"
	g_signal_emit (G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool), editing_tools_editing_tool_signals[EDITING_TOOLS_EDITING_TOOL_APPLIED_SIGNAL], 0, G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_COMMAND, Command), _tmp8_, &_tmp12_, FALSE);
#line 2677 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (_tmp11_);
#line 2677 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (_tmp7_);
#line 2677 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (_tmp4_);
#line 14234 "EditingTools.c"
}

static void
editing_tools_adjust_tool_update_transformations (EditingToolsAdjustTool* self,
                                                  PixelTransformationBundle* new_transformations)
{
#line 2682 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_ADJUST_TOOL (self));
#line 2682 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (new_transformations, TYPE_PIXEL_TRANSFORMATION_BUNDLE));
#line 14245 "EditingTools.c"
	{
		GeeIterator* _transformation_it = NULL;
		GeeIterable* _tmp0_;
		GeeIterable* _tmp1_;
		GeeIterator* _tmp2_;
		GeeIterator* _tmp3_;
#line 2683 "../src/editing_tools/EditingTools.vala"
		_tmp0_ = pixel_transformation_bundle_get_transformations (new_transformations);
#line 2683 "../src/editing_tools/EditingTools.vala"
		_tmp1_ = _tmp0_;
#line 2683 "../src/editing_tools/EditingTools.vala"
		_tmp2_ = gee_iterable_iterator (_tmp1_);
#line 2683 "../src/editing_tools/EditingTools.vala"
		_tmp3_ = _tmp2_;
#line 2683 "../src/editing_tools/EditingTools.vala"
		_g_object_unref0 (_tmp1_);
#line 2683 "../src/editing_tools/EditingTools.vala"
		_transformation_it = _tmp3_;
#line 2683 "../src/editing_tools/EditingTools.vala"
		while (TRUE) {
#line 14266 "EditingTools.c"
			GeeIterator* _tmp4_;
			PixelTransformation* transformation = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			PixelTransformation* _tmp7_;
#line 2683 "../src/editing_tools/EditingTools.vala"
			_tmp4_ = _transformation_it;
#line 2683 "../src/editing_tools/EditingTools.vala"
			if (!gee_iterator_next (_tmp4_)) {
#line 2683 "../src/editing_tools/EditingTools.vala"
				break;
#line 14278 "EditingTools.c"
			}
#line 2683 "../src/editing_tools/EditingTools.vala"
			_tmp5_ = _transformation_it;
#line 2683 "../src/editing_tools/EditingTools.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 2683 "../src/editing_tools/EditingTools.vala"
			transformation = (PixelTransformation*) _tmp6_;
#line 2684 "../src/editing_tools/EditingTools.vala"
			_tmp7_ = transformation;
#line 2684 "../src/editing_tools/EditingTools.vala"
			editing_tools_adjust_tool_update_transformation (self, _tmp7_);
#line 2683 "../src/editing_tools/EditingTools.vala"
			_pixel_transformation_unref0 (transformation);
#line 14292 "EditingTools.c"
		}
#line 2683 "../src/editing_tools/EditingTools.vala"
		_g_object_unref0 (_transformation_it);
#line 14296 "EditingTools.c"
	}
}

static void
editing_tools_adjust_tool_update_transformation (EditingToolsAdjustTool* self,
                                                 PixelTransformation* new_transformation)
{
	PixelTransformation* old_transformation = NULL;
	PixelTransformationBundle* _tmp0_;
	PixelTransformation* _tmp1_;
	PixelTransformer* _tmp2_;
	PixelTransformation* _tmp3_;
	PixelTransformationBundle* _tmp6_;
#line 2687 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_ADJUST_TOOL (self));
#line 2687 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (new_transformation, TYPE_PIXEL_TRANSFORMATION));
#line 2688 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->transformations;
#line 2688 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = pixel_transformation_bundle_get_transformation (_tmp0_, pixel_transformation_get_transformation_type (new_transformation));
#line 2688 "../src/editing_tools/EditingTools.vala"
	old_transformation = _tmp1_;
#line 2691 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = self->priv->transformer;
#line 2691 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = old_transformation;
#line 2691 "../src/editing_tools/EditingTools.vala"
	pixel_transformer_replace_transformation (_tmp2_, _tmp3_, new_transformation);
#line 2692 "../src/editing_tools/EditingTools.vala"
	if (pixel_transformation_get_transformation_type (new_transformation) != PIXEL_TRANSFORMATION_TYPE_TONE_EXPANSION) {
#line 14328 "EditingTools.c"
		PixelTransformer* _tmp4_;
		PixelTransformation* _tmp5_;
#line 2693 "../src/editing_tools/EditingTools.vala"
		_tmp4_ = self->priv->histogram_transformer;
#line 2693 "../src/editing_tools/EditingTools.vala"
		_tmp5_ = old_transformation;
#line 2693 "../src/editing_tools/EditingTools.vala"
		pixel_transformer_replace_transformation (_tmp4_, _tmp5_, new_transformation);
#line 14337 "EditingTools.c"
	}
#line 2695 "../src/editing_tools/EditingTools.vala"
	_tmp6_ = self->priv->transformations;
#line 2695 "../src/editing_tools/EditingTools.vala"
	pixel_transformation_bundle_set (_tmp6_, new_transformation);
#line 2687 "../src/editing_tools/EditingTools.vala"
	_pixel_transformation_unref0 (old_transformation);
#line 14345 "EditingTools.c"
}

static void
editing_tools_adjust_tool_slider_updated (EditingToolsAdjustTool* self,
                                          PixelTransformation* new_transformation,
                                          const gchar* name)
{
	PixelTransformation* old_transformation = NULL;
	PixelTransformationBundle* _tmp0_;
	PixelTransformation* _tmp1_;
	EditingToolsAdjustToolSliderAdjustmentCommand* command = NULL;
	EditingToolsAdjustToolSliderAdjustmentCommand* _tmp2_;
	CommandManager* _tmp3_;
	CommandManager* _tmp4_;
#line 2698 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_ADJUST_TOOL (self));
#line 2698 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (new_transformation, TYPE_PIXEL_TRANSFORMATION));
#line 2698 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (name != NULL);
#line 2699 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->transformations;
#line 2699 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = pixel_transformation_bundle_get_transformation (_tmp0_, pixel_transformation_get_transformation_type (new_transformation));
#line 2699 "../src/editing_tools/EditingTools.vala"
	old_transformation = _tmp1_;
#line 2701 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = editing_tools_adjust_tool_slider_adjustment_command_new (self, old_transformation, new_transformation, name);
#line 2701 "../src/editing_tools/EditingTools.vala"
	command = _tmp2_;
#line 2703 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = app_window_get_command_manager ();
#line 2703 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = _tmp3_;
#line 2703 "../src/editing_tools/EditingTools.vala"
	command_manager_execute (_tmp4_, G_TYPE_CHECK_INSTANCE_CAST (command, TYPE_COMMAND, Command));
#line 2703 "../src/editing_tools/EditingTools.vala"
	_command_manager_unref0 (_tmp4_);
#line 2698 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (command);
#line 2698 "../src/editing_tools/EditingTools.vala"
	_pixel_transformation_unref0 (old_transformation);
#line 14388 "EditingTools.c"
}

static void
_editing_tools_adjust_tool_on_delayed_temperature_adjustment_one_shot_callback (gpointer self)
{
#line 2708 "../src/editing_tools/EditingTools.vala"
	editing_tools_adjust_tool_on_delayed_temperature_adjustment ((EditingToolsAdjustTool*) self);
#line 14396 "EditingTools.c"
}

static void
editing_tools_adjust_tool_on_temperature_adjustment (EditingToolsAdjustTool* self)
{
	OneShotScheduler* _tmp0_;
	OneShotScheduler* _tmp2_;
#line 2706 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_ADJUST_TOOL (self));
#line 2707 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->temperature_scheduler;
#line 2707 "../src/editing_tools/EditingTools.vala"
	if (_tmp0_ == NULL) {
#line 14410 "EditingTools.c"
		OneShotScheduler* _tmp1_;
#line 2708 "../src/editing_tools/EditingTools.vala"
		_tmp1_ = one_shot_scheduler_new ("temperature", _editing_tools_adjust_tool_on_delayed_temperature_adjustment_one_shot_callback, self);
#line 2708 "../src/editing_tools/EditingTools.vala"
		_one_shot_scheduler_unref0 (self->priv->temperature_scheduler);
#line 2708 "../src/editing_tools/EditingTools.vala"
		self->priv->temperature_scheduler = _tmp1_;
#line 14418 "EditingTools.c"
	}
#line 2710 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = self->priv->temperature_scheduler;
#line 2710 "../src/editing_tools/EditingTools.vala"
	one_shot_scheduler_after_timeout (_tmp2_, EDITING_TOOLS_ADJUST_TOOL_SLIDER_DELAY_MSEC, TRUE);
#line 14424 "EditingTools.c"
}

static void
editing_tools_adjust_tool_on_delayed_temperature_adjustment (EditingToolsAdjustTool* self)
{
	TemperatureTransformation* new_temp_trans = NULL;
	EditingToolsAdjustToolAdjustToolWindow* _tmp0_;
	GtkScale* _tmp1_;
	TemperatureTransformation* _tmp2_;
#line 2713 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_ADJUST_TOOL (self));
#line 2714 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->adjust_tool_window;
#line 2714 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = _tmp0_->temperature_slider;
#line 2714 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = temperature_transformation_new ((gfloat) gtk_range_get_value (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_range_get_type (), GtkRange)));
#line 2714 "../src/editing_tools/EditingTools.vala"
	new_temp_trans = _tmp2_;
#line 2716 "../src/editing_tools/EditingTools.vala"
	editing_tools_adjust_tool_slider_updated (self, G_TYPE_CHECK_INSTANCE_CAST (new_temp_trans, TYPE_PIXEL_TRANSFORMATION, PixelTransformation), _ ("Temperature"));
#line 2713 "../src/editing_tools/EditingTools.vala"
	_pixel_transformation_unref0 (new_temp_trans);
#line 14448 "EditingTools.c"
}

static void
_editing_tools_adjust_tool_on_delayed_tint_adjustment_one_shot_callback (gpointer self)
{
#line 2721 "../src/editing_tools/EditingTools.vala"
	editing_tools_adjust_tool_on_delayed_tint_adjustment ((EditingToolsAdjustTool*) self);
#line 14456 "EditingTools.c"
}

static void
editing_tools_adjust_tool_on_tint_adjustment (EditingToolsAdjustTool* self)
{
	OneShotScheduler* _tmp0_;
	OneShotScheduler* _tmp2_;
#line 2719 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_ADJUST_TOOL (self));
#line 2720 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->tint_scheduler;
#line 2720 "../src/editing_tools/EditingTools.vala"
	if (_tmp0_ == NULL) {
#line 14470 "EditingTools.c"
		OneShotScheduler* _tmp1_;
#line 2721 "../src/editing_tools/EditingTools.vala"
		_tmp1_ = one_shot_scheduler_new ("tint", _editing_tools_adjust_tool_on_delayed_tint_adjustment_one_shot_callback, self);
#line 2721 "../src/editing_tools/EditingTools.vala"
		_one_shot_scheduler_unref0 (self->priv->tint_scheduler);
#line 2721 "../src/editing_tools/EditingTools.vala"
		self->priv->tint_scheduler = _tmp1_;
#line 14478 "EditingTools.c"
	}
#line 2722 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = self->priv->tint_scheduler;
#line 2722 "../src/editing_tools/EditingTools.vala"
	one_shot_scheduler_after_timeout (_tmp2_, EDITING_TOOLS_ADJUST_TOOL_SLIDER_DELAY_MSEC, TRUE);
#line 14484 "EditingTools.c"
}

static void
editing_tools_adjust_tool_on_delayed_tint_adjustment (EditingToolsAdjustTool* self)
{
	TintTransformation* new_tint_trans = NULL;
	EditingToolsAdjustToolAdjustToolWindow* _tmp0_;
	GtkScale* _tmp1_;
	TintTransformation* _tmp2_;
#line 2725 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_ADJUST_TOOL (self));
#line 2726 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->adjust_tool_window;
#line 2726 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = _tmp0_->tint_slider;
#line 2726 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = tint_transformation_new ((gfloat) gtk_range_get_value (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_range_get_type (), GtkRange)));
#line 2726 "../src/editing_tools/EditingTools.vala"
	new_tint_trans = _tmp2_;
#line 2728 "../src/editing_tools/EditingTools.vala"
	editing_tools_adjust_tool_slider_updated (self, G_TYPE_CHECK_INSTANCE_CAST (new_tint_trans, TYPE_PIXEL_TRANSFORMATION, PixelTransformation), _ ("Tint"));
#line 2725 "../src/editing_tools/EditingTools.vala"
	_pixel_transformation_unref0 (new_tint_trans);
#line 14508 "EditingTools.c"
}

static void
_editing_tools_adjust_tool_on_delayed_contrast_adjustment_one_shot_callback (gpointer self)
{
#line 2733 "../src/editing_tools/EditingTools.vala"
	editing_tools_adjust_tool_on_delayed_contrast_adjustment ((EditingToolsAdjustTool*) self);
#line 14516 "EditingTools.c"
}

static void
editing_tools_adjust_tool_on_contrast_adjustment (EditingToolsAdjustTool* self)
{
	OneShotScheduler* _tmp0_;
	OneShotScheduler* _tmp2_;
#line 2731 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_ADJUST_TOOL (self));
#line 2732 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->contrast_scheduler;
#line 2732 "../src/editing_tools/EditingTools.vala"
	if (_tmp0_ == NULL) {
#line 14530 "EditingTools.c"
		OneShotScheduler* _tmp1_;
#line 2733 "../src/editing_tools/EditingTools.vala"
		_tmp1_ = one_shot_scheduler_new ("contrast", _editing_tools_adjust_tool_on_delayed_contrast_adjustment_one_shot_callback, self);
#line 2733 "../src/editing_tools/EditingTools.vala"
		_one_shot_scheduler_unref0 (self->priv->contrast_scheduler);
#line 2733 "../src/editing_tools/EditingTools.vala"
		self->priv->contrast_scheduler = _tmp1_;
#line 14538 "EditingTools.c"
	}
#line 2734 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = self->priv->contrast_scheduler;
#line 2734 "../src/editing_tools/EditingTools.vala"
	one_shot_scheduler_after_timeout (_tmp2_, EDITING_TOOLS_ADJUST_TOOL_SLIDER_DELAY_MSEC, TRUE);
#line 14544 "EditingTools.c"
}

static void
editing_tools_adjust_tool_on_delayed_contrast_adjustment (EditingToolsAdjustTool* self)
{
	ContrastTransformation* new_exp_trans = NULL;
	EditingToolsAdjustToolAdjustToolWindow* _tmp0_;
	GtkScale* _tmp1_;
	ContrastTransformation* _tmp2_;
#line 2737 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_ADJUST_TOOL (self));
#line 2738 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->adjust_tool_window;
#line 2738 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = _tmp0_->contrast_slider;
#line 2738 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = contrast_transformation_new ((gfloat) gtk_range_get_value (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_range_get_type (), GtkRange)));
#line 2738 "../src/editing_tools/EditingTools.vala"
	new_exp_trans = _tmp2_;
#line 2740 "../src/editing_tools/EditingTools.vala"
	editing_tools_adjust_tool_slider_updated (self, G_TYPE_CHECK_INSTANCE_CAST (new_exp_trans, TYPE_PIXEL_TRANSFORMATION, PixelTransformation), _ ("Contrast"));
#line 2737 "../src/editing_tools/EditingTools.vala"
	_pixel_transformation_unref0 (new_exp_trans);
#line 14568 "EditingTools.c"
}

static void
_editing_tools_adjust_tool_on_delayed_saturation_adjustment_one_shot_callback (gpointer self)
{
#line 2746 "../src/editing_tools/EditingTools.vala"
	editing_tools_adjust_tool_on_delayed_saturation_adjustment ((EditingToolsAdjustTool*) self);
#line 14576 "EditingTools.c"
}

static void
editing_tools_adjust_tool_on_saturation_adjustment (EditingToolsAdjustTool* self)
{
	OneShotScheduler* _tmp0_;
	OneShotScheduler* _tmp2_;
#line 2744 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_ADJUST_TOOL (self));
#line 2745 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->saturation_scheduler;
#line 2745 "../src/editing_tools/EditingTools.vala"
	if (_tmp0_ == NULL) {
#line 14590 "EditingTools.c"
		OneShotScheduler* _tmp1_;
#line 2746 "../src/editing_tools/EditingTools.vala"
		_tmp1_ = one_shot_scheduler_new ("saturation", _editing_tools_adjust_tool_on_delayed_saturation_adjustment_one_shot_callback, self);
#line 2746 "../src/editing_tools/EditingTools.vala"
		_one_shot_scheduler_unref0 (self->priv->saturation_scheduler);
#line 2746 "../src/editing_tools/EditingTools.vala"
		self->priv->saturation_scheduler = _tmp1_;
#line 14598 "EditingTools.c"
	}
#line 2748 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = self->priv->saturation_scheduler;
#line 2748 "../src/editing_tools/EditingTools.vala"
	one_shot_scheduler_after_timeout (_tmp2_, EDITING_TOOLS_ADJUST_TOOL_SLIDER_DELAY_MSEC, TRUE);
#line 14604 "EditingTools.c"
}

static void
editing_tools_adjust_tool_on_delayed_saturation_adjustment (EditingToolsAdjustTool* self)
{
	SaturationTransformation* new_sat_trans = NULL;
	EditingToolsAdjustToolAdjustToolWindow* _tmp0_;
	GtkScale* _tmp1_;
	SaturationTransformation* _tmp2_;
#line 2751 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_ADJUST_TOOL (self));
#line 2752 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->adjust_tool_window;
#line 2752 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = _tmp0_->saturation_slider;
#line 2752 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = saturation_transformation_new ((gfloat) gtk_range_get_value (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_range_get_type (), GtkRange)));
#line 2752 "../src/editing_tools/EditingTools.vala"
	new_sat_trans = _tmp2_;
#line 2754 "../src/editing_tools/EditingTools.vala"
	editing_tools_adjust_tool_slider_updated (self, G_TYPE_CHECK_INSTANCE_CAST (new_sat_trans, TYPE_PIXEL_TRANSFORMATION, PixelTransformation), _ ("Saturation"));
#line 2751 "../src/editing_tools/EditingTools.vala"
	_pixel_transformation_unref0 (new_sat_trans);
#line 14628 "EditingTools.c"
}

static void
_editing_tools_adjust_tool_on_delayed_exposure_adjustment_one_shot_callback (gpointer self)
{
#line 2759 "../src/editing_tools/EditingTools.vala"
	editing_tools_adjust_tool_on_delayed_exposure_adjustment ((EditingToolsAdjustTool*) self);
#line 14636 "EditingTools.c"
}

static void
editing_tools_adjust_tool_on_exposure_adjustment (EditingToolsAdjustTool* self)
{
	OneShotScheduler* _tmp0_;
	OneShotScheduler* _tmp2_;
#line 2757 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_ADJUST_TOOL (self));
#line 2758 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->exposure_scheduler;
#line 2758 "../src/editing_tools/EditingTools.vala"
	if (_tmp0_ == NULL) {
#line 14650 "EditingTools.c"
		OneShotScheduler* _tmp1_;
#line 2759 "../src/editing_tools/EditingTools.vala"
		_tmp1_ = one_shot_scheduler_new ("exposure", _editing_tools_adjust_tool_on_delayed_exposure_adjustment_one_shot_callback, self);
#line 2759 "../src/editing_tools/EditingTools.vala"
		_one_shot_scheduler_unref0 (self->priv->exposure_scheduler);
#line 2759 "../src/editing_tools/EditingTools.vala"
		self->priv->exposure_scheduler = _tmp1_;
#line 14658 "EditingTools.c"
	}
#line 2761 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = self->priv->exposure_scheduler;
#line 2761 "../src/editing_tools/EditingTools.vala"
	one_shot_scheduler_after_timeout (_tmp2_, EDITING_TOOLS_ADJUST_TOOL_SLIDER_DELAY_MSEC, TRUE);
#line 14664 "EditingTools.c"
}

static void
editing_tools_adjust_tool_on_delayed_exposure_adjustment (EditingToolsAdjustTool* self)
{
	ExposureTransformation* new_exp_trans = NULL;
	EditingToolsAdjustToolAdjustToolWindow* _tmp0_;
	GtkScale* _tmp1_;
	ExposureTransformation* _tmp2_;
#line 2764 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_ADJUST_TOOL (self));
#line 2765 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->adjust_tool_window;
#line 2765 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = _tmp0_->exposure_slider;
#line 2765 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = exposure_transformation_new ((gfloat) gtk_range_get_value (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_range_get_type (), GtkRange)));
#line 2765 "../src/editing_tools/EditingTools.vala"
	new_exp_trans = _tmp2_;
#line 2767 "../src/editing_tools/EditingTools.vala"
	editing_tools_adjust_tool_slider_updated (self, G_TYPE_CHECK_INSTANCE_CAST (new_exp_trans, TYPE_PIXEL_TRANSFORMATION, PixelTransformation), _ ("Exposure"));
#line 2764 "../src/editing_tools/EditingTools.vala"
	_pixel_transformation_unref0 (new_exp_trans);
#line 14688 "EditingTools.c"
}

static void
_editing_tools_adjust_tool_on_delayed_shadows_adjustment_one_shot_callback (gpointer self)
{
#line 2772 "../src/editing_tools/EditingTools.vala"
	editing_tools_adjust_tool_on_delayed_shadows_adjustment ((EditingToolsAdjustTool*) self);
#line 14696 "EditingTools.c"
}

static void
editing_tools_adjust_tool_on_shadows_adjustment (EditingToolsAdjustTool* self)
{
	OneShotScheduler* _tmp0_;
	OneShotScheduler* _tmp2_;
#line 2770 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_ADJUST_TOOL (self));
#line 2771 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->shadows_scheduler;
#line 2771 "../src/editing_tools/EditingTools.vala"
	if (_tmp0_ == NULL) {
#line 14710 "EditingTools.c"
		OneShotScheduler* _tmp1_;
#line 2772 "../src/editing_tools/EditingTools.vala"
		_tmp1_ = one_shot_scheduler_new ("shadows", _editing_tools_adjust_tool_on_delayed_shadows_adjustment_one_shot_callback, self);
#line 2772 "../src/editing_tools/EditingTools.vala"
		_one_shot_scheduler_unref0 (self->priv->shadows_scheduler);
#line 2772 "../src/editing_tools/EditingTools.vala"
		self->priv->shadows_scheduler = _tmp1_;
#line 14718 "EditingTools.c"
	}
#line 2774 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = self->priv->shadows_scheduler;
#line 2774 "../src/editing_tools/EditingTools.vala"
	one_shot_scheduler_after_timeout (_tmp2_, EDITING_TOOLS_ADJUST_TOOL_SLIDER_DELAY_MSEC, TRUE);
#line 14724 "EditingTools.c"
}

static void
editing_tools_adjust_tool_on_delayed_shadows_adjustment (EditingToolsAdjustTool* self)
{
	ShadowDetailTransformation* new_shadows_trans = NULL;
	EditingToolsAdjustToolAdjustToolWindow* _tmp0_;
	GtkScale* _tmp1_;
	ShadowDetailTransformation* _tmp2_;
#line 2777 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_ADJUST_TOOL (self));
#line 2778 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->adjust_tool_window;
#line 2778 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = _tmp0_->shadows_slider;
#line 2778 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = shadow_detail_transformation_new ((gfloat) gtk_range_get_value (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_range_get_type (), GtkRange)));
#line 2778 "../src/editing_tools/EditingTools.vala"
	new_shadows_trans = _tmp2_;
#line 2780 "../src/editing_tools/EditingTools.vala"
	editing_tools_adjust_tool_slider_updated (self, G_TYPE_CHECK_INSTANCE_CAST (new_shadows_trans, TYPE_PIXEL_TRANSFORMATION, PixelTransformation), _ ("Shadows"));
#line 2777 "../src/editing_tools/EditingTools.vala"
	_pixel_transformation_unref0 (new_shadows_trans);
#line 14748 "EditingTools.c"
}

static void
_editing_tools_adjust_tool_on_delayed_highlights_adjustment_one_shot_callback (gpointer self)
{
#line 2785 "../src/editing_tools/EditingTools.vala"
	editing_tools_adjust_tool_on_delayed_highlights_adjustment ((EditingToolsAdjustTool*) self);
#line 14756 "EditingTools.c"
}

static void
editing_tools_adjust_tool_on_highlights_adjustment (EditingToolsAdjustTool* self)
{
	OneShotScheduler* _tmp0_;
	OneShotScheduler* _tmp2_;
#line 2783 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_ADJUST_TOOL (self));
#line 2784 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->highlights_scheduler;
#line 2784 "../src/editing_tools/EditingTools.vala"
	if (_tmp0_ == NULL) {
#line 14770 "EditingTools.c"
		OneShotScheduler* _tmp1_;
#line 2785 "../src/editing_tools/EditingTools.vala"
		_tmp1_ = one_shot_scheduler_new ("highlights", _editing_tools_adjust_tool_on_delayed_highlights_adjustment_one_shot_callback, self);
#line 2785 "../src/editing_tools/EditingTools.vala"
		_one_shot_scheduler_unref0 (self->priv->highlights_scheduler);
#line 2785 "../src/editing_tools/EditingTools.vala"
		self->priv->highlights_scheduler = _tmp1_;
#line 14778 "EditingTools.c"
	}
#line 2787 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = self->priv->highlights_scheduler;
#line 2787 "../src/editing_tools/EditingTools.vala"
	one_shot_scheduler_after_timeout (_tmp2_, EDITING_TOOLS_ADJUST_TOOL_SLIDER_DELAY_MSEC, TRUE);
#line 14784 "EditingTools.c"
}

static void
editing_tools_adjust_tool_on_delayed_highlights_adjustment (EditingToolsAdjustTool* self)
{
	HighlightDetailTransformation* new_highlights_trans = NULL;
	EditingToolsAdjustToolAdjustToolWindow* _tmp0_;
	GtkScale* _tmp1_;
	HighlightDetailTransformation* _tmp2_;
#line 2790 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_ADJUST_TOOL (self));
#line 2791 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->adjust_tool_window;
#line 2791 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = _tmp0_->highlights_slider;
#line 2791 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = highlight_detail_transformation_new ((gfloat) gtk_range_get_value (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_range_get_type (), GtkRange)));
#line 2791 "../src/editing_tools/EditingTools.vala"
	new_highlights_trans = _tmp2_;
#line 2793 "../src/editing_tools/EditingTools.vala"
	editing_tools_adjust_tool_slider_updated (self, G_TYPE_CHECK_INSTANCE_CAST (new_highlights_trans, TYPE_PIXEL_TRANSFORMATION, PixelTransformation), _ ("Highlights"));
#line 2790 "../src/editing_tools/EditingTools.vala"
	_pixel_transformation_unref0 (new_highlights_trans);
#line 14808 "EditingTools.c"
}

static void
editing_tools_adjust_tool_on_histogram_constraint (EditingToolsAdjustTool* self)
{
	gint expansion_black_point = 0;
	EditingToolsAdjustToolAdjustToolWindow* _tmp0_;
	RGBHistogramManipulator* _tmp1_;
	gint expansion_white_point = 0;
	EditingToolsAdjustToolAdjustToolWindow* _tmp2_;
	RGBHistogramManipulator* _tmp3_;
	ExpansionTransformation* new_exp_trans = NULL;
	ExpansionTransformation* _tmp4_;
#line 2796 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_ADJUST_TOOL (self));
#line 2797 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->adjust_tool_window;
#line 2797 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = _tmp0_->histogram_manipulator;
#line 2797 "../src/editing_tools/EditingTools.vala"
	expansion_black_point = rgb_histogram_manipulator_get_left_nub_position (_tmp1_);
#line 2799 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = self->priv->adjust_tool_window;
#line 2799 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = _tmp2_->histogram_manipulator;
#line 2799 "../src/editing_tools/EditingTools.vala"
	expansion_white_point = rgb_histogram_manipulator_get_right_nub_position (_tmp3_);
#line 2801 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = expansion_transformation_new_from_extrema (expansion_black_point, expansion_white_point);
#line 2801 "../src/editing_tools/EditingTools.vala"
	new_exp_trans = _tmp4_;
#line 2803 "../src/editing_tools/EditingTools.vala"
	editing_tools_adjust_tool_slider_updated (self, G_TYPE_CHECK_INSTANCE_CAST (new_exp_trans, TYPE_PIXEL_TRANSFORMATION, PixelTransformation), _ ("Contrast Expansion"));
#line 2796 "../src/editing_tools/EditingTools.vala"
	_pixel_transformation_unref0 (new_exp_trans);
#line 14844 "EditingTools.c"
}

static void
editing_tools_adjust_tool_on_canvas_resize (EditingToolsAdjustTool* self)
{
	EditingToolsPhotoCanvas* _tmp0_;
	GdkPixbuf* _tmp1_;
	GdkPixbuf* _tmp2_;
	GdkPixbuf* _tmp3_;
	EditingToolsPhotoCanvas* _tmp4_;
	GdkPixbuf* _tmp5_;
	GdkPixbuf* _tmp6_;
#line 2806 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_ADJUST_TOOL (self));
#line 2807 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 2807 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = editing_tools_photo_canvas_get_scaled_pixbuf (_tmp0_);
#line 2807 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = _tmp1_;
#line 2807 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = gdk_pixbuf_copy (_tmp2_);
#line 2807 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->priv->draw_to_pixbuf);
#line 2807 "../src/editing_tools/EditingTools.vala"
	self->priv->draw_to_pixbuf = _tmp3_;
#line 2807 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (_tmp2_);
#line 2808 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 2808 "../src/editing_tools/EditingTools.vala"
	_tmp5_ = editing_tools_photo_canvas_get_scaled_pixbuf (_tmp4_);
#line 2808 "../src/editing_tools/EditingTools.vala"
	_tmp6_ = _tmp5_;
#line 2808 "../src/editing_tools/EditingTools.vala"
	editing_tools_adjust_tool_init_fp_pixel_cache (self, _tmp6_);
#line 2808 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (_tmp6_);
#line 14883 "EditingTools.c"
}

static gboolean
editing_tools_adjust_tool_on_hscale_reset (EditingToolsAdjustTool* self,
                                           GtkWidget* widget,
                                           GdkEventButton* event)
{
	GtkScale* source = NULL;
	GtkScale* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean result;
#line 2811 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (EDITING_TOOLS_IS_ADJUST_TOOL (self), FALSE);
#line 2811 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (widget, gtk_widget_get_type ()), FALSE);
#line 2811 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 2812 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (widget, gtk_scale_get_type (), GtkScale));
#line 2812 "../src/editing_tools/EditingTools.vala"
	source = _tmp0_;
#line 2814 "../src/editing_tools/EditingTools.vala"
	if (event->button == ((guint) 1)) {
#line 2814 "../src/editing_tools/EditingTools.vala"
		_tmp2_ = event->type == GDK_BUTTON_PRESS;
#line 14910 "EditingTools.c"
	} else {
#line 2814 "../src/editing_tools/EditingTools.vala"
		_tmp2_ = FALSE;
#line 14914 "EditingTools.c"
	}
#line 2814 "../src/editing_tools/EditingTools.vala"
	if (_tmp2_) {
#line 2815 "../src/editing_tools/EditingTools.vala"
		_tmp1_ = has_only_key_modifier (event->state, GDK_CONTROL_MASK);
#line 14920 "EditingTools.c"
	} else {
#line 2814 "../src/editing_tools/EditingTools.vala"
		_tmp1_ = FALSE;
#line 14924 "EditingTools.c"
	}
#line 2814 "../src/editing_tools/EditingTools.vala"
	if (_tmp1_) {
#line 14928 "EditingTools.c"
		GtkScale* _tmp3_;
#line 2817 "../src/editing_tools/EditingTools.vala"
		_tmp3_ = source;
#line 2817 "../src/editing_tools/EditingTools.vala"
		gtk_range_set_value (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_range_get_type (), GtkRange), (gdouble) 0);
#line 2819 "../src/editing_tools/EditingTools.vala"
		result = TRUE;
#line 2819 "../src/editing_tools/EditingTools.vala"
		_g_object_unref0 (source);
#line 2819 "../src/editing_tools/EditingTools.vala"
		return result;
#line 14940 "EditingTools.c"
	}
#line 2822 "../src/editing_tools/EditingTools.vala"
	result = FALSE;
#line 2822 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (source);
#line 2822 "../src/editing_tools/EditingTools.vala"
	return result;
#line 14948 "EditingTools.c"
}

static void
_editing_tools_adjust_tool_on_canvas_resize_editing_tools_photo_canvas_resized_scaled_pixbuf (EditingToolsPhotoCanvas* _sender,
                                                                                              Dimensions* old_dim,
                                                                                              GdkPixbuf* scaled,
                                                                                              GdkRectangle* scaled_position,
                                                                                              gpointer self)
{
#line 2826 "../src/editing_tools/EditingTools.vala"
	editing_tools_adjust_tool_on_canvas_resize ((EditingToolsAdjustTool*) self);
#line 14960 "EditingTools.c"
}

static void
editing_tools_adjust_tool_bind_canvas_handlers (EditingToolsAdjustTool* self,
                                                EditingToolsPhotoCanvas* canvas)
{
#line 2825 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_ADJUST_TOOL (self));
#line 2825 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_PHOTO_CANVAS (canvas));
#line 2826 "../src/editing_tools/EditingTools.vala"
	g_signal_connect (canvas, "resized-scaled-pixbuf", (GCallback) _editing_tools_adjust_tool_on_canvas_resize_editing_tools_photo_canvas_resized_scaled_pixbuf, self);
#line 14973 "EditingTools.c"
}

static void
editing_tools_adjust_tool_unbind_canvas_handlers (EditingToolsAdjustTool* self,
                                                  EditingToolsPhotoCanvas* canvas)
{
	guint _tmp0_;
#line 2829 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_ADJUST_TOOL (self));
#line 2829 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_PHOTO_CANVAS (canvas));
#line 2830 "../src/editing_tools/EditingTools.vala"
	g_signal_parse_name ("resized-scaled-pixbuf", EDITING_TOOLS_TYPE_PHOTO_CANVAS, &_tmp0_, NULL, FALSE);
#line 2830 "../src/editing_tools/EditingTools.vala"
	g_signal_handlers_disconnect_matched (canvas, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _editing_tools_adjust_tool_on_canvas_resize_editing_tools_photo_canvas_resized_scaled_pixbuf, self);
#line 14989 "EditingTools.c"
}

static void
_editing_tools_adjust_tool_on_ok_gtk_button_clicked (GtkButton* _sender,
                                                     gpointer self)
{
#line 2834 "../src/editing_tools/EditingTools.vala"
	editing_tools_adjust_tool_on_ok ((EditingToolsAdjustTool*) self);
#line 14998 "EditingTools.c"
}

static void
_editing_tools_adjust_tool_on_reset_gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self)
{
#line 2835 "../src/editing_tools/EditingTools.vala"
	editing_tools_adjust_tool_on_reset ((EditingToolsAdjustTool*) self);
#line 15007 "EditingTools.c"
}

static void
_editing_tools_adjust_tool_on_exposure_adjustment_gtk_range_value_changed (GtkRange* _sender,
                                                                           gpointer self)
{
#line 2837 "../src/editing_tools/EditingTools.vala"
	editing_tools_adjust_tool_on_exposure_adjustment ((EditingToolsAdjustTool*) self);
#line 15016 "EditingTools.c"
}

static void
_editing_tools_adjust_tool_on_contrast_adjustment_gtk_range_value_changed (GtkRange* _sender,
                                                                           gpointer self)
{
#line 2838 "../src/editing_tools/EditingTools.vala"
	editing_tools_adjust_tool_on_contrast_adjustment ((EditingToolsAdjustTool*) self);
#line 15025 "EditingTools.c"
}

static void
_editing_tools_adjust_tool_on_saturation_adjustment_gtk_range_value_changed (GtkRange* _sender,
                                                                             gpointer self)
{
#line 2839 "../src/editing_tools/EditingTools.vala"
	editing_tools_adjust_tool_on_saturation_adjustment ((EditingToolsAdjustTool*) self);
#line 15034 "EditingTools.c"
}

static void
_editing_tools_adjust_tool_on_tint_adjustment_gtk_range_value_changed (GtkRange* _sender,
                                                                       gpointer self)
{
#line 2840 "../src/editing_tools/EditingTools.vala"
	editing_tools_adjust_tool_on_tint_adjustment ((EditingToolsAdjustTool*) self);
#line 15043 "EditingTools.c"
}

static void
_editing_tools_adjust_tool_on_temperature_adjustment_gtk_range_value_changed (GtkRange* _sender,
                                                                              gpointer self)
{
#line 2841 "../src/editing_tools/EditingTools.vala"
	editing_tools_adjust_tool_on_temperature_adjustment ((EditingToolsAdjustTool*) self);
#line 15052 "EditingTools.c"
}

static void
_editing_tools_adjust_tool_on_shadows_adjustment_gtk_range_value_changed (GtkRange* _sender,
                                                                          gpointer self)
{
#line 2842 "../src/editing_tools/EditingTools.vala"
	editing_tools_adjust_tool_on_shadows_adjustment ((EditingToolsAdjustTool*) self);
#line 15061 "EditingTools.c"
}

static void
_editing_tools_adjust_tool_on_highlights_adjustment_gtk_range_value_changed (GtkRange* _sender,
                                                                             gpointer self)
{
#line 2843 "../src/editing_tools/EditingTools.vala"
	editing_tools_adjust_tool_on_highlights_adjustment ((EditingToolsAdjustTool*) self);
#line 15070 "EditingTools.c"
}

static void
_editing_tools_adjust_tool_on_histogram_constraint_rgb_histogram_manipulator_nub_position_changed (RGBHistogramManipulator* _sender,
                                                                                                   gpointer self)
{
#line 2844 "../src/editing_tools/EditingTools.vala"
	editing_tools_adjust_tool_on_histogram_constraint ((EditingToolsAdjustTool*) self);
#line 15079 "EditingTools.c"
}

static gboolean
_editing_tools_adjust_tool_on_hscale_reset_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                          GdkEventButton* event,
                                                                          gpointer self)
{
	gboolean result;
	result = editing_tools_adjust_tool_on_hscale_reset ((EditingToolsAdjustTool*) self, _sender, event);
#line 2846 "../src/editing_tools/EditingTools.vala"
	return result;
#line 15091 "EditingTools.c"
}

static void
editing_tools_adjust_tool_bind_window_handlers (EditingToolsAdjustTool* self)
{
	EditingToolsAdjustToolAdjustToolWindow* _tmp0_;
	GtkButton* _tmp1_;
	EditingToolsAdjustToolAdjustToolWindow* _tmp2_;
	GtkButton* _tmp3_;
	EditingToolsAdjustToolAdjustToolWindow* _tmp4_;
	GtkButton* _tmp5_;
	EditingToolsAdjustToolAdjustToolWindow* _tmp6_;
	GtkScale* _tmp7_;
	EditingToolsAdjustToolAdjustToolWindow* _tmp8_;
	GtkScale* _tmp9_;
	EditingToolsAdjustToolAdjustToolWindow* _tmp10_;
	GtkScale* _tmp11_;
	EditingToolsAdjustToolAdjustToolWindow* _tmp12_;
	GtkScale* _tmp13_;
	EditingToolsAdjustToolAdjustToolWindow* _tmp14_;
	GtkScale* _tmp15_;
	EditingToolsAdjustToolAdjustToolWindow* _tmp16_;
	GtkScale* _tmp17_;
	EditingToolsAdjustToolAdjustToolWindow* _tmp18_;
	GtkScale* _tmp19_;
	EditingToolsAdjustToolAdjustToolWindow* _tmp20_;
	RGBHistogramManipulator* _tmp21_;
	EditingToolsAdjustToolAdjustToolWindow* _tmp22_;
	GtkScale* _tmp23_;
	EditingToolsAdjustToolAdjustToolWindow* _tmp24_;
	GtkScale* _tmp25_;
	EditingToolsAdjustToolAdjustToolWindow* _tmp26_;
	GtkScale* _tmp27_;
	EditingToolsAdjustToolAdjustToolWindow* _tmp28_;
	GtkScale* _tmp29_;
	EditingToolsAdjustToolAdjustToolWindow* _tmp30_;
	GtkScale* _tmp31_;
	EditingToolsAdjustToolAdjustToolWindow* _tmp32_;
	GtkScale* _tmp33_;
	EditingToolsAdjustToolAdjustToolWindow* _tmp34_;
	GtkScale* _tmp35_;
#line 2833 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_ADJUST_TOOL (self));
#line 2834 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->adjust_tool_window;
#line 2834 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = _tmp0_->ok_button;
#line 2834 "../src/editing_tools/EditingTools.vala"
	g_signal_connect (_tmp1_, "clicked", (GCallback) _editing_tools_adjust_tool_on_ok_gtk_button_clicked, self);
#line 2835 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = self->priv->adjust_tool_window;
#line 2835 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = _tmp2_->reset_button;
#line 2835 "../src/editing_tools/EditingTools.vala"
	g_signal_connect (_tmp3_, "clicked", (GCallback) _editing_tools_adjust_tool_on_reset_gtk_button_clicked, self);
#line 2836 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = self->priv->adjust_tool_window;
#line 2836 "../src/editing_tools/EditingTools.vala"
	_tmp5_ = _tmp4_->cancel_button;
#line 2836 "../src/editing_tools/EditingTools.vala"
	g_signal_connect (_tmp5_, "clicked", (GCallback) _editing_tools_editing_tool_notify_cancel_gtk_button_clicked, G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool));
#line 2837 "../src/editing_tools/EditingTools.vala"
	_tmp6_ = self->priv->adjust_tool_window;
#line 2837 "../src/editing_tools/EditingTools.vala"
	_tmp7_ = _tmp6_->exposure_slider;
#line 2837 "../src/editing_tools/EditingTools.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_range_get_type (), GtkRange), "value-changed", (GCallback) _editing_tools_adjust_tool_on_exposure_adjustment_gtk_range_value_changed, self);
#line 2838 "../src/editing_tools/EditingTools.vala"
	_tmp8_ = self->priv->adjust_tool_window;
#line 2838 "../src/editing_tools/EditingTools.vala"
	_tmp9_ = _tmp8_->contrast_slider;
#line 2838 "../src/editing_tools/EditingTools.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, gtk_range_get_type (), GtkRange), "value-changed", (GCallback) _editing_tools_adjust_tool_on_contrast_adjustment_gtk_range_value_changed, self);
#line 2839 "../src/editing_tools/EditingTools.vala"
	_tmp10_ = self->priv->adjust_tool_window;
#line 2839 "../src/editing_tools/EditingTools.vala"
	_tmp11_ = _tmp10_->saturation_slider;
#line 2839 "../src/editing_tools/EditingTools.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, gtk_range_get_type (), GtkRange), "value-changed", (GCallback) _editing_tools_adjust_tool_on_saturation_adjustment_gtk_range_value_changed, self);
#line 2840 "../src/editing_tools/EditingTools.vala"
	_tmp12_ = self->priv->adjust_tool_window;
#line 2840 "../src/editing_tools/EditingTools.vala"
	_tmp13_ = _tmp12_->tint_slider;
#line 2840 "../src/editing_tools/EditingTools.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, gtk_range_get_type (), GtkRange), "value-changed", (GCallback) _editing_tools_adjust_tool_on_tint_adjustment_gtk_range_value_changed, self);
#line 2841 "../src/editing_tools/EditingTools.vala"
	_tmp14_ = self->priv->adjust_tool_window;
#line 2841 "../src/editing_tools/EditingTools.vala"
	_tmp15_ = _tmp14_->temperature_slider;
#line 2841 "../src/editing_tools/EditingTools.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, gtk_range_get_type (), GtkRange), "value-changed", (GCallback) _editing_tools_adjust_tool_on_temperature_adjustment_gtk_range_value_changed, self);
#line 2842 "../src/editing_tools/EditingTools.vala"
	_tmp16_ = self->priv->adjust_tool_window;
#line 2842 "../src/editing_tools/EditingTools.vala"
	_tmp17_ = _tmp16_->shadows_slider;
#line 2842 "../src/editing_tools/EditingTools.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, gtk_range_get_type (), GtkRange), "value-changed", (GCallback) _editing_tools_adjust_tool_on_shadows_adjustment_gtk_range_value_changed, self);
#line 2843 "../src/editing_tools/EditingTools.vala"
	_tmp18_ = self->priv->adjust_tool_window;
#line 2843 "../src/editing_tools/EditingTools.vala"
	_tmp19_ = _tmp18_->highlights_slider;
#line 2843 "../src/editing_tools/EditingTools.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, gtk_range_get_type (), GtkRange), "value-changed", (GCallback) _editing_tools_adjust_tool_on_highlights_adjustment_gtk_range_value_changed, self);
#line 2844 "../src/editing_tools/EditingTools.vala"
	_tmp20_ = self->priv->adjust_tool_window;
#line 2844 "../src/editing_tools/EditingTools.vala"
	_tmp21_ = _tmp20_->histogram_manipulator;
#line 2844 "../src/editing_tools/EditingTools.vala"
	g_signal_connect (_tmp21_, "nub-position-changed", (GCallback) _editing_tools_adjust_tool_on_histogram_constraint_rgb_histogram_manipulator_nub_position_changed, self);
#line 2846 "../src/editing_tools/EditingTools.vala"
	_tmp22_ = self->priv->adjust_tool_window;
#line 2846 "../src/editing_tools/EditingTools.vala"
	_tmp23_ = _tmp22_->saturation_slider;
#line 2846 "../src/editing_tools/EditingTools.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, gtk_widget_get_type (), GtkWidget), "button-press-event", (GCallback) _editing_tools_adjust_tool_on_hscale_reset_gtk_widget_button_press_event, self);
#line 2847 "../src/editing_tools/EditingTools.vala"
	_tmp24_ = self->priv->adjust_tool_window;
#line 2847 "../src/editing_tools/EditingTools.vala"
	_tmp25_ = _tmp24_->exposure_slider;
#line 2847 "../src/editing_tools/EditingTools.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, gtk_widget_get_type (), GtkWidget), "button-press-event", (GCallback) _editing_tools_adjust_tool_on_hscale_reset_gtk_widget_button_press_event, self);
#line 2848 "../src/editing_tools/EditingTools.vala"
	_tmp26_ = self->priv->adjust_tool_window;
#line 2848 "../src/editing_tools/EditingTools.vala"
	_tmp27_ = _tmp26_->contrast_slider;
#line 2848 "../src/editing_tools/EditingTools.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp27_, gtk_widget_get_type (), GtkWidget), "button-press-event", (GCallback) _editing_tools_adjust_tool_on_hscale_reset_gtk_widget_button_press_event, self);
#line 2849 "../src/editing_tools/EditingTools.vala"
	_tmp28_ = self->priv->adjust_tool_window;
#line 2849 "../src/editing_tools/EditingTools.vala"
	_tmp29_ = _tmp28_->tint_slider;
#line 2849 "../src/editing_tools/EditingTools.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, gtk_widget_get_type (), GtkWidget), "button-press-event", (GCallback) _editing_tools_adjust_tool_on_hscale_reset_gtk_widget_button_press_event, self);
#line 2850 "../src/editing_tools/EditingTools.vala"
	_tmp30_ = self->priv->adjust_tool_window;
#line 2850 "../src/editing_tools/EditingTools.vala"
	_tmp31_ = _tmp30_->temperature_slider;
#line 2850 "../src/editing_tools/EditingTools.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, gtk_widget_get_type (), GtkWidget), "button-press-event", (GCallback) _editing_tools_adjust_tool_on_hscale_reset_gtk_widget_button_press_event, self);
#line 2851 "../src/editing_tools/EditingTools.vala"
	_tmp32_ = self->priv->adjust_tool_window;
#line 2851 "../src/editing_tools/EditingTools.vala"
	_tmp33_ = _tmp32_->shadows_slider;
#line 2851 "../src/editing_tools/EditingTools.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp33_, gtk_widget_get_type (), GtkWidget), "button-press-event", (GCallback) _editing_tools_adjust_tool_on_hscale_reset_gtk_widget_button_press_event, self);
#line 2852 "../src/editing_tools/EditingTools.vala"
	_tmp34_ = self->priv->adjust_tool_window;
#line 2852 "../src/editing_tools/EditingTools.vala"
	_tmp35_ = _tmp34_->highlights_slider;
#line 2852 "../src/editing_tools/EditingTools.vala"
	g_signal_connect (G_TYPE_CHECK_INSTANCE_CAST (_tmp35_, gtk_widget_get_type (), GtkWidget), "button-press-event", (GCallback) _editing_tools_adjust_tool_on_hscale_reset_gtk_widget_button_press_event, self);
#line 15243 "EditingTools.c"
}

static void
editing_tools_adjust_tool_unbind_window_handlers (EditingToolsAdjustTool* self)
{
	EditingToolsAdjustToolAdjustToolWindow* _tmp0_;
	GtkButton* _tmp1_;
	guint _tmp2_;
	EditingToolsAdjustToolAdjustToolWindow* _tmp3_;
	GtkButton* _tmp4_;
	guint _tmp5_;
	EditingToolsAdjustToolAdjustToolWindow* _tmp6_;
	GtkButton* _tmp7_;
	guint _tmp8_;
	EditingToolsAdjustToolAdjustToolWindow* _tmp9_;
	GtkScale* _tmp10_;
	guint _tmp11_;
	EditingToolsAdjustToolAdjustToolWindow* _tmp12_;
	GtkScale* _tmp13_;
	guint _tmp14_;
	EditingToolsAdjustToolAdjustToolWindow* _tmp15_;
	GtkScale* _tmp16_;
	guint _tmp17_;
	EditingToolsAdjustToolAdjustToolWindow* _tmp18_;
	GtkScale* _tmp19_;
	guint _tmp20_;
	EditingToolsAdjustToolAdjustToolWindow* _tmp21_;
	GtkScale* _tmp22_;
	guint _tmp23_;
	EditingToolsAdjustToolAdjustToolWindow* _tmp24_;
	GtkScale* _tmp25_;
	guint _tmp26_;
	EditingToolsAdjustToolAdjustToolWindow* _tmp27_;
	GtkScale* _tmp28_;
	guint _tmp29_;
	EditingToolsAdjustToolAdjustToolWindow* _tmp30_;
	RGBHistogramManipulator* _tmp31_;
	guint _tmp32_;
	EditingToolsAdjustToolAdjustToolWindow* _tmp33_;
	GtkScale* _tmp34_;
	guint _tmp35_;
	EditingToolsAdjustToolAdjustToolWindow* _tmp36_;
	GtkScale* _tmp37_;
	guint _tmp38_;
	EditingToolsAdjustToolAdjustToolWindow* _tmp39_;
	GtkScale* _tmp40_;
	guint _tmp41_;
	EditingToolsAdjustToolAdjustToolWindow* _tmp42_;
	GtkScale* _tmp43_;
	guint _tmp44_;
	EditingToolsAdjustToolAdjustToolWindow* _tmp45_;
	GtkScale* _tmp46_;
	guint _tmp47_;
	EditingToolsAdjustToolAdjustToolWindow* _tmp48_;
	GtkScale* _tmp49_;
	guint _tmp50_;
	EditingToolsAdjustToolAdjustToolWindow* _tmp51_;
	GtkScale* _tmp52_;
	guint _tmp53_;
#line 2855 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_ADJUST_TOOL (self));
#line 2856 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->adjust_tool_window;
#line 2856 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = _tmp0_->ok_button;
#line 2856 "../src/editing_tools/EditingTools.vala"
	g_signal_parse_name ("clicked", gtk_button_get_type (), &_tmp2_, NULL, FALSE);
#line 2856 "../src/editing_tools/EditingTools.vala"
	g_signal_handlers_disconnect_matched (_tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _editing_tools_adjust_tool_on_ok_gtk_button_clicked, self);
#line 2857 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = self->priv->adjust_tool_window;
#line 2857 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = _tmp3_->reset_button;
#line 2857 "../src/editing_tools/EditingTools.vala"
	g_signal_parse_name ("clicked", gtk_button_get_type (), &_tmp5_, NULL, FALSE);
#line 2857 "../src/editing_tools/EditingTools.vala"
	g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _editing_tools_adjust_tool_on_reset_gtk_button_clicked, self);
#line 2858 "../src/editing_tools/EditingTools.vala"
	_tmp6_ = self->priv->adjust_tool_window;
#line 2858 "../src/editing_tools/EditingTools.vala"
	_tmp7_ = _tmp6_->cancel_button;
#line 2858 "../src/editing_tools/EditingTools.vala"
	g_signal_parse_name ("clicked", gtk_button_get_type (), &_tmp8_, NULL, FALSE);
#line 2858 "../src/editing_tools/EditingTools.vala"
	g_signal_handlers_disconnect_matched (_tmp7_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp8_, 0, NULL, (GCallback) _editing_tools_editing_tool_notify_cancel_gtk_button_clicked, G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool));
#line 2859 "../src/editing_tools/EditingTools.vala"
	_tmp9_ = self->priv->adjust_tool_window;
#line 2859 "../src/editing_tools/EditingTools.vala"
	_tmp10_ = _tmp9_->exposure_slider;
#line 2859 "../src/editing_tools/EditingTools.vala"
	g_signal_parse_name ("value-changed", gtk_range_get_type (), &_tmp11_, NULL, FALSE);
#line 2859 "../src/editing_tools/EditingTools.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, gtk_range_get_type (), GtkRange), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp11_, 0, NULL, (GCallback) _editing_tools_adjust_tool_on_exposure_adjustment_gtk_range_value_changed, self);
#line 2860 "../src/editing_tools/EditingTools.vala"
	_tmp12_ = self->priv->adjust_tool_window;
#line 2860 "../src/editing_tools/EditingTools.vala"
	_tmp13_ = _tmp12_->contrast_slider;
#line 2860 "../src/editing_tools/EditingTools.vala"
	g_signal_parse_name ("value-changed", gtk_range_get_type (), &_tmp14_, NULL, FALSE);
#line 2860 "../src/editing_tools/EditingTools.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, gtk_range_get_type (), GtkRange), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp14_, 0, NULL, (GCallback) _editing_tools_adjust_tool_on_contrast_adjustment_gtk_range_value_changed, self);
#line 2861 "../src/editing_tools/EditingTools.vala"
	_tmp15_ = self->priv->adjust_tool_window;
#line 2861 "../src/editing_tools/EditingTools.vala"
	_tmp16_ = _tmp15_->saturation_slider;
#line 2861 "../src/editing_tools/EditingTools.vala"
	g_signal_parse_name ("value-changed", gtk_range_get_type (), &_tmp17_, NULL, FALSE);
#line 2861 "../src/editing_tools/EditingTools.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, gtk_range_get_type (), GtkRange), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp17_, 0, NULL, (GCallback) _editing_tools_adjust_tool_on_saturation_adjustment_gtk_range_value_changed, self);
#line 2862 "../src/editing_tools/EditingTools.vala"
	_tmp18_ = self->priv->adjust_tool_window;
#line 2862 "../src/editing_tools/EditingTools.vala"
	_tmp19_ = _tmp18_->tint_slider;
#line 2862 "../src/editing_tools/EditingTools.vala"
	g_signal_parse_name ("value-changed", gtk_range_get_type (), &_tmp20_, NULL, FALSE);
#line 2862 "../src/editing_tools/EditingTools.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, gtk_range_get_type (), GtkRange), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp20_, 0, NULL, (GCallback) _editing_tools_adjust_tool_on_tint_adjustment_gtk_range_value_changed, self);
#line 2863 "../src/editing_tools/EditingTools.vala"
	_tmp21_ = self->priv->adjust_tool_window;
#line 2863 "../src/editing_tools/EditingTools.vala"
	_tmp22_ = _tmp21_->temperature_slider;
#line 2863 "../src/editing_tools/EditingTools.vala"
	g_signal_parse_name ("value-changed", gtk_range_get_type (), &_tmp23_, NULL, FALSE);
#line 2863 "../src/editing_tools/EditingTools.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, gtk_range_get_type (), GtkRange), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp23_, 0, NULL, (GCallback) _editing_tools_adjust_tool_on_temperature_adjustment_gtk_range_value_changed, self);
#line 2864 "../src/editing_tools/EditingTools.vala"
	_tmp24_ = self->priv->adjust_tool_window;
#line 2864 "../src/editing_tools/EditingTools.vala"
	_tmp25_ = _tmp24_->shadows_slider;
#line 2864 "../src/editing_tools/EditingTools.vala"
	g_signal_parse_name ("value-changed", gtk_range_get_type (), &_tmp26_, NULL, FALSE);
#line 2864 "../src/editing_tools/EditingTools.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, gtk_range_get_type (), GtkRange), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp26_, 0, NULL, (GCallback) _editing_tools_adjust_tool_on_shadows_adjustment_gtk_range_value_changed, self);
#line 2865 "../src/editing_tools/EditingTools.vala"
	_tmp27_ = self->priv->adjust_tool_window;
#line 2865 "../src/editing_tools/EditingTools.vala"
	_tmp28_ = _tmp27_->highlights_slider;
#line 2865 "../src/editing_tools/EditingTools.vala"
	g_signal_parse_name ("value-changed", gtk_range_get_type (), &_tmp29_, NULL, FALSE);
#line 2865 "../src/editing_tools/EditingTools.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, gtk_range_get_type (), GtkRange), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp29_, 0, NULL, (GCallback) _editing_tools_adjust_tool_on_highlights_adjustment_gtk_range_value_changed, self);
#line 2866 "../src/editing_tools/EditingTools.vala"
	_tmp30_ = self->priv->adjust_tool_window;
#line 2866 "../src/editing_tools/EditingTools.vala"
	_tmp31_ = _tmp30_->histogram_manipulator;
#line 2866 "../src/editing_tools/EditingTools.vala"
	g_signal_parse_name ("nub-position-changed", TYPE_RGB_HISTOGRAM_MANIPULATOR, &_tmp32_, NULL, FALSE);
#line 2866 "../src/editing_tools/EditingTools.vala"
	g_signal_handlers_disconnect_matched (_tmp31_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp32_, 0, NULL, (GCallback) _editing_tools_adjust_tool_on_histogram_constraint_rgb_histogram_manipulator_nub_position_changed, self);
#line 2868 "../src/editing_tools/EditingTools.vala"
	_tmp33_ = self->priv->adjust_tool_window;
#line 2868 "../src/editing_tools/EditingTools.vala"
	_tmp34_ = _tmp33_->saturation_slider;
#line 2868 "../src/editing_tools/EditingTools.vala"
	g_signal_parse_name ("button-press-event", gtk_widget_get_type (), &_tmp35_, NULL, FALSE);
#line 2868 "../src/editing_tools/EditingTools.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, gtk_widget_get_type (), GtkWidget), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp35_, 0, NULL, (GCallback) _editing_tools_adjust_tool_on_hscale_reset_gtk_widget_button_press_event, self);
#line 2869 "../src/editing_tools/EditingTools.vala"
	_tmp36_ = self->priv->adjust_tool_window;
#line 2869 "../src/editing_tools/EditingTools.vala"
	_tmp37_ = _tmp36_->exposure_slider;
#line 2869 "../src/editing_tools/EditingTools.vala"
	g_signal_parse_name ("button-press-event", gtk_widget_get_type (), &_tmp38_, NULL, FALSE);
#line 2869 "../src/editing_tools/EditingTools.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp37_, gtk_widget_get_type (), GtkWidget), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp38_, 0, NULL, (GCallback) _editing_tools_adjust_tool_on_hscale_reset_gtk_widget_button_press_event, self);
#line 2870 "../src/editing_tools/EditingTools.vala"
	_tmp39_ = self->priv->adjust_tool_window;
#line 2870 "../src/editing_tools/EditingTools.vala"
	_tmp40_ = _tmp39_->contrast_slider;
#line 2870 "../src/editing_tools/EditingTools.vala"
	g_signal_parse_name ("button-press-event", gtk_widget_get_type (), &_tmp41_, NULL, FALSE);
#line 2870 "../src/editing_tools/EditingTools.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp40_, gtk_widget_get_type (), GtkWidget), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp41_, 0, NULL, (GCallback) _editing_tools_adjust_tool_on_hscale_reset_gtk_widget_button_press_event, self);
#line 2871 "../src/editing_tools/EditingTools.vala"
	_tmp42_ = self->priv->adjust_tool_window;
#line 2871 "../src/editing_tools/EditingTools.vala"
	_tmp43_ = _tmp42_->tint_slider;
#line 2871 "../src/editing_tools/EditingTools.vala"
	g_signal_parse_name ("button-press-event", gtk_widget_get_type (), &_tmp44_, NULL, FALSE);
#line 2871 "../src/editing_tools/EditingTools.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp43_, gtk_widget_get_type (), GtkWidget), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp44_, 0, NULL, (GCallback) _editing_tools_adjust_tool_on_hscale_reset_gtk_widget_button_press_event, self);
#line 2872 "../src/editing_tools/EditingTools.vala"
	_tmp45_ = self->priv->adjust_tool_window;
#line 2872 "../src/editing_tools/EditingTools.vala"
	_tmp46_ = _tmp45_->temperature_slider;
#line 2872 "../src/editing_tools/EditingTools.vala"
	g_signal_parse_name ("button-press-event", gtk_widget_get_type (), &_tmp47_, NULL, FALSE);
#line 2872 "../src/editing_tools/EditingTools.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp46_, gtk_widget_get_type (), GtkWidget), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp47_, 0, NULL, (GCallback) _editing_tools_adjust_tool_on_hscale_reset_gtk_widget_button_press_event, self);
#line 2873 "../src/editing_tools/EditingTools.vala"
	_tmp48_ = self->priv->adjust_tool_window;
#line 2873 "../src/editing_tools/EditingTools.vala"
	_tmp49_ = _tmp48_->shadows_slider;
#line 2873 "../src/editing_tools/EditingTools.vala"
	g_signal_parse_name ("button-press-event", gtk_widget_get_type (), &_tmp50_, NULL, FALSE);
#line 2873 "../src/editing_tools/EditingTools.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp49_, gtk_widget_get_type (), GtkWidget), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp50_, 0, NULL, (GCallback) _editing_tools_adjust_tool_on_hscale_reset_gtk_widget_button_press_event, self);
#line 2874 "../src/editing_tools/EditingTools.vala"
	_tmp51_ = self->priv->adjust_tool_window;
#line 2874 "../src/editing_tools/EditingTools.vala"
	_tmp52_ = _tmp51_->highlights_slider;
#line 2874 "../src/editing_tools/EditingTools.vala"
	g_signal_parse_name ("button-press-event", gtk_widget_get_type (), &_tmp53_, NULL, FALSE);
#line 2874 "../src/editing_tools/EditingTools.vala"
	g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp52_, gtk_widget_get_type (), GtkWidget), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp53_, 0, NULL, (GCallback) _editing_tools_adjust_tool_on_hscale_reset_gtk_widget_button_press_event, self);
#line 15449 "EditingTools.c"
}

gboolean
editing_tools_adjust_tool_enhance (EditingToolsAdjustTool* self)
{
	EditingToolsAdjustToolAdjustEnhanceCommand* command = NULL;
	EditingToolsPhotoCanvas* _tmp0_;
	Photo* _tmp1_;
	Photo* _tmp2_;
	EditingToolsAdjustToolAdjustEnhanceCommand* _tmp3_;
	EditingToolsAdjustToolAdjustEnhanceCommand* _tmp4_;
	CommandManager* _tmp5_;
	CommandManager* _tmp6_;
	gboolean result;
#line 2877 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (EDITING_TOOLS_IS_ADJUST_TOOL (self), FALSE);
#line 2878 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 2878 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = editing_tools_photo_canvas_get_photo (_tmp0_);
#line 2878 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = _tmp1_;
#line 2878 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = editing_tools_adjust_tool_adjust_enhance_command_new (self, _tmp2_);
#line 2878 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = _tmp3_;
#line 2878 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (_tmp2_);
#line 2878 "../src/editing_tools/EditingTools.vala"
	command = _tmp4_;
#line 2879 "../src/editing_tools/EditingTools.vala"
	_tmp5_ = app_window_get_command_manager ();
#line 2879 "../src/editing_tools/EditingTools.vala"
	_tmp6_ = _tmp5_;
#line 2879 "../src/editing_tools/EditingTools.vala"
	command_manager_execute (_tmp6_, G_TYPE_CHECK_INSTANCE_CAST (command, TYPE_COMMAND, Command));
#line 2879 "../src/editing_tools/EditingTools.vala"
	_command_manager_unref0 (_tmp6_);
#line 2881 "../src/editing_tools/EditingTools.vala"
	result = TRUE;
#line 2881 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (command);
#line 2881 "../src/editing_tools/EditingTools.vala"
	return result;
#line 15494 "EditingTools.c"
}

static void
editing_tools_adjust_tool_on_photos_altered (EditingToolsAdjustTool* self,
                                             GeeMap* map)
{
	EditingToolsPhotoCanvas* _tmp0_;
	Photo* _tmp1_;
	Photo* _tmp2_;
	gboolean _tmp3_;
	PixelTransformationBundle* adjustments = NULL;
	EditingToolsPhotoCanvas* _tmp4_;
	Photo* _tmp5_;
	Photo* _tmp6_;
	PixelTransformationBundle* _tmp7_;
	PixelTransformationBundle* _tmp8_;
	PixelTransformationBundle* _tmp9_;
#line 2884 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_ADJUST_TOOL (self));
#line 2884 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (map, GEE_TYPE_MAP));
#line 2885 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 2885 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = editing_tools_photo_canvas_get_photo (_tmp0_);
#line 2885 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = _tmp1_;
#line 2885 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = !gee_map_has_key (map, G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_DATA_OBJECT, DataObject));
#line 2885 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (_tmp2_);
#line 2885 "../src/editing_tools/EditingTools.vala"
	if (_tmp3_) {
#line 2886 "../src/editing_tools/EditingTools.vala"
		return;
#line 15530 "EditingTools.c"
	}
#line 2888 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 2888 "../src/editing_tools/EditingTools.vala"
	_tmp5_ = editing_tools_photo_canvas_get_photo (_tmp4_);
#line 2888 "../src/editing_tools/EditingTools.vala"
	_tmp6_ = _tmp5_;
#line 2888 "../src/editing_tools/EditingTools.vala"
	_tmp7_ = photo_get_color_adjustments (_tmp6_);
#line 2888 "../src/editing_tools/EditingTools.vala"
	_tmp8_ = _tmp7_;
#line 2888 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (_tmp6_);
#line 2888 "../src/editing_tools/EditingTools.vala"
	adjustments = _tmp8_;
#line 2889 "../src/editing_tools/EditingTools.vala"
	_tmp9_ = adjustments;
#line 2889 "../src/editing_tools/EditingTools.vala"
	editing_tools_adjust_tool_set_adjustments (self, _tmp9_);
#line 2884 "../src/editing_tools/EditingTools.vala"
	_pixel_transformation_bundle_unref0 (adjustments);
#line 15552 "EditingTools.c"
}

static void
editing_tools_adjust_tool_set_adjustments (EditingToolsAdjustTool* self,
                                           PixelTransformationBundle* new_adjustments)
{
	EditingToolsPhotoCanvas* _tmp8_;
#line 2892 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_ADJUST_TOOL (self));
#line 2892 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (new_adjustments, TYPE_PIXEL_TRANSFORMATION_BUNDLE));
#line 2893 "../src/editing_tools/EditingTools.vala"
	editing_tools_adjust_tool_unbind_window_handlers (self);
#line 2895 "../src/editing_tools/EditingTools.vala"
	editing_tools_adjust_tool_update_transformations (self, new_adjustments);
#line 15568 "EditingTools.c"
	{
		GeeIterator* _adjustment_it = NULL;
		GeeIterable* _tmp0_;
		GeeIterable* _tmp1_;
		GeeIterator* _tmp2_;
		GeeIterator* _tmp3_;
#line 2897 "../src/editing_tools/EditingTools.vala"
		_tmp0_ = pixel_transformation_bundle_get_transformations (new_adjustments);
#line 2897 "../src/editing_tools/EditingTools.vala"
		_tmp1_ = _tmp0_;
#line 2897 "../src/editing_tools/EditingTools.vala"
		_tmp2_ = gee_iterable_iterator (_tmp1_);
#line 2897 "../src/editing_tools/EditingTools.vala"
		_tmp3_ = _tmp2_;
#line 2897 "../src/editing_tools/EditingTools.vala"
		_g_object_unref0 (_tmp1_);
#line 2897 "../src/editing_tools/EditingTools.vala"
		_adjustment_it = _tmp3_;
#line 2897 "../src/editing_tools/EditingTools.vala"
		while (TRUE) {
#line 15589 "EditingTools.c"
			GeeIterator* _tmp4_;
			PixelTransformation* adjustment = NULL;
			GeeIterator* _tmp5_;
			gpointer _tmp6_;
			PixelTransformation* _tmp7_;
#line 2897 "../src/editing_tools/EditingTools.vala"
			_tmp4_ = _adjustment_it;
#line 2897 "../src/editing_tools/EditingTools.vala"
			if (!gee_iterator_next (_tmp4_)) {
#line 2897 "../src/editing_tools/EditingTools.vala"
				break;
#line 15601 "EditingTools.c"
			}
#line 2897 "../src/editing_tools/EditingTools.vala"
			_tmp5_ = _adjustment_it;
#line 2897 "../src/editing_tools/EditingTools.vala"
			_tmp6_ = gee_iterator_get (_tmp5_);
#line 2897 "../src/editing_tools/EditingTools.vala"
			adjustment = (PixelTransformation*) _tmp6_;
#line 2898 "../src/editing_tools/EditingTools.vala"
			_tmp7_ = adjustment;
#line 2898 "../src/editing_tools/EditingTools.vala"
			editing_tools_adjust_tool_update_slider (self, _tmp7_);
#line 2897 "../src/editing_tools/EditingTools.vala"
			_pixel_transformation_unref0 (adjustment);
#line 15615 "EditingTools.c"
		}
#line 2897 "../src/editing_tools/EditingTools.vala"
		_g_object_unref0 (_adjustment_it);
#line 15619 "EditingTools.c"
	}
#line 2900 "../src/editing_tools/EditingTools.vala"
	editing_tools_adjust_tool_bind_window_handlers (self);
#line 2901 "../src/editing_tools/EditingTools.vala"
	_tmp8_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 2901 "../src/editing_tools/EditingTools.vala"
	editing_tools_photo_canvas_repaint (_tmp8_);
#line 15627 "EditingTools.c"
}

static gpointer
_pixel_transformation_ref0 (gpointer self)
{
#line 2909 "../src/editing_tools/EditingTools.vala"
	return self ? pixel_transformation_ref (self) : NULL;
#line 15635 "EditingTools.c"
}

static void
editing_tools_adjust_tool_update_slider (EditingToolsAdjustTool* self,
                                         PixelTransformation* transformation)
{
#line 2906 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_ADJUST_TOOL (self));
#line 2906 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (transformation, TYPE_PIXEL_TRANSFORMATION));
#line 2907 "../src/editing_tools/EditingTools.vala"
	switch (pixel_transformation_get_transformation_type (transformation)) {
#line 2907 "../src/editing_tools/EditingTools.vala"
		case PIXEL_TRANSFORMATION_TYPE_TONE_EXPANSION:
#line 15650 "EditingTools.c"
		{
			ExpansionTransformation* expansion = NULL;
			ExpansionTransformation* _tmp0_;
#line 2909 "../src/editing_tools/EditingTools.vala"
			_tmp0_ = _pixel_transformation_ref0 (G_TYPE_CHECK_INSTANCE_CAST (transformation, TYPE_EXPANSION_TRANSFORMATION, ExpansionTransformation));
#line 2909 "../src/editing_tools/EditingTools.vala"
			expansion = _tmp0_;
#line 2911 "../src/editing_tools/EditingTools.vala"
			if (!self->priv->disable_histogram_refresh) {
#line 15660 "EditingTools.c"
				EditingToolsAdjustToolAdjustToolWindow* _tmp1_;
				RGBHistogramManipulator* _tmp2_;
				ExpansionTransformation* _tmp3_;
				EditingToolsAdjustToolAdjustToolWindow* _tmp4_;
				RGBHistogramManipulator* _tmp5_;
				ExpansionTransformation* _tmp6_;
#line 2912 "../src/editing_tools/EditingTools.vala"
				_tmp1_ = self->priv->adjust_tool_window;
#line 2912 "../src/editing_tools/EditingTools.vala"
				_tmp2_ = _tmp1_->histogram_manipulator;
#line 2912 "../src/editing_tools/EditingTools.vala"
				_tmp3_ = expansion;
#line 2912 "../src/editing_tools/EditingTools.vala"
				rgb_histogram_manipulator_set_left_nub_position (_tmp2_, expansion_transformation_get_black_point (_tmp3_));
#line 2914 "../src/editing_tools/EditingTools.vala"
				_tmp4_ = self->priv->adjust_tool_window;
#line 2914 "../src/editing_tools/EditingTools.vala"
				_tmp5_ = _tmp4_->histogram_manipulator;
#line 2914 "../src/editing_tools/EditingTools.vala"
				_tmp6_ = expansion;
#line 2914 "../src/editing_tools/EditingTools.vala"
				rgb_histogram_manipulator_set_right_nub_position (_tmp5_, expansion_transformation_get_white_point (_tmp6_));
#line 15683 "EditingTools.c"
			}
#line 2917 "../src/editing_tools/EditingTools.vala"
			_pixel_transformation_unref0 (expansion);
#line 2917 "../src/editing_tools/EditingTools.vala"
			break;
#line 15689 "EditingTools.c"
		}
#line 2907 "../src/editing_tools/EditingTools.vala"
		case PIXEL_TRANSFORMATION_TYPE_SHADOWS:
#line 15693 "EditingTools.c"
		{
			EditingToolsAdjustToolAdjustToolWindow* _tmp7_;
			GtkScale* _tmp8_;
#line 2920 "../src/editing_tools/EditingTools.vala"
			_tmp7_ = self->priv->adjust_tool_window;
#line 2920 "../src/editing_tools/EditingTools.vala"
			_tmp8_ = _tmp7_->shadows_slider;
#line 2920 "../src/editing_tools/EditingTools.vala"
			gtk_range_set_value (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_range_get_type (), GtkRange), (gdouble) shadow_detail_transformation_get_parameter (G_TYPE_CHECK_INSTANCE_CAST (transformation, TYPE_SHADOW_DETAIL_TRANSFORMATION, ShadowDetailTransformation)));
#line 2922 "../src/editing_tools/EditingTools.vala"
			break;
#line 15705 "EditingTools.c"
		}
#line 2907 "../src/editing_tools/EditingTools.vala"
		case PIXEL_TRANSFORMATION_TYPE_CONTRAST:
#line 15709 "EditingTools.c"
		{
			EditingToolsAdjustToolAdjustToolWindow* _tmp9_;
			GtkScale* _tmp10_;
#line 2925 "../src/editing_tools/EditingTools.vala"
			_tmp9_ = self->priv->adjust_tool_window;
#line 2925 "../src/editing_tools/EditingTools.vala"
			_tmp10_ = _tmp9_->contrast_slider;
#line 2925 "../src/editing_tools/EditingTools.vala"
			gtk_range_set_value (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, gtk_range_get_type (), GtkRange), (gdouble) contrast_transformation_get_parameter (G_TYPE_CHECK_INSTANCE_CAST (transformation, TYPE_CONTRAST_TRANSFORMATION, ContrastTransformation)));
#line 2927 "../src/editing_tools/EditingTools.vala"
			break;
#line 15721 "EditingTools.c"
		}
#line 2907 "../src/editing_tools/EditingTools.vala"
		case PIXEL_TRANSFORMATION_TYPE_HIGHLIGHTS:
#line 15725 "EditingTools.c"
		{
			EditingToolsAdjustToolAdjustToolWindow* _tmp11_;
			GtkScale* _tmp12_;
#line 2930 "../src/editing_tools/EditingTools.vala"
			_tmp11_ = self->priv->adjust_tool_window;
#line 2930 "../src/editing_tools/EditingTools.vala"
			_tmp12_ = _tmp11_->highlights_slider;
#line 2930 "../src/editing_tools/EditingTools.vala"
			gtk_range_set_value (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, gtk_range_get_type (), GtkRange), (gdouble) highlight_detail_transformation_get_parameter (G_TYPE_CHECK_INSTANCE_CAST (transformation, TYPE_HIGHLIGHT_DETAIL_TRANSFORMATION, HighlightDetailTransformation)));
#line 2932 "../src/editing_tools/EditingTools.vala"
			break;
#line 15737 "EditingTools.c"
		}
#line 2907 "../src/editing_tools/EditingTools.vala"
		case PIXEL_TRANSFORMATION_TYPE_EXPOSURE:
#line 15741 "EditingTools.c"
		{
			EditingToolsAdjustToolAdjustToolWindow* _tmp13_;
			GtkScale* _tmp14_;
#line 2935 "../src/editing_tools/EditingTools.vala"
			_tmp13_ = self->priv->adjust_tool_window;
#line 2935 "../src/editing_tools/EditingTools.vala"
			_tmp14_ = _tmp13_->exposure_slider;
#line 2935 "../src/editing_tools/EditingTools.vala"
			gtk_range_set_value (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, gtk_range_get_type (), GtkRange), (gdouble) exposure_transformation_get_parameter (G_TYPE_CHECK_INSTANCE_CAST (transformation, TYPE_EXPOSURE_TRANSFORMATION, ExposureTransformation)));
#line 2937 "../src/editing_tools/EditingTools.vala"
			break;
#line 15753 "EditingTools.c"
		}
#line 2907 "../src/editing_tools/EditingTools.vala"
		case PIXEL_TRANSFORMATION_TYPE_SATURATION:
#line 15757 "EditingTools.c"
		{
			EditingToolsAdjustToolAdjustToolWindow* _tmp15_;
			GtkScale* _tmp16_;
#line 2940 "../src/editing_tools/EditingTools.vala"
			_tmp15_ = self->priv->adjust_tool_window;
#line 2940 "../src/editing_tools/EditingTools.vala"
			_tmp16_ = _tmp15_->saturation_slider;
#line 2940 "../src/editing_tools/EditingTools.vala"
			gtk_range_set_value (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, gtk_range_get_type (), GtkRange), (gdouble) saturation_transformation_get_parameter (G_TYPE_CHECK_INSTANCE_CAST (transformation, TYPE_SATURATION_TRANSFORMATION, SaturationTransformation)));
#line 2942 "../src/editing_tools/EditingTools.vala"
			break;
#line 15769 "EditingTools.c"
		}
#line 2907 "../src/editing_tools/EditingTools.vala"
		case PIXEL_TRANSFORMATION_TYPE_TINT:
#line 15773 "EditingTools.c"
		{
			EditingToolsAdjustToolAdjustToolWindow* _tmp17_;
			GtkScale* _tmp18_;
#line 2945 "../src/editing_tools/EditingTools.vala"
			_tmp17_ = self->priv->adjust_tool_window;
#line 2945 "../src/editing_tools/EditingTools.vala"
			_tmp18_ = _tmp17_->tint_slider;
#line 2945 "../src/editing_tools/EditingTools.vala"
			gtk_range_set_value (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, gtk_range_get_type (), GtkRange), (gdouble) tint_transformation_get_parameter (G_TYPE_CHECK_INSTANCE_CAST (transformation, TYPE_TINT_TRANSFORMATION, TintTransformation)));
#line 2947 "../src/editing_tools/EditingTools.vala"
			break;
#line 15785 "EditingTools.c"
		}
#line 2907 "../src/editing_tools/EditingTools.vala"
		case PIXEL_TRANSFORMATION_TYPE_TEMPERATURE:
#line 15789 "EditingTools.c"
		{
			EditingToolsAdjustToolAdjustToolWindow* _tmp19_;
			GtkScale* _tmp20_;
#line 2950 "../src/editing_tools/EditingTools.vala"
			_tmp19_ = self->priv->adjust_tool_window;
#line 2950 "../src/editing_tools/EditingTools.vala"
			_tmp20_ = _tmp19_->temperature_slider;
#line 2950 "../src/editing_tools/EditingTools.vala"
			gtk_range_set_value (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, gtk_range_get_type (), GtkRange), (gdouble) temperature_transformation_get_parameter (G_TYPE_CHECK_INSTANCE_CAST (transformation, TYPE_TEMPERATURE_TRANSFORMATION, TemperatureTransformation)));
#line 2952 "../src/editing_tools/EditingTools.vala"
			break;
#line 15801 "EditingTools.c"
		}
		default:
		{
#line 2955 "../src/editing_tools/EditingTools.vala"
			g_error ("EditingTools.vala:2955: Unknown adjustment: %d", (gint) pixel_transformation_get_transformation_type (transformation));
#line 15807 "EditingTools.c"
		}
	}
}

static void
editing_tools_adjust_tool_init_fp_pixel_cache (EditingToolsAdjustTool* self,
                                               GdkPixbuf* source)
{
	gint source_width = 0;
	gint source_height = 0;
	gint source_num_channels = 0;
	gint source_rowstride = 0;
	guchar* source_pixels = NULL;
	guint8* _tmp0_;
	gint source_pixels_length1;
	gint _source_pixels_size_;
	gfloat* _tmp1_;
	gint cache_pixel_index = 0;
#line 2959 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_IS_ADJUST_TOOL (self));
#line 2959 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (source, gdk_pixbuf_get_type ()));
#line 2960 "../src/editing_tools/EditingTools.vala"
	source_width = gdk_pixbuf_get_width (source);
#line 2961 "../src/editing_tools/EditingTools.vala"
	source_height = gdk_pixbuf_get_height (source);
#line 2962 "../src/editing_tools/EditingTools.vala"
	source_num_channels = gdk_pixbuf_get_n_channels (source);
#line 2963 "../src/editing_tools/EditingTools.vala"
	source_rowstride = gdk_pixbuf_get_rowstride (source);
#line 2964 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = gdk_pixbuf_get_pixels (source);
#line 2964 "../src/editing_tools/EditingTools.vala"
	source_pixels = _tmp0_;
#line 2964 "../src/editing_tools/EditingTools.vala"
	source_pixels_length1 = -1;
#line 2964 "../src/editing_tools/EditingTools.vala"
	_source_pixels_size_ = source_pixels_length1;
#line 2966 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = g_new0 (gfloat, (3 * source_width) * source_height);
#line 2966 "../src/editing_tools/EditingTools.vala"
	self->priv->fp_pixel_cache = (g_free (self->priv->fp_pixel_cache), NULL);
#line 2966 "../src/editing_tools/EditingTools.vala"
	self->priv->fp_pixel_cache = _tmp1_;
#line 2966 "../src/editing_tools/EditingTools.vala"
	self->priv->fp_pixel_cache_length1 = (3 * source_width) * source_height;
#line 2966 "../src/editing_tools/EditingTools.vala"
	self->priv->_fp_pixel_cache_size_ = self->priv->fp_pixel_cache_length1;
#line 2967 "../src/editing_tools/EditingTools.vala"
	cache_pixel_index = 0;
#line 15858 "EditingTools.c"
	{
		gint j = 0;
#line 2969 "../src/editing_tools/EditingTools.vala"
		j = 0;
#line 15863 "EditingTools.c"
		{
			gboolean _tmp2_ = FALSE;
#line 2969 "../src/editing_tools/EditingTools.vala"
			_tmp2_ = TRUE;
#line 2969 "../src/editing_tools/EditingTools.vala"
			while (TRUE) {
#line 15870 "EditingTools.c"
				gint row_start_index = 0;
				gint row_end_index = 0;
#line 2969 "../src/editing_tools/EditingTools.vala"
				if (!_tmp2_) {
#line 15875 "EditingTools.c"
					gint _tmp3_;
#line 2969 "../src/editing_tools/EditingTools.vala"
					_tmp3_ = j;
#line 2969 "../src/editing_tools/EditingTools.vala"
					j = _tmp3_ + 1;
#line 15881 "EditingTools.c"
				}
#line 2969 "../src/editing_tools/EditingTools.vala"
				_tmp2_ = FALSE;
#line 2969 "../src/editing_tools/EditingTools.vala"
				if (!(j < source_height)) {
#line 2969 "../src/editing_tools/EditingTools.vala"
					break;
#line 15889 "EditingTools.c"
				}
#line 2970 "../src/editing_tools/EditingTools.vala"
				row_start_index = j * source_rowstride;
#line 2971 "../src/editing_tools/EditingTools.vala"
				row_end_index = row_start_index + (source_width * source_num_channels);
#line 15895 "EditingTools.c"
				{
					gint i = 0;
#line 2972 "../src/editing_tools/EditingTools.vala"
					i = row_start_index;
#line 15900 "EditingTools.c"
					{
						gboolean _tmp4_ = FALSE;
#line 2972 "../src/editing_tools/EditingTools.vala"
						_tmp4_ = TRUE;
#line 2972 "../src/editing_tools/EditingTools.vala"
						while (TRUE) {
#line 15907 "EditingTools.c"
							gfloat* _tmp5_;
							gint _tmp5__length1;
							gint _tmp6_;
							guchar* _tmp7_;
							gint _tmp7__length1;
							guchar _tmp8_;
							gfloat _tmp9_;
							gfloat* _tmp10_;
							gint _tmp10__length1;
							gint _tmp11_;
							guchar* _tmp12_;
							gint _tmp12__length1;
							gint _tmp13_;
							guchar _tmp14_;
							gfloat _tmp15_;
							gfloat* _tmp16_;
							gint _tmp16__length1;
							gint _tmp17_;
							guchar* _tmp18_;
							gint _tmp18__length1;
							gint _tmp19_;
							guchar _tmp20_;
							gfloat _tmp21_;
#line 2972 "../src/editing_tools/EditingTools.vala"
							if (!_tmp4_) {
#line 2972 "../src/editing_tools/EditingTools.vala"
								i += source_num_channels;
#line 15935 "EditingTools.c"
							}
#line 2972 "../src/editing_tools/EditingTools.vala"
							_tmp4_ = FALSE;
#line 2972 "../src/editing_tools/EditingTools.vala"
							if (!(i < row_end_index)) {
#line 2972 "../src/editing_tools/EditingTools.vala"
								break;
#line 15943 "EditingTools.c"
							}
#line 2973 "../src/editing_tools/EditingTools.vala"
							_tmp5_ = self->priv->fp_pixel_cache;
#line 2973 "../src/editing_tools/EditingTools.vala"
							_tmp5__length1 = self->priv->fp_pixel_cache_length1;
#line 2973 "../src/editing_tools/EditingTools.vala"
							_tmp6_ = cache_pixel_index;
#line 2973 "../src/editing_tools/EditingTools.vala"
							cache_pixel_index = _tmp6_ + 1;
#line 2973 "../src/editing_tools/EditingTools.vala"
							_tmp7_ = source_pixels;
#line 2973 "../src/editing_tools/EditingTools.vala"
							_tmp7__length1 = source_pixels_length1;
#line 2973 "../src/editing_tools/EditingTools.vala"
							_tmp8_ = _tmp7_[i];
#line 2973 "../src/editing_tools/EditingTools.vala"
							_tmp9_ = rgb_lookup_table[_tmp8_];
#line 2973 "../src/editing_tools/EditingTools.vala"
							_tmp5_[_tmp6_] = _tmp9_;
#line 2974 "../src/editing_tools/EditingTools.vala"
							_tmp10_ = self->priv->fp_pixel_cache;
#line 2974 "../src/editing_tools/EditingTools.vala"
							_tmp10__length1 = self->priv->fp_pixel_cache_length1;
#line 2974 "../src/editing_tools/EditingTools.vala"
							_tmp11_ = cache_pixel_index;
#line 2974 "../src/editing_tools/EditingTools.vala"
							cache_pixel_index = _tmp11_ + 1;
#line 2974 "../src/editing_tools/EditingTools.vala"
							_tmp12_ = source_pixels;
#line 2974 "../src/editing_tools/EditingTools.vala"
							_tmp12__length1 = source_pixels_length1;
#line 2974 "../src/editing_tools/EditingTools.vala"
							_tmp13_ = i;
#line 2974 "../src/editing_tools/EditingTools.vala"
							_tmp14_ = _tmp12_[_tmp13_ + 1];
#line 2974 "../src/editing_tools/EditingTools.vala"
							_tmp15_ = rgb_lookup_table[_tmp14_];
#line 2974 "../src/editing_tools/EditingTools.vala"
							_tmp10_[_tmp11_] = _tmp15_;
#line 2975 "../src/editing_tools/EditingTools.vala"
							_tmp16_ = self->priv->fp_pixel_cache;
#line 2975 "../src/editing_tools/EditingTools.vala"
							_tmp16__length1 = self->priv->fp_pixel_cache_length1;
#line 2975 "../src/editing_tools/EditingTools.vala"
							_tmp17_ = cache_pixel_index;
#line 2975 "../src/editing_tools/EditingTools.vala"
							cache_pixel_index = _tmp17_ + 1;
#line 2975 "../src/editing_tools/EditingTools.vala"
							_tmp18_ = source_pixels;
#line 2975 "../src/editing_tools/EditingTools.vala"
							_tmp18__length1 = source_pixels_length1;
#line 2975 "../src/editing_tools/EditingTools.vala"
							_tmp19_ = i;
#line 2975 "../src/editing_tools/EditingTools.vala"
							_tmp20_ = _tmp18_[_tmp19_ + 2];
#line 2975 "../src/editing_tools/EditingTools.vala"
							_tmp21_ = rgb_lookup_table[_tmp20_];
#line 2975 "../src/editing_tools/EditingTools.vala"
							_tmp16_[_tmp17_] = _tmp21_;
#line 16003 "EditingTools.c"
						}
					}
				}
			}
		}
	}
}

static gboolean
editing_tools_adjust_tool_real_on_keypress (EditingToolsEditingTool* base,
                                            GdkEventKey* event)
{
	EditingToolsAdjustTool * self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	gboolean result;
#line 2980 "../src/editing_tools/EditingTools.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, EDITING_TOOLS_TYPE_ADJUST_TOOL, EditingToolsAdjustTool);
#line 2980 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 2981 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = gdk_keyval_name (event->keyval);
#line 2981 "../src/editing_tools/EditingTools.vala"
	if (g_strcmp0 (_tmp2_, "KP_Enter") == 0) {
#line 2981 "../src/editing_tools/EditingTools.vala"
		_tmp1_ = TRUE;
#line 16031 "EditingTools.c"
	} else {
		const gchar* _tmp3_;
#line 2982 "../src/editing_tools/EditingTools.vala"
		_tmp3_ = gdk_keyval_name (event->keyval);
#line 2982 "../src/editing_tools/EditingTools.vala"
		_tmp1_ = g_strcmp0 (_tmp3_, "Enter") == 0;
#line 16038 "EditingTools.c"
	}
#line 2981 "../src/editing_tools/EditingTools.vala"
	if (_tmp1_) {
#line 2981 "../src/editing_tools/EditingTools.vala"
		_tmp0_ = TRUE;
#line 16044 "EditingTools.c"
	} else {
		const gchar* _tmp4_;
#line 2983 "../src/editing_tools/EditingTools.vala"
		_tmp4_ = gdk_keyval_name (event->keyval);
#line 2983 "../src/editing_tools/EditingTools.vala"
		_tmp0_ = g_strcmp0 (_tmp4_, "Return") == 0;
#line 16051 "EditingTools.c"
	}
#line 2981 "../src/editing_tools/EditingTools.vala"
	if (_tmp0_) {
#line 2984 "../src/editing_tools/EditingTools.vala"
		editing_tools_adjust_tool_on_ok (self);
#line 2985 "../src/editing_tools/EditingTools.vala"
		result = TRUE;
#line 2985 "../src/editing_tools/EditingTools.vala"
		return result;
#line 16061 "EditingTools.c"
	}
#line 2988 "../src/editing_tools/EditingTools.vala"
	result = EDITING_TOOLS_EDITING_TOOL_CLASS (editing_tools_adjust_tool_parent_class)->on_keypress (G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool), event);
#line 2988 "../src/editing_tools/EditingTools.vala"
	return result;
#line 16067 "EditingTools.c"
}

static EditingToolsAdjustToolAdjustToolWindow*
editing_tools_adjust_tool_adjust_tool_window_construct (GType object_type,
                                                        GtkWindow* container)
{
	EditingToolsAdjustToolAdjustToolWindow * self = NULL;
	GtkGrid* slider_organizer = NULL;
	GtkGrid* _tmp0_;
	GtkLabel* exposure_label = NULL;
	GtkLabel* _tmp1_;
	GtkScale* _tmp2_;
	GtkScale* _tmp3_;
	GtkScale* _tmp4_;
	GtkScale* _tmp5_;
	GtkLabel* contrast_label = NULL;
	GtkLabel* _tmp6_;
	GtkScale* _tmp7_;
	GtkScale* _tmp8_;
	GtkScale* _tmp9_;
	GtkScale* _tmp10_;
	GtkLabel* saturation_label = NULL;
	GtkLabel* _tmp11_;
	GtkScale* _tmp12_;
	GtkScale* _tmp13_;
	GtkScale* _tmp14_;
	GtkScale* _tmp15_;
	GtkLabel* tint_label = NULL;
	GtkLabel* _tmp16_;
	GtkScale* _tmp17_;
	GtkScale* _tmp18_;
	GtkScale* _tmp19_;
	GtkScale* _tmp20_;
	GtkLabel* temperature_label = NULL;
	GtkLabel* _tmp21_;
	GtkScale* _tmp22_;
	GtkScale* _tmp23_;
	GtkScale* _tmp24_;
	GtkScale* _tmp25_;
	GtkLabel* shadows_label = NULL;
	GtkLabel* _tmp26_;
	GtkScale* _tmp27_;
	GtkScale* _tmp28_;
	GtkScale* _tmp29_;
	GtkScale* _tmp30_;
	GtkLabel* highlights_label = NULL;
	GtkLabel* _tmp31_;
	GtkScale* _tmp32_;
	GtkScale* _tmp33_;
	GtkScale* _tmp34_;
	GtkScale* _tmp35_;
	GtkBox* button_layouter = NULL;
	GtkBox* _tmp36_;
	GtkButton* _tmp37_;
	GtkButton* _tmp38_;
	GtkButton* _tmp39_;
	RGBHistogramManipulator* _tmp40_;
	RGBHistogramManipulator* _tmp41_;
	RGBHistogramManipulator* _tmp42_;
	RGBHistogramManipulator* _tmp43_;
	GtkBox* pane_layouter = NULL;
	GtkBox* _tmp44_;
	RGBHistogramManipulator* _tmp45_;
	RGBHistogramManipulator* _tmp46_;
#line 2233 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (container, gtk_window_get_type ()), NULL);
#line 2234 "../src/editing_tools/EditingTools.vala"
	self = (EditingToolsAdjustToolAdjustToolWindow*) editing_tools_editing_tool_window_construct (object_type, container);
#line 2236 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = (GtkGrid*) gtk_grid_new ();
#line 2236 "../src/editing_tools/EditingTools.vala"
	g_object_ref_sink (_tmp0_);
#line 2236 "../src/editing_tools/EditingTools.vala"
	slider_organizer = _tmp0_;
#line 2237 "../src/editing_tools/EditingTools.vala"
	gtk_grid_set_column_homogeneous (slider_organizer, FALSE);
#line 2238 "../src/editing_tools/EditingTools.vala"
	gtk_grid_set_row_spacing (slider_organizer, (guint) 12);
#line 2239 "../src/editing_tools/EditingTools.vala"
	gtk_grid_set_column_spacing (slider_organizer, (guint) 12);
#line 2240 "../src/editing_tools/EditingTools.vala"
	gtk_widget_set_margin_start (G_TYPE_CHECK_INSTANCE_CAST (slider_organizer, gtk_widget_get_type (), GtkWidget), 12);
#line 2241 "../src/editing_tools/EditingTools.vala"
	gtk_widget_set_margin_bottom (G_TYPE_CHECK_INSTANCE_CAST (slider_organizer, gtk_widget_get_type (), GtkWidget), 12);
#line 2243 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = (GtkLabel*) gtk_label_new_with_mnemonic (_ ("Exposure:"));
#line 2243 "../src/editing_tools/EditingTools.vala"
	g_object_ref_sink (_tmp1_);
#line 2243 "../src/editing_tools/EditingTools.vala"
	exposure_label = _tmp1_;
#line 2244 "../src/editing_tools/EditingTools.vala"
	gtk_widget_set_halign (G_TYPE_CHECK_INSTANCE_CAST (exposure_label, gtk_widget_get_type (), GtkWidget), GTK_ALIGN_START);
#line 2245 "../src/editing_tools/EditingTools.vala"
	gtk_widget_set_valign (G_TYPE_CHECK_INSTANCE_CAST (exposure_label, gtk_widget_get_type (), GtkWidget), GTK_ALIGN_CENTER);
#line 2246 "../src/editing_tools/EditingTools.vala"
	gtk_grid_attach (slider_organizer, G_TYPE_CHECK_INSTANCE_CAST (exposure_label, gtk_widget_get_type (), GtkWidget), 0, 0, 1, 1);
#line 2247 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = self->exposure_slider;
#line 2247 "../src/editing_tools/EditingTools.vala"
	gtk_grid_attach (slider_organizer, G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_widget_get_type (), GtkWidget), 1, 0, 1, 1);
#line 2248 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = self->exposure_slider;
#line 2248 "../src/editing_tools/EditingTools.vala"
	gtk_widget_set_size_request (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_widget_get_type (), GtkWidget), EDITING_TOOLS_ADJUST_TOOL_SLIDER_WIDTH, -1);
#line 2249 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = self->exposure_slider;
#line 2249 "../src/editing_tools/EditingTools.vala"
	gtk_scale_set_value_pos (_tmp4_, GTK_POS_RIGHT);
#line 2250 "../src/editing_tools/EditingTools.vala"
	_tmp5_ = self->exposure_slider;
#line 2250 "../src/editing_tools/EditingTools.vala"
	gtk_widget_set_margin_end (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gtk_widget_get_type (), GtkWidget), 0);
#line 2252 "../src/editing_tools/EditingTools.vala"
	_tmp6_ = (GtkLabel*) gtk_label_new_with_mnemonic (_ ("Contrast:"));
#line 2252 "../src/editing_tools/EditingTools.vala"
	g_object_ref_sink (_tmp6_);
#line 2252 "../src/editing_tools/EditingTools.vala"
	contrast_label = _tmp6_;
#line 2253 "../src/editing_tools/EditingTools.vala"
	gtk_widget_set_halign (G_TYPE_CHECK_INSTANCE_CAST (contrast_label, gtk_widget_get_type (), GtkWidget), GTK_ALIGN_START);
#line 2254 "../src/editing_tools/EditingTools.vala"
	gtk_widget_set_valign (G_TYPE_CHECK_INSTANCE_CAST (contrast_label, gtk_widget_get_type (), GtkWidget), GTK_ALIGN_CENTER);
#line 2255 "../src/editing_tools/EditingTools.vala"
	gtk_grid_attach (slider_organizer, G_TYPE_CHECK_INSTANCE_CAST (contrast_label, gtk_widget_get_type (), GtkWidget), 0, 1, 1, 1);
#line 2256 "../src/editing_tools/EditingTools.vala"
	_tmp7_ = self->contrast_slider;
#line 2256 "../src/editing_tools/EditingTools.vala"
	gtk_grid_attach (slider_organizer, G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_widget_get_type (), GtkWidget), 1, 1, 1, 1);
#line 2257 "../src/editing_tools/EditingTools.vala"
	_tmp8_ = self->contrast_slider;
#line 2257 "../src/editing_tools/EditingTools.vala"
	gtk_widget_set_size_request (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_widget_get_type (), GtkWidget), EDITING_TOOLS_ADJUST_TOOL_SLIDER_WIDTH, -1);
#line 2258 "../src/editing_tools/EditingTools.vala"
	_tmp9_ = self->contrast_slider;
#line 2258 "../src/editing_tools/EditingTools.vala"
	gtk_scale_set_value_pos (_tmp9_, GTK_POS_RIGHT);
#line 2259 "../src/editing_tools/EditingTools.vala"
	_tmp10_ = self->contrast_slider;
#line 2259 "../src/editing_tools/EditingTools.vala"
	gtk_widget_set_margin_end (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, gtk_widget_get_type (), GtkWidget), 0);
#line 2261 "../src/editing_tools/EditingTools.vala"
	_tmp11_ = (GtkLabel*) gtk_label_new_with_mnemonic (_ ("Saturation:"));
#line 2261 "../src/editing_tools/EditingTools.vala"
	g_object_ref_sink (_tmp11_);
#line 2261 "../src/editing_tools/EditingTools.vala"
	saturation_label = _tmp11_;
#line 2262 "../src/editing_tools/EditingTools.vala"
	gtk_widget_set_halign (G_TYPE_CHECK_INSTANCE_CAST (saturation_label, gtk_widget_get_type (), GtkWidget), GTK_ALIGN_START);
#line 2263 "../src/editing_tools/EditingTools.vala"
	gtk_widget_set_valign (G_TYPE_CHECK_INSTANCE_CAST (saturation_label, gtk_widget_get_type (), GtkWidget), GTK_ALIGN_CENTER);
#line 2264 "../src/editing_tools/EditingTools.vala"
	gtk_grid_attach (slider_organizer, G_TYPE_CHECK_INSTANCE_CAST (saturation_label, gtk_widget_get_type (), GtkWidget), 0, 2, 1, 1);
#line 2265 "../src/editing_tools/EditingTools.vala"
	_tmp12_ = self->saturation_slider;
#line 2265 "../src/editing_tools/EditingTools.vala"
	gtk_grid_attach (slider_organizer, G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, gtk_widget_get_type (), GtkWidget), 1, 2, 1, 1);
#line 2266 "../src/editing_tools/EditingTools.vala"
	_tmp13_ = self->saturation_slider;
#line 2266 "../src/editing_tools/EditingTools.vala"
	gtk_widget_set_size_request (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, gtk_widget_get_type (), GtkWidget), EDITING_TOOLS_ADJUST_TOOL_SLIDER_WIDTH, -1);
#line 2267 "../src/editing_tools/EditingTools.vala"
	_tmp14_ = self->saturation_slider;
#line 2267 "../src/editing_tools/EditingTools.vala"
	gtk_scale_set_value_pos (_tmp14_, GTK_POS_RIGHT);
#line 2268 "../src/editing_tools/EditingTools.vala"
	_tmp15_ = self->saturation_slider;
#line 2268 "../src/editing_tools/EditingTools.vala"
	gtk_widget_set_margin_end (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, gtk_widget_get_type (), GtkWidget), 0);
#line 2270 "../src/editing_tools/EditingTools.vala"
	_tmp16_ = (GtkLabel*) gtk_label_new_with_mnemonic (_ ("Tint:"));
#line 2270 "../src/editing_tools/EditingTools.vala"
	g_object_ref_sink (_tmp16_);
#line 2270 "../src/editing_tools/EditingTools.vala"
	tint_label = _tmp16_;
#line 2271 "../src/editing_tools/EditingTools.vala"
	gtk_widget_set_halign (G_TYPE_CHECK_INSTANCE_CAST (tint_label, gtk_widget_get_type (), GtkWidget), GTK_ALIGN_START);
#line 2272 "../src/editing_tools/EditingTools.vala"
	gtk_widget_set_valign (G_TYPE_CHECK_INSTANCE_CAST (tint_label, gtk_widget_get_type (), GtkWidget), GTK_ALIGN_CENTER);
#line 2273 "../src/editing_tools/EditingTools.vala"
	gtk_grid_attach (slider_organizer, G_TYPE_CHECK_INSTANCE_CAST (tint_label, gtk_widget_get_type (), GtkWidget), 0, 3, 1, 1);
#line 2274 "../src/editing_tools/EditingTools.vala"
	_tmp17_ = self->tint_slider;
#line 2274 "../src/editing_tools/EditingTools.vala"
	gtk_grid_attach (slider_organizer, G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, gtk_widget_get_type (), GtkWidget), 1, 3, 1, 1);
#line 2275 "../src/editing_tools/EditingTools.vala"
	_tmp18_ = self->tint_slider;
#line 2275 "../src/editing_tools/EditingTools.vala"
	gtk_widget_set_size_request (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, gtk_widget_get_type (), GtkWidget), EDITING_TOOLS_ADJUST_TOOL_SLIDER_WIDTH, -1);
#line 2276 "../src/editing_tools/EditingTools.vala"
	_tmp19_ = self->tint_slider;
#line 2276 "../src/editing_tools/EditingTools.vala"
	gtk_scale_set_value_pos (_tmp19_, GTK_POS_RIGHT);
#line 2277 "../src/editing_tools/EditingTools.vala"
	_tmp20_ = self->tint_slider;
#line 2277 "../src/editing_tools/EditingTools.vala"
	gtk_widget_set_margin_end (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, gtk_widget_get_type (), GtkWidget), 0);
#line 2279 "../src/editing_tools/EditingTools.vala"
	_tmp21_ = (GtkLabel*) gtk_label_new_with_mnemonic (_ ("Temperature:"));
#line 2279 "../src/editing_tools/EditingTools.vala"
	g_object_ref_sink (_tmp21_);
#line 2279 "../src/editing_tools/EditingTools.vala"
	temperature_label = _tmp21_;
#line 2281 "../src/editing_tools/EditingTools.vala"
	gtk_widget_set_halign (G_TYPE_CHECK_INSTANCE_CAST (temperature_label, gtk_widget_get_type (), GtkWidget), GTK_ALIGN_START);
#line 2282 "../src/editing_tools/EditingTools.vala"
	gtk_widget_set_valign (G_TYPE_CHECK_INSTANCE_CAST (temperature_label, gtk_widget_get_type (), GtkWidget), GTK_ALIGN_CENTER);
#line 2283 "../src/editing_tools/EditingTools.vala"
	gtk_grid_attach (slider_organizer, G_TYPE_CHECK_INSTANCE_CAST (temperature_label, gtk_widget_get_type (), GtkWidget), 0, 4, 1, 1);
#line 2284 "../src/editing_tools/EditingTools.vala"
	_tmp22_ = self->temperature_slider;
#line 2284 "../src/editing_tools/EditingTools.vala"
	gtk_grid_attach (slider_organizer, G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, gtk_widget_get_type (), GtkWidget), 1, 4, 1, 1);
#line 2285 "../src/editing_tools/EditingTools.vala"
	_tmp23_ = self->temperature_slider;
#line 2285 "../src/editing_tools/EditingTools.vala"
	gtk_widget_set_size_request (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, gtk_widget_get_type (), GtkWidget), EDITING_TOOLS_ADJUST_TOOL_SLIDER_WIDTH, -1);
#line 2286 "../src/editing_tools/EditingTools.vala"
	_tmp24_ = self->temperature_slider;
#line 2286 "../src/editing_tools/EditingTools.vala"
	gtk_scale_set_value_pos (_tmp24_, GTK_POS_RIGHT);
#line 2287 "../src/editing_tools/EditingTools.vala"
	_tmp25_ = self->temperature_slider;
#line 2287 "../src/editing_tools/EditingTools.vala"
	gtk_widget_set_margin_end (G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, gtk_widget_get_type (), GtkWidget), 0);
#line 2289 "../src/editing_tools/EditingTools.vala"
	_tmp26_ = (GtkLabel*) gtk_label_new_with_mnemonic (_ ("Shadows:"));
#line 2289 "../src/editing_tools/EditingTools.vala"
	g_object_ref_sink (_tmp26_);
#line 2289 "../src/editing_tools/EditingTools.vala"
	shadows_label = _tmp26_;
#line 2290 "../src/editing_tools/EditingTools.vala"
	gtk_widget_set_halign (G_TYPE_CHECK_INSTANCE_CAST (shadows_label, gtk_widget_get_type (), GtkWidget), GTK_ALIGN_START);
#line 2291 "../src/editing_tools/EditingTools.vala"
	gtk_widget_set_valign (G_TYPE_CHECK_INSTANCE_CAST (shadows_label, gtk_widget_get_type (), GtkWidget), GTK_ALIGN_CENTER);
#line 2292 "../src/editing_tools/EditingTools.vala"
	gtk_grid_attach (slider_organizer, G_TYPE_CHECK_INSTANCE_CAST (shadows_label, gtk_widget_get_type (), GtkWidget), 0, 5, 1, 1);
#line 2293 "../src/editing_tools/EditingTools.vala"
	_tmp27_ = self->shadows_slider;
#line 2293 "../src/editing_tools/EditingTools.vala"
	gtk_grid_attach (slider_organizer, G_TYPE_CHECK_INSTANCE_CAST (_tmp27_, gtk_widget_get_type (), GtkWidget), 1, 5, 1, 1);
#line 2294 "../src/editing_tools/EditingTools.vala"
	_tmp28_ = self->shadows_slider;
#line 2294 "../src/editing_tools/EditingTools.vala"
	gtk_widget_set_size_request (G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, gtk_widget_get_type (), GtkWidget), EDITING_TOOLS_ADJUST_TOOL_SLIDER_WIDTH, -1);
#line 2295 "../src/editing_tools/EditingTools.vala"
	_tmp29_ = self->shadows_slider;
#line 2295 "../src/editing_tools/EditingTools.vala"
	gtk_scale_set_value_pos (_tmp29_, GTK_POS_RIGHT);
#line 2298 "../src/editing_tools/EditingTools.vala"
	_tmp30_ = self->shadows_slider;
#line 2298 "../src/editing_tools/EditingTools.vala"
	gtk_widget_set_margin_end (G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, gtk_widget_get_type (), GtkWidget), 5);
#line 2300 "../src/editing_tools/EditingTools.vala"
	_tmp31_ = (GtkLabel*) gtk_label_new_with_mnemonic (_ ("Highlights:"));
#line 2300 "../src/editing_tools/EditingTools.vala"
	g_object_ref_sink (_tmp31_);
#line 2300 "../src/editing_tools/EditingTools.vala"
	highlights_label = _tmp31_;
#line 2301 "../src/editing_tools/EditingTools.vala"
	gtk_widget_set_halign (G_TYPE_CHECK_INSTANCE_CAST (highlights_label, gtk_widget_get_type (), GtkWidget), GTK_ALIGN_START);
#line 2302 "../src/editing_tools/EditingTools.vala"
	gtk_widget_set_valign (G_TYPE_CHECK_INSTANCE_CAST (highlights_label, gtk_widget_get_type (), GtkWidget), GTK_ALIGN_CENTER);
#line 2303 "../src/editing_tools/EditingTools.vala"
	gtk_grid_attach (slider_organizer, G_TYPE_CHECK_INSTANCE_CAST (highlights_label, gtk_widget_get_type (), GtkWidget), 0, 6, 1, 1);
#line 2304 "../src/editing_tools/EditingTools.vala"
	_tmp32_ = self->highlights_slider;
#line 2304 "../src/editing_tools/EditingTools.vala"
	gtk_grid_attach (slider_organizer, G_TYPE_CHECK_INSTANCE_CAST (_tmp32_, gtk_widget_get_type (), GtkWidget), 1, 6, 1, 1);
#line 2305 "../src/editing_tools/EditingTools.vala"
	_tmp33_ = self->highlights_slider;
#line 2305 "../src/editing_tools/EditingTools.vala"
	gtk_widget_set_size_request (G_TYPE_CHECK_INSTANCE_CAST (_tmp33_, gtk_widget_get_type (), GtkWidget), EDITING_TOOLS_ADJUST_TOOL_SLIDER_WIDTH, -1);
#line 2306 "../src/editing_tools/EditingTools.vala"
	_tmp34_ = self->highlights_slider;
#line 2306 "../src/editing_tools/EditingTools.vala"
	gtk_scale_set_value_pos (_tmp34_, GTK_POS_RIGHT);
#line 2307 "../src/editing_tools/EditingTools.vala"
	_tmp35_ = self->highlights_slider;
#line 2307 "../src/editing_tools/EditingTools.vala"
	gtk_widget_set_margin_end (G_TYPE_CHECK_INSTANCE_CAST (_tmp35_, gtk_widget_get_type (), GtkWidget), 0);
#line 2309 "../src/editing_tools/EditingTools.vala"
	_tmp36_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 8);
#line 2309 "../src/editing_tools/EditingTools.vala"
	g_object_ref_sink (_tmp36_);
#line 2309 "../src/editing_tools/EditingTools.vala"
	button_layouter = _tmp36_;
#line 2310 "../src/editing_tools/EditingTools.vala"
	gtk_box_set_homogeneous (button_layouter, TRUE);
#line 2311 "../src/editing_tools/EditingTools.vala"
	_tmp37_ = self->cancel_button;
#line 2311 "../src/editing_tools/EditingTools.vala"
	gtk_box_pack_start (button_layouter, G_TYPE_CHECK_INSTANCE_CAST (_tmp37_, gtk_widget_get_type (), GtkWidget), TRUE, TRUE, (guint) 1);
#line 2312 "../src/editing_tools/EditingTools.vala"
	_tmp38_ = self->reset_button;
#line 2312 "../src/editing_tools/EditingTools.vala"
	gtk_box_pack_start (button_layouter, G_TYPE_CHECK_INSTANCE_CAST (_tmp38_, gtk_widget_get_type (), GtkWidget), TRUE, TRUE, (guint) 1);
#line 2313 "../src/editing_tools/EditingTools.vala"
	_tmp39_ = self->ok_button;
#line 2313 "../src/editing_tools/EditingTools.vala"
	gtk_box_pack_start (button_layouter, G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, gtk_widget_get_type (), GtkWidget), TRUE, TRUE, (guint) 1);
#line 2315 "../src/editing_tools/EditingTools.vala"
	_tmp40_ = self->histogram_manipulator;
#line 2315 "../src/editing_tools/EditingTools.vala"
	gtk_widget_set_margin_start (G_TYPE_CHECK_INSTANCE_CAST (_tmp40_, gtk_widget_get_type (), GtkWidget), 12);
#line 2316 "../src/editing_tools/EditingTools.vala"
	_tmp41_ = self->histogram_manipulator;
#line 2316 "../src/editing_tools/EditingTools.vala"
	gtk_widget_set_margin_end (G_TYPE_CHECK_INSTANCE_CAST (_tmp41_, gtk_widget_get_type (), GtkWidget), 12);
#line 2317 "../src/editing_tools/EditingTools.vala"
	_tmp42_ = self->histogram_manipulator;
#line 2317 "../src/editing_tools/EditingTools.vala"
	gtk_widget_set_margin_top (G_TYPE_CHECK_INSTANCE_CAST (_tmp42_, gtk_widget_get_type (), GtkWidget), 12);
#line 2318 "../src/editing_tools/EditingTools.vala"
	_tmp43_ = self->histogram_manipulator;
#line 2318 "../src/editing_tools/EditingTools.vala"
	gtk_widget_set_margin_bottom (G_TYPE_CHECK_INSTANCE_CAST (_tmp43_, gtk_widget_get_type (), GtkWidget), 8);
#line 2320 "../src/editing_tools/EditingTools.vala"
	_tmp44_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 8);
#line 2320 "../src/editing_tools/EditingTools.vala"
	g_object_ref_sink (_tmp44_);
#line 2320 "../src/editing_tools/EditingTools.vala"
	pane_layouter = _tmp44_;
#line 2321 "../src/editing_tools/EditingTools.vala"
	_tmp45_ = self->histogram_manipulator;
#line 2321 "../src/editing_tools/EditingTools.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (pane_layouter, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp45_, gtk_widget_get_type (), GtkWidget));
#line 2322 "../src/editing_tools/EditingTools.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (pane_layouter, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (slider_organizer, gtk_widget_get_type (), GtkWidget));
#line 2323 "../src/editing_tools/EditingTools.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (pane_layouter, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (button_layouter, gtk_widget_get_type (), GtkWidget));
#line 2324 "../src/editing_tools/EditingTools.vala"
	_tmp46_ = self->histogram_manipulator;
#line 2324 "../src/editing_tools/EditingTools.vala"
	gtk_box_set_child_packing (pane_layouter, G_TYPE_CHECK_INSTANCE_CAST (_tmp46_, gtk_widget_get_type (), GtkWidget), FALSE, TRUE, (guint) 0, GTK_PACK_START);
#line 2326 "../src/editing_tools/EditingTools.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (pane_layouter, gtk_widget_get_type (), GtkWidget));
#line 2233 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (pane_layouter);
#line 2233 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (button_layouter);
#line 2233 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (highlights_label);
#line 2233 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (shadows_label);
#line 2233 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (temperature_label);
#line 2233 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (tint_label);
#line 2233 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (saturation_label);
#line 2233 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (contrast_label);
#line 2233 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (exposure_label);
#line 2233 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (slider_organizer);
#line 2233 "../src/editing_tools/EditingTools.vala"
	return self;
#line 16426 "EditingTools.c"
}

static EditingToolsAdjustToolAdjustToolWindow*
editing_tools_adjust_tool_adjust_tool_window_new (GtkWindow* container)
{
#line 2233 "../src/editing_tools/EditingTools.vala"
	return editing_tools_adjust_tool_adjust_tool_window_construct (EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_TOOL_WINDOW, container);
#line 16434 "EditingTools.c"
}

static void
editing_tools_adjust_tool_adjust_tool_window_class_init (EditingToolsAdjustToolAdjustToolWindowClass * klass,
                                                         gpointer klass_data)
{
#line 2204 "../src/editing_tools/EditingTools.vala"
	editing_tools_adjust_tool_adjust_tool_window_parent_class = g_type_class_peek_parent (klass);
#line 2204 "../src/editing_tools/EditingTools.vala"
	G_OBJECT_CLASS (klass)->finalize = editing_tools_adjust_tool_adjust_tool_window_finalize;
#line 16445 "EditingTools.c"
}

static void
editing_tools_adjust_tool_adjust_tool_window_instance_init (EditingToolsAdjustToolAdjustToolWindow * self,
                                                            gpointer klass)
{
	GtkScale* _tmp0_;
	GtkScale* _tmp1_;
	GtkScale* _tmp2_;
	GtkScale* _tmp3_;
	GtkScale* _tmp4_;
	GtkScale* _tmp5_;
	GtkScale* _tmp6_;
	GtkButton* _tmp7_;
	GtkButton* _tmp8_;
	GtkButton* _tmp9_;
	RGBHistogramManipulator* _tmp10_;
#line 2205 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = (GtkScale*) gtk_scale_new_with_range (GTK_ORIENTATION_HORIZONTAL, (gdouble) EXPOSURE_TRANSFORMATION_MIN_PARAMETER, (gdouble) EXPOSURE_TRANSFORMATION_MAX_PARAMETER, 1.0);
#line 2205 "../src/editing_tools/EditingTools.vala"
	g_object_ref_sink (_tmp0_);
#line 2205 "../src/editing_tools/EditingTools.vala"
	self->exposure_slider = _tmp0_;
#line 2208 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = (GtkScale*) gtk_scale_new_with_range (GTK_ORIENTATION_HORIZONTAL, (gdouble) CONTRAST_TRANSFORMATION_MIN_PARAMETER, (gdouble) CONTRAST_TRANSFORMATION_MAX_PARAMETER, 1.0);
#line 2208 "../src/editing_tools/EditingTools.vala"
	g_object_ref_sink (_tmp1_);
#line 2208 "../src/editing_tools/EditingTools.vala"
	self->contrast_slider = _tmp1_;
#line 2211 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = (GtkScale*) gtk_scale_new_with_range (GTK_ORIENTATION_HORIZONTAL, (gdouble) SATURATION_TRANSFORMATION_MIN_PARAMETER, (gdouble) SATURATION_TRANSFORMATION_MAX_PARAMETER, 1.0);
#line 2211 "../src/editing_tools/EditingTools.vala"
	g_object_ref_sink (_tmp2_);
#line 2211 "../src/editing_tools/EditingTools.vala"
	self->saturation_slider = _tmp2_;
#line 2214 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = (GtkScale*) gtk_scale_new_with_range (GTK_ORIENTATION_HORIZONTAL, (gdouble) TINT_TRANSFORMATION_MIN_PARAMETER, (gdouble) TINT_TRANSFORMATION_MAX_PARAMETER, 1.0);
#line 2214 "../src/editing_tools/EditingTools.vala"
	g_object_ref_sink (_tmp3_);
#line 2214 "../src/editing_tools/EditingTools.vala"
	self->tint_slider = _tmp3_;
#line 2216 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = (GtkScale*) gtk_scale_new_with_range (GTK_ORIENTATION_HORIZONTAL, (gdouble) TEMPERATURE_TRANSFORMATION_MIN_PARAMETER, (gdouble) TEMPERATURE_TRANSFORMATION_MAX_PARAMETER, 1.0);
#line 2216 "../src/editing_tools/EditingTools.vala"
	g_object_ref_sink (_tmp4_);
#line 2216 "../src/editing_tools/EditingTools.vala"
	self->temperature_slider = _tmp4_;
#line 2220 "../src/editing_tools/EditingTools.vala"
	_tmp5_ = (GtkScale*) gtk_scale_new_with_range (GTK_ORIENTATION_HORIZONTAL, (gdouble) SHADOW_DETAIL_TRANSFORMATION_MIN_PARAMETER, (gdouble) SHADOW_DETAIL_TRANSFORMATION_MAX_PARAMETER, 1.0);
#line 2220 "../src/editing_tools/EditingTools.vala"
	g_object_ref_sink (_tmp5_);
#line 2220 "../src/editing_tools/EditingTools.vala"
	self->shadows_slider = _tmp5_;
#line 2224 "../src/editing_tools/EditingTools.vala"
	_tmp6_ = (GtkScale*) gtk_scale_new_with_range (GTK_ORIENTATION_HORIZONTAL, (gdouble) HIGHLIGHT_DETAIL_TRANSFORMATION_MIN_PARAMETER, (gdouble) HIGHLIGHT_DETAIL_TRANSFORMATION_MAX_PARAMETER, 1.0);
#line 2224 "../src/editing_tools/EditingTools.vala"
	g_object_ref_sink (_tmp6_);
#line 2224 "../src/editing_tools/EditingTools.vala"
	self->highlights_slider = _tmp6_;
#line 2228 "../src/editing_tools/EditingTools.vala"
	_tmp7_ = (GtkButton*) gtk_button_new_with_mnemonic (RESOURCES_OK_LABEL);
#line 2228 "../src/editing_tools/EditingTools.vala"
	g_object_ref_sink (_tmp7_);
#line 2228 "../src/editing_tools/EditingTools.vala"
	self->ok_button = _tmp7_;
#line 2229 "../src/editing_tools/EditingTools.vala"
	_tmp8_ = (GtkButton*) gtk_button_new_with_mnemonic (_ ("_Reset"));
#line 2229 "../src/editing_tools/EditingTools.vala"
	g_object_ref_sink (_tmp8_);
#line 2229 "../src/editing_tools/EditingTools.vala"
	self->reset_button = _tmp8_;
#line 2230 "../src/editing_tools/EditingTools.vala"
	_tmp9_ = (GtkButton*) gtk_button_new_with_mnemonic (RESOURCES_CANCEL_LABEL);
#line 2230 "../src/editing_tools/EditingTools.vala"
	g_object_ref_sink (_tmp9_);
#line 2230 "../src/editing_tools/EditingTools.vala"
	self->cancel_button = _tmp9_;
#line 2231 "../src/editing_tools/EditingTools.vala"
	_tmp10_ = rgb_histogram_manipulator_new ();
#line 2231 "../src/editing_tools/EditingTools.vala"
	g_object_ref_sink (_tmp10_);
#line 2231 "../src/editing_tools/EditingTools.vala"
	self->histogram_manipulator = _tmp10_;
#line 16529 "EditingTools.c"
}

static void
editing_tools_adjust_tool_adjust_tool_window_finalize (GObject * obj)
{
	EditingToolsAdjustToolAdjustToolWindow * self;
#line 2204 "../src/editing_tools/EditingTools.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_TOOL_WINDOW, EditingToolsAdjustToolAdjustToolWindow);
#line 2205 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->exposure_slider);
#line 2208 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->contrast_slider);
#line 2211 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->saturation_slider);
#line 2214 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->tint_slider);
#line 2216 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->temperature_slider);
#line 2220 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->shadows_slider);
#line 2224 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->highlights_slider);
#line 2228 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->ok_button);
#line 2229 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->reset_button);
#line 2230 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->cancel_button);
#line 2231 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->histogram_manipulator);
#line 2204 "../src/editing_tools/EditingTools.vala"
	G_OBJECT_CLASS (editing_tools_adjust_tool_adjust_tool_window_parent_class)->finalize (obj);
#line 16562 "EditingTools.c"
}

static GType
editing_tools_adjust_tool_adjust_tool_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (EditingToolsAdjustToolAdjustToolWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) editing_tools_adjust_tool_adjust_tool_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EditingToolsAdjustToolAdjustToolWindow), 0, (GInstanceInitFunc) editing_tools_adjust_tool_adjust_tool_window_instance_init, NULL };
	GType editing_tools_adjust_tool_adjust_tool_window_type_id;
	editing_tools_adjust_tool_adjust_tool_window_type_id = g_type_register_static (EDITING_TOOLS_TYPE_EDITING_TOOL_WINDOW, "EditingToolsAdjustToolAdjustToolWindow", &g_define_type_info, 0);
	return editing_tools_adjust_tool_adjust_tool_window_type_id;
}

static GType
editing_tools_adjust_tool_adjust_tool_window_get_type (void)
{
	static volatile gsize editing_tools_adjust_tool_adjust_tool_window_type_id__once = 0;
	if (g_once_init_enter (&editing_tools_adjust_tool_adjust_tool_window_type_id__once)) {
		GType editing_tools_adjust_tool_adjust_tool_window_type_id;
		editing_tools_adjust_tool_adjust_tool_window_type_id = editing_tools_adjust_tool_adjust_tool_window_get_type_once ();
		g_once_init_leave (&editing_tools_adjust_tool_adjust_tool_window_type_id__once, editing_tools_adjust_tool_adjust_tool_window_type_id);
	}
	return editing_tools_adjust_tool_adjust_tool_window_type_id__once;
}

static void
_editing_tools_adjust_tool_adjust_tool_command_on_owner_deactivated_editing_tools_editing_tool_deactivated (EditingToolsEditingTool* _sender,
                                                                                                            gpointer self)
{
#line 2342 "../src/editing_tools/EditingTools.vala"
	editing_tools_adjust_tool_adjust_tool_command_on_owner_deactivated ((EditingToolsAdjustToolAdjustToolCommand*) self);
#line 16592 "EditingTools.c"
}

static EditingToolsAdjustToolAdjustToolCommand*
editing_tools_adjust_tool_adjust_tool_command_construct (GType object_type,
                                                         EditingToolsAdjustTool* owner,
                                                         const gchar* name,
                                                         const gchar* explanation)
{
	EditingToolsAdjustToolAdjustToolCommand * self = NULL;
#line 2333 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (EDITING_TOOLS_IS_ADJUST_TOOL (owner), NULL);
#line 2333 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 2333 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (explanation != NULL, NULL);
#line 2334 "../src/editing_tools/EditingTools.vala"
	self = (EditingToolsAdjustToolAdjustToolCommand*) command_construct (object_type, name, explanation);
#line 2336 "../src/editing_tools/EditingTools.vala"
	self->owner = owner;
#line 2337 "../src/editing_tools/EditingTools.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (owner, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool), "deactivated", (GCallback) _editing_tools_adjust_tool_adjust_tool_command_on_owner_deactivated_editing_tools_editing_tool_deactivated, self, 0);
#line 2333 "../src/editing_tools/EditingTools.vala"
	return self;
#line 16616 "EditingTools.c"
}

static void
editing_tools_adjust_tool_adjust_tool_command_on_owner_deactivated (EditingToolsAdjustToolAdjustToolCommand* self)
{
	CommandManager* _tmp0_;
	CommandManager* _tmp1_;
#line 2345 "../src/editing_tools/EditingTools.vala"
	g_return_if_fail (EDITING_TOOLS_ADJUST_TOOL_IS_ADJUST_TOOL_COMMAND (self));
#line 2348 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = app_window_get_command_manager ();
#line 2348 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = _tmp0_;
#line 2348 "../src/editing_tools/EditingTools.vala"
	command_manager_reset (_tmp1_);
#line 2348 "../src/editing_tools/EditingTools.vala"
	_command_manager_unref0 (_tmp1_);
#line 16634 "EditingTools.c"
}

static void
editing_tools_adjust_tool_adjust_tool_command_class_init (EditingToolsAdjustToolAdjustToolCommandClass * klass,
                                                          gpointer klass_data)
{
#line 2330 "../src/editing_tools/EditingTools.vala"
	editing_tools_adjust_tool_adjust_tool_command_parent_class = g_type_class_peek_parent (klass);
#line 2330 "../src/editing_tools/EditingTools.vala"
	G_OBJECT_CLASS (klass)->finalize = editing_tools_adjust_tool_adjust_tool_command_finalize;
#line 16645 "EditingTools.c"
}

static void
editing_tools_adjust_tool_adjust_tool_command_instance_init (EditingToolsAdjustToolAdjustToolCommand * self,
                                                             gpointer klass)
{
}

static void
editing_tools_adjust_tool_adjust_tool_command_finalize (GObject * obj)
{
	EditingToolsAdjustToolAdjustToolCommand * self;
	EditingToolsAdjustTool* _tmp0_;
#line 2330 "../src/editing_tools/EditingTools.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_TOOL_COMMAND, EditingToolsAdjustToolAdjustToolCommand);
#line 2341 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->owner;
#line 2341 "../src/editing_tools/EditingTools.vala"
	if (_tmp0_ != NULL) {
#line 16665 "EditingTools.c"
		EditingToolsAdjustTool* _tmp1_;
		guint _tmp2_;
#line 2342 "../src/editing_tools/EditingTools.vala"
		_tmp1_ = self->owner;
#line 2342 "../src/editing_tools/EditingTools.vala"
		g_signal_parse_name ("deactivated", EDITING_TOOLS_TYPE_EDITING_TOOL, &_tmp2_, NULL, FALSE);
#line 2342 "../src/editing_tools/EditingTools.vala"
		g_signal_handlers_disconnect_matched (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool), G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _editing_tools_adjust_tool_adjust_tool_command_on_owner_deactivated_editing_tools_editing_tool_deactivated, self);
#line 16674 "EditingTools.c"
	}
#line 2330 "../src/editing_tools/EditingTools.vala"
	G_OBJECT_CLASS (editing_tools_adjust_tool_adjust_tool_command_parent_class)->finalize (obj);
#line 16678 "EditingTools.c"
}

static GType
editing_tools_adjust_tool_adjust_tool_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (EditingToolsAdjustToolAdjustToolCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) editing_tools_adjust_tool_adjust_tool_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EditingToolsAdjustToolAdjustToolCommand), 0, (GInstanceInitFunc) editing_tools_adjust_tool_adjust_tool_command_instance_init, NULL };
	GType editing_tools_adjust_tool_adjust_tool_command_type_id;
	editing_tools_adjust_tool_adjust_tool_command_type_id = g_type_register_static (TYPE_COMMAND, "EditingToolsAdjustToolAdjustToolCommand", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	return editing_tools_adjust_tool_adjust_tool_command_type_id;
}

static GType
editing_tools_adjust_tool_adjust_tool_command_get_type (void)
{
	static volatile gsize editing_tools_adjust_tool_adjust_tool_command_type_id__once = 0;
	if (g_once_init_enter (&editing_tools_adjust_tool_adjust_tool_command_type_id__once)) {
		GType editing_tools_adjust_tool_adjust_tool_command_type_id;
		editing_tools_adjust_tool_adjust_tool_command_type_id = editing_tools_adjust_tool_adjust_tool_command_get_type_once ();
		g_once_init_leave (&editing_tools_adjust_tool_adjust_tool_command_type_id__once, editing_tools_adjust_tool_adjust_tool_command_type_id);
	}
	return editing_tools_adjust_tool_adjust_tool_command_type_id__once;
}

static inline gpointer
editing_tools_adjust_tool_adjust_reset_command_get_instance_private (EditingToolsAdjustToolAdjustResetCommand* self)
{
	return G_STRUCT_MEMBER_P (self, EditingToolsAdjustToolAdjustResetCommand_private_offset);
}

static EditingToolsAdjustToolAdjustResetCommand*
editing_tools_adjust_tool_adjust_reset_command_construct (GType object_type,
                                                          EditingToolsAdjustTool* owner,
                                                          PixelTransformationBundle* current)
{
	EditingToolsAdjustToolAdjustResetCommand * self = NULL;
	PixelTransformationBundle* _tmp0_;
	PixelTransformationBundle* _tmp1_;
	PixelTransformationBundle* _tmp2_;
#line 2356 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (EDITING_TOOLS_IS_ADJUST_TOOL (owner), NULL);
#line 2356 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (current, TYPE_PIXEL_TRANSFORMATION_BUNDLE), NULL);
#line 2357 "../src/editing_tools/EditingTools.vala"
	self = (EditingToolsAdjustToolAdjustResetCommand*) editing_tools_adjust_tool_adjust_tool_command_construct (object_type, owner, _ ("Reset Colors"), _ ("Reset all color adjustments to original"));
#line 2359 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = pixel_transformation_bundle_copy (current);
#line 2359 "../src/editing_tools/EditingTools.vala"
	_pixel_transformation_bundle_unref0 (self->priv->original);
#line 2359 "../src/editing_tools/EditingTools.vala"
	self->priv->original = _tmp0_;
#line 2360 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = pixel_transformation_bundle_new ();
#line 2360 "../src/editing_tools/EditingTools.vala"
	_pixel_transformation_bundle_unref0 (self->priv->reset);
#line 2360 "../src/editing_tools/EditingTools.vala"
	self->priv->reset = _tmp1_;
#line 2361 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = self->priv->reset;
#line 2361 "../src/editing_tools/EditingTools.vala"
	pixel_transformation_bundle_set_to_identity (_tmp2_);
#line 2356 "../src/editing_tools/EditingTools.vala"
	return self;
#line 16741 "EditingTools.c"
}

static EditingToolsAdjustToolAdjustResetCommand*
editing_tools_adjust_tool_adjust_reset_command_new (EditingToolsAdjustTool* owner,
                                                    PixelTransformationBundle* current)
{
#line 2356 "../src/editing_tools/EditingTools.vala"
	return editing_tools_adjust_tool_adjust_reset_command_construct (EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_RESET_COMMAND, owner, current);
#line 16750 "EditingTools.c"
}

static void
editing_tools_adjust_tool_adjust_reset_command_real_execute (Command* base)
{
	EditingToolsAdjustToolAdjustResetCommand * self;
	EditingToolsAdjustTool* _tmp0_;
	PixelTransformationBundle* _tmp1_;
#line 2364 "../src/editing_tools/EditingTools.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_RESET_COMMAND, EditingToolsAdjustToolAdjustResetCommand);
#line 2365 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_TOOL_COMMAND, EditingToolsAdjustToolAdjustToolCommand)->owner;
#line 2365 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = self->priv->reset;
#line 2365 "../src/editing_tools/EditingTools.vala"
	editing_tools_adjust_tool_set_adjustments (_tmp0_, _tmp1_);
#line 16767 "EditingTools.c"
}

static void
editing_tools_adjust_tool_adjust_reset_command_real_undo (Command* base)
{
	EditingToolsAdjustToolAdjustResetCommand * self;
	EditingToolsAdjustTool* _tmp0_;
	PixelTransformationBundle* _tmp1_;
#line 2368 "../src/editing_tools/EditingTools.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_RESET_COMMAND, EditingToolsAdjustToolAdjustResetCommand);
#line 2369 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_TOOL_COMMAND, EditingToolsAdjustToolAdjustToolCommand)->owner;
#line 2369 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = self->priv->original;
#line 2369 "../src/editing_tools/EditingTools.vala"
	editing_tools_adjust_tool_set_adjustments (_tmp0_, _tmp1_);
#line 16784 "EditingTools.c"
}

static gboolean
editing_tools_adjust_tool_adjust_reset_command_real_compress (Command* base,
                                                              Command* command)
{
	EditingToolsAdjustToolAdjustResetCommand * self;
	EditingToolsAdjustToolAdjustResetCommand* reset_command = NULL;
	EditingToolsAdjustToolAdjustResetCommand* _tmp0_;
	EditingToolsAdjustToolAdjustResetCommand* _tmp1_;
	EditingToolsAdjustToolAdjustResetCommand* _tmp2_;
	EditingToolsAdjustTool* _tmp3_;
	EditingToolsAdjustTool* _tmp4_;
	gboolean result;
#line 2372 "../src/editing_tools/EditingTools.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_RESET_COMMAND, EditingToolsAdjustToolAdjustResetCommand);
#line 2372 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (IS_COMMAND (command), FALSE);
#line 2373 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = _g_object_ref0 (EDITING_TOOLS_ADJUST_TOOL_IS_ADJUST_RESET_COMMAND (command) ? ((EditingToolsAdjustToolAdjustResetCommand*) command) : NULL);
#line 2373 "../src/editing_tools/EditingTools.vala"
	reset_command = _tmp0_;
#line 2374 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = reset_command;
#line 2374 "../src/editing_tools/EditingTools.vala"
	if (_tmp1_ == NULL) {
#line 2375 "../src/editing_tools/EditingTools.vala"
		result = FALSE;
#line 2375 "../src/editing_tools/EditingTools.vala"
		_g_object_unref0 (reset_command);
#line 2375 "../src/editing_tools/EditingTools.vala"
		return result;
#line 16817 "EditingTools.c"
	}
#line 2377 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = reset_command;
#line 2377 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_TOOL_COMMAND, EditingToolsAdjustToolAdjustToolCommand)->owner;
#line 2377 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_TOOL_COMMAND, EditingToolsAdjustToolAdjustToolCommand)->owner;
#line 2377 "../src/editing_tools/EditingTools.vala"
	if (_tmp3_ != _tmp4_) {
#line 2378 "../src/editing_tools/EditingTools.vala"
		result = FALSE;
#line 2378 "../src/editing_tools/EditingTools.vala"
		_g_object_unref0 (reset_command);
#line 2378 "../src/editing_tools/EditingTools.vala"
		return result;
#line 16833 "EditingTools.c"
	}
#line 2381 "../src/editing_tools/EditingTools.vala"
	result = TRUE;
#line 2381 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (reset_command);
#line 2381 "../src/editing_tools/EditingTools.vala"
	return result;
#line 16841 "EditingTools.c"
}

static void
editing_tools_adjust_tool_adjust_reset_command_class_init (EditingToolsAdjustToolAdjustResetCommandClass * klass,
                                                           gpointer klass_data)
{
#line 2352 "../src/editing_tools/EditingTools.vala"
	editing_tools_adjust_tool_adjust_reset_command_parent_class = g_type_class_peek_parent (klass);
#line 2352 "../src/editing_tools/EditingTools.vala"
	g_type_class_adjust_private_offset (klass, &EditingToolsAdjustToolAdjustResetCommand_private_offset);
#line 2352 "../src/editing_tools/EditingTools.vala"
	((CommandClass *) klass)->execute = (void (*) (Command*)) editing_tools_adjust_tool_adjust_reset_command_real_execute;
#line 2352 "../src/editing_tools/EditingTools.vala"
	((CommandClass *) klass)->undo = (void (*) (Command*)) editing_tools_adjust_tool_adjust_reset_command_real_undo;
#line 2352 "../src/editing_tools/EditingTools.vala"
	((CommandClass *) klass)->compress = (gboolean (*) (Command*, Command*)) editing_tools_adjust_tool_adjust_reset_command_real_compress;
#line 2352 "../src/editing_tools/EditingTools.vala"
	G_OBJECT_CLASS (klass)->finalize = editing_tools_adjust_tool_adjust_reset_command_finalize;
#line 16860 "EditingTools.c"
}

static void
editing_tools_adjust_tool_adjust_reset_command_instance_init (EditingToolsAdjustToolAdjustResetCommand * self,
                                                              gpointer klass)
{
#line 2352 "../src/editing_tools/EditingTools.vala"
	self->priv = editing_tools_adjust_tool_adjust_reset_command_get_instance_private (self);
#line 16869 "EditingTools.c"
}

static void
editing_tools_adjust_tool_adjust_reset_command_finalize (GObject * obj)
{
	EditingToolsAdjustToolAdjustResetCommand * self;
#line 2352 "../src/editing_tools/EditingTools.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_RESET_COMMAND, EditingToolsAdjustToolAdjustResetCommand);
#line 2353 "../src/editing_tools/EditingTools.vala"
	_pixel_transformation_bundle_unref0 (self->priv->original);
#line 2354 "../src/editing_tools/EditingTools.vala"
	_pixel_transformation_bundle_unref0 (self->priv->reset);
#line 2352 "../src/editing_tools/EditingTools.vala"
	G_OBJECT_CLASS (editing_tools_adjust_tool_adjust_reset_command_parent_class)->finalize (obj);
#line 16884 "EditingTools.c"
}

static GType
editing_tools_adjust_tool_adjust_reset_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (EditingToolsAdjustToolAdjustResetCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) editing_tools_adjust_tool_adjust_reset_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EditingToolsAdjustToolAdjustResetCommand), 0, (GInstanceInitFunc) editing_tools_adjust_tool_adjust_reset_command_instance_init, NULL };
	GType editing_tools_adjust_tool_adjust_reset_command_type_id;
	editing_tools_adjust_tool_adjust_reset_command_type_id = g_type_register_static (EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_TOOL_COMMAND, "EditingToolsAdjustToolAdjustResetCommand", &g_define_type_info, 0);
	EditingToolsAdjustToolAdjustResetCommand_private_offset = g_type_add_instance_private (editing_tools_adjust_tool_adjust_reset_command_type_id, sizeof (EditingToolsAdjustToolAdjustResetCommandPrivate));
	return editing_tools_adjust_tool_adjust_reset_command_type_id;
}

static GType
editing_tools_adjust_tool_adjust_reset_command_get_type (void)
{
	static volatile gsize editing_tools_adjust_tool_adjust_reset_command_type_id__once = 0;
	if (g_once_init_enter (&editing_tools_adjust_tool_adjust_reset_command_type_id__once)) {
		GType editing_tools_adjust_tool_adjust_reset_command_type_id;
		editing_tools_adjust_tool_adjust_reset_command_type_id = editing_tools_adjust_tool_adjust_reset_command_get_type_once ();
		g_once_init_leave (&editing_tools_adjust_tool_adjust_reset_command_type_id__once, editing_tools_adjust_tool_adjust_reset_command_type_id);
	}
	return editing_tools_adjust_tool_adjust_reset_command_type_id__once;
}

static inline gpointer
editing_tools_adjust_tool_slider_adjustment_command_get_instance_private (EditingToolsAdjustToolSliderAdjustmentCommand* self)
{
	return G_STRUCT_MEMBER_P (self, EditingToolsAdjustToolSliderAdjustmentCommand_private_offset);
}

static EditingToolsAdjustToolSliderAdjustmentCommand*
editing_tools_adjust_tool_slider_adjustment_command_construct (GType object_type,
                                                               EditingToolsAdjustTool* owner,
                                                               PixelTransformation* old_transformation,
                                                               PixelTransformation* new_transformation,
                                                               const gchar* name)
{
	EditingToolsAdjustToolSliderAdjustmentCommand * self = NULL;
	PixelTransformation* _tmp0_;
	PixelTransformation* _tmp1_;
#line 2390 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (EDITING_TOOLS_IS_ADJUST_TOOL (owner), NULL);
#line 2390 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (old_transformation, TYPE_PIXEL_TRANSFORMATION), NULL);
#line 2390 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (new_transformation, TYPE_PIXEL_TRANSFORMATION), NULL);
#line 2390 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 2392 "../src/editing_tools/EditingTools.vala"
	self = (EditingToolsAdjustToolSliderAdjustmentCommand*) editing_tools_adjust_tool_adjust_tool_command_construct (object_type, owner, name, name);
#line 2394 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = _pixel_transformation_ref0 (old_transformation);
#line 2394 "../src/editing_tools/EditingTools.vala"
	_pixel_transformation_unref0 (self->priv->old_transformation);
#line 2394 "../src/editing_tools/EditingTools.vala"
	self->priv->old_transformation = _tmp0_;
#line 2395 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = _pixel_transformation_ref0 (new_transformation);
#line 2395 "../src/editing_tools/EditingTools.vala"
	_pixel_transformation_unref0 (self->priv->new_transformation);
#line 2395 "../src/editing_tools/EditingTools.vala"
	self->priv->new_transformation = _tmp1_;
#line 2396 "../src/editing_tools/EditingTools.vala"
	self->priv->transformation_type = pixel_transformation_get_transformation_type (old_transformation);
#line 2397 "../src/editing_tools/EditingTools.vala"
	_vala_assert (pixel_transformation_get_transformation_type (new_transformation) == self->priv->transformation_type, "new_transformation.get_transformation_type() == transformation_type");
#line 2390 "../src/editing_tools/EditingTools.vala"
	return self;
#line 16953 "EditingTools.c"
}

static EditingToolsAdjustToolSliderAdjustmentCommand*
editing_tools_adjust_tool_slider_adjustment_command_new (EditingToolsAdjustTool* owner,
                                                         PixelTransformation* old_transformation,
                                                         PixelTransformation* new_transformation,
                                                         const gchar* name)
{
#line 2390 "../src/editing_tools/EditingTools.vala"
	return editing_tools_adjust_tool_slider_adjustment_command_construct (EDITING_TOOLS_ADJUST_TOOL_TYPE_SLIDER_ADJUSTMENT_COMMAND, owner, old_transformation, new_transformation, name);
#line 16964 "EditingTools.c"
}

static void
editing_tools_adjust_tool_slider_adjustment_command_real_execute (Command* base)
{
	EditingToolsAdjustToolSliderAdjustmentCommand * self;
	EditingToolsAdjustTool* _tmp0_;
	PixelTransformation* _tmp1_;
	EditingToolsAdjustTool* _tmp2_;
	EditingToolsPhotoCanvas* _tmp3_;
#line 2400 "../src/editing_tools/EditingTools.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, EDITING_TOOLS_ADJUST_TOOL_TYPE_SLIDER_ADJUSTMENT_COMMAND, EditingToolsAdjustToolSliderAdjustmentCommand);
#line 2402 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_TOOL_COMMAND, EditingToolsAdjustToolAdjustToolCommand)->owner;
#line 2402 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = self->priv->new_transformation;
#line 2402 "../src/editing_tools/EditingTools.vala"
	editing_tools_adjust_tool_update_transformation (_tmp0_, _tmp1_);
#line 2403 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_TOOL_COMMAND, EditingToolsAdjustToolAdjustToolCommand)->owner;
#line 2403 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 2403 "../src/editing_tools/EditingTools.vala"
	editing_tools_photo_canvas_repaint (_tmp3_);
#line 16989 "EditingTools.c"
}

static void
editing_tools_adjust_tool_slider_adjustment_command_real_undo (Command* base)
{
	EditingToolsAdjustToolSliderAdjustmentCommand * self;
	EditingToolsAdjustTool* _tmp0_;
	PixelTransformation* _tmp1_;
	EditingToolsAdjustTool* _tmp2_;
	EditingToolsAdjustTool* _tmp3_;
	PixelTransformation* _tmp4_;
	EditingToolsAdjustTool* _tmp5_;
	EditingToolsAdjustTool* _tmp6_;
	EditingToolsPhotoCanvas* _tmp7_;
#line 2406 "../src/editing_tools/EditingTools.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, EDITING_TOOLS_ADJUST_TOOL_TYPE_SLIDER_ADJUSTMENT_COMMAND, EditingToolsAdjustToolSliderAdjustmentCommand);
#line 2407 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_TOOL_COMMAND, EditingToolsAdjustToolAdjustToolCommand)->owner;
#line 2407 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = self->priv->old_transformation;
#line 2407 "../src/editing_tools/EditingTools.vala"
	editing_tools_adjust_tool_update_transformation (_tmp0_, _tmp1_);
#line 2409 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_TOOL_COMMAND, EditingToolsAdjustToolAdjustToolCommand)->owner;
#line 2409 "../src/editing_tools/EditingTools.vala"
	editing_tools_adjust_tool_unbind_window_handlers (_tmp2_);
#line 2410 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_TOOL_COMMAND, EditingToolsAdjustToolAdjustToolCommand)->owner;
#line 2410 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = self->priv->old_transformation;
#line 2410 "../src/editing_tools/EditingTools.vala"
	editing_tools_adjust_tool_update_slider (_tmp3_, _tmp4_);
#line 2411 "../src/editing_tools/EditingTools.vala"
	_tmp5_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_TOOL_COMMAND, EditingToolsAdjustToolAdjustToolCommand)->owner;
#line 2411 "../src/editing_tools/EditingTools.vala"
	editing_tools_adjust_tool_bind_window_handlers (_tmp5_);
#line 2413 "../src/editing_tools/EditingTools.vala"
	_tmp6_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_TOOL_COMMAND, EditingToolsAdjustToolAdjustToolCommand)->owner;
#line 2413 "../src/editing_tools/EditingTools.vala"
	_tmp7_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 2413 "../src/editing_tools/EditingTools.vala"
	editing_tools_photo_canvas_repaint (_tmp7_);
#line 17032 "EditingTools.c"
}

static void
editing_tools_adjust_tool_slider_adjustment_command_real_redo (Command* base)
{
	EditingToolsAdjustToolSliderAdjustmentCommand * self;
	EditingToolsAdjustTool* _tmp0_;
	PixelTransformation* _tmp1_;
	EditingToolsAdjustTool* _tmp2_;
	EditingToolsAdjustTool* _tmp3_;
	PixelTransformation* _tmp4_;
	EditingToolsAdjustTool* _tmp5_;
	EditingToolsAdjustTool* _tmp6_;
	EditingToolsPhotoCanvas* _tmp7_;
#line 2416 "../src/editing_tools/EditingTools.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, EDITING_TOOLS_ADJUST_TOOL_TYPE_SLIDER_ADJUSTMENT_COMMAND, EditingToolsAdjustToolSliderAdjustmentCommand);
#line 2417 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_TOOL_COMMAND, EditingToolsAdjustToolAdjustToolCommand)->owner;
#line 2417 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = self->priv->new_transformation;
#line 2417 "../src/editing_tools/EditingTools.vala"
	editing_tools_adjust_tool_update_transformation (_tmp0_, _tmp1_);
#line 2419 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_TOOL_COMMAND, EditingToolsAdjustToolAdjustToolCommand)->owner;
#line 2419 "../src/editing_tools/EditingTools.vala"
	editing_tools_adjust_tool_unbind_window_handlers (_tmp2_);
#line 2420 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_TOOL_COMMAND, EditingToolsAdjustToolAdjustToolCommand)->owner;
#line 2420 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = self->priv->new_transformation;
#line 2420 "../src/editing_tools/EditingTools.vala"
	editing_tools_adjust_tool_update_slider (_tmp3_, _tmp4_);
#line 2421 "../src/editing_tools/EditingTools.vala"
	_tmp5_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_TOOL_COMMAND, EditingToolsAdjustToolAdjustToolCommand)->owner;
#line 2421 "../src/editing_tools/EditingTools.vala"
	editing_tools_adjust_tool_bind_window_handlers (_tmp5_);
#line 2423 "../src/editing_tools/EditingTools.vala"
	_tmp6_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_TOOL_COMMAND, EditingToolsAdjustToolAdjustToolCommand)->owner;
#line 2423 "../src/editing_tools/EditingTools.vala"
	_tmp7_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 2423 "../src/editing_tools/EditingTools.vala"
	editing_tools_photo_canvas_repaint (_tmp7_);
#line 17075 "EditingTools.c"
}

static gboolean
editing_tools_adjust_tool_slider_adjustment_command_real_compress (Command* base,
                                                                   Command* command)
{
	EditingToolsAdjustToolSliderAdjustmentCommand * self;
	EditingToolsAdjustToolSliderAdjustmentCommand* slider_adjustment = NULL;
	EditingToolsAdjustToolSliderAdjustmentCommand* _tmp0_;
	EditingToolsAdjustToolSliderAdjustmentCommand* _tmp1_;
	EditingToolsAdjustToolSliderAdjustmentCommand* _tmp2_;
	EditingToolsAdjustTool* _tmp3_;
	EditingToolsAdjustTool* _tmp4_;
	EditingToolsAdjustToolSliderAdjustmentCommand* _tmp5_;
	EditingToolsAdjustToolSliderAdjustmentCommand* _tmp6_;
	EditingToolsAdjustToolSliderAdjustmentCommand* _tmp7_;
	PixelTransformation* _tmp8_;
	PixelTransformation* _tmp9_;
	gboolean result;
#line 2426 "../src/editing_tools/EditingTools.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, EDITING_TOOLS_ADJUST_TOOL_TYPE_SLIDER_ADJUSTMENT_COMMAND, EditingToolsAdjustToolSliderAdjustmentCommand);
#line 2426 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (IS_COMMAND (command), FALSE);
#line 2427 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = _g_object_ref0 (EDITING_TOOLS_ADJUST_TOOL_IS_SLIDER_ADJUSTMENT_COMMAND (command) ? ((EditingToolsAdjustToolSliderAdjustmentCommand*) command) : NULL);
#line 2427 "../src/editing_tools/EditingTools.vala"
	slider_adjustment = _tmp0_;
#line 2428 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = slider_adjustment;
#line 2428 "../src/editing_tools/EditingTools.vala"
	if (_tmp1_ == NULL) {
#line 2429 "../src/editing_tools/EditingTools.vala"
		result = FALSE;
#line 2429 "../src/editing_tools/EditingTools.vala"
		_g_object_unref0 (slider_adjustment);
#line 2429 "../src/editing_tools/EditingTools.vala"
		return result;
#line 17113 "EditingTools.c"
	}
#line 2432 "../src/editing_tools/EditingTools.vala"
	_tmp2_ = slider_adjustment;
#line 2432 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_TOOL_COMMAND, EditingToolsAdjustToolAdjustToolCommand)->owner;
#line 2432 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_TOOL_COMMAND, EditingToolsAdjustToolAdjustToolCommand)->owner;
#line 2432 "../src/editing_tools/EditingTools.vala"
	if (_tmp3_ != _tmp4_) {
#line 2433 "../src/editing_tools/EditingTools.vala"
		result = FALSE;
#line 2433 "../src/editing_tools/EditingTools.vala"
		_g_object_unref0 (slider_adjustment);
#line 2433 "../src/editing_tools/EditingTools.vala"
		return result;
#line 17129 "EditingTools.c"
	}
#line 2436 "../src/editing_tools/EditingTools.vala"
	_tmp5_ = slider_adjustment;
#line 2436 "../src/editing_tools/EditingTools.vala"
	if (_tmp5_->priv->transformation_type != self->priv->transformation_type) {
#line 2437 "../src/editing_tools/EditingTools.vala"
		result = FALSE;
#line 2437 "../src/editing_tools/EditingTools.vala"
		_g_object_unref0 (slider_adjustment);
#line 2437 "../src/editing_tools/EditingTools.vala"
		return result;
#line 17141 "EditingTools.c"
	}
#line 2440 "../src/editing_tools/EditingTools.vala"
	_tmp6_ = slider_adjustment;
#line 2440 "../src/editing_tools/EditingTools.vala"
	command_execute (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_COMMAND, Command));
#line 2443 "../src/editing_tools/EditingTools.vala"
	_tmp7_ = slider_adjustment;
#line 2443 "../src/editing_tools/EditingTools.vala"
	_tmp8_ = _tmp7_->priv->new_transformation;
#line 2443 "../src/editing_tools/EditingTools.vala"
	_tmp9_ = _pixel_transformation_ref0 (_tmp8_);
#line 2443 "../src/editing_tools/EditingTools.vala"
	_pixel_transformation_unref0 (self->priv->new_transformation);
#line 2443 "../src/editing_tools/EditingTools.vala"
	self->priv->new_transformation = _tmp9_;
#line 2445 "../src/editing_tools/EditingTools.vala"
	result = TRUE;
#line 2445 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (slider_adjustment);
#line 2445 "../src/editing_tools/EditingTools.vala"
	return result;
#line 17163 "EditingTools.c"
}

static void
editing_tools_adjust_tool_slider_adjustment_command_class_init (EditingToolsAdjustToolSliderAdjustmentCommandClass * klass,
                                                                gpointer klass_data)
{
#line 2385 "../src/editing_tools/EditingTools.vala"
	editing_tools_adjust_tool_slider_adjustment_command_parent_class = g_type_class_peek_parent (klass);
#line 2385 "../src/editing_tools/EditingTools.vala"
	g_type_class_adjust_private_offset (klass, &EditingToolsAdjustToolSliderAdjustmentCommand_private_offset);
#line 2385 "../src/editing_tools/EditingTools.vala"
	((CommandClass *) klass)->execute = (void (*) (Command*)) editing_tools_adjust_tool_slider_adjustment_command_real_execute;
#line 2385 "../src/editing_tools/EditingTools.vala"
	((CommandClass *) klass)->undo = (void (*) (Command*)) editing_tools_adjust_tool_slider_adjustment_command_real_undo;
#line 2385 "../src/editing_tools/EditingTools.vala"
	((CommandClass *) klass)->redo = (void (*) (Command*)) editing_tools_adjust_tool_slider_adjustment_command_real_redo;
#line 2385 "../src/editing_tools/EditingTools.vala"
	((CommandClass *) klass)->compress = (gboolean (*) (Command*, Command*)) editing_tools_adjust_tool_slider_adjustment_command_real_compress;
#line 2385 "../src/editing_tools/EditingTools.vala"
	G_OBJECT_CLASS (klass)->finalize = editing_tools_adjust_tool_slider_adjustment_command_finalize;
#line 17184 "EditingTools.c"
}

static void
editing_tools_adjust_tool_slider_adjustment_command_instance_init (EditingToolsAdjustToolSliderAdjustmentCommand * self,
                                                                   gpointer klass)
{
#line 2385 "../src/editing_tools/EditingTools.vala"
	self->priv = editing_tools_adjust_tool_slider_adjustment_command_get_instance_private (self);
#line 17193 "EditingTools.c"
}

static void
editing_tools_adjust_tool_slider_adjustment_command_finalize (GObject * obj)
{
	EditingToolsAdjustToolSliderAdjustmentCommand * self;
#line 2385 "../src/editing_tools/EditingTools.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, EDITING_TOOLS_ADJUST_TOOL_TYPE_SLIDER_ADJUSTMENT_COMMAND, EditingToolsAdjustToolSliderAdjustmentCommand);
#line 2387 "../src/editing_tools/EditingTools.vala"
	_pixel_transformation_unref0 (self->priv->new_transformation);
#line 2388 "../src/editing_tools/EditingTools.vala"
	_pixel_transformation_unref0 (self->priv->old_transformation);
#line 2385 "../src/editing_tools/EditingTools.vala"
	G_OBJECT_CLASS (editing_tools_adjust_tool_slider_adjustment_command_parent_class)->finalize (obj);
#line 17208 "EditingTools.c"
}

static GType
editing_tools_adjust_tool_slider_adjustment_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (EditingToolsAdjustToolSliderAdjustmentCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) editing_tools_adjust_tool_slider_adjustment_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EditingToolsAdjustToolSliderAdjustmentCommand), 0, (GInstanceInitFunc) editing_tools_adjust_tool_slider_adjustment_command_instance_init, NULL };
	GType editing_tools_adjust_tool_slider_adjustment_command_type_id;
	editing_tools_adjust_tool_slider_adjustment_command_type_id = g_type_register_static (EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_TOOL_COMMAND, "EditingToolsAdjustToolSliderAdjustmentCommand", &g_define_type_info, 0);
	EditingToolsAdjustToolSliderAdjustmentCommand_private_offset = g_type_add_instance_private (editing_tools_adjust_tool_slider_adjustment_command_type_id, sizeof (EditingToolsAdjustToolSliderAdjustmentCommandPrivate));
	return editing_tools_adjust_tool_slider_adjustment_command_type_id;
}

static GType
editing_tools_adjust_tool_slider_adjustment_command_get_type (void)
{
	static volatile gsize editing_tools_adjust_tool_slider_adjustment_command_type_id__once = 0;
	if (g_once_init_enter (&editing_tools_adjust_tool_slider_adjustment_command_type_id__once)) {
		GType editing_tools_adjust_tool_slider_adjustment_command_type_id;
		editing_tools_adjust_tool_slider_adjustment_command_type_id = editing_tools_adjust_tool_slider_adjustment_command_get_type_once ();
		g_once_init_leave (&editing_tools_adjust_tool_slider_adjustment_command_type_id__once, editing_tools_adjust_tool_slider_adjustment_command_type_id);
	}
	return editing_tools_adjust_tool_slider_adjustment_command_type_id__once;
}

static inline gpointer
editing_tools_adjust_tool_adjust_enhance_command_get_instance_private (EditingToolsAdjustToolAdjustEnhanceCommand* self)
{
	return G_STRUCT_MEMBER_P (self, EditingToolsAdjustToolAdjustEnhanceCommand_private_offset);
}

static EditingToolsAdjustToolAdjustEnhanceCommand*
editing_tools_adjust_tool_adjust_enhance_command_construct (GType object_type,
                                                            EditingToolsAdjustTool* owner,
                                                            Photo* photo)
{
	EditingToolsAdjustToolAdjustEnhanceCommand * self = NULL;
	Photo* _tmp0_;
	PixelTransformationBundle* _tmp1_;
#line 2454 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (EDITING_TOOLS_IS_ADJUST_TOOL (owner), NULL);
#line 2454 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (IS_PHOTO (photo), NULL);
#line 2455 "../src/editing_tools/EditingTools.vala"
	self = (EditingToolsAdjustToolAdjustEnhanceCommand*) editing_tools_adjust_tool_adjust_tool_command_construct (object_type, owner, RESOURCES_ENHANCE_LABEL, RESOURCES_ENHANCE_TOOLTIP);
#line 2457 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = _g_object_ref0 (photo);
#line 2457 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->priv->photo);
#line 2457 "../src/editing_tools/EditingTools.vala"
	self->priv->photo = _tmp0_;
#line 2458 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = photo_get_color_adjustments (photo);
#line 2458 "../src/editing_tools/EditingTools.vala"
	_pixel_transformation_bundle_unref0 (self->priv->original);
#line 2458 "../src/editing_tools/EditingTools.vala"
	self->priv->original = _tmp1_;
#line 2454 "../src/editing_tools/EditingTools.vala"
	return self;
#line 17267 "EditingTools.c"
}

static EditingToolsAdjustToolAdjustEnhanceCommand*
editing_tools_adjust_tool_adjust_enhance_command_new (EditingToolsAdjustTool* owner,
                                                      Photo* photo)
{
#line 2454 "../src/editing_tools/EditingTools.vala"
	return editing_tools_adjust_tool_adjust_enhance_command_construct (EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_ENHANCE_COMMAND, owner, photo);
#line 17276 "EditingTools.c"
}

static void
editing_tools_adjust_tool_adjust_enhance_command_real_execute (Command* base)
{
	EditingToolsAdjustToolAdjustEnhanceCommand * self;
	PixelTransformationBundle* _tmp0_;
	EditingToolsAdjustTool* _tmp3_;
	PixelTransformationBundle* _tmp4_;
#line 2461 "../src/editing_tools/EditingTools.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_ENHANCE_COMMAND, EditingToolsAdjustToolAdjustEnhanceCommand);
#line 2462 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = self->priv->enhanced;
#line 2462 "../src/editing_tools/EditingTools.vala"
	if (_tmp0_ == NULL) {
#line 17292 "EditingTools.c"
		Photo* _tmp1_;
		PixelTransformationBundle* _tmp2_;
#line 2463 "../src/editing_tools/EditingTools.vala"
		_tmp1_ = self->priv->photo;
#line 2463 "../src/editing_tools/EditingTools.vala"
		_tmp2_ = photo_get_enhance_transformations (_tmp1_);
#line 2463 "../src/editing_tools/EditingTools.vala"
		_pixel_transformation_bundle_unref0 (self->priv->enhanced);
#line 2463 "../src/editing_tools/EditingTools.vala"
		self->priv->enhanced = _tmp2_;
#line 17303 "EditingTools.c"
	}
#line 2465 "../src/editing_tools/EditingTools.vala"
	_tmp3_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_TOOL_COMMAND, EditingToolsAdjustToolAdjustToolCommand)->owner;
#line 2465 "../src/editing_tools/EditingTools.vala"
	_tmp4_ = self->priv->enhanced;
#line 2465 "../src/editing_tools/EditingTools.vala"
	editing_tools_adjust_tool_set_adjustments (_tmp3_, _tmp4_);
#line 17311 "EditingTools.c"
}

static void
editing_tools_adjust_tool_adjust_enhance_command_real_undo (Command* base)
{
	EditingToolsAdjustToolAdjustEnhanceCommand * self;
	EditingToolsAdjustTool* _tmp0_;
	PixelTransformationBundle* _tmp1_;
#line 2468 "../src/editing_tools/EditingTools.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_ENHANCE_COMMAND, EditingToolsAdjustToolAdjustEnhanceCommand);
#line 2469 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_TOOL_COMMAND, EditingToolsAdjustToolAdjustToolCommand)->owner;
#line 2469 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = self->priv->original;
#line 2469 "../src/editing_tools/EditingTools.vala"
	editing_tools_adjust_tool_set_adjustments (_tmp0_, _tmp1_);
#line 17328 "EditingTools.c"
}

static gboolean
editing_tools_adjust_tool_adjust_enhance_command_real_compress (Command* base,
                                                                Command* command)
{
	EditingToolsAdjustToolAdjustEnhanceCommand * self;
	EnhanceSingleCommand* enhance_single = NULL;
	EnhanceSingleCommand* _tmp0_;
	EnhanceSingleCommand* _tmp1_;
	EditingToolsAdjustToolAdjustEnhanceCommand* enhance_command = NULL;
	EditingToolsAdjustToolAdjustEnhanceCommand* _tmp10_;
	EditingToolsAdjustToolAdjustEnhanceCommand* _tmp11_;
	EditingToolsAdjustToolAdjustEnhanceCommand* _tmp12_;
	EditingToolsAdjustTool* _tmp13_;
	EditingToolsAdjustTool* _tmp14_;
	gboolean result;
#line 2472 "../src/editing_tools/EditingTools.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_ENHANCE_COMMAND, EditingToolsAdjustToolAdjustEnhanceCommand);
#line 2472 "../src/editing_tools/EditingTools.vala"
	g_return_val_if_fail (IS_COMMAND (command), FALSE);
#line 2474 "../src/editing_tools/EditingTools.vala"
	_tmp0_ = _g_object_ref0 (IS_ENHANCE_SINGLE_COMMAND (command) ? ((EnhanceSingleCommand*) command) : NULL);
#line 2474 "../src/editing_tools/EditingTools.vala"
	enhance_single = _tmp0_;
#line 2475 "../src/editing_tools/EditingTools.vala"
	_tmp1_ = enhance_single;
#line 2475 "../src/editing_tools/EditingTools.vala"
	if (_tmp1_ != NULL) {
#line 17358 "EditingTools.c"
		Photo* photo = NULL;
		EnhanceSingleCommand* _tmp2_;
		DataSource* _tmp3_;
		Photo* _tmp4_;
		EditingToolsAdjustTool* _tmp5_;
		EditingToolsPhotoCanvas* _tmp6_;
		Photo* _tmp7_;
		Photo* _tmp8_;
		gboolean _tmp9_;
#line 2476 "../src/editing_tools/EditingTools.vala"
		_tmp2_ = enhance_single;
#line 2476 "../src/editing_tools/EditingTools.vala"
		_tmp3_ = single_data_source_command_get_source (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, TYPE_SINGLE_DATA_SOURCE_COMMAND, SingleDataSourceCommand));
#line 2476 "../src/editing_tools/EditingTools.vala"
		photo = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, TYPE_PHOTO, Photo);
#line 2480 "../src/editing_tools/EditingTools.vala"
		_tmp4_ = photo;
#line 2480 "../src/editing_tools/EditingTools.vala"
		_tmp5_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_TOOL_COMMAND, EditingToolsAdjustToolAdjustToolCommand)->owner;
#line 2480 "../src/editing_tools/EditingTools.vala"
		_tmp6_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, EDITING_TOOLS_TYPE_EDITING_TOOL, EditingToolsEditingTool)->canvas;
#line 2480 "../src/editing_tools/EditingTools.vala"
		_tmp7_ = editing_tools_photo_canvas_get_photo (_tmp6_);
#line 2480 "../src/editing_tools/EditingTools.vala"
		_tmp8_ = _tmp7_;
#line 2480 "../src/editing_tools/EditingTools.vala"
		_tmp9_ = data_source_equals (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_DATA_SOURCE, DataSource), G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, TYPE_DATA_SOURCE, DataSource));
#line 2480 "../src/editing_tools/EditingTools.vala"
		_g_object_unref0 (_tmp8_);
#line 2480 "../src/editing_tools/EditingTools.vala"
		result = _tmp9_;
#line 2480 "../src/editing_tools/EditingTools.vala"
		_g_object_unref0 (photo);
#line 2480 "../src/editing_tools/EditingTools.vala"
		_g_object_unref0 (enhance_single);
#line 2480 "../src/editing_tools/EditingTools.vala"
		return result;
#line 17396 "EditingTools.c"
	}
#line 2483 "../src/editing_tools/EditingTools.vala"
	_tmp10_ = _g_object_ref0 (EDITING_TOOLS_ADJUST_TOOL_IS_ADJUST_ENHANCE_COMMAND (command) ? ((EditingToolsAdjustToolAdjustEnhanceCommand*) command) : NULL);
#line 2483 "../src/editing_tools/EditingTools.vala"
	enhance_command = _tmp10_;
#line 2484 "../src/editing_tools/EditingTools.vala"
	_tmp11_ = enhance_command;
#line 2484 "../src/editing_tools/EditingTools.vala"
	if (_tmp11_ == NULL) {
#line 2485 "../src/editing_tools/EditingTools.vala"
		result = FALSE;
#line 2485 "../src/editing_tools/EditingTools.vala"
		_g_object_unref0 (enhance_command);
#line 2485 "../src/editing_tools/EditingTools.vala"
		_g_object_unref0 (enhance_single);
#line 2485 "../src/editing_tools/EditingTools.vala"
		return result;
#line 17414 "EditingTools.c"
	}
#line 2487 "../src/editing_tools/EditingTools.vala"
	_tmp12_ = enhance_command;
#line 2487 "../src/editing_tools/EditingTools.vala"
	_tmp13_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_TOOL_COMMAND, EditingToolsAdjustToolAdjustToolCommand)->owner;
#line 2487 "../src/editing_tools/EditingTools.vala"
	_tmp14_ = G_TYPE_CHECK_INSTANCE_CAST (self, EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_TOOL_COMMAND, EditingToolsAdjustToolAdjustToolCommand)->owner;
#line 2487 "../src/editing_tools/EditingTools.vala"
	if (_tmp13_ != _tmp14_) {
#line 2488 "../src/editing_tools/EditingTools.vala"
		result = FALSE;
#line 2488 "../src/editing_tools/EditingTools.vala"
		_g_object_unref0 (enhance_command);
#line 2488 "../src/editing_tools/EditingTools.vala"
		_g_object_unref0 (enhance_single);
#line 2488 "../src/editing_tools/EditingTools.vala"
		return result;
#line 17432 "EditingTools.c"
	}
#line 2491 "../src/editing_tools/EditingTools.vala"
	result = TRUE;
#line 2491 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (enhance_command);
#line 2491 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (enhance_single);
#line 2491 "../src/editing_tools/EditingTools.vala"
	return result;
#line 17442 "EditingTools.c"
}

static void
editing_tools_adjust_tool_adjust_enhance_command_class_init (EditingToolsAdjustToolAdjustEnhanceCommandClass * klass,
                                                             gpointer klass_data)
{
#line 2449 "../src/editing_tools/EditingTools.vala"
	editing_tools_adjust_tool_adjust_enhance_command_parent_class = g_type_class_peek_parent (klass);
#line 2449 "../src/editing_tools/EditingTools.vala"
	g_type_class_adjust_private_offset (klass, &EditingToolsAdjustToolAdjustEnhanceCommand_private_offset);
#line 2449 "../src/editing_tools/EditingTools.vala"
	((CommandClass *) klass)->execute = (void (*) (Command*)) editing_tools_adjust_tool_adjust_enhance_command_real_execute;
#line 2449 "../src/editing_tools/EditingTools.vala"
	((CommandClass *) klass)->undo = (void (*) (Command*)) editing_tools_adjust_tool_adjust_enhance_command_real_undo;
#line 2449 "../src/editing_tools/EditingTools.vala"
	((CommandClass *) klass)->compress = (gboolean (*) (Command*, Command*)) editing_tools_adjust_tool_adjust_enhance_command_real_compress;
#line 2449 "../src/editing_tools/EditingTools.vala"
	G_OBJECT_CLASS (klass)->finalize = editing_tools_adjust_tool_adjust_enhance_command_finalize;
#line 17461 "EditingTools.c"
}

static void
editing_tools_adjust_tool_adjust_enhance_command_instance_init (EditingToolsAdjustToolAdjustEnhanceCommand * self,
                                                                gpointer klass)
{
#line 2449 "../src/editing_tools/EditingTools.vala"
	self->priv = editing_tools_adjust_tool_adjust_enhance_command_get_instance_private (self);
#line 2452 "../src/editing_tools/EditingTools.vala"
	self->priv->enhanced = NULL;
#line 17472 "EditingTools.c"
}

static void
editing_tools_adjust_tool_adjust_enhance_command_finalize (GObject * obj)
{
	EditingToolsAdjustToolAdjustEnhanceCommand * self;
#line 2449 "../src/editing_tools/EditingTools.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_ENHANCE_COMMAND, EditingToolsAdjustToolAdjustEnhanceCommand);
#line 2450 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->priv->photo);
#line 2451 "../src/editing_tools/EditingTools.vala"
	_pixel_transformation_bundle_unref0 (self->priv->original);
#line 2452 "../src/editing_tools/EditingTools.vala"
	_pixel_transformation_bundle_unref0 (self->priv->enhanced);
#line 2449 "../src/editing_tools/EditingTools.vala"
	G_OBJECT_CLASS (editing_tools_adjust_tool_adjust_enhance_command_parent_class)->finalize (obj);
#line 17489 "EditingTools.c"
}

static GType
editing_tools_adjust_tool_adjust_enhance_command_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (EditingToolsAdjustToolAdjustEnhanceCommandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) editing_tools_adjust_tool_adjust_enhance_command_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EditingToolsAdjustToolAdjustEnhanceCommand), 0, (GInstanceInitFunc) editing_tools_adjust_tool_adjust_enhance_command_instance_init, NULL };
	GType editing_tools_adjust_tool_adjust_enhance_command_type_id;
	editing_tools_adjust_tool_adjust_enhance_command_type_id = g_type_register_static (EDITING_TOOLS_ADJUST_TOOL_TYPE_ADJUST_TOOL_COMMAND, "EditingToolsAdjustToolAdjustEnhanceCommand", &g_define_type_info, 0);
	EditingToolsAdjustToolAdjustEnhanceCommand_private_offset = g_type_add_instance_private (editing_tools_adjust_tool_adjust_enhance_command_type_id, sizeof (EditingToolsAdjustToolAdjustEnhanceCommandPrivate));
	return editing_tools_adjust_tool_adjust_enhance_command_type_id;
}

static GType
editing_tools_adjust_tool_adjust_enhance_command_get_type (void)
{
	static volatile gsize editing_tools_adjust_tool_adjust_enhance_command_type_id__once = 0;
	if (g_once_init_enter (&editing_tools_adjust_tool_adjust_enhance_command_type_id__once)) {
		GType editing_tools_adjust_tool_adjust_enhance_command_type_id;
		editing_tools_adjust_tool_adjust_enhance_command_type_id = editing_tools_adjust_tool_adjust_enhance_command_get_type_once ();
		g_once_init_leave (&editing_tools_adjust_tool_adjust_enhance_command_type_id__once, editing_tools_adjust_tool_adjust_enhance_command_type_id);
	}
	return editing_tools_adjust_tool_adjust_enhance_command_type_id__once;
}

static void
editing_tools_adjust_tool_class_init (EditingToolsAdjustToolClass * klass,
                                      gpointer klass_data)
{
#line 2200 "../src/editing_tools/EditingTools.vala"
	editing_tools_adjust_tool_parent_class = g_type_class_peek_parent (klass);
#line 2200 "../src/editing_tools/EditingTools.vala"
	((EditingToolsEditingToolClass *) klass)->finalize = editing_tools_adjust_tool_finalize;
#line 2200 "../src/editing_tools/EditingTools.vala"
	g_type_class_adjust_private_offset (klass, &EditingToolsAdjustTool_private_offset);
#line 2200 "../src/editing_tools/EditingTools.vala"
	((EditingToolsEditingToolClass *) klass)->activate = (void (*) (EditingToolsEditingTool*, EditingToolsPhotoCanvas*)) editing_tools_adjust_tool_real_activate;
#line 2200 "../src/editing_tools/EditingTools.vala"
	((EditingToolsEditingToolClass *) klass)->get_tool_window = (EditingToolsEditingToolWindow* (*) (EditingToolsEditingTool*)) editing_tools_adjust_tool_real_get_tool_window;
#line 2200 "../src/editing_tools/EditingTools.vala"
	((EditingToolsEditingToolClass *) klass)->deactivate = (void (*) (EditingToolsEditingTool*)) editing_tools_adjust_tool_real_deactivate;
#line 2200 "../src/editing_tools/EditingTools.vala"
	((EditingToolsEditingToolClass *) klass)->paint = (void (*) (EditingToolsEditingTool*, cairo_t*)) editing_tools_adjust_tool_real_paint;
#line 2200 "../src/editing_tools/EditingTools.vala"
	((EditingToolsEditingToolClass *) klass)->get_display_pixbuf = (GdkPixbuf* (*) (EditingToolsEditingTool*, Scaling*, Photo*, Dimensions*, GError**)) editing_tools_adjust_tool_real_get_display_pixbuf;
#line 2200 "../src/editing_tools/EditingTools.vala"
	((EditingToolsEditingToolClass *) klass)->on_keypress = (gboolean (*) (EditingToolsEditingTool*, GdkEventKey*)) editing_tools_adjust_tool_real_on_keypress;
#line 17536 "EditingTools.c"
}

static void
editing_tools_adjust_tool_instance_init (EditingToolsAdjustTool * self,
                                         gpointer klass)
{
#line 2200 "../src/editing_tools/EditingTools.vala"
	self->priv = editing_tools_adjust_tool_get_instance_private (self);
#line 2495 "../src/editing_tools/EditingTools.vala"
	self->priv->adjust_tool_window = NULL;
#line 2496 "../src/editing_tools/EditingTools.vala"
	self->priv->suppress_effect_redraw = FALSE;
#line 2497 "../src/editing_tools/EditingTools.vala"
	self->priv->draw_to_pixbuf = NULL;
#line 2498 "../src/editing_tools/EditingTools.vala"
	self->priv->histogram_pixbuf = NULL;
#line 2499 "../src/editing_tools/EditingTools.vala"
	self->priv->virgin_histogram_pixbuf = NULL;
#line 2500 "../src/editing_tools/EditingTools.vala"
	self->priv->transformer = NULL;
#line 2501 "../src/editing_tools/EditingTools.vala"
	self->priv->histogram_transformer = NULL;
#line 2502 "../src/editing_tools/EditingTools.vala"
	self->priv->transformations = NULL;
#line 2503 "../src/editing_tools/EditingTools.vala"
	self->priv->fp_pixel_cache = NULL;
#line 2503 "../src/editing_tools/EditingTools.vala"
	self->priv->fp_pixel_cache_length1 = 0;
#line 2503 "../src/editing_tools/EditingTools.vala"
	self->priv->_fp_pixel_cache_size_ = self->priv->fp_pixel_cache_length1;
#line 2504 "../src/editing_tools/EditingTools.vala"
	self->priv->disable_histogram_refresh = FALSE;
#line 2505 "../src/editing_tools/EditingTools.vala"
	self->priv->temperature_scheduler = NULL;
#line 2506 "../src/editing_tools/EditingTools.vala"
	self->priv->tint_scheduler = NULL;
#line 2507 "../src/editing_tools/EditingTools.vala"
	self->priv->contrast_scheduler = NULL;
#line 2508 "../src/editing_tools/EditingTools.vala"
	self->priv->saturation_scheduler = NULL;
#line 2509 "../src/editing_tools/EditingTools.vala"
	self->priv->exposure_scheduler = NULL;
#line 2510 "../src/editing_tools/EditingTools.vala"
	self->priv->shadows_scheduler = NULL;
#line 2511 "../src/editing_tools/EditingTools.vala"
	self->priv->highlights_scheduler = NULL;
#line 17583 "EditingTools.c"
}

static void
editing_tools_adjust_tool_finalize (EditingToolsEditingTool * obj)
{
	EditingToolsAdjustTool * self;
#line 2200 "../src/editing_tools/EditingTools.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, EDITING_TOOLS_TYPE_ADJUST_TOOL, EditingToolsAdjustTool);
#line 2495 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->priv->adjust_tool_window);
#line 2497 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->priv->draw_to_pixbuf);
#line 2498 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->priv->histogram_pixbuf);
#line 2499 "../src/editing_tools/EditingTools.vala"
	_g_object_unref0 (self->priv->virgin_histogram_pixbuf);
#line 2500 "../src/editing_tools/EditingTools.vala"
	_pixel_transformer_unref0 (self->priv->transformer);
#line 2501 "../src/editing_tools/EditingTools.vala"
	_pixel_transformer_unref0 (self->priv->histogram_transformer);
#line 2502 "../src/editing_tools/EditingTools.vala"
	_pixel_transformation_bundle_unref0 (self->priv->transformations);
#line 2503 "../src/editing_tools/EditingTools.vala"
	self->priv->fp_pixel_cache = (g_free (self->priv->fp_pixel_cache), NULL);
#line 2505 "../src/editing_tools/EditingTools.vala"
	_one_shot_scheduler_unref0 (self->priv->temperature_scheduler);
#line 2506 "../src/editing_tools/EditingTools.vala"
	_one_shot_scheduler_unref0 (self->priv->tint_scheduler);
#line 2507 "../src/editing_tools/EditingTools.vala"
	_one_shot_scheduler_unref0 (self->priv->contrast_scheduler);
#line 2508 "../src/editing_tools/EditingTools.vala"
	_one_shot_scheduler_unref0 (self->priv->saturation_scheduler);
#line 2509 "../src/editing_tools/EditingTools.vala"
	_one_shot_scheduler_unref0 (self->priv->exposure_scheduler);
#line 2510 "../src/editing_tools/EditingTools.vala"
	_one_shot_scheduler_unref0 (self->priv->shadows_scheduler);
#line 2511 "../src/editing_tools/EditingTools.vala"
	_one_shot_scheduler_unref0 (self->priv->highlights_scheduler);
#line 2200 "../src/editing_tools/EditingTools.vala"
	EDITING_TOOLS_EDITING_TOOL_CLASS (editing_tools_adjust_tool_parent_class)->finalize (obj);
#line 17624 "EditingTools.c"
}

static GType
editing_tools_adjust_tool_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (EditingToolsAdjustToolClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) editing_tools_adjust_tool_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EditingToolsAdjustTool), 0, (GInstanceInitFunc) editing_tools_adjust_tool_instance_init, NULL };
	GType editing_tools_adjust_tool_type_id;
	editing_tools_adjust_tool_type_id = g_type_register_static (EDITING_TOOLS_TYPE_EDITING_TOOL, "EditingToolsAdjustTool", &g_define_type_info, 0);
	EditingToolsAdjustTool_private_offset = g_type_add_instance_private (editing_tools_adjust_tool_type_id, sizeof (EditingToolsAdjustToolPrivate));
	return editing_tools_adjust_tool_type_id;
}

GType
editing_tools_adjust_tool_get_type (void)
{
	static volatile gsize editing_tools_adjust_tool_type_id__once = 0;
	if (g_once_init_enter (&editing_tools_adjust_tool_type_id__once)) {
		GType editing_tools_adjust_tool_type_id;
		editing_tools_adjust_tool_type_id = editing_tools_adjust_tool_get_type_once ();
		g_once_init_leave (&editing_tools_adjust_tool_type_id__once, editing_tools_adjust_tool_type_id);
	}
	return editing_tools_adjust_tool_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

